/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/event","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/strings","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","fs","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],te=function(B){for(var i=[],T=0,R=B.length;T<R;T++)i[T]=ee[B[T]];return i};define(ee[56],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function T(R,w){if(!R)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}i.ok=T}),define(ee[47],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function T(C){return(S,l,m)=>{let y=null,D=null;if(typeof m.value=="function"?(y="value",D=m.value):typeof m.get=="function"&&(y="get",D=m.get),!D)throw new Error("not supported");m[y]=C(D,l)}}i.createDecorator=T;function R(C,S,l){let m=null,y=null;if(typeof l.value=="function"?(m="value",y=l.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",y=l.get),!y)throw new Error("not supported");const D=`$memoize$${S}`;l[m]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,u)}),this[D]}}i.memoize=R;function w(C,S,l){return T((m,y)=>{const D=`$debounce$${y}`,u=`$debounce$result$${y}`;return function(...E){this[u]||(this[u]=l?l():void 0),clearTimeout(this[D]),S&&(this[u]=S(this[u],...E),E=[this[u]]),this[D]=setTimeout(()=>{m.apply(this,E),this[u]=l?l():void 0},C)}})}i.debounce=w;function I(C,S,l){return T((m,y)=>{const D=`$throttle$timer$${y}`,u=`$throttle$result$${y}`,E=`$throttle$lastRun$${y}`,d=`$throttle$pending$${y}`;return function(...g){if(this[u]||(this[u]=l?l():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),S&&(this[u]=S(this[u],...g)),this[d])return;const h=this[E]+C;h<=Date.now()?(this[E]=Date.now(),m.apply(this,[this[u]]),this[u]=l?l():void 0):(this[d]=!0,this[D]=setTimeout(()=>{this[d]=!1,this[E]=Date.now(),m.apply(this,[this[u]]),this[u]=l?l():void 0},h-Date.now()))}})}i.throttle=I}),define(ee[57],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var T;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(T=i.ScanError||(i.ScanError={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R=i.SyntaxKind||(i.SyntaxKind={}));var w;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(w=i.ParseErrorCode||(i.ParseErrorCode={}));var I;(function(n){n.DEFAULT={allowTrailingComma:!0}})(I=i.ParseOptions||(i.ParseOptions={}));function C(n,o=!1){let e=0,t=n.length,r="",c=0,v=16,L=0;function P(ie){let he=0,_=0;for(;he<ie;){const G=n.charCodeAt(e);if(G>=48&&G<=57)_=_*16+G-48;else if(G>=65&&G<=70)_=_*16+G-65+10;else if(G>=97&&G<=102)_=_*16+G-97+10;else break;e++,he++}return he<ie&&(_=-1),_}function k(ie){e=ie,r="",c=0,v=16,L=0}function U(){const ie=e;if(n.charCodeAt(e)===48)e++;else for(e++;e<n.length&&m(n.charCodeAt(e));)e++;if(e<n.length&&n.charCodeAt(e)===46)if(e++,e<n.length&&m(n.charCodeAt(e)))for(e++;e<n.length&&m(n.charCodeAt(e));)e++;else return L=3,n.substring(ie,e);let he=e;if(e<n.length&&(n.charCodeAt(e)===69||n.charCodeAt(e)===101))if(e++,(e<n.length&&n.charCodeAt(e)===43||n.charCodeAt(e)===45)&&e++,e<n.length&&m(n.charCodeAt(e))){for(e++;e<n.length&&m(n.charCodeAt(e));)e++;he=e}else L=3;return n.substring(ie,he)}function J(){let ie="",he=e;for(;;){if(e>=t){ie+=n.substring(he,e),L=2;break}const _=n.charCodeAt(e);if(_===34){ie+=n.substring(he,e),e++;break}if(_===92){if(ie+=n.substring(he,e),e++,e>=t){L=2;break}switch(n.charCodeAt(e++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const re=P(4);re>=0?ie+=String.fromCharCode(re):L=4;break}default:L=5}he=e;continue}if(_>=0&&_<=31)if(l(_)){ie+=n.substring(he,e),L=2;break}else L=6;e++}return ie}function ne(){if(r="",L=0,c=e,e>=t)return c=t,v=17;let ie=n.charCodeAt(e);if(S(ie)){do e++,r+=String.fromCharCode(ie),ie=n.charCodeAt(e);while(S(ie));return v=15}if(l(ie))return e++,r+=String.fromCharCode(ie),ie===13&&n.charCodeAt(e)===10&&(e++,r+=`
`),v=14;switch(ie){case 123:return e++,v=1;case 125:return e++,v=2;case 91:return e++,v=3;case 93:return e++,v=4;case 58:return e++,v=6;case 44:return e++,v=5;case 34:return e++,r=J(),v=10;case 47:{const he=e-1;if(n.charCodeAt(e+1)===47){for(e+=2;e<t&&!l(n.charCodeAt(e));)e++;return r=n.substring(he,e),v=12}if(n.charCodeAt(e+1)===42){e+=2;const _=t-1;let G=!1;for(;e<_;){if(n.charCodeAt(e)===42&&n.charCodeAt(e+1)===47){e+=2,G=!0;break}e++}return G||(e++,L=1),r=n.substring(he,e),v=13}return r+=String.fromCharCode(ie),e++,v=16}case 45:if(r+=String.fromCharCode(ie),e++,e===t||!m(n.charCodeAt(e)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=U(),v=11;default:for(;e<t&&ge(ie);)e++,ie=n.charCodeAt(e);if(c!==e){switch(r=n.substring(c,e),r){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return r+=String.fromCharCode(ie),e++,v=16}}function ge(ie){if(S(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ie;do ie=ne();while(ie>=12&&ie<=15);return ie}return{setPosition:k,getPosition:()=>e,scan:o?oe:ne,getToken:()=>v,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>e-c,getTokenError:()=>L}}i.createScanner=C;function S(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var y;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(y||(y={}));function D(n,o){const e=[],t=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function L(P,k,U,J){c.value=P,c.offset=k,c.length=U,c.type=J,c.colonOffset=void 0,r=c}try{f(n,{onObjectBegin:(P,k)=>{if(o<=P)throw t;r=void 0,v=o>P,e.push("")},onObjectProperty:(P,k,U)=>{if(o<k||(L(P,k,U,"property"),e[e.length-1]=P,o<=k+U))throw t},onObjectEnd:(P,k)=>{if(o<=P)throw t;r=void 0,e.pop()},onArrayBegin:(P,k)=>{if(o<=P)throw t;r=void 0,e.push(0)},onArrayEnd:(P,k)=>{if(o<=P)throw t;r=void 0,e.pop()},onLiteralValue:(P,k,U)=>{if(o<k||(L(P,k,U,a(P)),o<=k+U))throw t},onSeparator:(P,k,U)=>{if(o<=k)throw t;if(P===":"&&r&&r.type==="property")r.colonOffset=k,v=!1,r=void 0;else if(P===","){const J=e[e.length-1];typeof J=="number"?e[e.length-1]=J+1:(v=!0,e[e.length-1]=""),r=void 0}}})}catch(P){if(P!==t)throw P}return{path:e,previousNode:r,isAtPropertyKey:v,matches:P=>{let k=0;for(let U=0;k<P.length&&U<e.length;U++)if(P[k]===e[U]||P[k]==="*")k++;else if(P[k]!=="**")return!1;return k===P.length}}}i.getLocation=D;function u(n,o=[],e=I.DEFAULT){let t=null,r=[];const c=[];function v(P){Array.isArray(r)?r.push(P):t!==null&&(r[t]=P)}return f(n,{onObjectBegin:()=>{const P={};v(P),c.push(r),r=P,t=null},onObjectProperty:P=>{t=P},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const P=[];v(P),c.push(r),r=P,t=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:v,onError:(P,k,U)=>{o.push({error:P,offset:k,length:U})}},e),r[0]}i.parse=u;function E(n,o=[],e=I.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(P){t.type==="property"&&(t.length=P-t.offset,t=t.parent)}function c(P){return t.children.push(P),P}f(n,{onObjectBegin:P=>{t=c({type:"object",offset:P,length:-1,parent:t,children:[]})},onObjectProperty:(P,k,U)=>{t=c({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:P,offset:k,length:U,parent:t})},onObjectEnd:(P,k)=>{t.length=P+k-t.offset,t=t.parent,r(P+k)},onArrayBegin:(P,k)=>{t=c({type:"array",offset:P,length:-1,parent:t,children:[]})},onArrayEnd:(P,k)=>{t.length=P+k-t.offset,t=t.parent,r(P+k)},onLiteralValue:(P,k,U)=>{c({type:a(P),offset:k,length:U,parent:t,value:P}),r(k+U)},onSeparator:(P,k,U)=>{t.type==="property"&&(P===":"?t.colonOffset=k:P===","&&r(k))},onError:(P,k,U)=>{o.push({error:P,offset:k,length:U})}},e);const L=t.children[0];return L&&delete L.parent,L}i.parseTree=E;function d(n,o){if(!n)return;let e=n;for(let t of o)if(typeof t=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let r=!1;for(const c of e.children)if(Array.isArray(c.children)&&c.children[0].value===t){e=c.children[1],r=!0;break}if(!r)return}else{const r=t;if(e.type!=="array"||r<0||!Array.isArray(e.children)||r>=e.children.length)return;e=e.children[r]}return e}i.findNodeAtLocation=d;function g(n){if(!n.parent||!n.parent.children)return[];const o=g(n.parent);if(n.parent.type==="property"){const e=n.parent.children[0].value;o.push(e)}else if(n.parent.type==="array"){const e=n.parent.children.indexOf(n);e!==-1&&o.push(e)}return o}i.getNodePath=g;function h(n){switch(n.type){case"array":return n.children.map(h);case"object":{const o=Object.create(null);for(let e of n.children){const t=e.children[1];t&&(o[e.children[0].value]=h(t))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}i.getNodeValue=h;function p(n,o,e=!1){return o>=n.offset&&o<n.offset+n.length||e&&o===n.offset+n.length}i.contains=p;function b(n,o,e=!1){if(p(n,o,e)){const t=n.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=o;r++){const c=b(t[r],o,e);if(c)return c}return n}}i.findNodeAtOffset=b;function f(n,o,e=I.DEFAULT){const t=C(n,!1);function r(W){return W?()=>W(t.getTokenOffset(),t.getTokenLength()):()=>!0}function c(W){return W?X=>W(X,t.getTokenOffset(),t.getTokenLength()):()=>!0}const v=r(o.onObjectBegin),L=c(o.onObjectProperty),P=r(o.onObjectEnd),k=r(o.onArrayBegin),U=r(o.onArrayEnd),J=c(o.onLiteralValue),ne=c(o.onSeparator),ge=r(o.onComment),oe=c(o.onError),ie=e&&e.disallowComments,he=e&&e.allowTrailingComma;function _(){for(;;){const W=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:ie||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(W){case 12:case 13:ie?G(10):ge();break;case 16:G(1);break;case 15:case 14:break;default:return W}}}function G(W,X=[],$=[]){if(oe(W),X.length+$.length>0){let Y=t.getToken();for(;Y!==17;){if(X.indexOf(Y)!==-1){_();break}else if($.indexOf(Y)!==-1)break;Y=_()}}}function re(W){const X=t.getTokenValue();return W?J(X):L(X),_(),!0}function z(){switch(t.getToken()){case 11:{let W=0;try{W=JSON.parse(t.getTokenValue()),typeof W!="number"&&(G(2),W=0)}catch{G(2)}J(W);break}case 7:J(null);break;case 8:J(!0);break;case 9:J(!1);break;default:return!1}return _(),!0}function O(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(re(!1),t.getToken()===6?(ne(":"),_(),K()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function M(){v(),_();let W=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(W||G(4,[],[]),ne(","),_(),t.getToken()===2&&he)break}else W&&G(6,[],[]);O()||G(4,[],[2,5]),W=!0}return P(),t.getToken()!==2?G(7,[2],[]):_(),!0}function x(){k(),_();let W=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(W||G(4,[],[]),ne(","),_(),t.getToken()===4&&he)break}else W&&G(6,[],[]);K()||G(4,[],[4,5]),W=!0}return U(),t.getToken()!==4?G(8,[4],[]):_(),!0}function K(){switch(t.getToken()){case 3:return x();case 1:return M();case 10:return re(!0);default:return z()}}return _(),t.getToken()===17?e.allowEmptyContent?!0:(G(4,[],[]),!1):K()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}i.visit=f;function s(n,o){let e=C(n),t=[],r,c=0,v;do switch(v=e.getPosition(),r=e.scan(),r){case 12:case 13:case 17:c!==v&&t.push(n.substring(c,v)),o!==void 0&&t.push(e.getTokenValue().replace(/[^\r\n]/g,o)),c=e.getPosition();break}while(r!==17);return t.join("")}i.stripComments=s;function a(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=a}),function(){function B(w){const I=[];typeof w=="number"&&I.push("code/timeOrigin",w);function C(l){I.push(l,Date.now())}function S(){const l=[];for(let m=0;m<I.length;m+=2)l.push({name:I[m],startTime:I[m+1]});return l}return{mark:C,getMarks:S}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const C of performance.getEntriesByType("mark"))I.push({name:C.name,startTime:Math.round(w+C.startTime)});return I}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function T(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=i()),w.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=T(R))}(),define(ee[58],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var T;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(T=i.Source||(i.Source={}));var R;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(R=i.TerminateResponseCode||(i.TerminateResponseCode={}));function w(I,...C){const S=C.reduce((y,D)=>(y[D]=!0,y),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(y=>!S[y]).forEach(y=>{for(let D=0;D<l.length;D++)if(y.search(l[D])!==-1){delete I[y];break}})}i.sanitizeProcessEnvironment=w}),function(B,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var T=i();for(var R in T)(typeof exports=="object"?exports:B)[R]=T[R]}}(typeof self!="undefined"?self:this,function(){return function(B){var i={};function T(R){if(i[R])return i[R].exports;var w=i[R]={i:R,l:!1,exports:{}};return B[R].call(w.exports,w,w.exports,T),w.l=!0,w.exports}return T.m=B,T.c=i,T.d=function(R,w,I){T.o(R,w)||Object.defineProperty(R,w,{enumerable:!0,get:I})},T.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},T.t=function(R,w){if(1&w&&(R=T(R)),8&w||4&w&&typeof R=="object"&&R&&R.__esModule)return R;var I=Object.create(null);if(T.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:R}),2&w&&typeof R!="string")for(var C in R)T.d(I,C,function(S){return R[S]}.bind(null,C));return I},T.n=function(R){var w=R&&R.__esModule?function(){return R.default}:function(){return R};return T.d(w,"a",w),w},T.o=function(R,w){return Object.prototype.hasOwnProperty.call(R,w)},T.p="",T(T.s=0)}([function(B,i,T){(function(R){var w;i=B.exports=$,w=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var A=Array.prototype.slice.call(arguments,0);A.unshift("SEMVER"),console.log.apply(console,A)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var I=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,S=i.re=[],l=i.src=[],m=0,y=m++;l[y]="0|[1-9]\\d*";var D=m++;l[D]="[0-9]+";var u=m++;l[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=m++;l[E]="("+l[y]+")\\.("+l[y]+")\\.("+l[y]+")";var d=m++;l[d]="("+l[D]+")\\.("+l[D]+")\\.("+l[D]+")";var g=m++;l[g]="(?:"+l[y]+"|"+l[u]+")";var h=m++;l[h]="(?:"+l[D]+"|"+l[u]+")";var p=m++;l[p]="(?:-("+l[g]+"(?:\\."+l[g]+")*))";var b=m++;l[b]="(?:-?("+l[h]+"(?:\\."+l[h]+")*))";var f=m++;l[f]="[0-9A-Za-z-]+";var s=m++;l[s]="(?:\\+("+l[f]+"(?:\\."+l[f]+")*))";var a=m++,n="v?"+l[E]+l[p]+"?"+l[s]+"?";l[a]="^"+n+"$";var o="[v=\\s]*"+l[d]+l[b]+"?"+l[s]+"?",e=m++;l[e]="^"+o+"$";var t=m++;l[t]="((?:<|>)?=?)";var r=m++;l[r]=l[D]+"|x|X|\\*";var c=m++;l[c]=l[y]+"|x|X|\\*";var v=m++;l[v]="[v=\\s]*("+l[c]+")(?:\\.("+l[c]+")(?:\\.("+l[c]+")(?:"+l[p]+")?"+l[s]+"?)?)?";var L=m++;l[L]="[v=\\s]*("+l[r]+")(?:\\.("+l[r]+")(?:\\.("+l[r]+")(?:"+l[b]+")?"+l[s]+"?)?)?";var P=m++;l[P]="^"+l[t]+"\\s*"+l[v]+"$";var k=m++;l[k]="^"+l[t]+"\\s*"+l[L]+"$";var U=m++;l[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var J=m++;l[J]="(?:~>?)";var ne=m++;l[ne]="(\\s*)"+l[J]+"\\s+",S[ne]=new RegExp(l[ne],"g");var ge=m++;l[ge]="^"+l[J]+l[v]+"$";var oe=m++;l[oe]="^"+l[J]+l[L]+"$";var ie=m++;l[ie]="(?:\\^)";var he=m++;l[he]="(\\s*)"+l[ie]+"\\s+",S[he]=new RegExp(l[he],"g");var _=m++;l[_]="^"+l[ie]+l[v]+"$";var G=m++;l[G]="^"+l[ie]+l[L]+"$";var re=m++;l[re]="^"+l[t]+"\\s*("+o+")$|^$";var z=m++;l[z]="^"+l[t]+"\\s*("+n+")$|^$";var O=m++;l[O]="(\\s*)"+l[t]+"\\s*("+o+"|"+l[v]+")",S[O]=new RegExp(l[O],"g");var M=m++;l[M]="^\\s*("+l[v]+")\\s+-\\s+("+l[v]+")\\s*$";var x=m++;l[x]="^\\s*("+l[L]+")\\s+-\\s+("+l[L]+")\\s*$";var K=m++;l[K]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)w(W,l[W]),S[W]||(S[W]=new RegExp(l[W]));function X(A,q){if(A instanceof $)return A;if(typeof A!="string"||A.length>I||!(q?S[e]:S[a]).test(A))return null;try{return new $(A,q)}catch{return null}}function $(A,q){if(A instanceof $){if(A.loose===q)return A;A=A.version}else if(typeof A!="string")throw new TypeError("Invalid Version: "+A);if(A.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof $))return new $(A,q);w("SemVer",A,q),this.loose=q;var H=A.trim().match(q?S[e]:S[a]);if(!H)throw new TypeError("Invalid Version: "+A);if(this.raw=A,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var me=+de;if(me>=0&&me<C)return me}return de}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}i.parse=X,i.valid=function(A,q){var H=X(A,q);return H?H.version:null},i.clean=function(A,q){var H=X(A.trim().replace(/^[=v]+/,""),q);return H?H.version:null},i.SemVer=$,$.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$.prototype.toString=function(){return this.version},$.prototype.compare=function(A){return w("SemVer.compare",this.version,this.loose,A),A instanceof $||(A=new $(A,this.loose)),this.compareMain(A)||this.comparePre(A)},$.prototype.compareMain=function(A){return A instanceof $||(A=new $(A,this.loose)),N(this.major,A.major)||N(this.minor,A.minor)||N(this.patch,A.patch)},$.prototype.comparePre=function(A){if(A instanceof $||(A=new $(A,this.loose)),this.prerelease.length&&!A.prerelease.length)return-1;if(!this.prerelease.length&&A.prerelease.length)return 1;if(!this.prerelease.length&&!A.prerelease.length)return 0;var q=0;do{var H=this.prerelease[q],de=A.prerelease[q];if(w("prerelease compare",q,H,de),H===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(H===void 0)return-1;if(H!==de)return N(H,de)}while(++q)},$.prototype.inc=function(A,q){switch(A){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+A)}return this.format(),this.raw=this.version,this},i.inc=function(A,q,H,de){typeof H=="string"&&(de=H,H=void 0);try{return new $(A,H).inc(q,de).version}catch{return null}},i.diff=function(A,q){if(Q(A,q))return null;var H=X(A),de=X(q);if(H.prerelease.length||de.prerelease.length){for(var me in H)if((me==="major"||me==="minor"||me==="patch")&&H[me]!==de[me])return"pre"+me;return"prerelease"}for(var me in H)if((me==="major"||me==="minor"||me==="patch")&&H[me]!==de[me])return me},i.compareIdentifiers=N;var Y=/^[0-9]+$/;function N(A,q){var H=Y.test(A),de=Y.test(q);return H&&de&&(A=+A,q=+q),H&&!de?-1:de&&!H?1:A<q?-1:A>q?1:0}function F(A,q,H){return new $(A,H).compare(new $(q,H))}function V(A,q,H){return F(A,q,H)>0}function j(A,q,H){return F(A,q,H)<0}function Q(A,q,H){return F(A,q,H)===0}function Z(A,q,H){return F(A,q,H)!==0}function fe(A,q,H){return F(A,q,H)>=0}function ae(A,q,H){return F(A,q,H)<=0}function se(A,q,H,de){var me;switch(q){case"===":typeof A=="object"&&(A=A.version),typeof H=="object"&&(H=H.version),me=A===H;break;case"!==":typeof A=="object"&&(A=A.version),typeof H=="object"&&(H=H.version),me=A!==H;break;case"":case"=":case"==":me=Q(A,H,de);break;case"!=":me=Z(A,H,de);break;case">":me=V(A,H,de);break;case">=":me=fe(A,H,de);break;case"<":me=j(A,H,de);break;case"<=":me=ae(A,H,de);break;default:throw new TypeError("Invalid operator: "+q)}return me}function le(A,q){if(A instanceof le){if(A.loose===q)return A;A=A.value}if(!(this instanceof le))return new le(A,q);w("comparator",A,q),this.loose=q,this.parse(A),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}i.rcompareIdentifiers=function(A,q){return N(q,A)},i.major=function(A,q){return new $(A,q).major},i.minor=function(A,q){return new $(A,q).minor},i.patch=function(A,q){return new $(A,q).patch},i.compare=F,i.compareLoose=function(A,q){return F(A,q,!0)},i.rcompare=function(A,q,H){return F(q,A,H)},i.sort=function(A,q){return A.sort(function(H,de){return i.compare(H,de,q)})},i.rsort=function(A,q){return A.sort(function(H,de){return i.rcompare(H,de,q)})},i.gt=V,i.lt=j,i.eq=Q,i.neq=Z,i.gte=fe,i.lte=ae,i.cmp=se,i.Comparator=le;var ye={};function ue(A,q){if(A instanceof ue)return A.loose===q?A:new ue(A.raw,q);if(A instanceof le)return new ue(A.value,q);if(!(this instanceof ue))return new ue(A,q);if(this.loose=q,this.raw=A,this.set=A.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+A);this.format()}function Ee(A){return!A||A.toLowerCase()==="x"||A==="*"}function Se(A,q,H,de,me,Ce,be,Ae,Re,ke,Ue,De,Te){return((q=Ee(H)?"":Ee(de)?">="+H+".0.0":Ee(me)?">="+H+"."+de+".0":">="+q)+" "+(Ae=Ee(Re)?"":Ee(ke)?"<"+(+Re+1)+".0.0":Ee(Ue)?"<"+Re+"."+(+ke+1)+".0":De?"<="+Re+"."+ke+"."+Ue+"-"+De:"<="+Ae)).trim()}function Oe(A,q){for(var H=0;H<A.length;H++)if(!A[H].test(q))return!1;if(q.prerelease.length){for(H=0;H<A.length;H++)if(w(A[H].semver),A[H].semver!==ye&&A[H].semver.prerelease.length>0){var de=A[H].semver;if(de.major===q.major&&de.minor===q.minor&&de.patch===q.patch)return!0}return!1}return!0}function Fe(A,q,H){try{q=new ue(q,H)}catch{return!1}return q.test(A)}function ze(A,q,H,de){var me,Ce,be,Ae,Re;switch(A=new $(A,de),q=new ue(q,de),H){case">":me=V,Ce=ae,be=j,Ae=">",Re=">=";break;case"<":me=j,Ce=fe,be=V,Ae="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(A,q,de))return!1;for(var ke=0;ke<q.set.length;++ke){var Ue=q.set[ke],De=null,Te=null;if(Ue.forEach(function(Ne){Ne.semver===ye&&(Ne=new le(">=0.0.0")),De=De||Ne,Te=Te||Ne,me(Ne.semver,De.semver,de)?De=Ne:be(Ne.semver,Te.semver,de)&&(Te=Ne)}),De.operator===Ae||De.operator===Re||(!Te.operator||Te.operator===Ae)&&Ce(A,Te.semver)||Te.operator===Re&&be(A,Te.semver))return!1}return!0}le.prototype.parse=function(A){var q=this.loose?S[re]:S[z],H=A.match(q);if(!H)throw new TypeError("Invalid comparator: "+A);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new $(H[2],this.loose):this.semver=ye},le.prototype.toString=function(){return this.value},le.prototype.test=function(A){return w("Comparator.test",A,this.loose),this.semver===ye||(typeof A=="string"&&(A=new $(A,this.loose)),se(A,this.operator,this.semver,this.loose))},le.prototype.intersects=function(A,q){if(!(A instanceof le))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new ue(A.value,q),Fe(this.value,H,q);if(A.operator==="")return H=new ue(this.value,q),Fe(A.semver,H,q);var de=!(this.operator!==">="&&this.operator!==">"||A.operator!==">="&&A.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||A.operator!=="<="&&A.operator!=="<"),Ce=this.semver.version===A.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||A.operator!==">="&&A.operator!=="<="),Ae=se(this.semver,"<",A.semver,q)&&(this.operator===">="||this.operator===">")&&(A.operator==="<="||A.operator==="<"),Re=se(this.semver,">",A.semver,q)&&(this.operator==="<="||this.operator==="<")&&(A.operator===">="||A.operator===">");return de||me||Ce&&be||Ae||Re},i.Range=ue,ue.prototype.format=function(){return this.range=this.set.map(function(A){return A.join(" ").trim()}).join("||").trim(),this.range},ue.prototype.toString=function(){return this.range},ue.prototype.parseRange=function(A){var q=this.loose;A=A.trim(),w("range",A,q);var H=q?S[x]:S[M];A=A.replace(H,Se),w("hyphen replace",A),A=A.replace(S[O],"$1$2$3"),w("comparator trim",A,S[O]),A=(A=(A=A.replace(S[ne],"$1~")).replace(S[he],"$1^")).split(/\s+/).join(" ");var de=q?S[re]:S[z],me=A.split(" ").map(function(Ce){return function(be,Ae){return w("comp",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){w("caret",De,Te);var Ne=Te?S[G]:S[_];return De.replace(Ne,function(Me,ve,we,Pe,Ie){var Le;return w("caret",De,Me,ve,we,Pe,Ie),Ee(ve)?Le="":Ee(we)?Le=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(Pe)?Le=ve==="0"?">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+".0 <"+(+ve+1)+".0.0":Ie?(w("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=ve==="0"?we==="0"?">="+ve+"."+we+"."+Pe+Ie+" <"+ve+"."+we+"."+(+Pe+1):">="+ve+"."+we+"."+Pe+Ie+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Pe+Ie+" <"+(+ve+1)+".0.0"):(w("no pr"),Le=ve==="0"?we==="0"?">="+ve+"."+we+"."+Pe+" <"+ve+"."+we+"."+(+Pe+1):">="+ve+"."+we+"."+Pe+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Pe+" <"+(+ve+1)+".0.0"),w("caret return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),w("caret",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){var Ne=Te?S[oe]:S[ge];return De.replace(Ne,function(Me,ve,we,Pe,Ie){var Le;return w("tilde",De,Me,ve,we,Pe,Ie),Ee(ve)?Le="":Ee(we)?Le=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(Pe)?Le=">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":Ie?(w("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=">="+ve+"."+we+"."+Pe+Ie+" <"+ve+"."+(+we+1)+".0"):Le=">="+ve+"."+we+"."+Pe+" <"+ve+"."+(+we+1)+".0",w("tilde return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),w("tildes",be),be=function(Re,ke){return w("replaceXRanges",Re,ke),Re.split(/\s+/).map(function(Ue){return function(De,Te){De=De.trim();var Ne=Te?S[k]:S[P];return De.replace(Ne,function(Me,ve,we,Pe,Ie,Le){w("xRange",De,Me,ve,we,Pe,Ie,Le);var We=Ee(we),Ve=We||Ee(Pe),je=Ve||Ee(Ie);return ve==="="&&je&&(ve=""),We?Me=ve===">"||ve==="<"?"<0.0.0":"*":ve&&je?(Ve&&(Pe=0),je&&(Ie=0),ve===">"?(ve=">=",Ve?(we=+we+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ve==="<="&&(ve="<",Ve?we=+we+1:Pe=+Pe+1),Me=ve+we+"."+Pe+"."+Ie):Ve?Me=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(Me=">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0"),w("xRange return",Me),Me})}(Ue,ke)}).join(" ")}(be,Ae),w("xrange",be),be=function(Re,ke){return w("replaceStars",Re,ke),Re.trim().replace(S[K],"")}(be,Ae),w("stars",be),be}(Ce,q)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(de)})),me=me.map(function(Ce){return new le(Ce,q)})},ue.prototype.intersects=function(A,q){if(!(A instanceof ue))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(de){return A.set.some(function(me){return me.every(function(Ce){return de.intersects(Ce,q)})})})})},i.toComparators=function(A,q){return new ue(A,q).set.map(function(H){return H.map(function(de){return de.value}).join(" ").trim().split(" ")})},ue.prototype.test=function(A){if(!A)return!1;typeof A=="string"&&(A=new $(A,this.loose));for(var q=0;q<this.set.length;q++)if(Oe(this.set[q],A))return!0;return!1},i.satisfies=Fe,i.maxSatisfying=function(A,q,H){var de=null,me=null;try{var Ce=new ue(q,H)}catch{return null}return A.forEach(function(be){Ce.test(be)&&(de&&me.compare(be)!==-1||(me=new $(de=be,H)))}),de},i.minSatisfying=function(A,q,H){var de=null,me=null;try{var Ce=new ue(q,H)}catch{return null}return A.forEach(function(be){Ce.test(be)&&(de&&me.compare(be)!==1||(me=new $(de=be,H)))}),de},i.validRange=function(A,q){try{return new ue(A,q).range||"*"}catch{return null}},i.ltr=function(A,q,H){return ze(A,q,"<",H)},i.gtr=function(A,q,H){return ze(A,q,">",H)},i.outside=ze,i.prerelease=function(A,q){var H=X(A,q);return H&&H.prerelease.length?H.prerelease:null},i.intersects=function(A,q,H){return A=new ue(A,H),q=new ue(q,H),A.intersects(q)},i.coerce=function(A){if(A instanceof $)return A;if(typeof A!="string")return null;var q=A.match(S[U]);return q==null?null:X((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,T(1))},function(B,i){var T,R,w=B.exports={};function I(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function S(h){if(T===setTimeout)return setTimeout(h,0);if((T===I||!T)&&setTimeout)return T=setTimeout,setTimeout(h,0);try{return T(h,0)}catch{try{return T.call(null,h,0)}catch{return T.call(this,h,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:I}catch{T=I}try{R=typeof clearTimeout=="function"?clearTimeout:C}catch{R=C}})();var l,m=[],y=!1,D=-1;function u(){y&&l&&(y=!1,l.length?m=l.concat(m):D=-1,m.length&&E())}function E(){if(!y){var h=S(u);y=!0;for(var p=m.length;p;){for(l=m,m=[];++D<p;)l&&l[D].run();D=-1,p=m.length}l=null,y=!1,function(b){if(R===clearTimeout)return clearTimeout(b);if((R===C||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(b);try{R(b)}catch{try{return R.call(null,b)}catch{return R.call(this,b)}}}(h)}}function d(h,p){this.fun=h,this.array=p}function g(){}w.nextTick=function(h){var p=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)p[b-1]=arguments[b];m.push(new d(h,p)),m.length!==1||y||S(E)},d.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=g,w.addListener=g,w.once=g,w.off=g,w.removeListener=g,w.removeAllListeners=g,w.emit=g,w.prependListener=g,w.prependOnceListener=g,w.listeners=function(h){return[]},w.binding=function(h){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(h){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(ee[59],te([0,1]),function(B,i){"use strict";var T;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class R{constructor(S,l,m){this.level=S,this.key=l,this.value=m,this.forward=[]}}const w=void 0;class I{constructor(S,l=2**16){this.comparator=S,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new R(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,w,w)}has(S){return Boolean(I._search(this,S,this.comparator))}get(S){return I._search(this,S,this.comparator)?.value}set(S,l){return I._insert(this,S,l,this.comparator)&&(this._size+=1),this}delete(S){const l=I._delete(this,S,this.comparator);return l&&(this._size-=1),l}forEach(S,l){let m=this._header.forward[0];for(;m;)S.call(l,m.value,m.key,this),m=m.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",l=this._header.forward[0];for(;l;)S+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return S}static _search(S,l,m){let y=S._header;for(let D=S._level-1;D>=0;D--)for(;y.forward[D]&&m(y.forward[D].key,l)<0;)y=y.forward[D];if(y=y.forward[0],y&&m(y.key,l)===0)return y}static _insert(S,l,m,y){let D=[],u=S._header;for(let E=S._level-1;E>=0;E--){for(;u.forward[E]&&y(u.forward[E].key,l)<0;)u=u.forward[E];D[E]=u}if(u=u.forward[0],u&&y(u.key,l)===0)return u.value=m,!1;{let E=I._randomLevel(S);if(E>S._level){for(let d=S._level;d<E;d++)D[d]=S._header;S._level=E}u=new R(E,l,m);for(let d=0;d<E;d++)u.forward[d]=D[d].forward[d],D[d].forward[d]=u;return!0}}static _randomLevel(S,l=.5){let m=1;for(;Math.random()<l&&m<S._maxLevel;)m+=1;return m}static _delete(S,l,m){let y=[],D=S._header;for(let u=S._level-1;u>=0;u--){for(;D.forward[u]&&m(D.forward[u].key,l)<0;)D=D.forward[u];y[u]=D}if(D=D.forward[0],!D||m(D.key,l)!==0)return!1;for(let u=0;u<S._level&&y[u].forward[u]===D;u++)y[u].forward[u]=D.forward[u];for(;S._level>0&&S._header.forward[S._level-1]===w;)S._level-=1;return!0}}i.SkipList=I}),define(ee[37],te([0,1,7,2]),function(B,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function w(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}i.isReadableStream=w;function I(f){const s=f;return s?w(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=I;function C(f,s){return new S(f,s)}i.newWriteableStream=C;class S{constructor(s,a){this.reducer=s,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(a=>a(s))}emitError(s){this.listeners.error.length===0?(0,T.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(a=>a(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,a){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(s,a){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const o=n.indexOf(a);o>=0&&n.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,s){const a=[];let n;for(;(n=f.read())!==null;)a.push(n);return s(a)}i.consumeReadable=l;function m(f,s,a){const n=[];let o;for(;(o=f.read())!==null&&n.length<a;)n.push(o);return o===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof o!="undefined"){const e=o;return o=void 0,e}return f.read()}}}i.peekReadable=m;function y(f,s){return new Promise((a,n)=>{const o=[];D(f,{onData:e=>{s&&o.push(e)},onError:e=>{s?n(e):a(void 0)},onEnd:()=>{a(s?s(o):void 0)}})})}i.consumeStream=y;function D(f,s){let a=!1;return f.on("error",n=>{a||s.onError(n)}),f.on("end",()=>{a||s.onEnd()}),f.on("data",n=>{a||s.onData(n)}),(0,R.toDisposable)(()=>a=!0)}i.listenStream=D;function u(f,s){return new Promise((a,n)=>{const o=new R.DisposableStore,e=[],t=v=>{if(e.push(v),e.length>s)return o.dispose(),f.pause(),a({stream:f,buffer:e,ended:!1})},r=v=>n(v),c=()=>a({stream:f,buffer:e,ended:!0});o.add((0,R.toDisposable)(()=>f.removeListener("error",r))),f.on("error",r),o.add((0,R.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),o.add((0,R.toDisposable)(()=>f.removeListener("data",t))),f.on("data",t)})}i.peekStream=u;function E(f,s){const a=C(s);return a.end(f),a}i.toStream=E;function d(){const f=C(()=>{throw new Error("not supported")});return f.end(),f}i.emptyStream=d;function g(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}i.toReadable=g;function h(f,s,a){const n=C(a);return D(f,{onData:o=>n.write(s.data(o)),onError:o=>n.error(s.error?s.error(o):o),onEnd:()=>n.end()}),n}i.transform=h;function p(f,s,a){let n=!1;return{read:()=>{const o=s.read();return n?o:(n=!0,o!==null?a([f,o]):f)}}}i.prefixedReadable=p;function b(f,s,a){let n=!1;const o=C(a);return D(s,{onData:e=>n?o.write(e):(n=!0,o.write(a([f,e]))),onError:e=>o.error(e),onEnd:()=>{n||(n=!0,o.write(f)),o.end()}}),o}i.prefixedStream=b}),define(ee[17],te([0,1,37]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const R=typeof Buffer!="undefined";let w,I;class C{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return R?new C(Buffer.allocUnsafe(t)):new C(new Uint8Array(t))}static wrap(t){return R&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new C(t)}static fromString(t,r){return!(r?.dontUseNodeBuffer||!1)&&R?new C(Buffer.from(t)):(w||(w=new TextEncoder),new C(w.encode(t)))}static fromByteArray(t){const r=C.alloc(t.length);for(let c=0,v=t.length;c<v;c++)r.buffer[c]=t[c];return r}static concat(t,r){if(typeof r=="undefined"){r=0;for(let L=0,P=t.length;L<P;L++)r+=t[L].byteLength}const c=C.alloc(r);let v=0;for(let L=0,P=t.length;L<P;L++){const k=t[L];c.set(k,v),v+=k.byteLength}return c}clone(){const t=C.alloc(this.byteLength);return t.set(this),t}toString(){return R?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(t,r){return new C(this.buffer.subarray(t,r))}set(t,r){if(t instanceof C)this.buffer.set(t.buffer,r);else if(t instanceof Uint8Array)this.buffer.set(t,r);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),r);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),r);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return m(this.buffer,t)}writeUInt32BE(t,r){y(this.buffer,t,r)}readUInt32LE(t){return D(this.buffer,t)}writeUInt32LE(t,r){u(this.buffer,t,r)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,r){d(this.buffer,t,r)}}i.VSBuffer=C;function S(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0}i.readUInt16LE=S;function l(e,t,r){e[r+0]=t&255,t=t>>>8,e[r+1]=t&255}i.writeUInt16LE=l;function m(e,t){return e[t]*2**24+e[t+1]*2**16+e[t+2]*2**8+e[t+3]}i.readUInt32BE=m;function y(e,t,r){e[r+3]=t,t=t>>>8,e[r+2]=t,t=t>>>8,e[r+1]=t,t=t>>>8,e[r]=t}i.writeUInt32BE=y;function D(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}i.readUInt32LE=D;function u(e,t,r){e[r+0]=t&255,t=t>>>8,e[r+1]=t&255,t=t>>>8,e[r+2]=t&255,t=t>>>8,e[r+3]=t&255}i.writeUInt32LE=u;function E(e,t){return e[t]}i.readUInt8=E;function d(e,t,r){e[r]=t}i.writeUInt8=d;function g(e){return T.consumeReadable(e,t=>C.concat(t))}i.readableToBuffer=g;function h(e){return T.toReadable(e)}i.bufferToReadable=h;function p(e){return T.consumeStream(e,t=>C.concat(t))}i.streamToBuffer=p;async function b(e){return e.ended?C.concat(e.buffer):C.concat([...e.buffer,await p(e.stream)])}i.bufferedStreamToBuffer=b;function f(e){return T.toStream(e,t=>C.concat(t))}i.bufferToStream=f;function s(e){return T.transform(e,{data:t=>typeof t=="string"?C.fromString(t):C.wrap(t)},t=>C.concat(t))}i.streamToBufferReadableStream=s;function a(e){return T.newWriteableStream(t=>C.concat(t),e)}i.newWriteableBufferStream=a;function n(e,t){return T.prefixedReadable(e,t,r=>C.concat(r))}i.prefixedBufferReadable=n;function o(e,t){return T.prefixedStream(e,t,r=>C.concat(r))}i.prefixedBufferStream=o}),define(ee[21],te([0,1,8]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.keys(g).forEach(p=>{g[p]&&typeof g[p]=="object"?h[p]=R(g[p]):h[p]=g[p]}),h}i.deepClone=R;function w(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const p=h.shift();Object.freeze(p);for(const b in p)if(I.call(p,b)){const f=p[b];typeof f=="object"&&!Object.isFrozen(f)&&h.push(f)}}return g}i.deepFreeze=w;const I=Object.prototype.hasOwnProperty;function C(g,h){return S(g,h,new Set)}i.cloneAndChange=C;function S(g,h,p){if((0,T.isUndefinedOrNull)(g))return g;const b=h(g);if(typeof b!="undefined")return b;if((0,T.isArray)(g)){const f=[];for(const s of g)f.push(S(s,h,p));return f}if((0,T.isObject)(g)){if(p.has(g))throw new Error("Cannot clone recursive data-structure");p.add(g);const f={};for(let s in g)I.call(g,s)&&(f[s]=S(g[s],h,p));return p.delete(g),f}return g}function l(g,h,p=!0){return(0,T.isObject)(g)?((0,T.isObject)(h)&&Object.keys(h).forEach(b=>{b in g?p&&((0,T.isObject)(g[b])&&(0,T.isObject)(h[b])?l(g[b],h[b],p):g[b]=h[b]):g[b]=h[b]}),g):h}i.mixin=l;function m(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let p,b;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(p=0;p<g.length;p++)if(!m(g[p],h[p]))return!1}else{const f=[];for(b in g)f.push(b);f.sort();const s=[];for(b in h)s.push(b);if(s.sort(),!m(f,s))return!1;for(p=0;p<f.length;p++)if(!m(g[f[p]],h[f[p]]))return!1}return!0}i.equals=m;function y(g){const h=new Set;return JSON.stringify(g,(p,b)=>{if((0,T.isObject)(b)||Array.isArray(b)){if(h.has(b))return"[Circular]";h.add(b)}return b})}i.safeStringify=y;function D(g,h,p){const b=h(g);return typeof b=="undefined"?p:b}i.getOrDefault=D;function u(g,h){const p=Object.create(null);return!g||!h||Object.keys(h).forEach(f=>{const s=g[f],a=h[f];m(s,a)||(p[f]=a)}),p}i.distinct=u;function E(g,h){const p=h.toLowerCase(),b=Object.keys(g).find(f=>f.toLowerCase()===p);return b?g[b]:g[h]}i.getCaseInsensitive=E;function d(g,h){const p=Object.create(null);for(const[b,f]of Object.entries(g))h(b,f)&&(p[b]=f);return p}i.filter=d}),define(ee[60],te([0,1,9]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function R(m){const y=m;return y&&typeof y.type=="string"&&typeof y.severity=="string"}i.isRemoteConsoleLog=R;function w(m){const y=[];let D;try{const u=JSON.parse(m.arguments),E=u[u.length-1];E&&E.__$stack&&(u.pop(),D=E.__$stack),y.push(...u)}catch{y.push("Unable to log remote console arguments",m.arguments)}return{args:y,stack:D}}i.parse=w;function I(m){if(typeof m!="string")return I(w(m).stack);const y=m;if(y){const D=C(y),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(u&&u.length===4)return{uri:T.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}i.getFirstFrame=I;function C(m){if(!m)return m;const y=m.indexOf(`
`);return y===-1?m:m.substring(0,y)}function S(m,y){const{args:D,stack:u}=w(m),E=typeof D[0]=="string"&&D.length===1;let d=C(u);d&&(d=`(${d.trim()})`);let g=[];if(typeof D[0]=="string"?d&&E?g=[`%c[${y}] %c${D[0]} %c${d}`,l("blue"),l(""),l("grey")]:g=[`%c[${y}] %c${D[0]}`,l("blue"),l(""),...D.slice(1)]:g=[`%c[${y}]%`,l("blue"),...D],d&&!E&&g.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,g)}i.log=S;function l(m){return`color: ${m}`}}),define(ee[61],te([0,1,17,24,9]),function(B,i,T,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function I(y){return JSON.stringify(y,l)}i.stringify=I;function C(y){let D=JSON.parse(y);return D=m(D),D}i.parse=C;var S;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(S=i.MarshalledId||(i.MarshalledId={}));function l(y,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,R.regExpFlags)(D)}:D}function m(y,D=0){if(!y||D>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return w.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof T.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let u=0;u<y.length;++u)y[u]=m(y[u],D+1);else for(const u in y)Object.hasOwnProperty.call(y,u)&&(y[u]=m(y[u],D+1))}return y}i.revive=m}),define(ee[62],te([0,1,3,38,39,4,24]),function(B,i,T,R,w,I,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPathTerms=i.getBasenameTerms=i.isRelativePattern=i.hasSiblingFn=i.hasSiblingPromiseFn=i.parse=i.match=i.splitGlobAware=i.getEmptyExpression=void 0;function S(){return Object.create(null)}i.getEmptyExpression=S;const l="**",m="/",y="[/\\\\]",D="[^/\\\\]",u=/\//g;function E(O){switch(O){case 0:return"";case 1:return`${D}*?`;default:return`(?:${y}|${D}+${y}|${y}${D}+)*?`}}function d(O,M){if(!O)return[];const x=[];let K=!1,W=!1,X="";for(const $ of O){switch($){case M:if(!K&&!W){x.push(X),X="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":W=!0;break;case"]":W=!1;break}X+=$}return X&&x.push(X),x}i.splitGlobAware=d;function g(O){if(!O)return"";let M="";const x=d(O,m);if(x.every(K=>K===l))M=".*";else{let K=!1;x.forEach((W,X)=>{if(W===l){K||(M+=E(2),K=!0);return}let $=!1,Y="",N=!1,F="";for(const V of W){if(V!=="}"&&$){Y+=V;continue}if(N&&(V!=="]"||!F)){let j;V==="-"?j=V:(V==="^"||V==="!")&&!F?j="^":V===m?j="":j=C.escapeRegExpCharacters(V),F+=j;continue}switch(V){case"{":$=!0;continue;case"[":N=!0;continue;case"}":{M+=`(?:${d(Y,",").map(Z=>g(Z)).join("|")})`,$=!1,Y="";break}case"]":M+="["+F+"]",N=!1,F="";break;case"?":M+=D;continue;case"*":M+=E(1);continue;default:M+=C.escapeRegExpCharacters(V)}}X<x.length-1&&(x[X+1]!==l||X+2<x.length)&&(M+=y),K=!1})}return M}const h=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new w.LRUCache(1e4),o=function(){return!1},e=function(){return null};function t(O,M){if(!O)return e;let x;typeof O!="string"?x=O.pattern:x=O,x=x.trim();const K=`${x}_${!!M.trimForExclusions}`;let W=n.get(K);if(W)return r(W,O);let X;if(h.test(x)){const $=x.substr(4);W=function(Y,N){return typeof Y=="string"&&Y.endsWith($)?x:null}}else(X=p.exec(c(x,M)))?W=v(X[1],x):(M.trimForExclusions?f:b).test(x)?W=L(x,M):(X=s.exec(c(x,M)))?W=P(X[1].substr(1),x,!0):(X=a.exec(c(x,M)))?W=P(X[1],x,!1):W=k(x);return n.set(K,W),r(W,O)}function r(O,M){return typeof M=="string"?O:function(x,K){return R.isEqualOrParent(x,M.base)?O(I.relative(M.base,x),K):null}}function c(O,M){return M.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function v(O,M){const x=`/${O}`,K=`\\${O}`,W=function($,Y){return typeof $!="string"?null:Y?Y===O?M:null:$===O||$.endsWith(x)||$.endsWith(K)?M:null},X=[O];return W.basenames=X,W.patterns=[M],W.allBasenames=X,W}function L(O,M){const x=z(O.slice(1,-1).split(",").map(Y=>t(Y,M)).filter(Y=>Y!==e),O),K=x.length;if(!K)return e;if(K===1)return x[0];const W=function(Y,N){for(let F=0,V=x.length;F<V;F++)if(x[F](Y,N))return O;return null},X=x.find(Y=>!!Y.allBasenames);X&&(W.allBasenames=X.allBasenames);const $=x.reduce((Y,N)=>N.allPaths?Y.concat(N.allPaths):Y,[]);return $.length&&(W.allPaths=$),W}function P(O,M,x){const K=I.sep===I.posix.sep,W=K?O:O.replace(u,I.sep),X=I.sep+W,$=I.posix.sep+O,Y=x?function(N,F){return typeof N=="string"&&(N===W||N.endsWith(X)||!K&&(N===O||N.endsWith($)))?M:null}:function(N,F){return typeof N=="string"&&(N===W||!K&&N===O)?M:null};return Y.allPaths=[(x?"*/":"./")+O],Y}function k(O){try{const M=new RegExp(`^${g(O)}$`);return function(x){return M.lastIndex=0,typeof x=="string"&&M.test(x)?O:null}}catch{return e}}function U(O,M,x){return!O||typeof M!="string"?!1:J(O)(M,void 0,x)}i.match=U;function J(O,M={}){if(!O)return o;if(typeof O=="string"||ie(O)){const x=t(O,M);if(x===e)return o;const K=function(W,X){return!!x(W,X)};return x.allBasenames&&(K.allBasenames=x.allBasenames),x.allPaths&&(K.allPaths=x.allPaths),K}return G(O,M)}i.parse=J;function ne(O){if(!O)return;let M;return x=>(M||(M=(O()||Promise.resolve([])).then(K=>K?oe(K):{})),M.then(K=>!!K[x]))}i.hasSiblingPromiseFn=ne;function ge(O){if(!O)return;let M;return x=>{if(!M){const K=O();M=K?oe(K):{}}return!!M[x]}}i.hasSiblingFn=ge;function oe(O){const M={};for(const x of O)M[x]=!0;return M}function ie(O){const M=O;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}i.isRelativePattern=ie;function he(O){return O.allBasenames||[]}i.getBasenameTerms=he;function _(O){return O.allPaths||[]}i.getPathTerms=_;function G(O,M){const x=z(Object.getOwnPropertyNames(O).map(Y=>re(Y,O[Y],M)).filter(Y=>Y!==e)),K=x.length;if(!K)return e;if(!x.some(Y=>!!Y.requiresSiblings)){if(K===1)return x[0];const Y=function(V,j){for(let Q=0,Z=x.length;Q<Z;Q++){const fe=x[Q](V,j);if(fe)return fe}return null},N=x.find(V=>!!V.allBasenames);N&&(Y.allBasenames=N.allBasenames);const F=x.reduce((V,j)=>j.allPaths?V.concat(j.allPaths):V,[]);return F.length&&(Y.allPaths=F),Y}const W=function(Y,N,F){let V;for(let j=0,Q=x.length;j<Q;j++){const Z=x[j];Z.requiresSiblings&&F&&(N||(N=I.basename(Y)),V||(V=N.substr(0,N.length-I.extname(Y).length)));const fe=Z(Y,N,V,F);if(fe)return fe}return null},X=x.find(Y=>!!Y.allBasenames);X&&(W.allBasenames=X.allBasenames);const $=x.reduce((Y,N)=>N.allPaths?Y.concat(N.allPaths):Y,[]);return $.length&&(W.allPaths=$),W}function re(O,M,x){if(M===!1)return e;const K=t(O,x);if(K===e)return e;if(typeof M=="boolean")return K;if(M){const W=M.when;if(typeof W=="string"){const X=($,Y,N,F)=>{if(!F||!K($,Y))return null;const V=W.replace("$(basename)",N),j=F(V);return(0,T.isThenable)(j)?j.then(Q=>Q?O:null):j?O:null};return X.requiresSiblings=!0,X}}return K}function z(O,M){const x=O.filter(Y=>!!Y.basenames);if(x.length<2)return O;const K=x.reduce((Y,N)=>{const F=N.basenames;return F?Y.concat(F):Y},[]);let W;if(M){W=[];for(let Y=0,N=K.length;Y<N;Y++)W.push(M)}else W=x.reduce((Y,N)=>{const F=N.patterns;return F?Y.concat(F):Y},[]);const X=function(Y,N){if(typeof Y!="string")return null;if(!N){let V;for(V=Y.length;V>0;V--){const j=Y.charCodeAt(V-1);if(j===47||j===92)break}N=Y.substr(V)}const F=K.indexOf(N);return F!==-1?W[F]:null};X.basenames=K,X.patterns=W,X.allBasenames=K;const $=O.filter(Y=>!Y.basenames);return $.push(X),$}}),define(ee[63],te([0,1,38,11,4,12,18,24,9]),function(B,i,T,R,w,I,C,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function m(t,r,c){if(typeof t=="string"&&(t=l.URI.file(t)),c){const L=c.getWorkspaceFolder(t);if(L){const P=c.getWorkspace().folders.length>1;let k;if((0,C.isEqual)(L.uri,t)?k="":k=(0,C.relativePath)(L.uri,t),P){const U=L.name?L.name:(0,C.basename)(L.uri);k=k?U+" \u2022 "+k:U}return k}}if(t.scheme!==R.Schemas.file&&t.scheme!==R.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(t.fsPath))return(0,w.normalize)(D(t.fsPath));let v=(0,w.normalize)(t.fsPath);return!I.isWindows&&r?.userHome&&(v=E(v,r.userHome.fsPath)),v}i.getPathLabel=m;function y(t){if(!t)return;typeof t=="string"&&(t=l.URI.file(t));const r=(0,C.basename)(t)||(t.scheme===R.Schemas.file?t.fsPath:t.path);return I.isWindows&&(0,T.isRootOrDriveLetter)(r)?D(r):r}i.getBaseLabel=y;function D(t,r){return(0,T.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}i.normalizeDriveLetter=D;let u=Object.create(null);function E(t,r){if(I.isWindows||!t||!r)return t;let c=u.original===r?u.normalized:void 0;return c||(c=`${(0,S.rtrim)(r,w.posix.sep)}${w.posix.sep}`,u={original:r,normalized:c}),(I.isLinux?t.startsWith(c):(0,S.startsWithIgnoreCase)(t,c))&&(t=`~/${t.substr(c.length)}`),t}i.tildify=E;function d(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}i.untildify=d;const g="\u2026",h="\\\\",p="~";function b(t,r=w.sep){const c=new Array(t.length);let v=!1;for(let L=0;L<t.length;L++){let P=t[L];if(P===""){c[L]=`.${r}`;continue}if(!P){c[L]=P;continue}v=!0;let k="";P.indexOf(h)===0?(k=P.substr(0,P.indexOf(h)+h.length),P=P.substr(P.indexOf(h)+h.length)):P.indexOf(r)===0?(k=P.substr(0,P.indexOf(r)+r.length),P=P.substr(P.indexOf(r)+r.length)):P.indexOf(p)===0&&(k=P.substr(0,P.indexOf(p)+p.length),P=P.substr(P.indexOf(p)+p.length));const U=P.split(r);for(let J=1;v&&J<=U.length;J++)for(let ne=U.length-J;v&&ne>=0;ne--){v=!1;let ge=U.slice(ne,ne+J).join(r);for(let oe=0;!v&&oe<t.length;oe++)if(oe!==L&&t[oe]&&t[oe].indexOf(ge)>-1){const ie=ne+J===U.length,he=ne>0&&t[oe].indexOf(r)>-1?r+ge:ge,_=t[oe].endsWith(he);v=!ie||_}if(!v){let oe="";(U[0].endsWith(":")||k!=="")&&(ne===1&&(ne=0,J++,ge=U[0]+r+ge),ne>0&&(oe=U[0]+r),oe=k+oe),ne>0&&(oe=oe+g+r),oe=oe+ge,ne+J<U.length&&(oe=oe+r+g),c[L]=oe}}v&&(c[L]=P)}return c}i.shorten=b;var f;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function s(t,r=Object.create(null)){const c=[];let v=!1,L="";for(const P of t)if(P==="$"||v&&P==="{")L&&c.push({value:L,type:f.TEXT}),L="",v=!0;else if(P==="}"&&v){const k=r[L];if(typeof k=="string")k.length&&c.push({value:k,type:f.VARIABLE});else if(k){const U=c[c.length-1];(!U||U.type!==f.SEPARATOR)&&c.push({value:k.label,type:f.SEPARATOR})}L="",v=!1}else L+=P;return L&&!v&&c.push({value:L,type:f.TEXT}),c.filter((P,k)=>{if(P.type===f.SEPARATOR){const U=c[k-1],J=c[k+1];return[U,J].every(ne=>ne&&(ne.type===f.VARIABLE||ne.type===f.TEXT)&&ne.value.length>0)}return!0}).map(P=>P.value).join("")}i.template=s;function a(t,r){return I.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):t.replace(/&&|&/g,c=>c==="&"?"&&":"&")}i.mnemonicMenuLabel=a;function n(t,r){return I.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):I.isWindows?t.replace(/&&|&/g,c=>c==="&"?"&&":"&"):t.replace(/&&/g,"_")}i.mnemonicButtonLabel=n;function o(t){return t.replace(/&/g,"&&")}i.unmnemonicLabel=o;function e(t){const r=t.indexOf("/")!==-1?w.posix:w.win32,c=r.basename(t),v=r.dirname(t);return c.length?{name:c,parentPath:v}:{name:v,parentPath:""}}i.splitName=e}),define(ee[27],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(l){return T.test(l)}i.isUUID=R;const w=new Uint8Array(16),I=[];for(let l=0;l<256;l++)I.push(l.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let m=0;m<l.length;m++)l[m]=Math.floor(Math.random()*256);return l};function S(){C(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let l=0,m="";return m+=I[w[l++]],m+=I[w[l++]],m+=I[w[l++]],m+=I[w[l++]],m+="-",m+=I[w[l++]],m+=I[w[l++]],m+="-",m+=I[w[l++]],m+=I[w[l++]],m+="-",m+=I[w[l++]],m+=I[w[l++]],m+="-",m+=I[w[l++]],m+=I[w[l++]],m+=I[w[l++]],m+=I[w[l++]],m+=I[w[l++]],m+=I[w[l++]],m}i.generateUuid=S}),define(ee[64],te([0,1,131]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class R{constructor(I="utf8"){this.stringDecoder=new T.StringDecoder(I),this.remaining=null}write(I){const C=[],S=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(S.length<1)return C;let l=0,m,y=l;for(;y<S.length;)if(m=S.charCodeAt(y),m===13||m===10){if(C.push(S.substring(l,y)),y++,y<S.length){const D=m;m=S.charCodeAt(y),(D===13&&m===10||D===10&&m===13)&&y++}l=y}else y++;return this.remaining=l<S.length?S.substr(l):null,C}end(){return this.remaining}}i.LineDecoder=R}),define(ee[65],te([0,1,48,4,12,24,13]),function(B,i,T,R,w,I,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.realpathSync=i.realpath=i.realcaseSync=void 0;function S(D){if(w.isLinux)return D;const u=(0,R.dirname)(D);if(D===u)return D;const E=((0,R.basename)(D)||D).toLowerCase();try{const g=(0,C.readdirSync)(u).filter(h=>h.toLowerCase()===E);if(g.length===1){const h=S(u);if(h)return(0,R.join)(h,g[0])}else if(g.length>1){const h=g.indexOf(E);if(h>=0){const p=S(u);if(p)return(0,R.join)(p,g[h])}}}catch{}return null}i.realcaseSync=S;async function l(D){try{return await C.Promises.realpath(D)}catch{const E=y(D);return await C.Promises.access(E,T.constants.R_OK),E}}i.realpath=l;function m(D){try{return T.realpathSync(D)}catch{const E=y(D);return T.accessSync(E,T.constants.R_OK),E}}i.realpathSync=m;function y(D){return(0,I.rtrim)((0,R.normalize)(D),R.sep)}}),define(ee[66],te([0,1,33,4,13]),function(B,i,T,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,C=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var l;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(l||(l={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class D{constructor(a,n,o){this.exePath=a,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function u({useAlternateBitness:s=!1}={}){return s?m===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:s=!1,findPreview:a=!1}={}){const n=u({useAlternateBitness:s});if(!n)return null;const o=R.join(n,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(o))return null;let e=-1,t=null;for(const v of await w.Promises.readdir(o)){let L=-1;if(a){const k=v.indexOf("-");if(k<0)continue;const U=v.substring(0,k);if(!I.test(U)||v.substring(k+1)!=="preview")continue;L=parseInt(U,10)}else{if(!I.test(v))continue;L=parseInt(v,10)}if(L<=e)continue;const P=R.join(o,v,"pwsh.exe");!await w.SymlinkSupport.existsFile(P)||(t=P,e=L)}if(!t)return null;const r=n.includes("x86")?" (x86)":"",c=a?" Preview":"";return new D(t,`PowerShell${c}${r}`,!0)}async function d({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const a=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=s?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const e of await w.Promises.readdir(a))if(n.test(e)){const t=R.join(a,e,"pwsh.exe");return new D(t,o)}return null}function g(){const s=R.join(T.homedir(),".dotnet","tools","pwsh.exe");return new D(s,".NET Core PowerShell Global Tool")}function h(){const s=R.join(process.env.windir,m===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new D(s,"Windows PowerShell",!0)}async function*p(){let s=await E();s&&(yield s),s=await E({useAlternateBitness:!0}),s&&(yield s),s=await d(),s&&(yield s),s=g(),s&&(yield s),s=await E({findPreview:!0}),s&&(yield s),s=await d({findPreview:!0}),s&&(yield s),s=await E({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=h(),s&&(yield s)}async function*b(){for await(const s of p())await s.exists()&&(yield s)}i.enumeratePowerShellInstallations=b;async function f(){for await(const s of b())return s;return null}i.getFirstAvailablePowerShellInstallation=f});var pe=this&&this.__decorate||function(B,i,T,R){var w=arguments.length,I=w<3?i:R===null?R=Object.getOwnPropertyDescriptor(i,T):R,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(B,i,T,R);else for(var S=B.length-1;S>=0;S--)(C=B[S])&&(I=(w<3?C(I):w>3?C(i,T,I):C(i,T))||I);return w>3&&I&&Object.defineProperty(i,T,I),I};define(ee[49],te([0,1,19,3,17,25,47,7,10,2,61,24,8]),function(B,i,T,R,w,I,C,S,l,m,y,D,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var E;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(E=i.RequestType||(i.RequestType={}));function d(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(g=i.ResponseType||(i.ResponseType={}));function h(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(p||(p={}));class b{constructor(O){this.buffer=O,this.pos=0}read(O){const M=this.buffer.slice(this.pos,this.pos+O);return this.pos+=M.byteLength,M}}class f{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var s;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(s||(s={}));function a(z){const O=w.VSBuffer.alloc(4);return O.writeUInt32BE(z,0),O}function n(z){return z.read(4).readUInt32BE(0)}function o(z){const O=w.VSBuffer.alloc(1);return O.writeUInt8(z,0),O}const e={Undefined:o(s.Undefined),String:o(s.String),Buffer:o(s.Buffer),VSBuffer:o(s.VSBuffer),Array:o(s.Array),Object:o(s.Object)},t=typeof Buffer!="undefined";function r(z,O){if(typeof O=="undefined")z.write(e.Undefined);else if(typeof O=="string"){const M=w.VSBuffer.fromString(O);z.write(e.String),z.write(a(M.byteLength)),z.write(M)}else if(t&&Buffer.isBuffer(O)){const M=w.VSBuffer.wrap(O);z.write(e.Buffer),z.write(a(M.byteLength)),z.write(M)}else if(O instanceof w.VSBuffer)z.write(e.VSBuffer),z.write(a(O.byteLength)),z.write(O);else if(Array.isArray(O)){z.write(e.Array),z.write(a(O.length));for(const M of O)r(z,M)}else{const M=w.VSBuffer.fromString(JSON.stringify(O));z.write(e.Object),z.write(a(M.byteLength)),z.write(M)}}function c(z){switch(z.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return z.read(n(z)).toString();case s.Buffer:return z.read(n(z)).buffer;case s.VSBuffer:return z.read(n(z));case s.Array:{const M=n(z),x=[];for(let K=0;K<M;K++)x.push(c(z));return x}case s.Object:return JSON.parse(z.read(n(z)).toString())}}class v{constructor(O,M,x=null,K=1e3){this.protocol=O,this.ctx=M,this.logger=x,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(O,M){this.channels.set(O,M),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const M=this.send([O.type]);this.logger&&this.logger.logOutgoing(M,0,1,h(O.type));return}case 201:case 202:case 204:case 203:{const M=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(M,O.id,1,h(O.type),O.data);return}}}send(O,M=void 0){const x=new f;return r(x,O),r(x,M),this.sendBuffer(x.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onRawMessage(O){const M=new b(O),x=c(M),K=c(M),W=x[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],1,`${d(W)}: ${x[2]}.${x[3]}`,K),this.onPromise({type:W,id:x[1],channelName:x[2],name:x[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],1,`${d(W)}: ${x[2]}.${x[3]}`,K),this.onEventListen({type:W,id:x[1],channelName:x[2],name:x[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:x[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:x[1]})}}onPromise(O){const M=this.channels.get(O.channelName);if(!M){this.collectPendingRequest(O);return}const x=new I.CancellationTokenSource;let K;try{K=M.call(this.ctx,O.name,O.arg,x.token)}catch($){K=Promise.reject($)}const W=O.id;K.then($=>{this.sendResponse({id:W,data:$,type:201}),this.activeRequests.delete(O.id)},$=>{$ instanceof Error?this.sendResponse({id:W,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:W,data:$,type:203}),this.activeRequests.delete(O.id)});const X=(0,m.toDisposable)(()=>x.cancel());this.activeRequests.set(O.id,X)}onEventListen(O){const M=this.channels.get(O.channelName);if(!M){this.collectPendingRequest(O);return}const x=O.id,W=M.listen(this.ctx,O.name,O.arg)(X=>this.sendResponse({id:x,data:X,type:204}));this.activeRequests.set(O.id,W)}disposeActiveRequest(O){const M=this.activeRequests.get(O.id);M&&(M.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let M=this.pendingRequests.get(O.channelName);M||(M=[],this.pendingRequests.set(O.channelName,M));const x=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:O,timeoutTimer:x})}flushPendingRequests(O){const M=this.pendingRequests.get(O);if(M){for(const x of M)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}i.ChannelServer=v;var L;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(L=i.RequestInitiator||(i.RequestInitiator={}));class P{constructor(O,M=null){this.protocol=O,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=M}getChannel(O){const M=this;return{call(x,K,W){return M.isDisposed?Promise.reject(S.canceled()):M.requestPromise(O,x,K,W)},listen(x,K){return M.isDisposed?Promise.reject(S.canceled()):M.requestEvent(O,x,K)}}}requestPromise(O,M,x,K=I.CancellationToken.None){const W=this.lastRequestId++,$={id:W,type:100,channelName:O,name:M,arg:x};if(K.isCancellationRequested)return Promise.reject(S.canceled());let Y;return new Promise((F,V)=>{if(K.isCancellationRequested)return V(S.canceled());const j=()=>{const ae=se=>{switch(se.type){case 201:this.handlers.delete(W),F(se.data);break;case 202:{this.handlers.delete(W);const le=new Error(se.data.message);le.stack=se.data.stack,le.name=se.data.name,V(le);break}case 203:this.handlers.delete(W),V(se.data);break}};this.handlers.set(W,ae),this.sendRequest($)};let Q=null;this.state===p.Idle?j():(Q=(0,R.createCancelablePromise)(ae=>this.whenInitialized()),Q.then(()=>{Q=null,j()}));const Z=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:W,type:101}),V(S.canceled())},fe=K.onCancellationRequested(Z);Y=(0,m.combinedDisposable)((0,m.toDisposable)(Z),fe),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(O,M,x){const K=this.lastRequestId++,X={id:K,type:102,channelName:O,name:M,arg:x};let $=null;const Y=new l.Emitter({onFirstListenerAdd:()=>{$=(0,R.createCancelablePromise)(F=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(Y),this.sendRequest(X)})},onLastListenerRemove:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(Y),this.sendRequest({id:K,type:103}))}}),N=F=>Y.fire(F.data);return this.handlers.set(K,N),Y.event}sendRequest(O){switch(O.type){case 100:case 102:{const M=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(M,O.id,0,`${d(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const M=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(M,O.id,0,d(O.type));return}}}send(O,M=void 0){const x=new f;return r(x,O),r(x,M),this.sendBuffer(x.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onBuffer(O){const M=new b(O),x=c(M),K=c(M),W=x[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,h(W)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],0,h(W),K),this.onResponse({type:x[0],id:x[1],data:K})}}onResponse(O){if(O.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(O.id);M&&M(O)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}pe([C.memoize],P.prototype,"onDidInitializePromise",null),i.ChannelClient=P;class k{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:M,onDidClientDisconnect:x})=>{l.Event.once(M.onMessage)(W=>{const X=new b(W),$=c(X),Y=new v(M,$),N=new P(M);this.channels.forEach((V,j)=>Y.registerChannel(j,V));const F={channelServer:Y,channelClient:N,ctx:$};this._connections.add(F),this._onDidAddConnection.fire(F),x(()=>{Y.dispose(),N.dispose(),this._connections.delete(F),this._onDidRemoveConnection.fire(F)})})})}get connections(){const O=[];return this._connections.forEach(M=>O.push(M)),O}getChannel(O,M){const x=this;return{call(K,W,X){let $;if((0,u.isFunction)(M)){let N=(0,T.getRandomElement)(x.connections.filter(M));$=N?Promise.resolve(N):l.Event.toPromise(l.Event.filter(x.onDidAddConnection,M))}else $=M.routeCall(x,K,W);const Y=$.then(N=>N.channelClient.getChannel(O));return J(Y).call(K,W,X)},listen(K,W){if((0,u.isFunction)(M))return x.getMulticastEvent(O,M,K,W);const X=M.routeEvent(x,K,W).then($=>$.channelClient.getChannel(O));return J(X).listen(K,W)}}}getMulticastEvent(O,M,x,K){const W=this;let X=new m.DisposableStore;const $=new l.Emitter({onFirstListenerAdd:()=>{X=new m.DisposableStore;const Y=new l.EventMultiplexer,N=new Map,F=j=>{const Z=j.channelClient.getChannel(O).listen(x,K),fe=Y.add(Z);N.set(j,fe)},V=j=>{const Q=N.get(j);!Q||(Q.dispose(),N.delete(j))};W.connections.filter(M).forEach(F),l.Event.filter(W.onDidAddConnection,M)(F,void 0,X),W.onDidRemoveConnection(V,void 0,X),Y.event($.fire,$,X),X.add(Y)},onLastListenerRemove:()=>{X.dispose()}});return $.event}registerChannel(O,M){this.channels.set(O,M),this._connections.forEach(x=>{x.channelServer.registerChannel(O,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=k;class U{constructor(O,M,x=null){const K=new f;r(K,M),O.send(K.buffer),this.channelClient=new P(O,x),this.channelServer=new v(O,M,x)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,M){this.channelServer.registerChannel(O,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=U;function J(z){return{call(O,M,x){return z.then(K=>K.call(O,M,x))},listen(O,M){const x=new l.Relay;return z.then(K=>x.input=K.listen(O,M)),x.event}}}i.getDelayedChannel=J;function ne(z){let O=!1;return{call(M,x,K){return O?z.call(M,x,K):(0,R.timeout)(0).then(()=>O=!0).then(()=>z.call(M,x,K))},listen(M,x){if(O)return z.listen(M,x);const K=new l.Relay;return(0,R.timeout)(0).then(()=>O=!0).then(()=>K.input=z.listen(M,x)),K.event}}}i.getNextTickChannel=ne;class ge{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const M of O.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await l.Event.toPromise(O.onDidAddConnection),await this.route(O)}}i.StaticRouter=ge;var oe;(function(z){function O(W,X){const $=W,Y=X&&X.disableMarshalling,N=new Map;for(const F in $)x(F)&&N.set(F,l.Event.buffer($[F],!0));return new class{listen(F,V,j){const Q=N.get(V);if(Q)return Q;if(K(V)){const Z=$[V];if(typeof Z=="function")return Z.call($,j)}throw new Error(`Event not found: ${V}`)}call(F,V,j){const Q=$[V];if(typeof Q=="function"){if(!Y&&Array.isArray(j))for(let Z=0;Z<j.length;Z++)j[Z]=(0,y.revive)(j[Z]);return Q.apply($,j)}throw new Error(`Method not found: ${V}`)}}}z.fromService=O;function M(W,X){const $=X&&X.disableMarshalling;return new Proxy({},{get(Y,N){if(typeof N=="string")return X?.properties?.has(N)?X.properties.get(N):K(N)?function(F){return W.listen(N,F)}:x(N)?W.listen(N):async function(...F){let V;X&&!(0,u.isUndefinedOrNull)(X.context)?V=[X.context,...F]:V=F;const j=await W.call(N,V);return $?j:(0,y.revive)(j)};throw new Error(`Property not found: ${String(N)}`)}})}z.toService=M;function x(W){return W[0]==="o"&&W[1]==="n"&&D.isUpperAsciiLetter(W.charCodeAt(2))}function K(W){return/^onDynamic/.test(W)&&D.isUpperAsciiLetter(W.charCodeAt(9))}})(oe=i.ProxyChannel||(i.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let O=z.toString();if(O!=="[object Object]")return O}return z}function _(z){return Array.isArray(z)?z.map(he):he(z)}function G(z,O,M,x,K,W,X){X=_(X);const $=ie[K],Y=$[x%$.length];let N=[`%c[${z}]%c[${String(O).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(W)?(N=N.concat(X),N.push(")")):N.push(X),console.log.apply(console,N)}i.logWithColors=G;class re{constructor(O,M){this._outgoingPrefix=O,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,M,x,K,W){this._totalOutgoing+=O,G(this._outgoingPrefix,this._totalOutgoing,O,M,x,K,W)}logIncoming(O,M,x,K,W){this._totalIncoming+=O,G(this._incomingPrefix,this._totalIncoming,O,M,x,K,W)}}i.IPCLogger=re}),define(ee[67],te([0,1,3,10,2,8]),function(B,i,T,R,w,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var C;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(C=i.StorageHint||(i.StorageHint={}));function S(D){const u=D;return u?.changed instanceof Map||u?.deleted instanceof Set}i.isStorageItemsChangeEvent=S;var l;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(l||(l={}));class m extends w.Disposable{constructor(u,E=Object.create(null)){super();this.database=u,this.options=E,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(u=>this.onDidChangeItemsExternal(u)))}onDidChangeItemsExternal(u){u.changed?.forEach((E,d)=>this.accept(d,E)),u.deleted?.forEach(E=>this.accept(E,void 0))}accept(u,E){if(this.state===l.Closed)return;let d=!1;(0,I.isUndefinedOrNull)(E)?d=this.cache.delete(u):this.cache.get(u)!==E&&(this.cache.set(u,E),d=!0),d&&this._onDidChangeStorage.fire(u)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(u,E){const d=this.cache.get(u);return(0,I.isUndefinedOrNull)(d)?E:d}getBoolean(u,E){const d=this.get(u);return(0,I.isUndefinedOrNull)(d)?E:d==="true"}getNumber(u,E){const d=this.get(u);return(0,I.isUndefinedOrNull)(d)?E:parseInt(d,10)}async set(u,E){if(this.state===l.Closed)return;if((0,I.isUndefinedOrNull)(E))return this.delete(u);const d=String(E);if(this.cache.get(u)!==d)return this.cache.set(u,d),this.pendingInserts.set(u,d),this.pendingDeletes.delete(u),this._onDidChangeStorage.fire(u),this.doFlush()}async delete(u){if(!(this.state===l.Closed||!this.cache.delete(u)))return this.pendingDeletes.has(u)||this.pendingDeletes.add(u),this.pendingInserts.delete(u),this._onDidChangeStorage.fire(u),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const u={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(u).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(u){if(!!this.hasPending)return this.doFlush(u)}async doFlush(u){return this.flushDelayer.trigger(()=>this.flushPending(),u)}async whenFlushed(){if(!!this.hasPending)return new Promise(u=>this.whenFlushedCallbacks.push(u))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(u){u.insert&&u.insert.forEach((E,d)=>this.items.set(d,E)),u.delete&&u.delete.forEach(E=>this.items.delete(E))}async close(){}}i.InMemoryStorageDatabase=y}),define(ee[68],te([5,6]),function(B,i){return B.create("vs/base/common/date",i)}),define(ee[69],te([0,1,68]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const R=60,w=R*60,I=w*24,C=I*7,S=I*30,l=I*365;function m(D,u){typeof D!="number"&&(D=D.getTime());const E=Math.round((new Date().getTime()-D)/1e3);if(E<-30)return(0,T.localize)(0,null,m(new Date().getTime()+E*1e3,!1));if(E<30)return(0,T.localize)(1,null);let d;return E<R?(d=E,u?d===1?(0,T.localize)(2,null,d):(0,T.localize)(3,null,d):d===1?(0,T.localize)(4,null,d):(0,T.localize)(5,null,d)):E<w?(d=Math.floor(E/R),u?d===1?(0,T.localize)(6,null,d):(0,T.localize)(7,null,d):d===1?(0,T.localize)(8,null,d):(0,T.localize)(9,null,d)):E<I?(d=Math.floor(E/w),u?d===1?(0,T.localize)(10,null,d):(0,T.localize)(11,null,d):d===1?(0,T.localize)(12,null,d):(0,T.localize)(13,null,d)):E<C?(d=Math.floor(E/I),u?d===1?(0,T.localize)(14,null,d):(0,T.localize)(15,null,d):d===1?(0,T.localize)(16,null,d):(0,T.localize)(17,null,d)):E<S?(d=Math.floor(E/C),u?d===1?(0,T.localize)(18,null,d):(0,T.localize)(19,null,d):d===1?(0,T.localize)(20,null,d):(0,T.localize)(21,null,d)):E<l?(d=Math.floor(E/S),u?d===1?(0,T.localize)(22,null,d):(0,T.localize)(23,null,d):d===1?(0,T.localize)(24,null,d):(0,T.localize)(25,null,d)):(d=Math.floor(E/l),u?d===1?(0,T.localize)(26,null,d):(0,T.localize)(27,null,d):d===1?(0,T.localize)(28,null,d):(0,T.localize)(29,null,d))}i.fromNow=m;function y(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=y}),define(ee[70],te([5,6]),function(B,i){return B.create("vs/base/common/errorMessage",i)}),define(ee[28],te([0,1,19,8,70]),function(B,i,T,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function I(m,y){return y&&(m.stack||m.stacktrace)?w.localize(0,null,S(m),C(m.stack)||C(m.stacktrace)):S(m)}function C(m){return Array.isArray(m)?m.join(`
`):m}function S(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?w.localize(1,null,m.message):m.message||w.localize(2,null)}function l(m=null,y=!1){if(!m)return w.localize(3,null);if(Array.isArray(m)){const D=T.coalesce(m),u=l(D[0],y);return D.length>1?w.localize(4,null,u,D.length):u}if(R.isString(m))return m;if(m.detail){const D=m.detail;if(D.error)return I(D.error,y);if(D.exception)return I(D.exception,y)}return m.stack?I(m,y):m.message?m.message:w.localize(5,null)}i.toErrorMessage=l}),define(ee[71],te([5,6]),function(B,i){return B.create("vs/base/node/processes",i)}),define(ee[50],te([0,1,40,38,11,21,4,12,29,58,8,64,13,71]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return m.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return m.TerminateResponseCode}});function d(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(n,o){if(S.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const t=T.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],e);return new Promise(r=>{t.once("error",c=>{r({success:!1,error:c})}),t.once("exit",(c,v)=>{r(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?d(e.status):1})}else if(S.isLinux||S.isMacintosh)try{const e=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",B).fsPath;return new Promise(t=>{T.execFile(e,[n.pid.toString()],{encoding:"utf8",shell:!0},(r,c,v)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function h(n){!n||(delete n.DEBUG,S.isMacintosh&&delete n.DYLD_LIBRARY_PATH,S.isLinux&&delete n.LD_PRELOAD)}i.removeDangerousEnvVariables=h;function p(n=l.env){return n.comspec||"cmd.exe"}i.getWindowsShell=p;class b{constructor(o,e,t,r){if(e!==void 0&&t!==void 0&&r!==void 0)this.cmd=o,this.args=e,this.shell=t,this.options=r;else{const c=o;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(l.env).forEach(v=>{c[v]=l.env[v]}),Object.keys(this.options.env).forEach(v=>{c[v]=this.options.env[v]}),this.options.env=c}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(C.sep);return e!==-1&&(o=o.substring(e+1)),b.WellKnowCommands[o]?o:"other"}start(o){return S.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(l.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(e=>{let t,r;const c=new Promise((v,L)=>{t=v,r=L});if(e){let v=this.cmd;this.args&&(v=v+" "+this.args.join(" ")),this.childProcess=T.exec(v,this.options,(L,P,k)=>{this.childProcess=null;const U=L;U&&U.killed?r({killed:this.terminateRequested,stdout:P.toString(),stderr:k.toString()}):this.handleExec(t,o,L,P,k)})}else{let v=null;const L=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,t,o,r);const k={terminated:this.terminateRequested};y.isNumber(P)&&(k.cmdCode=P),t(k)};if(this.shell&&S.isWindows){const P=I.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let k=!1,U=!1;const J=[];let ne=this.ensureQuotes(this.cmd);J.push(ne.value),k=ne.quoted,this.args&&this.args.forEach(oe=>{ne=this.ensureQuotes(oe),J.push(ne.value),U=U&&ne.quoted});const ge=["/s","/c"];k?U?ge.push('"'+J.join(" ")+'"'):J.length>1?ge.push('"'+J[0]+'" '+J.slice(1).join(" ")):ge.push('"'+J[0]+'"'):ge.push(J.join(" ")),v=T.spawn(p(),ge,P)}else this.cmd&&(v=T.spawn(this.cmd,this.args,this.options));v&&(this.childProcess=v,this.childProcessPromise=Promise.resolve(v),this.pidResolve&&(this.pidResolve(y.isNumber(v.pid)?v.pid:-1),this.pidResolve=void 0),v.on("error",P=>{this.childProcess=null,r({terminated:this.terminateRequested,error:P})}),v.pid&&(this.childProcess.on("close",L),this.handleSpawn(v,t,o,r,!0)))}return c})}handleClose(o,e,t,r){}ensureQuotes(o){return b.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,g(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!S.isWindows)return o(!1);const e=T.spawn(p(),["/s","/c"]);e.on("error",t=>o(!0)),e.on("exit",t=>o(!1))})}}i.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class f extends b{constructor(o,e,t,r){super(o,e,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,t,r,c){[r,c].forEach((v,L)=>{const P=new D.LineDecoder;P.write(v).forEach(J=>{e({line:J,source:L===0?0:1})});const U=P.end();U&&e({line:U,source:L===0?0:1})}),o({terminated:this.terminateRequested,error:t})}handleSpawn(o,e,t,r,c){const v=new D.LineDecoder,L=new D.LineDecoder;o.stdout.on("data",P=>{v.write(P).forEach(U=>t({line:U,source:0}))}),o.stderr.on("data",P=>{L.write(P).forEach(U=>t({line:U,source:1}))}),this.stdoutLineDecoder=v,this.stderrLineDecoder=L}handleClose(o,e,t,r){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&t({line:c,source:0});const v=this.stderrLineDecoder?this.stderrLineDecoder.end():null;v&&t({line:v,source:1})}}i.LineProcess=f;function s(n){let o=[],e=!1;const t=function(r){if(e){o.push(r);return}(!n.send(r,v=>{if(v&&console.error(v),e=!1,o.length>0){const L=o.slice(0);o=[],L.forEach(P=>t(P))}})||S.isWindows)&&(e=!0)};return{send:t}}i.createQueuedSender=s;var a;(function(n){async function o(e,t,r){if(C.isAbsolute(e))return e;if(t===void 0&&(t=l.cwd()),C.dirname(e)!=="."||(r===void 0&&y.isString(l.env.PATH)&&(r=l.env.PATH.split(C.delimiter)),r===void 0||r.length===0))return C.join(t,e);async function v(L){if(await u.Promises.exists(L)){let P;try{P=await u.Promises.stat(L)}catch(k){k.message.startsWith("EACCES")&&(P=await u.Promises.lstat(L))}return P?!P.isDirectory():!1}return!1}for(let L of r){let P;if(C.isAbsolute(L)?P=C.join(L,e):P=C.join(t,L,e),await v(P))return P;let k=P+".com";if(await v(k)||(k=P+".exe",await v(k)))return k}return C.join(t,e)}n.findExecutable=o})(a=i.win32||(i.win32={}))}),define(ee[72],te([0,1,33,12,66,50]),function(B,i,T,R,w,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function C(E,d){return E===1?R.isWindows?D():I.getWindowsShell(d):m(E,d)}i.getSystemShell=C;function S(E,d){return E===1?R.isWindows?u(d):I.getWindowsShell(d):m(E,d)}i.getSystemShellSync=S;let l=null;function m(E,d){if(R.isLinux&&E===2||R.isMacintosh&&E===3)return"/bin/bash";if(!l){let g;if(R.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,T.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}l=g}return l}let y=null;async function D(){return y||(y=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),y}function u(E){if(y)return y;const d=R.isWindows&&parseFloat((0,T.release)())>=10,g=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),h=`${E.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?h:I.getWindowsShell(E)}}),define(ee[73],te([0,1,40,3,17,25,60,7,10,2,21,50,49]),function(B,i,T,R,w,I,C,S,l,m,y,D,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class E extends u.ChannelServer{constructor(h){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",p=>w.VSBuffer.wrap(Buffer.from(p,"base64")))},h);process.once("disconnect",()=>this.dispose())}}i.Server=E;class d{constructor(h,p){this.modulePath=h,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new R.Delayer(b),this.child=null,this._client=null}getChannel(h){const p=this;return{call(b,f,s){return p.requestPromise(h,b,f,s)},listen(b,f){return p.requestEvent(h,b,f)}}}requestPromise(h,p,b,f=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(h),a=(0,R.createCancelablePromise)(e=>s.call(p,b,e)),n=f.onCancellationRequested(()=>a.cancel()),o=(0,m.toDisposable)(()=>a.cancel());return this.activeRequests.add(o),a.finally(()=>{n.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(h,p,b){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let f;const s=new l.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(h).listen(p,b)(s.fire,s),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,D.removeDangerousEnvVariables)(p.env),this.child=(0,T.fork)(this.modulePath,h,p);const b=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,C.isRemoteConsoleLog)(t)){(0,C.log)(t,`IPC Library: ${this.options.serverName}`);return}b.fire(w.VSBuffer.wrap(Buffer.from(t,"base64")))});const s=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,a=t=>this.child&&this.child.connected&&s.send(t.buffer.toString("base64")),n=b.event,o={send:a,onMessage:n};this._client=new u.ChannelClient(o);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",e),this.activeRequests.forEach(c=>(0,m.dispose)(c)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(h){let p=this.channels.get(h);return p||(p=this.client.getChannel(h),this.channels.set(h,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=d}),define(ee[74],te([5,6]),function(B,i){return B.create("vs/base/node/zip",i)}),define(ee[75],te([5,6]),function(B,i){return B.create("vs/platform/configuration/common/configurationRegistry",i)}),define(ee[76],te([5,6]),function(B,i){return B.create("vs/platform/environment/node/shellEnv",i)}),define(ee[77],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(ee[78],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(ee[79],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(ee[80],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(ee[81],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(ee[82],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(ee[83],te([5,6]),function(B,i){return B.create("vs/platform/extensions/common/extensionValidator",i)}),define(ee[84],te([5,6]),function(B,i){return B.create("vs/platform/files/common/fileService",i)}),define(ee[85],te([5,6]),function(B,i){return B.create("vs/platform/files/common/io",i)}),define(ee[86],te([5,6]),function(B,i){return B.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(ee[87],te([5,6]),function(B,i){return B.create("vs/platform/request/common/request",i)}),define(ee[88],te([5,6]),function(B,i){return B.create("vs/platform/telemetry/common/telemetryService",i)}),define(ee[89],te([0,1,69,47,11,4,29,18,9]),function(B,i,T,R,w,I,C,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class m{constructor(g,h,p){this._args=g,this.paths=h,this.productService=p}get appRoot(){return(0,I.dirname)(w.FileAccess.asFileUri("",B).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(l.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=C.env.VSCODE_PORTABLE;return g?l.URI.file((0,I.join)(g,"argv.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,S.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,I.resolve)(g):(0,I.normalize)((0,I.join)(w.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,I.resolve)(g):(0,I.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,I.resolve)(g);const h=C.env.VSCODE_EXTENSIONS;if(h)return h;const p=C.env.VSCODE_PORTABLE;return p?(0,I.join)(p,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(h=>/^[^:/?#]+?:\/\//.test(h)?l.URI.parse(h):l.URI.file((0,I.normalize)(h)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?l.URI.parse(g):l.URI.file((0,I.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}pe([R.memoize],m.prototype,"appRoot",null),pe([R.memoize],m.prototype,"userHome",null),pe([R.memoize],m.prototype,"userDataPath",null),pe([R.memoize],m.prototype,"appSettingsHome",null),pe([R.memoize],m.prototype,"tmpDir",null),pe([R.memoize],m.prototype,"cacheHome",null),pe([R.memoize],m.prototype,"userRoamingDataHome",null),pe([R.memoize],m.prototype,"settingsResource",null),pe([R.memoize],m.prototype,"userDataSyncHome",null),pe([R.memoize],m.prototype,"userDataSyncLogResource",null),pe([R.memoize],m.prototype,"sync",null),pe([R.memoize],m.prototype,"machineSettingsResource",null),pe([R.memoize],m.prototype,"globalStorageHome",null),pe([R.memoize],m.prototype,"workspaceStorageHome",null),pe([R.memoize],m.prototype,"keybindingsResource",null),pe([R.memoize],m.prototype,"keyboardLayoutResource",null),pe([R.memoize],m.prototype,"argvResource",null),pe([R.memoize],m.prototype,"snippetsHome",null),pe([R.memoize],m.prototype,"isExtensionDevelopment",null),pe([R.memoize],m.prototype,"untitledWorkspacesHome",null),pe([R.memoize],m.prototype,"installSourcePath",null),pe([R.memoize],m.prototype,"builtinExtensionsPath",null),pe([R.memoize],m.prototype,"extensionsPath",null),pe([R.memoize],m.prototype,"extensionDevelopmentLocationURI",null),pe([R.memoize],m.prototype,"extensionDevelopmentKind",null),pe([R.memoize],m.prototype,"extensionTestsLocationURI",null),pe([R.memoize],m.prototype,"debugExtensionHost",null),pe([R.memoize],m.prototype,"serviceMachineIdResource",null),pe([R.memoize],m.prototype,"telemetryLogResource",null),pe([R.memoize],m.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=m;function y(d,g){return E(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}i.parseExtensionHostPort=y;function D(d,g){return E(d["inspect-search"],d["inspect-brk-search"],5876,g,d.extensionEnvironment)}i.parseSearchPort=D;function u(d,g){return E(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g,d.extensionEnvironment)}i.parsePtyHostPort=u;function E(d,g,h,p,b,f){const a=Number(g||d)||(p?null:h),n=a?Boolean(!!g):!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:a,break:n,debugId:b,env:o}}}),function(){"use strict";function B(i,T,R,w){function I(S){const l=C(S),m=[l];return i.isAbsolute(l)||m.unshift(w),i.resolve(...m)}function C(S){const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return i.join(m,R);const y=S["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const D=process.env.USERPROFILE;if(typeof D!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=i.join(D,"AppData","Roaming")}break;case"darwin":m=i.join(T.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||i.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(m,R)}return{getUserDataPath:I}}if(typeof define=="function")define(ee[90],te([0,132,33,11,18,29]),function(i,T,R,w,I,C){const S=I.dirname(w.FileAccess.asFileUri("",i)),l=i.__$__nodeRequire(I.joinPath(S,"package.json").fsPath);return B(T,R,l.name,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),T=require("path"),R=require("os");module.exports=B(T,R,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[91],te([0,1,33,89,90]),function(B,i,T,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class I extends R.AbstractNativeEnvironmentService{constructor(S,l){super(S,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,w.getUserDataPath)(S)},l)}}i.NativeEnvironmentService=I}),define(ee[92],te([0,1,21]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function w(I,C){const S=l=>{if(typeof l!="string")return;const m=R.exec(l);if(!m)return;const y=C[m[1]]??l;return typeof y=="string"?y:typeof y.message=="string"?y.message:l};return(0,T.cloneAndChange)(I,S)}i.localizeManifest=w}),define(ee[51],te([0,1,83]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||R.test(u)}i.isValidVersionStr=I;function C(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=u.match(R);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}i.parseVersion=C;function S(u){if(!u)return null;let E=u.majorBase,d=u.majorMustEqual,g=u.minorBase,h=u.minorMustEqual,p=u.patchBase,b=u.patchMustEqual;u.hasCaret&&(E===0||(h=!1),b=!1);let f=0;if(u.preRelease){const s=w.exec(u.preRelease);if(s){const[,a,n,o]=s;f=Date.UTC(Number(a),Number(n)-1,Number(o))}}return{majorBase:E,majorMustEqual:d,minorBase:g,minorMustEqual:h,patchBase:p,patchMustEqual:b,isMinimum:u.hasGreaterEquals,notBefore:f}}i.normalizeVersion=S;function l(u,E,d){let g;typeof u=="string"?g=S(C(u)):g=u;let h;E instanceof Date?h=E.getTime():typeof E=="string"&&(h=new Date(E).getTime());let p;if(typeof d=="string"?p=S(C(d)):p=d,!g||!p)return!1;let b=g.majorBase,f=g.minorBase,s=g.patchBase,a=p.majorBase,n=p.minorBase,o=p.patchBase,e=p.notBefore,t=p.majorMustEqual,r=p.minorMustEqual,c=p.patchMustEqual;return p.isMinimum?b>a?!0:b<a?!1:f>n?!0:f<n||h&&h<e?!1:s>=o:(b===1&&a===0&&(!t||!r||!c)&&(a=1,n=0,o=0,t=!0,r=!1,c=!1),b<a?!1:b>a?!t:f<n?!1:f>n?!r:s<o?!1:s>o?!c:!(h&&h<e))}i.isValidVersion=l;function m(u,E,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:D(u,E,d.engines.vscode,g)}i.isValidExtensionVersion=m;function y(u,E,d){return u==="*"||D(E,d,u)}i.isEngineValid=y;function D(u,E,d,g=[]){let h=S(C(d));if(!h)return g.push(T.localize(0,null,d)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return g.push(T.localize(1,null,d)),!1}else if(!h.majorMustEqual)return g.push(T.localize(2,null,d)),!1;return l(u,E,h)?!0:(g.push(T.localize(3,null,u,d)),!1)}}),define(ee[41],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class T{constructor(w,I=[],C=!1){this.ctor=w,this.staticArguments=I,this.supportsDelayedInstantiation=C}}i.SyncDescriptor=T}),define(ee[93],te([0,1,41]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const R=[];function w(C,S,l){S instanceof T.SyncDescriptor||(S=new T.SyncDescriptor(S,[],l)),R.push([C,S])}i.registerSingleton=w;function I(){return R}i.getSingletonServiceDescriptors=I}),define(ee[94],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class T{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}i.Node=T;class R{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let C of this._nodes.values())C.outgoing.size===0&&I.push(C);return I}insertEdge(I,C){const S=this.lookupOrInsertNode(I),l=this.lookupOrInsertNode(C);S.outgoing.set(this._hashFn(C),l),l.incoming.set(this._hashFn(I),S)}removeNode(I){const C=this._hashFn(I);this._nodes.delete(C);for(let S of this._nodes.values())S.outgoing.delete(C),S.incoming.delete(C)}lookupOrInsertNode(I){const C=this._hashFn(I);let S=this._nodes.get(C);return S||(S=new T(I),this._nodes.set(C,S)),S}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[C,S]of this._nodes)I.push(`${C}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,C]of this._nodes){const S=new Set([I]),l=this._findCycle(C,S);if(l)return l}}_findCycle(I,C){for(let[S,l]of I.outgoing){if(C.has(S))return[...C,S].join(" -> ");C.add(S);const m=this._findCycle(l,C);if(m)return m;C.delete(S)}}}i.Graph=R}),define(ee[26],te([0,1,8,9,14]),function(B,i,T,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,w.createDecorator)("configurationService");function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof R.URI)}i.isConfigurationOverrides=I;function C(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||T.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof R.URI)}i.isConfigurationUpdateOverrides=C;var S;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(S=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=l;function m(h,p){const b=Object.create(null);for(let f in h)y(b,f,h[f],p);return b}i.toValuesTree=m;function y(h,p,b,f){const s=p.split("."),a=s.pop();let n=h;for(let o=0;o<s.length;o++){let e=s[o],t=n[e];switch(typeof t){case"undefined":t=n[e]=Object.create(null);break;case"object":break;default:f(`Ignoring ${p} as ${s.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}n=t}if(typeof n=="object"&&n!==null)try{n[a]=b}catch{f(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=y;function D(h,p){const b=p.split(".");u(h,b)}i.removeFromValueTree=D;function u(h,p){const b=p.shift();if(p.length===0){delete h[b];return}if(Object.keys(h).indexOf(b)!==-1){const f=h[b];typeof f=="object"&&!Array.isArray(f)&&(u(f,p),Object.keys(f).length===0&&delete h[b])}}function E(h,p,b){function f(n,o){let e=n;for(const t of o){if(typeof e!="object"||e===null)return;e=e[t]}return e}const s=p.split("."),a=f(h,s);return typeof a=="undefined"?b:a}i.getConfigurationValue=E;function d(h,p,b){Object.keys(p).forEach(f=>{f!=="__proto__"&&(f in h?T.isObject(h[f])&&T.isObject(p[f])?d(h[f],p[f],b):b&&(h[f]=p[f]):h[f]=p[f])})}i.merge=d;function g(h,p,b){const f=h.inspect(p),s=h.inspect(b);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:f.defaultValue}i.getMigratedSettingValue=g}),define(ee[52],te([0,1,14]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,T.createDecorator)("downloadService")}),define(ee[20],te([0,1,14]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,T.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,T.refineServiceDecorator)(i.IEnvironmentService)}),define(ee[22],te([0,1,11,78,14]),function(B,i,T,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";var I;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(I=i.TargetPlatform||(i.TargetPlatform={}));function C(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=C;function S(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=S;function l(f,s){switch(f){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=l;function m(f,s){return s==="web"&&!f.includes("web")}i.isNotWebExtensionInWebTargetPlatform=m;function y(f,s,a){return m(s,a)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===a?!0:D(a).includes(f)}i.isTargetPlatformCompatible=y;function D(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=D;function u(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}i.isIExtensionIdentifier=u;var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E=i.SortBy||(i.SortBy={}));var d;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(d=i.SortOrder||(i.SortOrder={}));var g;(function(f){f.Install="install",f.Uninstall="uninstall"})(g=i.StatisticType||(i.StatisticType={}));var h;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(h=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,w.createDecorator)("extensionGalleryService");var p;(function(f){f.Unsupported="Unsupported",f.UnsupportedPreRelease="UnsupportedPreRelease",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(p=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class b extends Error{constructor(s,a){super(s);this.code=a,this.name=a}}i.ExtensionManagementError=b,i.IExtensionManagementService=(0,w.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,w.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,w.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",B).toString(!0),i.ExtensionsLabel=(0,R.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,R.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,w.createDecorator)("IExtensionManagementCLIService")}),define(ee[95],te([0,1,40,4,76,25,28,7,12,27,72,133,3]),function(B,i,T,R,w,I,C,S,l,m,y,D,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const E=1e4;let d;async function g(p,b,f){return b["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,D.isLaunchedFromCli)(f)&&!b["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,D.isLaunchedFromCli)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=u.Promises.withAsyncBody(async(s,a)=>{const n=new I.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),a(new Error((0,w.localize)(0,null)))},E);try{s(await h(p,n.token))}catch(e){!(0,S.isPromiseCanceledError)(e)&&!n.token.isCancellationRequested?a(new Error((0,w.localize)(1,null,(0,C.toErrorMessage)(e)))):s({})}finally{clearTimeout(o),n.dispose()}})),d)}i.getResolvedShellEnv=g;async function h(p,b){const f=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",f);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",s);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(a+"(.*)"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const e=await(0,y.getSystemShell)(l.OS,o);return p.trace("getUnixShellEnvironment#shell",e),new Promise((t,r)=>{if(b.isCancellationRequested)return r((0,S.canceled)());const c=(0,R.basename)(e);let v,L;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(v=`& '${process.execPath}' ${P} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,L=["-Login","-Command"]):(v=`'${process.execPath}' ${P} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"?L=["-ic"]:L=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),v);const k=(0,T.spawn)(e,[...L,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});b.onCancellationRequested(()=>(k.kill(),r((0,S.canceled)()))),k.on("error",ne=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(ne)),r(ne)});const U=[];k.stdout.on("data",ne=>U.push(ne));const J=[];k.stderr.on("data",ne=>J.push(ne)),k.on("close",(ne,ge)=>{const oe=Buffer.concat(U).toString("utf8");p.trace("getUnixShellEnvironment#raw",oe);const ie=Buffer.concat(J).toString("utf8");if(ie.trim()&&p.trace("getUnixShellEnvironment#stderr",ie),ne||ge)return r(new Error((0,w.localize)(2,null,ne,ge)));const he=n.exec(oe),_=he?he[1]:"{}";try{const G=JSON.parse(_);f?G.ELECTRON_RUN_AS_NODE=f:delete G.ELECTRON_RUN_AS_NODE,s?G.ELECTRON_NO_ATTACH_CONSOLE=s:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){p.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(G)),r(G)}})})}}),define(ee[53],te([0,1,17,7,85,16]),function(B,i,T,R,w,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function C(y,D,u,E,d,g){let h;try{await S(y,D,u,E,d,g)}catch(p){h=p}finally{h&&d.errorTransformer&&(h=d.errorTransformer(h)),typeof h!="undefined"&&u.error(h),u.end()}}i.readFileIntoStream=C;async function S(y,D,u,E,d,g){l(g);const h=await y.open(D,{create:!1});try{l(g);let p=0,b=0,f=d&&typeof d.length=="number"?d.length:void 0,s=T.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),a=d&&typeof d.position=="number"?d.position:0,n=0;do b=await y.read(h,a,s.buffer,n,s.byteLength-n),a+=b,n+=b,p+=b,typeof f=="number"&&(f-=b),n===s.byteLength&&(await u.write(E(s)),s=T.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),n=0);while(b>0&&(typeof f!="number"||f>0)&&l(g)&&m(p,d));if(n>0){let o=n;typeof f=="number"&&(o=Math.min(n,f)),u.write(E(s.slice(0,o)))}}catch(p){throw(0,I.ensureFileSystemProviderError)(p)}finally{await y.close(h)}}function l(y){if(y.isCancellationRequested)throw(0,R.canceled)();return!0}function m(y,D){if(D?.limits){if(typeof D.limits.memory=="number"&&y>D.limits.memory)throw(0,I.createFileSystemProviderError)((0,w.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof D.limits.size=="number"&&y>D.limits.size)throw(0,I.createFileSystemProviderError)((0,w.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[42],te([0,1,2,12,9,16]),function(B,i,T,R,w,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.coalesceEvents=i.toFileChanges=i.AbstractRecursiveWatcherClient=void 0;class C extends T.Disposable{constructor(D,u,E){super();this.onFileChanges=D,this.onLogMessage=u,this.verboseLogging=E,this.watcherDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const D=new T.DisposableStore;this.watcherDisposables.value=D,this.watcher=this.createWatcher(D),this.watcher.setVerboseLogging(this.verboseLogging),D.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),D.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),D.add(this.watcher.onDidError(u=>this.onError(u)))}onError(D){this.restartCounter<C.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${D}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${D}`)}restart(D){this.restartCounter++,this.init(),this.watch(D)}async watch(D){this.requests=D,await this.watcher?.watch(D)}async setVerboseLogging(D){this.verboseLogging=D,await this.watcher?.setVerboseLogging(D)}error(D){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${D}`})}dispose(){return this.watcher=void 0,super.dispose()}}i.AbstractRecursiveWatcherClient=C,C.MAX_RESTARTS=5;function S(y){return y.map(D=>({type:D.type,resource:w.URI.file(D.path)}))}i.toFileChanges=S;function l(y){const D=new m;for(const u of y)D.processEvent(u);return D.coalesce()}i.coalesceEvents=l;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(D){return R.isLinux?D.path:D.path.toLowerCase()}processEvent(D){const u=this.mapPathToChange.get(this.toKey(D));let E=!1;if(u){const d=u.type,g=D.type;u.path!==D.path&&D.type===2?E=!0:d===1&&g===2?(this.mapPathToChange.delete(this.toKey(D)),this.coalesced.delete(u)):d===2&&g===1?u.type=0:d===1&&g===0||(u.type=g)}else E=!0;E&&(this.coalesced.add(D),this.mapPathToChange.set(this.toKey(D),D))}coalesce(){const D=[],u=[];return Array.from(this.coalesced).filter(E=>E.type!==2?(D.push(E),!1):!0).sort((E,d)=>E.path.length-d.path.length).filter(E=>u.some(d=>(0,I.isParent)(E.path,d,!R.isLinux))?!1:(u.push(E.path),!0)).concat(D)}}}),define(ee[96],te([0,1,3,62,2,4,65,13,134,42]),function(B,i,T,R,w,I,C,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSFileWatcher=void 0;class y extends w.Disposable{constructor(u,E,d,g,h){super();this.path=u,this.excludes=E,this.onDidFilesChange=d,this.onLogMessage=g,this.verboseLogging=h,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(l.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.excludePatterns=this.excludes.map(p=>(0,R.parse)(p)),this.startWatching()}setVerboseLogging(u){this.verboseLogging=u}async startWatching(){try{const{stat:u,symbolicLink:E}=await S.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let d=this.path;if(E)try{d=await(0,C.realpath)(d)}catch(g){if(this.error(g),E.dangling)return}this.trace(`Request to start watching: ${d} (excludes: ${this.excludes}))}`),u.isDirectory()?this._register((0,l.watchFolder)(d,(g,h)=>{this.onFileChange({type:g==="changed"?0:g==="added"?1:2,path:(0,I.join)(this.path,(0,I.basename)(h))})},g=>this.error(g))):this._register((0,l.watchFile)(d,g=>{this.onFileChange({type:g==="changed"?0:2,path:this.path})},g=>this.error(g)))}catch(u){u.code!=="ENOENT"&&this.error(u)}}onFileChange(u){this.verboseLogging&&this.trace(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`),this.isPathIgnored(u.path,this.excludePatterns)?this.verboseLogging&&this.trace(` >> ignored ${u.path}`):this.fileChangesBuffer.push(u),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,m.coalesceEvents)(E);if(this.verboseLogging)for(const g of d)this.trace(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);d.length>0&&this.onDidFilesChange(d)})}isPathIgnored(u,E){return E.some(d=>d(u))}error(u){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${u}`})}trace(u){!this.isDisposed&&this.verboseLogging&&this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.isDisposed=!0,super.dispose()}}i.NodeJSFileWatcher=y}),define(ee[97],te([0,1,11,49,73,42]),function(B,i,T,R,w,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ParcelWatcherClient=void 0;class C extends I.AbstractRecursiveWatcherClient{constructor(l,m,y){super(l,m,y);this.init()}createWatcher(l){const m=l.add(new w.Client(T.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(m.onDidProcessExit(({code:y,signal:D})=>this.onError(`terminated by itself with code ${y}, signal: ${D}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher")))}}i.ParcelWatcherClient=C}),define(ee[54],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class T{constructor(...w){this._entries=new Map;for(let[I,C]of w)this.set(I,C)}set(w,I){const C=this._entries.get(w);return this._entries.set(w,I),C}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}i.ServiceCollection=T}),define(ee[98],te([0,1,3,7,41,94,14,54]),function(B,i,T,R,w,I,C,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InstantiationService=void 0;const l=!1;class m extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class y{constructor(d=new S.ServiceCollection,g=!1,h){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=h,this._services.set(C.IInstantiationService,this)}createChild(d){return new y(d,this._strict,this)}invokeFunction(d,...g){let h=u.traceInvocation(d),p=!1;try{return d({get:f=>{if(p)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,h);if(!s)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...g)}finally{p=!0,h.stop()}}createInstance(d,...g){let h,p;return d instanceof w.SyncDescriptor?(h=u.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(g),h)):(h=u.traceCreation(d),p=this._createInstance(d,g,h)),h.stop(),p}_createInstance(d,g=[],h){let p=C._util.getServiceDependencies(d).sort((s,a)=>s.index-a.index),b=[];for(const s of p){let a=this._getOrCreateServiceInstance(s.id,h);if(!a&&this._strict&&!s.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${s.id}.`);b.push(a)}let f=p.length>0?p[0].index:g.length;if(g.length!==f){console.warn(`[createInstance] First service dependency of ${d.name} at position ${f+1} conflicts with ${g.length} static arguments`);let s=f-g.length;s>0?g=g.concat(new Array(s)):g=g.slice(0,f)}return new d(...[...g,...b])}_setServiceInstance(d,g){if(this._services.get(d)instanceof w.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let h=this._getServiceInstanceOrDescriptor(d);return h instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,h,g.branch(d,!0)):(g.branch(d,!1),h)}_safeCreateAndCacheServiceInstance(d,g,h){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,h)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,h){const p=new I.Graph(s=>s.id.toString());let b=0;const f=[{id:d,desc:g,_trace:h}];for(;f.length;){const s=f.pop();if(p.lookupOrInsertNode(s),b++>1e3)throw new m(p);for(let a of C._util.getServiceDependencies(s.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(a.id);if(!n&&!a.optional&&console.warn(`[createInstance] ${d} depends on ${a.id} which is NOT registered.`),n instanceof w.SyncDescriptor){const o={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};p.insertEdge(s,o),f.push(o)}}}for(;;){const s=p.roots();if(s.length===0){if(!p.isEmpty())throw new m(p);break}for(const{data:a}of s){if(this._getServiceInstanceOrDescriptor(a.id)instanceof w.SyncDescriptor){const o=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,o)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,h=[],p,b){if(this._services.get(d)instanceof w.SyncDescriptor)return this._createServiceInstance(g,h,p,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,h,p,b);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],h,p){if(h){const b=new T.IdleValue(()=>this._createInstance(d,g,p));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let a=b.value,n=a[s];return typeof n!="function"||(n=n.bind(a),f[s]=n),n},set(f,s,a){return b.value[s]=a,!0}})}else return this._createInstance(d,g,p)}}i.InstantiationService=y;var D;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(D||(D={}));class u{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return l?new u(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(d){return l?new u(0,d.name):u._None}branch(d,g){let h=new u(2,d.toString());return this._dep.push([d,g,h]),h}stop(){let d=Date.now()-this._start;u._totals+=d;let g=!1;function h(b,f){let s=[],a=new Array(b+1).join("	");for(const[n,o,e]of f._dep)if(o&&e){g=!0,s.push(`${a}CREATES -> ${n}`);let t=h(b+1,e);t&&s.push(t)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(p.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(ee[55],te([0,1,14]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,T.createDecorator)("localizationsService");function R(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const I of w.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}i.isValidLocalization=R}),define(ee[15],te([0,1,28,10,2,12,14]),function(B,i,T,R,w,I,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,C.createDecorator)("logService"),i.ILoggerService=(0,C.createDecorator)("loggerService");function S(){return new Date().toISOString()}var l;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function m(o,e,t){switch(e){case l.Trace:o.trace(t);break;case l.Debug:o.debug(t);break;case l.Info:o.info(t);break;case l.Warning:o.warn(t);break;case l.Error:o.error(t);break;case l.Critical:o.critical(t);break;default:throw new Error("Invalid log level")}}i.log=m;function y(o){let e="";for(let t=0;t<o.length;t++){let r=o[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}e+=(t>0?" ":"")+r}return e}i.format=y;class D extends w.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=D;class u extends D{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...t){this.checkLogLevel(l.Trace)&&this.log(l.Trace,y([e,...t]))}debug(e,...t){this.checkLogLevel(l.Debug)&&this.log(l.Debug,y([e,...t]))}info(e,...t){this.checkLogLevel(l.Info)&&this.log(l.Info,y([e,...t]))}warn(e,...t){this.checkLogLevel(l.Warning)&&this.log(l.Warning,y([e,...t]))}error(e,...t){if(this.checkLogLevel(l.Error))if(e instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=e.stack,this.log(l.Error,y(r))}else this.log(l.Error,y([e,...t]))}critical(e,...t){this.checkLogLevel(l.Critical)&&this.log(l.Critical,y([e,...t]))}flush(){}}i.AbstractMessageLogger=u;class E extends D{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...t){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,e,...t):console.log(`[main ${S()}]`,e,...t))}debug(e,...t){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,e,...t):console.log(`[main ${S()}]`,e,...t))}info(e,...t){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,e,...t):console.log(`[main ${S()}]`,e,...t))}warn(e,...t){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,e,...t):console.warn(`[main ${S()}]`,e,...t))}error(e,...t){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,e,...t):console.error(`[main ${S()}]`,e,...t))}critical(e,...t){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,e,...t):console.error(`[main ${S()}]`,e,...t))}dispose(){}flush(){}}i.ConsoleMainLogger=E;class d extends D{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...t){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}}i.ConsoleLogger=d;class g extends D{constructor(e,t=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(t)}trace(e,...t){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...t])}warn(e,...t){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...t])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=g;class h extends D{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const r of this.logServices)r.trace(e,...t)}debug(e,...t){for(const r of this.logServices)r.debug(e,...t)}info(e,...t){for(const r of this.logServices)r.info(e,...t)}warn(e,...t){for(const r of this.logServices)r.warn(e,...t)}error(e,...t){for(const r of this.logServices)r.error(e,...t)}critical(e,...t){for(const r of this.logServices)r.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=h;class p extends w.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...t){this.logger.trace(e,...t)}debug(e,...t){this.logger.debug(e,...t)}info(e,...t){this.logger.info(e,...t)}warn(e,...t){this.logger.warn(e,...t)}error(e,...t){this.logger.error(e,...t)}critical(e,...t){this.logger.critical(e,...t)}flush(){this.logger.flush()}}i.LogService=p;class b extends w.Disposable{constructor(e,t){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(r))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,t){let r=this.loggers.get(e.toString());return r||(r=this.doCreateLogger(e,t?.always?l.Trace:this.logLevel,t),this.loggers.set(e.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=b;class f{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}}i.NullLogService=f;function s(o){if(o.verbose)return l.Trace;if(typeof o.logLevel=="string"){const e=a(o.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=s;function a(o){switch(o){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=a;function n(o){switch(o){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=n});var ce=this&&this.__param||function(B,i){return function(T,R){i(T,R,B)}};define(ee[99],te([0,1,40,3,28,10,2,11,4,13,20,15]),function(B,i,T,R,w,I,C,S,l,m,y,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let u=class extends C.Disposable{constructor(d,g){super();this.environmentService=d,this.logService=g,this.processesLimiter=new R.Limiter(5)}async postUninstall(d){const g=this.parseScript(d,"uninstall");return g&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),h=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${h}`)))),m.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,h=>this.logService.error("Error while removing extension storage path",h))}parseScript(d,g){const h=`vscode:${g}`;if(d.location.scheme===S.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[h]=="string"){const p=d.manifest.scripts[h].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${h} should be a node script`),null):{script:(0,l.join)(d.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(d,g,h,p,b){return new Promise((f,s)=>{const a=this.start(d,g,h,b);let n;const o=e=>{n&&(clearTimeout(n),n=null),e?s(e):f(void 0)};a.on("error",e=>{o((0,w.toErrorMessage)(e)||"Unknown")}),a.on("exit",(e,t)=>{o(e?`post-${g} process exited with code ${e}`:void 0)}),p&&(n=setTimeout(()=>{n=null,a.kill(),s("timed out")},5e3))})}start(d,g,h,p){const b={silent:!0,execArgv:void 0},f=(0,T.fork)(d,[`--type=extension-post-${g}`,...h],b);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=I.Event.fromNodeEventEmitter(f.stdout,"data"),a=I.Event.fromNodeEventEmitter(f.stderr,"data");s(e=>this.logService.info(p.identifier.id,p.manifest.version,`post-${g}`,e)),a(e=>this.logService.error(p.identifier.id,p.manifest.version,`post-${g}`,e));const n=I.Event.any(I.Event.map(s,e=>({data:`%c${e}`,format:[""]})),I.Event.map(a,e=>({data:`%c${e}`,format:["color: red"]})));return I.Event.debounce(n,(e,t)=>e?{data:e.data+t.data,format:[...e.format,...t.format]}:{data:t.data,format:t.format},100)(e=>{console.group(p.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),f}getExtensionStoragePath(d){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};u=pe([ce(0,y.IEnvironmentService),ce(1,D.ILogService)],u),i.ExtensionsLifecycle=u}),define(ee[100],te([0,1,19,3,7,10,2,4,42,15]),function(B,i,T,R,w,I,C,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class y extends C.Disposable{constructor(u){super();this.logService=u,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(u,E){return E.recursive?this.watchRecursive(u,E):this.watchNonRecursive(u,E)}watchRecursive(u,E){const d={path:this.toFilePath(u),excludes:E.excludes},g=(0,T.insert)(this.recursiveFoldersToWatch,d);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(u=>(0,w.onUnexpectedError)(u))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(u=>this._onDidChangeFile.fire((0,l.toFileChanges)(u)),u=>this.onWatcherLogMessage(u),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(u,E){return u.watch(E)}watchNonRecursive(u,E){const d=this.createNonRecursiveWatcher(this.toFilePath(u),E.excludes,h=>this._onDidChangeFile.fire((0,l.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===m.LogLevel.Trace),g=this.logService.onDidChangeLogLevel(()=>{d.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)});return(0,C.combinedDisposable)(d,g)}onWatcherLogMessage(u){u.type==="error"&&this._onDidWatchError.fire(u.message),this.logService[u.type](u.message)}toFilePath(u){return(0,S.normalize)(u.fsPath)}}i.AbstractDiskFileSystemProvider=y}),define(ee[101],te([0,1,19,3,17,25,10,135,2,39,11,102,18,37,84,16,53,15]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E,d,g,h,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let b=class xe extends l.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new C.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new R.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new g.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new R.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new g.FileChangesEvent(a,!0)))),this.nonRecursiveWatchedResources=m.TernarySearchTree.forUris(a=>{const n=this.getProvider(a.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(s,a){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,D.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:a});const n=new l.DisposableStore;return n.add(a.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(a)))),n.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:s}))),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(o=>this._onDidWatchError.fire(new Error(o)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:a}),this.provider.delete(s),(0,l.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){a.push(n)}}),!this.provider.has(s)&&await R.Promises.settled(a)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,a){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return S.Iterable.map(this.provider,([s,a])=>({scheme:s,capabilities:a.capabilities}))}async withProvider(s){if(!(0,u.isAbsolutePath)(s))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const a=this.provider.get(s.scheme);if(!a){const n=new Error;throw n.name="ENOPRO",n.message=(0,d.localize)(1,null,s.toString()),n}return a}async withReadProvider(s){const a=await this.withProvider(s);if((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)||(0,g.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const a=await this.withProvider(s);if((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,a){try{return await this.doResolveFile(s,a)}catch(n){throw(0,g.toFileSystemProviderErrorCode)(n)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(s)),1):(0,g.ensureFileSystemProviderError)(n)}}async doResolveFile(s,a){const n=await this.withProvider(s),o=this.isPathCaseSensitive(n),e=a?.resolveTo,t=a?.resolveSingleChildDescendants,r=a?.resolveMetadata,c=await n.stat(s);let v;return this.toFileStat(n,s,c,void 0,!!r,(L,P)=>(v||(v=m.TernarySearchTree.forUris(()=>!o),v.set(s,!0),e&&v.fill(!0,e)),v.get(L.resource)||v.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&t?P===1:!1))}async toFileStat(s,a,n,o,e,t){const{providerExtUri:r}=this.getExtUri(s),c={resource:a,name:r.basename(a),isFile:(n.type&g.FileType.File)!=0,isDirectory:(n.type&g.FileType.Directory)!=0,isSymbolicLink:(n.type&g.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&g.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,g.etag)({mtime:n.mtime,size:n.size})};if(c.isDirectory&&t(c,o)){try{const v=await s.readdir(a),L=await R.Promises.settled(v.map(async([P,k])=>{try{const U=r.joinPath(a,P),J=e?await s.stat(U):{type:k};return await this.toFileStat(s,U,J,v.length,e,t)}catch(U){return this.logService.trace(U),null}}));c.children=(0,T.coalesce)(L)}catch(v){this.logService.trace(v),c.children=[]}return c}return c}async resolveAll(s){return R.Promises.settled(s.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(s){const a=await this.withProvider(s);try{return!!await a.stat(s)}catch{return!1}}async canCreateFile(s,a){try{await this.doValidateCreateFile(s,a)}catch(n){return n}return!0}async doValidateCreateFile(s,a){if(!a?.overwrite&&await this.exists(s))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(s)),3,a)}async createFile(s,a=w.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const o=await this.writeFile(s,a);return this._onDidRunOperation.fire(new g.FileOperationEvent(s,0,o)),o}async writeFile(s,a,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:e}=this.getExtUri(o);try{await this.validateWriteFile(o,s,n)||await this.mkdirp(o,e.dirname(s));let r;if((0,g.hasReadWriteCapability)(o)&&!(a instanceof w.VSBuffer))if((0,E.isReadableStream)(a)){const c=await(0,E.peekStream)(a,3);c.ended?r=w.VSBuffer.concat(c.buffer):r=c}else r=(0,E.peekReadable)(a,c=>w.VSBuffer.concat(c),3);else r=a;!(0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasReadWriteCapability)(o)&&r instanceof w.VSBuffer?await this.doWriteUnbuffered(o,s,n,r):await this.doWriteBuffered(o,s,n,r instanceof w.VSBuffer?(0,w.bufferToReadable)(r):r)}catch(t){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(t).toString()),(0,g.toFileOperationResult)(t),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,a,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(a)));let e;try{e=await s.stat(a)}catch{return}if((e.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(a)),0,n);if(this.throwIfFileIsReadonly(a,e),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==g.ETAG_DISABLED&&typeof e.mtime=="number"&&typeof e.size=="number"&&n.mtime<e.mtime&&n.etag!==(0,g.etag)({mtime:n.mtime,size:e.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,n);return e}async readFile(s,a,n){const o=await this.withReadProvider(s);return a?.atomic?this.doReadFileAtomic(o,s,a,n):this.doReadFile(o,s,a,n)}async doReadFileAtomic(s,a,n,o){return new Promise((e,t)=>{this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(s,a,n,o);e(r)}catch(r){t(r)}})})}async doReadFile(s,a,n,o){const e=await this.doReadFileStream(s,a,{...n,preferUnbuffered:!0},o);return{...e,value:await(0,w.streamToBuffer)(e.value)}}async readFileStream(s,a,n){const o=await this.withReadProvider(s);return this.doReadFileStream(o,s,a,n)}async doReadFileStream(s,a,n,o){const e=new I.CancellationTokenSource(o),t=this.validateReadFile(a,n).then(c=>c,c=>{throw e.cancel(),c});let r;try{return typeof n?.etag=="string"&&n.etag!==g.ETAG_DISABLED&&await t,n?.atomic&&(0,g.hasFileAtomicReadCapability)(s)||!((0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasFileReadStreamCapability)(s))||(0,g.hasReadWriteCapability)(s)&&n?.preferUnbuffered?r=this.readFileUnbuffered(s,a,n):(0,g.hasFileReadStreamCapability)(s)?r=this.readFileStreamed(s,a,e.token,n):r=this.readFileBuffered(s,a,e.token,n),{...await t,value:r}}catch(c){r&&await(0,E.consumeStream)(r);const v=(0,d.localize)(8,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(c).toString());throw c instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(v,c.stat,n):new g.FileOperationError(v,(0,g.toFileOperationResult)(c),n)}}readFileStreamed(s,a,n,o=Object.create(null)){const e=s.readFileStream(a,o,n);return(0,E.transform)(e,{data:t=>t instanceof w.VSBuffer?t:w.VSBuffer.wrap(t),error:t=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(t).toString()),(0,g.toFileOperationResult)(t),o)},t=>w.VSBuffer.concat(t))}readFileBuffered(s,a,n,o=Object.create(null)){const e=(0,w.newWriteableBufferStream)();return(0,h.readFileIntoStream)(s,a,e,t=>t,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(t).toString()),(0,g.toFileOperationResult)(t),o)},n),e}readFileUnbuffered(s,a,n){const o=(0,E.newWriteableStream)(e=>w.VSBuffer.concat(e));return(async()=>{try{let e;n?.atomic&&(0,g.hasFileAtomicReadCapability)(s)?e=await s.readFile(a,{atomic:!0}):e=await s.readFile(a),typeof n?.position=="number"&&(e=e.slice(n.position)),typeof n?.length=="number"&&(e=e.slice(0,n.length)),this.validateReadFileLimits(a,e.byteLength,n),o.end(w.VSBuffer.wrap(e))}catch(e){o.error(e),o.end()}})(),o}async validateReadFile(s,a){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(s)),0,a);if(typeof a?.etag=="string"&&a.etag!==g.ETAG_DISABLED&&a.etag===n.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),n,a);return this.validateReadFileLimits(s,n.size,a),n}validateReadFileLimits(s,a,n){if(n?.limits){let o;if(typeof n.limits.memory=="number"&&a>n.limits.memory&&(o=9),typeof n.limits.size=="number"&&a>n.limits.size&&(o=7),typeof o=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(s)),o)}}async canMove(s,a,n){return this.doCanMoveCopy(s,a,"move",n)}async canCopy(s,a,n){return this.doCanMoveCopy(s,a,"copy",n)}async doCanMoveCopy(s,a,n,o){if(s.toString()!==a.toString())try{const e=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(e,s,t,a,n,o)}catch(e){return e}return!0}async move(s,a,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(o,s,e,a,"move",!!n),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,t==="move"?2:3,r)),r}async copy(s,a,n){const o=await this.withReadProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(o,s,e,a,"copy",!!n),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,t==="copy"?3:2,r)),r}async doMoveCopy(s,a,n,o,e,t){if(a.toString()===o.toString())return e;const{exists:r,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(s,a,n,o,e,t);if(r&&!c&&t&&await this.del(o,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(o)),e==="copy"){if(s===n&&(0,g.hasFileFolderCopyCapability)(s))await s.copy(a,o,{overwrite:t});else{const v=await this.resolve(a);v.isDirectory?await this.doCopyFolder(s,v,n,o):await this.doCopyFile(s,a,n,o)}return e}else return s===n?(await s.rename(a,o,{overwrite:t}),e):(await this.doMoveCopy(s,a,n,o,"copy",t),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(s,a,n,o){if((0,g.hasOpenReadWriteCloseCapability)(s)&&(0,g.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,a,n,o);if((0,g.hasOpenReadWriteCloseCapability)(s)&&(0,g.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,a,n,o);if((0,g.hasReadWriteCapability)(s)&&(0,g.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,a,n,o);if((0,g.hasReadWriteCapability)(s)&&(0,g.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,a,n,o)}async doCopyFolder(s,a,n,o){await n.mkdir(o),Array.isArray(a.children)&&await R.Promises.settled(a.children.map(async e=>{const t=this.getExtUri(n).providerExtUri.joinPath(o,e.name);return e.isDirectory?this.doCopyFolder(s,await this.resolve(e.resource),n,t):this.doCopyFile(s,e.resource,n,t)}))}async doValidateMoveCopy(s,a,n,o,e,t){let r=!1;if(s===n){const{providerExtUri:v,isPathCaseSensitive:L}=this.getExtUri(s);if(L||(r=v.isEqual(a,o)),r&&e==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(a),this.resourceForError(o)));if(!r&&v.isEqualOrParent(o,a))throw new Error((0,d.localize)(15,null,this.resourceForError(a),this.resourceForError(o)))}const c=await this.exists(o);if(c&&!r){if(!t)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(a),this.resourceForError(o)),4);if(s===n){const{providerExtUri:v}=this.getExtUri(s);if(v.isEqualOrParent(a,o))throw new Error((0,d.localize)(17,null,this.resourceForError(a),this.resourceForError(o)))}}return{exists:c,isSameResourceWithDifferentPathCase:r}}getExtUri(s){const a=this.isPathCaseSensitive(s);return{providerExtUri:a?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(a,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,0,n)),n}async mkdirp(s,a){const n=[],{providerExtUri:o}=this.getExtUri(s);for(;!o.isEqual(a,o.dirname(a));)try{if(((await s.stat(a)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(a)));break}catch(e){if((0,g.toFileSystemProviderErrorCode)(e)!==g.FileSystemProviderErrorCode.FileNotFound)throw e;n.push(o.basename(a)),a=o.dirname(a)}for(let e=n.length-1;e>=0;e--){a=o.joinPath(a,n[e]);try{await s.mkdir(a)}catch(t){if((0,g.toFileSystemProviderErrorCode)(t)!==g.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(s,a){try{await this.doValidateDelete(s,a)}catch(n){return n}return!0}async doValidateDelete(s,a){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!a?.useTrash&&!(n.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(s)));let e;try{e=await n.stat(s)}catch{}if(e)this.throwIfFileIsReadonly(s,e);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(s)),1);if(!!!a?.recursive){const r=await this.resolve(s);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(s)))}return n}async del(s,a){const n=await this.doValidateDelete(s,a),o=!!a?.useTrash,e=!!a?.recursive;await n.delete(s,{recursive:e,useTrash:o}),this._onDidRunOperation.fire(new g.FileOperationEvent(s,1))}onDidChangeFile(s,a){this._onDidChangeFilesRaw.fire({changes:s});let n,o;{for(const e of s)this.nonRecursiveWatchedResources.has(e.resource)?(n||(n=[]),n.push(e)):(o||(o=[]),o.push(e));n&&this._onDidFilesChange.fire(new g.FileChangesEvent(n,!a))}if(o){const e=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!e.work(o)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),e.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${e.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,a={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let o=!1,e=()=>{o=!0};return n.add((0,l.toDisposable)(()=>e())),(async()=>{try{const t=await this.doWatch(s,a);o?(0,l.dispose)(t):e=()=>(0,l.dispose)(t)}catch(t){this.logService.error(t)}})(),a.recursive||(this.nonRecursiveWatchedResources.set(s,(this.nonRecursiveWatchedResources.get(s)??0)+1),n.add((0,l.toDisposable)(()=>{const t=this.nonRecursiveWatchedResources.get(s);typeof t=="number"&&(t<=1?this.nonRecursiveWatchedResources.delete(s):this.nonRecursiveWatchedResources.set(s,t-1))}))),n}async doWatch(s,a){const n=await this.withProvider(s),o=this.toWatchKey(n,s,a);let e=this.activeWatchers.get(o);return e||(e={count:0,disposable:n.watch(s,a)},this.activeWatchers.set(o,e)),e.count+=1,(0,l.toDisposable)(()=>{e&&(e.count--,e.count===0&&((0,l.dispose)(e.disposable),this.activeWatchers.delete(o)))})}toWatchKey(s,a,n){const{providerExtUri:o}=this.getExtUri(s);return[o.getComparisonKey(a),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,l.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,a,n,o){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{const e=await s.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,E.isReadableStream)(o)||(0,E.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(s,e,o):await this.doWriteReadableBufferedQueued(s,e,o)}catch(t){throw(0,g.ensureFileSystemProviderError)(t)}finally{await s.close(e)}})}async doWriteStreamBufferedQueued(s,a,n){let o=0,e;if((0,E.isReadableBufferedStream)(n)){if(n.buffer.length>0){const t=w.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,a,t,t.byteLength,o,0),o+=t.byteLength}if(n.ended)return;e=n.stream}else e=n;return new Promise((t,r)=>{(0,E.listenStream)(e,{onData:async c=>{e.pause();try{await this.doWriteBuffer(s,a,c,c.byteLength,o,0)}catch(v){return r(v)}o+=c.byteLength,setTimeout(()=>e.resume())},onError:c=>r(c),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(s,a,n){let o=0,e;for(;(e=n.read())!==null;)await this.doWriteBuffer(s,a,e,e.byteLength,o,0),o+=e.byteLength}async doWriteBuffer(s,a,n,o,e,t){let r=0;for(;r<o;)r+=await s.write(a,e+r,n.buffer,t+r,o-r)}async doWriteUnbuffered(s,a,n,o){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,a,n,o))}async doWriteUnbufferedQueued(s,a,n,o){let e;o instanceof w.VSBuffer?e=o:(0,E.isReadableStream)(o)?e=await(0,w.streamToBuffer)(o):(0,E.isReadableBufferedStream)(o)?e=await(0,w.bufferedStreamToBuffer)(o):e=(0,w.readableToBuffer)(o),await s.writeFile(a,e.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,a,n,o))}async doPipeBufferedQueued(s,a,n,o){let e,t;try{e=await s.open(a,{create:!1}),t=await n.open(o,{create:!0,unlock:!1});const r=w.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,v=0,L=0;do L=await s.read(e,c,r.buffer,v,r.byteLength-v),await this.doWriteBuffer(n,t,r,L,c,v),c+=L,v+=L,v===r.byteLength&&(v=0);while(L>0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await R.Promises.settled([typeof e=="number"?s.close(e):Promise.resolve(),typeof t=="number"?n.close(t):Promise.resolve()])}}async doPipeUnbuffered(s,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,a,n,o))}async doPipeUnbufferedQueued(s,a,n,o){return n.writeFile(o,await s.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,a,n,o))}async doPipeUnbufferedToBufferedQueued(s,a,n,o){const e=await n.open(o,{create:!0,unlock:!1});try{const t=await s.readFile(a);await this.doWriteBuffer(n,e,w.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,g.ensureFileSystemProviderError)(t)}finally{await n.close(e)}}async doPipeBufferedToUnbuffered(s,a,n,o){const e=await(0,w.streamToBuffer)(this.readFileBuffered(s,a,I.CancellationToken.None));await this.doWriteUnbuffered(n,o,void 0,e)}throwIfFileSystemIsReadonly(s,a){if(s.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(a)),6);return s}throwIfFileIsReadonly(s,a){if((a.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===y.Schemas.file?s.fsPath:s.toString(!0)}};b.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},b=pe([ce(0,p.ILogService)],b),i.FileService=b}),define(ee[103],te([0,1,48,136,3,39,17,10,38,2,4,12,18,37,13,86,16,53,96,97,100,28]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E,d,g,h,p,b,f,s,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(T)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(o)}`)}})();class n extends s.AbstractDiskFileSystemProvider{constructor(e,t){super(e);this.options=t,this.onDidChangeCapabilities=S.Event.None,this.resourceLocks=new I.ResourceMap(r=>u.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,D.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:t,symbolicLink:r}=await d.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(t,r),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(e){try{const t=await d.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),r=[];return await Promise.all(t.map(async c=>{try{let v;c.isSymbolicLink()?v=(await this.stat((0,u.joinPath)(e,c.name))).type:v=this.toType(c),r.push([c.name,v])}catch(v){this.logService.trace(v)}})),r}catch(t){throw this.toFileSystemProviderError(t)}}toType(e,t){let r;return t?.dangling?r=h.FileType.Unknown:e.isFile()?r=h.FileType.File:e.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,t&&(r|=h.FileType.SymbolicLink),r}async createResourceLock(e){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(e)})`);let t;for(;t=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(e)})`),await t.wait();const r=new w.Barrier;return this.resourceLocks.set(e,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(e)})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(e)})`),this.resourceLocks.delete(e),r.open()})}async readFile(e,t){let r;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),r=await this.createResourceLock(e));const c=this.toFilePath(e);return await d.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{r?.dispose()}}readFileStream(e,t,r){const c=(0,E.newWriteableStream)(v=>C.VSBuffer.concat(v.map(L=>C.VSBuffer.wrap(L))).buffer);return(0,p.readFileIntoStream)(this,e,c,v=>v.buffer,{...t,bufferSize:256*1024},r),c}async writeFile(e,t,r){let c;try{const v=this.toFilePath(e);if(!r.create||!r.overwrite){if(await d.Promises.exists(v)){if(!r.overwrite)throw(0,h.createFileSystemProviderError)((0,g.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.createFileSystemProviderError)((0,g.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(e,{create:!0,unlock:r.unlock}),await this.write(c,0,t,0,t.byteLength)}catch(v){throw await this.toFileSystemProviderWriteError(e,v)}finally{typeof c=="number"&&await this.close(c)}}async open(e,t){let r;(0,h.isFileOpenForWriteOptions)(t)&&(r=await this.createResourceLock(e));let c;try{const v=this.toFilePath(e);if((0,h.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:P}=await d.SymlinkSupport.stat(v);P.mode&128||await d.Promises.chmod(v,P.mode|128)}catch(P){this.logService.trace(P)}let L;if((0,h.isFileOpenForWriteOptions)(t)){if(D.isWindows)try{await d.Promises.truncate(v,0),L="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}L||(L="w")}else L="r";c=await d.Promises.open(v,L)}catch(v){throw r?.dispose(),(0,h.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(e,v):this.toFileSystemProviderError(v)}return this.mapHandleToPos.set(c,0),(0,h.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(c,e),r&&this.mapHandleToLock.set(c,r),c}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await d.Promises.fdatasync(e)}catch(t){this.canFlush=!1,this.logService.error(t)}return await d.Promises.close(e)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(e);t&&(this.mapHandleToLock.delete(e),t.dispose())}}async read(e,t,r,c,v){const L=this.normalizePos(e,t);let P=null;try{const k=await d.Promises.read(e,r,c,v,L);return typeof k=="number"?P=k:P=k.bytesRead,P}catch(k){throw this.toFileSystemProviderError(k)}finally{this.updatePos(e,L,P)}}normalizePos(e,t){return t===this.mapHandleToPos.get(e)?null:t}updatePos(e,t,r){const c=this.mapHandleToPos.get(e);typeof c=="number"&&(typeof t=="number"||(typeof r=="number"?this.mapHandleToPos.set(e,c+r):this.mapHandleToPos.delete(e)))}async write(e,t,r,c,v){return(0,w.retry)(()=>this.doWrite(e,t,r,c,v),100,3)}async doWrite(e,t,r,c,v){const L=this.normalizePos(e,t);let P=null;try{const k=await d.Promises.write(e,r,c,v,L);return typeof k=="number"?P=k:P=k.bytesWritten,P}catch(k){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),k)}finally{this.updatePos(e,L,P)}}async mkdir(e){try{await d.Promises.mkdir(this.toFilePath(e))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(e,t){try{const r=this.toFilePath(e);t.recursive?await d.Promises.rm(r,d.RimRafMode.MOVE):await d.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(e,t,r){const c=this.toFilePath(e),v=this.toFilePath(t);if(c!==v)try{await this.validateTargetDeleted(e,t,"move",r.overwrite),await d.Promises.move(c,v)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,g.localize)(2,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(v)),L.toString()))),this.toFileSystemProviderError(L)}}async copy(e,t,r){const c=this.toFilePath(e),v=this.toFilePath(t);if(c!==v)try{await this.validateTargetDeleted(e,t,"copy",r.overwrite),await d.Promises.copy(c,v,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,g.localize)(3,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(v)),L.toString()))),this.toFileSystemProviderError(L)}}async validateTargetDeleted(e,t,r,c){const v=this.toFilePath(e),L=this.toFilePath(t);let P=!1;if(!!(this.capabilities&1024)||(P=(0,l.isEqual)(v,L,!0)),P&&r==="copy")throw(0,h.createFileSystemProviderError)((0,g.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!P&&await d.Promises.exists(L)){if(!c)throw(0,h.createFileSystemProviderError)((0,g.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(e,t,r){return new f.ParcelWatcherClient(c=>e(c),c=>t(c),r)}doWatch(e,t){const r=this.options?.watcher?.usePolling;if(r===!0)for(const c of t)c.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(r))for(const c of t)r.includes(c.path)&&(c.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(e,t)}createNonRecursiveWatcher(e,t,r,c,v){return new b.NodeJSFileWatcher(e,t,L=>r(L),L=>c(L),v)}toFileSystemProviderError(e){if(e instanceof h.FileSystemProviderError)return e;let t;switch(e.code){case"ENOENT":t=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=h.FileSystemProviderErrorCode.NoPermissions;break;default:t=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(e,t)}async toFileSystemProviderWriteError(e,t){let r=this.toFileSystemProviderError(t);if(e&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.toFilePath(e));c.mode&128||(r=(0,h.createFileSystemProviderError)(t,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return r}}i.DiskFileSystemProvider=n}),define(ee[104],te([0,1,16,15]),function(B,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function w(S,l,m,y,D){try{const u=await new Promise((d,g)=>{B(["spdlog"],d,g)});u.setFlushOn(R.LogLevel.Trace);const E=await u.createAsyncRotatingLogger(S,l,m,y);return D&&E.clearFormatters(),E}catch(u){console.error(u)}return null}function I(S,l,m){switch(l){case R.LogLevel.Trace:S.trace(m);break;case R.LogLevel.Debug:S.debug(m);break;case R.LogLevel.Info:S.info(m);break;case R.LogLevel.Warning:S.warn(m);break;case R.LogLevel.Error:S.error(m);break;case R.LogLevel.Critical:S.critical(m);break;default:throw new Error("Invalid log level")}}class C extends R.AbstractMessageLogger{constructor(l,m,y,D,u){super();this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(l,m,y,D),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(l,m,y,D){const u=y?6:1,E=30/u*T.ByteSize.MB,d=await w(l,m,E,u,D);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:g,message:h}of this.buffer)I(this._logger,g,h);this.buffer=[]}}log(l,m){this._logger?I(this._logger,l,m):this.getLevel()<=l&&this.buffer.push({level:l,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=C}),define(ee[32],te([0,1,14]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IProductService=void 0,i.IProductService=(0,T.createDecorator)("productService")}),define(ee[30],te([0,1,56,8]),function(B,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class w{constructor(){this.data=new Map}add(C,S){T.ok(R.isString(C)),T.ok(R.isObject(S)),T.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,S)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}i.Registry=new w}),define(ee[105],te([0,1,10,30]),function(B,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function w(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class I{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,m){this.schemasById[w(l)]=m,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new I;R.Registry.add(i.Extensions.JSONContribution,C)}),define(ee[34],te([0,1,19,10,8,75,105,30]),function(B,i,T,R,w,I,C,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var l;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(l=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=S.Registry.as(C.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,n=!0){this.registerConfigurations([a],n)}registerConfigurations(a,n=!0){const o=this.doRegisterConfigurations(a,n);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(a){const n=this.doDeregisterConfigurations(a);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:a,remove:n}){const o=[];o.push(...this.doDeregisterConfigurations(n)),o.push(...this.doRegisterConfigurations(a,!1)),y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,T.distinct)(o)})}registerDefaultConfigurations(a){const n=[],o=[];for(const{overrides:e,source:t}of a)for(const r in e)if(n.push(r),i.OVERRIDE_PROPERTY_REGEX.test(r)){const c={...this.configurationDefaultsOverrides.get(r)?.value||{},...e[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:c});const v={type:"object",default:c,description:I.localize(1,null,r),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:w.isString(t)?void 0:t};o.push(...d(r)),this.configurationProperties[r]=v,this.defaultLanguageConfigurationOverridesNode.properties[r]=v}else{this.configurationDefaultsOverrides.set(r,{value:e[r],source:t});const c=this.configurationProperties[r];c&&(this.updatePropertyDefaultValue(r,c),this.updateSchema(r,c))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const n=[];for(const{overrides:o,source:e}of a)for(const t in o){const r=this.configurationDefaultsOverrides.get(t),c=w.isString(e)?e:e?.id,v=w.isString(r?.source)?r?.source:r?.source?.id;if(c===v)if(n.push(t),this.configurationDefaultsOverrides.delete(t),i.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const L=this.configurationProperties[t];L&&(this.updatePropertyDefaultValue(t,L),this.updateSchema(t,L))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const n of a)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,n){const o=[];return a.forEach(e=>{o.push(...this.validateAndRegisterProperties(e,n,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),o}doDeregisterConfigurations(a){const n=[],o=e=>{if(e.properties)for(const t in e.properties)n.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t]);e.allOf&&e.allOf.forEach(t=>o(t))};for(const e of a){o(e);const t=this.configurationContributors.indexOf(e);t!==-1&&this.configurationContributors.splice(t,1)}return n}validateAndRegisterProperties(a,n=!0,o,e,t=3){t=w.isUndefinedOrNull(a.scope)?t:a.scope;let r=[],c=a.properties;if(c)for(let L in c){if(n&&b(L)){delete c[L];continue}const P=c[L];if(P.source=o,P.defaultDefaultValue=c[L].default,this.updatePropertyDefaultValue(L,P),i.OVERRIDE_PROPERTY_REGEX.test(L)?P.scope=void 0:(P.scope=w.isUndefinedOrNull(P.scope)?t:P.scope,P.restricted=w.isUndefinedOrNull(P.restricted)?!!e?.includes(L):P.restricted),c[L].hasOwnProperty("included")&&!c[L].included){this.excludedConfigurationProperties[L]=c[L],delete c[L];continue}else this.configurationProperties[L]=c[L];!c[L].deprecationMessage&&c[L].markdownDeprecationMessage&&(c[L].deprecationMessage=c[L].markdownDeprecationMessage),r.push(L)}let v=a.allOf;if(v)for(let L of v)r.push(...this.validateAndRegisterProperties(L,n,o,e,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const n=o=>{let e=o.properties;if(e)for(const r in e)this.updateSchema(r,e[r]);let t=o.allOf;t&&t.forEach(n)};n(a)}updateSchema(a,n){switch(i.allSettings.properties[a]=n,n.scope){case 1:i.applicationSettings.properties[a]=n;break;case 2:i.machineSettings.properties[a]=n;break;case 6:i.machineOverridableSettings.properties[a]=n;break;case 3:i.windowSettings.properties[a]=n;break;case 4:i.resourceSettings.properties[a]=n;break;case 5:i.resourceSettings.properties[a]=n,this.resourceLanguageSettingsSchema.properties[a]=n;break}}removeFromSchema(a,n){switch(delete i.allSettings.properties[a],n.scope){case 1:delete i.applicationSettings.properties[a];break;case 2:delete i.machineSettings.properties[a];break;case 6:delete i.machineOverridableSettings.properties[a];break;case 3:delete i.windowSettings.properties[a];break;case 4:case 5:delete i.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const n=`[${a}]`,o={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,o),i.allSettings.properties[n]=o,i.applicationSettings.properties[n]=o,i.machineSettings.properties[n]=o,i.machineOverridableSettings.properties[n]=o,i.windowSettings.properties[n]=o,i.resourceSettings.properties[n]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,n){const o=this.configurationDefaultsOverrides.get(a);let e=o?.value,t=o?.source;w.isUndefined(e)&&(e=n.defaultDefaultValue,t=void 0),w.isUndefined(e)&&(e=h(n.type)),n.default=e,n.defaultValueSource=t}}const u="\\[([^\\]]+)\\]",E=new RegExp(u,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function d(s){const a=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let n=E.exec(s);for(;n?.length;){const o=n[1].trim();o&&a.push(o),n=E.exec(s)}}return(0,T.distinct)(a)}i.overrideIdentifiersFromKey=d;function g(s){return s.reduce((a,n)=>`${a}[${n}]`,"")}i.keyFromOverrideIdentifiers=g;function h(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=h;const p=new D;S.Registry.add(i.Extensions.Configuration,p);function b(s){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?I.localize(7,null,s):p.getConfigurationProperties()[s]!==void 0?I.localize(8,null,s):null:I.localize(6,null)}i.validateProperty=b;function f(){const s=[],a=p.getConfigurationProperties();for(const n of Object.keys(a))s.push([n,a[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=f}),define(ee[106],te([0,1,19,10,57,2,39,21,8,9,26,34,30]),function(B,i,T,R,w,I,C,S,l,m,y,D,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class E{constructor(e={},t=[],r=[]){this._contents=e,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,y.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,t){const r=this.getContentsForOverrideIdentifer(t);return r?e?(0,y.getConfigurationValue)(r,e):r:void 0}getKeysForOverrideIdentifier(e){const t=[];for(const r of this.overrides)r.identifiers.includes(e)&&t.push(...r.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const e=[];for(const t of this.overrides)e.push(...t.identifiers);return T.distinct(e)}override(e){let t=this.overrideConfigurations.get(e);return t||(t=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,t)),t}merge(...e){const t=S.deepClone(this.contents),r=S.deepClone(this.overrides),c=[...this.keys];for(const v of e){this.mergeContents(t,v.contents);for(const L of v.overrides){const[P]=r.filter(k=>T.equals(k.identifiers,L.identifiers));P?(this.mergeContents(P.contents,L.contents),P.keys.push(...L.keys),P.keys=T.distinct(P.keys)):r.push(S.deepClone(L))}for(const L of v.keys)c.indexOf(L)===-1&&c.push(L)}return new E(t,c,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const c of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let v=this.contents[c],L=t[c];L&&(typeof v=="object"&&typeof L=="object"?(v=S.deepClone(v),this.mergeContents(v,L)):v=L),r[c]=v}return new E(r,this.keys,this.overrides)}mergeContents(e,t){for(const r of Object.keys(t)){if(r in e&&l.isObject(e[r])&&l.isObject(t[r])){this.mergeContents(e[r],t[r]);continue}e[r]=S.deepClone(t[r])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?S.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let t=null,r=null;const c=v=>{v&&(r?this.mergeContents(r,v):r=S.deepClone(v))};for(const v of this.overrides)T.equals(v.identifiers,[e])?t=v.contents:v.identifiers.includes(e)&&c(v.contents);return c(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),(0,y.addToValueTree)(this.contents,e,t,r=>{throw new Error(r)})}removeValue(e){this.removeKey(e)&&(0,y.removeFromValueTree)(this.contents,e)}addKey(e){let t=this.keys.length;for(let r=0;r<t;r++)e.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return t!==-1?(this.keys.splice(t,1),!0):!1}}i.ConfigurationModel=E;class d extends E{constructor(e={}){const t=u.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),c=Object.create(null),v=[];for(const L in t){const P=e[L],k=P!==void 0?P:t[L].default;(0,y.addToValueTree)(c,L,k,U=>console.error(`Conflict in default settings: ${U}`))}for(const L of Object.keys(c))D.OVERRIDE_PROPERTY_REGEX.test(L)&&v.push({identifiers:(0,D.overrideIdentifiersFromKey)(L),keys:Object.keys(c[L]),contents:(0,y.toValuesTree)(c[L],P=>console.error(`Conflict in default settings file: ${P}`))});super(c,r,v)}}i.DefaultConfigurationModel=d;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,t){if(!l.isUndefinedOrNull(e)){const r=this.doParseContent(e);this.parseRaw(r,t)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,t){this._raw=e;const{contents:r,keys:c,overrides:v,restricted:L}=this.doParseRaw(e,t);this._configurationModel=new E(r,c,v),this._restrictedConfigurations=L||[]}doParseContent(e){let t={},r=null,c=[],v=[],L=[];function P(U){Array.isArray(c)?c.push(U):r!==null&&(c[r]=U)}let k={onObjectBegin:()=>{let U={};P(U),v.push(c),c=U,r=null},onObjectProperty:U=>{r=U},onObjectEnd:()=>{c=v.pop()},onArrayBegin:()=>{let U=[];P(U),v.push(c),c=U,r=null},onArrayEnd:()=>{c=v.pop()},onLiteralValue:P,onError:(U,J,ne)=>{L.push({error:U,offset:J,length:ne})}};if(e)try{w.visit(e,k),t=c[0]||{}}catch(U){console.error(`Error while parsing settings file ${this._name}: ${U}`),this._parseErrors=[U]}return t}doParseRaw(e,t){const r=u.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),c=this.filter(e,r,!0,t);e=c.raw;const v=(0,y.toValuesTree)(e,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),L=Object.keys(e),P=this.toOverrides(e,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:v,keys:L,overrides:P,restricted:c.restricted}}filter(e,t,r,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:e,restricted:[]};const v={},L=[];for(let P in e)if(D.OVERRIDE_PROPERTY_REGEX.test(P)&&r){const k=this.filter(e[P],t,!1,c);v[P]=k.raw,L.push(...k.restricted)}else{const k=t[P],U=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&L.push(P),(U===void 0||c.scopes===void 0||c.scopes.includes(U))&&(c.skipRestricted&&k?.restricted||(v[P]=e[P]))}return{raw:v,restricted:L}}toOverrides(e,t){const r=[];for(const c of Object.keys(e))if(D.OVERRIDE_PROPERTY_REGEX.test(c)){const v={};for(const L in e[c])v[L]=e[c][L];r.push({identifiers:(0,D.overrideIdentifiersFromKey)(c),keys:Object.keys(v),contents:(0,y.toValuesTree)(v,t)})}return r}}i.ConfigurationModelParser=g;class h extends I.Disposable{constructor(e,t,r,c){super();this.userSettingsResource=e,this.scopes=t,this.fileService=c,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=h;class p{constructor(e,t,r=new E,c=new E,v=new C.ResourceMap,L=new E,P=new C.ResourceMap,k=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=v,this._memoryConfiguration=L,this._memoryConfigurationByResource=P,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(e)}updateValue(e,t,r={}){let c;r.resource?(c=this._memoryConfigurationByResource.get(r.resource),c||(c=new E,this._memoryConfigurationByResource.set(r.resource,c))):c=this._memoryConfiguration,t===void 0?c.removeValue(e):c.setValue(e,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,r){const c=this.getConsolidateConfigurationModel(t,r),v=this.getFolderConfigurationModelForResource(t.resource,r),L=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,P=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),k=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),U=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),J=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),ne=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ge=v?t.overrideIdentifier?v.freeze().override(t.overrideIdentifier).getValue(e):v.freeze().getValue(e):void 0,oe=t.overrideIdentifier?L.override(t.overrideIdentifier).getValue(e):L.getValue(e),ie=c.getValue(e),he=T.distinct(T.flatten(c.overrides.map(_=>_.identifiers))).filter(_=>c.getOverrideValue(e,_)!==void 0);return{defaultValue:P,userValue:k,userLocalValue:U,userRemoteValue:J,workspaceValue:ne,workspaceFolderValue:ge,memoryValue:oe,value:ie,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:J!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:ne!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:ge!==void 0?{value:v?.freeze().getValue(e),override:t.overrideIdentifier?v?.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:oe!==void 0?{value:L.getValue(e),override:t.overrideIdentifier?L.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const r=[];if(!t){const{added:c,updated:v,removed:L}=a(this._defaultConfiguration,e);t=[...c,...v,...L]}for(const c of t)for(const v of(0,D.overrideIdentifiersFromKey)(c)){const L=this._defaultConfiguration.getKeysForOverrideIdentifier(v),P=e.getKeysForOverrideIdentifier(v),k=[...P.filter(U=>L.indexOf(U)===-1),...L.filter(U=>P.indexOf(U)===-1),...L.filter(U=>!S.equals(this._defaultConfiguration.override(v).getValue(U),e.override(v).getValue(U)))];r.push([v,k])}return this.updateDefaultConfiguration(e),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:r,removed:c,overrides:v}=a(this.localUserConfiguration,e),L=[...t,...r,...c];return L.length&&this.updateLocalUserConfiguration(e),{keys:L,overrides:v}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:r,removed:c,overrides:v}=a(this.remoteUserConfiguration,e);let L=[...t,...r,...c];return L.length&&this.updateRemoteUserConfiguration(e),{keys:L,overrides:v}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:r,removed:c,overrides:v}=a(this.workspaceConfiguration,e);let L=[...t,...r,...c];return L.length&&this.updateWorkspaceConfiguration(e),{keys:L,overrides:v}}compareAndUpdateFolderConfiguration(e,t){const r=this.folderConfigurations.get(e),{added:c,updated:v,removed:L,overrides:P}=a(r,t);let k=[...c,...v,...L];return(k.length||!r)&&this.updateFolderConfiguration(e,t),{keys:k,overrides:P}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:c,removed:v,overrides:L}=a(t,void 0);return{keys:[...r,...c,...v],overrides:L}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let r=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?r.override(e.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:e},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const c=t.getFolder(e);c&&(r=this.getFolderConsolidatedConfiguration(c.uri)||r);const v=this._memoryConfigurationByResource.get(e);v&&(r=r.merge(v))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(e);c?(t=r.merge(c),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=r}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const r=t.getFolder(e);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:r,overrides:c,keys:v}=this._folderConfigurations.get(t);return e.push([t,{contents:r,overrides:c,keys:v}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>e.add(r))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(c=>t.add(c))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),r=this.parseConfigurationModel(e.user),c=this.parseConfigurationModel(e.workspace),v=e.folders.reduce((L,P)=>(L.set(m.URI.revive(P[0]),this.parseConfigurationModel(P[1])),L),new C.ResourceMap);return new p(t,r,new E,c,v,new E,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new E(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=p;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,t=new Map;for(const c of o)c.keys.forEach(v=>e.add(v)),c.overrides.forEach(([v,L])=>{const P=(0,C.getOrSet)(t,v,new Set);L.forEach(k=>P.add(k))});const r=[];return t.forEach((c,v)=>r.push([v,[...c.values()]])),{keys:[...e.values()],overrides:r}}i.mergeChanges=b;class f{constructor(e,t,r,c){this.change=e,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=c,this._previousConfiguration=void 0;const v=new Set;e.keys.forEach(P=>v.add(P)),e.overrides.forEach(([,P])=>P.forEach(k=>v.add(k))),this.affectedKeys=[...v.values()];const L=new E;this.affectedKeys.forEach(P=>L.setValue(P,{})),this.affectedKeysTree=L.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,t,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!S.equals(r,c)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let r=(0,y.toValuesTree)({[t]:!0},()=>{}),c;for(;typeof r=="object"&&(c=Object.keys(r)[0]);){if(e=e[c],!e)return!1;r=r[c]}return!0}}i.ConfigurationChangeEvent=f;class s extends f{constructor(e,t,r,c){super({keys:e.allKeys(),overrides:[]},void 0,e,t);this.source=r,this.sourceConfig=c}}i.AllKeysConfigurationChangeEvent=s;function a(o,e){const{added:t,removed:r,updated:c}=n(e,o),v=[],L=o?.getAllOverrideIdentifiers()||[],P=e?.getAllOverrideIdentifiers()||[];if(e){const k=P.filter(U=>!L.includes(U));for(const U of k)v.push([U,e.getKeysForOverrideIdentifier(U)])}if(o){const k=L.filter(U=>!P.includes(U));for(const U of k)v.push([U,o.getKeysForOverrideIdentifier(U)])}if(e&&o){for(const k of L)if(P.includes(k)){const U=n({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:e.getOverrideValue(void 0,k)||{},keys:e.getKeysForOverrideIdentifier(k)});v.push([k,[...U.added,...U.removed,...U.updated]])}}return{added:t,removed:r,updated:c,overrides:v}}function n(o,e){const t=o?e?o.keys.filter(v=>e.keys.indexOf(v)===-1):[...o.keys]:[],r=e?o?e.keys.filter(v=>o.keys.indexOf(v)===-1):[...e.keys]:[],c=[];if(o&&e){for(const v of e.keys)if(o.keys.indexOf(v)!==-1){const L=(0,y.getConfigurationValue)(e.contents,v),P=(0,y.getConfigurationValue)(o.contents,v);S.equals(L,P)||c.push(v)}}return{added:t,removed:r,updated:c}}}),define(ee[107],te([0,1,3,10,2,18,26,106,34,30]),function(B,i,T,R,w,I,C,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class y extends w.Disposable{constructor(u,E){super();this.settingsResource=u,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,E)),this.configuration=new S.Configuration(new S.DefaultConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:d})=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const u=await this.userConfiguration.loadConfiguration();this.configuration=new S.Configuration(new S.DefaultConfigurationModel,u)}getConfigurationData(){return this.configuration.toData()}getValue(u,E){const d=typeof u=="string"?u:void 0,g=(0,C.isConfigurationOverrides)(u)?u:(0,C.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(d,g,void 0)}updateValue(u,E,d,g){return Promise.reject(new Error("not supported"))}inspect(u){return this.configuration.inspect(u,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const u=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(u)}onDidChangeUserConfiguration(u){const E=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(u);this.trigger(d,E,1)}onDidDefaultConfigurationChange(u){const E=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new S.DefaultConfigurationModel,u);this.trigger(d,E,6)}trigger(u,E,d){const g=new S.ConfigurationChangeEvent(u,{data:E},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(u){switch(u){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=y}),define(ee[108],te([0,1,11]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isVirtualWorkspace=i.getVirtualWorkspaceScheme=i.getVirtualWorkspaceLocation=i.isVirtualResource=i.getRemoteName=i.getRemoteAuthority=void 0;function R(m){return m.scheme===T.Schemas.vscodeRemote?m.authority:void 0}i.getRemoteAuthority=R;function w(m){if(!m)return;const y=m.indexOf("+");return y<0?m:m.substr(0,y)}i.getRemoteName=w;function I(m){return m.scheme!==T.Schemas.file&&m.scheme!==T.Schemas.vscodeRemote}i.isVirtualResource=I;function C(m){if(m.folders.length)return m.folders.every(y=>I(y.uri))?m.folders[0].uri:void 0;if(m.configuration&&I(m.configuration))return m.configuration}i.getVirtualWorkspaceLocation=C;function S(m){return C(m)?.scheme}i.getVirtualWorkspaceScheme=S;function l(m){return C(m)!==void 0}i.isVirtualWorkspace=l}),define(ee[43],te([0,1,24,14,108]),function(B,i,T,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}i.getWorkspaceSupportTypeMessage=I;function C(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}i.isIExtensionIdentifier=C,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(S=i.ExtensionType||(i.ExtensionType={}));class l{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,d){if(typeof E=="undefined"||E===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof E=="string"||typeof d=="string"){let g=typeof E=="string"?E:E.value,h=typeof d=="string"?d:d.value;return T.equalsIgnoreCase(g,h)}return E._lower===d._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}i.ExtensionIdentifier=l;function m(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}i.isLanguagePackExtension=m;function y(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=y;function D(u,E){if(E){const d=`onResolveRemoteAuthority:${(0,w.getRemoteName)(E)}`;return u.activationEvents?.indexOf(d)!==-1}return!1}i.isResolverExtension=D,i.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[23],te([0,1,24,43]),function(B,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function w(d,g){return d.uuid&&g.uuid?d.uuid===g.uuid:d.id===g.id?!0:(0,T.compareIgnoreCase)(d.id,g.id)===0}i.areSameExtensions=w;class I{constructor(g,h){this.version=h,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof I?w(this,g)&&this.version===g.version:!1}}i.ExtensionIdentifierWithVersion=I;function C(d,g){return`${d}.${g}`}i.getExtensionId=C;function S(d){return d.toLocaleLowerCase()}i.adoptToGalleryExtensionId=S;function l(d,g){return S(C(d,g))}i.getGalleryExtensionId=l;function m(d,g){const h=[],p=b=>{for(const f of h)if(f.some(s=>w(g(s),g(b))))return f;return null};for(const b of d){const f=p(b);f?f.push(b):h.push([b])}return h}i.groupByExtension=m;function y(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=y;function D(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}i.getGalleryExtensionTelemetryData=D,i.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function u(d){const g=new Set;if(d.malicious)for(const h of d.malicious)g.add(h.id);return g}i.getMaliciousExtensionsSet=u;function E(d,g){const h=[],p=g.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const b=p.shift();if(b&&h.every(f=>!w(f.identifier,{id:b}))){const f=d.filter(s=>w(s.identifier,{id:b}));f.length===1&&(h.push(f[0]),p.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}i.getExtensionDependencies=E}),define(ee[109],te([0,1,25,7,63,11,44,9,79,22,23,43]),function(B,i,T,R,w,I,C,S,l,m,y,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=i.getIdAndVersion=void 0;const u=b=>(0,l.localize)(0,null,b),E=(0,l.localize)(1,null,"ms-dotnettools.csharp");function d(b,f){return f?`${b.publisher}.${b.name}@${b.version}`:`${b.publisher}.${b.name}`}const g=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function h(b){const f=g.exec(b);return f&&f[1]?[(0,y.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,y.adoptToGalleryExtensionId)(b),void 0]}i.getIdAndVersion=h;let p=class{constructor(f,s){this.extensionManagementService=f,this.extensionGalleryService=s}get location(){}async listExtensions(f,s,a=console){let n=await this.extensionManagementService.getInstalled(1);const o=D.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(s&&s!==""){if(o.indexOf(s.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(t=>t.manifest.categories?t.manifest.categories.map(c=>c.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){a.log("Possible Categories: "),o.forEach(t=>{a.log(t)});return}this.location&&a.log((0,l.localize)(2,null,this.location)),n=n.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let e;for(let t of n)e!==t.identifier.id&&(e=t.identifier.id,a.log(d(t.manifest,f)))}async installExtensions(f,s,a,n,o=console){const e=[],t=[];f.length&&o.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const r=await this.extensionManagementService.getInstalled(1),c=(P,k)=>{const U=r.find(J=>(0,y.areSameExtensions)(J.identifier,{id:P}));if(U){if(!k&&!n)return o.log((0,l.localize)(5,null,P,U.manifest.version,P)),!1;if(k&&U.manifest.version===k)return o.log((0,l.localize)(6,null,`${P}@${k}`)),!1}return!0},v=[],L=[];for(const P of f)if(P instanceof S.URI)v.push(P);else{const[k,U]=h(P);c(k,U)&&L.push({id:k,version:U,installOptions:{...a,isBuiltin:!1}})}for(const P of s){const[k,U]=h(P);c(k,U)&&L.push({id:k,version:U,installOptions:{...a,isBuiltin:!0}})}if(v.length&&await Promise.all(v.map(async P=>{try{const k=await this.installVSIX(P,{...a,isBuiltin:!1},n,o);k&&t.push(k)}catch(k){o.error(k.message||k.stack||k),e.push(P.toString())}})),L.length){const P=await this.getGalleryExtensions(L);await Promise.all(L.map(async k=>{const U=P.get(k.id.toLowerCase());if(U)try{const J=await this.installFromGallery(k,U,r,n,o);J&&t.push(J)}catch(J){o.error(J.message||J.stack||J),e.push(k.id)}else o.error(`${u(k.version?`${k.id}@${k.version}`:k.id)}
${E}`),e.push(k.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(f,s,a,n){const o=await this.extensionManagementService.getManifest(f);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,a,n))try{return await this.extensionManagementService.install(f,s),n.log((0,l.localize)(8,null,(0,w.getBaseLabel)(f))),o}catch(t){if((0,R.isPromiseCanceledError)(t))return n.log((0,l.localize)(9,null,(0,w.getBaseLabel)(f))),null;throw t}return null}async getGalleryExtensions(f){const s=new Map,a=await this.extensionGalleryService.getExtensions(f,f.some(n=>n.installOptions.installPreReleaseVersion),T.CancellationToken.None);for(const n of a)s.set(n.identifier.id.toLowerCase(),n);return s}async installFromGallery({id:f,version:s,installOptions:a},n,o,e,t){const r=await this.extensionGalleryService.getManifest(n,T.CancellationToken.None);if(r&&!this.validateExtensionKind(r,t))return null;const c=o.find(v=>(0,y.areSameExtensions)(v.identifier,n.identifier));if(c){if(n.version===c.manifest.version)return t.log((0,l.localize)(10,null,s?`${f}@${s}`:f)),null;t.log((0,l.localize)(11,null,f,n.version))}try{return a.isBuiltin?t.log(s?(0,l.localize)(12,null,f,s):(0,l.localize)(13,null,f)):t.log(s?(0,l.localize)(14,null,f,s):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(n,{...a,installGivenVersion:!!s}),t.log((0,l.localize)(16,null,f,n.version)),r}catch(v){if((0,R.isPromiseCanceledError)(v))return t.log((0,l.localize)(17,null,f)),null;throw v}}validateExtensionKind(f,s){return!0}async validateVSIX(f,s,a){const n={id:(0,y.getGalleryExtensionId)(f.publisher,f.name)},e=(await this.extensionManagementService.getInstalled(1)).find(t=>(0,y.areSameExtensions)(n,t.identifier)&&(0,C.gt)(t.manifest.version,f.version));return e&&!s?(a.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,f.version)),!1):this.validateExtensionKind(f,a)}async uninstallExtensions(f,s,a=console){const n=async e=>{if(e instanceof S.URI){const t=await this.extensionManagementService.getManifest(e);return d(t)}return e},o=[];for(const e of f){const t=await n(e),c=(await this.extensionManagementService.getInstalled()).filter(v=>(0,y.areSameExtensions)(v.identifier,{id:t}));if(!c.length)throw new Error(`${this.notInstalled(t)}
${E}`);if(c.some(v=>v.type===0)){a.log((0,l.localize)(19,null,t));return}if(!s&&c.some(v=>v.isBuiltin)){a.log((0,l.localize)(20,null,t));return}a.log((0,l.localize)(21,null,t));for(const v of c)await this.extensionManagementService.uninstall(v),o.push(v);this.location?a.log((0,l.localize)(22,null,t,this.location)):a.log((0,l.localize)(23,null,t))}}async locateExtension(f,s=console){const a=await this.extensionManagementService.getInstalled();f.forEach(n=>{a.forEach(o=>{if(o.identifier.id===n&&o.location.scheme===I.Schemas.file){s.log(o.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};p=pe([ce(0,m.IExtensionManagementService),ce(1,m.IExtensionGalleryService)],p),i.ExtensionManagementCLIService=p}),define(ee[110],te([0,1,3,7,2,12,18,44,9,27,13,20,22,23,16,15]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E,d,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends w.Disposable{constructor(f,s,a,n){super();this.fileService=s,this.extensionGalleryService=a,this.logService=n,this.extensionsDownloadDir=l.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const a=this.getName(f),n=(0,C.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(n)){const o=(0,C.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(f,o,s);try{await this.rename(o,n,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(o)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,o.path),e}}return n}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,s,a){try{await y.Promises.rename(f.fsPath,s.fsPath)}catch(n){if(I.isWindows&&n&&n.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,a);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],a=[];for(const e of f.children){const t=this.parse(e.name);t&&a.push([t,e])}const n=(0,E.groupByExtension)(a,([e])=>e),o=[];for(const e of n)e.sort((t,r)=>S.rcompare(t[0].version,r[0].version)),s.push(...e.slice(1).map(t=>t[1].resource)),o.push(e[0][1]);o.sort((e,t)=>e.mtime-t.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(e=>e.resource)),await T.Promises.settled(s.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new E.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,m.generateUuid)()}parse(f){const s=h.exec(f);return s&&s[1]&&s[2]?new E.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};p=pe([ce(0,D.INativeEnvironmentService),ce(1,d.IFileService),ce(2,u.IExtensionGalleryService),ce(3,g.ILogService)],p),i.ExtensionsDownloader=p}),define(ee[111],te([0,1,2,4,13,43]),function(B,i,T,R,w,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class C extends T.Disposable{constructor(l,m){super();this.environmentService=l,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(m.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(m.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(l){l.some(m=>!!m.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=C}),define(ee[112],te([0,1,137,19,3,2,11,4,13,20,22,23,55,15]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let d=class extends I.Disposable{constructor(p,b,f){super();this.extensionManagementService=p,this.logService=f,this.cache=this._register(new g(b,f)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),b=["en",...Object.keys(p)];return(0,R.distinct)(b)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const b=await this.cache.getLanguagePacks();Object.keys(b).some(f=>b[f]&&b[f].extensions.some(s=>(0,D.areSameExtensions)(s.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,b]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(b);return!(0,R.equals)(Object.keys(p),Object.keys(f))}};d=pe([ce(0,y.IExtensionManagementService),ce(1,m.INativeEnvironmentService),ce(2,E.ILogService)],d),i.LocalizationsService=d;let g=class extends I.Disposable{constructor(p,b){super();this.logService=b,this.languagePacks={},this.languagePacksFilePath=(0,S.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(b=>{Object.keys(b).forEach(f=>delete b[f]),this.createLanguagePacksFromExtensions(b,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...b){for(const f of b)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,f);Object.keys(p).forEach(f=>this.updateHash(p[f]))}createLanguagePacksFromExtension(p,b){const f=b.identifier,s=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const a of s)if(b.location.scheme===C.Schemas.file&&(0,u.isValidLocalization)(a)){let n=p[a.languageId];n||(n={hash:"",extensions:[],translations:{}},p[a.languageId]=n);let o=n.extensions.filter(e=>(0,D.areSameExtensions)(e.extensionIdentifier,f))[0];o?o.version=b.manifest.version:n.extensions.push({extensionIdentifier:f,version:b.manifest.version});for(const e of a.translations)n.translations[e.id]=(0,S.join)(b.location.fsPath,e.path)}}updateHash(p){if(p){const b=(0,T.createHash)("md5");for(const f of p.extensions)b.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);p.hash=b.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let b=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(b=p(f),f)).then(f=>{for(const a of Object.keys(f))f[a]||delete f[a];this.languagePacks=f,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),l.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>b,f=>this.logService.error(f))})}};g=pe([ce(0,m.INativeEnvironmentService),ce(1,E.ILogService)],g)}),define(ee[45],te([0,1,17,87,34,14,30]),function(B,i,T,R,w,I,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,I.createDecorator)("requestService");function S(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}i.isSuccess=S;function l(d){return d.res.statusCode===204}async function m(d){if(!S(d))throw new Error("Server returned "+d.res.statusCode);return l(d)?null:(await(0,T.streamToBuffer)(d.stream)).toString()}i.asText=m;async function y(d){if(!S(d))throw new Error("Server returned "+d.res.statusCode);if(l(d))return null;const h=(await(0,T.streamToBuffer)(d.stream)).toString();try{return JSON.parse(h)}catch(p){throw p.message+=`:
`+h,p}}i.asJson=y;function D(d){E(d)}i.updateProxyConfigurationsScope=D;let u;function E(d){const g=C.Registry.as(w.Extensions.Configuration),h=u;u={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[u],remove:h?[h]:[]})}E(2)}),define(ee[113],te([0,1,25,11,16,45]),function(B,i,T,R,w,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let C=class{constructor(l,m){this.requestService=l,this.fileService=m}async download(l,m,y=T.CancellationToken.None){if(l.scheme===R.Schemas.file||l.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(l,m);return}const D={type:"GET",url:l.toString()},u=await this.requestService.request(D,y);if(u.res.statusCode===200)await this.fileService.writeFile(m,u.stream);else{const E=await(0,I.asText)(u);throw new Error(`Expected 200, got back ${u.res.statusCode} instead.

${E}`)}}};C=pe([ce(0,I.IRequestService),ce(1,w.IFileService)],C),i.DownloadService=C}),define(ee[114],te([0,1,115,8]),function(B,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function w(C,S){return C.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:C.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function I(C,S,l={}){const m=(0,T.parse)(C),y=l.proxyUrl||w(m,S);if(!y)return null;const D=(0,T.parse)(y);if(!/^https?:$/.test(D.protocol||""))return null;const u={host:D.hostname||"",port:D.port||(D.protocol==="https"?"443":"80"),auth:D.auth,rejectUnauthorized:(0,R.isBoolean)(l.strictSSL)?l.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((E,d)=>{B(["http-proxy-agent"],E,d)}))(u):new(await new Promise((E,d)=>{B(["https-proxy-agent"],E,d)}))(u)}i.getProxyAgent=I}),define(ee[116],te([0,1,17,27]),function(B,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function w(I,C,S){let l=S&&S.get("storage.serviceMachineId",0)||null;if(l)return l;try{const y=(await C.readFile(I.serviceMachineIdResource)).value.toString();l=(0,R.isUUID)(y)?y:null}catch{l=null}if(!l){l=(0,R.generateUuid)();try{await C.writeFile(I.serviceMachineIdResource,T.VSBuffer.fromString(l))}catch{}}return S&&S.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=w}),define(ee[117],te([0,1,3,10,2,102,8,67,14]),function(B,i,T,R,w,I,C,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var y;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(y=i.WillSaveStateReason||(i.WillSaveStateReason={}));var D;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(D=i.StorageScope||(i.StorageScope={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u=i.StorageTarget||(i.StorageTarget={}));class E extends w.Disposable{constructor(p={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,I.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,b){b===m?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:b,target:this.getKeyTargets(p)[b]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,b,f){return this.getStorage(b)?.get(p,f)}getBoolean(p,b,f){return this.getStorage(b)?.getBoolean(p,f)}getNumber(p,b,f){return this.getStorage(b)?.getNumber(p,f)}store(p,b,f,s){if((0,C.isUndefinedOrNull)(b)){this.remove(p,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,f,s),this.getStorage(f)?.set(p,b)})}remove(p,b){this.withPausedEmitters(()=>{this.updateKeyTarget(p,b,void 0),this.getStorage(b)?.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,b){const f=[],s=this.getKeyTargets(p);for(const a of Object.keys(s))s[a]===b&&f.push(a);return f}updateKeyTarget(p,b,f){const s=this.getKeyTargets(b);typeof f=="number"?s[p]!==f&&(s[p]=f,this.getStorage(b)?.set(m,JSON.stringify(s))):typeof s[p]=="number"&&(delete s[p],this.getStorage(b)?.set(m,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const b=this.get(m,p);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}isNew(p){return this.getBoolean(i.IS_NEW_KEY,p)===!0}async flush(p=y.NONE){this._onWillSaveState.fire({reason:p});const b=this.getStorage(0),f=this.getStorage(1);switch(p){case y.NONE:await T.Promises.settled([b?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await T.Promises.settled([b?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const p=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return g(p,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends E{constructor(){super();this.globalStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}i.InMemoryStorageService=d;async function g(h,p,b,f){const s=c=>{try{return JSON.parse(c)}catch{return c}},a=new Map,n=new Map;h.forEach((c,v)=>{a.set(v,c),n.set(v,s(c))});const o=new Map,e=new Map;p.forEach((c,v)=>{o.set(v,c),e.set(v,s(c))}),console.group(`Storage: Global (path: ${b})`);let t=[];a.forEach((c,v)=>{t.push({key:v,value:c})}),console.table(t),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${f})`);let r=[];o.forEach((c,v)=>{r.push({key:v,value:c})}),console.table(r),console.groupEnd(),console.log(e)}i.logStorage=g}),define(ee[118],te([0,1,12,29,9,27]),function(B,i,T,R,w,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function C(m){if(T.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function S(m,y,D,u,E,d,g,h,p,b){const f=Object.create(null);f["common.machineId"]=g,f.sessionID=(0,I.generateUuid)()+Date.now(),f.commitHash=E,f.version=d,f["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,T.PlatformToString)(T.platform),f["common.nodePlatform"]=R.platform,f["common.nodeArch"]=u,f["common.product"]=b||"desktop";const s=l(h||[]);s&&(f["common.msftInternal"]=s);let a=0;const n=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),T.isLinuxSnap&&(f["common.snap"]="true");const o=C(D);o&&(f["common.platformDetail"]=o);try{const e=await m.readFile(w.URI.file(p));f["common.source"]=e.value.toString().slice(0,30)}catch{}return f}i.resolveCommonProperties=S;function l(m){const y=R.env.USERDNSDOMAIN;if(!y)return!1;const D=y.toLowerCase();return m.some(u=>D===u)}i.verifyMicrosoftInternalDomain=l}),define(ee[31],te([0,1,14]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,T.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(R=i.TelemetryLevel||(i.TelemetryLevel={}));var w;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(w=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(ee[119],te([0,1,19,3,25,7,10,2,12,8,9,77,22,23,15,32,31]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E,d,g,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let p=class extends S.Disposable{constructor(o,e,t,r){super();this.galleryService=o,this.telemetryService=e,this.logService=t,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new C.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new C.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new C.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new C.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,S.toDisposable)(()=>{this.installingExtensions.forEach(c=>c.cancel()),this.uninstallingExtensions.forEach(c=>c.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const e=await this.getTargetPlatform();return o.allTargetPlatforms.some(t=>(0,u.isTargetPlatformCompatible)(t,o.allTargetPlatforms,e))}async installFromGallery(o,e={}){try{if(!this.galleryService.isEnabled())throw new u.ExtensionManagementError(D.localize(0,null),u.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(o,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,e)}catch(t){throw s(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(o),void 0,t),this.logService.error("Failed to install extension.",o.identifier.id),this.logService.error(t),f(t)}}async migrateUnsupportedExtensions(){try{const o=await this.getExtensionsControlManifest();if(!o.unsupportedPreReleaseExtensions)return;const e=await this.getInstalled(1);for(const[t,r]of Object.entries(o.unsupportedPreReleaseExtensions)){const c=e.find(P=>(0,E.areSameExtensions)(P.identifier,{id:t}));if(!c)continue;const v=await this.galleryService.getCompatibleExtension({id:r.id},!0,await this.getTargetPlatform());if(!v){this.logService.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${r.id}' extension is not found`);continue}const L=await this.galleryService.getManifest(v,w.CancellationToken.None);if(!L){this.logService.info(`Skipping migrating '${c.identifier.id}' extension because, the manifest for '${r.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${c.identifier.id}' extension to '${r.id}' extension...`),await Promise.allSettled([this.uninstall(c),this.installExtension(L,v,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${c.identifier.id}' extension to '${r.id}' extension.`)}catch(P){this.logService.error(P)}}}catch(o){this.logService.error(o)}}async uninstall(o,e={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,e)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(1,null));const e=await this.findGalleryExtension(o);if(!e)throw new Error(D.localize(2,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.extensionsControlManifest||o-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=o),this.extensionsControlManifest}registerParticipant(o){this.participants.push(o)}async installExtension(o,e,t){if(!y.URI.isUri(e)){let P=this.installingExtensions.get(new E.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(P)return this.logService.info("Extensions is already requested to install",e.identifier.id),P.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],c=[],v=this.createInstallExtensionTask(o,e,t);y.URI.isUri(e)||this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(v.identifier,o.version).key(),v),this._onInstallExtension.fire({identifier:v.identifier,source:e}),this.logService.info("Installing extension:",v.identifier.id),r.push({task:v,manifest:o});let L=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const k=await this.getAllDepsAndPackExtensionsToInstall(v.identifier,o,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:U,manifest:J}of k)if(L=L||!!J.extensionDependencies?.some(ne=>(0,E.areSameExtensions)({id:ne},v.identifier)),this.installingExtensions.has(new E.ExtensionIdentifierWithVersion(U.identifier,U.version).key()))this.logService.info("Extension is already requested to install",U.identifier.id);else{const ne=this.createInstallExtensionTask(J,U,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(ne.identifier,J.version).key(),ne),this._onInstallExtension.fire({identifier:ne.identifier,source:U}),this.logService.info("Installing extension:",ne.identifier.id),r.push({task:ne,manifest:J})}}catch(k){if(y.URI.isUri(v.source))(0,T.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",v.identifier.id,k.message),(0,T.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",v.identifier.id,k.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),k}const P=r.reduce((k,{task:U,manifest:J})=>(k.set(U.identifier.id.toLowerCase(),{task:U,manifest:J}),k),new Map);for(;P.size;){let k;const U=[...P.values()].filter(({manifest:J})=>!J.extensionDependencies?.some(ne=>P.has(ne.toLowerCase())));U.length?k=P.size===1?U:U.filter(({task:J})=>!(J===v&&!L)):(this.logService.info("Found extensions with circular dependencies",U.map(({task:J})=>J.identifier.id)),k=[...P.values()]),await this.joinAllSettled(k.map(async({task:J})=>{const ne=new Date().getTime(),ge=(0,m.isUndefined)(t.operation)?J.operation:t.operation;try{const oe=await J.run();if(await this.joinAllSettled(this.participants.map(ie=>ie.postInstall(oe,J.source,t,w.CancellationToken.None))),!y.URI.isUri(J.source)&&(s(this.telemetryService,ge===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(J.source),new Date().getTime()-ne,void 0),l.isWeb&&ge!==3))try{await this.galleryService.reportStatistic(oe.manifest.publisher,oe.manifest.name,oe.manifest.version,"install")}catch{}c.push({local:oe,identifier:J.identifier,operation:ge,source:J.source})}catch(oe){throw y.URI.isUri(J.source)||s(this.telemetryService,ge===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(J.source),new Date().getTime()-ne,oe),this.logService.error("Error while installing the extension:",J.identifier.id),oe}finally{P.delete(J.identifier.id.toLowerCase())}}))}return c.forEach(({identifier:k})=>this.logService.info("Extension installed successfully:",k.id)),this._onDidInstallExtensions.fire(c),c.filter(({identifier:k})=>(0,E.areSameExtensions)(k,v.identifier))[0].local}catch(P){if(r.forEach(({task:k})=>k.cancel()),c.length)try{const k=await Promise.allSettled(c.map(({local:U})=>this.createUninstallExtensionTask(U,{versionOnly:!0}).run()));for(let U=0;U<k.length;U++){const J=k[U],{identifier:ne}=c[U];J.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ne.id):this.logService.warn("Rollback: Error while uninstalling extension",ne.id,(0,I.getErrorMessage)(J.reason))}}catch(k){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(k),c.map(({identifier:U})=>U.id))}throw this._onDidInstallExtensions.fire(r.map(({task:k})=>({identifier:k.identifier,operation:2,source:k.source}))),P}finally{for(const{task:P,manifest:k}of r)if(!y.URI.isUri(P.source)){const U=new E.ExtensionIdentifierWithVersion(P.identifier,k.version).key();this.installingExtensions.delete(U)||this.logService.warn("Installation task is not found in the cache",U)}}}async joinAllSettled(o){const e=[],t=[],r=await Promise.allSettled(o);for(const c of r)c.status==="fulfilled"?e.push(c.value):t.push(c.reason);if(t.length)throw b(t);return e}async getAllDepsAndPackExtensionsToInstall(o,e,t,r){if(!this.galleryService.isEnabled())return[];let c=await this.getInstalled();const v=[o,...c.map(k=>k.identifier)],L=[],P=async(k,U)=>{const J=U.extensionDependencies||[],ne=[...J];if(U.extensionPack){const ge=t?c.find(oe=>(0,E.areSameExtensions)(oe.identifier,k)):void 0;for(const oe of U.extensionPack)ge&&ge.manifest.extensionPack&&ge.manifest.extensionPack.some(ie=>(0,E.areSameExtensions)({id:ie},{id:oe}))||ne.every(ie=>!(0,E.areSameExtensions)({id:ie},{id:oe}))&&ne.push(oe)}if(ne.length){const ge=[...v,...L.map(ie=>ie.gallery.identifier)],oe=ne.filter(ie=>ge.every(he=>!(0,E.areSameExtensions)(he,{id:ie})));if(oe.length){const ie=await this.galleryService.query({names:oe,pageSize:ne.length},w.CancellationToken.None);for(const he of ie.firstPage){if(ge.find(re=>(0,E.areSameExtensions)(re,he.identifier)))continue;const _=J.some(re=>(0,E.areSameExtensions)({id:re},he.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(he,!0,r)}catch(re){if(re instanceof u.ExtensionManagementError&&re.code===u.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!_){this.logService.info("Skipping the packed extension as it cannot be installed",he.identifier.id);continue}else throw re}L.push({gallery:G.extension,manifest:G.manifest}),await P(G.extension.identifier,U)}}}};return await P(o,e),c=await this.getInstalled(),L.filter(k=>!c.some(U=>(0,E.areSameExtensions)(U.identifier,k.gallery.identifier)))}async checkAndGetCompatibleVersion(o,e,t){const r=await this.getExtensionsControlManifest();if((0,E.getMaliciousExtensionsSet)(r).has(o.identifier.id))throw new u.ExtensionManagementError(D.localize(3,null,o.identifier.id),u.ExtensionManagementErrorCode.Malicious);if(!!r.unsupportedPreReleaseExtensions&&!!r.unsupportedPreReleaseExtensions[o.identifier.id])throw new u.ExtensionManagementError(D.localize(4,null,o.identifier.id,r.unsupportedPreReleaseExtensions[o.identifier.id].displayName),u.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(o)){const L=await this.getTargetPlatform();throw new u.ExtensionManagementError(D.localize(5,null,o.identifier.id,this.productService.nameLong,(0,u.TargetPlatformToString)(L)),u.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.getCompatibleVersion(o,e,t);if(c){if(t&&o.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new u.ExtensionManagementError(D.localize(6,null,o.identifier.id,this.productService.nameLong,this.productService.version),u.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new u.ExtensionManagementError(D.localize(7,null,o.identifier.id,this.productService.nameLong,this.productService.version),u.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",c.identifier.id);const v=await this.galleryService.getManifest(c,w.CancellationToken.None);if(v===null)throw new u.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,u.ExtensionManagementErrorCode.Invalid);if(v.version!==c.version)throw new u.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,u.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:v}}async getCompatibleVersion(o,e,t){const r=await this.getTargetPlatform();let c=null;return e&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==t&&(c=await this.galleryService.getCompatibleExtension(o.identifier,t,r)),!c&&await this.galleryService.isExtensionCompatible(o,t,r)&&(c=o),!c&&e&&(c=await this.galleryService.getCompatibleExtension(o,t,r)),c}async unininstallExtension(o,e){const t=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),t.waitUntilTaskIsFinished();const r=(P,k)=>{const U=this.createUninstallExtensionTask(P,k);return this.uninstallingExtensions.set(U.extension.identifier.id.toLowerCase(),U),this.logService.info("Uninstalling extension:",P.identifier.id),this._onUninstallExtension.fire(P.identifier),U},c=(P,k)=>{k?this.logService.error("Failed to uninstall extension:",P.identifier.id,k.message):this.logService.info("Successfully uninstalled extension:",P.identifier.id),s(this.telemetryService,"extensionGallery:uninstall",(0,E.getLocalExtensionTelemetryData)(P),void 0,k),this._onDidUninstallExtension.fire({identifier:P.identifier,error:k?.code})},v=[],L=[];try{v.push(r(o,{}));const P=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const k=this.getAllPackExtensionsToUninstall(o,P);for(const U of k)this.uninstallingExtensions.has(U.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",U.identifier.id):v.push(r(U,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(v.map(k=>k.extension),P,o),await this.joinAllSettled(v.map(async k=>{try{if(await k.run(),await this.joinAllSettled(this.participants.map(U=>U.postUninstall(k.extension,e,w.CancellationToken.None))),k.extension.identifier.uuid)try{await this.galleryService.reportStatistic(k.extension.manifest.publisher,k.extension.manifest.name,k.extension.manifest.version,"uninstall")}catch{}c(k.extension)}catch(U){const J=U instanceof u.ExtensionManagementError?U:new u.ExtensionManagementError((0,I.getErrorMessage)(U),u.ExtensionManagementErrorCode.Internal);throw c(k.extension,J),J}finally{L.push(k)}}))}catch(P){const k=P instanceof u.ExtensionManagementError?P:new u.ExtensionManagementError((0,I.getErrorMessage)(P),u.ExtensionManagementErrorCode.Internal);for(const U of v){try{U.cancel()}catch{}L.includes(U)||c(U.extension,k)}throw k}finally{for(const P of v)this.uninstallingExtensions.delete(P.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",P.extension.identifier.id)}}checkForDependents(o,e,t){for(const r of o){const c=this.getDependents(r,e);if(c.length){const v=c.filter(L=>!o.some(P=>(0,E.areSameExtensions)(P.identifier,L.identifier)));if(v.length)throw new Error(this.getDependentsErrorMessage(r,v,t))}}}getDependentsErrorMessage(o,e,t){return t===o?e.length===1?D.localize(8,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?D.localize(9,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):D.localize(10,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?D.localize(11,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?D.localize(12,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):D.localize(13,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(o,e,t=[]){if(t.indexOf(o)!==-1)return[];t.push(o);const r=o.manifest.extensionPack?o.manifest.extensionPack:[];if(r.length){const c=e.filter(L=>!L.isBuiltin&&r.some(P=>(0,E.areSameExtensions)({id:P},L.identifier))),v=[];for(const L of c)v.push(...this.getAllPackExtensionsToUninstall(L,e,t));return[...c,...v]}return[]}getDependents(o,e){return e.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,E.areSameExtensions)({id:r},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const e=await this.findGalleryExtensionById(o.identifier.uuid);return e||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},w.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},w.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",o),o}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};p=pe([ce(0,u.IExtensionGalleryService),ce(1,h.ITelemetryService),ce(2,d.ILogService),ce(3,g.IProductService)],p),i.AbstractExtensionManagementService=p;function b(n){const o=Array.isArray(n)?n:[n];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}i.joinErrors=b;function f(n){if(n instanceof u.ExtensionManagementError)return n;const o=new u.ExtensionManagementError(n.message,u.ExtensionManagementErrorCode.Internal);return o.stack=n.stack,o}function s(n,o,e,t,r){const c=r?r instanceof u.ExtensionManagementError?r.code:u.ExtensionManagementErrorCode.Internal:void 0;n.publicLogError(o,{...e,success:!r,duration:t,errorcode:c})}i.reportTelemetry=s;class a{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(o=>new Promise((e,t)=>{const r=o.onCancellationRequested(()=>{r.dispose(),t((0,I.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=a}),define(ee[35],te([0,1,21,8,26,31]),function(B,i,T,R,w,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,b){return Promise.resolve(void 0)}publicLog2(p,b){return this.publicLog(p,b)}publicLogError(p,b){return Promise.resolve(void 0)}publicLogError2(p,b){return this.publicLogError(p,b)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=C,i.NullTelemetryService=new C;class S{async publicLog(p,b,f){}async publicLogError(p,b,f){}}i.NullEndpointTelemetryService=S,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(h,p){return p.onDidChangeConfiguration(b=>{b.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(b.source),configurationKeys:d(b.sourceConfig)})})}i.configurationTelemetry=l;function m(h,p){return!(p.disableTelemetry||!h.enableTelemetry)}i.supportsTelemetry=m;function y(h){const p=h.getValue(I.TELEMETRY_SETTING_ID),b=h.getValue("telemetry.enableCrashReporter");if(h.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||b===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=y;function D(h){const p=Object.create(null),b=Object.create(null),f=Object.create(null);E(h,f);for(let s in f){s=s.length>150?s.substr(s.length-149):s;const a=f[s];typeof a=="number"?b[s]=a:typeof a=="boolean"?b[s]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${a.length}`),p[s]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(p[s]=a)}return{properties:p,measurements:b}}i.validateTelemetryData=D;function u(h){if(!h)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{h.indexOf(`${f}+`)===0&&(p=f)}),p}i.cleanRemoteAuthority=u;function E(h,p,b=0,f){if(!!h)for(let s of Object.getOwnPropertyNames(h)){const a=h[s],n=f?f+s:s;Array.isArray(a)?p[n]=(0,T.safeStringify)(a):a instanceof Date?p[n]=a.toISOString():(0,R.isObject)(a)?b<2?E(a,p,b+1,n+"."):p[n]=(0,T.safeStringify)(a):p[n]=a}}function d(h){if(!h)return[];const p=[];return g(p,"",h),p}function g(h,p,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(f=>g(h,p?`${p}.${f}`:f,b[f])):h.push(p)}}),define(ee[120],te([0,1,19,25,7,21,12,29,8,9,26,20,22,23,51,16,15,32,45,116,117,31,35]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E,d,g,h,p,b,f,s,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const o=C.isWeb?"web":(0,u.getTargetPlatform)(C.platform,S.arch);var e;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(e||(e={}));function t(...N){return String(N.reduce((F,V)=>F|V,0))}var r;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},v={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class k{constructor(F=P){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,V=this.state.pageSize){return new k({...this.state,pageNumber:F,pageSize:V})}withFilter(F,...V){const j=[...this.state.criteria,...V.length?V.map(Q=>({filterType:F,value:Q})):[{filterType:F}]];return new k({...this.state,criteria:j})}withSortBy(F){return new k({...this.state,sortBy:F})}withSortOrder(F){return new k({...this.state,sortOrder:F})}withFlags(...F){return new k({...this.state,flags:F.reduce((V,j)=>V|j,0)})}withAssetTypes(...F){return new k({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:V,pageSize:j,sortBy:Q,sortOrder:Z,flags:fe,assetTypes:ae}=this.state;return{filters:[{criteria:F,pageNumber:V,pageSize:j,sortBy:Q,sortOrder:Z}],assetTypes:ae,flags:fe}}get searchText(){const F=this.state.criteria.filter(V=>V.filterType===r.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function U(N,F){const V=(N||[]).filter(j=>j.statisticName===F)[0];return V?V.value:0}function J(N){const F="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(j=>j.assetType.indexOf(F)===0).reduce((j,Q)=>{const Z=ie(N,Q.assetType);return Z&&j.push([Q.assetType.substring(F.length),Z]),j},[])}function ne(N){if(N.properties){const F=N.properties.filter(Q=>Q.key===c.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=F.filter(Q=>V.test(Q.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return ie(N,c.Repository)}function ge(N){return{uri:`${N.fallbackAssetUri}/${c.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${c.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function oe(N){const F=ie(N,c.Icon);if(F)return F;const V=u.DefaultIconPath;return{uri:V,fallbackUri:V}}function ie(N,F){return N.files.filter(j=>j.assetType===F)[0]?{uri:`${N.assetUri}/${F}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${F}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function he(N,F){const V=N.properties?N.properties.filter(Q=>Q.key===F):[],j=V.length>0&&V[0].value;return j?j.split(",").map(Q=>(0,E.adoptToGalleryExtensionId)(Q)):[]}function _(N){const F=N.properties?N.properties.filter(V=>V.key===v.Engine):[];return F.length>0&&F[0].value||""}function G(N){const F=N.properties?N.properties.filter(V=>V.key===v.PreRelease):[];return F.length>0&&F[0].value==="true"}function re(N){const F=N.properties?N.properties.filter(j=>j.key===v.LocalizedLanguages):[],V=F.length>0&&F[0].value||"";return V?V.split(","):[]}function z(N){return N.indexOf("preview")!==-1}function O(N){return N.targetPlatform?(0,u.toTargetPlatform)(N.targetPlatform):"undefined"}function M(N){const F=(0,T.distinct)(N.versions.map(O)),V=!!N.tags?.includes(u.WEB_EXTENSION_TAG),j=F.indexOf("web");return V?j===-1&&F.push("web"):j!==-1&&F.splice(j,1),F}function x(N,F){const V=(0,u.getFallbackTargetPlarforms)(F);for(let j=0;j<N.length;j++){const Q=N[j];if(Q.version===N[j-1]?.version){let Z=j;const fe=O(Q);if(fe===F)for(;Z>0&&N[Z-1].version===Q.version;)Z--;else if(V.includes(fe))for(;Z>0&&N[Z-1].version===Q.version&&O(N[Z-1])!==F;)Z--;Z!==j&&(N.splice(j,1),N.splice(Z,0,Q))}}return N}i.sortExtensionVersions=x;function K(N,F,V,j,Q){const Z=N.versions[0],fe={manifest:ie(F,c.Manifest),readme:ie(F,c.Details),changelog:ie(F,c.Changelog),license:ie(F,c.License),repository:ne(F),download:ge(F),icon:oe(F),coreTranslations:J(F)};return{identifier:{id:(0,E.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:F.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:U(N.statistics,"install"),rating:U(N.statistics,"averagerating"),ratingCount:U(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:V,assets:fe,properties:{dependencies:he(F,v.Dependency),extensionPack:he(F,v.ExtensionPack),engine:_(F),localizedLanguages:re(F),targetPlatform:O(F),isPreReleaseVersion:G(F)},hasPreReleaseVersion:G(Z),hasReleaseVersion:j,preview:z(N.flags),telemetryData:Q}}let W=class{constructor(F,V,j,Q,Z,fe,ae,se){this.requestService=V,this.logService=j,this.environmentService=Q,this.telemetryService=Z,this.fileService=fe,this.productService=ae,this.configurationService=se;const le=ae.extensionsGallery;this.extensionsGalleryUrl=le&&le.serviceUrl,this.extensionsControlUrl=le&&le.controlUrl,this.commonHeadersPromise=Y(ae.version,ae,this.environmentService,this.configurationService,this.fileService,F)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,V,j){const Q=(0,l.isBoolean)(V)?V:!1,Z=(0,l.isBoolean)(V)?j:V;let fe=new k().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,F.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...F.map(({id:le})=>le.toLowerCase()));F.every(le=>!le.version)&&(fe=fe.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:ae}=await this.queryGallery(fe,o,R.CancellationToken.None),se=ae.map(le=>{const ye=(0,E.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName);return{rawGalleryExtension:le,version:F.find(ue=>(0,E.areSameExtensions)(ue,{id:ye}))?.version,preRelease:Q}});return this.converToGalleryExtensions(se,o,()=>{},Z)}async getExtensions2(F){const V=[],j=[];for(const ae of F)ae.uuid?j.push(ae.uuid):V.push(ae.id.toLowerCase());let Q=new k().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly).withPage(1,F.length).withFilter(r.Target,"Microsoft.VisualStudio.Code");j.length&&(Q=Q.withFilter(r.ExtensionId,...j)),V.length&&(Q=Q.withFilter(r.ExtensionId,...V));const{galleryExtensions:Z}=await this.queryGallery(Q,o,R.CancellationToken.None),fe=Z.map(ae=>{const se=(0,E.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),le=F.find(ye=>(0,E.areSameExtensions)(ye,{id:se,uuid:ae.extensionId}));return{rawGalleryExtension:ae,preRelease:!!le?.preRelease}});return this.converToGalleryExtensions(fe,o,()=>{},R.CancellationToken.None)}async getCompatibleExtension(F,V,j){const Q=(0,u.isIExtensionIdentifier)(F)?null:F;if(Q){if((0,u.isNotWebExtensionInWebTargetPlatform)(Q.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(Q,V,j))return Q}const{id:Z,uuid:fe}=Q?Q.identifier:F;let ae=new k().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");fe?ae=ae.withFilter(r.ExtensionId,fe):ae=ae.withFilter(r.ExtensionName,Z);const{galleryExtensions:se}=await this.queryGallery(ae,j,R.CancellationToken.None),[le]=se;if(!le||!le.versions.length)return null;const ye=M(le);if((0,u.isNotWebExtensionInWebTargetPlatform)(ye,j))return null;for(let ue of le.versions){if(!_(ue)){const Ee=await this.getEngine(ue);ue={...ue,properties:[...ue.properties||[],{key:v.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(ue,V,ye,j)){const Ee=le.versions.some(Se=>!G(Se));return K(le,ue,ye,Ee)}}return null}async isExtensionCompatible(F,V,j){if(!(0,u.isTargetPlatformCompatible)(F.properties.targetPlatform,F.allTargetPlatforms,j)||!V&&F.properties.isPreReleaseVersion)return!1;let Q=F.properties.engine;if(!Q){const Z=await this.getManifest(F,R.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");Q=Z.engines.vscode}return(0,d.isEngineValid)(Q,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(F,V,j,Q){if(!(0,u.isTargetPlatformCompatible)(O(F),j,Q)||!V&&G(F))return!1;const Z=await this.getEngine(F);return(0,d.isEngineValid)(Z,this.productService.version,this.productService.date)}async query(F,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=F.text||"";const Q=(0,I.getOrDefault)(F,ue=>ue.pageSize,50);let Z=new k().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,Q).withFilter(r.Target,"Microsoft.VisualStudio.Code");j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,Ee,Se)=>(Z=Z.withFilter(r.Category,Se||Ee),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,Ee,Se)=>(Z=Z.withFilter(r.Tag,Se||Ee),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(r.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),Z=Z.withFilter(r.SearchText,j)),Z=Z.withSortBy(0)):F.ids?Z=Z.withFilter(r.ExtensionId,...F.ids):F.names?Z=Z.withFilter(r.ExtensionName,...F.names):Z=Z.withSortBy(4),typeof F.sortBy=="number"&&(Z=Z.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(Z=Z.withSortOrder(F.sortOrder));const{galleryExtensions:fe,total:ae}=await this.queryGallery(Z,o,V),se=ue=>({index:(Z.pageNumber-1)*Z.pageSize+ue,querySource:F.source}),le=await this.converToGalleryExtensions(fe.map(ue=>({rawGalleryExtension:ue,preRelease:!!F.includePreRelease})),o,se,V),ye=async(ue,Ee)=>{if(Ee.isCancellationRequested)throw(0,w.canceled)();const Se=Z.withPage(ue+1),{galleryExtensions:Oe}=await this.queryGallery(Se,o,Ee);return await this.converToGalleryExtensions(Oe.map(Fe=>({rawGalleryExtension:Fe,preRelease:!!F.includePreRelease})),o,se,V)};return{firstPage:le,total:ae,pageSize:Z.pageSize,getPage:ye}}async converToGalleryExtensions(F,V,j,Q){const Z=(se,le,ye,ue)=>{const Ee=M(se);let Se=se.versions[0];return Se=se.versions.find(Oe=>Oe.version===Se.version&&(0,u.isTargetPlatformCompatible)(O(Oe),Ee,V))||Se,G(Se)&&!ue&&(Se=se.versions.find(Oe=>Oe.version!==Se.version&&!G(Oe))||Se),K(se,Se,Ee,ye,j(le))},fe=[],ae=new Map;for(let se=0;se<F.length;se++){const{rawGalleryExtension:le,version:ye,preRelease:ue}=F[se],Ee=le.versions.some(Se=>!G(Se));if(ye){const Se=le.versions.find(Oe=>Oe.version===ye);Se&&fe.push([se,K(le,Se,M(le),Ee)])}else{const Se=Z(le,se,Ee,ue);Se.properties.isPreReleaseVersion?ae.set(Se.identifier.uuid,{index:se,preRelease:ue}):fe.push([se,Se])}}if(ae.size){const se=new Date().getTime(),le=new k().withFlags(e.IncludeVersions,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,ae.size).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionId,...ae.keys()),{galleryExtensions:ye}=await this.queryGallery(le,V,Q);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-se,count:ae.size}),ye.length!==ae.size)throw new Error("Not all extensions with latest versions are returned");for(const ue of ye){const Ee=ue.versions.some(ze=>!G(ze)),{index:Se,preRelease:Oe}=ae.get(ue.extensionId),Fe=Z(ue,Se,Ee,Oe);fe.push([Se,Fe])}}return fe.sort((se,le)=>se[0]-le[0]).map(([,se])=>se)}async queryGallery(F,V,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,e.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,t(e.Unpublished));const Q=await this.commonHeadersPromise,Z=JSON.stringify(F.raw),fe={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},ae=new Date().getTime();let se,le,ye=0;try{if(se=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:fe},j),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ye};const ue=await(0,b.asJson)(se);if(ue){const Ee=ue.results[0],Se=Ee.extensions;Se.forEach(Fe=>x(Fe.versions,V));const Oe=Ee.resultMetadata&&Ee.resultMetadata.filter(Fe=>Fe.metadataType==="ResultCount")[0];return ye=Oe&&Oe.metadataItems.filter(Fe=>Fe.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:ye}}return{galleryExtensions:[],total:ye}}catch(ue){throw le=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-ae,success:!!se&&(0,b.isSuccess)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:le?(0,w.isPromiseCanceledError)(le)?"canceled":(0,w.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(F,V,j,Q){if(!this.isEnabled())return;const Z=C.isWeb?this.api(`/itemName/${F}.${V}/version/${j}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${V}/${j}/stats?statType=${Q}`),fe=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:Z,headers:se},R.CancellationToken.None)}catch{}}async download(F,V,j){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const Q=(0,E.getGalleryExtensionTelemetryData)(F),Z=new Date().getTime(),fe=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Q,duration:ye}),ae=j===2?"install":j===3?"update":"",se=ae?{uri:`${F.assets.download.uri}${m.URI.parse(F.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${F.assets.download.fallbackUri}${m.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:F.assets.download,le=await this.getAsset(se);await this.fileService.writeFile(V,le.stream),fe(new Date().getTime()-Z)}async getReadme(F,V){if(F.assets.readme){const j=await this.getAsset(F.assets.readme,{},V);return await(0,b.asText)(j)||""}return""}async getManifest(F,V){if(F.assets.manifest){const j=await this.getAsset(F.assets.manifest,{},V),Q=await(0,b.asText)(j);return Q?JSON.parse(Q):null}return null}async getManifestFromRawExtensionVersion(F,V){const j=ie(F,c.Manifest);if(!j)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},Z=await this.getAsset(j,{headers:Q});return await(0,b.asJson)(Z)}async getCoreTranslation(F,V){const j=F.assets.coreTranslations.filter(Q=>Q[0]===V.toUpperCase())[0];if(j){const Q=await this.getAsset(j[1]),Z=await(0,b.asText)(Q);return Z?JSON.parse(Z):null}return null}async getChangelog(F,V){if(F.assets.changelog){const j=await this.getAsset(F.assets.changelog,{},V);return await(0,b.asText)(j)||""}return""}async getAllCompatibleVersions(F,V,j){let Q=new k().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?Q=Q.withFilter(r.ExtensionId,F.identifier.uuid):Q=Q.withFilter(r.ExtensionName,F.identifier.id);const{galleryExtensions:Z}=await this.queryGallery(Q,j,R.CancellationToken.None);if(!Z.length)return[];const fe=M(Z[0]);if((0,u.isNotWebExtensionInWebTargetPlatform)(fe,j))return[];const ae=[];for(const se of Z[0].versions)try{ae[ae.length-1]?.version!==se.version&&await this.isRawExtensionVersionCompatible(se,V,fe,j)&&ae.push({version:se.version,date:se.lastUpdated,isPreReleaseVersion:G(se)})}catch{}return ae}async getAsset(F,V={},j=R.CancellationToken.None){const Q=await this.commonHeadersPromise,Z={type:"GET"},fe={...Q,...V.headers||{}};V={...V,...Z,headers:fe};const ae=F.uri,se=F.fallbackUri,le={...V,url:ae};try{const ye=await this.requestService.request(le,j);if(ye.res.statusCode===200)return ye;const ue=await(0,b.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${ue}`)}catch(ye){if((0,w.isPromiseCanceledError)(ye))throw ye;const ue=(0,w.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:ue});const Ee={...V,url:se};return this.requestService.request(Ee,j)}}async getEngine(F){let V=_(F);if(!V){const j=await this.getManifestFromRawExtensionVersion(F,R.CancellationToken.None);if(!j)throw new Error("Manifest was not found");V=j.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,b.asJson)(F),j=[],Q={};if(V){for(const Z of V.malicious)j.push({id:Z});if(V.unsupported)for(const Z of Object.keys(V.unsupported)){const fe=V.unsupported[Z];(0,l.isBoolean)(fe)||(Q[Z.toLowerCase()]=fe.preReleaseExtension)}}return{malicious:j,unsupportedPreReleaseExtensions:Q}}};W=pe([ce(1,b.IRequestService),ce(2,h.ILogService),ce(3,D.IEnvironmentService),ce(4,a.ITelemetryService),ce(5,g.IFileService),ce(6,p.IProductService),ce(7,y.IConfigurationService)],W);let X=class extends W{constructor(F,V,j,Q,Z,fe,ae,se){super(F,V,j,Q,Z,fe,ae,se)}};X=pe([ce(0,s.IStorageService),ce(1,b.IRequestService),ce(2,h.ILogService),ce(3,D.IEnvironmentService),ce(4,a.ITelemetryService),ce(5,g.IFileService),ce(6,p.IProductService),ce(7,y.IConfigurationService)],X),i.ExtensionGalleryService=X;let $=class extends W{constructor(F,V,j,Q,Z,fe,ae){super(void 0,F,V,j,Q,Z,fe,ae)}};$=pe([ce(0,b.IRequestService),ce(1,h.ILogService),ce(2,D.IEnvironmentService),ce(3,a.ITelemetryService),ce(4,g.IFileService),ce(5,p.IProductService),ce(6,y.IConfigurationService)],$),i.ExtensionGalleryServiceWithNoStorageService=$;async function Y(N,F,V,j,Q,Z){const fe={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${F.nameShort})`},ae=await(0,f.getServiceMachineId)(V,Q,Z);return(0,n.supportsTelemetry)(F,V)&&(0,n.getTelemetryLevel)(j)===3&&(fe["X-Market-User-Id"]=ae),fe}i.resolveMarketplaceHeaders=Y}),define(ee[121],te([0,1,2,21,12,24,88,26,34,122,30,31,35]),function(B,i,T,R,w,I,C,S,l,m,y,D,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let E=class{constructor(h,p){this._configurationService=p,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(b),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(b=>{const f=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(h,p){this._experimentProperties[h]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,u.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const h=await this._commonProperties;let p=h.sessionID,b=h["common.machineId"],f=h["common.firstSessionDate"],s=h["common.msftInternal"];return{sessionId:p,machineId:b,firstSessionDate:f,msftInternal:s}}dispose(){this._disposables.dispose()}_log(h,p,b,f){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(s=>{b=(0,R.mixin)(b,s),b=(0,R.mixin)(b,this._experimentProperties),b=(0,R.cloneAndChange)(b,a=>{if(typeof a=="string")return this._cleanupInfo(a,f)}),this._appenders.forEach(a=>a.log(h,b))},s=>{console.error(s)})}publicLog(h,p,b){return this._log(h,3,p,b)}publicLog2(h,p,b){return this.publicLog(h,p,b)}publicLogError(h,p){return this.sendErrorTelemetry?this._log(h,2,p,!0):Promise.resolve(void 0)}publicLogError2(h,p){return this.publicLogError(h,p)}_anonymizeFilePaths(h){let p=h;const b=[];for(let n of this._cleanupPatterns)for(;;){const o=n.exec(h);if(!o)break;b.push([o.index,n.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(p="";;){const n=s.exec(h);if(!n)break;!f.test(n[0])&&b.every(([o,e])=>n.index<o||n.index>=e)&&(p+=h.substring(a,n.index)+"<REDACTED: user-file-path>",a=s.lastIndex)}return a<h.length&&(p+=h.substr(a)),p}_removePropertiesWithPossibleUserInfo(h){if(!h)return h;const p=h.toLowerCase(),b=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(p)?"<REDACTED: secret>":b.test(p)?"<REDACTED: email>":h}_cleanupInfo(h,p){let b=h;p&&(b=this._anonymizeFilePaths(b));for(let f of this._cleanupPatterns)b=b.replace(f,"");return b=this._removePropertiesWithPossibleUserInfo(b),b}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=pe([ce(1,S.IConfigurationService)],E),i.TelemetryService=E;function d(){const g=(0,C.localize)(0,null,m.default.nameLong),h=m.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=w.isWeb?"":(0,C.localize)(3,null),b=(0,C.localize)(4,null),f=(0,C.localize)(5,null),s=(0,C.localize)(6,null),a=(0,C.localize)(7,null),n=`
|       | ${b} | ${f} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,C.localize)(8,null);return`
${g} ${h} ${p}

&nbsp;

${a}
${n}

&nbsp;

${o}
`}y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[D.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[D.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,C.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,C.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${D.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[123],te([0,1,7,21,35]),function(B,i,T,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function I(S,l){const m=await new Promise((D,u)=>{B(["applicationinsights"],D,u)});let y;return m.defaultClient?(y=new m.TelemetryClient(S),y.channel.setUseDiskRetryCaching(!0)):(m.setup(S).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=m.defaultClient),S.indexOf("AIF-")===0&&(y.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),y}class C{constructor(l,m,y,D,u){this._eventPrefix=l,this._defaultData=m,this.testCollector=D,this.mirrored=u,this._defaultData||(this._defaultData=Object.create(null)),typeof y=="function"?this._aiClient=y():this._aiClient=y,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(m=>{l(m)},m=>{(0,T.onUnexpectedError)(m),console.error(m)})}}log(l,m){!this._aiClient||(m=(0,R.mixin)(m,this._defaultData),m=(0,w.validateTelemetryData)(m),this.testCollector&&(m.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(y=>y.trackEvent({name:this._eventPrefix+"/"+l,properties:m.properties,measurements:m.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(m=>{m.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}i.AppInsightsAppender=C}),define(ee[124],te([0,1,4,13]),function(B,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function w(I,C){const S=Object.create(null),l=(y,D)=>{const u=JSON.parse(y);S[D]=u};if(C){const y=[],D=await R.Promises.readdir(C);for(const E of D)try{(await R.Promises.stat((0,T.join)(C,E))).isDirectory()&&y.push(E)}catch{}const u=[];for(const E of y)(await R.Promises.readdir((0,T.join)(C,E))).filter(g=>g==="telemetry.json").length===1&&u.push(E);for(const E of u){const d=(await R.Promises.readFile((0,T.join)(C,E,"telemetry.json"))).toString();l(d,E)}}let m=(await R.Promises.readFile((0,T.join)(I,"telemetry-core.json"))).toString();return l(m,"vscode-core"),m=(await R.Promises.readFile((0,T.join)(I,"telemetry-extensions.json"))).toString(),l(m,"vscode-extensions"),JSON.stringify(S,null,4)}i.buildTelemetryMessage=w}),define(ee[36],te([0,1,14]),function(B,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(ee[125],te([0,1,10,2,9,20,23,16,15,36]),function(B,i,T,R,w,I,C,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let y=class extends R.Disposable{constructor(u,E,d,g,h){super();this.extensionsManagementService=u,this.logService=g,this.uriIdentityService=h,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(b=>{this.installedExtensions=b.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(u.onInstallExtension(b=>this.onInstallExtension(b))),this._register(u.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(u.onDidUninstallExtension(b=>this.onDidUninstallExtension(b)));const p=w.URI.file(d.extensionsPath);this._register(E.watch(p)),this._register(T.Event.filter(E.onDidChangeFilesRaw,b=>b.changes.some(f=>this.doesChangeAffects(f,p)))(()=>this.onDidChange()))}doesChangeAffects(u,E){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(u.resource),E)?this.uriIdentityService.extUri.isEqual(u.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!(u.type!==1&&u.type!==2||this.uriIdentityService.extUri.basename(u.resource).startsWith(".")):!1}onInstallExtension(u){this.addInstallingExtension(u.identifier)}onDidInstallExtensions(u){for(const E of u)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(u){u.error||this.removeInstalledExtension(u.identifier)}addInstallingExtension(u){this.removeInstallingExtension(u),this.installingExtensions.push(u)}removeInstallingExtension(u){this.installingExtensions=this.installingExtensions.filter(E=>!(0,C.areSameExtensions)(E,u))}addInstalledExtension(u){this.installedExtensions&&(this.removeInstalledExtension(u),this.installedExtensions.push(u))}removeInstalledExtension(u){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,C.areSameExtensions)(E,u)))}async onDidChange(){if(this.installedExtensions){const u=await this.extensionsManagementService.getInstalled(1),E=u.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(h=>(0,C.areSameExtensions)(h,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),d=this.installedExtensions.filter(g=>this.installingExtensions.some(h=>(0,C.areSameExtensions)(h,g))?!1:u.every(h=>!(0,C.areSameExtensions)(h.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=u.map(g=>g.identifier),(E.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:d})}}};y=pe([ce(1,S.IFileService),ce(2,I.INativeEnvironmentService),ce(3,l.ILogService),ce(4,m.IUriIdentityService)],y),i.ExtensionsWatcher=y}),define(ee[126],te([0,1,36,93,16,18,59,10,2]),function(B,i,T,R,w,I,C,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class m{constructor(u){this.uri=u,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let y=class{constructor(u){this._fileService=u,this._dispooables=new l.DisposableStore,this._limit=2**16;const E=new Map,d=g=>{let h=E.get(g.scheme);return h===void 0&&(h=u.hasProvider(g)&&!this._fileService.hasCapability(g,1024),E.set(g.scheme,h)),h};this._dispooables.add(S.Event.any(u.onDidChangeFileSystemProviderRegistrations,u.onDidChangeFileSystemProviderCapabilities)(g=>{E.delete(g.scheme)})),this.extUri=new I.ExtUri(d),this._canonicalUris=new C.SkipList((g,h)=>this.extUri.compare(g,h,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(u){this._fileService.hasProvider(u)&&(u=(0,I.normalizePath)(u));let E=this._canonicalUris.get(u);return E?E.touch().uri.with({fragment:u.fragment}):(this._canonicalUris.set(u,new m(u)),this._checkTrim(),u)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const u=[...this._canonicalUris.entries()].sort((d,g)=>d[1].touch<g[1].touch?1:d[1].touch>g[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let d=0;d<E;d++)this._canonicalUris.set(u[d][0],u[d][1].touch())}};y=pe([ce(0,w.IFileService)],y),i.UriIdentityService=y,(0,R.registerSingleton)(T.IUriIdentityService,y,!0)}),define(ee[46],te([0,1,48,3,4,8,13,74,138,139]),function(B,i,T,R,w,I,C,S,l,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class y extends Error{constructor(n,o){let e=o.message;switch(n){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=n,this.cause=o}}i.ExtractError=y;function D(a){const n=a.externalFileAttributes>>16||33188;return[448,56,7].map(o=>n&o).reduce((o,e)=>o+e,n&61440)}function u(a){if(a instanceof y)return a;let n;return/end of central directory record signature not found/.test(a.message)&&(n="CorruptZip"),new y(n,a)}function E(a,n,o,e,t,r){const c=w.dirname(n),v=w.join(e,c);if(!v.startsWith(e))return Promise.reject(new Error(S.localize(0,null,n)));const L=w.join(e,n);let P;return r.onCancellationRequested(()=>{P&&P.destroy()}),Promise.resolve(C.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((k,U)=>{if(!r.isCancellationRequested)try{P=(0,T.createWriteStream)(L,{mode:o}),P.once("close",()=>k()),P.once("error",U),a.once("error",U),a.pipe(P)}catch(J){U(J)}}))}function d(a,n,o,e){let t=(0,R.createCancelablePromise)(()=>Promise.resolve()),r=0;return e.onCancellationRequested(()=>{t.cancel(),a.close()}),new Promise((c,v)=>{const L=new R.Sequencer,P=k=>{k.isCancellationRequested||(r++,a.readEntry())};a.once("error",v),a.once("close",()=>t.then(()=>{e.isCancellationRequested||a.entryCount===r?c():v(new y("Incomplete",new Error(S.localize(1,null,r,a.entryCount))))},v)),a.readEntry(),a.on("entry",k=>{if(e.isCancellationRequested)return;if(!o.sourcePathRegex.test(k.fileName)){P(e);return}const U=k.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(U)){const ge=w.join(n,U);t=(0,R.createCancelablePromise)(oe=>C.Promises.mkdir(ge,{recursive:!0}).then(()=>P(oe)).then(void 0,v));return}const J=h(a,k),ne=D(k);t=(0,R.createCancelablePromise)(ge=>L.queue(()=>J.then(oe=>E(oe,U,ne,n,o,ge).then(()=>P(ge)))).then(null,v))})})}function g(a,n=!1){return new Promise((o,e)=>{(0,l.open)(a,n?{lazyEntries:!0}:void 0,(t,r)=>{t?e(u(t)):o((0,I.assertIsDefined)(r))})})}function h(a,n){return new Promise((o,e)=>{a.openReadStream(n,(t,r)=>{t?e(u(t)):o((0,I.assertIsDefined)(r))})})}function p(a,n){return new Promise((o,e)=>{const t=new m.ZipFile;n.forEach(c=>{c.contents?t.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&t.addFile(c.localPath,c.path)}),t.end();const r=(0,T.createWriteStream)(a);t.outputStream.pipe(r),t.outputStream.once("error",e),r.once("error",e),r.once("finish",()=>o(a))})}i.zip=p;function b(a,n,o={},e){const t=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let r=g(a,!0);return o.overwrite&&(r=r.then(c=>C.Promises.rm(n).then(()=>c))),r.then(c=>d(c,n,{sourcePathRegex:t},e))}i.extract=b;function f(a,n){return g(a).then(o=>new Promise((e,t)=>{o.on("entry",r=>{r.fileName===n&&h(o,r).then(c=>e(c),c=>t(c))}),o.once("close",()=>t(new Error(S.localize(2,null,n))))}))}function s(a,n){return f(a,n).then(o=>new Promise((e,t)=>{const r=[];o.once("error",t),o.on("data",c=>r.push(c)),o.on("end",()=>e(Buffer.concat(r)))}))}i.buffer=s}),define(ee[127],te([0,1,46,81]),function(B,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function w(I){return(0,T.buffer)(I,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}i.getManifest=w}),define(ee[128],te([0,1,19,3,7,2,11,4,12,18,44,9,27,13,46,82,20,22,23,92,16,15,32]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E,d,g,h,p,b,f,s,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let o=class extends I.Disposable{constructor(t,r,c,v,L){super();this.beforeRemovingExtension=t,this.fileService=r,this.logService=c,this.environmentService=v,this.productService=L,this._devSystemExtensionsPath=null,this.systemExtensionsPath=v.builtinExtensionsPath,this.extensionsPath=v.extensionsPath,this.uninstalledPath=S.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const r=[];(t===null||t===0)&&r.push(this.scanSystemExtensions().then(null,c=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(c).message,p.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&r.push(this.scanUserExtensions(!0).then(null,c=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(c).message,p.ExtensionManagementErrorCode.Internal))));try{const c=await Promise.all(r);return(0,T.flatten)(c)}catch(c){throw this.joinErrors(c)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[r,c]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return c=c.filter(v=>!r[new b.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]),t&&(c=(0,b.groupByExtension)(c,L=>L.identifier).map(L=>L.sort((P,k)=>y.rcompare(P.manifest.version,k.manifest.version))[0])),this.logService.trace("Scanned user extensions:",c.length),c}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,r,c,v){const L=t.key(),P=S.join(this.extensionsPath,`.${(0,u.generateUuid)()}`),k=S.join(this.extensionsPath,L);try{await E.Promises.rm(k)}catch{try{await E.Promises.rm(k)}catch{}throw new p.ExtensionManagementError((0,g.localize)(0,null,k,t.id),p.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,r,P,v);let U=await this.scanExtension(D.URI.file(P),1);if(!U)throw new Error((0,g.localize)(1,null,P));await this.storeMetadata(U,{...c,installedTimestamp:Date.now()});try{await this.rename(t,P,k,Date.now()+2*60*1e3),this.logService.info("Renamed to",k)}catch(J){try{await E.Promises.rm(P)}catch{}if(J.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(J)}. Deleted from extracted location`,P),J}try{U=await this.scanExtension(D.URI.file(k),1)}catch{}if(U)return U;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,r){return this.setMetadata(t,r),await this.storeMetadata(t,{...r,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,r){r.isMachineScoped=r.isMachineScoped||void 0,r.isBuiltin=r.isBuiltin||void 0,r.installedTimestamp=r.installedTimestamp||void 0;const c=S.join(t.location.fsPath,"package.json"),v=await E.Promises.readFile(c,"utf8"),{manifest:L}=await this.parseManifest(v);return L.__metadata=r,await E.Promises.writeFile(c,JSON.stringify(L,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const r=t.map(c=>new b.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version));await this.withUninstalledExtensions(c=>{r.forEach(v=>c[v.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(v=>delete v[t.key()]);const c=(await this.scanExtensions(1)).find(v=>new b.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).equals(t))||null;return c?(await this.storeMetadata(c,{installedTimestamp:Date.now()}),this.scanExtension(c.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let r;try{r=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(v){if(v.code!=="ENOENT")throw v}let c={};if(r)try{c=JSON.parse(r)}catch{}return t&&(t(c),Object.keys(c).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(c)):await E.Promises.rm(this.uninstalledPath)),c})}async removeExtension(t,r){this.logService.trace(`Deleting ${r} extension from disk`,t.identifier.id,t.location.fsPath),await E.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(r=>delete r[new b.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,r,c,v){this.logService.trace(`Started extracting the extension from ${r} to ${c}`);try{await E.Promises.rm(c)}catch(L){throw new p.ExtensionManagementError(this.joinErrors(L).message,p.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(r,c,{sourcePath:"extension",overwrite:!0},v),this.logService.info(`Extracted extension to ${c}:`,t.id)}catch(L){try{await E.Promises.rm(c)}catch{}let P=p.ExtensionManagementErrorCode.Extract;throw L instanceof d.ExtractError&&(L.type==="CorruptZip"?P=p.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(P=p.ExtensionManagementErrorCode.IncompleteZip)),new p.ExtensionManagementError(L.message,P)}}async rename(t,r,c,v){try{await E.Promises.rename(r,c)}catch(L){if(l.isWindows&&L&&L.code==="EPERM"&&Date.now()<v)return this.logService.info(`Failed renaming ${r} to ${c} with 'EPERM' error. Trying again...`,t.id),this.rename(t,r,c,v);throw new p.ExtensionManagementError(L.message||(0,g.localize)(3,null,r,c),L.code||p.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const r=this.scanDevSystemExtensions(),[c,v]=await Promise.all([t,r]);return[...c,...v]}async scanExtensionsInDir(t,r){const c=new R.Limiter(10),v=await this.fileService.resolve(D.URI.file(t));return v.children?(await Promise.all(v.children.filter(P=>P.isDirectory).map(P=>c.queue(async()=>r===1&&(0,m.basename)(P.resource).indexOf(".")===0?null:this.scanExtension(P.resource,r))))).filter(P=>P&&P.identifier):[]}async scanExtension(t,r){try{const c=await this.fileService.resolve(t);if(c.children){const{manifest:v,metadata:L}=await this.readManifest(t.fsPath),P=c.children.find(({name:ne})=>/^readme(\.txt|\.md|)$/i.test(ne))?.resource,k=c.children.find(({name:ne})=>/^changelog(\.txt|\.md|)$/i.test(ne))?.resource,U={id:(0,b.getGalleryExtensionId)(v.publisher,v.name)},J={type:r,identifier:U,manifest:v,location:t,readmeUrl:P,changelogUrl:k,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:r===0};return this.setMetadata(J,L),J}}catch(c){r!==0&&this.logService.trace(c)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const r=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",r.length),r.filter(c=>t.some(v=>(0,b.areSameExtensions)(c.identifier,{id:v})))}else return[]}setMetadata(t,r){t.publisherDisplayName=r?.publisherDisplayName||null,t.publisherId=r?.publisherId||null,t.identifier.uuid=r?.id,t.isMachineScoped=!!r?.isMachineScoped,t.isPreReleaseVersion=!!r?.isPreReleaseVersion,t.preRelease=!!r?.preRelease,t.isBuiltin=t.type===0||!!r?.isBuiltin,t.installedTimestamp=r?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),r=await this.scanAllUserExtensions(),c=new Set;for(const P of r)t[new b.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]||c.add(P.identifier.id.toLowerCase());const v=(0,b.groupByExtension)(r,P=>P.identifier);await R.Promises.settled(v.map(async P=>{const k=P.sort((U,J)=>y.rcompare(U.manifest.version,J.manifest.version))[0];c.has(k.identifier.id.toLowerCase())||await this.beforeRemovingExtension(k)}));const L=r.filter(P=>t[new b.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]);await R.Promises.settled(L.map(P=>this.removeUninstalledExtension(P)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),r=[],c=(0,b.groupByExtension)(t,v=>v.identifier);r.push(...(0,T.flatten)(c.map(v=>v.sort((L,P)=>y.rcompare(L.manifest.version,P.manifest.version)).slice(1)))),await R.Promises.settled(r.map(v=>this.removeExtension(v,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const r=Array.isArray(t)?t:[t];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((c,v)=>new Error(`${c.message}${c.message?",":""}${v instanceof Error?v.message:v}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=S.normalize(S.join(C.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const r=[E.Promises.readFile(S.join(t,"package.json"),"utf8").then(P=>this.parseManifest(P)),E.Promises.readFile(S.join(t,"package.nls.json"),"utf8").then(void 0,P=>P.code!=="ENOENT"?Promise.reject(P):"{}").then(P=>JSON.parse(P))],[{manifest:c,metadata:v},L]=await Promise.all(r);return{manifest:(0,f.localizeManifest)(c,L),metadata:v}}parseManifest(t){return new Promise((r,c)=>{try{const v=JSON.parse(t),L=v.__metadata||null;r({manifest:v,metadata:L})}catch{c(new Error((0,g.localize)(4,null)))}})}};o=pe([ce(1,s.IFileService),ce(2,a.ILogService),ce(3,h.INativeEnvironmentService),ce(4,n.IProductService)],o),i.ExtensionsScanner=o}),define(ee[129],te([0,1,28,7,11,4,12,29,18,44,9,27,13,46,80,52,20,119,22,23,110,99,127,111,128,125,51,16,14,15,32,31,36]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E,d,g,h,p,b,f,s,a,n,o,e,t,r,c,v,L,P,k,U){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let J=class extends p.AbstractExtensionManagementService{constructor(_,G,re,z,O,M,x,K,W){super(_,G,re,K);this.environmentService=z,this.downloadService=O,this.fileService=x;const X=this._register(M.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(e.ExtensionsScanner,Y=>X.postUninstall(Y))),this.manifestCache=this._register(new o.ExtensionsManifestCache(z,this)),this.extensionsDownloader=this._register(M.createInstance(s.ExtensionsDownloader));const $=this._register(new t.ExtensionsWatcher(this,x,z,re,W));this._register($.onDidChangeExtensionsByAnotherSource(({added:Y,removed:N})=>{Y.length&&this._onDidInstallExtensions.fire(Y.map(F=>({identifier:F.identifier,operation:1,local:F}))),N.forEach(F=>this._onDidUninstallExtension.fire({identifier:F}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const _=await this.isAlpineLinux(),G=(0,b.getTargetPlatform)(_?"alpine":C.platform,S.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!C.isLinux)return!1;let _;try{_=(await this.fileService.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{_=(await this.fileService.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(re){this.logService.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(re))}}return!!_&&(_.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(_){this.logService.trace("ExtensionManagementService#zip",_.identifier.id);const G=await this.collectFiles(_),re=await(0,E.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)()).fsPath,G);return y.URI.file(re)}async unzip(_){return this.logService.trace("ExtensionManagementService#unzip",_.toString()),(await this.install(_)).identifier}async getManifest(_){const G=await this.downloadVsix(_),re=I.resolve(G.fsPath);return(0,n.getManifest)(re)}getInstalled(_=null){return this.extensionsScanner.scanExtensions(_)}async install(_,G={}){this.logService.trace("ExtensionManagementService#install",_.toString());const re=await this.downloadVsix(_),z=await(0,n.getManifest)(I.resolve(re.fsPath));if(z.engines&&z.engines.vscode&&!(0,r.isEngineValid)(z.engines.vscode,this.productService.version,this.productService.date))throw new Error(d.localize(0,null,(0,f.getGalleryExtensionId)(z.publisher,z.name),this.productService.version));return this.installExtension(z,re,G)}async updateMetadata(_,G){this.logService.trace("ExtensionManagementService#updateMetadata",_.identifier.id);const re={..._.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(re.preRelease=!0),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,re),this.manifestCache.invalidate(),_}async updateExtensionScope(_,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,{..._.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),_}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(_){if(_.scheme===w.Schemas.file)return _;const G=(0,l.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)());return await this.downloadService.download(_,G),G}createInstallExtensionTask(_,G,re){return y.URI.isUri(G)?new oe(_,G,re,this.galleryService,this.extensionsScanner,this.logService):new ge(G,re,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(_,G){return new ie(_,G,this.extensionsScanner)}async collectFiles(_){const G=async z=>{let O=await u.Promises.readdir(z);O=O.map(K=>I.join(z,K));const M=await Promise.all(O.map(K=>u.Promises.stat(K)));let x=Promise.resolve([]);return M.forEach((K,W)=>{const X=O[W];K.isFile()&&(x=x.then($=>[...$,X])),K.isDirectory()&&(x=x.then($=>G(X).then(Y=>[...$,...Y])))}),x};return(await G(_.location.fsPath)).map(z=>({path:`extension/${I.relative(_.location.fsPath,z)}`,localPath:z}))}};J=pe([ce(0,b.IExtensionGalleryService),ce(1,k.ITelemetryService),ce(2,L.ILogService),ce(3,h.INativeEnvironmentService),ce(4,g.IDownloadService),ce(5,v.IInstantiationService),ce(6,c.IFileService),ce(7,P.IProductService),ce(8,U.IUriIdentityService)],J),i.ExtensionManagementService=J;class ne extends p.AbstractExtensionTask{constructor(_,G,re,z){super();this.identifier=_,this.source=G,this.extensionsScanner=re,this.logService=z,this._operation=2}get operation(){return this._operation}async installExtension(_,G){try{const re=await this.unsetUninstalledAndGetLocal(_.identifierWithVersion);if(re)return _.metadata?this.extensionsScanner.saveMetadataForLocalExtension(re,{...re.manifest.__metadata||{},..._.metadata}):re}catch{throw C.isMacintosh?new b.ExtensionManagementError(d.localize(1,null),b.ExtensionManagementErrorCode.Internal):new b.ExtensionManagementError(d.localize(2,null),b.ExtensionManagementErrorCode.Internal)}return this.extract(_,G)}async unsetUninstalledAndGetLocal(_){if(!await this.isUninstalled(_))return null;this.logService.trace("Removing the extension from uninstalled list:",_.id);const re=await this.extensionsScanner.setInstalled(_);return this.logService.info("Removed the extension from uninstalled list:",_.id),re}async isUninstalled(_){return!!(await this.extensionsScanner.getUninstalledExtensions())[_.key()]}async extract({zipPath:_,identifierWithVersion:G,metadata:re},z){let O=await this.extensionsScanner.extractUserExtension(G,_,re,z);return this.logService.info("Extracting completed.",G.id),O}}class ge extends ne{constructor(_,G,re,z,O){super(_.identifier,_,z,O);this.gallery=_,this.options=G,this.extensionsDownloader=re}async doRun(_){const re=(await this.extensionsScanner.scanExtensions(null)).find(O=>(0,f.areSameExtensions)(O.identifier,this.gallery.identifier));re&&(this._operation=3);const z=await this.downloadInstallableExtension(this.gallery,this._operation);z.metadata.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,z.metadata.isBuiltin=this.options.isBuiltin||re?.isBuiltin,z.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,z.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:re?.preRelease;try{const O=await this.installExtension(z,_);return re&&m.neq(re.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(re),O}catch(O){throw await this.deleteDownloadedVSIX(z.zipPath),O}}async deleteDownloadedVSIX(_){try{await this.extensionsDownloader.delete(y.URI.file(_))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",_.toString(),(0,R.getErrorMessage)(G))}}async downloadInstallableExtension(_,G){const re={id:_.identifier.uuid,publisherId:_.publisherId,publisherDisplayName:_.publisherDisplayName};let z;try{this.logService.trace("Started downloading extension:",_.identifier.id),z=(await this.extensionsDownloader.downloadExtension(_,G)).fsPath,this.logService.info("Downloaded extension:",_.identifier.id,z)}catch(O){throw new b.ExtensionManagementError((0,p.joinErrors)(O).message,b.ExtensionManagementErrorCode.Download)}try{const O=await(0,n.getManifest)(z);return{zipPath:z,identifierWithVersion:new f.ExtensionIdentifierWithVersion(_.identifier,O.version),metadata:re}}catch(O){throw await this.deleteDownloadedVSIX(z),new b.ExtensionManagementError((0,p.joinErrors)(O).message,b.ExtensionManagementErrorCode.Invalid)}}}class oe extends ne{constructor(_,G,re,z,O,M){super({id:(0,f.getGalleryExtensionId)(_.publisher,_.name)},G,O,M);this.manifest=_,this.location=G,this.options=re,this.galleryService=z}async doRun(_){const G=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),z=(await this.extensionsScanner.scanExtensions(1)).find(M=>(0,f.areSameExtensions)(this.identifier,M.identifier)),O=await this.getMetadata(this.identifier.id,this.manifest.version,_);if(O.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,O.isBuiltin=this.options.isBuiltin||z?.isBuiltin,z)if(this._operation=3,G.equals(new f.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version)))try{await this.extensionsScanner.removeExtension(z,"existing")}catch{throw new Error(d.localize(3,null,this.manifest.displayName||this.manifest.name))}else m.gt(z.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(z);else{const M=await this.unsetUninstalledAndGetLocal(G);if(M)try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(d.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),identifierWithVersion:G,metadata:O},_)}async getMetadata(_,G,re){try{let[z]=await this.galleryService.getExtensions([{id:_,version:G}],re);if(z||([z]=await this.galleryService.getExtensions([{id:_}],re)),z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion}}catch{}return{}}}class ie extends p.AbstractExtensionTask{constructor(_,G,re){super();this.extension=_,this.options=G,this.extensionsScanner=re}async doRun(_){const G=[],re=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const z=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...re.filter(O=>z.equals(new f.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version))))}else G.push(...re.filter(z=>(0,f.areSameExtensions)(z.identifier,this.extension.identifier)));if(!G.length)throw new Error(d.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const z of G)try{_.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(z)}catch(O){throw new Error(d.localize(6,null,(0,T.toErrorMessage)(O)))}}}}),define(ee[130],te([0,1,115,3,17,7,2,8,26,20,95,15,114,140]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let d=class extends C.Disposable{constructor(h,p,b){super();this.environmentService=p,this.logService=b,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,p){this.logService.trace("RequestService#request",h.url);const{proxyUrl:b,strictSSL:f}=this;let s;try{s=await(0,y.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",o))}const a={...process.env,...s},n=h.agent?h.agent:await(0,u.getProxyAgent)(h.url||"",a,{proxyUrl:b,strictSSL:f});return h.agent=n,h.strictSSL=f,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this._request(h,p)}async getNodeRequest(h){return((0,T.parse)(h.url).protocol==="https:"?await new Promise((f,s)=>{B(["https"],f,s)}):await new Promise((f,s)=>{B(["http"],f,s)})).request}_request(h,p){return R.Promises.withAsyncBody(async(b,f)=>{let s;const a=(0,T.parse)(h.url),n=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,S.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password),s=n(o,e=>{const t=(0,S.isNumber)(h.followRedirects)?h.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&t>0&&e.headers.location)this._request({...h,url:e.headers.location,followRedirects:t-1},p).then(b,f);else{let r=e;e.headers["content-encoding"]==="gzip"&&(r=e.pipe((0,E.createGunzip)())),b({res:e,stream:(0,w.streamToBufferReadableStream)(r)})}}),s.on("error",f),h.timeout&&s.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&s.write(h.data),s.end(),p.onCancellationRequested(()=>{s.abort(),f((0,I.canceled)())})})}async resolveProxy(h){}};d=pe([ce(0,l.IConfigurationService),ce(1,m.INativeEnvironmentService),ce(2,D.ILogService)],d),i.RequestService=d}),define(ee[141],te([0,1,33,3,17,28,7,2,11,4,29,9,13,26,107,52,113,20,91,120,22,109,129,16,101,103,41,98,54,55,112,15,104,122,32,45,130,118,31,121,35,123,124,36,126]),function(B,i,T,R,w,I,C,S,l,m,y,D,u,E,d,g,h,p,b,f,s,a,n,o,e,t,r,c,v,L,P,k,U,J,ne,ge,oe,ie,he,_,G,re,z,O,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class x extends S.Disposable{constructor(X){super();this.argv=X,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[X,$]=await this.initServices();return X.invokeFunction(async Y=>{const N=Y.get(k.ILogService),F=Y.get(o.IFileService),V=Y.get(p.INativeEnvironmentService),j=Y.get(s.IExtensionManagementCLIService);N.info("CLI main",this.argv),this.registerErrorHandler(N),await this.doRun(V,j,F),await Promise.all($.map(Q=>{(0,R.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const X=new v.ServiceCollection,$={_serviceBrand:void 0,...J.default};X.set(ne.IProductService,$);const Y=new b.NativeEnvironmentService(this.argv,$);X.set(p.INativeEnvironmentService,Y),await Promise.all([Y.appSettingsHome.fsPath,Y.extensionsPath].map(ae=>ae?u.Promises.mkdir(ae,{recursive:!0}):void 0));const N=(0,k.getLogLevel)(Y),F=[];F.push(new U.SpdLogLogger("cli",(0,m.join)(Y.logsPath,"cli.log"),!0,!1,N)),N===k.LogLevel.Trace&&F.push(new k.ConsoleLogger(N));const V=this._register(new k.MultiplexLogService(F));X.set(k.ILogService,V);const j=this._register(new e.FileService(V));X.set(o.IFileService,j);const Q=this._register(new t.DiskFileSystemProvider(V));j.registerProvider(l.Schemas.file,Q);const Z=this._register(new d.ConfigurationService(Y.settingsResource,j));X.set(E.IConfigurationService,Z),await Z.initialize(),X.set(O.IUriIdentityService,new M.UriIdentityService(j)),X.set(ge.IRequestService,new r.SyncDescriptor(oe.RequestService)),X.set(g.IDownloadService,new r.SyncDescriptor(h.DownloadService)),X.set(s.IExtensionManagementService,new r.SyncDescriptor(n.ExtensionManagementService)),X.set(s.IExtensionGalleryService,new r.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService)),X.set(s.IExtensionManagementCLIService,new r.SyncDescriptor(a.ExtensionManagementCLIService)),X.set(L.ILocalizationsService,new r.SyncDescriptor(P.LocalizationsService));const fe=[];if((0,G.supportsTelemetry)($,Y)){$.aiConfig&&$.aiConfig.asimovKey&&fe.push(new re.AppInsightsAppender("monacoworkbench",null,$.aiConfig.asimovKey));const{appRoot:ae,extensionsPath:se,installSourcePath:le}=Y,ye={appenders:fe,sendErrorTelemetry:!1,commonProperties:(async()=>{let ue;try{const Ee=await u.Promises.readFile((0,m.join)(Y.userDataPath,"storage.json"));ue=JSON.parse(Ee.toString())[he.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&V.error(Ee)}return(0,ie.resolveCommonProperties)(j,(0,T.release)(),(0,T.hostname)(),process.arch,$.commit,$.version,ue,$.msftInternalDomains,le)})(),piiPaths:[ae,se]};X.set(he.ITelemetryService,new r.SyncDescriptor(_.TelemetryService,[ye]))}else X.set(he.ITelemetryService,G.NullTelemetryService);return[new c.InstantiationService(X),fe]}registerErrorHandler(X){(0,C.setUnexpectedErrorHandler)($=>{const Y=(0,I.toErrorMessage)($,!0);!Y||X.error(`[uncaught exception in CLI]: ${Y}`)}),process.on("uncaughtException",$=>(0,C.onUnexpectedError)($)),process.on("unhandledRejection",$=>(0,C.onUnexpectedError)($))}async doRun(X,$,Y){if(this.argv["install-source"])return this.setInstallSource(X,Y,this.argv["install-source"]);if(this.argv["list-extensions"])return $.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const N={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return $.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],N,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return $.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return $.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,z.buildTelemetryMessage)(X.appRoot,X.extensionsPath))}}asExtensionIdOrVSIX(X){return X.map($=>/\.vsix$/i.test($)?D.URI.file((0,m.isAbsolute)($)?$:(0,m.join)((0,y.cwd)(),$)):$)}async setInstallSource(X,$,Y){await $.writeFile(D.URI.file(X.installSourcePath),w.VSBuffer.fromString(Y.slice(0,30)))}}async function K(W){const X=new x(W);try{await X.run()}finally{X.dispose()}}i.main=K})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/99305570d885bce929ba8f24d90f2c3ee54c5c2f/core/vs/code/node/cliProcessMain.js.map
