/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/languages/tokenizationRegistry","vs/editor/common/model/textModelSearch","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],we=function(X){for(var e=[],f=0,i=X.length;f<i;f++)e[f]=ve[X[f]];return e};define(ve[56],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(i,k){if(!i)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=f}),define(ve[74],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function f(T){return T?T.replace(/\$\((.*?)\)/g,(I,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=f;class i{constructor(I,C,P){this.id=I,this.definition=C,this.description=P,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(T,I){const C=["codicon","codicon-"+T];return I&&C.push("codicon-modifier-"+I),C}e.getClassNamesArray=k;var _;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function C(y){if(y instanceof i)return["codicon","codicon-"+y.id];const c=I.exec(y.id);if(!c)return C(i.error);let[,b,v]=c;const p=["codicon","codicon-"+b];return v&&p.push("codicon-modifier-"+v.substr(1)),p}T.asClassNameArray=C;function P(y){return C(y).join(" ")}T.asClassName=P;function R(y){return"."+C(y).join(".")}T.asCSSSelector=R})(_=e.CSSIcon||(e.CSSIcon={}))}),define(ve[75],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function i(R){const y=[];for(let c in R)f.call(R,c)&&y.push(R[c]);return y}e.values=i;function k(R,y){for(let c in R)if(f.call(R,c)&&y({key:c,value:R[c]},function(){delete R[c]})===!1)return}e.forEach=k;function _(R,y){const c=Object.create(null);for(const b of R){const v=y(b);let p=c[v];p||(p=c[v]=[]),p.push(b)}return c}e.groupBy=_;function T(R){const y=Object.create(null);return R&&R.forEach((c,b)=>{y[b]=c}),y}e.fromMap=T;function I(R,y){const c=[],b=[];for(let v of R)y.has(v)||c.push(v);for(let v of y)R.has(v)||b.push(v);return{removed:c,added:b}}e.diffSets=I;function C(R,y){const c=[],b=[];for(let[v,p]of R)y.has(v)||c.push(p);for(let[v,p]of y)R.has(v)||b.push(p);return{removed:c,added:b}}e.diffMaps=C;class P{constructor(){this.map=new Map}add(y,c){let b=this.map.get(y);b||(b=new Set,this.map.set(y,b)),b.add(c)}delete(y,c){const b=this.map.get(y);!b||(b.delete(c),b.size===0&&this.map.delete(y))}forEach(y,c){const b=this.map.get(y);!b||b.forEach(c)}}e.SetMap=P}),define(ve[57],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(T){return(I,C,P)=>{let R=null,y=null;if(typeof P.value=="function"?(R="value",y=P.value):typeof P.get=="function"&&(R="get",y=P.get),!y)throw new Error("not supported");P[R]=T(y,C)}}e.createDecorator=f;function i(T,I,C){let P=null,R=null;if(typeof C.value=="function"?(P="value",R=C.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(P="get",R=C.get),!R)throw new Error("not supported");const y=`$memoize$${I}`;C[P]=function(...c){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,c)}),this[y]}}e.memoize=i;function k(T,I,C){return f((P,R)=>{const y=`$debounce$${R}`,c=`$debounce$result$${R}`;return function(...b){this[c]||(this[c]=C?C():void 0),clearTimeout(this[y]),I&&(this[c]=I(this[c],...b),b=[this[c]]),this[y]=setTimeout(()=>{P.apply(this,b),this[c]=C?C():void 0},T)}})}e.debounce=k;function _(T,I,C){return f((P,R)=>{const y=`$throttle$timer$${R}`,c=`$throttle$result$${R}`,b=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...p){if(this[c]||(this[c]=C?C():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),I&&(this[c]=I(this[c],...p)),this[v])return;const w=this[b]+T;w<=Date.now()?(this[b]=Date.now(),P.apply(this,[this[c]]),this[c]=C?C():void 0):(this[v]=!0,this[y]=setTimeout(()=>{this[v]=!1,this[b]=Date.now(),P.apply(this,[this[c]]),this[c]=C?C():void 0},w-Date.now()))}})}e.throttle=_}),define(ve[15],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(E=>{E(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=f,e.errorHandler=new f;function i(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=i;function k(m){C(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=k;function _(m){C(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=_;function T(m){if(m instanceof Error){let{name:a,message:E}=m;const n=m.stacktrace||m.stack;return{$isError:!0,name:a,message:E,stack:n}}return m}e.transformErrorForSerialization=T;const I="Canceled";function C(m){return m instanceof Error&&m.name===I&&m.message===I}e.isPromiseCanceledError=C;class P extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=P;function R(){const m=new Error(I);return m.name=m.message,m}e.canceled=R;function y(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=y;function c(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=c;function b(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function v(m){const a=new Error(`${m} has been disposed`);return a.name="DISPOSED",a}e.disposed=v;function p(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=p;class w extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=w;class L extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=L;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function o(m){const a=m;return a instanceof Error&&Array.isArray(a.actions)}e.isErrorWithActions=o;function r(m,a=Object.create(null)){const E=new Error(m);return a.actions&&(E.actions=a.actions),E}e.createErrorWithActions=r}),define(ve[16],we([0,1,15]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(j,ne=0){return j[j.length-(1+ne)]}e.tail=i;function k(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=k;function _(j,ne,le=(ge,ke)=>ge===ke){if(j===ne)return!0;if(!j||!ne||j.length!==ne.length)return!1;for(let ge=0,ke=j.length;ge<ke;ge++)if(!le(j[ge],ne[ge]))return!1;return!0}e.equals=_;function T(j,ne,le){let ge=0,ke=j.length-1;for(;ge<=ke;){const Me=(ge+ke)/2|0,Ue=le(j[Me],ne);if(Ue<0)ge=Me+1;else if(Ue>0)ke=Me-1;else return Me}return-(ge+1)}e.binarySearch=T;function I(j,ne){let le=0,ge=j.length;if(ge===0)return 0;for(;le<ge;){const ke=Math.floor((le+ge)/2);ne(j[ke])?ge=ke:le=ke+1}return le}e.findFirstInSorted=I;function C(j,ne,le){if(j=j|0,j>=ne.length)throw new TypeError("invalid index");let ge=ne[Math.floor(ne.length*Math.random())],ke=[],Me=[],Ue=[];for(let q of ne){const J=le(q,ge);J<0?ke.push(q):J>0?Me.push(q):Ue.push(q)}return j<ke.length?C(j,ke,le):j<ke.length+Ue.length?Ue[0]:C(j-(ke.length+Ue.length),Me,le)}e.quickSelect=C;function P(j,ne){const le=[];let ge;for(const ke of j.slice(0).sort(ne))!ge||ne(ge[0],ke)!==0?(ge=[ke],le.push(ge)):ge.push(ke);return le}e.groupBy=P;function R(j,ne,le){const ge=[];function ke(q,J,re){if(J===0&&re.length===0)return;const he=ge[ge.length-1];he&&he.start+he.deleteCount===q?(he.deleteCount+=J,he.toInsert.push(...re)):ge.push({start:q,deleteCount:J,toInsert:re})}let Me=0,Ue=0;for(;;){if(Me===j.length){ke(Me,0,ne.slice(Ue));break}if(Ue===ne.length){ke(Me,j.length-Me,[]);break}const q=j[Me],J=ne[Ue],re=le(q,J);re===0?(Me+=1,Ue+=1):re<0?(ke(Me,1,[]),Me+=1):re>0&&(ke(Me,0,[J]),Ue+=1)}return ge}e.sortedDiff=R;function y(j,ne,le){const ge=R(j,ne,le),ke=[],Me=[];for(const Ue of ge)ke.push(...j.slice(Ue.start,Ue.start+Ue.deleteCount)),Me.push(...Ue.toInsert);return{removed:ke,added:Me}}e.delta=y;function c(j,ne,le){if(le===0)return[];const ge=j.slice(0,le).sort(ne);return v(j,ne,ge,le,j.length),ge}e.top=c;function b(j,ne,le,ge,ke){return le===0?Promise.resolve([]):new Promise((Me,Ue)=>{(async()=>{const q=j.length,J=j.slice(0,le).sort(ne);for(let re=le,he=Math.min(le+ge,q);re<q;re=he,he=Math.min(he+ge,q)){if(re>le&&await new Promise(Z=>setTimeout(Z)),ke&&ke.isCancellationRequested)throw(0,f.canceled)();v(j,ne,J,re,he)}return J})().then(Me,Ue)})}e.topAsync=b;function v(j,ne,le,ge,ke){for(const Me=le.length;ge<ke;ge++){const Ue=j[ge];if(ne(Ue,le[Me-1])<0){le.pop();const q=I(le,J=>ne(Ue,J)<0);le.splice(q,0,Ue)}}}function p(j){return j.filter(ne=>!!ne)}e.coalesce=p;function w(j){let ne=0;for(let le=0;le<j.length;le++)j[le]&&(j[ne]=j[le],ne+=1);j.length=ne}e.coalesceInPlace=w;function L(j,ne,le){j.splice(le,0,j.splice(ne,1)[0])}e.move=L;function S(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=S;function o(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=o;function r(j,ne=le=>le){const le=new Set;return j.filter(ge=>{const ke=ne(ge);return le.has(ke)?!1:(le.add(ke),!0)})}e.distinct=r;function m(j){const ne=Object.create(null);return le=>{const ge=j(le);return ne[ge]?!1:(ne[ge]=!0,!0)}}e.uniqueFilter=m;function a(j,ne){const le=E(j,ne);if(le!==-1)return j[le]}e.findLast=a;function E(j,ne){for(let le=j.length-1;le>=0;le--){const ge=j[le];if(ne(ge))return le}return-1}e.lastIndex=E;function n(j,ne){return j.length>0?j[0]:ne}e.firstOrDefault=n;function t(j,ne,le=(ge,ke)=>ge===ke){let ge=0;for(let ke=0,Me=Math.min(j.length,ne.length);ke<Me&&le(j[ke],ne[ke]);ke++)ge++;return ge}e.commonPrefixLength=t;function s(j){return[].concat(...j)}e.flatten=s;function u(j,ne){let le=typeof ne=="number"?j:0;typeof ne=="number"?le=j:(le=0,ne=j);const ge=[];if(le<=ne)for(let ke=le;ke<ne;ke++)ge.push(ke);else for(let ke=le;ke>ne;ke--)ge.push(ke);return ge}e.range=u;function d(j,ne,le){return j.reduce((ge,ke)=>(ge[ne(ke)]=le?le(ke):ke,ge),Object.create(null))}e.index=d;function h(j,ne){return j.push(ne),()=>g(j,ne)}e.insert=h;function g(j,ne){const le=j.indexOf(ne);if(le>-1)return j.splice(le,1),ne}e.remove=g;function l(j,ne,le){const ge=j.slice(0,ne),ke=j.slice(ne);return ge.concat(le,ke)}e.arrayInsert=l;function D(j,ne){let le;if(typeof ne=="number"){let ge=ne;le=()=>{const ke=Math.sin(ge++)*179426549;return ke-Math.floor(ke)}}else le=Math.random;for(let ge=j.length-1;ge>0;ge-=1){const ke=Math.floor(le()*(ge+1)),Me=j[ge];j[ge]=j[ke],j[ke]=Me}}e.shuffle=D;function A(j,ne){const le=j.indexOf(ne);le>-1&&(j.splice(le,1),j.unshift(ne))}e.pushToStart=A;function N(j,ne){const le=j.indexOf(ne);le>-1&&(j.splice(le,1),j.push(ne))}e.pushToEnd=N;function B(j,ne){return Array.isArray(j)?j.map(ne):ne(j)}e.mapArrayOrNot=B;function F(j){return Array.isArray(j)?j:[j]}e.asArray=F;function O(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=O;function z(j,ne){for(const le of j){const ge=ne(le);if(ge!==void 0)return ge}}e.mapFind=z;function W(j,ne,le){const ge=x(j,ne),ke=j.length,Me=le.length;j.length=ke+Me;for(let Ue=ke-1;Ue>=ge;Ue--)j[Ue+Me]=j[Ue];for(let Ue=0;Ue<Me;Ue++)j[Ue+ge]=le[Ue]}e.insertInto=W;function M(j,ne,le,ge){const ke=x(j,ne),Me=j.splice(ke,le);return W(j,ke,ge),Me}e.splice=M;function x(j,ne){return ne<0?Math.max(ne+j.length,0):Math.min(ne,j.length)}function V(j,ne){return(le,ge)=>ne(j(le),j(ge))}e.compareBy=V;const U=(j,ne)=>j-ne;e.numberComparator=U;function H(j,ne){if(j.length===0)return;let le=j[0];for(let ge=1;ge<j.length;ge++){const ke=j[ge];ne(ke,le)>0&&(le=ke)}return le}e.findMaxBy=H;function Y(j,ne){if(j.length===0)return;let le=j[0];for(let ge=1;ge<j.length;ge++){const ke=j[ge];ne(ke,le)>=0&&(le=ke)}return le}e.findLastMaxBy=Y;function se(j,ne){return H(j,(le,ge)=>-ne(le,ge))}e.findMinBy=se;class K{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let le=this.firstIdx;for(;le<this.items.length&&ne(this.items[le]);)le++;const ge=le===this.firstIdx?null:this.items.slice(this.firstIdx,le);return this.firstIdx=le,ge}takeFromEndWhile(ne){let le=this.lastIdx;for(;le>=0&&ne(this.items[le]);)le--;const ge=le===this.lastIdx?null:this.items.slice(le+1,this.lastIdx+1);return this.lastIdx=le,ge}peek(){return this.items[this.firstIdx]}dequeue(){const ne=this.items[this.firstIdx];return this.firstIdx++,ne}takeCount(ne){const le=this.items.slice(this.firstIdx,this.firstIdx+ne);return this.firstIdx+=ne,le}}e.ArrayQueue=K}),define(ve[76],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(i){const k=this;let _=!1,T;return function(){return _||(_=!0,T=i.apply(k,arguments)),T}}e.once=f}),define(ve[77],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(ve[78],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(i){function k(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}i.is=k;const _=Object.freeze([]);function T(){return _}i.empty=T;function*I(m){yield m}i.single=I;function C(m){return m||_}i.from=C;function P(m){return!m||m[Symbol.iterator]().next().done===!0}i.isEmpty=P;function R(m){return m[Symbol.iterator]().next().value}i.first=R;function y(m,a){for(const E of m)if(a(E))return!0;return!1}i.some=y;function c(m,a){for(const E of m)if(a(E))return E}i.find=c;function*b(m,a){for(const E of m)a(E)&&(yield E)}i.filter=b;function*v(m,a){let E=0;for(const n of m)yield a(n,E++)}i.map=v;function*p(...m){for(const a of m)for(const E of a)yield E}i.concat=p;function*w(m){for(const a of m)for(const E of a)yield E}i.concatNested=w;function L(m,a,E){let n=E;for(const t of m)n=a(n,t);return n}i.reduce=L;function*S(m,a,E=m.length){for(a<0&&(a+=m.length),E<0?E+=m.length:E>m.length&&(E=m.length);a<E;a++)yield m[a]}i.slice=S;function o(m,a=Number.POSITIVE_INFINITY){const E=[];if(a===0)return[E,m];const n=m[Symbol.iterator]();for(let t=0;t<a;t++){const s=n.next();if(s.done)return[E,i.empty()];E.push(s.value)}return[E,{[Symbol.iterator](){return n}}]}i.consume=o;function r(m,a,E=(n,t)=>n===t){const n=m[Symbol.iterator](),t=a[Symbol.iterator]();for(;;){const s=n.next(),u=t.next();if(s.done!==u.done)return!1;if(s.done)return!0;if(!E(s.value,u.value))return!1}}i.equals=r})(f=e.Iterable||(e.Iterable={}))}),define(ve[58],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var i;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(a){a.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function T(a,E=!1){let n=0,t=a.length,s="",u=0,d=16,h=0;function g(O){let z=0,W=0;for(;z<O;){const M=a.charCodeAt(n);if(M>=48&&M<=57)W=W*16+M-48;else if(M>=65&&M<=70)W=W*16+M-65+10;else if(M>=97&&M<=102)W=W*16+M-97+10;else break;n++,z++}return z<O&&(W=-1),W}function l(O){n=O,s="",u=0,d=16,h=0}function D(){const O=n;if(a.charCodeAt(n)===48)n++;else for(n++;n<a.length&&P(a.charCodeAt(n));)n++;if(n<a.length&&a.charCodeAt(n)===46)if(n++,n<a.length&&P(a.charCodeAt(n)))for(n++;n<a.length&&P(a.charCodeAt(n));)n++;else return h=3,a.substring(O,n);let z=n;if(n<a.length&&(a.charCodeAt(n)===69||a.charCodeAt(n)===101))if(n++,(n<a.length&&a.charCodeAt(n)===43||a.charCodeAt(n)===45)&&n++,n<a.length&&P(a.charCodeAt(n))){for(n++;n<a.length&&P(a.charCodeAt(n));)n++;z=n}else h=3;return a.substring(O,z)}function A(){let O="",z=n;for(;;){if(n>=t){O+=a.substring(z,n),h=2;break}const W=a.charCodeAt(n);if(W===34){O+=a.substring(z,n),n++;break}if(W===92){if(O+=a.substring(z,n),n++,n>=t){h=2;break}switch(a.charCodeAt(n++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const x=g(4);x>=0?O+=String.fromCharCode(x):h=4;break}default:h=5}z=n;continue}if(W>=0&&W<=31)if(C(W)){O+=a.substring(z,n),h=2;break}else h=6;n++}return O}function N(){if(s="",h=0,u=n,n>=t)return u=t,d=17;let O=a.charCodeAt(n);if(I(O)){do n++,s+=String.fromCharCode(O),O=a.charCodeAt(n);while(I(O));return d=15}if(C(O))return n++,s+=String.fromCharCode(O),O===13&&a.charCodeAt(n)===10&&(n++,s+=`
`),d=14;switch(O){case 123:return n++,d=1;case 125:return n++,d=2;case 91:return n++,d=3;case 93:return n++,d=4;case 58:return n++,d=6;case 44:return n++,d=5;case 34:return n++,s=A(),d=10;case 47:{const z=n-1;if(a.charCodeAt(n+1)===47){for(n+=2;n<t&&!C(a.charCodeAt(n));)n++;return s=a.substring(z,n),d=12}if(a.charCodeAt(n+1)===42){n+=2;const W=t-1;let M=!1;for(;n<W;){if(a.charCodeAt(n)===42&&a.charCodeAt(n+1)===47){n+=2,M=!0;break}n++}return M||(n++,h=1),s=a.substring(z,n),d=13}return s+=String.fromCharCode(O),n++,d=16}case 45:if(s+=String.fromCharCode(O),n++,n===t||!P(a.charCodeAt(n)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=D(),d=11;default:for(;n<t&&B(O);)n++,O=a.charCodeAt(n);if(u!==n){switch(s=a.substring(u,n),s){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return s+=String.fromCharCode(O),n++,d=16}}function B(O){if(I(O)||C(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:l,getPosition:()=>n,scan:E?F:N,getToken:()=>d,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>n-u,getTokenError:()=>h}}e.createScanner=T;function I(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function C(a){return a===10||a===13||a===8232||a===8233}function P(a){return a>=48&&a<=57}var R;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(R||(R={}));function y(a,E){const n=[],t=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function h(g,l,D,A){u.value=g,u.offset=l,u.length=D,u.type=A,u.colonOffset=void 0,s=u}try{o(a,{onObjectBegin:(g,l)=>{if(E<=g)throw t;s=void 0,d=E>g,n.push("")},onObjectProperty:(g,l,D)=>{if(E<l||(h(g,l,D,"property"),n[n.length-1]=g,E<=l+D))throw t},onObjectEnd:(g,l)=>{if(E<=g)throw t;s=void 0,n.pop()},onArrayBegin:(g,l)=>{if(E<=g)throw t;s=void 0,n.push(0)},onArrayEnd:(g,l)=>{if(E<=g)throw t;s=void 0,n.pop()},onLiteralValue:(g,l,D)=>{if(E<l||(h(g,l,D,m(g)),E<=l+D))throw t},onSeparator:(g,l,D)=>{if(E<=l)throw t;if(g===":"&&s&&s.type==="property")s.colonOffset=l,d=!1,s=void 0;else if(g===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(d=!0,n[n.length-1]=""),s=void 0}}})}catch(g){if(g!==t)throw g}return{path:n,previousNode:s,isAtPropertyKey:d,matches:g=>{let l=0;for(let D=0;l<g.length&&D<n.length;D++)if(g[l]===n[D]||g[l]==="*")l++;else if(g[l]!=="**")return!1;return l===g.length}}}e.getLocation=y;function c(a,E=[],n=_.DEFAULT){let t=null,s=[];const u=[];function d(g){Array.isArray(s)?s.push(g):t!==null&&(s[t]=g)}return o(a,{onObjectBegin:()=>{const g={};d(g),u.push(s),s=g,t=null},onObjectProperty:g=>{t=g},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const g=[];d(g),u.push(s),s=g,t=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:d,onError:(g,l,D)=>{E.push({error:g,offset:l,length:D})}},n),s[0]}e.parse=c;function b(a,E=[],n=_.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(g){t.type==="property"&&(t.length=g-t.offset,t=t.parent)}function u(g){return t.children.push(g),g}o(a,{onObjectBegin:g=>{t=u({type:"object",offset:g,length:-1,parent:t,children:[]})},onObjectProperty:(g,l,D)=>{t=u({type:"property",offset:l,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:g,offset:l,length:D,parent:t})},onObjectEnd:(g,l)=>{t.length=g+l-t.offset,t=t.parent,s(g+l)},onArrayBegin:(g,l)=>{t=u({type:"array",offset:g,length:-1,parent:t,children:[]})},onArrayEnd:(g,l)=>{t.length=g+l-t.offset,t=t.parent,s(g+l)},onLiteralValue:(g,l,D)=>{u({type:m(g),offset:l,length:D,parent:t,value:g}),s(l+D)},onSeparator:(g,l,D)=>{t.type==="property"&&(g===":"?t.colonOffset=l:g===","&&s(l))},onError:(g,l,D)=>{E.push({error:g,offset:l,length:D})}},n);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=b;function v(a,E){if(!a)return;let n=a;for(let t of E)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const u of n.children)if(Array.isArray(u.children)&&u.children[0].value===t){n=u.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=v;function p(a){if(!a.parent||!a.parent.children)return[];const E=p(a.parent);if(a.parent.type==="property"){const n=a.parent.children[0].value;E.push(n)}else if(a.parent.type==="array"){const n=a.parent.children.indexOf(a);n!==-1&&E.push(n)}return E}e.getNodePath=p;function w(a){switch(a.type){case"array":return a.children.map(w);case"object":{const E=Object.create(null);for(let n of a.children){const t=n.children[1];t&&(E[n.children[0].value]=w(t))}return E}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=w;function L(a,E,n=!1){return E>=a.offset&&E<a.offset+a.length||n&&E===a.offset+a.length}e.contains=L;function S(a,E,n=!1){if(L(a,E,n)){const t=a.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=E;s++){const u=S(t[s],E,n);if(u)return u}return a}}e.findNodeAtOffset=S;function o(a,E,n=_.DEFAULT){const t=T(a,!1);function s(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function u(K){return K?j=>K(j,t.getTokenOffset(),t.getTokenLength()):()=>!0}const d=s(E.onObjectBegin),h=u(E.onObjectProperty),g=s(E.onObjectEnd),l=s(E.onArrayBegin),D=s(E.onArrayEnd),A=u(E.onLiteralValue),N=u(E.onSeparator),B=s(E.onComment),F=u(E.onError),O=n&&n.disallowComments,z=n&&n.allowTrailingComma;function W(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:O||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(K){case 12:case 13:O?M(10):B();break;case 16:M(1);break;case 15:case 14:break;default:return K}}}function M(K,j=[],ne=[]){if(F(K),j.length+ne.length>0){let le=t.getToken();for(;le!==17;){if(j.indexOf(le)!==-1){W();break}else if(ne.indexOf(le)!==-1)break;le=W()}}}function x(K){const j=t.getTokenValue();return K?A(j):h(j),W(),!0}function V(){switch(t.getToken()){case 11:{let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(M(2),K=0)}catch{M(2)}A(K);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return W(),!0}function U(){return t.getToken()!==10?(M(3,[],[2,5]),!1):(x(!1),t.getToken()===6?(N(":"),W(),se()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function H(){d(),W();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||M(4,[],[]),N(","),W(),t.getToken()===2&&z)break}else K&&M(6,[],[]);U()||M(4,[],[2,5]),K=!0}return g(),t.getToken()!==2?M(7,[2],[]):W(),!0}function Y(){l(),W();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||M(4,[],[]),N(","),W(),t.getToken()===4&&z)break}else K&&M(6,[],[]);se()||M(4,[],[4,5]),K=!0}return D(),t.getToken()!==4?M(8,[4],[]):W(),!0}function se(){switch(t.getToken()){case 3:return Y();case 1:return H();case 10:return x(!0);default:return V()}}return W(),t.getToken()===17?n.allowEmptyContent?!0:(M(4,[],[]),!1):se()?(t.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=o;function r(a,E){let n=T(a),t=[],s,u=0,d;do switch(d=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:u!==d&&t.push(a.substring(u,d)),E!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,E)),u=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=r;function m(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(ve[139],we([0,1,58]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(P,R,y){let c,b,v,p,w;if(R){for(p=R.offset,w=p+R.length,v=p;v>0&&!C(P,v-1);)v--;let d=w;for(;d<P.length&&!C(P,d);)d++;b=P.substring(v,d),c=T(b,y)}else b=P,c=0,v=0,p=0,w=P.length;const L=I(y,P);let S=!1,o=0,r;y.insertSpaces?r=_(" ",y.tabSize||4):r="	";const m=(0,f.createScanner)(b,!1);let a=!1;function E(){return L+_(r,c+o)}function n(){let d=m.scan();for(S=!1;d===15||d===14;)S=S||d===14,d=m.scan();return a=d===16||m.getTokenError()!==0,d}const t=[];function s(d,h,g){!a&&h<w&&g>p&&P.substring(h,g)!==d&&t.push({offset:h,length:g-h,content:d})}let u=n();if(u!==17){const d=m.getTokenOffset()+v,h=_(r,c);s(h,v,d)}for(;u!==17;){let d=m.getTokenOffset()+m.getTokenLength()+v,h=n(),g="";for(;!S&&(h===12||h===13);){const D=m.getTokenOffset()+v;s(" ",d,D),d=m.getTokenOffset()+m.getTokenLength()+v,g=h===12?E():"",h=n()}if(h===2)u!==1&&(o--,g=E());else if(h===4)u!==3&&(o--,g=E());else{switch(u){case 3:case 1:o++,g=E();break;case 5:case 12:g=E();break;case 13:S?g=E():g=" ";break;case 6:g=" ";break;case 10:if(h===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?g=" ":h!==5&&h!==17&&(a=!0);break;case 16:a=!0;break}S&&(h===12||h===13)&&(g=E())}const l=m.getTokenOffset()+v;s(g,d,l),u=h}return t}e.format=i;function k(P,R){const y=JSON.stringify(P,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?y.replace(/\r\n|\r|\n/g,R.eol):y}e.toFormattedString=k;function _(P,R){let y="";for(let c=0;c<R;c++)y+=P;return y}function T(P,R){let y=0,c=0;const b=R.tabSize||4;for(;y<P.length;){const v=P.charAt(y);if(v===" ")c++;else if(v==="	")c+=b;else break;y++}return Math.floor(c/b)}function I(P,R){for(let y=0;y<R.length;y++){const c=R.charAt(y);if(c==="\r")return y+1<R.length&&R.charAt(y+1)===`
`?`\r
`:"\r";if(c===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=I;function C(P,R){return`\r
`.indexOf(P.charAt(R))!==-1}e.isEOL=C}),define(ve[140],we([0,1,58,139]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(P,R,y){return _(P,R,void 0,y)}e.removeProperty=k;function _(P,R,y,c,b){const v=R.slice(),p=[],w=(0,f.parseTree)(P,p);let L,S;for(;v.length>0&&(S=v.pop(),L=(0,f.findNodeAtLocation)(w,v),L===void 0&&y!==void 0);)typeof S=="string"?y={[S]:y}:y=[y];if(L)if(L.type==="object"&&typeof S=="string"&&Array.isArray(L.children)){const o=(0,f.findNodeAtLocation)(L,[S]);if(o!==void 0)if(y===void 0){if(!o.parent)throw new Error("Malformed AST");const r=L.children.indexOf(o.parent);let m,a=o.parent.offset+o.parent.length;if(r>0){const E=L.children[r-1];m=E.offset+E.length}else m=L.offset+1,L.children.length>1&&(a=L.children[1].offset);return T(P,{offset:m,length:a-m,content:""},c)}else return T(P,{offset:o.offset,length:o.length,content:JSON.stringify(y)},c);else{if(y===void 0)return[];const r=`${JSON.stringify(S)}: ${JSON.stringify(y)}`,m=b?b(L.children.map(E=>E.children[0].value)):L.children.length;let a;if(m>0){const E=L.children[m-1];a={offset:E.offset+E.length,length:0,content:","+r}}else L.children.length===0?a={offset:L.offset+1,length:0,content:r}:a={offset:L.offset+1,length:0,content:r+","};return T(P,a,c)}}else if(L.type==="array"&&typeof S=="number"&&Array.isArray(L.children))if(y!==void 0){const o=`${JSON.stringify(y)}`;let r;if(L.children.length===0||S===0)r={offset:L.offset+1,length:0,content:L.children.length===0?o:o+","};else{const m=S===-1||S>L.children.length?L.children.length:S,a=L.children[m-1];r={offset:a.offset+a.length,length:0,content:","+o}}return T(P,r,c)}else{const o=S,r=L.children[o];let m;if(L.children.length===1)m={offset:L.offset+1,length:L.length-2,content:""};else if(L.children.length-1===o){const a=L.children[o-1],E=a.offset+a.length,n=L.offset+L.length;m={offset:E,length:n-2-E,content:""}}else m={offset:r.offset,length:L.children[o+1].offset-r.offset,content:""};return T(P,m,c)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${L.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return T(P,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(y)},c)}}e.setProperty=_;function T(P,R,y){let c=I(P,R),b=R.offset,v=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;b>0&&!(0,i.isEOL)(c,b-1);)b--;for(;v<c.length&&!(0,i.isEOL)(c,v);)v++}const p=(0,i.format)(c,{offset:b,length:v-b},y);for(let L=p.length-1;L>=0;L--){const S=p[L];c=I(c,S),b=Math.min(b,S.offset),v=Math.max(v,S.offset+S.length),v+=S.content.length-S.length}const w=P.length-(c.length-v)-b;return[{offset:b,length:w,content:c.substring(b,v)}]}e.withFormatting=T;function I(P,R){return P.substring(0,R.offset)+R.content+P.substring(R.offset+R.length)}e.applyEdit=I;function C(P,R){let y=R.slice(0).sort((b,v)=>{const p=b.offset-v.offset;return p===0?b.length-v.length:p}),c=P.length;for(let b=y.length-1;b>=0;b--){let v=y[b];if(v.offset+v.length<=c)P=I(P,v);else throw new Error("Overlapping edit");c=v.offset}return P}e.applyEdits=C}),define(ve[93],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new f(()=>k(this.getValue()))}}e.Lazy=f}),define(ve[6],we([0,1,76,78]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let _=null;function T(t){_=t}if(e.setDisposableTracker=T,k){const t="__is_disposable_tracked__";T(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==S.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==S.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function I(t){return _?.trackDisposable(t),t}function C(t){_?.markAsDisposed(t)}function P(t,s){_?.setParent(t,s)}function R(t,s){if(!!_)for(const u of t)_.setParent(u,s)}function y(t){return _?.markAsSingleton(t),t}e.markAsSingleton=y;class c extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=c;function b(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=b;function v(t){if(i.Iterable.is(t)){let s=[];for(const u of t)if(u)try{u.dispose()}catch(d){s.push(d)}if(s.length===1)throw s[0];if(s.length>1)throw new c(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=v;function p(...t){const s=w(()=>v(t));return R(t,s),s}e.combinedDisposable=p;function w(t){const s=I({dispose:(0,f.once)(()=>{C(s),t()})});return s}e.toDisposable=w;class L{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return P(s,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=L,L.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new L,I(this),P(this._store,this)}dispose(){C(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&P(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&P(s,null),s}}e.MutableDisposable=o;class r{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class m{constructor(){this.references=new Map}acquire(s,...u){let d=this.references.get(s);d||(d={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,d));const{object:h}=d,g=(0,f.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(s,d.object),this.references.delete(s))});return d.counter++,{object:h,dispose:g}}}e.ReferenceCollection=m;class a{constructor(s){this.referenceCollection=s}async acquire(s,...u){const d=this.referenceCollection.acquire(s,...u);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(h){throw d.dispose(),h}}}e.AsyncReferenceCollection=a;class E{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=E;function n(t){const s=new L;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(ve[94],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(_){this.element=_,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class i{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let _=this._first;for(;_!==f.Undefined;){const T=_.next;_.prev=f.Undefined,_.next=f.Undefined,_=T}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,T){const I=new f(_);if(this._first===f.Undefined)this._first=I,this._last=I;else if(T){const P=this._last;this._last=I,I.prev=P,P.next=I}else{const P=this._first;this._first=I,I.next=P,P.prev=I}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(I))}}shift(){if(this._first!==f.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==f.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==f.Undefined&&_.next!==f.Undefined){const T=_.prev;T.next=_.next,_.next.prev=T}else _.prev===f.Undefined&&_.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):_.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):_.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==f.Undefined;)yield _.element,_=_.next}}e.LinkedList=i}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(Ae,Te){for(var De=0;De<Te.length;De++){var oe=Te[De];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Ae,oe.key,oe)}}function e(Ae,Te,De){return Te&&X(Ae.prototype,Te),De&&X(Ae,De),Ae}function f(Ae,Te){if(!!Ae){if(typeof Ae=="string")return i(Ae,Te);var De=Object.prototype.toString.call(Ae).slice(8,-1);if(De==="Object"&&Ae.constructor&&(De=Ae.constructor.name),De==="Map"||De==="Set")return Array.from(Ae);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return i(Ae,Te)}}function i(Ae,Te){(Te==null||Te>Ae.length)&&(Te=Ae.length);for(var De=0,oe=new Array(Te);De<Te;De++)oe[De]=Ae[De];return oe}function k(Ae,Te){var De=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(De)return(De=De.call(Ae)).next.bind(De);if(Array.isArray(Ae)||(De=f(Ae))||Te&&Ae&&typeof Ae.length=="number"){De&&(Ae=De);var oe=0;return function(){return oe>=Ae.length?{done:!0}:{done:!1,value:Ae[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var _={exports:{}};function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Ae){_.exports.defaults=Ae}_.exports={defaults:T(),getDefaults:T,changeDefaults:I};var C=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Te){return c[Te]};function v(Ae,Te){if(Te){if(C.test(Ae))return Ae.replace(P,b)}else if(R.test(Ae))return Ae.replace(y,b);return Ae}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(Ae){return Ae.replace(p,function(Te,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var L=/(^|[^\[])\^/g;function S(Ae,Te){Ae=Ae.source||Ae,Te=Te||"";var De={replace:function(me,be){return be=be.source||be,be=be.replace(L,"$1"),Ae=Ae.replace(me,be),De},getRegex:function(){return new RegExp(Ae,Te)}};return De}var o=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Ae,Te,De){if(Ae){var oe;try{oe=decodeURIComponent(w(De)).replace(o,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Te&&!r.test(De)&&(De=s(Te,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var a={},E=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Ae,Te){a[" "+Ae]||(E.test(Ae)?a[" "+Ae]=Ae+"/":a[" "+Ae]=g(Ae,"/",!0)),Ae=a[" "+Ae];var De=Ae.indexOf(":")===-1;return Te.substring(0,2)==="//"?De?Te:Ae.replace(n,"$1")+Te:Te.charAt(0)==="/"?De?Te:Ae.replace(t,"$1")+Te:Ae+Te}var u={exec:function(){}};function d(Ae){for(var Te=1,De,oe;Te<arguments.length;Te++){De=arguments[Te];for(oe in De)Object.prototype.hasOwnProperty.call(De,oe)&&(Ae[oe]=De[oe])}return Ae}function h(Ae,Te){var De=Ae.replace(/\|/g,function(be,_e,Ne){for(var Qe=!1,$e=_e;--$e>=0&&Ne[$e]==="\\";)Qe=!Qe;return Qe?"|":" |"}),oe=De.split(/ \|/),me=0;if(oe[0].trim()||oe.shift(),oe[oe.length-1].trim()||oe.pop(),oe.length>Te)oe.splice(Te);else for(;oe.length<Te;)oe.push("");for(;me<oe.length;me++)oe[me]=oe[me].trim().replace(/\\\|/g,"|");return oe}function g(Ae,Te,De){var oe=Ae.length;if(oe===0)return"";for(var me=0;me<oe;){var be=Ae.charAt(oe-me-1);if(be===Te&&!De)me++;else if(be!==Te&&De)me++;else break}return Ae.substr(0,oe-me)}function l(Ae,Te){if(Ae.indexOf(Te[1])===-1)return-1;for(var De=Ae.length,oe=0,me=0;me<De;me++)if(Ae[me]==="\\")me++;else if(Ae[me]===Te[0])oe++;else if(Ae[me]===Te[1]&&(oe--,oe<0))return me;return-1}function D(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Ae,Te){if(Te<1)return"";for(var De="";Te>1;)Te&1&&(De+=Ae),Te>>=1,Ae+=Ae;return De+Ae}var N={escape:v,unescape:w,edit:S,cleanUrl:m,resolveUrl:s,noopTest:u,merge:d,splitCells:h,rtrim:g,findClosingBracket:l,checkSanitizeDeprecation:D,repeatString:A},B=_.exports.defaults,F=N.rtrim,O=N.splitCells,z=N.escape,W=N.findClosingBracket;function M(Ae,Te,De,oe){var me=Te.href,be=Te.title?z(Te.title):null,_e=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){oe.state.inLink=!0;var Ne={type:"link",raw:De,href:me,title:be,text:_e,tokens:oe.inlineTokens(_e,[])};return oe.state.inLink=!1,Ne}else return{type:"image",raw:De,href:me,title:be,text:z(_e)}}function x(Ae,Te){var De=Ae.match(/^(\s+)(?:```)/);if(De===null)return Te;var oe=De[1];return Te.split(`
`).map(function(me){var be=me.match(/^\s+/);if(be===null)return me;var _e=be[0];return _e.length>=oe.length?me.slice(oe.length):me}).join(`
`)}var V=function(){function Ae(De){this.options=De||B}var Te=Ae.prototype;return Te.space=function(oe){var me=this.rules.block.newline.exec(oe);if(me)return me[0].length>1?{type:"space",raw:me[0]}:{raw:`
`}},Te.code=function(oe){var me=this.rules.block.code.exec(oe);if(me){var be=me[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:me[0],codeBlockStyle:"indented",text:this.options.pedantic?be:F(be,`
`)}}},Te.fences=function(oe){var me=this.rules.block.fences.exec(oe);if(me){var be=me[0],_e=x(be,me[3]||"");return{type:"code",raw:be,lang:me[2]?me[2].trim():me[2],text:_e}}},Te.heading=function(oe){var me=this.rules.block.heading.exec(oe);if(me){var be=me[2].trim();if(/#$/.test(be)){var _e=F(be,"#");(this.options.pedantic||!_e||/ $/.test(_e))&&(be=_e.trim())}var Ne={type:"heading",raw:me[0],depth:me[1].length,text:be,tokens:[]};return this.lexer.inline(Ne.text,Ne.tokens),Ne}},Te.hr=function(oe){var me=this.rules.block.hr.exec(oe);if(me)return{type:"hr",raw:me[0]}},Te.blockquote=function(oe){var me=this.rules.block.blockquote.exec(oe);if(me){var be=me[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:me[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},Te.list=function(oe){var me=this.rules.block.list.exec(oe);if(me){var be,_e,Ne,Qe,$e,Xe,st,ot,fe,ye,de=me[1].trim(),Q=de.length>1,Ie={type:"list",raw:"",ordered:Q,start:Q?+de.slice(0,-1):"",loose:!1,items:[]};de=Q?"\\d{1,9}\\"+de.slice(-1):"\\"+de,this.options.pedantic&&(de=Q?de:"[*+-]");for(var Oe=new RegExp("^( {0,3}"+de+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");oe&&!(this.rules.block.hr.test(oe)||!(me=Oe.exec(oe)));){fe=me[2].split(`
`),this.options.pedantic?(Qe=2,ye=fe[0].trimLeft()):(Qe=me[2].search(/[^ ]/),Qe=me[1].length+(Qe>4?1:Qe),ye=fe[0].slice(Qe-me[1].length)),Xe=!1,be=me[0],!fe[0]&&/^ *$/.test(fe[1])&&(be=me[1]+fe.slice(0,2).join(`
`)+`
`,Ie.loose=!0,fe=[]);var Ze=new RegExp("^ {0,"+Math.min(3,Qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<fe.length;$e++){if(ot=fe[$e],this.options.pedantic&&(ot=ot.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ze.test(ot)){be=me[1]+fe.slice(0,$e).join(`
`)+`
`;break}if(!Xe){ot.trim()||(Xe=!0),ot.search(/[^ ]/)>=Qe?ye+=`
`+ot.slice(Qe):ye+=`
`+ot;continue}if(ot.search(/[^ ]/)>=Qe||!ot.trim()){ye+=`
`+ot.slice(Qe);continue}else{be=me[1]+fe.slice(0,$e).join(`
`)+`
`;break}}Ie.loose||(st?Ie.loose=!0:/\n *\n *$/.test(be)&&(st=!0)),this.options.gfm&&(_e=/^\[[ xX]\] /.exec(ye),_e&&(Ne=_e[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:be,task:!!_e,checked:Ne,loose:!1,text:ye}),Ie.raw+=be,oe=oe.slice(be.length)}Ie.items[Ie.items.length-1].raw=be.trimRight(),Ie.items[Ie.items.length-1].text=ye.trimRight(),Ie.raw=Ie.raw.trimRight();var je=Ie.items.length;for($e=0;$e<je;$e++)this.lexer.state.top=!1,Ie.items[$e].tokens=this.lexer.blockTokens(Ie.items[$e].text,[]),Ie.items[$e].tokens.some(function(ht){return ht.type==="space"})&&(Ie.loose=!0,Ie.items[$e].loose=!0);return Ie}},Te.html=function(oe){var me=this.rules.block.html.exec(oe);if(me){var be={type:"html",raw:me[0],pre:!this.options.sanitizer&&(me[1]==="pre"||me[1]==="script"||me[1]==="style"),text:me[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(me[0]):z(me[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},Te.def=function(oe){var me=this.rules.block.def.exec(oe);if(me){me[3]&&(me[3]=me[3].substring(1,me[3].length-1));var be=me[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:me[0],href:me[2],title:me[3]}}},Te.table=function(oe){var me=this.rules.block.table.exec(oe);if(me){var be={type:"table",header:O(me[1]).map(function(st){return{text:st}}),align:me[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:me[3]?me[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=me[0];var _e=be.align.length,Ne,Qe,$e,Xe;for(Ne=0;Ne<_e;Ne++)/^ *-+: *$/.test(be.align[Ne])?be.align[Ne]="right":/^ *:-+: *$/.test(be.align[Ne])?be.align[Ne]="center":/^ *:-+ *$/.test(be.align[Ne])?be.align[Ne]="left":be.align[Ne]=null;for(_e=be.rows.length,Ne=0;Ne<_e;Ne++)be.rows[Ne]=O(be.rows[Ne],be.header.length).map(function(st){return{text:st}});for(_e=be.header.length,Qe=0;Qe<_e;Qe++)be.header[Qe].tokens=[],this.lexer.inlineTokens(be.header[Qe].text,be.header[Qe].tokens);for(_e=be.rows.length,Qe=0;Qe<_e;Qe++)for(Xe=be.rows[Qe],$e=0;$e<Xe.length;$e++)Xe[$e].tokens=[],this.lexer.inlineTokens(Xe[$e].text,Xe[$e].tokens);return be}}},Te.lheading=function(oe){var me=this.rules.block.lheading.exec(oe);if(me){var be={type:"heading",raw:me[0],depth:me[2].charAt(0)==="="?1:2,text:me[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Te.paragraph=function(oe){var me=this.rules.block.paragraph.exec(oe);if(me){var be={type:"paragraph",raw:me[0],text:me[1].charAt(me[1].length-1)===`
`?me[1].slice(0,-1):me[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Te.text=function(oe){var me=this.rules.block.text.exec(oe);if(me){var be={type:"text",raw:me[0],text:me[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Te.escape=function(oe){var me=this.rules.inline.escape.exec(oe);if(me)return{type:"escape",raw:me[0],text:z(me[1])}},Te.tag=function(oe){var me=this.rules.inline.tag.exec(oe);if(me)return!this.lexer.state.inLink&&/^<a /i.test(me[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(me[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):z(me[0]):me[0]}},Te.link=function(oe){var me=this.rules.inline.link.exec(oe);if(me){var be=me[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var _e=F(be.slice(0,-1),"\\");if((be.length-_e.length)%2==0)return}else{var Ne=W(me[2],"()");if(Ne>-1){var Qe=me[0].indexOf("!")===0?5:4,$e=Qe+me[1].length+Ne;me[2]=me[2].substring(0,Ne),me[0]=me[0].substring(0,$e).trim(),me[3]=""}}var Xe=me[2],st="";if(this.options.pedantic){var ot=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Xe);ot&&(Xe=ot[1],st=ot[3])}else st=me[3]?me[3].slice(1,-1):"";return Xe=Xe.trim(),/^</.test(Xe)&&(this.options.pedantic&&!/>$/.test(be)?Xe=Xe.slice(1):Xe=Xe.slice(1,-1)),M(me,{href:Xe&&Xe.replace(this.rules.inline._escapes,"$1"),title:st&&st.replace(this.rules.inline._escapes,"$1")},me[0],this.lexer)}},Te.reflink=function(oe,me){var be;if((be=this.rules.inline.reflink.exec(oe))||(be=this.rules.inline.nolink.exec(oe))){var _e=(be[2]||be[1]).replace(/\s+/g," ");if(_e=me[_e.toLowerCase()],!_e||!_e.href){var Ne=be[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return M(be,_e,be[0],this.lexer)}},Te.emStrong=function(oe,me,be){be===void 0&&(be="");var _e=this.rules.inline.emStrong.lDelim.exec(oe);if(!!_e&&!(_e[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=_e[1]||_e[2]||"";if(!Ne||Ne&&(be===""||this.rules.inline.punctuation.exec(be))){var Qe=_e[0].length-1,$e,Xe,st=Qe,ot=0,fe=_e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(fe.lastIndex=0,me=me.slice(-1*oe.length+Qe);(_e=fe.exec(me))!=null;)if($e=_e[1]||_e[2]||_e[3]||_e[4]||_e[5]||_e[6],!!$e){if(Xe=$e.length,_e[3]||_e[4]){st+=Xe;continue}else if((_e[5]||_e[6])&&Qe%3&&!((Qe+Xe)%3)){ot+=Xe;continue}if(st-=Xe,!(st>0)){if(Xe=Math.min(Xe,Xe+st+ot),Math.min(Qe,Xe)%2){var ye=oe.slice(1,Qe+_e.index+Xe);return{type:"em",raw:oe.slice(0,Qe+_e.index+Xe+1),text:ye,tokens:this.lexer.inlineTokens(ye,[])}}var de=oe.slice(2,Qe+_e.index+Xe-1);return{type:"strong",raw:oe.slice(0,Qe+_e.index+Xe+1),text:de,tokens:this.lexer.inlineTokens(de,[])}}}}}},Te.codespan=function(oe){var me=this.rules.inline.code.exec(oe);if(me){var be=me[2].replace(/\n/g," "),_e=/[^ ]/.test(be),Ne=/^ /.test(be)&&/ $/.test(be);return _e&&Ne&&(be=be.substring(1,be.length-1)),be=z(be,!0),{type:"codespan",raw:me[0],text:be}}},Te.br=function(oe){var me=this.rules.inline.br.exec(oe);if(me)return{type:"br",raw:me[0]}},Te.del=function(oe){var me=this.rules.inline.del.exec(oe);if(me)return{type:"del",raw:me[0],text:me[2],tokens:this.lexer.inlineTokens(me[2],[])}},Te.autolink=function(oe,me){var be=this.rules.inline.autolink.exec(oe);if(be){var _e,Ne;return be[2]==="@"?(_e=z(this.options.mangle?me(be[1]):be[1]),Ne="mailto:"+_e):(_e=z(be[1]),Ne=_e),{type:"link",raw:be[0],text:_e,href:Ne,tokens:[{type:"text",raw:_e,text:_e}]}}},Te.url=function(oe,me){var be;if(be=this.rules.inline.url.exec(oe)){var _e,Ne;if(be[2]==="@")_e=z(this.options.mangle?me(be[0]):be[0]),Ne="mailto:"+_e;else{var Qe;do Qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Qe!==be[0]);_e=z(be[0]),be[1]==="www."?Ne="http://"+_e:Ne=_e}return{type:"link",raw:be[0],text:_e,href:Ne,tokens:[{type:"text",raw:_e,text:_e}]}}},Te.inlineText=function(oe,me){var be=this.rules.inline.text.exec(oe);if(be){var _e;return this.lexer.state.inRawBlock?_e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):z(be[0]):be[0]:_e=z(this.options.smartypants?me(be[0]):be[0]),{type:"text",raw:be[0],text:_e}}},Ae}(),U=N.noopTest,H=N.edit,Y=N.merge,se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=H(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=H(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=H(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=H(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=H(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=H(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=Y({},se),se.gfm=Y({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=H(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=Y({},se.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:H(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=H(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=H(se._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=H(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=H(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=H(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=H(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=H(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=H(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=H(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=H(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=Y({},K),K.pedantic=Y({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=Y({},K.normal,{escape:H(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),K.gfm.url=H(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=Y({},K.gfm,{br:H(K.br).replace("{2,}","*").getRegex(),text:H(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var j={block:se,inline:K},ne=V,le=_.exports.defaults,ge=j.block,ke=j.inline,Me=N.repeatString;function Ue(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Ae){var Te="",De,oe,me=Ae.length;for(De=0;De<me;De++)oe=Ae.charCodeAt(De),Math.random()>.5&&(oe="x"+oe.toString(16)),Te+="&#"+oe+";";return Te}var J=function(){function Ae(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||le,this.options.tokenizer=this.options.tokenizer||new ne,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:ge.normal,inline:ke.normal};this.options.pedantic?(oe.block=ge.pedantic,oe.inline=ke.pedantic):this.options.gfm&&(oe.block=ge.gfm,this.options.breaks?oe.inline=ke.breaks:oe.inline=ke.gfm),this.tokenizer.rules=oe}Ae.lex=function(oe,me){var be=new Ae(me);return be.lex(oe)},Ae.lexInline=function(oe,me){var be=new Ae(me);return be.inlineTokens(oe)};var Te=Ae.prototype;return Te.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens);for(var me;me=this.inlineQueue.shift();)this.inlineTokens(me.src,me.tokens);return this.tokens},Te.blockTokens=function(oe,me){var be=this;me===void 0&&(me=[]),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var _e,Ne,Qe,$e;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(st){return(_e=st.call({lexer:be},oe,me))?(oe=oe.substring(_e.raw.length),me.push(_e),!0):!1}))){if(_e=this.tokenizer.space(oe)){oe=oe.substring(_e.raw.length),_e.type&&me.push(_e);continue}if(_e=this.tokenizer.code(oe)){oe=oe.substring(_e.raw.length),Ne=me[me.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+_e.raw,Ne.text+=`
`+_e.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):me.push(_e);continue}if(_e=this.tokenizer.fences(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.heading(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.hr(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.blockquote(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.list(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.html(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.def(oe)){oe=oe.substring(_e.raw.length),Ne=me[me.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+_e.raw,Ne.text+=`
`+_e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[_e.tag]||(this.tokens.links[_e.tag]={href:_e.href,title:_e.title});continue}if(_e=this.tokenizer.table(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.lheading(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(Qe=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var st=1/0,ot=oe.slice(1),fe=void 0;be.options.extensions.startBlock.forEach(function(ye){fe=ye.call({lexer:this},ot),typeof fe=="number"&&fe>=0&&(st=Math.min(st,fe))}),st<1/0&&st>=0&&(Qe=oe.substring(0,st+1))}(),this.state.top&&(_e=this.tokenizer.paragraph(Qe))){Ne=me[me.length-1],$e&&Ne.type==="paragraph"?(Ne.raw+=`
`+_e.raw,Ne.text+=`
`+_e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):me.push(_e),$e=Qe.length!==oe.length,oe=oe.substring(_e.raw.length);continue}if(_e=this.tokenizer.text(oe)){oe=oe.substring(_e.raw.length),Ne=me[me.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+_e.raw,Ne.text+=`
`+_e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):me.push(_e);continue}if(oe){var Xe="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Xe);break}else throw new Error(Xe)}}return this.state.top=!0,me},Te.inline=function(oe,me){this.inlineQueue.push({src:oe,tokens:me})},Te.inlineTokens=function(oe,me){var be=this;me===void 0&&(me=[]);var _e,Ne,Qe,$e=oe,Xe,st,ot;if(this.tokens.links){var fe=Object.keys(this.tokens.links);if(fe.length>0)for(;(Xe=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)fe.includes(Xe[0].slice(Xe[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Xe.index)+"["+Me("a",Xe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Xe=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Xe.index)+"["+Me("a",Xe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Xe=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Xe.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(st||(ot=""),st=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(_e=de.call({lexer:be},oe,me))?(oe=oe.substring(_e.raw.length),me.push(_e),!0):!1}))){if(_e=this.tokenizer.escape(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.tag(oe)){oe=oe.substring(_e.raw.length),Ne=me[me.length-1],Ne&&_e.type==="text"&&Ne.type==="text"?(Ne.raw+=_e.raw,Ne.text+=_e.text):me.push(_e);continue}if(_e=this.tokenizer.link(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(_e.raw.length),Ne=me[me.length-1],Ne&&_e.type==="text"&&Ne.type==="text"?(Ne.raw+=_e.raw,Ne.text+=_e.text):me.push(_e);continue}if(_e=this.tokenizer.emStrong(oe,$e,ot)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.codespan(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.br(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.del(oe)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(_e=this.tokenizer.autolink(oe,q)){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(!this.state.inLink&&(_e=this.tokenizer.url(oe,q))){oe=oe.substring(_e.raw.length),me.push(_e);continue}if(Qe=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,Q=oe.slice(1),Ie=void 0;be.options.extensions.startInline.forEach(function(Oe){Ie=Oe.call({lexer:this},Q),typeof Ie=="number"&&Ie>=0&&(de=Math.min(de,Ie))}),de<1/0&&de>=0&&(Qe=oe.substring(0,de+1))}(),_e=this.tokenizer.inlineText(Qe,Ue)){oe=oe.substring(_e.raw.length),_e.raw.slice(-1)!=="_"&&(ot=_e.raw.slice(-1)),st=!0,Ne=me[me.length-1],Ne&&Ne.type==="text"?(Ne.raw+=_e.raw,Ne.text+=_e.text):me.push(_e);continue}if(oe){var ye="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return me},e(Ae,null,[{key:"rules",get:function(){return{block:ge,inline:ke}}}]),Ae}(),re=_.exports.defaults,he=N.cleanUrl,Z=N.escape,ce=function(){function Ae(De){this.options=De||re}var Te=Ae.prototype;return Te.code=function(oe,me,be){var _e=(me||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(oe,_e);Ne!=null&&Ne!==oe&&(be=!0,oe=Ne)}return oe=oe.replace(/\n$/,"")+`
`,_e?'<pre><code class="'+this.options.langPrefix+Z(_e,!0)+'">'+(be?oe:Z(oe,!0))+`</code></pre>
`:"<pre><code>"+(be?oe:Z(oe,!0))+`</code></pre>
`},Te.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Te.html=function(oe){return oe},Te.heading=function(oe,me,be,_e){return this.options.headerIds?"<h"+me+' id="'+this.options.headerPrefix+_e.slug(be)+'">'+oe+"</h"+me+`>
`:"<h"+me+">"+oe+"</h"+me+`>
`},Te.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Te.list=function(oe,me,be){var _e=me?"ol":"ul",Ne=me&&be!==1?' start="'+be+'"':"";return"<"+_e+Ne+`>
`+oe+"</"+_e+`>
`},Te.listitem=function(oe){return"<li>"+oe+`</li>
`},Te.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Te.paragraph=function(oe){return"<p>"+oe+`</p>
`},Te.table=function(oe,me){return me&&(me="<tbody>"+me+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+me+`</table>
`},Te.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Te.tablecell=function(oe,me){var be=me.header?"th":"td",_e=me.align?"<"+be+' align="'+me.align+'">':"<"+be+">";return _e+oe+"</"+be+`>
`},Te.strong=function(oe){return"<strong>"+oe+"</strong>"},Te.em=function(oe){return"<em>"+oe+"</em>"},Te.codespan=function(oe){return"<code>"+oe+"</code>"},Te.br=function(){return this.options.xhtml?"<br/>":"<br>"},Te.del=function(oe){return"<del>"+oe+"</del>"},Te.link=function(oe,me,be){if(oe=he(this.options.sanitize,this.options.baseUrl,oe),oe===null)return be;var _e='<a href="'+Z(oe)+'"';return me&&(_e+=' title="'+me+'"'),_e+=">"+be+"</a>",_e},Te.image=function(oe,me,be){if(oe=he(this.options.sanitize,this.options.baseUrl,oe),oe===null)return be;var _e='<img src="'+oe+'" alt="'+be+'"';return me&&(_e+=' title="'+me+'"'),_e+=this.options.xhtml?"/>":">",_e},Te.text=function(oe){return oe},Ae}(),Se=function(){function Ae(){}var Te=Ae.prototype;return Te.strong=function(oe){return oe},Te.em=function(oe){return oe},Te.codespan=function(oe){return oe},Te.del=function(oe){return oe},Te.html=function(oe){return oe},Te.text=function(oe){return oe},Te.link=function(oe,me,be){return""+be},Te.image=function(oe,me,be){return""+be},Te.br=function(){return""},Ae}(),Be=function(){function Ae(){this.seen={}}var Te=Ae.prototype;return Te.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Te.getNextSafeSlug=function(oe,me){var be=oe,_e=0;if(this.seen.hasOwnProperty(be)){_e=this.seen[oe];do _e++,be=oe+"-"+_e;while(this.seen.hasOwnProperty(be))}return me||(this.seen[oe]=_e,this.seen[be]=0),be},Te.slug=function(oe,me){me===void 0&&(me={});var be=this.serialize(oe);return this.getNextSafeSlug(be,me.dryrun)},Ae}(),qe=ce,Ke=Se,Je=Be,it=_.exports.defaults,at=N.unescape,et=function(){function Ae(De){this.options=De||it,this.options.renderer=this.options.renderer||new qe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Je}Ae.parse=function(oe,me){var be=new Ae(me);return be.parse(oe)},Ae.parseInline=function(oe,me){var be=new Ae(me);return be.parseInline(oe)};var Te=Ae.prototype;return Te.parse=function(oe,me){me===void 0&&(me=!0);var be="",_e,Ne,Qe,$e,Xe,st,ot,fe,ye,de,Q,Ie,Oe,Ze,je,ht,Et,Dt,bt,mt=oe.length;for(_e=0;_e<mt;_e++){if(de=oe[_e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(bt=this.options.extensions.renderers[de.type].call({parser:this},de),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){be+=bt||"";continue}switch(de.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(de.tokens),de.depth,at(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(fe="",ot="",$e=de.header.length,Ne=0;Ne<$e;Ne++)ot+=this.renderer.tablecell(this.parseInline(de.header[Ne].tokens),{header:!0,align:de.align[Ne]});for(fe+=this.renderer.tablerow(ot),ye="",$e=de.rows.length,Ne=0;Ne<$e;Ne++){for(st=de.rows[Ne],ot="",Xe=st.length,Qe=0;Qe<Xe;Qe++)ot+=this.renderer.tablecell(this.parseInline(st[Qe].tokens),{header:!1,align:de.align[Qe]});ye+=this.renderer.tablerow(ot)}be+=this.renderer.table(fe,ye);continue}case"blockquote":{ye=this.parse(de.tokens),be+=this.renderer.blockquote(ye);continue}case"list":{for(Q=de.ordered,Ie=de.start,Oe=de.loose,$e=de.items.length,ye="",Ne=0;Ne<$e;Ne++)je=de.items[Ne],ht=je.checked,Et=je.task,Ze="",je.task&&(Dt=this.renderer.checkbox(ht),Oe?je.tokens.length>0&&je.tokens[0].type==="paragraph"?(je.tokens[0].text=Dt+" "+je.tokens[0].text,je.tokens[0].tokens&&je.tokens[0].tokens.length>0&&je.tokens[0].tokens[0].type==="text"&&(je.tokens[0].tokens[0].text=Dt+" "+je.tokens[0].tokens[0].text)):je.tokens.unshift({type:"text",text:Dt}):Ze+=Dt),Ze+=this.parse(je.tokens,Oe),ye+=this.renderer.listitem(Ze,Et,ht);be+=this.renderer.list(ye,Q,Ie);continue}case"html":{be+=this.renderer.html(de.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(ye=de.tokens?this.parseInline(de.tokens):de.text;_e+1<mt&&oe[_e+1].type==="text";)de=oe[++_e],ye+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);be+=me?this.renderer.paragraph(ye):ye;continue}default:{var wt='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(wt);return}else throw new Error(wt)}}}return be},Te.parseInline=function(oe,me){me=me||this.renderer;var be="",_e,Ne,Qe,$e=oe.length;for(_e=0;_e<$e;_e++){if(Ne=oe[_e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(Qe=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),Qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){be+=Qe||"";continue}switch(Ne.type){case"escape":{be+=me.text(Ne.text);break}case"html":{be+=me.html(Ne.text);break}case"link":{be+=me.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,me));break}case"image":{be+=me.image(Ne.href,Ne.title,Ne.text);break}case"strong":{be+=me.strong(this.parseInline(Ne.tokens,me));break}case"em":{be+=me.em(this.parseInline(Ne.tokens,me));break}case"codespan":{be+=me.codespan(Ne.text);break}case"br":{be+=me.br();break}case"del":{be+=me.del(this.parseInline(Ne.tokens,me));break}case"text":{be+=me.text(Ne.text);break}default:{var Xe='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return be},Ae}(),nt=J,ct=et,vt=V,We=ce,At=Se,ee=Be,te=N.merge,Ee=N.checkSanitizeDeprecation,ie=N.escape,Ce=_.exports.getDefaults,Fe=_.exports.changeDefaults,Ge=_.exports.defaults;function ze(Ae,Te,De){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof Te=="function"&&(De=Te,Te=null),Te=te({},ze.defaults,Te||{}),Ee(Te),De){var oe=Te.highlight,me;try{me=nt.lex(Ae,Te)}catch(Qe){return De(Qe)}var be=function($e){var Xe;if(!$e)try{Te.walkTokens&&ze.walkTokens(me,Te.walkTokens),Xe=ct.parse(me,Te)}catch(st){$e=st}return Te.highlight=oe,$e?De($e):De(null,Xe)};if(!oe||oe.length<3||(delete Te.highlight,!me.length))return be();var _e=0;ze.walkTokens(me,function(Qe){Qe.type==="code"&&(_e++,setTimeout(function(){oe(Qe.text,Qe.lang,function($e,Xe){if($e)return be($e);Xe!=null&&Xe!==Qe.text&&(Qe.text=Xe,Qe.escaped=!0),_e--,_e===0&&be()})},0))}),_e===0&&be();return}try{var Ne=nt.lex(Ae,Te);return Te.walkTokens&&ze.walkTokens(Ne,Te.walkTokens),ct.parse(Ne,Te)}catch(Qe){if(Qe.message+=`
Please report this to https://github.com/markedjs/marked.`,Te.silent)return"<p>An error occurred:</p><pre>"+ie(Qe.message+"",!0)+"</pre>";throw Qe}}ze.options=ze.setOptions=function(Ae){return te(ze.defaults,Ae),Fe(ze.defaults),ze},ze.getDefaults=Ce,ze.defaults=Ge,ze.use=function(){for(var Ae=this,Te=arguments.length,De=new Array(Te),oe=0;oe<Te;oe++)De[oe]=arguments[oe];var me=te.apply(void 0,[{}].concat(De)),be=ze.defaults.extensions||{renderers:{},childTokens:{}},_e;De.forEach(function(Ne){if(Ne.extensions&&(_e=!0,Ne.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Xe=be.renderers?be.renderers[$e.name]:null;Xe?be.renderers[$e.name]=function(){for(var st=arguments.length,ot=new Array(st),fe=0;fe<st;fe++)ot[fe]=arguments[fe];var ye=$e.renderer.apply(this,ot);return ye===!1&&(ye=Xe.apply(this,ot)),ye}:be.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[$e.level]?be[$e.level].unshift($e.tokenizer):be[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?be.startBlock?be.startBlock.push($e.start):be.startBlock=[$e.start]:$e.level==="inline"&&(be.startInline?be.startInline.push($e.start):be.startInline=[$e.start]))}$e.childTokens&&(be.childTokens[$e.name]=$e.childTokens)})),Ne.renderer&&function(){var $e=ze.defaults.renderer||new We,Xe=function(fe){var ye=$e[fe];$e[fe]=function(){for(var de=arguments.length,Q=new Array(de),Ie=0;Ie<de;Ie++)Q[Ie]=arguments[Ie];var Oe=Ne.renderer[fe].apply($e,Q);return Oe===!1&&(Oe=ye.apply($e,Q)),Oe}};for(var st in Ne.renderer)Xe(st);me.renderer=$e}(),Ne.tokenizer&&function(){var $e=ze.defaults.tokenizer||new vt,Xe=function(fe){var ye=$e[fe];$e[fe]=function(){for(var de=arguments.length,Q=new Array(de),Ie=0;Ie<de;Ie++)Q[Ie]=arguments[Ie];var Oe=Ne.tokenizer[fe].apply($e,Q);return Oe===!1&&(Oe=ye.apply($e,Q)),Oe}};for(var st in Ne.tokenizer)Xe(st);me.tokenizer=$e}(),Ne.walkTokens){var Qe=ze.defaults.walkTokens;me.walkTokens=function($e){Ne.walkTokens.call(Ae,$e),Qe&&Qe($e)}}_e&&(me.extensions=be),ze.setOptions(me)})},ze.walkTokens=function(Ae,Te){for(var De=function(){var _e=me.value;switch(Te(_e),_e.type){case"table":{for(var Ne=k(_e.header),Qe;!(Qe=Ne()).done;){var $e=Qe.value;ze.walkTokens($e.tokens,Te)}for(var Xe=k(_e.rows),st;!(st=Xe()).done;)for(var ot=st.value,fe=k(ot),ye;!(ye=fe()).done;){var de=ye.value;ze.walkTokens(de.tokens,Te)}break}case"list":{ze.walkTokens(_e.items,Te);break}default:ze.defaults.extensions&&ze.defaults.extensions.childTokens&&ze.defaults.extensions.childTokens[_e.type]?ze.defaults.extensions.childTokens[_e.type].forEach(function(Q){ze.walkTokens(_e[Q],Te)}):_e.tokens&&ze.walkTokens(_e.tokens,Te)}},oe=k(Ae),me;!(me=oe()).done;)De()},ze.parseInline=function(Ae,Te){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");Te=te({},ze.defaults,Te||{}),Ee(Te);try{var De=nt.lexInline(Ae,Te);return Te.walkTokens&&ze.walkTokens(De,Te.walkTokens),ct.parseInline(De,Te)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Te.silent)return"<p>An error occurred:</p><pre>"+ie(oe.message+"",!0)+"</pre>";throw oe}},ze.Parser=ct,ze.parser=ct.parse,ze.Renderer=We,ze.TextRenderer=At,ze.Lexer=nt,ze.lexer=nt.lex,ze.Tokenizer=vt,ze.Slugger=ee,ze.parse=ze;var ut=ze;return ut}),define(ve[79],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(T,I,C){return Math.min(Math.max(T,I),C)}e.clamp=f;function i(T,I){return(I+T%I)%I}e.rot=i;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class _{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=_}),function(){function X(k){const _=[];typeof k=="number"&&_.push("code/timeOrigin",k);function T(C){_.push(C,Date.now())}function I(){const C=[];for(let P=0;P<_.length;P+=2)C.push({name:_[P],startTime:_[P+1]});return C}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))_.push({name:T.name,startTime:Math.round(k+T.startTime)});return _}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function f(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=f(i))}(),define(ve[12],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let i=!1,k=!1,_=!1,T=!1,I=!1,C=!1,P=!1,R=!1,y,c=f,b,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const w=typeof p?.versions?.electron=="string",L=w&&p?.type==="renderer";if(e.isElectronSandboxed=L&&p?.sandboxed,typeof navigator=="object"&&!L)v=navigator.userAgent,i=v.indexOf("Windows")>=0,k=v.indexOf("Macintosh")>=0,R=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=v.indexOf("Linux")>=0,C=!0,y=navigator.language,c=y;else if(typeof p=="object"){i=p.platform==="win32",k=p.platform==="darwin",_=p.platform==="linux",T=_&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,P=w,y=f,c=f;const s=p.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),d=u.availableLanguages["*"];y=u.locale,c=d||f,b=u._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var S;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function o(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let r=0;k?r=1:i?r=3:_&&(r=2),e.isWindows=i,e.isMacintosh=k,e.isLinux=_,e.isLinuxSnap=T,e.isNative=I,e.isElectron=P,e.isWeb=C,e.isIOS=R,e.platform=r,e.userAgent=v,e.language=c;var m;(function(s){function u(){return e.language}s.value=u;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=d;function h(){return e.language==="en"}s.isDefault=h})(m=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=b,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let h=0,g=s.length;h<g;h++){const l=s[h];if(l.id===d.data.vscodeScheduleAsyncWork){s.splice(h,1),l.callback();return}}});let u=0;return d=>{const h=++u;s.push({id:h,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return s=>setTimeout(s)})();var a;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||R?2:i?1:3;let E=!0,n=!1;function t(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,E=new Uint16Array(s.buffer)[0]===(2<<8)+1}return E}e.isLittleEndian=t}),define(ve[40],we([0,1,12]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const k=f.globals.vscode.process;i={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ve[8],we([0,1,40]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,k=97,_=90,T=122,I=46,C=47,P=92,R=58,y=63;class c extends Error{constructor(r,m,a){let E;typeof m=="string"&&m.indexOf("not ")===0?(E="must not be",m=m.replace(/^not /,"")):E="must be";const n=r.indexOf(".")!==-1?"property":"argument";let t=`The "${r}" ${n} ${E} of type ${m}`;t+=`. Received type ${typeof a}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function b(o,r){if(typeof o!="string")throw new c(r,"string",o)}function v(o){return o===C||o===P}function p(o){return o===C}function w(o){return o>=i&&o<=_||o>=k&&o<=T}function L(o,r,m,a){let E="",n=0,t=-1,s=0,u=0;for(let d=0;d<=o.length;++d){if(d<o.length)u=o.charCodeAt(d);else{if(a(u))break;u=C}if(a(u)){if(!(t===d-1||s===1))if(s===2){if(E.length<2||n!==2||E.charCodeAt(E.length-1)!==I||E.charCodeAt(E.length-2)!==I){if(E.length>2){const h=E.lastIndexOf(m);h===-1?(E="",n=0):(E=E.slice(0,h),n=E.length-1-E.lastIndexOf(m)),t=d,s=0;continue}else if(E.length!==0){E="",n=0,t=d,s=0;continue}}r&&(E+=E.length>0?`${m}..`:"..",n=2)}else E.length>0?E+=`${m}${o.slice(t+1,d)}`:E=o.slice(t+1,d),n=d-t-1;t=d,s=0}else u===I&&s!==-1?++s:s=-1}return E}function S(o,r){if(r===null||typeof r!="object")throw new c("pathObject","Object",r);const m=r.dir||r.root,a=r.base||`${r.name||""}${r.ext||""}`;return m?m===r.root?`${m}${a}`:`${m}${o}${a}`:a}e.win32={resolve(...o){let r="",m="",a=!1;for(let E=o.length-1;E>=-1;E--){let n;if(E>=0){if(n=o[E],b(n,"path"),n.length===0)continue}else r.length===0?n=f.cwd():(n=f.env[`=${r}`]||f.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==r.toLowerCase()&&n.charCodeAt(2)===P)&&(n=`${r}\\`));const t=n.length;let s=0,u="",d=!1;const h=n.charCodeAt(0);if(t===1)v(h)&&(s=1,d=!0);else if(v(h))if(d=!0,v(n.charCodeAt(1))){let g=2,l=g;for(;g<t&&!v(n.charCodeAt(g));)g++;if(g<t&&g!==l){const D=n.slice(l,g);for(l=g;g<t&&v(n.charCodeAt(g));)g++;if(g<t&&g!==l){for(l=g;g<t&&!v(n.charCodeAt(g));)g++;(g===t||g!==l)&&(u=`\\\\${D}\\${n.slice(l,g)}`,s=g)}}}else s=1;else w(h)&&n.charCodeAt(1)===R&&(u=n.slice(0,2),s=2,t>2&&v(n.charCodeAt(2))&&(d=!0,s=3));if(u.length>0)if(r.length>0){if(u.toLowerCase()!==r.toLowerCase())continue}else r=u;if(a){if(r.length>0)break}else if(m=`${n.slice(s)}\\${m}`,a=d,d&&r.length>0)break}return m=L(m,!a,"\\",v),a?`${r}\\${m}`:`${r}${m}`||"."},normalize(o){b(o,"path");const r=o.length;if(r===0)return".";let m=0,a,E=!1;const n=o.charCodeAt(0);if(r===1)return p(n)?"\\":o;if(v(n))if(E=!0,v(o.charCodeAt(1))){let s=2,u=s;for(;s<r&&!v(o.charCodeAt(s));)s++;if(s<r&&s!==u){const d=o.slice(u,s);for(u=s;s<r&&v(o.charCodeAt(s));)s++;if(s<r&&s!==u){for(u=s;s<r&&!v(o.charCodeAt(s));)s++;if(s===r)return`\\\\${d}\\${o.slice(u)}\\`;s!==u&&(a=`\\\\${d}\\${o.slice(u,s)}`,m=s)}}}else m=1;else w(n)&&o.charCodeAt(1)===R&&(a=o.slice(0,2),m=2,r>2&&v(o.charCodeAt(2))&&(E=!0,m=3));let t=m<r?L(o.slice(m),!E,"\\",v):"";return t.length===0&&!E&&(t="."),t.length>0&&v(o.charCodeAt(r-1))&&(t+="\\"),a===void 0?E?`\\${t}`:t:E?`${a}\\${t}`:`${a}${t}`},isAbsolute(o){b(o,"path");const r=o.length;if(r===0)return!1;const m=o.charCodeAt(0);return v(m)||r>2&&w(m)&&o.charCodeAt(1)===R&&v(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let r,m;for(let n=0;n<o.length;++n){const t=o[n];b(t,"path"),t.length>0&&(r===void 0?r=m=t:r+=`\\${t}`)}if(r===void 0)return".";let a=!0,E=0;if(typeof m=="string"&&v(m.charCodeAt(0))){++E;const n=m.length;n>1&&v(m.charCodeAt(1))&&(++E,n>2&&(v(m.charCodeAt(2))?++E:a=!1))}if(a){for(;E<r.length&&v(r.charCodeAt(E));)E++;E>=2&&(r=`\\${r.slice(E)}`)}return e.win32.normalize(r)},relative(o,r){if(b(o,"from"),b(r,"to"),o===r)return"";const m=e.win32.resolve(o),a=e.win32.resolve(r);if(m===a||(o=m.toLowerCase(),r=a.toLowerCase(),o===r))return"";let E=0;for(;E<o.length&&o.charCodeAt(E)===P;)E++;let n=o.length;for(;n-1>E&&o.charCodeAt(n-1)===P;)n--;const t=n-E;let s=0;for(;s<r.length&&r.charCodeAt(s)===P;)s++;let u=r.length;for(;u-1>s&&r.charCodeAt(u-1)===P;)u--;const d=u-s,h=t<d?t:d;let g=-1,l=0;for(;l<h;l++){const A=o.charCodeAt(E+l);if(A!==r.charCodeAt(s+l))break;A===P&&(g=l)}if(l!==h){if(g===-1)return a}else{if(d>h){if(r.charCodeAt(s+l)===P)return a.slice(s+l+1);if(l===2)return a.slice(s+l)}t>h&&(o.charCodeAt(E+l)===P?g=l:l===2&&(g=3)),g===-1&&(g=0)}let D="";for(l=E+g+1;l<=n;++l)(l===n||o.charCodeAt(l)===P)&&(D+=D.length===0?"..":"\\..");return s+=g,D.length>0?`${D}${a.slice(s,u)}`:(a.charCodeAt(s)===P&&++s,a.slice(s,u))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const r=e.win32.resolve(o);if(r.length<=2)return o;if(r.charCodeAt(0)===P){if(r.charCodeAt(1)===P){const m=r.charCodeAt(2);if(m!==y&&m!==I)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(w(r.charCodeAt(0))&&r.charCodeAt(1)===R&&r.charCodeAt(2)===P)return`\\\\?\\${r}`;return o},dirname(o){b(o,"path");const r=o.length;if(r===0)return".";let m=-1,a=0;const E=o.charCodeAt(0);if(r===1)return v(E)?o:".";if(v(E)){if(m=a=1,v(o.charCodeAt(1))){let s=2,u=s;for(;s<r&&!v(o.charCodeAt(s));)s++;if(s<r&&s!==u){for(u=s;s<r&&v(o.charCodeAt(s));)s++;if(s<r&&s!==u){for(u=s;s<r&&!v(o.charCodeAt(s));)s++;if(s===r)return o;s!==u&&(m=a=s+1)}}}}else w(E)&&o.charCodeAt(1)===R&&(m=r>2&&v(o.charCodeAt(2))?3:2,a=m);let n=-1,t=!0;for(let s=r-1;s>=a;--s)if(v(o.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(m===-1)return".";n=m}return o.slice(0,n)},basename(o,r){r!==void 0&&b(r,"ext"),b(o,"path");let m=0,a=-1,E=!0,n;if(o.length>=2&&w(o.charCodeAt(0))&&o.charCodeAt(1)===R&&(m=2),r!==void 0&&r.length>0&&r.length<=o.length){if(r===o)return"";let t=r.length-1,s=-1;for(n=o.length-1;n>=m;--n){const u=o.charCodeAt(n);if(v(u)){if(!E){m=n+1;break}}else s===-1&&(E=!1,s=n+1),t>=0&&(u===r.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=s))}return m===a?a=s:a===-1&&(a=o.length),o.slice(m,a)}for(n=o.length-1;n>=m;--n)if(v(o.charCodeAt(n))){if(!E){m=n+1;break}}else a===-1&&(E=!1,a=n+1);return a===-1?"":o.slice(m,a)},extname(o){b(o,"path");let r=0,m=-1,a=0,E=-1,n=!0,t=0;o.length>=2&&o.charCodeAt(1)===R&&w(o.charCodeAt(0))&&(r=a=2);for(let s=o.length-1;s>=r;--s){const u=o.charCodeAt(s);if(v(u)){if(!n){a=s+1;break}continue}E===-1&&(n=!1,E=s+1),u===I?m===-1?m=s:t!==1&&(t=1):m!==-1&&(t=-1)}return m===-1||E===-1||t===0||t===1&&m===E-1&&m===a+1?"":o.slice(m,E)},format:S.bind(null,"\\"),parse(o){b(o,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return r;const m=o.length;let a=0,E=o.charCodeAt(0);if(m===1)return v(E)?(r.root=r.dir=o,r):(r.base=r.name=o,r);if(v(E)){if(a=1,v(o.charCodeAt(1))){let g=2,l=g;for(;g<m&&!v(o.charCodeAt(g));)g++;if(g<m&&g!==l){for(l=g;g<m&&v(o.charCodeAt(g));)g++;if(g<m&&g!==l){for(l=g;g<m&&!v(o.charCodeAt(g));)g++;g===m?a=g:g!==l&&(a=g+1)}}}}else if(w(E)&&o.charCodeAt(1)===R){if(m<=2)return r.root=r.dir=o,r;if(a=2,v(o.charCodeAt(2))){if(m===3)return r.root=r.dir=o,r;a=3}}a>0&&(r.root=o.slice(0,a));let n=-1,t=a,s=-1,u=!0,d=o.length-1,h=0;for(;d>=a;--d){if(E=o.charCodeAt(d),v(E)){if(!u){t=d+1;break}continue}s===-1&&(u=!1,s=d+1),E===I?n===-1?n=d:h!==1&&(h=1):n!==-1&&(h=-1)}return s!==-1&&(n===-1||h===0||h===1&&n===s-1&&n===t+1?r.base=r.name=o.slice(t,s):(r.name=o.slice(t,n),r.base=o.slice(t,s),r.ext=o.slice(n,s))),t>0&&t!==a?r.dir=o.slice(0,t-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let r="",m=!1;for(let a=o.length-1;a>=-1&&!m;a--){const E=a>=0?o[a]:f.cwd();b(E,"path"),E.length!==0&&(r=`${E}/${r}`,m=E.charCodeAt(0)===C)}return r=L(r,!m,"/",p),m?`/${r}`:r.length>0?r:"."},normalize(o){if(b(o,"path"),o.length===0)return".";const r=o.charCodeAt(0)===C,m=o.charCodeAt(o.length-1)===C;return o=L(o,!r,"/",p),o.length===0?r?"/":m?"./":".":(m&&(o+="/"),r?`/${o}`:o)},isAbsolute(o){return b(o,"path"),o.length>0&&o.charCodeAt(0)===C},join(...o){if(o.length===0)return".";let r;for(let m=0;m<o.length;++m){const a=o[m];b(a,"path"),a.length>0&&(r===void 0?r=a:r+=`/${a}`)}return r===void 0?".":e.posix.normalize(r)},relative(o,r){if(b(o,"from"),b(r,"to"),o===r||(o=e.posix.resolve(o),r=e.posix.resolve(r),o===r))return"";const m=1,a=o.length,E=a-m,n=1,t=r.length-n,s=E<t?E:t;let u=-1,d=0;for(;d<s;d++){const g=o.charCodeAt(m+d);if(g!==r.charCodeAt(n+d))break;g===C&&(u=d)}if(d===s)if(t>s){if(r.charCodeAt(n+d)===C)return r.slice(n+d+1);if(d===0)return r.slice(n+d)}else E>s&&(o.charCodeAt(m+d)===C?u=d:d===0&&(u=0));let h="";for(d=m+u+1;d<=a;++d)(d===a||o.charCodeAt(d)===C)&&(h+=h.length===0?"..":"/..");return`${h}${r.slice(n+u)}`},toNamespacedPath(o){return o},dirname(o){if(b(o,"path"),o.length===0)return".";const r=o.charCodeAt(0)===C;let m=-1,a=!0;for(let E=o.length-1;E>=1;--E)if(o.charCodeAt(E)===C){if(!a){m=E;break}}else a=!1;return m===-1?r?"/":".":r&&m===1?"//":o.slice(0,m)},basename(o,r){r!==void 0&&b(r,"ext"),b(o,"path");let m=0,a=-1,E=!0,n;if(r!==void 0&&r.length>0&&r.length<=o.length){if(r===o)return"";let t=r.length-1,s=-1;for(n=o.length-1;n>=0;--n){const u=o.charCodeAt(n);if(u===C){if(!E){m=n+1;break}}else s===-1&&(E=!1,s=n+1),t>=0&&(u===r.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=s))}return m===a?a=s:a===-1&&(a=o.length),o.slice(m,a)}for(n=o.length-1;n>=0;--n)if(o.charCodeAt(n)===C){if(!E){m=n+1;break}}else a===-1&&(E=!1,a=n+1);return a===-1?"":o.slice(m,a)},extname(o){b(o,"path");let r=-1,m=0,a=-1,E=!0,n=0;for(let t=o.length-1;t>=0;--t){const s=o.charCodeAt(t);if(s===C){if(!E){m=t+1;break}continue}a===-1&&(E=!1,a=t+1),s===I?r===-1?r=t:n!==1&&(n=1):r!==-1&&(n=-1)}return r===-1||a===-1||n===0||n===1&&r===a-1&&r===m+1?"":o.slice(r,a)},format:S.bind(null,"/"),parse(o){b(o,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return r;const m=o.charCodeAt(0)===C;let a;m?(r.root="/",a=1):a=0;let E=-1,n=0,t=-1,s=!0,u=o.length-1,d=0;for(;u>=a;--u){const h=o.charCodeAt(u);if(h===C){if(!s){n=u+1;break}continue}t===-1&&(s=!1,t=u+1),h===I?E===-1?E=u:d!==1&&(d=1):E!==-1&&(d=-1)}if(t!==-1){const h=n===0&&m?1:n;E===-1||d===0||d===1&&E===t-1&&E===n+1?r.base=r.name=o.slice(h,t):(r.name=o.slice(h,E),r.base=o.slice(h,t),r.ext=o.slice(E,t))}return n>0?r.dir=o.slice(0,n-1):m&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[95],we([0,1,8]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var i;(function(y){y.text="text/plain",y.binary="application/octet-stream",y.unknown="application/unknown",y.markdown="text/markdown",y.latex="text/latex"})(i=e.Mimes||(e.Mimes={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},_={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(y){const c=(0,f.extname)(y),b=k[c.toLowerCase()];return b!==void 0?b:I(y)}e.getMediaOrTextMime=T;function I(y){const c=(0,f.extname)(y);return _[c.toLowerCase()]}e.getMediaMime=I;function C(y){for(const c in _)if(_[c]===y)return c}e.getExtensionForMimeType=C;const P=/^(.+)\/(.+?)(;.+)?$/;function R(y,c){const b=P.exec(y);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:c?void 0:y}e.normalizeMimeType=R}),define(ve[96],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var i;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(_,...T){const I=T.reduce((R,y)=>(R[y]=!0,R),{}),C=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(R=>!I[R]).forEach(R=>{for(let y=0;y<C.length;y++)if(R.search(C[y])!==-1){delete _[R];break}})}e.sanitizeProcessEnvironment=k}),define(ve[46],we([0,1,12]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=f.globals.performance&&typeof f.globals.performance.now=="function";class k{constructor(T){this._highResolution=i&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ve[3],we([0,1,15,76,6,94,46]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(r){r.None=()=>k.Disposable.None;function m(M){return(x,V=null,U)=>{let H=!1,Y;return Y=M(se=>{if(!H)return Y?Y.dispose():H=!0,x.call(V,se)},null,U),H&&Y.dispose(),Y}}r.once=m;function a(M,x){return d((V,U=null,H)=>M(Y=>V.call(U,x(Y)),null,H))}r.map=a;function E(M,x){return d((V,U=null,H)=>M(Y=>{x(Y),V.call(U,Y)},null,H))}r.forEach=E;function n(M,x){return d((V,U=null,H)=>M(Y=>x(Y)&&V.call(U,Y),null,H))}r.filter=n;function t(M){return M}r.signal=t;function s(...M){return(x,V=null,U)=>(0,k.combinedDisposable)(...M.map(H=>H(Y=>x.call(V,Y),null,U)))}r.any=s;function u(M,x,V){let U=V;return a(M,H=>(U=x(U,H),U))}r.reduce=u;function d(M){let x;const V=new c({onFirstListenerAdd(){x=M(V.fire,V)},onLastListenerRemove(){x.dispose()}});return V.event}function h(M,x,V,U=100,H=!1){let Y,se,K=0;return M(j=>{K++,Y=V(Y,j),H&&!se&&(x(Y),Y=void 0),clearTimeout(se),se=setTimeout(()=>{const ne=Y;Y=void 0,se=void 0,(!H||K>1)&&x(ne),K=0},U)})}r.debouncedListener=h;function g(M,x,V=100,U=!1,H){let Y,se,K,j=0;const ne=new c({leakWarningThreshold:H,onFirstListenerAdd(){Y=M(le=>{j++,se=x(se,le),U&&!K&&(ne.fire(se),se=void 0),clearTimeout(K),K=setTimeout(()=>{const ge=se;se=void 0,K=void 0,(!U||j>1)&&ne.fire(ge),j=0},V)})},onLastListenerRemove(){Y.dispose()}});return ne.event}r.debounce=g;function l(M,x=(V,U)=>V===U){let V=!0,U;return n(M,H=>{const Y=V||!x(H,U);return V=!1,U=H,Y})}r.latch=l;function D(M,x){return[r.filter(M,x),r.filter(M,V=>!x(V))]}r.split=D;function A(M,x=!1,V=[]){let U=V.slice(),H=M(K=>{U?U.push(K):se.fire(K)});const Y=()=>{U&&U.forEach(K=>se.fire(K)),U=null},se=new c({onFirstListenerAdd(){H||(H=M(K=>se.fire(K)))},onFirstListenerDidAdd(){U&&(x?setTimeout(Y):Y())},onLastListenerRemove(){H&&H.dispose(),H=null}});return se.event}r.buffer=A;class N{constructor(x){this.event=x}map(x){return new N(a(this.event,x))}forEach(x){return new N(E(this.event,x))}filter(x){return new N(n(this.event,x))}reduce(x,V){return new N(u(this.event,x,V))}latch(){return new N(l(this.event))}debounce(x,V=100,U=!1,H){return new N(g(this.event,x,V,U,H))}on(x,V,U){return this.event(x,V,U)}once(x,V,U){return m(this.event)(x,V,U)}}function B(M){return new N(M)}r.chain=B;function F(M,x,V=U=>U){const U=(...K)=>se.fire(V(...K)),H=()=>M.on(x,U),Y=()=>M.removeListener(x,U),se=new c({onFirstListenerAdd:H,onLastListenerRemove:Y});return se.event}r.fromNodeEventEmitter=F;function O(M,x,V=U=>U){const U=(...K)=>se.fire(V(...K)),H=()=>M.addEventListener(x,U),Y=()=>M.removeEventListener(x,U),se=new c({onFirstListenerAdd:H,onLastListenerRemove:Y});return se.event}r.fromDOMEventEmitter=O;function z(M){return new Promise(x=>m(M)(x))}r.toPromise=z;function W(M,x){return x(void 0),M(V=>x(V))}r.runAndSubscribe=W})(I=e.Event||(e.Event={}));class C{constructor(m){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${m}_${C._idPool++}`}start(m){this._stopWatch=new T.StopWatch(!0),this._listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this._elapsedOverall+=m,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${m.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let P=-1;function R(r){const m=P;return P=r,{dispose(){P=m}}}e.setGlobalLeakWarningThreshold=R;class y{constructor(m,a=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m){let a=P;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||m<a)return;this._stacks||(this._stacks=new Map);const E=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(E)||0;if(this._stacks.set(E,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let t,s=0;for(const[u,d]of this._stacks)(!t||s<d)&&(t=u,s=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(E)||0;this._stacks.set(E,t-1)}}}class c{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=P>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(m,a,E)=>{this._listeners||(this._listeners=new _.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(a?[m,a]:m);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,a);const s=this._leakageMon?.check(this._listeners.size),u=(0,k.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return E instanceof k.DisposableStore?E.add(u):Array.isArray(E)&&E.push(u),u}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,m]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,E]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,E):a[0].call(a[1],E)}catch(n){(0,f.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class b extends c{async fireAsync(m,a,E){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,m]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],u={...t,token:a,waitUntil:d=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");E&&(d=E(d,typeof n=="function"?n:n[0])),s.push(d)}};try{typeof n=="function"?n.call(void 0,u):n[0].call(n[1],u)}catch(d){(0,f.onUnexpectedError)(d);continue}Object.freeze(s),await Promise.allSettled(s).then(d=>{for(const h of d)h.status==="rejected"&&(0,f.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=b;class v extends c{constructor(m){super(m);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=v;class p extends v{constructor(m){super(m);this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=p;class w extends c{constructor(m){super(m);this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(a=>super.fire(a)),this._queuedEvents=[]})}}e.MicrotaskEmitter=w;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const a={event:m,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const E=()=>{this.hasListeners&&this.unhook(a);const n=this.events.indexOf(a);this.events.splice(n,1)};return(0,k.toDisposable)((0,i.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(a=>this.emitter.fire(a))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=L;class S{constructor(){this.buffers=[]}wrapEvent(m){return(a,E,n)=>m(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>a.call(E,t)):a.call(E,t)},void 0,n)}bufferEvents(m){const a=[];this.buffers.push(a);const E=m();return this.buffers.pop(),a.forEach(n=>n()),E}}e.EventBufferer=S;class o{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=k.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ve[21],we([0,1,3]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(I,C){const P=setTimeout(I.bind(C),0);return{dispose(){clearTimeout(P)}}});var k;(function(I){function C(P){return P===I.None||P===I.Cancelled||P instanceof _?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}I.isCancellationToken=C,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(k=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=k.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(ve[141],we([0,1,21]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class i{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new f.CancellationTokenSource,I=this.task(T.token);return this.result={promise:I,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=i;class k{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const I=JSON.stringify(T);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=k}),define(ve[97],we([0,1,15,6]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(o){const r=o;return r?[r.on,r.pause,r.resume,r.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=k;function _(o){const r=o;return r?k(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=_;function T(o,r){return new I(o,r)}e.newWriteableStream=T;class I{constructor(r,m){this.reducer=r,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(m=>m(r))}emitError(r){this.listeners.error.length===0?(0,f.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(m=>m(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,m){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(r,m){if(this.state.destroyed)return;let a;switch(r){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const E=a.indexOf(m);E>=0&&a.splice(E,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(o,r){const m=[];let a;for(;(a=o.read())!==null;)m.push(a);return r(m)}e.consumeReadable=C;function P(o,r,m){const a=[];let E;for(;(E=o.read())!==null&&a.length<m;)a.push(E);return E===null&&a.length>0?r(a):{read:()=>{if(a.length>0)return a.shift();if(typeof E!="undefined"){const n=E;return E=void 0,n}return o.read()}}}e.peekReadable=P;function R(o,r){return new Promise((m,a)=>{const E=[];y(o,{onData:n=>{r&&E.push(n)},onError:n=>{r?a(n):m(void 0)},onEnd:()=>{m(r?r(E):void 0)}})})}e.consumeStream=R;function y(o,r){let m=!1;return o.on("error",a=>{m||r.onError(a)}),o.on("end",()=>{m||r.onEnd()}),o.on("data",a=>{m||r.onData(a)}),(0,i.toDisposable)(()=>m=!0)}e.listenStream=y;function c(o,r){return new Promise((m,a)=>{const E=new i.DisposableStore,n=[],t=d=>{if(n.push(d),n.length>r)return E.dispose(),o.pause(),m({stream:o,buffer:n,ended:!1})},s=d=>a(d),u=()=>m({stream:o,buffer:n,ended:!0});E.add((0,i.toDisposable)(()=>o.removeListener("error",s))),o.on("error",s),E.add((0,i.toDisposable)(()=>o.removeListener("end",u))),o.on("end",u),E.add((0,i.toDisposable)(()=>o.removeListener("data",t))),o.on("data",t)})}e.peekStream=c;function b(o,r){const m=T(r);return m.end(o),m}e.toStream=b;function v(){const o=T(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=v;function p(o){let r=!1;return{read:()=>r?null:(r=!0,o)}}e.toReadable=p;function w(o,r,m){const a=T(m);return y(o,{onData:E=>a.write(r.data(E)),onError:E=>a.error(r.error?r.error(E):E),onEnd:()=>a.end()}),a}e.transform=w;function L(o,r,m){let a=!1;return{read:()=>{const E=r.read();return a?E:(a=!0,E!==null?m([o,E]):o)}}}e.prefixedReadable=L;function S(o,r,m){let a=!1;const E=T(m);return y(r,{onData:n=>a?E.write(n):(a=!0,E.write(m([o,n]))),onError:n=>E.error(n),onEnd:()=>{a||(a=!0,E.write(o)),E.end()}}),E}e.prefixedStream=S}),define(ve[22],we([0,1,97]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let k,_;class T{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return i?new T(Buffer.allocUnsafe(t)):new T(new Uint8Array(t))}static wrap(t){return i&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new T(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&i?new T(Buffer.from(t)):(k||(k=new TextEncoder),new T(k.encode(t)))}static fromByteArray(t){const s=T.alloc(t.length);for(let u=0,d=t.length;u<d;u++)s.buffer[u]=t[u];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let h=0,g=t.length;h<g;h++)s+=t[h].byteLength}const u=T.alloc(s);let d=0;for(let h=0,g=t.length;h<g;h++){const l=t[h];u.set(l,d),d+=l.byteLength}return u}clone(){const t=T.alloc(this.byteLength);return t.set(this),t}toString(){return i?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(t,s){return new T(this.buffer.subarray(t,s))}set(t,s){if(t instanceof T)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return P(this.buffer,t)}writeUInt32BE(t,s){R(this.buffer,t,s)}readUInt32LE(t){return y(this.buffer,t)}writeUInt32LE(t,s){c(this.buffer,t,s)}readUInt8(t){return b(this.buffer,t)}writeUInt8(t,s){v(this.buffer,t,s)}}e.VSBuffer=T;function I(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=I;function C(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=C;function P(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=P;function R(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=R;function y(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=y;function c(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=c;function b(n,t){return n[t]}e.readUInt8=b;function v(n,t,s){n[s]=t}e.writeUInt8=v;function p(n){return f.consumeReadable(n,t=>T.concat(t))}e.readableToBuffer=p;function w(n){return f.toReadable(n)}e.bufferToReadable=w;function L(n){return f.consumeStream(n,t=>T.concat(t))}e.streamToBuffer=L;async function S(n){return n.ended?T.concat(n.buffer):T.concat([...n.buffer,await L(n.stream)])}e.bufferedStreamToBuffer=S;function o(n){return f.toStream(n,t=>T.concat(t))}e.bufferToStream=o;function r(n){return f.transform(n,{data:t=>typeof t=="string"?T.fromString(t):T.wrap(t)},t=>T.concat(t))}e.streamToBufferReadableStream=r;function m(n){return f.newWriteableStream(t=>T.concat(t),n)}e.newWriteableBufferStream=m;function a(n,t){return f.prefixedReadable(n,t,s=>T.concat(s))}e.prefixedBufferReadable=a;function E(n,t){return f.prefixedStream(n,t,s=>T.concat(s))}e.prefixedBufferStream=E}),define(ve[9],we([0,1,141,93]),function(X,e,f,i){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=_;const T=/{(\d+)}/g;function I(ie,...Ce){return Ce.length===0?ie:ie.replace(T,function(Fe,Ge){const ze=parseInt(Ge,10);return isNaN(ze)||ze<0||ze>=Ce.length?Fe:Ce[ze]})}e.format=I;const C=/{([^}]+)}/g;function P(ie,Ce){return ie.replace(C,(Fe,Ge)=>Ce[Ge]??Fe)}e.format2=P;function R(ie){return ie.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=R;function y(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function c(ie,Ce){let Fe=0;const Ge=Ce.charCodeAt(0);for(let ze=ie.length-1;ze>=0;ze--)ie.charCodeAt(ze)===Ge&&Fe++;return Fe}e.count=c;function b(ie,Ce,Fe="\u2026"){return ie.length<=Ce?ie:`${ie.substr(0,Ce)}${Fe}`}e.truncate=b;function v(ie,Ce=" "){const Fe=p(ie,Ce);return w(Fe,Ce)}e.trim=v;function p(ie,Ce){if(!ie||!Ce)return ie;const Fe=Ce.length;if(Fe===0||ie.length===0)return ie;let Ge=0;for(;ie.indexOf(Ce,Ge)===Ge;)Ge=Ge+Fe;return ie.substring(Ge)}e.ltrim=p;function w(ie,Ce){if(!ie||!Ce)return ie;const Fe=Ce.length,Ge=ie.length;if(Fe===0||Ge===0)return ie;let ze=Ge,ut=-1;for(;ut=ie.lastIndexOf(Ce,ze-1),!(ut===-1||ut+Fe!==ze);){if(ut===0)return"";ze=ut}return ie.substring(0,ze)}e.rtrim=w;function L(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=L;function S(ie){return ie.replace(/\*/g,"")}e.stripWildcards=S;function o(ie,Ce,Fe={}){if(!ie)throw new Error("Cannot create regex from empty string");Ce||(ie=y(ie)),Fe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Ge="";return Fe.global&&(Ge+="g"),Fe.matchCase||(Ge+="i"),Fe.multiline&&(Ge+="m"),Fe.unicode&&(Ge+="u"),new RegExp(ie,Ge)}e.createRegExp=o;function r(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=r;function m(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function a(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=a;function E(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=E;function n(ie){for(let Ce=0,Fe=ie.length;Ce<Fe;Ce++){const Ge=ie.charCodeAt(Ce);if(Ge!==32&&Ge!==9)return Ce}return-1}e.firstNonWhitespaceIndex=n;function t(ie,Ce=0,Fe=ie.length){for(let Ge=Ce;Ge<Fe;Ge++){const ze=ie.charCodeAt(Ge);if(ze!==32&&ze!==9)return ie.substring(Ce,Ge)}return ie.substring(Ce,Fe)}e.getLeadingWhitespace=t;function s(ie,Ce=ie.length-1){for(let Fe=Ce;Fe>=0;Fe--){const Ge=ie.charCodeAt(Fe);if(Ge!==32&&Ge!==9)return Fe}return-1}e.lastNonWhitespaceIndex=s;function u(ie,Ce){return ie<Ce?-1:ie>Ce?1:0}e.compare=u;function d(ie,Ce,Fe=0,Ge=ie.length,ze=0,ut=Ce.length){for(;Fe<Ge&&ze<ut;Fe++,ze++){let De=ie.charCodeAt(Fe),oe=Ce.charCodeAt(ze);if(De<oe)return-1;if(De>oe)return 1}const Ae=Ge-Fe,Te=ut-ze;return Ae<Te?-1:Ae>Te?1:0}e.compareSubstring=d;function h(ie,Ce){return g(ie,Ce,0,ie.length,0,Ce.length)}e.compareIgnoreCase=h;function g(ie,Ce,Fe=0,Ge=ie.length,ze=0,ut=Ce.length){for(;Fe<Ge&&ze<ut;Fe++,ze++){let De=ie.charCodeAt(Fe),oe=Ce.charCodeAt(ze);if(De===oe)continue;if(De>=128||oe>=128)return d(ie.toLowerCase(),Ce.toLowerCase(),Fe,Ge,ze,ut);l(De)&&(De-=32),l(oe)&&(oe-=32);const me=De-oe;if(me!==0)return me}const Ae=Ge-Fe,Te=ut-ze;return Ae<Te?-1:Ae>Te?1:0}e.compareSubstringIgnoreCase=g;function l(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=l;function D(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=D;function A(ie,Ce){return ie.length===Ce.length&&g(ie,Ce)===0}e.equalsIgnoreCase=A;function N(ie,Ce){const Fe=Ce.length;return Ce.length>ie.length?!1:g(ie,Ce,0,Fe)===0}e.startsWithIgnoreCase=N;function B(ie,Ce){let Fe,Ge=Math.min(ie.length,Ce.length);for(Fe=0;Fe<Ge;Fe++)if(ie.charCodeAt(Fe)!==Ce.charCodeAt(Fe))return Fe;return Ge}e.commonPrefixLength=B;function F(ie,Ce){let Fe,Ge=Math.min(ie.length,Ce.length);const ze=ie.length-1,ut=Ce.length-1;for(Fe=0;Fe<Ge;Fe++)if(ie.charCodeAt(ze-Fe)!==Ce.charCodeAt(ut-Fe))return Fe;return Ge}e.commonSuffixLength=F;function O(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=O;function z(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=z;function W(ie,Ce){return(ie-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=W;function M(ie,Ce,Fe){const Ge=ie.charCodeAt(Fe);if(O(Ge)&&Fe+1<Ce){const ze=ie.charCodeAt(Fe+1);if(z(ze))return W(Ge,ze)}return Ge}e.getNextCodePoint=M;function x(ie,Ce){const Fe=ie.charCodeAt(Ce-1);if(z(Fe)&&Ce>1){const Ge=ie.charCodeAt(Ce-2);if(O(Ge))return W(Ge,Fe)}return Fe}class V{constructor(Ce,Fe=0){this._str=Ce,this._len=Ce.length,this._offset=Fe}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=x(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=M(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=V;class U{constructor(Ce,Fe=0){this._iterator=new V(Ce,Fe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=nt.getInstance(),Fe=this._iterator,Ge=Fe.offset;let ze=Ce.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const ut=Fe.offset,Ae=Ce.getGraphemeBreakType(Fe.nextCodePoint());if(at(ze,Ae)){Fe.setOffset(ut);break}ze=Ae}return Fe.offset-Ge}prevGraphemeLength(){const Ce=nt.getInstance(),Fe=this._iterator,Ge=Fe.offset;let ze=Ce.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const ut=Fe.offset,Ae=Ce.getGraphemeBreakType(Fe.prevCodePoint());if(at(Ae,ze)){Fe.setOffset(ut);break}ze=Ae}return Ge-Fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=U;function H(ie,Ce){return new U(ie,Ce).nextGraphemeLength()}e.nextCharLength=H;function Y(ie,Ce){return new U(ie,Ce).prevGraphemeLength()}e.prevCharLength=Y;function se(ie,Ce){Ce>0&&z(ie.charCodeAt(Ce))&&Ce--;const Fe=Ce+H(ie,Ce);return[Fe-Y(ie,Fe),Fe]}e.getCharContainingOffset=se;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function j(ie){return K.test(ie)}e.containsRTL=j;const ne=/^[\t\n\r\x20-\x7E]*$/;function le(ie){return ne.test(ie)}e.isBasicASCII=le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ge(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=ge;function ke(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=ke;function Me(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=Me;function Ue(ie,Ce){if(ie.length<Ce)return ie;const Fe=/\b/g;let Ge=0;for(;Fe.test(ie)&&!(ie.length-Fe.lastIndex<Ce);)Ge=Fe.lastIndex,Fe.lastIndex+=1;return ie.substring(Ge).replace(/^\s/,"")}e.lcut=Ue;const q=/\x1B\x5B[12]?K/g,J=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function he(ie){return ie&&(ie=ie.replace(q,""),ie=ie.replace(J,""),ie=ie.replace(re,"")),ie}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Z(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Z;function ce(ie){return Z(ie)?ie.substr(1):ie}e.stripUTF8BOM=ce;function Se(ie,Ce){if(!ie||!Ce||ie.length<Ce.length)return!1;const Fe=Ce.length,Ge=ie.toLowerCase();let ze=0,ut=-1;for(;ze<Fe;){const Ae=Ge.indexOf(Ce[ze],ut+1);if(Ae<0)return!1;ut=Ae,ze++}return!0}e.fuzzyContains=Se;function Be(ie,Ce=!1){return ie?(Ce&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=Be;function qe(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=qe;function Ke(ie,Ce=1){if(Ce===0)return"";let Fe=-1;do Fe=ie.indexOf(`
`,Fe+1),Ce--;while(Ce>0&&Fe>=0);return Fe===-1?ie:(ie[Fe-1]==="\r"&&Fe--,ie.substr(0,Fe))}e.getNLines=Ke;function Je(ie){const Ce=90-65+1;return ie=ie%(2*Ce),ie<Ce?String.fromCharCode(97+ie):String.fromCharCode(65+ie-Ce)}e.singleLetterHash=Je;function it(ie){return nt.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=it;function at(ie,Ce){return ie===0?Ce!==5&&Ce!==7:ie===2&&Ce===3?!1:ie===4||ie===2||ie===3||Ce===4||Ce===2||Ce===3?!0:!(ie===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(ie===11||ie===9)&&(Ce===9||Ce===10)||(ie===12||ie===10)&&Ce===10||Ce===5||Ce===13||Ce===7||ie===1||ie===13&&Ce===14||ie===6&&Ce===6)}var et;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class nt{constructor(){this._data=ct()}static getInstance(){return nt._INSTANCE||(nt._INSTANCE=new nt),nt._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Fe=this._data,Ge=Fe.length/3;let ze=1;for(;ze<=Ge;)if(Ce<Fe[3*ze])ze=2*ze;else if(Ce>Fe[3*ze+1])ze=2*ze+1;else return Fe[3*ze+2];return 0}}nt._INSTANCE=null;function ct(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function vt(ie,Ce){if(ie===0)return 0;const Fe=We(ie,Ce);if(Fe!==void 0)return Fe;const Ge=new V(Ce,ie);return Ge.prevCodePoint(),Ge.offset}e.getLeftDeleteOffset=vt;function We(ie,Ce){const Fe=new V(Ce,ie);let Ge=Fe.prevCodePoint();for(;At(Ge)||Ge===65039||Ge===8419;){if(Fe.offset===0)return;Ge=Fe.prevCodePoint()}if(!Me(Ge))return;let ze=Fe.offset;return ze>0&&Fe.prevCodePoint()===8205&&(ze=Fe.offset),ze}function At(ie){return 127995<=ie&&ie<=127999}var ee;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class te{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return te.cache.get(Array.from(Ce))}static getLocales(){return te._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=te,k=te,te.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')),te.cache=new f.LRUCachedComputed(ie=>{function Ce(oe){const me=new Map;for(let be=0;be<oe.length;be+=2)me.set(oe[be],oe[be+1]);return me}function Fe(oe,me){const be=new Map(oe);for(const[_e,Ne]of me)be.set(_e,Ne);return be}function Ge(oe,me){if(!oe)return me;const be=new Map;for(const[_e,Ne]of oe)me.has(_e)&&be.set(_e,Ne);return be}const ze=k.ambiguousCharacterData.getValue();let ut=ie.filter(oe=>!oe.startsWith("_")&&oe in ze);ut.length===0&&(ut=["_default"]);let Ae;for(const oe of ut){const me=Ce(ze[oe]);Ae=Ge(Ae,me)}const Te=Ce(ze._common),De=Fe(Te,Ae);return new te(De)}),te._locales=new i.Lazy(()=>Object.keys(te.ambiguousCharacterData.getValue()).filter(ie=>!ie.startsWith("_")));class Ee{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ee.getRawData())),this._data}static isInvisibleCharacter(Ce){return Ee.getData().has(Ce)}static get codePoints(){return Ee.getData()}}e.InvisibleCharacters=Ee,Ee._data=void 0}),define(ve[47],we([0,1,9]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(L){return k(L,0)}e.hash=i;function k(L,S){switch(typeof L){case"object":return L===null?_(349,S):Array.isArray(L)?C(L,S):P(L,S);case"string":return I(L,S);case"boolean":return T(L,S);case"number":return _(L,S);case"undefined":return _(937,S);default:return _(617,S)}}e.doHash=k;function _(L,S){return(S<<5)-S+L|0}e.numberHash=_;function T(L,S){return _(L?433:863,S)}function I(L,S){S=_(149417,S);for(let o=0,r=L.length;o<r;o++)S=_(L.charCodeAt(o),S);return S}e.stringHash=I;function C(L,S){return S=_(104579,S),L.reduce((o,r)=>k(r,o),S)}function P(L,S){return S=_(181387,S),Object.keys(L).sort().reduce((o,r)=>(o=I(r,o),k(L[r],o)),S)}class R{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=R;var y;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function c(L,S,o=32){const r=o-S,m=~((1<<r)-1);return(L<<S|(m&L)>>>r)>>>0}function b(L,S=0,o=L.byteLength,r=0){for(let m=0;m<o;m++)L[S+m]=r}function v(L,S,o="0"){for(;L.length<S;)L=o+L;return L}function p(L,S=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(o=>o.toString(16).padStart(2,"0")).join(""):v((L>>>0).toString(16),S/4)}e.toHexString=p;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const o=S.length;if(o===0)return;const r=this._buff;let m=this._buffLen,a=this._leftoverHighSurrogate,E,n;for(a!==0?(E=a,n=-1,a=0):(E=S.charCodeAt(0),n=0);;){let t=E;if(f.isHighSurrogate(E))if(n+1<o){const s=S.charCodeAt(n+1);f.isLowSurrogate(s)?(n++,t=f.computeCodePoint(E,s)):t=65533}else{a=E;break}else f.isLowSurrogate(E)&&(t=65533);if(m=this._push(r,m,t),n++,n<o)E=S.charCodeAt(n);else break}this._buffLen=m,this._leftoverHighSurrogate=a}_push(S,o,r){return r<128?S[o++]=r:r<2048?(S[o++]=192|(r&1984)>>>6,S[o++]=128|(r&63)>>>0):r<65536?(S[o++]=224|(r&61440)>>>12,S[o++]=128|(r&4032)>>>6,S[o++]=128|(r&63)>>>0):(S[o++]=240|(r&1835008)>>>18,S[o++]=128|(r&258048)>>>12,S[o++]=128|(r&4032)>>>6,S[o++]=128|(r&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=w._bigBlock32,o=this._buffDV;for(let d=0;d<64;d+=4)S.setUint32(d,o.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)S.setUint32(d,c(S.getUint32(d-12,!1)^S.getUint32(d-32,!1)^S.getUint32(d-56,!1)^S.getUint32(d-64,!1),1),!1);let r=this._h0,m=this._h1,a=this._h2,E=this._h3,n=this._h4,t,s,u;for(let d=0;d<80;d++)d<20?(t=m&a|~m&E,s=1518500249):d<40?(t=m^a^E,s=1859775393):d<60?(t=m&a|m&E|a&E,s=2400959708):(t=m^a^E,s=3395469782),u=c(r,5)+t+n+s+S.getUint32(d*4,!1)&4294967295,n=E,E=a,a=c(m,30),m=r,r=u;this._h0=this._h0+r&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[24],we([0,1,16,9]),function(X,e,f,i){"use strict";var k,_,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(n,t,s){let u=n.get(t);return u===void 0&&(u=s,n.set(t,u)),u}e.getOrSet=I;function C(n){const t=[];return n.forEach((s,u)=>{t.push(`${u} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=C;function P(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=P;class R{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=R;class y{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class c{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const u=this._value.charCodeAt(s);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var b;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(b||(b={}));class v{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(w||(w={}));class L{constructor(t){this._iter=t}static forUris(t=()=>!1){return new L(new v(t))}static forPaths(){return new L(new c)}static forStrings(){return new L(new R)}static forConfigKeys(){return new L(new y)}clear(){this._root=void 0}fill(t,s){if(s){const u=s.slice(0);(0,f.shuffle)(u);for(let d of u)this.set(d,t)}else{const u=t.slice(0);(0,f.shuffle)(u);for(let d of u)this.set(d[0],d[1])}}set(t,s){const u=this._iter.reset(t);let d;this._root||(this._root=new p,this._root.segment=u.value());const h=[];for(d=this._root;;){const l=u.cmp(d.segment);if(l>0)d.left||(d.left=new p,d.left.segment=u.value()),h.push([-1,d]),d=d.left;else if(l<0)d.right||(d.right=new p,d.right.segment=u.value()),h.push([1,d]),d=d.right;else if(u.hasNext())u.next(),d.mid||(d.mid=new p,d.mid.segment=u.value()),h.push([0,d]),d=d.mid;else break}const g=d.value;d.value=s,d.key=t;for(let l=h.length-1;l>=0;l--){const D=h[l][1];D.updateHeight();const A=D.balanceFactor();if(A<-1||A>1){const N=h[l][0],B=h[l+1][0];if(N===1&&B===1)h[l][1]=D.rotateLeft();else if(N===-1&&B===-1)h[l][1]=D.rotateRight();else if(N===1&&B===-1)D.right=h[l+1][1]=h[l+1][1].rotateRight(),h[l][1]=D.rotateLeft();else if(N===-1&&B===1)D.left=h[l+1][1]=h[l+1][1].rotateLeft(),h[l][1]=D.rotateRight();else throw new Error;if(l>0)switch(h[l-1][0]){case-1:h[l-1][1].left=h[l][1];break;case 1:h[l-1][1].right=h[l][1];break;case 0:h[l-1][1].mid=h[l][1];break}else this._root=h[0][1]}}return g}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let u=this._root;for(;u;){const d=s.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const u=this._iter.reset(t),d=[];let h=this._root;for(;h;){const g=u.cmp(h.segment);if(g>0)d.push([-1,h]),h=h.left;else if(g<0)d.push([1,h]),h=h.right;else if(u.hasNext())u.next(),d.push([0,h]),h=h.mid;else break}if(!!h){if(s?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this._min(h.right),{key:l,value:D,segment:A}=g;this._delete(g.key,!1),h.key=l,h.value=D,h.segment=A}else{const g=h.left??h.right;if(d.length>0){const[l,D]=d[d.length-1];switch(l){case-1:D.left=g;break;case 0:D.mid=g;break;case 1:D.right=g;break}}else this._root=g}for(let g=d.length-1;g>=0;g--){const l=d[g][1];l.updateHeight();const D=l.balanceFactor();if(D>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),d[g][1]=l.rotateLeft()):D<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),d[g][1]=l.rotateRight()),g>0)switch(d[g-1][0]){case-1:d[g-1][1].left=d[g][1];break;case 1:d[g-1][1].right=d[g][1];break;case 0:d[g-1][1].mid=d[g][1];break}else this._root=d[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let u=this._root,d;for(;u;){const h=s.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(s.hasNext())s.next(),d=u.value||d,u=u.mid;else break}return u&&u.value||d}findSuperstr(t){const s=this._iter.reset(t);let u=this._root;for(;u;){const d=s.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(t){for(const[s,u]of this)t(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const u=s.balanceFactor();return u<-1||u>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=L;class S{constructor(t,s){this.uri=t,this.value=s}}class o{constructor(t,s){this[k]="ResourceMap",t instanceof o?(this.map=new Map(t.map),this.toKey=s??o.defaultToKey):(this.map=new Map,this.toKey=t??o.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new S(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[u,d]of this.map)t(d.value,d.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=o,o.defaultToKey=n=>n.toString();var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class m{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const u=this._map.get(t);if(!!u)return s!==0&&this.touch(u,s),u.value}set(t,s,u=0){let d=this._map.get(t);if(d)d.value=s,u!==0&&this.touch(d,u);else{switch(d={key:t,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(t,d),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const u=this._state;let d=this._head;for(;d;){if(s?t.bind(s)(d.value,d.key,this):t(d.value,d.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const t=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const h={value:u.key,done:!1};return u=u.next,h}else return{value:void 0,done:!0}}};return d}values(){const t=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const h={value:u.value,done:!1};return u=u.next,h}else return{value:void 0,done:!0}}};return d}entries(){const t=this,s=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const h={value:[u.key,u.value],done:!1};return u=u.next,h}else return{value:void 0,done:!0}}};return d}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>t;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,u=t.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const u=t.next,d=t.previous;t===this._tail?(d.next=void 0,this._tail=d):(u.previous=d,d.next=u),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const u=t.next,d=t.previous;t===this._head?(u.previous=void 0,this._head=u):(u.previous=d,d.next=u),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,u)=>{t.push([u,s])}),t}fromJSON(t){this.clear();for(const[s,u]of t)this.set(s,u)}}e.LinkedMap=m;class a extends m{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class E{constructor(t){T.set(this,void 0),tt(this,T,t,"f")}get size(){return Le(this,T,"f").size}forEach(t,s){Le(this,T,"f").forEach(t,s)}get(t){return Le(this,T,"f").get(t)}has(t){return Le(this,T,"f").has(t)}entries(){return Le(this,T,"f").entries()}keys(){return Le(this,T,"f").keys()}values(){return Le(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Le(this,T,"f").entries()}}e.ReadonlyMapView=E}),define(ve[98],we([0,1,24,9]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Z){return function(ce,Se){for(let Be=0,qe=Z.length;Be<qe;Be++){const Ke=Z[Be](ce,Se);if(Ke)return Ke}return null}}e.or=k,e.matchesStrictPrefix=_.bind(void 0,!1),e.matchesPrefix=_.bind(void 0,!0);function _(Z,ce,Se){if(!Se||Se.length<ce.length)return null;let Be;return Z?Be=i.startsWithIgnoreCase(Se,ce):Be=Se.indexOf(ce)===0,Be?ce.length>0?[{start:0,end:ce.length}]:[]:null}function T(Z,ce){const Se=ce.toLowerCase().indexOf(Z.toLowerCase());return Se===-1?null:[{start:Se,end:Se+Z.length}]}e.matchesContiguousSubString=T;function I(Z,ce){return C(Z.toLowerCase(),ce.toLowerCase(),0,0)}e.matchesSubString=I;function C(Z,ce,Se,Be){if(Se===Z.length)return[];if(Be===ce.length)return null;if(Z[Se]===ce[Be]){let qe=null;return(qe=C(Z,ce,Se+1,Be+1))?L({start:Be,end:Be+1},qe):null}return C(Z,ce,Se,Be+1)}function P(Z){return 97<=Z&&Z<=122}function R(Z){return 65<=Z&&Z<=90}e.isUpper=R;function y(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>b.add(Z.charCodeAt(0)));function v(Z){return c(Z)||b.has(Z)}function p(Z,ce){return Z===ce||v(Z)&&v(ce)}function w(Z){return P(Z)||R(Z)||y(Z)}function L(Z,ce){return ce.length===0?ce=[Z]:Z.end===ce[0].start?ce[0].start=Z.start:ce.unshift(Z),ce}function S(Z,ce){for(let Se=ce;Se<Z.length;Se++){const Be=Z.charCodeAt(Se);if(R(Be)||y(Be)||Se>0&&!w(Z.charCodeAt(Se-1)))return Se}return Z.length}function o(Z,ce,Se,Be){if(Se===Z.length)return[];if(Be===ce.length)return null;if(Z[Se]!==ce[Be].toLowerCase())return null;{let qe=null,Ke=Be+1;for(qe=o(Z,ce,Se+1,Be+1);!qe&&(Ke=S(ce,Ke))<ce.length;)qe=o(Z,ce,Se+1,Ke),Ke++;return qe===null?null:L({start:Be,end:Be+1},qe)}}function r(Z){let ce=0,Se=0,Be=0,qe=0,Ke=0;for(let nt=0;nt<Z.length;nt++)Ke=Z.charCodeAt(nt),R(Ke)&&ce++,P(Ke)&&Se++,w(Ke)&&Be++,y(Ke)&&qe++;const Je=ce/Z.length,it=Se/Z.length,at=Be/Z.length,et=qe/Z.length;return{upperPercent:Je,lowerPercent:it,alphaPercent:at,numericPercent:et}}function m(Z){const{upperPercent:ce,lowerPercent:Se}=Z;return Se===0&&ce>.6}function a(Z){const{upperPercent:ce,lowerPercent:Se,alphaPercent:Be,numericPercent:qe}=Z;return Se>.2&&ce<.8&&Be>.6&&qe<.2}function E(Z){let ce=0,Se=0,Be=0,qe=0;for(let Ke=0;Ke<Z.length;Ke++)Be=Z.charCodeAt(Ke),R(Be)&&ce++,P(Be)&&Se++,c(Be)&&qe++;return(ce===0||Se===0)&&qe===0?Z.length<=30:ce<=5}function n(Z,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!E(Z)||ce.length>60)return null;const Se=r(ce);if(!a(Se)){if(!m(Se))return null;ce=ce.toLowerCase()}let Be=null,qe=0;for(Z=Z.toLowerCase();qe<ce.length&&(Be=o(Z,ce,0,qe))===null;)qe=S(ce,qe+1);return Be}e.matchesCamelCase=n;function t(Z,ce,Se=!1){if(!ce||ce.length===0)return null;let Be=null,qe=0;for(Z=Z.toLowerCase(),ce=ce.toLowerCase();qe<ce.length&&(Be=s(Z,ce,0,qe,Se))===null;)qe=u(ce,qe+1);return Be}e.matchesWords=t;function s(Z,ce,Se,Be,qe){if(Se===Z.length)return[];if(Be===ce.length)return null;if(p(Z.charCodeAt(Se),ce.charCodeAt(Be))){let Ke=null,Je=Be+1;if(Ke=s(Z,ce,Se+1,Be+1,qe),!qe)for(;!Ke&&(Je=u(ce,Je))<ce.length;)Ke=s(Z,ce,Se+1,Je,qe),Je++;return Ke===null?null:L({start:Be,end:Be+1},Ke)}else return null}function u(Z,ce){for(let Se=ce;Se<Z.length;Se++)if(v(Z.charCodeAt(Se))||Se>0&&v(Z.charCodeAt(Se-1)))return Se;return Z.length}const d=k(e.matchesPrefix,n,T),h=k(e.matchesPrefix,n,I),g=new f.LRUCache(1e4);function l(Z,ce,Se=!1){if(typeof Z!="string"||typeof ce!="string")return null;let Be=g.get(Z);Be||(Be=new RegExp(i.convertSimple2RegExpPattern(Z),"i"),g.set(Z,Be));const qe=Be.exec(ce);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:Se?h(Z,ce):d(Z,ce)}e.matchesFuzzy=l;function D(Z,ce){const Se=ke(Z,Z.toLowerCase(),0,ce,ce.toLowerCase(),0,!0);return Se?N(Se):null}e.matchesFuzzy2=D;function A(Z,ce,Se,Be,qe,Ke){const Je=Math.min(13,Z.length);for(;Se<Je;Se++){const it=ke(Z,ce,Se,Be,qe,Ke,!1);if(it)return it}return[0,Ke]}e.anyScore=A;function N(Z){if(typeof Z=="undefined")return[];const ce=[],Se=Z[1];for(let Be=Z.length-1;Be>1;Be--){const qe=Z[Be]+Se,Ke=ce[ce.length-1];Ke&&Ke.end===qe?Ke.end=qe+1:ce.push({start:qe,end:qe+1})}return ce}e.createMatches=N;const B=128;function F(){const Z=[],ce=[];for(let Se=0;Se<=B;Se++)ce[Se]=0;for(let Se=0;Se<=B;Se++)Z.push(ce.slice(0));return Z}function O(Z){const ce=[];for(let Se=0;Se<=Z;Se++)ce[Se]=0;return ce}const z=O(2*B),W=O(2*B),M=F(),x=F(),V=F(),U=!1;function H(Z,ce,Se,Be,qe){function Ke(it,at,et=" "){for(;it.length<at;)it=et+it;return it}let Je=` |   |${Be.split("").map(it=>Ke(it,3)).join("|")}
`;for(let it=0;it<=Se;it++)it===0?Je+=" |":Je+=`${ce[it-1]}|`,Je+=Z[it].slice(0,qe+1).map(at=>Ke(at.toString(),3)).join("|")+`
`;return Je}function Y(Z,ce,Se,Be){Z=Z.substr(ce),Se=Se.substr(Be),console.log(H(x,Z,Z.length,Se,Se.length)),console.log(H(V,Z,Z.length,Se,Se.length)),console.log(H(M,Z,Z.length,Se,Se.length))}function se(Z,ce){if(ce<0||ce>=Z.length)return!1;const Se=Z.codePointAt(ce);switch(Se){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(Se)}}function K(Z,ce){if(ce<0||ce>=Z.length)return!1;switch(Z.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function j(Z,ce,Se){return ce[Z]!==Se[Z]}function ne(Z,ce,Se,Be,qe,Ke,Je=!1){for(;ce<Se&&qe<Ke;)Z[ce]===Be[qe]&&(Je&&(z[ce]=qe),ce+=1),qe+=1;return ce===Se}e.isPatternInWord=ne;var le;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(le||(le={}));var ge;(function(Z){Z.Default=[-100,0];function ce(Se){return!Se||Se.length===2&&Se[0]===-100&&Se[1]===0}Z.isDefault=ce})(ge=e.FuzzyScore||(e.FuzzyScore={}));function ke(Z,ce,Se,Be,qe,Ke,Je){const it=Z.length>B?B:Z.length,at=Be.length>B?B:Be.length;if(Se>=it||Ke>=at||it-Se>at-Ke||!ne(ce,Se,it,qe,Ke,at,!0))return;Me(it,at,Se,Ke,ce,qe);let et=1,nt=1,ct=Se,vt=Ke;const We=[!1];for(et=1,ct=Se;ct<it;et++,ct++){const ie=z[ct],Ce=W[ct],Fe=ct+1<it?W[ct+1]:at;for(nt=ie-Ke+1,vt=ie;vt<Fe;nt++,vt++){let Ge=Number.MIN_SAFE_INTEGER,ze=!1;vt<=Ce&&(Ge=Ue(Z,ce,ct,Se,Be,qe,vt,at,Ke,M[et-1][nt-1]===0,We));let ut=0;Ge!==Number.MAX_SAFE_INTEGER&&(ze=!0,ut=Ge+x[et-1][nt-1]);const Ae=vt>ie,Te=Ae?x[et][nt-1]+(M[et][nt-1]>0?-5:0):0,De=vt>ie+1&&M[et][nt-1]>0,oe=De?x[et][nt-2]+(M[et][nt-2]>0?-5:0):0;if(De&&(!Ae||oe>=Te)&&(!ze||oe>=ut))x[et][nt]=oe,V[et][nt]=3,M[et][nt]=0;else if(Ae&&(!ze||Te>=ut))x[et][nt]=Te,V[et][nt]=2,M[et][nt]=0;else if(ze)x[et][nt]=ut,V[et][nt]=1,M[et][nt]=M[et-1][nt-1]+1;else throw new Error("not possible")}}if(U&&Y(Z,Se,Be,Ke),!We[0]&&!Je)return;et--,nt--;const At=[x[et][nt],Ke];let ee=0,te=0;for(;et>=1;){let ie=nt;do{const Ce=V[et][ie];if(Ce===3)ie=ie-2;else if(Ce===2)ie=ie-1;else break}while(ie>=1);ee>1&&ce[Se+et-1]===qe[Ke+nt-1]&&!j(ie+Ke-1,Be,qe)&&ee+1>M[et][ie]&&(ie=nt),ie===nt?ee++:ee=1,te||(te=ie),et--,nt=ie-1,At.push(nt)}at===it&&(At[0]+=2);const Ee=te-it;return At[0]-=Ee,At}e.fuzzyScore=ke;function Me(Z,ce,Se,Be,qe,Ke){let Je=Z-1,it=ce-1;for(;Je>=Se&&it>=Be;)qe[Je]===Ke[it]&&(W[Je]=it,Je--),it--}function Ue(Z,ce,Se,Be,qe,Ke,Je,it,at,et,nt){if(ce[Se]!==Ke[Je])return Number.MIN_SAFE_INTEGER;let ct=1,vt=!1;return Je===Se-Be?ct=Z[Se]===qe[Je]?7:5:j(Je,qe,Ke)&&(Je===0||!j(Je-1,qe,Ke))?(ct=Z[Se]===qe[Je]?7:5,vt=!0):se(Ke,Je)&&(Je===0||!se(Ke,Je-1))?ct=5:(se(Ke,Je-1)||K(Ke,Je-1))&&(ct=5,vt=!0),ct>1&&Se===Be&&(nt[0]=!0),vt||(vt=j(Je,qe,Ke)||se(Ke,Je-1)||K(Ke,Je-1)),Se===Be?Je>at&&(ct-=vt?3:5):et?ct+=vt?2:0:ct+=vt?0:1,Je+1===it&&(ct-=vt?3:5),ct}function q(Z,ce,Se,Be,qe,Ke,Je){return re(Z,ce,Se,Be,qe,Ke,!0,Je)}e.fuzzyScoreGracefulAggressive=q;function J(Z,ce,Se,Be,qe,Ke,Je){return re(Z,ce,Se,Be,qe,Ke,!1,Je)}e.fuzzyScoreGraceful=J;function re(Z,ce,Se,Be,qe,Ke,Je,it){let at=ke(Z,ce,Se,Be,qe,Ke,it);if(at&&!Je)return at;if(Z.length>=3){const et=Math.min(7,Z.length-1);for(let nt=Se+1;nt<et;nt++){const ct=he(Z,nt);if(ct){const vt=ke(ct,ct.toLowerCase(),Se,Be,qe,Ke,it);vt&&(vt[0]-=3,(!at||vt[0]>at[0])&&(at=vt))}}}return at}function he(Z,ce){if(ce+1>=Z.length)return;const Se=Z[ce],Be=Z[ce+1];if(Se!==Be)return Z.slice(0,ce)+Be+Se+Z.slice(ce+2)}}),define(ve[142],we([0,1,74,98,9]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const _=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(f.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${_.source}`,"g");function C(w){return w.replace(I,(L,S)=>S?L:`\\${L}`)}e.escapeIcons=C;const P=new RegExp(`\\\\${_.source}`,"g");function R(w){return w.replace(P,L=>`\\${L}`)}e.markdownEscapeEscapedIcons=R;const y=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function c(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(y,(L,S,o,r)=>o?L:S||r||"")}e.stripIcons=c;function b(w){const L=w.indexOf(e.iconStartMarker);return L===-1?{text:w}:v(w,L)}e.parseLabelWithIcons=b;function v(w,L){const S=[];let o="";function r(d){if(d){o+=d;for(const h of d)S.push(E)}}let m=-1,a="",E=0,n,t,s=L;const u=w.length;for(r(w.substr(0,L));s<u;)n=w[s],t=w[s+1],n===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(m=s,r(a),a=e.iconStartMarker,s++):n===")"&&m!==-1?(E+=s-m+1,m=-1,a=""):m!==-1?T.test(n)?a+=n:(r(a),m=-1,a=""):r(n),s++;return r(a),{text:o,iconOffsets:S}}function p(w,L,S=!1){const{text:o,iconOffsets:r}=L;if(!r||r.length===0)return(0,i.matchesFuzzy)(w,o,S);const m=(0,k.ltrim)(o," "),a=o.length-m.length,E=(0,i.matchesFuzzy)(w,m,S);if(E)for(const n of E){const t=r[n.start+a]+a;n.start+=t,n.end+=t}return E}e.matchesFuzzyIconAware=p}),define(ve[99],we([0,1,15,142]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(b="",v=!1){if(this.value=b,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(b,v=0){return this.value+=P(this.supportThemeIcons?(0,i.escapeIcons)(b):b).replace(/([ \t]+)/g,(p,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,v){return this.value+="\n```",this.value+=b,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}}e.MarkdownString=_;function T(c){return I(c)?!c.value:Array.isArray(c)?c.every(T):!0}e.isEmptyMarkdownString=T;function I(c){return c instanceof _?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function C(c,b){return c===b?!0:!c||!b?!1:c.value===b.value&&c.isTrusted===b.isTrusted&&c.supportThemeIcons===b.supportThemeIcons}e.markdownStringEqual=C;function P(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function R(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function y(c){const b=[],v=c.split("|").map(w=>w.trim());c=v[0];const p=v[1];if(p){const w=/height=(\d+)/.exec(p),L=/width=(\d+)/.exec(p),S=w?w[1]:"",o=L?L[1]:"",r=isFinite(parseInt(o)),m=isFinite(parseInt(S));r&&b.push(`width="${o}"`),m&&b.push(`height="${S}"`)}return{href:c,dimensions:b}}e.parseHrefAndDimensions=y}),define(ve[80],we([0,1,24]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new f.LRUCache(1e4);function k(P){return C(P,"NFC",i)}e.normalizeNFC=k;const _=new f.LRUCache(1e4);function T(P){return C(P,"NFD",_)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function C(P,R,y){if(!P)return P;const c=y.get(P);if(c)return c;let b;return I.test(P)?b=P.normalize(R):b=P,y.set(P,b),b}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(R){return T(R).replace(P,"")}}()}),define(ve[48],we([0,1,9]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(i||(i={})),function(k){const _="error",T="warning",I="warn",C="info",P="ignore";function R(c){return c?f.equalsIgnoreCase(_,c)?k.Error:f.equalsIgnoreCase(T,c)||f.equalsIgnoreCase(I,c)?k.Warning:f.equalsIgnoreCase(C,c)?k.Info:k.Ignore:k.Ignore}k.fromValue=R;function y(c){switch(c){case k.Error:return _;case k.Warning:return T;case k.Info:return C;default:return P}}k.toString=y}(i||(i={})),e.default=i}),define(ve[13],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(h){return Array.isArray(h)}e.isArray=f;function i(h){return typeof h=="string"}e.isString=i;function k(h){return Array.isArray(h)&&h.every(g=>i(g))}e.isStringArray=k;function _(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=_;function T(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=T;function I(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=I;function C(h){return h===!0||h===!1}e.isBoolean=C;function P(h){return typeof h=="undefined"}e.isUndefined=P;function R(h){return!y(h)}e.isDefined=R;function y(h){return P(h)||h===null}e.isUndefinedOrNull=y;function c(h,g){if(!h)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=c;function b(h){if(y(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=b;function v(...h){const g=[];for(let l=0;l<h.length;l++){const D=h[l];if(y(D))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);g.push(D)}return g}e.assertAllDefined=v;const p=Object.prototype.hasOwnProperty;function w(h){if(!_(h))return!1;for(let g in h)if(p.call(h,g))return!1;return!0}e.isEmptyObject=w;function L(h){return typeof h=="function"}e.isFunction=L;function S(...h){return h.length>0&&h.every(L)}e.areFunctions=S;function o(h,g){const l=Math.min(h.length,g.length);for(let D=0;D<l;D++)r(h[D],g[D])}e.validateConstraints=o;function r(h,g){if(i(g)){if(typeof h!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(L(g)){try{if(h instanceof g)return}catch{}if(!y(h)&&h.constructor===g||g.length===1&&g.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function m(h){let g=[],l=Object.getPrototypeOf(h);for(;Object.prototype!==l;)g=g.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return g}e.getAllPropertyNames=m;function a(h){const g=[];for(const l of m(h))typeof h[l]=="function"&&g.push(l);return g}e.getAllMethodNames=a;function E(h,g){const l=A=>function(){const N=Array.prototype.slice.call(arguments,0);return g(A,N)};let D={};for(const A of h)D[A]=l(A);return D}e.createProxyObject=E;function n(h){return h===null?void 0:h}e.withNullAsUndefined=n;function t(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=t;function s(h){return class{constructor(){return new Proxy({},{get(g,l){if(g[l])return g[l];throw new Error(`Not Implemented: ${h}->${String(l)}`)}})}}}e.NotImplementedProxy=s;function u(h,g="Unreachable"){throw new Error(g)}e.assertNever=u;function d(h){return!!h&&typeof h.then=="function"&&typeof h.catch=="function"}e.isPromise=d}),define(ve[28],we([0,1,8,12,9,13]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function I(s){return s.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=I;function C(s){return s.indexOf("/")===-1&&(s=I(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function P(s,u=f.posix.sep){if(!s)return"";const d=s.length,h=s.charCodeAt(0);if(T(h)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let l=3;const D=l;for(;l<d&&!T(s.charCodeAt(l));l++);if(D!==l&&!T(s.charCodeAt(l+1))){for(l+=1;l<d;l++)if(T(s.charCodeAt(l)))return s.slice(0,l+1).replace(/[\\/]/g,u)}}return u}else if(L(h)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+u:s.slice(0,2);let g=s.indexOf("://");if(g!==-1){for(g+=3;g<d;g++)if(T(s.charCodeAt(g)))return s.slice(0,g+1)}return""}e.getRoot=P;function R(s){if(!i.isWindows||!s||s.length<5)return!1;let u=s.charCodeAt(0);if(u!==92||(u=s.charCodeAt(1),u!==92))return!1;let d=2;const h=d;for(;d<s.length&&(u=s.charCodeAt(d),u!==92);d++);return!(h===d||(u=s.charCodeAt(d+1),isNaN(u)||u===92))}e.isUNC=R;const y=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(s,u=i.isWindows){const d=u?y:c;return!(!s||s.length===0||/^\s+$/.test(s)||(d.lastIndex=0,d.test(s))||u&&b.test(s)||s==="."||s===".."||u&&s[s.length-1]==="."||u&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=v;function p(s,u,d){const h=s===u;return!d||h?h:!s||!u?!1:(0,k.equalsIgnoreCase)(s,u)}e.isEqual=p;function w(s,u,d,h=f.sep){if(s===u)return!0;if(!s||!u||u.length>s.length)return!1;if(d){if(!(0,k.startsWithIgnoreCase)(s,u))return!1;if(u.length===s.length)return!0;let l=u.length;return u.charAt(u.length-1)===h&&l--,s.charAt(l)===h}return u.charAt(u.length-1)!==h&&(u+=h),s.indexOf(u)===0}e.isEqualOrParent=w;function L(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=L;function S(s,u){return i.isWindows&&s.endsWith(":")&&(s+=f.sep),(0,f.isAbsolute)(s)||(s=(0,f.join)(u,s)),s=(0,f.normalize)(s),i.isWindows?(s=(0,k.rtrim)(s,f.sep),s.endsWith(":")&&(s+=f.sep)):(s=(0,k.rtrim)(s,f.sep),s||(s=f.sep)),s}e.sanitizeFilePath=S;function o(s){const u=(0,f.normalize)(s);return i.isWindows?s.length>3?!1:r(u)&&(s.length===2||u.charCodeAt(2)===92):u===f.posix.sep}e.isRootOrDriveLetter=o;function r(s,u){return(u!==void 0?u:i.isWindows)?L(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function m(s){return r(s)?s[0]:void 0}e.getDriveLetter=m;function a(s,u,d){return u.length>s.length?-1:s===u?0:(d&&(s=s.toLowerCase(),u=u.toLowerCase()),s.indexOf(u))}e.indexOfPath=a;function E(s){const u=s.split(":");let d,h,g;for(const l of u){const D=Number(l);(0,_.isNumber)(D)?h===void 0?h=D:g===void 0&&(g=D):d=d?[d,l].join(":"):l}if(!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=E;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(s,u,d=8){let h="";for(let l=0;l<d;l++)h+=n.charAt(Math.floor(Math.random()*n.length));let g;return u?g=`${u}-${h}`:g=h,s?(0,f.join)(s,g):g}e.randomPath=t}),define(ve[25],we([0,1,13]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const w=Array.isArray(p)?[]:{};return Object.keys(p).forEach(L=>{p[L]&&typeof p[L]=="object"?w[L]=i(p[L]):w[L]=p[L]}),w}e.deepClone=i;function k(p){if(!p||typeof p!="object")return p;const w=[p];for(;w.length>0;){const L=w.shift();Object.freeze(L);for(const S in L)if(_.call(L,S)){const o=L[S];typeof o=="object"&&!Object.isFrozen(o)&&w.push(o)}}return p}e.deepFreeze=k;const _=Object.prototype.hasOwnProperty;function T(p,w){return I(p,w,new Set)}e.cloneAndChange=T;function I(p,w,L){if((0,f.isUndefinedOrNull)(p))return p;const S=w(p);if(typeof S!="undefined")return S;if((0,f.isArray)(p)){const o=[];for(const r of p)o.push(I(r,w,L));return o}if((0,f.isObject)(p)){if(L.has(p))throw new Error("Cannot clone recursive data-structure");L.add(p);const o={};for(let r in p)_.call(p,r)&&(o[r]=I(p[r],w,L));return L.delete(p),o}return p}function C(p,w,L=!0){return(0,f.isObject)(p)?((0,f.isObject)(w)&&Object.keys(w).forEach(S=>{S in p?L&&((0,f.isObject)(p[S])&&(0,f.isObject)(w[S])?C(p[S],w[S],L):p[S]=w[S]):p[S]=w[S]}),p):w}e.mixin=C;function P(p,w){if(p===w)return!0;if(p==null||w===null||w===void 0||typeof p!=typeof w||typeof p!="object"||Array.isArray(p)!==Array.isArray(w))return!1;let L,S;if(Array.isArray(p)){if(p.length!==w.length)return!1;for(L=0;L<p.length;L++)if(!P(p[L],w[L]))return!1}else{const o=[];for(S in p)o.push(S);o.sort();const r=[];for(S in w)r.push(S);if(r.sort(),!P(o,r))return!1;for(L=0;L<o.length;L++)if(!P(p[o[L]],w[o[L]]))return!1}return!0}e.equals=P;function R(p){const w=new Set;return JSON.stringify(p,(L,S)=>{if((0,f.isObject)(S)||Array.isArray(S)){if(w.has(S))return"[Circular]";w.add(S)}return S})}e.safeStringify=R;function y(p,w,L){const S=w(p);return typeof S=="undefined"?L:S}e.getOrDefault=y;function c(p,w){const L=Object.create(null);return!p||!w||Object.keys(w).forEach(o=>{const r=p[o],m=w[o];P(r,m)||(L[o]=m)}),L}e.distinct=c;function b(p,w){const L=w.toLowerCase(),S=Object.keys(p).find(o=>o.toLowerCase()===L);return S?p[S]:p[w]}e.getCaseInsensitive=b;function v(p,w){const L=Object.create(null);for(const[S,o]of Object.entries(p))w(S,o)&&(L[S]=o);return L}e.filter=v}),define(ve[100],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(_){_[_.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",_[_.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",_[_.MAX_UINT_8=255]="MAX_UINT_8",_[_.MAX_UINT_16=65535]="MAX_UINT_16",_[_.MAX_UINT_32=4294967295]="MAX_UINT_32",_[_.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function i(_){return _<0?0:_>255?255:_|0}e.toUint8=i;function k(_){return _<0?0:_>4294967295?4294967295:_|0}e.toUint32=k}),define(ve[2],we([0,1,8,12]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,_=/^\//,T=/^\/\//;function I(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!_.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(n,t){return!n&&!t?"file":n}function P(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==y&&(t=y+t):t=y;break}return t}const R="",y="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(t,s,u,d,h,g=!1){typeof t=="object"?(this.scheme=t.scheme||R,this.authority=t.authority||R,this.path=t.path||R,this.query=t.query||R,this.fragment=t.fragment||R):(this.scheme=C(t,g),this.authority=s||R,this.path=P(this.scheme,u||R),this.query=d||R,this.fragment=h||R,I(this,g))}static isUri(t){return t instanceof b?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return o(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:u,path:d,query:h,fragment:g}=t;return s===void 0?s=this.scheme:s===null&&(s=R),u===void 0?u=this.authority:u===null&&(u=R),d===void 0?d=this.path:d===null&&(d=R),h===void 0?h=this.query:h===null&&(h=R),g===void 0?g=this.fragment:g===null&&(g=R),s===this.scheme&&u===this.authority&&d===this.path&&h===this.query&&g===this.fragment?this:new p(s,u,d,h,g)}static parse(t,s=!1){const u=c.exec(t);return u?new p(u[2]||R,E(u[4]||R),E(u[5]||R),E(u[7]||R),E(u[9]||R),s):new p(R,R,R,R,R)}static file(t){let s=R;if(i.isWindows&&(t=t.replace(/\\/g,y)),t[0]===y&&t[1]===y){const u=t.indexOf(y,2);u===-1?(s=t.substring(2),t=y):(s=t.substring(2,u),t=t.substring(u)||y)}return new p("file",s,t,R,R)}static from(t){const s=new p(t.scheme,t.authority,t.path,t.query,t.fragment);return I(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return i.isWindows&&t.scheme==="file"?u=b.file(f.win32.join(o(t,!0),...s)).path:u=f.posix.join(t.path,...s),t.with({path:u})}toString(t=!1){return r(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof b)return t;{const s=new p(t);return s._formatted=t.external,s._fsPath=t._sep===v?t.fsPath:null,s}}else return t}}e.URI=b;const v=i.isWindows?1:void 0;class p extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(t=!1){return t?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=v),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function L(n,t){let s,u=-1;for(let d=0;d<n.length;d++){const h=n.charCodeAt(d);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)u!==-1&&(s+=encodeURIComponent(n.substring(u,d)),u=-1),s!==void 0&&(s+=n.charAt(d));else{s===void 0&&(s=n.substr(0,d));const g=w[h];g!==void 0?(u!==-1&&(s+=encodeURIComponent(n.substring(u,d)),u=-1),s+=g):u===-1&&(u=d)}}return u!==-1&&(s+=encodeURIComponent(n.substring(u))),s!==void 0?s:n}function S(n){let t;for(let s=0;s<n.length;s++){const u=n.charCodeAt(s);u===35||u===63?(t===void 0&&(t=n.substr(0,s)),t+=w[u]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function o(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=o;function r(n,t){const s=t?S:L;let u="",{scheme:d,authority:h,path:g,query:l,fragment:D}=n;if(d&&(u+=d,u+=":"),(h||d==="file")&&(u+=y,u+=y),h){let A=h.indexOf("@");if(A!==-1){const N=h.substr(0,A);h=h.substr(A+1),A=N.indexOf(":"),A===-1?u+=s(N,!1):(u+=s(N.substr(0,A),!1),u+=":",u+=s(N.substr(A+1),!1)),u+="@"}h=h.toLowerCase(),A=h.indexOf(":"),A===-1?u+=s(h,!1):(u+=s(h.substr(0,A),!1),u+=h.substr(A))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const A=g.charCodeAt(1);A>=65&&A<=90&&(g=`/${String.fromCharCode(A+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const A=g.charCodeAt(0);A>=65&&A<=90&&(g=`${String.fromCharCode(A+32)}:${g.substr(2)}`)}u+=s(g,!0)}return l&&(u+="?",u+=s(l,!1)),D&&(u+="#",u+=t?D:L(D,!1)),u}function m(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+m(n.substr(3)):n}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(n){return n.match(a)?n.replace(a,t=>m(t)):n}}),define(ve[59],we([0,1,22,9,2]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(R){return JSON.stringify(R,C)}e.stringify=_;function T(R){let y=JSON.parse(R);return y=P(y),y}e.parse=T;var I;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function C(R,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,i.regExpFlags)(y)}:y}function P(R,y=0){if(!R||y>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return k.URI.revive(R);case 2:return new RegExp(R.source,R.flags)}if(R instanceof f.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let c=0;c<R.length;++c)R[c]=P(R[c],y+1);else for(const c in R)Object.hasOwnProperty.call(R,c)&&(R[c]=P(R[c],y+1))}return R}e.revive=P}),define(ve[10],we([0,1,12,2]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(k=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,P,R){this._hosts[C]=P,this._ports[C]=R}setConnectionToken(C,P){this._connectionTokens[C]=P}rewrite(C){if(this._delegate)return this._delegate(C);const P=C.authority;let R=this._hosts[P];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const y=this._ports[P],c=this._connectionTokens[P];let b=`path=${encodeURIComponent(C.path)}`;return typeof c=="string"&&(b+=`&tkn=${encodeURIComponent(c)}`),i.URI.from({scheme:f.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${R}:${y}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new _;class T{asBrowserUri(C,P){const R=this.toUri(C,P);return R.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===k.file&&(f.isNative||typeof f.globals.importScripts=="function"&&f.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?R.with({scheme:k.vscodeFileResource,authority:R.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(C,P){const R=this.toUri(C,P);return R.scheme===k.vscodeFileResource?R.with({scheme:k.file,authority:R.authority!==T.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(C,P){return i.URI.isUri(C)?C:i.URI.parse(P.toUrl(C))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ve[23],we([0,1,28,10,8,12,9,2]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(b){return(0,I.uriToFsPath)(b,!0)}e.originalFSPath=C;class P{constructor(v){this._ignorePathCasing=v}compare(v,p,w=!1){return v===p?0:(0,T.compare)(this.getComparisonKey(v,w),this.getComparisonKey(p,w))}isEqual(v,p,w=!1){return v===p?!0:!v||!p?!1:this.getComparisonKey(v,w)===this.getComparisonKey(p,w)}getComparisonKey(v,p=!1){return v.with({path:this._ignorePathCasing(v)?v.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(v){return this._ignorePathCasing(v)}isEqualOrParent(v,p,w=!1){if(v.scheme===p.scheme){if(v.scheme===i.Schemas.file)return f.isEqualOrParent(C(v),C(p),this._ignorePathCasing(v))&&v.query===p.query&&(w||v.fragment===p.fragment);if((0,e.isEqualAuthority)(v.authority,p.authority))return f.isEqualOrParent(v.path,p.path,this._ignorePathCasing(v),"/")&&v.query===p.query&&(w||v.fragment===p.fragment)}return!1}joinPath(v,...p){return I.URI.joinPath(v,...p)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return k.posix.basename(v.path)}extname(v){return k.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let p;return v.scheme===i.Schemas.file?p=I.URI.file(k.dirname(C(v))).path:(p=k.posix.dirname(v.path),v.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),p="/")),v.with({path:p})}normalizePath(v){if(!v.path.length)return v;let p;return v.scheme===i.Schemas.file?p=I.URI.file(k.normalize(C(v))).path:p=k.posix.normalize(v.path),v.with({path:p})}relativePath(v,p){if(v.scheme!==p.scheme||!(0,e.isEqualAuthority)(v.authority,p.authority))return;if(v.scheme===i.Schemas.file){const S=k.relative(C(v),C(p));return _.isWindows?f.toSlashes(S):S}let w=v.path||"/",L=p.path||"/";if(this._ignorePathCasing(v)){let S=0;for(const o=Math.min(w.length,L.length);S<o&&!(w.charCodeAt(S)!==L.charCodeAt(S)&&w.charAt(S).toLowerCase()!==L.charAt(S).toLowerCase());S++);w=L.substr(0,S)+w.substr(S)}return k.posix.relative(w,L)}resolvePath(v,p){if(v.scheme===i.Schemas.file){const w=I.URI.file(k.resolve(C(v),p));return v.with({authority:w.authority,path:w.path})}return p=f.toPosixPath(p),v.with({path:k.posix.resolve(v.path,p)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,p){return v===p||v!==void 0&&p!==void 0&&(0,T.equalsIgnoreCase)(v,p)}hasTrailingPathSeparator(v,p=k.sep){if(v.scheme===i.Schemas.file){const w=C(v);return w.length>f.getRoot(w).length&&w[w.length-1]===p}else{const w=v.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,p=k.sep){return(0,e.hasTrailingPathSeparator)(v,p)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,p=k.sep){let w=!1;if(v.scheme===i.Schemas.file){const L=C(v);w=L!==void 0&&L.length===f.getRoot(L).length&&L[L.length-1]===p}else{p="/";const L=v.path;w=L.length===1&&L.charCodeAt(L.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(v,p)?v.with({path:v.path+"/"}):v}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(b=>b.scheme===i.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new P(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(b,v){const p=[];for(let w=0;w<b.length;w++){const L=v(b[w]);b.some((S,o)=>o===w?!1:(0,e.isEqualOrParent)(L,v(S)))||p.push(b[w])}return p}e.distinctParents=R;var y;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function v(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(o=>{const[r,m]=o.split(":");r&&m&&w.set(r,m)});const S=p.path.substring(0,p.path.indexOf(";"));return S&&w.set(b.META_DATA_MIME,S),w}b.parseMetaData=v})(y=e.DataUri||(e.DataUri={}));function c(b,v,p){if(v){let w=b.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),b.with({scheme:p,authority:v,path:w})}return b.with({scheme:p})}e.toLocalResource=c}),define(ve[18],we([0,1,21,15,3,6,23,12]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(K){return!!K&&typeof K.then=="function"}e.isThenable=C;function P(K){const j=new f.CancellationTokenSource,ne=K(j.token),le=new Promise((ge,ke)=>{const Me=j.token.onCancellationRequested(()=>{Me.dispose(),j.dispose(),ke((0,i.canceled)())});Promise.resolve(ne).then(Ue=>{Me.dispose(),j.dispose(),ge(Ue)},Ue=>{Me.dispose(),j.dispose(),ke(Ue)})});return new class{cancel(){j.cancel()}then(ge,ke){return le.then(ge,ke)}catch(ge){return this.then(void 0,ge)}finally(ge){return le.finally(ge)}}}e.createCancelablePromise=P;function R(K,j,ne){return Promise.race([K,new Promise(le=>j.onCancellationRequested(()=>le(ne)))])}e.raceCancellation=R;async function y(K){let j=-1;const ne=K.map((ge,ke)=>ge.then(Me=>(j=ke,Me))),le=await Promise.race(ne);return K.forEach((ge,ke)=>{ke!==j&&ge.cancel()}),le}e.raceCancellablePromises=y;function c(K,j,ne){let le;const ge=setTimeout(()=>{le?.(void 0),ne?.()},j);return Promise.race([K.finally(()=>clearTimeout(ge)),new Promise(ke=>le=ke)])}e.raceTimeout=c;function b(K){return new Promise((j,ne)=>{const le=K();C(le)?le.then(j,ne):j(le)})}e.asPromise=b;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const ne=()=>{this.queuedPromise=null;const le=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,le};this.queuedPromise=new Promise(le=>{this.activePromise.then(ne,ne).then(le)})}return new Promise((ne,le)=>{this.queuedPromise.then(ne,le)})}return this.activePromise=j(),new Promise((ne,le)=>{this.activePromise.then(ge=>{this.activePromise=null,ne(ge)},ge=>{this.activePromise=null,le(ge)})})}}e.Throttler=v;class p{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=p;class w{constructor(){this.promiseMap=new Map}queue(j,ne){const ge=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.promiseMap.get(j)===ge&&this.promiseMap.delete(j)});return this.promiseMap.set(j,ge),ge}}e.SequencerByKey=w;const L=(K,j)=>{let ne=!0;const le=setTimeout(()=>{ne=!1,j()},K);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(le),ne=!1}}},S=K=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,K())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class o{constructor(j){this.defaultDelay=j,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,ne=this.defaultDelay){this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,ke)=>{this.doResolve=ge,this.doReject=ke}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const le=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ne===e.MicrotaskDelay?S(le):L(ne,le),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,i.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=o;class r{constructor(j){this.delayer=new o(j),this.throttler=new v}trigger(j,ne){return this.delayer.trigger(()=>this.throttler.queue(j),ne)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=r;class m{constructor(){this._isOpen=!1,this._promise=new Promise((j,ne)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class a extends m{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function E(K,j){return j?new Promise((ne,le)=>{const ge=setTimeout(()=>{ke.dispose(),ne()},K),ke=j.onCancellationRequested(()=>{clearTimeout(ge),ke.dispose(),le((0,i.canceled)())})}):P(ne=>E(K,ne))}e.timeout=E;function n(K,j=0){const ne=setTimeout(K,j);return(0,_.toDisposable)(()=>clearTimeout(ne))}e.disposableTimeout=n;function t(K){const j=[];let ne=0;const le=K.length;function ge(){return ne<le?K[ne++]():null}function ke(Me){Me!=null&&j.push(Me);const Ue=ge();return Ue?Ue.then(ke):Promise.resolve(j)}return Promise.resolve(null).then(ke)}e.sequence=t;function s(K,j=le=>!!le,ne=null){let le=0;const ge=K.length,ke=()=>{if(le>=ge)return Promise.resolve(ne);const Me=K[le++];return Promise.resolve(Me()).then(q=>j(q)?Promise.resolve(q):ke())};return ke()}e.first=s;function u(K,j=le=>!!le,ne=null){if(K.length===0)return Promise.resolve(ne);let le=K.length;const ge=()=>{le=-1;for(const ke of K)ke.cancel?.()};return new Promise((ke,Me)=>{for(const Ue of K)Ue.then(q=>{--le>=0&&j(q)?(ge(),ke(q)):le===0&&ke(ne)}).catch(q=>{--le>=0&&(ge(),Me(q))})})}e.firstParallel=u;class d{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(j){return this._size++,new Promise((ne,le)=>{this.outstandingPromises.push({factory:j,c:ne,e:le}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const ne=j.factory();ne.then(j.c,j.e),ne.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class h extends d{constructor(){super(1)}}e.Queue=h;class g{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const j=new x;return this.drainers.add(j),j.p}isDrained(){for(const[,j]of this.queues)if(j.size>0)return!1;return!0}queueFor(j,ne=T.extUri){const le=ne.getComparisonKey(j);let ge=this.queues.get(le);return ge||(ge=new h,k.Event.once(ge.onFinished)(()=>{ge?.dispose(),this.queues.delete(le),this.onDidQueueFinish()}),this.queues.set(le,ge)),ge}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const j of this.drainers)j.complete();this.drainers.clear()}dispose(){for(const[,j]of this.queues)j.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=g;class l{constructor(j,ne){this._token=-1,typeof j=="function"&&typeof ne=="number"&&this.setIfNotSet(j,ne)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,ne){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},ne)}setIfNotSet(j,ne){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},ne))}}e.TimeoutTimer=l;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,ne){this.cancel(),this._token=setInterval(()=>{j()},ne)}}e.IntervalTimer=D;class A{constructor(j,ne){this.timeoutToken=-1,this.runner=j,this.timeout=ne,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class N{constructor(j,ne){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=ne,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class B extends A{constructor(j,ne){super(j,ne);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class F extends _.Disposable{constructor(j,ne,le,ge){super();this.maxWorkChunkSize=j,this.maxPendingWork=ne,this.throttleDelay=le,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.maxPendingWork)return!1}else if(this.pending+j.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...j),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,I.setTimeout0)(()=>{if(j)return;const ne=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ne-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(K,j)=>{const ne=requestIdleCallback(K,typeof j=="number"?{timeout:j}:void 0);let le=!1;return{dispose(){le||(le=!0,cancelIdleCallback(ne))}}}}();class O{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(ne){this._error=ne}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function z(K,j,ne){let le;for(let ge=0;ge<ne;ge++)try{return await K()}catch(ke){le=ke,await E(j)}throw le}e.retry=z;class W{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(j,ne,le){return this._pending={taskId:j,cancel:()=>le?.(),promise:ne},ne.then(()=>this.donePending(j),()=>this.donePending(j)),ne}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let ne,le;const ge=new Promise((ke,Me)=>{ne=ke,le=Me});this._next={run:j,promise:ge,promiseResolve:ne,promiseReject:le}}return this._next.promise}}e.TaskSequentializer=W;class M{constructor(j,ne=()=>Date.now()){this.interval=j,this.nowFn=ne,this.lastIncrementTime=0,this.value=0}increment(){const j=this.nowFn();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,ne)=>{this.completeCallback=j,this.errorCallback=ne})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(ne=>{this.completeCallback(j),this.resolved=!0,ne()})}error(j){return new Promise(ne=>{this.errorCallback(j),this.rejected=!0,ne()})}cancel(){new Promise(j=>{this.errorCallback((0,i.canceled)()),this.rejected=!0,j()})}}e.DeferredPromise=x;var V;(function(K){async function j(le){let ge;const ke=await Promise.all(le.map(Me=>Me.then(Ue=>Ue,Ue=>{ge||(ge=Ue)})));if(typeof ge!="undefined")throw ge;return ke}K.settled=j;function ne(le){return new Promise(async(ge,ke)=>{try{await le(ge,ke)}catch(Me){ke(Me)}})}K.withAsyncBody=ne})(V=e.Promises||(e.Promises={}));var U;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(U||(U={}));class H{constructor(j){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const ne={emitOne:le=>this.emitOne(le),emitMany:le=>this.emitMany(le),reject:le=>this.reject(le)};try{await Promise.resolve(j(ne)),this.resolve()}catch(le){this.reject(le)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}static fromArray(j){return new H(ne=>{ne.emitMany(j)})}static fromPromise(j){return new H(async ne=>{ne.emitMany(await j)})}static fromPromises(j){return new H(async ne=>{await Promise.all(j.map(async le=>ne.emitOne(await le)))})}static merge(j){return new H(async ne=>{await Promise.all(j.map(async le=>{for await(const ge of le)ne.emitOne(ge)}))})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(j<this._results.length)return{done:!1,value:this._results[j++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(j,ne){return new H(async le=>{for await(const ge of j)le.emitOne(ne(ge))})}map(j){return H.map(this,j)}static filter(j,ne){return new H(async le=>{for await(const ge of j)ne(ge)&&le.emitOne(ge)})}filter(j){return H.filter(this,j)}static coalesce(j){return H.filter(j,ne=>!!ne)}coalesce(){return H.coalesce(this)}static async toPromise(j){const ne=[];for await(const le of j)ne.push(le);return ne}toPromise(){return H.toPromise(this)}emitOne(j){this._state===0&&(this._results.push(j),this._onStateChanged.fire())}emitMany(j){this._state===0&&(this._results=this._results.concat(j),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(j){this._state===0&&(this._state=2,this._error=j,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Y extends H{constructor(j,ne){super(ne);this._source=j}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Y;function se(K){const j=new f.CancellationTokenSource,ne=K(j.token);return new Y(j,async le=>{const ge=j.token.onCancellationRequested(()=>{ge.dispose(),j.dispose(),le.reject((0,i.canceled)())});try{for await(const ke of ne){if(j.token.isCancellationRequested)return;le.emitOne(ke)}ge.dispose(),j.dispose()}catch(ke){ge.dispose(),j.dispose(),le.reject(ke)}})}e.createCancelableAsyncIterable=se}),define(ve[101],we([0,1,18,8]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new f.IdleValue(()=>{const g=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:g,collatorIsNumeric:g.resolvedOptions().numeric}}),_=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(g,l,D=!1){const A=g||"",N=l||"",B=k.value.collator.compare(A,N);return k.value.collatorIsNumeric&&B===0&&A!==N?A<N?-1:1:B}e.compareFileNames=I;function C(g,l){const D=_.value.collator;return g=g||"",l=l||"",m(D,g,l)}e.compareFileNamesDefault=C;function P(g,l){const D=_.value.collator;return g=g||"",l=l||"",t(g,l)||m(D,g,l)}e.compareFileNamesUpper=P;function R(g,l){const D=_.value.collator;return g=g||"",l=l||"",n(g,l)||m(D,g,l)}e.compareFileNamesLower=R;function y(g,l){return g=g||"",l=l||"",g===l?0:g<l?-1:1}e.compareFileNamesUnicode=y;function c(g,l,D=!1){D||(g=g&&g.toLowerCase(),l=l&&l.toLowerCase());const[A,N]=o(g),[B,F]=o(l);return A!==B?A<B?-1:1:N===F?0:N<F?-1:1}e.noIntlCompareFileNames=c;function b(g,l){const[D,A]=o(g),[N,B]=o(l);let F=k.value.collator.compare(A,B);if(F===0){if(k.value.collatorIsNumeric&&A!==B)return A<B?-1:1;if(F=k.value.collator.compare(D,N),k.value.collatorIsNumeric&&F===0&&D!==N)return D<N?-1:1}return F}e.compareFileExtensions=b;function v(g,l){g=g||"",l=l||"";const D=r(g),A=r(l),N=_.value.collator,B=T.value.collator;return m(B,D,A)||m(N,g,l)}e.compareFileExtensionsDefault=v;function p(g,l){g=g||"",l=l||"";const D=r(g),A=r(l),N=_.value.collator,B=T.value.collator;return m(B,D,A)||t(g,l)||m(N,g,l)}e.compareFileExtensionsUpper=p;function w(g,l){g=g||"",l=l||"";const D=r(g),A=r(l),N=_.value.collator,B=T.value.collator;return m(B,D,A)||n(g,l)||m(N,g,l)}e.compareFileExtensionsLower=w;function L(g,l){g=g||"",l=l||"";const D=r(g).toLowerCase(),A=r(l).toLowerCase();return D!==A?D<A?-1:1:g!==l?g<l?-1:1:0}e.compareFileExtensionsUnicode=L;const S=/^(.*?)(\.([^.]*))?$/;function o(g,l=!1){const D=g?S.exec(g):[];let A=[D&&D[1]||"",D&&D[3]||""];return l&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function r(g){const l=g?S.exec(g):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function m(g,l,D){let A=g.compare(l,D);return A!==0?A:l.length!==D.length?l.length<D.length?-1:1:0}function a(g){const l=g.charAt(0);return l.toLocaleUpperCase()!==l}function E(g){const l=g.charAt(0);return l.toLocaleLowerCase()!==l}function n(g,l){return a(g)&&E(l)?-1:E(g)&&a(l)?1:0}function t(g,l){return E(g)&&a(l)?-1:a(g)&&E(l)?1:0}function s(g,l,D=!1){return D||(g=g&&g.toLowerCase(),l=l&&l.toLowerCase()),g===l?0:g<l?-1:1}function u(g,l,D=!1){const A=g.split(i.sep),N=l.split(i.sep),B=A.length-1,F=N.length-1;let O,z;for(let W=0;;W++){if(O=B===W,z=F===W,O&&z)return I(A[W],N[W],D);if(O)return-1;if(z)return 1;const M=s(A[W],N[W],D);if(M!==0)return M}}e.comparePaths=u;function d(g,l,D){const A=g.toLowerCase(),N=l.toLowerCase(),B=h(g,l,D);if(B)return B;const F=A.endsWith(D),O=N.endsWith(D);if(F!==O)return F?-1:1;const z=I(A,N);return z!==0?z:A.localeCompare(N)}e.compareAnything=d;function h(g,l,D){const A=g.toLowerCase(),N=l.toLowerCase(),B=A.startsWith(D),F=N.startsWith(D);if(B!==F)return B?-1:1;if(B&&F){if(A.length<N.length)return-1;if(A.length>N.length)return 1}return 0}e.compareByPrefix=h}),define(ve[102],we([0,1,101,98,47,8,12,9]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,P=[C,[]];function R(M,x,V,U){if(!M||!x)return P;const H=M.length,Y=x.length;if(H<Y)return P;const se=M.toLowerCase();return y(x,V,Y,M,se,H,U)}e.scoreFuzzy=R;function y(M,x,V,U,H,Y,se){const K=[],j=[];for(let ke=0;ke<V;ke++){const Me=ke*Y,Ue=Me-Y,q=ke>0,J=M[ke],re=x[ke];for(let he=0;he<Y;he++){const Z=he>0,ce=Me+he,Se=ce-1,Be=Ue+he-1,qe=Z?K[Se]:0,Ke=q&&Z?K[Be]:0,Je=q&&Z?j[Be]:0;let it;!Ke&&q?it=0:it=c(J,re,U,H,he,Je),it&&Ke+it>=qe&&(se||q||H.startsWith(x,he))?(j[ce]=Je+1,K[ce]=Ke+it):(j[ce]=C,K[ce]=qe)}}const ne=[];let le=V-1,ge=Y-1;for(;le>=0&&ge>=0;){const ke=le*Y+ge;j[ke]===C||(ne.push(ge),le--),ge--}return[K[V*Y-1],ne.reverse()]}function c(M,x,V,U,H,Y){let se=0;if(!b(x,U[H]))return se;if(se+=1,Y>0&&(se+=Y*5),M===V[H]&&(se+=1),H===0)se+=8;else{const K=v(V.charCodeAt(H-1));K?se+=K:(0,i.isUpper)(V.charCodeAt(H))&&Y===0&&(se+=2)}return se}function b(M,x){return M===x?!0:M==="/"||M==="\\"?x==="/"||x==="\\":!1}function v(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function w(M,x,V=0,U=0){const H=x;return H.values&&H.values.length>1?L(M,H.values,V,U):S(M,x,V,U)}e.scoreFuzzy2=w;function L(M,x,V,U){let H=0;const Y=[];for(const se of x){const[K,j]=S(M,se,V,U);if(typeof K!="number")return p;H+=K,Y.push(...j)}return[H,h(Y)]}function S(M,x,V,U){const H=(0,i.fuzzyScore)(x.original,x.originalLowercase,V,M,M.toLowerCase(),U,!0);return H?[H[0],(0,i.createMatches)(H)]:p}const o=Object.freeze({score:0}),r=1<<18,m=1<<17,a=1<<16;function E(M,x,V,U){const H=U.values?U.values:[U];return(0,k.hash)({[U.normalized]:{values:H.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:M,description:x,allowNonContiguousMatches:V}})}function n(M,x,V,U,H){if(!M||!x.normalized)return o;const Y=U.getItemLabel(M);if(!Y)return o;const se=U.getItemDescription(M),K=E(Y,se,V,x),j=H[K];if(j)return j;const ne=t(Y,se,U.getItemPath(M),x,V);return H[K]=ne,ne}e.scoreItemFuzzy=n;function t(M,x,V,U,H){const Y=!V||!U.containsPathSeparator;return V&&(T.isLinux?U.pathNormalized===V:(0,I.equalsIgnoreCase)(U.pathNormalized,V))?{score:r,labelMatch:[{start:0,end:M.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:U.values&&U.values.length>1?s(M,x,V,U.values,Y,H):u(M,x,V,U,Y,H)}function s(M,x,V,U,H,Y){let se=0;const K=[],j=[];for(const ne of U){const{score:le,labelMatch:ge,descriptionMatch:ke}=u(M,x,V,ne,H,Y);if(le===C)return o;se+=le,ge&&K.push(...ge),ke&&j.push(...ke)}return{score:se,labelMatch:h(K),descriptionMatch:h(j)}}function u(M,x,V,U,H,Y){if(H||!x){const[se,K]=R(M,U.normalized,U.normalizedLowercase,Y&&!U.expectContiguousMatch);if(se){const j=(0,i.matchesPrefix)(U.normalized,M);let ne;return j?(ne=m,ne+=Math.round(U.normalized.length/M.length*100)):ne=a,{score:ne+se,labelMatch:j||d(K)}}}if(x){let se=x;V&&(se=`${x}${_.sep}`);const K=se.length,j=`${se}${M}`,[ne,le]=R(j,U.normalized,U.normalizedLowercase,Y&&!U.expectContiguousMatch);if(ne){const ge=d(le),ke=[],Me=[];return ge.forEach(Ue=>{Ue.start<K&&Ue.end>K?(ke.push({start:0,end:Ue.end-K}),Me.push({start:Ue.start,end:K})):Ue.start>=K?ke.push({start:Ue.start-K,end:Ue.end-K}):Me.push(Ue)}),{score:ne,labelMatch:ke,descriptionMatch:Me}}}return o}function d(M){const x=[];if(!M)return x;let V;for(const U of M)V&&V.end===U?V.end+=1:(V={start:U,end:U+1},x.push(V));return x}function h(M){const x=M.sort((H,Y)=>H.start-Y.start),V=[];let U;for(const H of x)!U||!g(U,H)?(U=H,V.push(H)):(U.start=Math.min(U.start,H.start),U.end=Math.max(U.end,H.end));return V}function g(M,x){return!(M.end<x.start||x.end<M.start)}function l(M,x,V,U,H,Y){const se=n(M,V,U,H,Y),K=n(x,V,U,H,Y),j=se.score,ne=K.score;if((j===r||ne===r)&&j!==ne)return j===r?-1:1;if(j>a||ne>a){if(j!==ne)return j>ne?-1:1;if(j<m&&ne<m){const J=A(se.labelMatch,K.labelMatch);if(J!==0)return J}const Ue=H.getItemLabel(M)||"",q=H.getItemLabel(x)||"";if(Ue.length!==q.length)return Ue.length-q.length}if(j!==ne)return j>ne?-1:1;const le=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,ge=Array.isArray(K.labelMatch)&&K.labelMatch.length>0;if(le&&!ge)return-1;if(ge&&!le)return 1;const ke=D(M,se,H),Me=D(x,K,H);return ke&&Me&&ke!==Me?Me>ke?-1:1:N(M,x,V,H)}e.compareItemsByFuzzyScore=l;function D(M,x,V){let U=-1,H=-1;if(x.descriptionMatch&&x.descriptionMatch.length?U=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(U=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(H=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const Y=V.getItemDescription(M);Y&&(H+=Y.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(H=x.descriptionMatch[x.descriptionMatch.length-1].end);return H-U}function A(M,x){if(!M&&!x||(!M||!M.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!M||!M.length)return 1;const V=M[0].start,H=M[M.length-1].end-V,Y=x[0].start,K=x[x.length-1].end-Y;return H===K?0:K<H?1:-1}function N(M,x,V,U){const H=U.getItemLabel(M)||"",Y=U.getItemLabel(x)||"",se=U.getItemDescription(M),K=U.getItemDescription(x),j=H.length+(se?se.length:0),ne=Y.length+(K?K.length:0);if(j!==ne)return j-ne;const le=U.getItemPath(M),ge=U.getItemPath(x);return le&&ge&&le.length!==ge.length?le.length-ge.length:H!==Y?(0,f.compareAnything)(H,Y,V.normalized):se&&K&&se!==K?(0,f.compareAnything)(se,K,V.normalized):le&&ge&&le!==ge?(0,f.compareAnything)(le,ge,V.normalized):0}function B(M){return M.startsWith('"')&&M.endsWith('"')}const F=" ";function O(M){typeof M!="string"&&(M="");const x=M.toLowerCase(),{pathNormalized:V,normalized:U,normalizedLowercase:H}=z(M),Y=V.indexOf(_.sep)>=0,se=B(M);let K;const j=M.split(F);if(j.length>1)for(const ne of j){const le=B(ne),{pathNormalized:ge,normalized:ke,normalizedLowercase:Me}=z(ne);ke&&(K||(K=[]),K.push({original:ne,originalLowercase:ne.toLowerCase(),pathNormalized:ge,normalized:ke,normalizedLowercase:Me,expectContiguousMatch:le}))}return{original:M,originalLowercase:x,pathNormalized:V,normalized:U,normalizedLowercase:H,values:K,containsPathSeparator:Y,expectContiguousMatch:se}}e.prepareQuery=O;function z(M){let x;T.isWindows?x=M.replace(/\//g,_.sep):x=M.replace(/\\/g,_.sep);const V=(0,I.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:V,normalizedLowercase:V.toLowerCase()}}function W(M){return Array.isArray(M)?O(M.map(x=>x.original).join(F)):O(M.original)}e.pieceToQuery=W}),define(ve[32],we([0,1,18,28,24,8,9]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const C="**",P="/",R="[/\\\\]",y="[^/\\\\]",c=/\//g;function b(U){switch(U){case 0:return"";case 1:return`${y}*?`;default:return`(?:${R}|${y}+${R}|${R}${y}+)*?`}}function v(U,H){if(!U)return[];const Y=[];let se=!1,K=!1,j="";for(const ne of U){switch(ne){case H:if(!se&&!K){Y.push(j),j="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":K=!0;break;case"]":K=!1;break}j+=ne}return j&&Y.push(j),Y}e.splitGlobAware=v;function p(U){if(!U)return"";let H="";const Y=v(U,P);if(Y.every(se=>se===C))H=".*";else{let se=!1;Y.forEach((K,j)=>{if(K===C){se||(H+=b(2),se=!0);return}let ne=!1,le="",ge=!1,ke="";for(const Me of K){if(Me!=="}"&&ne){le+=Me;continue}if(ge&&(Me!=="]"||!ke)){let Ue;Me==="-"?Ue=Me:(Me==="^"||Me==="!")&&!ke?Ue="^":Me===P?Ue="":Ue=T.escapeRegExpCharacters(Me),ke+=Ue;continue}switch(Me){case"{":ne=!0;continue;case"[":ge=!0;continue;case"}":{H+=`(?:${v(le,",").map(J=>p(J)).join("|")})`,ne=!1,le="";break}case"]":H+="["+ke+"]",ge=!1,ke="";break;case"?":H+=y;continue;case"*":H+=b(1);continue;default:H+=T.escapeRegExpCharacters(Me)}}j<Y.length-1&&(Y[j+1]!==C||j+2<Y.length)&&(H+=R),se=!1})}return H}const w=/^\*\*\/\*\.[\w\.-]+$/,L=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new k.LRUCache(1e4),E=function(){return!1},n=function(){return null};function t(U,H){if(!U)return n;let Y;typeof U!="string"?Y=U.pattern:Y=U,Y=Y.trim();const se=`${Y}_${!!H.trimForExclusions}`;let K=a.get(se);if(K)return s(K,U);let j;if(w.test(Y)){const ne=Y.substr(4);K=function(le,ge){return typeof le=="string"&&le.endsWith(ne)?Y:null}}else(j=L.exec(u(Y,H)))?K=d(j[1],Y):(H.trimForExclusions?o:S).test(Y)?K=h(Y,H):(j=r.exec(u(Y,H)))?K=g(j[1].substr(1),Y,!0):(j=m.exec(u(Y,H)))?K=g(j[1],Y,!1):K=l(Y);return a.set(se,K),s(K,U)}function s(U,H){return typeof H=="string"?U:function(Y,se){return i.isEqualOrParent(Y,H.base)?U(_.relative(H.base,Y),se):null}}function u(U,H){return H.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function d(U,H){const Y=`/${U}`,se=`\\${U}`,K=function(ne,le){return typeof ne!="string"?null:le?le===U?H:null:ne===U||ne.endsWith(Y)||ne.endsWith(se)?H:null},j=[U];return K.basenames=j,K.patterns=[H],K.allBasenames=j,K}function h(U,H){const Y=V(U.slice(1,-1).split(",").map(le=>t(le,H)).filter(le=>le!==n),U),se=Y.length;if(!se)return n;if(se===1)return Y[0];const K=function(le,ge){for(let ke=0,Me=Y.length;ke<Me;ke++)if(Y[ke](le,ge))return U;return null},j=Y.find(le=>!!le.allBasenames);j&&(K.allBasenames=j.allBasenames);const ne=Y.reduce((le,ge)=>ge.allPaths?le.concat(ge.allPaths):le,[]);return ne.length&&(K.allPaths=ne),K}function g(U,H,Y){const se=_.sep===_.posix.sep,K=se?U:U.replace(c,_.sep),j=_.sep+K,ne=_.posix.sep+U,le=Y?function(ge,ke){return typeof ge=="string"&&(ge===K||ge.endsWith(j)||!se&&(ge===U||ge.endsWith(ne)))?H:null}:function(ge,ke){return typeof ge=="string"&&(ge===K||!se&&ge===U)?H:null};return le.allPaths=[(Y?"*/":"./")+U],le}function l(U){try{const H=new RegExp(`^${p(U)}$`);return function(Y){return H.lastIndex=0,typeof Y=="string"&&H.test(Y)?U:null}}catch{return n}}function D(U,H,Y){return!U||typeof H!="string"?!1:A(U)(H,void 0,Y)}e.match=D;function A(U,H={}){if(!U)return E;if(typeof U=="string"||O(U)){const Y=t(U,H);if(Y===n)return E;const se=function(K,j){return!!Y(K,j)};return Y.allBasenames&&(se.allBasenames=Y.allBasenames),Y.allPaths&&(se.allPaths=Y.allPaths),se}return M(U,H)}e.parse=A;function N(U){if(!U)return;let H;return Y=>(H||(H=(U()||Promise.resolve([])).then(se=>se?F(se):{})),H.then(se=>!!se[Y]))}e.hasSiblingPromiseFn=N;function B(U){if(!U)return;let H;return Y=>{if(!H){const se=U();H=se?F(se):{}}return!!H[Y]}}e.hasSiblingFn=B;function F(U){const H={};for(const Y of U)H[Y]=!0;return H}function O(U){const H=U;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=O;function z(U){return U.allBasenames||[]}e.getBasenameTerms=z;function W(U){return U.allPaths||[]}e.getPathTerms=W;function M(U,H){const Y=V(Object.getOwnPropertyNames(U).map(le=>x(le,U[le],H)).filter(le=>le!==n)),se=Y.length;if(!se)return n;if(!Y.some(le=>!!le.requiresSiblings)){if(se===1)return Y[0];const le=function(Me,Ue){for(let q=0,J=Y.length;q<J;q++){const re=Y[q](Me,Ue);if(re)return re}return null},ge=Y.find(Me=>!!Me.allBasenames);ge&&(le.allBasenames=ge.allBasenames);const ke=Y.reduce((Me,Ue)=>Ue.allPaths?Me.concat(Ue.allPaths):Me,[]);return ke.length&&(le.allPaths=ke),le}const K=function(le,ge,ke){let Me;for(let Ue=0,q=Y.length;Ue<q;Ue++){const J=Y[Ue];J.requiresSiblings&&ke&&(ge||(ge=_.basename(le)),Me||(Me=ge.substr(0,ge.length-_.extname(le).length)));const re=J(le,ge,Me,ke);if(re)return re}return null},j=Y.find(le=>!!le.allBasenames);j&&(K.allBasenames=j.allBasenames);const ne=Y.reduce((le,ge)=>ge.allPaths?le.concat(ge.allPaths):le,[]);return ne.length&&(K.allPaths=ne),K}function x(U,H,Y){if(H===!1)return n;const se=t(U,Y);if(se===n)return n;if(typeof H=="boolean")return se;if(H){const K=H.when;if(typeof K=="string"){const j=(ne,le,ge,ke)=>{if(!ke||!se(ne,le))return null;const Me=K.replace("$(basename)",ge),Ue=ke(Me);return(0,f.isThenable)(Ue)?Ue.then(q=>q?U:null):Ue?U:null};return j.requiresSiblings=!0,j}}return se}function V(U,H){const Y=U.filter(le=>!!le.basenames);if(Y.length<2)return U;const se=Y.reduce((le,ge)=>{const ke=ge.basenames;return ke?le.concat(ke):le},[]);let K;if(H){K=[];for(let le=0,ge=se.length;le<ge;le++)K.push(H)}else K=Y.reduce((le,ge)=>{const ke=ge.patterns;return ke?le.concat(ke):le},[]);const j=function(le,ge){if(typeof le!="string")return null;if(!ge){let Me;for(Me=le.length;Me>0;Me--){const Ue=le.charCodeAt(Me-1);if(Ue===47||Ue===92)break}ge=le.substr(Me)}const ke=se.indexOf(ge);return ke!==-1?K[ke]:null};j.basenames=se,j.patterns=K,j.allBasenames=se;const ne=U.filter(le=>!le.basenames);return ne.push(j),ne}}),define(ve[81],we([0,1,28,10,8,12,23,9,2]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(t,s,u){if(typeof t=="string"&&(t=C.URI.file(t)),u){const h=u.getWorkspaceFolder(t);if(h){const g=u.getWorkspace().folders.length>1;let l;if((0,T.isEqual)(h.uri,t)?l="":l=(0,T.relativePath)(h.uri,t),g){const D=h.name?h.name:(0,T.basename)(h.uri);l=l?D+" \u2022 "+l:D}return l}}if(t.scheme!==i.Schemas.file&&t.scheme!==i.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(t.fsPath))return(0,k.normalize)(y(t.fsPath));let d=(0,k.normalize)(t.fsPath);return!_.isWindows&&s?.userHome&&(d=b(d,s.userHome.fsPath)),d}e.getPathLabel=P;function R(t){if(!t)return;typeof t=="string"&&(t=C.URI.file(t));const s=(0,T.basename)(t)||(t.scheme===i.Schemas.file?t.fsPath:t.path);return _.isWindows&&(0,f.isRootOrDriveLetter)(s)?y(s):s}e.getBaseLabel=R;function y(t,s){return(0,f.hasDriveLetter)(t,s)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=y;let c=Object.create(null);function b(t,s){if(_.isWindows||!t||!s)return t;let u=c.original===s?c.normalized:void 0;return u||(u=`${(0,I.rtrim)(s,k.posix.sep)}${k.posix.sep}`,c={original:s,normalized:u}),(_.isLinux?t.startsWith(u):(0,I.startsWithIgnoreCase)(t,u))&&(t=`~/${t.substr(u.length)}`),t}e.tildify=b;function v(t,s){return t.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=v;const p="\u2026",w="\\\\",L="~";function S(t,s=k.sep){const u=new Array(t.length);let d=!1;for(let h=0;h<t.length;h++){let g=t[h];if(g===""){u[h]=`.${s}`;continue}if(!g){u[h]=g;continue}d=!0;let l="";g.indexOf(w)===0?(l=g.substr(0,g.indexOf(w)+w.length),g=g.substr(g.indexOf(w)+w.length)):g.indexOf(s)===0?(l=g.substr(0,g.indexOf(s)+s.length),g=g.substr(g.indexOf(s)+s.length)):g.indexOf(L)===0&&(l=g.substr(0,g.indexOf(L)+L.length),g=g.substr(g.indexOf(L)+L.length));const D=g.split(s);for(let A=1;d&&A<=D.length;A++)for(let N=D.length-A;d&&N>=0;N--){d=!1;let B=D.slice(N,N+A).join(s);for(let F=0;!d&&F<t.length;F++)if(F!==h&&t[F]&&t[F].indexOf(B)>-1){const O=N+A===D.length,z=N>0&&t[F].indexOf(s)>-1?s+B:B,W=t[F].endsWith(z);d=!O||W}if(!d){let F="";(D[0].endsWith(":")||l!=="")&&(N===1&&(N=0,A++,B=D[0]+s+B),N>0&&(F=D[0]+s),F=l+F),N>0&&(F=F+p+s),F=F+B,N+A<D.length&&(F=F+s+p),u[h]=F}}d&&(u[h]=g)}return u}e.shorten=S;var o;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function r(t,s=Object.create(null)){const u=[];let d=!1,h="";for(const g of t)if(g==="$"||d&&g==="{")h&&u.push({value:h,type:o.TEXT}),h="",d=!0;else if(g==="}"&&d){const l=s[h];if(typeof l=="string")l.length&&u.push({value:l,type:o.VARIABLE});else if(l){const D=u[u.length-1];(!D||D.type!==o.SEPARATOR)&&u.push({value:l.label,type:o.SEPARATOR})}h="",d=!1}else h+=g;return h&&!d&&u.push({value:h,type:o.TEXT}),u.filter((g,l)=>{if(g.type===o.SEPARATOR){const D=u[l-1],A=u[l+1];return[D,A].every(N=>N&&(N.type===o.VARIABLE||N.type===o.TEXT)&&N.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=r;function m(t,s){return _.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):t.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function a(t,s){return _.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,""):_.isWindows?t.replace(/&&|&/g,u=>u==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function E(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=E;function n(t){const s=t.indexOf("/")!==-1?k.posix:k.win32,u=s.basename(t),d=s.dirname(t);return u.length?{name:u,parentPath:d}:{name:d,parentPath:""}}e.splitName=n}),define(ve[103],we([0,1,2]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(R){return R.toJSON()}class k{constructor(y){this._uriTransformer=y}transformIncoming(y){const c=this._uriTransformer.transformIncoming(y);return c===y?y:i(f.URI.from(c))}transformOutgoing(y){const c=this._uriTransformer.transformOutgoing(y);return c===y?y:i(f.URI.from(c))}transformOutgoingURI(y){const c=this._uriTransformer.transformOutgoing(y);return c===y?y:f.URI.from(c)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function _(R,y,c){if(!R||c>200)return null;if(typeof R=="object"){if(R instanceof f.URI)return y.transformOutgoing(R);for(let b in R)if(Object.hasOwnProperty.call(R,b)){const v=_(R[b],y,c+1);v!==null&&(R[b]=v)}}return null}function T(R,y){const c=_(R,y,0);return c===null?R:c}e.transformOutgoingURIs=T;function I(R,y,c,b){if(!R||b>200)return null;if(typeof R=="object"){if(R.$mid===1)return c?f.URI.revive(y.transformIncoming(R)):y.transformIncoming(R);for(let v in R)if(Object.hasOwnProperty.call(R,v)){const p=I(R[v],y,c,b+1);p!==null&&(R[v]=p)}}return null}function C(R,y){const c=I(R,y,!1,0);return c===null?R:c}e.transformIncomingURIs=C;function P(R,y){const c=I(R,y,!0,0);return c===null?R:c}e.transformAndReviveIncomingURIs=P}),define(ve[33],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(C){return f.test(C)}e.isUUID=i;const k=new Uint8Array(16),_=[];for(let C=0;C<256;C++)_.push(C.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(C){for(let P=0;P<C.length;P++)C[P]=Math.floor(Math.random()*256);return C};function I(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let C=0,P="";return P+=_[k[C++]],P+=_[k[C++]],P+=_[k[C++]],P+=_[k[C++]],P+="-",P+=_[k[C++]],P+=_[k[C++]],P+="-",P+=_[k[C++]],P+=_[k[C++]],P+="-",P+=_[k[C++]],P+=_[k[C++]],P+="-",P+=_[k[C++]],P+=_[k[C++]],P+=_[k[C++]],P+=_[k[C++]],P+=_[k[C++]],P+=_[k[C++]],P}e.generateUuid=I}),define(ve[143],we([0,1,104]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(_="utf8"){this.stringDecoder=new f.StringDecoder(_),this.remaining=null}write(_){const T=[],I=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(I.length<1)return T;let C=0,P,R=C;for(;R<I.length;)if(P=I.charCodeAt(R),P===13||P===10){if(T.push(I.substring(C,R)),R++,R<I.length){const y=P;P=I.charCodeAt(R),(y===13&&P===10||y===10&&P===13)&&R++}C=R}else R++;return this.remaining=C<I.length?I.substr(C):null,T}end(){return this.remaining}}e.LineDecoder=i}),define(ve[29],we([0,1,60,82,291,18,28,80,8,12,23,2]),function(X,e,f,i,k,_,T,I,C,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var c;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(c=e.RimRafMode||(e.RimRafMode={}));async function b(O,z=c.UNLINK){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return z===c.UNLINK?p(O):v(O)}async function v(O){try{const z=(0,T.randomPath)((0,i.tmpdir)());try{await e.Promises.rename(O,z)}catch{return p(O)}p(z).catch(W=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function p(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function w(O){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");f.rmdirSync(O,{recursive:!0})}e.rimrafSync=w;async function L(O,z){return r(await(z?S(O):(0,k.promisify)(f.readdir)(O)))}async function S(O){try{return await(0,k.promisify)(f.readdir)(O,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const z=[],W=await L(O);for(const M of W){let x=!1,V=!1,U=!1;try{const H=await e.Promises.lstat((0,C.join)(O,M));x=H.isFile(),V=H.isDirectory(),U=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}z.push({name:M,isFile:()=>x,isDirectory:()=>V,isSymbolicLink:()=>U})}return z}function o(O){return r(f.readdirSync(O))}e.readdirSync=o;function r(O){return O.map(z=>typeof z=="string"?P.isMacintosh?(0,I.normalizeNFC)(z):z:(z.name=P.isMacintosh?(0,I.normalizeNFC)(z.name):z.name,z))}async function m(O){const z=await L(O),W=[];for(const M of z)await E.existsDirectory((0,C.join)(O,M))&&W.push(M);return W}function a(O,z=1e3){return new Promise(W=>{let M=!1;const x=setInterval(()=>{M||(M=!0,f.access(O,V=>{M=!1,V&&(clearInterval(x),W(void 0))}))},z)})}e.whenDeleted=a;var E;(function(O){async function z(x){let V;try{if(V=await e.Promises.lstat(x),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(P.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw H}throw U}}O.stat=z;async function W(x){try{const{stat:V,symbolicLink:U}=await O.stat(x);return V.isFile()&&U?.dangling!==!0}catch{}return!1}O.existsFile=W;async function M(x){try{const{stat:V,symbolicLink:U}=await O.stat(x);return V.isDirectory()&&U?.dangling!==!0}catch{}return!1}O.existsDirectory=M})(E=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new _.ResourceQueue;function t(O,z,W){return n.queueFor(y.URI.file(O),R.extUriBiasedIgnorePathCase).queue(()=>{const M=h(W);return new Promise((x,V)=>u(O,z,M,U=>U?V(U):x()))})}let s=!0;function u(O,z,W,M){if(!s)return f.writeFile(O,z,{mode:W.mode,flag:W.flag},M);f.open(O,W.flag,W.mode,(x,V)=>{if(x)return M(x);f.writeFile(V,z,U=>{if(U)return f.close(V,()=>M(U));f.fdatasync(V,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),s=!1),f.close(V,Y=>M(Y))))})})}function d(O,z,W){const M=h(W);if(!s)return f.writeFileSync(O,z,{mode:M.mode,flag:M.flag});const x=f.openSync(O,M.flag,M.mode);try{f.writeFileSync(x,z);try{f.fdatasyncSync(x)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),s=!1}}finally{f.closeSync(x)}}e.writeFileSync=d;function h(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function g(O,z){if(O===z)return;async function W(M){try{const x=await e.Promises.lstat(M);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(M,x.atime,new Date)}catch{}}try{await e.Promises.rename(O,z),await W(z)}catch(M){if(O.toLowerCase()!==z.toLowerCase()&&M.code==="EXDEV"||O.endsWith("."))await l(O,z,{preserveSymlinks:!1}),await b(O,c.MOVE),await W(z);else throw M}}async function l(O,z,W){return A(O,z,{root:{source:O,target:z},options:W,handledSourcePaths:new Set})}const D=511;async function A(O,z,W){if(W.handledSourcePaths.has(O))return;W.handledSourcePaths.add(O);const{stat:M,symbolicLink:x}=await E.stat(O);if(x){if(W.options.preserveSymlinks)try{return await F(O,z,W)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(x.dangling)return}return M.isDirectory()?N(O,z,M.mode&D,W):B(O,z,M.mode&D)}async function N(O,z,W,M){await e.Promises.mkdir(z,{recursive:!0,mode:W});const x=await L(O);for(const V of x)await A((0,C.join)(O,V),(0,C.join)(z,V),M)}async function B(O,z,W){await e.Promises.copyFile(O,z),await e.Promises.chmod(z,W)}async function F(O,z,W){let M=await e.Promises.readlink(O);(0,T.isEqualOrParent)(M,W.root.source,!P.isLinux)&&(M=(0,C.join)(W.root.target,M.substr(W.root.source.length+1))),await e.Promises.symlink(M,z)}e.Promises=new class{get access(){return(0,k.promisify)(f.access)}get stat(){return(0,k.promisify)(f.stat)}get lstat(){return(0,k.promisify)(f.lstat)}get utimes(){return(0,k.promisify)(f.utimes)}get read(){return(0,k.promisify)(f.read)}get readFile(){return(0,k.promisify)(f.readFile)}get write(){return(0,k.promisify)(f.write)}get appendFile(){return(0,k.promisify)(f.appendFile)}get fdatasync(){return(0,k.promisify)(f.fdatasync)}get truncate(){return(0,k.promisify)(f.truncate)}get rename(){return(0,k.promisify)(f.rename)}get copyFile(){return(0,k.promisify)(f.copyFile)}get open(){return(0,k.promisify)(f.open)}get close(){return(0,k.promisify)(f.close)}get symlink(){return(0,k.promisify)(f.symlink)}get readlink(){return(0,k.promisify)(f.readlink)}get chmod(){return(0,k.promisify)(f.chmod)}get mkdir(){return(0,k.promisify)(f.mkdir)}get unlink(){return(0,k.promisify)(f.unlink)}get rmdir(){return(0,k.promisify)(f.rmdir)}get realpath(){return(0,k.promisify)(f.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return L}get readDirsInDir(){return m}get writeFile(){return t}get rm(){return b}get move(){return g}get copy(){return l}}}),define(ve[105],we([0,1,60,8,12,9,29]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function I(y){if(k.isLinux)return y;const c=(0,i.dirname)(y);if(y===c)return y;const b=((0,i.basename)(y)||y).toLowerCase();try{const p=(0,T.readdirSync)(c).filter(w=>w.toLowerCase()===b);if(p.length===1){const w=I(c);if(w)return(0,i.join)(w,p[0])}else if(p.length>1){const w=p.indexOf(b);if(w>=0){const L=I(c);if(L)return(0,i.join)(L,p[w])}}}catch{}return null}e.realcaseSync=I;async function C(y){try{return await T.Promises.realpath(y)}catch{const b=R(y);return await T.Promises.access(b,f.constants.R_OK),b}}e.realpath=C;function P(y){try{return f.realpathSync(y)}catch{const b=R(y);return f.accessSync(b,f.constants.R_OK),b}}e.realpathSync=P;function R(y){return(0,_.rtrim)((0,i.normalize)(y),i.sep)}});var Ve=this&&this.__decorate||function(X,e,f,i){var k=arguments.length,_=k<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,f):i,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(X,e,f,i);else for(var I=X.length-1;I>=0;I--)(T=X[I])&&(_=(k<3?T(_):k>3?T(e,f,_):T(e,f))||_);return k>3&&_&&Object.defineProperty(e,f,_),_};define(ve[106],we([0,1,16,18,22,21,57,15,3,6,59,9,13]),function(X,e,f,i,k,_,T,I,C,P,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function v(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function w(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var L;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(L||(L={}));class S{constructor(U){this.buffer=U,this.pos=0}read(U){const H=this.buffer.slice(this.pos,this.pos+U);return this.pos+=H.byteLength,H}}class o{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(r||(r={}));function m(V){const U=k.VSBuffer.alloc(4);return U.writeUInt32BE(V,0),U}function a(V){return V.read(4).readUInt32BE(0)}function E(V){const U=k.VSBuffer.alloc(1);return U.writeUInt8(V,0),U}const n={Undefined:E(r.Undefined),String:E(r.String),Buffer:E(r.Buffer),VSBuffer:E(r.VSBuffer),Array:E(r.Array),Object:E(r.Object)},t=typeof Buffer!="undefined";function s(V,U){if(typeof U=="undefined")V.write(n.Undefined);else if(typeof U=="string"){const H=k.VSBuffer.fromString(U);V.write(n.String),V.write(m(H.byteLength)),V.write(H)}else if(t&&Buffer.isBuffer(U)){const H=k.VSBuffer.wrap(U);V.write(n.Buffer),V.write(m(H.byteLength)),V.write(H)}else if(U instanceof k.VSBuffer)V.write(n.VSBuffer),V.write(m(U.byteLength)),V.write(U);else if(Array.isArray(U)){V.write(n.Array),V.write(m(U.length));for(const H of U)s(V,H)}else{const H=k.VSBuffer.fromString(JSON.stringify(U));V.write(n.Object),V.write(m(H.byteLength)),V.write(H)}}function u(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(a(V)).toString();case r.Buffer:return V.read(a(V)).buffer;case r.VSBuffer:return V.read(a(V));case r.Array:{const H=a(V),Y=[];for(let se=0;se<H;se++)Y.push(u(V));return Y}case r.Object:return JSON.parse(V.read(a(V)).toString())}}class d{constructor(U,H,Y=null,se=1e3){this.protocol=U,this.ctx=H,this.logger=Y,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(U,H){this.channels.set(U,H),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const H=this.send([U.type]);this.logger&&this.logger.logOutgoing(H,0,1,w(U.type));return}case 201:case 202:case 204:case 203:{const H=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(H,U.id,1,w(U.type),U.data);return}}}send(U,H=void 0){const Y=new o;return s(Y,U),s(Y,H),this.sendBuffer(Y.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const H=new S(U),Y=u(H),se=u(H),K=Y[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],1,`${v(K)}: ${Y[2]}.${Y[3]}`,se),this.onPromise({type:K,id:Y[1],channelName:Y[2],name:Y[3],arg:se});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],1,`${v(K)}: ${Y[2]}.${Y[3]}`,se),this.onEventListen({type:K,id:Y[1],channelName:Y[2],name:Y[3],arg:se});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],1,`${v(K)}`),this.disposeActiveRequest({type:K,id:Y[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],1,`${v(K)}`),this.disposeActiveRequest({type:K,id:Y[1]})}}onPromise(U){const H=this.channels.get(U.channelName);if(!H){this.collectPendingRequest(U);return}const Y=new _.CancellationTokenSource;let se;try{se=H.call(this.ctx,U.name,U.arg,Y.token)}catch(ne){se=Promise.reject(ne)}const K=U.id;se.then(ne=>{this.sendResponse({id:K,data:ne,type:201}),this.activeRequests.delete(U.id)},ne=>{ne instanceof Error?this.sendResponse({id:K,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:K,data:ne,type:203}),this.activeRequests.delete(U.id)});const j=(0,P.toDisposable)(()=>Y.cancel());this.activeRequests.set(U.id,j)}onEventListen(U){const H=this.channels.get(U.channelName);if(!H){this.collectPendingRequest(U);return}const Y=U.id,K=H.listen(this.ctx,U.name,U.arg)(j=>this.sendResponse({id:Y,data:j,type:204}));this.activeRequests.set(U.id,K)}disposeActiveRequest(U){const H=this.activeRequests.get(U.id);H&&(H.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let H=this.pendingRequests.get(U.channelName);H||(H=[],this.pendingRequests.set(U.channelName,H));const Y=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:U,timeoutTimer:Y})}flushPendingRequests(U){const H=this.pendingRequests.get(U);if(H){for(const Y of H)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var h;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(U,H=null){this.protocol=U,this.isDisposed=!1,this.state=L.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=H}getChannel(U){const H=this;return{call(Y,se,K){return H.isDisposed?Promise.reject(I.canceled()):H.requestPromise(U,Y,se,K)},listen(Y,se){return H.isDisposed?Promise.reject(I.canceled()):H.requestEvent(U,Y,se)}}}requestPromise(U,H,Y,se=_.CancellationToken.None){const K=this.lastRequestId++,ne={id:K,type:100,channelName:U,name:H,arg:Y};if(se.isCancellationRequested)return Promise.reject(I.canceled());let le;return new Promise((ke,Me)=>{if(se.isCancellationRequested)return Me(I.canceled());const Ue=()=>{const he=Z=>{switch(Z.type){case 201:this.handlers.delete(K),ke(Z.data);break;case 202:{this.handlers.delete(K);const ce=new Error(Z.data.message);ce.stack=Z.data.stack,ce.name=Z.data.name,Me(ce);break}case 203:this.handlers.delete(K),Me(Z.data);break}};this.handlers.set(K,he),this.sendRequest(ne)};let q=null;this.state===L.Idle?Ue():(q=(0,i.createCancelablePromise)(he=>this.whenInitialized()),q.then(()=>{q=null,Ue()}));const J=()=>{q?(q.cancel(),q=null):this.sendRequest({id:K,type:101}),Me(I.canceled())},re=se.onCancellationRequested(J);le=(0,P.combinedDisposable)((0,P.toDisposable)(J),re),this.activeRequests.add(le)}).finally(()=>{this.activeRequests.delete(le)})}requestEvent(U,H,Y){const se=this.lastRequestId++,j={id:se,type:102,channelName:U,name:H,arg:Y};let ne=null;const le=new C.Emitter({onFirstListenerAdd:()=>{ne=(0,i.createCancelablePromise)(ke=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(le),this.sendRequest(j)})},onLastListenerRemove:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(le),this.sendRequest({id:se,type:103}))}}),ge=ke=>le.fire(ke.data);return this.handlers.set(se,ge),le.event}sendRequest(U){switch(U.type){case 100:case 102:{const H=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(H,U.id,0,`${v(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const H=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(H,U.id,0,v(U.type));return}}}send(U,H=void 0){const Y=new o;return s(Y,U),s(Y,H),this.sendBuffer(Y.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const H=new S(U),Y=u(H),se=u(H),K=Y[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,w(K)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,Y[1],0,w(K),se),this.onResponse({type:Y[0],id:Y[1],data:se})}}onResponse(U){if(U.type===200){this.state=L.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(U.id);H&&H(U)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===L.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}Ve([T.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class l{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:H,onDidClientDisconnect:Y})=>{C.Event.once(H.onMessage)(K=>{const j=new S(K),ne=u(j),le=new d(H,ne),ge=new g(H);this.channels.forEach((Me,Ue)=>le.registerChannel(Ue,Me));const ke={channelServer:le,channelClient:ge,ctx:ne};this._connections.add(ke),this._onDidAddConnection.fire(ke),Y(()=>{le.dispose(),ge.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}get connections(){const U=[];return this._connections.forEach(H=>U.push(H)),U}getChannel(U,H){const Y=this;return{call(se,K,j){let ne;if((0,c.isFunction)(H)){let ge=(0,f.getRandomElement)(Y.connections.filter(H));ne=ge?Promise.resolve(ge):C.Event.toPromise(C.Event.filter(Y.onDidAddConnection,H))}else ne=H.routeCall(Y,se,K);const le=ne.then(ge=>ge.channelClient.getChannel(U));return A(le).call(se,K,j)},listen(se,K){if((0,c.isFunction)(H))return Y.getMulticastEvent(U,H,se,K);const j=H.routeEvent(Y,se,K).then(ne=>ne.channelClient.getChannel(U));return A(j).listen(se,K)}}}getMulticastEvent(U,H,Y,se){const K=this;let j=new P.DisposableStore;const ne=new C.Emitter({onFirstListenerAdd:()=>{j=new P.DisposableStore;const le=new C.EventMultiplexer,ge=new Map,ke=Ue=>{const J=Ue.channelClient.getChannel(U).listen(Y,se),re=le.add(J);ge.set(Ue,re)},Me=Ue=>{const q=ge.get(Ue);!q||(q.dispose(),ge.delete(Ue))};K.connections.filter(H).forEach(ke),C.Event.filter(K.onDidAddConnection,H)(ke,void 0,j),K.onDidRemoveConnection(Me,void 0,j),le.event(ne.fire,ne,j),j.add(le)},onLastListenerRemove:()=>{j.dispose()}});return ne.event}registerChannel(U,H){this.channels.set(U,H),this._connections.forEach(Y=>{Y.channelServer.registerChannel(U,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=l;class D{constructor(U,H,Y=null){const se=new o;s(se,H),U.send(se.buffer),this.channelClient=new g(U,Y),this.channelServer=new d(U,H,Y)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,H){this.channelServer.registerChannel(U,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function A(V){return{call(U,H,Y){return V.then(se=>se.call(U,H,Y))},listen(U,H){const Y=new C.Relay;return V.then(se=>Y.input=se.listen(U,H)),Y.event}}}e.getDelayedChannel=A;function N(V){let U=!1;return{call(H,Y,se){return U?V.call(H,Y,se):(0,i.timeout)(0).then(()=>U=!0).then(()=>V.call(H,Y,se))},listen(H,Y){if(U)return V.listen(H,Y);const se=new C.Relay;return(0,i.timeout)(0).then(()=>U=!0).then(()=>se.input=V.listen(H,Y)),se.event}}}e.getNextTickChannel=N;class B{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const H of U.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await C.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=B;var F;(function(V){function U(K,j){const ne=K,le=j&&j.disableMarshalling,ge=new Map;for(const ke in ne)Y(ke)&&ge.set(ke,C.Event.buffer(ne[ke],!0));return new class{listen(ke,Me,Ue){const q=ge.get(Me);if(q)return q;if(se(Me)){const J=ne[Me];if(typeof J=="function")return J.call(ne,Ue)}throw new Error(`Event not found: ${Me}`)}call(ke,Me,Ue){const q=ne[Me];if(typeof q=="function"){if(!le&&Array.isArray(Ue))for(let J=0;J<Ue.length;J++)Ue[J]=(0,R.revive)(Ue[J]);return q.apply(ne,Ue)}throw new Error(`Method not found: ${Me}`)}}}V.fromService=U;function H(K,j){const ne=j&&j.disableMarshalling;return new Proxy({},{get(le,ge){if(typeof ge=="string")return j?.properties?.has(ge)?j.properties.get(ge):se(ge)?function(ke){return K.listen(ge,ke)}:Y(ge)?K.listen(ge):async function(...ke){let Me;j&&!(0,c.isUndefinedOrNull)(j.context)?Me=[j.context,...ke]:Me=ke;const Ue=await K.call(ge,Me);return ne?Ue:(0,R.revive)(Ue)};throw new Error(`Property not found: ${String(ge)}`)}})}V.toService=H;function Y(K){return K[0]==="o"&&K[1]==="n"&&y.isUpperAsciiLetter(K.charCodeAt(2))}function se(K){return/^onDynamic/.test(K)&&y.isUpperAsciiLetter(K.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let U=V.toString();if(U!=="[object Object]")return U}return V}function W(V){return Array.isArray(V)?V.map(z):z(V)}function M(V,U,H,Y,se,K,j){j=W(j);const ne=O[se],le=ne[Y%ne.length];let ge=[`%c[${V}]%c[${String(U).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${le}`];/\($/.test(K)?(ge=ge.concat(j),ge.push(")")):ge.push(j),console.log.apply(console,ge)}e.logWithColors=M;class x{constructor(U,H){this._outgoingPrefix=U,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,H,Y,se,K){this._totalOutgoing+=U,M(this._outgoingPrefix,this._totalOutgoing,U,H,Y,se,K)}logIncoming(U,H,Y,se,K){this._totalIncoming+=U,M(this._incomingPrefix,this._totalIncoming,U,H,Y,se,K)}}e.IPCLogger=x}),define(ve[107],we([0,1,22,3,6,106]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let u=0;function d(g,l){if(!s.has(g)){const D=String(++u);s.set(g,D)}return s.get(g)}function h(g,l,D,A){if(!t.enableDiagnostics)return;const N=d(g,l);if(A instanceof f.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const B=f.VSBuffer.alloc(A.byteLength);B.set(A),t.records.push({timestamp:Date.now(),id:N,label:l,type:D,buff:B})}else t.records.push({timestamp:Date.now(),id:N,label:l,type:D,data:A})}t.traceSocketEvent=h})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function R(){return P||(P=f.VSBuffer.alloc(0)),P}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,u){if(s===0)return R();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const l=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=s),l}if(this._chunks[0].byteLength>s){const l=this._chunks[0].slice(0,s);return u&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),l}let d=f.VSBuffer.alloc(s),h=0,g=0;for(;s>0;){const l=this._chunks[g];if(l.byteLength>s){const D=l.slice(0,s);d.set(D,h),h+=s,u&&(this._chunks[g]=l.slice(s),this._totalLength-=s),s-=s}else d.set(l,h),h+=l.byteLength,u?(this._chunks.shift(),this._totalLength-=l.byteLength):g++,s-=l.byteLength}return d}}e.ChunkStream=y;var c;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(c||(c={}));function b(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var v;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,u,d,h){this.type=s,this.id=u,this.ack=d,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(s){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const d=this._state.messageType,h=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new p(d,h,g,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class L{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=f.VSBuffer.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(u,s.data)}_bufferAdd(s,u){const d=this._totalLength===0;return this._data.push(s,u),this._totalLength+=s.byteLength+u.byteLength,d}_bufferTake(){const s=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,u){this._bufferAdd(s,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class S extends k.Disposable{constructor(s){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new L(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=S;class o extends _.IPCClient{constructor(s,u,d=null){super(s,u,d);this.protocol=s}static fromSocket(s,u){return new o(new S(s),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=o;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class m{constructor(s){this.data=s,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],u=0,d=this._first;for(;d;)s[u++]=d.data,d=d.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const u=new m(s);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class E{constructor(){this.lastRuns=[];const s=Date.now();for(let u=0;u<E._HISTORY_LENGTH;u++)this.lastRuns[u]=s-1e3*u;setInterval(()=>{for(let u=E._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return E._INSTANCE||(E._INSTANCE=new E),E._INSTANCE}load(){const s=Date.now(),u=(1+E._HISTORY_LENGTH)*1e3;let d=0;for(let h=0;h<E._HISTORY_LENGTH;h++)s-this.lastRuns[h]<=u&&d++;return 1-d/E._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}E._HISTORY_LENGTH=10,E._INSTANCE=null;class n{constructor(s,u=null,d=E.getInstance()){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=d,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new L(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),u&&this._socketReader.acceptChunk(u)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,R());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new p(7,0,0,R());this._socketWriter.write(s)}sendResume(){const s=new p(8,0,0,R());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,u){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new L(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,R());this._socketWriter.write(s);const u=this._outgoingUnackMsg.toArray();for(let d=0,h=u.length;d<h;d++)this._socketWriter.write(u[d]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new p(6,0,0,R())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let d=0,h=u.length;d<h;d++)this._socketWriter.write(u[d]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new p(1,u,this._incomingAckId,s);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(s){const u=new p(2,0,0,s);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),u=Date.now()-s.writtenTime,d=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&d>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const g=Math.max(2e4-u,2e4-d,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},g)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,R());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(ve[108],we([0,1,100]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(I){const C=(0,f.toUint8)(I);this._defaultValue=C,this._asciiMap=i._createAsciiMap(C),this._map=new Map}static _createAsciiMap(I){const C=new Uint8Array(256);for(let P=0;P<256;P++)C[P]=I;return C}set(I,C){const P=(0,f.toUint8)(C);I>=0&&I<256?this._asciiMap[I]=P:this._map.set(I,P)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=i;var k;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(k||(k={}));class _{constructor(){this._actual=new i(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=_}),define(ve[144],we([0,1,108]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends f.CharacterClassifier{constructor(I){super(0);for(let C=0,P=I.length;C<P;C++)this.set(I.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function _(T){const I={};return C=>(I.hasOwnProperty(C)||(I[C]=T(C)),I[C])}e.getMapForWordSeparators=_(T=>new k(T))}),define(ve[49],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(k,_){this.lineNumber=k,this.column=_}with(k=this.lineNumber,_=this.column){return k===this.lineNumber&&_===this.column?this:new f(k,_)}delta(k=0,_=0){return this.with(this.lineNumber+k,this.column+_)}equals(k){return f.equals(this,k)}static equals(k,_){return!k&&!_?!0:!!k&&!!_&&k.lineNumber===_.lineNumber&&k.column===_.column}isBefore(k){return f.isBefore(this,k)}static isBefore(k,_){return k.lineNumber<_.lineNumber?!0:_.lineNumber<k.lineNumber?!1:k.column<_.column}isBeforeOrEqual(k){return f.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,_){return k.lineNumber<_.lineNumber?!0:_.lineNumber<k.lineNumber?!1:k.column<=_.column}static compare(k,_){const T=k.lineNumber|0,I=_.lineNumber|0;if(T===I){const C=k.column|0,P=_.column|0;return C-P}return T-I}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new f(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=f}),define(ve[41],we([0,1,49]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(_,T,I,C){_>I||_===I&&T>C?(this.startLineNumber=I,this.startColumn=C,this.endLineNumber=_,this.endColumn=T):(this.startLineNumber=_,this.startColumn=T,this.endLineNumber=I,this.endColumn=C)}isEmpty(){return i.isEmpty(this)}static isEmpty(_){return _.startLineNumber===_.endLineNumber&&_.startColumn===_.endColumn}containsPosition(_){return i.containsPosition(this,_)}static containsPosition(_,T){return!(T.lineNumber<_.startLineNumber||T.lineNumber>_.endLineNumber||T.lineNumber===_.startLineNumber&&T.column<_.startColumn||T.lineNumber===_.endLineNumber&&T.column>_.endColumn)}static strictContainsPosition(_,T){return!(T.lineNumber<_.startLineNumber||T.lineNumber>_.endLineNumber||T.lineNumber===_.startLineNumber&&T.column<=_.startColumn||T.lineNumber===_.endLineNumber&&T.column>=_.endColumn)}containsRange(_){return i.containsRange(this,_)}static containsRange(_,T){return!(T.startLineNumber<_.startLineNumber||T.endLineNumber<_.startLineNumber||T.startLineNumber>_.endLineNumber||T.endLineNumber>_.endLineNumber||T.startLineNumber===_.startLineNumber&&T.startColumn<_.startColumn||T.endLineNumber===_.endLineNumber&&T.endColumn>_.endColumn)}strictContainsRange(_){return i.strictContainsRange(this,_)}static strictContainsRange(_,T){return!(T.startLineNumber<_.startLineNumber||T.endLineNumber<_.startLineNumber||T.startLineNumber>_.endLineNumber||T.endLineNumber>_.endLineNumber||T.startLineNumber===_.startLineNumber&&T.startColumn<=_.startColumn||T.endLineNumber===_.endLineNumber&&T.endColumn>=_.endColumn)}plusRange(_){return i.plusRange(this,_)}static plusRange(_,T){let I,C,P,R;return T.startLineNumber<_.startLineNumber?(I=T.startLineNumber,C=T.startColumn):T.startLineNumber===_.startLineNumber?(I=T.startLineNumber,C=Math.min(T.startColumn,_.startColumn)):(I=_.startLineNumber,C=_.startColumn),T.endLineNumber>_.endLineNumber?(P=T.endLineNumber,R=T.endColumn):T.endLineNumber===_.endLineNumber?(P=T.endLineNumber,R=Math.max(T.endColumn,_.endColumn)):(P=_.endLineNumber,R=_.endColumn),new i(I,C,P,R)}intersectRanges(_){return i.intersectRanges(this,_)}static intersectRanges(_,T){let I=_.startLineNumber,C=_.startColumn,P=_.endLineNumber,R=_.endColumn,y=T.startLineNumber,c=T.startColumn,b=T.endLineNumber,v=T.endColumn;return I<y?(I=y,C=c):I===y&&(C=Math.max(C,c)),P>b?(P=b,R=v):P===b&&(R=Math.min(R,v)),I>P||I===P&&C>R?null:new i(I,C,P,R)}equalsRange(_){return i.equalsRange(this,_)}static equalsRange(_,T){return!!_&&!!T&&_.startLineNumber===T.startLineNumber&&_.startColumn===T.startColumn&&_.endLineNumber===T.endLineNumber&&_.endColumn===T.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(_){return new f.Position(_.endLineNumber,_.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(_){return new f.Position(_.startLineNumber,_.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(_,T){return new i(this.startLineNumber,this.startColumn,_,T)}setStartPosition(_,T){return new i(_,T,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(_){return new i(_.startLineNumber,_.startColumn,_.startLineNumber,_.startColumn)}static fromPositions(_,T=_){return new i(_.lineNumber,_.column,T.lineNumber,T.column)}static lift(_){return _?new i(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn):null}static isIRange(_){return _&&typeof _.startLineNumber=="number"&&typeof _.startColumn=="number"&&typeof _.endLineNumber=="number"&&typeof _.endColumn=="number"}static areIntersectingOrTouching(_,T){return!(_.endLineNumber<T.startLineNumber||_.endLineNumber===T.startLineNumber&&_.endColumn<T.startColumn||T.endLineNumber<_.startLineNumber||T.endLineNumber===_.startLineNumber&&T.endColumn<_.startColumn)}static areIntersecting(_,T){return!(_.endLineNumber<T.startLineNumber||_.endLineNumber===T.startLineNumber&&_.endColumn<=T.startColumn||T.endLineNumber<_.startLineNumber||T.endLineNumber===_.startLineNumber&&T.endColumn<=_.startColumn)}static compareRangesUsingStarts(_,T){if(_&&T){const P=_.startLineNumber|0,R=T.startLineNumber|0;if(P===R){const y=_.startColumn|0,c=T.startColumn|0;if(y===c){const b=_.endLineNumber|0,v=T.endLineNumber|0;if(b===v){const p=_.endColumn|0,w=T.endColumn|0;return p-w}return b-v}return y-c}return P-R}return(_?1:0)-(T?1:0)}static compareRangesUsingEnds(_,T){return _.endLineNumber===T.endLineNumber?_.endColumn===T.endColumn?_.startLineNumber===T.startLineNumber?_.startColumn-T.startColumn:_.startLineNumber-T.startLineNumber:_.endColumn-T.endColumn:_.endLineNumber-T.endLineNumber}static spansMultipleLines(_){return _.endLineNumber>_.startLineNumber}}e.Range=i}),define(ve[145],we([0,1,49,41]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class _ extends i.Range{constructor(I,C,P,R){super(I,C,P,R);this.selectionStartLineNumber=I,this.selectionStartColumn=C,this.positionLineNumber=P,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return _.selectionsEqual(this,I)}static selectionsEqual(I,C){return I.selectionStartLineNumber===C.selectionStartLineNumber&&I.selectionStartColumn===C.selectionStartColumn&&I.positionLineNumber===C.positionLineNumber&&I.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,C){return this.getDirection()===0?new _(this.startLineNumber,this.startColumn,I,C):new _(I,C,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new f.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(I,C){return this.getDirection()===0?new _(I,C,this.endLineNumber,this.endColumn):new _(this.endLineNumber,this.endColumn,I,C)}static fromPositions(I,C=I){return new _(I.lineNumber,I.column,C.lineNumber,C.column)}static fromRange(I,C){return C===0?new _(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):new _(I.endLineNumber,I.endColumn,I.startLineNumber,I.startColumn)}static liftSelection(I){return new _(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,C){if(I&&!C||!I&&C)return!1;if(!I&&!C)return!0;if(I.length!==C.length)return!1;for(let P=0,R=I.length;P<R;P++)if(!this.selectionsEqual(I[P],C[P]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,C,P,R,y){return y===0?new _(I,C,P,R):new _(P,R,I,C)}}e.Selection=_}),define(ve[146],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class i{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let C=0,P=I.notIn.length;C<P;C++)switch(I.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,C){if(I.getTokenCount()===0)return!0;const P=I.findTokenIndexAtOffset(C-2),R=I.getStandardTokenType(P);return this.isOK(R)}_findNeutralCharacterInRange(I,C){for(let P=I;P<=C;P++){const R=String.fromCharCode(P);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class k{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of I)_(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),_(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),_(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),_(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&_(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=k;function _(T,I,C){T.has(I)?T.get(I).push(C):T.set(I,[C])}}),define(ve[83],we([0,1,32,8]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(_,T,I,C){if(Array.isArray(_)){let P=0;for(const R of _){const y=k(R,T,I,C);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof _=="string")return C?_==="*"?5:_===I?10:0:0;if(_){const{language:P,pattern:R,scheme:y,hasAccessToAllModels:c}=_;if(!C&&!c)return 0;let b=0;if(y)if(y===T.scheme)b=10;else if(y==="*")b=5;else return 0;if(P)if(P===I)b=10;else if(P==="*")b=Math.max(b,5);else return 0;if(R){let v;if(typeof R=="string"?v=R:v={...R,base:(0,i.normalize)(R.base)},v===T.fsPath||(0,f.match)(v,T.fsPath))b=10;else return 0}return b}else return 0}}e.score=k}),define(ve[147],we([0,1,108]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class k{constructor(v,p,w){const L=new Uint8Array(v*p);for(let S=0,o=v*p;S<o;S++)L[S]=w;this._data=L,this.rows=v,this.cols=p}get(v,p){return this._data[v*this.cols+p]}set(v,p,w){this._data[v*this.cols+p]=w}}e.Uint8Matrix=k;class _{constructor(v){let p=0,w=0;for(let S=0,o=v.length;S<o;S++){const[r,m,a]=v[S];m>p&&(p=m),r>w&&(w=r),a>w&&(w=a)}p++,w++;const L=new k(w,p,0);for(let S=0,o=v.length;S<o;S++){const[r,m,a]=v[S];L.set(r,m,a)}this._states=L,this._maxCharCode=p}nextState(v,p){return p<0||p>=this._maxCharCode?0:this._states.get(v,p)}}e.StateMachine=_;let T=null;function I(){return T===null&&(T=new _([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var C;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(C||(C={}));let P=null;function R(){if(P===null){P=new f.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<b.length;p++)P.set(b.charCodeAt(p),1);const v=".,;";for(let p=0;p<v.length;p++)P.set(v.charCodeAt(p),2)}return P}class y{static _createLink(v,p,w,L,S){let o=S-1;do{const r=p.charCodeAt(o);if(v.get(r)!==2)break;o--}while(o>L);if(L>0){const r=p.charCodeAt(L-1),m=p.charCodeAt(o);(r===40&&m===41||r===91&&m===93||r===123&&m===125)&&o--}return{range:{startLineNumber:w,startColumn:L+1,endLineNumber:w,endColumn:o+2},url:p.substring(L,o+1)}}static computeLinks(v,p=I()){const w=R(),L=[];for(let S=1,o=v.getLineCount();S<=o;S++){const r=v.getLineContent(S),m=r.length;let a=0,E=0,n=0,t=1,s=!1,u=!1,d=!1,h=!1;for(;a<m;){let g=!1;const l=r.charCodeAt(a);if(t===13){let D;switch(l){case 40:s=!0,D=0;break;case 41:D=s?0:1;break;case 91:d=!0,u=!0,D=0;break;case 93:d=!1,D=u?0:1;break;case 123:h=!0,D=0;break;case 125:D=h?0:1;break;case 39:D=n===34||n===96?0:1;break;case 34:D=n===39||n===96?0:1;break;case 96:D=n===39||n===34?0:1;break;case 42:D=n===42?1:0;break;case 124:D=n===124?1:0;break;case 32:D=d?0:1;break;default:D=w.get(l)}D===1&&(L.push(y._createLink(w,r,S,E,a)),g=!0)}else if(t===12){let D;l===91?(u=!0,D=0):D=w.get(l),D===1?g=!0:t=13}else t=p.nextState(t,l),t===0&&(g=!0);g&&(t=1,s=!1,u=!1,h=!1,E=a+1,n=l),a++}t===13&&L.push(y._createLink(w,r,S,E,m))}return L}}e.LinkComputer=y;function c(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:y.computeLinks(b)}e.computeLinks=c}),define(ve[148],we([0,1,3,6]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,C){return this._map.set(I,C),this.fire([I]),(0,i.toDisposable)(()=>{this._map.get(I)===C&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,C){this._factories.get(I)?.dispose();const P=new _(this,I,C);return this._factories.set(I,P),(0,i.toDisposable)(()=>{const R=this._factories.get(I);!R||R!==P||(this._factories.delete(I),R.dispose())})}async getOrCreate(I){const C=this.get(I);if(C)return C;const P=this._factories.get(I);return!P||P.isResolved?null:(await P.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const P=this._factories.get(I);return!!(!P||P.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=k;class _ extends i.Disposable{constructor(I,C,P){super();this._registry=I,this._languageId=C,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(ve[109],we([0,1,25]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var _;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(_=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(w){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,w.tabSize|0),this.indentSize=w.tabSize|0,this.insertSpaces=Boolean(w.insertSpaces),this.defaultEOL=w.defaultEOL|0,this.trimAutoWhitespace=Boolean(w.trimAutoWhitespace),this.bracketPairColorizationOptions=w.bracketPairColorizationOptions}equals(w){return this.tabSize===w.tabSize&&this.indentSize===w.indentSize&&this.insertSpaces===w.insertSpaces&&this.defaultEOL===w.defaultEOL&&this.trimAutoWhitespace===w.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,w.bracketPairColorizationOptions)}createChangeEvent(w){return{tabSize:this.tabSize!==w.tabSize,indentSize:this.indentSize!==w.indentSize,insertSpaces:this.insertSpaces!==w.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==w.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class P{constructor(w,L){this._findMatchBrand=void 0,this.range=w,this.matches=L}}e.FindMatch=P;var R;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var y;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(y=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class b{constructor(w,L,S,o,r,m){this.identifier=w,this.range=L,this.text=S,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=r,this._isTracked=m}}e.ValidAnnotatedEditOperation=b;class v{constructor(w,L,S){this.reverseEdits=w,this.changes=L,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=v}),define(ve[149],we([0,1,9,144,49,41,109]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class C{constructor(o,r,m,a){this.searchString=o,this.isRegex=r,this.matchCase=m,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=P(this.searchString):o=this.searchString.indexOf(`
`)>=0;let r=null;try{r=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch{return null}if(!r)return null;let m=!this.isRegex&&!o;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new R(r,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=C;function P(S){if(!S||S.length===0)return!1;for(let o=0,r=S.length;o<r;o++)if(S.charCodeAt(o)===92){if(o++,o>=r)break;const a=S.charCodeAt(o);if(a===110||a===114||a===87)return!0}return!1}e.isMultilineRegexSource=P;class R{constructor(o,r,m){this.regex=o,this.wordSeparators=r,this.simpleSearch=m}}e.SearchData=R;function y(S,o,r){if(!r)return new T.FindMatch(S,null);const m=[];for(let a=0,E=o.length;a<E;a++)m[a]=o[a];return new T.FindMatch(S,m)}e.createFindMatch=y;class c{constructor(o){const r=[];let m=0;for(let a=0,E=o.length;a<E;a++)o.charCodeAt(a)===10&&(r[m++]=a);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(o){const r=this._lineFeedsOffsets;let m=0,a=r.length-1;if(a===-1||o<=r[0])return 0;for(;m<a;){const E=m+((a-m)/2>>0);r[E]>=o?a=E-1:r[E+1]>=o?(m=E,a=E):m=E+1}return m+1}}class b{static findMatches(o,r,m,a,E){const n=r.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(o,m,new L(n.wordSeparators,n.regex),a,E):this._doFindMatchesLineByLine(o,m,n,a,E):[]}static _getMultilineMatchRange(o,r,m,a,E,n){let t,s=0;a?(s=a.findLineFeedCountBeforeOffset(E),t=r+E+s):t=r+E;let u;if(a){const l=a.findLineFeedCountBeforeOffset(E+n.length)-s;u=t+n.length+l}else u=t+n.length;const d=o.getPositionAt(t),h=o.getPositionAt(u);return new _.Range(d.lineNumber,d.column,h.lineNumber,h.column)}static _doFindMatchesMultiline(o,r,m,a,E){const n=o.getOffsetAt(r.getStartPosition()),t=o.getValueInRange(r,1),s=o.getEOL()===`\r
`?new c(t):null,u=[];let d=0,h;for(m.reset(0);h=m.next(t);)if(u[d++]=y(this._getMultilineMatchRange(o,n,t,s,h.index,h[0]),h,a),d>=E)return u;return u}static _doFindMatchesLineByLine(o,r,m,a,E){const n=[];let t=0;if(r.startLineNumber===r.endLineNumber){const u=o.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return t=this._findMatchesInLine(m,u,r.startLineNumber,r.startColumn-1,t,n,a,E),n}const s=o.getLineContent(r.startLineNumber).substring(r.startColumn-1);t=this._findMatchesInLine(m,s,r.startLineNumber,r.startColumn-1,t,n,a,E);for(let u=r.startLineNumber+1;u<r.endLineNumber&&t<E;u++)t=this._findMatchesInLine(m,o.getLineContent(u),u,0,t,n,a,E);if(t<E){const u=o.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);t=this._findMatchesInLine(m,u,r.endLineNumber,0,t,n,a,E)}return n}static _findMatchesInLine(o,r,m,a,E,n,t,s){const u=o.wordSeparators;if(!t&&o.simpleSearch){const g=o.simpleSearch,l=g.length,D=r.length;let A=-l;for(;(A=r.indexOf(g,A+l))!==-1;)if((!u||w(u,r,D,A,l))&&(n[E++]=new T.FindMatch(new _.Range(m,A+1+a,m,A+1+l+a),null),E>=s))return E;return E}const d=new L(o.wordSeparators,o.regex);let h;d.reset(0);do if(h=d.next(r),h&&(n[E++]=y(new _.Range(m,h.index+1+a,m,h.index+1+h[0].length+a),h,t),E>=s))return E;while(h);return E}static findNextMatch(o,r,m,a){const E=r.parseSearchRequest();if(!E)return null;const n=new L(E.wordSeparators,E.regex);return E.regex.multiline?this._doFindNextMatchMultiline(o,m,n,a):this._doFindNextMatchLineByLine(o,m,n,a)}static _doFindNextMatchMultiline(o,r,m,a){const E=new k.Position(r.lineNumber,1),n=o.getOffsetAt(E),t=o.getLineCount(),s=o.getValueInRange(new _.Range(E.lineNumber,E.column,t,o.getLineMaxColumn(t)),1),u=o.getEOL()===`\r
`?new c(s):null;m.reset(r.column-1);let d=m.next(s);return d?y(this._getMultilineMatchRange(o,n,s,u,d.index,d[0]),d,a):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(o,new k.Position(1,1),m,a):null}static _doFindNextMatchLineByLine(o,r,m,a){const E=o.getLineCount(),n=r.lineNumber,t=o.getLineContent(n),s=this._findFirstMatchInLine(m,t,n,r.column,a);if(s)return s;for(let u=1;u<=E;u++){const d=(n+u-1)%E,h=o.getLineContent(d+1),g=this._findFirstMatchInLine(m,h,d+1,1,a);if(g)return g}return null}static _findFirstMatchInLine(o,r,m,a,E){o.reset(a-1);const n=o.next(r);return n?y(new _.Range(m,n.index+1,m,n.index+1+n[0].length),n,E):null}static findPreviousMatch(o,r,m,a){const E=r.parseSearchRequest();if(!E)return null;const n=new L(E.wordSeparators,E.regex);return E.regex.multiline?this._doFindPreviousMatchMultiline(o,m,n,a):this._doFindPreviousMatchLineByLine(o,m,n,a)}static _doFindPreviousMatchMultiline(o,r,m,a){const E=this._doFindMatchesMultiline(o,new _.Range(1,1,r.lineNumber,r.column),m,a,10*I);if(E.length>0)return E[E.length-1];const n=o.getLineCount();return r.lineNumber!==n||r.column!==o.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(o,new k.Position(n,o.getLineMaxColumn(n)),m,a):null}static _doFindPreviousMatchLineByLine(o,r,m,a){const E=o.getLineCount(),n=r.lineNumber,t=o.getLineContent(n).substring(0,r.column-1),s=this._findLastMatchInLine(m,t,n,a);if(s)return s;for(let u=1;u<=E;u++){const d=(E+n-u-1)%E,h=o.getLineContent(d+1),g=this._findLastMatchInLine(m,h,d+1,a);if(g)return g}return null}static _findLastMatchInLine(o,r,m,a){let E=null,n;for(o.reset(0);n=o.next(r);)E=y(new _.Range(m,n.index+1,m,n.index+1+n[0].length),n,a);return E}}e.TextModelSearch=b;function v(S,o,r,m,a){if(m===0)return!0;const E=o.charCodeAt(m-1);if(S.get(E)!==0||E===13||E===10)return!0;if(a>0){const n=o.charCodeAt(m);if(S.get(n)!==0)return!0}return!1}function p(S,o,r,m,a){if(m+a===r)return!0;const E=o.charCodeAt(m+a);if(S.get(E)!==0||E===13||E===10)return!0;if(a>0){const n=o.charCodeAt(m+a-1);if(S.get(n)!==0)return!0}return!1}function w(S,o,r,m,a){return v(S,o,r,m,a)&&p(S,o,r,m,a)}e.isValidMatch=w;class L{constructor(o,r){this._wordSeparators=o,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const r=o.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(m=this._searchRegex.exec(o),!m))return null;const a=m.index,E=m[0].length;if(a===this._prevMatchStartIndex&&E===this._prevMatchLength){if(E===0){f.getNextCodePoint(o,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=E,!this._wordSeparators||w(this._wordSeparators,o,r,a,E))return m}while(m);return null}}e.Searcher=L}),define(ve[110],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(I=""){let C="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)I.indexOf(P)>=0||(C+="\\"+P);return C+="\\s]+)",new RegExp(C,"g")}e.DEFAULT_WORD_REGEXP=f();function i(I){let C=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)C=I;else{let P="g";I.ignoreCase&&(P+="i"),I.multiline&&(P+="m"),I.unicode&&(P+="u"),C=new RegExp(I.source,P)}return C.lastIndex=0,C}e.ensureValidWordDefinition=i;const k={maxLen:1e3,windowSize:15,timeBudget:150};function _(I,C,P,R,y=k){if(P.length>y.maxLen){let w=I-y.maxLen/2;return w<0?w=0:R+=w,P=P.substring(w,I+y.maxLen/2),_(I,C,P,R,y)}const c=Date.now(),b=I-1-R;let v=-1,p=null;for(let w=1;!(Date.now()-c>=y.timeBudget);w++){const L=b-y.windowSize*w;C.lastIndex=Math.max(0,L);const S=T(C,P,b,v);if(!S&&p||(p=S,L<=0))break;v=L}if(p){const w={word:p[0],startColumn:R+1+p.index,endColumn:R+1+p.index+p[0].length};return C.lastIndex=0,w}return null}e.getWordAtText=_;function T(I,C,P,R){let y;for(;y=I.exec(C);){const c=y.index||0;if(c<=P&&I.lastIndex>=P)return y;if(R>0&&c>R)return null}return null}}),define(ve[111],we([0,1,22,12]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(k||(k={}));function _(y){for(let c=0,b=y.length;c<b;c+=4){const v=y[c+0],p=y[c+1],w=y[c+2],L=y[c+3];y[c+0]=L,y[c+1]=w,y[c+2]=p,y[c+3]=v}}function T(y){const c=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return i.isLittleEndian()||_(c),f.VSBuffer.wrap(c)}function I(y){const c=y.buffer;if(i.isLittleEndian()||_(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const b=new Uint8Array(c.byteLength);return b.set(c),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function C(y){const c=new Uint32Array(P(y));let b=0;if(c[b++]=y.id,y.type==="full")c[b++]=1,c[b++]=y.data.length,c.set(y.data,b),b+=y.data.length;else{c[b++]=2,c[b++]=y.deltas.length;for(const v of y.deltas)c[b++]=v.start,c[b++]=v.deleteCount,v.data?(c[b++]=v.data.length,c.set(v.data,b),b+=v.data.length):c[b++]=0}return T(c)}e.encodeSemanticTokensDto=C;function P(y){let c=0;if(c+=1+1,y.type==="full")c+=1+y.data.length;else{c+=1,c+=(1+1+1)*y.deltas.length;for(const b of y.deltas)b.data&&(c+=b.data.length)}return c}function R(y){const c=I(y);let b=0;const v=c[b++];if(c[b++]===1){const S=c[b++],o=c.subarray(b,b+S);return b+=S,{id:v,type:"full",data:o}}const w=c[b++],L=[];for(let S=0;S<w;S++){const o=c[b++],r=c[b++],m=c[b++];let a;m>0&&(a=c.subarray(b,b+m),b+=m),L[S]={start:o,deleteCount:r,data:a}}return{id:v,type:"delta",deltas:L}}e.decodeSemanticTokensDto=R}),define(ve[112],we([0,1,16,100]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,P){C=(0,i.toUint32)(C);const R=this.values,y=this.prefixSum,c=P.length;return c===0?!1:(this.values=new Uint32Array(R.length+c),this.values.set(R.subarray(0,C),0),this.values.set(R.subarray(C),C+c),this.values.set(P,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(C,P){return C=(0,i.toUint32)(C),P=(0,i.toUint32)(P),this.values[C]===P?!1:(this.values[C]=P,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,P){C=(0,i.toUint32)(C),P=(0,i.toUint32)(P);const R=this.values,y=this.prefixSum;if(C>=R.length)return!1;const c=R.length-C;return P>=c&&(P=c),P===0?!1:(this.values=new Uint32Array(R.length-P),this.values.set(R.subarray(0,C),0),this.values.set(R.subarray(C+P),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(C){return C<0?0:(C=(0,i.toUint32)(C),this._getPrefixSum(C))}_getPrefixSum(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),C>=this.values.length&&(C=this.values.length-1);for(let R=P;R<=C;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalSum();let P=0,R=this.values.length-1,y=0,c=0,b=0;for(;P<=R;)if(y=P+(R-P)/2|0,c=this.prefixSum[y],b=c-this.values[y],C<b)R=y-1;else if(C>=c)P=y+1;else break;return new T(y,C-b)}}e.PrefixSumComputer=k;class _{constructor(C){this._values=C,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(C){return this._ensureValid(),C===0?0:this._prefixSum[C-1]}getIndexOf(C){this._ensureValid();const P=this._indexBySum[C],R=P>0?this._prefixSum[P-1]:0;return new T(P,C-R)}removeValues(C,P){this._values.splice(C,P),this._invalidate(C)}insertValues(C,P){this._values=(0,f.arrayInsert)(this._values,C,P),this._invalidate(C)}_invalidate(C){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,C-1)}_ensureValid(){if(!this._isValid){for(let C=this._validEndIndex+1,P=this._values.length;C<P;C++){const R=this._values[C],y=C>0?this._prefixSum[C-1]:0;this._prefixSum[C]=y+R;for(let c=0;c<R;c++)this._indexBySum[y+c]=C}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(C,P){this._values[C]!==P&&(this._values[C]=P,this._invalidate(C))}}e.ConstantTimePrefixSumComputer=_;class T{constructor(C,P){this.index=C,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=C,this.remainder=P}}e.PrefixSumIndexOfResult=T}),define(ve[150],we([0,1,9,49,112]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class _{constructor(I,C,P,R){this._uri=I,this._lines=C,this._eol=P,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const C=I.changes;for(const P of C)this._acceptDeleteRange(P.range),this._acceptInsertText(new i.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,C=this._lines.length,P=new Uint32Array(C);for(let R=0;R<C;R++)P[R]=this._lines[R].length+I;this._lineStarts=new k.PrefixSumComputer(P)}}_setLineText(I,C){this._lines[I]=C,this._lineStarts&&this._lineStarts.setValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,C){if(C.length===0)return;const P=(0,f.splitLines)(C);if(P.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+P[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}P[P.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+P[0]);const R=new Uint32Array(P.length-1);for(let y=1;y<P.length;y++)this._lines.splice(I.lineNumber+y-1,0,P[y]),R[y-1]=P[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,R)}}e.MirrorTextModel=_}),define(ve[151],we([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(ve[152],we([0,1,151]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,k=i*60,_=k*24,T=_*7,I=_*30,C=_*365;function P(y,c){typeof y!="number"&&(y=y.getTime());const b=Math.round((new Date().getTime()-y)/1e3);if(b<-30)return(0,f.localize)(0,null,P(new Date().getTime()+b*1e3,!1));if(b<30)return(0,f.localize)(1,null);let v;return b<i?(v=b,c?v===1?(0,f.localize)(2,null,v):(0,f.localize)(3,null,v):v===1?(0,f.localize)(4,null,v):(0,f.localize)(5,null,v)):b<k?(v=Math.floor(b/i),c?v===1?(0,f.localize)(6,null,v):(0,f.localize)(7,null,v):v===1?(0,f.localize)(8,null,v):(0,f.localize)(9,null,v)):b<_?(v=Math.floor(b/k),c?v===1?(0,f.localize)(10,null,v):(0,f.localize)(11,null,v):v===1?(0,f.localize)(12,null,v):(0,f.localize)(13,null,v)):b<T?(v=Math.floor(b/_),c?v===1?(0,f.localize)(14,null,v):(0,f.localize)(15,null,v):v===1?(0,f.localize)(16,null,v):(0,f.localize)(17,null,v)):b<I?(v=Math.floor(b/T),c?v===1?(0,f.localize)(18,null,v):(0,f.localize)(19,null,v):v===1?(0,f.localize)(20,null,v):(0,f.localize)(21,null,v)):b<C?(v=Math.floor(b/I),c?v===1?(0,f.localize)(22,null,v):(0,f.localize)(23,null,v):v===1?(0,f.localize)(24,null,v):(0,f.localize)(25,null,v)):(v=Math.floor(b/C),c?v===1?(0,f.localize)(26,null,v):(0,f.localize)(27,null,v):v===1?(0,f.localize)(28,null,v):(0,f.localize)(29,null,v))}e.fromNow=P;function R(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ve[153],we([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ve[50],we([0,1,16,13,153]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(P,R){return R&&(P.stack||P.stacktrace)?k.localize(0,null,I(P),T(P.stack)||T(P.stacktrace)):I(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function I(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function C(P=null,R=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const y=f.coalesce(P),c=C(y[0],R);return y.length>1?k.localize(4,null,c,y.length):c}if(i.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return _(y.error,R);if(y.exception)return _(y.exception,R)}return P.stack?_(P,R):P.message?P.message:k.localize(5,null)}e.toErrorMessage=C}),define(ve[154],we([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(ve[113],we([0,1,37,28,10,25,8,12,40,96,13,143,29,154]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function v(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(a,E){if(I.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};E&&(n.cwd=E);const t=f.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],n);return new Promise(s=>{t.once("error",u=>{s({success:!1,error:u})}),t.once("exit",(u,d)=>{s(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?v(n.status):1})}else if(I.isLinux||I.isMacintosh)try{const n=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(t=>{f.execFile(n,[a.pid.toString()],{encoding:"utf8",shell:!0},(s,u,d)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function w(a){!a||(delete a.DEBUG,I.isMacintosh&&delete a.DYLD_LIBRARY_PATH,I.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=w;function L(a=C.env){return a.comspec||"cmd.exe"}e.getWindowsShell=L;class S{constructor(E,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=E,this.args=n,this.shell=t,this.options=s;else{const u=E;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(C.env).forEach(d=>{u[d]=C.env[d]}),Object.keys(this.options.env).forEach(d=>{u[d]=this.options.env[d]}),this.options.env=u}}getSanitizedCommand(){let E=this.cmd.toLowerCase();const n=E.lastIndexOf(T.sep);return n!==-1&&(E=E.substring(n+1)),S.WellKnowCommands[E]?E:"other"}start(E){return I.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(C.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(n=>{let t,s;const u=new Promise((d,h)=>{t=d,s=h});if(n){let d=this.cmd;this.args&&(d=d+" "+this.args.join(" ")),this.childProcess=f.exec(d,this.options,(h,g,l)=>{this.childProcess=null;const D=h;D&&D.killed?s({killed:this.terminateRequested,stdout:g.toString(),stderr:l.toString()}):this.handleExec(t,E,h,g,l)})}else{let d=null;const h=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,t,E,s);const l={terminated:this.terminateRequested};R.isNumber(g)&&(l.cmdCode=g),t(l)};if(this.shell&&I.isWindows){const g=_.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let l=!1,D=!1;const A=[];let N=this.ensureQuotes(this.cmd);A.push(N.value),l=N.quoted,this.args&&this.args.forEach(F=>{N=this.ensureQuotes(F),A.push(N.value),D=D&&N.quoted});const B=["/s","/c"];l?D?B.push('"'+A.join(" ")+'"'):A.length>1?B.push('"'+A[0]+'" '+A.slice(1).join(" ")):B.push('"'+A[0]+'"'):B.push(A.join(" ")),d=f.spawn(L(),B,g)}else this.cmd&&(d=f.spawn(this.cmd,this.args,this.options));d&&(this.childProcess=d,this.childProcessPromise=Promise.resolve(d),this.pidResolve&&(this.pidResolve(R.isNumber(d.pid)?d.pid:-1),this.pidResolve=void 0),d.on("error",g=>{this.childProcess=null,s({terminated:this.terminateRequested,error:g})}),d.pid&&(this.childProcess.on("close",h),this.handleSpawn(d,t,E,s,!0)))}return u})}handleClose(E,n,t,s){}ensureQuotes(E){return S.regexp.test(E)?{value:'"'+E+'"',quoted:!0}:{value:E,quoted:E.length>0&&E[0]==='"'&&E[E.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(E=>E.pid,E=>-1):new Promise(E=>{this.pidResolve=E})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(E=>(this.terminateRequested=!0,p(E,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),E=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(E=>{if(!this.shell||!I.isWindows)return E(!1);const n=f.spawn(L(),["/s","/c"]);n.on("error",t=>E(!0)),n.on("exit",t=>E(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class o extends S{constructor(E,n,t,s){super(E,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(E,n,t,s,u){[s,u].forEach((d,h)=>{const g=new y.LineDecoder;g.write(d).forEach(A=>{n({line:A,source:h===0?0:1})});const D=g.end();D&&n({line:D,source:h===0?0:1})}),E({terminated:this.terminateRequested,error:t})}handleSpawn(E,n,t,s,u){const d=new y.LineDecoder,h=new y.LineDecoder;E.stdout.on("data",g=>{d.write(g).forEach(D=>t({line:D,source:0}))}),E.stderr.on("data",g=>{h.write(g).forEach(D=>t({line:D,source:1}))}),this.stdoutLineDecoder=d,this.stderrLineDecoder=h}handleClose(E,n,t,s){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&t({line:u,source:0});const d=this.stderrLineDecoder?this.stderrLineDecoder.end():null;d&&t({line:d,source:1})}}e.LineProcess=o;function r(a){let E=[],n=!1;const t=function(s){if(n){E.push(s);return}(!a.send(s,d=>{if(d&&console.error(d),n=!1,E.length>0){const h=E.slice(0);E=[],h.forEach(g=>t(g))}})||I.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=r;var m;(function(a){async function E(n,t,s){if(T.isAbsolute(n))return n;if(t===void 0&&(t=C.cwd()),T.dirname(n)!=="."||(s===void 0&&R.isString(C.env.PATH)&&(s=C.env.PATH.split(T.delimiter)),s===void 0||s.length===0))return T.join(t,n);async function d(h){if(await c.Promises.exists(h)){let g;try{g=await c.Promises.stat(h)}catch(l){l.message.startsWith("EACCES")&&(g=await c.Promises.lstat(h))}return g?!g.isDirectory():!1}return!1}for(let h of s){let g;if(T.isAbsolute(h)?g=T.join(h,n):g=T.join(t,h,n),await d(g))return g;let l=g+".com";if(await d(l)||(l=g+".exe",await d(l)))return l}return T.join(t,n)}a.findExecutable=E})(m=e.win32||(e.win32={}))}),define(ve[155],we([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(ve[114],we([0,1,155,12,110,16,25]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=C;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class R{constructor(te,Ee,ie,Ce){this.id=te,this.name=Ee,this.defaultValue=ie,this.schema=Ce}applyUpdate(te,Ee){return c(te,Ee)}compute(te,Ee,ie){return ie}}class y{constructor(te,Ee){this.newValue=te,this.didChange=Ee}}e.ApplyUpdateResult=y;function c(ee,te){if(typeof ee!="object"||typeof te!="object"||!ee||!te)return new y(te,ee!==te);if(Array.isArray(ee)||Array.isArray(te)){const ie=Array.isArray(ee)&&Array.isArray(te)&&_.equals(ee,te);return new y(te,ie)}let Ee=!1;for(const ie in te)if(te.hasOwnProperty(ie)){const Ce=c(ee[ie],te[ie]);Ce.didChange&&(ee[ie]=Ce.newValue,Ee=!0)}return new y(ee,Ee)}class b{constructor(te){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0}applyUpdate(te,Ee){return c(te,Ee)}validate(te){return this.defaultValue}}class v{constructor(te,Ee,ie,Ce){this.id=te,this.name=Ee,this.defaultValue=ie,this.schema=Ce}applyUpdate(te,Ee){return c(te,Ee)}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,Ee,ie){return ie}}function p(ee,te){return typeof ee=="undefined"?te:ee==="false"?!1:Boolean(ee)}e.boolean=p;class w extends v{constructor(te,Ee,ie,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="boolean",Ce.default=ie);super(te,Ee,ie,Ce)}validate(te){return p(te,this.defaultValue)}}function L(ee,te,Ee,ie){if(typeof ee=="undefined")return te;let Ce=parseInt(ee,10);return isNaN(Ce)?te:(Ce=Math.max(Ee,Ce),Ce=Math.min(ie,Ce),Ce|0)}e.clampedInt=L;class S extends v{constructor(te,Ee,ie,Ce,Fe,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="integer",Ge.default=ie,Ge.minimum=Ce,Ge.maximum=Fe);super(te,Ee,ie,Ge);this.minimum=Ce,this.maximum=Fe}static clampedInt(te,Ee,ie,Ce){return L(te,Ee,ie,Ce)}validate(te){return S.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class o extends v{constructor(te,Ee,ie,Ce,Fe){typeof Fe!="undefined"&&(Fe.type="number",Fe.default=ie);super(te,Ee,ie,Fe);this.validationFn=Ce}static clamp(te,Ee,ie){return te<Ee?Ee:te>ie?ie:te}static float(te,Ee){if(typeof te=="number")return te;if(typeof te=="undefined")return Ee;const ie=parseFloat(te);return isNaN(ie)?Ee:ie}validate(te){return this.validationFn(o.float(te,this.defaultValue))}}class r extends v{static string(te,Ee){return typeof te!="string"?Ee:te}constructor(te,Ee,ie,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.default=ie);super(te,Ee,ie,Ce)}validate(te){return r.string(te,this.defaultValue)}}function m(ee,te,Ee){return typeof ee!="string"||Ee.indexOf(ee)===-1?te:ee}e.stringSet=m;class a extends v{constructor(te,Ee,ie,Ce,Fe=void 0){typeof Fe!="undefined"&&(Fe.type="string",Fe.enum=Ce,Fe.default=ie);super(te,Ee,ie,Fe);this._allowedValues=Ce}validate(te){return m(te,this.defaultValue,this._allowedValues)}}class E extends R{constructor(te,Ee,ie,Ce,Fe,Ge,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.enum=Fe,ze.default=Ce);super(te,Ee,ie,ze);this._allowedValues=Fe,this._convert=Ge}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function n(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,Ee,ie){return ie===0?te.accessibilitySupport:ie}}class s extends R{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:f.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{insertSpace:p(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:p(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var u;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(u=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function d(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function g(ee){switch(ee){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function l(ee){switch(ee){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class D extends b{constructor(){super(127)}compute(te,Ee,ie){const Ce=["monaco-editor"];return Ee.get(33)&&Ce.push(Ee.get(33)),te.extraEditorClassName&&Ce.push(te.extraEditorClassName),Ee.get(65)==="default"?Ce.push("mouse-default"):Ee.get(65)==="copy"&&Ce.push("mouse-copy"),Ee.get(99)&&Ce.push("showUnused"),Ee.get(125)&&Ce.push("showDeprecated"),Ce.join(" ")}}class A extends w{constructor(){super(32,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(te,Ee,ie){return ie&&te.emptySelectionClipboard}}class N extends R{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:f.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:f.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{cursorMoveOnType:p(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":m(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":m(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:p(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:p(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:p(Ee.loop,this.defaultValue.loop)}}}class B extends R{constructor(){super(44,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?B.OFF:te==="true"?B.ON:te:Boolean(te)?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class F extends b{constructor(){super(43)}compute(te,Ee,ie){return te.fontInfo}}class O extends v{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(te){const Ee=o.float(te,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Ee,6,100)}compute(te,Ee,ie){return te.fontInfo.fontSize}}class z extends R{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(S.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class W extends R{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:ie,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:ie,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:ie,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:ie,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:ie,description:f.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{multiple:m(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??m(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??m(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??m(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??m(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??m(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class M extends R{constructor(){const te={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:f.localize(41,null)},"editor.hover.above":{type:"boolean",default:te.above,description:f.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{enabled:p(Ee.enabled,this.defaultValue.enabled),delay:S.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:p(Ee.sticky,this.defaultValue.sticky),above:p(Ee.above,this.defaultValue.above)}}}var x;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class V extends b{constructor(){super(130)}compute(te,Ee,ie){return V.computeLayout(Ee,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const Ee=te.height/te.lineHeight,ie=te.scrollBeyondLastLine?Ee-1:0,Ce=(te.viewLineCount+ie)/(te.pixelRatio*te.height),Fe=Math.floor(te.viewLineCount/Ce);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:ie,desiredRatio:Ce,minimapLineCount:Fe}}static _computeMinimapLayout(te,Ee){const ie=te.outerWidth,Ce=te.outerHeight,Fe=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Fe*Ce),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ce};const Ge=Ee.stableMinimapLayoutInput,ze=Ge&&te.outerHeight===Ge.outerHeight&&te.lineHeight===Ge.lineHeight&&te.typicalHalfwidthCharacterWidth===Ge.typicalHalfwidthCharacterWidth&&te.pixelRatio===Ge.pixelRatio&&te.scrollBeyondLastLine===Ge.scrollBeyondLastLine&&te.minimap.enabled===Ge.minimap.enabled&&te.minimap.side===Ge.minimap.side&&te.minimap.size===Ge.minimap.size&&te.minimap.showSlider===Ge.minimap.showSlider&&te.minimap.renderCharacters===Ge.minimap.renderCharacters&&te.minimap.maxColumn===Ge.minimap.maxColumn&&te.minimap.scale===Ge.minimap.scale&&te.verticalScrollbarWidth===Ge.verticalScrollbarWidth&&te.isViewportWrapping===Ge.isViewportWrapping,ut=te.lineHeight,Ae=te.typicalHalfwidthCharacterWidth,Te=te.scrollBeyondLastLine,De=te.minimap.renderCharacters;let oe=Fe>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const me=te.minimap.maxColumn,be=te.minimap.size,_e=te.minimap.side,Ne=te.verticalScrollbarWidth,Qe=te.viewLineCount,$e=te.remainingWidth,Xe=te.isViewportWrapping,st=De?2:3;let ot=Math.floor(Fe*Ce);const fe=ot/Fe;let ye=!1,de=!1,Q=st*oe,Ie=oe/Fe,Oe=1;if(be==="fill"||be==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:wt,desiredRatio:_t,minimapLineCount:Mt}=V.computeContainedMinimapLineCount({viewLineCount:Qe,scrollBeyondLastLine:Te,height:Ce,lineHeight:ut,pixelRatio:Fe});if(Qe/Mt>1)ye=!0,de=!0,oe=1,Q=1,Ie=oe/Fe;else{let Pt=!1,Rt=oe+1;if(be==="fit"){const yt=Math.ceil((Qe+wt)*Q);Xe&&ze&&$e<=Ee.stableFitRemainingWidth?(Pt=!0,Rt=Ee.stableFitMaxMinimapScale):Pt=yt>ot}if(be==="fill"||Pt){ye=!0;const yt=oe;Q=Math.min(ut*Fe,Math.max(1,Math.floor(1/_t))),Xe&&ze&&$e<=Ee.stableFitRemainingWidth&&(Rt=Ee.stableFitMaxMinimapScale),oe=Math.min(Rt,Math.max(1,Math.floor(Q/st))),oe>yt&&(Oe=Math.min(2,oe/yt)),Ie=oe/Fe/Oe,ot=Math.ceil(Math.max(mt,Qe+wt)*Q),Xe?(Ee.stableMinimapLayoutInput=te,Ee.stableFitRemainingWidth=$e,Ee.stableFitMaxMinimapScale=oe):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const Ze=Math.floor(me*Ie),je=Math.min(Ze,Math.max(0,Math.floor(($e-Ne-2)*Ie/(Ae+Ie)))+e.MINIMAP_GUTTER_WIDTH);let ht=Math.floor(Fe*je);const Et=ht/Fe;ht=Math.floor(ht*Oe);const Dt=De?1:2,bt=_e==="left"?0:ie-je-Ne;return{renderMinimap:Dt,minimapLeft:bt,minimapWidth:je,minimapHeightIsEditorHeight:ye,minimapIsSampling:de,minimapScale:oe,minimapLineHeight:Q,minimapCanvasInnerWidth:ht,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:Et,minimapCanvasOuterHeight:fe}}static computeLayout(te,Ee){const ie=Ee.outerWidth|0,Ce=Ee.outerHeight|0,Fe=Ee.lineHeight|0,Ge=Ee.lineNumbersDigitCount|0,ze=Ee.typicalHalfwidthCharacterWidth,ut=Ee.maxDigitWidth,Ae=Ee.pixelRatio,Te=Ee.viewLineCount,De=te.get(122),oe=De==="inherit"?te.get(121):De,me=oe==="inherit"?te.get(117):oe,be=te.get(120),_e=te.get(2),Ne=Ee.isDominatedByLongLines,Qe=te.get(49),$e=te.get(59).renderType!==0,Xe=te.get(60),st=te.get(93),ot=te.get(64),fe=te.get(91),ye=fe.verticalScrollbarSize,de=fe.verticalHasArrows,Q=fe.arrowSize,Ie=fe.horizontalScrollbarSize,Oe=te.get(57),Ze=te.get(37);let je;if(typeof Oe=="string"&&/^\d+(\.\d+)?ch$/.test(Oe)){const St=parseFloat(Oe.substr(0,Oe.length-2));je=S.clampedInt(St*ze,0,0,1e3)}else je=S.clampedInt(Oe,0,0,1e3);Ze&&(je+=16);let ht=0;if($e){const St=Math.max(Ge,Xe);ht=Math.round(St*ut)}let Et=0;Qe&&(Et=Fe);let Dt=0,bt=Dt+Et,mt=bt+ht,wt=mt+je;const _t=ie-Et-ht-je;let Mt=!1,It=!1,Pt=-1;_e!==2&&(oe==="inherit"&&Ne?(Mt=!0,It=!0):me==="on"||me==="bounded"?It=!0:me==="wordWrapColumn"&&(Pt=be));const Rt=V._computeMinimapLayout({outerWidth:ie,outerHeight:Ce,lineHeight:Fe,typicalHalfwidthCharacterWidth:ze,pixelRatio:Ae,scrollBeyondLastLine:st,minimap:ot,verticalScrollbarWidth:ye,viewLineCount:Te,remainingWidth:_t,isViewportWrapping:It},Ee.memory||new P);Rt.renderMinimap!==0&&Rt.minimapLeft===0&&(Dt+=Rt.minimapWidth,bt+=Rt.minimapWidth,mt+=Rt.minimapWidth,wt+=Rt.minimapWidth);const yt=_t-Rt.minimapWidth,Ht=Math.max(1,Math.floor((yt-ye-2)/ze)),Ot=de?Q:0;return It&&(Pt=Math.max(1,Ht),me==="bounded"&&(Pt=Math.min(Pt,be))),{width:ie,height:Ce,glyphMarginLeft:Dt,glyphMarginWidth:Et,lineNumbersLeft:bt,lineNumbersWidth:ht,decorationsLeft:mt,decorationsWidth:je,contentLeft:wt,contentWidth:yt,minimap:Rt,viewportColumn:Ht,isWordWrapMinified:Mt,isViewportWrapping:It,wrappingColumn:Pt,verticalScrollbarWidth:ye,horizontalScrollbarHeight:Ie,overviewRuler:{top:Ot,width:ye,height:Ce-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=V;class U extends R{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:f.localize(43,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:p(te.enabled,this.defaultValue.enabled)}}}class H extends R{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:f.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:f.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,markdownDescription:f.localize(46,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{enabled:p(Ee.enabled,this.defaultValue.enabled),fontSize:S.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class Y extends o{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>o.clamp(te,0,150),{markdownDescription:f.localize(47,null)})}compute(te,Ee,ie){return te.fontInfo.lineHeight}}class se extends R{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:f.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(49,null),f.localize(50,null),f.localize(51,null)],default:te.size,description:f.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:f.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:f.localize(54,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:f.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:f.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{enabled:p(Ee.enabled,this.defaultValue.enabled),size:m(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(Ee.side,this.defaultValue.side,["right","left"]),showSlider:m(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:p(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(Ee.scale,1,1,3),maxColumn:S.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function K(ee){return ee==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends R{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(59,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{top:S.clampedInt(Ee.top,0,0,1e3),bottom:S.clampedInt(Ee.bottom,0,0,1e3)}}}class ne extends R{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:f.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:f.localize(61,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{enabled:p(Ee.enabled,this.defaultValue.enabled),cycle:p(Ee.cycle,this.defaultValue.cycle)}}}class le extends b{constructor(){super(128)}compute(te,Ee,ie){return te.pixelRatio}}class ge extends R{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:f.localize(62,null)},comments:{type:"boolean",default:te.comments,description:f.localize(63,null)},other:{type:"boolean",default:te.other,description:f.localize(64,null)}}}],default:te,description:f.localize(65,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const Ee=te,ie={other:p(Ee.other,this.defaultValue.other),comments:p(Ee.comments,this.defaultValue.comments),strings:p(Ee.strings,this.defaultValue.strings)};return ie.other&&ie.comments&&ie.strings?!0:!ie.other&&!ie.comments&&!ie.strings?!1:ie}return this.defaultValue}}var ke;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends R{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(66,null),f.localize(67,null),f.localize(68,null),f.localize(69,null)],default:"on",description:f.localize(70,null)})}validate(te){let Ee=this.defaultValue.renderType,ie=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(Ee=4,ie=te):te==="interval"?Ee=3:te==="relative"?Ee=2:te==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:ie}}}function Ue(ee){const te=ee.get(86);return te==="editable"?ee.get(80):te!=="on"}e.filterValidationDecorations=Ue;class q extends R{constructor(){const te=[],Ee={type:"number",description:f.localize(71,null)};super(90,"rulers",te,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:f.localize(72,null),format:"color-hex"}}}]},default:te,description:f.localize(73,null)})}validate(te){if(Array.isArray(te)){const Ee=[];for(let ie of te)if(typeof ie=="number")Ee.push({column:S.clampedInt(ie,0,0,1e4),color:null});else if(ie&&typeof ie=="object"){const Ce=ie;Ee.push({column:S.clampedInt(Ce.column,0,0,1e4),color:Ce.color})}return Ee.sort((ie,Ce)=>ie.column-Ce.column),Ee}return this.defaultValue}}function J(ee,te){if(typeof ee!="string")return te;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class re extends R{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(74,null),f.localize(75,null),f.localize(76,null)],default:"auto",description:f.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(78,null),f.localize(79,null),f.localize(80,null)],default:"auto",description:f.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:f.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:f.localize(84,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te,ie=S.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ce=S.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:J(Ee.vertical,this.defaultValue.vertical),horizontal:J(Ee.horizontal,this.defaultValue.horizontal),useShadows:p(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:p(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:p(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:p(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:p(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ie,horizontalSliderSize:S.clampedInt(Ee.horizontalSliderSize,ie,0,1e3),verticalScrollbarSize:Ce,verticalSliderSize:S.clampedInt(Ee.verticalSliderSize,Ce,0,1e3),scrollByPage:p(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class he extends R{constructor(){const te={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(112,"unicodeHighlight",te,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:te.nonBasicASCII,description:f.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:te.invisibleCharacters,description:f.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:te.ambiguousCharacters,description:f.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:te.includeComments,description:f.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:te.includeStrings,description:f.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:te.allowedCharacters,description:f.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:te.allowedLocales,description:f.localize(91,null)}})}applyUpdate(te,Ee){let ie=!1;Ee.allowedCharacters&&(T.equals(te.allowedCharacters,Ee.allowedCharacters)||(te={...te,allowedCharacters:Ee.allowedCharacters},ie=!0)),Ee.allowedLocales&&(T.equals(te.allowedLocales,Ee.allowedLocales)||(te={...te,allowedLocales:Ee.allowedLocales},ie=!0));const Ce=super.applyUpdate(te,Ee);return ie?new y(Ce.newValue,!0):Ce}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{nonBasicASCII:Be(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:p(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:p(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Be(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Be(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(te.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(te.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(te,Ee){if(typeof te!="object"||!te)return Ee;const ie={};for(const[Ce,Fe]of Object.entries(te))Fe===!0&&(ie[Ce]=!0);return ie}}class Z extends R{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:f.localize(92,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{enabled:p(Ee.enabled,this.defaultValue.enabled),mode:m(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ce extends R{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:f.localize(93,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:p(te.enabled,this.defaultValue.enabled)}}}class Se extends R{constructor(){const te={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",te,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(94,null),f.localize(95,null),f.localize(96,null)],default:te.bracketPairs,description:f.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(98,null),f.localize(99,null),f.localize(100,null)],default:te.bracketPairsHorizontal,description:f.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:te.highlightActiveBracketPair,description:f.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:te.indentation,description:f.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:te.highlightActiveIndentation,description:f.localize(104,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{bracketPairs:Be(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Be(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:p(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:p(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:p(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Be(ee,te,Ee){const ie=Ee.indexOf(ee);return ie===-1?te:Ee[ie]}class qe extends R{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(105,null),f.localize(106,null)],default:te.insertMode,description:f.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:f.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:f.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:f.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:f.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:f.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:f.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:f.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:f.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(146,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const Ee=te;return{insertMode:m(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:p(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:p(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:p(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:p(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:p(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:p(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:p(Ee.preview,this.defaultValue.preview),previewMode:m(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:p(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:p(Ee.showMethods,this.defaultValue.showMethods),showFunctions:p(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:p(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:p(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:p(Ee.showFields,this.defaultValue.showFields),showVariables:p(Ee.showVariables,this.defaultValue.showVariables),showClasses:p(Ee.showClasses,this.defaultValue.showClasses),showStructs:p(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:p(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:p(Ee.showModules,this.defaultValue.showModules),showProperties:p(Ee.showProperties,this.defaultValue.showProperties),showEvents:p(Ee.showEvents,this.defaultValue.showEvents),showOperators:p(Ee.showOperators,this.defaultValue.showOperators),showUnits:p(Ee.showUnits,this.defaultValue.showUnits),showValues:p(Ee.showValues,this.defaultValue.showValues),showConstants:p(Ee.showConstants,this.defaultValue.showConstants),showEnums:p(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:p(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:p(Ee.showKeywords,this.defaultValue.showKeywords),showWords:p(Ee.showWords,this.defaultValue.showWords),showColors:p(Ee.showColors,this.defaultValue.showColors),showFiles:p(Ee.showFiles,this.defaultValue.showFiles),showReferences:p(Ee.showReferences,this.defaultValue.showReferences),showFolders:p(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:p(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:p(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:p(Ee.showUsers,this.defaultValue.showUsers),showIssues:p(Ee.showIssues,this.defaultValue.showIssues)}}}class Ke extends R{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(147,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:p(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Je extends b{constructor(){super(129)}compute(te,Ee,ie){return Ee.get(80)?!0:te.tabFocusMode}}var it;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(it=e.WrappingIndent||(e.WrappingIndent={}));function at(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class et extends b{constructor(){super(131)}compute(te,Ee,ie){const Ce=Ee.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:Ce.isWordWrapMinified,isViewportWrapping:Ce.isViewportWrapping,wrappingColumn:Ce.wrappingColumn}}}const nt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",vt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?ct:i.isLinux?vt:nt,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function We(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var At;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=42]="fontFamily",ee[ee.fontInfo=43]="fontInfo",ee[ee.fontLigatures=44]="fontLigatures",ee[ee.fontSize=45]="fontSize",ee[ee.fontWeight=46]="fontWeight",ee[ee.formatOnPaste=47]="formatOnPaste",ee[ee.formatOnType=48]="formatOnType",ee[ee.glyphMargin=49]="glyphMargin",ee[ee.gotoLocation=50]="gotoLocation",ee[ee.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",ee[ee.hover=52]="hover",ee[ee.inDiffEditor=53]="inDiffEditor",ee[ee.inlineSuggest=54]="inlineSuggest",ee[ee.letterSpacing=55]="letterSpacing",ee[ee.lightbulb=56]="lightbulb",ee[ee.lineDecorationsWidth=57]="lineDecorationsWidth",ee[ee.lineHeight=58]="lineHeight",ee[ee.lineNumbers=59]="lineNumbers",ee[ee.lineNumbersMinChars=60]="lineNumbersMinChars",ee[ee.linkedEditing=61]="linkedEditing",ee[ee.links=62]="links",ee[ee.matchBrackets=63]="matchBrackets",ee[ee.minimap=64]="minimap",ee[ee.mouseStyle=65]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=67]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=69]="multiCursorModifier",ee[ee.multiCursorPaste=70]="multiCursorPaste",ee[ee.occurrencesHighlight=71]="occurrencesHighlight",ee[ee.overviewRulerBorder=72]="overviewRulerBorder",ee[ee.overviewRulerLanes=73]="overviewRulerLanes",ee[ee.padding=74]="padding",ee[ee.parameterHints=75]="parameterHints",ee[ee.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=78]="quickSuggestions",ee[ee.quickSuggestionsDelay=79]="quickSuggestionsDelay",ee[ee.readOnly=80]="readOnly",ee[ee.renameOnType=81]="renameOnType",ee[ee.renderControlCharacters=82]="renderControlCharacters",ee[ee.renderFinalNewline=83]="renderFinalNewline",ee[ee.renderLineHighlight=84]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=86]="renderValidationDecorations",ee[ee.renderWhitespace=87]="renderWhitespace",ee[ee.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",ee[ee.roundedSelection=89]="roundedSelection",ee[ee.rulers=90]="rulers",ee[ee.scrollbar=91]="scrollbar",ee[ee.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=93]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=94]="scrollPredominantAxis",ee[ee.selectionClipboard=95]="selectionClipboard",ee[ee.selectionHighlight=96]="selectionHighlight",ee[ee.selectOnLineNumbers=97]="selectOnLineNumbers",ee[ee.showFoldingControls=98]="showFoldingControls",ee[ee.showUnused=99]="showUnused",ee[ee.snippetSuggestions=100]="snippetSuggestions",ee[ee.smartSelect=101]="smartSelect",ee[ee.smoothScrolling=102]="smoothScrolling",ee[ee.stickyTabStops=103]="stickyTabStops",ee[ee.stopRenderingLineAfter=104]="stopRenderingLineAfter",ee[ee.suggest=105]="suggest",ee[ee.suggestFontSize=106]="suggestFontSize",ee[ee.suggestLineHeight=107]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",ee[ee.suggestSelection=109]="suggestSelection",ee[ee.tabCompletion=110]="tabCompletion",ee[ee.tabIndex=111]="tabIndex",ee[ee.unicodeHighlighting=112]="unicodeHighlighting",ee[ee.unusualLineTerminators=113]="unusualLineTerminators",ee[ee.useShadowDOM=114]="useShadowDOM",ee[ee.useTabStops=115]="useTabStops",ee[ee.wordSeparators=116]="wordSeparators",ee[ee.wordWrap=117]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=120]="wordWrapColumn",ee[ee.wordWrapOverride1=121]="wordWrapOverride1",ee[ee.wordWrapOverride2=122]="wordWrapOverride2",ee[ee.wrappingIndent=123]="wrappingIndent",ee[ee.wrappingStrategy=124]="wrappingStrategy",ee[ee.showDeprecated=125]="showDeprecated",ee[ee.inlayHints=126]="inlayHints",ee[ee.editorClassName=127]="editorClassName",ee[ee.pixelRatio=128]="pixelRatio",ee[ee.tabFocusMode=129]="tabFocusMode",ee[ee.layoutInfo=130]="layoutInfo",ee[ee.wrappingInfo=131]="wrappingInfo"})(At=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new w(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(148,null)})),acceptSuggestionOnEnter:We(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(149,null),""],markdownDescription:f.localize(150,null)})),accessibilitySupport:We(new t),accessibilityPageSize:We(new S(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(151,null)})),ariaLabel:We(new r(4,"ariaLabel",f.localize(152,null))),autoClosingBrackets:We(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(153,null),f.localize(154,null),""],description:f.localize(155,null)})),autoClosingDelete:We(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(156,null),""],description:f.localize(157,null)})),autoClosingOvertype:We(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(158,null),""],description:f.localize(159,null)})),autoClosingQuotes:We(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(160,null),f.localize(161,null),""],description:f.localize(162,null)})),autoIndent:We(new E(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[f.localize(163,null),f.localize(164,null),f.localize(165,null),f.localize(166,null),f.localize(167,null)],description:f.localize(168,null)})),automaticLayout:We(new w(10,"automaticLayout",!1)),autoSurround:We(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(169,null),f.localize(170,null),f.localize(171,null),""],description:f.localize(172,null)})),bracketPairColorization:We(new ce),bracketPairGuides:We(new Se),stickyTabStops:We(new w(103,"stickyTabStops",!1,{description:f.localize(173,null)})),codeLens:We(new w(14,"codeLens",!0,{description:f.localize(174,null)})),codeLensFontFamily:We(new r(15,"codeLensFontFamily","",{description:f.localize(175,null)})),codeLensFontSize:We(new S(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(176,null)})),colorDecorators:We(new w(17,"colorDecorators",!0,{description:f.localize(177,null)})),columnSelection:We(new w(18,"columnSelection",!1,{description:f.localize(178,null)})),comments:We(new s),contextmenu:We(new w(20,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new w(21,"copyWithSyntaxHighlighting",!0,{description:f.localize(179,null)})),cursorBlinking:We(new E(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:f.localize(180,null)})),cursorSmoothCaretAnimation:We(new w(23,"cursorSmoothCaretAnimation",!1,{description:f.localize(181,null)})),cursorStyle:We(new E(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:f.localize(182,null)})),cursorSurroundingLines:We(new S(25,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(183,null)})),cursorSurroundingLinesStyle:We(new a(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(184,null),f.localize(185,null)],description:f.localize(186,null)})),cursorWidth:We(new S(27,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(187,null)})),disableLayerHinting:We(new w(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new w(29,"disableMonospaceOptimizations",!1)),domReadOnly:We(new w(30,"domReadOnly",!1)),dragAndDrop:We(new w(31,"dragAndDrop",!0,{description:f.localize(188,null)})),emptySelectionClipboard:We(new A),extraEditorClassName:We(new r(33,"extraEditorClassName","")),fastScrollSensitivity:We(new o(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:f.localize(189,null)})),find:We(new N),fixedOverflowWidgets:We(new w(36,"fixedOverflowWidgets",!1)),folding:We(new w(37,"folding",!0,{description:f.localize(190,null)})),foldingStrategy:We(new a(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(191,null),f.localize(192,null)],description:f.localize(193,null)})),foldingHighlight:We(new w(39,"foldingHighlight",!0,{description:f.localize(194,null)})),foldingImportsByDefault:We(new w(40,"foldingImportsByDefault",!1,{description:f.localize(195,null)})),unfoldOnClickAfterEndOfLine:We(new w(41,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(196,null)})),fontFamily:We(new r(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(197,null)})),fontInfo:We(new F),fontLigatures2:We(new B),fontSize:We(new O),fontWeight:We(new z),formatOnPaste:We(new w(47,"formatOnPaste",!1,{description:f.localize(198,null)})),formatOnType:We(new w(48,"formatOnType",!1,{description:f.localize(199,null)})),glyphMargin:We(new w(49,"glyphMargin",!0,{description:f.localize(200,null)})),gotoLocation:We(new W),hideCursorInOverviewRuler:We(new w(51,"hideCursorInOverviewRuler",!1,{description:f.localize(201,null)})),hover:We(new M),inDiffEditor:We(new w(53,"inDiffEditor",!1)),letterSpacing:We(new o(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>o.clamp(ee,-5,20),{description:f.localize(202,null)})),lightbulb:We(new U),lineDecorationsWidth:We(new v(57,"lineDecorationsWidth",10)),lineHeight:We(new Y),lineNumbers:We(new Me),lineNumbersMinChars:We(new S(60,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new w(61,"linkedEditing",!1,{description:f.localize(203,null)})),links:We(new w(62,"links",!0,{description:f.localize(204,null)})),matchBrackets:We(new a(63,"matchBrackets","always",["always","near","never"],{description:f.localize(205,null)})),minimap:We(new se),mouseStyle:We(new a(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new o(66,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:f.localize(206,null)})),mouseWheelZoom:We(new w(67,"mouseWheelZoom",!1,{markdownDescription:f.localize(207,null)})),multiCursorMergeOverlapping:We(new w(68,"multiCursorMergeOverlapping",!0,{description:f.localize(208,null)})),multiCursorModifier:We(new E(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],K,{markdownEnumDescriptions:[f.localize(209,null),f.localize(210,null)],markdownDescription:f.localize(211,null)})),multiCursorPaste:We(new a(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(212,null),f.localize(213,null)],markdownDescription:f.localize(214,null)})),occurrencesHighlight:We(new w(71,"occurrencesHighlight",!0,{description:f.localize(215,null)})),overviewRulerBorder:We(new w(72,"overviewRulerBorder",!0,{description:f.localize(216,null)})),overviewRulerLanes:We(new S(73,"overviewRulerLanes",3,0,3)),padding:We(new j),parameterHints:We(new ne),peekWidgetDefaultFocus:We(new a(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(217,null),f.localize(218,null)],description:f.localize(219,null)})),definitionLinkOpensInPeek:We(new w(77,"definitionLinkOpensInPeek",!1,{description:f.localize(220,null)})),quickSuggestions:We(new ge),quickSuggestionsDelay:We(new S(79,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(221,null)})),readOnly:We(new w(80,"readOnly",!1)),renameOnType:We(new w(81,"renameOnType",!1,{description:f.localize(222,null),markdownDeprecationMessage:f.localize(223,null)})),renderControlCharacters:We(new w(82,"renderControlCharacters",!0,{description:f.localize(224,null),restricted:!0})),renderFinalNewline:We(new w(83,"renderFinalNewline",!0,{description:f.localize(225,null)})),renderLineHighlight:We(new a(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(226,null)],description:f.localize(227,null)})),renderLineHighlightOnlyWhenFocus:We(new w(85,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(228,null)})),renderValidationDecorations:We(new a(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new a(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(229,null),f.localize(230,null),f.localize(231,null),""],description:f.localize(232,null)})),revealHorizontalRightPadding:We(new S(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:We(new w(89,"roundedSelection",!0,{description:f.localize(233,null)})),rulers:We(new q),scrollbar:We(new re),scrollBeyondLastColumn:We(new S(92,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(234,null)})),scrollBeyondLastLine:We(new w(93,"scrollBeyondLastLine",!0,{description:f.localize(235,null)})),scrollPredominantAxis:We(new w(94,"scrollPredominantAxis",!0,{description:f.localize(236,null)})),selectionClipboard:We(new w(95,"selectionClipboard",!0,{description:f.localize(237,null),included:i.isLinux})),selectionHighlight:We(new w(96,"selectionHighlight",!0,{description:f.localize(238,null)})),selectOnLineNumbers:We(new w(97,"selectOnLineNumbers",!0)),showFoldingControls:We(new a(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(239,null),f.localize(240,null)],description:f.localize(241,null)})),showUnused:We(new w(99,"showUnused",!0,{description:f.localize(242,null)})),showDeprecated:We(new w(125,"showDeprecated",!0,{description:f.localize(243,null)})),inlayHints:We(new H),snippetSuggestions:We(new a(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(244,null),f.localize(245,null),f.localize(246,null),f.localize(247,null)],description:f.localize(248,null)})),smartSelect:We(new Ke),smoothScrolling:We(new w(102,"smoothScrolling",!1,{description:f.localize(249,null)})),stopRenderingLineAfter:We(new S(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:We(new qe),inlineSuggest:We(new Z),suggestFontSize:We(new S(106,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(250,null)})),suggestLineHeight:We(new S(107,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(251,null)})),suggestOnTriggerCharacters:We(new w(108,"suggestOnTriggerCharacters",!0,{description:f.localize(252,null)})),suggestSelection:We(new a(109,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(253,null),f.localize(254,null),f.localize(255,null)],description:f.localize(256,null)})),tabCompletion:We(new a(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(257,null),f.localize(258,null),f.localize(259,null)],description:f.localize(260,null)})),tabIndex:We(new S(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:We(new he),unusualLineTerminators:We(new a(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(261,null),f.localize(262,null),f.localize(263,null)],description:f.localize(264,null)})),useShadowDOM:We(new w(114,"useShadowDOM",!0)),useTabStops:We(new w(115,"useTabStops",!0,{description:f.localize(265,null)})),wordSeparators:We(new r(116,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:f.localize(266,null)})),wordWrap:We(new a(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(267,null),f.localize(268,null),f.localize(269,null),f.localize(270,null)],description:f.localize(271,null)})),wordWrapBreakAfterCharacters:We(new r(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new r(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new S(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(272,null)})),wordWrapOverride1:We(new a(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new a(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:We(new E(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],at,{enumDescriptions:[f.localize(273,null),f.localize(274,null),f.localize(275,null),f.localize(276,null)],description:f.localize(277,null)})),wrappingStrategy:We(new a(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(278,null),f.localize(279,null)],description:f.localize(280,null)})),editorClassName:We(new D),pixelRatio:We(new le),tabFocusMode:We(new Je),layoutInfo:We(new V),wrappingInfo:We(new et)}}),define(ve[156],we([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[157],we([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[158],we([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[159],we([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[160],we([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ve[161],we([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(ve[162],we([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[163],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[164],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[165],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[166],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[167],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[168],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[169],we([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[170],we([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[171],we([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[172],we([19,20]),function(X,e){return X.create("vs/workbench/common/editor",e)}),define(ve[173],we([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[174],we([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[175],we([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[176],we([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[177],we([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[178],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var f;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var i;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var k;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var _;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(_=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[179],we([0,1,158]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function _(c){return c=c.trim(),c==="*"||i.test(c)}e.isValidVersionStr=_;function T(c){if(!_(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=c.match(i);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=T;function I(c){if(!c)return null;let b=c.majorBase,v=c.majorMustEqual,p=c.minorBase,w=c.minorMustEqual,L=c.patchBase,S=c.patchMustEqual;c.hasCaret&&(b===0||(w=!1),S=!1);let o=0;if(c.preRelease){const r=k.exec(c.preRelease);if(r){const[,m,a,E]=r;o=Date.UTC(Number(m),Number(a)-1,Number(E))}}return{majorBase:b,majorMustEqual:v,minorBase:p,minorMustEqual:w,patchBase:L,patchMustEqual:S,isMinimum:c.hasGreaterEquals,notBefore:o}}e.normalizeVersion=I;function C(c,b,v){let p;typeof c=="string"?p=I(T(c)):p=c;let w;b instanceof Date?w=b.getTime():typeof b=="string"&&(w=new Date(b).getTime());let L;if(typeof v=="string"?L=I(T(v)):L=v,!p||!L)return!1;let S=p.majorBase,o=p.minorBase,r=p.patchBase,m=L.majorBase,a=L.minorBase,E=L.patchBase,n=L.notBefore,t=L.majorMustEqual,s=L.minorMustEqual,u=L.patchMustEqual;return L.isMinimum?S>m?!0:S<m?!1:o>a?!0:o<a||w&&w<n?!1:r>=E:(S===1&&m===0&&(!t||!s||!u)&&(m=1,a=0,E=0,t=!0,s=!1,u=!1),S<m?!1:S>m?!t:o<a?!1:o>a?!s:r<E?!1:r>E?!u:!(w&&w<n))}e.isValidVersion=C;function P(c,b,v,p){return v.isBuiltin||typeof v.main=="undefined"?!0:y(c,b,v.engines.vscode,p)}e.isValidExtensionVersion=P;function R(c,b,v){return c==="*"||y(b,v,c)}e.isEngineValid=R;function y(c,b,v,p=[]){let w=I(T(v));if(!w)return p.push(f.localize(0,null,v)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return p.push(f.localize(1,null,v)),!1}else if(!w.majorMustEqual)return p.push(f.localize(2,null,v)),!1;return C(c,b,w)?!0:(p.push(f.localize(3,null,c,v)),!1)}}),define(ve[115],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(k,_=[],T=!1){this.ctor=k,this.staticArguments=_,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=f}),define(ve[61],we([0,1,115]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function k(T,I,C){I instanceof f.SyncDescriptor||(I=new f.SyncDescriptor(I,[],C)),i.push([T,I])}e.registerSingleton=k;function _(){return i}e.getSingletonServiceDescriptors=_}),define(ve[180],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=f;class i{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let T of this._nodes.values())T.outgoing.size===0&&_.push(T);return _}insertEdge(_,T){const I=this.lookupOrInsertNode(_),C=this.lookupOrInsertNode(T);I.outgoing.set(this._hashFn(T),C),C.incoming.set(this._hashFn(_),I)}removeNode(_){const T=this._hashFn(_);this._nodes.delete(T);for(let I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(_){const T=this._hashFn(_);let I=this._nodes.get(T);return I||(I=new f(_),this._nodes.set(T,I)),I}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[T,I]of this._nodes)_.push(`${T}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,T]of this._nodes){const I=new Set([_]),C=this._findCycle(T,I);if(C)return C}}_findCycle(_,T){for(let[I,C]of _.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const P=this._findCycle(C,T);if(P)return P;T.delete(I)}}}e.Graph=i}),define(ve[4],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(C){return C[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(f=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function i(T,I,C,P){I[f.DI_TARGET]===I?I[f.DI_DEPENDENCIES].push({id:T,index:C,optional:P}):(I[f.DI_DEPENDENCIES]=[{id:T,index:C,optional:P}],I[f.DI_TARGET]=I)}function k(T){if(f.serviceIds.has(T))return f.serviceIds.get(T);const I=function(C,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(I,C,R,!1)};return I.toString=()=>T,f.serviceIds.set(T,I),I}e.createDecorator=k;function _(T){return T}e.refineServiceDecorator=_}),define(ve[181],we([0,1,4]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,f.createDecorator)("modelService");function i(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=i}),define(ve[182],we([0,1,3,47,6,24,79,83,181]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(P):!!p.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new f.Emitter}get onDidChange(){return this._onDidChange.event}register(w,L){let S={selector:w,provider:L,_score:-1,_time:this._clock++};return this._entries.push(S),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(S){const o=this._entries.indexOf(S);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S=void 0)}})}has(w){return this.all(w).length>0}all(w){if(!w)return[];this._updateScores(w);const L=[];for(let S of this._entries)S._score>0&&L.push(S.provider);return L}ordered(w){const L=[];return this._orderedForEach(w,S=>L.push(S.provider)),L}orderedGroups(w){const L=[];let S,o;return this._orderedForEach(w,r=>{S&&o===r._score?S.push(r.provider):(o=r._score,S=[r.provider],L.push(S))}),L}_orderedForEach(w,L){if(!!w){this._updateScores(w);for(const S of this._entries)S._score>0&&L(S)}}_updateScores(w){const L={uri:w.uri.toString(),language:w.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===L.language&&this._lastCandidate.uri===L.uri)){this._lastCandidate=L;for(let S of this._entries)if(S._score=(0,I.score)(S.selector,w.uri,w.getLanguageId(),(0,C.shouldSynchronizeModel)(w)),P(S.selector)&&S._score>0){for(let o of this._entries)o._score=0;S._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(w,L){return w._score<L._score?1:w._score>L._score?-1:w._time<L._time?1:w._time>L._time?-1:0}}e.LanguageFeatureRegistry=R;const y=new WeakMap;let c=0;function b(p){let w=y.get(p);return w===void 0&&(w=++c,y.set(p,w)),w}class v{constructor(w,L,S=Number.MAX_SAFE_INTEGER){this._registry=w,this.min=L,this.max=S,this._cache=new _.LRUCache(50,.7)}_key(w){return w.id+this._registry.all(w).reduce((L,S)=>(0,i.doHash)(b(S),L),0)}_clamp(w){return w===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(w*1.3)))}get(w){const L=this._key(w),S=this._cache.get(L);return this._clamp(S?.value)}update(w,L){const S=this._key(w);let o=this._cache.get(S);return o||(o=new T.MovingAverage,this._cache.set(S,o)),o.update(L),this.get(w)}}e.LanguageFeatureRequestDelays=v}),define(ve[84],we([0,1,2,41,182,148,74]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));var C;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline",l[l.Strikethrough=8]="Strikethrough"})(C=e.FontStyle||(e.FontStyle={}));var P;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var R;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var y;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=1024]="ITALIC_MASK",l[l.BOLD_MASK=2048]="BOLD_MASK",l[l.UNDERLINE_MASK=4096]="UNDERLINE_MASK",l[l.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",l[l.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(y=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&768)>>>8}static getFontStyle(D){return(D&15360)>>>10}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){const A=this.getForeground(D);let N="mtk"+A;const B=this.getFontStyle(D);return B&1&&(N+=" mtki"),B&2&&(N+=" mtkb"),B&4&&(N+=" mtku"),B&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(D,A){const N=this.getForeground(D),B=this.getFontStyle(D);let F=`color: ${A[N]};`;B&1&&(F+="font-style: italic;"),B&2&&(F+="font-weight: bold;");let O="";return B&4&&(O+=" underline"),B&8&&(O+=" line-through"),O&&(F+=`text-decoration:${O};`),F}}e.TokenMetadata=c;var b;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var v;(function(l){const D=new Map;D.set(0,T.Codicon.symbolMethod),D.set(1,T.Codicon.symbolFunction),D.set(2,T.Codicon.symbolConstructor),D.set(3,T.Codicon.symbolField),D.set(4,T.Codicon.symbolVariable),D.set(5,T.Codicon.symbolClass),D.set(6,T.Codicon.symbolStruct),D.set(7,T.Codicon.symbolInterface),D.set(8,T.Codicon.symbolModule),D.set(9,T.Codicon.symbolProperty),D.set(10,T.Codicon.symbolEvent),D.set(11,T.Codicon.symbolOperator),D.set(12,T.Codicon.symbolUnit),D.set(13,T.Codicon.symbolValue),D.set(15,T.Codicon.symbolEnum),D.set(14,T.Codicon.symbolConstant),D.set(15,T.Codicon.symbolEnum),D.set(16,T.Codicon.symbolEnumMember),D.set(17,T.Codicon.symbolKeyword),D.set(27,T.Codicon.symbolSnippet),D.set(18,T.Codicon.symbolText),D.set(19,T.Codicon.symbolColor),D.set(20,T.Codicon.symbolFile),D.set(21,T.Codicon.symbolReference),D.set(22,T.Codicon.symbolCustomColor),D.set(23,T.Codicon.symbolFolder),D.set(24,T.Codicon.symbolTypeParameter),D.set(25,T.Codicon.account),D.set(26,T.Codicon.issues);function A(F){let O=D.get(F);return O||(console.info("No codicon found for CompletionItemKind "+F),O=T.Codicon.symbolProperty),O}l.toIcon=A;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function B(F,O){let z=N.get(F);return typeof z=="undefined"&&!O&&(z=9),z}l.fromString=B})(v=e.CompletionItemKinds||(e.CompletionItemKinds={}));var p;(function(l){l[l.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var L;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var r;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(r=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(l){return l&&f.URI.isUri(l.uri)&&i.Range.isIRange(l.range)&&(i.Range.isIRange(l.originSelectionRange)||i.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=a;var E;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(E=e.SymbolKind||(e.SymbolKind={}));var n;(function(l){l[l.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var t;(function(l){const D=new Map;D.set(0,T.Codicon.symbolFile),D.set(1,T.Codicon.symbolModule),D.set(2,T.Codicon.symbolNamespace),D.set(3,T.Codicon.symbolPackage),D.set(4,T.Codicon.symbolClass),D.set(5,T.Codicon.symbolMethod),D.set(6,T.Codicon.symbolProperty),D.set(7,T.Codicon.symbolField),D.set(8,T.Codicon.symbolConstructor),D.set(9,T.Codicon.symbolEnum),D.set(10,T.Codicon.symbolInterface),D.set(11,T.Codicon.symbolFunction),D.set(12,T.Codicon.symbolVariable),D.set(13,T.Codicon.symbolConstant),D.set(14,T.Codicon.symbolString),D.set(15,T.Codicon.symbolNumber),D.set(16,T.Codicon.symbolBoolean),D.set(17,T.Codicon.symbolArray),D.set(18,T.Codicon.symbolObject),D.set(19,T.Codicon.symbolKey),D.set(20,T.Codicon.symbolNull),D.set(21,T.Codicon.symbolEnumMember),D.set(22,T.Codicon.symbolStruct),D.set(23,T.Codicon.symbolEvent),D.set(24,T.Codicon.symbolOperator),D.set(25,T.Codicon.symbolTypeParameter);function A(N){let B=D.get(N);return B||(console.info("No codicon found for SymbolKind "+N),B=T.Codicon.symbolProperty),B}l.toIcon=A})(t=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(D){this.value=D}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var u;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var h;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(h=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new _.TokenizationRegistry;var g;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(g=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[116],we([0,1,13,2,4]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function _(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof i.URI)}e.isConfigurationOverrides=_;function T(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||f.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=T;var I;(function(w){w[w.USER=1]="USER",w[w.USER_LOCAL=2]="USER_LOCAL",w[w.USER_REMOTE=3]="USER_REMOTE",w[w.WORKSPACE=4]="WORKSPACE",w[w.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",w[w.DEFAULT=6]="DEFAULT",w[w.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(w){switch(w){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function P(w,L){const S=Object.create(null);for(let o in w)R(S,o,w[o],L);return S}e.toValuesTree=P;function R(w,L,S,o){const r=L.split("."),m=r.pop();let a=w;for(let E=0;E<r.length;E++){let n=r[E],t=a[n];switch(typeof t){case"undefined":t=a[n]=Object.create(null);break;case"object":break;default:o(`Ignoring ${L} as ${r.slice(0,E+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[m]=S}catch{o(`Ignoring ${L} as ${r.join(".")} is ${JSON.stringify(a)}`)}else o(`Ignoring ${L} as ${r.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=R;function y(w,L){const S=L.split(".");c(w,S)}e.removeFromValueTree=y;function c(w,L){const S=L.shift();if(L.length===0){delete w[S];return}if(Object.keys(w).indexOf(S)!==-1){const o=w[S];typeof o=="object"&&!Array.isArray(o)&&(c(o,L),Object.keys(o).length===0&&delete w[S])}}function b(w,L,S){function o(a,E){let n=a;for(const t of E){if(typeof n!="object"||n===null)return;n=n[t]}return n}const r=L.split("."),m=o(w,r);return typeof m=="undefined"?S:m}e.getConfigurationValue=b;function v(w,L,S){Object.keys(L).forEach(o=>{o!=="__proto__"&&(o in w?f.isObject(w[o])&&f.isObject(L[o])?v(w[o],L[o],S):S&&(w[o]=L[o]):w[o]=L[o])})}e.merge=v;function p(w,L,S){const o=w.inspect(L),r=w.inspect(S);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:o.defaultValue}e.getMigratedSettingValue=p}),define(ve[62],we([0,1,12,9,4]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=f.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",f.isMacintosh),T.set("isLinux",f.isLinux),T.set("isWindows",f.isWindows),T.set("isWeb",f.isWeb),T.set("isMacNative",f.isMacintosh&&!f.isWeb),T.set("isEdge",_.indexOf("Edg/")>=0),T.set("isFirefox",_.indexOf("Firefox")>=0),T.set("isChrome",_.indexOf("Chrome")>=0),T.set("isSafari",_.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var C;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return c.INSTANCE}static true(){return b.INSTANCE}static has(F){return v.create(F)}static equals(F,O){return p.create(F,O)}static notEquals(F,O){return S.create(F,O)}static regex(F,O){return t.create(F,O)}static in(F,O){return w.create(F,O)}static not(F){return o.create(F)}static and(...F){return d.create(F,null)}static or(...F){return h.create(F,null,!0)}static greater(F,O){return m.create(F,O)}static greaterEquals(F,O){return a.create(F,O)}static smaller(F,O){return E.create(F,O)}static smallerEquals(F,O){return n.create(F,O)}static deserialize(F,O=!1){if(!!F)return this._deserializeOrExpression(F,O)}static _deserializeOrExpression(F,O){let z=F.split("||");return h.create(z.map(W=>this._deserializeAndExpression(W,O)),null,!0)}static _deserializeAndExpression(F,O){let z=F.split("&&");return d.create(z.map(W=>this._deserializeOne(W,O)),null)}static _deserializeOne(F,O){if(F=F.trim(),F.indexOf("!=")>=0){let z=F.split("!=");return S.create(z[0].trim(),this._deserializeValue(z[1],O))}if(F.indexOf("==")>=0){let z=F.split("==");return p.create(z[0].trim(),this._deserializeValue(z[1],O))}if(F.indexOf("=~")>=0){let z=F.split("=~");return t.create(z[0].trim(),this._deserializeRegexValue(z[1],O))}if(F.indexOf(" in ")>=0){let z=F.split(" in ");return w.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const z=F.split(">=");return a.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const z=F.split(">");return m.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const z=F.split("<=");return n.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const z=F.split("<");return E.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(F)?o.create(F.substr(1).trim()):v.create(F)}static _deserializeValue(F,O){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let z=/^'([^']*)'$/.exec(F);return z?z[1].trim():F}static _deserializeRegexValue(F,O){if((0,i.isFalsyOrWhitespace)(F)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=F.indexOf("/"),W=F.lastIndexOf("/");if(z===W||z<0){if(O)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let M=F.slice(z+1,W),x=F[W+1]==="i"?"i":"";try{return new RegExp(M,x)}catch(V){if(O)throw new Error(`bad regexp-value '${F}', parse error: ${V}`);return console.warn(`bad regexp-value '${F}', parse error: ${V}`),null}}}e.ContextKeyExpr=P;function R(B,F){const O=B?B.substituteConstants():void 0,z=F?F.substituteConstants():void 0;return!O&&!z?!0:!O||!z?!1:O.equals(z)}e.expressionsAreEqualWithConstantSubstitution=R;function y(B,F){return B.cmp(F)}class c{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=c,c.INSTANCE=new c;class b{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class v{constructor(F,O){this.key=F,this.negated=O,this.type=2}static create(F,O=null){const z=T.get(F);return typeof z=="boolean"?z?b.INSTANCE:c.INSTANCE:new v(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:l(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?b.INSTANCE:c.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class p{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=4}static create(F,O,z=null){if(typeof O=="boolean")return O?v.create(F,z):o.create(F,z);const W=T.get(F);return typeof W=="boolean"?O===(W?"true":"false")?b.INSTANCE:c.INSTANCE:new p(F,O,z)}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const O=F?"true":"false";return this.value===O?b.INSTANCE:c.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class w{constructor(F,O){this.key=F,this.valueKey=O,this.type=10,this.negated=null}static create(F,O){return new w(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const O=F.getValue(this.valueKey),z=F.getValue(this.key);return Array.isArray(O)?O.indexOf(z)>=0:typeof z=="string"&&typeof O=="object"&&O!==null?I.call(O,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=L.create(this)),this.negated}}e.ContextKeyInExpr=w;class L{constructor(F){this._actual=F,this.type=11}static create(F){return new L(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new L(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=L;class S{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=5}static create(F,O,z=null){if(typeof O=="boolean")return O?o.create(F,z):v.create(F,z);const W=T.get(F);return typeof W=="boolean"?O===(W?"true":"false")?c.INSTANCE:b.INSTANCE:new S(F,O,z)}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const O=F?"true":"false";return this.value===O?c.INSTANCE:b.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class o{constructor(F,O){this.key=F,this.negated=O,this.type=3}static create(F,O=null){const z=T.get(F);return typeof z=="boolean"?z?c.INSTANCE:b.INSTANCE:new o(F,O)}cmp(F){return F.type!==this.type?this.type-F.type:l(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?c.INSTANCE:b.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function r(B,F){if(typeof B=="string"){const O=parseFloat(B);isNaN(O)||(B=O)}return typeof B=="string"||typeof B=="number"?F(B):c.INSTANCE}class m{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=12}static create(F,O,z=null){return r(O,W=>new m(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=m;class a{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=13}static create(F,O,z=null){return r(O,W=>new a(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class E{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=14}static create(F,O,z=null){return r(O,W=>new E(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=E;class n{constructor(F,O,z){this.key=F,this.value=O,this.negated=z,this.type=15}static create(F,O,z=null){return r(O,W=>new n(F,W,z))}cmp(F){return F.type!==this.type?this.type-F.type:D(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(F,O){this.key=F,this.regexp=O,this.type=7,this.negated=null}static create(F,O){return new t(F,O)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const O=this.regexp?this.regexp.source:"",z=F.regexp?F.regexp.source:"";return O<z?-1:O>z?1:0}equals(F){if(F.type===this.type){const O=this.regexp?this.regexp.source:"",z=F.regexp?F.regexp.source:"";return this.key===F.key&&O===z}return!1}substituteConstants(){return this}evaluate(F){let O=F.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(F){this._actual=F,this.type=8}static create(F){return new s(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new s(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function u(B){let F=null;for(let O=0,z=B.length;O<z;O++){const W=B[O].substituteConstants();if(B[O]!==W&&F===null){F=[];for(let M=0;M<O;M++)F[M]=B[M]}F!==null&&(F[O]=W)}return F===null?B:F}class d{constructor(F,O){this.expr=F,this.negated=O,this.type=6}static create(F,O){return d._normalizeArr(F,O)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const W=y(this.expr[O],F.expr[O]);if(W!==0)return W}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(F.expr[O]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:d.create(F,this.negated)}evaluate(F){for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].evaluate(F))return!1;return!0}static _normalizeArr(F,O){const z=[];let W=!1;for(const M of F)if(!!M){if(M.type===1){W=!0;continue}if(M.type===0)return c.INSTANCE;if(M.type===6){z.push(...M.expr);continue}z.push(M)}if(z.length===0&&W)return b.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(y);for(let M=1;M<z.length;M++)z[M-1].equals(z[M])&&(z.splice(M,1),M--);if(z.length===1)return z[0];for(;z.length>1;){const M=z[z.length-1];if(M.type!==9)break;z.pop();const x=z.pop(),V=z.length===0,U=h.create(M.expr.map(H=>d.create([H,x],null)),null,V);U&&(z.push(U),z.sort(y))}return z.length===1?z[0]:new d(z,O)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let O of this.expr)F.push(...O.keys());return F}map(F){return new d(this.expr.map(O=>O.map(F)),null)}negate(){if(!this.negated){const F=[];for(let O of this.expr)F.push(O.negate());this.negated=h.create(F,this,!0)}return this.negated}}class h{constructor(F,O){this.expr=F,this.negated=O,this.type=9}static create(F,O,z){return h._normalizeArr(F,O,z)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const W=y(this.expr[O],F.expr[O]);if(W!==0)return W}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(F.expr[O]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:h.create(F,this.negated,!1)}evaluate(F){for(let O=0,z=this.expr.length;O<z;O++)if(this.expr[O].evaluate(F))return!0;return!1}static _normalizeArr(F,O,z){let W=[],M=!1;if(F){for(let x=0,V=F.length;x<V;x++){const U=F[x];if(!!U){if(U.type===0){M=!0;continue}if(U.type===1)return b.INSTANCE;if(U.type===9){W=W.concat(U.expr);continue}W.push(U)}}if(W.length===0&&M)return c.INSTANCE;W.sort(y)}if(W.length!==0){if(W.length===1)return W[0];for(let x=1;x<W.length;x++)W[x-1].equals(W[x])&&(W.splice(x,1),x--);if(W.length===1)return W[0];if(z){for(let x=0;x<W.length;x++)for(let V=x+1;V<W.length;V++)A(W[x],W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0]}return new h(W,O)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let O of this.expr)F.push(...O.keys());return F}map(F){return new h(this.expr.map(O=>O.map(F)),null)}negate(){if(!this.negated){let F=[];for(let O of this.expr)F.push(O.negate());for(;F.length>1;){const O=F.shift(),z=F.shift(),W=[];for(const x of N(O))for(const V of N(z))W.push(d.create([x,V],null));const M=F.length===0;F.unshift(h.create(W,null,M))}this.negated=F[0]}return this.negated}}class g extends v{constructor(F,O,z){super(F,null);this._defaultValue=O,typeof z=="object"?g._info.push({...z,key:F}):z!==!0&&g._info.push({key:F,description:z,type:O!=null?typeof O:void 0})}static all(){return g._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return p.create(this.key,F)}notEqualsTo(F){return S.create(this.key,F)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(B,F){return B<F?-1:B>F?1:0}function D(B,F,O,z){return B<O?-1:B>O?1:F<z?-1:F>z?1:0}function A(B,F){if(F.type===6&&B.type!==9&&B.type!==6){for(const W of F.expr)if(B.equals(W))return!0}const O=B.negate(),z=N(O).concat(N(F));z.sort(y);for(let W=0;W<z.length;W++){const x=z[W].negate();for(let V=W+1;V<z.length;V++){const U=z[V];if(x.equals(U))return!0}}return!1}e.implies=A;function N(B){return B.type===9?B.expr:[B]}}),define(ve[183],we([0,1,4]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[184],we([0,1,10,157,4]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var _;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));function T(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function I(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function C(o,r){switch(o){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function P(o,r){return r==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function R(o,r,m){return P(r,m)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===m?!0:y(m).includes(o)}e.isTargetPlatformCompatible=R;function y(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function c(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=c;var b;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var v;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var p;(function(o){o.Install="install",o.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var w;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var L;(function(o){o.Unsupported="Unsupported",o.UnsupportedPreRelease="UnsupportedPreRelease",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(L=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class S extends Error{constructor(r,m){super(r);this.code=m,this.name=m}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=f.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(ve[185],we([0,1,4]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(ve[186],we([0,1,37,10,8,12,96,29,113,159,185]),function(X,e,f,i,k,_,T,I,C,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=P.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends c{openTerminal(r,m){return this.spawnTerminal(f,r,C.getWindowsShell(),m)}spawnTerminal(r,m,a,E){const n=m.windowsExec||b.getDefaultTerminalWindows();E&&E[1]===":"&&(E=E[0].toUpperCase()+E.substr(1));const t=k.basename(n).toLowerCase();if(t==="cmder"||t==="cmder.exe")return r.spawn(n,E?[E]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return n.indexOf(" ")>=0&&s.push('""'),s.push(n),(t==="wt"||t==="wt.exe")&&s.push("-d ."),new Promise((u,d)=>{const h=w(process),g=r.spawn(a,s,{cwd:E,env:h});g.on("error",d),g.on("exit",()=>u())})}runInTerminal(r,m,a,E,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:b.getDefaultTerminalWindows();return new Promise((s,u)=>{const d=`"${m} - ${y}"`,h=`""${a.join('" "')}" & pause"`,g=["/c","start",d,"/wait",t,"/c",h],l=Object.assign({},w(process),E);Object.keys(l).filter(N=>l[N]===null).forEach(N=>delete l[N]);const D={cwd:m,env:l,windowsVerbatimArguments:!0};f.spawn(b.CMD,g,D).on("error",N=>{u(L(N))}),s(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class v extends c{openTerminal(r,m){return this.spawnTerminal(f,r,m)}runInTerminal(r,m,a,E,n){const t=n.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((s,u)=>{if(t===R.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const d=t===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",g=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,X).fsPath,"-t",r||y,"-w",m];for(let A of a)g.push("-a"),g.push(A);if(E){const A=Object.assign({},w(process),E);for(let N in A){const B=A[N];B===null?(g.push("-u"),g.push(N)):(g.push("-e"),g.push(`${N}=${B}`))}}let l="";const D=f.spawn(v.OSASCRIPT,g);D.on("error",A=>{u(L(A))}),D.stderr.on("data",A=>{l+=A.toString()}),D.on("exit",A=>{if(A===0)s(void 0);else if(l){const N=l.split(`
`,1);u(new Error(N[0]))}else u(new Error(P.localize(1,null,d,A)))})}else u(new Error(P.localize(2,null,t)))})}spawnTerminal(r,m,a){const E=m.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const s=["-a",E];a&&s.push(a);const u=w(process),d=r.spawn("/usr/bin/open",s,{cwd:a,env:u});d.on("error",t),d.on("exit",()=>n())})}}e.MacExternalTerminalService=v,v.OSASCRIPT="/usr/bin/osascript";class p extends c{openTerminal(r,m){return this.spawnTerminal(f,r,m)}runInTerminal(r,m,a,E,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,u)=>{let d=[];t.then(h=>{h.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const g=`${S(a)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;d.push(`''${g}''`);const l=Object.assign({},w(process),E);Object.keys(l).filter(B=>l[B]===null).forEach(B=>delete l[B]);const D={cwd:m,env:l};let A="";const N=f.spawn(h,d,D);N.on("error",B=>{u(L(B))}),N.stderr.on("data",B=>{A+=B.toString()}),N.on("exit",B=>{if(B===0)s(void 0);else if(A){const F=A.split(`
`,1);u(new Error(F[0]))}else u(new Error(P.localize(4,null,h,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!_.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await I.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{r?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,m,a){const E=m.linuxExec?Promise.resolve(m.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{E.then(s=>{const u=w(process),d=r.spawn(s,[],{cwd:a,env:u});d.on("error",t),d.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=P.localize(3,null);function w(o){const r={...o.env};return(0,T.sanitizeProcessEnvironment)(r),r}function L(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(P.localize(5,null,o.path)):o}function S(o){let r="";for(let m of o)m.indexOf(" ")>=0?r+='"'+m+'"':r+=m,r+=" ";return r}}),define(ve[42],we([0,1,24,8,9,13,2,160,4]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var R;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var y;(function(W){W[W.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var c;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=b;function v(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=v;function p(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function w(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=w;function L(W){return b(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=L;var S;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class o extends Error{constructor(M,x){super(M);this.code=x}}e.FileSystemProviderError=o;function r(W,M){const x=new o(W.toString(),M);return a(x,M),x}e.createFileSystemProviderError=r;function m(W){return W||r((0,I.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=m;function a(W,M){return W.name=M?`${M} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=a;function E(W){if(!W)return S.Unknown;if(W instanceof o)return W.code;const M=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!M)return S.Unknown;switch(M[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=E;function n(W){if(W instanceof g)return W.fileOperationResult;switch(E(W)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class s{constructor(M,x,V){this.resource=M,this.operation=x,this.target=V}isOperation(M){return this.operation===M}}e.FileOperationEvent=s;var u;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(M,x){this.added=void 0,this.updated=void 0,this.deleted=void 0;const V=new Map;for(const U of M){const H=V.get(U.type);H?H.push([U.resource,U]):V.set(U.type,[[U.resource,U]])}for(const[U,H]of V)switch(U){case 1:this.added=f.TernarySearchTree.forUris(()=>x),this.added.fill(H);break;case 0:this.updated=f.TernarySearchTree.forUris(()=>x),this.updated.fill(H);break;case 2:this.deleted=f.TernarySearchTree.forUris(()=>x),this.deleted.fill(H);break}}contains(M,...x){return this.doContains(M,{includeChildren:!1},...x)}affects(M,...x){return this.doContains(M,{includeChildren:!0},...x)}doContains(M,x,...V){if(!M)return!1;const U=V.length>0;return!!((!U||V.includes(1))&&(this.added?.get(M)||x.includeChildren&&this.added?.findSuperstr(M))||(!U||V.includes(0))&&(this.updated?.get(M)||x.includeChildren&&this.updated?.findSuperstr(M))||(!U||V.includes(2))&&(this.deleted?.findSubstr(M)||x.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function h(W,M,x){return!W||!M||W===M||M.length>W.length?!1:(M.charAt(M.length-1)!==i.sep&&(M+=i.sep),x?(0,k.startsWithIgnoreCase)(W,M):W.indexOf(M)===0)}e.isParent=h;class g extends Error{constructor(M,x,V){super(M);this.fileOperationResult=x,this.options=V}}e.FileOperationError=g;class l extends g{constructor(M,x,V){super(M,2,V);this.stat=x}}e.NotModifiedSinceFileOperationError=l;var D;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=N;async function B(W,M){if(!M.hasProvider(T.URI.from({scheme:W.scheme})))return new Promise(x=>{const V=M.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===W.scheme&&U.added&&(V.dispose(),x())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(M){return(0,_.isNumber)(M)||(M=0),M<F.KB?(0,I.localize)(1,null,M.toFixed(0)):M<F.MB?(0,I.localize)(2,null,(M/F.KB).toFixed(2)):M<F.GB?(0,I.localize)(3,null,(M/F.MB).toFixed(2)):M<F.TB?(0,I.localize)(4,null,(M/F.GB).toFixed(2)):(0,I.localize)(5,null,(M/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var O;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function z(W){return{maxFileSize:W===0?300*F.MB:16*F.GB,maxHeapSize:W===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=z}),define(ve[85],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...k){this._entries=new Map;for(let[_,T]of k)this.set(_,T)}set(k,_){const T=this._entries.get(k);return this._entries.set(k,_),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=f}),define(ve[187],we([0,1,18,15,115,180,4,85]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class P extends Error{constructor(v){super("cyclic dependency between services");this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class R{constructor(v=new I.ServiceCollection,p=!1,w){this._activeInstantiations=new Set,this._services=v,this._strict=p,this._parent=w,this._services.set(T.IInstantiationService,this)}createChild(v){return new R(v,this._strict,this)}invokeFunction(v,...p){let w=c.traceInvocation(v),L=!1;try{return v({get:o=>{if(L)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(o,w);if(!r)throw new Error(`[invokeFunction] unknown service '${o}'`);return r}},...p)}finally{L=!0,w.stop()}}createInstance(v,...p){let w,L;return v instanceof k.SyncDescriptor?(w=c.traceCreation(v.ctor),L=this._createInstance(v.ctor,v.staticArguments.concat(p),w)):(w=c.traceCreation(v),L=this._createInstance(v,p,w)),w.stop(),L}_createInstance(v,p=[],w){let L=T._util.getServiceDependencies(v).sort((r,m)=>r.index-m.index),S=[];for(const r of L){let m=this._getOrCreateServiceInstance(r.id,w);if(!m&&this._strict&&!r.optional)throw new Error(`[createInstance] ${v.name} depends on UNKNOWN service ${r.id}.`);S.push(m)}let o=L.length>0?L[0].index:p.length;if(p.length!==o){console.warn(`[createInstance] First service dependency of ${v.name} at position ${o+1} conflicts with ${p.length} static arguments`);let r=o-p.length;r>0?p=p.concat(new Array(r)):p=p.slice(0,o)}return new v(...[...p,...S])}_setServiceInstance(v,p){if(this._services.get(v)instanceof k.SyncDescriptor)this._services.set(v,p);else if(this._parent)this._parent._setServiceInstance(v,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){let p=this._services.get(v);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):p}_getOrCreateServiceInstance(v,p){let w=this._getServiceInstanceOrDescriptor(v);return w instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,w,p.branch(v,!0)):(p.branch(v,!1),w)}_safeCreateAndCacheServiceInstance(v,p,w){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,p,w)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,p,w){const L=new _.Graph(r=>r.id.toString());let S=0;const o=[{id:v,desc:p,_trace:w}];for(;o.length;){const r=o.pop();if(L.lookupOrInsertNode(r),S++>1e3)throw new P(L);for(let m of T._util.getServiceDependencies(r.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(m.id);if(!a&&!m.optional&&console.warn(`[createInstance] ${v} depends on ${m.id} which is NOT registered.`),a instanceof k.SyncDescriptor){const E={id:m.id,desc:a,_trace:r._trace.branch(m.id,!0)};L.insertEdge(r,E),o.push(E)}}}for(;;){const r=L.roots();if(r.length===0){if(!L.isEmpty())throw new P(L);break}for(const{data:m}of r){if(this._getServiceInstanceOrDescriptor(m.id)instanceof k.SyncDescriptor){const E=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,E)}L.removeNode(m)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,p,w=[],L,S){if(this._services.get(v)instanceof k.SyncDescriptor)return this._createServiceInstance(p,w,L,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,p,w,L,S);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(v,p=[],w,L){if(w){const S=new f.IdleValue(()=>this._createInstance(v,p,L));return new Proxy(Object.create(null),{get(o,r){if(r in o)return o[r];let m=S.value,a=m[r];return typeof a!="function"||(a=a.bind(m),o[r]=a),a},set(o,r,m){return S.value[r]=m,!0}})}else return this._createInstance(v,p,L)}}e.InstantiationService=R;var y;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(y||(y={}));class c{constructor(v,p){this.type=v,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(v){return C?new c(1,v.name||v.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(v){return C?new c(0,v.name):c._None}branch(v,p){let w=new c(2,v.toString());return this._dep.push([v,p,w]),w}stop(){let v=Date.now()-this._start;c._totals+=v;let p=!1;function w(S,o){let r=[],m=new Array(S+1).join("	");for(const[a,E,n]of o._dep)if(E&&n){p=!0,r.push(`${m}CREATES -> ${a}`);let t=w(S+1,n);t&&r.push(t)}else r.push(`${m}uses -> ${a}`);return r.join(`
`)}let L=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(v>2||p)&&console.log(L.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(ve[11],we([0,1,50,3,6,12,4]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function I(){return new Date().toISOString()}var C;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function P(E,n,t){switch(n){case C.Trace:E.trace(t);break;case C.Debug:E.debug(t);break;case C.Info:E.info(t);break;case C.Warning:E.warn(t);break;case C.Error:E.error(t);break;case C.Critical:E.critical(t);break;default:throw new Error("Invalid log level")}}e.log=P;function R(E){let n="";for(let t=0;t<E.length;t++){let s=E[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(t>0?" ":"")+s}return n}e.format=R;class y extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class c extends y{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(C.Trace)&&this.log(C.Trace,R([n,...t]))}debug(n,...t){this.checkLogLevel(C.Debug)&&this.log(C.Debug,R([n,...t]))}info(n,...t){this.checkLogLevel(C.Info)&&this.log(C.Info,R([n,...t]))}warn(n,...t){this.checkLogLevel(C.Warning)&&this.log(C.Warning,R([n,...t]))}error(n,...t){if(this.checkLogLevel(C.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(C.Error,R(s))}else this.log(C.Error,R([n,...t]))}critical(n,...t){this.checkLogLevel(C.Critical)&&this.log(C.Critical,R([n,...t]))}flush(){}}e.AbstractMessageLogger=c;class b extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!_.isWindows}trace(n,...t){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,n,...t):console.log(`[main ${I()}]`,n,...t))}debug(n,...t){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,n,...t):console.log(`[main ${I()}]`,n,...t))}info(n,...t){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,n,...t):console.log(`[main ${I()}]`,n,...t))}warn(n,...t){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,n,...t):console.warn(`[main ${I()}]`,n,...t))}error(n,...t){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,n,...t):console.error(`[main ${I()}]`,n,...t))}critical(n,...t){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,n,...t):console.error(`[main ${I()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class v extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=v;class p extends y{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,f.toErrorMessage)(n,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class w extends y{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=w;class L extends k.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=L;class S extends k.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?C.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class o{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(n){}getLevel(){return C.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=o;function r(E){if(E.verbose)return C.Trace;if(typeof E.logLevel=="string"){const n=m(E.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function m(E){switch(E){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=m;function a(E){switch(E){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=a}),define(ve[188],we([0,1,42,11]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(I,C,P,R,y){try{const c=await new Promise((v,p)=>{X(["spdlog"],v,p)});c.setFlushOn(i.LogLevel.Trace);const b=await c.createAsyncRotatingLogger(I,C,P,R);return y&&b.clearFormatters(),b}catch(c){console.error(c)}return null}function _(I,C,P){switch(C){case i.LogLevel.Trace:I.trace(P);break;case i.LogLevel.Debug:I.debug(P);break;case i.LogLevel.Info:I.info(P);break;case i.LogLevel.Warning:I.warn(P);break;case i.LogLevel.Error:I.error(P);break;case i.LogLevel.Critical:I.critical(P);break;default:throw new Error("Invalid log level")}}class T extends i.AbstractMessageLogger{constructor(C,P,R,y,c){super();this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(C,P,R,y),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(C,P,R,y){const c=R?6:1,b=30/c*f.ByteSize.MB,v=await k(C,P,b,c,y);if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:p,message:w}of this.buffer)_(this._logger,p,w);this.buffer=[]}}log(C,P){this._logger?_(this._logger,C,P):this.getLevel()<=C&&this.buffer.push({level:C,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(ve[117],we([0,1,48,161,4]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var _;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(_=e.MarkerTag||(e.MarkerTag={}));var T;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function P(v,p){return p-v}C.compare=P;const R=Object.create(null);R[C.Error]=(0,i.localize)(0,null),R[C.Warning]=(0,i.localize)(1,null),R[C.Info]=(0,i.localize)(2,null);function y(v){return R[v]||""}C.toString=y;function c(v){switch(v){case f.default.Error:return C.Error;case f.default.Warning:return C.Warning;case f.default.Info:return C.Info;case f.default.Ignore:return C.Hint}}C.fromSeverity=c;function b(v){switch(v){case C.Error:return f.default.Error;case C.Warning:return f.default.Warning;case C.Info:return f.default.Info;case C.Hint:return f.default.Ignore}}C.toSeverity=b}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(C){const P="";function R(c){return y(c,!0)}C.makeKey=R;function y(c,b){let v=[P];return c.source?v.push(c.source.replace("\xA6","\\\xA6")):v.push(P),c.code?typeof c.code=="string"?v.push(c.code.replace("\xA6","\\\xA6")):v.push(c.code.value.replace("\xA6","\\\xA6")):v.push(P),c.severity!==void 0&&c.severity!==null?v.push(T.toString(c.severity)):v.push(P),c.message&&b?v.push(c.message.replace("\xA6","\\\xA6")):v.push(P),c.startLineNumber!==void 0&&c.startLineNumber!==null?v.push(c.startLineNumber.toString()):v.push(P),c.startColumn!==void 0&&c.startColumn!==null?v.push(c.startColumn.toString()):v.push(P),c.endLineNumber!==void 0&&c.endLineNumber!==null?v.push(c.endLineNumber.toString()):v.push(P),c.endColumn!==void 0&&c.endColumn!==null?v.push(c.endColumn.toString()):v.push(P),v.push(P),v.join("\xA6")}C.makeKeyOptionalMessage=y})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(ve[189],we([0,1,3,48,4]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,k.createDecorator)("notificationService");var _;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new C,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=I;class C{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=C}),define(ve[190],we([0,1,6,9,2,4]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,_.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function T(C,P){return k.URI.isUri(C)?(0,i.equalsIgnoreCase)(C.scheme,P):(0,i.startsWithIgnoreCase)(C,P+":")}e.matchesScheme=T;function I(C,...P){return P.some(R=>T(C,R))}e.matchesSomeScheme=I}),define(ve[191],we([0,1,10,12,40,23]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const I=i.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const I=(0,_.dirname)(f.FileAccess.asFileUri("",X));T=X.__$__nodeRequire((0,_.joinPath)(I,"product.json").fsPath);const C=X.__$__nodeRequire((0,_.joinPath)(I,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:C.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var He=this&&this.__param||function(X,e){return function(f,i){e(f,i,X)}};define(ve[118],we([0,1,18,21,6,4]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var T;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let C=class extends k.Disposable{constructor(y,c){super();this.deferred=new f.DeferredPromise,c.withProgress(y,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};C=Ve([He(1,e.IProgressService)],C),e.UnmanagedProgress=C;class P extends k.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(y){this.stop();const c=++this.currentOperationId,b=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:b.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(ve[51],we([0,1,56,13]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,I){f.ok(i.isString(T)),f.ok(i.isObject(I)),f.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ve[192],we([0,1,3,51]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class _{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,P){this.schemasById[k(C)]=P,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new _;i.Registry.add(e.Extensions.JSONContribution,T)}),define(ve[119],we([0,1,16,3,13,156,192,51]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=I.Registry.as(T.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(m,a=!0){this.registerConfigurations([m],a)}registerConfigurations(m,a=!0){const E=this.doRegisterConfigurations(m,a);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E})}deregisterConfigurations(m){const a=this.doDeregisterConfigurations(m);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:m,remove:a}){const E=[];E.push(...this.doDeregisterConfigurations(a)),E.push(...this.doRegisterConfigurations(m,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,f.distinct)(E)})}registerDefaultConfigurations(m){const a=[],E=[];for(const{overrides:n,source:t}of m)for(const s in n)if(a.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const u={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:u});const d={type:"object",default:u,description:_.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:k.isString(t)?void 0:t};E.push(...v(s)),this.configurationProperties[s]=d,this.defaultLanguageConfigurationOverridesNode.properties[s]=d}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:t});const u=this.configurationProperties[s];u&&(this.updatePropertyDefaultValue(s,u),this.updateSchema(s,u))}this.registerOverrideIdentifiers(E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(m){const a=[];for(const{overrides:E,source:n}of m)for(const t in E){const s=this.configurationDefaultsOverrides.get(t),u=k.isString(n)?n:n?.id,d=k.isString(s?.source)?s?.source:s?.source?.id;if(u===d)if(a.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const a of m)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(m,a){const E=[];return m.forEach(n=>{E.push(...this.validateAndRegisterProperties(n,a,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),E}doDeregisterConfigurations(m){const a=[],E=n=>{if(n.properties)for(const t in n.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>E(t))};for(const n of m){E(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return a}validateAndRegisterProperties(m,a=!0,E,n,t=3){t=k.isUndefinedOrNull(m.scope)?t:m.scope;let s=[],u=m.properties;if(u)for(let h in u){if(a&&S(h)){delete u[h];continue}const g=u[h];if(g.source=E,g.defaultDefaultValue=u[h].default,this.updatePropertyDefaultValue(h,g),e.OVERRIDE_PROPERTY_REGEX.test(h)?g.scope=void 0:(g.scope=k.isUndefinedOrNull(g.scope)?t:g.scope,g.restricted=k.isUndefinedOrNull(g.restricted)?!!n?.includes(h):g.restricted),u[h].hasOwnProperty("included")&&!u[h].included){this.excludedConfigurationProperties[h]=u[h],delete u[h];continue}else this.configurationProperties[h]=u[h];!u[h].deprecationMessage&&u[h].markdownDeprecationMessage&&(u[h].deprecationMessage=u[h].markdownDeprecationMessage),s.push(h)}let d=m.allOf;if(d)for(let h of d)s.push(...this.validateAndRegisterProperties(h,a,E,n,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(m){const a=E=>{let n=E.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=E.allOf;t&&t.forEach(a)};a(m)}updateSchema(m,a){switch(e.allSettings.properties[m]=a,a.scope){case 1:e.applicationSettings.properties[m]=a;break;case 2:e.machineSettings.properties[m]=a;break;case 6:e.machineOverridableSettings.properties[m]=a;break;case 3:e.windowSettings.properties[m]=a;break;case 4:e.resourceSettings.properties[m]=a;break;case 5:e.resourceSettings.properties[m]=a,this.resourceLanguageSettingsSchema.properties[m]=a;break}}removeFromSchema(m,a){switch(delete e.allSettings.properties[m],a.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m],delete this.resourceLanguageSettingsSchema.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const a=`[${m}]`,E={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,E),e.allSettings.properties[a]=E,e.applicationSettings.properties[a]=E,e.machineSettings.properties[a]=E,e.machineOverridableSettings.properties[a]=E,e.windowSettings.properties[a]=E,e.resourceSettings.properties[a]=E}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const m={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,a){const E=this.configurationDefaultsOverrides.get(m);let n=E?.value,t=E?.source;k.isUndefined(n)&&(n=a.defaultDefaultValue,t=void 0),k.isUndefined(n)&&(n=w(a.type)),a.default=n,a.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",b=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(r){const m=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let a=b.exec(r);for(;a?.length;){const E=a[1].trim();E&&m.push(E),a=b.exec(r)}}return(0,f.distinct)(m)}e.overrideIdentifiersFromKey=v;function p(r){return r.reduce((m,a)=>`${m}[${a}]`,"")}e.keyFromOverrideIdentifiers=p;function w(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const L=new y;I.Registry.add(e.Extensions.Configuration,L);function S(r){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?_.localize(7,null,r):L.getConfigurationProperties()[r]!==void 0?_.localize(8,null,r):null:_.localize(6,null)}e.validateProperty=S;function o(){const r=[],m=L.getConfigurationProperties();for(const a of Object.keys(m))r.push([a,m[a].scope]);return r.push(["launch",4]),r.push(["task",4]),r}e.getScopes=o}),define(ve[193],we([0,1,16,3,58,6,24,25,13,2,116,119,51]),function(X,e,f,i,k,_,T,I,C,P,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,R.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,R.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return f.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return f.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=I.deepClone(this.contents),s=I.deepClone(this.overrides),u=[...this.keys];for(const d of n){this.mergeContents(t,d.contents);for(const h of d.overrides){const[g]=s.filter(l=>f.equals(l.identifiers,h.identifiers));g?(this.mergeContents(g.contents,h.contents),g.keys.push(...h.keys),g.keys=f.distinct(g.keys)):s.push(I.deepClone(h))}for(const h of d.keys)u.indexOf(h)===-1&&u.push(h)}return new b(t,u,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const u of f.distinct([...Object.keys(this.contents),...Object.keys(t)])){let d=this.contents[u],h=t[u];h&&(typeof d=="object"&&typeof h=="object"?(d=I.deepClone(d),this.mergeContents(d,h)):d=h),s[u]=d}return new b(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&C.isObject(n[s])&&C.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=I.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?I.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const u=d=>{d&&(s?this.mergeContents(s,d):s=I.deepClone(d))};for(const d of this.overrides)f.equals(d.identifiers,[n])?t=d.contents:d.identifiers.includes(n)&&u(d.contents);return u(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,R.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,R.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=b;class v extends b{constructor(n={}){const t=c.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),u=Object.create(null),d=[];for(const h in t){const g=n[h],l=g!==void 0?g:t[h].default;(0,R.addToValueTree)(u,h,l,D=>console.error(`Conflict in default settings: ${D}`))}for(const h of Object.keys(u))y.OVERRIDE_PROPERTY_REGEX.test(h)&&d.push({identifiers:(0,y.overrideIdentifiersFromKey)(h),keys:Object.keys(u[h]),contents:(0,R.toValuesTree)(u[h],g=>console.error(`Conflict in default settings file: ${g}`))});super(u,s,d)}}e.DefaultConfigurationModel=v;class p{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!C.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:u,overrides:d,restricted:h}=this.doParseRaw(n,t);this._configurationModel=new b(s,u,d),this._restrictedConfigurations=h||[]}doParseContent(n){let t={},s=null,u=[],d=[],h=[];function g(D){Array.isArray(u)?u.push(D):s!==null&&(u[s]=D)}let l={onObjectBegin:()=>{let D={};g(D),d.push(u),u=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{let D=[];g(D),d.push(u),u=D,s=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:g,onError:(D,A,N)=>{h.push({error:D,offset:A,length:N})}};if(n)try{k.visit(n,l),t=u[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return t}doParseRaw(n,t){const s=c.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),u=this.filter(n,s,!0,t);n=u.raw;const d=(0,R.toValuesTree)(n,l=>console.error(`Conflict in settings file ${this._name}: ${l}`)),h=Object.keys(n),g=this.toOverrides(n,l=>console.error(`Conflict in settings file ${this._name}: ${l}`));return{contents:d,keys:h,overrides:g,restricted:u.restricted}}filter(n,t,s,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:n,restricted:[]};const d={},h=[];for(let g in n)if(y.OVERRIDE_PROPERTY_REGEX.test(g)&&s){const l=this.filter(n[g],t,!1,u);d[g]=l.raw,h.push(...l.restricted)}else{const l=t[g],D=l?typeof l.scope!="undefined"?l.scope:3:void 0;l?.restricted&&h.push(g),(D===void 0||u.scopes===void 0||u.scopes.includes(D))&&(u.skipRestricted&&l?.restricted||(d[g]=n[g]))}return{raw:d,restricted:h}}toOverrides(n,t){const s=[];for(const u of Object.keys(n))if(y.OVERRIDE_PROPERTY_REGEX.test(u)){const d={};for(const h in n[u])d[h]=n[u][h];s.push({identifiers:(0,y.overrideIdentifiersFromKey)(u),keys:Object.keys(d),contents:(0,R.toValuesTree)(d,t)})}return s}}e.ConfigurationModelParser=p;class w extends _.Disposable{constructor(n,t,s,u){super();this.userSettingsResource=n,this.scopes=t,this.fileService=u,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class L{constructor(n,t,s=new b,u=new b,d=new T.ResourceMap,h=new b,g=new T.ResourceMap,l=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=d,this._memoryConfiguration=h,this._memoryConfigurationByResource=g,this._freeze=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let u;s.resource?(u=this._memoryConfigurationByResource.get(s.resource),u||(u=new b,this._memoryConfigurationByResource.set(s.resource,u))):u=this._memoryConfiguration,t===void 0?u.removeValue(n):u.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const u=this.getConsolidateConfigurationModel(t,s),d=this.getFolderConfigurationModelForResource(t.resource,s),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,g=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),l=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),D=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),N=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,B=d?t.overrideIdentifier?d.freeze().override(t.overrideIdentifier).getValue(n):d.freeze().getValue(n):void 0,F=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(n):h.getValue(n),O=u.getValue(n),z=f.distinct(f.flatten(u.overrides.map(W=>W.identifiers))).filter(W=>u.getOverrideValue(n,W)!==void 0);return{defaultValue:g,userValue:l,userLocalValue:D,userRemoteValue:A,workspaceValue:N,workspaceFolderValue:B,memoryValue:F,value:O,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:l!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:d?.freeze().getValue(n),override:t.overrideIdentifier?d?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:h.getValue(n),override:t.overrideIdentifier?h.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];if(!t){const{added:u,updated:d,removed:h}=m(this._defaultConfiguration,n);t=[...u,...d,...h]}for(const u of t)for(const d of(0,y.overrideIdentifiersFromKey)(u)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(d),g=n.getKeysForOverrideIdentifier(d),l=[...g.filter(D=>h.indexOf(D)===-1),...h.filter(D=>g.indexOf(D)===-1),...h.filter(D=>!I.equals(this._defaultConfiguration.override(d).getValue(D),n.override(d).getValue(D)))];s.push([d,l])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:u,overrides:d}=m(this.localUserConfiguration,n),h=[...t,...s,...u];return h.length&&this.updateLocalUserConfiguration(n),{keys:h,overrides:d}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:u,overrides:d}=m(this.remoteUserConfiguration,n);let h=[...t,...s,...u];return h.length&&this.updateRemoteUserConfiguration(n),{keys:h,overrides:d}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:u,overrides:d}=m(this.workspaceConfiguration,n);let h=[...t,...s,...u];return h.length&&this.updateWorkspaceConfiguration(n),{keys:h,overrides:d}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:u,updated:d,removed:h,overrides:g}=m(s,t);let l=[...u,...d,...h];return(l.length||!s)&&this.updateFolderConfiguration(n,t),{keys:l,overrides:g}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:u,removed:d,overrides:h}=m(t,void 0);return{keys:[...s,...u,...d],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const u=t.getFolder(n);u&&(s=this.getFolderConsolidatedConfiguration(u.uri)||s);const d=this._memoryConfigurationByResource.get(n);d&&(s=s.merge(d))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(n);u?(t=s.merge(u),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:u,keys:d}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:u,keys:d}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(u=>t.add(u))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),u=this.parseConfigurationModel(n.workspace),d=n.folders.reduce((h,g)=>(h.set(P.URI.revive(g[0]),this.parseConfigurationModel(g[1])),h),new T.ResourceMap);return new L(t,s,new b,u,d,new b,new T.ResourceMap,!1)}static parseConfigurationModel(n){return new b(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=L;function S(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const n=new Set,t=new Map;for(const u of E)u.keys.forEach(d=>n.add(d)),u.overrides.forEach(([d,h])=>{const g=(0,T.getOrSet)(t,d,new Set);h.forEach(l=>g.add(l))});const s=[];return t.forEach((u,d)=>s.push([d,[...u.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=S;class o{constructor(n,t,s,u){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=u,this._previousConfiguration=void 0;const d=new Set;n.keys.forEach(g=>d.add(g)),n.overrides.forEach(([,g])=>g.forEach(l=>d.add(l))),this.affectedKeys=[...d.values()];const h=new b;this.affectedKeys.forEach(g=>h.setValue(g,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=L.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!I.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,R.toValuesTree)({[t]:!0},()=>{}),u;for(;typeof s=="object"&&(u=Object.keys(s)[0]);){if(n=n[u],!n)return!1;s=s[u]}return!0}}e.ConfigurationChangeEvent=o;class r extends o{constructor(n,t,s,u){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=r;function m(E,n){const{added:t,removed:s,updated:u}=a(n,E),d=[],h=E?.getAllOverrideIdentifiers()||[],g=n?.getAllOverrideIdentifiers()||[];if(n){const l=g.filter(D=>!h.includes(D));for(const D of l)d.push([D,n.getKeysForOverrideIdentifier(D)])}if(E){const l=h.filter(D=>!g.includes(D));for(const D of l)d.push([D,E.getKeysForOverrideIdentifier(D)])}if(n&&E){for(const l of h)if(g.includes(l)){const D=a({contents:E.getOverrideValue(void 0,l)||{},keys:E.getKeysForOverrideIdentifier(l)},{contents:n.getOverrideValue(void 0,l)||{},keys:n.getKeysForOverrideIdentifier(l)});d.push([l,[...D.added,...D.removed,...D.updated]])}}return{added:t,removed:s,updated:u,overrides:d}}function a(E,n){const t=E?n?E.keys.filter(d=>n.keys.indexOf(d)===-1):[...E.keys]:[],s=n?E?n.keys.filter(d=>E.keys.indexOf(d)===-1):[...n.keys]:[],u=[];if(E&&n){for(const d of n.keys)if(E.keys.indexOf(d)!==-1){const h=(0,R.getConfigurationValue)(n.contents,d),g=(0,R.getConfigurationValue)(E.contents,d);I.equals(h,g)||u.push(d)}}return{added:t,removed:s,updated:u}}}),define(ve[120],we([0,1,4]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var i;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,I=i.Unknown,C){super(T);this._message=T,this._code=I,this._detail=C,this.isHandled=I===i.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===i.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===i.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(ve[63],we([0,1,10]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function i(P){return P.scheme===f.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=i;function k(P){if(!P)return;const R=P.indexOf("+");return R<0?P:P.substr(0,R)}e.getRemoteName=k;function _(P){return P.scheme!==f.Schemas.file&&P.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=_;function T(P){if(P.folders.length)return P.folders.every(R=>_(R.uri))?P.folders[0].uri:void 0;if(P.configuration&&_(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=T;function I(P){return T(P)?.scheme}e.getVirtualWorkspaceScheme=I;function C(P){return T(P)!==void 0}e.isVirtualWorkspace=C}),define(ve[27],we([0,1,9,4,63]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=_;function T(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class C{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,v){if(typeof b=="undefined"||b===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof b=="string"||typeof v=="string"){let p=typeof b=="string"?b:b.value,w=typeof v=="string"?v:v.value;return f.equalsIgnoreCase(p,w)}return b._lower===v._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=C;function P(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function R(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function y(c,b){if(b){const v=`onResolveRemoteAuthority:${(0,k.getRemoteName)(b)}`;return c.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[194],we([0,1,9,27]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(v,p){return v.uuid&&p.uuid?v.uuid===p.uuid:v.id===p.id?!0:(0,f.compareIgnoreCase)(v.id,p.id)===0}e.areSameExtensions=k;class _{constructor(p,w){this.version=w,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof _?k(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=_;function T(v,p){return`${v}.${p}`}e.getExtensionId=T;function I(v){return v.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function C(v,p){return I(T(v,p))}e.getGalleryExtensionId=C;function P(v,p){const w=[],L=S=>{for(const o of w)if(o.some(r=>k(p(r),p(S))))return o;return null};for(const S of v){const o=L(S);o?o.push(S):w.push([S])}return w}e.groupByExtension=P;function R(v){return{id:v.identifier.id,name:v.manifest.name,galleryId:null,publisherId:v.publisherId,publisherName:v.manifest.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:v.manifest.extensionDependencies&&v.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function y(v){return{id:v.identifier.id,name:v.name,galleryId:v.identifier.uuid,publisherId:v.publisherId,publisherName:v.publisher,publisherDisplayName:v.publisherDisplayName,isPreReleaseVersion:v.properties.isPreReleaseVersion,dependencies:!!(v.properties.dependencies&&v.properties.dependencies.length>0),...v.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function c(v){const p=new Set;if(v.malicious)for(const w of v.malicious)p.add(w.id);return p}e.getMaliciousExtensionsSet=c;function b(v,p){const w=[],L=p.manifest.extensionDependencies?.slice(0)??[];for(;L.length;){const S=L.shift();if(S&&w.every(o=>!k(o.identifier,{id:S}))){const o=v.filter(r=>k(r.identifier,{id:S}));o.length===1&&(w.push(o[0]),L.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=b}),define(ve[121],we([0,1,3,12,4,11]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var T;(function(v){v.Http="http",v.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=y;function c(v,p){return p?p!==1&&v<1024:!i.isWindows&&v<1024}e.isPortPrivileged=c;let b=class{constructor(p){this.logService=p,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,w){return this._tunnelProvider=p,p?(this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],w=Array.from(this._tunnels.values());for(let L of w){const S=Array.from(L.values());for(let o of S){const r=await o.value;r&&p.push(r)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:w}of p.values())await w.then(L=>L?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,w,L,S,o=!1,r=I.Private,m){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${L} on local port ${S}.`),!p)return;w||(w="localhost");const a=this.retainOrCreateTunnel(p,w,L,S,o,r,m);return a?a.then(E=>{if(!E){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,L);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(E);return(E.tunnelRemoteHost!==w||E.tunnelRemotePort!==L)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const w=this._tunnels.get(p.tunnelRemoteHost);if(w){const L=w.get(p.tunnelRemotePort);L&&(L.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,L))}}}}async tryDisposeTunnel(p,w,L){if(L.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${w}.`);const S=L.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(w),S}}async closeTunnel(p,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${w} `);const L=this._tunnels.get(p);if(L&&L.has(w)){const S=L.get(w);S.refcount=0,await this.tryDisposeTunnel(p,w,S)}}addTunnelToMap(p,w,L){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(w,{refcount:1,value:L})}async removeEmptyTunnelFromMap(p,w){const L=this._tunnels.get(p);L&&(await L.get(w)||L.delete(w),L.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,w){let L=[p];R(p)?(L.push(...e.LOCALHOST_ADDRESSES),L.push(...e.ALL_INTERFACES_ADDRESSES)):y(p)&&L.push(...e.ALL_INTERFACES_ADDRESSES);const S=L.map(o=>this._tunnels.get(o));for(const o of S){const r=o?.get(w);if(r)return r}}canTunnel(p){return!!P(p)}createWithProvider(p,w,L,S,o,r,m){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${L} on local port ${S}.`);const E={elevationRequired:o?c(S===void 0?L:S):!1},n={remoteAddress:{host:w,port:L},localAddressPort:S,privacy:r,public:r!==I.Private,protocol:m},t=p.forwardPort(n,E);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(w,L,t),t}};b=Ve([He(0,_.ILogService)],b),e.AbstractTunnelService=b}),define(ve[195],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{constructor(){this.validators=new Map}vsda(){return new Promise((k,_)=>X(["vsda"],k,_))}async createNewMessage(k){try{const _=await this.vsda(),T=new _.validator;if(T){const I=String(f._nextId++);return this.validators.set(I,T),{id:I,data:T.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,_){if(!k.id)return!0;const T=this.validators.get(k.id);if(!T)return!1;this.validators.delete(k.id);try{return T.validate(_)==="ok"}catch{return!1}}async sign(k){try{const _=await this.vsda(),T=new _.signer;if(T)return T.sign(k)}catch{}return k}}e.SignService=f,f._nextId=1}),define(ve[196],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,_,T=5){let I;return I=_(C=>{const P=typeof C=="string"?C:C.data;let R=this._terminalBufferMap.get(k);if(R){R.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(k),T);R={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(k),I.dispose()}},this._terminalBufferMap.set(k,R)}),I}stopBuffering(k){const _=this._terminalBufferMap.get(k);_&&_.dispose()}flushBuffer(k){const _=this._terminalBufferMap.get(k);_&&(this._terminalBufferMap.delete(k),this._callback(k,_.data.join("")))}}e.TerminalDataBufferer=f}),define(ve[197],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(ve[86],we([0,1,74,3,6,4,51,197]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var C;(function(w){function L(S){return S&&typeof S=="object"&&typeof S.id=="string"}w.isThemeColor=L})(C=e.ThemeColor||(e.ThemeColor={}));function P(w){return{id:w}}e.themeColorFromId=P;var R;(function(w){function L(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||C.isThemeColor(t.color))}w.isThemeIcon=L;const S=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function o(t){const s=S.exec(t);if(!s)return;let[,u]=s;return{id:u}}w.fromString=o;function r(t){return{id:t}}w.fromId=r;function m(t,s){let u=t.id;const d=u.lastIndexOf("~");return d!==-1&&(u=u.substring(0,d)),s&&(u=`${u}~${s}`),{id:u}}w.modify=m;function a(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}w.getModifier=a;function E(t,s){return t.id===s.id&&t.color?.id===s.color?.id}w.isEqual=E;function n(t,s){return{id:t.id,color:s?P(s):void 0}}w.asThemeIcon=n,w.asClassNameArray=f.CSSIcon.asClassNameArray,w.asClassName=f.CSSIcon.asClassName,w.asCSSSelector=f.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function y(w){switch(w){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(L){return this.themingParticipants.push(L),this.onThemingParticipantAddedEmitter.fire(L),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(L);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new c;T.Registry.add(e.Extensions.ThemingContribution,b);function v(w){return b.onColorThemeChange(w)}e.registerThemingParticipant=v;class p extends k.Disposable{constructor(L){super();this.themeService=L,this.theme=L.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(L){this.theme=L,this.updateStyles()}updateStyles(){}getColor(L,S){let o=this.theme.getColor(L);return o&&S&&(o=S(o,this.theme)),o?o.toString():null}}e.Themable=p}),define(ve[43],we([0,1,24,23,2,4]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,_.createDecorator)("contextService");var T;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function I(c){const b=c;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=I;function C(c){const b=c;return!!(b&&typeof b=="object"&&k.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=C;class P{constructor(b,v,p,w,L){this._id=b,this._transient=p,this._configuration=w,this._ignorePathCasing=L,this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=v}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class R{constructor(b,v){this.raw=v,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,i.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function y(c){return new R({uri:c,index:0,name:(0,i.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=y}),define(ve[198],we([0,1,28,58,140,81,10,8,12,23,2,162,4,63,43]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(M){return(typeof M=="string"?(0,I.extname)(M):(0,P.extname)(M))===p}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function L(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=L;function S(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=S;function o(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=o;function r(M){return M&&M.hasOwnProperty("folderUri")}e.isFolderBackupInfo=r;function m(M){return M&&M.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=m;function a(M){const x=M;return typeof x?.id=="string"&&R.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=a;function E(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=E;function n(M){const x=M;return typeof x?.id=="string"&&R.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=n;function t(M){const x=M;if(x?.uri)return{id:x.id,uri:R.URI.revive(x.uri)};const V=M;if(V?.configPath)return{id:V.id,configPath:R.URI.revive(V.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=t;function s(M,x){return P.extUriBiasedIgnorePathCase.isEqualOrParent(M,x.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function u(M){return d(M)||h(M)}e.isStoredWorkspaceFolder=u;function d(M){const x=M;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=d;function h(M){const x=M;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=h;function g(M,x,V,U,H=!C.isWindows,Y){if(M.scheme!==U.scheme)return{name:V,uri:M.toString(!0)};let se=x?void 0:Y.relativePath(U,M);if(se!==void 0)se.length===0?se=".":C.isWindows&&M.scheme===T.Schemas.file&&!H&&(se=se.replace(/\//g,"\\"));else if(M.scheme===T.Schemas.file)se=M.fsPath,C.isWindows&&(se=(0,_.normalizeDriveLetter)(se),H&&(se=(0,f.toSlashes)(se)));else{if(!Y.isEqualAuthority(M.authority,U.authority))return{name:V,uri:M.toString(!0)};se=M.path}return{name:V,path:se}}e.getStoredWorkspaceFolder=g;function l(M,x,V){let U=[],H=new Set;const Y=V.dirname(x);for(let se of M){let K;if(d(se))se.path&&(K=V.resolvePath(Y,se.path));else if(h(se))try{K=R.URI.parse(se.uri),K.path[0]!=="/"&&(K=K.with({path:"/"+K.path}))}catch(j){console.warn(j)}if(K){let j=V.getComparisonKey(K);if(!H.has(j)){H.add(j);const ne=se.name||V.basenameOrAuthority(K);U.push(new v.WorkspaceFolder({uri:K,name:ne,index:U.length},se))}}}return U}e.toWorkspaceFolders=l;function D(M,x,V,U,H){let Y=A(x,M);const se=H.dirname(x),K=H.dirname(U),j=[],ne=N(Y.folders);for(const Me of Y.folders){const Ue=d(Me)?H.resolvePath(se,Me.path):R.URI.parse(Me.uri);let q;V?q=!1:q=!d(Me)||(0,I.isAbsolute)(Me.path),j.push(g(Ue,q,Me.name,K,ne,H))}const le={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},ge=k.setProperty(M,["folders"],j,le);let ke=k.applyEdits(M,ge);return(0,P.isEqualAuthority)(Y.remoteAuthority,(0,b.getRemoteAuthority)(U))&&(ke=k.applyEdits(ke,k.removeProperty(ke,["remoteAuthority"],le))),ke}e.rewriteWorkspaceFileForNewLocation=D;function A(M,x){let V=i.parse(x);if(V&&Array.isArray(V.folders))V.folders=V.folders.filter(U=>u(U));else throw new Error(`${M} looks like an invalid workspace file.`);return V}function N(M){return C.isWindows?M.some(x=>d(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=N;function B(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function F(M){return typeof M.folderUri=="string"}function O(M){return typeof M.fileUri=="string"}function z(M,x){const V={workspaces:[],files:[]};if(M){const U=function(Y,se){for(let K=0;K<Y.length;K++)try{se(Y[K],K)}catch(j){x.warn(`Error restoring recent entry ${JSON.stringify(Y[K])}: ${j.toString()}. Skip entry.`)}},H=M;if(Array.isArray(H.entries))U(H.entries,Y=>{const se=Y.label,K=Y.remoteAuthority;B(Y)?V.workspaces.push({label:se,remoteAuthority:K,workspace:{id:Y.workspace.id,configPath:R.URI.parse(Y.workspace.configPath)}}):F(Y)?V.workspaces.push({label:se,remoteAuthority:K,folderUri:R.URI.parse(Y.folderUri)}):O(Y)&&V.files.push({label:se,remoteAuthority:K,fileUri:R.URI.parse(Y.fileUri)})});else{const Y=M;Array.isArray(Y.workspaces3)&&U(Y.workspaces3,(se,K)=>{const j=Array.isArray(Y.workspaceLabels)&&Y.workspaceLabels[K]||void 0;typeof se=="object"&&typeof se.id=="string"&&typeof se.configURIPath=="string"?V.workspaces.push({label:j,workspace:{id:se.id,configPath:R.URI.parse(se.configURIPath)}}):typeof se=="string"&&V.workspaces.push({label:j,folderUri:R.URI.parse(se)})}),Array.isArray(Y.files2)&&U(Y.files2,(se,K)=>{const j=Array.isArray(Y.fileLabels)&&Y.fileLabels[K]||void 0;typeof se=="string"&&V.files.push({label:j,fileUri:R.URI.parse(se)})})}}return V}e.restoreRecentlyOpened=z;function W(M){const x={entries:[]};for(const V of M.workspaces)S(V)?x.entries.push({folderUri:V.folderUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority}):x.entries.push({workspace:{id:V.workspace.id,configPath:V.workspace.configPath.toString()},label:V.label,remoteAuthority:V.remoteAuthority});for(const V of M.files)x.entries.push({fileUri:V.fileUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority});return x}e.toStoreData=W}),define(ve[87],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const _=this._idPool++;return this._data.set(_,k),this.logDebugInfo(),_}get(k,_){return this._data.has(k)?this._data.get(k)[_]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(ve[44],we([0,1,10,23,4]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class _{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(I=>{const C=this._providerInfo.get(I.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(I,C){C===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,C)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=_,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],we([0,1,4]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(ve[199],we([0,1,18]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(T,I,C){this._deferredPromises=new Map,this._id=T,this._shared=I,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of P.values())R.complete()}catch(R){for(const y of P.values())y.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,I){let C=this._value[T];return typeof C=="undefined"&&(C=I),C}update(T,I){this._value[T]=I;let C=this._deferredPromises.get(T);if(C!==void 0)return C.p;const P=new f.DeferredPromise;return this._deferredPromises.set(T,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class k extends i{constructor(T,I){super(T.identifier.value,!0,I);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(ve[200],we([0,1,3,2,11]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let _=class{constructor(I,C){this._logService=I,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,C,P){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I)).acceptModelChanged(C.value,P)}$acceptDirtyStateChanged(I,C){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I)).acceptDirty(C)}$acceptModelSaved(I){const C=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(I,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,C);const P=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(I));P.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};_=Ve([He(0,k.ILogService)],_),e.ExtHostNotebookDocuments=_}),define(ve[14],we([0,1,4]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class i{constructor(_){this.getProxy=_.getProxy.bind(_),this.set=_.set.bind(_),this.assertRegistered=_.assertRegistered.bind(_),this.drain=_.drain.bind(_)}}e.ExtHostRpcService=i});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[201],we([0,1,27,3]),function(X,e,f,i){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class _{constructor(I,C){k.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(I.identifier),tt(this,k,C,"f"),Le(this,k,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(I){return Le(this,k,"f").get(this._id,I)}store(I,C){return Le(this,k,"f").store(this._id,I,C)}delete(I){return Le(this,k,"f").delete(this._id,I)}}e.ExtensionSecrets=_,k=new WeakMap}),define(ve[122],we([0,1,4,3]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(ve[64],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(S){S[S.Upsert=0]="Upsert",S[S.RemoveChild=1]="RemoveChild",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp",S[S.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const i=new WeakMap,k=(S,o)=>{const r={controllerId:o};return i.set(S,r),r};e.createPrivateApiFor=k;const _=S=>i.get(S);e.getPrivateApiFor=_;const T=(S,o,r,m)=>{let a=r;return{enumerable:!0,configurable:!1,get(){return a},set(E){if(!m(a,E)){const n=a;a=E,S.listener?.({op:3,key:o,value:E,previous:n})}}}},I=(S,o)=>S===o,C={range:(S,o)=>S===o?!0:!S||!o?!1:S.isEqual(o),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(S,o)=>!(S.length!==o.length||S.some(r=>!o.find(m=>r.id===m.id)))},P=Object.keys(C),R=(S,o)=>({range:T(S,"range",void 0,C.range),label:T(S,"label",o,C.label),description:T(S,"description",void 0,C.description),canResolveChildren:T(S,"canResolveChildren",!1,C.canResolveChildren),busy:T(S,"busy",!1,C.busy),error:T(S,"error",void 0,C.error),tags:T(S,"tags",[],C.tags)}),y=(S,o)=>{const r=new Map;for(const m of P)C[m](S[m],o[m])||r.set(m,o[m]);return r};e.diffTestItems=y;class c extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=c;class b extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class v extends Error{constructor(o,r,m){super(`TestItem with ID "${o}" is from controller "${r}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=v;const p=S=>{const o=(0,e.getPrivateApiFor)(S);let r=new Map;return{get size(){return r.size},forEach(m,a){for(const E of r.values())m.call(a,E,this)},replace(m){const a=new Map,E=new Set(r.keys()),n={op:4,ops:[]};for(const t of m){if(!(t instanceof w))throw new b(t.id);const s=(0,e.getPrivateApiFor)(t).controllerId;if(s!==o.controllerId)throw new v(t.id,s,o.controllerId);if(a.has(t.id))throw new c(t.id);a.set(t.id,t),E.delete(t.id),n.ops.push({op:0,item:t})}for(const t of E.keys())n.ops.push({op:1,id:t});o.listener?.(n),r=a},add(m){if(!(m instanceof w))throw new b(m.id);r.set(m.id,m),o.listener?.({op:0,item:m})},delete(m){r.delete(m)&&o.listener?.({op:1,id:m})},get(m){return r.get(m)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class w{constructor(o,r,m,a){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const E=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return E.parent instanceof L?void 0:E.parent}},children:{value:p(this),enumerable:!0,writable:!1},...R(E,m)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class L extends w{constructor(o,r){super(o,o,r,void 0)}}e.TestItemRootImpl=L}),define(ve[52],we([0,1,4,121,3,14]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(C){function P(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:y.protocol}}C.fromApiTunnel=P;function R(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==i.TunnelPrivacyId.ConstantPrivate&&y.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}C.fromServiceTunnel=R})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let I=class{constructor(P){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,R){}async getTunnels(){return[]}async setTunnelExtensionFunctions(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,R){return{dispose:()=>{}}}async $providePortAttributes(P,R,y,c,b){return[]}async $forwardPort(P,R){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=Ve([He(0,_.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[7],we([0,1,16,15,99,24,95,9,13,2,33,42,120]),function(X,e,f,i,k,_,T,I,C,P,R,y,c){"use strict";var b,v,p,w,L,S,o,r,m,a,E,n,t,s,u,d,h,g,l,D;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(G){function $(){return Reflect.construct(G,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(G,"name")),Object.setPrototypeOf($,G),Object.setPrototypeOf($.prototype,G.prototype),$}let N=L=class{constructor($){b.set(this,void 0),tt(this,b,$,"f")}static from(...$){let ue=$;return new L(function(){if(ue){for(const Pe of ue)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ue=void 0}})}dispose(){typeof Le(this,b,"f")=="function"&&(Le(this,b,"f").call(this),tt(this,b,void 0,"f"))}};b=new WeakMap,N=L=Ve([A],N),e.Disposable=N;let B=S=class{constructor($,ue){if($<0)throw(0,i.illegalArgument)("line must be non-negative");if(ue<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=$,this._character=ue}static Min(...$){if($.length===0)throw new TypeError;let ue=$[0];for(let Pe=1;Pe<$.length;Pe++){const Ye=$[Pe];Ye.isBefore(ue)&&(ue=Ye)}return ue}static Max(...$){if($.length===0)throw new TypeError;let ue=$[0];for(let Pe=1;Pe<$.length;Pe++){const Ye=$[Pe];Ye.isAfter(ue)&&(ue=Ye)}return ue}static isPosition($){if(!$)return!1;if($ instanceof S)return!0;let{line:ue,character:Pe}=$;return typeof ue=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,ue=0){if($===null||ue===null)throw(0,i.illegalArgument)();let Pe;return typeof $=="undefined"?Pe=0:typeof $=="number"?Pe=$:(Pe=typeof $.lineDelta=="number"?$.lineDelta:0,ue=typeof $.characterDelta=="number"?$.characterDelta:0),Pe===0&&ue===0?this:new S(this.line+Pe,this.character+ue)}with($,ue=this.character){if($===null||ue===null)throw(0,i.illegalArgument)();let Pe;return typeof $=="undefined"?Pe=this.line:typeof $=="number"?Pe=$:(Pe=typeof $.line=="number"?$.line:this.line,ue=typeof $.character=="number"?$.character:this.character),Pe===this.line&&ue===this.character?this:new S(Pe,ue)}toJSON(){return{line:this.line,character:this.character}}};B=S=Ve([A],B),e.Position=B;let F=o=class{constructor($,ue,Pe,Ye){let rt,lt;if(typeof $=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(rt=new B($,ue),lt=new B(Pe,Ye)):$ instanceof B&&ue instanceof B&&(rt=$,lt=ue),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange($){return $ instanceof o?!0:$?B.isPosition($.start)&&B.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof o?this.contains($._start)&&this.contains($._end):$ instanceof B?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const ue=B.Max($.start,this._start),Pe=B.Min($.end,this._end);if(!ue.isAfter(Pe))return new o(ue,Pe)}union($){if(this.contains($))return this;if($.contains(this))return $;const ue=B.Min($.start,this._start),Pe=B.Max($.end,this.end);return new o(ue,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,ue=this.end){if($===null||ue===null)throw(0,i.illegalArgument)();let Pe;return $?B.isPosition($)?Pe=$:(Pe=$.start||this.start,ue=$.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ue.isEqual(this.end)?this:new o(Pe,ue)}toJSON(){return[this.start,this.end]}};F=o=Ve([A],F),e.Range=F;let O=r=class extends F{constructor($,ue,Pe,Ye){let rt,lt;if(typeof $=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(rt=new B($,ue),lt=new B(Pe,Ye)):$ instanceof B&&ue instanceof B&&(rt=$,lt=ue),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection($){return $ instanceof r?!0:$?F.isRange($)&&B.isPosition($.anchor)&&B.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=r=Ve([A],O),e.Selection=O;class z{constructor($,ue,Pe){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,i.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,i.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(ue),this.connectionToken=Pe}}e.ResolvedAuthority=z;class W extends Error{constructor($,ue=c.RemoteAuthorityResolverErrorCode.Unknown,Pe){super($);this._message=$,this._code=ue,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype)}static NotAvailable($,ue){return new W($,c.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable($){return new W($,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=W;var M;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(M=e.EndOfLine||(e.EndOfLine={}));var x;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=m=class{constructor($,ue){this._range=$,this._newText=ue}static isTextEdit($){return $ instanceof m?!0:$?F.isRange($)&&typeof $.newText=="string":!1}static replace($,ue){return new m($,ue)}static insert($,ue){return m.replace(new F($,$),ue)}static delete($){return m.replace($,"")}static setEndOfLine($){const ue=new m(new F(new B(0,0),new B(0,0)),"");return ue.newEol=$,ue}get range(){return this._range}set range($){if($&&!F.isRange($))throw(0,i.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,i.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,i.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=m=Ve([A],V),e.TextEdit=V;var U;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace"})(U=e.FileEditType||(e.FileEditType={}));let H=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,ue,Pe,Ye){this._edits.push({_type:1,from:$,to:ue,options:Pe,metadata:Ye})}createFile($,ue,Pe){this._edits.push({_type:1,from:void 0,to:$,options:ue,metadata:Pe})}deleteFile($,ue,Pe){this._edits.push({_type:1,from:$,to:void 0,options:ue,metadata:Pe})}replaceNotebookMetadata($,ue,Pe){this._edits.push({_type:3,metadata:Pe,uri:$,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells($,ue,Pe,Ye,rt){let lt,ft,Tt=[],Ft;if(xe.isNotebookRange(ue)&&Ut.isNotebookCellDataArray(Pe)&&!Ut.isNotebookCellDataArray(Ye)?(lt=ue.start,ft=ue.end,Tt=Pe,Ft=Ye):typeof ue=="number"&&typeof Pe=="number"&&Ut.isNotebookCellDataArray(Ye)&&(lt=ue,ft=Pe,Tt=Ye,Ft=rt),lt===void 0||ft===void 0)throw new Error("Invalid arguments");(lt!==ft||Tt.length>0)&&this._edits.push({_type:5,uri:$,index:lt,count:ft-lt,cells:Tt,metadata:Ft})}replaceNotebookCellMetadata($,ue,Pe,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:8,index:ue,metadata:Pe}})}replace($,ue,Pe,Ye){this._edits.push({_type:2,uri:$,edit:new V(ue,Pe),metadata:Ye})}insert($,ue,Pe,Ye){this.replace($,new F(ue,ue),Pe,Ye)}delete($,ue,Pe){this.replace($,ue,"",Pe)}has($){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===$.toString())}set($,ue){if(ue)for(const Pe of ue)Pe&&this._edits.push({_type:2,uri:$,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Ye=this._edits[Pe];Ye._type===2&&Ye.uri.toString()===$.toString()&&(this._edits[Pe]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get($){const ue=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===$.toString()&&ue.push(Pe.edit);return ue}entries(){const $=new _.ResourceMap;for(let ue of this._edits)if(ue._type===2){let Pe=$.get(ue.uri);Pe||(Pe=[ue.uri,[]],$.set(ue.uri,Pe)),Pe[1].push(ue.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};H=Ve([A],H),e.WorkspaceEdit=H;let Y=a=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof a?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=a._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,ue=this._tabstop++){if(typeof $=="function"){const Pe=new a;Pe._tabstop=this._tabstop,$(Pe),this._tabstop=Pe._tabstop,$=Pe.value}else $=a._escape($);return this.value+="${",this.value+=ue,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,ue=this._tabstop++){const Pe=$.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable($,ue){if(typeof ue=="function"){const Pe=new a;Pe._tabstop=this._tabstop,ue(Pe),this._tabstop=Pe._tabstop,ue=Pe.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};Y=a=Ve([A],Y),e.SnippetString=Y;var se;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let j=E=class{constructor($,ue){if(this.uri=$,ue)if(ue instanceof F)this.range=ue;else if(ue instanceof B)this.range=new F(ue,ue);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof E?!0:$?F.isRange($.range)&&P.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};j=E=Ve([A],j),e.Location=j;let ne=class{constructor($,ue){this.location=$,this.message=ue}static is($){return $?typeof $.message=="string"&&$.location&&F.isRange($.location.range)&&P.URI.isUri($.location.uri):!1}static isEqual($,ue){return $===ue?!0:!$||!ue?!1:$.message===ue.message&&$.location.range.isEqual(ue.location.range)&&$.location.uri.toString()===ue.location.uri.toString()}};ne=Ve([A],ne),e.DiagnosticRelatedInformation=ne;let le=class{constructor($,ue,Pe=K.Error){if(!F.isRange($))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=$,this.message=ue,this.severity=Pe}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,ue){return $===ue?!0:!$||!ue?!1:$.message===ue.message&&$.severity===ue.severity&&$.code===ue.code&&$.severity===ue.severity&&$.source===ue.source&&$.range.isEqual(ue.range)&&(0,f.equals)($.tags,ue.tags)&&(0,f.equals)($.relatedInformation,ue.relatedInformation,ne.isEqual)}};le=Ve([A],le),e.Diagnostic=le;let ge=class{constructor($,ue){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=ue}};ge=Ve([A],ge),e.Hover=ge;var ke;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor($,ue=ke.Text){this.range=$,this.kind=ue}toJSON(){return{range:this.range,kind:ke[this.kind]}}};Me=Ve([A],Me),e.DocumentHighlight=Me;var Ue;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(Ue=e.SymbolKind||(e.SymbolKind={}));var q;(function(G){G[G.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let J=n=class{constructor($,ue,Pe,Ye,rt){this.name=$,this.kind=ue,this.containerName=rt,typeof Pe=="string"&&(this.containerName=Pe),Ye instanceof j?this.location=Ye:Pe instanceof F&&(this.location=new j(Ye,Pe)),n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ue[this.kind],location:this.location,containerName:this.containerName}}};J=n=Ve([A],J),e.SymbolInformation=J;let re=t=class{constructor($,ue,Pe,Ye,rt){this.name=$,this.detail=ue,this.kind=Pe,this.range=Ye,this.selectionRange=rt,this.children=[],t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(t.validate)}};re=t=Ve([A],re),e.DocumentSymbol=re;var he;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(he=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor($,ue){this.title=$,this.kind=ue}};Z=Ve([A],Z),e.CodeAction=Z;let ce=s=class{constructor($){this.value=$}append($){return new s(this.value?this.value+s.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+s.sep)}};ce.sep=".",ce=s=Ve([A],ce),e.CodeActionKind=ce,ce.Empty=new ce(""),ce.QuickFix=ce.Empty.append("quickfix"),ce.Refactor=ce.Empty.append("refactor"),ce.RefactorExtract=ce.Refactor.append("extract"),ce.RefactorInline=ce.Refactor.append("inline"),ce.RefactorRewrite=ce.Refactor.append("rewrite"),ce.Source=ce.Empty.append("source"),ce.SourceOrganizeImports=ce.Source.append("organizeImports"),ce.SourceFixAll=ce.Source.append("fixAll");let Se=class{constructor($,ue){if(this.range=$,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=Ve([A],Se),e.SelectionRange=Se;class Be{constructor($,ue,Pe,Ye,rt,lt){this.kind=$,this.name=ue,this.detail=Pe,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=Be;class qe{constructor($,ue){this.fromRanges=ue,this.from=$}}e.CallHierarchyIncomingCall=qe;class Ke{constructor($,ue){this.fromRanges=ue,this.to=$}}e.CallHierarchyOutgoingCall=Ke;var Je;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor($,ue){this.range=$,this.command=ue}get isResolved(){return!!this.command}};it=Ve([A],it),e.CodeLens=it;let at=u=class{constructor($,ue=!1){v.set(this,void 0),tt(this,v,new k.MarkdownString($,{supportThemeIcons:ue}),"f")}static isMarkdownString($){return $ instanceof u?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Le(this,v,"f").value}set value($){Le(this,v,"f").value=$}get isTrusted(){return Le(this,v,"f").isTrusted}set isTrusted($){Le(this,v,"f").isTrusted=$}get supportThemeIcons(){return Le(this,v,"f").supportThemeIcons}set supportThemeIcons($){Le(this,v,"f").supportThemeIcons=$}get supportHtml(){return Le(this,v,"f").supportHtml}set supportHtml($){Le(this,v,"f").supportHtml=$}appendText($){return Le(this,v,"f").appendText($),this}appendMarkdown($){return Le(this,v,"f").appendMarkdown($),this}appendCodeblock($,ue){return Le(this,v,"f").appendCodeblock(ue??"",$),this}};v=new WeakMap,at=u=Ve([A],at),e.MarkdownString=at;let et=class{constructor($,ue){this.label=$,this.documentation=ue}};et=Ve([A],et),e.ParameterInformation=et;let nt=class{constructor($,ue){this.label=$,this.documentation=ue,this.parameters=[]}};nt=Ve([A],nt),e.SignatureInformation=nt;let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ct=Ve([A],ct),e.SignatureHelp=ct;var vt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(vt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var We;(function(G){G[G.Other=0]="Other",G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(We=e.InlayHintKind||(e.InlayHintKind={}));let At=class{constructor($,ue,Pe){this.text=$,this.position=ue,this.kind=Pe}};At=Ve([A],At),e.InlayHint=At;var ee;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ee=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var te;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var Ee;(function(G){G[G.Deprecated=1]="Deprecated"})(Ee=e.CompletionItemTag||(e.CompletionItemTag={}));let ie=class{constructor($,ue){this.label=$,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&te[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ie=Ve([A],ie),e.CompletionItem=ie;let Ce=class{constructor($=[],ue=!1){this.items=$,this.isIncomplete=ue}};Ce=Ve([A],Ce),e.CompletionList=Ce;let Fe=class{constructor($,ue,Pe){this.text=$,this.range=ue,this.command=Pe}};Fe=Ve([A],Fe),e.InlineSuggestion=Fe;let Ge=class{constructor($){this.items=$}};Ge=Ve([A],Ge),e.InlineSuggestions=Ge;var ze;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ze=e.ViewColumn||(e.ViewColumn={}));var ut;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var me;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(me=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var be;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(be=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function $(ue){switch(ue){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=$}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let _e=class{constructor($,ue){if(ue&&!P.URI.isUri(ue))throw(0,i.illegalArgument)("target");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.target=ue}};_e=Ve([A],_e),e.DocumentLink=_e;let Ne=class{constructor($,ue,Pe,Ye){this.red=$,this.green=ue,this.blue=Pe,this.alpha=Ye}};Ne=Ve([A],Ne),e.Color=Ne;let Qe=class{constructor($,ue){if(ue&&!(ue instanceof Ne))throw(0,i.illegalArgument)("color");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.color=ue}};Qe=Ve([A],Qe),e.ColorInformation=Qe;let $e=class{constructor($){if(!$||typeof $!="string")throw(0,i.illegalArgument)("label");this.label=$}};$e=Ve([A],$e),e.ColorPresentation=$e;var Xe;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Xe=e.ColorFormat||(e.ColorFormat={}));var st;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ot{constructor($,ue,Pe){if(this.startIndex=$,this.length=ue,this.tooltip=Pe,typeof $!="number"||$<0)throw(0,i.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,i.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=ot;var fe;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(fe=e.TerminalLocation||(e.TerminalLocation={}));class ye{constructor($){this.options=$,typeof $!="object"&&(0,i.illegalArgument)("options")}}e.TerminalProfile=ye;var de;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(de=e.TaskRevealKind||(e.TaskRevealKind={}));var Q;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Q=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=d=class{constructor($,ue){if(this.label=ue,typeof $!="string"||typeof ue!="string")throw(0,i.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};Ie.Clean=new d("clean","Clean"),Ie.Build=new d("build","Build"),Ie.Rebuild=new d("rebuild","Rebuild"),Ie.Test=new d("test","Test"),Ie=d=Ve([A],Ie),e.TaskGroup=Ie;function Oe(G){let $="";for(let ue=0;ue<G.length;ue++)$+=G[ue].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,ue,Pe){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=$,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Pe):this._options=ue)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)$.push(ue);return Oe($)}};Ze=Ve([A],Ze),e.ProcessExecution=Ze;let je=class{constructor($,ue,Pe){if(this._args=[],Array.isArray(ue)){if(!$)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$,this._args=ue,this._options=Pe}else{if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$,this._options=ue}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)$.push(typeof ue=="string"?ue:ue.value);return Oe($)}};je=Ve([A],je),e.ShellExecution=je;var ht;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(ht=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class Dt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Dt;let bt=h=class{constructor($,ue,Pe,Ye,rt,lt){this.__deprecated=!1,this._definition=this.definition=$;let ft;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Pe,this.execution=Ye,ft=rt,this.__deprecated=!0):ue===Et.Global||ue===Et.Workspace?(this.target=ue,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=rt,ft=lt):(this.target=ue,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=rt,ft=lt),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof je?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const ue=this._definition.type;(h.EmptyType===ue||h.ProcessType===ue||h.ShellType===ue||h.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=h=Ve([A],bt),e.Task=bt;var mt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(mt=e.ProgressLocation||(e.ProgressLocation={}));let wt=class{constructor($,ue=_t.None){this.collapsibleState=ue,P.URI.isUri($)?this.resourceUri=$:this.label=$}};wt=Ve([A],wt),e.TreeItem=wt;var _t;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Mt=class{constructor($){this._value=$}async asString(){return JSON.stringify(this._value)}};Mt=Ve([A],Mt),e.TreeDataTransferItem=Mt;let It=class{constructor(){this._items=new Map}get($){return this._items.get($)}set($,ue){this._items.set($,ue)}forEach($){this._items.forEach($)}};It=Ve([A],It),e.TreeDataTransfer=It;let Pt=class{constructor($,ue){this.id=$,this.color=ue}};Pt=Ve([A],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let Rt=class{constructor($){this.id=$}};Rt=Ve([A],Rt),e.ThemeColor=Rt;var yt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(yt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ht=class{constructor($,ue){if(typeof $!="string"&&(!$||!P.URI.isUri($)&&!P.URI.isUri($.uri)))throw(0,i.illegalArgument)("base");if(typeof ue!="string")throw(0,i.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=P.URI.file($),this.base=$):P.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=ue}};Ht=Ve([A],Ht),e.RelativePattern=Ht;let Ot=class{constructor($,ue,Pe,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof ue=="string"&&(this.condition=ue),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Ot=Ve([A],Ot),e.Breakpoint=Ot;let St=class extends Ot{constructor($,ue,Pe,Ye,rt){super(ue,Pe,Ye,rt);if($===null)throw(0,i.illegalArgument)("location");this.location=$}};St=Ve([A],St),e.SourceBreakpoint=St;let Qt=class extends Ot{constructor($,ue,Pe,Ye,rt){super(ue,Pe,Ye,rt);this.functionName=$}};Qt=Ve([A],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends Ot{constructor($,ue,Pe,Ye,rt,lt,ft){super(Ye,rt,lt,ft);if(!ue)throw(0,i.illegalArgument)("dataId");this.label=$,this.dataId=ue,this.canPersist=Pe}};Vt=Ve([A],Vt),e.DataBreakpoint=Vt;let Xt=class{constructor($,ue,Pe){this.command=$,this.args=ue||[],this.options=Pe}};Xt=Ve([A],Xt),e.DebugAdapterExecutable=Xt;let oi=class{constructor($,ue){this.port=$,this.host=ue}};oi=Ve([A],oi),e.DebugAdapterServer=oi;let Lt=class{constructor($){this.path=$}};Lt=Ve([A],Lt),e.DebugAdapterNamedPipeServer=Lt;let Yt=class{constructor($){this.implementation=$}};Yt=Ve([A],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor($,ue){this.range=$,this.expression=ue}};ai=Ve([A],ai),e.EvaluatableExpression=ai;var Jt;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(Jt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor($,ue){this.range=$,this.text=ue}};zt=Ve([A],zt),e.InlineValueText=zt;let pt=class{constructor($,ue,Pe=!0){this.range=$,this.variableName=ue,this.caseSensitiveLookup=Pe}};pt=Ve([A],pt),e.InlineValueVariableLookup=pt;let ci=class{constructor($,ue){this.range=$,this.expression=ue}};ci=Ve([A],ci),e.InlineValueEvaluatableExpression=ci;let Nt=class{constructor($,ue){this.frameId=$,this.stoppedLocation=ue}};Nt=Ve([A],Nt),e.InlineValueContext=Nt;var jt;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Zt=g=class extends Error{constructor($,ue=y.FileSystemProviderErrorCode.Unknown,Pe){super(P.URI.isUri($)?$.toString(!0):$);this.code=Pe?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists($){return new g($,y.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound($){return new g($,y.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory($){return new g($,y.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory($){return new g($,y.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions($){return new g($,y.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable($){return new g($,y.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}};Zt=g=Ve([A],Zt),e.FileSystemError=Zt;let li=class{constructor($,ue,Pe){this.start=$,this.end=ue,this.kind=Pe}};li=Ve([A],li),e.FoldingRange=li;var fi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class ei{constructor($,ue=[]){this.tokenTypes=$,this.tokenModifiers=ue}}e.SemanticTokensLegend=ei;function Si(G){return typeof G=="undefined"||(0,C.isStringArray)(G)}class qt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let ue=0,Pe=$.tokenTypes.length;ue<Pe;ue++)this._tokenTypeStrToInt.set($.tokenTypes[ue],ue);for(let ue=0,Pe=$.tokenModifiers.length;ue<Pe;ue++)this._tokenModifierStrToInt.set($.tokenModifiers[ue],ue)}}push($,ue,Pe,Ye,rt){if(typeof $=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded($,ue,Pe,Ye,rt);if(F.isRange($)&&typeof ue=="string"&&Si(Pe))return this._push($,ue,Pe);throw(0,i.illegalArgument)()}_push($,ue,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,rt=$.start.character,lt=$.end.character-$.start.character,ft=this._tokenTypeStrToInt.get(ue);let Tt=0;if(Pe)for(const Ft of Pe){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Bt=this._tokenModifierStrToInt.get(Ft);Tt|=1<<Bt>>>0}this._pushEncoded(Ye,rt,lt,ft,Tt)}_pushEncoded($,ue,Pe,Ye,rt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Tt=this._data.length/5|0;let Ft=0,Bt=0;for(let xt=0;xt<Tt;xt++){let Wt=this._data[5*xt],di=this._data[5*xt+1];Wt===0?(Wt=Ft,di+=Bt):Wt+=Ft,this._data[5*xt]=Wt,this._data[5*xt+1]=di,Ft=Wt,Bt=di}}let lt=$,ft=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=rt,this._prevLine=$,this._prevChar=ue}static _sortAndDeltaEncode($){let ue=[];const Pe=$.length/5|0;for(let ft=0;ft<Pe;ft++)ue[ft]=ft;ue.sort((ft,Tt)=>{const Ft=$[5*ft],Bt=$[5*Tt];if(Ft===Bt){const xt=$[5*ft+1],Wt=$[5*Tt+1];return xt-Wt}return Ft-Bt});const Ye=new Uint32Array($.length);let rt=0,lt=0;for(let ft=0;ft<Pe;ft++){const Tt=5*ue[ft],Ft=$[Tt+0],Bt=$[Tt+1],xt=$[Tt+2],Wt=$[Tt+3],di=$[Tt+4],$i=Ft-rt,Xi=$i===0?Bt-lt:Bt,hi=5*ft;Ye[hi+0]=$i,Ye[hi+1]=Xi,Ye[hi+2]=xt,Ye[hi+3]=Wt,Ye[hi+4]=di,rt=Ft,lt=Bt}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),$):new Gt(qt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=qt;class Gt{constructor($,ue){this.resultId=ue,this.data=$}}e.SemanticTokens=Gt;class _i{constructor($,ue,Pe){this.start=$,this.deleteCount=ue,this.data=Pe}}e.SemanticTokensEdit=_i;class Ci{constructor($,ue){this.resultId=ue,this.edits=$}}e.SemanticTokensEdits=Ci;var Kt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Kt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(G){G[G.Initial=1]="Initial",G[G.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ti=class{constructor(){}};ti.Back={iconPath:new Pt("arrow-left")},ti=Ve([A],ti),e.QuickInputButtons=ti;var Di;(function(G){G[G.Separator=-1]="Separator",G[G.Default=1]="Default"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor($,ue,Pe){this.badge=$,this.tooltip=ue,this.color=Pe}static validate($){if($.badge){let ue=(0,I.nextCharLength)($.badge,0);if(ue<$.badge.length&&(ue+=(0,I.nextCharLength)($.badge,ue)),$.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ii=class{constructor($){this.kind=$}};ii=Ve([A],ii),e.ColorTheme=ii;var gi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class xe{constructor($,ue){if($<0)throw(0,i.illegalArgument)("start must be positive");if(ue<0)throw(0,i.illegalArgument)("end must be positive");$<=ue?(this._start=$,this._end=ue):(this._start=ue,this._end=$)}static isNotebookRange($){return $ instanceof xe?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let ue=this._start,Pe=this._end;return $.start!==void 0&&(ue=$.start),$.end!==void 0&&(Pe=$.end),ue===this._start&&Pe===this._end?this:new xe(ue,Pe)}}e.NotebookRange=xe;class Ut{constructor($,ue,Pe,Ye,rt,lt,ft){this.kind=$,this.value=ue,this.languageId=Pe,this.mime=Ye,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ft,Ut.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(ue=>Ut.isNotebookCellData(ue))}static isNotebookCellData($){return!0}}e.NotebookCellData=Ut;class pi{constructor($){this.cells=$}}e.NotebookData=pi;class gt{constructor($,ue){this.data=$,this.mime=ue;const Pe=(0,T.normalizeMimeType)(ue,!0);if(!Pe)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem($){return $ instanceof gt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const ue={name:$.name,message:$.message,stack:$.stack};return gt.json(ue,"application/vnd.code.notebook.error")}static stdout($){return gt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return gt.text($,"application/vnd.code.notebook.stderr")}static bytes($,ue="application/octet-stream"){return new gt($,ue)}static text($,ue=T.Mimes.text){const Pe=Le(gt,p,"f",w).encode(String($));return new gt(Pe,ue)}static json($,ue="application/json"){const Pe=JSON.stringify($,void 0,"	");return gt.text(Pe,ue)}}e.NotebookCellOutputItem=gt,p=gt,w={value:new TextEncoder};class ni{constructor($,ue,Pe){this.items=ni.ensureUniqueMimeTypes($,!0),typeof ue=="string"?(this.id=ue,this.metadata=Pe):(this.id=(0,R.generateUuid)(),this.metadata=ue??Pe)}static isNotebookCellOutput($){return $ instanceof ni?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,C.isArray)($.items)}static ensureUniqueMimeTypes($,ue=!1){const Pe=new Set,Ye=new Set;for(let rt=0;rt<$.length;rt++){const lt=$[rt],ft=(0,T.normalizeMimeType)(lt.mime);if(!Pe.has(ft)){Pe.add(ft);continue}Ye.add(rt),ue&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?$:$.filter((rt,lt)=>!Ye.has(lt))}}e.NotebookCellOutput=ni;var Ii;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor($,ue){this.text=$,this.alignment=ue}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor($,ue=[]){this.uri=$,this.provides=(0,f.asArray)(ue)}}e.NotebookRendererScript=Ri;let ri=class{constructor($,ue){this.label=$,this.timestamp=ue}};ri=Ve([A],ri),e.TimelineItem=ri;var Li;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor($,ue){this.ranges=$,this.wordPattern=ue}}e.LinkedEditingRanges=Oi;class Ni{constructor($,ue){this._port=$,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var ae;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(ae=e.TestResultState||(e.TestResultState={}));var pe;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(pe=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Re=class{constructor($=void 0,ue=void 0,Pe=void 0){this.include=$,this.exclude=ue,this.profile=Pe}};Re=Ve([A],Re),e.TestRunRequest=Re;let dt=l=class{constructor($){this.message=$}static diff($,ue,Pe){const Ye=new l($);return Ye.expectedOutput=ue,Ye.actualOutput=Pe,Ye}};dt=l=Ve([A],dt),e.TestMessage=dt;let Ct=class{constructor($){this.id=$}};Ct=Ve([A],Ct),e.TestTag=Ct;let kt=class{constructor($,ue){this.covered=$,this.total=ue}};kt=Ve([A],kt),e.CoveredCount=kt;let Ui=D=class{constructor($,ue,Pe,Ye){this.uri=$,this.statementCoverage=ue,this.branchCoverage=Pe,this.functionCoverage=Ye}static fromDetails($,ue){const Pe=new kt(0,0),Ye=new kt(0,0),rt=new kt(0,0);for(const ft of ue)if("branches"in ft){Pe.total+=1,Pe.covered+=ft.executionCount>0?1:0;for(const Tt of ft.branches)Ye.total+=1,Ye.covered+=Tt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ft.executionCount>0?1:0;const lt=new D($,Pe,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=ue,lt}};Ui=D=Ve([A],Ui),e.FileCoverage=Ui;let Bi=class{constructor($,ue,Pe=[]){this.executionCount=$,this.location=ue,this.branches=Pe}};Bi=Ve([A],Bi),e.StatementCoverage=Bi;let xi=class{constructor($,ue){this.executionCount=$,this.location=ue}};xi=Ve([A],xi),e.BranchCoverage=xi;let Wi=class{constructor($,ue){this.executionCount=$,this.location=ue}};Wi=Ve([A],Wi),e.FunctionCoverage=Wi;var qi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor($,ue,Pe,Ye,rt,lt){this.kind=$,this.name=ue,this.detail=Pe,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=Qi}),define(ve[123],we([0,1,56,10,9,150,110,7,16]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function R(v,p){p?P.set(v,p):P.delete(v)}e.setWordDefinitionFor=R;function y(v){return P.get(v)}e.getWordDefinitionFor=y;class c extends _.MirrorTextModel{constructor(p,w,L,S,o,r,m,a){super(w,L,S,o);this._proxy=p,this._languageId=r,this._isDirty=m,this._notebook=a,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,C.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===i.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(w){return w?p._getTextInRange(w):p.getText()},get eol(){return p._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(w){return p._lineAt(w)},offsetAt(w){return p._offsetAt(w)},positionAt(w){return p._positionAt(w)},validateRange(w){return p._validateRange(w)},validatePosition(w){return p._validatePosition(w)},getWordRangeAtPosition(w,L){return p._getWordRangeAtPosition(w,L)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,f.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,f.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const w=this._validateRange(p);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const L=this._eol,S=w.start.line,o=w.end.line,r=[];r.push(this._lines[S].substring(w.start.character));for(let m=S+1;m<o;m++)r.push(this._lines[m]);return r.push(this._lines[o].substring(0,w.end.character)),r.join(L)}_lineAt(p){let w;if(p instanceof I.Position?w=p.line:typeof p=="number"&&(w=p),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new b(w,this._lines[w],w===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(p),L=this._lines[w.index].length;return new I.Position(w.index,Math.min(w.remainder,L))}_validateRange(p){if(!(p instanceof I.Range))throw new Error("Invalid argument");const w=this._validatePosition(p.start),L=this._validatePosition(p.end);return w===p.start&&L===p.end?p:new I.Range(w.line,w.character,L.line,L.character)}_validatePosition(p){if(!(p instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:w,character:L}=p,S=!1;if(w<0)w=0,L=0,S=!0;else if(w>=this._lines.length)w=this._lines.length-1,L=this._lines[w].length,S=!0;else{const o=this._lines[w].length;L<0?(L=0,S=!0):L>o&&(L=o,S=!0)}return S?new I.Position(w,L):p}_getWordRangeAtPosition(p,w){const L=this._validatePosition(p);if(!w)w=y(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const S=(0,T.getWordAtText)(L.character+1,(0,T.ensureValidWordDefinition)(w),this._lines[L.line],0);if(S)return new I.Range(L.line,S.startColumn-1,L.line,S.endColumn-1)}}e.ExtHostDocumentData=c;class b{constructor(p,w,L){this._line=p,this._text=w,this._isLastLine=L}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(ve[202],we([0,1,7,3,112,6,83,24,2,33]),function(X,e,f,i,k,_,T,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(c,b,v,p){this._notebook=v,this._selector=p,this._disposables=new _.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(L=>{const S=this._cellUris.get(L.document.uri);S!==void 0&&(this._cellLengths.setValue(S,this._cells[S].document.getText().length+1),this._cellLines.setValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=L=>{L===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(L=>w(L.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const c=[],b=[];for(const v of this._notebook.getCells())v.kind===f.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,v.document.uri,v.document.languageId,!0))&&(this._cellUris.set(v.document.uri,this._cells.length),this._cells.push(v),c.push(v.document.getText().length+1),b.push(v.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(c){if(!c){let S="";for(const o of this._cells)S+=o.document.getText()+`
`;return S=S.slice(0,-1),S}if(c.isEmpty)return"";const b=this.locationAt(c.start),v=this.locationAt(c.end),p=this._cellUris.get(b.uri),w=this._cellUris.get(v.uri);if(p===void 0||w===void 0)return"";if(p===w)return this._cells[p].document.getText(new f.Range(b.range.start,v.range.end));const L=[this._cells[p].document.getText(new f.Range(b.range.start,new f.Position(this._cells[p].document.lineCount,0)))];for(let S=p+1;S<w;S++)L.push(this._cells[S].document.getText());return L.push(this._cells[w].document.getText(new f.Range(new f.Position(0,0),v.range.end))),L.join(`
`)}offsetAt(c){const b=this._cellLines.getIndexOf(c.line),v=this._cellLengths.getPrefixSum(b.index-1),p=this._cells[b.index].document.offsetAt(c.with(b.remainder));return v+p}positionAt(c){if(typeof c=="number"){const v=this._cellLengths.getIndexOf(c),p=this._cellLines.getPrefixSum(v.index-1);return this._cells[v.index].document.positionAt(v.remainder).translate(p)}const b=this._cellUris.get(c.uri);if(b!==void 0){const v=this._cellLines.getPrefixSum(b-1);return new f.Position(v+c.range.start.line,c.range.start.character)}return new f.Position(0,0)}locationAt(c){f.Range.isRange(c)||(c=new f.Range(c,c));const b=this._cellLines.getIndexOf(c.start.line);let v=b;c.isEmpty||(v=this._cellLines.getIndexOf(c.end.line));const p=new f.Position(b.remainder,c.start.character),w=new f.Position(v.remainder,c.end.character),L=new f.Range(p,w),S=this._cells[b.index];return new f.Location(S.document.uri,S.document.validateRange(L))}contains(c){return this._cellUris.has(c)}validateRange(c){const b=this.validatePosition(c.start),v=this.validatePosition(c.end);return c.with(b,v)}validatePosition(c){const b=this._cellLines.getIndexOf(c.line),v=new f.Position(b.remainder,c.character),p=this._cells[b.index].document.validatePosition(v),w=this._cellLines.getPrefixSum(b.index-1);return new f.Position(w+p.line,p.character)}}e.ExtHostNotebookConcatDocument=R}),define(ve[203],we([0,1,7,14,3]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let _=class{constructor(I){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let C=I==="light"?f.ColorThemeKind.Light:I==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};_=Ve([He(0,i.IExtHostRpcService)],_),e.ExtHostTheming=_}),define(ve[65],we([0,1,4]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class i{constructor(_){_?(this.transformIncoming=_.transformIncoming.bind(_),this.transformOutgoing=_.transformOutgoing.bind(_),this.transformOutgoingURI=_.transformOutgoingURI.bind(_),this.transformOutgoingScheme=_.transformOutgoingScheme.bind(_)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=i}),define(ve[204],we([0,1,22]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(C){let P=this.buffers.indexOf(C);return P<0&&(P=this.buffers.length,this.buffers.push(C)),P}}function k(I,C){if(C.serializeBuffersForPostMessage){const P=new i,R=(b,v)=>{if(v instanceof ArrayBuffer){const p=P.add(v);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(v)){const p=_(v);if(p){const w=P.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:p,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},y=JSON.stringify(I,R),c=P.buffers.map(b=>{const v=new Uint8Array(b);return f.VSBuffer.wrap(v)});return{message:y,buffers:c}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=k;function _(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(I,C){const P=C.map(c=>{const b=new ArrayBuffer(c.byteLength);return new Uint8Array(b).set(c.buffer),b}),R=C.length?(c,b)=>{if(typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const v=b,{index:p}=v,w=P[p];if(v.view)switch(v.view.type){case 1:return new Int8Array(w,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return b}:void 0;return{message:JSON.parse(I,R),arrayBuffers:P}}e.deserializeWebviewMessage=T}),define(ve[205],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(i){function k(T){const I=new Map;return T.types.forEach((C,P)=>{I.set(C,{asString:async()=>T.items[P].asString})}),I}i.toITreeDataTransfer=k;async function _(T){const I={types:[],items:[]},C=Array.from(T.entries());for(const P of C)I.types.push(P[0]),I.items.push({asString:await P[1].asString()});return I}i.toTreeDataTransferDTO=_})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[88],we([0,1,10,2]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(I,C){return I.scheme===f.Schemas.http||I.scheme===f.Schemas.https?I:(C&&C.authority&&C.isRemote&&I.scheme===f.Schemas.file&&(I=i.URI.from({scheme:f.Schemas.vscodeRemote,authority:C.authority,path:I.path})),i.URI.from({scheme:f.Schemas.https,authority:`${I.scheme}+${_(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=k;function _(I){return I.replace(/./g,C=>{const P=C.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?C:"-"+P.toString(16).padStart(4,"0")})}function T(I){return I.replace(/-([0-9a-f]{4})/g,(C,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=T}),define(ve[206],we([0,1,3,6,88]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class _{constructor(I,C,P){this._proxy=I,this._editors=C,this._initData=P,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const R=C.getVisibleTextEditors();for(const y of this._insets.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,C,P,R,y){let c;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===I){c=o;break}if(!c)throw new Error("not a visible editor");const b=this,v=this._handlePool++,p=new f.Emitter,w=new f.Emitter,L=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,k.asWebviewUri)(o,b._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(o){this._options=o,b._proxy.$setOptions(v,o)}get options(){return this._options}set html(o){this._html=o,b._proxy.$setHtml(v,o)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(o){return b._proxy.$postMessage(v,o)}},S=new class{constructor(){this.editor=I,this.line=C,this.height=P,this.webview=L,this.onDidDispose=w.event}dispose(){b._insets.has(v)&&(b._insets.delete(v),b._proxy.$disposeEditorInset(v),w.fire(),w.dispose(),p.dispose())}};return this._proxy.$createEditorInset(v,c.id,c.value.document.uri,C+1,P,R||{},y.identifier,y.extensionLocation),this._insets.set(v,{editor:I,inset:S,onDidReceiveMessage:p}),S}$onDidDispose(I){const C=this._insets.get(I);C&&C.inset.dispose()}$onDidReceiveMessage(I,C){const P=this._insets.get(I);P&&P.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=_}),define(ve[207],we([0,1,172,13,2,6,4,62,51,42,16,10]),function(X,e,f,i,k,_,T,I,C,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,f.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,f.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,f.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,f.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,f.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,f.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,f.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,f.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,f.localize)(10,null)),e.SideBySideEditorActiveContext=new I.RawContextKey("sideBySideEditorActive",!1,(0,f.localize)(11,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,f.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,f.localize)(13,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,f.localize)(14,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,f.localize)(15,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,f.localize)(16,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,f.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,f.localize)(18,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,f.localize)(19,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,f.localize)(20,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,f.localize)(21,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,f.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function c(F,O,z){for(const W of z.visibleEditorPanes)if(W.group.id===O&&F.matches(W.input))return W.getViewState()}e.findViewStateForEditor=c;function b(F){if(m(F))return!1;const O=F;return k.URI.isUri(O?.resource)}e.isResourceEditorInput=b;function v(F){if(m(F))return!1;const O=F;return O?.original!==void 0&&O.modified!==void 0}e.isResourceDiffEditorInput=v;function p(F){if(m(F)||v(F))return!1;const O=F;return O?.primary!==void 0&&O.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function w(F){if(m(F))return!1;const O=F;return O?O.resource===void 0||O.resource.scheme===y.Schemas.untitled||O.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;var L;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(L=e.Verbosity||(e.Verbosity={}));var S;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var o;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends _.Disposable{}e.AbstractEditorInput=r;function m(F){return F instanceof r}e.isEditorInput=m;function a(F){const O=F;return k.URI.isUri(O?.preferredResource)}function E(F){const O=F;return m(O?.primary)&&m(O?.secondary)}e.isSideBySideEditorInput=E;function n(F){const O=F;return m(O?.modified)&&m(O?.original)}e.isDiffEditorInput=n;function t(F){return m(F?.editor)}e.isEditorInputWithOptions=t;function s(F){const O=F;return t(F)&&O?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function u(F){const O=F;return typeof O?.groupId=="number"&&m(O.editor)}e.isEditorIdentifier=u;var d;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(d=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(h=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var g;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(g=e.SideBySideEditor||(e.SideBySideEditor={}));class l{getOriginalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:M,secondary:x}=this.getSideEditors(O);if(M&&x){if(z?.supportSideBySide===g.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===g.ANY)return this.getOriginalUri(M,{filterByScheme:z.filterByScheme})??this.getOriginalUri(x,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===g.PRIMARY?M:x}}if(v(O)||p(O))return;const W=a(O)?O.preferredResource:O.resource;return!W||!z||!z.filterByScheme?W:this.filterUri(W,z.filterByScheme)}getSideEditors(O){return E(O)||p(O)?{primary:O.primary,secondary:O.secondary}:n(O)||v(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:M,secondary:x}=this.getSideEditors(O);if(M&&x){if(z?.supportSideBySide===g.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===g.ANY)return this.getCanonicalUri(M,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(x,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===g.PRIMARY?M:x}}if(v(O)||p(O))return;const W=O.resource;return!W||!z||!z.filterByScheme?W:this.filterUri(W,z.filterByScheme)}filterUri(O,z){if(Array.isArray(z)){if(z.some(W=>O.scheme===W))return O}else if(z===O.scheme)return O}}e.EditorResourceAccessor=new l;var D;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(D=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(O){const z=this.instantiationService=O.get(T.IInstantiationService);for(const[W,M]of this.editorSerializerConstructors)this.createEditorSerializer(W,M,z);this.editorSerializerConstructors.clear()}createEditorSerializer(O,z,W){const M=W.createInstance(z);this.editorSerializerInstances.set(O,M)}registerFileEditorFactory(O){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=O}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(O,z){if(this.editorSerializerConstructors.has(O)||this.editorSerializerInstances.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.instantiationService?this.createEditorSerializer(O,z,this.instantiationService):this.editorSerializerConstructors.set(O,z),(0,_.toDisposable)(()=>{this.editorSerializerConstructors.delete(O),this.editorSerializerInstances.delete(O)})}getEditorSerializer(O){return this.editorSerializerInstances.get(typeof O=="string"?O:O.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new A);async function N(F,O){if(!F||!F.length)return[];const z=await Promise.all(F.map(async W=>{const M=k.URI.revive(W.fileUri);if(!M||!await O.canHandleResource(M))return;let V=W.exists,U=W.type;if(typeof V!="boolean"||typeof U!="number")try{U=(await O.resolve(M)).isDirectory?P.FileType.Directory:P.FileType.Unknown,V=!0}catch{V=!1}if(!V&&W.openOnlyIfExists||U===P.FileType.Directory)return;const H={selection:V?W.selection:void 0,pinned:!0,override:W.editorOverrideId};let Y;return V?Y={resource:M,options:H}:Y={resource:M,options:H,forceUntitled:!0},Y}));return(0,R.coalesce)(z)}e.pathsToEditors=N;var B;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[124],we([0,1,3,18,173]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class _{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,C,P,R){const y={command:I};if(C&&Object.keys(C).length>0&&(y.arguments=C),this.internalSend("request",y),typeof R=="number"){const c=setTimeout(()=>{clearTimeout(c);const b=this.pendingRequests.get(y.seq);if(b){this.pendingRequests.delete(y.seq);const v={type:"response",seq:0,request_seq:y.seq,success:!1,command:I,message:(0,k.localize)(0,null,R,I)};b(v)}},R)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,C){return I.type!=="event"||C.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,i.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":{const C=I,P=this.pendingRequests.get(C.request_seq);P&&(this.pendingRequests.delete(C.request_seq),P(C));break}}}}internalSend(I,C){C.type=I,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((C,P)=>I.set(P,C)),await(0,i.timeout)(500),I.forEach((C,P)=>{C({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=_}),define(ve[208],we([0,1,9,2,8,25,10]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function C(n,t,s){return n.replace(I,function(u,d){return t&&d.length>0&&d[0]!=="_"?u:s&&s.hasOwnProperty(d)?s[d]:u})}e.formatPII=C;function P(n){const t={};for(const s of Object.keys(n))s.startsWith("!")||(t[s]=n[s]);return t}e.filterExceptionsFromTelemetry=P;function R(n){return n.configuration.request==="attach"&&!y(n)&&(!n.parentSession||R(n.parentSession))}e.isSessionAttach=R;function y(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(t,"extensionhost")||(0,f.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?y(n.parentSession):void 0}e.getExtensionHostDebugSession=y;function c(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=c;function b(n,t,s){let u,d=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=h.exec(n);){const l=g.index+1,D=l+g[0].length;if(l<=t&&D>=s){u=g[0],d=l;break}}if(u){const l=/\w+/g;let D=null;for(;(D=l.exec(u))&&!(D.index+1+d+D[0].length>=s););D&&(u=u.substring(0,l.lastIndex))}return u?{start:d,end:d+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(n){return!!(n&&n.match(v))}e.isUri=p;function w(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(p(n.path))return i.URI.parse(n.path);if((0,k.isAbsolute)(n.path))return i.URI.file(n.path)}return n.path}function L(n){if(typeof n.path=="object"){const t=i.URI.revive(n.path);if(t)return t.scheme===T.Schemas.file?t.fsPath:t.toString()}return n.path}function S(n,t){const s=t?w:L,u=(0,_.deepClone)(n);return r(u,(d,h)=>{d&&h&&(h.path=s(h))}),u}e.convertToDAPaths=S;function o(n,t){const s=t?w:L,u=(0,_.deepClone)(n);return r(u,(d,h)=>{!d&&h&&(h.path=s(h))}),u}e.convertToVSCPaths=o;function r(n,t){switch(n.type){case"event":{const s=n;switch(s.event){case"output":t(!1,s.body.source);break;case"loadedSource":t(!1,s.body.source);break;case"breakpoint":t(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=n;switch(s.command){case"setBreakpoints":t(!0,s.arguments.source);break;case"breakpointLocations":t(!0,s.arguments.source);break;case"source":t(!0,s.arguments.source);break;case"gotoTargets":t(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(u=>t(!1,u));break;default:break}break}case"response":{const s=n;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(u=>t(!1,u.source));break;case"loadedSources":s.body.sources.forEach(u=>t(!1,u));break;case"scopes":s.body.scopes.forEach(u=>t(!1,u.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(u=>t(!1,u.source));break;case"setBreakpoints":s.body.breakpoints.forEach(u=>t(!1,u.source));break;default:break}break}}}function m(n){return n.filter(t=>!t.presentation?.hidden).sort((t,s)=>t.presentation?s.presentation?t.presentation.group?s.presentation.group?t.presentation.group!==s.presentation.group?t.presentation.group.localeCompare(s.presentation.group):a(t.presentation.order,s.presentation.order):-1:s.presentation.group?1:a(t.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=m;function a(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function E(n,t){const s=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(s!=="none"&&(await t.saveAll(),s==="allEditorsInActiveGroup")){const u=t.activeEditorPane;u&&await t.save({editor:u.input,groupId:u.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(ve[209],we([0,1,29,37,174,125,8,9,25,12,184,124]),function(X,e,f,i,k,_,T,I,C,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends y.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",r=>this.handleData(r))}sendMessage(S){if(this.outputStream){const o=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${c.TWO_CRLF}${o}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+o))}continue}}else{const o=this.rawData.indexOf(c.TWO_CRLF);if(o!==-1){const m=this.rawData.toString("utf8",0,o).split(c.HEADER_LINESEPARATOR);for(const a of m){const E=a.split(c.HEADER_FIELDSEPARATOR);E[0]==="Content-Length"&&(this.contentLength=Number(E[1]))}this.rawData=this.rawData.slice(o+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class b extends c{startSession(){return new Promise((S,o)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",m=>{r?this._onError.fire(m):o(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class v extends b{constructor(S){super();this.adapterServer=S}createConnection(S){return _.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=v;class p extends b{constructor(S){super();this.adapterServer=S}createConnection(S){return _.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=p;class w extends c{constructor(S,o,r){super();this.adapterExecutable=S,this.debugType=o,this.outputService=r}async startSession(){const S=this.adapterExecutable.command,o=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(S)if(T.isAbsolute(S)){if(!await f.Promises.exists(S))throw new Error(k.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let m=process.env;if(r.env&&Object.keys(r.env).length>0&&(m=C.mixin(C.deepClone(process.env),r.env)),S==="node")if(Array.isArray(o)&&o.length>0){const E=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:m,execArgv:E?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(n.cwd=r.cwd);const t=i.fork(o[0],o.slice(1),n);if(!t.pid)throw new Error(k.localize(2,null,o[0]));this.serverProcess=t}else throw new Error(k.localize(3,null));else{const E={env:m};r.cwd&&(E.cwd=r.cwd),this.serverProcess=i.spawn(S,o,E)}this.serverProcess.on("error",E=>{this._onError.fire(E)}),this.serverProcess.on("exit",(E,n)=>{this._onExit.fire(E)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",E=>{this._onError.fire(E)}),this.serverProcess.stdin.on("error",E=>{this._onError.fire(E)});const a=this.outputService;if(a){const E=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const t=a.getChannel(R.ExtensionsChannelId);t&&t.append(E(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((S,o)=>{const r=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,a,E){if(m)return o(m)});r.on("exit",S),r.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,o){if(!S)return;const r=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?r.runtime=T.join(o,S.runtime):r.runtime=S.runtime),S.runtimeArgs&&(r.runtimeArgs=S.runtimeArgs),S.program&&(T.isAbsolute(S.program)?r.program=S.program:r.program=T.join(o,S.program)),S.args&&(r.args=S.args);const m=S;return m.win&&(r.win=w.extract(m.win,o)),m.winx86&&(r.winx86=w.extract(m.winx86,o)),m.windows&&(r.windows=w.extract(m.windows,o)),m.osx&&(r.osx=w.extract(m.osx,o)),m.linux&&(r.linux=w.extract(m.linux,o)),r}static platformAdapterExecutable(S,o){let r=Object.create(null);o=o.toLowerCase();for(const s of S)if(s.contributes){const u=s.contributes.debuggers;u&&u.length>0&&u.filter(d=>typeof d.type=="string"&&I.equalsIgnoreCase(d.type,o)).forEach(d=>{const h=w.extract(d,s.extensionLocation.fsPath);r=C.mixin(r,h,s.isBuiltin)})}let m;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=r.winx86||r.win||r.windows:P.isWindows?m=r.win||r.windows:P.isMacintosh?m=r.osx:P.isLinux&&(m=r.linux),m=m||r;const a=m.program||r.program,E=m.args||r.args,n=m.runtime||r.runtime,t=m.runtimeArgs||r.runtimeArgs;if(n)return{type:"executable",command:n,args:(t||[]).concat(typeof a=="string"?[a]:[]).concat(E||[])};if(a)return{type:"executable",command:a,args:E||[]}}}e.ExecutableDebugAdapter=w}),define(ve[210],we([0,1,37,12,28,186]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(c,b){return new Promise((v,p)=>{let w="";const L=f.spawn(c,b);L.pid&&L.stdout.on("data",S=>{w+=S.toString()}),L.on("error",S=>{p(S)}),L.on("close",S=>{v(w)})})}let I;function C(c,b){if(!I)if(i.isWindows)I=new _.WindowsExternalTerminalService;else if(i.isMacintosh)I=new _.MacExternalTerminalService;else if(i.isLinux)I=new _.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const v=b.getConfiguration("terminal");return I.runInTerminal(c.title,c.cwd,c.args,c.env||{},v.external||{})}e.runInExternalTerminal=C;async function P(c){if(c)if(i.isWindows){const b=await new Promise((v,p)=>{X(["windows-process-tree"],v,p)});return new Promise(v=>{b.getProcessTree(c,p=>{v(p.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(c)]).then(b=>{const v=b.trim();return!(v.length===0||v.indexOf(" tmux")>=0)},b=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var R;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(R||(R={}));function y(c,b,v,p){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=1:c.indexOf("cmd.exe")>=0?w=0:c.indexOf("bash")>=0?w=2:i.isWindows?w=0:w=2;let L,S=" ";switch(w){case 1:if(L=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),v){const o=(0,k.getDriveLetter)(v);o&&(S+=`${o}:; `),S+=`cd ${L(v)}; `}if(p)for(const o in p){const r=p[o];r===null?S+=`Remove-Item env:${o}; `:S+=`\${env:${o}}='${r}'; `}if(b.length>0){const o=L(b.shift());S+=o[0]==="'"?`& ${o} `:`${o} `;for(const r of b)S+=`${L(r)} `}break;case 0:if(L=o=>(o=o.replace(/\"/g,'""'),o.indexOf(" ")>=0||o.indexOf('"')>=0||o.length===0?`"${o}"`:o),v){const o=(0,k.getDriveLetter)(v);o&&(S+=`${o}: && `),S+=`cd ${L(v)} && `}if(p){S+='cmd /C "';for(const o in p){let r=p[o];r===null?S+=`set "${o}=" && `:(r=r.replace(/[\^\&\|\<\>]/g,m=>`^${m}`),S+=`set "${o}=${r}" && `)}}for(const o of b)S+=`${L(o)} `;p&&(S+='"');break;case 2:{L=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const o=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(v&&(S+=`cd ${L(v)} ; `),p){S+="/usr/bin/env";for(const r in p){const m=p[r];m===null?S+=` -u ${o(r)}`:S+=` ${o(`${r}=${m}`)}`}S+=" "}for(const r of b)S+=`${L(r)} `;break}}return S}e.prepareCommand=y}),define(ve[126],we([0,1,32,78,95,10,8,12,62]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(l){l[l.Markup=1]="Markup",l[l.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",k.Mimes.latex,k.Mimes.markdown,"image/png","image/jpeg",k.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[k.Mimes.latex,k.Mimes.markdown,"application/json",k.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(l){l[l.Running=1]="Running",l[l.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var y;(function(l){l[l.Pending=2]="Pending",l[l.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(l){l[l.WithHardKernelDependency=0]="WithHardKernelDependency",l[l.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",l[l.Pure=2]="Pure",l[l.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(l){l.Always="always",l.Never="never",l.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var v;(function(l){l[l.ModelChange=1]="ModelChange",l[l.Move=2]="Move",l[l.ChangeLanguage=5]="ChangeLanguage",l[l.Initialize=6]="Initialize",l[l.ChangeCellMetadata=7]="ChangeCellMetadata",l[l.Output=8]="Output",l[l.OutputItem=9]="OutputItem",l[l.ChangeCellContent=10]="ChangeCellContent",l[l.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",l[l.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",l[l.ChangeCellMime=13]="ChangeCellMime",l[l.Unknown=100]="Unknown"})(v=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(l){l[l.Handle=0]="Handle",l[l.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(l){l[l.Replace=1]="Replace",l[l.Output=2]="Output",l[l.Metadata=3]="Metadata",l[l.CellLanguage=4]="CellLanguage",l[l.DocumentMetadata=5]="DocumentMetadata",l[l.Move=6]="Move",l[l.OutputItems=7]="OutputItems",l[l.PartialMetadata=8]="PartialMetadata",l[l.PartialInternalMetadata=9]="PartialInternalMetadata"})(w=e.CellEditType||(e.CellEditType={}));var L;(function(l){l.scheme=_.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function A(W,M){return W.with({scheme:l.scheme,fragment:`ch${M.toString().padStart(7,"0")}${W.scheme!==_.Schemas.file?W.scheme:""}`})}l.generate=A;function N(W){if(W.scheme!==l.scheme)return;const M=D.exec(W.fragment);return M?{handle:Number(M[1]),notebook:W.with({scheme:W.fragment.substring(M[0].length)||_.Schemas.file,fragment:null})}:void 0}l.parse=N;function B(W,M,x){return W.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`ch${M.toString().padStart(7,"0")},${x??""},${W.scheme!==_.Schemas.file?W.scheme:""}`})}l.generateCellOutputUri=B;function F(W){if(W.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const M=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!M)return;const x=Number(M[1]),V=M[2]&&M[2]!==""?M[2]:void 0,U=M[3];return{handle:x,outputId:V,notebook:W.with({scheme:U||_.Schemas.file,fragment:null})}}l.parseCellOutputUri=F;function O(W,M,x){return W.with({scheme:x,fragment:`ch${M.toString().padStart(7,"0")}${W.scheme!==_.Schemas.file?W.scheme:""}`})}l.generateCellUri=O;function z(W,M){if(W.scheme!==M)return;const x=D.exec(W.fragment);return x?{handle:Number(x[1]),notebook:W.with({scheme:W.fragment.substring(x[0].length)||_.Schemas.file,fragment:null})}:void 0}l.parseCellUri=z})(L=e.CellUri||(e.CellUri={}));const S=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[k.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[k.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(l){return S.get(l)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function r(l){return S.get(l)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function m(l){return S.get(l)?.mergeable??!1}e.mimeTypeIsMergeable=m;const a=l=>I.isWindows?l.replace(/\//g,"\\"):l;class E{constructor(D=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(D)].map(N=>({pattern:N,matches:f.parse(a(N))}))}sort(D){const A=new Map(i.Iterable.map(D,B=>[B,a(B)]));let N=[];for(const{matches:B}of this.order)for(const[F,O]of A)if(B(O)){N.push(F),A.delete(F);break}return A.size&&(N=N.concat([...A.keys()].sort((B,F)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(F)))),N}prioritize(D,A){const N=this.findIndex(D);if(N===-1){this.order.unshift({pattern:D,matches:f.parse(a(D))});return}const B=new Set(A.map(O=>this.findIndex(O,N)));B.delete(-1);const F=Array.from(B).sort();this.order.splice(N+1,0,...F.map(O=>this.order[O]));for(let O=F.length-1;O>=0;O--)this.order.splice(F[O],1)}toArray(){return this.order.map(D=>D.pattern)}findIndex(D,A=this.order.length){const N=a(D);for(let B=0;B<A;B++)if(this.order[B].matches(N))return B;return-1}}e.MimeTypeDisplayOrder=E;function n(l,D,A,N=(B,F)=>B===F){const B=[];function F(W,M,x){if(M===0&&x.length===0)return;const V=B[B.length-1];V&&V.start+V.deleteCount===W?(V.deleteCount+=M,V.toInsert.push(...x)):B.push({start:W,deleteCount:M,toInsert:x})}let O=0,z=0;for(;;){if(O===l.length){F(O,0,D.slice(z));break}if(z===D.length){F(O,l.length-O,[]);break}const W=l[O],M=D[z];if(N(W,M)){O+=1,z+=1;continue}A(M)?(F(O,1,[]),O+=1):(F(O,0,[M]),z+=1)}return B}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(l){l.default="default",l.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(l){const D=l;return!!((typeof D.include=="string"||f.isRelativePattern(D.include))&&(typeof D.exclude=="string"||f.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=s;function u(l,D,A){if(Array.isArray(l.viewType)&&l.viewType.indexOf(D)>=0||l.viewType===D)return!0;if(l.filenamePattern){const N=s(l.filenamePattern)?l.filenamePattern.include:l.filenamePattern,B=s(l.filenamePattern)?l.filenamePattern.exclude:void 0;if(f.match(N,(0,T.basename)(A.fsPath).toLowerCase()))return!(B&&f.match(B,(0,T.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class d{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)D[A]=this.textModel.cells[A].getHashValue();return D}}e.CellSequence=d,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var h;(function(l){l[l.Left=1]="Left",l[l.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class g{static create(D){return`${g._prefix}${D}`}static parse(D){if(D.startsWith(g._prefix))return D.substring(g._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=g,g._prefix="notebook/"}),define(ve[211],we([0,1,4]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(ve[212],we([0,1,4,62]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new i.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new i.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new i.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,f.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(_){_[_.Append=1]="Append",_[_.Replace=2]="Replace",_[_.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[213],we([0,1,176,4,62]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,i.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[214],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=f;function i(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=i}),define(ve[127],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var f;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(f=e.TestResultState||(e.TestResultState={}));var i;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(i=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var _;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(y,c)=>{c.expand!==void 0&&(y.expand=c.expand),c.item!==void 0&&(y.item=y.item?Object.assign(y.item,c.item):c.item)};e.applyTestItemUpdate=T;var I;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var C;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(c){}update(c){}remove(c,b){}complete(){}}e.IncrementalChangeCollector=P;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const b=this.createChangeCollector();for(const v of c)switch(v[0]){case 0:{const p=v[1];if(p.parent){if(this.items.has(p.parent)){const w=this.items.get(p.parent);w.children.add(p.item.extId);const L=this.createItem(p,w);this.items.set(p.item.extId,L),b.add(L)}}else{const w=this.createItem(p);this.roots.add(w),this.items.set(p.item.extId,w),b.add(w)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=v[1],w=this.items.get(p.extId);if(!w)break;p.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,p),b.update(w);break}case 2:{const p=this.items.get(v[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const w=[[v[1]]];for(;w.length;)for(const L of w.pop()){const S=this.items.get(L);S&&(w.push(S.children),this.items.delete(L),b.remove(S,S!==p),S.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(v[1]);break;case 3:this.updatePendingRoots(v[1]);break;case 5:this._tags.set(v[1].id,v[1]);break;case 6:this._tags.delete(v[1]);break}b.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=R}),define(ve[89],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(_){_.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(_){_[_.IsSame=0]="IsSame",_[_.Disconnected=1]="Disconnected",_[_.IsChild=2]="IsChild",_[_.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class k{constructor(T,I=T.length){if(this.path=T,this.viewEnd=I,T.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,I,C=T.parent){if(T.id===I)return new k([I]);let P=[T.id];for(let R=C;R&&R.id!==I;R=R.parent)P.push(R.id);return P.push(I),new k(P.reverse())}static isRoot(T){return!T.includes("\0")}static fromString(T){return new k(T.split("\0"))}static join(T,I){return new k([...T.path,I])}static joinToString(T,I){return T.toString()+"\0"+I}static compare(T,I){return T===I?0:I.startsWith(T+"\0")?2:T.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new k(this.path,T)}compare(T){if(typeof T=="string")return k.compare(this.toString(),T);for(let I=0;I<T.viewEnd&&I<this.viewEnd;I++)if(T.path[I]!==this.path[I])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=k}),define(ve[215],we([0,1,8,40,13,25,12,81,177]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,c,b){this._contributedVariables=new Map,this._context=y,this._labelService=c,b&&(this._envVariablesPromise=b.then(v=>this.prepareEnv(v)))}prepareEnv(y){if(T.isWindows){const c=Object.create(null);return Object.keys(y).forEach(b=>{c[b.toLowerCase()]=y[b]}),c}return y}resolveWithEnvironment(y,c,b){return this.recursiveResolve(this.prepareEnv(y),c?c.uri:void 0,b)}async resolveAsync(y,c){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,c)}async resolveAnyBase(y,c,b,v){const p=_.deepClone(c);return T.isWindows&&p.windows?Object.keys(p.windows).forEach(w=>p[w]=p.windows[w]):T.isMacintosh&&p.osx?Object.keys(p.osx).forEach(w=>p[w]=p.osx[w]):T.isLinux&&p.linux&&Object.keys(p.linux).forEach(w=>p[w]=p.linux[w]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,p,b,v)}async resolveAnyAsync(y,c,b){return this.resolveAnyBase(y,c,b)}async resolveAnyMap(y,c,b){const v=new Map;return{newConfig:await this.resolveAnyBase(y,c,b,v),resolvedVariables:v}}resolveWithInteractionReplace(y,c,b,v){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,c,b,v){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,c){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,c)}recursiveResolve(y,c,b,v,p){if(k.isString(b))return this.resolveString(y,c,b,v,p);if(k.isArray(b))return b.map(w=>this.recursiveResolve(y,c,w,v,p));if(k.isObject(b)){let w=Object.create(null);return Object.keys(b).forEach(L=>{const S=this.resolveString(y,c,L,v,p);w[S]=this.recursiveResolve(y,c,b[L],v,p)}),w}return b}resolveString(y,c,b,v,p){return b.replace(P.VARIABLE_REGEXP,(L,S)=>{if(S.includes(P.VARIABLE_LHS))return L;let o=this.evaluateSingleVariable(y,L,S,c,v);return p&&p.set(S,o),o!==L&&k.isString(o)&&o.match(P.VARIABLE_REGEXP)&&(o=this.resolveString(y,c,o,v,p)),o})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,c,b,v,p){let w;const L=b.split(":");L.length>1&&(b=L[0],w=L[1]);const S=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,C.localize)(0,null,c))},o=()=>{const m=S();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,C.localize)(1,null,c,f.basename(m)))},r=()=>{if(w){const m=this._context.getFolderUri(w);if(m)return m;throw new Error((0,C.localize)(2,null,c,w))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,c)):new Error((0,C.localize)(4,null,c))};switch(b){case"env":if(w){if(y){const m=y[T.isWindows?w.toLowerCase():w];if(k.isString(m))return m}return""}throw new Error((0,C.localize)(5,null,c));case"config":if(w){const m=this._context.getConfigurationValue(v,w);if(k.isUndefinedOrNull(m))throw new Error((0,C.localize)(6,null,c,w));if(k.isObject(m))throw new Error((0,C.localize)(7,null,c,w));return m}throw new Error((0,C.localize)(8,null,c));case"command":return this.resolveFromMap(c,w,p,"command");case"input":return this.resolveFromMap(c,w,p,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return v||w?(0,I.normalizeDriveLetter)(this.fsPath(r())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(r()));case"lineNumber":{const m=this._context.getLineNumber();if(m)return m;throw new Error((0,C.localize)(9,null,c))}case"selectedText":{const m=this._context.getSelectedText();if(m)return m;throw new Error((0,C.localize)(10,null,c))}case"file":return S();case"fileWorkspaceFolder":return o();case"relativeFile":return v||w?f.relative(this.fsPath(r()),S()):S();case"relativeFileDirname":{const m=f.dirname(S());if(v||w){const a=f.relative(this.fsPath(r()),m);return a.length===0?".":a}return m}case"fileDirname":return f.dirname(S());case"fileExtname":return f.extname(S());case"fileBasename":return f.basename(S());case"fileBasenameNoExtension":{const m=f.basename(S());return m.slice(0,m.length-f.extname(m).length)}case"fileDirnameBasename":return f.basename(f.dirname(S()));case"execPath":{const m=this._context.getExecPath();return m||c}case"execInstallFolder":{const m=this._context.getAppRoot();return m||c}case"pathSeparator":return f.sep;default:try{const m=w?`${b}:${w}`:b;return this.resolveFromMap(c,m,p,void 0)}catch{return c}}}}resolveFromMap(y,c,b,v){if(c&&b){const p=v===void 0?b[c]:b[v+":"+c];if(typeof p=="string")return p;throw new Error((0,C.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[128],we([0,1,4,207]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var _;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(_=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var I;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function P(v){const p=v;return(0,i.isEditorInput)(p?.editor)&&(0,i.isEditorInput)(p?.replacement)}e.isEditorReplacement=P;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function c(v){const p=v;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=c;function b(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(ve[216],we([0,1,4,128]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(_){const T=_;return typeof _=="number"||(0,i.isEditorGroup)(T)}e.isPreferredGroup=k}),define(ve[17],we([0,1,16,22,99,292,59,25,13,2,41,84,178,117,64,126,89,216,7]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(fe){function ye(Q){const{selectionStartLineNumber:Ie,selectionStartColumn:Oe,positionLineNumber:Ze,positionColumn:je}=Q,ht=new S.Position(Ie-1,Oe-1),Et=new S.Position(Ze-1,je-1);return new S.Selection(ht,Et)}fe.to=ye;function de(Q){const{anchor:Ie,active:Oe}=Q;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}fe.from=de})(o=e.Selection||(e.Selection={}));var r;(function(fe){function ye(Q){if(!Q)return;const{start:Ie,end:Oe}=Q;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}fe.from=ye;function de(Q){if(!Q)return;const{startLineNumber:Ie,startColumn:Oe,endLineNumber:Ze,endColumn:je}=Q;return new S.Range(Ie-1,Oe-1,Ze-1,je-1)}fe.to=de})(r=e.Range||(e.Range={}));var m;(function(fe){function ye(de){switch(de){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 3:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}fe.to=ye})(m=e.TokenType||(e.TokenType={}));var a;(function(fe){function ye(Q){return new S.Position(Q.lineNumber-1,Q.column-1)}fe.to=ye;function de(Q){return{lineNumber:Q.line+1,column:Q.character+1}}fe.from=de})(a=e.Position||(e.Position={}));var E;(function(fe){function ye(Ie,Oe){return(0,f.coalesce)((0,f.asArray)(Ie).map(Ze=>de(Ze,Oe)))}fe.from=ye;function de(Ie,Oe){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:Q(Ie.scheme,Oe),pattern:typeof Ie.pattern=="undefined"?void 0:te.from(Ie.pattern),exclusive:Ie.exclusive}}function Q(Ie,Oe){return Oe&&typeof Ie=="string"?Oe.transformOutgoingScheme(Ie):Ie}})(E=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(fe){function ye(Q){switch(Q){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}fe.from=ye;function de(Q){switch(Q){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}fe.to=de})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(fe){function ye(Q){let Ie;return Q.code&&((0,C.isString)(Q.code)||(0,C.isNumber)(Q.code)?Ie=String(Q.code):Ie={value:String(Q.code.value),target:Q.code.target}),{...r.from(Q.range),message:Q.message,source:Q.source,code:Ie,severity:u.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(s.from),tags:Array.isArray(Q.tags)?(0,f.coalesce)(Q.tags.map(n.from)):void 0}}fe.from=ye;function de(Q){const Ie=new S.Diagnostic(r.to(Q),Q.message,u.to(Q.severity));return Ie.source=Q.source,Ie.code=(0,C.isString)(Q.code)?Q.code:Q.code?.value,Ie.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(s.to),Ie.tags=Q.tags&&(0,f.coalesce)(Q.tags.map(n.to)),Ie}fe.to=de})(t=e.Diagnostic||(e.Diagnostic={}));var s;(function(fe){function ye(Q){return{...r.from(Q.location.range),message:Q.message,resource:Q.location.uri}}fe.from=ye;function de(Q){return new S.DiagnosticRelatedInformation(new S.Location(Q.resource,r.to(Q)),Q.message)}fe.to=de})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var u;(function(fe){function ye(Q){switch(Q){case S.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}fe.from=ye;function de(Q){switch(Q){case b.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}fe.to=de})(u=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(fe){function ye(Q){return typeof Q=="number"&&Q>=S.ViewColumn.One?Q-1:Q===S.ViewColumn.Beside?L.SIDE_GROUP:L.ACTIVE_GROUP}fe.from=ye;function de(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}fe.to=de})(d=e.ViewColumn||(e.ViewColumn={}));function h(fe){return typeof fe.range!="undefined"}function g(fe){return fe.length===0?!0:!!h(fe[0])}e.isDecorationOptionsArr=g;var l;(function(fe){function ye(je){return je.map(fe.from)}fe.fromMany=ye;function de(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function Q(je){let ht;if(de(je)){const{language:mt,value:wt}=je;ht={value:"```"+mt+`
`+wt+"\n```\n"}}else S.MarkdownString.isMarkdownString(je)?ht={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml}:typeof je=="string"?ht={value:je}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const Dt=mt=>{try{let wt=P.URI.parse(mt,!0);wt=wt.with({query:Ie(wt.query,Et)}),Et[mt]=wt}catch{}return""},bt=new _.Renderer;return bt.link=Dt,bt.image=mt=>Dt(k.parseHrefAndDimensions(mt).href),_(ht.value,{renderer:bt}),ht}fe.from=Q;function Ie(je,ht){if(!je)return je;let Et;try{Et=(0,T.parse)(je)}catch{}if(!Et)return je;let Dt=!1;return Et=(0,I.cloneAndChange)(Et,bt=>{if(P.URI.isUri(bt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[mt]=bt,Dt=!0,mt}else return}),Dt?JSON.stringify(Et):je}function Oe(je){const ht=new S.MarkdownString(je.value,je.supportThemeIcons);return ht.isTrusted=je.isTrusted,ht.supportHtml=je.supportHtml,ht}fe.to=Oe;function Ze(je){if(!!je)return typeof je=="string"?je:fe.from(je)}fe.fromStrict=Ze})(l=e.MarkdownString||(e.MarkdownString={}));function D(fe){return g(fe)?fe.map(ye=>({range:r.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?l.fromMany(ye.hoverMessage):ye.hoverMessage?l.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):fe.map(ye=>({range:r.from(ye)}))}e.fromRangeOrRangeWithMessage=D;function A(fe){return typeof fe=="undefined"?fe:typeof fe=="string"?P.URI.file(fe):fe}e.pathOrURIToURI=A;var N;(function(fe){function ye(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?A(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}fe.from=ye})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(fe){function ye(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?A(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?N.from(de.before):void 0,after:de.after?N.from(de.after):void 0}}fe.from=ye})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(fe){function ye(de){if(typeof de=="undefined")return de;switch(de){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}fe.from=ye})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(fe){function ye(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?F.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?B.from(de.light):void 0,dark:de.dark?B.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?A(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?N.from(de.before):void 0,after:de.after?N.from(de.after):void 0}}fe.from=ye})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(fe){function ye(Q){return{text:Q.newText,eol:Q.newEol&&ct.from(Q.newEol),range:r.from(Q.range)}}fe.from=ye;function de(Q){const Ie=new S.TextEdit(r.to(Q.range),Q.text);return Ie.newEol=typeof Q.eol=="undefined"?void 0:ct.to(Q.eol),Ie}fe.to=de})(z=e.TextEdit||(e.TextEdit={}));var W;(function(fe){function ye(Q,Ie,Oe){const Ze={edits:[]};if(Q instanceof S.WorkspaceEdit)for(let je of Q._allEntries())if(je._type===1)Ze.edits.push({_type:1,oldUri:je.from,newUri:je.to,options:je.options,metadata:je.metadata});else if(je._type===2){const ht=Ie?.getDocument(je.uri);Ze.edits.push({_type:2,resource:je.uri,edit:z.from(je.edit),modelVersionId:ht?.version,metadata:je.metadata})}else je._type===3?Ze.edits.push({_type:3,metadata:je.metadata,resource:je.uri,edit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Oe?.getNotebookDocument(je.uri,!0)?.apiNotebook.version}):je._type===5&&Ze.edits.push({_type:3,metadata:je.metadata,resource:je.uri,notebookVersionId:Oe?.getNotebookDocument(je.uri,!0)?.apiNotebook.version,edit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(ze.from)}});return Ze}fe.from=ye;function de(Q){const Ie=new S.WorkspaceEdit;for(const Oe of Q.edits)Oe.edit?Ie.replace(P.URI.revive(Oe.resource),r.to(Oe.edit.range),Oe.edit.text):Ie.renameFile(P.URI.revive(Oe.oldUri),P.URI.revive(Oe.newUri),Oe.options);return Ie}fe.to=de})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var M;(function(fe){const ye=Object.create(null);ye[S.SymbolKind.File]=0,ye[S.SymbolKind.Module]=1,ye[S.SymbolKind.Namespace]=2,ye[S.SymbolKind.Package]=3,ye[S.SymbolKind.Class]=4,ye[S.SymbolKind.Method]=5,ye[S.SymbolKind.Property]=6,ye[S.SymbolKind.Field]=7,ye[S.SymbolKind.Constructor]=8,ye[S.SymbolKind.Enum]=9,ye[S.SymbolKind.Interface]=10,ye[S.SymbolKind.Function]=11,ye[S.SymbolKind.Variable]=12,ye[S.SymbolKind.Constant]=13,ye[S.SymbolKind.String]=14,ye[S.SymbolKind.Number]=15,ye[S.SymbolKind.Boolean]=16,ye[S.SymbolKind.Array]=17,ye[S.SymbolKind.Object]=18,ye[S.SymbolKind.Key]=19,ye[S.SymbolKind.Null]=20,ye[S.SymbolKind.EnumMember]=21,ye[S.SymbolKind.Struct]=22,ye[S.SymbolKind.Event]=23,ye[S.SymbolKind.Operator]=24,ye[S.SymbolKind.TypeParameter]=25;function de(Ie){return typeof ye[Ie]=="number"?ye[Ie]:6}fe.from=de;function Q(Ie){for(const Oe in ye)if(ye[Oe]===Ie)return Number(Oe);return S.SymbolKind.Property}fe.to=Q})(M=e.SymbolKind||(e.SymbolKind={}));var x;(function(fe){function ye(Q){switch(Q){case S.SymbolTag.Deprecated:return 1}}fe.from=ye;function de(Q){switch(Q){case 1:return S.SymbolTag.Deprecated}}fe.to=de})(x=e.SymbolTag||(e.SymbolTag={}));var V;(function(fe){function ye(Q){return{name:Q.name,kind:M.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:K.from(Q.location)}}fe.from=ye;function de(Q){const Ie=new S.SymbolInformation(Q.name,M.to(Q.kind),Q.containerName,K.to(Q.location));return Ie.tags=Q.tags&&Q.tags.map(x.to),Ie}fe.to=de})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(fe){function ye(Q){const Ie={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:r.from(Q.range),selectionRange:r.from(Q.selectionRange),kind:M.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(Ie.children=Q.children.map(ye)),Ie}fe.from=ye;function de(Q){const Ie=new S.DocumentSymbol(Q.name,Q.detail,M.to(Q.kind),r.to(Q.range),r.to(Q.selectionRange));return(0,f.isNonEmptyArray)(Q.tags)&&(Ie.tags=Q.tags.map(x.to)),Q.children&&(Ie.children=Q.children.map(de)),Ie}fe.to=de})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(fe){function ye(Q){const Ie=new S.CallHierarchyItem(M.to(Q.kind),Q.name,Q.detail||"",P.URI.revive(Q.uri),r.to(Q.range),r.to(Q.selectionRange));return Ie._sessionId=Q._sessionId,Ie._itemId=Q._itemId,Ie}fe.to=ye;function de(Q,Ie,Oe){if(Ie=Ie??Q._sessionId,Oe=Oe??Q._itemId,Ie===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Oe,name:Q.name,detail:Q.detail,kind:M.from(Q.kind),uri:Q.uri,range:r.from(Q.range),selectionRange:r.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}fe.from=de})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Y;(function(fe){function ye(de){return new S.CallHierarchyIncomingCall(H.to(de.from),de.fromRanges.map(Q=>r.to(Q)))}fe.to=ye})(Y=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var se;(function(fe){function ye(de){return new S.CallHierarchyOutgoingCall(H.to(de.to),de.fromRanges.map(Q=>r.to(Q)))}fe.to=ye})(se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(fe){function ye(Q){return{range:Q.range&&r.from(Q.range),uri:Q.uri}}fe.from=ye;function de(Q){return new S.Location(P.URI.revive(Q.uri),r.to(Q.range))}fe.to=de})(K=e.location||(e.location={}));var j;(function(fe){function ye(Q){const Ie=Q,Oe=Q;return{originSelectionRange:Ie.originSelectionRange?r.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Oe.uri,range:r.from(Ie.targetRange?Ie.targetRange:Oe.range),targetSelectionRange:Ie.targetSelectionRange?r.from(Ie.targetSelectionRange):void 0}}fe.from=ye;function de(Q){return{targetUri:P.URI.revive(Q.uri),targetRange:r.to(Q.range),targetSelectionRange:Q.targetSelectionRange?r.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?r.to(Q.originSelectionRange):void 0}}fe.to=de})(j=e.DefinitionLink||(e.DefinitionLink={}));var ne;(function(fe){function ye(Q){return{range:r.from(Q.range),contents:l.fromMany(Q.contents)}}fe.from=ye;function de(Q){return new S.Hover(Q.contents.map(l.to),r.to(Q.range))}fe.to=de})(ne=e.Hover||(e.Hover={}));var le;(function(fe){function ye(Q){return{range:r.from(Q.range),expression:Q.expression}}fe.from=ye;function de(Q){return new S.EvaluatableExpression(r.to(Q.range),Q.expression)}fe.to=de})(le=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(fe){function ye(Q){if(Q instanceof S.InlineValueText)return{type:"text",range:r.from(Q.range),text:Q.text};if(Q instanceof S.InlineValueVariableLookup)return{type:"variable",range:r.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}fe.from=ye;function de(Q){switch(Q.type){case"text":return{range:r.to(Q.range),text:Q.text};case"variable":return{range:r.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:r.to(Q.range),expression:Q.expression}}}fe.to=de})(ge=e.InlineValue||(e.InlineValue={}));var ke;(function(fe){function ye(Q){return{frameId:Q.frameId,stoppedLocation:r.from(Q.stoppedLocation)}}fe.from=ye;function de(Q){return new S.InlineValueContext(Q.frameId,r.to(Q.stoppedLocation))}fe.to=de})(ke=e.InlineValueContext||(e.InlineValueContext={}));var Me;(function(fe){function ye(Q){return{range:r.from(Q.range),kind:Q.kind}}fe.from=ye;function de(Q){return new S.DocumentHighlight(r.to(Q.range),Q.kind)}fe.to=de})(Me=e.DocumentHighlight||(e.DocumentHighlight={}));var Ue;(function(fe){function ye(de){switch(de){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}fe.to=ye})(Ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var q;(function(fe){function ye(de){return{triggerKind:Ue.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}fe.to=ye})(q=e.CompletionContext||(e.CompletionContext={}));var J;(function(fe){function ye(Q){switch(Q){case S.CompletionItemTag.Deprecated:return 1}}fe.from=ye;function de(Q){switch(Q){case 1:return S.CompletionItemTag.Deprecated}}fe.to=de})(J=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(fe){const ye=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function de(Oe){return ye.get(Oe)??9}fe.from=de;const Q=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function Ie(Oe){return Q.get(Oe)??S.CompletionItemKind.Property}fe.to=Ie})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var he;(function(fe){function ye(de,Q){const Ie=new S.CompletionItem(de.label);return Ie.insertText=de.insertText,Ie.kind=re.to(de.kind),Ie.tags=de.tags?.map(J.to),Ie.detail=de.detail,Ie.documentation=k.isMarkdownString(de.documentation)?l.to(de.documentation):de.documentation,Ie.sortText=de.sortText,Ie.filterText=de.filterText,Ie.preselect=de.preselect,Ie.commitCharacters=de.commitCharacters,R.Range.isIRange(de.range)?Ie.range=r.to(de.range):typeof de.range=="object"&&(Ie.range={inserting:r.to(de.range.insert),replacing:r.to(de.range.replace)}),Ie.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Ie.insertText=new S.SnippetString(de.insertText):(Ie.insertText=de.insertText,Ie.textEdit=Ie.range instanceof S.Range?new S.TextEdit(Ie.range,Ie.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Ie.additionalTextEdits=de.additionalTextEdits.map(Oe=>z.to(Oe))),Ie.command=Q&&de.command?Q.fromInternal(de.command):void 0,Ie}fe.to=ye})(he=e.CompletionItem||(e.CompletionItem={}));var Z;(function(fe){function ye(Q){return{label:Q.label,documentation:Q.documentation?l.fromStrict(Q.documentation):void 0}}fe.from=ye;function de(Q){return{label:Q.label,documentation:k.isMarkdownString(Q.documentation)?l.to(Q.documentation):Q.documentation}}fe.to=de})(Z=e.ParameterInformation||(e.ParameterInformation={}));var ce;(function(fe){function ye(Q){return{label:Q.label,documentation:Q.documentation?l.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.from):[],activeParameter:Q.activeParameter}}fe.from=ye;function de(Q){return{label:Q.label,documentation:k.isMarkdownString(Q.documentation)?l.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.to):[],activeParameter:Q.activeParameter}}fe.to=de})(ce=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(fe){function ye(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ce.from):[]}}fe.from=ye;function de(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ce.to):[]}}fe.to=de})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Be;(function(fe){function ye(Q){return{text:Q.text,position:a.from(Q.position),kind:qe.from(Q.kind??S.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}fe.from=ye;function de(Q){const Ie=new S.InlayHint(Q.text,a.to(Q.position),qe.to(Q.kind));return Ie.whitespaceAfter=Q.whitespaceAfter,Ie.whitespaceBefore=Q.whitespaceBefore,Ie}fe.to=de})(Be=e.InlayHint||(e.InlayHint={}));var qe;(function(fe){function ye(Q){return Q}fe.from=ye;function de(Q){return Q}fe.to=de})(qe=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(fe){function ye(Q){return{range:r.from(Q.range),url:Q.target,tooltip:Q.tooltip}}fe.from=ye;function de(Q){let Ie;if(Q.url)try{Ie=typeof Q.url=="string"?P.URI.parse(Q.url,!0):P.URI.revive(Q.url)}catch{}return new S.DocumentLink(r.to(Q.range),Ie)}fe.to=de})(Ke=e.DocumentLink||(e.DocumentLink={}));var Je;(function(fe){function ye(Q){const Ie=new S.ColorPresentation(Q.label);return Q.textEdit&&(Ie.textEdit=z.to(Q.textEdit)),Q.additionalTextEdits&&(Ie.additionalTextEdits=Q.additionalTextEdits.map(Oe=>z.to(Oe))),Ie}fe.to=ye;function de(Q){return{label:Q.label,textEdit:Q.textEdit?z.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ie=>z.from(Ie)):void 0}}fe.from=de})(Je=e.ColorPresentation||(e.ColorPresentation={}));var it;(function(fe){function ye(Q){return new S.Color(Q[0],Q[1],Q[2],Q[3])}fe.to=ye;function de(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}fe.from=de})(it=e.Color||(e.Color={}));var at;(function(fe){function ye(Q){return{range:r.from(Q.range)}}fe.from=ye;function de(Q){return new S.SelectionRange(r.to(Q.range))}fe.to=de})(at=e.SelectionRange||(e.SelectionRange={}));var et;(function(fe){function ye(de){switch(de){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}fe.to=ye})(et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(fe){function ye(Q){switch(Q){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}fe.from=ye;function de(Q){switch(Q){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}fe.to=de})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ct;(function(fe){function ye(Q){if(Q===S.EndOfLine.CRLF)return 1;if(Q===S.EndOfLine.LF)return 0}fe.from=ye;function de(Q){if(Q===1)return S.EndOfLine.CRLF;if(Q===0)return S.EndOfLine.LF}fe.to=de})(ct=e.EndOfLine||(e.EndOfLine={}));var vt;(function(fe){function ye(de){if(typeof de=="object")return de.viewId;switch(de){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}fe.from=ye})(vt=e.ProgressLocation||(e.ProgressLocation={}));var We;(function(fe){function ye(de){const Q={start:de.start+1,end:de.end+1};return de.kind&&(Q.kind=At.from(de.kind)),Q}fe.from=ye})(We=e.FoldingRange||(e.FoldingRange={}));var At;(function(fe){function ye(de){if(de)switch(de){case S.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}fe.from=ye})(At=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ee;(function(fe){function ye(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?r.from(de.selection):void 0,override:typeof de.override=="boolean"?c.EditorResolution.DISABLED:void 0}}fe.from=ye})(ee=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var te;(function(fe){function ye(Q){return Q instanceof S.RelativePattern||typeof Q=="string"?Q:de(Q)?new S.RelativePattern(Q.base,Q.pattern):Q}fe.from=ye;function de(Q){const Ie=Q;return Ie&&typeof Ie.base=="string"&&typeof Ie.pattern=="string"}})(te=e.GlobPattern||(e.GlobPattern={}));var Ee;(function(fe){function ye(de){if(de){if(Array.isArray(de))return de.map(ye);if(typeof de=="string")return de;{const Q=de;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:te.from(Q.pattern),exclusive:Q.exclusive}}}else return}fe.from=ye})(Ee=e.LanguageSelector||(e.LanguageSelector={}));var ie;(function(fe){function ye(Q){return{start:Q.start,end:Q.end}}fe.from=ye;function de(Q){return new S.NotebookRange(Q.start,Q.end)}fe.to=de})(ie=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(fe){function ye(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}fe.to=ye;function de(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}fe.from=de})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Fe;(function(fe){function ye(Q){switch(Q){case S.NotebookCellKind.Markup:return p.CellKind.Markup;case S.NotebookCellKind.Code:default:return p.CellKind.Code}}fe.from=ye;function de(Q){switch(Q){case p.CellKind.Markup:return S.NotebookCellKind.Markup;case p.CellKind.Code:default:return S.NotebookCellKind.Code}}fe.to=de})(Fe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ge;(function(fe){function ye(Q){const Ie={metadata:Q.metadata??Object.create(null),cells:[]};for(let Oe of Q.cells)S.NotebookCellData.validate(Oe),Ie.cells.push(ze.from(Oe));return Ie}fe.from=ye;function de(Q){const Ie=new S.NotebookData(Q.cells.map(ze.to));return(0,C.isEmptyObject)(Q.metadata)||(Ie.metadata=Q.metadata),Ie}fe.to=de})(Ge=e.NotebookData||(e.NotebookData={}));var ze;(function(fe){function ye(Q){return{cellKind:Fe.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Ce.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Ae.from):[]}}fe.from=ye;function de(Q){return new S.NotebookCellData(Fe.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Ae.to):void 0,Q.metadata,Q.internalMetadata?Ce.to(Q.internalMetadata):void 0)}fe.to=de})(ze=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(fe){function ye(Q){return{mime:Q.mime,valueBytes:i.VSBuffer.wrap(Q.data)}}fe.from=ye;function de(Q){return new S.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}fe.to=de})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(fe){function ye(Q){return{outputId:Q.id,items:Q.items.map(ut.from),metadata:Q.metadata}}fe.from=ye;function de(Q){const Ie=Q.items.map(ut.to);return new S.NotebookCellOutput(Ie,Q.outputId,Q.metadata)}fe.to=de})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Te;(function(fe){function ye(Oe){if(Oe!=null){if(Oe instanceof S.RelativePattern||typeof Oe=="string")return Oe;if(Ie(Oe))return new S.RelativePattern(Oe.base,Oe.pattern);if(Q(Oe))return{include:te.from(Oe.include)||void 0,exclude:te.from(Oe.exclude)||void 0}}}fe.from=ye;function de(Oe){return typeof Oe=="string"?Oe:Ie(Oe)?{base:Oe.base,pattern:Oe.pattern}:{include:Oe.include,exclude:Oe.exclude}}fe.to=de;function Q(Oe){const Ze=Oe,je=te.from(Ze.include);if(!(je&&je instanceof S.RelativePattern||typeof je=="string"))return!1;const ht=te.from(Ze.exclude);return!!(ht&&ht instanceof S.RelativePattern||typeof ht=="string")}function Ie(Oe){const Ze=Oe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Te=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(fe){function ye(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?N.from(de.top):void 0}}fe.from=ye})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var oe;(function(fe){function ye(de,Q,Ie){const Oe=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===S.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Oe,Ie),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}fe.from=ye})(oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var me;(function(fe){function ye(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{}}}fe.from=ye})(me=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var be;(function(fe){function ye(Q){return{uri:Q.uri,provides:Q.provides}}fe.from=ye;function de(Q){return new S.NotebookRendererScript(P.URI.revive(Q.uri),Q.provides)}fe.to=de})(be=e.NotebookRendererScript||(e.NotebookRendererScript={}));var _e;(function(fe){function ye(Q){return{message:l.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location?K.from(Q.location):void 0}}fe.from=ye;function de(Q){const Ie=new S.TestMessage(typeof Q.message=="string"?Q.message:l.to(Q.message));return Ie.actualOutput=Q.actual,Ie.expectedOutput=Q.expected,Ie.location=Q.location?K.to(Q.location):void 0,Ie}fe.to=de})(_e=e.TestMessage||(e.TestMessage={}));var Ne;(function(fe){let ye;(function(de){de.Delimiter="\0"})(ye||(ye={})),fe.namespace=(de,Q)=>de+"\0"+Q,fe.denamespace=de=>{const Q=de.indexOf("\0");return{ctrlId:de.slice(0,Q),tagId:de.slice(Q+1)}}})(Ne=e.TestTag||(e.TestTag={}));var Qe;(function(fe){function ye(Oe){const Ze=(0,v.getPrivateApiFor)(Oe).controllerId;return{extId:w.TestId.fromExtHostTestItem(Oe,Ze).toString(),label:Oe.label,uri:Oe.uri,tags:Oe.tags.map(je=>Ne.namespace(Ze,je.id)),range:r.from(Oe.range)||null,description:Oe.description||null,error:Oe.error&&l.fromStrict(Oe.error)||null}}fe.from=ye;function de(Oe){return{parent:void 0,error:void 0,id:w.TestId.fromString(Oe.extId).localId,label:Oe.label,uri:P.URI.revive(Oe.uri),tags:(Oe.tags||[]).map(Ze=>{const{tagId:je}=Ne.denamespace(Ze);return new S.TestTag(je)}),range:r.to(Oe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Oe.description||void 0}}fe.toPlain=de;function Q(Oe){const Ze=w.TestId.fromString(Oe.extId),je=new v.TestItemImpl(Ze.controllerId,Ze.localId,Oe.label,P.URI.revive(Oe.uri));return je.range=r.to(Oe.range||void 0),je.description=Oe.description||void 0,je}function Ie(Oe){let Ze;for(const je of Oe.tests){const ht=Q(je.item);(0,v.getPrivateApiFor)(ht).parent=Ze,Ze=ht}return Ze}fe.toItemFromContext=Ie})(Qe=e.TestItem||(e.TestItem={})),function(fe){function ye(Q){return{id:Q.id}}fe.from=ye;function de(Q){return new S.TestTag(Q.id)}fe.to=de}(Ne=e.TestTag||(e.TestTag={}));var $e;(function(fe){const ye=(Q,Ie)=>{const Oe={...Qe.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(je=>je.type===0).map(_e.to)})),children:Q.children.map(Ze=>Ie.get(Ze)).filter(C.isDefined).map(Ze=>ye(Ze,Ie))};for(const Ze of Oe.children)Ze.parent=Oe;return Oe};function de(Q){const Ie=[],Oe=new Map;for(const Ze of Q.items)Oe.set(Ze.item.extId,Ze),Q.request.targets.some(je=>je.controllerId===Ze.controllerId&&je.testIds.includes(Ze.item.extId))&&Ie.push(Ze);return{completedAt:Q.completedAt,results:Ie.map(Ze=>ye(Ze,Oe))}}fe.to=de})($e=e.TestResults||(e.TestResults={}));var Xe;(function(fe){function ye(Oe){return{covered:Oe.covered,total:Oe.covered}}function de(Oe){return"line"in Oe?a.from(Oe):r.from(Oe)}function Q(Oe){return"branches"in Oe?{count:Oe.executionCount,location:de(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&de(Ze.location)})):void 0}:{type:0,count:Oe.executionCount,location:de(Oe.location)}}fe.fromDetailed=Q;function Ie(Oe){return{uri:Oe.uri,statement:ye(Oe.statementCoverage),branch:Oe.branchCoverage&&ye(Oe.branchCoverage),function:Oe.functionCoverage&&ye(Oe.functionCoverage),details:Oe.detailedCoverage?.map(Q)}}fe.fromFile=Ie})(Xe=e.TestCoverage||(e.TestCoverage={}));var st;(function(fe){function ye(de){switch(de){case 1:return S.CodeActionTriggerKind.Invoke;case 2:return S.CodeActionTriggerKind.Automatic}}fe.to=ye})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ot;(function(fe){function ye(Q){const Ie=new S.TypeHierarchyItem(M.to(Q.kind),Q.name,Q.detail||"",P.URI.revive(Q.uri),r.to(Q.range),r.to(Q.selectionRange));return Ie._sessionId=Q._sessionId,Ie._itemId=Q._itemId,Ie}fe.to=ye;function de(Q,Ie,Oe){if(Ie=Ie??Q._sessionId,Oe=Oe??Q._itemId,Ie===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Oe,kind:M.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:r.from(Q.range),selectionRange:r.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}fe.from=de})(ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[217],we([0,1,2,15,7,17,94]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(P,R,y,c={timeout:1500,errors:3}){this._logService=P,this._documents=R,this._mainThreadBulkEdits=y,this._thresholds=c,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(R,y,c)=>{const v={dispose:this._callbacks.push([R,y,P])};return Array.isArray(c)&&c.push(v),v}}async $participateInSave(P,R){const y=f.URI.revive(P);let c=!1;const b=setTimeout(()=>c=!0,this._thresholds.timeout),v=[];try{for(let p of[...this._callbacks]){if(c)break;const w=this._documents.getDocument(y),L=await this._deliverEventAsyncAndBlameBadListeners(p,{document:w,reason:_.TextDocumentSaveReason.to(R)});v.push(L)}}finally{clearTimeout(b)}return v}_deliverEventAsyncAndBlameBadListeners([P,R,y],c){const b=this._badListeners.get(P);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,R,c).then(()=>!0,v=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const p=this._badListeners.get(P);this._badListeners.set(P,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,R,y,c){const b=[],v=Date.now(),{document:p,reason:w}=c,{version:L}=p,S=Object.freeze({document:p,reason:w,waitUntil(o){if(Object.isFrozen(b))throw(0,i.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(o))}});try{R.apply(y,[S])}catch(o){return Promise.reject(o)}return Object.freeze(b),new Promise((o,r)=>{const m=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(m),o(a)}).catch(a=>{clearTimeout(m),r(a)})}).then(o=>{const r={edits:[]};for(const m of o)if(Array.isArray(m)&&m.every(a=>a instanceof k.TextEdit))for(const{newText:a,newEol:E,range:n}of m)r.edits.push({_type:2,resource:p.uri,edit:{range:n&&_.Range.from(n),text:a,eol:E&&_.EndOfLine.from(E)}});if(r.edits.length!==0)return L===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(ve[218],we([0,1,3,32,2,17,7]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(R,y,c,b,v){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter,this._config=0,c&&(this._config+=1),b&&(this._config+=2),v&&(this._config+=4);const p=(0,i.parse)(y),w=R(L=>{if(!c)for(let S of L.created){const o=k.URI.revive(S);p(o.fsPath)&&this._onDidCreate.fire(o)}if(!b)for(let S of L.changed){const o=k.URI.revive(S);p(o.fsPath)&&this._onDidChange.fire(o)}if(!v)for(let S of L.deleted){const o=k.URI.revive(S);p(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(R,y,c){this._logService=y,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,y,c,b){return new I(this._onFileSystemEvent.event,R,y,c,b)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,y){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:y.map(c=>({oldUri:k.URI.revive(c.source),newUri:k.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:y.map(c=>k.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:y.map(c=>k.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,y){return(c,b,v)=>{const p=function(L){c.call(b,L)};return p.extension=R,y.event(p,void 0,v)}}async $onWillRunFileOperation(R,y,c,b){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:y.map(v=>({oldUri:k.URI.revive(v.source),newUri:k.URI.revive(v.target)}))},c,b);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:y.map(v=>k.URI.revive(v.target))},c,b);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:y.map(v=>k.URI.revive(v.target))},c,b)}}async _fireWillEvent(R,y,c,b){const v=new Set,p=[];if(await R.fireAsync(y,b,async(L,S)=>{const o=Date.now(),r=await Promise.resolve(L);r instanceof T.WorkspaceEdit&&(p.push(r),v.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-o>c&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),b.isCancellationRequested||p.length===0)return;const w={edits:[]};for(let L of p){let{edits:S}=_.WorkspaceEdit.from(L,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(S)}return{edit:w,extensionNames:Array.from(v)}}}e.ExtHostFileSystemEventService=C}),define(ve[219],we([0,1,10,25,2,17,126]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(y,c,b,v){this.start=y,this.deletedCount=c,this.deletedItems=b,this.items=v}static asApiEvents(y){return y.map(c=>({start:c.start,deletedCount:c.deletedCount,deletedItems:c.deletedItems,items:c.items.map(b=>b.apiCell)}))}}class C{constructor(y,c,b){this.notebook=y,this._extHostDocument=c,this._cellData=b,this.handle=b.handle,this.uri=k.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(_.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(y,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:_.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return y._mime},set mime(b){y._mime=b},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}})}return this._apiCell}setOutputs(y){this._outputs=y.map(_.NotebookCellOutput.to)}setOutputItems(y,c,b){const v=b.map(_.NotebookCellOutputItem.to),p=this._outputs.find(w=>w.id===y);p&&(c||(p.items.length=0),p.items.push(...v))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=C;class P{constructor(y,c,b,v,p,w){this._proxy=y,this._textDocumentsAndEditors=c,this._textDocuments=b,this._emitter=v,this.uri=p,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this;this._notebook={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===f.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(c){return c=y._validateIndex(c),y._cells[c].apiCell},getCells(c){return(c?y._getCells(c):y._cells).map(v=>v.apiCell)},save(){return y._save()}}}return this._notebook}updateBackup(y){this._backup?.delete(),this._backup=y}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,c){this._versionId=y.versionId,this._isDirty=c;for(const b of y.rawEvents)b.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===T.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(b.index,b.mime):b.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(b.index,b.metadata):b.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(b.index,b.internalMetadata)}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let c=y.start|0,b=y.end|0;return c<0&&(c=0),b>this._cells.length&&(b=this._cells.length),y.with({start:c,end:b})}_getCells(y){y=this._validateRange(y);const c=[];for(let b=y.start;b<y.end;b++)c.push(this._cells[b]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,c){if(this._disposed)return;const b=[],v=[],p=[];y.reverse().forEach(w=>{const S=w[2].map(m=>{const a=new C(this,this._textDocumentsAndEditors,m);return c||v.push(C.asModelAddData(this.apiNotebook,m)),a}),o=new I(w[0],w[1],[],S),r=this._cells.splice(w[0],w[1],...S);for(const m of r)p.push(m.uri),o.deletedItems.push(m.apiCell);b.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:p}),c||this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(b)}))}_moveCell(y,c){const b=this._cells.splice(y,1);this._cells.splice(c,0,...b);const v=[new I(y,1,b.map(p=>p.apiCell),[]),new I(c,0,[],b)];this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(v)}))}_setCellOutputs(y,c){const b=this._cells[y];b.setOutputs(c),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_setCellOutputItems(y,c,b,v){const p=this._cells[y];p.setOutputItems(c,b,v),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(y,c){const b=this._cells[y];b.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelLanguageChanged(b.uri,c)}_changeCellMime(y,c){const b=this._cells[y];b.apiCell.mime=c}_changeCellMetadata(y,c){const b=this._cells[y],v=b.apiCell.metadata;b.setMetadata(c);const p=b.apiCell.metadata;(0,i.equals)(v,p)||this._emitter.emitCellMetadataChange((0,i.deepFreeze)({document:this.apiNotebook,cell:b.apiCell}))}_changeCellInternalMetadata(y,c){this._cells[y].setInternalMetadata(c)}getCellFromApiCell(y){return this._cells.find(c=>c.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(c=>c.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(ve[129],we([0,1,7,17,15]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class _{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:P})}replaceCells(C,P,R){this._throwIfFinalized(),!(C===P&&R.length===0)&&this._collectedEdits.push({editType:1,index:C,count:P-C,cells:R.map(i.NotebookCellData.from)})}}class T{constructor(C,P,R,y,c,b){this.id=C,this._proxy=P,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=y,this._viewColumn=b}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(P){if(!Array.isArray(P)||!P.every(f.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");C._selections=P,C._trySetSelections(P)},get visibleRanges(){return C._visibleRanges},revealRange(P,R){C._proxy.$tryRevealRange(C.id,i.NotebookRange.from(P),R??f.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(P){const R=new _(this.document.version);return P(R),C._applyEdit(R.finalize())},setDecorations(P,R){return C.setDecorations(P,R)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(i.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const P=[];let R=-1;for(let y=0;y<C.cellEdits.length;y++){if(R<0){P.push(C.cellEdits[y]),R++;continue}const b=P[R],v=C.cellEdits[y];if(b.editType===1&&v.editType===1&&b.index===v.index){b.cells.push(...C.cellEdits[y].cells),b.count+=C.cellEdits[y].count;continue}P.push(C.cellEdits[y]),R++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,P)}setDecorations(C,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return P.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(P),C.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(ve[220],we([0,1,17,118,165,21,57,15]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,b,v){const p=this._handles++,{title:w,location:L,cancellable:S}=b,o={label:(0,k.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(p,{location:f.ProgressLocation.from(L),title:w,source:o,cancellable:S},c).catch(I.onUnexpectedExternalError),this._withProgress(p,v,!!S)}_withProgress(c,b,v){let p;v&&(p=new _.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,p));const w=S=>{this._proxy.$progressEnd(S),this._mapHandleToCancellationSource.delete(S),p&&p.dispose()};let L;try{L=b(new R(this._proxy,c),v&&p?p.token:_.CancellationToken.None)}catch(S){throw w(c),S}return L.then(S=>w(c),S=>w(c)),L}$acceptProgressCanceled(c){const b=this._mapHandleToCancellationSource.get(c);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=C;function P(y,c){return y.message=c.message,typeof c.increment=="number"&&(typeof y.increment=="number"?y.increment+=c.increment:y.increment=c.increment),y}class R extends i.Progress{constructor(c,b){super(v=>this.throttledReport(v));this._proxy=c,this._handle=b}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}Ve([(0,T.throttle)(100,(y,c)=>P(y,c),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(ve[130],we([0,1,56,15,77,17,7]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(c,b,v){const p=I._Keys.nextId();c.$registerTextEditorDecorationType(b.identifier,p,_.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:p,dispose(){c.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=I,I._Keys=new k.IdGenerator("TextEditorDecorationType");class C{constructor(c,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,b){this._throwIfFinalized();let v=null;if(c instanceof T.Position)v=new T.Range(c,c);else if(c instanceof T.Range)v=c;else throw new Error("Unrecognized location");this._pushEdit(v,b,!1)}insert(c,b){this._throwIfFinalized(),this._pushEdit(new T.Range(c,c),b,!0)}delete(c){this._throwIfFinalized();let b=null;if(c instanceof T.Range)b=c;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(c,b,v){const p=this._document.validateRange(c);this._collectedEdits.push({range:p,text:b,forceMoveMarkers:v})}setEndOfLine(c){if(this._throwIfFinalized(),c!==T.EndOfLine.LF&&c!==T.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=C;class P{constructor(c,b,v,p){this._proxy=c,this._id=b,this._accept(v),this._logService=p;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(L){w._setTabSize(L)},get insertSpaces(){return w._insertSpaces},set insertSpaces(L){w._setInsertSpaces(L)},get cursorStyle(){return w._cursorStyle},set cursorStyle(L){w._setCursorStyle(L)},get lineNumbers(){return w._lineNumbers},set lineNumbers(L){w._setLineNumbers(L)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=_.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const b=Math.floor(c);return b>0?b:null}if(typeof c=="string"){const b=parseInt(c,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(c){const b=this._validateTabSize(c);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const b=this._validateInsertSpaces(c);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:_.TextEditorLineNumbersStyle.from(c)})))}assign(c){const b={};let v=!1;if(typeof c.tabSize!="undefined"){const p=this._validateTabSize(c.tabSize);p==="auto"?(v=!0,b.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,v=!0,b.tabSize=p)}if(typeof c.insertSpaces!="undefined"){const p=this._validateInsertSpaces(c.insertSpaces);p==="auto"?(v=!0,b.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,v=!0,b.insertSpaces=p)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,v=!0,b.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,v=!0,b.lineNumbers=_.TextEditorLineNumbersStyle.from(c.lineNumbers)),v&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(c,b){b.catch(v=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(v)})}}e.ExtHostTextEditorOptions=P;class R{constructor(c,b,v,p,w,L,S,o){this.id=c,this._proxy=b,this._logService=v,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new P(this._proxy,this.id,L,v),this._visibleRanges=S,this._viewColumn=o;const r=this;this.value=Object.freeze({get document(){return p.getValue()},set document(m){throw(0,i.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(m){if(!(m instanceof T.Selection))throw(0,i.illegalArgument)("selection");r._selections=[m],r._trySetSelection()},get selections(){return r._selections},set selections(m){if(!Array.isArray(m)||m.some(a=>!(a instanceof T.Selection)))throw(0,i.illegalArgument)("selections");r._selections=m,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(m){throw(0,i.readonly)("visibleRanges")},get options(){return r._options.value},set options(m){r._disposed||r._options.assign(m)},get viewColumn(){return r._viewColumn},set viewColumn(m){throw(0,i.readonly)("viewColumn")},edit(m,a={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const E=new C(p.getValue(),a);return m(E),r._applyEdit(E)},insertSnippet(m,a,E={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!a||Array.isArray(a)&&a.length===0)n=r._selections.map(t=>_.Range.from(t));else if(a instanceof T.Position){const{lineNumber:t,column:s}=_.Position.from(a);n=[{startLineNumber:t,startColumn:s,endLineNumber:t,endColumn:s}]}else if(a instanceof T.Range)n=[_.Range.from(a)];else{n=[];for(const t of a)if(t instanceof T.Range)n.push(_.Range.from(t));else{const{lineNumber:s,column:u}=_.Position.from(t);n.push({startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u})}}return b.$tryInsertSnippet(c,m.value,n,E)},setDecorations(m,a){const E=a.length===0;E&&!r._hasDecorationsForKey.has(m.key)||(E?r._hasDecorationsForKey.delete(m.key):r._hasDecorationsForKey.add(m.key),r._runOnProxy(()=>{if(_.isDecorationOptionsArr(a))return b.$trySetDecorations(c,m.key,_.fromRangeOrRangeWithMessage(a));{const n=new Array(4*a.length);for(let t=0,s=a.length;t<s;t++){const u=a[t];n[4*t]=u.start.line+1,n[4*t+1]=u.start.character+1,n[4*t+2]=u.end.line+1,n[4*t+3]=u.end.character+1}return b.$trySetDecorationsFast(c,m.key,n)}}))},revealRange(m,a){r._runOnProxy(()=>b.$tryRevealRange(c,_.Range.from(m),a||T.TextEditorRevealType.Default))},show(m){b.$tryShowEditor(c,_.ViewColumn.from(m))},hide(){b.$tryHideEditor(c)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,f.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,f.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,f.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,f.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(_.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const b=c.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const v=b.edits.map(w=>w.range);v.sort((w,L)=>w.end.line===L.end.line?w.end.character===L.end.character?w.start.line===L.start.line?w.start.character-L.start.character:w.start.line-L.start.line:w.end.character-L.end.character:w.end.line-L.end.line);for(let w=0,L=v.length-1;w<L;w++){const S=v[w].end;if(v[w+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=b.edits.map(w=>({range:_.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,p,{setEndOfLine:typeof b.setEndOfLine=="number"?_.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=R}),define(ve[221],we([0,1,18,3,6,13,64,17,127,89]),function(X,e,f,i,k,_,T,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends k.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const b of this.tree.values())this.updateExpandability(b)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const b=this.diff[this.diff.length-1];if(b&&c[0]===1){if(b[0]===1&&b[1].extId===c[1].extId){(0,C.applyTestItemUpdate)(b[1],c[1]);return}if(b[0]===0&&b[1].item.extId===c[1].extId){(0,C.applyTestItemUpdate)(b[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,b){const v=this.tree.get(c);if(!!v){if((v.expandLevels===void 0||b>v.expandLevels)&&(v.expandLevels=b),v.expand===1){const p=this.resolveChildren(v);return p.isOpen()?this.expandChildren(v,b-1):p.wait().then(()=>this.expandChildren(v,b-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.expandChildren(v,b-1)):this.expandChildren(v,b-1)}}dispose(){for(const c of this.tree.values())(0,T.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,b){switch(b.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(c.fullId,b.id));break;case 0:this.upsertItem(b.item,c);break;case 4:for(const v of b.ops)this.onTestItemEvent(c,v);break;case 3:{const{key:v,value:p,previous:w}=b,L=c.fullId.toString();switch(v){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(p,w,L);break;case"range":this.pushDiff([1,{extId:L,item:{range:I.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:L,item:{error:I.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:L,item:{[v]:p??null}}]);break}break}default:(0,_.assertNever)(b)}}upsertItem(c,b){if(!(c instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const v=P.TestId.fromExtHostTestItem(c,this.root.id,b?.actual),p=(0,T.getPrivateApiFor)(c);p.parent&&p.parent!==b?.actual&&p.parent.children.delete(c.id);let w=this.tree.get(v.toString());if(!w){w={fullId:v,actual:c,parent:b?v.parentId:null,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(c,b),this.pushDiff([0,{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:I.TestItem.from(c)}]),this.connectItemAndChildren(c,w,b);return}if(w.actual===c){this.connectItem(c,w,b);return}const L=w.actual.children,S=w.actual,o=(0,T.diffTestItems)(S,c);(0,T.getPrivateApiFor)(S).listener=void 0,w.actual=c,w.expand=0;for(const[r,m]of o)this.onTestItemEvent(w,{op:3,key:r,value:m,previous:S[r]});this.connectItemAndChildren(c,w,b);for(const r of L)c.children.get(r.id)||this.removeItem(P.TestId.joinToString(v,r.id))}diffTagRefs(c,b,v){const p=new Set(b.map(w=>w.id));for(const w of c)p.delete(w.id)||this.incrementTagRefs(w);this.pushDiff([1,{extId:v,item:{tags:c.map(w=>I.TestTag.namespace(this.controllerId,w.id))}}]),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const b=this.tags.get(c.id);b?b.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const b=this.tags.get(c);b&&!--b.refCount&&(this.tags.delete(c),this.pushDiff([6,I.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,b){(0,T.getPrivateApiFor)(c).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(c,b,v){this.setItemParent(c,v);const p=(0,T.getPrivateApiFor)(c);p.parent=v?.actual,p.listener=w=>this.onTestItemEvent(b,w),this.updateExpandability(b)}connectItemAndChildren(c,b,v){this.connectItem(c,b,v);for(const p of c.children)this.upsertItem(p,b)}updateExpandability(c){let b;this._resolveHandler?c.resolveBarrier?b=c.resolveBarrier.isOpen()?3:2:b=c.actual.canResolveChildren?1:0:b=0,b!==c.expand&&(c.expand=b,this.pushDiff([1,{extId:c.fullId.toString(),expand:b}]),b===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,b){if(b<0)return;const v=[];for(const p of c.actual.children){const w=this.expand(P.TestId.joinToString(c.fullId,p.id),b);(0,f.isThenable)(w)&&v.push(w)}if(v.length)return Promise.all(v).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const w=new f.Barrier;return w.open(),w}c.expand=2,this.pushExpandStateUpdate(c);const b=c.resolveBarrier=new f.Barrier,v=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=w.stack||w.message||String(w))};let p;try{p=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(w){v(w)}return(0,f.isThenable)(p)?p.catch(v).then(()=>{b.open(),this.updateExpandability(c)}):(b.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const b=this.tree.get(c);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const v=[b];for(;v.length;){const p=v.pop();if(!!p){(0,T.getPrivateApiFor)(p.actual).listener=void 0;for(const w of p.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(p.fullId.toString());for(const w of p.actual.children)v.push(this.tree.get(P.TestId.joinToString(p.fullId,w.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=R}),define(ve[222],we([0,1,4,183]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(i.IEnvironmentService)}),define(ve[223],we([0,1,27,3,8]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class _{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=_;class T{constructor(R){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let y of R.activationEvents)y==="onUri"&&(y=`onUri:${f.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(R)}}keepOnly(R){const y=new Set;R.forEach(c=>y.add(f.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>y.has(f.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,y){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const c=T._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(c.map(b=>b.identifier)),y.length>0){const b=new Set;y.forEach(v=>b.add(f.ExtensionIdentifier.toKey(v))),this._extensionDescriptions=this._extensionDescriptions.filter(v=>!b.has(f.ExtensionIdentifier.toKey(v.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new _(c)}static _findLoopingExtensions(R){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,L){this.addNode(w),this.addNode(L),this._arcs.has(w)?this._arcs.get(w).push(L):this._arcs.set(w,[L])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,L){const S=y.getArcs(w);for(let o=0;o<S.length;o++)if(!L.has(S[o]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let w of R){const L=f.ExtensionIdentifier.toKey(w.identifier);if(c.set(L,w),w.extensionDependencies)for(let S of w.extensionDependencies){const o=f.ExtensionIdentifier.toKey(S);y.addArc(L,o)}}let b=new Set;y.getNodes().filter(w=>y.getArcs(w).length===0).forEach(w=>b.add(w));let v=y.getNodes().filter(w=>!b.has(w)),p;do{p=!1;for(let w=0;w<v.length;w++){const L=v[w];y.hasOnlyGoodArcs(L,b)&&(v.splice(w,1),w--,b.add(L),p=!0)}}while(p);return v.map(w=>c.get(w))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const y=this._activationMap.get(R);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const y=this._extensionsMap.get(f.ExtensionIdentifier.toKey(R));return y||void 0}}e.ExtensionDescriptionRegistry=T;var I;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(I||(I={}));function C(P,R){const y=P.isBuiltin?0:P.isUnderDevelopment?2:1,c=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(y!==c)return y-c;const b=k.posix.basename(P.extensionLocation.path),v=k.posix.basename(R.extensionLocation.path);return b<v?-1:b>v?1:0}}),define(ve[224],we([0,1,22]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var i;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(i=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function _(I){const C=f.VSBuffer.alloc(1);switch(I){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=_;function T(I,C){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=T}),define(ve[30],we([0,1,3,2,4,27,194]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new _.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var I;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class P{constructor(m){this.dependency=m}}e.MissingExtensionDependency=P;var R;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=y;function c(r,m){return r.enabledApiProposals?r.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=c;function b(r,m){if(!c(r,m))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=b;class v{constructor(m,a,E,n){this.codeLoadingTime=m,this.activateCallTime=a,this.activateResolvedTime=E,this.activationReason=n}}e.ActivationTimes=v;class p{constructor(m,a){this.description=m,this.value=a}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var w;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(w=e.ActivationKind||(e.ActivationKind={}));function L(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=L;function S(r,m){return{identifier:new _.ExtensionIdentifier(r.identifier.id),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!m,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=S;class o{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(m){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(m,a){return Promise.resolve()}_onWillActivateExtension(m){}_onDidActivateExtension(m,a,E,n,t){}_onDidActivateExtensionError(m,a){}_onExtensionRuntimeError(m,a){}_onExtensionHostExit(m){}}e.NullExtensionService=o}),define(ve[225],we([0,1,15,27,30,11]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class I{constructor(p,w,L,S){this.startup=p,this.codeLoadingTime=w,this.activateCallTime=L,this.activateResolvedTime=S}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class C{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,w){return p===-1||w===-1?-1:w-p}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class P{constructor(p,w,L,S,o,r){this.activationFailed=p,this.activationFailedError=w,this.activationTimes=L,this.module=S,this.exports=o,this.subscriptions=r}}e.ActivatedExtension=P;class R extends P{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class y extends P{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class c extends P{constructor(p){super(!0,p,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=c;let b=class{constructor(p,w,L,S,o){this._logService=o,this._isDisposed=!1,this._registry=p,this._resolvedExtensionsSet=new Set,w.forEach(r=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(r))),this._hostExtensionsMap=new Map,L.forEach(r=>this._hostExtensionsMap.set(i.ExtensionIdentifier.toKey(r),r)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(p){const w=i.ExtensionIdentifier.toKey(p);return this._activatedExtensions.has(w)}getActivatedExtension(p){const w=i.ExtensionIdentifier.toKey(p),L=this._activatedExtensions.get(w);if(!L)throw new Error("Extension `"+p.value+"` is not known or not activated");return L}activateByEvent(p,w){if(this._alreadyActivatedEvents[p])return T;const L=this._registry.getExtensionDescriptionsForActivationEvent(p);return this._activateExtensions(L.map(S=>({id:S.identifier,reason:{startup:w,extensionId:S.identifier,activationEvent:p}}))).then(()=>{this._alreadyActivatedEvents[p]=!0})}activateById(p,w){const L=this._registry.getExtensionDescription(p);if(!L)throw new Error("Extension `"+p+"` is not known");return this._activateExtensions([{id:L.identifier,reason:w}])}_handleActivateRequest(p,w,L){if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(p.id))){w[i.ExtensionIdentifier.toKey(p.id)]=p;return}const S=this._registry.getExtensionDescription(p.id);if(!S){const m=new Error(`Cannot activate unknown extension '${p.id.value}'`);this._host.onExtensionActivationError(p.id,m,new k.MissingExtensionDependency(p.id.value)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(p.id),new c(m));return}const o=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let r=!0;for(let m=0,a=o.length;m<a;m++){const E=o[m];if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(E)))continue;const n=this._activatedExtensions.get(i.ExtensionIdentifier.toKey(E));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const d=S.displayName||S.identifier.value,h=this._registry.getExtensionDescription(E),g=h&&h.displayName||E,l=new Error(`Cannot activate the '${d}' extension because its dependency '${g}' failed to activate`);l.detail=n.activationFailedError,this._host.onExtensionActivationError(S.identifier,l,null),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(S.identifier),new c(l));return}if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(E))){r=!1,w[i.ExtensionIdentifier.toKey(E)]={id:this._hostExtensionsMap.get(i.ExtensionIdentifier.toKey(E)),reason:p.reason};continue}const t=this._registry.getExtensionDescription(E);if(t){if(!t.main&&!t.browser)continue;r=!1,w[i.ExtensionIdentifier.toKey(E)]={id:t.identifier,reason:p.reason};continue}const s=S.displayName||S.identifier.value,u=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${E}'`);this._host.onExtensionActivationError(S.identifier,u,new k.MissingExtensionDependency(E)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(S.identifier),new c(u));return}r?w[i.ExtensionIdentifier.toKey(S.identifier)]=p:L.push(p)}_activateExtensions(p){if(p.length===0||(p=p.filter(o=>!this._activatedExtensions.has(i.ExtensionIdentifier.toKey(o.id))),p.length===0))return Promise.resolve(void 0);const w=Object.create(null),L=[];for(let o=0,r=p.length;o<r;o++)this._handleActivateRequest(p[o],w,L);for(let o=0,r=L.length;o<r;o++){const m=i.ExtensionIdentifier.toKey(L[o].id);w[m]&&delete w[m]}const S=Object.keys(w).map(o=>w[o]);return L.length===0?Promise.all(S.map(o=>this._activateExtension(o.id,o.reason))).then(o=>{}):this._activateExtensions(S).then(o=>this._activateExtensions(L))}_activateExtension(p,w){const L=i.ExtensionIdentifier.toKey(p);if(this._activatedExtensions.has(L))return Promise.resolve(void 0);const S=this._activatingExtensions.get(L);if(S)return S;const o=this._host.actualActivateExtension(p,w).then(void 0,r=>{const m=new Error;return r&&r.name&&(m.name=r.name),r&&r.message?m.message=`Activating extension '${p.value}' failed: ${r.message}.`:m.message=`Activating extension '${p.value}' failed: ${r}.`,r&&r.stack&&(m.stack=r.stack),this._isDisposed&&f.isPromiseCanceledError(r)?new c(r):(this._host.onExtensionActivationError(p,m,null),this._logService.error(`Activating extension ${p.value} failed due to an error:`),this._logService.error(r),new c(r))}).then(r=>{this._activatedExtensions.set(L,r),this._activatingExtensions.delete(L)});return this._activatingExtensions.set(L,o),o}};b=Ve([He(4,_.ILogService)],b),e.ExtensionsActivator=b}),define(ve[226],we([0,1,11,26,30]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let _=class extends f.LogService{constructor(I,C){super(I.createLogger(C.logFile,{name:k.ExtensionHostLogFileName}))}};_=Ve([He(0,f.ILoggerService),He(1,i.IExtHostInitDataService)],_),e.ExtHostLogService=_}),define(ve[227],we([0,1,15]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,T)=>{this._actualOk=_,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,f.onUnexpectedError)(_))}then(_,T){return this._ensureActual().then(_,T)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=i}),define(ve[53],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(P,R){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=R,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const i=[];function k(C){const P=new f(!0,C);return i[P.nid]=P,P}e.createMainContextProxyIdentifier=k;function _(C){const P=new f(!1,C);return i[P.nid]=P,P}e.createExtHostContextProxyIdentifier=_;function T(C){return i[C].sid}e.getStringIdentifierForProxy=T;class I{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=I}),define(ve[5],we([0,1,59,2,53]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var _;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(_=e.UIKind||(e.UIKind={}));var T;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(o){o.name="$ident";function r(a,E){return Object.defineProperty(a,o.name,{value:E,enumerable:!0}),a}o.mixin=r;function m(a){return a[o.name]}o.of=m})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class b{static mixin(r){return r._id=b._n++,r}}e.IdObject=b,b._n=0;var v;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function L(o){if(o&&o.edits)for(const r of o.edits)typeof r.resource=="object"?r.resource=i.URI.revive(r.resource):(r.newUri=i.URI.revive(r.newUri),r.oldUri=i.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,f.revive)(r.metadata));return o}e.reviveWorkspaceEditDto=L;var S;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,k.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[90],we([0,1,5,3,4]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class _{constructor(I){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,C){return this._proxy.$getPassword(I,C)}store(I,C,P){return this._proxy.$setPassword(I,C,P)}delete(I,C){return this._proxy.$deletePassword(I,C)}}e.ExtHostSecretState=_,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(ve[66],we([0,1,4,11,5,14]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(C,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(k.MainContext.MainThreadTelemetry)}report(C,P,R){const y=this.getUsageKey(C,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:C}))}getUsageKey(C,P){return`${C}-${P.identifier.value}`}};T=Ve([He(0,_.IExtHostRpcService),He(1,i.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(I,C,P){}})}),define(ve[228],we([0,1,3,5,7,27]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,P,R,y={}){const c=_.ExtensionIdentifier.toKey(C.identifier),b=this._inFlightRequests.get(c)||[],v=[...R].sort().join(" ");let p=b.find(w=>w.scopes===v);if(p)return p.result;{const w=this._getSession(C,c,P,R,y);p={scopes:v,result:w},b.push(p),this._inFlightRequests.set(c,b);try{await w}finally{const L=b.findIndex(S=>S.scopes===v);L>-1&&(b.splice(L),this._inFlightRequests.set(c,b))}return w}}async _getSession(C,P,R,y,c={}){await this._proxy.$ensureProvider(R);const b=C.displayName||C.name;return this._proxy.$getSession(R,y,P,b,c)}async removeSession(C,P){const R=this._authenticationProviders.get(C);return R?R.provider.removeSession(P):this._proxy.$removeSession(C,P)}registerAuthenticationProvider(C,P,R,y){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:P,provider:R,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===C)||this._providers.push({id:C,label:P});const c=R.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(C,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,P,y?.supportsMultipleAccounts??!1),new k.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(C);const b=this._providers.findIndex(v=>v.id===C);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,P){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,P){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,P){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,P){return this._onDidChangeSessions.fire({provider:{id:C,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(ve[229],we([0,1,5,14,17]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(I,C){this._extHostDocumentsAndEditors=C,this._proxy=I.getProxy(f.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const C=k.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};_=Ve([He(0,i.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(ve[230],we([0,1,5]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(_){const T=_.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(I){return T.$writeText(I)}})}}e.ExtHostClipboard=i});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[38],we([0,1,13,7,17,25,5,16,11,59,41,49,2,6,4,14,64,22,53,50]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let m=class{constructor(u,d){r.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,tt(this,r,u.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=d,this.converter=new a(this,h=>{const g=this._apiCommands.get(h);return g?.result===n.Void?g:void 0},d),this._argumentProcessors=[{processArgument(h){return(0,P.revive)(h)}},{processArgument(h){return(0,_.cloneAndChange)(h,function(g){if(R.Range.isIRange(g))return k.Range.to(g);if(y.Position.isIPosition(g))return k.Position.to(g);if(R.Range.isIRange(g.range)&&c.URI.isUri(g.uri))return k.location.to(g);if(g instanceof L.VSBuffer)return g.buffer.buffer;if(!Array.isArray(g))return g})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const d=this.registerCommand(!1,u.id,async(...h)=>{const g=u.args.map((D,A)=>{if(!D.validate(h[A]))throw new Error(`Invalid argument '${D.name}' when running '${u.id}', received: ${h[A]}`);return D.convert(h[A])}),l=await this.executeCommand(u.internalId,...g);return u.result.convert(l,h,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new i.Disposable(()=>{d.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,d,h,g,l,D){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:h,thisArg:g,description:l,extension:D}),u&&Le(this,r,"f").$registerCommand(d),new i.Disposable(()=>{this._commands.delete(d)&&u&&Le(this,r,"f").$unregisterCommand(d)})}executeCommand(u,...d){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,d,!0)}async _doExecuteCommand(u,d,h){if(this._commands.has(u))return this._executeContributedCommand(u,d,!1);{let g=!1;const l=(0,_.cloneAndChange)(d,function(D){if(D instanceof i.Position)return k.Position.from(D);if(D instanceof i.Range)return k.Range.from(D);if(D instanceof i.Location)return k.location.from(D);if(i.NotebookRange.isNotebookRange(D))return k.NotebookRange.from(D);if(D instanceof ArrayBuffer)return g=!0,L.VSBuffer.wrap(new Uint8Array(D));if(D instanceof Uint8Array)return g=!0,L.VSBuffer.wrap(D);if(!Array.isArray(D))return D});try{const D=await Le(this,r,"f").$executeCommand(u,g?new S.SerializableObjectWithBuffers(l):l,h);return(0,P.revive)(D)}catch(D){if(D instanceof Error&&D.message==="$executeCommand:retry")return this._doExecuteCommand(u,d,!1);throw D}}}async _executeContributedCommand(u,d,h){const g=this._commands.get(u);if(!g)throw new Error("Unknown command");let{callback:l,thisArg:D,description:A}=g;if(A)for(let N=0;N<A.args.length;N++)try{(0,f.validateConstraint)(d[N],A.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${A.args[N].name}' - ${A.args[N].description}`)}try{return await l.apply(D,d)}catch(N){if(u===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...d);B&&(u=B.command)}throw this._logService.error(N,u,g.extension?.identifier),h?new class extends Error{constructor(){super((0,o.toErrorMessage)(N));this.id=u,this.source=g.extension?.displayName??g.extension?.name}}:N}}$executeContributedCommand(u,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(d=d.map(h=>this._argumentProcessors.reduce((g,l)=>l.processArgument(g),h)),this._executeContributedCommand(u,d,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),Le(this,r,"f").$getCommands().then(d=>(u&&(d=d.filter(h=>h[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[d,h]of this._commands){let{description:g}=h;g&&(u[d]=g)}return Promise.resolve(u)}};r=new WeakMap,m=Ve([He(0,p.IExtHostRpcService),He(1,C.ILogService)],m),e.ExtHostCommands=m,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class a{constructor(u,d,h){this._commands=u,this._lookupApiCommand=d,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,d){if(!u)return;const h={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return h;const g=this._lookupApiCommand(u.command);if(g)h.id=g.internalId,h.arguments=g.args.map((l,D)=>l.convert(u.arguments&&u.arguments[D]));else if((0,I.isNonEmptyArray)(u.arguments)){const l=++this._cachIdPool;this._cache.set(l,u),d.add((0,b.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),h.$ident=l,h.id=this.delegatingCommandId,h.arguments=[l],this._logService.trace("CommandsConverter#CREATE",u.command,l)}return h}fromInternal(u){const d=T.ObjectIdentifier.of(u);return typeof d=="number"?this._cache.get(d):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const d=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class E{constructor(u,d,h,g){this.name=u,this.description=d,this.validate=h,this.convert=g}optional(){return new E(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,d){return new E(u??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",s=>c.URI.isUri(s),s=>s),E.Position=new E("position","A position in a text document",s=>i.Position.isPosition(s),k.Position.from),E.Range=new E("range","A range in a text document",s=>i.Range.isRange(s),k.Range.from),E.Selection=new E("selection","A selection in a text document",s=>i.Selection.isSelection(s),k.Selection.from),E.Number=new E("number","",s=>typeof s=="number",s=>s),E.String=new E("string","",s=>typeof s=="string",s=>s),E.CallHierarchyItem=new E("item","A call hierarchy item",s=>s instanceof i.CallHierarchyItem,k.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",s=>s instanceof i.TypeHierarchyItem,k.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",s=>s instanceof w.TestItemImpl,k.TestItem.from);class n{constructor(u,d){this.description=u,this.convert=d}}e.ApiCommandResult=n,n.Void=new n("no result",s=>s);class t{constructor(u,d,h,g,l){this.id=u,this.internalId=d,this.description=h,this.args=g,this.result=l}}e.ApiCommand=t}),define(ve[231],we([0,1,17,7,84,38,16,111]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(f.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,b)=>{if((0,T.isFalsyOrEmpty)(c))return;class v extends i.SymbolInformation{static to(w){const L=new v(w.name,f.SymbolKind.to(w.kind),w.containerName||"",new i.Location(b[0],f.Range.to(w.range)));return L.detail=w.detail,L.range=L.location.range,L.selectionRange=f.Range.to(w.selectionRange),L.children=w.children?w.children.map(v.to):[],L}}return c.map(v.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(f.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(f.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(f.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(f.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(f.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(b=>i.Position.isPosition(b)),c=>c.map(f.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(b=>{let v;for(const p of b.reverse())v=new i.SelectionRange(f.Range.to(p),v);return v}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(f.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(f.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(f.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(f.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:f.Range.to(c.range),placeholder:c.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return f.WorkspaceEdit.to(c)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(f.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new i.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const b=(0,I.decodeSemanticTokensDto)(c);if(b.type==="full")return new i.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new i.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const b=(0,I.decodeSemanticTokensDto)(c);if(b.type==="full")return new i.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,b,v)=>{if(!c)return new i.CompletionList([]);const p=c.suggestions.map(w=>f.CompletionItem.to(w,v));return new i.CompletionList(p,c.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return f.SignatureHelp.to(c)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,b,v)=>R(p=>new i.CodeLens(f.Range.to(p.range),p.command&&v.fromInternal(p.command)))(c))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>i.Range.isRange(c),c=>i.Selection.isSelection(c)?f.Selection.from(c):f.Range.from(c)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,b,v)=>R(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return v.fromInternal(p.command)}else{const w=new i.CodeAction(p.title,p.kind?new i.CodeActionKind(p.kind):void 0);return p.edit&&(w.edit=f.WorkspaceEdit.to(p.edit)),p.command&&(w.command=v.fromInternal(p.command)),w.isPreferred=p.isPreferred,w}})(c))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(b=>new i.ColorInformation(f.Range.to(b.range),f.Color.to(b.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",c=>c instanceof i.Color,f.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:f.Range.from(c.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(f.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(f.InlayHint.to))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(b=>f.NotebookExclusiveDocumentPattern.to(b))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(f.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[f.ViewColumn.from(c),void 0]:[f.ViewColumn.from(c.viewColumn),f.TextEditorOpenOptions.from(c)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[f.ViewColumn.from(c),void 0]:[f.ViewColumn.from(c.viewColumn),f.TextEditorOpenOptions.from(c)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[f.ViewColumn.from(c.viewColumn),f.TextEditorOpenOptions.from(c)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(f.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(f.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(f.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void)];class P{static register(b){C.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=P;function R(c){return b=>{if(Array.isArray(b))return b.map(c)}}function y(c){if(!Array.isArray(c))return;const b=[];for(const v of c)k.isLocationLink(v)?b.push(f.DefinitionLink.to(v)):b.push(f.location.to(v));return b}}),define(ve[232],we([0,1,18,57,3,6,2,84,27,17,7,5]),function(X,e,f,i,k,_,T,I,C,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(b,v,p){const w=b.getProxy(y.MainContext.MainThreadComments);class L{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,v.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const s=this._commentControllers.get(t.handle);return s||t}else if(t&&t.$mid===7){const s=this._commentControllers.get(t.commentControlHandle);if(!s)return t;const u=s.getCommentThread(t.commentThreadHandle);return u||t}else if(t&&t.$mid===8){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const u=s.getCommentThread(t.thread.commentThreadHandle);return u?{thread:u,text:t.text}:t}else if(t&&t.$mid===9){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const u=s.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let d=t.commentUniqueId,h=u.getCommentByUniqueId(d);return h||t}else if(t&&t.$mid===10){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const u=s.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let d=t.text,h=t.commentUniqueId,g=u.getCommentByUniqueId(h);return g?(g.body=d,g):t}return t}})}createCommentController(t,s,u){const d=L.handlePool++,h=new o(t,d,s,u);this._commentControllers.set(h.handle,h);const g=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(t.identifier))||[];return g.push(h),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(t.identifier),g),h.value}$createCommentThreadTemplate(t,s,u){const d=this._commentControllers.get(t);!d||d.$createCommentThreadTemplate(s,u)}async $updateCommentThreadTemplate(t,s,u){const d=this._commentControllers.get(t);!d||d.$updateCommentThreadTemplate(s,u)}$deleteCommentThread(t,s){const u=this._commentControllers.get(t);u&&u.$deleteCommentThread(s)}$provideCommentingRanges(t,s,u){const d=this._commentControllers.get(t);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const h=p.getDocument(T.URI.revive(s));return(0,f.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(h,u)).then(g=>g?g.map(l=>P.Range.from(l)):void 0)}$toggleReaction(t,s,u,d,h){const g=this._commentControllers.get(t);return!g||!g.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const l=g.getCommentThread(s);if(l){const D=l.getCommentByUniqueId(d.uniqueIdInThread);if(g!==void 0&&D&&g.reactionHandler)return g.reactionHandler(D,a(h))}return Promise.resolve(void 0)})}dispose(){}}L.handlePool=0;class S{constructor(t,s,u,d,h,g,l){this._commentControllerHandle=s,this._id=u,this._uri=d,this._range=h,this._comments=g,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputDisposables.value=new _.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),w.$createCommentThread(s,this.handle,this._id,this._uri,P.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=g,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(s,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(A){D.range=A},get comments(){return D.comments},set comments(A){D.comments=A},get collapsibleState(){return D.collapsibleState},set collapsibleState(A){D.collapsibleState=A},get canReply(){return D.canReply},set canReply(A){D.canReply=A},get contextValue(){return D.contextValue},set contextValue(A){D.contextValue=A},get label(){return D.label},set label(A){D.label=A},dispose:()=>{D.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new _.DisposableStore);const t=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),s={};t("range")&&(s.range=P.Range.from(this._range)),t("label")&&(s.label=this.label),t("contextValue")&&(s.contextValue=this.contextValue??null),t("comments")&&(s.comments=this._comments.map(u=>r(this,u,this._commentsMap))),t("collapsibleState")&&(s.collapseState=E(this._collapseState)),t("canReply")&&(s.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(t){for(let s of this._commentsMap){let u=s[0],d=s[1];if(t===d)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}S._handlePool=0,Ve([(0,i.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(t,s,u,d){this._extension=t,this._handle=s,this._id=u,this._label=d,this._threads=new Map,w.$registerCommentController(this.handle,u,d);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(g){h.options=g},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(g){h.commentingRangeProvider=g},get reactionHandler(){return h.reactionHandler},set reactionHandler(g){h.reactionHandler=g},createCommentThread(g,l,D){return h.createCommentThread(g,l,D).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,w.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,s,u,d){if(typeof t=="string"){const h=new S(this.id,this.handle,t,s,u,d,this._extension.identifier);return this._threads.set(h.handle,h),h}else{const h=new S(this.id,this.handle,void 0,t,s,u,this._extension.identifier);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(t,s){const u=new S(this.id,this.handle,void 0,T.URI.revive(t),P.Range.to(s),[],this._extension.identifier);return u.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(t,s){let u=this._threads.get(t);u&&(u.range=P.Range.to(s))}$deleteCommentThread(t){let s=this._threads.get(t);s&&s.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function r(n,t,s){let u=s.get(t);u||(u=++n.commentHandle,s.set(t,u));const d=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:u,body:P.MarkdownString.from(t.body),userName:t.author.name,userIconPath:d,label:t.label,commentReactions:t.reactions?t.reactions.map(h=>m(h)):void 0}}function m(n){return{label:n.label,iconPath:n.iconPath?P.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function a(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?T.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function E(n){if(n!==void 0)switch(n){case R.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new L}e.createExtHostComments=c}),define(ve[131],we([0,1,2,5,7,4,14,11,16,9,8]),function(X,e,f,i,k,_,T,I,C,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class bi{constructor(b,v){this._logService=v,this._provider=new Map,this._proxy=b.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,v){const p=bi._handlePool++;this._provider.set(p,{provider:b,extensionId:v}),this._proxy.$registerDecorationProvider(p,v.value);const w=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(L=>{if(!L){this._proxy.$onDidChange(p,null);return}let S=(0,C.asArray)(L);if(S.length<=bi._maxEventSize){this._proxy.$onDidChange(p,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",v.value,S.length);const o=S.map(a=>({uri:a,rank:(0,P.count)(a.path,"/")})),r=(0,C.groupBy)(o,(a,E)=>a.rank-E.rank||(0,P.compare)(a.uri.path,E.uri.path));let m=[];e:for(let a of r){let E;for(let n of a){let t=(0,R.dirname)(n.uri.path);if(E!==t&&(E=t,m.push(n.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(p,m)});return new k.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(b,v,p){if(!this._provider.has(b))return Object.create(null);const w=Object.create(null),{provider:L,extensionId:S}=this._provider.get(b);return await Promise.all(v.map(async o=>{try{const{uri:r,id:m}=o,a=await Promise.resolve(L.provideFileDecoration(f.URI.revive(r),p));if(!a)return;try{k.FileDecoration.validate(a),w[m]=[a.propagate,a.tooltip,a.badge,a.color]}catch(E){this._logService.warn(`INVALID decoration from extension '${S.value}': ${E}`)}}catch(r){this._logService.error(r)}})),w}};y._handlePool=0,y._maxEventSize=250,y=Ve([He(0,T.IExtHostRpcService),He(1,I.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,_.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[233],we([0,1,163,117,2,5,7,17,3,11,24,44]),function(X,e,f,i,k,_,T,I,C,P,R,y){"use strict";var c,b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(S,o,r,m,a,E){this._name=S,this._owner=o,this._maxDiagnosticsPerFile=r,c.set(this,void 0),b.set(this,void 0),v.set(this,void 0),this._isDisposed=!1,tt(this,v,new R.ResourceMap(n=>m.getComparisonKey(n)),"f"),tt(this,c,a,"f"),tt(this,b,E,"f")}dispose(){this._isDisposed||(Le(this,b,"f").fire([...Le(this,v,"f").keys()]),Le(this,c,"f")&&Le(this,c,"f").$clear(this._owner),Le(this,v,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(S,o){if(!S){this.clear();return}this._checkDisposed();let r=[];if(k.URI.isUri(S)){if(!o){this.delete(S);return}Le(this,v,"f").set(S,o.slice()),r=[S]}else if(Array.isArray(S)){r=[];let a;S=[...S].sort(p._compareIndexedTuplesByUri);for(const E of S){const[n,t]=E;if((!a||n.toString()!==a.toString())&&(a&&Le(this,v,"f").get(a).length===0&&Le(this,v,"f").delete(a),a=n,r.push(n),Le(this,v,"f").set(n,[])),t){const s=Le(this,v,"f").get(n);s&&s.push(...t)}else{const s=Le(this,v,"f").get(n);s&&(s.length=0)}}}if(Le(this,b,"f").fire(r),!Le(this,c,"f"))return;const m=[];for(let a of r){let E=[];const n=Le(this,v,"f").get(a);if(n)if(n.length>this._maxDiagnosticsPerFile){E=[];const t=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(let u of n)if(u.severity===t[s]&&E.push(I.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;E.push({severity:i.MarkerSeverity.Info,message:(0,f.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:E[E.length-1].startLineNumber,startColumn:E[E.length-1].startColumn,endLineNumber:E[E.length-1].endLineNumber,endColumn:E[E.length-1].endColumn})}else E=n.map(t=>I.Diagnostic.from(t));m.push([a,E])}Le(this,c,"f").$changeMany(this._owner,m)}delete(S){this._checkDisposed(),Le(this,b,"f").fire([S]),Le(this,v,"f").delete(S),Le(this,c,"f")&&Le(this,c,"f").$changeMany(this._owner,[[S,void 0]])}clear(){this._checkDisposed(),Le(this,b,"f").fire([...Le(this,v,"f").keys()]),Le(this,v,"f").clear(),Le(this,c,"f")&&Le(this,c,"f").$clear(this._owner)}forEach(S,o){this._checkDisposed();for(let r of Le(this,v,"f").keys())S.apply(o,[r,this.get(r),this])}get(S){this._checkDisposed();const o=Le(this,v,"f").get(S);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(S){return this._checkDisposed(),Array.isArray(Le(this,v,"f").get(S))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(S,o){return S[0].toString()<o[0].toString()?-1:S[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=p,c=new WeakMap,b=new WeakMap,v=new WeakMap;let w=class si{constructor(S,o,r){this._logService=o,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=S.getProxy(_.MainContext.MainThreadDiagnostics)}static _mapper(S){const o=new R.ResourceMap;for(const r of S)o.set(r,r);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(S,o){const{_collections:r,_proxy:m,_onDidChangeDiagnostics:a,_logService:E,_fileSystemInfoService:n}=this,t=new class{$changeMany(d,h){m.$changeMany(d,h),E.trace("[DiagnosticCollection] change many (extension, owner, uris)",S.value,d,h.length===0?"CLEARING":h)}$clear(d){m.$clear(d),E.trace("[DiagnosticCollection] remove all (extension, owner)",S.value,d)}dispose(){m.dispose()}};let s;if(!o)o="_generated_diagnostic_collection_name_#"+si._idPool++,s=o;else if(!r.has(o))s=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do s=o+si._idPool++;while(r.has(s))}return new class extends p{constructor(){super(o,s,si._maxDiagnosticsPerFile,n.extUri,t,a);r.set(s,this)}dispose(){super.dispose(),r.delete(s)}}}getDiagnostics(S){if(S)return this._getDiagnostics(S);{const o=new Map,r=[];for(const m of this._collections.values())m.forEach((a,E)=>{let n=o.get(a.toString());typeof n=="undefined"&&(n=r.length,o.set(a.toString(),n),r.push([a,[]])),r[n][1]=r[n][1].concat(...E)});return r}}_getDiagnostics(S){let o=[];for(let r of this._collections.values())r.has(S)&&(o=o.concat(r.get(S)));return o}$acceptMarkersChange(S){if(!this._mirrorCollection){const o="_generated_mirror",r=new p(o,o,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,r),this._mirrorCollection=r}for(const[o,r]of S)this._mirrorCollection.set(k.URI.revive(o),r.map(I.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=Ve([He(1,P.ILogService),He(2,y.IExtHostFileSystemInfo)],w),e.ExtHostDiagnostics=w}),define(ve[234],we([0,1,2,5]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(T){this._proxy=T.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(I=>I?I.map(C=>f.URI.revive(C)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(I=>I?f.URI.revive(I):void 0)}}e.ExtHostDialogs=k}),define(ve[235],we([0,1,15,2,7,5,10,21,9]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,c,b){this._documentsAndEditors=c,this._logService=b,this._documentContentProviders=new Map,this._proxy=y.getProxy(_.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,c){if(Object.keys(T.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const b=P._handlePool++;this._documentContentProviders.set(b,c),this._proxy.$registerTextContentProvider(b,y);let v;return typeof c.onDidChange=="function"&&(v=c.onDidChange(p=>{if(p.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(b,p).then(w=>{if(!w&&typeof w!="string")return;const L=this._documentsAndEditors.getDocument(p);if(!L)return;const S=(0,C.splitLines)(w);if(!L.equalLines(S))return this._proxy.$onVirtualDocumentChange(p,w)},f.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(y,c){const b=this._documentContentProviders.get(y);return b?Promise.resolve(b.provideTextDocumentContent(i.URI.revive(c),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ve[236],we([0,1,3,6,2,5,123,17,13,25,7]),function(X,e,f,i,k,_,T,I,C,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(b,v){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(_.MainContext.MainThreadDocuments),this._documentsAndEditors=v,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const w of p)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const w of p)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const v=this._documentsAndEditors.getDocument(b);if(v)return v}getDocument(b){const v=this.getDocumentData(b);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return v.document}ensureDocumentData(b){const v=this._documentsAndEditors.getDocument(b);if(v)return Promise.resolve(v);let p=this._documentLoader.get(b.toString());return p||(p=this._proxy.$tryOpenDocument(b).then(w=>{this._documentLoader.delete(b.toString());const L=k.URI.revive(w);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(L))},w=>(this._documentLoader.delete(b.toString()),Promise.reject(w))),this._documentLoader.set(b.toString(),p)),p}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(v=>k.URI.revive(v))}$acceptModelLanguageChanged(b,v){const p=k.URI.revive(b),w=this._documentsAndEditors.getDocument(p);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(v),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(b){const v=k.URI.revive(b),p=this._documentsAndEditors.getDocument(v);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(b,v){const p=k.URI.revive(b),w=this._documentsAndEditors.getDocument(p);if(!w)throw new Error("unknown document");w._acceptIsDirty(v),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,v,p){const w=k.URI.revive(b),L=this._documentsAndEditors.getDocument(w);if(!L)throw new Error("unknown document");L._acceptIsDirty(p),L.onEvents(v);let S;v.isUndoing?S=R.TextDocumentChangeReason.Undo:v.isRedoing&&(S=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:L.document,contentChanges:v.changes.map(o=>({range:I.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:S}))}setWordDefinitionFor(b,v){(0,T.setWordDefinitionFor)(b,v)}}e.ExtHostDocuments=y}),define(ve[45],we([0,1,56,3,6,2,4,5,123,14,130,17,11,24,10,78,93]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class L{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(r,m){this._extHostRpc=r,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const m=[],a=[],E=[];if(r.removedDocuments)for(const n of r.removedDocuments){const t=_.URI.revive(n),s=this._documents.get(t);s?.unref()&&(this._documents.delete(t),m.push(s.value))}if(r.addedDocuments)for(const n of r.addedDocuments){const t=_.URI.revive(n.uri);let s=this._documents.get(t);if(s&&t.scheme!==v.Schemas.vscodeNotebookCell&&t.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);s||(s=new L(new C.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,s),a.push(s.value)),s.ref()}if(r.removedEditors)for(const n of r.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&E.push(t)}if(r.addedEditors)for(const n of r.addedEditors){const t=_.URI.revive(n.documentUri);f.ok(this._documents.has(t),`document '${t}' does not exist`),f.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const s=this._documents.get(t).value,u=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>s.document),n.selections.map(y.Selection.to),n.options,n.visibleRanges.map(d=>y.Range.to(d)),typeof n.editorPosition=="number"?y.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,u)}r.newActiveEditor!==void 0&&(f.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,k.dispose)(m),(0,k.dispose)(E),r.removedDocuments&&this._onDidRemoveDocuments.fire(m),r.addedDocuments&&this._onDidAddDocuments.fire(a),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return r?m:m?.value}allEditors(){return[...this._editors.values()]}};S=Ve([He(0,P.IExtHostRpcService),He(1,c.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[54],we([0,1,17,5,2,3,4,14,18]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");let P=class{constructor(y){this._onDidChangeTabs=new _.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new _.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=y.getProxy(i.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let c=-1;this._tabs=y.map((v,p)=>(v.isActive&&(c=p),Object.freeze({label:v.label,viewColumn:f.ViewColumn.to(v.viewColumn),index:p,resource:k.URI.revive(v.resource),additionalResourcesAndViewIds:v.additionalResourcesAndViewIds.map(({resource:w,viewId:L})=>({resource:k.URI.revive(w),viewId:L})),viewId:v.editorId,isActive:v.isActive,move:async(w,L)=>{this._proxy.$moveTab(v,w,f.ViewColumn.from(L)),await(0,C.raceTimeout)(_.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(v),await(0,C.raceTimeout)(_.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((v,p)=>v.viewColumn===p.viewColumn?v.index-p.index:v.viewColumn-p.viewColumn);const b=this._activeTab;this._activeTab=c===-1?void 0:this._tabs[c],this._activeTab!==b&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=Ve([He(0,I.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(ve[237],we([0,1,2,5,6,7,17,147,9,22,30]),function(X,e,f,i,k,_,T,I,C,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(v){this._stateMachine=void 0,this._schemes.push(v)}delete(v){const p=this._schemes.indexOf(v);p>=0&&(this._schemes.splice(p,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const v=this._schemes.sort(),p=[];let w,L,S=14,o=14;for(const r of v){let m=w?(0,C.commonPrefixLength)(w,r):0;for(m===0?L=1:L=o;m<r.length;m++)m+1===r.length?(S=o,o=9):o+=1,p.push([L,r.toUpperCase().charCodeAt(m),o]),p.push([L,r.toLowerCase().charCodeAt(m),o]),L=o;w=r,o=S}p.push([9,58,10]),p.push([10,47,12]),this._stateMachine=new I.StateMachine(p)}}provideDocumentLinks(v){this._initStateMachine();const p=[],w=I.LinkComputer.computeLinks({getLineContent(L){return v.lineAt(L-1).text},getLineCount(){return v.lineCount}},this._stateMachine);for(const L of w){const S=T.DocumentLink.to(L);S.target&&p.push(S)}return p}}class c{constructor(v,p){this._extHostLanguageFeatures=p,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=v.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(v,p,w,L={}){if(this._registeredSchemes.has(p))throw new Error(`a provider for the scheme '${p}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(p),this._registeredSchemes.add(p),this._fsProvider.set(S,w);let o=2;L.isCaseSensitive&&(o+=1024),L.isReadonly&&(o+=2048),typeof w.copy=="function"&&(o+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&((0,R.checkProposedApiEnabled)(v,"fsChunks"),o+=4),this._proxy.$registerFileSystemProvider(S,p,o).catch(m=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${p}`),console.error(m)});const r=w.onDidChangeFile(m=>{const a=[];for(const E of m){let{uri:n,type:t}=E;if(n.scheme!==p)continue;let s;switch(t){case _.FileChangeType.Changed:s=0;break;case _.FileChangeType.Created:s=1;break;case _.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:n,type:s})}this._proxy.$onFileSystemChange(S,a)});return(0,k.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(p),this._registeredSchemes.delete(p),this._fsProvider.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(v){const{type:p,ctime:w,mtime:L,size:S,permissions:o}=v;return{type:p,ctime:w,mtime:L,size:S,permissions:o}}$stat(v,p){return Promise.resolve(this._getFsProvider(v).stat(f.URI.revive(p))).then(w=>c._asIStat(w))}$readdir(v,p){return Promise.resolve(this._getFsProvider(v).readDirectory(f.URI.revive(p)))}$readFile(v,p){return Promise.resolve(this._getFsProvider(v).readFile(f.URI.revive(p))).then(w=>P.VSBuffer.wrap(w))}$writeFile(v,p,w,L){return Promise.resolve(this._getFsProvider(v).writeFile(f.URI.revive(p),w.buffer,L))}$delete(v,p,w){return Promise.resolve(this._getFsProvider(v).delete(f.URI.revive(p),w))}$rename(v,p,w,L){return Promise.resolve(this._getFsProvider(v).rename(f.URI.revive(p),f.URI.revive(w),L))}$copy(v,p,w,L){const S=this._getFsProvider(v);if(!S.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(S.copy(f.URI.revive(p),f.URI.revive(w),L))}$mkdir(v,p){return Promise.resolve(this._getFsProvider(v).createDirectory(f.URI.revive(p)))}$watch(v,p,w,L){const S=this._getFsProvider(v).watch(f.URI.revive(w),L);this._watches.set(p,S)}$unwatch(v,p){const w=this._watches.get(p);w&&(w.dispose(),this._watches.delete(p))}$open(v,p,w){const L=this._getFsProvider(v);if(!L.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(L.open(f.URI.revive(p),w))}$close(v,p){const w=this._getFsProvider(v);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(p))}$read(v,p,w,L){const S=this._getFsProvider(v);if(!S.read)throw new Error('FileSystemProvider does not implement "read"');const o=P.VSBuffer.alloc(L);return Promise.resolve(S.read(p,w,o.buffer,0,L)).then(r=>o.slice(0,r))}$write(v,p,w,L){const S=this._getFsProvider(v);if(!S.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(S.write(p,w,L.buffer,0,L.byteLength))}_getFsProvider(v){const p=this._fsProvider.get(v);if(!p){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return p}}e.ExtHostFileSystem=c}),define(ve[67],we([0,1,5,42,7,22,4,14,44,6]),function(X,e,f,i,k,_,T,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class $t{constructor(c,b){this._fileSystemProvider=new Map,this._proxy=c.getProxy(f.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(p){try{const w=v._fileSystemProvider.get(p.scheme);if(!w)return await v._proxy.$stat(p);await v._proxy.$ensureActivation(p.scheme);const L=await w.stat(p);return{type:L.type,ctime:L.ctime,mtime:L.mtime,size:L.size,permissions:L.permissions}}catch(w){$t._handleError(w)}},async readDirectory(p){try{const w=v._fileSystemProvider.get(p.scheme);return w?(await v._proxy.$ensureActivation(p.scheme),(await w.readDirectory(p)).slice()):await v._proxy.$readdir(p)}catch(w){return $t._handleError(w)}},async createDirectory(p){try{return await v._proxy.$mkdir(p)}catch(w){return $t._handleError(w)}},async readFile(p){try{const w=v._fileSystemProvider.get(p.scheme);return w?(await v._proxy.$ensureActivation(p.scheme),(await w.readFile(p)).slice()):(await v._proxy.$readFile(p)).buffer}catch(w){return $t._handleError(w)}},async writeFile(p,w){try{return await v._proxy.$writeFile(p,_.VSBuffer.wrap(w))}catch(L){return $t._handleError(L)}},async delete(p,w){try{const L=v._fileSystemProvider.get(p.scheme);return L?(await v._proxy.$ensureActivation(p.scheme),await L.delete(p,{recursive:!1,...w})):await v._proxy.$delete(p,{recursive:!1,useTrash:!1,...w})}catch(L){return $t._handleError(L)}},async rename(p,w,L){try{return await v._proxy.$rename(p,w,{overwrite:!1,...L})}catch(S){return $t._handleError(S)}},async copy(p,w,L){try{return await v._proxy.$copy(p,w,{overwrite:!1,...L})}catch(S){return $t._handleError(S)}},isWritableFileSystem(p){const w=b.getCapabilities(p);if(typeof w=="number")return!(w&2048)}})}static _handleError(c){if(c instanceof k.FileSystemError)throw c;if(!(c instanceof Error))throw new k.FileSystemError(String(c));if(c.name==="ENOPRO")throw k.FileSystemError.Unavailable(c.message);switch(c.name){case i.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(c.message);case i.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(c.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(c.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(c.message);case i.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(c.message);case i.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(c.message);default:throw new k.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,b){return this._fileSystemProvider.set(c,b),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(c))}};R=Ve([He(0,I.IExtHostRpcService),He(1,C.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[238],we([0,1,2,38]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(T,I,C,P){this._extHostNotebooks=I,this._textDocumentsAndEditors=C,this._commands=P;const R=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new i.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new i.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new i.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new i.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:f.URI.revive(y.notebookUri),inputUri:f.URI.revive(y.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:f.URI.revive(y.notebookUri),inputUri:f.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(T,I,C,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:C,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=k}),define(ve[239],we([0,1,6,5]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(T){this._handlePool=0,this._proxy=T.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,T),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=k}),define(ve[240],we([0,1,2,25,17,7,5,9,41,16,13,145,6,111,77,87,46,15,3]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentSymbols(q,J){const re=this._documents.getDocument(q),he=await this._provider.provideDocumentSymbols(re,J);if(!(0,P.isFalsyOrEmpty)(he))return he[0]instanceof _.DocumentSymbol?he.map(k.DocumentSymbol.from):o._asDocumentSymbolTree(he)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((he,Z)=>{let ce=he.location.range.start.compareTo(Z.location.range.start);return ce===0&&(ce=Z.location.range.end.compareTo(he.location.range.end)),ce});const J=[],re=[];for(const he of q){const Z={name:he.name||"!!MISSING: name!!",kind:k.SymbolKind.from(he.kind),tags:he.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:he.containerName,range:k.Range.from(he.location.range),selectionRange:k.Range.from(he.location.range),children:[]};for(;;){if(re.length===0){re.push(Z),J.push(Z);break}const ce=re[re.length-1];if(C.Range.containsRange(ce.range,Z.range)&&!C.Range.equalsRange(ce.range,Z.range)){ce.children&&ce.children.push(Z),re.push(Z);break}re.pop()}}return J}}class r{constructor(q,J,re){this._documents=q,this._commands=J,this._provider=re,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,J){const re=this._documents.getDocument(q),he=await this._provider.provideCodeLenses(re,J);if(!he||J.isCancellationRequested)return;const Z=this._cache.add(he),ce=new c.DisposableStore;this._disposables.set(Z,ce);const Se={cacheId:Z,lenses:[]};for(let Be=0;Be<he.length;Be++)Se.lenses.push({cacheId:[Z,Be],range:k.Range.from(he[Be].range),command:this._commands.toInternal(he[Be].command,ce)});return Se}async resolveCodeLens(q,J){const re=q.cacheId&&this._cache.get(...q.cacheId);if(!re)return;let he;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?he=re:he=await this._provider.resolveCodeLens(re,J),he||(he=re),J.isCancellationRequested)return;const Z=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!Z)return q.command=this._commands.toInternal(he.command??r._badCmd,Z),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function m(Ue){return Array.isArray(Ue)?Ue.map(k.DefinitionLink.from):Ue?[k.DefinitionLink.from(Ue)]:[]}class a{constructor(q,J){this._documents=q,this._provider=J}async provideDefinition(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.provideDefinition(he,Z,re);return m(ce)}}class E{constructor(q,J){this._documents=q,this._provider=J}async provideDeclaration(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.provideDeclaration(he,Z,re);return m(ce)}}class n{constructor(q,J){this._documents=q,this._provider=J}async provideImplementation(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.provideImplementation(he,Z,re);return m(ce)}}class t{constructor(q,J){this._documents=q,this._provider=J}async provideTypeDefinition(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.provideTypeDefinition(he,Z,re);return m(ce)}}class s{constructor(q,J){this._documents=q,this._provider=J}async provideHover(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.provideHover(he,Z,re);if(!(!ce||(0,P.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=he.getWordRangeAtPosition(Z)),ce.range||(ce.range=new _.Range(Z,Z)),k.Hover.from(ce)}}class u{constructor(q,J){this._documents=q,this._provider=J}async provideEvaluatableExpression(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.provideEvaluatableExpression(he,Z,re);if(ce)return k.EvaluatableExpression.from(ce)}}class d{constructor(q,J){this._documents=q,this._provider=J}async provideInlineValues(q,J,re,he){const Z=this._documents.getDocument(q),ce=await this._provider.provideInlineValues(Z,k.Range.to(J),k.InlineValueContext.to(re),he);if(Array.isArray(ce))return ce.map(Se=>k.InlineValue.from(Se))}}class h{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentHighlights(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.provideDocumentHighlights(he,Z,re);if(Array.isArray(ce))return ce.map(k.DocumentHighlight.from)}}class g{constructor(q,J){this._documents=q,this._provider=J}async provideLinkedEditingRanges(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.provideLinkedEditingRanges(he,Z,re);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,P.coalesce)(ce.ranges.map(k.Range.from)),wordPattern:ce.wordPattern}}}class l{constructor(q,J){this._documents=q,this._provider=J}async provideReferences(q,J,re,he){const Z=this._documents.getDocument(q),ce=k.Position.to(J),Se=await this._provider.provideReferences(Z,ce,re,he);if(Array.isArray(Se))return Se.map(k.location.from)}}class D{constructor(q,J,re,he,Z,ce,Se){this._documents=q,this._commands=J,this._diagnostics=re,this._provider=he,this._logService=Z,this._extension=ce,this._apiDeprecation=Se,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,J,re,he){const Z=this._documents.getDocument(q),ce=y.Selection.isISelection(J)?k.Selection.to(J):k.Range.to(J),Se=[];for(const at of this._diagnostics.getDiagnostics(q))if(ce.intersection(at.range)&&Se.push(at)>D._maxCodeActionsPerFile)break;const Be={diagnostics:Se,only:re.only?new _.CodeActionKind(re.only):void 0,triggerKind:k.CodeActionTriggerKind.to(re.trigger)},qe=await this._provider.provideCodeActions(Z,ce,Be,he);if(!(0,P.isNonEmptyArray)(qe)||he.isCancellationRequested)return;const Ke=this._cache.add(qe),Je=new c.DisposableStore;this._disposables.set(Ke,Je);const it=[];for(let at=0;at<qe.length;at++){const et=qe[at];!et||(D._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Je)})):(Be.only&&(et.kind?Be.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Ke,at],title:et.title,command:et.command&&this._commands.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(k.Diagnostic.from),edit:et.edit&&k.WorkspaceEdit.from(et.edit),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Ke,actions:it}}async resolveCodeAction(q,J){const[re,he]=q,Z=this._cache.get(re,he);if(!Z||D._isCommand(Z)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(Z,J)??Z;return ce?.edit?k.WorkspaceEdit.from(ce.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}D._maxCodeActionsPerFile=1e3;class A{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentFormattingEdits(q,J,re){const he=this._documents.getDocument(q),Z=await this._provider.provideDocumentFormattingEdits(he,J,re);if(Array.isArray(Z))return Z.map(k.TextEdit.from)}}class N{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentRangeFormattingEdits(q,J,re,he){const Z=this._documents.getDocument(q),ce=k.Range.to(J),Se=await this._provider.provideDocumentRangeFormattingEdits(Z,ce,re,he);if(Array.isArray(Se))return Se.map(k.TextEdit.from)}}class B{constructor(q,J){this._documents=q,this._provider=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,J,re,he,Z){const ce=this._documents.getDocument(q),Se=k.Position.to(J),Be=await this._provider.provideOnTypeFormattingEdits(ce,Se,re,he,Z);if(Array.isArray(Be))return Be.map(k.TextEdit.from)}}class F{constructor(q,J){this._provider=q,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,J){const re=T.IdObject.mixin({symbols:[]}),he=await this._provider.provideWorkspaceSymbols(q,J);if((0,P.isNonEmptyArray)(he))for(const Z of he){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const ce=T.IdObject.mixin(k.WorkspaceSymbol.from(Z));this._symbolCache.set(ce._id,Z),re.symbols.push(ce)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(q,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const re=this._symbolCache.get(q._id);if(re){const he=await this._provider.resolveWorkspaceSymbol(re,J);return he&&(0,i.mixin)(q,k.WorkspaceSymbol.from(he),!0)}}releaseWorkspaceSymbols(q){const J=this._resultCache.get(q);if(J){for(let[re,he]=J;re<=he;re++)this._symbolCache.delete(re);this._resultCache.delete(q)}}}class O{constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,J,re,he){const Z=this._documents.getDocument(q),ce=k.Position.to(J);try{const Se=await this._provider.provideRenameEdits(Z,ce,re,he);return Se?k.WorkspaceEdit.from(Se):void 0}catch(Se){const Be=O._asMessage(Se);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(q,J,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const he=this._documents.getDocument(q),Z=k.Position.to(J);try{const ce=await this._provider.prepareRename(he,Z,re);let Se,Be;if(_.Range.isRange(ce)?(Se=ce,Be=he.getText(ce)):(0,R.isObject)(ce)&&(Se=ce.range,Be=ce.placeholder),!Se||!Be)return;if(Se.start.line>Z.line||Se.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(Se),text:Be}}catch(ce){const Se=O._asMessage(ce);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class z{constructor(q,J){this.resultId=q,this.tokens=J}}class W{constructor(q,J){this._documents=q,this._provider=J,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,J,re){const he=this._documents.getDocument(q),Z=J!==0?this._previousResults.get(J):null;let ce=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(he,Z.resultId,re):await this._provider.provideDocumentSemanticTokens(he,re);return Z&&this._previousResults.delete(J),ce?(ce=W._fixProvidedSemanticTokens(ce),this._send(W._convertToEdits(Z,ce),ce)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return W._isSemanticTokens(q)?W._isCorrectSemanticTokens(q)?q:new _.SemanticTokens(new Uint32Array(q.data),q.resultId):W._isSemanticTokensEdits(q)?W._isCorrectSemanticTokensEdits(q)?q:new _.SemanticTokensEdits(q.edits.map(J=>new _.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const J of q.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,J){if(!W._isSemanticTokens(J)||!q||!q.tokens)return J;const re=q.tokens,he=re.length,Z=J.data,ce=Z.length;let Se=0;const Be=Math.min(he,ce);for(;Se<Be&&re[Se]===Z[Se];)Se++;if(Se===he&&Se===ce)return new _.SemanticTokensEdits([],J.resultId);let qe=0;const Ke=Be-Se;for(;qe<Ke&&re[he-qe-1]===Z[ce-qe-1];)qe++;return new _.SemanticTokensEdits([{start:Se,deleteCount:he-Se-qe,data:Z.subarray(Se,ce-qe)}],J.resultId)}_send(q,J){if(W._isSemanticTokens(q)){const re=this._nextResultId++;return this._previousResults.set(re,new z(q.resultId,q.data)),(0,b.encodeSemanticTokensDto)({id:re,type:"full",data:q.data})}if(W._isSemanticTokensEdits(q)){const re=this._nextResultId++;return W._isSemanticTokens(J)?this._previousResults.set(re,new z(J.resultId,J.data)):this._previousResults.set(re,new z(q.resultId)),(0,b.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(q.edits||[]).map(he=>({start:he.start,deleteCount:he.deleteCount,data:he.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class M{constructor(q,J){this._documents=q,this._provider=J}async provideDocumentRangeSemanticTokens(q,J,re){const he=this._documents.getDocument(q),Z=await this._provider.provideDocumentRangeSemanticTokens(he,k.Range.to(J),re);return Z?this._send(Z):null}_send(q){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=M;class x{constructor(q,J,re,he,Z){this._documents=q,this._commands=J,this._provider=re,this._apiDeprecation=he,this._extension=Z,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,J,re,he){const Z=this._documents.getDocument(q),ce=k.Position.to(J),Se=Z.getWordRangeAtPosition(ce)||new _.Range(ce,ce),Be=Se.with({end:ce}),qe=new w.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,ce,he,k.CompletionContext.to(re));if(!Ke||he.isCancellationRequested)return;const Je=Array.isArray(Ke)?new _.CompletionList(Ke):Ke,it=x.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),at=new c.DisposableStore;this._disposables.set(it,at);const et=[],nt={x:it,b:et,a:{replace:k.Range.from(Se),insert:k.Range.from(Be)},c:Je.isIncomplete||void 0,d:qe.elapsed()};for(let ct=0;ct<Je.items.length;ct++){const vt=Je.items[ct],We=this._convertCompletionItem(vt,[it,ct],Be,Se);et.push(We)}return nt}async resolveCompletionItem(q,J){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...q);if(!re)return;const he=await this._provider.resolveCompletionItem(re,J);if(!!he)return this._convertCompletionItem(he,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,J,re,he){const Z=this._disposables.get(J[0]);if(!Z)throw Error("DisposableStore is missing...");const ce={x:J,a:q.label,b:q.kind!==void 0?k.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(k.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(q.command,Z)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=q.textEdit.newText):typeof q.insertText=="string"?ce.h=q.insertText:q.insertText instanceof _.SnippetString&&(ce.h=q.insertText.value,ce.i|=4);let Se;return q.textEdit?Se=q.textEdit.range:q.range&&(Se=q.range),_.Range.isRange(Se)?ce.j=k.Range.from(Se):Se&&(!re?.isEqual(Se.inserting)||!he?.isEqual(Se.replacing))&&(ce.j={insert:k.Range.from(Se.inserting),replace:k.Range.from(Se.replacing)}),ce}}class V{constructor(q,J,re){this._documents=q,this._provider=J,this._commands=re,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,J,re,he){const Z=this._documents.getDocument(q),ce=k.Position.to(J),Se=await this._provider.provideInlineCompletionItems(Z,ce,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:k.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text,isSnippetText:re.selectedSuggestionInfo.isSnippetText,completionKind:k.CompletionItemKind.to(re.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:re.triggerKind},he);if(!Se||he.isCancellationRequested)return;const Be=(0,R.isArray)(Se)?{items:Se}:Se,qe=this._cache.add(Be.items);let Ke;return{pid:qe,items:Be.items.map((Je,it)=>{let at;return Je.command&&(Ke||(Ke=new c.DisposableStore,this._disposables.set(qe,Ke)),at=this._commands.toInternal(Je.command,Ke)),{text:Je.text,range:Je.range?k.Range.from(Je.range):void 0,command:at,idx:it}})}}disposeCompletions(q){this._cache.delete(q);const J=this._disposables.get(q);J&&J.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,J){const re=this._cache.get(q,J);re&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new S.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let J=U.map.get(q);return J||(J=new U,U.map.set(q,J)),J}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=U,U.map=new WeakMap;class H{constructor(q,J){this._documents=q,this._provider=J,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(q,J,re,he){const Z=this._documents.getDocument(q),ce=k.Position.to(J),Se=this.reviveContext(re),Be=await this._provider.provideSignatureHelp(Z,ce,he,Se);if(Be){const qe=this._cache.add([Be]);return{...k.SignatureHelp.from(Be),id:qe}}}reviveContext(q){let J;if(q.activeSignatureHelp){const re=k.SignatureHelp.to(q.activeSignatureHelp),he=this._cache.get(q.activeSignatureHelp.id,0);he?(J=he,J.activeSignature=re.activeSignature,J.activeParameter=re.activeParameter):J=re}return{...q,activeSignatureHelp:J}}releaseSignatureHelp(q){this._cache.delete(q)}}class Y{constructor(q,J){this._documents=q,this._provider=J}async provideInlayHints(q,J,re){const he=this._documents.getDocument(q),Z=await this._provider.provideInlayHints(he,k.Range.to(J),re);return Z?{hints:Z.map(k.InlayHint.from)}:void 0}}class se{constructor(q,J){this._documents=q,this._provider=J,this._cache=new p.Cache("DocumentLink")}async provideLinks(q,J){const re=this._documents.getDocument(q),he=await this._provider.provideDocumentLinks(re,J);if(!(!Array.isArray(he)||he.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:he.filter(se._validateLink).map(k.DocumentLink.from)};{const Z=this._cache.add(he),ce={links:[],id:Z};for(let Se=0;Se<he.length;Se++){if(!se._validateLink(he[Se]))continue;const Be=k.DocumentLink.from(he[Se]);Be.cacheId=[Z,Se],ce.links.push(Be)}return ce}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,J){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...q);if(!re)return;const he=await this._provider.resolveDocumentLink(re,J);if(!(!he||!se._validateLink(he)))return k.DocumentLink.from(he)}releaseLinks(q){this._cache.delete(q)}}class K{constructor(q,J){this._documents=q,this._provider=J}async provideColors(q,J){const re=this._documents.getDocument(q),he=await this._provider.provideDocumentColors(re,J);return Array.isArray(he)?he.map(ce=>({color:k.Color.from(ce.color),range:k.Range.from(ce.range)})):[]}async provideColorPresentations(q,J,re){const he=this._documents.getDocument(q),Z=k.Range.to(J.range),ce=k.Color.to(J.color),Se=await this._provider.provideColorPresentations(ce,{document:he,range:Z},re);if(!!Array.isArray(Se))return Se.map(k.ColorPresentation.from)}}class j{constructor(q,J){this._documents=q,this._provider=J}async provideFoldingRanges(q,J,re){const he=this._documents.getDocument(q),Z=await this._provider.provideFoldingRanges(he,J,re);if(!!Array.isArray(Z))return Z.map(k.FoldingRange.from)}}class ne{constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}async provideSelectionRanges(q,J,re){const he=this._documents.getDocument(q),Z=J.map(k.Position.to),ce=await this._provider.provideSelectionRanges(he,Z,re);if(!(0,P.isNonEmptyArray)(ce))return[];if(ce.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let Be=0;Be<Z.length;Be++){const qe=[];Se.push(qe);let Ke=Z[Be],Je=ce[Be];for(;;){if(!Je.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(k.SelectionRange.from(Je)),!Je.parent)break;Ke=Je.range,Je=Je.parent}}return Se}}class le{constructor(q,J){this._documents=q,this._provider=J,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.prepareCallHierarchy(he,Z,re);if(!ce)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(ce)?ce.map(Be=>this._cacheAndConvertItem(Se,Be)):[this._cacheAndConvertItem(Se,ce)]}async provideCallsTo(q,J,re){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(he,re);if(!!Z)return Z.map(ce=>({from:this._cacheAndConvertItem(q,ce.from),fromRanges:ce.fromRanges.map(Se=>k.Range.from(Se))}))}async provideCallsFrom(q,J,re){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(he,re);if(!!Z)return Z.map(ce=>({to:this._cacheAndConvertItem(q,ce.to),fromRanges:ce.fromRanges.map(Se=>k.Range.from(Se))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,J){const re=this._cache.get(q),he=k.CallHierarchyItem.from(J,q,re.size.toString(36));return re.set(he._itemId,J),he}_itemFromCache(q,J){return this._cache.get(q)?.get(J)}}class ge{constructor(q,J){this._documents=q,this._provider=J,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(q,J,re){const he=this._documents.getDocument(q),Z=k.Position.to(J),ce=await this._provider.prepareTypeHierarchy(he,Z,re);if(!ce)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(ce)?ce.map(Be=>this._cacheAndConvertItem(Se,Be)):[this._cacheAndConvertItem(Se,ce)]}async provideSupertypes(q,J,re){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(he,re);if(!!Z)return Z.map(ce=>this._cacheAndConvertItem(q,ce))}async provideSubtypes(q,J,re){const he=this._itemFromCache(q,J);if(!he)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(he,re);if(!!Z)return Z.map(ce=>this._cacheAndConvertItem(q,ce))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,J){const re=this._cache.get(q),he=k.TypeHierarchyItem.from(J,q,re.size.toString(36));return re.set(he._itemId,J),he}_itemFromCache(q,J){return this._cache.get(q)?.get(J)}}class ke{constructor(q,J){this.adapter=q,this.extension=J}}class Me{constructor(q,J,re,he,Z,ce,Se){this._adapter=new Map,this._uriTransformer=J,this._proxy=q.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=he,this._diagnostics=Z,this._logService=ce,this._apiDeprecation=Se}_transformDocumentSelector(q){return k.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new _.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Me._handlePool++}_withAdapter(q,J,re,he,Z=!1){const ce=this._adapter.get(q);if(!ce)return Promise.resolve(he);if(ce.adapter instanceof J){let Se;ce.extension&&(Se=Date.now(),this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${J.name}'`));const Be=re(ce.adapter,ce.extension),qe=ce.extension;return qe&&Promise.resolve(Be).then(()=>this._logService.trace(`[${qe.identifier.value}] provider DONE after ${Date.now()-Se}ms`),Ke=>{Z&&Ke instanceof L.CancellationError||(this._logService.error(`[${qe.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Be}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,J){const re=this._nextHandle();return this._adapter.set(re,new ke(q,J)),re}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,J,re,he){const Z=this._addNewAdapter(new o(this._documents,re),q),ce=he&&he.label||Me._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(J),ce),this._createDisposable(Z)}$provideDocumentSymbols(q,J,re){return this._withAdapter(q,o,he=>he.provideDocumentSymbols(f.URI.revive(J),re),void 0)}registerCodeLensProvider(q,J,re){const he=this._nextHandle(),Z=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(he,new ke(new r(this._documents,this._commands.converter,re),q)),this._proxy.$registerCodeLensSupport(he,this._transformDocumentSelector(J),Z);let ce=this._createDisposable(he);if(Z!==void 0){const Se=re.onDidChangeCodeLenses(Be=>this._proxy.$emitCodeLensEvent(Z));ce=_.Disposable.from(ce,Se)}return ce}$provideCodeLenses(q,J,re){return this._withAdapter(q,r,he=>he.provideCodeLenses(f.URI.revive(J),re),void 0)}$resolveCodeLens(q,J,re){return this._withAdapter(q,r,he=>he.resolveCodeLens(J,re),void 0)}$releaseCodeLenses(q,J){this._withAdapter(q,r,re=>Promise.resolve(re.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(q,J,re){const he=this._addNewAdapter(new a(this._documents,re),q);return this._proxy.$registerDefinitionSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDefinition(q,J,re,he){return this._withAdapter(q,a,Z=>Z.provideDefinition(f.URI.revive(J),re,he),[])}registerDeclarationProvider(q,J,re){const he=this._addNewAdapter(new E(this._documents,re),q);return this._proxy.$registerDeclarationSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDeclaration(q,J,re,he){return this._withAdapter(q,E,Z=>Z.provideDeclaration(f.URI.revive(J),re,he),[])}registerImplementationProvider(q,J,re){const he=this._addNewAdapter(new n(this._documents,re),q);return this._proxy.$registerImplementationSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideImplementation(q,J,re,he){return this._withAdapter(q,n,Z=>Z.provideImplementation(f.URI.revive(J),re,he),[])}registerTypeDefinitionProvider(q,J,re){const he=this._addNewAdapter(new t(this._documents,re),q);return this._proxy.$registerTypeDefinitionSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideTypeDefinition(q,J,re,he){return this._withAdapter(q,t,Z=>Z.provideTypeDefinition(f.URI.revive(J),re,he),[])}registerHoverProvider(q,J,re,he){const Z=this._addNewAdapter(new s(this._documents,re),q);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(J)),this._createDisposable(Z)}$provideHover(q,J,re,he){return this._withAdapter(q,s,Z=>Z.provideHover(f.URI.revive(J),re,he),void 0)}registerEvaluatableExpressionProvider(q,J,re,he){const Z=this._addNewAdapter(new u(this._documents,re),q);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(J)),this._createDisposable(Z)}$provideEvaluatableExpression(q,J,re,he){return this._withAdapter(q,u,Z=>Z.provideEvaluatableExpression(f.URI.revive(J),re,he),void 0)}registerInlineValuesProvider(q,J,re,he){const Z=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new d(this._documents,re),q);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(J),Z);let Se=this._createDisposable(ce);if(Z!==void 0){const Be=re.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(Z));Se=_.Disposable.from(Se,Be)}return Se}$provideInlineValues(q,J,re,he,Z){return this._withAdapter(q,d,ce=>ce.provideInlineValues(f.URI.revive(J),re,he,Z),void 0)}registerDocumentHighlightProvider(q,J,re){const he=this._addNewAdapter(new h(this._documents,re),q);return this._proxy.$registerDocumentHighlightProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDocumentHighlights(q,J,re,he){return this._withAdapter(q,h,Z=>Z.provideDocumentHighlights(f.URI.revive(J),re,he),void 0)}registerLinkedEditingRangeProvider(q,J,re){const he=this._addNewAdapter(new g(this._documents,re),q);return this._proxy.$registerLinkedEditingRangeProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideLinkedEditingRanges(q,J,re,he){return this._withAdapter(q,g,async Z=>{const ce=await Z.provideLinkedEditingRanges(f.URI.revive(J),re,he);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?Me._serializeRegExp(ce.wordPattern):void 0}},void 0)}registerReferenceProvider(q,J,re){const he=this._addNewAdapter(new l(this._documents,re),q);return this._proxy.$registerReferenceSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideReferences(q,J,re,he,Z){return this._withAdapter(q,l,ce=>ce.provideReferences(f.URI.revive(J),re,he,Z),void 0)}registerCodeActionProvider(q,J,re,he){const Z=new c.DisposableStore,ce=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,re,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(J),{providedKinds:he?.providedCodeActionKinds?.map(Se=>Se.value),documentation:he?.documentation?.map(Se=>({kind:Se.kind.value,command:this._commands.converter.toInternal(Se.command,Z)}))},Me._extLabel(q),Boolean(re.resolveCodeAction)),Z.add(this._createDisposable(ce)),Z}$provideCodeActions(q,J,re,he,Z){return this._withAdapter(q,D,ce=>ce.provideCodeActions(f.URI.revive(J),re,he,Z),void 0)}$resolveCodeAction(q,J,re){return this._withAdapter(q,D,he=>he.resolveCodeAction(J,re),void 0)}$releaseCodeActions(q,J){this._withAdapter(q,D,re=>Promise.resolve(re.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(q,J,re){const he=this._addNewAdapter(new A(this._documents,re),q);return this._proxy.$registerDocumentFormattingSupport(he,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(he)}$provideDocumentFormattingEdits(q,J,re,he){return this._withAdapter(q,A,Z=>Z.provideDocumentFormattingEdits(f.URI.revive(J),re,he),void 0)}registerDocumentRangeFormattingEditProvider(q,J,re){const he=this._addNewAdapter(new N(this._documents,re),q);return this._proxy.$registerRangeFormattingSupport(he,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(he)}$provideDocumentRangeFormattingEdits(q,J,re,he,Z){return this._withAdapter(q,N,ce=>ce.provideDocumentRangeFormattingEdits(f.URI.revive(J),re,he,Z),void 0)}registerOnTypeFormattingEditProvider(q,J,re,he){const Z=this._addNewAdapter(new B(this._documents,re),q);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(J),he,q.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(q,J,re,he,Z,ce){return this._withAdapter(q,B,Se=>Se.provideOnTypeFormattingEdits(f.URI.revive(J),re,he,Z,ce),void 0)}registerWorkspaceSymbolProvider(q,J){const re=this._addNewAdapter(new F(J,this._logService),q);return this._proxy.$registerNavigateTypeSupport(re,typeof J.resolveWorkspaceSymbol=="function"),this._createDisposable(re)}$provideWorkspaceSymbols(q,J,re){return this._withAdapter(q,F,he=>he.provideWorkspaceSymbols(J,re),{symbols:[]})}$resolveWorkspaceSymbol(q,J,re){return this._withAdapter(q,F,he=>he.resolveWorkspaceSymbol(J,re),void 0)}$releaseWorkspaceSymbols(q,J){this._withAdapter(q,F,re=>re.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(q,J,re){const he=this._addNewAdapter(new O(this._documents,re,this._logService),q);return this._proxy.$registerRenameSupport(he,this._transformDocumentSelector(J),O.supportsResolving(re)),this._createDisposable(he)}$provideRenameEdits(q,J,re,he,Z){return this._withAdapter(q,O,ce=>ce.provideRenameEdits(f.URI.revive(J),re,he,Z),void 0)}$resolveRenameLocation(q,J,re,he){return this._withAdapter(q,O,Z=>Z.resolveRenameLocation(f.URI.revive(J),re,he),void 0)}registerDocumentSemanticTokensProvider(q,J,re,he){const Z=this._nextHandle(),ce=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new ke(new W(this._documents,re),q)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(J),he,ce);let Se=this._createDisposable(Z);if(ce){const Be=re.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(ce));Se=_.Disposable.from(Se,Be)}return Se}$provideDocumentSemanticTokens(q,J,re,he){return this._withAdapter(q,W,Z=>Z.provideDocumentSemanticTokens(f.URI.revive(J),re,he),null,!0)}$releaseDocumentSemanticTokens(q,J){this._withAdapter(q,W,re=>re.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(q,J,re,he){const Z=this._addNewAdapter(new M(this._documents,re),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(J),he),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(q,J,re,he){return this._withAdapter(q,M,Z=>Z.provideDocumentRangeSemanticTokens(f.URI.revive(J),re,he),null,!0)}registerCompletionItemProvider(q,J,re,he){const Z=this._addNewAdapter(new x(this._documents,this._commands.converter,re,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(J),he,x.supportsResolving(re),`${q.identifier.value}(${he.join("")})`),this._createDisposable(Z)}$provideCompletionItems(q,J,re,he,Z){return this._withAdapter(q,x,ce=>ce.provideCompletionItems(f.URI.revive(J),re,he,Z),void 0)}$resolveCompletionItem(q,J,re){return this._withAdapter(q,x,he=>he.resolveCompletionItem(J,re),void 0)}$releaseCompletionItems(q,J){this._withAdapter(q,x,re=>re.releaseCompletionItems(J),void 0)}registerInlineCompletionsProvider(q,J,re){const he=this._addNewAdapter(new V(this._documents,re,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideInlineCompletions(q,J,re,he,Z){return this._withAdapter(q,V,ce=>ce.provideInlineCompletions(f.URI.revive(J),re,he,Z),void 0)}$handleInlineCompletionDidShow(q,J,re){this._withAdapter(q,V,async he=>{he.handleDidShowCompletionItem(J,re)},void 0)}$freeInlineCompletionsList(q,J){this._withAdapter(q,V,async re=>{re.disposeCompletions(J)},void 0)}registerSignatureHelpProvider(q,J,re,he){const Z=Array.isArray(he)?{triggerCharacters:he,retriggerCharacters:[]}:he,ce=this._addNewAdapter(new H(this._documents,re),q);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(J),Z),this._createDisposable(ce)}$provideSignatureHelp(q,J,re,he,Z){return this._withAdapter(q,H,ce=>ce.provideSignatureHelp(f.URI.revive(J),re,he,Z),void 0)}$releaseSignatureHelp(q,J){this._withAdapter(q,H,re=>re.releaseSignatureHelp(J),void 0)}registerInlayHintsProvider(q,J,re){const he=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new Y(this._documents,re),q);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(J),he);let ce=this._createDisposable(Z);if(he!==void 0){const Se=re.onDidChangeInlayHints(Be=>this._proxy.$emitInlayHintsEvent(he));ce=_.Disposable.from(ce,Se)}return ce}$provideInlayHints(q,J,re,he){return this._withAdapter(q,Y,Z=>Z.provideInlayHints(f.URI.revive(J),re,he),void 0)}registerDocumentLinkProvider(q,J,re){const he=this._addNewAdapter(new se(this._documents,re),q);return this._proxy.$registerDocumentLinkProvider(he,this._transformDocumentSelector(J),typeof re.resolveDocumentLink=="function"),this._createDisposable(he)}$provideDocumentLinks(q,J,re){return this._withAdapter(q,se,he=>he.provideLinks(f.URI.revive(J),re),void 0)}$resolveDocumentLink(q,J,re){return this._withAdapter(q,se,he=>he.resolveLink(J,re),void 0)}$releaseDocumentLinks(q,J){this._withAdapter(q,se,re=>re.releaseLinks(J),void 0)}registerColorProvider(q,J,re){const he=this._addNewAdapter(new K(this._documents,re),q);return this._proxy.$registerDocumentColorProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideDocumentColors(q,J,re){return this._withAdapter(q,K,he=>he.provideColors(f.URI.revive(J),re),[])}$provideColorPresentations(q,J,re,he){return this._withAdapter(q,K,Z=>Z.provideColorPresentations(f.URI.revive(J),re,he),void 0)}registerFoldingRangeProvider(q,J,re){const he=this._nextHandle(),Z=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(he,new ke(new j(this._documents,re),q)),this._proxy.$registerFoldingRangeProvider(he,this._transformDocumentSelector(J),Z);let ce=this._createDisposable(he);if(Z!==void 0){const Se=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));ce=_.Disposable.from(ce,Se)}return ce}$provideFoldingRanges(q,J,re,he){return this._withAdapter(q,j,Z=>Z.provideFoldingRanges(f.URI.revive(J),re,he),void 0)}registerSelectionRangeProvider(q,J,re){const he=this._addNewAdapter(new ne(this._documents,re,this._logService),q);return this._proxy.$registerSelectionRangeProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideSelectionRanges(q,J,re,he){return this._withAdapter(q,ne,Z=>Z.provideSelectionRanges(f.URI.revive(J),re,he),[])}registerCallHierarchyProvider(q,J,re){const he=this._addNewAdapter(new le(this._documents,re),q);return this._proxy.$registerCallHierarchyProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$prepareCallHierarchy(q,J,re,he){return this._withAdapter(q,le,Z=>Promise.resolve(Z.prepareSession(f.URI.revive(J),re,he)),void 0)}$provideCallHierarchyIncomingCalls(q,J,re,he){return this._withAdapter(q,le,Z=>Z.provideCallsTo(J,re,he),void 0)}$provideCallHierarchyOutgoingCalls(q,J,re,he){return this._withAdapter(q,le,Z=>Z.provideCallsFrom(J,re,he),void 0)}$releaseCallHierarchy(q,J){this._withAdapter(q,le,re=>Promise.resolve(re.releaseSession(J)),void 0)}registerTypeHierarchyProvider(q,J,re){const he=this._addNewAdapter(new ge(this._documents,re),q);return this._proxy.$registerTypeHierarchyProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$prepareTypeHierarchy(q,J,re,he){return this._withAdapter(q,ge,Z=>Promise.resolve(Z.prepareSession(f.URI.revive(J),re,he)),void 0)}$provideTypeHierarchySupertypes(q,J,re,he){return this._withAdapter(q,ge,Z=>Z.provideSupertypes(J,re,he),void 0)}$provideTypeHierarchySubtypes(q,J,re,he){return this._withAdapter(q,ge,Z=>Z.provideSubtypes(J,re,he),void 0)}$releaseTypeHierarchy(q,J){this._withAdapter(q,ge,re=>Promise.resolve(re.releaseSession(J)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,I.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Me._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Me._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Me._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Me._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Me._serializeRegExp(q.beforeText),afterText:q.afterText?Me._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Me._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Me._serializeOnEnterRule)}setLanguageConfiguration(q,J,re){let{wordPattern:he}=re;if(he&&(0,I.regExpLeadsToEndlessLoop)(he))throw new Error(`Invalid language configuration: wordPattern '${he}' is not allowed to match the empty string.`);he?this._documents.setWordDefinitionFor(J,he):this._documents.setWordDefinitionFor(J,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const Z=this._nextHandle(),ce={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Me._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Me._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Me._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,J,ce),this._createDisposable(Z)}$setWordDefinitions(q){for(const J of q)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=Me,Me._handlePool=0}),define(ve[241],we([0,1,5,17,7,48,18,6]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(R,y,c,b){this._documents=y,this._commands=c,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(f.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,y){await this._proxy.$changeLanguage(R,y);const c=this._documents.getDocumentData(R);if(!c)throw new Error(`document '${R.toString}' NOT found`);return c.document}async tokenAtPosition(R,y){const c=R.version,b=i.Position.from(y),v=await this._proxy.$tokensAtPosition(R.uri,b),p={type:k.StandardTokenType.Other,range:R.getWordRangeAtPosition(y)??new k.Range(y.line,y.character,y.line,y.character)};if(!v)return p;const w={range:i.Range.to(v.range),type:i.TokenType.to(v.type)};return!w.range.contains(y)||c!==R.version?p:w}createLanguageStatusItem(R,y,c){const b=this._handlePool++,v=this._proxy,p=this._ids,w=`${R.identifier.value}/${y}`;if(p.has(w))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);p.add(w);const L={selector:c,id:y,name:R.displayName??R.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let S,o=new I.DisposableStore;const r=()=>{S?.dispose(),S=(0,T.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(b,{id:w,name:L.name??R.displayName??R.name,source:R.displayName??R.name,selector:i.DocumentSelector.from(L.selector,this._uriTransformer),label:L.text,detail:L.detail??"",severity:L.severity===k.LanguageStatusSeverity.Error?_.default.Error:L.severity===k.LanguageStatusSeverity.Warning?_.default.Warning:_.default.Info,command:L.command&&this._commands.toInternal(L.command,o),accessibilityInfo:L.accessibilityInformation,busy:L.busy})},0)},m={dispose(){o.dispose(),S?.dispose(),v.$removeLanguageStatus(b),p.delete(w)},get id(){return L.id},get name(){return L.name},set name(a){L.name=a,r()},get selector(){return L.selector},set selector(a){L.selector=a,r()},get text(){return L.text},set text(a){L.text=a,r()},get detail(){return L.detail},set detail(a){L.detail=a,r()},get severity(){return L.severity},set severity(a){L.severity=a,r()},get accessibilityInformation(){return L.accessibilityInformation},set accessibilityInformation(a){L.accessibilityInformation=a,r()},get command(){return L.command},set command(a){L.command=a,r()},get busy(){return L.busy},set busy(a){L.busy=a,r()}};return r(),m}}e.ExtHostLanguages=C}),define(ve[132],we([0,1,11,5,26,14,3]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends f.AbstractLoggerService{constructor(R,y){const c=new T.Emitter;super(y.logLevel,c.event);this._proxy=R.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,y,c){return new C(this._proxy,R,y,c)}};I=Ve([He(0,_.IExtHostRpcService),He(1,k.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class C extends f.AbstractMessageLogger{constructor(R,y,c,b){super(b?.always);this.proxy=R,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(y,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,y){const c=[[R,y]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(R){this.proxy.$log(this.file,R)}}}),define(ve[242],we([0,1,5,11,30]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function _(I){return I&&I.title}let T=class{constructor(C,P){this._logService=P,this._proxy=C.getProxy(f.MainContext.MainThreadMessageService)}showMessage(C,P,R,y,c){const b={extension:C};let v;typeof y=="string"||_(y)?v=[y,...c]:(b.modal=y?.modal,b.useCustom=y?.useCustom,b.detail=y?.detail,v=c),b.useCustom&&(0,k.checkProposedApiEnabled)(C,"resolvers");const p=[];for(let w=0;w<v.length;w++){const L=v[w];if(typeof L=="string")p.push({title:L,handle:w,isCloseAffordance:!1});else if(typeof L=="object"){let{title:S,isCloseAffordance:o}=L;p.push({title:S,isCloseAffordance:!!o,handle:w})}else this._logService.warn("Invalid message item:",L)}return this._proxy.$showMessage(P,R,b,p).then(w=>{if(typeof w=="number")return v[w]})}};T=Ve([He(1,i.ILogService)],T),e.ExtHostMessageService=T}),define(ve[243],we([0,1,22,3,47,6,24,9,13,2,87,5,17,7,53,219,129]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class L{constructor(o,r,m,a,E){this._textDocumentsAndEditors=m,this._textDocuments=a,this._extensionStoragePaths=E,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new i.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new i.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new i.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const t=n.notebookEditor?.notebookUri,s=n.cell.handle,d=this._documents.get(t)?.getCell(s);if(d)return d.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const r=this._editors.get(o);if(!r)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(o){for(const[r,m]of this._editors)if(m.apiEditor===o)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,r){const m=this._documents.get(o);if(!m&&!r)throw new Error(`NO notebook document for '${o}'`);return m}_getProviderData(o){const r=this._notebookContentProviders.get(o);if(!r)throw new Error(`NO provider for '${o}'`);return r}registerNotebookContentProvider(o,r,m,a,E){if((0,I.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:o,provider:m});let n;return m.onDidChangeNotebookContentOptions&&(n=m.onDidChangeNotebookContentOptions(()=>{const t=c.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(r,t)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},r,c.NotebookDocumentContentOptions.from(a),L._convertNotebookRegistrationData(o,E)),new b.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(o,r){if(!r)return;const m=r.filenamePattern.map(a=>c.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(r.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:r.displayName,filenamePattern:m,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,r,m){const a=L._notebookStatusBarItemProviderHandlePool++,E=typeof m.onDidChangeCellStatusBarItems=="function"?L._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,E,r);let n;return E!==void 0&&(n=m.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(E))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,E),n&&n.dispose()})}async createNotebookDocument(o){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&c.NotebookData.from(o.content)});return P.URI.revive(r)}async openNotebookDocument(o){const r=this._documents.get(o);if(r)return r.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(o),a=this._documents.get(P.URI.revive(m));return(0,C.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(o,r){P.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let m;typeof r=="object"?m={position:c.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(c.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:m={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,m),E=a&&this._editors.get(a)?.apiEditor;if(E)return E;throw a?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,r,m,a){const E=this._notebookStatusBarItemProviders.get(o),n=P.URI.revive(r),t=this._documents.get(n);if(!t||!E)return;const s=t.getCellFromIndex(m);if(!s)return;const u=await E.provideCellStatusBarItems(s.apiCell,a);if(!u)return;const d=new _.DisposableStore,h=this._statusBarCache.add([d]),l=(Array.isArray(u)?u:[u]).map(D=>c.NotebookStatusBarItem.from(D,this._commandsConverter,d));return{cacheId:h,items:l}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,r,m,a,E){if((0,I.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,m),this._notebookProxy.$registerNotebookSerializer(n,{id:o.identifier,location:o.extensionLocation},r,c.NotebookDocumentContentOptions.from(a),L._convertNotebookRegistrationData(o,E)),(0,_.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(o,r,m){const a=this._notebookSerializer.get(o);if(!a)throw new Error("NO serializer found");const E=await a.deserializeNotebook(r.buffer,m);return new v.SerializableObjectWithBuffers(c.NotebookData.from(E))}async $notebookToData(o,r,m){const a=this._notebookSerializer.get(o);if(!a)throw new Error("NO serializer found");const E=await a.serializeNotebook(c.NotebookData.to(r.value),m);return f.VSBuffer.wrap(E)}async $openNotebook(o,r,m,a,E){const{provider:n}=this._getProviderData(o),t=await n.openNotebook(P.URI.revive(r),{backupId:m,untitledDocumentData:a?.buffer},E);return new v.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(c.NotebookCellData.from)})}async $saveNotebook(o,r,m){const a=this.getNotebookDocument(P.URI.revive(r)),{provider:E}=this._getProviderData(o);return await E.saveNotebook(a.apiNotebook,m),!0}async $saveNotebookAs(o,r,m,a){const E=this.getNotebookDocument(P.URI.revive(r)),{provider:n}=this._getProviderData(o);return await n.saveNotebookAs(P.URI.revive(m),E.apiNotebook,a),!0}async $backupNotebook(o,r,m){const a=this.getNotebookDocument(P.URI.revive(r)),E=this._getProviderData(o),n=this._extensionStoragePaths.workspaceValue(E.extension)??this._extensionStoragePaths.globalValue(E.extension),t=String((0,k.hash)([a.uri.toString(),this._backupIdPool++])),s=P.URI.joinPath(n,t),u=await E.provider.backupNotebook(a.apiNotebook,{destination:s},m);return a.updateBackup(u),u.id}_createExtHostEditor(o,r,m){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const a=new w.ExtHostNotebookEditor(r,this._notebookEditorsProxy,o,m.visibleRanges.map(c.NotebookRange.to),m.selections.map(c.NotebookRange.to),typeof m.viewColumn=="number"?c.ViewColumn.to(m.viewColumn):void 0);this._editors.set(r,a)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const m of o.value.removedDocuments){const a=P.URI.revive(m),E=this._documents.get(a);E&&(E.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===a.toString()&&this._editors.delete(n.id)}if(o.value.addedDocuments){const m=[];for(const a of o.value.addedDocuments){const E=P.URI.revive(a.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const n=this,t=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(s){n._onDidChangeNotebookCells.fire(s)},emitCellOutputsChange(s){n._onDidChangeCellOutputs.fire(s)},emitCellMetadataChange(s){n._onDidChangeCellMetadata.fire(s)}},E,a);m.push(...a.cells.map(s=>p.ExtHostCell.asModelAddData(t.apiNotebook,s))),this._documents.get(E)?.dispose(),this._documents.set(E,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(o.value.addedEditors)for(const m of o.value.addedEditors){if(this._editors.has(m.id))return;const a=P.URI.revive(m.documentUri),E=this._documents.get(a);E&&this._createExtHostEditor(E,m.id,m)}const r=[];if(o.value.removedEditors)for(const m of o.value.removedEditors){const a=this._editors.get(m);a&&(this._editors.delete(m),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),r.push(a))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const m=new Set;this._visibleNotebookEditors.forEach(a=>m.add(a.id));for(const a of this._editors.values()){const E=m.has(a.id);a._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=L,L._notebookStatusBarItemProviderHandlePool=0}),define(ve[244],we([0,1,3,77,11,5,14,17]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(y,c){const b=C._Keys.nextId();y.$registerNotebookEditorDecorationType(b,I.NotebookDecorationRenderOptions.from(c)),this.value={key:b,dispose(){y.$removeNotebookEditorDecorationType(b)}}}}C._Keys=new i.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(y,c,b){this._logService=y,this._extHostRpc=c,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new C(this._extHostRpc.getProxy(_.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,c);const b=this._notebooksAndEditors.getEditorById(y);c.visibleRanges&&b._acceptVisibleRanges(c.visibleRanges.ranges.map(I.NotebookRange.to)),c.selections&&b._acceptSelections(c.selections.selections.map(I.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const c in y)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(I.ViewColumn.to(y[c]))}};P=Ve([He(0,k.ILogService),He(1,T.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(ve[245],we([0,1,16,18,21,3,6,24,2,27,11,5,38,17,7,88,211,30,53]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(n,t,s,u,d){this._initData=t,this._extHostNotebook=s,this._commands=u,this._logService=d,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new _.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(y.MainContext.MainThreadNotebookKernels);const h=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",g=>!0,g=>{if(g&&"notebookEditor"in g&&"id"in g){const l=this._extHostNotebook.getIdByEditor(g.notebookEditor);return{id:g.id,extension:g.extension,notebookEditorId:l}}else if(g&&"notebookEditor"in g){const l=this._extHostNotebook.getIdByEditor(g.notebookEditor);if(l===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${g.notebookEditor.document.uri.toString()}`);return{notebookEditorId:l}}return g})],c.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(n,t,s,u,d,h){for(const H of this._kernelData.values())if(H.controller.id===t&&P.ExtensionIdentifier.equals(n.identifier,H.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const g=this._handlePool++,l=this;this._logService.trace(`NotebookController[${g}], CREATED by ${n.identifier.value}, ${t}`);const D=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${n.identifier}'`);let A=!1;const N=new T.DisposableStore,B=new _.Emitter,F=new _.Emitter,O={id:`${n.identifier.value}/${t}`,notebookType:s,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:u||n.identifier.value,preloads:h?h.map(b.NotebookRendererScript.from):[]};let z=d??D,W;this._proxy.$addKernel(g,O).catch(H=>{console.log(H),A=!0});let M=0;const x=()=>{if(A)return;const H=++M;Promise.resolve().then(()=>{H===M&&this._proxy.$updateKernel(g,O)})},V=new I.ResourceMap,U={get id(){return t},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return O.label},set label(H){O.label=H??n.displayName??n.name,x()},get detail(){return O.detail??""},set detail(H){O.detail=H,x()},get description(){return O.description??""},set description(H){O.description=H,x()},get kind(){return(0,L.checkProposedApiEnabled)(n,"notebookControllerKind"),O.kind??""},set kind(H){(0,L.checkProposedApiEnabled)(n,"notebookControllerKind"),O.kind=H,x()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(H){O.supportedLanguages=H,x()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(H){O.supportsExecutionOrder=H,x()},get rendererScripts(){return O.preloads?O.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(H){z=H??D},get interruptHandler(){return W},set interruptHandler(H){W=H,O.supportsInterrupt=Boolean(H),x()},createNotebookCellExecution(H){if(A)throw new Error("notebook controller is DISPOSED");if(!V.has(H.notebook.uri))throw l._logService.trace(`NotebookController[${g}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Y=>Y.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return l._createNotebookCellExecution(H)},dispose:()=>{A||(this._logService.trace(`NotebookController[${g}], DISPOSED`),A=!0,this._kernelData.delete(g),N.dispose(),B.dispose(),F.dispose(),this._proxy.$removeKernel(g))},updateNotebookAffinity(H,Y){l._proxy.$updateNotebookPriority(g,H.uri,Y)},onDidReceiveMessage:F.event,postMessage(H,Y){return(0,L.checkProposedApiEnabled)(n,"notebookMessaging"),l._proxy.$postMessage(g,Y&&l._extHostNotebook.getIdByEditor(Y),H)},asWebviewUri(H){return(0,L.checkProposedApiEnabled)(n,"notebookMessaging"),(0,p.asWebviewUri)(H,l._initData.remote)}};return this._kernelData.set(g,{extensionId:n.identifier,controller:U,onDidReceiveMessage:F,onDidChangeSelection:B,associatedNotebooks:V}),U}$acceptNotebookAssociation(n,t,s){const u=this._kernelData.get(n);if(u){const d=this._extHostNotebook.getNotebookDocument(C.URI.revive(t));s?u.associatedNotebooks.set(d.uri,!0):u.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,d.uri.toString(),s),u.onDidChangeSelection.fire({selected:s,notebook:d.apiNotebook})}}async $executeCells(n,t,s){const u=this._kernelData.get(n);if(!u)return;const d=this._extHostNotebook.getNotebookDocument(C.URI.revive(t)),h=[];for(const g of s){const l=d.getCell(g);l&&h.push(l.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,d.uri.toString(),h.length),await u.controller.executeHandler.call(u.controller,h,d.apiNotebook,u.controller)}catch(g){this._logService.error(`NotebookController[${n}] execute cells FAILED`,g),console.error(g)}}async $cancelCells(n,t,s){const u=this._kernelData.get(n);if(!u)return;const d=this._extHostNotebook.getNotebookDocument(C.URI.revive(t));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,d.apiNotebook);else for(const h of s){const g=d.getCell(h);g&&this._activeExecutions.get(g.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,t,s){const u=this._kernelData.get(n);if(!u)return;const d=this._extHostNotebook.getEditorById(t);u.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:s}))}$cellExecutionChanged(n,t,s){const d=this._extHostNotebook.getNotebookDocument(C.URI.revive(n)).getCell(t);d&&this._onDidChangeCellExecutionState.fire({cell:d.apiCell,state:s??v.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const u=new m(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,u);const d=u.onDidChangeState(()=>{u.state===r.Resolved&&(u.dispose(),d.dispose(),this._activeExecutions.delete(s.uri))});return u.asApiObject()}};o=Ve([He(4,R.ILogService)],o),e.ExtHostNotebookKernels=o;var r;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(r||(r={}));class m extends T.Disposable{constructor(n,t,s){super();this._document=n,this._cell=t,this._proxy=s,this._onDidChangeState=new _.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new a(10,u=>this.update(u)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const t=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new S.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let t=this._cell;if(n&&(t=this._document.getCellFromApiCell(n)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(n){return n.map(t=>{const s=v.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return s===t.items?b.NotebookCellOutput.from(t):b.NotebookCellOutput.from({items:s,id:t.id,metadata:t.metadata})})}async updateOutputs(n,t,s){const u=this.cellIndexToHandle(t),d=this.validateAndConvertOutputs((0,f.asArray)(n));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:u,append:s,outputs:d})}async updateOutputItems(n,t,s){return n=v.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(n),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:n.map(b.NotebookCellOutputItem.from),outputId:t.id,append:s})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(s){n._executionOrder=s,n.update([{editType:w.CellExecutionUpdateType.ExecutionState,uri:n._document.uri,cellHandle:n._cell.handle,executionOrder:n._executionOrder}])},start(s){if(n._state===r.Resolved||n._state===r.Started)throw new Error("Cannot call start again");n._state=r.Started,n._onDidChangeState.fire(),n.update({editType:w.CellExecutionUpdateType.ExecutionState,uri:n._document.uri,cellHandle:n._cell.handle,runStartTime:s})},end(s,u){if(n._state===r.Resolved)throw new Error("Cannot call resolve twice");n._state=r.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._document.uri,n._cell.handle,new S.SerializableObjectWithBuffers({uri:n._document.uri,cellHandle:n._cell.handle,runEndTime:u,lastRunSuccess:s}))},clearOutput(s){return n.verifyStateForOutput(),n.updateOutputs([],s,!1)},appendOutput(s,u){return n.verifyStateForOutput(),n.updateOutputs(s,u,!0)},replaceOutput(s,u){return n.verifyStateForOutput(),n.updateOutputs(s,u,!1)},appendOutputItems(s,u){return n.verifyStateForOutput(),n.updateOutputItems(s,u,!0)},replaceOutputItems(s,u){return n.verifyStateForOutput(),n.updateOutputItems(s,u,!1)}})}}class a{constructor(n,t){this.delay=n,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>n.complete())}}}),define(ve[246],we([0,1,3,5,129,30]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(C,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,P,R){const y=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(P)?.fire({editor:y.apiEditor,message:R})}createRendererMessaging(C,P){if(!C.contributes?.notebookRenderer?.some(b=>b.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const R=(0,_.isProposedApiEnabled)(C,"notebookEditor"),y=new WeakMap;return{onDidReceiveMessage:(b,v,p)=>{const w=R?b:L=>{const S={};y.set(S,L.editor),b({editor:S,message:L.message})};return this.getOrCreateEmitterFor(P).event(w,v,p)},postMessage:(b,v)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,v]=[v,b]);const p=R?v:y.get(v),w=p&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(p);return this.proxy.$postMessage(w?.id,P,b)}}}getOrCreateEmitterFor(C){let P=this._rendererMessageEmitters.get(C);return P||(P=new f.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,P),P)}}e.ExtHostNotebookRenderers=T}),define(ve[133],we([0,1,5,6,4,14,11,212,67,26,44,152,22]),function(X,e,f,i,k,_,T,I,C,P,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class b extends i.Disposable{constructor(w,L,S,o){super();this.id=w,this.name=L,this.logger=S,this.proxy=o,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(w){this.append(w+`
`)}append(w){this.write(w),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const w=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,w)}replace(w){const L=this.offset;this.write(w),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,L),this.visible&&this.logger.flush()}show(w,L){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof w=="boolean"?w:L))}hide(){this.proxy.$close(this.id)}write(w){this.offset+=c.VSBuffer.fromString(w).byteLength,this.logger.info(w)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=b;let v=class{constructor(w,L,S,o,r){this.extHostFileSystem=S,this.extHostFileSystemInfo=o,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=w.getProxy(f.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(L.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.visibleChannelId=w;for(const[L,S]of this.channels)S.visible=L===this.visibleChannelId}createOutputChannel(w,L){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const S=this.doCreateOutputChannel(w,L);return S.then(o=>{this.channels.set(o.id,o),o.visible=o.id===this.visibleChannelId}),this.createExtHostOutputChannel(w,S)}async doCreateOutputChannel(w,L){const S=await this.createOutputDirectory(),o=this.extHostFileSystemInfo.extUri.joinPath(S,`${this.namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),m=await this.proxy.$register(w,!1,o,L.identifier.value);return new b(m,w,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(w,L){let S=!1;const o=()=>{if(S)throw new Error("Channel has been closed")};return{get name(){return w},append(r){o(),L.then(m=>m.append(r))},appendLine(r){o(),L.then(m=>m.appendLine(r))},clear(){o(),L.then(r=>r.clear())},replace(r){o(),L.then(m=>m.replace(r))},show(r,m){o(),L.then(a=>a.show(r,m))},hide(){o(),L.then(r=>r.hide())},dispose(){S=!0,L.then(r=>r.dispose())}}}};v=Ve([He(0,_.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,C.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,T.ILoggerService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(ve[247],we([0,1,18,21,3,6,5,2,7,15,16,48,86,30]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(p,w,L){const S=p.getProxy(T.MainContext.MainThreadQuickOpen);class o{constructor(d,h){this._sessions=new Map,this._instances=0,this._workspace=d,this._commands=h}showQuickPick(d,h,g=i.CancellationToken.None){this._onDidSelectItem=void 0;const l=Promise.resolve(d),D=++this._instances,A=S.$show(D,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},g),N={},B=A.then(()=>N);return Promise.race([B,l]).then(F=>{if(F!==N)return l.then(O=>{const z=[];for(let W=0;W<O.length;W++){const M=O[W];typeof M=="string"?z.push({label:M,handle:W}):M.kind===C.QuickPickItemKind.Separator?z.push({type:"separator",label:M.label}):z.push({label:M.label,description:M.description,detail:M.detail,picked:M.picked,alwaysShow:M.alwaysShow,handle:W})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{h.onDidSelectItem(O[W])}),S.$setItems(D,z),A.then(W=>{if(typeof W=="number")return O[W];if(Array.isArray(W))return W.map(M=>O[M])})})}).then(void 0,F=>{if(!(0,P.isPromiseCanceledError)(F))return S.$setError(D,F),Promise.reject(F)})}$onItemSelected(d){this._onDidSelectItem&&this._onDidSelectItem(d)}showInput(d,h=i.CancellationToken.None){return this._validateInput=d?d.validateInput:void 0,S.$input(d,typeof this._validateInput=="function",h).then(void 0,g=>{if(!(0,P.isPromiseCanceledError)(g))return Promise.reject(g)})}$validateInput(d){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(d)):Promise.resolve(void 0)}async showWorkspaceFolderPick(d,h=i.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!g)return;const l=await this._workspace.getWorkspaceFolders2();if(!!l)return l.find(D=>D.uri.toString()===g.uri.toString())}createQuickPick(d){const h=new t(d,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(d){const h=new s(d,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(d,h){const g=this._sessions.get(d);g&&g._fireDidChangeValue(h)}$onDidAccept(d){const h=this._sessions.get(d);h&&h._fireDidAccept()}$onDidChangeActive(d,h){const g=this._sessions.get(d);g instanceof t&&g._fireDidChangeActive(h)}$onDidChangeSelection(d,h){const g=this._sessions.get(d);g instanceof t&&g._fireDidChangeSelection(h)}$onDidTriggerButton(d,h){const g=this._sessions.get(d);g&&g._fireDidTriggerButton(h)}$onDidTriggerItemButton(d,h,g){const l=this._sessions.get(d);l instanceof t&&l._fireDidTriggerItemButton(h,g)}$onDidHide(d){const h=this._sessions.get(d);h&&h._fireDidHide()}}class r{constructor(d,h){this._extensionId=d,this._onDidDispose=h,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(d){this._title=d,this.update({title:d})}get step(){return this._steps}set step(d){this._steps=d,this.update({step:d})}get totalSteps(){return this._totalSteps}set totalSteps(d){this._totalSteps=d,this.update({totalSteps:d})}get enabled(){return this._enabled}set enabled(d){this._enabled=d,this.update({enabled:d})}get busy(){return this._busy}set busy(d){this._busy=d,this.update({busy:d})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(d){this._ignoreFocusOut=d,this.update({ignoreFocusOut:d})}get value(){return this._value}set value(d){this._value=d,this.update({value:d})}get placeholder(){return this._placeholder}set placeholder(d){this._placeholder=d,this.update({placeholder:d})}get buttons(){return this._buttons}set buttons(d){this._buttons=d.slice(),this._handlesToButtons.clear(),d.forEach((h,g)=>{const l=h===C.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(l,h)}),this.update({buttons:d.map((h,g)=>({...n(h),tooltip:h.tooltip,handle:h===C.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(d){this._value=d,this._onDidChangeValueEmitter.fire(d)}_fireDidTriggerButton(d){const h=this._handlesToButtons.get(d);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,_.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(d){if(!this._disposed){for(const h of Object.keys(d)){const g=d[h];this._pendingUpdate[h]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}r._nextId=1;function m(u){if(u instanceof C.ThemeIcon)return{id:u.id};const d=E(u),h=a(u);return{dark:typeof d=="string"?I.URI.file(d):d,light:typeof h=="string"?I.URI.file(h):h}}function a(u){return typeof u=="object"&&"light"in u?u.light:u}function E(u){return typeof u=="object"&&"dark"in u?u.dark:u}function n(u){const d=m(u.iconPath);let h,g;return"id"in d?g=c.ThemeIcon.asClassName(d):h=d,{iconPath:h,iconClass:g}}class t extends r{constructor(d,h){super(d.identifier,h);this.extension=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(d){d.some(g=>g.kind!==void 0)&&(0,b.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=d.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),d.forEach((g,l)=>{this._handlesToItems.set(l,g),this._itemsToHandles.set(g,l)});const h=[];for(let g=0;g<d.length;g++){const l=d[g];l.kind===C.QuickPickItemKind.Separator?h.push({type:"separator",label:l.label}):h.push({handle:g,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((D,A)=>({...n(D),tooltip:D.tooltip,handle:A}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(d){this._canSelectMany=d,this.update({canSelectMany:d})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(d){this._matchOnDescription=d,this.update({matchOnDescription:d})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(d){this._matchOnDetail=d,this.update({matchOnDetail:d})}get sortByLabel(){return this._sortByLabel}set sortByLabel(d){this._sortByLabel=d,this.update({sortByLabel:d})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(d){this._keepScrollPosition=d,this.update({keepScrollPosition:d})}get activeItems(){return this._activeItems}set activeItems(d){this._activeItems=d.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(d){this._selectedItems=d.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(d){const h=(0,R.coalesce)(d.map(g=>this._handlesToItems.get(g)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(d){const h=(0,R.coalesce)(d.map(g=>this._handlesToItems.get(g)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(d,h){const g=this._handlesToItems.get(d);if(!g||!g.buttons||!g.buttons.length)return;const l=g.buttons[h];l&&this._onDidTriggerItemButtonEmitter.fire({button:l,item:g})}}class s extends r{constructor(d,h){super(d,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(d){this._password=d,this.update({password:d})}get prompt(){return this._prompt}set prompt(d){this._prompt=d,this.update({prompt:d})}get validationMessage(){return this._validationMessage}set validationMessage(d){this._validationMessage=d,this.update({validationMessage:d,severity:d?y.default.Error:y.default.Ignore})}}return new o(w,L)}e.createExtHostQuickOpen=v});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[248],we([0,1,2,3,57,6,18,5,16,101,11,27,86,17,30]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v){"use strict";var p,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function L(h){if(h)return typeof h.iconPath=="string"?f.URI.file(h.iconPath):f.URI.isUri(h.iconPath)||c.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function S(h,g){if(!h.iconPath&&!g.iconPath)return 0;if(h.iconPath){if(!g.iconPath)return 1}else return-1;const l=typeof h.iconPath=="string"?h.iconPath:f.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,D=typeof g.iconPath=="string"?g.iconPath:f.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,P.comparePaths)(l,D)}function o(h,g){let l=0;if(h.strikeThrough!==g.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==g.faded)return h.faded?1:-1;if(h.tooltip!==g.tooltip)return(h.tooltip||"").localeCompare(g.tooltip||"");if(l=S(h,g),l!==0)return l;if(h.light&&g.light)l=S(h.light,g.light);else{if(h.light)return 1;if(g.light)return-1}if(l!==0)return l;if(h.dark&&g.dark)l=S(h.dark,g.dark);else{if(h.dark)return 1;if(g.dark)return-1}return l}function r(h,g){if(h.command!==g.command)return h.command<g.command?-1:1;if(h.title!==g.title)return h.title<g.title?-1:1;if(h.tooltip!==g.tooltip){if(h.tooltip!==void 0&&g.tooltip!==void 0)return h.tooltip<g.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(h.arguments===g.arguments)return 0;if(h.arguments)if(g.arguments){if(h.arguments.length!==g.arguments.length)return h.arguments.length-g.arguments.length}else return 1;else return-1;for(let l=0;l<h.arguments.length;l++){const D=h.arguments[l],A=g.arguments[l];if(D!==A)return D<A?-1:1}return 0}function m(h,g){let l=(0,P.comparePaths)(h.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(l!==0)return l;if(h.command&&g.command)l=r(h.command,g.command);else{if(h.command)return 1;if(g.command)return-1}if(l!==0)return l;if(h.decorations&&g.decorations)l=o(h.decorations,g.decorations);else{if(h.decorations)return 1;if(g.decorations)return-1}return l}function a(h,g){for(let l=0;l<h.length;l++)if(h[l]!==g[l])return!1;return!0}function E(h,g){return h.command===g.command&&h.title===g.title&&h.tooltip===g.tooltip&&(h.arguments&&g.arguments?a(h.arguments,g.arguments):h.arguments===g.arguments)}function n(h,g){return(0,C.equals)(h,g,E)}class t{constructor(g,l,D){this._extension=g,this._sourceControlHandle=D,p.set(this,void 0),this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._visible=!0,tt(this,p,l,"f")}get value(){return this._value}set value(g){g=g??"",Le(this,p,"f").$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){Le(this,p,"f").$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(g){if((0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,Le(this,p,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,Le(this,p,"f").$setInputBoxVisibility(this._sourceControlHandle,g))}showValidationMessage(g,l){(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),Le(this,p,"f").$showValidationMessage(this._sourceControlHandle,g,l)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=t,p=new WeakMap;class s{constructor(g,l,D,A,N){this._proxy=g,this._commands=l,this._sourceControlHandle=D,this._id=A,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,l){const D=this._resourceStatesCommandsMap.get(g);return D?(0,T.asPromise)(()=>this._commands.executeCommand(D.command,...D.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(m),D=(0,C.sortedDiff)(this._resourceSnapshot,g,m).map(B=>{const F=B.toInsert.map(O=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,O);const W=O.resourceUri;let M;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const le=new _.DisposableStore;M=this._commands.converter.toInternal(O.command,le),this._resourceStatesDisposablesMap.set(z,le)}else this._resourceStatesCommandsMap.set(z,O.command);const x=L(O.decorations),V=O.decorations&&L(O.decorations.light)||x,U=O.decorations&&L(O.decorations.dark)||x,H=[V,U],Y=O.decorations&&O.decorations.tooltip||"",se=O.decorations&&!!O.decorations.strikeThrough,K=O.decorations&&!!O.decorations.faded,j=O.contextValue||"";return{rawResource:[z,W,H,Y,se,K,j,M],handle:z}});return{start:B.start,deleteCount:B.deleteCount,toInsert:F}}),A=D.map(({start:B,deleteCount:F,toInsert:O})=>[B,F,O.map(z=>z.rawResource)]),N=D.reverse();for(const{start:B,deleteCount:F,toInsert:O}of N){const z=O.map(M=>M.handle),W=this._handlesSnapshot.splice(B,F,...z);for(const M of W)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=g,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class u{constructor(g,l,D,A,N,B){this._extension=g,this._commands=D,this._id=A,this._label=N,this._rootUri=B,w.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new _.MutableDisposable,this._statusBarDisposables=new _.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=u._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,w,l,"f"),this._inputBox=new t(g,Le(this,w,"f"),this.handle),Le(this,w,"f").$registerSourceControl(this.handle,A,N,B)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,Le(this,w,"f").$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,Le(this,w,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,Le(this,w,"f").$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new _.DisposableStore,this._acceptInputCommand=g;const l=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);Le(this,w,"f").$updateSourceControl(this.handle,{acceptInputCommand:l})}get actionButton(){return(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(g){(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new _.DisposableStore,this._actionButton=g;const l=g!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Le(this,w,"f").$updateSourceControl(this.handle,{actionButton:l??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&n(this._statusBarCommands,g))return;this._statusBarDisposables.value=new _.DisposableStore,this._statusBarCommands=g;const l=(g||[]).map(D=>this._commands.converter.toInternal(D,this._statusBarDisposables.value));Le(this,w,"f").$updateSourceControl(this.handle,{statusBarCommands:l})}get selected(){return this._selected}createResourceGroup(g,l){const D=new s(Le(this,w,"f"),this._commands,this.handle,g,l),A=i.Event.once(D.onDidDispose)(()=>this.createdResourceGroups.delete(D));return this.createdResourceGroups.set(D,A),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const g=[],l=[];for(const[D,A]of this.createdResourceGroups){A.dispose();const N=D.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(D),this.eventuallyUpdateResourceStates()});i.Event.once(D.onDidDispose)(()=>{this.updatedResourceGroups.delete(D),N.dispose(),this._groups.delete(D.handle),Le(this,w,"f").$unregisterGroup(this.handle,D.handle)}),g.push([D.handle,D.id,D.label,D.features]);const B=D._takeResourceStateSnapshot();B.length>0&&l.push([D.handle,B]),this._groups.set(D.handle,D)}Le(this,w,"f").$registerGroups(this.handle,g,l),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(l=>{const D=l._takeResourceStateSnapshot();D.length!==0&&g.push([l.handle,D])}),g.length>0&&Le(this,w,"f").$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),Le(this,w,"f").$unregisterSourceControl(this.handle)}}w=new WeakMap,u._handlePool=0,Ve([(0,k.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),Ve([(0,k.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let d=class Hi{constructor(g,l,D){this._commands=l,this.logService=D,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=g.getProxy(I.MainContext.MainThreadSCM),this._telemetry=g.getProxy(I.MainContext.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const N=this._sourceControls.get(A.sourceControlHandle);if(!N)return A;const B=N.getResourceGroup(A.groupHandle);return B?B.getResourceState(A.handle):A}else if(A&&A.$mid===4){const N=this._sourceControls.get(A.sourceControlHandle);return N?N.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const N=this._sourceControls.get(A.handle);return N||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(g,l,D,A){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,l,D,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const N=Hi._handlePool++,B=new u(g,this._proxy,this._commands,l,D,A);this._sourceControls.set(N,B);const F=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(g.identifier))||[];return F.push(B),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(g.identifier),F),B}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const l=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(g.identifier)),D=l&&l[l.length-1];return D&&D.inputBox}$provideOriginalResource(g,l,D){const A=f.URI.revive(l);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,A.toString());const N=this._sourceControls.get(g);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(A,D)).then(B=>B||null)}$onInputBoxValueChange(g,l){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const D=this._sourceControls.get(g);return D&&D.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(g,l,D,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,l,D);const N=this._sourceControls.get(g);if(!N)return Promise.resolve(void 0);const B=N.getResourceGroup(l);return B?B.$executeResourceCommand(D,A):Promise.resolve(void 0)}$validateInput(g,l,D){this.logService.trace("ExtHostSCM#$validateInput",g);const A=this._sourceControls.get(g);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>A.inputBox.validateInput(l,D)).then(N=>{if(!N)return Promise.resolve(void 0);const B=b.MarkdownString.fromStrict(N.message);return B?Promise.resolve([B,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};d._handlePool=0,d=Ve([He(2,R.ILogService)],d),e.ExtHostSCM=d});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[249],we([0,1,7,5,166,6,17,13]),function(X,e,f,i,k,_,T,I){"use strict";var C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(v,p,w,L,S=f.StatusBarAlignment.Left,o){C.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new _.DisposableStore,tt(this,C,v,"f"),tt(this,P,p,"f"),this._entryId=R.ID_GEN++,this._extension=w,this._id=L,this._alignment=S,this._priority=this.validatePriority(o)}validatePriority(v){if(!!(0,I.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set name(v){this._name=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!R.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){this._command?.fromApi!==v&&(this._internalCommandRegistration.clear(),typeof v=="string"?this._command={fromApi:v,internal:Le(this,P,"f").toInternal({title:"",command:v},this._internalCommandRegistration)}:v?this._command={fromApi:v,internal:Le(this,P,"f").toInternal(v,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Le(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let v;this._extension?this._id?v=`${this._extension.identifier.value}.${this._id}`:v=this._extension.identifier.value:v=this._id;let p;this._name?p=this._name:p=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const L=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Le(this,C,"f").$setEntry(this._entryId,v,p,this._text,L,this._command?.internal,w,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,C=new WeakMap,P=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(v){this._messages=[],this._item=v.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const p={message:v};return this._messages.unshift(p),this._update(),new f.Disposable(()=>{const w=this._messages.indexOf(p);w>=0&&(this._messages.splice(w,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(v,p){this._proxy=v.getProxy(i.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new y(this)}createStatusBarEntry(v,p,w,L){return new R(this._proxy,this._commands,v,p,w,L)}setStatusBarMessage(v,p){const w=this._statusMessage.setMessage(v);let L;return typeof p=="number"?L=setTimeout(()=>w.dispose(),p):typeof p!="undefined"&&p.then(()=>w.dispose(),()=>w.dispose()),new f.Disposable(()=>{w.dispose(),clearTimeout(L)})}}e.ExtHostStatusBar=c}),define(ve[91],we([0,1,5,3,4]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class _{constructor(I){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,C){this._proxy.$registerExtensionStorageKeysToSync(I,C)}getValue(I,C,P){return this._proxy.$getValue(I,C).then(R=>R||P)}setValue(I,C,P){return this._proxy.$setValue(I,C,P)}$acceptValue(I,C,P){this._onDidChangeStorage.fire({shared:I,key:C,value:P})}}e.ExtHostStorage=_,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(ve[68],we([0,1,4,26,11,67,2]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let I=class{constructor(P,R,y){this._logService=R,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(P){return T.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,R=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return T.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return T.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=Ve([He(0,i.IExtHostInitDataService),He(1,k.ILogService),He(2,_.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(ve[34],we([0,1,3,5,4,2,14,6,7,167,15,214,21,33,196,86,13,18]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class S{constructor(u,d,h,g){this._proxy=u,this._id=d,this._creationOptions=h,this._name=g,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(D=>this._pidPromiseComplete=D);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},get state(){return l._state},sendText(D,A=!0){l._checkDisposed(),l._proxy.$sendText(l._id,D,A)},show(D){l._checkDisposed(),l._proxy.$show(l._id,D)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(u,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,w.withNullAsUndefined)(u.shellPath),shellArgs:(0,w.withNullAsUndefined)(u.shellArgs),cwd:(0,w.withNullAsUndefined)(u.cwd),env:(0,w.withNullAsUndefined)(u.env),icon:(0,w.withNullAsUndefined)(n(u.iconPath)),color:p.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,w.withNullAsUndefined)(u.message),strictEnv:(0,w.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(u.location,d?.resolvedExtHostIdentifier),disablePersistence:(0,w.withNullAsUndefined)(u.disablePersistence)})}async createExtensionTerminal(u,d,h,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:p.ThemeColor.isThemeColor(g)?g.id:void 0,location:this._serializeParentTerminal(u,d),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,d){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,d){return u===this._cols&&d===this._rows||u===0||d===0?!1:(this._cols=u,this._rows=d,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=S;class o{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new f.Emitter,this._onDidChangeProperty=new f.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${d}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,d){this._pty.setDimensions?.({columns:u,rows:d})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose?.((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions?.(d=>{d&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this._pty.onDidChangeName?.(d=>{this._onDidChangeProperty.fire({type:"title",value:d})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let r=1,m=class extends I.Disposable{constructor(u,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new v.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[h,g]of this._terminalProcesses)g.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,d){const h=new S(this._proxy,(0,b.generateUuid)(),u,u.name),g=new o(u.pty);return h.createExtensionTerminal(u.location,this._serializeParentTerminal(u,d).resolvedExtHostIdentifier,n(u.iconPath),t(u.color)).then(l=>{const D=this._setupExtHostProcessListeners(l,g);this._terminalProcessDisposables[l]=D}),this._terminals.push(h),h.value}_serializeParentTerminal(u,d){if(d=d||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const h=u.location.parentTerminal;if(h){const g=this._terminals.find(l=>l.value===h);g&&(d.resolvedExtHostIdentifier=g._id)}}else u.location&&typeof u.location!="object"?d.location=u.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(u,d){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const g=new o(d),l=this._setupExtHostProcessListeners(u,g);this._terminalProcessDisposables[u]=l}async $acceptActiveTerminalChanged(u){const d=this._activeTerminal;if(u===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(u);h&&(this._activeTerminal=h,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,d){const h=this._getTerminalById(u);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:d})}async $acceptTerminalDimensions(u,d,h){const g=this._getTerminalById(u);g&&g.setDimensions(d,h)&&this._onDidChangeTerminalDimensions.fire({terminal:g.value,dimensions:g.value.dimensions})}async $acceptTerminalMaximumDimensions(u,d,h){this._terminalProcesses.get(u)?.resize(d,h)}async $acceptTerminalTitleChange(u,d){const h=this._getTerminalById(u);h&&(h.name=d)}async $acceptTerminalClosed(u,d){const h=this._getTerminalObjectIndexById(this._terminals,u);if(h!==null){const g=this._terminals.splice(h,1)[0];g.setExitCode(d),this._onDidCloseTerminal.fire(g.value)}}$acceptTerminalOpened(u,d,h,g){if(d){const A=this._getTerminalObjectIndexById(this._terminals,d);if(A!==null){this._terminals[A]._id=u,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const l={name:g.name,shellPath:g.executable,shellArgs:g.args,cwd:typeof g.cwd=="string"?g.cwd:_.URI.revive(g.cwd),env:g.env,hideFromUser:g.hideFromUser},D=new S(this._proxy,u,l,h);this._terminals.push(D),this._onDidOpenTerminal.fire(D.value),D.isOpen=!0}async $acceptTerminalProcessId(u,d){const h=this._getTerminalById(u);h&&h._setProcessId(d)}async $startExtensionTerminal(u,d){const h=this._getTerminalById(u);if(!h)return{message:(0,P.localize)(0,null,u)};h.isOpen||await new Promise(l=>{const D=this.onDidOpenTerminal(async A=>{A===h.value&&(D.dispose(),l())})});const g=this._terminalProcesses.get(u);g?g.startSendingEvents(d):this._extensionTerminalAwaitingStart[u]={initialDimensions:d}}_setupExtHostProcessListeners(u,d){const h=new I.DisposableStore;h.add(d.onProcessReady(l=>this._proxy.$sendProcessReady(u,l.pid,l.cwd))),h.add(d.onDidChangeProperty(l=>this._proxy.$sendProcessProperty(u,l))),this._bufferer.startBuffering(u,d.onProcessData),h.add(d.onProcessExit(l=>this._onProcessExit(u,l))),this._terminalProcesses.set(u,d);const g=this._extensionTerminalAwaitingStart[u];return g&&d instanceof o&&(d.startSendingEvents(g.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),h}$acceptProcessAckDataEvent(u,d){this._terminalProcesses.get(u)?.acknowledgeDataEvent(d)}$acceptProcessInput(u,d){this._terminalProcesses.get(u)?.input(d)}$acceptTerminalInteraction(u){const d=this._getTerminalById(u);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(u,d,h){try{this._terminalProcesses.get(u)?.resize(d,h)}catch(g){if(g.code!=="EPIPE"&&g.code!=="ERR_IPC_CHANNEL_CLOSED")throw g}}$acceptProcessShutdown(u,d){this._terminalProcesses.get(u)?.shutdown(d)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(d=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(d=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:d}))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,d,h){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,h),this._proxy.$registerProfileProvider(d,u.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(u,d){const h=new c.CancellationTokenSource().token;let g=await this._profileProviders.get(u)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(g&&!("options"in g)&&(g={options:g}),!g||!("options"in g))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in g.options){this.createExtensionTerminal(g.options,d);return}this.createTerminalFromOptions(g.options,d)}}async $provideLinks(u,d){const h=this._getTerminalById(u);if(!h)return[];this._terminalLinkCache.delete(u);const g=this._terminalLinkCancellationSource.get(u);g&&g.dispose(!0);const l=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,l);const D=[],A={terminal:h.value,line:d},N=[];for(const O of this._linkProviders)N.push(L.Promises.withAsyncBody(async z=>{l.token.onCancellationRequested(()=>z({provider:O,links:[]}));const W=await O.provideTerminalLinks(A,l.token)||[];l.token.isCancellationRequested||z({provider:O,links:W})}));const B=await Promise.all(N);if(l.token.isCancellationRequested)return[];const F=new Map;for(const O of B)O&&O.links.length>0&&D.push(...O.links.map(z=>{const W={id:r++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return F.set(W.id,{provider:O.provider,link:z}),W}));return this._terminalLinkCache.set(u,F),D}$activateLink(u,d){const h=this._terminalLinkCache.get(u)?.get(d);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(u,d){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const h=this._terminalProcessDisposables[u];h&&(h.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,d)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,d){const h=this._getTerminalObjectIndexById(u,d);return h!==null?u[h]:null}_getTerminalObjectIndexById(u,d){let h=null;return u.some((g,l)=>g._id===d?(h=l,!0):!1),h}getEnvironmentVariableCollection(u){let d=this._environmentVariableCollections.get(u.identifier.value);return d||(d=new a,this._setEnvironmentVariableCollection(u.identifier.value,d)),d}_syncEnvironmentVariableCollection(u,d){const h=(0,y.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(u,d.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(u){u.forEach(d=>{const h=d[0],g=new a(d[1]);this._setEnvironmentVariableCollection(h,g)})}$acceptDefaultProfile(u,d){this._defaultProfile=u,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(u,d){this._environmentVariableCollections.set(u,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,d)})}};m=Ve([He(1,T.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class a{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,d){this._setIfDiffers(u,{value:d,type:C.EnvironmentVariableMutatorType.Replace})}append(u,d){this._setIfDiffers(u,{value:d,type:C.EnvironmentVariableMutatorType.Append})}prepend(u,d){this._setIfDiffers(u,{value:d,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,d){const h=this.map.get(u);(!h||h.value!==d.value||h.type!==d.type)&&(this.map.set(u,d),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,d){this.map.forEach((h,g)=>u.call(d,g,h,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let E=class extends m{constructor(u){super(!1,u)}createTerminal(u,d,h){throw new R.NotSupportedError}createTerminalFromOptions(u,d){throw new R.NotSupportedError}};E=Ve([He(0,T.IExtHostRpcService)],E),e.WorkerExtHostTerminalService=E;function n(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function t(s){return p.ThemeColor.isThemeColor(s)?s:void 0}});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[250],we([0,1,16,22,21,3,76,47,6,25,13,33,5,14,64,17,7,221,127,89]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let m=class{constructor(A,N){this.resultsChangedEmitter=new _.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(c.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new E(this.proxy),N.registerArgumentProcessor({processArgument:B=>B?.$mid===13?p.TestItem.toItemFromContext(B):B})}createTestController(A,N){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const B=new C.DisposableStore,F=B.add(new L.SingleUseTestCollection(A));F.root.label=N;const O=new Map,z=this.proxy,W={items:F.root.children,get label(){return N},set label(x){N=x,F.root.label=x,z.$updateControllerLabel(A,N)},get id(){return A},createRunProfile:(x,V,U,H,Y)=>{let se=(0,I.hash)(x);for(;O.has(se);)se++;const K=new g(this.proxy,A,se,x,V,U,H,Y);return O.set(se,K),K},createTestItem(x,V,U){return new v.TestItemImpl(A,x,V,U)},createTestRun:(x,V,U=!0)=>this.runTracker.createTestRun(A,F,x,V,U),set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{B.dispose()}};W.createRunConfiguration=W.createRunProfile,z.$registerTestController(A,N),B.add((0,C.toDisposable)(()=>z.$unregisterTestController(A)));const M={controller:W,collection:F,profiles:O};return this.controllers.set(A,M),B.add((0,C.toDisposable)(()=>this.controllers.delete(A))),B.add(F.onDidGenerateDiff(x=>z.$publishDiff(A,x))),W}createTestObserver(){return this.observer.checkout()}async runTests(A,N=k.CancellationToken.None){const B=n(A);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(B.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(O=>O.id)??[F.collection.root.id],profileGroup:l[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:A.exclude?.map(O=>O.id)},N)}$provideFileCoverage(A,N,B){return(0,f.mapFind)(this.runTracker.trackers,O=>O.id===A?O.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(A,N,B,F){return(0,f.mapFind)(this.runTracker.trackers,z=>z.id===A?z.getCoverage(N):void 0)?.resolveFileCoverage(B,F)??Promise.resolve([])}$configureRunProfile(A,N){this.controllers.get(A)?.profiles.get(N)?.configureHandler?.()}$publishTestResults(A){this.results=Object.freeze(A.map(N=>(0,P.deepFreeze)(p.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,N){const B=this.controllers.get(o.TestId.fromString(A).controllerId)?.collection;B&&(await B.expand(A,N<0?1/0:N),B.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,N){const B=this.controllers.get(A.controllerId);if(!B)return;const{collection:F,profiles:O}=B,z=O.get(A.profileId);if(!z)return;const W=A.testIds.map(U=>F.tree.get(U)).filter(R.isDefined),M=A.excludeExtIds.map(U=>B.collection.tree.get(U)).filter(R.isDefined).filter(U=>W.some(H=>H.fullId.compare(U.fullId)===2));if(!W.length)return;const x=new w.TestRunRequest(W.some(U=>U.actual instanceof v.TestItemRootImpl)?void 0:W.map(U=>U.actual),M.map(U=>U.actual),z),V=this.runTracker.prepareForMainThreadTestRun(x,t.fromInternal(A,B.collection),N);try{await z.runHandler(x,N)}finally{V.isRunning&&!N.isCancellationRequested&&await _.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};m=Ve([He(0,b.IExtHostRpcService)],m),e.ExtHostTesting=m;class a extends C.Disposable{constructor(A,N,B){super();this.dto=A,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new _.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const N=this.dto.id,B=this.dto.controllerId,F=(0,y.generateUuid)(),O=new s(this.proxy,N,F),z=V=>(U,...H)=>{if(M){console.warn(`Setting the state of test "${U.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(U)||(this.ensureTestIsKnown(U),V(U,...H))},W=(V,U)=>{const H=U instanceof Array?U.map(p.TestMessage.from):[p.TestMessage.from(U)];if(V.uri&&V.range){const Y={range:p.Range.from(V.range),uri:V.uri};for(const se of H)se.location=se.location||Y}this.proxy.$appendTestMessagesInRun(N,F,o.TestId.fromExtHostTestItem(V,B).toString(),H)};let M=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return O.coverageProvider},set coverageProvider(V){O.coverageProvider=V},enqueued:z(V=>{this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(V,B).toString(),1)}),skipped:z(V=>{this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(V,B).toString(),5)}),started:z(V=>{this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(V,B).toString(),2)}),errored:z((V,U,H)=>{W(V,U),this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(V,B).toString(),6,H)}),failed:z((V,U,H)=>{W(V,U),this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(V,B).toString(),4,H)}),passed:z((V,U)=>{this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,U)}),appendOutput:(V,U,H)=>{M||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(N,F,i.VSBuffer.fromString(V),U&&p.location.from(U),H&&o.TestId.fromExtHostTestItem(H,B).toString()))},end:()=>{M||(M=!0,this.proxy.$finishedTestRunTask(N,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:x,coverage:O}),this.proxy.$startedTestRunTask(N,{id:F,name:A,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof v.TestItemImpl))throw new v.InvalidTestItemError(A.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const N=[],B=this.dto.colllection.root;for(;;){const F=p.TestItem.from(A);if(N.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),A===B))break;A=A.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class E{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,N,B){return this.getTracker(A,N,B)}cancelRunById(A){for(const N of this.tracked.values())if(N.id===A){N.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,N,B,F,O){const z=this.tracked.get(B);if(z)return z.createRun(F);const W=t.fromPublic(A,N,B,O),M=n(B);this.proxy.$startedExtensionTestRun({controllerId:A,profile:M&&{group:l[M.kind],id:M.profileId},exclude:B.exclude?.map(V=>V.id)??[],id:W.id,include:B.include?.map(V=>V.id)??[N.root.id],persist:O});const x=this.getTracker(B,W);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),x.createRun(F)}getTracker(A,N,B){const F=new a(N,this.proxy,B);return this.tracked.set(A,F),F.onEnd(()=>this.tracked.delete(A)),F}}e.TestRunCoordinator=E;const n=D=>{if(!!D.profile){if(!(D.profile instanceof g))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class t{constructor(A,N,B,F,O,z){this.controllerId=A,this.id=N,this.isPersisted=O,this.colllection=z,this.includePrefix=B.map(W=>W+"\0"),this.excludePrefix=F.map(W=>W+"\0")}static fromPublic(A,N,B,F){return new t(A,(0,y.generateUuid)(),B.include?.map(O=>o.TestId.fromExtHostTestItem(O,A).toString())??[A],B.exclude?.map(O=>o.TestId.fromExtHostTestItem(O,A).toString())??[],F,N)}static fromInternal(A,N){return new t(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,N)}isIncluded(A){const N=o.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(N===B||N.startsWith(B))return!1;for(const B of this.includePrefix)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=t;class s{constructor(A,N,B){this.proxy=A,this.runId=N,this.taskId=B}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(A,N){const B=await this.fileCoverage;let F=B?.[A];return!this._coverageProvider||!B||!F?[]:(F.detailedCoverage||(F=B[A]=await this._coverageProvider.resolveFileCoverage?.(F,N)??F),F.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class u extends S.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,p.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:N,removed:B}=this;return{get added(){return[...A].map(F=>F.revived)},get updated(){return[...N].map(F=>F.revived)},get removed(){return[...B].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new _.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,N){return{...A,revived:p.TestItem.toPlain(A.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=d;class h{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(N=>N.revived)},dispose:(0,T.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class g{constructor(A,N,B,F,O,z,W=!1,M=void 0){this.controllerId=N,this.profileId=B,this._label=F,this.kind=O,this.runHandler=z,this._isDefault=W,this._tag=M,r.set(this,void 0),tt(this,r,A,"f");const x=l[O];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${O}`);Le(this,r,"f").$publishTestRunProfile({profileId:B,controllerId:N,tag:M?p.TestTag.namespace(this.controllerId,M.id):null,label:F,group:x,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Le(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Le(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Le(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?p.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Le(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Le(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=g,r=new WeakMap;const l={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(ve[251],we([0,1,3,16,5,130,17,7]),function(X,e,f,i,k,_,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(R,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const y=this._extHostDocumentsAndEditors.allEditors();return R?y:y.map(c=>c.value)}async showTextDocument(R,y,c){let b;typeof y=="number"?b={position:T.ViewColumn.from(y),preserveFocus:c}:typeof y=="object"?b={position:T.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?T.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:b={preserveFocus:!1};const v=await this._proxy.$tryShowTextDocument(R.uri,b),p=v&&this._extHostDocumentsAndEditors.getEditor(v);if(p)return p.value;throw v?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,y){return new _.TextEditorDecorationType(this._proxy,R,y).value}$acceptEditorPropertiesChanged(R,y){const c=this._extHostDocumentsAndEditors.getEditor(R);if(!c)throw new Error("unknown text editor");if(y.options&&c._acceptOptions(y.options),y.selections){const b=y.selections.selections.map(T.Selection.to);c._acceptSelections(b)}if(y.visibleRanges){const b=i.coalesce(y.visibleRanges.map(T.Range.to));c._acceptVisibleRanges(b)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...y.options,lineNumbers:T.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const b=I.TextEditorSelectionChangeKind.fromValue(y.selections.source),v=y.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:v,kind:b})}if(y.visibleRanges){const b=i.coalesce(y.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:b})}}$acceptEditorPositionData(R){for(const y in R){const c=this._extHostDocumentsAndEditors.getEditor(y);if(!c)throw new Error("Unknown text editor");const b=T.ViewColumn.to(R[y]);c.value.viewColumn!==b&&(c._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:b}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=C}),define(ve[252],we([0,1,2,4,5,6,7]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class I{constructor(R,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(k.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const b=c.uri===void 0?void 0:f.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(C(b))?.get(c.handle)}return c}})}async $getTimeline(R,y,c,b,v){return this._providers.get(R)?.provideTimeline(f.URI.revive(y),c,b,v)}registerTimelineProvider(R,y,c,b){const v=new _.DisposableStore,p=this.convertTimelineItem(y.id,b,v).bind(this);let w;y.onDidChange&&(w=y.onDidChange(S=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...S,id:y.id}),this));const L=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:R,onDidChange:void 0,async provideTimeline(S,o,r,m){m?.resetCache&&(v.clear(),L.get(y.id)?.clear());const a=await y.provideTimeline(S,o,r);if(a==null)return;const E=p(S,m);return{...a,source:y.id,items:a.items.map(E)}},dispose(){for(const S of L.values())S.get(y.id)?.clear();w?.dispose(),v.dispose()}})}convertTimelineItem(R,y,c){return(b,v)=>{let p;if(v?.cacheResults){let w=this._itemsBySourceAndUriMap.get(R);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(R,w));const L=C(b);p=w.get(L),p===void 0&&(p=new Map,w.set(L,p))}return w=>{const{iconPath:L,...S}=w,o=`${R}|${w.id??w.timestamp}`;p?.set(o,w);let r,m,a;return w.iconPath&&(L instanceof T.ThemeIcon?a={id:L.id,color:L.color}:f.URI.isUri(L)?(r=L,m=L):{light:r,dark:m}=L),{...S,id:S.id??void 0,handle:o,source:R,command:w.command?y.toInternal(w.command,c):void 0,icon:r,iconDark:m,themeIcon:a,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,_.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=I;function C(P){return P?.toString()}}),define(ve[253],we([0,1,6,10,2,5]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(C){this._openers=new Map,this._proxy=C.getProxy(_.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,P,R,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const c=y.schemes.find(b=>!T.supportedSchemes.has(b));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,R),this._proxy.$registerUriOpener(P,y.schemes,C,y.label),(0,f.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(C,P,R){const y=this._openers.get(C);if(!y)throw new Error(`Unknown opener with id: ${C}`);const c=k.URI.revive(P);return y.canOpenExternalUri(c,R)}async $openUri(C,P,R){const y=this._openers.get(C);if(!y)throw new Error(`Unknown opener id: '${C}'`);return y.openExternalUri(k.URI.revive(P.resolvedUri),{sourceUri:k.URI.revive(P.sourceUri)},R)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(ve[254],we([0,1,5,2,6,15,27]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(P,R){if(this.handles.has(T.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=I.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(P)),this.handlers.set(y,R),this._proxy.$registerUriHandler(y,P),(0,k.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,R){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(i.URI.revive(R))}catch(c){(0,_.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(P){return i.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[69],we([0,1,3,10,2,179,204,88,5]),function(X,e,f,i,k,_,T,I,C){"use strict";var P,R,y,c,b,v,p,w,L,S,o,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(h,g,l,D,A,N,B){P.set(this,void 0),R.set(this,void 0),y.set(this,void 0),c.set(this,void 0),b.set(this,void 0),v.set(this,void 0),p.set(this,""),w.set(this,void 0),L.set(this,!1),S.set(this,!1),o.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new f.Emitter),this._onDidDispose=Le(this,r,"f").event,tt(this,P,h,"f"),tt(this,R,g,"f"),tt(this,w,l,"f"),tt(this,c,D,"f"),tt(this,b,A,"f"),tt(this,v,N,"f"),tt(this,o,a(N),"f"),tt(this,y,B,"f")}dispose(){tt(this,L,!0,"f"),Le(this,r,"f").fire(),Le(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return tt(this,S,!0,"f"),(0,I.asWebviewUri)(h,Le(this,c,"f").remote)}get cspSource(){const h=Le(this,v,"f").extensionLocation;if(h.scheme===i.Schemas.https||h.scheme===i.Schemas.http){let g=h.toString();return g.endsWith("/")||(g+="/"),g+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Le(this,p,"f")}set html(h){this.assertNotDisposed(),Le(this,p,"f")!==h&&(tt(this,p,h,"f"),!Le(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(tt(this,S,!0,"f"),Le(this,y,"f").report("Webview vscode-resource: uris",Le(this,v,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,R,"f").$setHtml(Le(this,P,"f"),h))}get options(){return this.assertNotDisposed(),Le(this,w,"f")}set options(h){this.assertNotDisposed(),Le(this,R,"f").$setOptions(Le(this,P,"f"),t(Le(this,v,"f"),Le(this,b,"f"),h)),tt(this,w,h,"f")}async postMessage(h){if(Le(this,L,"f"))return!1;const g=(0,T.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Le(this,o,"f")});return Le(this,R,"f").$postMessage(Le(this,P,"f"),g.message,...g.buffers)}assertNotDisposed(){if(Le(this,L,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,P=new WeakMap,R=new WeakMap,y=new WeakMap,c=new WeakMap,b=new WeakMap,v=new WeakMap,p=new WeakMap,w=new WeakMap,L=new WeakMap,S=new WeakMap,o=new WeakMap,r=new WeakMap;function a(d){try{const h=(0,_.normalizeVersion)((0,_.parseVersion)(d.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class E{constructor(h,g,l,D,A){this.initData=g,this.workspace=l,this._logService=D,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=h.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(h,g,l){const D=this.getWebview(h);if(D){const{message:A}=(0,T.deserializeWebviewMessage)(g,l.value);D._onMessageEmitter.fire(A)}}$onMissingCsp(h,g){this._logService.warn(`${g} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,g,l){const D=new m(h,this._webviewProxy,s(g),this.initData,this.workspace,l,this._deprecationService);return this._webviews.set(h,D),D._onDidDispose(()=>{this._webviews.delete(h)}),D}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=E;function n(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=n;function t(d,h,g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots||u(d,h)}}e.serializeWebviewOptions=t;function s(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(h=>k.URI.from(h))}}e.reviveOptions=s;function u(d,h){return[...(h?.getWorkspaceFolders()||[]).map(g=>g.uri),d.extensionLocation]}}),define(ve[255],we([0,1,21,47,6,10,23,2,17,69,87,5,7]),function(X,e,f,i,k,_,T,I,C,P,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(a,E){this.document=a,this._storagePath=E,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,E){await this.getEdit(a).undo(),E||this.disposeBackup()}async redo(a,E){await this.getEdit(a).redo(),E||this.disposeBackup()}disposeEdits(a){for(const E of a)this._edits.delete(E)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=r(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const E=this._edits.get(a,0);if(!E)throw new Error("No edit found");return E}}class v{constructor(){this._documents=new Map}get(a,E){return this._documents.get(this.key(a,E))}add(a,E,n){const t=this.key(a,E.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${a} resource:${E.uri}`);const s=new b(E,n);return this._documents.set(t,s),s}delete(a,E){const n=this.key(a,E.uri);this._documents.delete(n)}key(a,E){return`${a}@@@${E}`}}var p;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(p||(p={}));class w{constructor(){this._providers=new Map}addTextProvider(a,E,n){return this.add(0,a,E,n)}addCustomProvider(a,E,n){return this.add(1,a,E,n)}get(a){return this._providers.get(a)}add(a,E,n,t){if(this._providers.has(E))throw new Error(`Provider for viewType:${E} already registered`);return this._providers.set(E,{type:a,extension:n,provider:t}),new c.Disposable(()=>this._providers.delete(E))}}class L{constructor(a,E,n,t,s){this._extHostDocuments=E,this._extensionStoragePaths=n,this._extHostWebview=t,this._extHostWebviewPanels=s,this._editorProviders=new w,this._documents=new v,this._proxy=a.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,E,n,t){const s=new k.DisposableStore;return S(n)?(s.add(this._editorProviders.addTextProvider(E,a,n)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(a),E,t.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(a))):(s.add(this._editorProviders.addCustomProvider(E,a,n)),this.supportEditing(n)&&s.add(n.onDidChangeCustomDocument(u=>{const d=this.getCustomDocumentEntry(E,u.document.uri);if(o(u)){const h=d.addEdit(u);this._proxy.$onDidEdit(u.document.uri,E,h,u.label)}else this._proxy.$onContentChange(u.document.uri,E)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(a),E,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(a))),c.Disposable.from(s,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(E)}))}async $createCustomDocument(a,E,n,t,s){const u=this._editorProviders.get(E);if(!u)throw new Error(`No provider found for '${E}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${E}'`);const d=I.URI.revive(a),h=await u.provider.openCustomDocument(d,{backupId:n,untitledDocumentData:t?.buffer},s);let g;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(g=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(E,h,g),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(a,E){const n=this._editorProviders.get(E);if(!n)throw new Error(`No provider found for '${E}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${E}'`);const t=I.URI.revive(a),{document:s}=this.getCustomDocumentEntry(E,t);this._documents.delete(E,s),s.dispose()}async $resolveWebviewEditor(a,E,n,t,s,u){const d=this._editorProviders.get(n);if(!d)throw new Error(`No provider found for '${n}'`);const h=C.ViewColumn.to(s),g=this._extHostWebview.createNewWebview(E,t.webviewOptions,d.extension),l=this._extHostWebviewPanels.createNewWebviewPanel(E,n,t.title,h,t.panelOptions,g),D=I.URI.revive(a);switch(d.type){case 1:{const{document:A}=this.getCustomDocumentEntry(n,D);return d.provider.resolveCustomEditor(A,l,u)}case 0:{const A=this._extHostDocuments.getDocument(D);return d.provider.resolveCustomTextEditor(A,l,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,E,n){this.getCustomDocumentEntry(E,a).disposeEdits(n)}async $onMoveCustomEditor(a,E,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const s=this._extHostWebviewPanels.getWebviewPanel(a);if(!s)throw new Error("No webview found");const u=I.URI.revive(E),d=this._extHostDocuments.getDocument(u);await t.provider.moveCustomTextEditor(d,s,f.CancellationToken.None)}async $undo(a,E,n,t){return this.getCustomDocumentEntry(E,a).undo(n,t)}async $redo(a,E,n,t){return this.getCustomDocumentEntry(E,a).redo(n,t)}async $revert(a,E,n){const t=this.getCustomDocumentEntry(E,a);await this.getCustomEditorProvider(E).revertCustomDocument(t.document,n),t.disposeBackup()}async $onSave(a,E,n){const t=this.getCustomDocumentEntry(E,a);await this.getCustomEditorProvider(E).saveCustomDocument(t.document,n),t.disposeBackup()}async $onSaveAs(a,E,n,t){const s=this.getCustomDocumentEntry(E,a);return this.getCustomEditorProvider(E).saveCustomDocumentAs(s.document,I.URI.revive(n),t)}async $backup(a,E,n){const t=this.getCustomDocumentEntry(E,a),u=await this.getCustomEditorProvider(E).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},n);return t.updateBackup(u),u.id}getCustomDocumentEntry(a,E){const n=this._documents.get(a,I.URI.revive(E));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(a){const n=this._editorProviders.get(a)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=L;function S(m){return typeof m.resolveCustomTextEditor=="function"}function o(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function r(m){const a=m.scheme===_.Schemas.file||m.scheme===_.Schemas.untitled?m.fsPath:m.toString();return(0,i.hash)(a)+""}});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[256],we([0,1,3,6,2,33,17,69,5,7]),function(X,e,f,i,k,_,T,I,C,P){"use strict";var R,y,c,b,v,p,w,L,S,o,r,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class E extends i.Disposable{constructor(u,d,h,g,l,D,A){super();R.set(this,void 0),y.set(this,void 0),c.set(this,void 0),b.set(this,void 0),v.set(this,void 0),p.set(this,void 0),w.set(this,void 0),L.set(this,void 0),S.set(this,!0),o.set(this,!0),r.set(this,!1),m.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,m,"f").event,a.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=Le(this,a,"f").event,tt(this,R,u,"f"),tt(this,y,d,"f"),tt(this,c,h,"f"),tt(this,v,D,"f"),tt(this,L,l,"f"),tt(this,p,g,"f"),tt(this,b,A,"f")}dispose(){Le(this,r,"f")||(tt(this,r,!0,"f"),Le(this,m,"f").fire(),Le(this,y,"f").$disposeWebview(Le(this,R,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Le(this,b,"f")}get viewType(){return this.assertNotDisposed(),Le(this,c,"f")}get title(){return this.assertNotDisposed(),Le(this,p,"f")}set title(u){this.assertNotDisposed(),Le(this,p,"f")!==u&&(tt(this,p,u,"f"),Le(this,y,"f").$setTitle(Le(this,R,"f"),u))}get iconPath(){return this.assertNotDisposed(),Le(this,w,"f")}set iconPath(u){this.assertNotDisposed(),Le(this,w,"f")!==u&&(tt(this,w,u,"f"),Le(this,y,"f").$setIconPath(Le(this,R,"f"),k.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Le(this,v,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Le(this,L,"f")=="number"&&Le(this,L,"f")<0))return Le(this,L,"f")}get active(){return this.assertNotDisposed(),Le(this,o,"f")}get visible(){return this.assertNotDisposed(),Le(this,S,"f")}_updateViewState(u){Le(this,r,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(tt(this,o,u.active,"f"),tt(this,S,u.visible,"f"),tt(this,L,u.viewColumn,"f"),Le(this,a,"f").fire({webviewPanel:this}))}reveal(u,d){this.assertNotDisposed(),Le(this,y,"f").$reveal(Le(this,R,"f"),{viewColumn:u?T.ViewColumn.from(u):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Le(this,r,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,y=new WeakMap,c=new WeakMap,b=new WeakMap,v=new WeakMap,p=new WeakMap,w=new WeakMap,L=new WeakMap,S=new WeakMap,o=new WeakMap,r=new WeakMap,m=new WeakMap,a=new WeakMap;class n{constructor(u,d,h){this.webviews=d,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,_.generateUuid)()}createWebviewPanel(u,d,h,g,l={}){const D=typeof g=="object"?g.viewColumn:g,A={viewColumn:T.ViewColumn.from(D),preserveFocus:typeof g=="object"&&!!g.preserveFocus},N=(0,I.shouldSerializeBuffersForPostMessage)(u),B=n.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(u),B,d,{title:h,panelOptions:t(l),webviewOptions:(0,I.serializeWebviewOptions)(u,this.workspace,l),serializeBuffersForPostMessage:N},A);const F=this.webviews.createNewWebview(B,l,u);return this.createNewWebviewPanel(B,d,h,D,l,F)}$onDidChangeWebviewPanelViewStates(u){const d=Object.keys(u);d.sort((h,g)=>{const l=u[h],D=u[g];return l.active?1:D.active?-1:+l.visible-+D.visible});for(const h of d){const g=this.getWebviewPanel(h);if(!g)continue;const l=u[h];g._updateViewState({active:l.active,visible:l.visible,viewColumn:T.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,d,h){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:h,extension:u}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(u)}),new P.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(u,d,h,g){const l=this._serializers.get(d);if(!l)throw new Error(`No serializer found for '${d}'`);const{serializer:D,extension:A}=l,N=this.webviews.createNewWebview(u,h.webviewOptions,A),B=this.createNewWebviewPanel(u,d,h.title,g,h.panelOptions,N);await D.deserializeWebviewPanel(B,h.state)}createNewWebviewPanel(u,d,h,g,l,D){const A=new E(u,this._proxy,d,h,g,l,D);return this._webviewPanels.set(u,A),A}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=n;function t(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[257],we([0,1,3,6,69,5,7]),function(X,e,f,i,k,_,T){"use strict";var I,C,P,R,y,c,b,v,p,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class L extends i.Disposable{constructor(r,m,a,E,n,t){super();I.set(this,void 0),C.set(this,void 0),P.set(this,void 0),R.set(this,void 0),y.set(this,!1),c.set(this,void 0),b.set(this,void 0),v.set(this,void 0),p.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=Le(this,p,"f").event,w.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,w,"f").event,tt(this,P,a,"f"),tt(this,b,E,"f"),tt(this,I,r,"f"),tt(this,C,m,"f"),tt(this,R,n,"f"),tt(this,c,t,"f")}dispose(){Le(this,y,"f")||(tt(this,y,!0,"f"),Le(this,w,"f").fire(),Le(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Le(this,b,"f")}set title(r){this.assertNotDisposed(),Le(this,b,"f")!==r&&(tt(this,b,r,"f"),Le(this,C,"f").$setWebviewViewTitle(Le(this,I,"f"),r))}get description(){return this.assertNotDisposed(),Le(this,v,"f")}set description(r){this.assertNotDisposed(),Le(this,v,"f")!==r&&(tt(this,v,r,"f"),Le(this,C,"f").$setWebviewViewDescription(Le(this,I,"f"),r))}get visible(){return Le(this,c,"f")}get webview(){return Le(this,R,"f")}get viewType(){return Le(this,P,"f")}_setVisible(r){r===Le(this,c,"f")||Le(this,y,"f")||(tt(this,c,r,"f"),Le(this,p,"f").fire())}show(r){this.assertNotDisposed(),Le(this,C,"f").$show(Le(this,I,"f"),!!r)}assertNotDisposed(){if(Le(this,y,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,C=new WeakMap,P=new WeakMap,R=new WeakMap,y=new WeakMap,c=new WeakMap,b=new WeakMap,v=new WeakMap,p=new WeakMap,w=new WeakMap;class S{constructor(r,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,m,a,E){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:a,extension:r}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(r),m,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(r,m,a,E,n){const t=this._viewProviders.get(m);if(!t)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:u}=t,d=this._extHostWebview.createNewWebview(r,{},u),h=new L(r,this._proxy,m,a,d,!0);this._webviewViews.set(r,h),await s.resolveWebviewView(h,{state:E},n)}async $onDidChangeWebviewViewVisibility(r,m){this.getWebviewView(r)._setVisible(m)}async $disposeWebviewView(r){const m=this.getWebviewView(r);this._webviewViews.delete(r),m.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const m=this._webviewViews.get(r);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=S}),define(ve[134],we([0,1,3,5,2,10,9,4,14]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class zi{constructor(y){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=y.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,c){let b;if(typeof y=="string"){b=y;try{y=k.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,T.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===_.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,b,c)}async asExternalUri(y,c){if((0,T.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(y,c);return k.URI.from(b)}};P.InitialState={focused:!0},P=Ve([He(0,C.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(ve[258],we([0,1,8,82,33,38,6,5,2,14]),function(X,e,f,i,k,_,T,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends T.Disposable{constructor(c,b){super();const v=c.getProxy(I.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async p=>{const w=C.URI.file((0,f.join)((0,i.tmpdir)(),(0,k.generateUuid)()));return await v.$download(p,w),w})}};R=Ve([He(0,P.IExtHostRpcService),He(1,_.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(ve[259],we([0,1,132,10,188,33]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends f.ExtHostLoggerService{doCreateLogger(C,P,R){return C.scheme===i.Schemas.file?new k.SpdLogLogger(R?.name||(0,_.generateUuid)(),C.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,P):super.doCreateLogger(C,P,R)}}e.ExtHostLoggerService=T}),define(ve[260],we([0,1,60,8,2,68,6,10,18,29]),function(X,e,f,i,k,_,T,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends _.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const E=await super._getWorkspaceStorageURI(a);if(E.scheme!==I.Schemas.file)return E;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${E.fsPath}.`),E;const n=E.fsPath;let t=0;do{let s;t===0?s=n:s=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await y(s);const u=i.join(s,"vscode.lock"),d=await p(this._logService,u,!1);if(d)return this._workspaceStorageLock=d,process.on("exit",()=>{d.dispose()}),k.URI.file(s);t++}while(t<10);return E}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function y(m){try{await P.Promises.stat(m);return}catch{}try{await P.Promises.mkdir(m,{recursive:!0})}catch{}}const c=1e3,b=10*60*1e3;class v extends T.Disposable{constructor(a,E){super();this.logService=a,this.filename=E,this._timer=this._register(new C.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await w(a,E);(!n||n.pid!==process.pid)&&(a.info(`Lock '${E}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(E,new Date,new Date)}catch(t){a.error(t),a.info(`Lock '${E}': Could not update mtime.`)}},c)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const E={pid:process.pid,willReleaseAt:Date.now()+a};await P.Promises.writeFile(this.filename,JSON.stringify(E),{flag:"w"})}catch(E){this.logService.error(E)}}}async function p(m,a,E){try{const t={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(a,JSON.stringify(t),{flag:"wx"})}catch(t){m.error(t)}const n=await w(m,a);return!n||n.pid!==process.pid?E?(m.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),o(m,a)):(m.info(`Lock '${a}': Lock acquired.`),new v(m,a))}async function w(m,a){let E;try{E=await P.Promises.readFile(a)}catch(n){return m.error(n),null}try{return JSON.parse(String(E))}catch(n){return m.error(n),null}}async function L(m,a){let E;try{E=await P.Promises.stat(a)}catch(n){return m.error(n),0}return E.mtime.getTime()}function S(m){try{return process.kill(m,0),!0}catch{return!1}}async function o(m,a){const E=await w(m,a);if(!E)return m.info(`Lock '${a}': Could not read pid of lock holder.`),r(m,a);if(E.willReleaseAt){let d=E.willReleaseAt-Date.now();if(d<5e3){for(d>0?m.info(`Lock '${a}': The lockfile is scheduled to be released in ${d} ms.`):m.info(`Lock '${a}': The lockfile is scheduled to have been released.`);d>0;){if(await(0,C.timeout)(Math.min(100,d)),await L(m,a)===0)return r(m,a);d=E.willReleaseAt-Date.now()}return r(m,a)}}if(!S(E.pid))return m.info(`Lock '${a}': The pid ${E.pid} appears to be gone.`),r(m,a);const n=await L(m,a),t=Date.now()-n;if(t<=b)return m.info(`Lock '${a}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;m.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,C.timeout)(2e3);const s=await L(m,a),u=Date.now()-s;return u<=b?(m.info(`Lock '${a}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(m.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),r(m,a))}async function r(m,a){m.info(`Lock '${a}': Deleting a stale lock.`);try{await P.Promises.unlink(a)}catch{}return p(m,a,!0)}}),define(ve[261],we([0,1,33,14,34]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let _=class extends k.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,C,P){return this.createTerminalFromOptions({name:I,shellPath:C,shellArgs:P})}createTerminalFromOptions(I,C){const P=new k.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),I,I.name);return this._terminals.push(P),P.create(I,this._serializeParentTerminal(I,C)),P.value}};_=Ve([He(0,i.IExtHostRpcService)],_),e.ExtHostTerminalService=_}),define(ve[262],we([0,1,5,14,171,6,26,2,37,23,29,7,12,52,3,121,79,11]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class S{constructor(h,g,l){this.remoteAddress=h,this.localAddress=g,this._dispose=l,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function o(d){const h=d.trim().split(`
`),g=[];return h.forEach(D=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(D);A&&A.length>=3&&g.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),g.reduce((D,A)=>(D[A.socket]=A,D),{})}e.getSockets=o;function r(...d){const h=[].concat(...d.map(a));return[...new Map(h.filter(g=>g.st==="0A").map(g=>{const l=g.local_address.split(":");return{socket:parseInt(g.inode,10),ip:m(l[0]),port:parseInt(l[1],16)}}).map(g=>[g.ip+":"+g.port,g])).values()]}e.loadListeningPorts=r;function m(d){let h="";if(d.length===8)for(let g=d.length-2;g>=0;g-=2)h+=parseInt(d.substr(g,2),16),g!==0&&(h+=".");else for(let g=d.length-4;g>=0;g-=4)h+=parseInt(d.substr(g,4),16).toString(16),g!==0&&(h+=":");return h}e.parseIpAddress=m;function a(d){const h=d.trim().split(`
`),g=h.shift().trim().split(/\s+/).filter(D=>D!=="rx_queue"&&D!=="tm->when");return h.map(D=>D.trim().split(/\s+/).reduce((A,N,B)=>(A[g[B]||B]=N,A),{}))}e.loadConnectionTable=a;function E(d){return!!d.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||d.indexOf("out/vs/server/main.js")!==-1||d.indexOf("_productName=VSCode")!==-1}function n(d){const h=d.trim().split(`
`),g=[];return h.forEach(l=>{const D=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(l);D&&D.length>=4&&g.push({pid:parseInt(D[1],10),ppid:parseInt(D[2]),cmd:D[3]})}),g}e.getRootProcesses=n;async function t(d,h,g){const l=g.reduce((A,N)=>(A[N.pid]=N,A),{}),D=[];return d.forEach(({socket:A,ip:N,port:B})=>{const F=h[A]?h[A].pid:void 0,O=F?l[F]?.cmd:void 0;F&&O&&!E(O)&&D.push({host:N,port:B,detail:O,pid:F})}),D}e.findPorts=t;function s(d,h,g){const l=new Map,D=n(h);for(const A of d){const N=g.get(A.port);if(N){l.set(A.port,N);continue}const B=D.find(F=>F.cmd.includes(`${A.port}`));if(B){let F=B,O;do O=D.find(z=>z.ppid===F.pid),O&&(F=O);while(O);l.set(A.port,{host:A.ip,port:A.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else l.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return l}e.tryFindRootPorts=s;let u=class extends _.Disposable{constructor(h,g,l){super();this.logService=l,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new v.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(f.MainContext.MainThreadTunnelService),c.isLinux&&g.remote.isRemote&&g.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,g){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${g.remoteAddress.host}:${g.remoteAddress.port}.`);const l=await this._proxy.$openTunnel(g,h.displayName);if(l){const D=new S(l.remoteAddress,l.localAddress,()=>this._proxy.$closeTunnel(l.remoteAddress));return this._register(D),D}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,g){const l=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(l,{selector:h,provider:g}),this._proxy.$registerPortsAttributesProvider(h,l),new y.Disposable(()=>{this._portAttributesProviders.delete(l),this._proxy.$unregisterPortsAttributesProvider(l)})}async $providePortAttributes(h,g,l,D,A){const N=[];for(const F of h){const O=this._portAttributesProviders.get(F);if(!O)return[];N.push(...await Promise.all(g.map(async z=>O.provider.providePortAttributes(z,l,D,A))))}const B=N.filter(F=>!!F);return B.length>0?B.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let g=new w.MovingAverage,l;for(;this._candidateFindingEnabled;){const D=new Date().getTime(),A=(await this.findCandidatePorts()).filter(B=>(0,p.isLocalhost)(B.host)||(0,p.isAllInterfaces)(B.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(B=>B.port).join(", ")}`);const N=new Date().getTime()-D;g.update(N),(!l||JSON.stringify(l)!==JSON.stringify(A))&&(l=A,await this._proxy.$onFoundNewCandidates(l)),await new Promise(B=>setTimeout(()=>B(),this.calculateDelay(g.value)))}}async setTunnelExtensionFunctions(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let g=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&g.length===0&&(g=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:g})}}else this._forwardPortProvider=void 0;return(0,_.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,g){if(this._extensionTunnels.has(h.host)){const l=this._extensionTunnels.get(h.host);l.has(h.port)&&(g&&l.get(h.port).disposeListener.dispose(),await l.get(h.port).tunnel.dispose(),l.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,g){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const l=this._forwardPortProvider(h,g);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),l!==void 0){const D=await l;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const A=this._register(D.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(D.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:D,disposeListener:A}),b.TunnelDto.fromApiTunnel(D)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const g=await Promise.all(h.map(D=>this._showCandidatePort(D.host,D.port,D.detail??""))),l=h.filter((D,A)=>g[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(D=>D.port).join(", ")} to ${l.map(D=>D.port).join(", ")}`),l}async findCandidatePorts(){let h="",g="";try{h=await R.Promises.readFile("/proc/net/tcp","utf8"),g=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const l=r(h,g),D=await new Promise(M=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,V,U)=>{M(V)})}),A=o(D),N=await R.Promises.readdir("/proc"),B=[];for(let M of N)try{const x=Number(M),V=P.joinPath(I.URI.file("/proc"),M);if((await R.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(x)){const H=await R.Promises.readlink(P.joinPath(V,"cwd").fsPath),Y=await R.Promises.readFile(P.joinPath(V,"cmdline").fsPath,"utf8");B.push({pid:x,cwd:H,cmd:Y})}}catch{}const F=[],O=l.filter(M=>{const x=A[M.socket];return x||F.push(M),x}),z=t(O,A,B);let W;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const M=await new Promise(x=>{(0,C.exec)("ps -F -A -l | grep root",(V,U,H)=>{x(U)})});this._foundRootPorts=s(F,M,this._foundRootPorts),W=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${W.join(", ")}`)}return z.then(M=>W?M.concat(W):M)}};u=Ve([He(0,i.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,L.ILogService)],u),e.ExtHostTunnelService=u}),define(ve[263],we([0,1,18,22,21,15,3,6,103,227,53]),function(X,e,f,i,k,_,T,I,C,P,R){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(l,D){try{return JSON.stringify(l,D)}catch{return"null"}}const b="$$ref$$",v={[b]:-1};class p{constructor(D,A){this.jsonString=D,this.referencedBuffers=A}}function w(l,D=null,A=!1){const N=[];return{jsonString:(A?c:JSON.stringify)(l,(F,O)=>{if(typeof O=="undefined")return v;if(typeof O=="object"){if(O instanceof i.VSBuffer){const z=N.push(O)-1;return{[b]:z}}if(D)return D(F,O)}return O}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=w;function L(l,D,A){return JSON.parse(l,(N,B)=>{if(B){const F=B[b];if(typeof F=="number")return D[F];if(A&&B.$mid===1)return A.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=L;function S(l,D){return JSON.stringify(l,D)}function o(l){return l?(D,A)=>A&&A.$mid===1?l.transformOutgoing(A):A:null}var r;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},E=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends I.Disposable{constructor(D,A=null,N=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=D,this._logger=A,this._uriTransformer=N,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,F=R.ProxyIdentifier.count;B<F;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(D=>{this._pendingRPCReplies[D].resolveErr(_.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(D){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(D){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(D){this._responsiveState!==D&&(this._responsiveState=D,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(D){return this._uriTransformer?(0,C.transformIncomingURIs)(D,this._uriTransformer):D}getProxy(D){const{nid:A,sid:N}=D;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,N)),this._proxies[A]}_createProxy(D,A){let N={get:(B,F)=>(typeof F=="string"&&!B[F]&&F.charCodeAt(0)===36&&(B[F]=(...O)=>this._remoteCall(D,F,O)),F===n?A:B[F])};return new Proxy(Object.create(null),N)}set(D,A){return this._locals[D.nid]=A,A}assertRegistered(D){for(let A=0,N=D.length;A<N;A++){const B=D[A];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(D){if(this._isDisposed)return;const A=D.byteLength,N=s.read(D,0),B=N.readUInt8(),F=N.readUInt32();switch(B){case 1:case 2:{let{rpcId:O,method:z,args:W}=d.deserializeRequestJSONArgs(N);this._uriTransformer&&(W=(0,C.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(A,F,O,z,W,B===2);break}case 3:case 4:{let{rpcId:O,method:z,args:W}=d.deserializeRequestMixedArgs(N);this._uriTransformer&&(W=(0,C.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(A,F,O,z,W,B===4);break}case 5:{this._logger&&this._logger.logIncoming(A,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(A,F);break}case 7:{this._receiveReply(A,F,void 0);break}case 9:{let O=d.deserializeReplyOKJSON(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReply(A,F,O);break}case 10:{const O=d.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(A,F,O);break}case 8:{let O=d.deserializeReplyOKVSBuffer(N);this._receiveReply(A,F,O);break}case 11:{let O=d.deserializeReplyErrError(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReplyErr(A,F,O);break}case 12:{this._receiveReplyErr(A,F,void 0);break}default:console.error("received unexpected message"),console.error(D)}}_receiveRequest(D,A,N,B,F,O){this._logger&&this._logger.logIncoming(D,A,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(N)}.${B}(`,F);const z=String(A);let W,M;if(O){const V=new k.CancellationTokenSource;F.push(V.token),W=this._invokeHandler(N,B,F),M=()=>V.cancel()}else W=this._invokeHandler(N,B,F),M=a;this._cancelInvokedHandlers[z]=M;const x=d.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(x.byteLength,A,1,"ack"),this._protocol.send(x),W.then(V=>{delete this._cancelInvokedHandlers[z];const U=d.serializeReplyOK(A,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,A,1,"reply:",V),this._protocol.send(U)},V=>{delete this._cancelInvokedHandlers[z];const U=d.serializeReplyErr(A,V);this._logger&&this._logger.logOutgoing(U.byteLength,A,1,"replyErr:",V),this._protocol.send(U)})}_receiveCancel(D,A){this._logger&&this._logger.logIncoming(D,A,1,"receiveCancel");const N=String(A);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(D,A,N){this._logger&&this._logger.logIncoming(D,A,0,"receiveReply:",N);const B=String(A);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],F.resolveOk(N)}_receiveReplyErr(D,A,N){this._logger&&this._logger.logIncoming(D,A,0,"receiveReplyErr:",N);const B=String(A);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let O;N&&(N.$isError?(O=new Error,O.name=N.name,O.message=N.message,O.stack=N.stack):O=N),F.resolveErr(O)}_invokeHandler(D,A,N){try{return Promise.resolve(this._doInvokeHandler(D,A,N))}catch(B){return Promise.reject(B)}}_doInvokeHandler(D,A,N){const B=this._locals[D];if(!B)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(D));let F=B[A];if(typeof F!="function")throw new Error("Unknown method "+A+" on actor "+(0,R.getStringIdentifierForProxy)(D));return F.apply(B,N)}_remoteCall(D,A,N){if(this._isDisposed)return Promise.reject(_.canceled());let B=null;if(N.length>0&&k.CancellationToken.isCancellationToken(N[N.length-1])&&(B=N.pop()),B&&B.isCancellationRequested)return Promise.reject(_.canceled());const F=d.serializeRequestArguments(N,this._uriReplacer),O=++this._lastMessageId,z=String(O),W=new P.LazyPromise;B&&B.onCancellationRequested(()=>{const x=d.serializeCancel(O);this._logger&&this._logger.logOutgoing(x.byteLength,O,0,"cancel"),this._protocol.send(d.serializeCancel(O))}),this._pendingRPCReplies[z]=W,this._onWillSendRequest(O);const M=d.serializeRequest(O,D,A,F,!!B);return this._logger&&this._logger.logOutgoing(M.byteLength,O,0,`request: ${(0,R.getStringIdentifierForProxy)(D)}.${A}(`,N),this._protocol.send(M),W}}e.RPCProtocol=t,y=E,t.UNRESPONSIVE_TIME=3*1e3;class s{constructor(D,A){this._buff=D,this._offset=A}static alloc(D,A,N){let B=new s(i.VSBuffer.alloc(N+1+4),0);return B.writeUInt8(D),B.writeUInt32(A),B}static read(D,A){return new s(D,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(D){this._buff.writeUInt8(D,this._offset),this._offset+=1}readUInt8(){const D=this._buff.readUInt8(this._offset);return this._offset+=1,D}writeUInt32(D){this._buff.writeUInt32BE(D,this._offset),this._offset+=4}readUInt32(){const D=this._buff.readUInt32BE(this._offset);return this._offset+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this._buff.writeUInt8(D.byteLength,this._offset),this._offset+=1,this._buff.set(D,this._offset),this._offset+=D.byteLength}readShortString(){const D=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,N}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readLongString(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,N}writeBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readVSBuffer(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+D);return this._offset+=D,A}static sizeMixedArray(D){let A=0;A+=1;for(let N=0,B=D.length;N<B;N++){const F=D[N];switch(A+=1,F.type){case 1:A+=this.sizeLongString(F.value);break;case 2:A+=this.sizeVSBuffer(F.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(F.value);for(let O=0;O<F.buffers.length;++O)A+=this.sizeVSBuffer(F.buffers[O]);break;case 4:break}}return A}writeMixedArray(D){this._buff.writeUInt8(D.length,this._offset),this._offset+=1;for(let A=0,N=D.length;A<N;A++){const B=D[A];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let F=0;F<B.buffers.length;++F)this.writeBuffer(B.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(D);for(let N=0;N<D;N++)switch(this.readUInt8()){case 1:A[N]=this.readLongString();break;case 2:A[N]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),O=this.readLongString(),z=[];for(let W=0;W<F;++W)z.push(this.readVSBuffer());A[N]=new R.SerializableObjectWithBuffers(L(O,z,null));break}case 4:A[N]=void 0;break}return A}}s.sizeUInt32=4;var u;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(u||(u={}));class d{static _useMixedArgSerialization(D){for(let A=0,N=D.length;A<N;A++)if(D[A]instanceof i.VSBuffer||D[A]instanceof R.SerializableObjectWithBuffers||typeof D[A]=="undefined")return!0;return!1}static serializeRequestArguments(D,A){if(this._useMixedArgSerialization(D)){const N=[];for(let B=0,F=D.length;B<F;B++){const O=D[B];if(O instanceof i.VSBuffer)N[B]={type:2,value:O};else if(typeof O=="undefined")N[B]={type:4};else if(O instanceof R.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:W}=w(O.value,A);N[B]={type:3,value:i.VSBuffer.fromString(z),buffers:W}}else N[B]={type:1,value:i.VSBuffer.fromString(S(O,A))}}return{type:1,args:N}}return{type:0,args:S(D,A)}}static serializeRequest(D,A,N,B,F){switch(B.type){case 0:return this._requestJSONArgs(D,A,N,B.args,F);case 1:return this._requestMixedArgs(D,A,N,B.args,F)}}static _requestJSONArgs(D,A,N,B,F){const O=i.VSBuffer.fromString(N),z=i.VSBuffer.fromString(B);let W=0;W+=s.sizeUInt8(),W+=s.sizeShortString(O),W+=s.sizeLongString(z);let M=s.alloc(F?2:1,D,W);return M.writeUInt8(A),M.writeShortString(O),M.writeLongString(z),M.buffer}static deserializeRequestJSONArgs(D){const A=D.readUInt8(),N=D.readShortString(),B=D.readLongString();return{rpcId:A,method:N,args:JSON.parse(B)}}static _requestMixedArgs(D,A,N,B,F){const O=i.VSBuffer.fromString(N);let z=0;z+=s.sizeUInt8(),z+=s.sizeShortString(O),z+=s.sizeMixedArray(B);let W=s.alloc(F?4:3,D,z);return W.writeUInt8(A),W.writeShortString(O),W.writeMixedArray(B),W.buffer}static deserializeRequestMixedArgs(D){const A=D.readUInt8(),N=D.readShortString(),B=D.readMixedArray(),F=new Array(B.length);for(let O=0,z=B.length;O<z;O++){const W=B[O];typeof W=="string"?F[O]=JSON.parse(W):F[O]=W}return{rpcId:A,method:N,args:F}}static serializeAcknowledged(D){return s.alloc(5,D,0).buffer}static serializeCancel(D){return s.alloc(6,D,0).buffer}static serializeReplyOK(D,A,N){if(typeof A=="undefined")return this._serializeReplyOKEmpty(D);if(A instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(D,A);if(A instanceof R.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:F}=w(A.value,N,!0);return this._serializeReplyOKJSONWithBuffers(D,B,F)}else return this._serializeReplyOKJSON(D,c(A,N))}static _serializeReplyOKEmpty(D){return s.alloc(7,D,0).buffer}static _serializeReplyOKVSBuffer(D,A){let N=0;N+=s.sizeVSBuffer(A);let B=s.alloc(8,D,N);return B.writeVSBuffer(A),B.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static _serializeReplyOKJSON(D,A){const N=i.VSBuffer.fromString(A);let B=0;B+=s.sizeLongString(N);let F=s.alloc(9,D,B);return F.writeLongString(N),F.buffer}static _serializeReplyOKJSONWithBuffers(D,A,N){const B=i.VSBuffer.fromString(A);let F=0;F+=s.sizeUInt32,F+=s.sizeLongString(B);for(const z of N)F+=s.sizeVSBuffer(z);let O=s.alloc(10,D,F);O.writeUInt32(N.length),O.writeLongString(B);for(const z of N)O.writeBuffer(z);return O.buffer}static deserializeReplyOKJSON(D){const A=D.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(D,A){const N=D.readUInt32(),B=D.readLongString(),F=[];for(let O=0;O<N;++O)F.push(D.readVSBuffer());return new R.SerializableObjectWithBuffers(L(B,F,A))}static serializeReplyErr(D,A){return A?this._serializeReplyErrEror(D,A):this._serializeReplyErrEmpty(D)}static _serializeReplyErrEror(D,A){const N=i.VSBuffer.fromString(c(_.transformErrorForSerialization(A),null));let B=0;B+=s.sizeLongString(N);let F=s.alloc(11,D,B);return F.writeLongString(N),F.buffer}static deserializeReplyErrError(D){const A=D.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(D){return s.alloc(12,D,0).buffer}}var h;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var g;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(g||(g={}))}),define(ve[264],we([0,1,4]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(ve[265],we([0,1,28,10,8,12,23,2,4,63,43,222,264]),function(X,e,f,i,k,_,T,I,C,P,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let b=class Vi{constructor(p,w,L,S){this.localUserHome=p,this.remoteAgentService=w,this.environmentService=L,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||_.OS)(),this.resolveUserHome=(async()=>{const o=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=o?.userHome||p})()}async hasValidBasename(p){if(p.scheme===i.Schemas.file||p.scheme===i.Schemas.vscodeRemote){const w=await this.resolveOS;return(0,f.isValidBasename)((0,T.basename)(p),w===1)}return!0}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,w){if(p.remoteAuthority)return i.Schemas.vscodeRemote;const L=(0,P.getVirtualWorkspaceScheme)(w.getWorkspace());if(L)return L;const S=w.getWorkspace().folders[0];if(S)return S.uri.scheme;const o=w.getWorkspace().configuration;return o?o.scheme:i.Schemas.file}async userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?k.win32:k.posix)}async fileURI(p){let w="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const S=p.indexOf("/",2);S===-1?(w=p.substring(2),p="/"):(w=p.substring(2,S),p=p.substring(S)||"/")}return I.URI.from({scheme:i.Schemas.file,authority:w,path:p,query:"",fragment:""})}};b=Ve([He(1,c.IRemoteAgentService),He(2,y.IWorkbenchEnvironmentService),He(3,R.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(ve[70],we([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(T,I){this.line=T,this.character=I}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,I){return new f(0,0)}with(T){return new f(0,0)}}e.Position=f;class i{constructor(T,I,C,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(T,I),this.end=new f(C,P)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new i(0,0,0,0)}with(T){return new i(0,0,0,0)}}e.Range=i;var k;(function(_){_[_.Information=1]="Information",_[_.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[31],we([0,1,16,32,25,28,9,4,8,15,70,13]),function(X,e,f,i,k,_,T,I,C,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",b=" characters skipped \u27EB",v=(c.length+b.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var p;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function L(x){return!!x.preview}e.resultIsMatch=L;function S(x){return!!x.resource}e.isFileMatch=S;function o(x){return!!x.message}e.isProgressMessage=o;var r;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=m;class a{constructor(V,U,H){this.ranges=U;const Y=Array.isArray(U)?U:[U];if(H&&H.matchLines===1&&E(Y)){V=(0,T.getNLines)(V,H.matchLines);let se="",K=0,j=0;const ne=Math.floor(H.charsPerLine/5),le=[];for(const ge of Y){const ke=Math.max(ge.startColumn-ne,0),Me=ge.startColumn+H.charsPerLine;if(ke>j+ne+v){const Ue=c+(ke-j)+b;se+=Ue+V.slice(ke,Me),K+=ke-(j+Ue.length)}else se+=V.slice(j,Me);le.push(new t(0,ge.startColumn-K,ge.endColumn-K)),j=Me}this.preview={text:se,matches:Array.isArray(this.ranges)?le:le[0]}}else{const se=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:V,matches:(0,f.mapArrayOrNot)(U,K=>new n(K.startLineNumber-se,K.startColumn,K.endLineNumber-se,K.endColumn))}}}}e.TextSearchMatch=a;function E(x){const V=x[0].startLineNumber;for(const U of x)if(U.startLineNumber!==V||U.endLineNumber!==V)return!1;return!0}class n{constructor(V,U,H,Y){this.startLineNumber=V,this.startColumn=U,this.endLineNumber=H,this.endColumn=Y}}e.SearchRange=n;class t extends n{constructor(V,U,H){super(V,U,V,H)}}e.OneLineRange=t;var s;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function u(x,V=!0){const U=x&&x.files&&x.files.exclude,H=V&&x&&x.search&&x.search.exclude;if(!U&&!H)return;if(!U||!H)return U||H;let Y=Object.create(null);return Y=k.mixin(Y,k.deepClone(U)),Y=k.mixin(Y,k.deepClone(H),!0),Y}e.getExcludes=u;function d(x,V){return x.excludePattern&&i.match(x.excludePattern,V)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&i.match(x.includePattern,V)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(U=>{const H=U.folder.fsPath;if(_.isEqualOrParent(V,H)){const Y=C.relative(H,V);return!U.includePattern||!!i.match(U.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var h;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class g extends Error{constructor(V,U){super(V);this.code=U}}e.SearchError=g;function l(x){const V=x.message;if((0,P.isPromiseCanceledError)(x))return new g(V,h.canceled);try{const U=JSON.parse(V);return new g(U.message,U.code)}catch{return new g(V,h.other)}}e.deserializeSearchError=l;function D(x){const V={message:x.message,code:x.code};return new Error(JSON.stringify(V))}e.serializeSearchError=D;function A(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=A;function N(x){return x.type==="success"}e.isSerializedSearchSuccess=N;function B(x){return!!x.path}e.isSerializedFileMatch=B;function F(x,V){const U=x.searchPath?x.searchPath:x.relativePath;return(0,T.fuzzyContains)(U,V)}e.isFilePatternMatch=F;class O{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function z(x,V){const U={...x||{},...V||{}};return Object.keys(U).filter(H=>{const Y=U[H];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=z;class W{constructor(V,U){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...U.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let H=V.includePattern;U.includePattern&&(H?H={...H,...U.includePattern}:H=U.includePattern),H&&(this._parsedIncludeExpression=i.parse(H))}matchesExcludesSync(V,U,H){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,U,H))}includedInQuerySync(V,U,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,U,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,U,H))}includedInQuery(V,U,H){const Y=this._parsedExcludeExpression(V,U,H),se=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,U,H):!0;return(0,y.isPromise)(Y)?Y.then(K=>K?!1:se()):se()}hasSiblingExcludeClauses(){return M(this._excludeExpression)}}e.QueryGlobTester=W;function M(x){for(const V in x)if(typeof x[V]!="boolean")return!0;return!1}}),define(ve[35],we([0,1,16,18,21,3,24,10,79,23,9,13,2,169,4,11,189,43,44,26,14,7,31,5]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o,r,m,a,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(D,A,N){return new P.ExtUri(B=>d(B,N)).isEqual(D,A)}function t(D,A,N){return n(D.uri,A.uri,N)?0:(0,R.compare)(D.uri.toString(),A.uri.toString())}function s(D,A,N){return D.index!==A.index?D.index<A.index?-1:1:n(D.uri,A.uri,N)?(0,R.compare)(D.name,A.name):(0,R.compare)(D.uri.toString(),A.uri.toString())}function u(D,A,N,B){const F=D.slice(0).sort((z,W)=>N(z,W,B)),O=A.slice(0).sort((z,W)=>N(z,W,B));return(0,f.delta)(F,O,(z,W)=>N(z,W,B))}function d(D,A){const N=A.getCapabilities(D.scheme);return!(N&&N&1024)}class h extends L.Workspace{constructor(A,N,B,F,O,z,W){super(A,B.map(M=>new L.WorkspaceFolder(M)),F,O,W);this._name=N,this._isUntitled=z,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(W),B.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(A,N,B,F){if(!A)return{workspace:null,added:[],removed:[]};const{id:O,name:z,folders:W,configuration:M,transient:x,isUntitled:V}=A,U=[],H=N;N?W.forEach((j,ne)=>{const le=c.URI.revive(j.uri),ge=h._findFolder(B||N,le,F);ge?(ge.name=j.name,ge.index=j.index,U.push(ge)):U.push({uri:le,name:j.name,index:ne})}):U.push(...W.map(({uri:j,name:ne,index:le})=>({uri:c.URI.revive(j),name:ne,index:le}))),U.sort((j,ne)=>j.index<ne.index?-1:1);const Y=new h(O,z,U,!!x,M?c.URI.revive(M):null,!!V,j=>d(j,F)),{added:se,removed:K}=u(H?H.workspaceFolders:[],Y.workspaceFolders,t,F);return{workspace:Y,added:se,removed:K}}static _findFolder(A,N,B){for(let F=0;F<A.folders.length;F++){const O=A.workspaceFolders[F];if(n(O.uri,N,B))return O}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,N){return N&&this._structure.get(A)&&(A=(0,P.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let g=class{constructor(A,N,B,F){this._onDidChangeWorkspace=new _.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new _.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=B,this._requestIdProvider=new C.Counter,this._barrier=new i.Barrier,this._proxy=A.getProxy(E.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(E.MainContext.MainThreadMessageService);const O=N.workspace;this._confirmedWorkspace=O?new h(O.id,O.name,[],!!O.transient,O.configuration?c.URI.revive(O.configuration):null,!!O.isUntitled,z=>d(z,B)):void 0}$initializeWorkspace(A,N){this._trusted=N,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:I.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,N,B,...F){const O=[];if(Array.isArray(F)&&F.forEach(V=>{c.URI.isUri(V.uri)&&!O.some(U=>n(U.uri,V.uri,this._extHostFileSystemInfo))&&O.push({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[N,B].some(V=>typeof V!="number"||V<0)||B===0&&O.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+B>z.length)return!1;const W=z.slice(0);W.splice(N,B,...O.map(V=>({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<W.length;V++){const U=W[V];if(W.some((H,Y)=>Y!==V&&n(U.uri,H.uri,this._extHostFileSystemInfo)))return!1}W.forEach((V,U)=>V.index=U);const{added:M,removed:x}=u(z,W,s,this._extHostFileSystemInfo);if(M.length===0&&x.length===0)return!1;if(this._proxy){const V=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(V,N,B,O).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,b.localize)(0,null,V,U.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(A,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,N)}async getWorkspaceFolder2(A,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,N)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,N){let B,F="";if(typeof A=="string"?(B=c.URI.file(A),F=A):typeof A!="undefined"&&(B=A,F=A.fsPath),!B)return F;const O=this.getWorkspaceFolder(B,!0);if(!O)return F;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let z=(0,P.relativePath)(O.uri,B);return N&&O.name&&(z=`${O.name}/${z}`),z}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:N,added:B,removed:F}=h.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:F}))}findFiles(A,N,B,F,O=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let z;if(N===null?z=!1:N&&(typeof N=="string"?z=N:z=N.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:M}=l(A);return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(W),(0,y.withUndefinedAsNull)(M),(0,y.withUndefinedAsNull)(z),(0,y.withUndefinedAsNull)(B),O).then(x=>Array.isArray(x)?x.map(V=>c.URI.revive(V)):[])}async findTextInFiles(A,N,B,F,O=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),W=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:M,folder:x}=l(N.include),V=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,U={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:W,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:M,excludePattern:V},H=!1;if(this._activeSearchCallbacks[z]=Y=>{if(H)return;const se=c.URI.revive(Y.resource);Y.results.forEach(K=>{(0,a.resultIsMatch)(K)?B({uri:se,preview:{text:K.preview.text,matches:(0,f.mapArrayOrNot)(K.preview.matches,j=>new m.Range(j.startLineNumber,j.startColumn,j.endLineNumber,j.endColumn))},ranges:(0,f.mapArrayOrNot)(K.ranges,j=>new m.Range(j.startLineNumber,j.startColumn,j.endLineNumber,j.endColumn))}):B({uri:se,text:K.text,lineNumber:K.lineNumber})})},O.isCancellationRequested)return{};try{const Y=await this._proxy.$startTextSearch(A,(0,y.withUndefinedAsNull)(x),U,z,O);return delete this._activeSearchCallbacks[z],Y||{}}catch(Y){throw delete this._activeSearchCallbacks[z],Y}}$handleTextSearchResult(A,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};g=Ve([He(0,r.IExtHostRpcService),He(1,o.IExtHostInitDataService),He(2,S.IExtHostFileSystemInfo),He(3,p.ILogService)],g),e.ExtHostWorkspace=g,e.IExtHostWorkspace=(0,v.createDecorator)("IExtHostWorkspace");function l(D){let A,N;return D&&(typeof D=="string"?A=D:(A=D.pattern,N=D.baseFolder||c.URI.file(D.base))),{includePattern:A,folder:N}}}),define(ve[36],we([0,1,25,3,35,5,7,193,119,13,18,4,14,11,2]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(E,n){if(n){const t=n.split(".");let s=E;for(let u=0;s&&u<t.length;u++)s=s[t[u]];return s}}function w(E){return E instanceof v.URI}function L(E){return E&&E.uri instanceof v.URI&&E.languageId&&typeof E.languageId=="string"}function S(E){return E&&!E.uri&&E.languageId&&typeof E.languageId=="string"}function o(E){return E&&E.uri instanceof v.URI&&(!E.name||typeof E.name=="string")&&(!E.index||typeof E.index=="number")}function r(E){if(w(E))return{resource:E};if(L(E))return{resource:E.uri,overrideIdentifier:E.languageId};if(S(E))return{overrideIdentifier:E.languageId};if(o(E))return{resource:E.uri};if(E===null)return{resource:null}}let m=class{constructor(n,t,s){this._proxy=n.getProxy(_.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=s,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new a(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(n,t))}};m=Ve([He(0,c.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,b.ILogService)],m),e.ExtHostConfiguration=m;class a{constructor(n,t,s,u){this._onDidChangeConfiguration=new i.Emitter,this._proxy=n,this._logService=u,this._extHostWorkspace=t,this._configuration=I.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,s))}getConfiguration(n,t,s){const u=r(t)||{},d=this._toReadonlyValue(n?p(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,u,s?.identifier);function h(l){if(l==null)return null;if(typeof l=="boolean")return l?1:4;switch(l){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const g={has(l){return typeof p(d,l)!="undefined"},get:(l,D)=>{this._validateConfigurationAccess(n?`${n}.${l}`:l,u,s?.identifier);let A=p(d,l);if(typeof A=="undefined")A=D;else{let N;const B=(F,O)=>{let z;const W=()=>{N=N||(0,f.deepClone)(d),z=z||p(N,O)};return(0,P.isObject)(F)?new Proxy(F,{get:(M,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return W(),()=>z;if(N)return z=z||p(N,O),z[x];const V=M[x];return typeof x=="string"?B(V,`${O}.${x}`):V},set:(M,x,V)=>(W(),z&&(z[x]=V),!0),deleteProperty:(M,x)=>(W(),z&&delete z[x],!0),defineProperty:(M,x,V)=>(W(),z&&Object.defineProperty(z,x,V),!0)}):F};A=B(A,l)}return A},update:(l,D,A,N)=>{l=n?`${n}.${l}`:l;const B=h(A);return D!==void 0?this._proxy.$updateConfigurationOption(B,l,D,u,N):this._proxy.$removeConfigurationOption(B,l,u,N)},inspect:l=>{l=n?`${n}.${l}`:l;const D=(0,f.deepClone)(this._configuration.inspect(l,u,this._extHostWorkspace.workspace));if(D)return{key:l,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof d=="object"&&(0,f.mixin)(g,d,!1),Object.freeze(g)}_toReadonlyValue(n){const t=s=>(0,P.isObject)(s)?new Proxy(s,{get:(u,d)=>t(u[d]),set:(u,d,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(u,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(u,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return t(n)}_validateConfigurationAccess(n,t,s){const u=C.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),d=s?`[${s.value}] `:"";if(u===4){typeof t?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){t?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const s=new I.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,d)=>s.affectsConfiguration(u,r(d))})}_toMap(n){return n.reduce((t,s)=>(t.set(s[0],s[1]),t),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[71],we([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,66,213,15]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o,r){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var E;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(E=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(O){function z(x){if(x){const V=x;return V&&!!V.process}else return!1}O.is=z;function W(x){if(x==null)return;const V={process:x.process,args:x.args};return x.options&&(V.options=n.from(x.options)),V}O.from=W;function M(x){if(x!=null)return new T.ProcessExecution(x.process,x.args,x.options)}O.to=M})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(O){function z(M){if(M!=null)return M}O.from=z;function W(M){if(M!=null)return M}O.to=W})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(O){function z(x){if(x){const V=x;return V&&(!!V.commandLine||!!V.command)}else return!1}O.is=z;function W(x){if(x==null)return;const V={};return x.commandLine!==void 0?V.commandLine=x.commandLine:(V.command=x.command,V.args=x.args),x.options&&(V.options=s.from(x.options)),V}O.from=W;function M(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new T.ShellExecution(x.commandLine,x.options):new T.ShellExecution(x.command,x.args?x.args:[],x.options)}O.to=M})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(O){function z(x){if(x){let V=x;return V&&V.customExecution==="customExecution"}else return!1}O.is=z;function W(x){return{customExecution:"customExecution"}}O.from=W;function M(x,V){return V.get(x)}O.to=M})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(O){function z(W,M){let x;return W.scope!==void 0&&typeof W.scope!="number"?x=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===T.TaskScope.Workspace&&M&&M.workspaceFile?x=M.workspaceFile:x=o.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:x}}O.from=z})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(O){function z(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}O.from=z})(g=e.TaskGroupDTO||(e.TaskGroupDTO={}));var l;(function(O){function z(x,V){if(x==null)return[];const U=[];for(let H of x){const Y=W(H,V);Y&&U.push(Y)}return U}O.fromMany=z;function W(x,V){if(x==null)return;let U;x.execution instanceof T.ProcessExecution?U=t.from(x.execution):x.execution instanceof T.ShellExecution?U=u.from(x.execution):x.execution&&x.execution instanceof T.CustomExecution&&(U=d.from(x.execution));const H=a.from(x.definition);let Y;return x.scope?typeof x.scope=="number"?Y=x.scope:Y=x.scope.uri:Y=T.TaskScope.Workspace,!H||!Y?void 0:{_id:x._id,definition:H,name:x.name,source:{extensionId:V.identifier.value,label:x.source,scope:Y},execution:U,isBackground:x.isBackground,group:g.from(x.group),presentationOptions:E.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}O.from=W;async function M(x,V,U){if(x==null)return;let H;t.is(x.execution)?H=t.to(x.execution):u.is(x.execution)?H=u.to(x.execution):d.is(x.execution)&&(H=d.to(x._id,U));const Y=a.to(x.definition);let se;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?se=x.source.scope:se=await V.resolveWorkspaceFolder(f.URI.revive(x.source.scope)):se=T.TaskScope.Workspace),!Y||!se)return;const K=new T.Task(Y,se,x.name,x.source.label,H,x.problemMatchers);return x.isBackground!==void 0&&(K.isBackground=x.isBackground),x.group!==void 0&&(K.group=T.TaskGroup.from(x.group._id),K.group&&x.group.isDefault&&(K.group=new T.TaskGroup(K.group.id,K.group.label),x.group.isDefault&&(K.group.isDefault=x.group.isDefault))),x.presentationOptions&&(K.presentationOptions=E.to(x.presentationOptions)),x._id&&(K._id=x._id),x.detail&&(K.detail=x.detail),K}O.to=M})(l=e.TaskDTO||(e.TaskDTO={}));var D;(function(O){function z(M){return M}O.from=z;function W(M){if(!!M)return Object.assign(Object.create(null),M)}O.to=W})(D=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(z,W,M){this._id=W,this._task=M,m.set(this,void 0),tt(this,m,z,"f")}get task(){return this._task}terminate(){Le(this,m,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}m=new WeakMap;var N;(function(O){function z(W){return{id:W._id,task:void 0}}O.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(z,W,M,x,V,U,H,Y){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=z.getProxy(_.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=x,this._configurationService=V,this._terminalService=U,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,W,M){if(!M)return new T.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:W,provider:M,extension:z}),this._proxy.$registerTaskProvider(x,W),new T.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(z,W){this._proxy.$registerTaskSystem(z,W)}fetchTasks(z){return this._proxy.$fetchTasks(D.from(z)).then(async W=>{const M=[];for(let x of W){const V=await l.to(x,this._workspaceProvider,this._providedCustomExecutions2);V&&M.push(V)}return M})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(W=>z.push(W)),z}terminateTask(z){if(!(z instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,W,M){const x=this._providedCustomExecutions2.get(z.id);x&&(this._activeCustomExecutions2.set(z.id,x),this._terminalService.attachPtyToTerminal(W,await x.callback(M))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const W=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const W=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:W,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const W=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:z.exitCode})}$provideTasks(z,W){const M=this._handlers.get(z);if(!M)return Promise.reject(new Error("no handler found"));const x=[],V=(0,i.asPromise)(()=>M.provider.provideTasks(R.CancellationToken.None)).then(U=>this.provideTasksInternal(W,x,M,U));return new Promise(U=>{V.then(H=>{Promise.all(x).then(()=>{U(H)})})})}async $resolveTask(z,W){const M=this._handlers.get(z);if(!M)return Promise.reject(new Error("no handler found"));if(W.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${M.type}].`);const x=await l.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const V=await M.provider.resolveTask(x,R.CancellationToken.None);if(!V)return;this.checkDeprecation(V,M);const U=l.from(V,M.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(U.execution)&&await this.addCustomExecution(U,V,!0),await this.resolveTaskInternal(U)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,W,M){const x=await this._proxy.$createTaskId(z);!M&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,W.execution)),this._providedCustomExecutions2.set(x,W.execution)}async getTaskExecution(z,W){if(typeof z=="string"){const V=this._taskExecutionPromises.get(z);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let M=this._taskExecutionPromises.get(z.id);if(M)return M;const x=new Promise((V,U)=>{function H(Y,se,K){K?V(new A(Y,se.id,K)):U("Unexpected: Task does not exist.")}W?H(this,z,W):l.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(Y=>H(this,z,Y))});return this._taskExecutionPromises.set(z.id,x),x.then(V=>(this._taskExecutions.set(z.id,V),V),V=>Promise.reject(V))}checkDeprecation(z,W){z._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let M=this._notProvidedCustomExecutions.values(),x=M.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=M.next()}};B=Ve([He(0,c.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,L.ILogService),He(7,S.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let F=class extends B{constructor(z,W,M,x,V,U,H,Y){super(z,W,M,x,V,U,H,Y);this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(z,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const M=l.from(W,z);if(M===void 0)throw new Error("Task is not valid");if(d.is(M.execution))await this.addCustomExecution(M,W,!1);else throw new r.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),W);return this._proxy.$executeTask(M).catch(V=>{throw new Error(V)}),x}provideTasksInternal(z,W,M,x){const V=[];if(x)for(let U of x){this.checkDeprecation(U,M),(!U.definition||!z[U.definition.type])&&this._logService.warn(`The task [${U.source}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`);const H=l.from(U,M.extension);H&&d.is(H.execution)?(V.push(H),W.push(this.addCustomExecution(H,U,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:M.extension}}async resolveTaskInternal(z){if(d.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,W,M){}};F=Ve([He(0,c.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,L.ILogService),He(7,S.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(ve[266],we([0,1,16,75,32,81,24,10,8,23,9,13,2,149,175,116,43,128,265,31]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(h,g,l,D){this.configurationService=h,this.workspaceContextService=g,this.editorGroupsService=l,this.pathService=D}text(h,g,l={}){h=this.getContentPattern(h,l);const D=this.configurationService.getValue(),A=g&&g.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(g?.map(w.toWorkspaceFolder),l),type:2,contentPattern:h,previewOptions:l.previewOptions,maxFileSize:l.maxFileSize,usePCRE2:D.search.usePCRE2||A||!1,beforeContext:l.beforeContext,afterContext:l.afterContext,userDisabledExcludesAndIgnoreFiles:l.disregardExcludeSettings&&l.disregardIgnoreFiles}}getContentPattern(h,g){const l=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const D={...h,wordSeparators:l.editor.wordSeparators};return this.isCaseSensitive(h,g)&&(D.isCaseSensitive=!0),this.isMultiline(h)&&(D.isMultiline=!0),D}file(h,g={}){return{...this.commonQuery(h,g),type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey}}handleIncludeExclude(h,g){return h?(h=Array.isArray(h)?h.map(t):t(h),g?this.parseSearchPaths(h):{pattern:a(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],g={}){const l=this.handleIncludeExclude(g.includePattern,g.expandPatterns),D=this.handleIncludeExclude(g.excludePattern,g.expandPatterns),A=h.length>1,N=(l.searchPaths&&l.searchPaths.length?l.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,g,D)):h.map(O=>this.getFolderQueryForRoot(O,g,D,A))).filter(O=>!!O),B={_reason:g._reason,folderQueries:N,usingSearchPaths:!!(l.searchPaths&&l.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:D.pattern,includePattern:l.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const z=f.coalesce(f.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(x=>x.resource)))).filter(M=>(0,o.pathIncludedInQuery)(B,M.fsPath)),W=this.commonQueryFromFileList(z);return{...B,...W}}const F=g.extraFileResources&&g.extraFileResources.filter(O=>(0,o.pathIncludedInQuery)(B,O.fsPath));return B.extraFileResources=F&&F.length?F:void 0,B}commonQueryFromFileList(h){const g=[],l=new T.ResourceMap,D={};let A=!1;return h.forEach(N=>{if(N.scheme===I.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(N)){const F=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:C.dirname(N.fsPath)});let O=l.get(F);O||(A=!0,O={folder:F,includePattern:{}},g.push(O),l.set(F,O));const z=C.relative(F.fsPath,N.fsPath);(0,y.assertIsDefined)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else N.fsPath&&(A=!0,D[N.fsPath]=!0)}),{folderQueries:g,includePattern:D,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(h,g){if(g.isSmartCase){if(h.isRegExp){if(R.containsUppercaseCharacter(h.pattern,!0))return!0}else if(R.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,b.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const g=W=>C.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),D=(Array.isArray(h)?h:E(h)).map(W=>{const M=this.pathService.resolvedUserHome;return M?(0,_.untildify)(W,M.scheme===I.Schemas.file?M.fsPath:M.path):W}),A=i.groupBy(D,W=>g(W)?"searchPaths":"exprSegments"),N=(A.exprSegments||[]).map(W=>R.rtrim(W,"/")).map(W=>R.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),n(W))),B={},F=this.expandSearchPathPatterns(A.searchPaths||[]);F&&F.length&&(B.searchPaths=F);const O=f.flatten(N),z=a(...O);return z&&(B.pattern=z),B}getExcludesForFolder(h,g){return g.disregardExcludeSettings?void 0:(0,o.getExcludes)(h,!g.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const g=f.flatten(h.map(D=>{let{pathPortion:A,globPortion:N}=m(D);N&&(N=s(N));const B=this.expandOneSearchPath(A);return f.flatten(B.map(F=>this.resolveOneSearchPathPattern(F,N)))})),l=new Map;return g.forEach(D=>{const A=D.searchPath.toString(),N=l.get(A);N?D.pattern&&(N.pattern=N.pattern||{},N.pattern[D.pattern]=!0):l.set(A,{searchPath:D.searchPath,pattern:D.pattern?a(D.pattern):void 0})}),Array.from(l.values())}expandOneSearchPath(h){if(C.isAbsolute(h)){const g=this.workspaceContextService.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==I.Schemas.file?[{searchPath:g[0].uri.with({path:h})}]:[{searchPath:c.URI.file(C.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const g=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=t(h),h.startsWith("../")||h===".."){const D=C.posix.resolve(g.path,h);return[{searchPath:g.with({path:D})}]}const l=s(h);return[{searchPath:g,pattern:l}]}else{if(h==="./"||h===".\\")return[];{const g=h.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(A=>{const N=g.match(new RegExp(`^${R.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return N?{match:N,folder:A}:null}).filter(y.isDefined);if(D.length)return D.map(A=>{const N=A.match[1];return{searchPath:A.folder.uri,pattern:N&&s(N)}});{const A=h.match(/\.[\/\\](.+)[\/\\]?/),N=A?A[1]:h,B=v.localize(0,null,N);throw new Error(B)}}}}resolveOneSearchPathPattern(h,g){const l=h.pattern&&g?`${h.pattern}/${g}`:h.pattern||g,D=[{searchPath:h.searchPath,pattern:l}];return l&&!l.endsWith("**")&&D.push({searchPath:h.searchPath,pattern:l+"/**"}),D}getFolderQueryForSearchPath(h,g,l){const D=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(h.searchPath),g,l,!1);return D?{...D,includePattern:h.pattern}:null}getFolderQueryForRoot(h,g,l,D){let A;const N=c.URI.isUri(h)?h:h.uri;if(l.searchPaths){const W=l.searchPaths.filter(M=>(0,P.isEqual)(M.searchPath,N))[0];if(W&&!W.pattern)return null;W&&(A=W.pattern)}const B=this.configurationService.getValue({resource:N}),O={...this.getExcludesForFolder(B,g)||{},...A||{}},z=c.URI.isUri(h)?(0,P.basename)(h):h.name;return{folder:N,folderName:D?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!B.search.followSymlinks}}};r=Ve([He(0,p.IConfigurationService),He(1,w.IWorkspaceContextService),He(2,L.IEditorGroupsService),He(3,S.IPathService)],r),e.QueryBuilder=r;function m(d){const h=d.match(/[\*\{\}\(\)\[\]\?]/);if(h){const g=h.index,l=d.substr(0,g).match(/[/|\\][^/\\]*$/);if(l){let D=d.substr(0,l.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:d.substr((l.index||0)+1)}}}return{pathPortion:d}}function a(...d){return d.length?d.reduce((h,g)=>(h[g]=!0,h),Object.create(null)):void 0}function E(d){return k.splitGlobAware(d,",").map(h=>h.trim()).filter(h=>!!h.length)}function n(d){return[`**/${d}/**`,`**/${d}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function t(d){return d.replace(/\\/g,"/")}function s(d){return t(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(d,h){d=f.distinct(d,D=>D.toString());const g=[],l=h.getWorkspace();return d&&d.forEach(D=>{let A;if(h.getWorkbenchState()===2)A=(0,P.relativePath)(l.folders[0].uri,D),A&&A!=="."&&(A="./"+A);else{const N=h.getWorkspaceFolder(D);if(N){const B=N.name;if(l.folders.filter(O=>O.name===B).length===1){const O=(0,P.relativePath)(N.uri,D);O===""?A=`./${N.name}`:A=`./${N.name}/${O}`}else A=D.fsPath}}A&&g.push(A)}),g}e.resolveResourcesForSearchIncludes=u}),define(ve[267],we([0,1,23,2,21,15,4,266,31,43]),function(X,e,f,i,k,_,T,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function y(p,w){const L=w.activationEvents;if(!L)return Promise.resolve(void 0);const S=[],o=[];for(const t of L)if(/^workspaceContains:/.test(t)){const s=t.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||p.forceUsingSearch?o.push(s):S.push(s)}if(S.length===0&&o.length===0)return Promise.resolve(void 0);let r;const m=new Promise((t,s)=>{r=t}),a=t=>r({activationEvent:t}),E=Promise.all(S.map(t=>c(p,t,a))).then(()=>{}),n=b(p,w.identifier,o,a);return Promise.all([E,n]).then(()=>{r(void 0)}),m}e.checkActivateWorkspaceContainsExtension=y;async function c(p,w,L){for(const S of p.folders)if(await p.exists(f.joinPath(i.URI.revive(S),w))){L(`workspaceContains:${w}`);return}}async function b(p,w,L,S){if(L.length===0)return Promise.resolve(void 0);const o=new k.CancellationTokenSource,r=p.checkExists(p.folders,L,o.token),m=setTimeout(async()=>{o.cancel(),p.logService.info(`Not activating extension '${w.value}': Timed out while searching for 'workspaceContains' pattern ${L.join(",")}`)},R);let a=!1;try{a=await r}catch(E){_.isPromiseCanceledError(E)||_.onUnexpectedError(E)}o.dispose(),clearTimeout(m),a&&S(`workspaceContains:${L.join(",")}`)}function v(p,w,L,S){const o=p.get(T.IInstantiationService),r=p.get(C.ISearchService),a=o.createInstance(I.QueryBuilder).file(w.map(E=>(0,P.toWorkspaceFolder)(i.URI.revive(E))),{_reason:"checkExists",includePattern:L,exists:!0});return r.fileSearch(a,S).then(E=>!!E.limitHit,E=>_.isPromiseCanceledError(E)?!1:Promise.reject(E))}e.checkGlobFileExists=v});var tt=this&&this.__classPrivateFieldSet||function(X,e,f,i,k){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?k.call(X,f):k?k.value=f:e.set(X,f),f},Le=this&&this.__classPrivateFieldGet||function(X,e,f,i){if(f==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!i:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?i:f==="a"?i.call(X):i?i.value:e.get(X)};define(ve[39],we([0,1,164,8,72,23,18,6,24,2,11,5,36,225,91,35,30,223,15,27,22,199,7,120,4,26,68,14,85,52,34,3,267,90,201,10]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o,r,m,a,E,n,t,s,u,d,h,g,l,D,A,N,B){"use strict";var F,O,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let W=class ji extends I.Disposable{constructor(U,H,Y,se,K,j,ne,le,ge,ke){super();this._onDidChangeRemoteConnectionData=this._register(new l.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=H,this._extHostContext=Y,this._initData=ne,this._extHostWorkspace=se,this._extHostConfiguration=K,this._logService=j,this._extHostTunnelService=ge,this._extHostTerminalService=ke,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new L.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new v.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=le,this._instaService=U.createChild(new d.ServiceCollection([v.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const Me=new Set;this._initData.hostExtensions.forEach(Ue=>Me.add(o.ExtensionIdentifier.toKey(Ue))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ue,q,J)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ue,S.transformErrorForSerialization(q),J)},actualActivateExtension:async(Ue,q)=>{if(Me.has(o.ExtensionIdentifier.toKey(Ue)))return await this._mainThreadExtensionsProxy.$activateExtension(Ue,q),new b.HostExtension;const J=this._registry.getExtensionDescription(Ue);return this._activateExtension(J,q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){S.onUnexpectedError(U)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let U=[];try{U=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch{}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,H){return this._activator.activateByEvent(U,H)}_activateById(U,H){return this._activator.activateById(U,H)}activateByIdWithErrors(U,H){return this._activateById(U,H).then(()=>{const Y=this._activator.getActivatedExtension(U);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}async _realPathExtensionUri(U){if(U.scheme!==B.Schemas.file)return U;const H=await this._hostUtils.realpath(U.fsPath);return P.URI.file(H)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const U=C.TernarySearchTree.forUris(H=>_.extUriBiasedIgnorePathCase.ignorePathCasing(H));for(const H of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(H)){const Y=await this._realPathExtensionUri(H.extensionLocation);U.set(Y,H)}return U})()),this._extensionPathIndex}_deactivate(U){let H=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return H;const Y=this._activator.getActivatedExtension(U);if(!Y)return H;try{typeof Y.module.deactivate=="function"&&(H=Promise.resolve(Y.module.deactivate()).then(void 0,se=>(this._logService.error(se),Promise.resolve(void 0))))}catch(se){this._logService.error(`An error occurred when deactivating the extension '${U.value}':`),this._logService.error(se)}try{(0,I.dispose)(Y.subscriptions)}catch(se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this._logService.error(se)}return H}async _activateExtension(U,H){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,H).then(Y=>{const se=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,se.codeLoadingTime,se.activateCallTime,se.activateResolvedTime,H),this._logExtensionActivationTimes(U,H,"success",se),Y},Y=>{throw this._logExtensionActivationTimes(U,H,"failure"),Y})}_logExtensionActivationTimes(U,H,Y,se){const K=M(U,H);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...se||{},outcome:Y})}_doActivateExtension(U,H){const Y=M(U,H);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const se=this._getEntryPoint(U);if(!se)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${H.startup}, activationEvent: '${H.activationEvent}'${U.identifier.value!==H.extensionId.value?`, root cause: ${H.extensionId.value}`:""}`),this._logService.flush();const K=new b.ExtensionActivationTimesBuilder(H.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,_.joinPath)(U.extensionLocation,se),K),this._loadExtensionContext(U)]).then(j=>(k.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),ji._callActivate(this._logService,U.identifier,j[0],j[1],K))).then(j=>(k.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),j))}_loadExtensionContext(U){const H=new m.ExtensionGlobalMemento(U,this._storage),Y=new m.ExtensionMemento(U.identifier.value,!1,this._storage),se=new N.ExtensionSecrets(U,this._secretState),K=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,j=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([H.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const ne=this;let le;return Object.freeze({globalState:H,workspaceState:Y,secrets:se,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(ge){return i.join(U.extensionLocation.fsPath,ge)},get storagePath(){return ne._storagePath.workspaceValue(U)?.fsPath},get globalStoragePath(){return ne._storagePath.globalValue(U).fsPath},get logPath(){return i.join(ne._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return P.URI.joinPath(ne._initData.logsLocation,U.identifier.value)},get storageUri(){return ne._storagePath.workspaceValue(U)},get globalStorageUri(){return ne._storagePath.globalValue(U)},get extensionMode(){return K},get extension(){return le===void 0&&(le=new x(ne,U.identifier,U,j)),le},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(U,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne._extHostTerminalService.getEnvironmentVariableCollection(U)}})})}static _callActivate(U,H,Y,se,K){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,H,Y,se,K).then(j=>new b.ActivatedExtension(!1,null,K.build(),Y,j,se.subscriptions))}static _callActivateOptional(U,H,Y,se,K){if(typeof Y.activate=="function")try{K.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${H.value}`);const j=typeof global=="object"?global:self,ne=Y.activate.apply(j,[se]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(ne).then(le=>(K.activateResolveStop(),le))}catch(j){return Promise.reject(j)}else return Promise.resolve(Y)}_activateOneStartupFinished(U,H){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:H}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const H of U.activationEvents)H==="onStartupFinished"&&this._activateOneStartupFinished(U,H)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._register(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const H=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(H),se=Promise.all([U,Y]).then(()=>{});return Promise.race([se,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),se}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(H=>this._handleWorkspaceContainsEagerExtension(U,H))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,H){if(this.isActivated(H.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,se={logService:this._logService,folders:U.map(j=>j.uri),forceUsingSearch:Y,exists:j=>this._hostUtils.exists(j.fsPath),checkExists:(j,ne,le)=>this._mainThreadWorkspaceProxy.$checkExists(j,ne,le)},K=await(0,D.checkActivateWorkspaceContainsExtension)(se,H);if(!!K)return this._activateById(H.identifier,{startup:!0,extensionId:H.identifier,activationEvent:K.activationEvent}).then(void 0,j=>this._logService.error(j))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(U){throw console.error(U),U}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:H}=this._initData.environment;if(!U||!H)throw new Error(f.localize(0,null));const Y=await this._loadCommonJSModule(null,H,new b.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(f.localize(1,null,H.toString()));return new Promise((se,K)=>{const j=(ge,ke)=>{ge?K(ge):se(typeof ke=="number"&&ke>0?1:0)},ne=(0,_.originalFSPath)(H),le=Y.run(ne,j);le&&le.then&&le.then(()=>{se(0)}).catch(ge=>{K(ge instanceof Error&&ge.stack?ge.stack:String(ge))})})}async $extensionTestsExit(U){this._logService.info(`Extension host terminating: test runner requested exit with code ${U}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,H){return this._resolvers[U]=H,(0,I.toDisposable)(()=>{delete this._resolvers[U]})}async _activateAndGetResolver(U){const H=U.indexOf("+");if(H===-1)throw new Error("Not an authority that can be resolved!");const Y=U.substr(0,H);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(U,H){const{authorityPrefix:Y,resolver:se}=await this._activateAndGetResolver(U);if(!se)return{type:"error",error:{code:E.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(se)),k.mark(`code/extHost/willResolveAuthority/${Y}`);const K=await se.resolve(U,{resolveAttempt:H});k.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const j={authority:U,host:K.host,port:K.port,connectionToken:K.connectionToken},ne={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted,authenticationSession:K.authenticationSessionForInitializingExtensions?{id:K.authenticationSessionForInitializingExtensions.id,providerId:K.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:j,options:ne,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(k.mark(`code/extHost/didResolveAuthorityError/${Y}`),K instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(U,H){const{authorityPrefix:Y,resolver:se}=await this._activateAndGetResolver(U);if(!se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${Y}`);const K=P.URI.revive(H);if(typeof se.getCanonicalURI=="undefined")return K;const j=await(0,T.asPromise)(()=>se.getCanonicalURI(K));return j||K}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,H){return H===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(U,!1))}async $activate(U,H){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,H),!0):!1}async $deltaExtensions(U,H){U.forEach(se=>se.extensionLocation=P.URI.revive(se.extensionLocation));const Y=await this.getExtensionPathIndex();return await Promise.all(H.map(async se=>{const K=this._registry.getExtensionDescription(se);K&&Y.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(U.map(async se=>{const K=await this._realPathExtensionUri(se.extensionLocation);Y.set(K,se)})),this._registry.deltaExtensions(U,H),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let H=r.VSBuffer.alloc(U),Y=Math.random()%256;for(let se=0;se<U;se++)H.writeUInt8(Y,se);return H}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};W=Ve([He(0,n.IInstantiationService),He(1,e.IHostUtils),He(2,u.IExtHostRpcService),He(3,p.IExtHostWorkspace),He(4,c.IExtHostConfiguration),He(5,R.ILogService),He(6,t.IExtHostInitDataService),He(7,s.IExtensionStoragePaths),He(8,h.IExtHostTunnelService),He(9,g.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function M(V,U){return{id:V.identifier.value,name:V.name,extensionVersion:V.version,publisherDisplayName:V.publisher,activationEvents:V.activationEvents?V.activationEvents.join(","):null,isBuiltin:V.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class x{constructor(U,H,Y,se){F.set(this,void 0),O.set(this,void 0),z.set(this,void 0),tt(this,F,U,"f"),tt(this,O,H,"f"),tt(this,z,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=i.normalize((0,_.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=se}get isActive(){return Le(this,F,"f").isActivated(Le(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Le(this,F,"f").getExtensionExports(Le(this,z,"f"))}activate(){return Le(this,F,"f").activateByIdWithErrors(Le(this,z,"f"),{startup:!1,extensionId:Le(this,O,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,F=new WeakMap,O=new WeakMap,z=new WeakMap}),define(ve[55],we([0,1,8,2,3,18,5,7,124,35,39,45,215,36,208,14,4,13,40,54]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let r=class{constructor(d,h,g,l,D,A){this._workspaceService=h,this._extensionService=g,this._editorsService=l,this._configurationService=D,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=d.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(B=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,h){const g=d;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let l=`debug:${encodeURIComponent(g.path||"")}`,D="?";return h&&(l+=`${D}session=${encodeURIComponent(h.id)}`,D="&"),l+=`${D}ref=${g.sourceReference}`,i.URI.parse(l)}else{if(g.path)return i.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const h=[];for(const g of d.getAllExtensionDescriptions())if(g.contributes){const l=g.contributes.debuggers;if(l&&l.length>0)for(const D of l)(0,v.isDebuggerMainContribution)(D)&&h.push(D.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(h=>d.push(h)),d}addBreakpoints(d){this.startBreakpoints();const h=d.filter(D=>{const A=D.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,D),!0)});this.fireBreakpointChanges(h,[],[]);const g=[],l=new Map;for(const D of h)if(D instanceof I.SourceBreakpoint){let A=l.get(D.location.uri.toString());A||(A={type:"sourceMulti",uri:D.location.uri,lines:[]},l.set(D.location.uri.toString(),A),g.push(A)),A.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof I.FunctionBreakpoint&&g.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(g)}removeBreakpoints(d){this.startBreakpoints();const h=d.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],h,[]);const g=h.filter(A=>A instanceof I.SourceBreakpoint).map(A=>A.id),l=h.filter(A=>A instanceof I.FunctionBreakpoint).map(A=>A.id),D=h.filter(A=>A instanceof I.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(g,l,D)}startDebugging(d,h,g){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,h,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,debugUI:g.debugUI,suppressSaveBeforeStart:g.suppressSaveBeforeStart})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,h,g){if(!h)return new I.Disposable(()=>{});const l=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:l,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,g,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,l),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(d,h,g){if(!g)return new I.Disposable(()=>{});if(!this.definesDebugType(d,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:l,factory:g}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,l),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==g),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(d,h){if(!h)return new I.Disposable(()=>{});const g=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:g,factory:h}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(l=>l.factory!==h)})}async $runInTerminal(d,h){return Promise.resolve(void 0)}async $substituteVariables(d,h){if(!this._variableResolver){const[D,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,A)}let g;const l=await this.getFolder(d);return l&&(g={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(g,h)}createDebugAdapter(d,h){if(d.type==="implementation")return new t(d.implementation)}createSignService(){}async $startDASession(d,h){const g=this,l=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(l.type),l).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const A=this.convertToDto(D),N=this.createDebugAdapter(A,l);if(!N)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const B=N;return this._debugAdapters.set(d,B),this.getDebugAdapterTrackers(l).then(F=>(F&&this._debugAdaptersTrackers.set(d,F),B.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const z=O,W={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(z.arguments.value);W.body={signature:M},B.sendResponse(W)}else throw new Error("no signer")}catch(M){W.success=!1,W.message=M.message,B.sendResponse(W)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(O),O=(0,v.convertToVSCPaths)(O,!0),g._debugServiceProxy.$acceptDAMessage(d,O)}),B.onError(O=>{F&&F.onError&&F.onError(O),this._debugServiceProxy.$acceptDAError(d,O.name,O.message,O.stack)}),B.onExit(O=>{F&&F.onExit&&F.onExit((0,L.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,L.withNullAsUndefined)(O),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),B.startSession()))})}$sendDAMessage(d,h){h=(0,v.convertToDAPaths)(h,!1);const g=this._debugAdaptersTrackers.get(d);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(h);const l=this._debugAdapters.get(d);l&&l.sendMessage(h)}$stopDASession(d){const h=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),h&&h.onWillStopSession&&h.onWillStopSession();const g=this._debugAdapters.get(d);return this._debugAdapters.delete(d),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const h=[],g=[],l=[];if(d.added)for(const D of d.added){const A=D.id;if(A&&!this._breakpoints.has(A)){let N;if(D.type==="function")N=new I.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")N=new I.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const B=i.URI.revive(D.uri);N=new I.SourceBreakpoint(new I.Location(B,new I.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}N._id=A,this._breakpoints.set(A,N),h.push(N)}}if(d.removed)for(const D of d.removed){const A=this._breakpoints.get(D);A&&(this._breakpoints.delete(D),g.push(A))}if(d.changed){for(const D of d.changed)if(D.id){const A=this._breakpoints.get(D.id);if(A){if(A instanceof I.FunctionBreakpoint&&D.type==="function"){const N=A;N.enabled=D.enabled,N.condition=D.condition,N.hitCondition=D.hitCondition,N.logMessage=D.logMessage,N.functionName=D.functionName}else if(A instanceof I.SourceBreakpoint&&D.type==="source"){const N=A;N.enabled=D.enabled,N.condition=D.condition,N.hitCondition=D.hitCondition,N.logMessage=D.logMessage,N.location=new I.Location(i.URI.revive(D.uri),new I.Position(D.line,D.character))}l.push(A)}}}this.fireBreakpointChanges(h,g,l)}$provideDebugConfigurations(d,h,g){return(0,_.asPromise)(async()=>{const l=this.getConfigProviderByHandle(d);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(h);return l.provideDebugConfigurations(D,g)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(d,h,g,l){return(0,_.asPromise)(async()=>{const D=this.getConfigProviderByHandle(d);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(h);return D.resolveDebugConfiguration(A,g,l)})}$resolveDebugConfigurationWithSubstitutedVariables(d,h,g,l){return(0,_.asPromise)(async()=>{const D=this.getConfigProviderByHandle(d);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(h);return D.resolveDebugConfigurationWithSubstitutedVariables(A,g,l)})}async $provideDebugAdapter(d,h){const g=this.getAdapterDescriptorFactoryByHandle(d);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.getSession(h);return this.getAdapterDescriptor(g,l).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(d){const h=await this.getSession(d);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(d){const h=await this.getSession(d);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,h){const g=await this.getSession(d);g&&g._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(d,h){const l={session:await this.getSession(d),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(l)}convertToDto(d){if(d instanceof I.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof I.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const h=this._adapterFactories.filter(g=>g.type===d);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(d){const h=this._adapterFactories.filter(g=>g.handle===d);if(h.length>0)return h[0].factory}getConfigProviderByHandle(d){const h=this._configProviders.filter(g=>g.handle===d);if(h.length>0)return h[0].provider}definesDebugType(d,h){if(d.contributes){const g=d.contributes.debuggers;if(g&&g.length>0){for(const l of g)if(l.label&&l.type&&l.type===h)return!0}}return!1}getDebugAdapterTrackers(d){const g=d.configuration.type,l=this._trackerFactories.filter(D=>D.type===g||D.type==="*").map(D=>(0,_.asPromise)(()=>D.factory.createDebugAdapterTracker(d)).then(A=>A,A=>null));return Promise.race([Promise.all(l).then(D=>{const A=D.filter(N=>!!N);if(A.length>0)return new n(A)}),new Promise((D,A)=>{const N=setTimeout(()=>{clearTimeout(N),A(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(d,h){const g=h.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new I.DebugAdapterServer(g));if(d){const D=await this._extensionService.getExtensionRegistry();return(0,_.asPromise)(()=>d.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,D))).then(A=>{if(A)return A})}const l=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,l))}daExecutableFromPackage(d,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,h,g){(d.length>0||h.length>0||g.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:h,changed:g}))}async getSession(d){if(d)if(typeof d=="string"){const h=this._debugSessions.get(d);if(h)return h}else{let h=this._debugSessions.get(d.id);if(!h){const g=await this.getFolder(d.folderUri),l=d.parent?this._debugSessions.get(d.parent):void 0;h=new m(this._debugServiceProxy,d.id,d.type,d.name,g,d.configuration,l),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(d){if(d){const h=i.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};r=Ve([He(0,p.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class m{constructor(d,h,g,l,D,A,N){this._debugServiceProxy=d,this._id=h,this._type=g,this._name=l,this._workspaceFolder=D,this._configuration=A,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,h)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=m;class a{constructor(d){this.value=Object.freeze({append(h){d.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=a;class E extends c.AbstractVariableResolverService{constructor(d,h,g,l,D){function A(){if(h){const N=h.activeEditor();if(N)return N.document.uri;const B=l.tabs.filter(F=>F.isActive);if(B.length>0){const F=B[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:B[0].resource}}}super({getFolderUri:N=>{const B=d.filter(F=>F.name===N);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(N,B)=>g.getConfiguration(void 0,N).get(B),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=A();if(N)return f.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const N=A();if(N){const B=D.getWorkspaceFolder(N);if(B)return f.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(h){const N=h.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(h){const N=h.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=E;class n{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(h=>h.onError?h.onError(d):void 0)}onExit(d,h){this.trackers.forEach(g=>g.onExit?g.onExit(d,h):void 0)}}class t extends C.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends r{constructor(d,h,g,l,D,A){super(d,h,g,l,D,A)}createVariableResolver(d,h,g){return new E(d,h,g,this._editorTabs)}};s=Ve([He(0,p.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],s),e.WorkerExtHostDebugService=s}),define(ve[268],we([0,1,72,2,5,36,30,27,14,26,4,39,40,11]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let v=class{constructor(o,r,m,a,E,n,t){this._apiFactory=o,this._extensionRegistry=r,this._instaService=m,this._extHostConfiguration=a,this._extHostExtensionService=E,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,r,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(w,r)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(L,r,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let r of o.nodeModuleName)this._factories.set(r,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(r=>o.alternativeModuleName(r))}};v=Ve([He(2,R.IInstantiationService),He(3,_.IExtHostConfiguration),He(4,y.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,b.ILogService)],v),e.RequireInterceptor=v;class p{constructor(o,r,m,a,E){this._apiFactory=o,this._extensionPaths=r,this._extensionRegistry=m,this._configProvider=a,this._logService=E,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,r){const m=this._extensionPaths.findSubstr(r);if(m){let a=this._extApiImpl.get(I.ExtensionIdentifier.toKey(m.identifier));return a||(a=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(m.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((E,n)=>a+=`	${n} -> ${E.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(o,r,m){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(k.MainContext.MainThreadTelemetry);const{environment:a}=m,E=r.getProxy(k.MainContext.MainThreadKeytar);if(a.appRoot){let n=a.appRoot.fsPath;c.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>E.$getPassword(n,t),setPassword:(n,t,s)=>E.$setPassword(n,t,s),deletePassword:(n,t)=>E.$deletePassword(n,t),findPassword:n=>E.$findPassword(n),findCredentials(n){return E.$findCredentials(n)}}}load(o,r){const m=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:m?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const r=o.length;if(r<=7||!this.alternativeNames)return;const m=r-7;if((o.charAt(m)==="/"||o.charAt(m)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};w=Ve([He(1,C.IExtHostRpcService),He(2,P.IExtHostInitDataService)],w);let L=class{constructor(o,r,m){this._extensionPaths=o,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(k.MainContext.MainThreadTelemetry);const a=m.getProxy(k.MainContext.MainThreadWindow);this._impl=(E,n)=>{const t=i.URI.parse(E);return n?this.callOriginal(E,n):t.scheme==="http"||t.scheme==="https"?a.$openUri(t,E,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?a.$openUri(t,E,{}):this.callOriginal(E,n)}}load(o,r,m){const a=this._extensionPaths.findSubstr(r);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=m(o),this._impl}callOriginal(o,r){return this.sendNoForwardTelemetry(),this._original(o,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};L=Ve([He(2,C.IExtHostRpcService)],L)}),define(ve[269],we([0,1,170,12,7,209,35,39,45,36,34,14,55,195,18,210,54]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let L=class extends c.ExtHostDebugServiceBase{constructor(r,m,a,E,n,t,s){super(r,m,a,E,n,s);this._terminalService=t,this._integratedTerminalInstances=new S}createDebugAdapter(r,m){switch(r.type){case"server":return new _.SocketDebugAdapter(r);case"pipeServer":return new _.NamedPipeDebugAdapter(r);case"executable":return new _.ExecutableDebugAdapter(r,m.type)}return super.createDebugAdapter(r,m)}daExecutableFromPackage(r,m){const a=_.ExecutableDebugAdapter.platformAdapterExecutable(m.getAllExtensionDescriptions(),r.type);if(a)return new k.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new b.SignService}async $runInTerminal(r,m){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(A=>{this._integratedTerminalInstances.onTerminalClosed(A)}));const a=await this._configurationService.getConfigProvider(),E=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),t=r.title||f.localize(0,null),s=JSON.stringify({shell:E,shellArgs:n});let u=await this._integratedTerminalInstances.checkout(s,t),d,h=!1;if(u)d=r.cwd;else{const A={shellPath:E,shellArgs:n,cwd:r.cwd,name:t,iconPath:new k.ThemeIcon("debug")};h=!0,u=this._terminalService.createTerminalFromOptions(A,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,s)}u.show(!0);const g=await u.processId;h?await new Promise(A=>setTimeout(A,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0||E.indexOf("cmd.exe")>=0?u.sendText("cls"):E.indexOf("bash")>=0?u.sendText("clear"):i.isWindows?u.sendText("cls"):u.sendText("clear"));const l=(0,p.prepareCommand)(E,r.args,d,r.env);u.sendText(l);const D=this.onDidTerminateDebugSession(A=>{A.id===m&&(this._integratedTerminalInstances.free(u),D.dispose())});return g}else if(r.kind==="external")return(0,p.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,m)}createVariableResolver(r,m,a){return new c.ExtHostVariableResolverService(r,m,a,this._editorTabs,this._workspaceService)}};L=Ve([He(0,y.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,w.IExtHostEditorTabs)],L),e.ExtHostDebugService=L;class S{constructor(){this._terminalInstances=new Map}async checkout(r,m){const E=[...this._terminalInstances.entries()].map(([n,t])=>(0,v.createCancelablePromise)(async s=>{if(n.name!==m||t.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await n.processId))return null;const u=Date.now();return t.lastUsedAt+S.minUseDelay>u||s.isCancellationRequested||t.config!==r?null:(t.lastUsedAt=u,n)}));return await(0,v.firstParallel)(E,n=>!!n)}insert(r,m){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:m})}free(r){const m=this._terminalInstances.get(r);m&&(m.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}S.minUseDelay=1e3}),define(ve[270],we([0,1,8,2,113,35,55,45,36,43,34,14,26,71,10,11,66,54,23,82]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends b.ExtHostTaskBase{constructor(a,E,n,t,s,u,d,h,g){super(a,E,n,t,s,u,d,h);this.workspaceService=n,this.editorTabs=g,E.remote.isRemote&&E.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:E.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,E){const n=E;if(!E.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const t=b.TaskHandleDTO.from(n,this.workspaceService),s=await this._proxy.$getTaskExecution(t);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(s,E);return this._proxy.$executeTask(t).catch(()=>{}),u}else{const t=b.TaskDTO.from(E,a);if(t===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,E,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),E);return this._proxy.$executeTask(t).catch(()=>{}),s}}provideTasksInternal(a,E,n,t){const s=[];if(t)for(let u of t){this.checkDeprecation(u,n),(!u.definition||!a[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const d=b.TaskDTO.from(u,n.extension);d&&(s.push(d),b.CustomExecutionDTO.is(d.execution)&&E.push(this.addCustomExecution(d,u,!0)))}return{tasks:s,extension:n.extension}}async resolveTaskInternal(a){return a}async getVariableResolver(a){if(this._variableResolver===void 0){const E=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(a,this._editorService,E,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(a){let E=a&&a.length>0?a[0]:void 0;if(!E){const n=i.URI.file((0,o.homedir)());E=new P.WorkspaceFolder({uri:n,name:S.basename(n),index:0})}return{uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,E){const n=i.URI.revive(a),t={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(n),u=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(u),h=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(let g of E.variables)t.variables[g]=await d.resolveAsync(h,g);if(E.process!==void 0){let g;if(E.process.path!==void 0){g=E.process.path.split(f.delimiter);for(let l=0;l<g.length;l++)g[l]=await d.resolveAsync(h,g[l])}t.process=await k.win32.findExecutable(await d.resolveAsync(h,E.process.name),E.process.cwd!==void 0?await d.resolveAsync(h,E.process.cwd):void 0,g)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(a,E,n){return k.win32.findExecutable(a,E,n)}};r=Ve([He(0,y.IExtHostRpcService),He(1,c.IExtHostInitDataService),He(2,_.IExtHostWorkspace),He(3,I.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,p.ILogService),He(7,w.IExtHostApiDeprecationService),He(8,L.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(ve[271],we([0,1,18,15,72,6,2,5,263,11,61,85,26,187,14,65,39,34]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(r,m,a,E){this._disposables=new _.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new C.RPCProtocol(r,null,E),m=S._transform(m,this._rpcProtocol);const n=new y.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());n.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...m}),n.set(v.IExtHostRpcService,new v.ExtHostRpcService(this._rpcProtocol)),n.set(p.IURITransformerService,new p.URITransformerService(E)),n.set(w.IHostUtils,a);const t=new b.InstantiationService(n,!0);this._disposables.add(t.invokeFunction(h=>h.get(L.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(h=>h.get(w.IExtHostExtensionService))),this._logService=t.invokeFunction(h=>h.get(P.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",m),this._extensionService=t.invokeFunction(h=>h.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const s=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(g,l)=>{let D="",A,N;for(const B of l)D+=`
	at ${B.toString()}`,N=B.getFileName(),!A&&N&&(A=h.findSubstr(T.URI.file(N)));return s.set(g,A),`${g.name||"Error"}: ${g.message||""}${D}`}});const u=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),d=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(h=>{const g=i.transformErrorForSerialization(h),l=s.get(h);l?u.$onExtensionRuntimeError(l.identifier,g):d.$onUnexpectedError(g)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),i.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();Promise.race([(0,f.timeout)(5e3),m]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,m){r.extensions.forEach(E=>E.extensionLocation=T.URI.revive(m.transformIncomingURIs(E.extensionLocation))),r.environment.appRoot=T.URI.revive(m.transformIncomingURIs(r.environment.appRoot));const a=r.environment.extensionDevelopmentLocationURI;return a&&(r.environment.extensionDevelopmentLocationURI=a.map(E=>T.URI.revive(m.transformIncomingURIs(E)))),r.environment.extensionTestsLocationURI=T.URI.revive(m.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=T.URI.revive(m.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=T.URI.revive(m.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=T.URI.revive(m.transformIncomingURIs(r.logsLocation)),r.logFile=T.URI.revive(m.transformIncomingURIs(r.logFile)),r.workspace=m.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=S}),define(ve[272],we([0,1,8,21,50,32,23,46,31]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(c,b,v){this.config=c,this.provider=b,this.sessionToken=v,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&_.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&_.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const b=this.config.folderQueries||[];return new Promise((v,p)=>{const w=L=>{this.resultCount++,c(L)};if(this.isCanceled)return v({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(L=>{const S=L.toString(),o=f.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,o)||this.matchFile(w,{base:L,basename:o})}),Promise.all(b.map(L=>this.searchInFolder(L,w))).then(L=>{v({limitHit:this.isLimitHit,stats:L[0]||void 0})},L=>{p(new Error((0,k.toErrorMessage)(L)))})})}async searchInFolder(c,b){const v=new i.CancellationTokenSource,p=this.getSearchOptionsForFolder(c),w=this.initDirectoryTree(),L=new C.QueryGlobTester(this.config,c),S=!L.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(v),o=I.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,v.token),m=o.elapsed(),a=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(E=>{const n=f.posix.relative(c.folder.path,E.path);if(S){const t=f.basename(E.path);this.matchFile(b,{base:c.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(w,c.folder,n,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,L,b),{providerTime:m,postProcessTime:a.elapsed()})}finally{v.dispose(),this.activeCancellationTokens.delete(v)}}getSearchOptionsForFolder(c){const b=(0,C.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),v=(0,C.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:v,includes:b,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},b,v,p){if(v===this.filePattern){const L=f.basename(this.filePattern);this.matchFile(p,{base:b,relativePath:this.filePattern,basename:L})}function w(L){const S=f.basename(L),o=f.dirname(L);let r=c[o];r||(r=c[o]=[],w(o)),r.push({base:b,relativePath:L,basename:S})}w(v)}matchDirectoryTree({rootEntries:c,pathToEntries:b},v,p){const w=this,L=this.filePattern;function S(o){const r=_.hasSiblingFn(()=>o.map(m=>m.basename));for(let m=0,a=o.length;m<a;m++){const E=o[m],{relativePath:n,basename:t}=E;if(v.matchesExcludesSync(n,t,L!==t?r:void 0))continue;const s=b[n];if(s)S(s);else{if(n===L)continue;w.matchFile(p,E)}if(w.isLimitHit)break}}S(c)}matchFile(c,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(b))}}class R{constructor(){this.sessions=new Map}fileSearch(c,b,v,p){const w=this.getSessionTokenSource(c.cacheKey),L=new P(c,b,w&&w.token);let S=0;const o=r=>{S+=r.length,v(r.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(L,R.BATCH_SIZE,o,p).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:r.stats}}))}clearCache(c){const b=this.getSessionTokenSource(c);b&&b.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new i.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:T.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,b,v,p){p.onCancellationRequested(()=>{c.cancel()});const w=S=>{S&&(L.push(S),b>0&&L.length>=b&&(v(L),L=[]))};let L=[];return c.search(w).then(S=>(L.length&&v(L),S),S=>(L.length&&v(L),Promise.reject(S)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ve[135],we([0,1,16,21,50,32,10,8,23,13,2,31]),function(X,e,f,i,k,_,T,I,C,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(o,r,m,a){this.query=o,this.provider=r,this.fileUtils=m,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,r){const m=this.query.folderQueries||[],a=new i.CancellationTokenSource;return r.onCancellationRequested(()=>a.cancel()),new Promise((E,n)=>{this.collector=new v(o);let t=!1;const s=(u,d)=>{if(!t&&!this.isLimitHit){const h=this.resultSize(u);w(u)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,t=!0,a.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const g=this.resultSize(u);this.resultCount+=g,(g>0||!w(u))&&this.collector.add(u,d)}};Promise.all(m.map((u,d)=>this.searchInFolder(u,h=>s(h,d),a.token))).then(u=>{a.dispose(),this.collector.flush();const d=u.some(h=>!!h&&!!h.limitHit);E({limitHit:this.isLimitHit||d,messages:(0,f.flatten)(u.map(h=>h?.message?(0,P.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},u=>{a.dispose();const d=(0,k.toErrorMessage)(u);n(new Error(d))})})}resultSize(o){return w(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,r){const m=Array.isArray(o.ranges)?o.ranges:[o.ranges],a=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:m.slice(0,r),preview:{matches:a.slice(0,r),text:o.preview.text},uri:o.uri}}async searchInFolder(o,r,m){const a=new y.QueryGlobTester(this.query,o),E=[],n={report:u=>{if(!this.validateProviderResult(u))return;const d=o.folder.scheme===T.Schemas.file?_.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(u.uri))):void 0,h=C.relativePath(o.folder,u.uri);if(h){const g=a.includedInQuery(h,I.basename(h),d);(0,P.isPromise)(g)?E.push(g.then(l=>{l&&r(u)})):g&&r(u)}}},t=this.getSearchOptionsForFolder(o),s=await this.provider.provideTextSearchResults(b(this.query.contentPattern),t,n,m);return E.length&&await Promise.all(E),s}validateProviderResult(o){if(w(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const r=(0,y.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),m=(0,y.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),a={folder:R.URI.from(o.folder),excludes:m,includes:r,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=c;function b(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class v{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new L(512,r=>this.sendItems(r))}add(o,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!C.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(p(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=v;function p(S){return w(S)?{preview:{matches:(0,f.mapArrayOrNot)(S.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:S.preview.text},ranges:(0,f.mapArrayOrNot)(S.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function w(S){return!!S.preview}e.extensionResultIsMatch=w;class L{constructor(o,r){this.maxBatchSize=o,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,r){!o||this.addItemToBatch(o,r)}addItems(o,r){!o||this.addItemsToBatch(o,r)}addItemToBatch(o,r){this.batch.push(o),this.batchSize+=r,this.onUpdate()}addItemsToBatch(o,r){this.batch=this.batch.concat(o),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<L.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},L.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=L,L.TIMEOUT=4e3,L.START_BATCH_AFTER_COUNT=50}),define(ve[73],we([0,1,6,5,4,272,14,65,11,2,135]),function(X,e,f,i,k,_,T,I,C,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let y=class{constructor(p,w,L){this.extHostRpc=p,this._uriTransformer=w,this._logService=L,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new _.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,w){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const L=this._handlePool++;return this._textSearchProvider.set(L,w),this._proxy.$registerTextSearchProvider(L,this._transformScheme(p)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(L),this._proxy.$unregisterProvider(L)})}registerFileSearchProvider(p,w){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const L=this._handlePool++;return this._fileSearchProvider.set(L,w),this._proxy.$registerFileSearchProvider(L,this._transformScheme(p)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(L),this._proxy.$unregisterProvider(L)})}$provideFileSearchResults(p,w,L,S){const o=c(L),r=this._fileSearchProvider.get(p);if(r)return this._fileSearchManager.fileSearch(o,r,m=>{this._proxy.$handleFileMatch(p,w,m.map(a=>a.resource))},S);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,w,L,S){const o=this._textSearchProvider.get(p);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const r=c(L);return this.createTextSearchManager(r,o).search(a=>this._proxy.$handleTextMatch(p,w,a),S)}$enableExtensionHostSearch(){}createTextSearchManager(p,w){return new R.TextSearchManager(p,w,{readdir:L=>Promise.resolve([]),toCanonicalName:L=>L},"textSearchProvider")}};y=Ve([He(0,T.IExtHostRpcService),He(1,I.IURITransformerService),He(2,C.ILogService)],y),e.ExtHostSearch=y;function c(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(b),extraFileResources:v.extraFileResources&&v.extraFileResources.map(p=>P.URI.revive(p))}}e.reviveQuery=c;function b(v){return{...v,folder:P.URI.revive(v.folder)}}}),define(ve[273],we([0,1,61,133,35,131,36,38,45,34,71,55,73,91,52,66,134,67,44,90,122,54,132,11,226]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o,r,m,a,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(E.ILoggerService,a.ExtHostLoggerService),(0,f.registerSingleton)(E.ILogService,n.ExtHostLogService),(0,f.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,f.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,f.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,f.registerSingleton)(L.IExtHostConsumerFileSystem,L.ExtHostConsumerFileSystem),(0,f.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,f.registerSingleton)(_.IExtHostDecorations,_.ExtHostDecorations),(0,f.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(S.IExtHostFileSystemInfo,S.ExtHostFileSystemInfo),(0,f.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,f.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,f.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,f.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,f.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,f.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService),(0,f.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,f.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,f.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,f.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,f.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs)}),define(ve[92],we([0,1,16,11,31,70]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}e.anchorGlob=T;function I(y,c,b,v){const p=(0,f.mapArrayOrNot)(b,C),w=new k.TextSearchMatch(c,p,v),L=w.preview.matches;return{ranges:(0,f.mapArrayOrNot)(p,P),uri:y,preview:{text:w.preview.text,matches:(0,f.mapArrayOrNot)(L,P)}}}e.createTextSearchResult=I;function C(y){return new k.SearchRange(y.start.line,y.start.character,y.end.line,y.end.character)}function P(y){return new _.Range(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let R=class{constructor(c,b){this.prefix=c,this.logService=b}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};R=Ve([He(1,i.ILogService)],R),e.OutputChannel=R}),define(ve[274],we([0,1,97,22]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(n){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===n)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const _=512,T=512,I=512*8,C=512*128;var P;(function(n){n[n.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(t,s){super(t);this.decodeStreamErrorKind=s}}e.DecodeStreamError=R;class y{constructor(t){this.iconvLiteDecoder=t}static async create(t){let s;if(t!==e.UTF8)s=(await new Promise((d,h)=>{X(["iconv-lite-umd"],d,h)})).getDecoder(p(t));else{const u=new TextDecoder;s={write(d){return u.decode(d,{stream:!0})},end(){return u.decode()}}}return new y(s)}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function c(n,t){const s=t.minBytesRequiredForDetection??t.guessEncoding?I:T;return new Promise((u,d)=>{const h=(0,f.newWriteableStream)(B=>B.join("")),g=[];let l=0,D,A;const N=async()=>{try{const B=await E({buffer:i.VSBuffer.concat(g),bytesRead:l},t.guessEncoding);if(B.seemsBinary&&t.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);B.encoding=await t.overwriteEncoding(B.encoding),D=await y.create(B.encoding);const F=D.write(i.VSBuffer.concat(g).buffer);h.write(F),g.length=0,l=0,u({stream:h,detected:B})}catch(B){A?.dispose(),h.destroy(),d(B)}};A=(0,f.listenStream)(n,{onData:async B=>{D?h.write(D.write(B.buffer)):(g.push(B),l+=B.byteLength,l>=s&&(n.pause(),await N(),setTimeout(()=>n.resume())))},onError:B=>h.error(B),onEnd:async()=>{D||await N(),h.end(D?.end())}})})}e.toDecodeStream=c;async function b(n,t,s){const d=(await new Promise((l,D)=>{X(["iconv-lite-umd"],l,D)})).getEncoder(p(t),s);let h=!1,g=!1;return{read(){if(g)return null;const l=n.read();if(typeof l!="string"){if(g=!0,!h&&s?.addBOM)switch(t){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=d.end();return D&&D.length>0?(h=!0,i.VSBuffer.wrap(D)):null}return h=!0,i.VSBuffer.wrap(d.write(l))}}}e.toEncodeReadable=b;async function v(n){return(await new Promise((s,u)=>{X(["iconv-lite-umd"],s,u)})).encodingExists(p(n))}e.encodingExists=v;function p(n){return n===e.UTF8_with_bom||n===null?e.UTF8:n}e.toNodeEncoding=p;function w(n,t){if(!n||t<e.UTF16be_BOM.length)return null;const s=n.readUInt8(0),u=n.readUInt8(1);if(s===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const d=n.readUInt8(2);return s===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&d===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=w;const L=["ascii","utf-16","utf-32"];async function S(n){const t=await new Promise((g,l)=>{X(["jschardet"],g,l)}),s=n.slice(0,C),u=m(s.buffer),d=t.detect(u);if(!d||!d.encoding)return null;const h=d.encoding.toLowerCase();return 0<=L.indexOf(h)?null:r(d.encoding)}const o={ibm866:"cp866",big5:"cp950"};function r(n){const t=n.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[t]||t}function m(n){let t="";for(let s=0;s<n.length;s++)t+=String.fromCharCode(n[s]);return t}function a(n){switch(n){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const t=n.match(/windows(\d+)/);return t?"windows-"+t[1]:n}}}e.toCanonicalName=a;function E({buffer:n,bytesRead:t},s){let u=w(n,t),d=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&n){let h=!0,g=!0,l=!1;for(let D=0;D<t&&D<_;D++){const A=D%2==1,N=n.readUInt8(D)===0;if(N&&(l=!0),h&&(A&&!N||!A&&N)&&(h=!1),g&&(A&&N||!A&&!N)&&(g=!1),N&&!h&&!g)break}l&&(h?u=e.UTF16le:g?u=e.UTF16be:d=!0)}return s&&!d&&!u&&n?S(n.slice(0,t)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:d,encoding:u}}e.detectEncodingFromBuffer=E,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[136],we([0,1,274,29,135]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class _ extends k.TextSearchManager{constructor(I,C,P=i,R="searchProcess"){super(I,C,{readdir:y=>P.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,f.toCanonicalName)(y)},R)}}e.NativeTextSearchManager=_}),define(ve[275],we([0,1,61,4]),function(X,e,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,i.createDecorator)("treeViewsDragAndDropService");class k{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(T){if(T&&this._dragOperations.has(T)){const I=this._dragOperations.get(T);return this._dragOperations.delete(T),I}}addDragOperationTransfer(T,I){this._dragOperations.set(T,I)}}e.TreeViewsDragAndDropService=k,(0,f.registerSingleton)(e.ITreeViewsDragAndDropService,k)}),define(ve[276],we([0,1,168,23,2,3,6,18,7,13,16,17,21,205,275]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(S,o){if((0,P.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let r;return Array.isArray(S.highlights)&&(r=S.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),r=r.length?r:void 0),{label:S.label,highlights:r}}}class w{constructor(o,r,m){this._proxy=o,this.commands=r,this.logService=m,this.treeViews=new Map,this.treeDragAndDropService=new v.TreeViewsDragAndDropService;function a(E){return E&&E.$treeViewId&&E.$treeItemHandle}r.registerArgumentProcessor({processArgument:E=>a(E)?this.convertArgument(E):Array.isArray(E)&&E.length>0?E.map(n=>a(n)?this.convertArgument(n):n):E})}registerTreeDataProvider(o,r,m){const a=this.createTreeView(o,{treeDataProvider:r},m);return{dispose:()=>a.dispose()}}createTreeView(o,r,m){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=r.dragAndDropController?.supportedMimeTypes,E=!!r.dragAndDropController?.onWillDrop,n=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dragAndDropMimeTypes:a,hasWillDrop:E}),t=this.createExtHostTreeView(o,r,m);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(s){t.message=s},get title(){return t.title},set title(s){t.title=s},get description(){return t.description},set description(s){t.description=s},reveal:(s,u)=>t.reveal(s,u),dispose:async()=>{await n,this.treeViews.delete(o),t.dispose()}}}$getChildren(o,r){const m=this.treeViews.get(o);return m?m.getChildren(r):Promise.reject(new Error((0,f.localize)(0,null,o)))}async $onDrop(o,r,m,a,E,n){const t=this.treeViews.get(o);if(!t)return Promise.reject(new Error((0,f.localize)(1,null,o)));const s=b.TreeDataTransferConverter.toITreeDataTransfer(r);return E===o&&n&&await this.addAdditionalTransferItems(s,t,n,a),t.onDrop(s,m)}async addAdditionalTransferItems(o,r,m,a){const E=this.treeDragAndDropService.removeDragOperationTransfer(a);let n;if(E)n=await E;else if(a&&r.onWillDrop){const t=r.onWillDrop(m);this.treeDragAndDropService.addDragOperationTransfer(a,t),n=await t}return n&&n.forEach((t,s)=>{t&&o.set(s,t)}),o}async $onWillDrop(o,r,m){const a=this.treeViews.get(o);if(!a)return Promise.reject(new Error((0,f.localize)(2,null,o)));const E=await this.addAdditionalTransferItems(new Map,a,r,m);if(!!E)return b.TreeDataTransferConverter.toTreeDataTransferDTO(E)}async $hasResolve(o){const r=this.treeViews.get(o);if(!r)throw new Error((0,f.localize)(3,null,o));return r.hasResolve}$resolve(o,r,m){const a=this.treeViews.get(o);if(!a)throw new Error((0,f.localize)(4,null,o));return a.resolveTreeItem(r,m)}$setExpanded(o,r,m){const a=this.treeViews.get(o);if(!a)throw new Error((0,f.localize)(5,null,o));a.setExpanded(r,m)}$setSelection(o,r){const m=this.treeViews.get(o);if(!m)throw new Error((0,f.localize)(6,null,o));m.setSelection(r)}$setVisible(o,r){const m=this.treeViews.get(o);if(!m)throw new Error((0,f.localize)(7,null,o));m.setVisible(r)}createExtHostTreeView(o,r,m){const a=new L(o,r,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(o,a),a}convertArgument(o){const r=this.treeViews.get(o.$treeViewId);return r?r.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=w;class L extends T.Disposable{constructor(o,r,m,a,E,n){super();if(this.viewId=o,this.proxy=m,this.commands=a,this.logService=E,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,n.contributes&&n.contributes.views)for(const u in n.contributes.views)for(const d of n.contributes.views[u])d.id===o&&(this._title=d.name);this.dataProvider=r.treeDataProvider,this.dndController=r.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(u=>this._onDidChangeData.fire({message:!1,element:u}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(u=>this._onDidChangeData.fire({message:!1,element:u})));let t,s;this._register(_.Event.debounce(this._onDidChangeData.event,(u,d)=>(u||(u={message:!1,elements:[]}),d.element!==!1&&(t||(t=new Promise(h=>s=h),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(d.element)?u.elements.push(...d.element):u.elements.push(d.element)),d.message&&(u.message=!0),u),200,!0)(({message:u,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=s;return t=null,this.refresh(d).then(()=>h())})),u&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,P.isUndefinedOrNull)(o))}async getChildren(o){const r=o?this.getExtensionElement(o):void 0;if(o&&!r)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let m=this.getChildrenNodes(o);return m||(m=await this.fetchChildrenNodes(r)),m?m.map(a=>a.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,r){r=r||{select:!0,focus:!1};const m=(0,P.isUndefinedOrNull)(r.select)?!0:r.select,a=(0,P.isUndefinedOrNull)(r.focus)?!1:r.focus,E=(0,P.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(n=>this.resolveTreeNode(o,n[n.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:n.map(s=>s.item)},{select:m,focus:a,expand:E})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:a,expand:E})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,r){const m=this.getExtensionElement(o);m&&(r?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(o){(0,R.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(o){const r=[];for(const m of o){const a=this.getExtensionElement(m);a&&r.push(a)}if(!(!this.dndController?.onWillDrop||r.length===0))return this.dndController.onWillDrop(r)}get hasOnWillDrop(){return!!this.dndController?.onWillDrop}async onDrop(o,r){const m=this.getExtensionElement(r);if(!!m)return(0,I.asPromise)(()=>this.dndController?.onDrop(o,m))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,r){if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(o);if(m){const a=this.nodes.get(m);if(a){const E=await this.dataProvider.resolveTreeItem(a.extensionItem,m,r)??a.extensionItem;return a.item.tooltip=this.getTooltip(E.tooltip),a.item.command=this.getCommand(a.disposableStore,E.command),a.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(r=>r?this.resolveUnknownParentChain(r).then(m=>this.resolveTreeNode(r,m[m.length-1]).then(a=>(m.push(a),m))):Promise.resolve([]))}resolveParent(o){const r=this.nodes.get(o);return r?Promise.resolve(r.parent?this.elements.get(r.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,r){const m=this.nodes.get(o);return m?Promise.resolve(m):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(a=>this.createHandle(o,a,r,!0)).then(a=>this.getChildren(r?r.item.handle:void 0).then(()=>{const E=this.getExtensionElement(a);if(E){const n=this.nodes.get(E);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(o){if(o){let r;if(typeof o=="string"){const m=this.getExtensionElement(o);r=m?this.nodes.get(m):void 0}else r=o;return r&&r.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const r=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=o?this.nodes.get(o):void 0,a=await this.dataProvider.getChildren(o);if(r.token.isCancellationRequested)return;const E=await Promise.all((0,R.coalesce)(a||[]).map(async n=>{const t=await this.dataProvider.getTreeItem(n);return t&&!r.token.isCancellationRequested?this.createAndRegisterTreeNode(n,t,m):null}));return r.token.isCancellationRequested?void 0:(0,R.coalesce)(E)}finally{r.dispose()}}refresh(o){if(o.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(o);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const r=new Set,m=o.map(E=>this.nodes.get(E));for(const E of m)if(E&&!r.has(E.item.handle)){let n=E;for(;n&&n.parent&&m.findIndex(t=>n&&n.parent&&t&&t.item.handle===n.parent.item.handle)===-1;){const t=this.elements.get(n.parent.item.handle);n=t?this.nodes.get(t):void 0}n&&!n.parent&&r.add(E.item.handle)}const a=[];return r.forEach(E=>{const n=this.elements.get(E);if(n){const t=this.nodes.get(n);t&&(!t.parent||!r.has(t.parent.item.handle))&&a.push(E)}}),a}refreshHandles(o){const r={};return Promise.all(o.map(m=>this.refreshNode(m).then(a=>{a&&(r[m]=a.item)}))).then(()=>Object.keys(r).length?this.proxy.$refresh(this.viewId,r):void 0)}refreshNode(o){const r=this.getExtensionElement(o);if(r){const m=this.nodes.get(r);if(m)return this.clearChildren(r),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(a=>{if(a){const E=this.createTreeNode(r,a,m.parent);return this.updateNodeCache(r,E,m,m.parent),m.dispose(),E}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,r,m){const a=this.createTreeNode(o,r,m);if(r.id&&this.elements.has(a.item.handle))throw new Error((0,f.localize)(8,null,r.id));return this.addNodeToCache(o,a),this.addNodeToParentCache(a,m),a}getTooltip(o){return C.MarkdownString.isMarkdownString(o)?y.MarkdownString.from(o):o}getCommand(o,r){return r?this.commands.toInternal(r,o):void 0}createTreeNode(o,r,m){const a=new T.DisposableStore,E=this.createHandle(o,r,m),n=this.getLightIconPath(r);return{item:{handle:E,parentHandle:m?m.item.handle:void 0,label:p(r.label,this.extension),description:r.description,resourceUri:r.resourceUri,tooltip:this.getTooltip(r.tooltip),command:this.getCommand(a,r.command),contextValue:r.contextValue,icon:n,iconDark:this.getDarkIconPath(r)||n,themeIcon:this.getThemeIcon(r),collapsibleState:(0,P.isUndefinedOrNull)(r.collapsibleState)?C.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation},extensionItem:r,parent:m,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(o){return o.iconPath instanceof C.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:r,label:m,resourceUri:a},E,n){if(r)return`${L.ID_HANDLE_PREFIX}/${r}`;const t=p(m,this.extension),s=E?E.item.handle:L.LABEL_HANDLE_PREFIX;let u=t?t.label:a?(0,i.basename)(a):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const d=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,h=this.getChildrenNodes(E)||[];let g,l=0;do{if(g=`${s}/${l}:${u}`,n||!this.elements.has(g)||d===g)break;l++}while(l<=h.length);return g}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof C.ThemeIcon))return typeof o.iconPath=="string"||k.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof C.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return k.URI.isUri(o)?o:k.URI.file(o)}addNodeToCache(o,r){this.elements.set(r.item.handle,o),this.nodes.set(o,r)}updateNodeCache(o,r,m,a){this.elements.delete(r.item.handle),this.nodes.delete(o),r.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(o,r);const E=this.getChildrenNodes(a)||[],n=E.filter(t=>t.item.handle===m.item.handle)[0];n&&E.splice(E.indexOf(n),1,r)}addNodeToParentCache(o,r){r?(r.children||(r.children=[]),r.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const r=this.nodes.get(o);if(r){if(r.children)for(const m of r.children){const a=this.elements.get(m.item.handle);a&&this.clear(a)}r.children=void 0}}else this.clearAll()}clear(o){const r=this.nodes.get(o);if(r){if(r.children)for(const m of r.children){const a=this.elements.get(m.item.handle);a&&this.clear(a)}this.nodes.delete(o),this.elements.delete(r.item.handle),r.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}L.LABEL_HANDLE_PREFIX="0",L.ID_HANDLE_PREFIX="1"}),define(ve[277],we([0,1,21,15,3,48,2,114,109,146,83,42,5,231,230,38,232,36,233,234,235,217,236,45,39,237,218,240,241,242,133,220,247,248,249,91,34,251,276,17,7,254,69,134,35,75,206,239,63,131,71,55,73,11,65,14,26,243,203,52,66,228,252,202,68,67,257,255,256,229,44,250,253,90,54,122,245,70,246,10,190,244,200,238,6,30]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S,o,r,m,a,E,n,t,s,u,d,h,g,l,D,A,N,B,F,O,z,W,M,x,V,U,H,Y,se,K,j,ne,le,ge,ke,Me,Ue,q,J,re,he,Z,ce,Se,Be,qe,Ke,Je,it,at,et,nt,ct,vt,We,At,ee,te,Ee,ie,Ce,Fe,Ge,ze,ut,Ae,Te,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function oe(me){const be=me.get(J.IExtHostInitDataService),_e=me.get(ct.IExtHostFileSystemInfo),Ne=me.get(Je.IExtHostConsumerFileSystem),Qe=me.get(n.IExtHostExtensionService),$e=me.get(H.IExtHostWorkspace),Xe=me.get(te.IExtHostTelemetry),st=me.get(L.IExtHostConfiguration),ot=me.get(Ue.IURITransformerService),fe=me.get(q.IExtHostRpcService),ye=me.get(B.IExtHostStorage),de=me.get(Ke.IExtensionStoragePaths),Q=me.get(Me.ILoggerService),Ie=me.get(Me.ILogService),Oe=me.get(Z.IExtHostTunnelService),Ze=me.get(ce.IExtHostApiDeprecationService),je=me.get(U.IExtHostWindow),ht=me.get(At.IExtHostSecretState),Et=me.get(ee.IExtHostEditorTabs);fe.set(c.ExtHostContext.ExtHostFileSystemInfo,_e),fe.set(c.ExtHostContext.ExtHostLogLevelServiceShape,Q),fe.set(c.ExtHostContext.ExtHostWorkspace,$e),fe.set(c.ExtHostContext.ExtHostConfiguration,st),fe.set(c.ExtHostContext.ExtHostExtensionService,Qe),fe.set(c.ExtHostContext.ExtHostStorage,ye),fe.set(c.ExtHostContext.ExtHostTunnelService,Oe),fe.set(c.ExtHostContext.ExtHostWindow,je),fe.set(c.ExtHostContext.ExtHostSecretState,ht),fe.set(c.ExtHostContext.ExtHostTelemetry,Xe),fe.set(c.ExtHostContext.ExtHostEditorTabs,Et);const Dt=fe.set(c.ExtHostContext.ExtHostDecorations,me.get(ne.IExtHostDecorations)),bt=fe.set(c.ExtHostContext.ExtHostDocumentsAndEditors,me.get(E.IExtHostDocumentsAndEditors)),mt=fe.set(c.ExtHostContext.ExtHostCommands,me.get(p.IExtHostCommands)),wt=fe.set(c.ExtHostContext.ExtHostTerminalService,me.get(F.IExtHostTerminalService)),_t=fe.set(c.ExtHostContext.ExtHostDebugService,me.get(ge.IExtHostDebugService)),Mt=fe.set(c.ExtHostContext.ExtHostSearch,me.get(ke.IExtHostSearch)),It=fe.set(c.ExtHostContext.ExtHostTask,me.get(le.IExtHostTask)),Pt=fe.set(c.ExtHostContext.ExtHostOutputService,me.get(g.IExtHostOutputService)),Rt=fe.set(c.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(fe)),yt=fe.set(c.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(fe,bt)),Ht=fe.set(c.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(fe,bt,Ie)),Ot=fe.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new m.ExtHostDocumentSaveParticipant(Ie,yt,fe.getProxy(c.MainContext.MainThreadBulkEdits))),St=fe.set(c.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(fe,mt,bt,yt,de)),Qt=fe.set(c.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(Ie,St)),Vt=fe.set(c.ExtHostContext.ExtHostNotebookEditors,new ze.ExtHostNotebookEditors(Ie,fe,St)),Xt=fe.set(c.ExtHostContext.ExtHostNotebookKernels,new Ee.ExtHostNotebookKernels(fe,be,St,mt,Ie)),oi=fe.set(c.ExtHostContext.ExtHostNotebookRenderers,new Ce.ExtHostNotebookRenderers(fe,St)),Lt=fe.set(c.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(fe,bt)),Yt=fe.set(c.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(fe.getProxy(c.MainContext.MainThreadTreeViews),mt,Ie)),ai=fe.set(c.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(fe.getProxy(c.MainContext.MainThreadEditorInsets),Lt,be)),Jt=fe.set(c.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(fe,Ie,_e)),zt=fe.set(c.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(fe,yt,mt.converter,ot)),pt=fe.set(c.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(fe,ot,yt,mt,Jt,Ie,Ze)),ci=fe.set(c.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(fe,pt)),Nt=fe.set(c.ExtHostContext.ExtHostFileSystemEventService,new s.ExtHostFileSystemEventService(fe,Ie,bt)),jt=fe.set(c.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(fe,$e,mt)),Zt=fe.set(c.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(fe,mt,Ie)),li=fe.set(c.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(fe,mt,yt)),fi=fe.set(c.ExtHostContext.ExtHostProgress,new l.ExtHostProgress(fe.getProxy(c.MainContext.MainThreadProgress))),Ei=fe.set(c.ExtHostContext.ExtHosLabelService,new K.ExtHostLabelService(fe)),mi=fe.set(c.ExtHostContext.ExtHostTheming,new he.ExtHostTheming(fe)),ei=fe.set(c.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(fe)),Si=fe.set(c.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(fe,mt)),qt=fe.set(c.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(fe,{remote:be.remote},$e,Ie,Ze)),Gt=fe.set(c.ExtHostContext.ExtHostWebviewPanels,new et.ExtHostWebviewPanels(fe,qt,$e)),_i=fe.set(c.ExtHostContext.ExtHostCustomEditors,new at.ExtHostCustomEditors(fe,yt,de,qt,Gt)),Ci=fe.set(c.ExtHostContext.ExtHostWebviewViews,new it.ExtHostWebviewViews(fe,qt)),Kt=fe.set(c.ExtHostContext.ExtHostTesting,new vt.ExtHostTesting(fe,mt)),yi=fe.set(c.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(fe));fe.set(c.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(fe,St,bt,mt));const ti=(0,Y.values)(c.ExtHostContext);fe.assertRegistered(ti);const Di=new nt.ExtHostBulkEdits(fe,bt),ki=new v.ExtHostClipboard(fe),ui=new h.ExtHostMessageService(fe,Ie),ii=new o.ExtHostDialogs(fe),gi=new N.ExtHostStatusBar(fe,mt.converter);return b.ExtHostApiCommands.register(mt),function(xe,Ut,pi){const gt=function(){let ae=!xe.isUnderDevelopment;function pe(){ae||(Ie.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ae=!0)}return function Re(dt){if(Array.isArray(dt))dt.forEach(Re);else if(typeof dt=="string")pe();else{const Ct=dt;typeof Ct.scheme=="undefined"&&pe(),typeof Ct.exclusive=="boolean"&&(0,De.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return dt}}(),ni={getSession(ae,pe,Re){return ei.getSession(xe,ae,pe,Re)},async hasSession(ae,pe){return(0,De.checkProposedApiEnabled)(xe,"authSession"),!!await ei.getSession(xe,ae,pe,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(ae,pe,Re,dt){return ei.registerAuthenticationProvider(ae,pe,Re,dt)}},Ii={registerCommand(ae,pe,Re){return mt.registerCommand(!0,ae,pe,Re,void 0,xe)},registerTextEditorCommand(ae,pe,Re){return mt.registerCommand(!0,ae,(...dt)=>{const Ct=Lt.getActiveTextEditor();if(!Ct){Ie.warn("Cannot execute "+ae+" because there is no active text editor.");return}return Ct.edit(kt=>{pe.apply(Re,[Ct,kt,...dt])}).then(kt=>{kt||Ie.warn("Edits from command "+ae+" were not applied.")},kt=>{Ie.warn("An error occurred while running command "+ae,kt)})},void 0,void 0,xe)},registerDiffInformationCommand:(ae,pe,Re)=>((0,De.checkProposedApiEnabled)(xe,"diffCommand"),mt.registerCommand(!0,ae,async(...dt)=>{const Ct=bt.activeEditor(!0);if(!Ct){Ie.warn("Cannot execute "+ae+" because there is no active text editor.");return}const kt=await Lt.getDiffInformation(Ct.id);pe.apply(Re,[kt,...dt])},void 0,void 0,xe)),executeCommand(ae,...pe){return mt.executeCommand(ae,...pe)},getCommands(ae=!1){return mt.getCommands(ae)}},vi={get machineId(){return be.telemetryInfo.machineId},get sessionId(){return be.telemetryInfo.sessionId},get language(){return be.environment.appLanguage},get appName(){return be.environment.appName},get appRoot(){return be.environment.appRoot?.fsPath??""},get appHost(){return be.environment.appHost},get uriScheme(){return be.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return wt.getDefaultShell(!1)},get isTelemetryEnabled(){return Xe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Xe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ae=Date.now()-new Date(be.telemetryInfo.firstSessionDate).getTime();return isNaN(ae)?!1:ae<1e3*60*60*24},openExternal(ae,pe){return je.openUri(ae,{allowTunneling:!!be.remote.authority,allowContributedOpeners:pe?.allowContributedOpeners})},async asExternalUri(ae){if(ae.scheme===be.environment.appUriScheme)return Rt.createAppUri(ae);try{return await je.asExternalUri(ae,{allowTunneling:!!be.remote.authority})}catch(pe){if((0,Ge.matchesScheme)(ae,Fe.Schemas.http)||(0,Ge.matchesScheme)(ae,Fe.Schemas.https))return ae;throw pe}},get remoteName(){return(0,j.getRemoteName)(be.remote.authority)},get remoteAuthority(){return(0,De.checkProposedApiEnabled)(xe,"resolvers"),be.remote.authority},get uiKind(){return be.uiKind}};be.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=be.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Pi={createTestController(ae,pe){return Kt.createTestController(ae,pe)},createTestObserver(){return(0,De.checkProposedApiEnabled)(xe,"testObserver"),Kt.createTestObserver()},runTests(ae){return(0,De.checkProposedApiEnabled)(xe,"testObserver"),Kt.runTests(ae)},get onDidChangeTestResults(){return(0,De.checkProposedApiEnabled)(xe,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,De.checkProposedApiEnabled)(xe,"testObserver"),Kt.results}},Ti={getExtension(ae){const pe=Ut.getExtensionDescription(ae);if(pe)return new n.Extension(Qe,xe.identifier,pe,wi)},get all(){return Ut.getAllExtensionDescriptions().map(ae=>new n.Extension(Qe,xe.identifier,ae,wi))},get onDidChange(){return Ut.onDidChange}},Ai={createDiagnosticCollection(ae){return Jt.createDiagnosticCollection(xe.identifier,ae)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:ae=>Jt.getDiagnostics(ae),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(ae,pe){return zt.changeLanguage(ae.uri,pe)},match(ae,pe){return(0,R.score)(W.LanguageSelector.from(ae),pe.uri,pe.languageId,!0)},registerCodeActionsProvider(ae,pe,Re){return pt.registerCodeActionProvider(xe,gt(ae),pe,Re)},registerCodeLensProvider(ae,pe){return pt.registerCodeLensProvider(xe,gt(ae),pe)},registerDefinitionProvider(ae,pe){return pt.registerDefinitionProvider(xe,gt(ae),pe)},registerDeclarationProvider(ae,pe){return pt.registerDeclarationProvider(xe,gt(ae),pe)},registerImplementationProvider(ae,pe){return pt.registerImplementationProvider(xe,gt(ae),pe)},registerTypeDefinitionProvider(ae,pe){return pt.registerTypeDefinitionProvider(xe,gt(ae),pe)},registerHoverProvider(ae,pe){return pt.registerHoverProvider(xe,gt(ae),pe,xe.identifier)},registerEvaluatableExpressionProvider(ae,pe){return pt.registerEvaluatableExpressionProvider(xe,gt(ae),pe,xe.identifier)},registerInlineValuesProvider(ae,pe){return pt.registerInlineValuesProvider(xe,gt(ae),pe,xe.identifier)},registerDocumentHighlightProvider(ae,pe){return pt.registerDocumentHighlightProvider(xe,gt(ae),pe)},registerLinkedEditingRangeProvider(ae,pe){return pt.registerLinkedEditingRangeProvider(xe,gt(ae),pe)},registerReferenceProvider(ae,pe){return pt.registerReferenceProvider(xe,gt(ae),pe)},registerRenameProvider(ae,pe){return pt.registerRenameProvider(xe,gt(ae),pe)},registerDocumentSymbolProvider(ae,pe,Re){return pt.registerDocumentSymbolProvider(xe,gt(ae),pe,Re)},registerWorkspaceSymbolProvider(ae){return pt.registerWorkspaceSymbolProvider(xe,ae)},registerDocumentFormattingEditProvider(ae,pe){return pt.registerDocumentFormattingEditProvider(xe,gt(ae),pe)},registerDocumentRangeFormattingEditProvider(ae,pe){return pt.registerDocumentRangeFormattingEditProvider(xe,gt(ae),pe)},registerOnTypeFormattingEditProvider(ae,pe,Re,...dt){return pt.registerOnTypeFormattingEditProvider(xe,gt(ae),pe,[Re].concat(dt))},registerDocumentSemanticTokensProvider(ae,pe,Re){return pt.registerDocumentSemanticTokensProvider(xe,gt(ae),pe,Re)},registerDocumentRangeSemanticTokensProvider(ae,pe,Re){return pt.registerDocumentRangeSemanticTokensProvider(xe,gt(ae),pe,Re)},registerSignatureHelpProvider(ae,pe,Re,...dt){return typeof Re=="object"?pt.registerSignatureHelpProvider(xe,gt(ae),pe,Re):pt.registerSignatureHelpProvider(xe,gt(ae),pe,typeof Re=="undefined"?[]:[Re,...dt])},registerCompletionItemProvider(ae,pe,...Re){return pt.registerCompletionItemProvider(xe,gt(ae),pe,Re)},registerInlineCompletionItemProvider(ae,pe){return(0,De.checkProposedApiEnabled)(xe,"inlineCompletions"),pt.registerInlineCompletionsProvider(xe,gt(ae),pe)},registerDocumentLinkProvider(ae,pe){return pt.registerDocumentLinkProvider(xe,gt(ae),pe)},registerColorProvider(ae,pe){return pt.registerColorProvider(xe,gt(ae),pe)},registerFoldingRangeProvider(ae,pe){return pt.registerFoldingRangeProvider(xe,gt(ae),pe)},registerSelectionRangeProvider(ae,pe){return pt.registerSelectionRangeProvider(xe,ae,pe)},registerCallHierarchyProvider(ae,pe){return pt.registerCallHierarchyProvider(xe,ae,pe)},registerTypeHierarchyProvider(ae,pe){return pt.registerTypeHierarchyProvider(xe,ae,pe)},setLanguageConfiguration:(ae,pe)=>pt.setLanguageConfiguration(xe,ae,pe),getTokenInformationAtPosition(ae,pe){return(0,De.checkProposedApiEnabled)(xe,"tokenInformation"),zt.tokenAtPosition(ae,pe)},registerInlayHintsProvider(ae,pe){return(0,De.checkProposedApiEnabled)(xe,"inlayHints"),pt.registerInlayHintsProvider(xe,ae,pe)},createLanguageStatusItem(ae,pe){return(0,De.checkProposedApiEnabled)(xe,"languageStatus"),zt.createLanguageStatusItem(xe,ae,pe)}},Ri={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(ae,pe,Re){const dt=await(T.URI.isUri(ae)?Promise.resolve(ri.openTextDocument(ae)):Promise.resolve(ae));return Lt.showTextDocument(dt,pe,Re)},createTextEditorDecorationType(ae){return Lt.createTextEditorDecorationType(xe,ae)},onDidChangeActiveTextEditor(ae,pe,Re){return Lt.onDidChangeActiveTextEditor(ae,pe,Re)},onDidChangeVisibleTextEditors(ae,pe,Re){return Lt.onDidChangeVisibleTextEditors(ae,pe,Re)},onDidChangeTextEditorSelection(ae,pe,Re){return Lt.onDidChangeTextEditorSelection(ae,pe,Re)},onDidChangeTextEditorOptions(ae,pe,Re){return Lt.onDidChangeTextEditorOptions(ae,pe,Re)},onDidChangeTextEditorVisibleRanges(ae,pe,Re){return Lt.onDidChangeTextEditorVisibleRanges(ae,pe,Re)},onDidChangeTextEditorViewColumn(ae,pe,Re){return Lt.onDidChangeTextEditorViewColumn(ae,pe,Re)},onDidCloseTerminal(ae,pe,Re){return wt.onDidCloseTerminal(ae,pe,Re)},onDidOpenTerminal(ae,pe,Re){return wt.onDidOpenTerminal(ae,pe,Re)},onDidChangeActiveTerminal(ae,pe,Re){return wt.onDidChangeActiveTerminal(ae,pe,Re)},onDidChangeTerminalDimensions(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"terminalDimensions"),wt.onDidChangeTerminalDimensions(ae,pe,Re)},onDidChangeTerminalState(ae,pe,Re){return wt.onDidChangeTerminalState(ae,pe,Re)},onDidWriteTerminalData(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(ae,pe,Re)},get state(){return je.state},onDidChangeWindowState(ae,pe,Re){return je.onDidChangeWindowState(ae,pe,Re)},showInformationMessage(ae,...pe){return ui.showMessage(xe,_.default.Info,ae,pe[0],pe.slice(1))},showWarningMessage(ae,...pe){return ui.showMessage(xe,_.default.Warning,ae,pe[0],pe.slice(1))},showErrorMessage(ae,...pe){return ui.showMessage(xe,_.default.Error,ae,pe[0],pe.slice(1))},showQuickPick(ae,pe,Re){return Array.isArray(ae)&&ae.some(dt=>dt.kind===M.QuickPickItemKind.Separator)&&(0,De.checkProposedApiEnabled)(xe,"quickPickSeparators"),jt.showQuickPick(ae,pe,Re)},showWorkspaceFolderPick(ae){return jt.showWorkspaceFolderPick(ae)},showInputBox(ae,pe){return jt.showInput(ae,pe)},showOpenDialog(ae){return ii.showOpenDialog(ae)},showSaveDialog(ae){return ii.showSaveDialog(ae)},createStatusBarItem(ae,pe,Re){let dt,Ct,kt;return typeof ae=="string"?(dt=ae,Ct=pe,kt=Re):(Ct=ae,kt=pe),gi.createStatusBarEntry(xe,dt,Ct,kt)},setStatusBarMessage(ae,pe){return gi.setStatusBarMessage(ae,pe)},withScmProgress(ae){return Ze.report("window.withScmProgress",xe,"Use 'withProgress' instead."),fi.withProgress(xe,{location:M.ProgressLocation.SourceControl},(pe,Re)=>ae({report(dt){}}))},withProgress(ae,pe){return fi.withProgress(xe,ae,pe)},createOutputChannel(ae){return Pt.createOutputChannel(ae,xe)},createWebviewPanel(ae,pe,Re,dt){return Gt.createWebviewPanel(xe,ae,pe,Re,dt)},createWebviewTextEditorInset(ae,pe,Re,dt){return(0,De.checkProposedApiEnabled)(xe,"editorInsets"),ai.createWebviewEditorInset(ae,pe,Re,dt,xe)},createTerminal(ae,pe,Re){return typeof ae=="object"?"pty"in ae?wt.createExtensionTerminal(ae):wt.createTerminalFromOptions(ae):wt.createTerminal(ae,pe,Re)},registerTerminalLinkProvider(ae){return wt.registerLinkProvider(ae)},registerTerminalProfileProvider(ae,pe){return wt.registerProfileProvider(xe,ae,pe)},registerTreeDataProvider(ae,pe){return Yt.registerTreeDataProvider(ae,pe,xe)},createTreeView(ae,pe){return Yt.createTreeView(ae,pe,xe)},registerWebviewPanelSerializer:(ae,pe)=>Gt.registerWebviewPanelSerializer(xe,ae,pe),registerCustomEditorProvider:(ae,pe,Re={})=>_i.registerCustomEditorProvider(xe,ae,pe,Re),registerFileDecorationProvider(ae){return Dt.registerFileDecorationProvider(ae,xe.identifier)},registerUriHandler(ae){return Rt.registerUriHandler(xe.identifier,ae)},createQuickPick(){return jt.createQuickPick(xe)},createInputBox(){return jt.createInputBox(xe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(ae,pe,Re){return mi.onDidChangeActiveColorTheme(ae,pe,Re)},registerWebviewViewProvider(ae,pe,Re){return Ci.registerWebviewViewProvider(xe,ae,pe,Re?.webviewOptions)},get activeNotebookEditor(){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),St.onDidChangeActiveNotebookEditor(ae,pe,Re)},get visibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(ae,pe,Re)},onDidChangeNotebookEditorVisibleRanges(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(ae,pe,Re)},showNotebookDocument(ae,pe){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),St.showNotebookDocument(ae,pe)},registerExternalUriOpener(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"externalUriOpener"),yi.registerExternalUriOpener(xe.identifier,ae,pe,Re)},get tabs(){return(0,De.checkProposedApiEnabled)(xe,"tabs"),Et.tabs},get activeTab(){return(0,De.checkProposedApiEnabled)(xe,"tabs"),Et.activeTab},get onDidChangeTabs(){return(0,De.checkProposedApiEnabled)(xe,"tabs"),Et.onDidChangeTabs},get onDidChangeActiveTab(){return(0,De.checkProposedApiEnabled)(xe,"tabs"),Et.onDidChangeActiveTab},getInlineCompletionItemController(ae){return(0,De.checkProposedApiEnabled)(xe,"inlineCompletions"),u.InlineCompletionController.get(ae)}},ri={get rootPath(){return Ze.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$e.getPath()},set rootPath(ae){throw i.readonly()},getWorkspaceFolder(ae){return $e.getWorkspaceFolder(ae)},get workspaceFolders(){return $e.getWorkspaceFolders()},get name(){return $e.name},set name(ae){throw i.readonly()},get workspaceFile(){return $e.workspaceFile},set workspaceFile(ae){throw i.readonly()},updateWorkspaceFolders:(ae,pe,...Re)=>$e.updateWorkspaceFolders(xe,ae,pe||0,...Re),onDidChangeWorkspaceFolders:function(ae,pe,Re){return $e.onDidChangeWorkspace(ae,pe,Re)},asRelativePath:(ae,pe)=>$e.getRelativePath(ae,pe),findFiles:(ae,pe,Re,dt)=>$e.findFiles(W.GlobPattern.from(ae),W.GlobPattern.from(pe),Re,xe.identifier,dt),findTextInFiles:(ae,pe,Re,dt)=>{(0,De.checkProposedApiEnabled)(xe,"findTextInFiles");let Ct,kt;return typeof pe=="object"?(Ct=pe,kt=Re):(Ct={},kt=pe,dt=Re),$e.findTextInFiles(ae,Ct||{},kt,xe.identifier,dt)},saveAll:ae=>$e.saveAll(ae),applyEdit(ae){return Di.applyWorkspaceEdit(ae)},createFileSystemWatcher:(ae,pe,Re,dt)=>Nt.createFileSystemWatcher(W.GlobPattern.from(ae),pe,Re,dt),get textDocuments(){return yt.getAllDocumentData().map(ae=>ae.document)},set textDocuments(ae){throw i.readonly()},openTextDocument(ae){let pe;const Re=ae;if(typeof ae=="string")pe=Promise.resolve(T.URI.file(ae));else if(T.URI.isUri(ae))pe=Promise.resolve(ae);else if(!Re||typeof Re=="object")pe=yt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return pe.then(dt=>yt.ensureDocumentData(dt).then(Ct=>Ct.document))},onDidOpenTextDocument:(ae,pe,Re)=>yt.onDidAddDocument(ae,pe,Re),onDidCloseTextDocument:(ae,pe,Re)=>yt.onDidRemoveDocument(ae,pe,Re),onDidChangeTextDocument:(ae,pe,Re)=>yt.onDidChangeDocument(ae,pe,Re),onDidSaveTextDocument:(ae,pe,Re)=>yt.onDidSaveDocument(ae,pe,Re),onWillSaveTextDocument:(ae,pe,Re)=>Ot.getOnWillSaveTextDocumentEvent(xe)(ae,pe,Re),get notebookDocuments(){return St.notebookDocuments.map(ae=>ae.apiNotebook)},async openNotebookDocument(ae,pe){let Re;if(T.URI.isUri(ae))Re=ae,await St.openNotebookDocument(ae);else if(typeof ae=="string")Re=T.URI.revive(await St.createNotebookDocument({viewType:ae,content:pe}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ae,pe,Re,dt){return St.registerNotebookSerializer(xe,ae,pe,Re,(0,De.isProposedApiEnabled)(xe,"notebookLiveShare")?dt:void 0)},registerNotebookContentProvider:(ae,pe,Re,dt)=>((0,De.checkProposedApiEnabled)(xe,"notebookContentProvider"),St.registerNotebookContentProvider(xe,ae,pe,Re,(0,De.isProposedApiEnabled)(xe,"notebookLiveShare")?dt:void 0)),onDidChangeConfiguration:(ae,pe,Re)=>pi.onDidChangeConfiguration(ae,pe,Re),getConfiguration(ae,pe){return pe=arguments.length===1?void 0:pe,pi.getConfiguration(ae,pe,xe)},registerTextDocumentContentProvider(ae,pe){return Ht.registerTextDocumentContentProvider(ae,pe)},registerTaskProvider:(ae,pe)=>(Ze.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(xe,ae,pe)),registerFileSystemProvider(ae,pe,Re){return(0,Te.combinedDisposable)(ci.registerFileSystemProvider(xe,ae,pe,Re),Ne.addFileSystemProvider(ae,pe))},get fs(){return Ne.value},registerFileSearchProvider:(ae,pe)=>((0,De.checkProposedApiEnabled)(xe,"fileSearchProvider"),Mt.registerFileSearchProvider(ae,pe)),registerTextSearchProvider:(ae,pe)=>((0,De.checkProposedApiEnabled)(xe,"textSearchProvider"),Mt.registerTextSearchProvider(ae,pe)),registerRemoteAuthorityResolver:(ae,pe)=>((0,De.checkProposedApiEnabled)(xe,"resolvers"),Qe.registerRemoteAuthorityResolver(ae,pe)),registerResourceLabelFormatter:ae=>((0,De.checkProposedApiEnabled)(xe,"resolvers"),Ei.$registerResourceLabelFormatter(ae)),onDidCreateFiles:(ae,pe,Re)=>Nt.onDidCreateFile(ae,pe,Re),onDidDeleteFiles:(ae,pe,Re)=>Nt.onDidDeleteFile(ae,pe,Re),onDidRenameFiles:(ae,pe,Re)=>Nt.onDidRenameFile(ae,pe,Re),onWillCreateFiles:(ae,pe,Re)=>Nt.getOnWillCreateFileEvent(xe)(ae,pe,Re),onWillDeleteFiles:(ae,pe,Re)=>Nt.getOnWillDeleteFileEvent(xe)(ae,pe,Re),onWillRenameFiles:(ae,pe,Re)=>Nt.getOnWillRenameFileEvent(xe)(ae,pe,Re),openTunnel:ae=>((0,De.checkProposedApiEnabled)(xe,"resolvers"),Oe.openTunnel(xe,ae).then(pe=>{if(!pe)throw new Error("cannot open tunnel");return pe})),get tunnels(){return(0,De.checkProposedApiEnabled)(xe,"resolvers"),Oe.getTunnels()},onDidChangeTunnels:(ae,pe,Re)=>((0,De.checkProposedApiEnabled)(xe,"resolvers"),Oe.onDidChangeTunnels(ae,pe,Re)),registerPortAttributesProvider:(ae,pe)=>((0,De.checkProposedApiEnabled)(xe,"portsAttributes"),Oe.registerPortsAttributesProvider(ae,pe)),registerTimelineProvider:(ae,pe)=>((0,De.checkProposedApiEnabled)(xe,"timeline"),Si.registerTimelineProvider(ae,pe,xe.identifier,mt.converter)),get isTrusted(){return $e.trusted},requestWorkspaceTrust:ae=>((0,De.checkProposedApiEnabled)(xe,"workspaceTrust"),$e.requestWorkspaceTrust(ae)),onDidGrantWorkspaceTrust:(ae,pe,Re)=>$e.onDidGrantWorkspaceTrust(ae,pe,Re)},Li={get inputBox(){return Ze.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),Zt.getLastInputBox(xe)},createSourceControl(ae,pe,Re){return Zt.createSourceControl(xe,ae,pe,Re)}},Fi={createCommentController(ae,pe){return li.createCommentController(xe,ae,pe)}},Mi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(ae,pe,Re){return _t.onDidStartDebugSession(ae,pe,Re)},onDidTerminateDebugSession(ae,pe,Re){return _t.onDidTerminateDebugSession(ae,pe,Re)},onDidChangeActiveDebugSession(ae,pe,Re){return _t.onDidChangeActiveDebugSession(ae,pe,Re)},onDidReceiveDebugSessionCustomEvent(ae,pe,Re){return _t.onDidReceiveDebugSessionCustomEvent(ae,pe,Re)},onDidChangeBreakpoints(ae,pe,Re){return _t.onDidChangeBreakpoints(ae,pe,Re)},registerDebugConfigurationProvider(ae,pe,Re){return _t.registerDebugConfigurationProvider(ae,pe,Re||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ae,pe){return _t.registerDebugAdapterDescriptorFactory(xe,ae,pe)},registerDebugAdapterTrackerFactory(ae,pe){return _t.registerDebugAdapterTrackerFactory(ae,pe)},startDebugging(ae,pe,Re){return!Re||typeof Re=="object"&&"configuration"in Re?_t.startDebugging(ae,pe,{parentSession:Re}):_t.startDebugging(ae,pe,Re||{})},stopDebugging(ae){return _t.stopDebugging(ae)},addBreakpoints(ae){return _t.addBreakpoints(ae)},removeBreakpoints(ae){return _t.removeBreakpoints(ae)},asDebugSourceUri(ae,pe){return _t.asDebugSourceUri(ae,pe)}},Oi={registerTaskProvider:(ae,pe)=>It.registerTaskProvider(xe,ae,pe),fetchTasks:ae=>It.fetchTasks(ae),executeTask:ae=>It.executeTask(xe,ae),get taskExecutions(){return It.taskExecutions},onDidStartTask:(ae,pe,Re)=>It.onDidStartTask(ae,pe,Re),onDidEndTask:(ae,pe,Re)=>It.onDidEndTask(ae,pe,Re),onDidStartTaskProcess:(ae,pe,Re)=>It.onDidStartTaskProcess(ae,pe,Re),onDidEndTaskProcess:(ae,pe,Re)=>It.onDidEndTaskProcess(ae,pe,Re)},Ni={createNotebookController(ae,pe,Re,dt,Ct){return Xt.createNotebookController(xe,ae,pe,Re,dt,(0,De.isProposedApiEnabled)(xe,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(ae,pe)=>St.registerNotebookCellStatusBarItemProvider(xe,ae,pe),get onDidSaveNotebookDocument(){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ae){return(0,De.checkProposedApiEnabled)(xe,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(ae)},createRendererMessaging(ae){return oi.createRendererMessaging(xe,ae)},onDidChangeNotebookDocumentMetadata(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(ae,pe,Re)},onDidChangeNotebookCells(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),St.onDidChangeNotebookCells(ae,pe,Re)},onDidChangeNotebookCellExecutionState(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),Xt.onDidChangeNotebookCellExecutionState(ae,pe,Re)},onDidChangeCellOutputs(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),St.onDidChangeCellOutputs(ae,pe,Re)},onDidChangeCellMetadata(ae,pe,Re){return(0,De.checkProposedApiEnabled)(xe,"notebookEditor"),St.onDidChangeCellMetadata(ae,pe,Re)},createConcatTextDocument(ae,pe){return(0,De.checkProposedApiEnabled)(xe,"notebookConcatTextDocument"),new qe.ExtHostNotebookConcatDocument(St,yt,ae,pe)}};return{version:be.version,authentication:ni,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ri,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:P.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:c.UIKind,Uri:T.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:ie.TextSearchCompleteMessageType,TreeDataTransfer:M.TreeDataTransfer,TreeDataTransferItem:M.TreeDataTransferItem,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity,QuickPickItemKind:M.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=oe}),define(ve[278],we([0,1,279,293,294,2,295]),function(X,e,f,i,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(y,c,b,v,p,w){const L=w.environment.useHostProxy,S=typeof L=="boolean"?L:!w.remote.isRemote,o=(0,T.createProxyResolver)({resolveProxy:m=>y.resolveProxy(m),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(m,a,...E)=>{switch(m){case T.LogLevel.Trace:v.trace(a,...E);break;case T.LogLevel.Debug:v.debug(a,...E);break;case T.LogLevel.Info:v.info(a,...E);break;case T.LogLevel.Warning:v.warn(a,...E);break;case T.LogLevel.Error:v.error(a,...E);break;case T.LogLevel.Critical:v.critical(a,...E);break;case T.LogLevel.Off:break;default:n(m,a,E);break}function n(t,s,...u){v.error("Unknown log level",t),v.error(s,...u)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:m=>{p.$publicLog2("resolveProxy",m)},useHostProxy:S,env:process.env}),r=C(c,o);return R(b,r)}e.connectProxyResolver=I;function C(y,c){const b={config:y.getConfiguration("http").get("proxySupport")||"off"};y.onDidChangeConfiguration(p=>{b.config=y.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!y.getConfiguration("http").get("systemCertificates")};return y.onDidChangeConfiguration(p=>{v.config=!!y.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,T.createHttpPatch)(f,c,{config:"off"},v,!0)),on:Object.assign({},f,(0,T.createHttpPatch)(f,c,{config:"on"},v,!0)),override:Object.assign({},f,(0,T.createHttpPatch)(f,c,{config:"override"},v,!0)),onRequest:Object.assign({},f,(0,T.createHttpPatch)(f,c,b,v,!0)),default:Object.assign(f,(0,T.createHttpPatch)(f,c,b,v,!1))},https:{off:Object.assign({},i,(0,T.createHttpPatch)(i,c,{config:"off"},v,!0)),on:Object.assign({},i,(0,T.createHttpPatch)(i,c,{config:"on"},v,!0)),override:Object.assign({},i,(0,T.createHttpPatch)(i,c,{config:"override"},v,!0)),onRequest:Object.assign({},i,(0,T.createHttpPatch)(i,c,b,v,!0)),default:Object.assign(i,(0,T.createHttpPatch)(i,c,b,v,!1))},tls:Object.assign(k,(0,T.createTlsPatch)(k))}}const P=new Map;function R(y,c){return y.getExtensionPathIndex().then(b=>{const v=X.__$__nodeRequire("module"),p=v._load;v._load=function(L,S,o){if(L==="tls")return c.tls;if(L!=="http"&&L!=="https")return p.apply(this,arguments);const r=c[L],m=b.findSubstr(_.URI.file(S.filename));let a=P.get(m);if(a||P.set(m,a={}),!a[L]){let E=r.default;a[L]={...E}}return a[L]}})}}),define(ve[280],we([0,1,37,8,80,28,12,9,92,281]),function(X,e,f,i,k,_,T,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(o,r,m,a){const E=c(o,r,m,a),n=r.folder.fsPath;return{cmd:f.spawn(R,E.args,{cwd:n}),rgDiskPath:R,siblingClauses:E.siblingClauses,rgArgs:E,cwd:n}}e.spawnRipgrepCmd=y;function c(o,r,m,a){const E=["--files","--hidden","--case-sensitive"];v([r],m,!1).forEach(t=>{const s=(0,C.anchorGlob)(t);if(E.push("-g",s),T.isMacintosh){const u=(0,k.normalizeNFD)(s);u!==s&&E.push("-g",u)}});const n=b([r],a,void 0,!1);return n.globArgs.forEach(t=>{const s=`!${(0,C.anchorGlob)(t)}`;if(E.push("-g",s),T.isMacintosh){const u=(0,k.normalizeNFD)(s);u!==s&&E.push("-g",u)}}),r.disregardIgnoreFiles!==!1?E.push("--no-ignore"):E.push("--no-ignore-parent"),r.ignoreSymlinks||E.push("--follow"),o.exists&&E.push("--quiet"),E.push("--no-config"),r.disregardGlobalIgnoreFiles&&E.push("--no-ignore-global"),{args:E,siblingClauses:n.siblingClauses}}function b(o,r,m,a=!0){const E=[];let n={};return o.forEach(t=>{const s=Object.assign({},t.excludePattern||{},r||{}),u=p(s,a?t.folder.fsPath:void 0,m);E.push(...u.globArgs),u.siblingClauses&&(n=Object.assign(n,u.siblingClauses))}),{globArgs:E,siblingClauses:n}}e.foldersToRgExcludeGlobs=b;function v(o,r,m=!0){const a=[];return o.forEach(E=>{const n=Object.assign({},r||{},E.includePattern||{}),t=p(n,m?E.folder.fsPath:void 0);a.push(...t.globArgs)}),a}e.foldersToIncludeGlobs=v;function p(o,r,m){const a=[],E={};return Object.keys(o).forEach(n=>{if(m&&m.has(n)||!n)return;const t=o[n];n=L(r?w(r,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),a.push(S(n))):t&&t.when&&(E[n]=t)}),{globArgs:a,siblingClauses:E}}function w(o,r){return i.isAbsolute(r)?r:i.join(o,r)}e.getAbsoluteGlob=w;function L(o){return o=I.rtrim(o,"\\"),I.rtrim(o,"/")}function S(o){return _.getRoot(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.fixDriveC=S}),define(ve[282],we([0,1,37,60,8,104,16,50,32,80,28,12,46,9,13,29,31,280,102]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const o=new Set;process.on("exit",()=>{o.forEach(n=>n())});class r{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&C.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&C.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(s=>{const u=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),d=s.folder.fsPath;t.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==d).forEach(h=>{(0,R.isEqualOrParent)(h,d)&&(u[k.relative(d,h)]=!0)}),this.folderExcludePatterns.set(d,new a(u,d))})}cancel(){this.isCanceled=!0,o.forEach(t=>t())}walk(t,s,u,d,h){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);s.forEach(g=>{const l=k.basename(g.fsPath);this.globalExcludePattern&&this.globalExcludePattern(g.fsPath,l)||this.matchFile(u,{relativePath:g.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(t,(g,l)=>{this.call(this.cmdTraversal,this,g,u,d,D=>{if(D){const A=(0,I.toErrorMessage)(D);console.error(A),this.errors.push(A),l(D,void 0)}else l(null,void 0)})},(g,l)=>{this.fileWalkSW.stop();const D=g?T.coalesce(g)[0]:null;h(D,this.isLimitHit)})}parallel(t,s,u){const d=new Array(t.length),h=new Array(t.length);let g=!1,l=0;if(t.length===0)return u(null,[]);t.forEach((D,A)=>{s(D,(N,B)=>{if(N?(g=!0,d[A]=null,h[A]=N):(d[A]=B,h[A]=null),++l===t.length)return u(g?h:null,d)})})}call(t,s,...u){try{t.apply(s,u)}catch(d){u[u.length-1](d)}}cmdTraversal(t,s,u,d){const h=t.folder.fsPath,g=y.isMacintosh;let l;const D=()=>l&&l.kill();o.add(D);let A=M=>{o.delete(D),A=()=>{},d(M)},N="";const B=this.initDirectoryTree();let F;const O=(0,L.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);l=O.cmd,F=!Object.keys(O.siblingClauses).length;const z=O.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let W=`${O.rgDiskPath} ${z}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),u({message:W}),this.cmdResultCount=0,this.collectStdout(l,"utf8",u,(M,x,V)=>{if(M){A(M);return}if(this.isLimitHit){A();return}const H=(N+(g?P.normalizeNFC(x||""):x)).split(`
`);if(V){const Y=H.length;H[Y-1]=H[Y-1].trim(),H[Y-1]||H.pop()}else N=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,F){for(const Y of H)if(this.matchFile(s,{base:h,relativePath:Y,searchPath:this.getSearchPath(t,Y)}),this.isLimitHit){D();break}(V||this.isLimitHit)&&A();return}this.addDirectoryEntries(t,B,h,H,s),V&&(this.matchDirectoryTree(B,h,s),A())})}spawnFindCmd(t){const s=this.folderExcludePatterns.get(t.folder.fsPath),u=s.getBasenameTerms(),d=s.getPathTerms(),h=["-L","."];if(u.length||d.length){h.push("-not","(","(");for(const g of u)h.push("-name",g),h.push("-o");for(const g of d)h.push("-path",g),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),f.spawn("find",h,{cwd:t.folder.fsPath})}readStdout(t,s,u){let d="";this.collectStdout(t,s,()=>{},(h,g,l)=>{if(h){u(h);return}d+=g,l&&u(null,d)})}collectStdout(t,s,u,d){let h=(D,A,N)=>{(D||N)&&(h=()=>{},this.cmdSW&&this.cmdSW.stop()),d(D,A,N)},g=!1;t.stdout?(this.forwardData(t.stdout,s,h),t.stdout.once("data",()=>g=!0)):u({message:"stdout is null"});let l;t.stderr?l=this.collectData(t.stderr):u({message:"stderr is null"}),t.on("error",D=>{h(D)}),t.on("close",D=>{let A;!g&&(A=this.decodeData(l,s))&&E(A)?h(new Error(`command failed with error code ${D}: ${this.decodeData(l,s)}`)):(this.exists&&D===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(t,s,u){const d=new _.StringDecoder(s);return t.on("data",h=>{u(null,d.write(h))}),d}collectData(t){const s=[];return t.on("data",u=>{s.push(u)}),s}decodeData(t,s){const u=new _.StringDecoder(s);return t.map(d=>u.write(d)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:s},u,d,h){d.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const g=l=>{const D=k.basename(l),A=k.dirname(l);let N=s[A];N||(N=s[A]=[],g(A)),N.push({base:u,relativePath:l,basename:D,searchPath:this.getSearchPath(t,l)})};d.forEach(g)}matchDirectoryTree({rootEntries:t,pathToEntries:s},u,d){const h=this,g=this.folderExcludePatterns.get(u),l=this.filePattern;function D(A){h.directoriesWalked++;const N=C.hasSiblingFn(()=>A.map(B=>B.basename));for(let B=0,F=A.length;B<F;B++){const O=A[B],{relativePath:z,basename:W}=O;if(g.test(z,W,l!==W?N:void 0))continue;const M=s[z];if(M)D(M);else{if(h.filesWalked++,z===l)continue;h.matchFile(d,O)}if(h.isLimitHit)break}}D(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,s,u,d,h){const g=t.folder,l=C.hasSiblingFn(()=>u);this.parallel(u,(D,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const N=s?[s,D].join(k.sep):D;if(this.folderExcludePatterns.get(t.folder.fsPath).test(N,D,this.config.filePattern!==D?l:void 0))return A(null);const B=[g.fsPath,N].join(k.sep);i.lstat(B,(F,O)=>{if(F||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(B,O,(z,W)=>z||this.isCanceled||this.isLimitHit?A(null):W.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(B,O,(M,x)=>M||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?A(null):(this.walkedPaths[x]=!0,p.Promises.readdir(B).then(V=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(t,N,V,d,U=>A(U||null))},V=>{A(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&v.isNumber(W.size)&&W.size>this.maxFilesize||this.matchFile(d,{base:g.fsPath,relativePath:N,searchPath:this.getSearchPath(t,N)}),A(null,void 0)))})},D=>{const A=D&&T.coalesce(D);return h(A&&A.length>0?A[0]:void 0)})}matchFile(t,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,k.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(s))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,w.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,s,u){return s.isSymbolicLink()?i.stat(t,u):u(null,s)}realPathIfNeeded(t,s,u){return s.isSymbolicLink()?i.realpath(t,(d,h)=>d?u(d):u(null,h)):u(null,t)}getSearchPath(t,s){return t.folderName?k.join(t.folderName,s):s}}e.FileWalker=r;class m{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new r(t)}search(t,s,u){this.walker.walk(this.folderQueries,this.extraFiles,t,s,(d,h)=>{u(d,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class a{constructor(t,s){this.expression=t,this.root=s,this.init(t)}init(t){let s,u;Object.keys(t).filter(d=>t[d]).forEach(d=>{k.isAbsolute(d)?(s=s||C.getEmptyExpression(),s[d]=t[d]):(u=u||C.getEmptyExpression(),u[d]=t[d])}),this.absoluteParsedExpr=s&&C.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=u&&C.parse(u,{trimForExclusions:!0})}test(t,s,u){return this.relativeParsedExpr&&this.relativeParsedExpr(t,s,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,t),s,u)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...C.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...C.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...C.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...C.getPathTerms(this.relativeParsedExpr)),t}}function E(n){const t=n.trim().split(`
`),s=t[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return b.uppercaseFirstLetter(t[t.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=E}),define(ve[137],we([0,1,37,296,104,16,75,32,8,9,2,31,70,297,281,92]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class L{constructor(g){this.outputChannel=g}provideTextSearchResults(g,l,D,A){return this.outputChannel.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...l,folder:l.folder.toString()})}`),new Promise((N,B)=>{A.onCancellationRequested(()=>U());const F=E(g,l),O=l.folder.fsPath,z=F.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");this.outputChannel.appendLine(`${w} ${z}
 - cwd: ${O}`);let W=f.spawn(w,F,{cwd:O});W.on("error",j=>{console.error(j),this.outputChannel.appendLine("Error: "+(j&&j.message)),B((0,y.serializeSearchError)(new y.SearchError(j&&j.message,y.SearchErrorCode.rgProcessError)))});let M=!1;const x=new r(l.maxResults,O,l.previewOptions);x.on("result",j=>{M=!0,Y="",D.report(j)});let V=!1;const U=()=>{V=!0,W&&W.kill(),x&&x.cancel()};let H=!1;x.on("hitLimit",()=>{H=!0,U()});let Y="";W.stdout.on("data",j=>{x.handleData(j),M||(Y+=j)});let se=!1;W.stdout.once("data",()=>se=!0);let K="";W.stderr.on("data",j=>{const ne=j.toString();this.outputChannel.appendLine(ne),K+=ne}),W.on("close",()=>{if(this.outputChannel.appendLine(se?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),Y&&this.outputChannel.appendLine(`Got data without result: ${Y}`),this.outputChannel.appendLine(""),V)N({limitHit:H});else{x.flush(),W=null;let j;K&&!se&&(j=S(K))?B((0,y.serializeSearchError)(new y.SearchError(j.message,j.code))):N({limitHit:H})}})})}}e.RipgrepTextSearchEngine=L;function S(h){const g=h.split(`
`),l=g[0].trim();if(g.some(A=>A.startsWith("regex parse error")))return new y.SearchError(o(g),y.SearchErrorCode.regexParseError);const D=l.match(/grep config error: unknown encoding: (.*)/);if(D)return new y.SearchError(`Unknown encoding: ${D[1]}`,y.SearchErrorCode.unknownEncoding);if(l.startsWith("error parsing glob"))return new y.SearchError(l.charAt(0).toUpperCase()+l.substr(1),y.SearchErrorCode.globParseError);if(l.startsWith("the literal"))return new y.SearchError(l.charAt(0).toUpperCase()+l.substr(1),y.SearchErrorCode.invalidLiteral);if(l.startsWith("PCRE2: error compiling pattern"))return new y.SearchError(l,y.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function o(h){const g=["Regex parse error"],l=h.filter(D=>D.startsWith("PCRE2:"));if(l.length>=1){const D=l[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const A=D.split(":")[1];g.push(":"+A)}}return g.join("")}e.buildRegexParseError=o;class r extends i.EventEmitter{constructor(g,l,D){super();this.maxResults=g,this.rootFolder=l,this.previewOptions=D,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(g,l){return super.on(g,l),this}handleData(g){if(this.isDone)return;const l=typeof g=="string"?g:this.stringDecoder.write(g);this.handleDecodedData(l)}handleDecodedData(g){let l=g.indexOf(`
`);const D=this.remainder+g;if(l>=0)l+=this.remainder.length;else{this.remainder=D;return}let A=0;for(;l>=0;)this.handleLine(D.substring(A,l).trim()),A=l+1,l=D.indexOf(`
`,A);this.remainder=D.substring(A)}handleLine(g){if(this.isDone||!g)return;let l;try{l=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(l.type==="match"){const D=m(l.data.path),A=R.URI.file(C.join(this.rootFolder,D)),N=this.createTextSearchMatch(l.data,A);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(l.type==="context"){const D=m(l.data.path),A=R.URI.file(C.join(this.rootFolder,D));this.createTextSearchContext(l.data,A).forEach(B=>this.onResult(B))}}createTextSearchMatch(g,l){const D=g.line_number-1,A=m(g.lines),N=Buffer.from(A);let B=0,F=0,O=D;g.submatches.length===0&&g.submatches.push(A.length?{start:0,end:1,match:{text:A[0]}}:{start:0,end:0,match:{text:""}});const z=(0,_.coalesce)(g.submatches.map((W,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=m(W.match),V=N.slice(B,W.start).toString().length,U=F+V,H=a(x),Y=O,se=H.numLines+Y,K=H.numLines>0?H.lastLineLength:H.lastLineLength+U;return B=W.end,F=K,O=se,new c.Range(Y,U,se,K)}));return(0,p.createTextSearchResult)(l,A,z,this.previewOptions)}createTextSearchContext(g,l){const D=m(g.lines),A=g.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((N,B)=>({text:N,uri:l,lineNumber:A+B}))}onResult(g){this.emit("result",g)}}e.RipgrepParser=r;function m(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function a(h){const g=/\n/g;let l=0,D=-1,A;for(;A=g.exec(h);)l++,D=A.index;const N=D>=0?h.length-D-1:h.length;return{numLines:l,lastLineLength:N}}function E(h,g){const l=["--hidden"];l.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:A}=(0,T.groupBy)(g.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const B=new Set;A.forEach(F=>{B.add(F)}),l.push("-g","!*"),B.forEach(F=>{n(F).map(p.anchorGlob).forEach(O=>{l.push("-g",O)})})}D&&D.length&&D.forEach(B=>{l.push("-g",B)}),g.excludes.map(p.anchorGlob).forEach(B=>l.push("-g",`!${B}`)),g.maxFileSize&&l.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?l.push("--no-ignore-parent"):l.push("--no-ignore"),g.followSymlinks&&l.push("--follow"),g.encoding&&g.encoding!=="utf8"&&l.push("--encoding",g.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,P.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),g.usePCRE2&&l.push("--pcre2"),l.push("--crlf"),h.isRegExp&&(h.pattern=t(h.pattern),l.push("--engine","auto"));let N;if(h.isWordMatch){const F=(0,P.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");l.push("--regexp",F)}else if(h.isRegExp){let B=u(h.pattern);B=d(B),l.push("--regexp",B)}else N=h.pattern,l.push("--fixed-strings");return l.push("--no-config"),g.useGlobalIgnoreFiles||l.push("--no-ignore-global"),l.push("--json"),h.isMultiline&&l.push("--multiline"),g.beforeContext&&l.push("--before-context",g.beforeContext+""),g.afterContext&&l.push("--after-context",g.afterContext+""),l.push("--"),N&&l.push(N),l.push("."),l}function n(h){const g=(0,I.splitGlobAware)(h,"/");return g.map((l,D)=>g.slice(0,D+1).join("/"))}e.spreadGlobComponents=n;function t(h){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(g);)h=h.replace(g,"$1\\x{$2}");const l=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(l);)h=h.replace(l,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=t;const s=h=>h.type==="Assertion"&&h.kind==="lookbehind";function u(h){let g;try{g=new b.RegExpParser().parsePattern(h)}catch{return h}let l="",D=0;const A=(F,O,z)=>{l+=h.slice(D,F)+z,D=O},N=[];return new b.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const O=N[0];if(!O)A(F.start,F.end,"\\r?\\n");else if(!N.some(s))if(O.type==="CharacterClass")if(O.negate){const z=h.slice(O.start+2,F.start)+h.slice(F.end,O.end-1);if(O.parent?.type==="Quantifier"){const W=O.parent;A(W.start,W.end,(z?`[^${z}]`:".")+(W.greedy?"+":"*"))}else A(O.start,O.end,"(?!\\r?\\n"+(z?`|[${z}]`:"")+")")}else{const z=h.slice(O.start+1,F.start)+h.slice(F.end,O.end-1);A(O.start,O.end,z===""?"\\r?\\n":`(?:[${z}]|\\r?\\n)`)}else O.type==="Quantifier"&&A(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){N.unshift(F)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(F){N.unshift(F)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(F){N.unshift(F)},onCharacterClassLeave(){N.shift()},onAssertionEnter(F){s(F)&&N.push(F)},onAssertionLeave(F){N[0]===F&&N.shift()}}).visit(g),l+=h.slice(D),l}e.fixRegexNewline=u;function d(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(ve[283],we([0,1,21,137,118,10]),function(X,e,f,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,R,y,c){const b=new i.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===_.Schemas.userData){const v={...R,folder:R.folder.with({scheme:_.Schemas.file})},p=new k.Progress(w=>y.report({...w,uri:w.uri.with({scheme:R.folder.scheme})}));return this.withToken(c,w=>b.provideTextSearchResults(P,v,p,w))}else return this.withToken(c,v=>b.provideTextSearchResults(P,R,y,v))}async withToken(P,R){const y=I(P);this.inProgress.add(y);const c=await R(y.token);return this.inProgress.delete(y),c}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=T;function I(C){const P=new f.CancellationTokenSource;return C.onCancellationRequested(()=>P.cancel()),P}}),define(ve[284],we([0,1,29,137,136]),function(X,e,f,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class _{constructor(C){this.query=C}search(C,P,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const y={appendLine(b){R({message:b})}},c=new k.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(y),f);return new Promise((b,v)=>c.search(p=>{P(p.map(T))},C).then(p=>b({limitHit:p.limitHit,type:"success",stats:p.stats}),v))}}e.TextSearchEngineAdapter=_;function T(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((C,P)=>{if(P.ranges){const R=P;return C+(Array.isArray(R.ranges)?R.ranges.length:1)}else return C+1},0)}}}),define(ve[285],we([0,1,16,18,15,3,102,8,46,2,42,31,282,284]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let m;const a=L(r),E=new _.Emitter({onFirstListenerDidAdd:()=>{m=(0,i.createCancelablePromise)(n=>this.doFileSearchWithEngine(c.Engine,a,t=>E.fire(t),n)),m.then(n=>E.fire(n),n=>E.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return E.event}textSearch(r){let m;const a=L(r),E=new _.Emitter({onFirstListenerDidAdd:()=>{m=(0,i.createCancelablePromise)(n=>this.ripgrepTextSearch(a,t=>E.fire(t),n)),m.then(n=>E.fire(n),n=>E.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return E.event}ripgrepTextSearch(r,m,a){return r.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(r).search(a,m,m)}doFileSearch(r,m,a){return this.doFileSearchWithEngine(c.Engine,r,m,a)}doFileSearchWithEngine(r,m,a,E,n=v.BATCH_SIZE){let t=0;const s=d=>{Array.isArray(d)?(t+=d.length,a(d.map(h=>this.rawMatchToSearchItem(h)))):d.relativePath?(t++,a(this.rawMatchToSearchItem(d))):a(d)};if(m.sortByScore){let d=this.trySortedSearchFromCache(m,s,E);if(!d){const h=m.maxResults?Object.assign({},m,{maxResults:null}):m,g=new r(h);d=this.doSortedSearch(g,m,a,s,E)}return new Promise((h,g)=>{d.then(([l,D])=>{const A=D.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(A,a,n),h(l)},g)})}const u=new r(m);return this.doSearch(u,s,n,E).then(d=>({limitHit:d.limitHit,type:"success",stats:{detailStats:d.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,I.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,m,a,E,n){const t=new _.Emitter;let s=(0,i.createCancelablePromise)(d=>{let h=[];const g=l=>{Array.isArray(l)?h=l:(E(l),t.fire(l))};return this.doSearch(r,g,-1,d).then(l=>[l,h])}),u;if(m.cacheKey){u=this.getOrCreateCache(m.cacheKey);const d={promise:s,event:t.event,resolved:!1};u.resultsToSearchCache[m.filePattern||""]=d,s.then(()=>{d.resolved=!0},h=>{delete u.resultsToSearchCache[m.filePattern||""]}),s=this.preventCancellation(s)}return s.then(([d,h])=>{const g=u?u.scorerCache:Object.create(null),l=(typeof m.maxResults!="number"||m.maxResults>0)&&C.StopWatch.create(!1);return this.sortResults(m,h,g,n).then(D=>{const A=l?l.elapsed():-1;return[{type:"success",stats:{detailStats:d.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:D.length},messages:d.messages,limitHit:d.limitHit||typeof m.maxResults=="number"&&h.length>m.maxResults},D]})})}getOrCreateCache(r){const m=this.caches[r];return m||(this.caches[r]=new p)}trySortedSearchFromCache(r,m,a){const E=r.cacheKey&&this.caches[r.cacheKey];if(!E)return;const n=this.getResultsFromCache(E,r.filePattern||"",m,a);if(n)return n.then(([t,s,u])=>{const d=C.StopWatch.create(!1);return this.sortResults(r,s,E.scorerCache,a).then(h=>{const g=d.elapsed(),l={fromCache:!0,detailStats:u,type:this.processType,resultCount:s.length,sortingTime:g};return[{type:"success",limitHit:t.limitHit||typeof r.maxResults=="number"&&s.length>r.maxResults,stats:l},h]})})}sortResults(r,m,a,E){const n=(0,T.prepareQuery)(r.filePattern||""),t=(u,d)=>(0,T.compareItemsByFuzzyScore)(u,d,n,!0,w,a),s=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return f.topAsync(m,t,s,1e4,E)}sendProgress(r,m,a){if(a&&a>0)for(let E=0;E<r.length;E+=a)m(r.slice(E,E+a));else m(r)}getResultsFromCache(r,m,a,E){const n=C.StopWatch.create(!1),t=m.indexOf(I.sep)>=0;let s;for(const g in r.resultsToSearchCache)if(m.startsWith(g)){if(t&&g.indexOf(I.sep)<0&&g!=="")continue;const l=r.resultsToSearchCache[g];s={promise:this.preventCancellation(l.promise),event:l.event,resolved:l.resolved};break}if(!s)return null;const u=n.elapsed(),d=C.StopWatch.create(!1),h=s.event(a);return E&&E.onCancellationRequested(()=>{h.dispose()}),s.promise.then(([g,l])=>{if(E&&E.isCancellationRequested)throw(0,k.canceled)();const D=[],A=(0,T.prepareQuery)(m).normalizedLowercase;for(const N of l)!(0,y.isFilePatternMatch)(N,A)||D.push(N);return[g,D,{cacheWasResolved:s.resolved,cacheLookupTime:u,cacheFilterTime:d.elapsed(),cacheEntryCount:l.length}]})}doSearch(r,m,a,E){return new Promise((n,t)=>{let s=[];E&&E.onCancellationRequested(()=>r.cancel()),r.search(u=>{u&&(a?(s.push(u),a>0&&s.length>=a&&(m(s),s=[])):m(u))},u=>{m(u)},(u,d)=>{s.length&&m(s),u?t(u):n(d)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,a){return r.then(m,a)}catch(m){return this.then(void 0,m)}finally(m){return r.finally(m)}}}}e.SearchService=v,v.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(o){return(0,I.basename)(o.relativePath)}getItemDescription(o){return(0,I.dirname)(o.relativePath)}getItemPath(o){return o.relativePath}};function L(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(S),extraFileResources:o.extraFileResources&&o.extraFileResources.map(r=>P.URI.revive(r))}}function S(o){return{...o,folder:P.URI.revive(o.folder)}}}),define(ve[286],we([0,1,6,10,2,29,11,26,14,73,65,31,285,283,92,136]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends P.ExtHostSearch{constructor(S,o,r,m){super(S,r,m);this._pfs=_,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new v.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.userData,new b.RipgrepSearchProvider(a)),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const S=new v.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new b.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(i.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(S,o){const r=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(S)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(S,o,r,m){const a=(0,P.reviveQuery)(r);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,o,a,m):super.$provideFileSearchResults(S,o,r,m)}doInternalFileSearch(S,o,r,m){const a=E=>{if((0,y.isSerializedFileMatch)(E)&&(E=[E]),Array.isArray(E)){this._proxy.$handleFileMatch(S,o,E.map(n=>k.URI.file(n.path)));return}E.message&&this._logService.debug("ExtHostSearch",E.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,a,m)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,o){return new p.NativeTextSearchManager(S,o,void 0,"textSearchProvider")}};w=Ve([He(0,C.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,R.IURITransformerService),He(3,T.ILogService)],w),e.NativeExtHostSearch=w}),define(ve[138],we([0,1,298,125,82,22,15,3,6,8,12,33,106,107,299]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(l,D=""){this.debugLabel=D,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(l,D){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,D)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const D=A=>{this.traceSocketEvent("read",A),l(_.VSBuffer.wrap(A))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(l){const D=A=>{this.traceSocketEvent("close",{hadError:A}),l({type:0,hadError:A,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(l){const D=()=>{this.traceSocketEvent("nodeEndReceived"),l()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(l){if(!this.socket.destroyed)try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,T.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,T.onUnexpectedError)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=p;var w;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var L;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(L||(L={}));class S extends C.Disposable{constructor(l,D,A,N){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:A?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new o(this,D,A,N,this._onData,(B,F)=>this._write(B,F))),this._register(this._flowManager.onError(B=>{console.error(B),(0,T.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(B=>this._onClose.fire(B)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,D){this.socket.traceSocketEvent(l,D)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,D){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let A=2;l.byteLength<126?A+=0:l.byteLength<2**16?A+=2:A+=8;const N=_.VSBuffer.alloc(A);if(D?N.writeUInt8(194,0):N.writeUInt8(130,0),l.byteLength<126)N.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){N.writeUInt8(126,1);let B=1;N.writeUInt8(l.byteLength>>>8&255,++B),N.writeUInt8(l.byteLength>>>0&255,++B)}else{N.writeUInt8(127,1);let B=1;N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(0,++B),N.writeUInt8(l.byteLength>>>24&255,++B),N.writeUInt8(l.byteLength>>>16&255,++B),N.writeUInt8(l.byteLength>>>8&255,++B),N.writeUInt8(l.byteLength>>>0&255,++B)}this.socket.write(_.VSBuffer.concat([N,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),A=D.readUInt8(0),N=(A&128)>>>7,B=(A&64)>>>6,F=D.readUInt8(1),O=(F&128)>>>7,z=F&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(B)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),A=D.readUInt8(1),N=(A&128)>>>7;let B=A&127,F=1;B===126?B=D.readUInt8(++F)*2**8+D.readUInt8(++F):B===127&&(B=D.readUInt8(++F)*0+D.readUInt8(++F)*0+D.readUInt8(++F)*0+D.readUInt8(++F)*0+D.readUInt8(++F)*2**24+D.readUInt8(++F)*2**16+D.readUInt8(++F)*2**8+D.readUInt8(++F));let O=0;N&&(O=D.readUInt8(++F)*2**24+D.readUInt8(++F)*2**16+D.readUInt8(++F)*2**8+D.readUInt8(++F)),this._state.state=3,this._state.readLen=B,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),a(D,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(D,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class o extends C.Disposable{constructor(l,D,A,N,B,F){super();this._tracer=l,this._onData=B,this._writeFn=F,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,D?(this._zlibInflateStream=this._register(new r(this._tracer,N,A,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const D=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(D,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,D){return new Promise((A,N)=>{l.write(D),l.flush(B=>A(B))})}acceptFrame(l,D,A){this._readQueue.push({data:l,isCompressed:D,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const D=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(D)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,D,A){return new Promise((N,B)=>{l.write(D),A&&l.write(_.VSBuffer.fromByteArray([0,0,255,255])),l.flush(F=>N(F))})}}class r extends C.Disposable{constructor(l,D,A,N){super();this._tracer=l,this._recordInflateBytes=D,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=v.createInflateRaw(N),this._zlibInflate.on("error",B=>{this._tracer.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibInflate.on("data",B=>{this._tracer.traceSocketEvent("zlibInflateData",B),this._pendingInflateData.push(_.VSBuffer.wrap(B))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const D=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(D)})}}class m extends C.Disposable{constructor(l,D){super();this._tracer=l,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=v.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(_.VSBuffer.wrap(A))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let D=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.byteLength-4),l(D)})}}function a(g,l){if(l===0)return;let D=g.byteLength>>>2;for(let z=0;z<D;z++){const W=g.readUInt32BE(z*4);g.writeUInt32BE(W^l,z*4)}let A=D*4,N=g.byteLength-A;const B=l>>>24&255,F=l>>>16&255,O=l>>>8&255;N>=1&&g.writeUInt8(g.readUInt8(A)^B,A),N>=2&&g.writeUInt8(g.readUInt8(A+1)^F,A+1),N>=3&&g.writeUInt8(g.readUInt8(A+2)^O,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const E={[2]:107,[1]:103};function n(){const g=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):l=(0,P.join)((0,k.tmpdir)(),`vscode-ipc-${g}.sock`),s(l),l}e.createRandomIPCHandle=n;function t(g,l,D){const A=(0,f.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${D}-${l}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${D}-${l}.sock`):N=(0,P.join)(g,`${D}-${l}.sock`),s(N),N}e.createStaticIPCHandle=t;function s(g){const l=E[R.platform];typeof l=="number"&&g.length>=l&&console.warn(`WARNING: IPC handle "${g}" is longer than ${l} chars, try a shorter --user-data-dir`)}class u extends c.IPCServer{constructor(l){super(u.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const D=I.Event.fromNodeEventEmitter(l,"connection");return I.Event.map(D,A=>({protocol:new b.Protocol(new p(A,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function d(g){return new Promise((l,D)=>{const A=(0,i.createServer)();A.on("error",D),A.listen(g,()=>{A.removeListener("error",D),l(new u(A))})})}e.serve=d;function h(g,l){return new Promise((D,A)=>{const N=(0,i.createConnection)(g,()=>{N.removeListener("error",A),D(b.Client.fromSocket(new p(N,`ipc-client${l}`),l))});N.once("error",A)})}e.connect=h}),define(ve[287],we([0,1,138,279,60,38,2,198,11]),function(X,e,f,i,k,_,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(c,b,v){this._commands=c,this.logService=b,this._ipcHandlePath=v,this._server=i.createServer((p,w)=>this.onRequest(p,w)),this.setup().catch(p=>(b.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,b){const v=[];c.setEncoding("utf8"),c.on("data",p=>v.push(p)),c.on("end",()=>{const p=JSON.parse(v.join(""));switch(p.type){case"open":this.open(p,b);break;case"openExternal":this.openExternal(p,b);break;case"status":this.getStatus(p,b);break;case"extensionManagement":this.manageExtensions(p,b).catch(this.logService.error);break;default:b.writeHead(404),b.write(`Unknown message type: ${p.type}`,w=>{w&&this.logService.error(w)}),b.end();break}})}open(c,b){const{fileURIs:v,folderURIs:p,forceNewWindow:w,diffMode:L,addMode:S,forceReuseWindow:o,gotoLineMode:r,waitMarkerFilePath:m,remoteAuthority:a}=c,E=[];if(Array.isArray(p))for(const u of p)try{E.push({folderUri:T.URI.parse(u)})}catch{}if(Array.isArray(v))for(const u of v)try{(0,I.hasWorkspaceFileExtension)(u)?E.push({workspaceUri:T.URI.parse(u)}):E.push({fileUri:T.URI.parse(u)})}catch{}const n=m?T.URI.file(m):void 0,s={forceNewWindow:w,diffMode:L,addMode:S,gotoLineMode:r,forceReuseWindow:o,preferNewWindow:!o&&!n&&!S,waitMarkerFileURI:n,remoteAuthority:a};this._commands.executeCommand("_remoteCLI.windowOpen",E,s),b.writeHead(200),b.end()}async openExternal(c,b){for(const v of c.uris){const p=T.URI.parse(v),w=p.scheme==="file"?p:v;await this._commands.executeCommand("_remoteCLI.openExternal",w)}b.writeHead(200),b.end()}async manageExtensions(c,b){try{const v=L=>L?.map(S=>/\.vsix$/i.test(S)?T.URI.parse(S):S),p={list:c.list,install:v(c.install),uninstall:v(c.uninstall),force:c.force},w=await this._commands.executeCommand("_remoteCLI.manageExtensions",p);b.writeHead(200),b.write(w)}catch(v){b.writeHead(500),b.write(String(v),p=>{p&&this.logService.error(p)})}b.end()}async getStatus(c,b){try{const v=await this._commands.executeCommand("_remoteCLI.getSystemStatus");b.writeHead(200),b.write(v),b.end()}catch(v){b.writeHead(500),b.write(String(v),p=>{p&&this.logService.error(p)}),b.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let R=class extends P{constructor(c,b){super(c,b,(0,f.createRandomIPCHandle)())}};R=Ve([He(0,_.IExtHostCommands),He(1,C.ILogService)],R),e.CLIServer=R}),define(ve[288],we([0,1,72,277,268,5,278,39,258,2,10,7,287,105]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends k.RequireInterceptor{_installInterceptor(){const L=this,S=X.__$__nodeRequire("module"),o=S._load;S._load=function(m,a,E){for(let n of L._alternatives){let t=n(m);if(t){m=t;break}}return L._factories.has(m)?L._factories.get(m).load(m,P.URI.file((0,b.realpathSync)(a.filename)),n=>o.apply(this,[n,a,E])):o.apply(this,arguments)}}}class p extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const L=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(C.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(v,L,this._registry).install(),f.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const r=process.send,m=this._extHostContext.getProxy(_.MainContext.MainThreadConsole);process.send=(...a)=>a.length===0||!a[0]||a[0].type!=="__$console"?r.apply(process,a):(m.$logExtensionHostMessage(a[0]),!1)}_getEntryPoint(L){return L.main}_loadCommonJSModule(L,S,o){if(S.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let r=null;o.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{L&&f.mark(`code/extHost/willLoadExtensionCode/${L.value}`),r=X.__$__nodeRequire(S.fsPath)}catch(m){return Promise.reject(m)}finally{L&&f.mark(`code/extHost/didLoadExtensionCode/${L.value}`),o.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(L){if(!!this._initData.remote.isRemote)for(const S in L){const o=L[S];o===null?delete process.env[S]:process.env[S]=o}}}e.ExtHostExtensionService=p}),define(ve[289],we([0,1,61,261,270,269,286,288,262,55,39,73,71,34,52,68,260,259,11]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(R.IExtHostExtensionService,I.ExtHostExtensionService),(0,f.registerSingleton)(S.ILoggerService,L.ExtHostLoggerService),(0,f.registerSingleton)(p.IExtensionStoragePaths,w.ExtensionStoragePaths),(0,f.registerSingleton)(P.IExtHostDebugService,_.ExtHostDebugService),(0,f.registerSingleton)(y.IExtHostSearch,T.NativeExtHostSearch),(0,f.registerSingleton)(c.IExtHostTask,k.ExtHostTask),(0,f.registerSingleton)(b.IExtHostTerminalService,i.ExtHostTerminalService),(0,f.registerSingleton)(v.IExtHostTunnelService,C.ExtHostTunnelService)}),define(ve[290],we([0,1,125,300,72,15,107,138,191,224,271,22,103,29,105,18,114,273,289]),function(X,e,f,i,k,_,T,I,C,P,R,y,c,b,v,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let s=0;s<process.execArgv.length;s++)process.execArgv[s]==="--inspect-port=0"&&(process.execArgv.splice(s,1),s--)}();const L=i(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=X.__$__nodeRequire("module"),s=t._load;t._load=function(u){if(u==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return s.apply(this,arguments)}})();const S=process.exit.bind(process);function o(t){process.exit=function(s){if(t)S(s);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const s=new Error("An extension called process.crash() and this was prevented.");console.warn(s.stack)}}let r=function(t){S()};function m(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,s)=>{let u=null,d=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,g=3e5,l=new p.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),h),D=new p.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),g);process.on("message",(N,B)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const F=y.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let O;if(N.skipWebSocketFrames)O=new I.NodeSocket(B,"extHost-socket");else{const z=y.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));O=new I.WebSocketNodeSocket(new I.NodeSocket(B,"extHost-socket"),N.permessageDeflate,z,!1)}u?(l.cancel(),D.cancel(),u.beginAcceptReconnection(O,F),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(d),u=new T.PersistentProtocol(O,F),u.sendResume(),u.onDidDispose(()=>r("renderer disconnected")),t(u),u.onSocketClose(()=>{l.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(D.isScheduled())return;l.isScheduled()&&D.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((s,u)=>{const d=f.createConnection(t,()=>{d.removeListener("error",u),s(new T.PersistentProtocol(new I.NodeSocket(d,"extHost-renderer")))});d.once("error",u),d.on("close",()=>{r("renderer closed the socket")})})}}async function a(){const t=await m();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(s=>{(0,P.isMessageOfType)(s,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(s)})}send(s){this._terminating||t.send(s)}drain(){return t.drain()}}}function E(t){return new Promise(s=>{const u=t.onMessage(d=>{u.dispose();const h=JSON.parse(d.toString()),g=h.commit,l=C.default.commit;g&&l&&g!==l&&S(55);let D=0;setInterval(function(){try{process.kill(h.parentPid,0),D=0}catch(N){N&&N.code==="EPERM"?(D++,D>=3&&r(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):r(`parent process ${h.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let A;try{A=X.__$__nodeRequire("native-watchdog"),A.start(h.parentPid)}catch(N){(0,_.onUnexpectedError)(N)}t.send((0,P.createMessageOfType)(0)),s({protocol:t,initData:h})});t.send((0,P.createMessageOfType)(1))})}async function n(){const t=[];process.on("unhandledRejection",(D,A)=>{t.push(A),setTimeout(()=>{const N=t.indexOf(A);N>=0&&A.catch(B=>{t.splice(N,1),(0,_.isPromiseCanceledError)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),D&&(0,_.onUnexpectedError)(D))})},1e3)}),process.on("rejectionHandled",D=>{const A=t.indexOf(D);A>=0&&t.splice(A,1)}),process.on("uncaughtException",function(D){(0,_.onUnexpectedError)(D)}),k.mark("code/extHost/willConnectToRenderer");const s=await a();k.mark("code/extHost/didConnectToRenderer");const u=await E(s);k.mark("code/extHost/didWaitForInitData");const{initData:d}=u;o(!!d.environment.extensionTestsLocationURI),d.environment.useHostProxy=L.useHostProxy!==void 0?L.useHostProxy!=="false":void 0,d.environment.skipWorkspaceStorageLock=(0,w.boolean)(L.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(A){S(A)}exists(A){return b.Promises.exists(A)}realpath(A){return(0,v.realpath)(A)}};let g=null;if(d.remote.authority&&L.uriTransformerPath)try{const A=X.__$__nodeRequire(L.uriTransformerPath)(d.remote.authority);g=new c.URITransformer(A)}catch(D){console.error(D)}const l=new R.ExtensionHostMain(u.protocol,d,h,g);r=D=>l.terminate(D)}e.startExtensionHostProcess=n}),define(ve[301],we([0,1,290]),function(X,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.startExtensionHostProcess)().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/99305570d885bce929ba8f24d90f2c3ee54c5c2f/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
