/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/languages/languageSelector","vs/base/common/hash","vs/editor/common/languages","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Z){for(var e=[],s=0,t=Z.length;s<t;s++)e[s]=ye[Z[s]];return e};define(ye[42],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function s(t,E){if(!t)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=s}),define(ye[52],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function s(k){return k?k.replace(/\$\((.*?)\)/g,(I,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=s;class t{constructor(I,C,A){this.id=I,this.definition=C,this.description=A,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function E(k,I){const C=["codicon","codicon-"+k];return I&&C.push("codicon-modifier-"+I),C}e.getClassNamesArray=E;var T;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function C(b){if(b instanceof t)return["codicon","codicon-"+b.id];const n=I.exec(b.id);if(!n)return C(t.error);let[,g,o]=n;const c=["codicon","codicon-"+g];return o&&c.push("codicon-modifier-"+o.substr(1)),c}k.asClassNameArray=C;function A(b){return C(b).join(" ")}k.asClassName=A;function R(b){return"."+C(b).join(".")}k.asCSSSelector=R})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ye[74],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const s=Object.prototype.hasOwnProperty;function t(R){const b=[];for(let n in R)s.call(R,n)&&b.push(R[n]);return b}e.values=t;function E(R,b){for(let n in R)if(s.call(R,n)&&b({key:n,value:R[n]},function(){delete R[n]})===!1)return}e.forEach=E;function T(R,b){const n=Object.create(null);for(const g of R){const o=b(g);let c=n[o];c||(c=n[o]=[]),c.push(g)}return n}e.groupBy=T;function k(R){const b=Object.create(null);return R&&R.forEach((n,g)=>{b[g]=n}),b}e.fromMap=k;function I(R,b){const n=[],g=[];for(let o of R)b.has(o)||n.push(o);for(let o of b)R.has(o)||g.push(o);return{removed:n,added:g}}e.diffSets=I;function C(R,b){const n=[],g=[];for(let[o,c]of R)b.has(o)||n.push(c);for(let[o,c]of b)R.has(o)||g.push(c);return{removed:n,added:g}}e.diffMaps=C;class A{constructor(){this.map=new Map}add(b,n){let g=this.map.get(b);g||(g=new Set,this.map.set(b,g)),g.add(n)}delete(b,n){const g=this.map.get(b);!g||(g.delete(n),g.size===0&&this.map.delete(b))}forEach(b,n){const g=this.map.get(b);!g||g.forEach(n)}}e.SetMap=A}),define(ye[53],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function s(k){return(I,C,A)=>{let R=null,b=null;if(typeof A.value=="function"?(R="value",b=A.value):typeof A.get=="function"&&(R="get",b=A.get),!b)throw new Error("not supported");A[R]=k(b,C)}}e.createDecorator=s;function t(k,I,C){let A=null,R=null;if(typeof C.value=="function"?(A="value",R=C.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(A="get",R=C.get),!R)throw new Error("not supported");const b=`$memoize$${I}`;C[A]=function(...n){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,n)}),this[b]}}e.memoize=t;function E(k,I,C){return s((A,R)=>{const b=`$debounce$${R}`,n=`$debounce$result$${R}`;return function(...g){this[n]||(this[n]=C?C():void 0),clearTimeout(this[b]),I&&(this[n]=I(this[n],...g),g=[this[n]]),this[b]=setTimeout(()=>{A.apply(this,g),this[n]=C?C():void 0},k)}})}e.debounce=E;function T(k,I,C){return s((A,R)=>{const b=`$throttle$timer$${R}`,n=`$throttle$result$${R}`,g=`$throttle$lastRun$${R}`,o=`$throttle$pending$${R}`;return function(...c){if(this[n]||(this[n]=C?C():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),I&&(this[n]=I(this[n],...c)),this[o])return;const u=this[g]+k;u<=Date.now()?(this[g]=Date.now(),A.apply(this,[this[n]]),this[n]=C?C():void 0):(this[o]=!0,this[b]=setTimeout(()=>{this[o]=!1,this[g]=Date.now(),A.apply(this,[this[n]]),this[n]=C?C():void 0},u-Date.now()))}})}e.throttle=T}),define(ye[54],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(ye[100],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var s;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(s=e.ScanError||(e.ScanError={}));var t;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(l){l.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(l,M=!1){let r=0,i=l.length,p="",m=0,h=16,w=0;function v(O){let z=0,U=0;for(;z<O;){const $=l.charCodeAt(r);if($>=48&&$<=57)U=U*16+$-48;else if($>=65&&$<=70)U=U*16+$-65+10;else if($>=97&&$<=102)U=U*16+$-97+10;else break;r++,z++}return z<O&&(U=-1),U}function a(O){r=O,p="",m=0,h=16,w=0}function S(){const O=r;if(l.charCodeAt(r)===48)r++;else for(r++;r<l.length&&A(l.charCodeAt(r));)r++;if(r<l.length&&l.charCodeAt(r)===46)if(r++,r<l.length&&A(l.charCodeAt(r)))for(r++;r<l.length&&A(l.charCodeAt(r));)r++;else return w=3,l.substring(O,r);let z=r;if(r<l.length&&(l.charCodeAt(r)===69||l.charCodeAt(r)===101))if(r++,(r<l.length&&l.charCodeAt(r)===43||l.charCodeAt(r)===45)&&r++,r<l.length&&A(l.charCodeAt(r))){for(r++;r<l.length&&A(l.charCodeAt(r));)r++;z=r}else w=3;return l.substring(O,z)}function P(){let O="",z=r;for(;;){if(r>=i){O+=l.substring(z,r),w=2;break}const U=l.charCodeAt(r);if(U===34){O+=l.substring(z,r),r++;break}if(U===92){if(O+=l.substring(z,r),r++,r>=i){w=2;break}switch(l.charCodeAt(r++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const V=v(4);V>=0?O+=String.fromCharCode(V):w=4;break}default:w=5}z=r;continue}if(U>=0&&U<=31)if(C(U)){O+=l.substring(z,r),w=2;break}else w=6;r++}return O}function N(){if(p="",w=0,m=r,r>=i)return m=i,h=17;let O=l.charCodeAt(r);if(I(O)){do r++,p+=String.fromCharCode(O),O=l.charCodeAt(r);while(I(O));return h=15}if(C(O))return r++,p+=String.fromCharCode(O),O===13&&l.charCodeAt(r)===10&&(r++,p+=`
`),h=14;switch(O){case 123:return r++,h=1;case 125:return r++,h=2;case 91:return r++,h=3;case 93:return r++,h=4;case 58:return r++,h=6;case 44:return r++,h=5;case 34:return r++,p=P(),h=10;case 47:{const z=r-1;if(l.charCodeAt(r+1)===47){for(r+=2;r<i&&!C(l.charCodeAt(r));)r++;return p=l.substring(z,r),h=12}if(l.charCodeAt(r+1)===42){r+=2;const U=i-1;let $=!1;for(;r<U;){if(l.charCodeAt(r)===42&&l.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,w=1),p=l.substring(z,r),h=13}return p+=String.fromCharCode(O),r++,h=16}case 45:if(p+=String.fromCharCode(O),r++,r===i||!A(l.charCodeAt(r)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=S(),h=11;default:for(;r<i&&B(O);)r++,O=l.charCodeAt(r);if(m!==r){switch(p=l.substring(m,r),p){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return p+=String.fromCharCode(O),r++,h=16}}function B(O){if(I(O)||C(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:a,getPosition:()=>r,scan:M?_:N,getToken:()=>h,getTokenValue:()=>p,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>w}}e.createScanner=k;function I(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function C(l){return l===10||l===13||l===8232||l===8233}function A(l){return l>=48&&l<=57}var R;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(R||(R={}));function b(l,M){const r=[],i=new Object;let p;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function w(v,a,S,P){m.value=v,m.offset=a,m.length=S,m.type=P,m.colonOffset=void 0,p=m}try{f(l,{onObjectBegin:(v,a)=>{if(M<=v)throw i;p=void 0,h=M>v,r.push("")},onObjectProperty:(v,a,S)=>{if(M<a||(w(v,a,S,"property"),r[r.length-1]=v,M<=a+S))throw i},onObjectEnd:(v,a)=>{if(M<=v)throw i;p=void 0,r.pop()},onArrayBegin:(v,a)=>{if(M<=v)throw i;p=void 0,r.push(0)},onArrayEnd:(v,a)=>{if(M<=v)throw i;p=void 0,r.pop()},onLiteralValue:(v,a,S)=>{if(M<a||(w(v,a,S,D(v)),M<=a+S))throw i},onSeparator:(v,a,S)=>{if(M<=a)throw i;if(v===":"&&p&&p.type==="property")p.colonOffset=a,h=!1,p=void 0;else if(v===","){const P=r[r.length-1];typeof P=="number"?r[r.length-1]=P+1:(h=!0,r[r.length-1]=""),p=void 0}}})}catch(v){if(v!==i)throw v}return{path:r,previousNode:p,isAtPropertyKey:h,matches:v=>{let a=0;for(let S=0;a<v.length&&S<r.length;S++)if(v[a]===r[S]||v[a]==="*")a++;else if(v[a]!=="**")return!1;return a===v.length}}}e.getLocation=b;function n(l,M=[],r=T.DEFAULT){let i=null,p=[];const m=[];function h(v){Array.isArray(p)?p.push(v):i!==null&&(p[i]=v)}return f(l,{onObjectBegin:()=>{const v={};h(v),m.push(p),p=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{p=m.pop()},onArrayBegin:()=>{const v=[];h(v),m.push(p),p=v,i=null},onArrayEnd:()=>{p=m.pop()},onLiteralValue:h,onError:(v,a,S)=>{M.push({error:v,offset:a,length:S})}},r),p[0]}e.parse=n;function g(l,M=[],r=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(v){i.type==="property"&&(i.length=v-i.offset,i=i.parent)}function m(v){return i.children.push(v),v}f(l,{onObjectBegin:v=>{i=m({type:"object",offset:v,length:-1,parent:i,children:[]})},onObjectProperty:(v,a,S)=>{i=m({type:"property",offset:a,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:v,offset:a,length:S,parent:i})},onObjectEnd:(v,a)=>{i.length=v+a-i.offset,i=i.parent,p(v+a)},onArrayBegin:(v,a)=>{i=m({type:"array",offset:v,length:-1,parent:i,children:[]})},onArrayEnd:(v,a)=>{i.length=v+a-i.offset,i=i.parent,p(v+a)},onLiteralValue:(v,a,S)=>{m({type:D(v),offset:a,length:S,parent:i,value:v}),p(a+S)},onSeparator:(v,a,S)=>{i.type==="property"&&(v===":"?i.colonOffset=a:v===","&&p(a))},onError:(v,a,S)=>{M.push({error:v,offset:a,length:S})}},r);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=g;function o(l,M){if(!l)return;let r=l;for(let i of M)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let p=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===i){r=m.children[1],p=!0;break}if(!p)return}else{const p=i;if(r.type!=="array"||p<0||!Array.isArray(r.children)||p>=r.children.length)return;r=r.children[p]}return r}e.findNodeAtLocation=o;function c(l){if(!l.parent||!l.parent.children)return[];const M=c(l.parent);if(l.parent.type==="property"){const r=l.parent.children[0].value;M.push(r)}else if(l.parent.type==="array"){const r=l.parent.children.indexOf(l);r!==-1&&M.push(r)}return M}e.getNodePath=c;function u(l){switch(l.type){case"array":return l.children.map(u);case"object":{const M=Object.create(null);for(let r of l.children){const i=r.children[1];i&&(M[r.children[0].value]=u(i))}return M}case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=u;function F(l,M,r=!1){return M>=l.offset&&M<l.offset+l.length||r&&M===l.offset+l.length}e.contains=F;function y(l,M,r=!1){if(F(l,M,r)){const i=l.children;if(Array.isArray(i))for(let p=0;p<i.length&&i[p].offset<=M;p++){const m=y(i[p],M,r);if(m)return m}return l}}e.findNodeAtOffset=y;function f(l,M,r=T.DEFAULT){const i=k(l,!1);function p(ae){return ae?()=>ae(i.getTokenOffset(),i.getTokenLength()):()=>!0}function m(ae){return ae?le=>ae(le,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=p(M.onObjectBegin),w=m(M.onObjectProperty),v=p(M.onObjectEnd),a=p(M.onArrayBegin),S=p(M.onArrayEnd),P=m(M.onLiteralValue),N=m(M.onSeparator),B=p(M.onComment),_=m(M.onError),O=r&&r.disallowComments,z=r&&r.allowTrailingComma;function U(){for(;;){const ae=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:O||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ae){case 12:case 13:O?$(10):B();break;case 16:$(1);break;case 15:case 14:break;default:return ae}}}function $(ae,le=[],Ce=[]){if(_(ae),le.length+Ce.length>0){let Ee=i.getToken();for(;Ee!==17;){if(le.indexOf(Ee)!==-1){U();break}else if(Ce.indexOf(Ee)!==-1)break;Ee=U()}}}function V(ae){const le=i.getTokenValue();return ae?P(le):w(le),U(),!0}function ue(){switch(i.getToken()){case 11:{let ae=0;try{ae=JSON.parse(i.getTokenValue()),typeof ae!="number"&&($(2),ae=0)}catch{$(2)}P(ae);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return U(),!0}function K(){return i.getToken()!==10?($(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(N(":"),U(),be()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function re(){h(),U();let ae=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ae||$(4,[],[]),N(","),U(),i.getToken()===2&&z)break}else ae&&$(6,[],[]);K()||$(4,[],[2,5]),ae=!0}return v(),i.getToken()!==2?$(7,[2],[]):U(),!0}function pe(){a(),U();let ae=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ae||$(4,[],[]),N(","),U(),i.getToken()===4&&z)break}else ae&&$(6,[],[]);be()||$(4,[],[4,5]),ae=!0}return S(),i.getToken()!==4?$(8,[4],[]):U(),!0}function be(){switch(i.getToken()){case 3:return pe();case 1:return re();case 10:return V(!0);default:return ue()}}return U(),i.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):be()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=f;function d(l,M){let r=k(l),i=[],p,m=0,h;do switch(h=r.getPosition(),p=r.scan(),p){case 12:case 13:case 17:m!==h&&i.push(l.substring(m,h)),M!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,M)),m=r.getPosition();break}while(p!==17);return i.join("")}e.stripComments=d;function D(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Ae,De){for(var ve=0;ve<De.length;ve++){var ie=De[ve];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Ae,ie.key,ie)}}function e(Ae,De,ve){return De&&Z(Ae.prototype,De),ve&&Z(Ae,ve),Ae}function s(Ae,De){if(!!Ae){if(typeof Ae=="string")return t(Ae,De);var ve=Object.prototype.toString.call(Ae).slice(8,-1);if(ve==="Object"&&Ae.constructor&&(ve=Ae.constructor.name),ve==="Map"||ve==="Set")return Array.from(Ae);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return t(Ae,De)}}function t(Ae,De){(De==null||De>Ae.length)&&(De=Ae.length);for(var ve=0,ie=new Array(De);ve<De;ve++)ie[ve]=Ae[ve];return ie}function E(Ae,De){var ve=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(ve)return(ve=ve.call(Ae)).next.bind(ve);if(Array.isArray(Ae)||(ve=s(Ae))||De&&Ae&&typeof Ae.length=="number"){ve&&(Ae=ve);var ie=0;return function(){return ie>=Ae.length?{done:!0}:{done:!1,value:Ae[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Ae){T.exports.defaults=Ae}T.exports={defaults:k(),getDefaults:k,changeDefaults:I};var C=/[&<>"']/,A=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(De){return n[De]};function o(Ae,De){if(De){if(C.test(Ae))return Ae.replace(A,g)}else if(R.test(Ae))return Ae.replace(b,g);return Ae}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(Ae){return Ae.replace(c,function(De,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var F=/(^|[^\[])\^/g;function y(Ae,De){Ae=Ae.source||Ae,De=De||"";var ve={replace:function(se,de){return de=de.source||de,de=de.replace(F,"$1"),Ae=Ae.replace(se,de),ve},getRegex:function(){return new RegExp(Ae,De)}};return ve}var f=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(Ae,De,ve){if(Ae){var ie;try{ie=decodeURIComponent(u(ve)).replace(f,"").toLowerCase()}catch{return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}De&&!d.test(ve)&&(ve=p(De,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var l={},M=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(Ae,De){l[" "+Ae]||(M.test(Ae)?l[" "+Ae]=Ae+"/":l[" "+Ae]=v(Ae,"/",!0)),Ae=l[" "+Ae];var ve=Ae.indexOf(":")===-1;return De.substring(0,2)==="//"?ve?De:Ae.replace(r,"$1")+De:De.charAt(0)==="/"?ve?De:Ae.replace(i,"$1")+De:Ae+De}var m={exec:function(){}};function h(Ae){for(var De=1,ve,ie;De<arguments.length;De++){ve=arguments[De];for(ie in ve)Object.prototype.hasOwnProperty.call(ve,ie)&&(Ae[ie]=ve[ie])}return Ae}function w(Ae,De){var ve=Ae.replace(/\|/g,function(de,me,Te){for(var We=!1,Le=me;--Le>=0&&Te[Le]==="\\";)We=!We;return We?"|":" |"}),ie=ve.split(/ \|/),se=0;if(ie[0].trim()||ie.shift(),ie[ie.length-1].trim()||ie.pop(),ie.length>De)ie.splice(De);else for(;ie.length<De;)ie.push("");for(;se<ie.length;se++)ie[se]=ie[se].trim().replace(/\\\|/g,"|");return ie}function v(Ae,De,ve){var ie=Ae.length;if(ie===0)return"";for(var se=0;se<ie;){var de=Ae.charAt(ie-se-1);if(de===De&&!ve)se++;else if(de!==De&&ve)se++;else break}return Ae.substr(0,ie-se)}function a(Ae,De){if(Ae.indexOf(De[1])===-1)return-1;for(var ve=Ae.length,ie=0,se=0;se<ve;se++)if(Ae[se]==="\\")se++;else if(Ae[se]===De[0])ie++;else if(Ae[se]===De[1]&&(ie--,ie<0))return se;return-1}function S(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Ae,De){if(De<1)return"";for(var ve="";De>1;)De&1&&(ve+=Ae),De>>=1,Ae+=Ae;return ve+Ae}var N={escape:o,unescape:u,edit:y,cleanUrl:D,resolveUrl:p,noopTest:m,merge:h,splitCells:w,rtrim:v,findClosingBracket:a,checkSanitizeDeprecation:S,repeatString:P},B=T.exports.defaults,_=N.rtrim,O=N.splitCells,z=N.escape,U=N.findClosingBracket;function $(Ae,De,ve,ie){var se=De.href,de=De.title?z(De.title):null,me=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){ie.state.inLink=!0;var Te={type:"link",raw:ve,href:se,title:de,text:me,tokens:ie.inlineTokens(me,[])};return ie.state.inLink=!1,Te}else return{type:"image",raw:ve,href:se,title:de,text:z(me)}}function V(Ae,De){var ve=Ae.match(/^(\s+)(?:```)/);if(ve===null)return De;var ie=ve[1];return De.split(`
`).map(function(se){var de=se.match(/^\s+/);if(de===null)return se;var me=de[0];return me.length>=ie.length?se.slice(ie.length):se}).join(`
`)}var ue=function(){function Ae(ve){this.options=ve||B}var De=Ae.prototype;return De.space=function(ie){var se=this.rules.block.newline.exec(ie);if(se)return se[0].length>1?{type:"space",raw:se[0]}:{raw:`
`}},De.code=function(ie){var se=this.rules.block.code.exec(ie);if(se){var de=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?de:_(de,`
`)}}},De.fences=function(ie){var se=this.rules.block.fences.exec(ie);if(se){var de=se[0],me=V(de,se[3]||"");return{type:"code",raw:de,lang:se[2]?se[2].trim():se[2],text:me}}},De.heading=function(ie){var se=this.rules.block.heading.exec(ie);if(se){var de=se[2].trim();if(/#$/.test(de)){var me=_(de,"#");(this.options.pedantic||!me||/ $/.test(me))&&(de=me.trim())}var Te={type:"heading",raw:se[0],depth:se[1].length,text:de,tokens:[]};return this.lexer.inline(Te.text,Te.tokens),Te}},De.hr=function(ie){var se=this.rules.block.hr.exec(ie);if(se)return{type:"hr",raw:se[0]}},De.blockquote=function(ie){var se=this.rules.block.blockquote.exec(ie);if(se){var de=se[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(de,[]),text:de}}},De.list=function(ie){var se=this.rules.block.list.exec(ie);if(se){var de,me,Te,We,Le,Ke,it,rt,ne,ge,te=se[1].trim(),W=te.length>1,we={type:"list",raw:"",ordered:W,start:W?+te.slice(0,-1):"",loose:!1,items:[]};te=W?"\\d{1,9}\\"+te.slice(-1):"\\"+te,this.options.pedantic&&(te=W?te:"[*+-]");for(var Pe=new RegExp("^( {0,3}"+te+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ie&&!(this.rules.block.hr.test(ie)||!(se=Pe.exec(ie)));){ne=se[2].split(`
`),this.options.pedantic?(We=2,ge=ne[0].trimLeft()):(We=se[2].search(/[^ ]/),We=se[1].length+(We>4?1:We),ge=ne[0].slice(We-se[1].length)),Ke=!1,de=se[0],!ne[0]&&/^ *$/.test(ne[1])&&(de=se[1]+ne.slice(0,2).join(`
`)+`
`,we.loose=!0,ne=[]);var Ye=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<ne.length;Le++){if(rt=ne[Le],this.options.pedantic&&(rt=rt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ye.test(rt)){de=se[1]+ne.slice(0,Le).join(`
`)+`
`;break}if(!Ke){rt.trim()||(Ke=!0),rt.search(/[^ ]/)>=We?ge+=`
`+rt.slice(We):ge+=`
`+rt;continue}if(rt.search(/[^ ]/)>=We||!rt.trim()){ge+=`
`+rt.slice(We);continue}else{de=se[1]+ne.slice(0,Le).join(`
`)+`
`;break}}we.loose||(it?we.loose=!0:/\n *\n *$/.test(de)&&(it=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Te=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:de,task:!!me,checked:Te,loose:!1,text:ge}),we.raw+=de,ie=ie.slice(de.length)}we.items[we.items.length-1].raw=de.trimRight(),we.items[we.items.length-1].text=ge.trimRight(),we.raw=we.raw.trimRight();var xe=we.items.length;for(Le=0;Le<xe;Le++)this.lexer.state.top=!1,we.items[Le].tokens=this.lexer.blockTokens(we.items[Le].text,[]),we.items[Le].tokens.some(function(ut){return ut.type==="space"})&&(we.loose=!0,we.items[Le].loose=!0);return we}},De.html=function(ie){var se=this.rules.block.html.exec(ie);if(se){var de={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};return this.options.sanitize&&(de.type="paragraph",de.text=this.options.sanitizer?this.options.sanitizer(se[0]):z(se[0]),de.tokens=[],this.lexer.inline(de.text,de.tokens)),de}},De.def=function(ie){var se=this.rules.block.def.exec(ie);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var de=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:de,raw:se[0],href:se[2],title:se[3]}}},De.table=function(ie){var se=this.rules.block.table.exec(ie);if(se){var de={type:"table",header:O(se[1]).map(function(it){return{text:it}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]?se[3].replace(/\n$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=se[0];var me=de.align.length,Te,We,Le,Ke;for(Te=0;Te<me;Te++)/^ *-+: *$/.test(de.align[Te])?de.align[Te]="right":/^ *:-+: *$/.test(de.align[Te])?de.align[Te]="center":/^ *:-+ *$/.test(de.align[Te])?de.align[Te]="left":de.align[Te]=null;for(me=de.rows.length,Te=0;Te<me;Te++)de.rows[Te]=O(de.rows[Te],de.header.length).map(function(it){return{text:it}});for(me=de.header.length,We=0;We<me;We++)de.header[We].tokens=[],this.lexer.inlineTokens(de.header[We].text,de.header[We].tokens);for(me=de.rows.length,We=0;We<me;We++)for(Ke=de.rows[We],Le=0;Le<Ke.length;Le++)Ke[Le].tokens=[],this.lexer.inlineTokens(Ke[Le].text,Ke[Le].tokens);return de}}},De.lheading=function(ie){var se=this.rules.block.lheading.exec(ie);if(se){var de={type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.paragraph=function(ie){var se=this.rules.block.paragraph.exec(ie);if(se){var de={type:"paragraph",raw:se[0],text:se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.text=function(ie){var se=this.rules.block.text.exec(ie);if(se){var de={type:"text",raw:se[0],text:se[0],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.escape=function(ie){var se=this.rules.inline.escape.exec(ie);if(se)return{type:"escape",raw:se[0],text:z(se[1])}},De.tag=function(ie){var se=this.rules.inline.tag.exec(ie);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):z(se[0]):se[0]}},De.link=function(ie){var se=this.rules.inline.link.exec(ie);if(se){var de=se[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var me=_(de.slice(0,-1),"\\");if((de.length-me.length)%2==0)return}else{var Te=U(se[2],"()");if(Te>-1){var We=se[0].indexOf("!")===0?5:4,Le=We+se[1].length+Te;se[2]=se[2].substring(0,Te),se[0]=se[0].substring(0,Le).trim(),se[3]=""}}var Ke=se[2],it="";if(this.options.pedantic){var rt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ke);rt&&(Ke=rt[1],it=rt[3])}else it=se[3]?se[3].slice(1,-1):"";return Ke=Ke.trim(),/^</.test(Ke)&&(this.options.pedantic&&!/>$/.test(de)?Ke=Ke.slice(1):Ke=Ke.slice(1,-1)),$(se,{href:Ke&&Ke.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},De.reflink=function(ie,se){var de;if((de=this.rules.inline.reflink.exec(ie))||(de=this.rules.inline.nolink.exec(ie))){var me=(de[2]||de[1]).replace(/\s+/g," ");if(me=se[me.toLowerCase()],!me||!me.href){var Te=de[0].charAt(0);return{type:"text",raw:Te,text:Te}}return $(de,me,de[0],this.lexer)}},De.emStrong=function(ie,se,de){de===void 0&&(de="");var me=this.rules.inline.emStrong.lDelim.exec(ie);if(!!me&&!(me[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=me[1]||me[2]||"";if(!Te||Te&&(de===""||this.rules.inline.punctuation.exec(de))){var We=me[0].length-1,Le,Ke,it=We,rt=0,ne=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,se=se.slice(-1*ie.length+We);(me=ne.exec(se))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(Ke=Le.length,me[3]||me[4]){it+=Ke;continue}else if((me[5]||me[6])&&We%3&&!((We+Ke)%3)){rt+=Ke;continue}if(it-=Ke,!(it>0)){if(Ke=Math.min(Ke,Ke+it+rt),Math.min(We,Ke)%2){var ge=ie.slice(1,We+me.index+Ke);return{type:"em",raw:ie.slice(0,We+me.index+Ke+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var te=ie.slice(2,We+me.index+Ke-1);return{type:"strong",raw:ie.slice(0,We+me.index+Ke+1),text:te,tokens:this.lexer.inlineTokens(te,[])}}}}}},De.codespan=function(ie){var se=this.rules.inline.code.exec(ie);if(se){var de=se[2].replace(/\n/g," "),me=/[^ ]/.test(de),Te=/^ /.test(de)&&/ $/.test(de);return me&&Te&&(de=de.substring(1,de.length-1)),de=z(de,!0),{type:"codespan",raw:se[0],text:de}}},De.br=function(ie){var se=this.rules.inline.br.exec(ie);if(se)return{type:"br",raw:se[0]}},De.del=function(ie){var se=this.rules.inline.del.exec(ie);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2],[])}},De.autolink=function(ie,se){var de=this.rules.inline.autolink.exec(ie);if(de){var me,Te;return de[2]==="@"?(me=z(this.options.mangle?se(de[1]):de[1]),Te="mailto:"+me):(me=z(de[1]),Te=me),{type:"link",raw:de[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.url=function(ie,se){var de;if(de=this.rules.inline.url.exec(ie)){var me,Te;if(de[2]==="@")me=z(this.options.mangle?se(de[0]):de[0]),Te="mailto:"+me;else{var We;do We=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(We!==de[0]);me=z(de[0]),de[1]==="www."?Te="http://"+me:Te=me}return{type:"link",raw:de[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.inlineText=function(ie,se){var de=this.rules.inline.text.exec(ie);if(de){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):z(de[0]):de[0]:me=z(this.options.smartypants?se(de[0]):de[0]),{type:"text",raw:de[0],text:me}}},Ae}(),K=N.noopTest,re=N.edit,pe=N.merge,be={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:K,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};be._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,be._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,be.def=re(be.def).replace("label",be._label).replace("title",be._title).getRegex(),be.bullet=/(?:[*+-]|\d{1,9}[.)])/,be.listItemStart=re(/^( *)(bull) */).replace("bull",be.bullet).getRegex(),be.list=re(be.list).replace(/bull/g,be.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+be.def.source+")").getRegex(),be._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",be._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,be.html=re(be.html,"i").replace("comment",be._comment).replace("tag",be._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),be.paragraph=re(be._paragraph).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.blockquote=re(be.blockquote).replace("paragraph",be.paragraph).getRegex(),be.normal=pe({},be),be.gfm=pe({},be.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),be.gfm.table=re(be.gfm.table).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.pedantic=pe({},be.normal,{html:re(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",be._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:K,paragraph:re(be.normal._paragraph).replace("hr",be.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",be.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:K,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:K,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=re(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=re(be._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=re(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=re(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=re(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=re(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=re(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=re(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=re(ae.reflink).replace("label",ae._label).getRegex(),ae.reflinkSearch=re(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=pe({},ae),ae.pedantic=pe({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:re(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:re(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=pe({},ae.normal,{escape:re(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=re(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=pe({},ae.gfm,{br:re(ae.br).replace("{2,}","*").getRegex(),text:re(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:be,inline:ae},Ce=ue,Ee=T.exports.defaults,Fe=le.block,$e=le.inline,Ve=N.repeatString;function je(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ae){var De="",ve,ie,se=Ae.length;for(ve=0;ve<se;ve++)ie=Ae.charCodeAt(ve),Math.random()>.5&&(ie="x"+ie.toString(16)),De+="&#"+ie+";";return De}var G=function(){function Ae(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Ee,this.options.tokenizer=this.options.tokenizer||new Ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ie={block:Fe.normal,inline:$e.normal};this.options.pedantic?(ie.block=Fe.pedantic,ie.inline=$e.pedantic):this.options.gfm&&(ie.block=Fe.gfm,this.options.breaks?ie.inline=$e.breaks:ie.inline=$e.gfm),this.tokenizer.rules=ie}Ae.lex=function(ie,se){var de=new Ae(se);return de.lex(ie)},Ae.lexInline=function(ie,se){var de=new Ae(se);return de.inlineTokens(ie)};var De=Ae.prototype;return De.lex=function(ie){ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},De.blockTokens=function(ie,se){var de=this;se===void 0&&(se=[]),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var me,Te,We,Le;ie;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(me=it.call({lexer:de},ie,se))?(ie=ie.substring(me.raw.length),se.push(me),!0):!1}))){if(me=this.tokenizer.space(ie)){ie=ie.substring(me.raw.length),me.type&&se.push(me);continue}if(me=this.tokenizer.code(ie)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):se.push(me);continue}if(me=this.tokenizer.fences(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.heading(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.hr(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.blockquote(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.list(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.html(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.def(ie)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.lheading(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(We=ie,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=1/0,rt=ie.slice(1),ne=void 0;de.options.extensions.startBlock.forEach(function(ge){ne=ge.call({lexer:this},rt),typeof ne=="number"&&ne>=0&&(it=Math.min(it,ne))}),it<1/0&&it>=0&&(We=ie.substring(0,it+1))}(),this.state.top&&(me=this.tokenizer.paragraph(We))){Te=se[se.length-1],Le&&Te.type==="paragraph"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):se.push(me),Le=We.length!==ie.length,ie=ie.substring(me.raw.length);continue}if(me=this.tokenizer.text(ie)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):se.push(me);continue}if(ie){var Ke="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return this.state.top=!0,se},De.inline=function(ie,se){this.inlineQueue.push({src:ie,tokens:se})},De.inlineTokens=function(ie,se){var de=this;se===void 0&&(se=[]);var me,Te,We,Le=ie,Ke,it,rt;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(Ke=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)ne.includes(Ke[0].slice(Ke[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ke.index)+"["+Ve("a",Ke[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ke=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ke.index)+"["+Ve("a",Ke[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ke=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ke.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;)if(it||(rt=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(te){return(me=te.call({lexer:de},ie,se))?(ie=ie.substring(me.raw.length),se.push(me),!0):!1}))){if(me=this.tokenizer.escape(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.tag(ie)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):se.push(me);continue}if(me=this.tokenizer.link(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(me.raw.length),Te=se[se.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):se.push(me);continue}if(me=this.tokenizer.emStrong(ie,Le,rt)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.codespan(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.br(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.del(ie)){ie=ie.substring(me.raw.length),se.push(me);continue}if(me=this.tokenizer.autolink(ie,H)){ie=ie.substring(me.raw.length),se.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(ie,H))){ie=ie.substring(me.raw.length),se.push(me);continue}if(We=ie,this.options.extensions&&this.options.extensions.startInline&&function(){var te=1/0,W=ie.slice(1),we=void 0;de.options.extensions.startInline.forEach(function(Pe){we=Pe.call({lexer:this},W),typeof we=="number"&&we>=0&&(te=Math.min(te,we))}),te<1/0&&te>=0&&(We=ie.substring(0,te+1))}(),me=this.tokenizer.inlineText(We,je)){ie=ie.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(rt=me.raw.slice(-1)),it=!0,Te=se[se.length-1],Te&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):se.push(me);continue}if(ie){var ge="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return se},e(Ae,null,[{key:"rules",get:function(){return{block:Fe,inline:$e}}}]),Ae}(),X=T.exports.defaults,oe=N.cleanUrl,q=N.escape,ee=function(){function Ae(ve){this.options=ve||X}var De=Ae.prototype;return De.code=function(ie,se,de){var me=(se||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(ie,me);Te!=null&&Te!==ie&&(de=!0,ie=Te)}return ie=ie.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+q(me,!0)+'">'+(de?ie:q(ie,!0))+`</code></pre>
`:"<pre><code>"+(de?ie:q(ie,!0))+`</code></pre>
`},De.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},De.html=function(ie){return ie},De.heading=function(ie,se,de,me){return this.options.headerIds?"<h"+se+' id="'+this.options.headerPrefix+me.slug(de)+'">'+ie+"</h"+se+`>
`:"<h"+se+">"+ie+"</h"+se+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ie,se,de){var me=se?"ol":"ul",Te=se&&de!==1?' start="'+de+'"':"";return"<"+me+Te+`>
`+ie+"</"+me+`>
`},De.listitem=function(ie){return"<li>"+ie+`</li>
`},De.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ie){return"<p>"+ie+`</p>
`},De.table=function(ie,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+se+`</table>
`},De.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},De.tablecell=function(ie,se){var de=se.header?"th":"td",me=se.align?"<"+de+' align="'+se.align+'">':"<"+de+">";return me+ie+"</"+de+`>
`},De.strong=function(ie){return"<strong>"+ie+"</strong>"},De.em=function(ie){return"<em>"+ie+"</em>"},De.codespan=function(ie){return"<code>"+ie+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ie){return"<del>"+ie+"</del>"},De.link=function(ie,se,de){if(ie=oe(this.options.sanitize,this.options.baseUrl,ie),ie===null)return de;var me='<a href="'+q(ie)+'"';return se&&(me+=' title="'+se+'"'),me+=">"+de+"</a>",me},De.image=function(ie,se,de){if(ie=oe(this.options.sanitize,this.options.baseUrl,ie),ie===null)return de;var me='<img src="'+ie+'" alt="'+de+'"';return se&&(me+=' title="'+se+'"'),me+=this.options.xhtml?"/>":">",me},De.text=function(ie){return ie},Ae}(),he=function(){function Ae(){}var De=Ae.prototype;return De.strong=function(ie){return ie},De.em=function(ie){return ie},De.codespan=function(ie){return ie},De.del=function(ie){return ie},De.html=function(ie){return ie},De.text=function(ie){return ie},De.link=function(ie,se,de){return""+de},De.image=function(ie,se,de){return""+de},De.br=function(){return""},Ae}(),Re=function(){function Ae(){this.seen={}}var De=Ae.prototype;return De.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ie,se){var de=ie,me=0;if(this.seen.hasOwnProperty(de)){me=this.seen[ie];do me++,de=ie+"-"+me;while(this.seen.hasOwnProperty(de))}return se||(this.seen[ie]=me,this.seen[de]=0),de},De.slug=function(ie,se){se===void 0&&(se={});var de=this.serialize(ie);return this.getNextSafeSlug(de,se.dryrun)},Ae}(),Ue=ee,ze=he,Qe=Re,et=T.exports.defaults,st=N.unescape,Xe=function(){function Ae(ve){this.options=ve||et,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new Qe}Ae.parse=function(ie,se){var de=new Ae(se);return de.parse(ie)},Ae.parseInline=function(ie,se){var de=new Ae(se);return de.parseInline(ie)};var De=Ae.prototype;return De.parse=function(ie,se){se===void 0&&(se=!0);var de="",me,Te,We,Le,Ke,it,rt,ne,ge,te,W,we,Pe,Ye,xe,ut,bt,Ct,wt,ft=ie.length;for(me=0;me<ft;me++){if(te=ie[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[te.type]&&(wt=this.options.extensions.renderers[te.type].call({parser:this},te),wt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(te.type))){de+=wt||"";continue}switch(te.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(te.tokens),te.depth,st(this.parseInline(te.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(te.text,te.lang,te.escaped);continue}case"table":{for(ne="",rt="",Le=te.header.length,Te=0;Te<Le;Te++)rt+=this.renderer.tablecell(this.parseInline(te.header[Te].tokens),{header:!0,align:te.align[Te]});for(ne+=this.renderer.tablerow(rt),ge="",Le=te.rows.length,Te=0;Te<Le;Te++){for(it=te.rows[Te],rt="",Ke=it.length,We=0;We<Ke;We++)rt+=this.renderer.tablecell(this.parseInline(it[We].tokens),{header:!1,align:te.align[We]});ge+=this.renderer.tablerow(rt)}de+=this.renderer.table(ne,ge);continue}case"blockquote":{ge=this.parse(te.tokens),de+=this.renderer.blockquote(ge);continue}case"list":{for(W=te.ordered,we=te.start,Pe=te.loose,Le=te.items.length,ge="",Te=0;Te<Le;Te++)xe=te.items[Te],ut=xe.checked,bt=xe.task,Ye="",xe.task&&(Ct=this.renderer.checkbox(ut),Pe?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=Ct+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=Ct+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:Ct}):Ye+=Ct),Ye+=this.parse(xe.tokens,Pe),ge+=this.renderer.listitem(Ye,bt,ut);de+=this.renderer.list(ge,W,we);continue}case"html":{de+=this.renderer.html(te.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(te.tokens));continue}case"text":{for(ge=te.tokens?this.parseInline(te.tokens):te.text;me+1<ft&&ie[me+1].type==="text";)te=ie[++me],ge+=`
`+(te.tokens?this.parseInline(te.tokens):te.text);de+=se?this.renderer.paragraph(ge):ge;continue}default:{var pt='Token with "'+te.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return de},De.parseInline=function(ie,se){se=se||this.renderer;var de="",me,Te,We,Le=ie.length;for(me=0;me<Le;me++){if(Te=ie[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(We=this.options.extensions.renderers[Te.type].call({parser:this},Te),We!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){de+=We||"";continue}switch(Te.type){case"escape":{de+=se.text(Te.text);break}case"html":{de+=se.html(Te.text);break}case"link":{de+=se.link(Te.href,Te.title,this.parseInline(Te.tokens,se));break}case"image":{de+=se.image(Te.href,Te.title,Te.text);break}case"strong":{de+=se.strong(this.parseInline(Te.tokens,se));break}case"em":{de+=se.em(this.parseInline(Te.tokens,se));break}case"codespan":{de+=se.codespan(Te.text);break}case"br":{de+=se.br();break}case"del":{de+=se.del(this.parseInline(Te.tokens,se));break}case"text":{de+=se.text(Te.text);break}default:{var Ke='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ke);return}else throw new Error(Ke)}}}return de},Ae}(),nt=G,lt=Xe,vt=ue,Oe=ee,Rt=he,j=Re,Q=N.merge,fe=N.checkSanitizeDeprecation,Ne=N.escape,qe=T.exports.getDefaults,ot=T.exports.changeDefaults,ht=T.exports.defaults;function Je(Ae,De,ve){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof De=="function"&&(ve=De,De=null),De=Q({},Je.defaults,De||{}),fe(De),ve){var ie=De.highlight,se;try{se=nt.lex(Ae,De)}catch(We){return ve(We)}var de=function(Le){var Ke;if(!Le)try{De.walkTokens&&Je.walkTokens(se,De.walkTokens),Ke=lt.parse(se,De)}catch(it){Le=it}return De.highlight=ie,Le?ve(Le):ve(null,Ke)};if(!ie||ie.length<3||(delete De.highlight,!se.length))return de();var me=0;Je.walkTokens(se,function(We){We.type==="code"&&(me++,setTimeout(function(){ie(We.text,We.lang,function(Le,Ke){if(Le)return de(Le);Ke!=null&&Ke!==We.text&&(We.text=Ke,We.escaped=!0),me--,me===0&&de()})},0))}),me===0&&de();return}try{var Te=nt.lex(Ae,De);return De.walkTokens&&Je.walkTokens(Te,De.walkTokens),lt.parse(Te,De)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ne(We.message+"",!0)+"</pre>";throw We}}Je.options=Je.setOptions=function(Ae){return Q(Je.defaults,Ae),ot(Je.defaults),Je},Je.getDefaults=qe,Je.defaults=ht,Je.use=function(){for(var Ae=this,De=arguments.length,ve=new Array(De),ie=0;ie<De;ie++)ve[ie]=arguments[ie];var se=Q.apply(void 0,[{}].concat(ve)),de=Je.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(Te){if(Te.extensions&&(me=!0,Te.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ke=de.renderers?de.renderers[Le.name]:null;Ke?de.renderers[Le.name]=function(){for(var it=arguments.length,rt=new Array(it),ne=0;ne<it;ne++)rt[ne]=arguments[ne];var ge=Le.renderer.apply(this,rt);return ge===!1&&(ge=Ke.apply(this,rt)),ge}:de.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Le.level]?de[Le.level].unshift(Le.tokenizer):de[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?de.startBlock?de.startBlock.push(Le.start):de.startBlock=[Le.start]:Le.level==="inline"&&(de.startInline?de.startInline.push(Le.start):de.startInline=[Le.start]))}Le.childTokens&&(de.childTokens[Le.name]=Le.childTokens)})),Te.renderer&&function(){var Le=Je.defaults.renderer||new Oe,Ke=function(ne){var ge=Le[ne];Le[ne]=function(){for(var te=arguments.length,W=new Array(te),we=0;we<te;we++)W[we]=arguments[we];var Pe=Te.renderer[ne].apply(Le,W);return Pe===!1&&(Pe=ge.apply(Le,W)),Pe}};for(var it in Te.renderer)Ke(it);se.renderer=Le}(),Te.tokenizer&&function(){var Le=Je.defaults.tokenizer||new vt,Ke=function(ne){var ge=Le[ne];Le[ne]=function(){for(var te=arguments.length,W=new Array(te),we=0;we<te;we++)W[we]=arguments[we];var Pe=Te.tokenizer[ne].apply(Le,W);return Pe===!1&&(Pe=ge.apply(Le,W)),Pe}};for(var it in Te.tokenizer)Ke(it);se.tokenizer=Le}(),Te.walkTokens){var We=Je.defaults.walkTokens;se.walkTokens=function(Le){Te.walkTokens.call(Ae,Le),We&&We(Le)}}me&&(se.extensions=de),Je.setOptions(se)})},Je.walkTokens=function(Ae,De){for(var ve=function(){var me=se.value;switch(De(me),me.type){case"table":{for(var Te=E(me.header),We;!(We=Te()).done;){var Le=We.value;Je.walkTokens(Le.tokens,De)}for(var Ke=E(me.rows),it;!(it=Ke()).done;)for(var rt=it.value,ne=E(rt),ge;!(ge=ne()).done;){var te=ge.value;Je.walkTokens(te.tokens,De)}break}case"list":{Je.walkTokens(me.items,De);break}default:Je.defaults.extensions&&Je.defaults.extensions.childTokens&&Je.defaults.extensions.childTokens[me.type]?Je.defaults.extensions.childTokens[me.type].forEach(function(W){Je.walkTokens(me[W],De)}):me.tokens&&Je.walkTokens(me.tokens,De)}},ie=E(Ae),se;!(se=ie()).done;)ve()},Je.parseInline=function(Ae,De){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");De=Q({},Je.defaults,De||{}),fe(De);try{var ve=nt.lexInline(Ae,De);return De.walkTokens&&Je.walkTokens(ve,De.walkTokens),lt.parseInline(ve,De)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ne(ie.message+"",!0)+"</pre>";throw ie}},Je.Parser=lt,Je.parser=lt.parse,Je.Renderer=Oe,Je.TextRenderer=Rt,Je.Lexer=nt,Je.lexer=nt.lex,Je.Tokenizer=vt,Je.Slugger=j,Je.parse=Je;var Tt=Je;return Tt}),define(ye[75],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function s(k,I,C){return Math.min(Math.max(k,I),C)}e.clamp=s;function t(k,I){return(I+k%I)%I}e.rot=t;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class T{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function Z(E){const T=[];typeof E=="number"&&T.push("code/timeOrigin",E);function k(C){T.push(C,Date.now())}function I(){const C=[];for(let A=0;A<T.length;A+=2)C.push({name:T[A],startTime:T[A+1]});return C}return{mark:k,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(E+k.startTime)});return T}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function s(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=s(t))}(),define(ye[76],_e([0,1,17]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(b){b.text="text/plain",b.binary="application/octet-stream",b.unknown="application/unknown",b.markdown="text/markdown",b.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(b){const n=(0,s.extname)(b),g=E[n.toLowerCase()];return g!==void 0?g:I(b)}e.getMediaOrTextMime=k;function I(b){const n=(0,s.extname)(b);return T[n.toLowerCase()]}e.getMediaMime=I;function C(b){for(const n in T)if(T[n]===b)return n}e.getExtensionForMimeType=C;const A=/^(.+)\/(.+?)(;.+)?$/;function R(b,n){const g=A.exec(b);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:n?void 0:b}e.normalizeMimeType=R}),define(ye[101],_e([0,1,15,6]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(f){const d=f;return d?[d.on,d.pause,d.resume,d.destroy].every(D=>typeof D=="function"):!1}e.isReadableStream=E;function T(f){const d=f;return d?E(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(f,d){return new I(f,d)}e.newWriteableStream=k;class I{constructor(d,D){this.reducer=d,this.options=D,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(D=>this.pendingWritePromises.push(D))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(D=>D(d))}emitError(d){this.listeners.error.length===0?(0,s.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(D=>D(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,D){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(D),this.resume();break;case"end":this.listeners.end.push(D),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(D),this.state.flowing&&this.flowErrors();break}}removeListener(d,D){if(this.state.destroyed)return;let l;switch(d){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const M=l.indexOf(D);M>=0&&l.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const D=[...this.pendingWritePromises];this.pendingWritePromises.length=0,D.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(f,d){const D=[];let l;for(;(l=f.read())!==null;)D.push(l);return d(D)}e.consumeReadable=C;function A(f,d,D){const l=[];let M;for(;(M=f.read())!==null&&l.length<D;)l.push(M);return M===null&&l.length>0?d(l):{read:()=>{if(l.length>0)return l.shift();if(typeof M!="undefined"){const r=M;return M=void 0,r}return f.read()}}}e.peekReadable=A;function R(f,d){return new Promise((D,l)=>{const M=[];b(f,{onData:r=>{d&&M.push(r)},onError:r=>{d?l(r):D(void 0)},onEnd:()=>{D(d?d(M):void 0)}})})}e.consumeStream=R;function b(f,d){let D=!1;return f.on("error",l=>{D||d.onError(l)}),f.on("end",()=>{D||d.onEnd()}),f.on("data",l=>{D||d.onData(l)}),(0,t.toDisposable)(()=>D=!0)}e.listenStream=b;function n(f,d){return new Promise((D,l)=>{const M=new t.DisposableStore,r=[],i=h=>{if(r.push(h),r.length>d)return M.dispose(),f.pause(),D({stream:f,buffer:r,ended:!1})},p=h=>l(h),m=()=>D({stream:f,buffer:r,ended:!0});M.add((0,t.toDisposable)(()=>f.removeListener("error",p))),f.on("error",p),M.add((0,t.toDisposable)(()=>f.removeListener("end",m))),f.on("end",m),M.add((0,t.toDisposable)(()=>f.removeListener("data",i))),f.on("data",i)})}e.peekStream=n;function g(f,d){const D=k(d);return D.end(f),D}e.toStream=g;function o(){const f=k(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=o;function c(f){let d=!1;return{read:()=>d?null:(d=!0,f)}}e.toReadable=c;function u(f,d,D){const l=k(D);return b(f,{onData:M=>l.write(d.data(M)),onError:M=>l.error(d.error?d.error(M):M),onEnd:()=>l.end()}),l}e.transform=u;function F(f,d,D){let l=!1;return{read:()=>{const M=d.read();return l?M:(l=!0,M!==null?D([f,M]):f)}}}e.prefixedReadable=F;function y(f,d,D){let l=!1;const M=k(D);return b(d,{onData:r=>l?M.write(r):(l=!0,M.write(D([f,r]))),onError:r=>M.error(r),onEnd:()=>{l||(l=!0,M.write(f)),M.end()}}),M}e.prefixedStream=y}),define(ye[22],_e([0,1,101]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let E,T;class k{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return t?new k(Buffer.allocUnsafe(i)):new k(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new k(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(i)):(E||(E=new TextEncoder),new k(E.encode(i)))}static fromByteArray(i){const p=k.alloc(i.length);for(let m=0,h=i.length;m<h;m++)p.buffer[m]=i[m];return p}static concat(i,p){if(typeof p=="undefined"){p=0;for(let w=0,v=i.length;w<v;w++)p+=i[w].byteLength}const m=k.alloc(p);let h=0;for(let w=0,v=i.length;w<v;w++){const a=i[w];m.set(a,h),h+=a.byteLength}return m}clone(){const i=k.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(i,p){return new k(this.buffer.subarray(i,p))}set(i,p){if(i instanceof k)this.buffer.set(i.buffer,p);else if(i instanceof Uint8Array)this.buffer.set(i,p);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),p);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),p);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return A(this.buffer,i)}writeUInt32BE(i,p){R(this.buffer,i,p)}readUInt32LE(i){return b(this.buffer,i)}writeUInt32LE(i,p){n(this.buffer,i,p)}readUInt8(i){return g(this.buffer,i)}writeUInt8(i,p){o(this.buffer,i,p)}}e.VSBuffer=k;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=I;function C(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255}e.writeUInt16LE=C;function A(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=A;function R(r,i,p){r[p+3]=i,i=i>>>8,r[p+2]=i,i=i>>>8,r[p+1]=i,i=i>>>8,r[p]=i}e.writeUInt32BE=R;function b(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=b;function n(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255,i=i>>>8,r[p+2]=i&255,i=i>>>8,r[p+3]=i&255}e.writeUInt32LE=n;function g(r,i){return r[i]}e.readUInt8=g;function o(r,i,p){r[p]=i}e.writeUInt8=o;function c(r){return s.consumeReadable(r,i=>k.concat(i))}e.readableToBuffer=c;function u(r){return s.toReadable(r)}e.bufferToReadable=u;function F(r){return s.consumeStream(r,i=>k.concat(i))}e.streamToBuffer=F;async function y(r){return r.ended?k.concat(r.buffer):k.concat([...r.buffer,await F(r.stream)])}e.bufferedStreamToBuffer=y;function f(r){return s.toStream(r,i=>k.concat(i))}e.bufferToStream=f;function d(r){return s.transform(r,{data:i=>typeof i=="string"?k.fromString(i):k.wrap(i)},i=>k.concat(i))}e.streamToBufferReadableStream=d;function D(r){return s.newWriteableStream(i=>k.concat(i),r)}e.newWriteableBufferStream=D;function l(r,i){return s.prefixedReadable(r,i,p=>k.concat(p))}e.prefixedBufferReadable=l;function M(r,i){return s.prefixedStream(r,i,p=>k.concat(p))}e.prefixedBufferStream=M});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[21],_e([0,1,16,9]),function(Z,e,s,t){"use strict";var E,T,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(r,i,p){let m=r.get(i);return m===void 0&&(m=p,r.set(i,m)),m}e.getOrSet=I;function C(r){const i=[];return r.forEach((p,m)=>{i.push(`${m} => ${p}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=C;function A(r){const i=[];return r.forEach(p=>{i.push(p)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=A;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const p=i.charCodeAt(0),m=this._value.charCodeAt(this._pos);return p-m}value(){return this._value[this._pos]}}e.StringIterator=R;class b{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class n{constructor(i=!0,p=!0){this._splitOnBackslash=i,this._caseSensitive=p}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let p=i.length-1;p>=0;p--,this._valueLen--){const m=this._value.charCodeAt(p);if(!(m===47||this._splitOnBackslash&&m===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var g;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(g||(g={}));class o{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(u||(u={}));class F{constructor(i){this._iter=i}static forUris(i=()=>!1){return new F(new o(i))}static forPaths(){return new F(new n)}static forStrings(){return new F(new R)}static forConfigKeys(){return new F(new b)}clear(){this._root=void 0}fill(i,p){if(p){const m=p.slice(0);(0,s.shuffle)(m);for(let h of m)this.set(h,i)}else{const m=i.slice(0);(0,s.shuffle)(m);for(let h of m)this.set(h[0],h[1])}}set(i,p){const m=this._iter.reset(i);let h;this._root||(this._root=new c,this._root.segment=m.value());const w=[];for(h=this._root;;){const a=m.cmp(h.segment);if(a>0)h.left||(h.left=new c,h.left.segment=m.value()),w.push([-1,h]),h=h.left;else if(a<0)h.right||(h.right=new c,h.right.segment=m.value()),w.push([1,h]),h=h.right;else if(m.hasNext())m.next(),h.mid||(h.mid=new c,h.mid.segment=m.value()),w.push([0,h]),h=h.mid;else break}const v=h.value;h.value=p,h.key=i;for(let a=w.length-1;a>=0;a--){const S=w[a][1];S.updateHeight();const P=S.balanceFactor();if(P<-1||P>1){const N=w[a][0],B=w[a+1][0];if(N===1&&B===1)w[a][1]=S.rotateLeft();else if(N===-1&&B===-1)w[a][1]=S.rotateRight();else if(N===1&&B===-1)S.right=w[a+1][1]=w[a+1][1].rotateRight(),w[a][1]=S.rotateLeft();else if(N===-1&&B===1)S.left=w[a+1][1]=w[a+1][1].rotateLeft(),w[a][1]=S.rotateRight();else throw new Error;if(a>0)switch(w[a-1][0]){case-1:w[a-1][1].left=w[a][1];break;case 1:w[a-1][1].right=w[a][1];break;case 0:w[a-1][1].mid=w[a][1];break}else this._root=w[0][1]}}return v}get(i){return this._getNode(i)?.value}_getNode(i){const p=this._iter.reset(i);let m=this._root;for(;m;){const h=p.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(p.hasNext())p.next(),m=m.mid;else break}return m}has(i){const p=this._getNode(i);return!(p?.value===void 0&&p?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,p){const m=this._iter.reset(i),h=[];let w=this._root;for(;w;){const v=m.cmp(w.segment);if(v>0)h.push([-1,w]),w=w.left;else if(v<0)h.push([1,w]),w=w.right;else if(m.hasNext())m.next(),h.push([0,w]),w=w.mid;else break}if(!!w){if(p?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const v=this._min(w.right),{key:a,value:S,segment:P}=v;this._delete(v.key,!1),w.key=a,w.value=S,w.segment=P}else{const v=w.left??w.right;if(h.length>0){const[a,S]=h[h.length-1];switch(a){case-1:S.left=v;break;case 0:S.mid=v;break;case 1:S.right=v;break}}else this._root=v}for(let v=h.length-1;v>=0;v--){const a=h[v][1];a.updateHeight();const S=a.balanceFactor();if(S>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),h[v][1]=a.rotateLeft()):S<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),h[v][1]=a.rotateRight()),v>0)switch(h[v-1][0]){case-1:h[v-1][1].left=h[v][1];break;case 1:h[v-1][1].right=h[v][1];break;case 0:h[v-1][1].mid=h[v][1];break}else this._root=h[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const p=this._iter.reset(i);let m=this._root,h;for(;m;){const w=p.cmp(m.segment);if(w>0)m=m.left;else if(w<0)m=m.right;else if(p.hasNext())p.next(),h=m.value||h,m=m.mid;else break}return m&&m.value||h}findSuperstr(i){const p=this._iter.reset(i);let m=this._root;for(;m;){const h=p.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(p.hasNext())p.next(),m=m.mid;else return m.mid?this._entries(m.mid):void 0}}forEach(i){for(const[p,m]of this)i(m,p)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=p=>{if(!p)return!0;const m=p.balanceFactor();return m<-1||m>1?!1:i(p.left)&&i(p.right)};return i(this._root)}}e.TernarySearchTree=F;class y{constructor(i,p){this.uri=i,this.value=p}}class f{constructor(i,p){this[E]="ResourceMap",i instanceof f?(this.map=new Map(i.map),this.toKey=p??f.defaultToKey):(this.map=new Map,this.toKey=i??f.defaultToKey)}set(i,p){return this.map.set(this.toKey(i),new y(i,p)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,p){typeof p!="undefined"&&(i=i.bind(p));for(let[m,h]of this.map)i(h.value,h.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=f,f.defaultToKey=r=>r.toString();var d;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class D{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,p=0){const m=this._map.get(i);if(!!m)return p!==0&&this.touch(m,p),m.value}set(i,p,m=0){let h=this._map.get(i);if(h)h.value=p,m!==0&&this.touch(h,m);else{switch(h={key:i,value:p,next:void 0,previous:void 0},m){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const p=this._map.get(i);if(!!p)return this._map.delete(i),this.removeItem(p),this._size--,p.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,p){const m=this._state;let h=this._head;for(;h;){if(p?i.bind(p)(h.value,h.key,this):i(h.value,h.key,this),this._state!==m)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,p=this._state;let m=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(m){const w={value:m.key,done:!1};return m=m.next,w}else return{value:void 0,done:!0}}};return h}values(){const i=this,p=this._state;let m=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(m){const w={value:m.value,done:!1};return m=m.next,w}else return{value:void 0,done:!0}}};return h}entries(){const i=this,p=this._state;let m=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(m){const w={value:[m.key,m.value],done:!1};return m=m.next,w}else return{value:void 0,done:!0}}};return h}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let p=this._head,m=this.size;for(;p&&m>i;)this._map.delete(p.key),p=p.next,m--;this._head=p,this._size=m,p&&(p.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const p=i.next,m=i.previous;if(!p||!m)throw new Error("Invalid list");p.previous=m,m.next=p}i.next=void 0,i.previous=void 0,this._state++}touch(i,p){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(i===this._head)return;const m=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(m.previous=h,h.next=m),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(p===2){if(i===this._tail)return;const m=i.next,h=i.previous;i===this._head?(m.previous=void 0,this._head=m):(m.previous=h,h.next=m),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((p,m)=>{i.push([m,p])}),i}fromJSON(i){this.clear();for(const[p,m]of i)this.set(p,m)}}e.LinkedMap=D;class l extends D{constructor(i,p=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,p),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,p=2){return super.get(i,p)}peek(i){return super.get(i,0)}set(i,p){return super.set(i,p,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class M{constructor(i){k.set(this,void 0),Ze(this,k,i,"f")}get size(){return Ie(this,k,"f").size}forEach(i,p){Ie(this,k,"f").forEach(i,p)}get(i){return Ie(this,k,"f").get(i)}has(i){return Ie(this,k,"f").has(i)}entries(){return Ie(this,k,"f").entries()}keys(){return Ie(this,k,"f").keys()}values(){return Ie(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ie(this,k,"f").entries()}}e.ReadonlyMapView=M}),define(ye[102],_e([0,1,21,9]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...q){return function(ee,he){for(let Re=0,Ue=q.length;Re<Ue;Re++){const ze=q[Re](ee,he);if(ze)return ze}return null}}e.or=E,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(q,ee,he){if(!he||he.length<ee.length)return null;let Re;return q?Re=t.startsWithIgnoreCase(he,ee):Re=he.indexOf(ee)===0,Re?ee.length>0?[{start:0,end:ee.length}]:[]:null}function k(q,ee){const he=ee.toLowerCase().indexOf(q.toLowerCase());return he===-1?null:[{start:he,end:he+q.length}]}e.matchesContiguousSubString=k;function I(q,ee){return C(q.toLowerCase(),ee.toLowerCase(),0,0)}e.matchesSubString=I;function C(q,ee,he,Re){if(he===q.length)return[];if(Re===ee.length)return null;if(q[he]===ee[Re]){let Ue=null;return(Ue=C(q,ee,he+1,Re+1))?F({start:Re,end:Re+1},Ue):null}return C(q,ee,he,Re+1)}function A(q){return 97<=q&&q<=122}function R(q){return 65<=q&&q<=90}e.isUpper=R;function b(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>g.add(q.charCodeAt(0)));function o(q){return n(q)||g.has(q)}function c(q,ee){return q===ee||o(q)&&o(ee)}function u(q){return A(q)||R(q)||b(q)}function F(q,ee){return ee.length===0?ee=[q]:q.end===ee[0].start?ee[0].start=q.start:ee.unshift(q),ee}function y(q,ee){for(let he=ee;he<q.length;he++){const Re=q.charCodeAt(he);if(R(Re)||b(Re)||he>0&&!u(q.charCodeAt(he-1)))return he}return q.length}function f(q,ee,he,Re){if(he===q.length)return[];if(Re===ee.length)return null;if(q[he]!==ee[Re].toLowerCase())return null;{let Ue=null,ze=Re+1;for(Ue=f(q,ee,he+1,Re+1);!Ue&&(ze=y(ee,ze))<ee.length;)Ue=f(q,ee,he+1,ze),ze++;return Ue===null?null:F({start:Re,end:Re+1},Ue)}}function d(q){let ee=0,he=0,Re=0,Ue=0,ze=0;for(let nt=0;nt<q.length;nt++)ze=q.charCodeAt(nt),R(ze)&&ee++,A(ze)&&he++,u(ze)&&Re++,b(ze)&&Ue++;const Qe=ee/q.length,et=he/q.length,st=Re/q.length,Xe=Ue/q.length;return{upperPercent:Qe,lowerPercent:et,alphaPercent:st,numericPercent:Xe}}function D(q){const{upperPercent:ee,lowerPercent:he}=q;return he===0&&ee>.6}function l(q){const{upperPercent:ee,lowerPercent:he,alphaPercent:Re,numericPercent:Ue}=q;return he>.2&&ee<.8&&Re>.6&&Ue<.2}function M(q){let ee=0,he=0,Re=0,Ue=0;for(let ze=0;ze<q.length;ze++)Re=q.charCodeAt(ze),R(Re)&&ee++,A(Re)&&he++,n(Re)&&Ue++;return(ee===0||he===0)&&Ue===0?q.length<=30:ee<=5}function r(q,ee){if(!ee||(ee=ee.trim(),ee.length===0)||!M(q)||ee.length>60)return null;const he=d(ee);if(!l(he)){if(!D(he))return null;ee=ee.toLowerCase()}let Re=null,Ue=0;for(q=q.toLowerCase();Ue<ee.length&&(Re=f(q,ee,0,Ue))===null;)Ue=y(ee,Ue+1);return Re}e.matchesCamelCase=r;function i(q,ee,he=!1){if(!ee||ee.length===0)return null;let Re=null,Ue=0;for(q=q.toLowerCase(),ee=ee.toLowerCase();Ue<ee.length&&(Re=p(q,ee,0,Ue,he))===null;)Ue=m(ee,Ue+1);return Re}e.matchesWords=i;function p(q,ee,he,Re,Ue){if(he===q.length)return[];if(Re===ee.length)return null;if(c(q.charCodeAt(he),ee.charCodeAt(Re))){let ze=null,Qe=Re+1;if(ze=p(q,ee,he+1,Re+1,Ue),!Ue)for(;!ze&&(Qe=m(ee,Qe))<ee.length;)ze=p(q,ee,he+1,Qe,Ue),Qe++;return ze===null?null:F({start:Re,end:Re+1},ze)}else return null}function m(q,ee){for(let he=ee;he<q.length;he++)if(o(q.charCodeAt(he))||he>0&&o(q.charCodeAt(he-1)))return he;return q.length}const h=E(e.matchesPrefix,r,k),w=E(e.matchesPrefix,r,I),v=new s.LRUCache(1e4);function a(q,ee,he=!1){if(typeof q!="string"||typeof ee!="string")return null;let Re=v.get(q);Re||(Re=new RegExp(t.convertSimple2RegExpPattern(q),"i"),v.set(q,Re));const Ue=Re.exec(ee);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?w(q,ee):h(q,ee)}e.matchesFuzzy=a;function S(q,ee){const he=$e(q,q.toLowerCase(),0,ee,ee.toLowerCase(),0,!0);return he?N(he):null}e.matchesFuzzy2=S;function P(q,ee,he,Re,Ue,ze){const Qe=Math.min(13,q.length);for(;he<Qe;he++){const et=$e(q,ee,he,Re,Ue,ze,!1);if(et)return et}return[0,ze]}e.anyScore=P;function N(q){if(typeof q=="undefined")return[];const ee=[],he=q[1];for(let Re=q.length-1;Re>1;Re--){const Ue=q[Re]+he,ze=ee[ee.length-1];ze&&ze.end===Ue?ze.end=Ue+1:ee.push({start:Ue,end:Ue+1})}return ee}e.createMatches=N;const B=128;function _(){const q=[],ee=[];for(let he=0;he<=B;he++)ee[he]=0;for(let he=0;he<=B;he++)q.push(ee.slice(0));return q}function O(q){const ee=[];for(let he=0;he<=q;he++)ee[he]=0;return ee}const z=O(2*B),U=O(2*B),$=_(),V=_(),ue=_(),K=!1;function re(q,ee,he,Re,Ue){function ze(et,st,Xe=" "){for(;et.length<st;)et=Xe+et;return et}let Qe=` |   |${Re.split("").map(et=>ze(et,3)).join("|")}
`;for(let et=0;et<=he;et++)et===0?Qe+=" |":Qe+=`${ee[et-1]}|`,Qe+=q[et].slice(0,Ue+1).map(st=>ze(st.toString(),3)).join("|")+`
`;return Qe}function pe(q,ee,he,Re){q=q.substr(ee),he=he.substr(Re),console.log(re(V,q,q.length,he,he.length)),console.log(re(ue,q,q.length,he,he.length)),console.log(re($,q,q.length,he,he.length))}function be(q,ee){if(ee<0||ee>=q.length)return!1;const he=q.codePointAt(ee);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(he)}}function ae(q,ee){if(ee<0||ee>=q.length)return!1;switch(q.charCodeAt(ee)){case 32:case 9:return!0;default:return!1}}function le(q,ee,he){return ee[q]!==he[q]}function Ce(q,ee,he,Re,Ue,ze,Qe=!1){for(;ee<he&&Ue<ze;)q[ee]===Re[Ue]&&(Qe&&(z[ee]=Ue),ee+=1),Ue+=1;return ee===he}e.isPatternInWord=Ce;var Ee;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Fe;(function(q){q.Default=[-100,0];function ee(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}q.isDefault=ee})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function $e(q,ee,he,Re,Ue,ze,Qe){const et=q.length>B?B:q.length,st=Re.length>B?B:Re.length;if(he>=et||ze>=st||et-he>st-ze||!Ce(ee,he,et,Ue,ze,st,!0))return;Ve(et,st,he,ze,ee,Ue);let Xe=1,nt=1,lt=he,vt=ze;const Oe=[!1];for(Xe=1,lt=he;lt<et;Xe++,lt++){const Ne=z[lt],qe=U[lt],ot=lt+1<et?U[lt+1]:st;for(nt=Ne-ze+1,vt=Ne;vt<ot;nt++,vt++){let ht=Number.MIN_SAFE_INTEGER,Je=!1;vt<=qe&&(ht=je(q,ee,lt,he,Re,Ue,vt,st,ze,$[Xe-1][nt-1]===0,Oe));let Tt=0;ht!==Number.MAX_SAFE_INTEGER&&(Je=!0,Tt=ht+V[Xe-1][nt-1]);const Ae=vt>Ne,De=Ae?V[Xe][nt-1]+($[Xe][nt-1]>0?-5:0):0,ve=vt>Ne+1&&$[Xe][nt-1]>0,ie=ve?V[Xe][nt-2]+($[Xe][nt-2]>0?-5:0):0;if(ve&&(!Ae||ie>=De)&&(!Je||ie>=Tt))V[Xe][nt]=ie,ue[Xe][nt]=3,$[Xe][nt]=0;else if(Ae&&(!Je||De>=Tt))V[Xe][nt]=De,ue[Xe][nt]=2,$[Xe][nt]=0;else if(Je)V[Xe][nt]=Tt,ue[Xe][nt]=1,$[Xe][nt]=$[Xe-1][nt-1]+1;else throw new Error("not possible")}}if(K&&pe(q,he,Re,ze),!Oe[0]&&!Qe)return;Xe--,nt--;const Rt=[V[Xe][nt],ze];let j=0,Q=0;for(;Xe>=1;){let Ne=nt;do{const qe=ue[Xe][Ne];if(qe===3)Ne=Ne-2;else if(qe===2)Ne=Ne-1;else break}while(Ne>=1);j>1&&ee[he+Xe-1]===Ue[ze+nt-1]&&!le(Ne+ze-1,Re,Ue)&&j+1>$[Xe][Ne]&&(Ne=nt),Ne===nt?j++:j=1,Q||(Q=Ne),Xe--,nt=Ne-1,Rt.push(nt)}st===et&&(Rt[0]+=2);const fe=Q-et;return Rt[0]-=fe,Rt}e.fuzzyScore=$e;function Ve(q,ee,he,Re,Ue,ze){let Qe=q-1,et=ee-1;for(;Qe>=he&&et>=Re;)Ue[Qe]===ze[et]&&(U[Qe]=et,Qe--),et--}function je(q,ee,he,Re,Ue,ze,Qe,et,st,Xe,nt){if(ee[he]!==ze[Qe])return Number.MIN_SAFE_INTEGER;let lt=1,vt=!1;return Qe===he-Re?lt=q[he]===Ue[Qe]?7:5:le(Qe,Ue,ze)&&(Qe===0||!le(Qe-1,Ue,ze))?(lt=q[he]===Ue[Qe]?7:5,vt=!0):be(ze,Qe)&&(Qe===0||!be(ze,Qe-1))?lt=5:(be(ze,Qe-1)||ae(ze,Qe-1))&&(lt=5,vt=!0),lt>1&&he===Re&&(nt[0]=!0),vt||(vt=le(Qe,Ue,ze)||be(ze,Qe-1)||ae(ze,Qe-1)),he===Re?Qe>st&&(lt-=vt?3:5):Xe?lt+=vt?2:0:lt+=vt?0:1,Qe+1===et&&(lt-=vt?3:5),lt}function H(q,ee,he,Re,Ue,ze,Qe){return X(q,ee,he,Re,Ue,ze,!0,Qe)}e.fuzzyScoreGracefulAggressive=H;function G(q,ee,he,Re,Ue,ze,Qe){return X(q,ee,he,Re,Ue,ze,!1,Qe)}e.fuzzyScoreGraceful=G;function X(q,ee,he,Re,Ue,ze,Qe,et){let st=$e(q,ee,he,Re,Ue,ze,et);if(st&&!Qe)return st;if(q.length>=3){const Xe=Math.min(7,q.length-1);for(let nt=he+1;nt<Xe;nt++){const lt=oe(q,nt);if(lt){const vt=$e(lt,lt.toLowerCase(),he,Re,Ue,ze,et);vt&&(vt[0]-=3,(!st||vt[0]>st[0])&&(st=vt))}}}return st}function oe(q,ee){if(ee+1>=q.length)return;const he=q[ee],Re=q[ee+1];if(he!==Re)return q.slice(0,ee)+Re+he+q.slice(ee+2)}}),define(ye[103],_e([0,1,52,102,9]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(s.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${T.source}`,"g");function C(u){return u.replace(I,(F,y)=>y?F:`\\${F}`)}e.escapeIcons=C;const A=new RegExp(`\\\\${T.source}`,"g");function R(u){return u.replace(A,F=>`\\${F}`)}e.markdownEscapeEscapedIcons=R;const b=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function n(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(b,(F,y,f,d)=>f?F:y||d||"")}e.stripIcons=n;function g(u){const F=u.indexOf(e.iconStartMarker);return F===-1?{text:u}:o(u,F)}e.parseLabelWithIcons=g;function o(u,F){const y=[];let f="";function d(h){if(h){f+=h;for(const w of h)y.push(M)}}let D=-1,l="",M=0,r,i,p=F;const m=u.length;for(d(u.substr(0,F));p<m;)r=u[p],i=u[p+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(D=p,d(l),l=e.iconStartMarker,p++):r===")"&&D!==-1?(M+=p-D+1,D=-1,l=""):D!==-1?k.test(r)?l+=r:(d(l),D=-1,l=""):d(r),p++;return d(l),{text:f,iconOffsets:y}}function c(u,F,y=!1){const{text:f,iconOffsets:d}=F;if(!d||d.length===0)return(0,t.matchesFuzzy)(u,f,y);const D=(0,E.ltrim)(f," "),l=f.length-D.length,M=(0,t.matchesFuzzy)(u,D,y);if(M)for(const r of M){const i=d[r.start+l]+l;r.start+=i,r.end+=i}return M}e.matchesFuzzyIconAware=c}),define(ye[77],_e([0,1,15,103]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(g="",o=!1){if(this.value=g,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(g,o=0){return this.value+=A(this.supportThemeIcons?(0,t.escapeIcons)(g):g).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,o){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=T;function k(n){return I(n)?!n.value:Array.isArray(n)?n.every(k):!0}e.isEmptyMarkdownString=k;function I(n){return n instanceof T?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function C(n,g){return n===g?!0:!n||!g?!1:n.value===g.value&&n.isTrusted===g.isTrusted&&n.supportThemeIcons===g.supportThemeIcons}e.markdownStringEqual=C;function A(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function R(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function b(n){const g=[],o=n.split("|").map(u=>u.trim());n=o[0];const c=o[1];if(c){const u=/height=(\d+)/.exec(c),F=/width=(\d+)/.exec(c),y=u?u[1]:"",f=F?F[1]:"",d=isFinite(parseInt(f)),D=isFinite(parseInt(y));d&&g.push(`width="${f}"`),D&&g.push(`height="${y}"`)}return{href:n,dimensions:g}}e.parseHrefAndDimensions=b}),define(ye[34],_e([0,1,9]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(t||(t={})),function(E){const T="error",k="warning",I="warn",C="info",A="ignore";function R(n){return n?s.equalsIgnoreCase(T,n)?E.Error:s.equalsIgnoreCase(k,n)||s.equalsIgnoreCase(I,n)?E.Warning:s.equalsIgnoreCase(C,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=R;function b(n){switch(n){case E.Error:return T;case E.Warning:return k;case E.Info:return C;default:return A}}E.toString=b}(t||(t={})),e.default=t}),define(ye[35],_e([0,1,17,23,9,10]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(p){return p===47||p===92}e.isPathSeparator=k;function I(p){return p.replace(/[\\/]/g,s.posix.sep)}e.toSlashes=I;function C(p){return p.indexOf("/")===-1&&(p=I(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}e.toPosixPath=C;function A(p,m=s.posix.sep){if(!p)return"";const h=p.length,w=p.charCodeAt(0);if(k(w)){if(k(p.charCodeAt(1))&&!k(p.charCodeAt(2))){let a=3;const S=a;for(;a<h&&!k(p.charCodeAt(a));a++);if(S!==a&&!k(p.charCodeAt(a+1))){for(a+=1;a<h;a++)if(k(p.charCodeAt(a)))return p.slice(0,a+1).replace(/[\\/]/g,m)}}return m}else if(F(w)&&p.charCodeAt(1)===58)return k(p.charCodeAt(2))?p.slice(0,2)+m:p.slice(0,2);let v=p.indexOf("://");if(v!==-1){for(v+=3;v<h;v++)if(k(p.charCodeAt(v)))return p.slice(0,v+1)}return""}e.getRoot=A;function R(p){if(!t.isWindows||!p||p.length<5)return!1;let m=p.charCodeAt(0);if(m!==92||(m=p.charCodeAt(1),m!==92))return!1;let h=2;const w=h;for(;h<p.length&&(m=p.charCodeAt(h),m!==92);h++);return!(w===h||(m=p.charCodeAt(h+1),isNaN(m)||m===92))}e.isUNC=R;const b=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(p,m=t.isWindows){const h=m?b:n;return!(!p||p.length===0||/^\s+$/.test(p)||(h.lastIndex=0,h.test(p))||m&&g.test(p)||p==="."||p===".."||m&&p[p.length-1]==="."||m&&p.length!==p.trim().length||p.length>255)}e.isValidBasename=o;function c(p,m,h){const w=p===m;return!h||w?w:!p||!m?!1:(0,E.equalsIgnoreCase)(p,m)}e.isEqual=c;function u(p,m,h,w=s.sep){if(p===m)return!0;if(!p||!m||m.length>p.length)return!1;if(h){if(!(0,E.startsWithIgnoreCase)(p,m))return!1;if(m.length===p.length)return!0;let a=m.length;return m.charAt(m.length-1)===w&&a--,p.charAt(a)===w}return m.charAt(m.length-1)!==w&&(m+=w),p.indexOf(m)===0}e.isEqualOrParent=u;function F(p){return p>=65&&p<=90||p>=97&&p<=122}e.isWindowsDriveLetter=F;function y(p,m){return t.isWindows&&p.endsWith(":")&&(p+=s.sep),(0,s.isAbsolute)(p)||(p=(0,s.join)(m,p)),p=(0,s.normalize)(p),t.isWindows?(p=(0,E.rtrim)(p,s.sep),p.endsWith(":")&&(p+=s.sep)):(p=(0,E.rtrim)(p,s.sep),p||(p=s.sep)),p}e.sanitizeFilePath=y;function f(p){const m=(0,s.normalize)(p);return t.isWindows?p.length>3?!1:d(m)&&(p.length===2||m.charCodeAt(2)===92):m===s.posix.sep}e.isRootOrDriveLetter=f;function d(p,m){return(m!==void 0?m:t.isWindows)?F(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function D(p){return d(p)?p[0]:void 0}e.getDriveLetter=D;function l(p,m,h){return m.length>p.length?-1:p===m?0:(h&&(p=p.toLowerCase(),m=m.toLowerCase()),p.indexOf(m))}e.indexOfPath=l;function M(p){const m=p.split(":");let h,w,v;for(const a of m){const S=Number(a);(0,T.isNumber)(S)?w===void 0?w=S:v===void 0&&(v=S):h=h?[h,a].join(":"):a}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:w!==void 0?w:void 0,column:v!==void 0?v:w!==void 0?1:void 0}}e.parseLineAndColumnAware=M;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(p,m,h=8){let w="";for(let a=0;a<h;a++)w+=r.charAt(Math.floor(Math.random()*r.length));let v;return m?v=`${m}-${w}`:v=w,p?(0,s.join)(p,v):v}e.randomPath=i}),define(ye[55],_e([0,1,22,9,2]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(R){return JSON.stringify(R,C)}e.stringify=T;function k(R){let b=JSON.parse(R);return b=A(b),b}e.parse=k;var I;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function C(R,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function A(R,b=0){if(!R||b>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return E.URI.revive(R);case 2:return new RegExp(R.source,R.flags)}if(R instanceof s.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let n=0;n<R.length;++n)R[n]=A(R[n],b+1);else for(const n in R)Object.hasOwnProperty.call(R,n)&&(R[n]=A(R[n],b+1))}return R}e.revive=A}),define(ye[11],_e([0,1,23,2]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(E=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,A,R){this._hosts[C]=A,this._ports[C]=R}setConnectionToken(C,A){this._connectionTokens[C]=A}rewrite(C){if(this._delegate)return this._delegate(C);const A=C.authority;let R=this._hosts[A];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const b=this._ports[A],n=this._connectionTokens[A];let g=`path=${encodeURIComponent(C.path)}`;return typeof n=="string"&&(g+=`&tkn=${encodeURIComponent(n)}`),t.URI.from({scheme:s.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${R}:${b}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new T;class k{asBrowserUri(C,A){const R=this.toUri(C,A);return R.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===E.file&&(s.isNative||typeof s.globals.importScripts=="function"&&s.globals.origin===`${E.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?R.with({scheme:E.vscodeFileResource,authority:R.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(C,A){const R=this.toUri(C,A);return R.scheme===E.vscodeFileResource?R.with({scheme:E.file,authority:R.authority!==k.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(C,A){return t.URI.isUri(C)?C:t.URI.parse(A.toUrl(C))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ye[24],_e([0,1,35,11,17,23,9,2]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(g){return(0,I.uriToFsPath)(g,!0)}e.originalFSPath=C;class A{constructor(o){this._ignorePathCasing=o}compare(o,c,u=!1){return o===c?0:(0,k.compare)(this.getComparisonKey(o,u),this.getComparisonKey(c,u))}isEqual(o,c,u=!1){return o===c?!0:!o||!c?!1:this.getComparisonKey(o,u)===this.getComparisonKey(c,u)}getComparisonKey(o,c=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,c,u=!1){if(o.scheme===c.scheme){if(o.scheme===t.Schemas.file)return s.isEqualOrParent(C(o),C(c),this._ignorePathCasing(o))&&o.query===c.query&&(u||o.fragment===c.fragment);if((0,e.isEqualAuthority)(o.authority,c.authority))return s.isEqualOrParent(o.path,c.path,this._ignorePathCasing(o),"/")&&o.query===c.query&&(u||o.fragment===c.fragment)}return!1}joinPath(o,...c){return I.URI.joinPath(o,...c)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return E.posix.basename(o.path)}extname(o){return E.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let c;return o.scheme===t.Schemas.file?c=I.URI.file(E.dirname(C(o))).path:(c=E.posix.dirname(o.path),o.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),c="/")),o.with({path:c})}normalizePath(o){if(!o.path.length)return o;let c;return o.scheme===t.Schemas.file?c=I.URI.file(E.normalize(C(o))).path:c=E.posix.normalize(o.path),o.with({path:c})}relativePath(o,c){if(o.scheme!==c.scheme||!(0,e.isEqualAuthority)(o.authority,c.authority))return;if(o.scheme===t.Schemas.file){const y=E.relative(C(o),C(c));return T.isWindows?s.toSlashes(y):y}let u=o.path||"/",F=c.path||"/";if(this._ignorePathCasing(o)){let y=0;for(const f=Math.min(u.length,F.length);y<f&&!(u.charCodeAt(y)!==F.charCodeAt(y)&&u.charAt(y).toLowerCase()!==F.charAt(y).toLowerCase());y++);u=F.substr(0,y)+u.substr(y)}return E.posix.relative(u,F)}resolvePath(o,c){if(o.scheme===t.Schemas.file){const u=I.URI.file(E.resolve(C(o),c));return o.with({authority:u.authority,path:u.path})}return c=s.toPosixPath(c),o.with({path:E.posix.resolve(o.path,c)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,c){return o===c||o!==void 0&&c!==void 0&&(0,k.equalsIgnoreCase)(o,c)}hasTrailingPathSeparator(o,c=E.sep){if(o.scheme===t.Schemas.file){const u=C(o);return u.length>s.getRoot(u).length&&u[u.length-1]===c}else{const u=o.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,c=E.sep){return(0,e.hasTrailingPathSeparator)(o,c)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,c=E.sep){let u=!1;if(o.scheme===t.Schemas.file){const F=C(o);u=F!==void 0&&F.length===s.getRoot(F).length&&F[F.length-1]===c}else{c="/";const F=o.path;u=F.length===1&&F.charCodeAt(F.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(o,c)?o.with({path:o.path+"/"}):o}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(g=>g.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new A(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(g,o){const c=[];for(let u=0;u<g.length;u++){const F=o(g[u]);g.some((y,f)=>f===u?!1:(0,e.isEqualOrParent)(F,o(y)))||c.push(g[u])}return c}e.distinctParents=R;var b;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function o(c){const u=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(f=>{const[d,D]=f.split(":");d&&D&&u.set(d,D)});const y=c.path.substring(0,c.path.indexOf(";"));return y&&u.set(g.META_DATA_MIME,y),u}g.parseMetaData=o})(b=e.DataUri||(e.DataUri={}));function n(g,o,c){if(o){let u=g.path;return u&&u[0]!==E.posix.sep&&(u=E.posix.sep+u),g.with({scheme:c,authority:o,path:u})}return g.with({scheme:c})}e.toLocalResource=n}),define(ye[14],_e([0,1,20,15,4,6,24,23]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(ae){return!!ae&&typeof ae.then=="function"}e.isThenable=C;function A(ae){const le=new s.CancellationTokenSource,Ce=ae(le.token),Ee=new Promise((Fe,$e)=>{const Ve=le.token.onCancellationRequested(()=>{Ve.dispose(),le.dispose(),$e((0,t.canceled)())});Promise.resolve(Ce).then(je=>{Ve.dispose(),le.dispose(),Fe(je)},je=>{Ve.dispose(),le.dispose(),$e(je)})});return new class{cancel(){le.cancel()}then(Fe,$e){return Ee.then(Fe,$e)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Ee.finally(Fe)}}}e.createCancelablePromise=A;function R(ae,le,Ce){return Promise.race([ae,new Promise(Ee=>le.onCancellationRequested(()=>Ee(Ce)))])}e.raceCancellation=R;async function b(ae){let le=-1;const Ce=ae.map((Fe,$e)=>Fe.then(Ve=>(le=$e,Ve))),Ee=await Promise.race(Ce);return ae.forEach((Fe,$e)=>{$e!==le&&Fe.cancel()}),Ee}e.raceCancellablePromises=b;function n(ae,le,Ce){let Ee;const Fe=setTimeout(()=>{Ee?.(void 0),Ce?.()},le);return Promise.race([ae.finally(()=>clearTimeout(Fe)),new Promise($e=>Ee=$e)])}e.raceTimeout=n;function g(ae){return new Promise((le,Ce)=>{const Ee=ae();C(Ee)?Ee.then(le,Ce):le(Ee)})}e.asPromise=g;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(le){if(this.activePromise){if(this.queuedPromiseFactory=le,!this.queuedPromise){const Ce=()=>{this.queuedPromise=null;const Ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ee};this.queuedPromise=new Promise(Ee=>{this.activePromise.then(Ce,Ce).then(Ee)})}return new Promise((Ce,Ee)=>{this.queuedPromise.then(Ce,Ee)})}return this.activePromise=le(),new Promise((Ce,Ee)=>{this.activePromise.then(Fe=>{this.activePromise=null,Ce(Fe)},Fe=>{this.activePromise=null,Ee(Fe)})})}}e.Throttler=o;class c{constructor(){this.current=Promise.resolve(null)}queue(le){return this.current=this.current.then(()=>le(),()=>le())}}e.Sequencer=c;class u{constructor(){this.promiseMap=new Map}queue(le,Ce){const Fe=(this.promiseMap.get(le)??Promise.resolve()).catch(()=>{}).then(Ce).finally(()=>{this.promiseMap.get(le)===Fe&&this.promiseMap.delete(le)});return this.promiseMap.set(le,Fe),Fe}}e.SequencerByKey=u;const F=(ae,le)=>{let Ce=!0;const Ee=setTimeout(()=>{Ce=!1,le()},ae);return{isTriggered:()=>Ce,dispose:()=>{clearTimeout(Ee),Ce=!1}}},y=ae=>{let le=!0;return queueMicrotask(()=>{le&&(le=!1,ae())}),{isTriggered:()=>le,dispose:()=>{le=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(le){this.defaultDelay=le,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(le,Ce=this.defaultDelay){this.task=le,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,$e)=>{this.doResolve=Fe,this.doReject=$e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Ce===e.MicrotaskDelay?y(Ee):F(Ce,Ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,t.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class d{constructor(le){this.delayer=new f(le),this.throttler=new o}trigger(le,Ce){return this.delayer.trigger(()=>this.throttler.queue(le),Ce)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=d;class D{constructor(){this._isOpen=!1,this._promise=new Promise((le,Ce)=>{this._completePromise=le})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=D;class l extends D{constructor(le){super();this._timeout=setTimeout(()=>this.open(),le)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function M(ae,le){return le?new Promise((Ce,Ee)=>{const Fe=setTimeout(()=>{$e.dispose(),Ce()},ae),$e=le.onCancellationRequested(()=>{clearTimeout(Fe),$e.dispose(),Ee((0,t.canceled)())})}):A(Ce=>M(ae,Ce))}e.timeout=M;function r(ae,le=0){const Ce=setTimeout(ae,le);return(0,T.toDisposable)(()=>clearTimeout(Ce))}e.disposableTimeout=r;function i(ae){const le=[];let Ce=0;const Ee=ae.length;function Fe(){return Ce<Ee?ae[Ce++]():null}function $e(Ve){Ve!=null&&le.push(Ve);const je=Fe();return je?je.then($e):Promise.resolve(le)}return Promise.resolve(null).then($e)}e.sequence=i;function p(ae,le=Ee=>!!Ee,Ce=null){let Ee=0;const Fe=ae.length,$e=()=>{if(Ee>=Fe)return Promise.resolve(Ce);const Ve=ae[Ee++];return Promise.resolve(Ve()).then(H=>le(H)?Promise.resolve(H):$e())};return $e()}e.first=p;function m(ae,le=Ee=>!!Ee,Ce=null){if(ae.length===0)return Promise.resolve(Ce);let Ee=ae.length;const Fe=()=>{Ee=-1;for(const $e of ae)$e.cancel?.()};return new Promise(($e,Ve)=>{for(const je of ae)je.then(H=>{--Ee>=0&&le(H)?(Fe(),$e(H)):Ee===0&&$e(Ce)}).catch(H=>{--Ee>=0&&(Fe(),Ve(H))})})}e.firstParallel=m;class h{constructor(le){this._size=0,this.maxDegreeOfParalellism=le,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(le){return this._size++,new Promise((Ce,Ee)=>{this.outstandingPromises.push({factory:le,c:Ce,e:Ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const le=this.outstandingPromises.shift();this.runningPromises++;const Ce=le.factory();Ce.then(le.c,le.e),Ce.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class w extends h{constructor(){super(1)}}e.Queue=w;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const le=new V;return this.drainers.add(le),le.p}isDrained(){for(const[,le]of this.queues)if(le.size>0)return!1;return!0}queueFor(le,Ce=k.extUri){const Ee=Ce.getComparisonKey(le);let Fe=this.queues.get(Ee);return Fe||(Fe=new w,E.Event.once(Fe.onFinished)(()=>{Fe?.dispose(),this.queues.delete(Ee),this.onDidQueueFinish()}),this.queues.set(Ee,Fe)),Fe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const le of this.drainers)le.complete();this.drainers.clear()}dispose(){for(const[,le]of this.queues)le.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class a{constructor(le,Ce){this._token=-1,typeof le=="function"&&typeof Ce=="number"&&this.setIfNotSet(le,Ce)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(le,Ce){this.cancel(),this._token=setTimeout(()=>{this._token=-1,le()},Ce)}setIfNotSet(le,Ce){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,le()},Ce))}}e.TimeoutTimer=a;class S{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(le,Ce){this.cancel(),this._token=setInterval(()=>{le()},Ce)}}e.IntervalTimer=S;class P{constructor(le,Ce){this.timeoutToken=-1,this.runner=le,this.timeout=Ce,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(le=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,le)}get delay(){return this.timeout}set delay(le){this.timeout=le}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class N{constructor(le,Ce){Ce%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ce}ms is not a multiple of 1000ms.`),this.runner=le,this.timeout=Ce,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(le=this.timeout){le%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(le/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class B extends P{constructor(le,Ce){super(le,Ce);this.units=[]}work(le){this.units.push(le),this.isScheduled()||this.schedule()}doRun(){const le=this.units;this.units=[],this.runner&&this.runner(le)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class _ extends T.Disposable{constructor(le,Ce,Ee,Fe){super();this.maxWorkChunkSize=le,this.maxPendingWork=Ce,this.throttleDelay=Ee,this.handler=Fe,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(le){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+le.length>this.maxPendingWork)return!1}else if(this.pending+le.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...le),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ae=>{(0,I.setTimeout0)(()=>{if(le)return;const Ce=Date.now()+15;ae(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ce-Date.now())}}))});let le=!1;return{dispose(){le||(le=!0)}}}:e.runWhenIdle=(ae,le)=>{const Ce=requestIdleCallback(ae,typeof le=="number"?{timeout:le}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(Ce))}}}}();class O{constructor(le){this._didRun=!1,this._executor=()=>{try{this._value=le()}catch(Ce){this._error=Ce}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function z(ae,le,Ce){let Ee;for(let Fe=0;Fe<Ce;Fe++)try{return await ae()}catch($e){Ee=$e,await M(le)}throw Ee}e.retry=z;class U{hasPending(le){return this._pending?typeof le=="number"?this._pending.taskId===le:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(le,Ce,Ee){return this._pending={taskId:le,cancel:()=>Ee?.(),promise:Ce},Ce.then(()=>this.donePending(le),()=>this.donePending(le)),Ce}donePending(le){this._pending&&le===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const le=this._next;this._next=void 0,le.run().then(le.promiseResolve,le.promiseReject)}}setNext(le){if(this._next)this._next.run=le;else{let Ce,Ee;const Fe=new Promise(($e,Ve)=>{Ce=$e,Ee=Ve});this._next={run:le,promise:Fe,promiseResolve:Ce,promiseReject:Ee}}return this._next.promise}}e.TaskSequentializer=U;class ${constructor(le,Ce=()=>Date.now()){this.interval=le,this.nowFn=Ce,this.lastIncrementTime=0,this.value=0}increment(){const le=this.nowFn();return le-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=le,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((le,Ce)=>{this.completeCallback=le,this.errorCallback=Ce})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(le){return new Promise(Ce=>{this.completeCallback(le),this.resolved=!0,Ce()})}error(le){return new Promise(Ce=>{this.errorCallback(le),this.rejected=!0,Ce()})}cancel(){new Promise(le=>{this.errorCallback((0,t.canceled)()),this.rejected=!0,le()})}}e.DeferredPromise=V;var ue;(function(ae){async function le(Ee){let Fe;const $e=await Promise.all(Ee.map(Ve=>Ve.then(je=>je,je=>{Fe||(Fe=je)})));if(typeof Fe!="undefined")throw Fe;return $e}ae.settled=le;function Ce(Ee){return new Promise(async(Fe,$e)=>{try{await Ee(Fe,$e)}catch(Ve){$e(Ve)}})}ae.withAsyncBody=Ce})(ue=e.Promises||(e.Promises={}));var K;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(K||(K={}));class re{constructor(le){this._state=0,this._results=[],this._error=null,this._onStateChanged=new E.Emitter,queueMicrotask(async()=>{const Ce={emitOne:Ee=>this.emitOne(Ee),emitMany:Ee=>this.emitMany(Ee),reject:Ee=>this.reject(Ee)};try{await Promise.resolve(le(Ce)),this.resolve()}catch(Ee){this.reject(Ee)}finally{Ce.emitOne=void 0,Ce.emitMany=void 0,Ce.reject=void 0}})}static fromArray(le){return new re(Ce=>{Ce.emitMany(le)})}static fromPromise(le){return new re(async Ce=>{Ce.emitMany(await le)})}static fromPromises(le){return new re(async Ce=>{await Promise.all(le.map(async Ee=>Ce.emitOne(await Ee)))})}static merge(le){return new re(async Ce=>{await Promise.all(le.map(async Ee=>{for await(const Fe of Ee)Ce.emitOne(Fe)}))})}[Symbol.asyncIterator](){let le=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(le<this._results.length)return{done:!1,value:this._results[le++]};if(this._state===1)return{done:!0,value:void 0};await E.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(le,Ce){return new re(async Ee=>{for await(const Fe of le)Ee.emitOne(Ce(Fe))})}map(le){return re.map(this,le)}static filter(le,Ce){return new re(async Ee=>{for await(const Fe of le)Ce(Fe)&&Ee.emitOne(Fe)})}filter(le){return re.filter(this,le)}static coalesce(le){return re.filter(le,Ce=>!!Ce)}coalesce(){return re.coalesce(this)}static async toPromise(le){const Ce=[];for await(const Ee of le)Ce.push(Ee);return Ce}toPromise(){return re.toPromise(this)}emitOne(le){this._state===0&&(this._results.push(le),this._onStateChanged.fire())}emitMany(le){this._state===0&&(this._results=this._results.concat(le),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(le){this._state===0&&(this._state=2,this._error=le,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class pe extends re{constructor(le,Ce){super(Ce);this._source=le}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=pe;function be(ae){const le=new s.CancellationTokenSource,Ce=ae(le.token);return new pe(le,async Ee=>{const Fe=le.token.onCancellationRequested(()=>{Fe.dispose(),le.dispose(),Ee.reject((0,t.canceled)())});try{for await(const $e of Ce){if(le.token.isCancellationRequested)return;Ee.emitOne($e)}Fe.dispose(),le.dispose()}catch($e){Fe.dispose(),le.dispose(),Ee.reject($e)}})}e.createCancelableAsyncIterable=be}),define(ye[104],_e([0,1,14,17]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new s.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),T=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(v,a,S=!1){const P=v||"",N=a||"",B=E.value.collator.compare(P,N);return E.value.collatorIsNumeric&&B===0&&P!==N?P<N?-1:1:B}e.compareFileNames=I;function C(v,a){const S=T.value.collator;return v=v||"",a=a||"",D(S,v,a)}e.compareFileNamesDefault=C;function A(v,a){const S=T.value.collator;return v=v||"",a=a||"",i(v,a)||D(S,v,a)}e.compareFileNamesUpper=A;function R(v,a){const S=T.value.collator;return v=v||"",a=a||"",r(v,a)||D(S,v,a)}e.compareFileNamesLower=R;function b(v,a){return v=v||"",a=a||"",v===a?0:v<a?-1:1}e.compareFileNamesUnicode=b;function n(v,a,S=!1){S||(v=v&&v.toLowerCase(),a=a&&a.toLowerCase());const[P,N]=f(v),[B,_]=f(a);return P!==B?P<B?-1:1:N===_?0:N<_?-1:1}e.noIntlCompareFileNames=n;function g(v,a){const[S,P]=f(v),[N,B]=f(a);let _=E.value.collator.compare(P,B);if(_===0){if(E.value.collatorIsNumeric&&P!==B)return P<B?-1:1;if(_=E.value.collator.compare(S,N),E.value.collatorIsNumeric&&_===0&&S!==N)return S<N?-1:1}return _}e.compareFileExtensions=g;function o(v,a){v=v||"",a=a||"";const S=d(v),P=d(a),N=T.value.collator,B=k.value.collator;return D(B,S,P)||D(N,v,a)}e.compareFileExtensionsDefault=o;function c(v,a){v=v||"",a=a||"";const S=d(v),P=d(a),N=T.value.collator,B=k.value.collator;return D(B,S,P)||i(v,a)||D(N,v,a)}e.compareFileExtensionsUpper=c;function u(v,a){v=v||"",a=a||"";const S=d(v),P=d(a),N=T.value.collator,B=k.value.collator;return D(B,S,P)||r(v,a)||D(N,v,a)}e.compareFileExtensionsLower=u;function F(v,a){v=v||"",a=a||"";const S=d(v).toLowerCase(),P=d(a).toLowerCase();return S!==P?S<P?-1:1:v!==a?v<a?-1:1:0}e.compareFileExtensionsUnicode=F;const y=/^(.*?)(\.([^.]*))?$/;function f(v,a=!1){const S=v?y.exec(v):[];let P=[S&&S[1]||"",S&&S[3]||""];return a&&(!P[0]&&P[1]||P[0]&&P[0].charAt(0)===".")&&(P=[P[0]+"."+P[1],""]),P}function d(v){const a=v?y.exec(v):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function D(v,a,S){let P=v.compare(a,S);return P!==0?P:a.length!==S.length?a.length<S.length?-1:1:0}function l(v){const a=v.charAt(0);return a.toLocaleUpperCase()!==a}function M(v){const a=v.charAt(0);return a.toLocaleLowerCase()!==a}function r(v,a){return l(v)&&M(a)?-1:M(v)&&l(a)?1:0}function i(v,a){return M(v)&&l(a)?-1:l(v)&&M(a)?1:0}function p(v,a,S=!1){return S||(v=v&&v.toLowerCase(),a=a&&a.toLowerCase()),v===a?0:v<a?-1:1}function m(v,a,S=!1){const P=v.split(t.sep),N=a.split(t.sep),B=P.length-1,_=N.length-1;let O,z;for(let U=0;;U++){if(O=B===U,z=_===U,O&&z)return I(P[U],N[U],S);if(O)return-1;if(z)return 1;const $=p(P[U],N[U],S);if($!==0)return $}}e.comparePaths=m;function h(v,a,S){const P=v.toLowerCase(),N=a.toLowerCase(),B=w(v,a,S);if(B)return B;const _=P.endsWith(S),O=N.endsWith(S);if(_!==O)return _?-1:1;const z=I(P,N);return z!==0?z:P.localeCompare(N)}e.compareAnything=h;function w(v,a,S){const P=v.toLowerCase(),N=a.toLowerCase(),B=P.startsWith(S),_=N.startsWith(S);if(B!==_)return B?-1:1;if(B&&_){if(P.length<N.length)return-1;if(P.length>N.length)return 1}return 0}e.compareByPrefix=w}),define(ye[29],_e([0,1,14,35,21,17,9]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const C="**",A="/",R="[/\\\\]",b="[^/\\\\]",n=/\//g;function g(K){switch(K){case 0:return"";case 1:return`${b}*?`;default:return`(?:${R}|${b}+${R}|${R}${b}+)*?`}}function o(K,re){if(!K)return[];const pe=[];let be=!1,ae=!1,le="";for(const Ce of K){switch(Ce){case re:if(!be&&!ae){pe.push(le),le="";continue}break;case"{":be=!0;break;case"}":be=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}le+=Ce}return le&&pe.push(le),pe}e.splitGlobAware=o;function c(K){if(!K)return"";let re="";const pe=o(K,A);if(pe.every(be=>be===C))re=".*";else{let be=!1;pe.forEach((ae,le)=>{if(ae===C){be||(re+=g(2),be=!0);return}let Ce=!1,Ee="",Fe=!1,$e="";for(const Ve of ae){if(Ve!=="}"&&Ce){Ee+=Ve;continue}if(Fe&&(Ve!=="]"||!$e)){let je;Ve==="-"?je=Ve:(Ve==="^"||Ve==="!")&&!$e?je="^":Ve===A?je="":je=k.escapeRegExpCharacters(Ve),$e+=je;continue}switch(Ve){case"{":Ce=!0;continue;case"[":Fe=!0;continue;case"}":{re+=`(?:${o(Ee,",").map(G=>c(G)).join("|")})`,Ce=!1,Ee="";break}case"]":re+="["+$e+"]",Fe=!1,$e="";break;case"?":re+=b;continue;case"*":re+=g(1);continue;default:re+=k.escapeRegExpCharacters(Ve)}}le<pe.length-1&&(pe[le+1]!==C||le+2<pe.length)&&(re+=R),be=!1})}return re}const u=/^\*\*\/\*\.[\w\.-]+$/,F=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new E.LRUCache(1e4),M=function(){return!1},r=function(){return null};function i(K,re){if(!K)return r;let pe;typeof K!="string"?pe=K.pattern:pe=K,pe=pe.trim();const be=`${pe}_${!!re.trimForExclusions}`;let ae=l.get(be);if(ae)return p(ae,K);let le;if(u.test(pe)){const Ce=pe.substr(4);ae=function(Ee,Fe){return typeof Ee=="string"&&Ee.endsWith(Ce)?pe:null}}else(le=F.exec(m(pe,re)))?ae=h(le[1],pe):(re.trimForExclusions?f:y).test(pe)?ae=w(pe,re):(le=d.exec(m(pe,re)))?ae=v(le[1].substr(1),pe,!0):(le=D.exec(m(pe,re)))?ae=v(le[1],pe,!1):ae=a(pe);return l.set(be,ae),p(ae,K)}function p(K,re){return typeof re=="string"?K:function(pe,be){return t.isEqualOrParent(pe,re.base)?K(T.relative(re.base,pe),be):null}}function m(K,re){return re.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function h(K,re){const pe=`/${K}`,be=`\\${K}`,ae=function(Ce,Ee){return typeof Ce!="string"?null:Ee?Ee===K?re:null:Ce===K||Ce.endsWith(pe)||Ce.endsWith(be)?re:null},le=[K];return ae.basenames=le,ae.patterns=[re],ae.allBasenames=le,ae}function w(K,re){const pe=ue(K.slice(1,-1).split(",").map(Ee=>i(Ee,re)).filter(Ee=>Ee!==r),K),be=pe.length;if(!be)return r;if(be===1)return pe[0];const ae=function(Ee,Fe){for(let $e=0,Ve=pe.length;$e<Ve;$e++)if(pe[$e](Ee,Fe))return K;return null},le=pe.find(Ee=>!!Ee.allBasenames);le&&(ae.allBasenames=le.allBasenames);const Ce=pe.reduce((Ee,Fe)=>Fe.allPaths?Ee.concat(Fe.allPaths):Ee,[]);return Ce.length&&(ae.allPaths=Ce),ae}function v(K,re,pe){const be=T.sep===T.posix.sep,ae=be?K:K.replace(n,T.sep),le=T.sep+ae,Ce=T.posix.sep+K,Ee=pe?function(Fe,$e){return typeof Fe=="string"&&(Fe===ae||Fe.endsWith(le)||!be&&(Fe===K||Fe.endsWith(Ce)))?re:null}:function(Fe,$e){return typeof Fe=="string"&&(Fe===ae||!be&&Fe===K)?re:null};return Ee.allPaths=[(pe?"*/":"./")+K],Ee}function a(K){try{const re=new RegExp(`^${c(K)}$`);return function(pe){return re.lastIndex=0,typeof pe=="string"&&re.test(pe)?K:null}}catch{return r}}function S(K,re,pe){return!K||typeof re!="string"?!1:P(K)(re,void 0,pe)}e.match=S;function P(K,re={}){if(!K)return M;if(typeof K=="string"||O(K)){const pe=i(K,re);if(pe===r)return M;const be=function(ae,le){return!!pe(ae,le)};return pe.allBasenames&&(be.allBasenames=pe.allBasenames),pe.allPaths&&(be.allPaths=pe.allPaths),be}return $(K,re)}e.parse=P;function N(K){if(!K)return;let re;return pe=>(re||(re=(K()||Promise.resolve([])).then(be=>be?_(be):{})),re.then(be=>!!be[pe]))}e.hasSiblingPromiseFn=N;function B(K){if(!K)return;let re;return pe=>{if(!re){const be=K();re=be?_(be):{}}return!!re[pe]}}e.hasSiblingFn=B;function _(K){const re={};for(const pe of K)re[pe]=!0;return re}function O(K){const re=K;return re&&typeof re.base=="string"&&typeof re.pattern=="string"}e.isRelativePattern=O;function z(K){return K.allBasenames||[]}e.getBasenameTerms=z;function U(K){return K.allPaths||[]}e.getPathTerms=U;function $(K,re){const pe=ue(Object.getOwnPropertyNames(K).map(Ee=>V(Ee,K[Ee],re)).filter(Ee=>Ee!==r)),be=pe.length;if(!be)return r;if(!pe.some(Ee=>!!Ee.requiresSiblings)){if(be===1)return pe[0];const Ee=function(Ve,je){for(let H=0,G=pe.length;H<G;H++){const X=pe[H](Ve,je);if(X)return X}return null},Fe=pe.find(Ve=>!!Ve.allBasenames);Fe&&(Ee.allBasenames=Fe.allBasenames);const $e=pe.reduce((Ve,je)=>je.allPaths?Ve.concat(je.allPaths):Ve,[]);return $e.length&&(Ee.allPaths=$e),Ee}const ae=function(Ee,Fe,$e){let Ve;for(let je=0,H=pe.length;je<H;je++){const G=pe[je];G.requiresSiblings&&$e&&(Fe||(Fe=T.basename(Ee)),Ve||(Ve=Fe.substr(0,Fe.length-T.extname(Ee).length)));const X=G(Ee,Fe,Ve,$e);if(X)return X}return null},le=pe.find(Ee=>!!Ee.allBasenames);le&&(ae.allBasenames=le.allBasenames);const Ce=pe.reduce((Ee,Fe)=>Fe.allPaths?Ee.concat(Fe.allPaths):Ee,[]);return Ce.length&&(ae.allPaths=Ce),ae}function V(K,re,pe){if(re===!1)return r;const be=i(K,pe);if(be===r)return r;if(typeof re=="boolean")return be;if(re){const ae=re.when;if(typeof ae=="string"){const le=(Ce,Ee,Fe,$e)=>{if(!$e||!be(Ce,Ee))return null;const Ve=ae.replace("$(basename)",Fe),je=$e(Ve);return(0,s.isThenable)(je)?je.then(H=>H?K:null):je?K:null};return le.requiresSiblings=!0,le}}return be}function ue(K,re){const pe=K.filter(Ee=>!!Ee.basenames);if(pe.length<2)return K;const be=pe.reduce((Ee,Fe)=>{const $e=Fe.basenames;return $e?Ee.concat($e):Ee},[]);let ae;if(re){ae=[];for(let Ee=0,Fe=be.length;Ee<Fe;Ee++)ae.push(re)}else ae=pe.reduce((Ee,Fe)=>{const $e=Fe.patterns;return $e?Ee.concat($e):Ee},[]);const le=function(Ee,Fe){if(typeof Ee!="string")return null;if(!Fe){let Ve;for(Ve=Ee.length;Ve>0;Ve--){const je=Ee.charCodeAt(Ve-1);if(je===47||je===92)break}Fe=Ee.substr(Ve)}const $e=be.indexOf(Fe);return $e!==-1?ae[$e]:null};le.basenames=be,le.patterns=ae,le.allBasenames=be;const Ce=K.filter(Ee=>!Ee.basenames);return Ce.push(le),Ce}}),define(ye[78],_e([0,1,35,11,17,23,24,9,2]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(i,p,m){if(typeof i=="string"&&(i=C.URI.file(i)),m){const w=m.getWorkspaceFolder(i);if(w){const v=m.getWorkspace().folders.length>1;let a;if((0,k.isEqual)(w.uri,i)?a="":a=(0,k.relativePath)(w.uri,i),v){const S=w.name?w.name:(0,k.basename)(w.uri);a=a?S+" \u2022 "+a:S}return a}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,s.hasDriveLetter)(i.fsPath))return(0,E.normalize)(b(i.fsPath));let h=(0,E.normalize)(i.fsPath);return!T.isWindows&&p?.userHome&&(h=g(h,p.userHome.fsPath)),h}e.getPathLabel=A;function R(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const p=(0,k.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return T.isWindows&&(0,s.isRootOrDriveLetter)(p)?b(p):p}e.getBaseLabel=R;function b(i,p){return(0,s.hasDriveLetter)(i,p)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let n=Object.create(null);function g(i,p){if(T.isWindows||!i||!p)return i;let m=n.original===p?n.normalized:void 0;return m||(m=`${(0,I.rtrim)(p,E.posix.sep)}${E.posix.sep}`,n={original:p,normalized:m}),(T.isLinux?i.startsWith(m):(0,I.startsWithIgnoreCase)(i,m))&&(i=`~/${i.substr(m.length)}`),i}e.tildify=g;function o(i,p){return i.replace(/^~($|\/|\\)/,`${p}$1`)}e.untildify=o;const c="\u2026",u="\\\\",F="~";function y(i,p=E.sep){const m=new Array(i.length);let h=!1;for(let w=0;w<i.length;w++){let v=i[w];if(v===""){m[w]=`.${p}`;continue}if(!v){m[w]=v;continue}h=!0;let a="";v.indexOf(u)===0?(a=v.substr(0,v.indexOf(u)+u.length),v=v.substr(v.indexOf(u)+u.length)):v.indexOf(p)===0?(a=v.substr(0,v.indexOf(p)+p.length),v=v.substr(v.indexOf(p)+p.length)):v.indexOf(F)===0&&(a=v.substr(0,v.indexOf(F)+F.length),v=v.substr(v.indexOf(F)+F.length));const S=v.split(p);for(let P=1;h&&P<=S.length;P++)for(let N=S.length-P;h&&N>=0;N--){h=!1;let B=S.slice(N,N+P).join(p);for(let _=0;!h&&_<i.length;_++)if(_!==w&&i[_]&&i[_].indexOf(B)>-1){const O=N+P===S.length,z=N>0&&i[_].indexOf(p)>-1?p+B:B,U=i[_].endsWith(z);h=!O||U}if(!h){let _="";(S[0].endsWith(":")||a!=="")&&(N===1&&(N=0,P++,B=S[0]+p+B),N>0&&(_=S[0]+p),_=a+_),N>0&&(_=_+c+p),_=_+B,N+P<S.length&&(_=_+p+c),m[w]=_}}h&&(m[w]=v)}return m}e.shorten=y;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function d(i,p=Object.create(null)){const m=[];let h=!1,w="";for(const v of i)if(v==="$"||h&&v==="{")w&&m.push({value:w,type:f.TEXT}),w="",h=!0;else if(v==="}"&&h){const a=p[w];if(typeof a=="string")a.length&&m.push({value:a,type:f.VARIABLE});else if(a){const S=m[m.length-1];(!S||S.type!==f.SEPARATOR)&&m.push({value:a.label,type:f.SEPARATOR})}w="",h=!1}else w+=v;return w&&!h&&m.push({value:w,type:f.TEXT}),m.filter((v,a)=>{if(v.type===f.SEPARATOR){const S=m[a-1],P=m[a+1];return[S,P].every(N=>N&&(N.type===f.VARIABLE||N.type===f.TEXT)&&N.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=d;function D(i,p){return T.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function l(i,p){return T.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,m=>m==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function M(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=M;function r(i){const p=i.indexOf("/")!==-1?E.posix:E.win32,m=p.basename(i),h=p.dirname(i);return m.length?{name:m,parentPath:h}:{name:h,parentPath:""}}e.splitName=r}),define(ye[105],_e([0,1,2]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class E{constructor(b){this._uriTransformer=b}transformIncoming(b){const n=this._uriTransformer.transformIncoming(b);return n===b?b:t(s.URI.from(n))}transformOutgoing(b){const n=this._uriTransformer.transformOutgoing(b);return n===b?b:t(s.URI.from(n))}transformOutgoingURI(b){const n=this._uriTransformer.transformOutgoing(b);return n===b?b:s.URI.from(n)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function T(R,b,n){if(!R||n>200)return null;if(typeof R=="object"){if(R instanceof s.URI)return b.transformOutgoing(R);for(let g in R)if(Object.hasOwnProperty.call(R,g)){const o=T(R[g],b,n+1);o!==null&&(R[g]=o)}}return null}function k(R,b){const n=T(R,b,0);return n===null?R:n}e.transformOutgoingURIs=k;function I(R,b,n,g){if(!R||g>200)return null;if(typeof R=="object"){if(R.$mid===1)return n?s.URI.revive(b.transformIncoming(R)):b.transformIncoming(R);for(let o in R)if(Object.hasOwnProperty.call(R,o)){const c=I(R[o],b,n,g+1);c!==null&&(R[o]=c)}}return null}function C(R,b){const n=I(R,b,!1,0);return n===null?R:n}e.transformIncomingURIs=C;function A(R,b){const n=I(R,b,!0,0);return n===null?R:n}e.transformAndReviveIncomingURIs=A}),define(ye[36],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return s.test(C)}e.isUUID=t;const E=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let A=0;A<C.length;A++)C[A]=Math.floor(Math.random()*256);return C};function I(){k(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let C=0,A="";return A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+="-",A+=T[E[C++]],A+=T[E[C++]],A+="-",A+=T[E[C++]],A+=T[E[C++]],A+="-",A+=T[E[C++]],A+=T[E[C++]],A+="-",A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A+=T[E[C++]],A}e.generateUuid=I}),define(ye[106],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var s;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(s=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let C=0,A=I.notIn.length;C<A;C++)switch(I.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,C){if(I.getTokenCount()===0)return!0;const A=I.findTokenIndexAtOffset(C-2),R=I.getStandardTokenType(A);return this.isOK(R)}_findNeutralCharacterInRange(I,C){for(let A=I;A<=C;A++){const R=String.fromCharCode(A);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class E{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of I)T(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),T(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),T(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),T(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&T(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=E;function T(k,I,C){k.has(I)?k.get(I).push(C):k.set(I,[C])}}),define(ye[56],_e([0,1,29,17]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(T,k,I,C){if(Array.isArray(T)){let A=0;for(const R of T){const b=E(R,k,I,C);if(b===10)return b;b>A&&(A=b)}return A}else{if(typeof T=="string")return C?T==="*"?5:T===I?10:0:0;if(T){const{language:A,pattern:R,scheme:b,hasAccessToAllModels:n}=T;if(!C&&!n)return 0;let g=0;if(b)if(b===k.scheme)g=10;else if(b==="*")g=5;else return 0;if(A)if(A===I)g=10;else if(A==="*")g=Math.max(g,5);else return 0;if(R){let o;if(typeof R=="string"?o=R:o={...R,base:(0,t.normalize)(R.base)},o===k.fsPath||(0,s.match)(o,k.fsPath))g=10;else return 0}return g}else return 0}}e.score=E}),define(ye[107],_e([0,1,4,6]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class E{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new s.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,C){return this._map.set(I,C),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===C&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,C){this._factories.get(I)?.dispose();const A=new T(this,I,C);return this._factories.set(I,A),(0,t.toDisposable)(()=>{const R=this._factories.get(I);!R||R!==A||(this._factories.delete(I),R.dispose())})}async getOrCreate(I){const C=this.get(I);if(C)return C;const A=this._factories.get(I);return!A||A.isResolved?null:(await A.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const A=this._factories.get(I);return!!(!A||A.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=E;class T extends t.Disposable{constructor(I,C,A){super();this._registry=I,this._languageId=C,this._factory=A,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(ye[79],_e([0,1,22,23]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(E||(E={}));function T(b){for(let n=0,g=b.length;n<g;n+=4){const o=b[n+0],c=b[n+1],u=b[n+2],F=b[n+3];b[n+0]=F,b[n+1]=u,b[n+2]=c,b[n+3]=o}}function k(b){const n=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return t.isLittleEndian()||T(n),s.VSBuffer.wrap(n)}function I(b){const n=b.buffer;if(t.isLittleEndian()||T(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const g=new Uint8Array(n.byteLength);return g.set(n),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function C(b){const n=new Uint32Array(A(b));let g=0;if(n[g++]=b.id,b.type==="full")n[g++]=1,n[g++]=b.data.length,n.set(b.data,g),g+=b.data.length;else{n[g++]=2,n[g++]=b.deltas.length;for(const o of b.deltas)n[g++]=o.start,n[g++]=o.deleteCount,o.data?(n[g++]=o.data.length,n.set(o.data,g),g+=o.data.length):n[g++]=0}return k(n)}e.encodeSemanticTokensDto=C;function A(b){let n=0;if(n+=1+1,b.type==="full")n+=1+b.data.length;else{n+=1,n+=(1+1+1)*b.deltas.length;for(const g of b.deltas)g.data&&(n+=g.data.length)}return n}function R(b){const n=I(b);let g=0;const o=n[g++];if(n[g++]===1){const y=n[g++],f=n.subarray(g,g+y);return g+=y,{id:o,type:"full",data:f}}const u=n[g++],F=[];for(let y=0;y<u;y++){const f=n[g++],d=n[g++],D=n[g++];let l;D>0&&(l=n.subarray(g,g+D),g+=D),F[y]={start:f,deleteCount:d,data:l}}return{id:o,type:"delta",deltas:F}}e.decodeSemanticTokensDto=R}),define(ye[108],_e([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ye[109],_e([0,1,108]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,E=t*60,T=E*24,k=T*7,I=T*30,C=T*365;function A(b,n){typeof b!="number"&&(b=b.getTime());const g=Math.round((new Date().getTime()-b)/1e3);if(g<-30)return(0,s.localize)(0,null,A(new Date().getTime()+g*1e3,!1));if(g<30)return(0,s.localize)(1,null);let o;return g<t?(o=g,n?o===1?(0,s.localize)(2,null,o):(0,s.localize)(3,null,o):o===1?(0,s.localize)(4,null,o):(0,s.localize)(5,null,o)):g<E?(o=Math.floor(g/t),n?o===1?(0,s.localize)(6,null,o):(0,s.localize)(7,null,o):o===1?(0,s.localize)(8,null,o):(0,s.localize)(9,null,o)):g<T?(o=Math.floor(g/E),n?o===1?(0,s.localize)(10,null,o):(0,s.localize)(11,null,o):o===1?(0,s.localize)(12,null,o):(0,s.localize)(13,null,o)):g<k?(o=Math.floor(g/T),n?o===1?(0,s.localize)(14,null,o):(0,s.localize)(15,null,o):o===1?(0,s.localize)(16,null,o):(0,s.localize)(17,null,o)):g<I?(o=Math.floor(g/k),n?o===1?(0,s.localize)(18,null,o):(0,s.localize)(19,null,o):o===1?(0,s.localize)(20,null,o):(0,s.localize)(21,null,o)):g<C?(o=Math.floor(g/I),n?o===1?(0,s.localize)(22,null,o):(0,s.localize)(23,null,o):o===1?(0,s.localize)(24,null,o):(0,s.localize)(25,null,o)):(o=Math.floor(g/C),n?o===1?(0,s.localize)(26,null,o):(0,s.localize)(27,null,o):o===1?(0,s.localize)(28,null,o):(0,s.localize)(29,null,o))}e.fromNow=A;function R(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ye[110],_e([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ye[43],_e([0,1,16,10,110]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(A,R){return R&&(A.stack||A.stacktrace)?E.localize(0,null,I(A),k(A.stack)||k(A.stacktrace)):I(A)}function k(A){return Array.isArray(A)?A.join(`
`):A}function I(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?E.localize(1,null,A.message):A.message||E.localize(2,null)}function C(A=null,R=!1){if(!A)return E.localize(3,null);if(Array.isArray(A)){const b=s.coalesce(A),n=C(b[0],R);return b.length>1?E.localize(4,null,n,b.length):n}if(t.isString(A))return A;if(A.detail){const b=A.detail;if(b.error)return T(b.error,R);if(b.exception)return T(b.exception,R)}return A.stack?T(A,R):A.message?A.message:E.localize(5,null)}e.toErrorMessage=C}),define(ye[111],_e([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(ye[112],_e([0,1,111,23,113,16,26]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=C;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class R{constructor(Q,fe,Ne,qe){this.id=Q,this.name=fe,this.defaultValue=Ne,this.schema=qe}applyUpdate(Q,fe){return n(Q,fe)}compute(Q,fe,Ne){return Ne}}class b{constructor(Q,fe){this.newValue=Q,this.didChange=fe}}e.ApplyUpdateResult=b;function n(j,Q){if(typeof j!="object"||typeof Q!="object"||!j||!Q)return new b(Q,j!==Q);if(Array.isArray(j)||Array.isArray(Q)){const Ne=Array.isArray(j)&&Array.isArray(Q)&&T.equals(j,Q);return new b(Q,Ne)}let fe=!1;for(const Ne in Q)if(Q.hasOwnProperty(Ne)){const qe=n(j[Ne],Q[Ne]);qe.didChange&&(j[Ne]=qe.newValue,fe=!0)}return new b(j,fe)}class g{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,fe){return n(Q,fe)}validate(Q){return this.defaultValue}}class o{constructor(Q,fe,Ne,qe){this.id=Q,this.name=fe,this.defaultValue=Ne,this.schema=qe}applyUpdate(Q,fe){return n(Q,fe)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,fe,Ne){return Ne}}function c(j,Q){return typeof j=="undefined"?Q:j==="false"?!1:Boolean(j)}e.boolean=c;class u extends o{constructor(Q,fe,Ne,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Ne);super(Q,fe,Ne,qe)}validate(Q){return c(Q,this.defaultValue)}}function F(j,Q,fe,Ne){if(typeof j=="undefined")return Q;let qe=parseInt(j,10);return isNaN(qe)?Q:(qe=Math.max(fe,qe),qe=Math.min(Ne,qe),qe|0)}e.clampedInt=F;class y extends o{constructor(Q,fe,Ne,qe,ot,ht=void 0){typeof ht!="undefined"&&(ht.type="integer",ht.default=Ne,ht.minimum=qe,ht.maximum=ot);super(Q,fe,Ne,ht);this.minimum=qe,this.maximum=ot}static clampedInt(Q,fe,Ne,qe){return F(Q,fe,Ne,qe)}validate(Q){return y.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class f extends o{constructor(Q,fe,Ne,qe,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Ne);super(Q,fe,Ne,ot);this.validationFn=qe}static clamp(Q,fe,Ne){return Q<fe?fe:Q>Ne?Ne:Q}static float(Q,fe){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return fe;const Ne=parseFloat(Q);return isNaN(Ne)?fe:Ne}validate(Q){return this.validationFn(f.float(Q,this.defaultValue))}}class d extends o{static string(Q,fe){return typeof Q!="string"?fe:Q}constructor(Q,fe,Ne,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Ne);super(Q,fe,Ne,qe)}validate(Q){return d.string(Q,this.defaultValue)}}function D(j,Q,fe){return typeof j!="string"||fe.indexOf(j)===-1?Q:j}e.stringSet=D;class l extends o{constructor(Q,fe,Ne,qe,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=qe,ot.default=Ne);super(Q,fe,Ne,ot);this._allowedValues=qe}validate(Q){return D(Q,this.defaultValue,this._allowedValues)}}class M extends R{constructor(Q,fe,Ne,qe,ot,ht,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.enum=ot,Je.default=qe);super(Q,fe,Ne,Je);this._allowedValues=ot,this._convert=ht}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function r(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",description:s.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,fe,Ne){return Ne===0?Q.accessibilitySupport:Ne}}class p extends R{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:s.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertSpace:c(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var m;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(m=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(w=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function v(j){switch(j){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function a(j){switch(j){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class S extends g{constructor(){super(127)}compute(Q,fe,Ne){const qe=["monaco-editor"];return fe.get(33)&&qe.push(fe.get(33)),Q.extraEditorClassName&&qe.push(Q.extraEditorClassName),fe.get(65)==="default"?qe.push("mouse-default"):fe.get(65)==="copy"&&qe.push("mouse-copy"),fe.get(99)&&qe.push("showUnused"),fe.get(125)&&qe.push("showDeprecated"),qe.join(" ")}}class P extends u{constructor(){super(32,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(Q,fe,Ne){return Ne&&Q.emptySelectionClipboard}}class N extends R{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:s.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:s.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{cursorMoveOnType:c(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":D(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":D(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(fe.loop,this.defaultValue.loop)}}}class B extends R{constructor(){super(44,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?B.OFF:Q==="true"?B.ON:Q:Boolean(Q)?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class _ extends g{constructor(){super(43)}compute(Q,fe,Ne){return Q.fontInfo}}class O extends o{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(22,null)})}validate(Q){const fe=f.float(Q,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(fe,6,100)}compute(Q,fe,Ne){return Q.fontInfo.fontSize}}class z extends R{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:s.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(y.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class U extends R{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[s.localize(25,null),s.localize(26,null),s.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:s.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:s.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:s.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ne,description:s.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ne,description:s.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ne,description:s.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ne,description:s.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ne,description:s.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{multiple:D(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??D(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??D(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??D(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??D(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??D(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:d.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:d.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:d.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:d.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:d.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends R{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:s.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,description:s.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:s.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:s.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),delay:y.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:c(fe.sticky,this.defaultValue.sticky),above:c(fe.above,this.defaultValue.above)}}}var V;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class ue extends g{constructor(){super(130)}compute(Q,fe,Ne){return ue.computeLayout(fe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const fe=Q.height/Q.lineHeight,Ne=Q.scrollBeyondLastLine?fe-1:0,qe=(Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),ot=Math.floor(Q.viewLineCount/qe);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Ne,desiredRatio:qe,minimapLineCount:ot}}static _computeMinimapLayout(Q,fe){const Ne=Q.outerWidth,qe=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const ht=fe.stableMinimapLayoutInput,Je=ht&&Q.outerHeight===ht.outerHeight&&Q.lineHeight===ht.lineHeight&&Q.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&Q.pixelRatio===ht.pixelRatio&&Q.scrollBeyondLastLine===ht.scrollBeyondLastLine&&Q.minimap.enabled===ht.minimap.enabled&&Q.minimap.side===ht.minimap.side&&Q.minimap.size===ht.minimap.size&&Q.minimap.showSlider===ht.minimap.showSlider&&Q.minimap.renderCharacters===ht.minimap.renderCharacters&&Q.minimap.maxColumn===ht.minimap.maxColumn&&Q.minimap.scale===ht.minimap.scale&&Q.verticalScrollbarWidth===ht.verticalScrollbarWidth&&Q.isViewportWrapping===ht.isViewportWrapping,Tt=Q.lineHeight,Ae=Q.typicalHalfwidthCharacterWidth,De=Q.scrollBeyondLastLine,ve=Q.minimap.renderCharacters;let ie=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const se=Q.minimap.maxColumn,de=Q.minimap.size,me=Q.minimap.side,Te=Q.verticalScrollbarWidth,We=Q.viewLineCount,Le=Q.remainingWidth,Ke=Q.isViewportWrapping,it=ve?2:3;let rt=Math.floor(ot*qe);const ne=rt/ot;let ge=!1,te=!1,W=it*ie,we=ie/ot,Pe=1;if(de==="fill"||de==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:pt,desiredRatio:yt,minimapLineCount:Ot}=ue.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:De,height:qe,lineHeight:Tt,pixelRatio:ot});if(We/Ot>1)ge=!0,te=!0,ie=1,W=1,we=ie/ot;else{let It=!1,At=ie+1;if(de==="fit"){const St=Math.ceil((We+pt)*W);Ke&&Je&&Le<=fe.stableFitRemainingWidth?(It=!0,At=fe.stableFitMaxMinimapScale):It=St>rt}if(de==="fill"||It){ge=!0;const St=ie;W=Math.min(Tt*ot,Math.max(1,Math.floor(1/yt))),Ke&&Je&&Le<=fe.stableFitRemainingWidth&&(At=fe.stableFitMaxMinimapScale),ie=Math.min(At,Math.max(1,Math.floor(W/it))),ie>St&&(Pe=Math.min(2,ie/St)),we=ie/ot/Pe,rt=Math.ceil(Math.max(ft,We+pt)*W),Ke?(fe.stableMinimapLayoutInput=Q,fe.stableFitRemainingWidth=Le,fe.stableFitMaxMinimapScale=ie):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const Ye=Math.floor(se*we),xe=Math.min(Ye,Math.max(0,Math.floor((Le-Te-2)*we/(Ae+we)))+e.MINIMAP_GUTTER_WIDTH);let ut=Math.floor(ot*xe);const bt=ut/ot;ut=Math.floor(ut*Pe);const Ct=ve?1:2,wt=me==="left"?0:Ne-xe-Te;return{renderMinimap:Ct,minimapLeft:wt,minimapWidth:xe,minimapHeightIsEditorHeight:ge,minimapIsSampling:te,minimapScale:ie,minimapLineHeight:W,minimapCanvasInnerWidth:ut,minimapCanvasInnerHeight:rt,minimapCanvasOuterWidth:bt,minimapCanvasOuterHeight:ne}}static computeLayout(Q,fe){const Ne=fe.outerWidth|0,qe=fe.outerHeight|0,ot=fe.lineHeight|0,ht=fe.lineNumbersDigitCount|0,Je=fe.typicalHalfwidthCharacterWidth,Tt=fe.maxDigitWidth,Ae=fe.pixelRatio,De=fe.viewLineCount,ve=Q.get(122),ie=ve==="inherit"?Q.get(121):ve,se=ie==="inherit"?Q.get(117):ie,de=Q.get(120),me=Q.get(2),Te=fe.isDominatedByLongLines,We=Q.get(49),Le=Q.get(59).renderType!==0,Ke=Q.get(60),it=Q.get(93),rt=Q.get(64),ne=Q.get(91),ge=ne.verticalScrollbarSize,te=ne.verticalHasArrows,W=ne.arrowSize,we=ne.horizontalScrollbarSize,Pe=Q.get(57),Ye=Q.get(37);let xe;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const Et=parseFloat(Pe.substr(0,Pe.length-2));xe=y.clampedInt(Et*Je,0,0,1e3)}else xe=y.clampedInt(Pe,0,0,1e3);Ye&&(xe+=16);let ut=0;if(Le){const Et=Math.max(ht,Ke);ut=Math.round(Et*Tt)}let bt=0;We&&(bt=ot);let Ct=0,wt=Ct+bt,ft=wt+ut,pt=ft+xe;const yt=Ne-bt-ut-xe;let Ot=!1,kt=!1,It=-1;me!==2&&(ie==="inherit"&&Te?(Ot=!0,kt=!0):se==="on"||se==="bounded"?kt=!0:se==="wordWrapColumn"&&(It=de));const At=ue._computeMinimapLayout({outerWidth:Ne,outerHeight:qe,lineHeight:ot,typicalHalfwidthCharacterWidth:Je,pixelRatio:Ae,scrollBeyondLastLine:it,minimap:rt,verticalScrollbarWidth:ge,viewLineCount:De,remainingWidth:yt,isViewportWrapping:kt},fe.memory||new A);At.renderMinimap!==0&&At.minimapLeft===0&&(Ct+=At.minimapWidth,wt+=At.minimapWidth,ft+=At.minimapWidth,pt+=At.minimapWidth);const St=yt-At.minimapWidth,zt=Math.max(1,Math.floor((St-ge-2)/Je)),Lt=te?W:0;return kt&&(It=Math.max(1,zt),se==="bounded"&&(It=Math.min(It,de))),{width:Ne,height:qe,glyphMarginLeft:Ct,glyphMarginWidth:bt,lineNumbersLeft:wt,lineNumbersWidth:ut,decorationsLeft:ft,decorationsWidth:xe,contentLeft:pt,contentWidth:St,minimap:At,viewportColumn:zt,isWordWrapMinified:Ot,isViewportWrapping:kt,wrappingColumn:It,verticalScrollbarWidth:ge,horizontalScrollbarHeight:we,overviewRuler:{top:Lt,width:ge,height:qe-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=ue;class K extends R{constructor(){const Q={enabled:!0};super(56,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:s.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:c(Q.enabled,this.defaultValue.enabled)}}}class re extends R{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:s.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:s.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),fontSize:y.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:d.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class pe extends f{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>f.clamp(Q,0,150),{markdownDescription:s.localize(47,null)})}compute(Q,fe,Ne){return Q.fontInfo.lineHeight}}class be extends R{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:s.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(49,null),s.localize(50,null),s.localize(51,null)],default:Q.size,description:s.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:s.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:s.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:s.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:s.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),size:D(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:D(fe.side,this.defaultValue.side,["right","left"]),showSlider:D(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(fe.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(fe.scale,1,1,3),maxColumn:y.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ae(j){return j==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class le extends R{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{top:y.clampedInt(fe.top,0,0,1e3),bottom:y.clampedInt(fe.bottom,0,0,1e3)}}}class Ce extends R{constructor(){const Q={enabled:!0,cycle:!1};super(75,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:s.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),cycle:c(fe.cycle,this.defaultValue.cycle)}}}class Ee extends g{constructor(){super(128)}compute(Q,fe,Ne){return Q.pixelRatio}}class Fe extends R{constructor(){const Q={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:s.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:s.localize(63,null)},other:{type:"boolean",default:Q.other,description:s.localize(64,null)}}}],default:Q,description:s.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const fe=Q,Ne={other:c(fe.other,this.defaultValue.other),comments:c(fe.comments,this.defaultValue.comments),strings:c(fe.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var $e;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})($e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ve extends R{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(66,null),s.localize(67,null),s.localize(68,null),s.localize(69,null)],default:"on",description:s.localize(70,null)})}validate(Q){let fe=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(fe=4,Ne=Q):Q==="interval"?fe=3:Q==="relative"?fe=2:Q==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ne}}}function je(j){const Q=j.get(86);return Q==="editable"?j.get(80):Q!=="on"}e.filterValidationDecorations=je;class H extends R{constructor(){const Q=[],fe={type:"number",description:s.localize(71,null)};super(90,"rulers",Q,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:s.localize(72,null),format:"color-hex"}}}]},default:Q,description:s.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const fe=[];for(let Ne of Q)if(typeof Ne=="number")fe.push({column:y.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const qe=Ne;fe.push({column:y.clampedInt(qe.column,0,0,1e4),color:qe.color})}return fe.sort((Ne,qe)=>Ne.column-qe.column),fe}return this.defaultValue}}function G(j,Q){if(typeof j!="string")return Q;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class X extends R{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(74,null),s.localize(75,null),s.localize(76,null)],default:"auto",description:s.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(78,null),s.localize(79,null),s.localize(80,null)],default:"auto",description:s.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:s.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:s.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:s.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q,Ne=y.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=y.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:G(fe.vertical,this.defaultValue.vertical),horizontal:G(fe.horizontal,this.defaultValue.horizontal),useShadows:c(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:y.clampedInt(fe.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:y.clampedInt(fe.verticalSliderSize,qe,0,1e3),scrollByPage:c(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class oe extends R{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(112,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:s.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:s.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:s.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:s.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:s.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:s.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:s.localize(91,null)}})}applyUpdate(Q,fe){let Ne=!1;fe.allowedCharacters&&(k.equals(Q.allowedCharacters,fe.allowedCharacters)||(Q={...Q,allowedCharacters:fe.allowedCharacters},Ne=!0)),fe.allowedLocales&&(k.equals(Q.allowedLocales,fe.allowedLocales)||(Q={...Q,allowedLocales:fe.allowedLocales},Ne=!0));const qe=super.applyUpdate(Q,fe);return Ne?new b(qe.newValue,!0):qe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{nonBasicASCII:Re(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Re(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Re(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,fe){if(typeof Q!="object"||!Q)return fe;const Ne={};for(const[qe,ot]of Object.entries(Q))ot===!0&&(Ne[qe]=!0);return Ne}}class q extends R{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:s.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),mode:D(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends R{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:s.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:c(Q.enabled,this.defaultValue.enabled)}}}class he extends R{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(94,null),s.localize(95,null),s.localize(96,null)],default:Q.bracketPairs,description:s.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(98,null),s.localize(99,null),s.localize(100,null)],default:Q.bracketPairsHorizontal,description:s.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:s.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:s.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:s.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{bracketPairs:Re(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Re(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:c(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Re(j,Q,fe){const Ne=fe.indexOf(j);return Ne===-1?Q:fe[Ne]}class Ue extends R{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(105,null),s.localize(106,null)],default:Q.insertMode,description:s.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:s.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:s.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:s.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:s.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:s.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:s.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:s.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:s.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertMode:D(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(fe.showIcons,this.defaultValue.showIcons),showStatusBar:c(fe.showStatusBar,this.defaultValue.showStatusBar),preview:c(fe.preview,this.defaultValue.preview),previewMode:D(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(fe.showMethods,this.defaultValue.showMethods),showFunctions:c(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:c(fe.showFields,this.defaultValue.showFields),showVariables:c(fe.showVariables,this.defaultValue.showVariables),showClasses:c(fe.showClasses,this.defaultValue.showClasses),showStructs:c(fe.showStructs,this.defaultValue.showStructs),showInterfaces:c(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(fe.showModules,this.defaultValue.showModules),showProperties:c(fe.showProperties,this.defaultValue.showProperties),showEvents:c(fe.showEvents,this.defaultValue.showEvents),showOperators:c(fe.showOperators,this.defaultValue.showOperators),showUnits:c(fe.showUnits,this.defaultValue.showUnits),showValues:c(fe.showValues,this.defaultValue.showValues),showConstants:c(fe.showConstants,this.defaultValue.showConstants),showEnums:c(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(fe.showKeywords,this.defaultValue.showKeywords),showWords:c(fe.showWords,this.defaultValue.showWords),showColors:c(fe.showColors,this.defaultValue.showColors),showFiles:c(fe.showFiles,this.defaultValue.showFiles),showReferences:c(fe.showReferences,this.defaultValue.showReferences),showFolders:c(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(fe.showSnippets,this.defaultValue.showSnippets),showUsers:c(fe.showUsers,this.defaultValue.showUsers),showIssues:c(fe.showIssues,this.defaultValue.showIssues)}}}class ze extends R{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Qe extends g{constructor(){super(129)}compute(Q,fe,Ne){return fe.get(80)?!0:Q.tabFocusMode}}var et;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(et=e.WrappingIndent||(e.WrappingIndent={}));function st(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Xe extends g{constructor(){super(131)}compute(Q,fe,Ne){const qe=fe.get(130);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const nt="Consolas, 'Courier New', monospace",lt="Menlo, Monaco, 'Courier New', monospace",vt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?lt:t.isLinux?vt:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Oe(j){return e.editorOptionsRegistry[j.id]=j,j}var Rt;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.bracketPairColorization=12]="bracketPairColorization",j[j.guides=13]="guides",j[j.codeLens=14]="codeLens",j[j.codeLensFontFamily=15]="codeLensFontFamily",j[j.codeLensFontSize=16]="codeLensFontSize",j[j.colorDecorators=17]="colorDecorators",j[j.columnSelection=18]="columnSelection",j[j.comments=19]="comments",j[j.contextmenu=20]="contextmenu",j[j.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",j[j.cursorBlinking=22]="cursorBlinking",j[j.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",j[j.cursorStyle=24]="cursorStyle",j[j.cursorSurroundingLines=25]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",j[j.cursorWidth=27]="cursorWidth",j[j.disableLayerHinting=28]="disableLayerHinting",j[j.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",j[j.domReadOnly=30]="domReadOnly",j[j.dragAndDrop=31]="dragAndDrop",j[j.emptySelectionClipboard=32]="emptySelectionClipboard",j[j.extraEditorClassName=33]="extraEditorClassName",j[j.fastScrollSensitivity=34]="fastScrollSensitivity",j[j.find=35]="find",j[j.fixedOverflowWidgets=36]="fixedOverflowWidgets",j[j.folding=37]="folding",j[j.foldingStrategy=38]="foldingStrategy",j[j.foldingHighlight=39]="foldingHighlight",j[j.foldingImportsByDefault=40]="foldingImportsByDefault",j[j.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=42]="fontFamily",j[j.fontInfo=43]="fontInfo",j[j.fontLigatures=44]="fontLigatures",j[j.fontSize=45]="fontSize",j[j.fontWeight=46]="fontWeight",j[j.formatOnPaste=47]="formatOnPaste",j[j.formatOnType=48]="formatOnType",j[j.glyphMargin=49]="glyphMargin",j[j.gotoLocation=50]="gotoLocation",j[j.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",j[j.hover=52]="hover",j[j.inDiffEditor=53]="inDiffEditor",j[j.inlineSuggest=54]="inlineSuggest",j[j.letterSpacing=55]="letterSpacing",j[j.lightbulb=56]="lightbulb",j[j.lineDecorationsWidth=57]="lineDecorationsWidth",j[j.lineHeight=58]="lineHeight",j[j.lineNumbers=59]="lineNumbers",j[j.lineNumbersMinChars=60]="lineNumbersMinChars",j[j.linkedEditing=61]="linkedEditing",j[j.links=62]="links",j[j.matchBrackets=63]="matchBrackets",j[j.minimap=64]="minimap",j[j.mouseStyle=65]="mouseStyle",j[j.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=67]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",j[j.multiCursorModifier=69]="multiCursorModifier",j[j.multiCursorPaste=70]="multiCursorPaste",j[j.occurrencesHighlight=71]="occurrencesHighlight",j[j.overviewRulerBorder=72]="overviewRulerBorder",j[j.overviewRulerLanes=73]="overviewRulerLanes",j[j.padding=74]="padding",j[j.parameterHints=75]="parameterHints",j[j.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",j[j.quickSuggestions=78]="quickSuggestions",j[j.quickSuggestionsDelay=79]="quickSuggestionsDelay",j[j.readOnly=80]="readOnly",j[j.renameOnType=81]="renameOnType",j[j.renderControlCharacters=82]="renderControlCharacters",j[j.renderFinalNewline=83]="renderFinalNewline",j[j.renderLineHighlight=84]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=86]="renderValidationDecorations",j[j.renderWhitespace=87]="renderWhitespace",j[j.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",j[j.roundedSelection=89]="roundedSelection",j[j.rulers=90]="rulers",j[j.scrollbar=91]="scrollbar",j[j.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=93]="scrollBeyondLastLine",j[j.scrollPredominantAxis=94]="scrollPredominantAxis",j[j.selectionClipboard=95]="selectionClipboard",j[j.selectionHighlight=96]="selectionHighlight",j[j.selectOnLineNumbers=97]="selectOnLineNumbers",j[j.showFoldingControls=98]="showFoldingControls",j[j.showUnused=99]="showUnused",j[j.snippetSuggestions=100]="snippetSuggestions",j[j.smartSelect=101]="smartSelect",j[j.smoothScrolling=102]="smoothScrolling",j[j.stickyTabStops=103]="stickyTabStops",j[j.stopRenderingLineAfter=104]="stopRenderingLineAfter",j[j.suggest=105]="suggest",j[j.suggestFontSize=106]="suggestFontSize",j[j.suggestLineHeight=107]="suggestLineHeight",j[j.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",j[j.suggestSelection=109]="suggestSelection",j[j.tabCompletion=110]="tabCompletion",j[j.tabIndex=111]="tabIndex",j[j.unicodeHighlighting=112]="unicodeHighlighting",j[j.unusualLineTerminators=113]="unusualLineTerminators",j[j.useShadowDOM=114]="useShadowDOM",j[j.useTabStops=115]="useTabStops",j[j.wordSeparators=116]="wordSeparators",j[j.wordWrap=117]="wordWrap",j[j.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=120]="wordWrapColumn",j[j.wordWrapOverride1=121]="wordWrapOverride1",j[j.wordWrapOverride2=122]="wordWrapOverride2",j[j.wrappingIndent=123]="wrappingIndent",j[j.wrappingStrategy=124]="wrappingStrategy",j[j.showDeprecated=125]="showDeprecated",j[j.inlayHints=126]="inlayHints",j[j.editorClassName=127]="editorClassName",j[j.pixelRatio=128]="pixelRatio",j[j.tabFocusMode=129]="tabFocusMode",j[j.layoutInfo=130]="layoutInfo",j[j.wrappingInfo=131]="wrappingInfo"})(Rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(148,null)})),acceptSuggestionOnEnter:Oe(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(149,null),""],markdownDescription:s.localize(150,null)})),accessibilitySupport:Oe(new i),accessibilityPageSize:Oe(new y(3,"accessibilityPageSize",10,1,1073741824,{description:s.localize(151,null)})),ariaLabel:Oe(new d(4,"ariaLabel",s.localize(152,null))),autoClosingBrackets:Oe(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(153,null),s.localize(154,null),""],description:s.localize(155,null)})),autoClosingDelete:Oe(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(156,null),""],description:s.localize(157,null)})),autoClosingOvertype:Oe(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(158,null),""],description:s.localize(159,null)})),autoClosingQuotes:Oe(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(160,null),s.localize(161,null),""],description:s.localize(162,null)})),autoIndent:Oe(new M(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[s.localize(163,null),s.localize(164,null),s.localize(165,null),s.localize(166,null),s.localize(167,null)],description:s.localize(168,null)})),automaticLayout:Oe(new u(10,"automaticLayout",!1)),autoSurround:Oe(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(169,null),s.localize(170,null),s.localize(171,null),""],description:s.localize(172,null)})),bracketPairColorization:Oe(new ee),bracketPairGuides:Oe(new he),stickyTabStops:Oe(new u(103,"stickyTabStops",!1,{description:s.localize(173,null)})),codeLens:Oe(new u(14,"codeLens",!0,{description:s.localize(174,null)})),codeLensFontFamily:Oe(new d(15,"codeLensFontFamily","",{description:s.localize(175,null)})),codeLensFontSize:Oe(new y(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(176,null)})),colorDecorators:Oe(new u(17,"colorDecorators",!0,{description:s.localize(177,null)})),columnSelection:Oe(new u(18,"columnSelection",!1,{description:s.localize(178,null)})),comments:Oe(new p),contextmenu:Oe(new u(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new u(21,"copyWithSyntaxHighlighting",!0,{description:s.localize(179,null)})),cursorBlinking:Oe(new M(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:s.localize(180,null)})),cursorSmoothCaretAnimation:Oe(new u(23,"cursorSmoothCaretAnimation",!1,{description:s.localize(181,null)})),cursorStyle:Oe(new M(24,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],a,{description:s.localize(182,null)})),cursorSurroundingLines:Oe(new y(25,"cursorSurroundingLines",0,0,1073741824,{description:s.localize(183,null)})),cursorSurroundingLinesStyle:Oe(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(184,null),s.localize(185,null)],description:s.localize(186,null)})),cursorWidth:Oe(new y(27,"cursorWidth",0,0,1073741824,{markdownDescription:s.localize(187,null)})),disableLayerHinting:Oe(new u(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new u(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new u(30,"domReadOnly",!1)),dragAndDrop:Oe(new u(31,"dragAndDrop",!0,{description:s.localize(188,null)})),emptySelectionClipboard:Oe(new P),extraEditorClassName:Oe(new d(33,"extraEditorClassName","")),fastScrollSensitivity:Oe(new f(34,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:s.localize(189,null)})),find:Oe(new N),fixedOverflowWidgets:Oe(new u(36,"fixedOverflowWidgets",!1)),folding:Oe(new u(37,"folding",!0,{description:s.localize(190,null)})),foldingStrategy:Oe(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(191,null),s.localize(192,null)],description:s.localize(193,null)})),foldingHighlight:Oe(new u(39,"foldingHighlight",!0,{description:s.localize(194,null)})),foldingImportsByDefault:Oe(new u(40,"foldingImportsByDefault",!1,{description:s.localize(195,null)})),unfoldOnClickAfterEndOfLine:Oe(new u(41,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(196,null)})),fontFamily:Oe(new d(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(197,null)})),fontInfo:Oe(new _),fontLigatures2:Oe(new B),fontSize:Oe(new O),fontWeight:Oe(new z),formatOnPaste:Oe(new u(47,"formatOnPaste",!1,{description:s.localize(198,null)})),formatOnType:Oe(new u(48,"formatOnType",!1,{description:s.localize(199,null)})),glyphMargin:Oe(new u(49,"glyphMargin",!0,{description:s.localize(200,null)})),gotoLocation:Oe(new U),hideCursorInOverviewRuler:Oe(new u(51,"hideCursorInOverviewRuler",!1,{description:s.localize(201,null)})),hover:Oe(new $),inDiffEditor:Oe(new u(53,"inDiffEditor",!1)),letterSpacing:Oe(new f(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>f.clamp(j,-5,20),{description:s.localize(202,null)})),lightbulb:Oe(new K),lineDecorationsWidth:Oe(new o(57,"lineDecorationsWidth",10)),lineHeight:Oe(new pe),lineNumbers:Oe(new Ve),lineNumbersMinChars:Oe(new y(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new u(61,"linkedEditing",!1,{description:s.localize(203,null)})),links:Oe(new u(62,"links",!0,{description:s.localize(204,null)})),matchBrackets:Oe(new l(63,"matchBrackets","always",["always","near","never"],{description:s.localize(205,null)})),minimap:Oe(new be),mouseStyle:Oe(new l(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new f(66,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:s.localize(206,null)})),mouseWheelZoom:Oe(new u(67,"mouseWheelZoom",!1,{markdownDescription:s.localize(207,null)})),multiCursorMergeOverlapping:Oe(new u(68,"multiCursorMergeOverlapping",!0,{description:s.localize(208,null)})),multiCursorModifier:Oe(new M(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ae,{markdownEnumDescriptions:[s.localize(209,null),s.localize(210,null)],markdownDescription:s.localize(211,null)})),multiCursorPaste:Oe(new l(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(212,null),s.localize(213,null)],markdownDescription:s.localize(214,null)})),occurrencesHighlight:Oe(new u(71,"occurrencesHighlight",!0,{description:s.localize(215,null)})),overviewRulerBorder:Oe(new u(72,"overviewRulerBorder",!0,{description:s.localize(216,null)})),overviewRulerLanes:Oe(new y(73,"overviewRulerLanes",3,0,3)),padding:Oe(new le),parameterHints:Oe(new Ce),peekWidgetDefaultFocus:Oe(new l(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(217,null),s.localize(218,null)],description:s.localize(219,null)})),definitionLinkOpensInPeek:Oe(new u(77,"definitionLinkOpensInPeek",!1,{description:s.localize(220,null)})),quickSuggestions:Oe(new Fe),quickSuggestionsDelay:Oe(new y(79,"quickSuggestionsDelay",10,0,1073741824,{description:s.localize(221,null)})),readOnly:Oe(new u(80,"readOnly",!1)),renameOnType:Oe(new u(81,"renameOnType",!1,{description:s.localize(222,null),markdownDeprecationMessage:s.localize(223,null)})),renderControlCharacters:Oe(new u(82,"renderControlCharacters",!0,{description:s.localize(224,null),restricted:!0})),renderFinalNewline:Oe(new u(83,"renderFinalNewline",!0,{description:s.localize(225,null)})),renderLineHighlight:Oe(new l(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(226,null)],description:s.localize(227,null)})),renderLineHighlightOnlyWhenFocus:Oe(new u(85,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(228,null)})),renderValidationDecorations:Oe(new l(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new l(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(229,null),s.localize(230,null),s.localize(231,null),""],description:s.localize(232,null)})),revealHorizontalRightPadding:Oe(new y(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Oe(new u(89,"roundedSelection",!0,{description:s.localize(233,null)})),rulers:Oe(new H),scrollbar:Oe(new X),scrollBeyondLastColumn:Oe(new y(92,"scrollBeyondLastColumn",5,0,1073741824,{description:s.localize(234,null)})),scrollBeyondLastLine:Oe(new u(93,"scrollBeyondLastLine",!0,{description:s.localize(235,null)})),scrollPredominantAxis:Oe(new u(94,"scrollPredominantAxis",!0,{description:s.localize(236,null)})),selectionClipboard:Oe(new u(95,"selectionClipboard",!0,{description:s.localize(237,null),included:t.isLinux})),selectionHighlight:Oe(new u(96,"selectionHighlight",!0,{description:s.localize(238,null)})),selectOnLineNumbers:Oe(new u(97,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new l(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[s.localize(239,null),s.localize(240,null)],description:s.localize(241,null)})),showUnused:Oe(new u(99,"showUnused",!0,{description:s.localize(242,null)})),showDeprecated:Oe(new u(125,"showDeprecated",!0,{description:s.localize(243,null)})),inlayHints:Oe(new re),snippetSuggestions:Oe(new l(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(244,null),s.localize(245,null),s.localize(246,null),s.localize(247,null)],description:s.localize(248,null)})),smartSelect:Oe(new ze),smoothScrolling:Oe(new u(102,"smoothScrolling",!1,{description:s.localize(249,null)})),stopRenderingLineAfter:Oe(new y(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new Ue),inlineSuggest:Oe(new q),suggestFontSize:Oe(new y(106,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(250,null)})),suggestLineHeight:Oe(new y(107,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(251,null)})),suggestOnTriggerCharacters:Oe(new u(108,"suggestOnTriggerCharacters",!0,{description:s.localize(252,null)})),suggestSelection:Oe(new l(109,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(253,null),s.localize(254,null),s.localize(255,null)],description:s.localize(256,null)})),tabCompletion:Oe(new l(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null)],description:s.localize(260,null)})),tabIndex:Oe(new y(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new oe),unusualLineTerminators:Oe(new l(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(261,null),s.localize(262,null),s.localize(263,null)],description:s.localize(264,null)})),useShadowDOM:Oe(new u(114,"useShadowDOM",!0)),useTabStops:Oe(new u(115,"useTabStops",!0,{description:s.localize(265,null)})),wordSeparators:Oe(new d(116,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:s.localize(266,null)})),wordWrap:Oe(new l(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(267,null),s.localize(268,null),s.localize(269,null),s.localize(270,null)],description:s.localize(271,null)})),wordWrapBreakAfterCharacters:Oe(new d(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new d(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new y(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:s.localize(272,null)})),wordWrapOverride1:Oe(new l(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new l(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new M(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],st,{enumDescriptions:[s.localize(273,null),s.localize(274,null),s.localize(275,null),s.localize(276,null)],description:s.localize(277,null)})),wrappingStrategy:Oe(new l(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[s.localize(278,null),s.localize(279,null)],description:s.localize(280,null)})),editorClassName:Oe(new S),pixelRatio:Oe(new Ee),tabFocusMode:Oe(new Qe),layoutInfo:Oe(new ue),wrappingInfo:Oe(new Xe)}}),define(ye[114],_e([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[115],_e([18,19]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[116],_e([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ye[117],_e([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(ye[118],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[119],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[120],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[121],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[122],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[123],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[124],_e([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[125],_e([18,19]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(ye[126],_e([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[127],_e([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ye[128],_e([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ye[129],_e([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[130],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var s;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(s=e.EditorActivation||(e.EditorActivation={}));var t;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var E;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ye[131],_e([0,1,115]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function T(n){return n=n.trim(),n==="*"||t.test(n)}e.isValidVersionStr=T;function k(n){if(!T(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=n.match(t);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=k;function I(n){if(!n)return null;let g=n.majorBase,o=n.majorMustEqual,c=n.minorBase,u=n.minorMustEqual,F=n.patchBase,y=n.patchMustEqual;n.hasCaret&&(g===0||(u=!1),y=!1);let f=0;if(n.preRelease){const d=E.exec(n.preRelease);if(d){const[,D,l,M]=d;f=Date.UTC(Number(D),Number(l)-1,Number(M))}}return{majorBase:g,majorMustEqual:o,minorBase:c,minorMustEqual:u,patchBase:F,patchMustEqual:y,isMinimum:n.hasGreaterEquals,notBefore:f}}e.normalizeVersion=I;function C(n,g,o){let c;typeof n=="string"?c=I(k(n)):c=n;let u;g instanceof Date?u=g.getTime():typeof g=="string"&&(u=new Date(g).getTime());let F;if(typeof o=="string"?F=I(k(o)):F=o,!c||!F)return!1;let y=c.majorBase,f=c.minorBase,d=c.patchBase,D=F.majorBase,l=F.minorBase,M=F.patchBase,r=F.notBefore,i=F.majorMustEqual,p=F.minorMustEqual,m=F.patchMustEqual;return F.isMinimum?y>D?!0:y<D?!1:f>l?!0:f<l||u&&u<r?!1:d>=M:(y===1&&D===0&&(!i||!p||!m)&&(D=1,l=0,M=0,i=!0,p=!1,m=!1),y<D?!1:y>D?!i:f<l?!1:f>l?!p:d<M?!1:d>M?!m:!(u&&u<r))}e.isValidVersion=C;function A(n,g,o,c){return o.isBuiltin||typeof o.main=="undefined"?!0:b(n,g,o.engines.vscode,c)}e.isValidExtensionVersion=A;function R(n,g,o){return n==="*"||b(g,o,n)}e.isEngineValid=R;function b(n,g,o,c=[]){let u=I(k(o));if(!u)return c.push(s.localize(0,null,o)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(s.localize(1,null,o)),!1}else if(!u.majorMustEqual)return c.push(s.localize(2,null,o)),!1;return C(n,g,u)?!0:(c.push(s.localize(3,null,n,o)),!1)}}),define(ye[80],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(E,T=[],k=!1){this.ctor=E,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=s}),define(ye[44],_e([0,1,80]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function E(k,I,C){I instanceof s.SyncDescriptor||(I=new s.SyncDescriptor(I,[],C)),t.push([k,I])}e.registerSingleton=E;function T(){return t}e.getSingletonServiceDescriptors=T}),define(ye[132],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=s;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const I=this.lookupOrInsertNode(T),C=this.lookupOrInsertNode(k);I.outgoing.set(this._hashFn(k),C),C.incoming.set(this._hashFn(T),I)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let I of this._nodes.values())I.outgoing.delete(k),I.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let I=this._nodes.get(k);return I||(I=new s(T),this._nodes.set(k,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,I]of this._nodes)T.push(`${k}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const I=new Set([T]),C=this._findCycle(k,I);if(C)return C}}_findCycle(T,k){for(let[I,C]of T.outgoing){if(k.has(I))return[...k,I].join(" -> ");k.add(I);const A=this._findCycle(C,k);if(A)return A;k.delete(I)}}}e.Graph=t}),define(ye[3],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var s;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function I(C){return C[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=I})(s=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function t(k,I,C,A){I[s.DI_TARGET]===I?I[s.DI_DEPENDENCIES].push({id:k,index:C,optional:A}):(I[s.DI_DEPENDENCIES]=[{id:k,index:C,optional:A}],I[s.DI_TARGET]=I)}function E(k){if(s.serviceIds.has(k))return s.serviceIds.get(k);const I=function(C,A,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,C,R,!1)};return I.toString=()=>k,s.serviceIds.set(k,I),I}e.createDecorator=E;function T(k){return k}e.refineServiceDecorator=T}),define(ye[133],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,s.createDecorator)("modelService");function t(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(ye[134],_e([0,1,4,57,6,21,75,56,133]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(A):!!c.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new s.Emitter}get onDidChange(){return this._onDidChange.event}register(u,F){let y={selector:u,provider:F,_score:-1,_time:this._clock++};return this._entries.push(y),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(y){const f=this._entries.indexOf(y);f>=0&&(this._entries.splice(f,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),y=void 0)}})}has(u){return this.all(u).length>0}all(u){if(!u)return[];this._updateScores(u);const F=[];for(let y of this._entries)y._score>0&&F.push(y.provider);return F}ordered(u){const F=[];return this._orderedForEach(u,y=>F.push(y.provider)),F}orderedGroups(u){const F=[];let y,f;return this._orderedForEach(u,d=>{y&&f===d._score?y.push(d.provider):(f=d._score,y=[d.provider],F.push(y))}),F}_orderedForEach(u,F){if(!!u){this._updateScores(u);for(const y of this._entries)y._score>0&&F(y)}}_updateScores(u){const F={uri:u.uri.toString(),language:u.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===F.language&&this._lastCandidate.uri===F.uri)){this._lastCandidate=F;for(let y of this._entries)if(y._score=(0,I.score)(y.selector,u.uri,u.getLanguageId(),(0,C.shouldSynchronizeModel)(u)),A(y.selector)&&y._score>0){for(let f of this._entries)f._score=0;y._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(u,F){return u._score<F._score?1:u._score>F._score?-1:u._time<F._time?1:u._time>F._time?-1:0}}e.LanguageFeatureRegistry=R;const b=new WeakMap;let n=0;function g(c){let u=b.get(c);return u===void 0&&(u=++n,b.set(c,u)),u}class o{constructor(u,F,y=Number.MAX_SAFE_INTEGER){this._registry=u,this.min=F,this.max=y,this._cache=new T.LRUCache(50,.7)}_key(u){return u.id+this._registry.all(u).reduce((F,y)=>(0,t.doHash)(g(y),F),0)}_clamp(u){return u===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(u*1.3)))}get(u){const F=this._key(u),y=this._cache.get(F);return this._clamp(y?.value)}update(u,F){const y=this._key(u);let f=this._cache.get(y);return f||(f=new k.MovingAverage,this._cache.set(y,f)),f.update(F),this.get(u)}}e.LanguageFeatureRequestDelays=o}),define(ye[58],_e([0,1,2,59,134,107,52]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(C=e.FontStyle||(e.FontStyle={}));var A;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var R;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=1024]="ITALIC_MASK",a[a.BOLD_MASK=2048]="BOLD_MASK",a[a.UNDERLINE_MASK=4096]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&768)>>>8}static getFontStyle(S){return(S&15360)>>>10}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){const P=this.getForeground(S);let N="mtk"+P;const B=this.getFontStyle(S);return B&1&&(N+=" mtki"),B&2&&(N+=" mtkb"),B&4&&(N+=" mtku"),B&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(S,P){const N=this.getForeground(S),B=this.getFontStyle(S);let _=`color: ${P[N]};`;B&1&&(_+="font-style: italic;"),B&2&&(_+="font-weight: bold;");let O="";return B&4&&(O+=" underline"),B&8&&(O+=" line-through"),O&&(_+=`text-decoration:${O};`),_}}e.TokenMetadata=n;var g;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(g=e.CompletionItemKind||(e.CompletionItemKind={}));var o;(function(a){const S=new Map;S.set(0,k.Codicon.symbolMethod),S.set(1,k.Codicon.symbolFunction),S.set(2,k.Codicon.symbolConstructor),S.set(3,k.Codicon.symbolField),S.set(4,k.Codicon.symbolVariable),S.set(5,k.Codicon.symbolClass),S.set(6,k.Codicon.symbolStruct),S.set(7,k.Codicon.symbolInterface),S.set(8,k.Codicon.symbolModule),S.set(9,k.Codicon.symbolProperty),S.set(10,k.Codicon.symbolEvent),S.set(11,k.Codicon.symbolOperator),S.set(12,k.Codicon.symbolUnit),S.set(13,k.Codicon.symbolValue),S.set(15,k.Codicon.symbolEnum),S.set(14,k.Codicon.symbolConstant),S.set(15,k.Codicon.symbolEnum),S.set(16,k.Codicon.symbolEnumMember),S.set(17,k.Codicon.symbolKeyword),S.set(27,k.Codicon.symbolSnippet),S.set(18,k.Codicon.symbolText),S.set(19,k.Codicon.symbolColor),S.set(20,k.Codicon.symbolFile),S.set(21,k.Codicon.symbolReference),S.set(22,k.Codicon.symbolCustomColor),S.set(23,k.Codicon.symbolFolder),S.set(24,k.Codicon.symbolTypeParameter),S.set(25,k.Codicon.account),S.set(26,k.Codicon.issues);function P(_){let O=S.get(_);return O||(console.info("No codicon found for CompletionItemKind "+_),O=k.Codicon.symbolProperty),O}a.toIcon=P;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function B(_,O){let z=N.get(_);return typeof z=="undefined"&&!O&&(z=9),z}a.fromString=B})(o=e.CompletionItemKinds||(e.CompletionItemKinds={}));var c;(function(a){a[a.Deprecated=1]="Deprecated"})(c=e.CompletionItemTag||(e.CompletionItemTag={}));var u;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(u=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var F;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(F=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var D;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(a){return a&&s.URI.isUri(a.uri)&&t.Range.isIRange(a.range)&&(t.Range.isIRange(a.originSelectionRange)||t.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=l;var M;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(M=e.SymbolKind||(e.SymbolKind={}));var r;(function(a){a[a.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(a){const S=new Map;S.set(0,k.Codicon.symbolFile),S.set(1,k.Codicon.symbolModule),S.set(2,k.Codicon.symbolNamespace),S.set(3,k.Codicon.symbolPackage),S.set(4,k.Codicon.symbolClass),S.set(5,k.Codicon.symbolMethod),S.set(6,k.Codicon.symbolProperty),S.set(7,k.Codicon.symbolField),S.set(8,k.Codicon.symbolConstructor),S.set(9,k.Codicon.symbolEnum),S.set(10,k.Codicon.symbolInterface),S.set(11,k.Codicon.symbolFunction),S.set(12,k.Codicon.symbolVariable),S.set(13,k.Codicon.symbolConstant),S.set(14,k.Codicon.symbolString),S.set(15,k.Codicon.symbolNumber),S.set(16,k.Codicon.symbolBoolean),S.set(17,k.Codicon.symbolArray),S.set(18,k.Codicon.symbolObject),S.set(19,k.Codicon.symbolKey),S.set(20,k.Codicon.symbolNull),S.set(21,k.Codicon.symbolEnumMember),S.set(22,k.Codicon.symbolStruct),S.set(23,k.Codicon.symbolEvent),S.set(24,k.Codicon.symbolOperator),S.set(25,k.Codicon.symbolTypeParameter);function P(N){let B=S.get(N);return B||(console.info("No codicon found for SymbolKind "+N),B=k.Codicon.symbolProperty),B}a.toIcon=P})(i=e.SymbolKinds||(e.SymbolKinds={}));class p{constructor(S){this.value=S}}e.FoldingRangeKind=p,p.Comment=new p("comment"),p.Imports=new p("imports"),p.Region=new p("region");var m;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(m=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var w;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistry;var v;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[81],_e([0,1,10,2,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=T;function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||s.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var I;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function A(u,F){const y=Object.create(null);for(let f in u)R(y,f,u[f],F);return y}e.toValuesTree=A;function R(u,F,y,f){const d=F.split("."),D=d.pop();let l=u;for(let M=0;M<d.length;M++){let r=d[M],i=l[r];switch(typeof i){case"undefined":i=l[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${F} as ${d.slice(0,M+1).join(".")} is ${JSON.stringify(i)}`);return}l=i}if(typeof l=="object"&&l!==null)try{l[D]=y}catch{f(`Ignoring ${F} as ${d.join(".")} is ${JSON.stringify(l)}`)}else f(`Ignoring ${F} as ${d.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=R;function b(u,F){const y=F.split(".");n(u,y)}e.removeFromValueTree=b;function n(u,F){const y=F.shift();if(F.length===0){delete u[y];return}if(Object.keys(u).indexOf(y)!==-1){const f=u[y];typeof f=="object"&&!Array.isArray(f)&&(n(f,F),Object.keys(f).length===0&&delete u[y])}}function g(u,F,y){function f(l,M){let r=l;for(const i of M){if(typeof r!="object"||r===null)return;r=r[i]}return r}const d=F.split("."),D=f(u,d);return typeof D=="undefined"?y:D}e.getConfigurationValue=g;function o(u,F,y){Object.keys(F).forEach(f=>{f!=="__proto__"&&(f in u?s.isObject(u[f])&&s.isObject(F[f])?o(u[f],F[f],y):y&&(u[f]=F[f]):u[f]=F[f])})}e.merge=o;function c(u,F,y){const f=u.inspect(F),d=u.inspect(y);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:f.defaultValue}e.getMigratedSettingValue=c}),define(ye[45],_e([0,1,23,9,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=s.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",s.isMacintosh),k.set("isLinux",s.isLinux),k.set("isWindows",s.isWindows),k.set("isWeb",s.isWeb),k.set("isMacNative",s.isMacintosh&&!s.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var C;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return n.INSTANCE}static true(){return g.INSTANCE}static has(_){return o.create(_)}static equals(_,O){return c.create(_,O)}static notEquals(_,O){return y.create(_,O)}static regex(_,O){return i.create(_,O)}static in(_,O){return u.create(_,O)}static not(_){return f.create(_)}static and(..._){return h.create(_,null)}static or(..._){return w.create(_,null,!0)}static greater(_,O){return D.create(_,O)}static greaterEquals(_,O){return l.create(_,O)}static smaller(_,O){return M.create(_,O)}static smallerEquals(_,O){return r.create(_,O)}static deserialize(_,O=!1){if(!!_)return this._deserializeOrExpression(_,O)}static _deserializeOrExpression(_,O){let z=_.split("||");return w.create(z.map(U=>this._deserializeAndExpression(U,O)),null,!0)}static _deserializeAndExpression(_,O){let z=_.split("&&");return h.create(z.map(U=>this._deserializeOne(U,O)),null)}static _deserializeOne(_,O){if(_=_.trim(),_.indexOf("!=")>=0){let z=_.split("!=");return y.create(z[0].trim(),this._deserializeValue(z[1],O))}if(_.indexOf("==")>=0){let z=_.split("==");return c.create(z[0].trim(),this._deserializeValue(z[1],O))}if(_.indexOf("=~")>=0){let z=_.split("=~");return i.create(z[0].trim(),this._deserializeRegexValue(z[1],O))}if(_.indexOf(" in ")>=0){let z=_.split(" in ");return u.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const z=_.split(">=");return l.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const z=_.split(">");return D.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const z=_.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const z=_.split("<");return M.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(_)?f.create(_.substr(1).trim()):o.create(_)}static _deserializeValue(_,O){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let z=/^'([^']*)'$/.exec(_);return z?z[1].trim():_}static _deserializeRegexValue(_,O){if((0,t.isFalsyOrWhitespace)(_)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=_.indexOf("/"),U=_.lastIndexOf("/");if(z===U||z<0){if(O)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let $=_.slice(z+1,U),V=_[U+1]==="i"?"i":"";try{return new RegExp($,V)}catch(ue){if(O)throw new Error(`bad regexp-value '${_}', parse error: ${ue}`);return console.warn(`bad regexp-value '${_}', parse error: ${ue}`),null}}}e.ContextKeyExpr=A;function R(B,_){const O=B?B.substituteConstants():void 0,z=_?_.substituteConstants():void 0;return!O&&!z?!0:!O||!z?!1:O.equals(z)}e.expressionsAreEqualWithConstantSubstitution=R;function b(B,_){return B.cmp(_)}class n{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class g{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class o{constructor(_,O){this.key=_,this.negated=O,this.type=2}static create(_,O=null){const z=k.get(_);return typeof z=="boolean"?z?g.INSTANCE:n.INSTANCE:new o(_,O)}cmp(_){return _.type!==this.type?this.type-_.type:a(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=k.get(this.key);return typeof _=="boolean"?_?g.INSTANCE:n.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class c{constructor(_,O,z){this.key=_,this.value=O,this.negated=z,this.type=4}static create(_,O,z=null){if(typeof O=="boolean")return O?o.create(_,z):f.create(_,z);const U=k.get(_);return typeof U=="boolean"?O===(U?"true":"false")?g.INSTANCE:n.INSTANCE:new c(_,O,z)}cmp(_){return _.type!==this.type?this.type-_.type:S(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=k.get(this.key);if(typeof _=="boolean"){const O=_?"true":"false";return this.value===O?g.INSTANCE:n.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class u{constructor(_,O){this.key=_,this.valueKey=O,this.type=10,this.negated=null}static create(_,O){return new u(_,O)}cmp(_){return _.type!==this.type?this.type-_.type:S(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const O=_.getValue(this.valueKey),z=_.getValue(this.key);return Array.isArray(O)?O.indexOf(z)>=0:typeof z=="string"&&typeof O=="object"&&O!==null?I.call(O,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=F.create(this)),this.negated}}e.ContextKeyInExpr=u;class F{constructor(_){this._actual=_,this.type=11}static create(_){return new F(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new F(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=F;class y{constructor(_,O,z){this.key=_,this.value=O,this.negated=z,this.type=5}static create(_,O,z=null){if(typeof O=="boolean")return O?f.create(_,z):o.create(_,z);const U=k.get(_);return typeof U=="boolean"?O===(U?"true":"false")?n.INSTANCE:g.INSTANCE:new y(_,O,z)}cmp(_){return _.type!==this.type?this.type-_.type:S(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=k.get(this.key);if(typeof _=="boolean"){const O=_?"true":"false";return this.value===O?n.INSTANCE:g.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class f{constructor(_,O){this.key=_,this.negated=O,this.type=3}static create(_,O=null){const z=k.get(_);return typeof z=="boolean"?z?n.INSTANCE:g.INSTANCE:new f(_,O)}cmp(_){return _.type!==this.type?this.type-_.type:a(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=k.get(this.key);return typeof _=="boolean"?_?n.INSTANCE:g.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function d(B,_){if(typeof B=="string"){const O=parseFloat(B);isNaN(O)||(B=O)}return typeof B=="string"||typeof B=="number"?_(B):n.INSTANCE}class D{constructor(_,O,z){this.key=_,this.value=O,this.negated=z,this.type=12}static create(_,O,z=null){return d(O,U=>new D(_,U,z))}cmp(_){return _.type!==this.type?this.type-_.type:S(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=D;class l{constructor(_,O,z){this.key=_,this.value=O,this.negated=z,this.type=13}static create(_,O,z=null){return d(O,U=>new l(_,U,z))}cmp(_){return _.type!==this.type?this.type-_.type:S(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class M{constructor(_,O,z){this.key=_,this.value=O,this.negated=z,this.type=14}static create(_,O,z=null){return d(O,U=>new M(_,U,z))}cmp(_){return _.type!==this.type?this.type-_.type:S(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class r{constructor(_,O,z){this.key=_,this.value=O,this.negated=z,this.type=15}static create(_,O,z=null){return d(O,U=>new r(_,U,z))}cmp(_){return _.type!==this.type?this.type-_.type:S(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(_,O){this.key=_,this.regexp=O,this.type=7,this.negated=null}static create(_,O){return new i(_,O)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const O=this.regexp?this.regexp.source:"",z=_.regexp?_.regexp.source:"";return O<z?-1:O>z?1:0}equals(_){if(_.type===this.type){const O=this.regexp?this.regexp.source:"",z=_.regexp?_.regexp.source:"";return this.key===_.key&&O===z}return!1}substituteConstants(){return this}evaluate(_){let O=_.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class p{constructor(_){this._actual=_,this.type=8}static create(_){return new p(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new p(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=p;function m(B){let _=null;for(let O=0,z=B.length;O<z;O++){const U=B[O].substituteConstants();if(B[O]!==U&&_===null){_=[];for(let $=0;$<O;$++)_[$]=B[$]}_!==null&&(_[O]=U)}return _===null?B:_}class h{constructor(_,O){this.expr=_,this.negated=O,this.type=6}static create(_,O){return h._normalizeArr(_,O)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const U=b(this.expr[O],_.expr[O]);if(U!==0)return U}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(_.expr[O]))return!1;return!0}return!1}substituteConstants(){const _=m(this.expr);return _===this.expr?this:h.create(_,this.negated)}evaluate(_){for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].evaluate(_))return!1;return!0}static _normalizeArr(_,O){const z=[];let U=!1;for(const $ of _)if(!!$){if($.type===1){U=!0;continue}if($.type===0)return n.INSTANCE;if($.type===6){z.push(...$.expr);continue}z.push($)}if(z.length===0&&U)return g.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(b);for(let $=1;$<z.length;$++)z[$-1].equals(z[$])&&(z.splice($,1),$--);if(z.length===1)return z[0];for(;z.length>1;){const $=z[z.length-1];if($.type!==9)break;z.pop();const V=z.pop(),ue=z.length===0,K=w.create($.expr.map(re=>h.create([re,V],null)),null,ue);K&&(z.push(K),z.sort(b))}return z.length===1?z[0]:new h(z,O)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let O of this.expr)_.push(...O.keys());return _}map(_){return new h(this.expr.map(O=>O.map(_)),null)}negate(){if(!this.negated){const _=[];for(let O of this.expr)_.push(O.negate());this.negated=w.create(_,this,!0)}return this.negated}}class w{constructor(_,O){this.expr=_,this.negated=O,this.type=9}static create(_,O,z){return w._normalizeArr(_,O,z)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const U=b(this.expr[O],_.expr[O]);if(U!==0)return U}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(_.expr[O]))return!1;return!0}return!1}substituteConstants(){const _=m(this.expr);return _===this.expr?this:w.create(_,this.negated,!1)}evaluate(_){for(let O=0,z=this.expr.length;O<z;O++)if(this.expr[O].evaluate(_))return!0;return!1}static _normalizeArr(_,O,z){let U=[],$=!1;if(_){for(let V=0,ue=_.length;V<ue;V++){const K=_[V];if(!!K){if(K.type===0){$=!0;continue}if(K.type===1)return g.INSTANCE;if(K.type===9){U=U.concat(K.expr);continue}U.push(K)}}if(U.length===0&&$)return n.INSTANCE;U.sort(b)}if(U.length!==0){if(U.length===1)return U[0];for(let V=1;V<U.length;V++)U[V-1].equals(U[V])&&(U.splice(V,1),V--);if(U.length===1)return U[0];if(z){for(let V=0;V<U.length;V++)for(let ue=V+1;ue<U.length;ue++)P(U[V],U[ue])&&(U.splice(ue,1),ue--);if(U.length===1)return U[0]}return new w(U,O)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let O of this.expr)_.push(...O.keys());return _}map(_){return new w(this.expr.map(O=>O.map(_)),null)}negate(){if(!this.negated){let _=[];for(let O of this.expr)_.push(O.negate());for(;_.length>1;){const O=_.shift(),z=_.shift(),U=[];for(const V of N(O))for(const ue of N(z))U.push(h.create([V,ue],null));const $=_.length===0;_.unshift(w.create(U,null,$))}this.negated=_[0]}return this.negated}}class v extends o{constructor(_,O,z){super(_,null);this._defaultValue=O,typeof z=="object"?v._info.push({...z,key:_}):z!==!0&&v._info.push({key:_,description:z,type:O!=null?typeof O:void 0})}static all(){return v._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return c.create(this.key,_)}notEqualsTo(_){return y.create(this.key,_)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function a(B,_){return B<_?-1:B>_?1:0}function S(B,_,O,z){return B<O?-1:B>O?1:_<z?-1:_>z?1:0}function P(B,_){if(_.type===6&&B.type!==9&&B.type!==6){for(const U of _.expr)if(B.equals(U))return!0}const O=B.negate(),z=N(O).concat(N(_));z.sort(b);for(let U=0;U<z.length;U++){const V=z[U].negate();for(let ue=U+1;ue<z.length;ue++){const K=z[ue];if(V.equals(K))return!0}}return!1}e.implies=P;function N(B){return B.type===9?B.expr:[B]}}),define(ye[135],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[46],_e([0,1,21,17,9,10,2,116,3]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function A(U){return U.create===!0}e.isFileOpenForWriteOptions=A;var R;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var b;(function(U){U[U.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var n;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=g;function o(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=o;function c(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function u(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=u;function F(U){return g(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=F;var y;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor($,V){super($);this.code=V}}e.FileSystemProviderError=f;function d(U,$){const V=new f(U.toString(),$);return l(V,$),V}e.createFileSystemProviderError=d;function D(U){return U||d((0,I.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=D;function l(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=l;function M(U){if(!U)return y.Unknown;if(U instanceof f)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return y.Unknown;switch($[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=M;function r(U){if(U instanceof v)return U.fileOperationResult;switch(M(U)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class p{constructor($,V,ue){this.resource=$,this.operation=V,this.target=ue}isOperation($){return this.operation===$}}e.FileOperationEvent=p;var m;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class h{constructor($,V){this.added=void 0,this.updated=void 0,this.deleted=void 0;const ue=new Map;for(const K of $){const re=ue.get(K.type);re?re.push([K.resource,K]):ue.set(K.type,[[K.resource,K]])}for(const[K,re]of ue)switch(K){case 1:this.added=s.TernarySearchTree.forUris(()=>V),this.added.fill(re);break;case 0:this.updated=s.TernarySearchTree.forUris(()=>V),this.updated.fill(re);break;case 2:this.deleted=s.TernarySearchTree.forUris(()=>V),this.deleted.fill(re);break}}contains($,...V){return this.doContains($,{includeChildren:!1},...V)}affects($,...V){return this.doContains($,{includeChildren:!0},...V)}doContains($,V,...ue){if(!$)return!1;const K=ue.length>0;return!!((!K||ue.includes(1))&&(this.added?.get($)||V.includeChildren&&this.added?.findSuperstr($))||(!K||ue.includes(0))&&(this.updated?.get($)||V.includeChildren&&this.updated?.findSuperstr($))||(!K||ue.includes(2))&&(this.deleted?.findSubstr($)||V.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function w(U,$,V){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),V?(0,E.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=w;class v extends Error{constructor($,V,ue){super($);this.fileOperationResult=V,this.options=ue}}e.FileOperationError=v;class a extends v{constructor($,V,ue){super($,2,ue);this.stat=V}}e.NotModifiedSinceFileOperationError=a;var S;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=N;async function B(U,$){if(!$.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(V=>{const ue=$.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===U.scheme&&K.added&&(ue.dispose(),V())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize($){return(0,T.isNumber)($)||($=0),$<_.KB?(0,I.localize)(1,null,$.toFixed(0)):$<_.MB?(0,I.localize)(2,null,($/_.KB).toFixed(2)):$<_.GB?(0,I.localize)(3,null,($/_.MB).toFixed(2)):$<_.TB?(0,I.localize)(4,null,($/_.GB).toFixed(2)):(0,I.localize)(5,null,($/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var O;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*_.MB:16*_.GB,maxHeapSize:U===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=z}),define(ye[60],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...E){this._entries=new Map;for(let[T,k]of E)this.set(T,k)}set(E,T){const k=this._entries.get(E);return this._entries.set(E,T),k}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=s}),define(ye[136],_e([0,1,14,15,80,132,3,60]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class A extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class R{constructor(o=new I.ServiceCollection,c=!1,u){this._activeInstantiations=new Set,this._services=o,this._strict=c,this._parent=u,this._services.set(k.IInstantiationService,this)}createChild(o){return new R(o,this._strict,this)}invokeFunction(o,...c){let u=n.traceInvocation(o),F=!1;try{return o({get:f=>{if(F)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(f,u);if(!d)throw new Error(`[invokeFunction] unknown service '${f}'`);return d}},...c)}finally{F=!0,u.stop()}}createInstance(o,...c){let u,F;return o instanceof E.SyncDescriptor?(u=n.traceCreation(o.ctor),F=this._createInstance(o.ctor,o.staticArguments.concat(c),u)):(u=n.traceCreation(o),F=this._createInstance(o,c,u)),u.stop(),F}_createInstance(o,c=[],u){let F=k._util.getServiceDependencies(o).sort((d,D)=>d.index-D.index),y=[];for(const d of F){let D=this._getOrCreateServiceInstance(d.id,u);if(!D&&this._strict&&!d.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${d.id}.`);y.push(D)}let f=F.length>0?F[0].index:c.length;if(c.length!==f){console.warn(`[createInstance] First service dependency of ${o.name} at position ${f+1} conflicts with ${c.length} static arguments`);let d=f-c.length;d>0?c=c.concat(new Array(d)):c=c.slice(0,f)}return new o(...[...c,...y])}_setServiceInstance(o,c){if(this._services.get(o)instanceof E.SyncDescriptor)this._services.set(o,c);else if(this._parent)this._parent._setServiceInstance(o,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let c=this._services.get(o);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):c}_getOrCreateServiceInstance(o,c){let u=this._getServiceInstanceOrDescriptor(o);return u instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,u,c.branch(o,!0)):(c.branch(o,!1),u)}_safeCreateAndCacheServiceInstance(o,c,u){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,c,u)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,c,u){const F=new T.Graph(d=>d.id.toString());let y=0;const f=[{id:o,desc:c,_trace:u}];for(;f.length;){const d=f.pop();if(F.lookupOrInsertNode(d),y++>1e3)throw new A(F);for(let D of k._util.getServiceDependencies(d.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(D.id);if(!l&&!D.optional&&console.warn(`[createInstance] ${o} depends on ${D.id} which is NOT registered.`),l instanceof E.SyncDescriptor){const M={id:D.id,desc:l,_trace:d._trace.branch(D.id,!0)};F.insertEdge(d,M),f.push(M)}}}for(;;){const d=F.roots();if(d.length===0){if(!F.isEmpty())throw new A(F);break}for(const{data:D}of d){if(this._getServiceInstanceOrDescriptor(D.id)instanceof E.SyncDescriptor){const M=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,M)}F.removeNode(D)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,c,u=[],F,y){if(this._services.get(o)instanceof E.SyncDescriptor)return this._createServiceInstance(c,u,F,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,c,u,F,y);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(o,c=[],u,F){if(u){const y=new s.IdleValue(()=>this._createInstance(o,c,F));return new Proxy(Object.create(null),{get(f,d){if(d in f)return f[d];let D=y.value,l=D[d];return typeof l!="function"||(l=l.bind(D),f[d]=l),l},set(f,d,D){return y.value[d]=D,!0}})}else return this._createInstance(o,c,F)}}e.InstantiationService=R;var b;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(b||(b={}));class n{constructor(o,c){this.type=o,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return C?new n(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(o){return C?new n(0,o.name):n._None}branch(o,c){let u=new n(2,o.toString());return this._dep.push([o,c,u]),u}stop(){let o=Date.now()-this._start;n._totals+=o;let c=!1;function u(y,f){let d=[],D=new Array(y+1).join("	");for(const[l,M,r]of f._dep)if(M&&r){c=!0,d.push(`${D}CREATES -> ${l}`);let i=u(y+1,r);i&&d.push(i)}else d.push(`${D}uses -> ${l}`);return d.join(`
`)}let F=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(o>2||c)&&console.log(F.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(ye[12],_e([0,1,43,4,6,23,3]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function I(){return new Date().toISOString()}var C;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function A(M,r,i){switch(r){case C.Trace:M.trace(i);break;case C.Debug:M.debug(i);break;case C.Info:M.info(i);break;case C.Warning:M.warn(i);break;case C.Error:M.error(i);break;case C.Critical:M.critical(i);break;default:throw new Error("Invalid log level")}}e.log=A;function R(M){let r="";for(let i=0;i<M.length;i++){let p=M[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}r+=(i>0?" ":"")+p}return r}e.format=R;class b extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class n extends b{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,R([r,...i]))}debug(r,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,R([r,...i]))}info(r,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,R([r,...i]))}warn(r,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,R([r,...i]))}error(r,...i){if(this.checkLogLevel(C.Error))if(r instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=r.stack,this.log(C.Error,R(p))}else this.log(C.Error,R([r,...i]))}critical(r,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,R([r,...i]))}flush(){}}e.AbstractMessageLogger=n;class g extends b{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}debug(r,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}info(r,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}warn(r,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,r,...i):console.warn(`[main ${I()}]`,r,...i))}error(r,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}critical(r,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class o extends b{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class c extends b{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,s.toErrorMessage)(r,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class u extends b{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const p of this.logServices)p.trace(r,...i)}debug(r,...i){for(const p of this.logServices)p.debug(r,...i)}info(r,...i){for(const p of this.logServices)p.info(r,...i)}warn(r,...i){for(const p of this.logServices)p.warn(r,...i)}error(r,...i){for(const p of this.logServices)p.error(r,...i)}critical(r,...i){for(const p of this.logServices)p.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=u;class F extends E.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=F;class y extends E.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(p=>{this.logLevel=p,this.logLevelChangeableLoggers.forEach(m=>m.setLevel(p))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let p=this.loggers.get(r.toString());return p||(p=this.doCreateLogger(r,i?.always?C.Trace:this.logLevel,i),this.loggers.set(r.toString(),p),i?.always||this.logLevelChangeableLoggers.push(p)),p}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return C.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=f;function d(M){if(M.verbose)return C.Trace;if(typeof M.logLevel=="string"){const r=D(M.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function D(M){switch(M){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=D;function l(M){switch(M){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=l}),define(ye[82],_e([0,1,34,117,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var k;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function A(o,c){return c-o}C.compare=A;const R=Object.create(null);R[C.Error]=(0,t.localize)(0,null),R[C.Warning]=(0,t.localize)(1,null),R[C.Info]=(0,t.localize)(2,null);function b(o){return R[o]||""}C.toString=b;function n(o){switch(o){case s.default.Error:return C.Error;case s.default.Warning:return C.Warning;case s.default.Info:return C.Info;case s.default.Ignore:return C.Hint}}C.fromSeverity=n;function g(o){switch(o){case C.Error:return s.default.Error;case C.Warning:return s.default.Warning;case C.Info:return s.default.Info;case C.Hint:return s.default.Ignore}}C.toSeverity=g}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(C){const A="";function R(n){return b(n,!0)}C.makeKey=R;function b(n,g){let o=[A];return n.source?o.push(n.source.replace("\xA6","\\\xA6")):o.push(A),n.code?typeof n.code=="string"?o.push(n.code.replace("\xA6","\\\xA6")):o.push(n.code.value.replace("\xA6","\\\xA6")):o.push(A),n.severity!==void 0&&n.severity!==null?o.push(k.toString(n.severity)):o.push(A),n.message&&g?o.push(n.message.replace("\xA6","\\\xA6")):o.push(A),n.startLineNumber!==void 0&&n.startLineNumber!==null?o.push(n.startLineNumber.toString()):o.push(A),n.startColumn!==void 0&&n.startColumn!==null?o.push(n.startColumn.toString()):o.push(A),n.endLineNumber!==void 0&&n.endLineNumber!==null?o.push(n.endLineNumber.toString()):o.push(A),n.endColumn!==void 0&&n.endColumn!==null?o.push(n.endColumn.toString()):o.push(A),o.push(A),o.join("\xA6")}C.makeKeyOptionalMessage=b})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(ye[137],_e([0,1,4,34,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,E.createDecorator)("notificationService");var T;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new C,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=I;class C{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=C}),define(ye[138],_e([0,1,6,9,2,3]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return s.Disposable.None},registerValidator(){return s.Disposable.None},registerExternalUriResolver(){return s.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return s.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function k(C,A){return E.URI.isUri(C)?(0,t.equalsIgnoreCase)(C.scheme,A):(0,t.startsWithIgnoreCase)(C,A+":")}e.matchesScheme=k;function I(C,...A){return A.some(R=>k(C,R))}e.matchesSomeScheme=I});var Be=this&&this.__decorate||function(Z,e,s,t){var E=arguments.length,T=E<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,s):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Z,e,s,t);else for(var I=Z.length-1;I>=0;I--)(k=Z[I])&&(T=(E<3?k(T):E>3?k(e,s,T):k(e,s))||T);return E>3&&T&&Object.defineProperty(e,s,T),T},He=this&&this.__param||function(Z,e){return function(s,t){e(s,t,Z)}};define(ye[139],_e([0,1,14,20,6,3]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var k;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let C=class extends E.Disposable{constructor(b,n){super();this.deferred=new s.DeferredPromise,n.withProgress(b,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};C=Be([He(1,e.IProgressService)],C),e.UnmanagedProgress=C;class A extends E.Disposable{constructor(b){super();this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(b){this.stop();const n=++this.currentOperationId,g=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:g.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(ye[37],_e([0,1,42,10]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(k,I){s.ok(t.isString(k)),s.ok(t.isObject(I)),s.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,I)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new E}),define(ye[140],_e([0,1,4,37]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,A){this.schemasById[E(C)]=A,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;t.Registry.add(e.Extensions.JSONContribution,k)}),define(ye[83],_e([0,1,16,4,10,114,140,37]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=I.Registry.as(k.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(D,l=!0){this.registerConfigurations([D],l)}registerConfigurations(D,l=!0){const M=this.doRegisterConfigurations(D,l);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(D){const l=this.doDeregisterConfigurations(D);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:D,remove:l}){const M=[];M.push(...this.doDeregisterConfigurations(l)),M.push(...this.doRegisterConfigurations(D,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,s.distinct)(M)})}registerDefaultConfigurations(D){const l=[],M=[];for(const{overrides:r,source:i}of D)for(const p in r)if(l.push(p),e.OVERRIDE_PROPERTY_REGEX.test(p)){const m={...this.configurationDefaultsOverrides.get(p)?.value||{},...r[p]};this.configurationDefaultsOverrides.set(p,{source:i,value:m});const h={type:"object",default:m,description:T.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:E.isString(i)?void 0:i};M.push(...o(p)),this.configurationProperties[p]=h,this.defaultLanguageConfigurationOverridesNode.properties[p]=h}else{this.configurationDefaultsOverrides.set(p,{value:r[p],source:i});const m=this.configurationProperties[p];m&&(this.updatePropertyDefaultValue(p,m),this.updateSchema(p,m))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(D){const l=[];for(const{overrides:M,source:r}of D)for(const i in M){const p=this.configurationDefaultsOverrides.get(i),m=E.isString(r)?r:r?.id,h=E.isString(p?.source)?p?.source:p?.source?.id;if(m===h)if(l.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const w=this.configurationProperties[i];w&&(this.updatePropertyDefaultValue(i,w),this.updateSchema(i,w))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...D){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(D){for(const l of D)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(D,l){const M=[];return D.forEach(r=>{M.push(...this.validateAndRegisterProperties(r,l,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),M}doDeregisterConfigurations(D){const l=[],M=r=>{if(r.properties)for(const i in r.properties)l.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>M(i))};for(const r of D){M(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return l}validateAndRegisterProperties(D,l=!0,M,r,i=3){i=E.isUndefinedOrNull(D.scope)?i:D.scope;let p=[],m=D.properties;if(m)for(let w in m){if(l&&y(w)){delete m[w];continue}const v=m[w];if(v.source=M,v.defaultDefaultValue=m[w].default,this.updatePropertyDefaultValue(w,v),e.OVERRIDE_PROPERTY_REGEX.test(w)?v.scope=void 0:(v.scope=E.isUndefinedOrNull(v.scope)?i:v.scope,v.restricted=E.isUndefinedOrNull(v.restricted)?!!r?.includes(w):v.restricted),m[w].hasOwnProperty("included")&&!m[w].included){this.excludedConfigurationProperties[w]=m[w],delete m[w];continue}else this.configurationProperties[w]=m[w];!m[w].deprecationMessage&&m[w].markdownDeprecationMessage&&(m[w].deprecationMessage=m[w].markdownDeprecationMessage),p.push(w)}let h=D.allOf;if(h)for(let w of h)p.push(...this.validateAndRegisterProperties(w,l,M,r,i));return p}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(D){const l=M=>{let r=M.properties;if(r)for(const p in r)this.updateSchema(p,r[p]);let i=M.allOf;i&&i.forEach(l)};l(D)}updateSchema(D,l){switch(e.allSettings.properties[D]=l,l.scope){case 1:e.applicationSettings.properties[D]=l;break;case 2:e.machineSettings.properties[D]=l;break;case 6:e.machineOverridableSettings.properties[D]=l;break;case 3:e.windowSettings.properties[D]=l;break;case 4:e.resourceSettings.properties[D]=l;break;case 5:e.resourceSettings.properties[D]=l,this.resourceLanguageSettingsSchema.properties[D]=l;break}}removeFromSchema(D,l){switch(delete e.allSettings.properties[D],l.scope){case 1:delete e.applicationSettings.properties[D];break;case 2:delete e.machineSettings.properties[D];break;case 6:delete e.machineOverridableSettings.properties[D];break;case 3:delete e.windowSettings.properties[D];break;case 4:case 5:delete e.resourceSettings.properties[D],delete this.resourceLanguageSettingsSchema.properties[D];break}}updateOverridePropertyPatternKey(){for(const D of this.overrideIdentifiers.values()){const l=`[${D}]`,M={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,M),e.allSettings.properties[l]=M,e.applicationSettings.properties[l]=M,e.machineSettings.properties[l]=M,e.machineOverridableSettings.properties[l]=M,e.windowSettings.properties[l]=M,e.resourceSettings.properties[l]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const D={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=D,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(D,l){const M=this.configurationDefaultsOverrides.get(D);let r=M?.value,i=M?.source;E.isUndefined(r)&&(r=l.defaultDefaultValue,i=void 0),E.isUndefined(r)&&(r=u(l.type)),l.default=r,l.defaultValueSource=i}}const n="\\[([^\\]]+)\\]",g=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(d){const D=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let l=g.exec(d);for(;l?.length;){const M=l[1].trim();M&&D.push(M),l=g.exec(d)}}return(0,s.distinct)(D)}e.overrideIdentifiersFromKey=o;function c(d){return d.reduce((D,l)=>`${D}[${l}]`,"")}e.keyFromOverrideIdentifiers=c;function u(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const F=new b;I.Registry.add(e.Extensions.Configuration,F);function y(d){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?T.localize(7,null,d):F.getConfigurationProperties()[d]!==void 0?T.localize(8,null,d):null:T.localize(6,null)}e.validateProperty=y;function f(){const d=[],D=F.getConfigurationProperties();for(const l of Object.keys(D))d.push([l,D[l].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=f}),define(ye[141],_e([0,1,16,4,100,6,21,26,10,2,81,83,37]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(r={},i=[],p=[]){this._contents=r,this._keys=i,this._overrides=p,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const p=this.getContentsForOverrideIdentifer(i);return p?r?(0,R.getConfigurationValue)(p,r):p:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const p of this.overrides)p.identifiers.includes(r)&&i.push(...p.keys);return s.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return s.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=I.deepClone(this.contents),p=I.deepClone(this.overrides),m=[...this.keys];for(const h of r){this.mergeContents(i,h.contents);for(const w of h.overrides){const[v]=p.filter(a=>s.equals(a.identifiers,w.identifiers));v?(this.mergeContents(v.contents,w.contents),v.keys.push(...w.keys),v.keys=s.distinct(v.keys)):p.push(I.deepClone(w))}for(const w of h.keys)m.indexOf(w)===-1&&m.push(w)}return new g(i,m,p)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let p={};for(const m of s.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[m],w=i[m];w&&(typeof h=="object"&&typeof w=="object"?(h=I.deepClone(h),this.mergeContents(h,w)):h=w),p[m]=h}return new g(p,this.keys,this.overrides)}mergeContents(r,i){for(const p of Object.keys(i)){if(p in r&&C.isObject(r[p])&&C.isObject(i[p])){this.mergeContents(r[p],i[p]);continue}r[p]=I.deepClone(i[p])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,p=null;const m=h=>{h&&(p?this.mergeContents(p,h):p=I.deepClone(h))};for(const h of this.overrides)s.equals(h.identifiers,[r])?i=h.contents:h.identifiers.includes(r)&&m(h.contents);return m(i),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,R.addToValueTree)(this.contents,r,i,p=>{throw new Error(p)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let p=0;p<i;p++)r.indexOf(this.keys[p])===0&&(i=p);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class o extends g{constructor(r={}){const i=n.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),p=Object.keys(i),m=Object.create(null),h=[];for(const w in i){const v=r[w],a=v!==void 0?v:i[w].default;(0,R.addToValueTree)(m,w,a,S=>console.error(`Conflict in default settings: ${S}`))}for(const w of Object.keys(m))b.OVERRIDE_PROPERTY_REGEX.test(w)&&h.push({identifiers:(0,b.overrideIdentifiersFromKey)(w),keys:Object.keys(m[w]),contents:(0,R.toValuesTree)(m[w],v=>console.error(`Conflict in default settings file: ${v}`))});super(m,p,h)}}e.DefaultConfigurationModel=o;class c{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!C.isUndefinedOrNull(r)){const p=this.doParseContent(r);this.parseRaw(p,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:p,keys:m,overrides:h,restricted:w}=this.doParseRaw(r,i);this._configurationModel=new g(p,m,h),this._restrictedConfigurations=w||[]}doParseContent(r){let i={},p=null,m=[],h=[],w=[];function v(S){Array.isArray(m)?m.push(S):p!==null&&(m[p]=S)}let a={onObjectBegin:()=>{let S={};v(S),h.push(m),m=S,p=null},onObjectProperty:S=>{p=S},onObjectEnd:()=>{m=h.pop()},onArrayBegin:()=>{let S=[];v(S),h.push(m),m=S,p=null},onArrayEnd:()=>{m=h.pop()},onLiteralValue:v,onError:(S,P,N)=>{w.push({error:S,offset:P,length:N})}};if(r)try{E.visit(r,a),i=m[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return i}doParseRaw(r,i){const p=n.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),m=this.filter(r,p,!0,i);r=m.raw;const h=(0,R.toValuesTree)(r,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),w=Object.keys(r),v=this.toOverrides(r,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:h,keys:w,overrides:v,restricted:m.restricted}}filter(r,i,p,m){if(!m?.scopes&&!m?.skipRestricted)return{raw:r,restricted:[]};const h={},w=[];for(let v in r)if(b.OVERRIDE_PROPERTY_REGEX.test(v)&&p){const a=this.filter(r[v],i,!1,m);h[v]=a.raw,w.push(...a.restricted)}else{const a=i[v],S=a?typeof a.scope!="undefined"?a.scope:3:void 0;a?.restricted&&w.push(v),(S===void 0||m.scopes===void 0||m.scopes.includes(S))&&(m.skipRestricted&&a?.restricted||(h[v]=r[v]))}return{raw:h,restricted:w}}toOverrides(r,i){const p=[];for(const m of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(m)){const h={};for(const w in r[m])h[w]=r[m][w];p.push({identifiers:(0,b.overrideIdentifiersFromKey)(m),keys:Object.keys(h),contents:(0,R.toValuesTree)(h,i)})}return p}}e.ConfigurationModelParser=c;class u extends T.Disposable{constructor(r,i,p,m){super();this.userSettingsResource=r,this.scopes=i,this.fileService=m,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(p.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=u;class F{constructor(r,i,p=new g,m=new g,h=new k.ResourceMap,w=new g,v=new k.ResourceMap,a=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=p,this._workspaceConfiguration=m,this._folderConfigurations=h,this._memoryConfiguration=w,this._memoryConfigurationByResource=v,this._freeze=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,i,p){return this.getConsolidateConfigurationModel(i,p).getValue(r)}updateValue(r,i,p={}){let m;p.resource?(m=this._memoryConfigurationByResource.get(p.resource),m||(m=new g,this._memoryConfigurationByResource.set(p.resource,m))):m=this._memoryConfiguration,i===void 0?m.removeValue(r):m.setValue(r,i),p.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,p){const m=this.getConsolidateConfigurationModel(i,p),h=this.getFolderConfigurationModelForResource(i.resource,p),w=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),a=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),S=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),P=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),N=p?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,B=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(r):h.freeze().getValue(r):void 0,_=i.overrideIdentifier?w.override(i.overrideIdentifier).getValue(r):w.getValue(r),O=m.getValue(r),z=s.distinct(s.flatten(m.overrides.map(U=>U.identifiers))).filter(U=>m.getOverrideValue(r,U)!==void 0);return{defaultValue:v,userValue:a,userLocalValue:S,userRemoteValue:P,workspaceValue:N,workspaceFolderValue:B,memoryValue:_,value:O,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:a!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:P!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:h?.freeze().getValue(r),override:i.overrideIdentifier?h?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:_!==void 0?{value:w.getValue(r),override:i.overrideIdentifier?w.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const p=[];if(!i){const{added:m,updated:h,removed:w}=D(this._defaultConfiguration,r);i=[...m,...h,...w]}for(const m of i)for(const h of(0,b.overrideIdentifiersFromKey)(m)){const w=this._defaultConfiguration.getKeysForOverrideIdentifier(h),v=r.getKeysForOverrideIdentifier(h),a=[...v.filter(S=>w.indexOf(S)===-1),...w.filter(S=>v.indexOf(S)===-1),...w.filter(S=>!I.equals(this._defaultConfiguration.override(h).getValue(S),r.override(h).getValue(S)))];p.push([h,a])}return this.updateDefaultConfiguration(r),{keys:i,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:p,removed:m,overrides:h}=D(this.localUserConfiguration,r),w=[...i,...p,...m];return w.length&&this.updateLocalUserConfiguration(r),{keys:w,overrides:h}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:p,removed:m,overrides:h}=D(this.remoteUserConfiguration,r);let w=[...i,...p,...m];return w.length&&this.updateRemoteUserConfiguration(r),{keys:w,overrides:h}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:p,removed:m,overrides:h}=D(this.workspaceConfiguration,r);let w=[...i,...p,...m];return w.length&&this.updateWorkspaceConfiguration(r),{keys:w,overrides:h}}compareAndUpdateFolderConfiguration(r,i){const p=this.folderConfigurations.get(r),{added:m,updated:h,removed:w,overrides:v}=D(p,i);let a=[...m,...h,...w];return(a.length||!p)&&this.updateFolderConfiguration(r,i),{keys:a,overrides:v}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:p,updated:m,removed:h,overrides:w}=D(i,void 0);return{keys:[...p,...m,...h],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let p=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?p.override(r.overrideIdentifier):p}getConsolidatedConfigurationModelForResource({resource:r},i){let p=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const m=i.getFolder(r);m&&(p=this.getFolderConsolidatedConfiguration(m.uri)||p);const h=this._memoryConfigurationByResource.get(r);h&&(p=p.merge(h))}return p}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const p=this.getWorkspaceConsolidatedConfiguration(),m=this._folderConfigurations.get(r);m?(i=p.merge(m),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=p}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const p=i.getFolder(r);if(p)return this._folderConfigurations.get(p.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:p,overrides:m,keys:h}=this._folderConfigurations.get(i);return r.push([i,{contents:p,overrides:m,keys:h}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(p=>r.add(p))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(p=>r.add(p))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._folderConfigurations.forEach(p=>p.getKeysForOverrideIdentifier(r).forEach(m=>i.add(m))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),p=this.parseConfigurationModel(r.user),m=this.parseConfigurationModel(r.workspace),h=r.folders.reduce((w,v)=>(w.set(A.URI.revive(v[0]),this.parseConfigurationModel(v[1])),w),new k.ResourceMap);return new F(i,p,new g,m,h,new g,new k.ResourceMap,!1)}static parseConfigurationModel(r){return new g(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=F;function y(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const r=new Set,i=new Map;for(const m of M)m.keys.forEach(h=>r.add(h)),m.overrides.forEach(([h,w])=>{const v=(0,k.getOrSet)(i,h,new Set);w.forEach(a=>v.add(a))});const p=[];return i.forEach((m,h)=>p.push([h,[...m.values()]])),{keys:[...r.values()],overrides:p}}e.mergeChanges=y;class f{constructor(r,i,p,m){this.change=r,this.previous=i,this.currentConfiguraiton=p,this.currentWorkspace=m,this._previousConfiguration=void 0;const h=new Set;r.keys.forEach(v=>h.add(v)),r.overrides.forEach(([,v])=>v.forEach(a=>h.add(a))),this.affectedKeys=[...h.values()];const w=new g;this.affectedKeys.forEach(v=>w.setValue(v,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=F.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,m=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!I.equals(p,m)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let p=(0,R.toValuesTree)({[i]:!0},()=>{}),m;for(;typeof p=="object"&&(m=Object.keys(p)[0]);){if(r=r[m],!r)return!1;p=p[m]}return!0}}e.ConfigurationChangeEvent=f;class d extends f{constructor(r,i,p,m){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=p,this.sourceConfig=m}}e.AllKeysConfigurationChangeEvent=d;function D(M,r){const{added:i,removed:p,updated:m}=l(r,M),h=[],w=M?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const a=v.filter(S=>!w.includes(S));for(const S of a)h.push([S,r.getKeysForOverrideIdentifier(S)])}if(M){const a=w.filter(S=>!v.includes(S));for(const S of a)h.push([S,M.getKeysForOverrideIdentifier(S)])}if(r&&M){for(const a of w)if(v.includes(a)){const S=l({contents:M.getOverrideValue(void 0,a)||{},keys:M.getKeysForOverrideIdentifier(a)},{contents:r.getOverrideValue(void 0,a)||{},keys:r.getKeysForOverrideIdentifier(a)});h.push([a,[...S.added,...S.removed,...S.updated]])}}return{added:i,removed:p,updated:m,overrides:h}}function l(M,r){const i=M?r?M.keys.filter(h=>r.keys.indexOf(h)===-1):[...M.keys]:[],p=r?M?r.keys.filter(h=>M.keys.indexOf(h)===-1):[...r.keys]:[],m=[];if(M&&r){for(const h of r.keys)if(M.keys.indexOf(h)!==-1){const w=(0,R.getConfigurationValue)(r.contents,h),v=(0,R.getConfigurationValue)(M.contents,h);I.equals(w,v)||m.push(h)}}return{added:i,removed:p,updated:m}}}),define(ye[84],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,s.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(k,I=t.Unknown,C){super(k);this._message=k,this._code=I,this._detail=C,this.isHandled=I===t.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(k){return k instanceof E&&k._code===t.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof E&&k._code===t.NoResolverFound}static isHandled(k){return k instanceof E&&k.isHandled}}e.RemoteAuthorityResolverError=E}),define(ye[61],_e([0,1,11]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(A){return A.scheme===s.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=t;function E(A){if(!A)return;const R=A.indexOf("+");return R<0?A:A.substr(0,R)}e.getRemoteName=E;function T(A){return A.scheme!==s.Schemas.file&&A.scheme!==s.Schemas.vscodeRemote}e.isVirtualResource=T;function k(A){if(A.folders.length)return A.folders.every(R=>T(R.uri))?A.folders[0].uri:void 0;if(A.configuration&&T(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=k;function I(A){return k(A)?.scheme}e.getVirtualWorkspaceScheme=I;function C(A){return k(A)!==void 0}e.isVirtualWorkspace=C}),define(ye[25],_e([0,1,9,3,61]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=T;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,o){if(typeof g=="undefined"||g===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof g=="string"||typeof o=="string"){let c=typeof g=="string"?g:g.value,u=typeof o=="string"?o:o.value;return s.equalsIgnoreCase(c,u)}return g._lower===o._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=C;function A(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function R(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function b(n,g){if(g){const o=`onResolveRemoteAuthority:${(0,E.getRemoteName)(g)}`;return n.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[142],_e([0,1,9,25]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(o,c){return o.uuid&&c.uuid?o.uuid===c.uuid:o.id===c.id?!0:(0,s.compareIgnoreCase)(o.id,c.id)===0}e.areSameExtensions=E;class T{constructor(c,u){this.version=u,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof T?E(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(o,c){return`${o}.${c}`}e.getExtensionId=k;function I(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function C(o,c){return I(k(o,c))}e.getGalleryExtensionId=C;function A(o,c){const u=[],F=y=>{for(const f of u)if(f.some(d=>E(c(d),c(y))))return f;return null};for(const y of o){const f=F(y);f?f.push(y):u.push([y])}return u}e.groupByExtension=A;function R(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function b(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function n(o){const c=new Set;if(o.malicious)for(const u of o.malicious)c.add(u.id);return c}e.getMaliciousExtensionsSet=n;function g(o,c){const u=[],F=c.manifest.extensionDependencies?.slice(0)??[];for(;F.length;){const y=F.shift();if(y&&u.every(f=>!E(f.identifier,{id:y}))){const f=o.filter(d=>E(d.identifier,{id:y}));f.length===1&&(u.push(f[0]),F.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=g}),define(ye[143],_e([0,1,4,23,3,12]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,E.createDecorator)("sharedTunnelsService");var k;(function(o){o.Http="http",o.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=b;function n(o,c){return c?c!==1&&o<1024:!t.isWindows&&o<1024}e.isPortPrivileged=n;let g=class{constructor(c){this.logService=c,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c,u){return this._tunnelProvider=c,c?(this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],u=Array.from(this._tunnels.values());for(let F of u){const y=Array.from(F.values());for(let f of y){const d=await f.value;d&&c.push(d)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:u}of c.values())await u.then(F=>F?.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,u,F,y,f=!1,d=I.Private,D){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${F} on local port ${y}.`),!c)return;u||(u="localhost");const l=this.retainOrCreateTunnel(c,u,F,y,f,d,D);return l?l.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,F);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(M);return(M.tunnelRemoteHost!==u||M.tunnelRemotePort!==F)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this._tunnels.get(c.tunnelRemoteHost);if(u){const F=u.get(c.tunnelRemotePort);F&&(F.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,F))}}}}async tryDisposeTunnel(c,u,F){if(F.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const y=F.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(u),y}}async closeTunnel(c,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const F=this._tunnels.get(c);if(F&&F.has(u)){const y=F.get(u);y.refcount=0,await this.tryDisposeTunnel(c,u,y)}}addTunnelToMap(c,u,F){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(u,{refcount:1,value:F})}async removeEmptyTunnelFromMap(c,u){const F=this._tunnels.get(c);F&&(await F.get(u)||F.delete(u),F.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,u){let F=[c];R(c)?(F.push(...e.LOCALHOST_ADDRESSES),F.push(...e.ALL_INTERFACES_ADDRESSES)):b(c)&&F.push(...e.ALL_INTERFACES_ADDRESSES);const y=F.map(f=>this._tunnels.get(f));for(const f of y){const d=f?.get(u);if(d)return d}}canTunnel(c){return!!A(c)}createWithProvider(c,u,F,y,f,d,D){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${F} on local port ${y}.`);const M={elevationRequired:f?n(y===void 0?F:y):!1},r={remoteAddress:{host:u,port:F},localAddressPort:y,privacy:d,public:d!==I.Private,protocol:D},i=c.forwardPort(r,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(u,F,i),i}};g=Be([He(0,T.ILogService)],g),e.AbstractTunnelService=g}),define(ye[144],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,T,k=5){let I;return I=T(C=>{const A=typeof C=="string"?C:C.data;let R=this._terminalBufferMap.get(E);if(R){R.data.push(A);return}const b=setTimeout(()=>this.flushBuffer(E),k);R={data:[A],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(E),I.dispose()}},this._terminalBufferMap.set(E,R)}),I}stopBuffering(E){const T=this._terminalBufferMap.get(E);T&&T.dispose()}flushBuffer(E){const T=this._terminalBufferMap.get(E);T&&(this._terminalBufferMap.delete(E),this._callback(E,T.data.join("")))}}e.TerminalDataBufferer=s}),define(ye[145],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var s;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(s=e.ColorScheme||(e.ColorScheme={}))}),define(ye[62],_e([0,1,52,4,6,3,37,145]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var C;(function(u){function F(y){return y&&typeof y=="object"&&typeof y.id=="string"}u.isThemeColor=F})(C=e.ThemeColor||(e.ThemeColor={}));function A(u){return{id:u}}e.themeColorFromId=A;var R;(function(u){function F(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||C.isThemeColor(i.color))}u.isThemeIcon=F;const y=new RegExp(`^\\$\\((${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?)\\)$`);function f(i){const p=y.exec(i);if(!p)return;let[,m]=p;return{id:m}}u.fromString=f;function d(i){return{id:i}}u.fromId=d;function D(i,p){let m=i.id;const h=m.lastIndexOf("~");return h!==-1&&(m=m.substring(0,h)),p&&(m=`${m}~${p}`),{id:m}}u.modify=D;function l(i){const p=i.id.lastIndexOf("~");if(p!==-1)return i.id.substring(p+1)}u.getModifier=l;function M(i,p){return i.id===p.id&&i.color?.id===p.color?.id}u.isEqual=M;function r(i,p){return{id:i.id,color:p?A(p):void 0}}u.asThemeIcon=r,u.asClassNameArray=s.CSSIcon.asClassNameArray,u.asClassName=s.CSSIcon.asClassName,u.asCSSSelector=s.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=s.Codicon.file,e.FolderThemeIcon=s.Codicon.folder;function b(u){switch(u){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(F){return this.themingParticipants.push(F),this.onThemingParticipantAddedEmitter.fire(F),(0,E.toDisposable)(()=>{const y=this.themingParticipants.indexOf(F);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new n;k.Registry.add(e.Extensions.ThemingContribution,g);function o(u){return g.onColorThemeChange(u)}e.registerThemingParticipant=o;class c extends E.Disposable{constructor(F){super();this.themeService=F,this.theme=F.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(F){this.theme=F,this.updateStyles()}updateStyles(){}getColor(F,y){let f=this.theme.getColor(F);return f&&y&&(f=y(f,this.theme)),f?f.toString():null}}e.Themable=c}),define(ye[47],_e([0,1,21,24,2,3]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var k;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function I(n){const g=n;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=I;function C(n){const g=n;return!!(g&&typeof g=="object"&&E.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=C;class A{constructor(g,o,c,u,F){this._id=g,this._transient=c,this._configuration=u,this._ignorePathCasing=F,this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(g){this._id=g.id,this._configuration=g.configuration,this._transient=g.transient,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=A;class R{constructor(g,o){this.raw=o,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,t.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function b(n){return new R({uri:n,index:0,name:(0,t.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=b}),define(ye[63],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const T=this._idPool++;return this._data.set(T,E),this.logDebugInfo(),T}get(E,T){return this._data.has(E)?this._data.get(E)[T]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!s.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s,s.enableDebugLogging=!1}),define(ye[30],_e([0,1,11,24,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const C=this._providerInfo.get(I.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(I,C){C===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,C)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(ye[146],_e([0,1,14]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(k,I,C){this._deferredPromises=new Map,this._id=k,this._shared=I,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of A.values())R.complete()}catch(R){for(const b of A.values())b.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,I){let C=this._value[k];return typeof C=="undefined"&&(C=I),C}update(k,I){this._value[k]=I;let C=this._deferredPromises.get(k);if(C!==void 0)return C.p;const A=new s.DeferredPromise;return this._deferredPromises.set(k,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class E extends t{constructor(k,I){super(k.identifier.value,!0,I);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=E}),define(ye[147],_e([0,1,4,2,12]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(I,C){this._logService=I,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new s.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,C,A){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(C.value,A)}$acceptDirtyStateChanged(I,C){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptDirty(C)}$acceptModelSaved(I){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(I,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,C);const A=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));A.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};T=Be([He(0,E.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(ye[13],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class t{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=t});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[148],_e([0,1,25,4]),function(Z,e,s,t){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(I,C){E.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=s.ExtensionIdentifier.toKey(I.identifier),Ze(this,E,C,"f"),Ie(this,E,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(I){return Ie(this,E,"f").get(this._id,I)}store(I,C){return Ie(this,E,"f").store(this._id,I,C)}delete(I){return Ie(this,E,"f").delete(this._id,I)}}e.ExtensionSecrets=T,E=new WeakMap}),define(ye[85],_e([0,1,3,4]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(ye[48],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var s;(function(y){y[y.Upsert=0]="Upsert",y[y.RemoveChild=1]="RemoveChild",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp",y[y.Bulk=4]="Bulk"})(s=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,E=(y,f)=>{const d={controllerId:f};return t.set(y,d),d};e.createPrivateApiFor=E;const T=y=>t.get(y);e.getPrivateApiFor=T;const k=(y,f,d,D)=>{let l=d;return{enumerable:!0,configurable:!1,get(){return l},set(M){if(!D(l,M)){const r=l;l=M,y.listener?.({op:3,key:f,value:M,previous:r})}}}},I=(y,f)=>y===f,C={range:(y,f)=>y===f?!0:!y||!f?!1:y.isEqual(f),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(y,f)=>!(y.length!==f.length||y.some(d=>!f.find(D=>d.id===D.id)))},A=Object.keys(C),R=(y,f)=>({range:k(y,"range",void 0,C.range),label:k(y,"label",f,C.label),description:k(y,"description",void 0,C.description),canResolveChildren:k(y,"canResolveChildren",!1,C.canResolveChildren),busy:k(y,"busy",!1,C.busy),error:k(y,"error",void 0,C.error),tags:k(y,"tags",[],C.tags)}),b=(y,f)=>{const d=new Map;for(const D of A)C[D](y[D],f[D])||d.set(D,f[D]);return d};e.diffTestItems=b;class n extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=n;class g extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class o extends Error{constructor(f,d,D){super(`TestItem with ID "${f}" is from controller "${d}" and cannot be added as a child of an item from controller "${D}".`)}}e.MixedTestItemController=o;const c=y=>{const f=(0,e.getPrivateApiFor)(y);let d=new Map;return{get size(){return d.size},forEach(D,l){for(const M of d.values())D.call(l,M,this)},replace(D){const l=new Map,M=new Set(d.keys()),r={op:4,ops:[]};for(const i of D){if(!(i instanceof u))throw new g(i.id);const p=(0,e.getPrivateApiFor)(i).controllerId;if(p!==f.controllerId)throw new o(i.id,p,f.controllerId);if(l.has(i.id))throw new n(i.id);l.set(i.id,i),M.delete(i.id),r.ops.push({op:0,item:i})}for(const i of M.keys())r.ops.push({op:1,id:i});f.listener?.(r),d=l},add(D){if(!(D instanceof u))throw new g(D.id);d.set(D.id,D),f.listener?.({op:0,item:D})},delete(D){d.delete(D)&&f.listener?.({op:1,id:D})},get(D){return d.get(D)},toJSON(){return Array.from(d.values())},[Symbol.iterator](){return d.values()}}};class u{constructor(f,d,D,l){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const M=(0,e.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof F?void 0:M.parent}},children:{value:c(this),enumerable:!0,writable:!1},...R(M,D)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=u;class F extends u{constructor(f,d){super(f,f,d,void 0)}}e.TestItemRootImpl=F}),define(ye[64],_e([0,1,3,143,4,13]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(C){function A(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:b.protocol}}C.fromApiTunnel=A;function R(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==t.TunnelPrivacyId.ConstantPrivate&&b.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}C.fromServiceTunnel=R})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,s.createDecorator)("IExtHostTunnelService");let I=class{constructor(A){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,R){}async getTunnels(){return[]}async setTunnelExtensionFunctions(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,R){return{dispose:()=>{}}}async $providePortAttributes(A,R,b,n,g){return[]}async $forwardPort(A,R){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=Be([He(0,T.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[7],_e([0,1,16,15,77,21,76,9,10,2,36,46,84]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n){"use strict";var g,o,c,u,F,y,f,d,D,l,M,r,i,p,m,h,w,v,a,S;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(x){function L(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(L,x),Object.setPrototypeOf(L.prototype,x.prototype),L}let N=F=class{constructor(L){g.set(this,void 0),Ze(this,g,L,"f")}static from(...L){let J=L;return new F(function(){if(J){for(const Se of J)Se&&typeof Se.dispose=="function"&&Se.dispose();J=void 0}})}dispose(){typeof Ie(this,g,"f")=="function"&&(Ie(this,g,"f").call(this),Ze(this,g,void 0,"f"))}};g=new WeakMap,N=F=Be([P],N),e.Disposable=N;let B=y=class{constructor(L,J){if(L<0)throw(0,t.illegalArgument)("line must be non-negative");if(J<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=L,this._character=J}static Min(...L){if(L.length===0)throw new TypeError;let J=L[0];for(let Se=1;Se<L.length;Se++){const Ge=L[Se];Ge.isBefore(J)&&(J=Ge)}return J}static Max(...L){if(L.length===0)throw new TypeError;let J=L[0];for(let Se=1;Se<L.length;Se++){const Ge=L[Se];Ge.isAfter(J)&&(J=Ge)}return J}static isPosition(L){if(!L)return!1;if(L instanceof y)return!0;let{line:J,character:Se}=L;return typeof J=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,J=0){if(L===null||J===null)throw(0,t.illegalArgument)();let Se;return typeof L=="undefined"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,J=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&J===0?this:new y(this.line+Se,this.character+J)}with(L,J=this.character){if(L===null||J===null)throw(0,t.illegalArgument)();let Se;return typeof L=="undefined"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,J=typeof L.character=="number"?L.character:this.character),Se===this.line&&J===this.character?this:new y(Se,J)}toJSON(){return{line:this.line,character:this.character}}};B=y=Be([P],B),e.Position=B;let _=f=class{constructor(L,J,Se,Ge){let tt,at;if(typeof L=="number"&&typeof J=="number"&&typeof Se=="number"&&typeof Ge=="number"?(tt=new B(L,J),at=new B(Se,Ge)):L instanceof B&&J instanceof B&&(tt=L,at=J),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(L){return L instanceof f?!0:L?B.isPosition(L.start)&&B.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof f?this.contains(L._start)&&this.contains(L._end):L instanceof B?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const J=B.Max(L.start,this._start),Se=B.Min(L.end,this._end);if(!J.isAfter(Se))return new f(J,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const J=B.Min(L.start,this._start),Se=B.Max(L.end,this.end);return new f(J,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,J=this.end){if(L===null||J===null)throw(0,t.illegalArgument)();let Se;return L?B.isPosition(L)?Se=L:(Se=L.start||this.start,J=L.end||this.end):Se=this.start,Se.isEqual(this._start)&&J.isEqual(this.end)?this:new f(Se,J)}toJSON(){return[this.start,this.end]}};_=f=Be([P],_),e.Range=_;let O=d=class extends _{constructor(L,J,Se,Ge){let tt,at;if(typeof L=="number"&&typeof J=="number"&&typeof Se=="number"&&typeof Ge=="number"?(tt=new B(L,J),at=new B(Se,Ge)):L instanceof B&&J instanceof B&&(tt=L,at=J),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(L){return L instanceof d?!0:L?_.isRange(L)&&B.isPosition(L.anchor)&&B.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=d=Be([P],O),e.Selection=O;class z{constructor(L,J,Se){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("host");if(typeof J!="number"||J===0||Math.round(J)!==J)throw(0,t.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,t.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(J),this.connectionToken=Se}}e.ResolvedAuthority=z;class U extends Error{constructor(L,J=n.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L);this._message=L,this._code=J,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(L,J){return new U(L,n.RemoteAuthorityResolverErrorCode.NotAvailable,J)}static TemporarilyNotAvailable(L){return new U(L,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var $;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var V;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=D=class{constructor(L,J){this._range=L,this._newText=J}static isTextEdit(L){return L instanceof D?!0:L?_.isRange(L)&&typeof L.newText=="string":!1}static replace(L,J){return new D(L,J)}static insert(L,J){return D.replace(new _(L,L),J)}static delete(L){return D.replace(L,"")}static setEndOfLine(L){const J=new D(new _(new B(0,0),new B(0,0)),"");return J.newEol=L,J}get range(){return this._range}set range(L){if(L&&!_.isRange(L))throw(0,t.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,t.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,t.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=D=Be([P],ue),e.TextEdit=ue;var K;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let re=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,J,Se,Ge){this._edits.push({_type:1,from:L,to:J,options:Se,metadata:Ge})}createFile(L,J,Se){this._edits.push({_type:1,from:void 0,to:L,options:J,metadata:Se})}deleteFile(L,J,Se){this._edits.push({_type:1,from:L,to:void 0,options:J,metadata:Se})}replaceNotebookMetadata(L,J,Se){this._edits.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:J},notebookMetadata:J})}replaceNotebookCells(L,J,Se,Ge,tt){let at,dt,Pt=[],Mt;if(Me.isNotebookRange(J)&&xt.isNotebookCellDataArray(Se)&&!xt.isNotebookCellDataArray(Ge)?(at=J.start,dt=J.end,Pt=Se,Mt=Ge):typeof J=="number"&&typeof Se=="number"&&xt.isNotebookCellDataArray(Ge)&&(at=J,dt=Se,Pt=Ge,Mt=tt),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||Pt.length>0)&&this._edits.push({_type:5,uri:L,index:at,count:dt-at,cells:Pt,metadata:Mt})}replaceNotebookCellMetadata(L,J,Se,Ge){this._edits.push({_type:3,metadata:Ge,uri:L,edit:{editType:8,index:J,metadata:Se}})}replace(L,J,Se,Ge){this._edits.push({_type:2,uri:L,edit:new ue(J,Se),metadata:Ge})}insert(L,J,Se,Ge){this.replace(L,new _(J,J),Se,Ge)}delete(L,J,Se){this.replace(L,J,"",Se)}has(L){return this._edits.some(J=>J._type===2&&J.uri.toString()===L.toString())}set(L,J){if(J)for(const Se of J)Se&&this._edits.push({_type:2,uri:L,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ge=this._edits[Se];Ge._type===2&&Ge.uri.toString()===L.toString()&&(this._edits[Se]=void 0)}(0,s.coalesceInPlace)(this._edits)}}get(L){const J=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===L.toString()&&J.push(Se.edit);return J}entries(){const L=new T.ResourceMap;for(let J of this._edits)if(J._type===2){let Se=L.get(J.uri);Se||(Se=[J.uri,[]],L.set(J.uri,Se)),Se[1].push(J.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};re=Be([P],re),e.WorkspaceEdit=re;let pe=l=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof l?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=l._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,J=this._tabstop++){if(typeof L=="function"){const Se=new l;Se._tabstop=this._tabstop,L(Se),this._tabstop=Se._tabstop,L=Se.value}else L=l._escape(L);return this.value+="${",this.value+=J,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,J=this._tabstop++){const Se=L.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=J,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,J){if(typeof J=="function"){const Se=new l;Se._tabstop=this._tabstop,J(Se),this._tabstop=Se._tabstop,J=Se.value}else typeof J=="string"&&(J=J.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,J&&(this.value+=":",this.value+=J),this.value+="}",this}};pe=l=Be([P],pe),e.SnippetString=pe;var be;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(be=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let le=M=class{constructor(L,J){if(this.uri=L,J)if(J instanceof _)this.range=J;else if(J instanceof B)this.range=new _(J,J);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof M?!0:L?_.isRange(L.range)&&A.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};le=M=Be([P],le),e.Location=le;let Ce=class{constructor(L,J){this.location=L,this.message=J}static is(L){return L?typeof L.message=="string"&&L.location&&_.isRange(L.location.range)&&A.URI.isUri(L.location.uri):!1}static isEqual(L,J){return L===J?!0:!L||!J?!1:L.message===J.message&&L.location.range.isEqual(J.location.range)&&L.location.uri.toString()===J.location.uri.toString()}};Ce=Be([P],Ce),e.DiagnosticRelatedInformation=Ce;let Ee=class{constructor(L,J,Se=ae.Error){if(!_.isRange(L))throw new TypeError("range must be set");if(!J)throw new TypeError("message must be set");this.range=L,this.message=J,this.severity=Se}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,J){return L===J?!0:!L||!J?!1:L.message===J.message&&L.severity===J.severity&&L.code===J.code&&L.severity===J.severity&&L.source===J.source&&L.range.isEqual(J.range)&&(0,s.equals)(L.tags,J.tags)&&(0,s.equals)(L.relatedInformation,J.relatedInformation,Ce.isEqual)}};Ee=Be([P],Ee),e.Diagnostic=Ee;let Fe=class{constructor(L,J){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=J}};Fe=Be([P],Fe),e.Hover=Fe;var $e;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ve=class{constructor(L,J=$e.Text){this.range=L,this.kind=J}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Ve=Be([P],Ve),e.DocumentHighlight=Ve;var je;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var H;(function(x){x[x.Deprecated=1]="Deprecated"})(H=e.SymbolTag||(e.SymbolTag={}));let G=r=class{constructor(L,J,Se,Ge,tt){this.name=L,this.kind=J,this.containerName=tt,typeof Se=="string"&&(this.containerName=Se),Ge instanceof le?this.location=Ge:Se instanceof _&&(this.location=new le(Ge,Se)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};G=r=Be([P],G),e.SymbolInformation=G;let X=i=class{constructor(L,J,Se,Ge,tt){this.name=L,this.detail=J,this.kind=Se,this.range=Ge,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(i.validate)}};X=i=Be([P],X),e.DocumentSymbol=X;var oe;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(oe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(L,J){this.title=L,this.kind=J}};q=Be([P],q),e.CodeAction=q;let ee=p=class{constructor(L){this.value=L}append(L){return new p(this.value?this.value+p.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+p.sep)}};ee.sep=".",ee=p=Be([P],ee),e.CodeActionKind=ee,ee.Empty=new ee(""),ee.QuickFix=ee.Empty.append("quickfix"),ee.Refactor=ee.Empty.append("refactor"),ee.RefactorExtract=ee.Refactor.append("extract"),ee.RefactorInline=ee.Refactor.append("inline"),ee.RefactorRewrite=ee.Refactor.append("rewrite"),ee.Source=ee.Empty.append("source"),ee.SourceOrganizeImports=ee.Source.append("organizeImports"),ee.SourceFixAll=ee.Source.append("fixAll");let he=class{constructor(L,J){if(this.range=L,this.parent=J,J&&!J.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};he=Be([P],he),e.SelectionRange=he;class Re{constructor(L,J,Se,Ge,tt,at){this.kind=L,this.name=J,this.detail=Se,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Re;class Ue{constructor(L,J){this.fromRanges=J,this.from=L}}e.CallHierarchyIncomingCall=Ue;class ze{constructor(L,J){this.fromRanges=J,this.to=L}}e.CallHierarchyOutgoingCall=ze;var Qe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(L,J){this.range=L,this.command=J}get isResolved(){return!!this.command}};et=Be([P],et),e.CodeLens=et;let st=m=class{constructor(L,J=!1){o.set(this,void 0),Ze(this,o,new E.MarkdownString(L,{supportThemeIcons:J}),"f")}static isMarkdownString(L){return L instanceof m?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ie(this,o,"f").value}set value(L){Ie(this,o,"f").value=L}get isTrusted(){return Ie(this,o,"f").isTrusted}set isTrusted(L){Ie(this,o,"f").isTrusted=L}get supportThemeIcons(){return Ie(this,o,"f").supportThemeIcons}set supportThemeIcons(L){Ie(this,o,"f").supportThemeIcons=L}get supportHtml(){return Ie(this,o,"f").supportHtml}set supportHtml(L){Ie(this,o,"f").supportHtml=L}appendText(L){return Ie(this,o,"f").appendText(L),this}appendMarkdown(L){return Ie(this,o,"f").appendMarkdown(L),this}appendCodeblock(L,J){return Ie(this,o,"f").appendCodeblock(J??"",L),this}};o=new WeakMap,st=m=Be([P],st),e.MarkdownString=st;let Xe=class{constructor(L,J){this.label=L,this.documentation=J}};Xe=Be([P],Xe),e.ParameterInformation=Xe;let nt=class{constructor(L,J){this.label=L,this.documentation=J,this.parameters=[]}};nt=Be([P],nt),e.SignatureInformation=nt;let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};lt=Be([P],lt),e.SignatureHelp=lt;var vt;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(vt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Oe;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Oe=e.InlayHintKind||(e.InlayHintKind={}));let Rt=class{constructor(L,J,Se){this.text=L,this.position=J,this.kind=Se}};Rt=Be([P],Rt),e.InlayHint=Rt;var j;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(j=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var fe;(function(x){x[x.Deprecated=1]="Deprecated"})(fe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ne=class{constructor(L,J){this.label=L,this.kind=J}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ne=Be([P],Ne),e.CompletionItem=Ne;let qe=class{constructor(L=[],J=!1){this.items=L,this.isIncomplete=J}};qe=Be([P],qe),e.CompletionList=qe;let ot=class{constructor(L,J,Se){this.text=L,this.range=J,this.command=Se}};ot=Be([P],ot),e.InlineSuggestion=ot;let ht=class{constructor(L){this.items=L}};ht=Be([P],ht),e.InlineSuggestions=ht;var Je;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Je=e.ViewColumn||(e.ViewColumn={}));var Tt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ie;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(J){switch(J){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(L,J){if(J&&!A.URI.isUri(J))throw(0,t.illegalArgument)("target");if(!_.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.target=J}};me=Be([P],me),e.DocumentLink=me;let Te=class{constructor(L,J,Se,Ge){this.red=L,this.green=J,this.blue=Se,this.alpha=Ge}};Te=Be([P],Te),e.Color=Te;let We=class{constructor(L,J){if(J&&!(J instanceof Te))throw(0,t.illegalArgument)("color");if(!_.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.color=J}};We=Be([P],We),e.ColorInformation=We;let Le=class{constructor(L){if(!L||typeof L!="string")throw(0,t.illegalArgument)("label");this.label=L}};Le=Be([P],Le),e.ColorPresentation=Le;var Ke;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ke=e.ColorFormat||(e.ColorFormat={}));var it;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(L,J,Se){if(this.startIndex=L,this.length=J,this.tooltip=Se,typeof L!="number"||L<0)throw(0,t.illegalArgument)("startIndex");if(typeof J!="number"||J<1)throw(0,t.illegalArgument)("length");if(Se!==void 0&&typeof Se!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=rt;var ne;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(L){this.options=L,typeof L!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=ge;var te;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(te=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let we=h=class{constructor(L,J){if(this.label=J,typeof L!="string"||typeof J!="string")throw(0,t.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};we.Clean=new h("clean","Clean"),we.Build=new h("build","Build"),we.Rebuild=new h("rebuild","Rebuild"),we.Test=new h("test","Test"),we=h=Be([P],we),e.TaskGroup=we;function Pe(x){let L="";for(let J=0;J<x.length;J++)L+=x[J].replace(/,/g,",,")+",";return L}let Ye=class{constructor(L,J,Se){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=L,J!==void 0&&(Array.isArray(J)?(this._args=J,this._options=Se):this._options=J)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let J of this._args)L.push(J);return Pe(L)}};Ye=Be([P],Ye),e.ProcessExecution=Ye;let xe=class{constructor(L,J,Se){if(this._args=[],Array.isArray(J)){if(!L)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L,this._args=J,this._options=Se}else{if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L,this._options=J}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let J of this._args)L.push(typeof J=="string"?J:J.value);return Pe(L)}};xe=Be([P],xe),e.ShellExecution=xe;var ut;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class Ct{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Ct;let wt=w=class{constructor(L,J,Se,Ge,tt,at){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof J=="string"?(this._name=this.name=J,this._source=this.source=Se,this.execution=Ge,dt=tt,this.__deprecated=!0):J===bt.Global||J===bt.Workspace?(this.target=J,this._name=this.name=Se,this._source=this.source=Ge,this.execution=tt,dt=at):(this.target=J,this._name=this.name=Se,this._source=this.source=Ge,this.execution=tt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ye?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const J=this._definition.type;(w.EmptyType===J||w.ProcessType===J||w.ShellType===J||w.ExtensionCallbackType===J)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=w=Be([P],wt),e.Task=wt;var ft;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let pt=class{constructor(L,J=yt.None){this.collapsibleState=J,A.URI.isUri(L)?this.resourceUri=L:this.label=L}};pt=Be([P],pt),e.TreeItem=pt;var yt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ot=class{constructor(L){this._value=L}async asString(){return JSON.stringify(this._value)}};Ot=Be([P],Ot),e.TreeDataTransferItem=Ot;let kt=class{constructor(){this._items=new Map}get(L){return this._items.get(L)}set(L,J){this._items.set(L,J)}forEach(L){this._items.forEach(L)}};kt=Be([P],kt),e.TreeDataTransfer=kt;let It=class{constructor(L,J){this.id=L,this.color=J}};It=Be([P],It),e.ThemeIcon=It,It.File=new It("file"),It.Folder=new It("folder");let At=class{constructor(L){this.id=L}};At=Be([P],At),e.ThemeColor=At;var St;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(St=e.ConfigurationTarget||(e.ConfigurationTarget={}));let zt=class{constructor(L,J){if(typeof L!="string"&&(!L||!A.URI.isUri(L)&&!A.URI.isUri(L.uri)))throw(0,t.illegalArgument)("base");if(typeof J!="string")throw(0,t.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=A.URI.file(L),this.base=L):A.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=J}};zt=Be([P],zt),e.RelativePattern=zt;let Lt=class{constructor(L,J,Se,Ge){this.enabled=typeof L=="boolean"?L:!0,typeof J=="string"&&(this.condition=J),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Lt=Be([P],Lt),e.Breakpoint=Lt;let Et=class extends Lt{constructor(L,J,Se,Ge,tt){super(J,Se,Ge,tt);if(L===null)throw(0,t.illegalArgument)("location");this.location=L}};Et=Be([P],Et),e.SourceBreakpoint=Et;let Qt=class extends Lt{constructor(L,J,Se,Ge,tt){super(J,Se,Ge,tt);this.functionName=L}};Qt=Be([P],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends Lt{constructor(L,J,Se,Ge,tt,at,dt){super(Ge,tt,at,dt);if(!J)throw(0,t.illegalArgument)("dataId");this.label=L,this.dataId=J,this.canPersist=Se}};Vt=Be([P],Vt),e.DataBreakpoint=Vt;let Yt=class{constructor(L,J,Se){this.command=L,this.args=J||[],this.options=Se}};Yt=Be([P],Yt),e.DebugAdapterExecutable=Yt;let si=class{constructor(L,J){this.port=L,this.host=J}};si=Be([P],si),e.DebugAdapterServer=si;let Ft=class{constructor(L){this.path=L}};Ft=Be([P],Ft),e.DebugAdapterNamedPipeServer=Ft;let Xt=class{constructor(L){this.implementation=L}};Xt=Be([P],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor(L,J){this.range=L,this.expression=J}};ai=Be([P],ai),e.EvaluatableExpression=ai;var Jt;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(Jt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,J){this.range=L,this.text=J}};Wt=Be([P],Wt),e.InlineValueText=Wt;let gt=class{constructor(L,J,Se=!0){this.range=L,this.variableName=J,this.caseSensitiveLookup=Se}};gt=Be([P],gt),e.InlineValueVariableLookup=gt;let li=class{constructor(L,J){this.range=L,this.expression=J}};li=Be([P],li),e.InlineValueEvaluatableExpression=li;let Nt=class{constructor(L,J){this.frameId=L,this.stoppedLocation=J}};Nt=Be([P],Nt),e.InlineValueContext=Nt;var jt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Zt=v=class extends Error{constructor(L,J=b.FileSystemProviderErrorCode.Unknown,Se){super(A.URI.isUri(L)?L.toString(!0):L);this.code=Se?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,J),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(L){return new v(L,b.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(L){return new v(L,b.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(L){return new v(L,b.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(L){return new v(L,b.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(L){return new v(L,b.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(L){return new v(L,b.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}};Zt=v=Be([P],Zt),e.FileSystemError=Zt;let ci=class{constructor(L,J,Se){this.start=L,this.end=J,this.kind=Se}};ci=Be([P],ci),e.FoldingRange=ci;var fi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class ei{constructor(L,J=[]){this.tokenTypes=L,this.tokenModifiers=J}}e.SemanticTokensLegend=ei;function yi(x){return typeof x=="undefined"||(0,C.isStringArray)(x)}class qt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let J=0,Se=L.tokenTypes.length;J<Se;J++)this._tokenTypeStrToInt.set(L.tokenTypes[J],J);for(let J=0,Se=L.tokenModifiers.length;J<Se;J++)this._tokenModifierStrToInt.set(L.tokenModifiers[J],J)}}push(L,J,Se,Ge,tt){if(typeof L=="number"&&typeof J=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,J,Se,Ge,tt);if(_.isRange(L)&&typeof J=="string"&&yi(Se))return this._push(L,J,Se);throw(0,t.illegalArgument)()}_push(L,J,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(J))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,tt=L.start.character,at=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(J);let Pt=0;if(Se)for(const Mt of Se){if(!this._tokenModifierStrToInt.has(Mt))throw new Error("`tokenModifier` is not in the provided legend");const Ut=this._tokenModifierStrToInt.get(Mt);Pt|=1<<Ut>>>0}this._pushEncoded(Ge,tt,at,dt,Pt)}_pushEncoded(L,J,Se,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&J<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Mt=0,Ut=0;for(let Bt=0;Bt<Pt;Bt++){let $t=this._data[5*Bt],di=this._data[5*Bt+1];$t===0?($t=Mt,di+=Ut):$t+=Mt,this._data[5*Bt]=$t,this._data[5*Bt+1]=di,Mt=$t,Ut=di}}let at=L,dt=J;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=J}static _sortAndDeltaEncode(L){let J=[];const Se=L.length/5|0;for(let dt=0;dt<Se;dt++)J[dt]=dt;J.sort((dt,Pt)=>{const Mt=L[5*dt],Ut=L[5*Pt];if(Mt===Ut){const Bt=L[5*dt+1],$t=L[5*Pt+1];return Bt-$t}return Mt-Ut});const Ge=new Uint32Array(L.length);let tt=0,at=0;for(let dt=0;dt<Se;dt++){const Pt=5*J[dt],Mt=L[Pt+0],Ut=L[Pt+1],Bt=L[Pt+2],$t=L[Pt+3],di=L[Pt+4],Hi=Mt-tt,Yi=Hi===0?Ut-at:Ut,hi=5*dt;Ge[hi+0]=Hi,Ge[hi+1]=Yi,Ge[hi+2]=Bt,Ge[hi+3]=$t,Ge[hi+4]=di,tt=Mt,at=Ut}return Ge}build(L){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),L):new Kt(qt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=qt;class Kt{constructor(L,J){this.resultId=J,this.data=L}}e.SemanticTokens=Kt;class _i{constructor(L,J,Se){this.start=L,this.deleteCount=J,this.data=Se}}e.SemanticTokensEdit=_i;class Si{constructor(L,J){this.resultId=J,this.edits=L}}e.SemanticTokensEdits=Si;var Gt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ci;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Ci=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ti=class{constructor(){}};ti.Back={iconPath:new It("arrow-left")},ti=Be([P],ti),e.QuickInputButtons=ti;var Di;(function(x){x[x.Separator=-1]="Separator",x[x.Default=1]="Default"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(L,J,Se){this.badge=L,this.tooltip=J,this.color=Se}static validate(L){if(L.badge){let J=(0,I.nextCharLength)(L.badge,0);if(J<L.badge.length&&(J+=(0,I.nextCharLength)(L.badge,J)),L.badge.length>J)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ii=class{constructor(L){this.kind=L}};ii=Be([P],ii),e.ColorTheme=ii;var gi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Me{constructor(L,J){if(L<0)throw(0,t.illegalArgument)("start must be positive");if(J<0)throw(0,t.illegalArgument)("end must be positive");L<=J?(this._start=L,this._end=J):(this._start=J,this._end=L)}static isNotebookRange(L){return L instanceof Me?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let J=this._start,Se=this._end;return L.start!==void 0&&(J=L.start),L.end!==void 0&&(Se=L.end),J===this._start&&Se===this._end?this:new Me(J,Se)}}e.NotebookRange=Me;class xt{constructor(L,J,Se,Ge,tt,at,dt){this.kind=L,this.value=J,this.languageId=Se,this.mime=Ge,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,xt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(J=>xt.isNotebookCellData(J))}static isNotebookCellData(L){return!0}}e.NotebookCellData=xt;class pi{constructor(L){this.cells=L}}e.NotebookData=pi;class mt{constructor(L,J){this.data=L,this.mime=J;const Se=(0,k.normalizeMimeType)(J,!0);if(!Se)throw new Error(`INVALID mime type: ${J}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}static isNotebookCellOutputItem(L){return L instanceof mt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const J={name:L.name,message:L.message,stack:L.stack};return mt.json(J,"application/vnd.code.notebook.error")}static stdout(L){return mt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return mt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,J="application/octet-stream"){return new mt(L,J)}static text(L,J=k.Mimes.text){const Se=Ie(mt,c,"f",u).encode(String(L));return new mt(Se,J)}static json(L,J="application/json"){const Se=JSON.stringify(L,void 0,"	");return mt.text(Se,J)}}e.NotebookCellOutputItem=mt,c=mt,u={value:new TextEncoder};class ni{constructor(L,J,Se){this.items=ni.ensureUniqueMimeTypes(L,!0),typeof J=="string"?(this.id=J,this.metadata=Se):(this.id=(0,R.generateUuid)(),this.metadata=J??Se)}static isNotebookCellOutput(L){return L instanceof ni?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,J=!1){const Se=new Set,Ge=new Set;for(let tt=0;tt<L.length;tt++){const at=L[tt],dt=(0,k.normalizeMimeType)(at.mime);if(!Se.has(dt)){Se.add(dt);continue}Ge.add(tt),J&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?L:L.filter((tt,at)=>!Ge.has(at))}}e.NotebookCellOutput=ni;var Ii;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(L,J){this.text=L,this.alignment=J}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(L,J=[]){this.uri=L,this.provides=(0,s.asArray)(J)}}e.NotebookRendererScript=Ri;let ri=class{constructor(L,J){this.label=L,this.timestamp=J}};ri=Be([P],ri),e.TimelineItem=ri;var Fi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(L,J){this.ranges=L,this.wordPattern=J}}e.LinkedEditingRanges=Li;class Ni{constructor(L,J){this._port=L,this._autoForwardAction=J}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var Y;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Y=e.TestResultState||(e.TestResultState={}));var ce;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(ce=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ke=class{constructor(L=void 0,J=void 0,Se=void 0){this.include=L,this.exclude=J,this.profile=Se}};ke=Be([P],ke),e.TestRunRequest=ke;let ct=a=class{constructor(L){this.message=L}static diff(L,J,Se){const Ge=new a(L);return Ge.expectedOutput=J,Ge.actualOutput=Se,Ge}};ct=a=Be([P],ct),e.TestMessage=ct;let _t=class{constructor(L){this.id=L}};_t=Be([P],_t),e.TestTag=_t;let Dt=class{constructor(L,J){this.covered=L,this.total=J}};Dt=Be([P],Dt),e.CoveredCount=Dt;let xi=S=class{constructor(L,J,Se,Ge){this.uri=L,this.statementCoverage=J,this.branchCoverage=Se,this.functionCoverage=Ge}static fromDetails(L,J){const Se=new Dt(0,0),Ge=new Dt(0,0),tt=new Dt(0,0);for(const dt of J)if("branches"in dt){Se.total+=1,Se.covered+=dt.executionCount>0?1:0;for(const Pt of dt.branches)Ge.total+=1,Ge.covered+=Pt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new S(L,Se,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=J,at}};xi=S=Be([P],xi),e.FileCoverage=xi;let Ui=class{constructor(L,J,Se=[]){this.executionCount=L,this.location=J,this.branches=Se}};Ui=Be([P],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(L,J){this.executionCount=L,this.location=J}};Bi=Be([P],Bi),e.BranchCoverage=Bi;let $i=class{constructor(L,J){this.executionCount=L,this.location=J}};$i=Be([P],$i),e.FunctionCoverage=$i;var qi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ki;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Ki=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(L,J,Se,Ge,tt,at){this.kind=L,this.name=J,this.detail=Se,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(ye[86],_e([0,1,42,11,9,223,113,7,16]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function R(o,c){c?A.set(o,c):A.delete(o)}e.setWordDefinitionFor=R;function b(o){return A.get(o)}e.getWordDefinitionFor=b;class n extends T.MirrorTextModel{constructor(c,u,F,y,f,d,D,l){super(u,F,y,f);this._proxy=c,this._languageId=d,this._isDirty=D,this._notebook=l,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,C.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===t.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},get notebook(){return c._notebook},save(){return c._save()},getText(u){return u?c._getTextInRange(u):c.getText()},get eol(){return c._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(u){return c._lineAt(u)},offsetAt(u){return c._offsetAt(u)},positionAt(u){return c._positionAt(u)},validateRange(u){return c._validateRange(u)},validatePosition(u){return c._validatePosition(u)},getWordRangeAtPosition(u,F){return c._getWordRangeAtPosition(u,F)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,s.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,s.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const u=this._validateRange(c);if(u.isEmpty)return"";if(u.isSingleLine)return this._lines[u.start.line].substring(u.start.character,u.end.character);const F=this._eol,y=u.start.line,f=u.end.line,d=[];d.push(this._lines[y].substring(u.start.character));for(let D=y+1;D<f;D++)d.push(this._lines[D]);return d.push(this._lines[f].substring(0,u.end.character)),d.join(F)}_lineAt(c){let u;if(c instanceof I.Position?u=c.line:typeof c=="number"&&(u=c),typeof u!="number"||u<0||u>=this._lines.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new g(u,this._lines[u],u===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(c),F=this._lines[u.index].length;return new I.Position(u.index,Math.min(u.remainder,F))}_validateRange(c){if(!(c instanceof I.Range))throw new Error("Invalid argument");const u=this._validatePosition(c.start),F=this._validatePosition(c.end);return u===c.start&&F===c.end?c:new I.Range(u.line,u.character,F.line,F.character)}_validatePosition(c){if(!(c instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:u,character:F}=c,y=!1;if(u<0)u=0,F=0,y=!0;else if(u>=this._lines.length)u=this._lines.length-1,F=this._lines[u].length,y=!0;else{const f=this._lines[u].length;F<0?(F=0,y=!0):F>f&&(F=f,y=!0)}return y?new I.Position(u,F):c}_getWordRangeAtPosition(c,u){const F=this._validatePosition(c);if(!u)u=b(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const y=(0,k.getWordAtText)(F.character+1,(0,k.ensureValidWordDefinition)(u),this._lines[F.line],0);if(y)return new I.Range(F.line,y.startColumn-1,F.line,y.endColumn-1)}}e.ExtHostDocumentData=n;class g{constructor(c,u,F){this._line=c,this._text=u,this._isLastLine=F}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ye[149],_e([0,1,7,4,224,6,56,21,2,36]),function(Z,e,s,t,E,T,k,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(n,g,o,c){this._notebook=o,this._selector=c,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(F=>{const y=this._cellUris.get(F.document.uri);y!==void 0&&(this._cellLengths.setValue(y,this._cells[y].document.getText().length+1),this._cellLines.setValue(y,this._cells[y].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const u=F=>{F===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(F=>u(F.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const n=[],g=[];for(const o of this._notebook.getCells())o.kind===s.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),n.push(o.document.getText().length+1),g.push(o.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(n){if(!n){let y="";for(const f of this._cells)y+=f.document.getText()+`
`;return y=y.slice(0,-1),y}if(n.isEmpty)return"";const g=this.locationAt(n.start),o=this.locationAt(n.end),c=this._cellUris.get(g.uri),u=this._cellUris.get(o.uri);if(c===void 0||u===void 0)return"";if(c===u)return this._cells[c].document.getText(new s.Range(g.range.start,o.range.end));const F=[this._cells[c].document.getText(new s.Range(g.range.start,new s.Position(this._cells[c].document.lineCount,0)))];for(let y=c+1;y<u;y++)F.push(this._cells[y].document.getText());return F.push(this._cells[u].document.getText(new s.Range(new s.Position(0,0),o.range.end))),F.join(`
`)}offsetAt(n){const g=this._cellLines.getIndexOf(n.line),o=this._cellLengths.getPrefixSum(g.index-1),c=this._cells[g.index].document.offsetAt(n.with(g.remainder));return o+c}positionAt(n){if(typeof n=="number"){const o=this._cellLengths.getIndexOf(n),c=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(c)}const g=this._cellUris.get(n.uri);if(g!==void 0){const o=this._cellLines.getPrefixSum(g-1);return new s.Position(o+n.range.start.line,n.range.start.character)}return new s.Position(0,0)}locationAt(n){s.Range.isRange(n)||(n=new s.Range(n,n));const g=this._cellLines.getIndexOf(n.start.line);let o=g;n.isEmpty||(o=this._cellLines.getIndexOf(n.end.line));const c=new s.Position(g.remainder,n.start.character),u=new s.Position(o.remainder,n.end.character),F=new s.Range(c,u),y=this._cells[g.index];return new s.Location(y.document.uri,y.document.validateRange(F))}contains(n){return this._cellUris.has(n)}validateRange(n){const g=this.validatePosition(n.start),o=this.validatePosition(n.end);return n.with(g,o)}validatePosition(n){const g=this._cellLines.getIndexOf(n.line),o=new s.Position(g.remainder,n.character),c=this._cells[g.index].document.validatePosition(o),u=this._cellLines.getPrefixSum(g.index-1);return new s.Position(u+c.line,c.character)}}e.ExtHostNotebookConcatDocument=R}),define(ye[150],_e([0,1,7,13,4]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(I){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let C=I==="light"?s.ColorThemeKind.Light:I==="dark"?s.ColorThemeKind.Dark:s.ColorThemeKind.HighContrast;this._actual=new s.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Be([He(0,t.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ye[65],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class t{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=t}),define(ye[151],_e([0,1,22]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(C){let A=this.buffers.indexOf(C);return A<0&&(A=this.buffers.length,this.buffers.push(C)),A}}function E(I,C){if(C.serializeBuffersForPostMessage){const A=new t,R=(g,o)=>{if(o instanceof ArrayBuffer){const c=A.add(o);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(o)){const c=T(o);if(c){const u=A.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:u,view:{type:c,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},b=JSON.stringify(I,R),n=A.buffers.map(g=>{const o=new Uint8Array(g);return s.VSBuffer.wrap(o)});return{message:b,buffers:n}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=E;function T(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(I,C){const A=C.map(n=>{const g=new ArrayBuffer(n.byteLength);return new Uint8Array(g).set(n.buffer),g}),R=C.length?(n,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const o=g,{index:c}=o,u=A[c];if(o.view)switch(o.view.type){case 1:return new Int8Array(u,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return g}:void 0;return{message:JSON.parse(I,R),arrayBuffers:A}}e.deserializeWebviewMessage=k}),define(ye[152],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var s;(function(t){function E(k){const I=new Map;return k.types.forEach((C,A)=>{I.set(C,{asString:async()=>k.items[A].asString})}),I}t.toITreeDataTransfer=E;async function T(k){const I={types:[],items:[]},C=Array.from(k.entries());for(const A of C)I.types.push(A[0]),I.items.push({asString:await A[1].asString()});return I}t.toTreeDataTransferDTO=T})(s=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ye[66],_e([0,1,11,2]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(I,C){return I.scheme===s.Schemas.http||I.scheme===s.Schemas.https?I:(C&&C.authority&&C.isRemote&&I.scheme===s.Schemas.file&&(I=t.URI.from({scheme:s.Schemas.vscodeRemote,authority:C.authority,path:I.path})),t.URI.from({scheme:s.Schemas.https,authority:`${I.scheme}+${T(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=E;function T(I){return I.replace(/./g,C=>{const A=C.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?C:"-"+A.toString(16).padStart(4,"0")})}function k(I){return I.replace(/-([0-9a-f]{4})/g,(C,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=k}),define(ye[153],_e([0,1,4,6,66]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(I,C,A){this._proxy=I,this._editors=C,this._initData=A,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const R=C.getVisibleTextEditors();for(const b of this._insets.values())R.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,C,A,R,b){let n;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===I){n=f;break}if(!n)throw new Error("not a visible editor");const g=this,o=this._handlePool++,c=new s.Emitter,u=new s.Emitter,F=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,E.asWebviewUri)(f,g._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(f){this._options=f,g._proxy.$setOptions(o,f)}get options(){return this._options}set html(f){this._html=f,g._proxy.$setHtml(o,f)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(f){return g._proxy.$postMessage(o,f)}},y=new class{constructor(){this.editor=I,this.line=C,this.height=A,this.webview=F,this.onDidDispose=u.event}dispose(){g._insets.has(o)&&(g._insets.delete(o),g._proxy.$disposeEditorInset(o),u.fire(),u.dispose(),c.dispose())}};return this._proxy.$createEditorInset(o,n.id,n.value.document.uri,C+1,A,R||{},b.identifier,b.extensionLocation),this._insets.set(o,{editor:I,inset:y,onDidReceiveMessage:c}),y}$onDidDispose(I){const C=this._insets.get(I);C&&C.inset.dispose()}$onDidReceiveMessage(I,C){const A=this._insets.get(I);A&&A.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=T}),define(ye[154],_e([0,1,125,10,2,6,3,45,37,46,16,11]),function(Z,e,s,t,E,T,k,I,C,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,s.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,s.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,s.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,s.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,s.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,s.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,s.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,s.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,s.localize)(10,null)),e.SideBySideEditorActiveContext=new I.RawContextKey("sideBySideEditorActive",!1,(0,s.localize)(11,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,s.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,s.localize)(13,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,s.localize)(14,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,s.localize)(15,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,s.localize)(16,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,s.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,s.localize)(18,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,s.localize)(19,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,s.localize)(20,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,s.localize)(21,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,s.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(_,O,z){for(const U of z.visibleEditorPanes)if(U.group.id===O&&_.matches(U.input))return U.getViewState()}e.findViewStateForEditor=n;function g(_){if(D(_))return!1;const O=_;return E.URI.isUri(O?.resource)}e.isResourceEditorInput=g;function o(_){if(D(_))return!1;const O=_;return O?.original!==void 0&&O.modified!==void 0}e.isResourceDiffEditorInput=o;function c(_){if(D(_)||o(_))return!1;const O=_;return O?.primary!==void 0&&O.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function u(_){if(D(_))return!1;const O=_;return O?O.resource===void 0||O.resource.scheme===b.Schemas.untitled||O.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var F;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(F=e.Verbosity||(e.Verbosity={}));var y;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(y=e.SaveReason||(e.SaveReason={}));var f;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription"})(f=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends T.Disposable{}e.AbstractEditorInput=d;function D(_){return _ instanceof d}e.isEditorInput=D;function l(_){const O=_;return E.URI.isUri(O?.preferredResource)}function M(_){const O=_;return D(O?.primary)&&D(O?.secondary)}e.isSideBySideEditorInput=M;function r(_){const O=_;return D(O?.modified)&&D(O?.original)}e.isDiffEditorInput=r;function i(_){return D(_?.editor)}e.isEditorInputWithOptions=i;function p(_){const O=_;return i(_)&&O?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function m(_){const O=_;return typeof O?.groupId=="number"&&D(O.editor)}e.isEditorIdentifier=m;var h;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var w;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LOCKED=2]="GROUP_LOCKED",_[_.EDITOR_OPEN=3]="EDITOR_OPEN",_[_.EDITOR_CLOSE=4]="EDITOR_CLOSE",_[_.EDITOR_MOVE=5]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=7]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=9]="EDITOR_PIN",_[_.EDITOR_STICKY=10]="EDITOR_STICKY",_[_.EDITOR_DIRTY=11]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(w=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var v;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(v=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:$,secondary:V}=this.getSideEditors(O);if($&&V){if(z?.supportSideBySide===v.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===v.ANY)return this.getOriginalUri($,{filterByScheme:z.filterByScheme})??this.getOriginalUri(V,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===v.PRIMARY?$:V}}if(o(O)||c(O))return;const U=l(O)?O.preferredResource:O.resource;return!U||!z||!z.filterByScheme?U:this.filterUri(U,z.filterByScheme)}getSideEditors(O){return M(O)||c(O)?{primary:O.primary,secondary:O.secondary}:r(O)||o(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,z){if(!O)return;if(z?.supportSideBySide){const{primary:$,secondary:V}=this.getSideEditors(O);if($&&V){if(z?.supportSideBySide===v.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===v.ANY)return this.getCanonicalUri($,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(V,{filterByScheme:z.filterByScheme});O=z.supportSideBySide===v.PRIMARY?$:V}}if(o(O)||c(O))return;const U=O.resource;return!U||!z||!z.filterByScheme?U:this.filterUri(U,z.filterByScheme)}filterUri(O,z){if(Array.isArray(z)){if(z.some(U=>O.scheme===U))return O}else if(z===O.scheme)return O}}e.EditorResourceAccessor=new a;var S;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(S=e.CloseDirection||(e.CloseDirection={}));class P{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(O){const z=this.instantiationService=O.get(k.IInstantiationService);for(const[U,$]of this.editorSerializerConstructors)this.createEditorSerializer(U,$,z);this.editorSerializerConstructors.clear()}createEditorSerializer(O,z,U){const $=U.createInstance(z);this.editorSerializerInstances.set(O,$)}registerFileEditorFactory(O){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=O}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(O,z){if(this.editorSerializerConstructors.has(O)||this.editorSerializerInstances.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.instantiationService?this.createEditorSerializer(O,z,this.instantiationService):this.editorSerializerConstructors.set(O,z),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(O),this.editorSerializerInstances.delete(O)})}getEditorSerializer(O){return this.editorSerializerInstances.get(typeof O=="string"?O:O.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new P);async function N(_,O){if(!_||!_.length)return[];const z=await Promise.all(_.map(async U=>{const $=E.URI.revive(U.fileUri);if(!$||!await O.canHandleResource($))return;let ue=U.exists,K=U.type;if(typeof ue!="boolean"||typeof K!="number")try{K=(await O.resolve($)).isDirectory?A.FileType.Directory:A.FileType.Unknown,ue=!0}catch{ue=!1}if(!ue&&U.openOnlyIfExists||K===A.FileType.Directory)return;const re={selection:ue?U.selection:void 0,pinned:!0,override:U.editorOverrideId};let pe;return ue?pe={resource:$,options:re}:pe={resource:$,options:re,forceUntitled:!0},pe}));return(0,R.coalesce)(z)}e.pathsToEditors=N;var B;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(ye[155],_e([0,1,4,14,126]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,C,A,R){const b={command:I};if(C&&Object.keys(C).length>0&&(b.arguments=C),this.internalSend("request",b),typeof R=="number"){const n=setTimeout(()=>{clearTimeout(n);const g=this.pendingRequests.get(b.seq);if(g){this.pendingRequests.delete(b.seq);const o={type:"response",seq:0,request_seq:b.seq,success:!1,command:I,message:(0,E.localize)(0,null,R,I)};g(o)}},R)}return A&&this.pendingRequests.set(b.seq,A),b.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,C){return I.type!=="event"||C.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":{const C=I,A=this.pendingRequests.get(C.request_seq);A&&(this.pendingRequests.delete(C.request_seq),A(C));break}}}}internalSend(I,C){C.type=I,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((C,A)=>I.set(A,C)),await(0,t.timeout)(500),I.forEach((C,A)=>{C({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ye[156],_e([0,1,9,2,17,26,11]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function C(r,i,p){return r.replace(I,function(m,h){return i&&h.length>0&&h[0]!=="_"?m:p&&p.hasOwnProperty(h)?p[h]:m})}e.formatPII=C;function A(r){const i={};for(const p of Object.keys(r))p.startsWith("!")||(i[p]=r[p]);return i}e.filterExceptionsFromTelemetry=A;function R(r){return r.configuration.request==="attach"&&!b(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function b(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(i,"extensionhost")||(0,s.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?b(r.parentSession):void 0}e.getExtensionHostDebugSession=b;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function g(r,i,p){let m,h=0;const w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=w.exec(r);){const a=v.index+1,S=a+v[0].length;if(a<=i&&S>=p){m=v[0],h=a;break}}if(m){const a=/\w+/g;let S=null;for(;(S=a.exec(m))&&!(S.index+1+h+S[0].length>=p););S&&(m=m.substring(0,a.lastIndex))}return m?{start:h,end:h+m.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(r){return!!(r&&r.match(o))}e.isUri=c;function u(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(c(r.path))return t.URI.parse(r.path);if((0,E.isAbsolute)(r.path))return t.URI.file(r.path)}return r.path}function F(r){if(typeof r.path=="object"){const i=t.URI.revive(r.path);if(i)return i.scheme===k.Schemas.file?i.fsPath:i.toString()}return r.path}function y(r,i){const p=i?u:F,m=(0,T.deepClone)(r);return d(m,(h,w)=>{h&&w&&(w.path=p(w))}),m}e.convertToDAPaths=y;function f(r,i){const p=i?u:F,m=(0,T.deepClone)(r);return d(m,(h,w)=>{!h&&w&&(w.path=p(w))}),m}e.convertToVSCPaths=f;function d(r,i){switch(r.type){case"event":{const p=r;switch(p.event){case"output":i(!1,p.body.source);break;case"loadedSource":i(!1,p.body.source);break;case"breakpoint":i(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=r;switch(p.command){case"setBreakpoints":i(!0,p.arguments.source);break;case"breakpointLocations":i(!0,p.arguments.source);break;case"source":i(!0,p.arguments.source);break;case"gotoTargets":i(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(m=>i(!1,m));break;default:break}break}case"response":{const p=r;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(m=>i(!1,m.source));break;case"loadedSources":p.body.sources.forEach(m=>i(!1,m));break;case"scopes":p.body.scopes.forEach(m=>i(!1,m.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(m=>i(!1,m.source));break;case"setBreakpoints":p.body.breakpoints.forEach(m=>i(!1,m.source));break;default:break}break}}}function D(r){return r.filter(i=>!i.presentation?.hidden).sort((i,p)=>i.presentation?p.presentation?i.presentation.group?p.presentation.group?i.presentation.group!==p.presentation.group?i.presentation.group.localeCompare(p.presentation.group):l(i.presentation.order,p.presentation.order):-1:p.presentation.group?1:l(i.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.getVisibleAndSorted=D;function l(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function M(r,i){const p=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(p!=="none"&&(await i.saveAll(),p==="allEditorsInActiveGroup")){const m=i.activeEditorPane;m&&await i.save({editor:m.input,groupId:m.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(ye[87],_e([0,1,29,157,76,11,17,23,45]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var A;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",E.Mimes.latex,E.Mimes.markdown,"image/png","image/jpeg",E.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[E.Mimes.latex,E.Mimes.markdown,"application/json",E.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var b;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(b=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var F;(function(a){a.scheme=T.Schemas.vscodeNotebookCell;const S=/^ch(\d{7,})/;function P(U,$){return U.with({scheme:a.scheme,fragment:`ch${$.toString().padStart(7,"0")}${U.scheme!==T.Schemas.file?U.scheme:""}`})}a.generate=P;function N(U){if(U.scheme!==a.scheme)return;const $=S.exec(U.fragment);return $?{handle:Number($[1]),notebook:U.with({scheme:U.fragment.substring($[0].length)||T.Schemas.file,fragment:null})}:void 0}a.parse=N;function B(U,$,V){return U.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`ch${$.toString().padStart(7,"0")},${V??""},${U.scheme!==T.Schemas.file?U.scheme:""}`})}a.generateCellOutputUri=B;function _(U){if(U.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const $=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(U.fragment);if(!$)return;const V=Number($[1]),ue=$[2]&&$[2]!==""?$[2]:void 0,K=$[3];return{handle:V,outputId:ue,notebook:U.with({scheme:K||T.Schemas.file,fragment:null})}}a.parseCellOutputUri=_;function O(U,$,V){return U.with({scheme:V,fragment:`ch${$.toString().padStart(7,"0")}${U.scheme!==T.Schemas.file?U.scheme:""}`})}a.generateCellUri=O;function z(U,$){if(U.scheme!==$)return;const V=S.exec(U.fragment);return V?{handle:Number(V[1]),notebook:U.with({scheme:U.fragment.substring(V[0].length)||T.Schemas.file,fragment:null})}:void 0}a.parseCellUri=z})(F=e.CellUri||(e.CellUri={}));const y=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function f(a){return y.get(a)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=f;function d(a){return y.get(a)?.supportedByCore??!1}e.mimeTypeSupportedByCore=d;function D(a){return y.get(a)?.mergeable??!1}e.mimeTypeIsMergeable=D;const l=a=>I.isWindows?a.replace(/\//g,"\\"):a;class M{constructor(S=[],P=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=P,this.order=[...new Set(S)].map(N=>({pattern:N,matches:s.parse(l(N))}))}sort(S){const P=new Map(t.Iterable.map(S,B=>[B,l(B)]));let N=[];for(const{matches:B}of this.order)for(const[_,O]of P)if(B(O)){N.push(_),P.delete(_);break}return P.size&&(N=N.concat([...P.keys()].sort((B,_)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(_)))),N}prioritize(S,P){const N=this.findIndex(S);if(N===-1){this.order.unshift({pattern:S,matches:s.parse(l(S))});return}const B=new Set(P.map(O=>this.findIndex(O,N)));B.delete(-1);const _=Array.from(B).sort();this.order.splice(N+1,0,..._.map(O=>this.order[O]));for(let O=_.length-1;O>=0;O--)this.order.splice(_[O],1)}toArray(){return this.order.map(S=>S.pattern)}findIndex(S,P=this.order.length){const N=l(S);for(let B=0;B<P;B++)if(this.order[B].matches(N))return B;return-1}}e.MimeTypeDisplayOrder=M;function r(a,S,P,N=(B,_)=>B===_){const B=[];function _(U,$,V){if($===0&&V.length===0)return;const ue=B[B.length-1];ue&&ue.start+ue.deleteCount===U?(ue.deleteCount+=$,ue.toInsert.push(...V)):B.push({start:U,deleteCount:$,toInsert:V})}let O=0,z=0;for(;;){if(O===a.length){_(O,0,S.slice(z));break}if(z===S.length){_(O,a.length-O,[]);break}const U=a[O],$=S[z];if(N(U,$)){O+=1,z+=1;continue}P($)?(_(O,1,[]),O+=1):(_(O,0,[$]),z+=1)}return B}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(a){a.default="default",a.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function p(a){const S=a;return!!((typeof S.include=="string"||s.isRelativePattern(S.include))&&(typeof S.exclude=="string"||s.isRelativePattern(S.exclude)))}e.isDocumentExcludePattern=p;function m(a,S,P){if(Array.isArray(a.viewType)&&a.viewType.indexOf(S)>=0||a.viewType===S)return!0;if(a.filenamePattern){const N=p(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,B=p(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(s.match(N,(0,k.basename)(P.fsPath).toLowerCase()))return!(B&&s.match(B,(0,k.basename)(P.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=m;class h{constructor(S){this.textModel=S}getElements(){const S=new Int32Array(this.textModel.cells.length);for(let P=0;P<this.textModel.cells.length;P++)S[P]=this.textModel.cells[P].getHashValue();return S}}e.CellSequence=h,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var w;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class v{static create(S){return`${v._prefix}${S}`}static parse(S){if(S.startsWith(v._prefix))return S.substring(v._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=v,v._prefix="notebook/"}),define(ye[158],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(ye[159],_e([0,1,3,45]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,s.createDecorator)(e.OUTPUT_SERVICE_ID);var E;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(E=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ye[160],_e([0,1,128,3,45]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,s.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,s.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,s.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ye[161],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function s(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=s;function t(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=t}),define(ye[88],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var s;(function(b){b[b.Unset=0]="Unset",b[b.Queued=1]="Queued",b[b.Running=2]="Running",b[b.Passed=3]="Passed",b[b.Failed=4]="Failed",b[b.Skipped=5]="Skipped",b[b.Errored=6]="Errored"})(s=e.TestResultState||(e.TestResultState={}));var t;(function(b){b[b.Run=2]="Run",b[b.Debug=4]="Debug",b[b.Coverage=8]="Coverage",b[b.HasNonDefaultProfile=16]="HasNonDefaultProfile",b[b.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(b){b[b.Error=0]="Error",b[b.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var T;(function(b){b[b.NotExpandable=0]="NotExpandable",b[b.Expandable=1]="Expandable",b[b.BusyExpanding=2]="BusyExpanding",b[b.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(b,n)=>{n.expand!==void 0&&(b.expand=n.expand),n.item!==void 0&&(b.item=b.item?Object.assign(b.item,n.item):n.item)};e.applyTestItemUpdate=k;var I;(function(b){b[b.Function=0]="Function",b[b.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var C;(function(b){b[b.Add=0]="Add",b[b.Update=1]="Update",b[b.Remove=2]="Remove",b[b.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",b[b.Retire=4]="Retire",b[b.AddTag=5]="AddTag",b[b.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(n){}update(n){}remove(n,g){}complete(){}}e.IncrementalChangeCollector=A;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const g=this.createChangeCollector();for(const o of n)switch(o[0]){case 0:{const c=o[1];if(c.parent){if(this.items.has(c.parent)){const u=this.items.get(c.parent);u.children.add(c.item.extId);const F=this.createItem(c,u);this.items.set(c.item.extId,F),g.add(F)}}else{const u=this.createItem(c);this.roots.add(u),this.items.set(c.item.extId,u),g.add(u)}c.expand===2&&this.busyControllerCount++;break}case 1:{const c=o[1],u=this.items.get(c.extId);if(!u)break;c.expand!==void 0&&(u.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(u,c),g.update(u);break}case 2:{const c=this.items.get(o[1]);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c);const u=[[o[1]]];for(;u.length;)for(const F of u.pop()){const y=this.items.get(F);y&&(u.push(y.children),this.items.delete(F),g.remove(y,y!==c),y.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}g.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=R}),define(ye[67],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(T){T.Delimiter="\0"})(s=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class E{constructor(k,I=k.length){if(this.path=k,this.viewEnd=I,k.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,I,C=k.parent){if(k.id===I)return new E([I]);let A=[k.id];for(let R=C;R&&R.id!==I;R=R.parent)A.push(R.id);return A.push(I),new E(A.reverse())}static isRoot(k){return!k.includes("\0")}static fromString(k){return new E(k.split("\0"))}static join(k,I){return new E([...k.path,I])}static joinToString(k,I){return k.toString()+"\0"+I}static compare(k,I){return k===I?0:I.startsWith(k+"\0")?2:k.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new E(this.path,k)}compare(k){if(typeof k=="string")return E.compare(this.toString(),k);for(let I=0;I<k.viewEnd&&I<this.viewEnd;I++)if(k.path[I]!==this.path[I])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=E}),define(ye[162],_e([0,1,17,89,10,26,23,78,129]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(b,n,g){this._contributedVariables=new Map,this._context=b,this._labelService=n,g&&(this._envVariablesPromise=g.then(o=>this.prepareEnv(o)))}prepareEnv(b){if(k.isWindows){const n=Object.create(null);return Object.keys(b).forEach(g=>{n[g.toLowerCase()]=b[g]}),n}return b}resolveWithEnvironment(b,n,g){return this.recursiveResolve(this.prepareEnv(b),n?n.uri:void 0,g)}async resolveAsync(b,n){return this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,n)}async resolveAnyBase(b,n,g,o){const c=T.deepClone(n);return k.isWindows&&c.windows?Object.keys(c.windows).forEach(u=>c[u]=c.windows[u]):k.isMacintosh&&c.osx?Object.keys(c.osx).forEach(u=>c[u]=c.osx[u]):k.isLinux&&c.linux&&Object.keys(c.linux).forEach(u=>c[u]=c.linux[u]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,c,g,o)}async resolveAnyAsync(b,n,g){return this.resolveAnyBase(b,n,g)}async resolveAnyMap(b,n,g){const o=new Map;return{newConfig:await this.resolveAnyBase(b,n,g,o),resolvedVariables:o}}resolveWithInteractionReplace(b,n,g,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,n,g,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,n){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,n)}recursiveResolve(b,n,g,o,c){if(E.isString(g))return this.resolveString(b,n,g,o,c);if(E.isArray(g))return g.map(u=>this.recursiveResolve(b,n,u,o,c));if(E.isObject(g)){let u=Object.create(null);return Object.keys(g).forEach(F=>{const y=this.resolveString(b,n,F,o,c);u[y]=this.recursiveResolve(b,n,g[F],o,c)}),u}return g}resolveString(b,n,g,o,c){return g.replace(A.VARIABLE_REGEXP,(F,y)=>{if(y.includes(A.VARIABLE_LHS))return F;let f=this.evaluateSingleVariable(b,F,y,n,o);return c&&c.set(y,f),f!==F&&E.isString(f)&&f.match(A.VARIABLE_REGEXP)&&(f=this.resolveString(b,n,f,o,c)),f})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,n,g,o,c){let u;const F=g.split(":");F.length>1&&(g=F[0],u=F[1]);const y=()=>{const D=this._context.getFilePath();if(D)return D;throw new Error((0,C.localize)(0,null,n))},f=()=>{const D=y();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,C.localize)(1,null,n,s.basename(D)))},d=()=>{if(u){const D=this._context.getFolderUri(u);if(D)return D;throw new Error((0,C.localize)(2,null,n,u))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,n)):new Error((0,C.localize)(4,null,n))};switch(g){case"env":if(u){if(b){const D=b[k.isWindows?u.toLowerCase():u];if(E.isString(D))return D}return""}throw new Error((0,C.localize)(5,null,n));case"config":if(u){const D=this._context.getConfigurationValue(o,u);if(E.isUndefinedOrNull(D))throw new Error((0,C.localize)(6,null,n,u));if(E.isObject(D))throw new Error((0,C.localize)(7,null,n,u));return D}throw new Error((0,C.localize)(8,null,n));case"command":return this.resolveFromMap(n,u,c,"command");case"input":return this.resolveFromMap(n,u,c,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return o||u?(0,I.normalizeDriveLetter)(this.fsPath(d())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return s.basename(this.fsPath(d()));case"lineNumber":{const D=this._context.getLineNumber();if(D)return D;throw new Error((0,C.localize)(9,null,n))}case"selectedText":{const D=this._context.getSelectedText();if(D)return D;throw new Error((0,C.localize)(10,null,n))}case"file":return y();case"fileWorkspaceFolder":return f();case"relativeFile":return o||u?s.relative(this.fsPath(d()),y()):y();case"relativeFileDirname":{const D=s.dirname(y());if(o||u){const l=s.relative(this.fsPath(d()),D);return l.length===0?".":l}return D}case"fileDirname":return s.dirname(y());case"fileExtname":return s.extname(y());case"fileBasename":return s.basename(y());case"fileBasenameNoExtension":{const D=s.basename(y());return D.slice(0,D.length-s.extname(D).length)}case"fileDirnameBasename":return s.basename(s.dirname(y()));case"execPath":{const D=this._context.getExecPath();return D||n}case"execInstallFolder":{const D=this._context.getAppRoot();return D||n}case"pathSeparator":return s.sep;default:try{const D=u?`${g}:${u}`:g;return this.resolveFromMap(n,D,c,void 0)}catch{return n}}}}resolveFromMap(b,n,g,o){if(n&&g){const c=o===void 0?g[n]:g[o+":"+n];if(typeof c=="string")return c;throw new Error((0,C.localize)(11,null,b))}return b}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[90],_e([0,1,3,154]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var E;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var T;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var I;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function A(o){const c=o;return(0,t.isEditorInput)(c?.editor)&&(0,t.isEditorInput)(c?.replacement)}e.isEditorReplacement=A;var R;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function n(o){const c=o;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.isEditorGroup=n;function g(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=g}),define(ye[163],_e([0,1,3,90]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(T){const k=T;return typeof T=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=E}),define(ye[8],_e([0,1,16,22,77,225,55,26,10,2,59,58,130,82,48,87,67,163,7]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(ne){function ge(W){const{selectionStartLineNumber:we,selectionStartColumn:Pe,positionLineNumber:Ye,positionColumn:xe}=W,ut=new y.Position(we-1,Pe-1),bt=new y.Position(Ye-1,xe-1);return new y.Selection(ut,bt)}ne.to=ge;function te(W){const{anchor:we,active:Pe}=W;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ne.from=te})(f=e.Selection||(e.Selection={}));var d;(function(ne){function ge(W){if(!W)return;const{start:we,end:Pe}=W;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ne.from=ge;function te(W){if(!W)return;const{startLineNumber:we,startColumn:Pe,endLineNumber:Ye,endColumn:xe}=W;return new y.Range(we-1,Pe-1,Ye-1,xe-1)}ne.to=te})(d=e.Range||(e.Range={}));var D;(function(ne){function ge(te){switch(te){case 1:return y.StandardTokenType.Comment;case 0:return y.StandardTokenType.Other;case 3:return y.StandardTokenType.RegEx;case 2:return y.StandardTokenType.String}}ne.to=ge})(D=e.TokenType||(e.TokenType={}));var l;(function(ne){function ge(W){return new y.Position(W.lineNumber-1,W.column-1)}ne.to=ge;function te(W){return{lineNumber:W.line+1,column:W.character+1}}ne.from=te})(l=e.Position||(e.Position={}));var M;(function(ne){function ge(we,Pe){return(0,s.coalesce)((0,s.asArray)(we).map(Ye=>te(Ye,Pe)))}ne.from=ge;function te(we,Pe){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:W(we.scheme,Pe),pattern:typeof we.pattern=="undefined"?void 0:Q.from(we.pattern),exclusive:we.exclusive}}function W(we,Pe){return Pe&&typeof we=="string"?Pe.transformOutgoingScheme(we):we}})(M=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ne){function ge(W){switch(W){case y.DiagnosticTag.Unnecessary:return 1;case y.DiagnosticTag.Deprecated:return 2}}ne.from=ge;function te(W){switch(W){case 1:return y.DiagnosticTag.Unnecessary;case 2:return y.DiagnosticTag.Deprecated;default:return}}ne.to=te})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ne){function ge(W){let we;return W.code&&((0,C.isString)(W.code)||(0,C.isNumber)(W.code)?we=String(W.code):we={value:String(W.code.value),target:W.code.target}),{...d.from(W.range),message:W.message,source:W.source,code:we,severity:m.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(p.from),tags:Array.isArray(W.tags)?(0,s.coalesce)(W.tags.map(r.from)):void 0}}ne.from=ge;function te(W){const we=new y.Diagnostic(d.to(W),W.message,m.to(W.severity));return we.source=W.source,we.code=(0,C.isString)(W.code)?W.code:W.code?.value,we.relatedInformation=W.relatedInformation&&W.relatedInformation.map(p.to),we.tags=W.tags&&(0,s.coalesce)(W.tags.map(r.to)),we}ne.to=te})(i=e.Diagnostic||(e.Diagnostic={}));var p;(function(ne){function ge(W){return{...d.from(W.location.range),message:W.message,resource:W.location.uri}}ne.from=ge;function te(W){return new y.DiagnosticRelatedInformation(new y.Location(W.resource,d.to(W)),W.message)}ne.to=te})(p=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var m;(function(ne){function ge(W){switch(W){case y.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ne.from=ge;function te(W){switch(W){case g.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}ne.to=te})(m=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(ne){function ge(W){return typeof W=="number"&&W>=y.ViewColumn.One?W-1:W===y.ViewColumn.Beside?F.SIDE_GROUP:F.ACTIVE_GROUP}ne.from=ge;function te(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=te})(h=e.ViewColumn||(e.ViewColumn={}));function w(ne){return typeof ne.range!="undefined"}function v(ne){return ne.length===0?!0:!!w(ne[0])}e.isDecorationOptionsArr=v;var a;(function(ne){function ge(xe){return xe.map(ne.from)}ne.fromMany=ge;function te(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function W(xe){let ut;if(te(xe)){const{language:ft,value:pt}=xe;ut={value:"```"+ft+`
`+pt+"\n```\n"}}else y.MarkdownString.isMarkdownString(xe)?ut={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ut={value:xe}:ut={value:""};const bt=Object.create(null);ut.uris=bt;const Ct=ft=>{try{let pt=A.URI.parse(ft,!0);pt=pt.with({query:we(pt.query,bt)}),bt[ft]=pt}catch{}return""},wt=new T.Renderer;return wt.link=Ct,wt.image=ft=>Ct(E.parseHrefAndDimensions(ft).href),T(ut.value,{renderer:wt}),ut}ne.from=W;function we(xe,ut){if(!xe)return xe;let bt;try{bt=(0,k.parse)(xe)}catch{}if(!bt)return xe;let Ct=!1;return bt=(0,I.cloneAndChange)(bt,wt=>{if(A.URI.isUri(wt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=wt,Ct=!0,ft}else return}),Ct?JSON.stringify(bt):xe}function Pe(xe){const ut=new y.MarkdownString(xe.value,xe.supportThemeIcons);return ut.isTrusted=xe.isTrusted,ut.supportHtml=xe.supportHtml,ut}ne.to=Pe;function Ye(xe){if(!!xe)return typeof xe=="string"?xe:ne.from(xe)}ne.fromStrict=Ye})(a=e.MarkdownString||(e.MarkdownString={}));function S(ne){return v(ne)?ne.map(ge=>({range:d.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?a.fromMany(ge.hoverMessage):ge.hoverMessage?a.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):ne.map(ge=>({range:d.from(ge)}))}e.fromRangeOrRangeWithMessage=S;function P(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?A.URI.file(ne):ne}e.pathOrURIToURI=P;var N;(function(ne){function ge(te){return typeof te=="undefined"?te:{contentText:te.contentText,contentIconPath:te.contentIconPath?P(te.contentIconPath):void 0,border:te.border,borderColor:te.borderColor,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,color:te.color,backgroundColor:te.backgroundColor,margin:te.margin,width:te.width,height:te.height}}ne.from=ge})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(ne){function ge(te){return typeof te=="undefined"?te:{backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?P(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?N.from(te.before):void 0,after:te.after?N.from(te.after):void 0}}ne.from=ge})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var _;(function(ne){function ge(te){if(typeof te=="undefined")return te;switch(te){case y.DecorationRangeBehavior.OpenOpen:return 0;case y.DecorationRangeBehavior.ClosedClosed:return 1;case y.DecorationRangeBehavior.OpenClosed:return 2;case y.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=ge})(_=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(ne){function ge(te){return{isWholeLine:te.isWholeLine,rangeBehavior:te.rangeBehavior?_.from(te.rangeBehavior):void 0,overviewRulerLane:te.overviewRulerLane,light:te.light?B.from(te.light):void 0,dark:te.dark?B.from(te.dark):void 0,backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?P(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?N.from(te.before):void 0,after:te.after?N.from(te.after):void 0}}ne.from=ge})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ne){function ge(W){return{text:W.newText,eol:W.newEol&&lt.from(W.newEol),range:d.from(W.range)}}ne.from=ge;function te(W){const we=new y.TextEdit(d.to(W.range),W.text);return we.newEol=typeof W.eol=="undefined"?void 0:lt.to(W.eol),we}ne.to=te})(z=e.TextEdit||(e.TextEdit={}));var U;(function(ne){function ge(W,we,Pe){const Ye={edits:[]};if(W instanceof y.WorkspaceEdit)for(let xe of W._allEntries())if(xe._type===1)Ye.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ut=we?.getDocument(xe.uri);Ye.edits.push({_type:2,resource:xe.uri,edit:z.from(xe.edit),modelVersionId:ut?.version,metadata:xe.metadata})}else xe._type===3?Ye.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Ye.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:Pe?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Je.from)}});return Ye}ne.from=ge;function te(W){const we=new y.WorkspaceEdit;for(const Pe of W.edits)Pe.edit?we.replace(A.URI.revive(Pe.resource),d.to(Pe.edit.range),Pe.edit.text):we.renameFile(A.URI.revive(Pe.oldUri),A.URI.revive(Pe.newUri),Pe.options);return we}ne.to=te})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(ne){const ge=Object.create(null);ge[y.SymbolKind.File]=0,ge[y.SymbolKind.Module]=1,ge[y.SymbolKind.Namespace]=2,ge[y.SymbolKind.Package]=3,ge[y.SymbolKind.Class]=4,ge[y.SymbolKind.Method]=5,ge[y.SymbolKind.Property]=6,ge[y.SymbolKind.Field]=7,ge[y.SymbolKind.Constructor]=8,ge[y.SymbolKind.Enum]=9,ge[y.SymbolKind.Interface]=10,ge[y.SymbolKind.Function]=11,ge[y.SymbolKind.Variable]=12,ge[y.SymbolKind.Constant]=13,ge[y.SymbolKind.String]=14,ge[y.SymbolKind.Number]=15,ge[y.SymbolKind.Boolean]=16,ge[y.SymbolKind.Array]=17,ge[y.SymbolKind.Object]=18,ge[y.SymbolKind.Key]=19,ge[y.SymbolKind.Null]=20,ge[y.SymbolKind.EnumMember]=21,ge[y.SymbolKind.Struct]=22,ge[y.SymbolKind.Event]=23,ge[y.SymbolKind.Operator]=24,ge[y.SymbolKind.TypeParameter]=25;function te(we){return typeof ge[we]=="number"?ge[we]:6}ne.from=te;function W(we){for(const Pe in ge)if(ge[Pe]===we)return Number(Pe);return y.SymbolKind.Property}ne.to=W})($=e.SymbolKind||(e.SymbolKind={}));var V;(function(ne){function ge(W){switch(W){case y.SymbolTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return y.SymbolTag.Deprecated}}ne.to=te})(V=e.SymbolTag||(e.SymbolTag={}));var ue;(function(ne){function ge(W){return{name:W.name,kind:$.from(W.kind),tags:W.tags&&W.tags.map(V.from),containerName:W.containerName,location:ae.from(W.location)}}ne.from=ge;function te(W){const we=new y.SymbolInformation(W.name,$.to(W.kind),W.containerName,ae.to(W.location));return we.tags=W.tags&&W.tags.map(V.to),we}ne.to=te})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(ne){function ge(W){const we={name:W.name||"!!MISSING: name!!",detail:W.detail,range:d.from(W.range),selectionRange:d.from(W.selectionRange),kind:$.from(W.kind),tags:W.tags?.map(V.from)??[]};return W.children&&(we.children=W.children.map(ge)),we}ne.from=ge;function te(W){const we=new y.DocumentSymbol(W.name,W.detail,$.to(W.kind),d.to(W.range),d.to(W.selectionRange));return(0,s.isNonEmptyArray)(W.tags)&&(we.tags=W.tags.map(V.to)),W.children&&(we.children=W.children.map(te)),we}ne.to=te})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(ne){function ge(W){const we=new y.CallHierarchyItem($.to(W.kind),W.name,W.detail||"",A.URI.revive(W.uri),d.to(W.range),d.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}ne.to=ge;function te(W,we,Pe){if(we=we??W._sessionId,Pe=Pe??W._itemId,we===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Pe,name:W.name,detail:W.detail,kind:$.from(W.kind),uri:W.uri,range:d.from(W.range),selectionRange:d.from(W.selectionRange),tags:W.tags?.map(V.from)}}ne.from=te})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(ne){function ge(te){return new y.CallHierarchyIncomingCall(re.to(te.from),te.fromRanges.map(W=>d.to(W)))}ne.to=ge})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(ne){function ge(te){return new y.CallHierarchyOutgoingCall(re.to(te.to),te.fromRanges.map(W=>d.to(W)))}ne.to=ge})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ae;(function(ne){function ge(W){return{range:W.range&&d.from(W.range),uri:W.uri}}ne.from=ge;function te(W){return new y.Location(A.URI.revive(W.uri),d.to(W.range))}ne.to=te})(ae=e.location||(e.location={}));var le;(function(ne){function ge(W){const we=W,Pe=W;return{originSelectionRange:we.originSelectionRange?d.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:Pe.uri,range:d.from(we.targetRange?we.targetRange:Pe.range),targetSelectionRange:we.targetSelectionRange?d.from(we.targetSelectionRange):void 0}}ne.from=ge;function te(W){return{targetUri:A.URI.revive(W.uri),targetRange:d.to(W.range),targetSelectionRange:W.targetSelectionRange?d.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?d.to(W.originSelectionRange):void 0}}ne.to=te})(le=e.DefinitionLink||(e.DefinitionLink={}));var Ce;(function(ne){function ge(W){return{range:d.from(W.range),contents:a.fromMany(W.contents)}}ne.from=ge;function te(W){return new y.Hover(W.contents.map(a.to),d.to(W.range))}ne.to=te})(Ce=e.Hover||(e.Hover={}));var Ee;(function(ne){function ge(W){return{range:d.from(W.range),expression:W.expression}}ne.from=ge;function te(W){return new y.EvaluatableExpression(d.to(W.range),W.expression)}ne.to=te})(Ee=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Fe;(function(ne){function ge(W){if(W instanceof y.InlineValueText)return{type:"text",range:d.from(W.range),text:W.text};if(W instanceof y.InlineValueVariableLookup)return{type:"variable",range:d.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof y.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=ge;function te(W){switch(W.type){case"text":return{range:d.to(W.range),text:W.text};case"variable":return{range:d.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:d.to(W.range),expression:W.expression}}}ne.to=te})(Fe=e.InlineValue||(e.InlineValue={}));var $e;(function(ne){function ge(W){return{frameId:W.frameId,stoppedLocation:d.from(W.stoppedLocation)}}ne.from=ge;function te(W){return new y.InlineValueContext(W.frameId,d.to(W.stoppedLocation))}ne.to=te})($e=e.InlineValueContext||(e.InlineValueContext={}));var Ve;(function(ne){function ge(W){return{range:d.from(W.range),kind:W.kind}}ne.from=ge;function te(W){return new y.DocumentHighlight(d.to(W.range),W.kind)}ne.to=te})(Ve=e.DocumentHighlight||(e.DocumentHighlight={}));var je;(function(ne){function ge(te){switch(te){case 1:return y.CompletionTriggerKind.TriggerCharacter;case 2:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return y.CompletionTriggerKind.Invoke}}ne.to=ge})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var H;(function(ne){function ge(te){return{triggerKind:je.to(te.triggerKind),triggerCharacter:te.triggerCharacter}}ne.to=ge})(H=e.CompletionContext||(e.CompletionContext={}));var G;(function(ne){function ge(W){switch(W){case y.CompletionItemTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return y.CompletionItemTag.Deprecated}}ne.to=te})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(ne){const ge=new Map([[y.CompletionItemKind.Method,0],[y.CompletionItemKind.Function,1],[y.CompletionItemKind.Constructor,2],[y.CompletionItemKind.Field,3],[y.CompletionItemKind.Variable,4],[y.CompletionItemKind.Class,5],[y.CompletionItemKind.Interface,7],[y.CompletionItemKind.Struct,6],[y.CompletionItemKind.Module,8],[y.CompletionItemKind.Property,9],[y.CompletionItemKind.Unit,12],[y.CompletionItemKind.Value,13],[y.CompletionItemKind.Constant,14],[y.CompletionItemKind.Enum,15],[y.CompletionItemKind.EnumMember,16],[y.CompletionItemKind.Keyword,17],[y.CompletionItemKind.Snippet,27],[y.CompletionItemKind.Text,18],[y.CompletionItemKind.Color,19],[y.CompletionItemKind.File,20],[y.CompletionItemKind.Reference,21],[y.CompletionItemKind.Folder,23],[y.CompletionItemKind.Event,10],[y.CompletionItemKind.Operator,11],[y.CompletionItemKind.TypeParameter,24],[y.CompletionItemKind.Issue,26],[y.CompletionItemKind.User,25]]);function te(Pe){return ge.get(Pe)??9}ne.from=te;const W=new Map([[0,y.CompletionItemKind.Method],[1,y.CompletionItemKind.Function],[2,y.CompletionItemKind.Constructor],[3,y.CompletionItemKind.Field],[4,y.CompletionItemKind.Variable],[5,y.CompletionItemKind.Class],[7,y.CompletionItemKind.Interface],[6,y.CompletionItemKind.Struct],[8,y.CompletionItemKind.Module],[9,y.CompletionItemKind.Property],[12,y.CompletionItemKind.Unit],[13,y.CompletionItemKind.Value],[14,y.CompletionItemKind.Constant],[15,y.CompletionItemKind.Enum],[16,y.CompletionItemKind.EnumMember],[17,y.CompletionItemKind.Keyword],[27,y.CompletionItemKind.Snippet],[18,y.CompletionItemKind.Text],[19,y.CompletionItemKind.Color],[20,y.CompletionItemKind.File],[21,y.CompletionItemKind.Reference],[23,y.CompletionItemKind.Folder],[10,y.CompletionItemKind.Event],[11,y.CompletionItemKind.Operator],[24,y.CompletionItemKind.TypeParameter],[25,y.CompletionItemKind.User],[26,y.CompletionItemKind.Issue]]);function we(Pe){return W.get(Pe)??y.CompletionItemKind.Property}ne.to=we})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var oe;(function(ne){function ge(te,W){const we=new y.CompletionItem(te.label);return we.insertText=te.insertText,we.kind=X.to(te.kind),we.tags=te.tags?.map(G.to),we.detail=te.detail,we.documentation=E.isMarkdownString(te.documentation)?a.to(te.documentation):te.documentation,we.sortText=te.sortText,we.filterText=te.filterText,we.preselect=te.preselect,we.commitCharacters=te.commitCharacters,R.Range.isIRange(te.range)?we.range=d.to(te.range):typeof te.range=="object"&&(we.range={inserting:d.to(te.range.insert),replacing:d.to(te.range.replace)}),we.keepWhitespace=typeof te.insertTextRules=="undefined"?!1:Boolean(te.insertTextRules&1),typeof te.insertTextRules!="undefined"&&te.insertTextRules&4?we.insertText=new y.SnippetString(te.insertText):(we.insertText=te.insertText,we.textEdit=we.range instanceof y.Range?new y.TextEdit(we.range,we.insertText):void 0),te.additionalTextEdits&&te.additionalTextEdits.length>0&&(we.additionalTextEdits=te.additionalTextEdits.map(Pe=>z.to(Pe))),we.command=W&&te.command?W.fromInternal(te.command):void 0,we}ne.to=ge})(oe=e.CompletionItem||(e.CompletionItem={}));var q;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?a.fromStrict(W.documentation):void 0}}ne.from=ge;function te(W){return{label:W.label,documentation:E.isMarkdownString(W.documentation)?a.to(W.documentation):W.documentation}}ne.to=te})(q=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?a.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(q.from):[],activeParameter:W.activeParameter}}ne.from=ge;function te(W){return{label:W.label,documentation:E.isMarkdownString(W.documentation)?a.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(q.to):[],activeParameter:W.activeParameter}}ne.to=te})(ee=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(ne){function ge(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(ee.from):[]}}ne.from=ge;function te(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(ee.to):[]}}ne.to=te})(he=e.SignatureHelp||(e.SignatureHelp={}));var Re;(function(ne){function ge(W){return{text:W.text,position:l.from(W.position),kind:Ue.from(W.kind??y.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}ne.from=ge;function te(W){const we=new y.InlayHint(W.text,l.to(W.position),Ue.to(W.kind));return we.whitespaceAfter=W.whitespaceAfter,we.whitespaceBefore=W.whitespaceBefore,we}ne.to=te})(Re=e.InlayHint||(e.InlayHint={}));var Ue;(function(ne){function ge(W){return W}ne.from=ge;function te(W){return W}ne.to=te})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(ne){function ge(W){return{range:d.from(W.range),url:W.target,tooltip:W.tooltip}}ne.from=ge;function te(W){let we;if(W.url)try{we=typeof W.url=="string"?A.URI.parse(W.url,!0):A.URI.revive(W.url)}catch{}return new y.DocumentLink(d.to(W.range),we)}ne.to=te})(ze=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ne){function ge(W){const we=new y.ColorPresentation(W.label);return W.textEdit&&(we.textEdit=z.to(W.textEdit)),W.additionalTextEdits&&(we.additionalTextEdits=W.additionalTextEdits.map(Pe=>z.to(Pe))),we}ne.to=ge;function te(W){return{label:W.label,textEdit:W.textEdit?z.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(we=>z.from(we)):void 0}}ne.from=te})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ne){function ge(W){return new y.Color(W[0],W[1],W[2],W[3])}ne.to=ge;function te(W){return[W.red,W.green,W.blue,W.alpha]}ne.from=te})(et=e.Color||(e.Color={}));var st;(function(ne){function ge(W){return{range:d.from(W.range)}}ne.from=ge;function te(W){return new y.SelectionRange(d.to(W.range))}ne.to=te})(st=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(ne){function ge(te){switch(te){case 2:return y.TextDocumentSaveReason.AfterDelay;case 1:return y.TextDocumentSaveReason.Manual;case 3:case 4:return y.TextDocumentSaveReason.FocusOut}}ne.to=ge})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ne){function ge(W){switch(W){case y.TextEditorLineNumbersStyle.Off:return 0;case y.TextEditorLineNumbersStyle.Relative:return 2;case y.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=ge;function te(W){switch(W){case 0:return y.TextEditorLineNumbersStyle.Off;case 2:return y.TextEditorLineNumbersStyle.Relative;case 1:default:return y.TextEditorLineNumbersStyle.On}}ne.to=te})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var lt;(function(ne){function ge(W){if(W===y.EndOfLine.CRLF)return 1;if(W===y.EndOfLine.LF)return 0}ne.from=ge;function te(W){if(W===1)return y.EndOfLine.CRLF;if(W===0)return y.EndOfLine.LF}ne.to=te})(lt=e.EndOfLine||(e.EndOfLine={}));var vt;(function(ne){function ge(te){if(typeof te=="object")return te.viewId;switch(te){case y.ProgressLocation.SourceControl:return 3;case y.ProgressLocation.Window:return 10;case y.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=ge})(vt=e.ProgressLocation||(e.ProgressLocation={}));var Oe;(function(ne){function ge(te){const W={start:te.start+1,end:te.end+1};return te.kind&&(W.kind=Rt.from(te.kind)),W}ne.from=ge})(Oe=e.FoldingRange||(e.FoldingRange={}));var Rt;(function(ne){function ge(te){if(te)switch(te){case y.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}ne.from=ge})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var j;(function(ne){function ge(te){if(te)return{pinned:typeof te.preview=="boolean"?!te.preview:void 0,inactive:te.background,preserveFocus:te.preserveFocus,selection:typeof te.selection=="object"?d.from(te.selection):void 0,override:typeof te.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=ge})(j=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(ne){function ge(W){return W instanceof y.RelativePattern||typeof W=="string"?W:te(W)?new y.RelativePattern(W.base,W.pattern):W}ne.from=ge;function te(W){const we=W;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(Q=e.GlobPattern||(e.GlobPattern={}));var fe;(function(ne){function ge(te){if(te){if(Array.isArray(te))return te.map(ge);if(typeof te=="string")return te;{const W=te;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:Q.from(W.pattern),exclusive:W.exclusive}}}else return}ne.from=ge})(fe=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(ne){function ge(W){return{start:W.start,end:W.end}}ne.from=ge;function te(W){return new y.NotebookRange(W.start,W.end)}ne.to=te})(Ne=e.NotebookRange||(e.NotebookRange={}));var qe;(function(ne){function ge(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ne.to=ge;function te(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ne.from=te})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ot;(function(ne){function ge(W){switch(W){case y.NotebookCellKind.Markup:return c.CellKind.Markup;case y.NotebookCellKind.Code:default:return c.CellKind.Code}}ne.from=ge;function te(W){switch(W){case c.CellKind.Markup:return y.NotebookCellKind.Markup;case c.CellKind.Code:default:return y.NotebookCellKind.Code}}ne.to=te})(ot=e.NotebookCellKind||(e.NotebookCellKind={}));var ht;(function(ne){function ge(W){const we={metadata:W.metadata??Object.create(null),cells:[]};for(let Pe of W.cells)y.NotebookCellData.validate(Pe),we.cells.push(Je.from(Pe));return we}ne.from=ge;function te(W){const we=new y.NotebookData(W.cells.map(Je.to));return(0,C.isEmptyObject)(W.metadata)||(we.metadata=W.metadata),we}ne.to=te})(ht=e.NotebookData||(e.NotebookData={}));var Je;(function(ne){function ge(W){return{cellKind:ot.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:qe.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Ae.from):[]}}ne.from=ge;function te(W){return new y.NotebookCellData(ot.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Ae.to):void 0,W.metadata,W.internalMetadata?qe.to(W.internalMetadata):void 0)}ne.to=te})(Je=e.NotebookCellData||(e.NotebookCellData={}));var Tt;(function(ne){function ge(W){return{mime:W.mime,valueBytes:t.VSBuffer.wrap(W.data)}}ne.from=ge;function te(W){return new y.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ne.to=te})(Tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(ne){function ge(W){return{outputId:W.id,items:W.items.map(Tt.from),metadata:W.metadata}}ne.from=ge;function te(W){const we=W.items.map(Tt.to);return new y.NotebookCellOutput(we,W.outputId,W.metadata)}ne.to=te})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(ne){function ge(Pe){if(Pe!=null){if(Pe instanceof y.RelativePattern||typeof Pe=="string")return Pe;if(we(Pe))return new y.RelativePattern(Pe.base,Pe.pattern);if(W(Pe))return{include:Q.from(Pe.include)||void 0,exclude:Q.from(Pe.exclude)||void 0}}}ne.from=ge;function te(Pe){return typeof Pe=="string"?Pe:we(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}ne.to=te;function W(Pe){const Ye=Pe,xe=Q.from(Ye.include);if(!(xe&&xe instanceof y.RelativePattern||typeof xe=="string"))return!1;const ut=Q.from(Ye.exclude);return!!(ut&&ut instanceof y.RelativePattern||typeof ut=="string")}function we(Pe){const Ye=Pe;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(ne){function ge(te){return{backgroundColor:te.backgroundColor,borderColor:te.borderColor,top:te.top?N.from(te.top):void 0}}ne.from=ge})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ie;(function(ne){function ge(te,W,we){const Pe=typeof te.command=="string"?{title:"",command:te.command}:te.command;return{alignment:te.alignment===y.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Pe,we),text:te.text,tooltip:te.tooltip,accessibilityInformation:te.accessibilityInformation,priority:te.priority}}ne.from=ge})(ie=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var se;(function(ne){function ge(te){return{transientOutputs:te?.transientOutputs??!1,transientCellMetadata:te?.transientCellMetadata??{},transientDocumentMetadata:te?.transientDocumentMetadata??{}}}ne.from=ge})(se=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(ne){function ge(W){return{uri:W.uri,provides:W.provides}}ne.from=ge;function te(W){return new y.NotebookRendererScript(A.URI.revive(W.uri),W.provides)}ne.to=te})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(ne){function ge(W){return{message:a.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ae.from(W.location):void 0}}ne.from=ge;function te(W){const we=new y.TestMessage(typeof W.message=="string"?W.message:a.to(W.message));return we.actualOutput=W.actual,we.expectedOutput=W.expected,we.location=W.location?ae.to(W.location):void 0,we}ne.to=te})(me=e.TestMessage||(e.TestMessage={}));var Te;(function(ne){let ge;(function(te){te.Delimiter="\0"})(ge||(ge={})),ne.namespace=(te,W)=>te+"\0"+W,ne.denamespace=te=>{const W=te.indexOf("\0");return{ctrlId:te.slice(0,W),tagId:te.slice(W+1)}}})(Te=e.TestTag||(e.TestTag={}));var We;(function(ne){function ge(Pe){const Ye=(0,o.getPrivateApiFor)(Pe).controllerId;return{extId:u.TestId.fromExtHostTestItem(Pe,Ye).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(xe=>Te.namespace(Ye,xe.id)),range:d.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&a.fromStrict(Pe.error)||null}}ne.from=ge;function te(Pe){return{parent:void 0,error:void 0,id:u.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:A.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ye=>{const{tagId:xe}=Te.denamespace(Ye);return new y.TestTag(xe)}),range:d.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}ne.toPlain=te;function W(Pe){const Ye=u.TestId.fromString(Pe.extId),xe=new o.TestItemImpl(Ye.controllerId,Ye.localId,Pe.label,A.URI.revive(Pe.uri));return xe.range=d.to(Pe.range||void 0),xe.description=Pe.description||void 0,xe}function we(Pe){let Ye;for(const xe of Pe.tests){const ut=W(xe.item);(0,o.getPrivateApiFor)(ut).parent=Ye,Ye=ut}return Ye}ne.toItemFromContext=we})(We=e.TestItem||(e.TestItem={})),function(ne){function ge(W){return{id:W.id}}ne.from=ge;function te(W){return new y.TestTag(W.id)}ne.to=te}(Te=e.TestTag||(e.TestTag={}));var Le;(function(ne){const ge=(W,we)=>{const Pe={...We.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(xe=>xe.type===0).map(me.to)})),children:W.children.map(Ye=>we.get(Ye)).filter(C.isDefined).map(Ye=>ge(Ye,we))};for(const Ye of Pe.children)Ye.parent=Pe;return Pe};function te(W){const we=[],Pe=new Map;for(const Ye of W.items)Pe.set(Ye.item.extId,Ye),W.request.targets.some(xe=>xe.controllerId===Ye.controllerId&&xe.testIds.includes(Ye.item.extId))&&we.push(Ye);return{completedAt:W.completedAt,results:we.map(Ye=>ge(Ye,Pe))}}ne.to=te})(Le=e.TestResults||(e.TestResults={}));var Ke;(function(ne){function ge(Pe){return{covered:Pe.covered,total:Pe.covered}}function te(Pe){return"line"in Pe?l.from(Pe):d.from(Pe)}function W(Pe){return"branches"in Pe?{count:Pe.executionCount,location:te(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&te(Ye.location)})):void 0}:{type:0,count:Pe.executionCount,location:te(Pe.location)}}ne.fromDetailed=W;function we(Pe){return{uri:Pe.uri,statement:ge(Pe.statementCoverage),branch:Pe.branchCoverage&&ge(Pe.branchCoverage),function:Pe.functionCoverage&&ge(Pe.functionCoverage),details:Pe.detailedCoverage?.map(W)}}ne.fromFile=we})(Ke=e.TestCoverage||(e.TestCoverage={}));var it;(function(ne){function ge(te){switch(te){case 1:return y.CodeActionTriggerKind.Invoke;case 2:return y.CodeActionTriggerKind.Automatic}}ne.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var rt;(function(ne){function ge(W){const we=new y.TypeHierarchyItem($.to(W.kind),W.name,W.detail||"",A.URI.revive(W.uri),d.to(W.range),d.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}ne.to=ge;function te(W,we,Pe){if(we=we??W._sessionId,Pe=Pe??W._itemId,we===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Pe,kind:$.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:d.from(W.range),selectionRange:d.from(W.selectionRange),tags:W.tags?.map(V.from)}}ne.from=te})(rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ye[164],_e([0,1,2,15,7,8,226]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(A,R,b,n={timeout:1500,errors:3}){this._logService=A,this._documents=R,this._mainThreadBulkEdits=b,this._thresholds=n,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(R,b,n)=>{const o={dispose:this._callbacks.push([R,b,A])};return Array.isArray(n)&&n.push(o),o}}async $participateInSave(A,R){const b=s.URI.revive(A);let n=!1;const g=setTimeout(()=>n=!0,this._thresholds.timeout),o=[];try{for(let c of[...this._callbacks]){if(n)break;const u=this._documents.getDocument(b),F=await this._deliverEventAsyncAndBlameBadListeners(c,{document:u,reason:T.TextDocumentSaveReason.to(R)});o.push(F)}}finally{clearTimeout(g)}return o}_deliverEventAsyncAndBlameBadListeners([A,R,b],n){const g=this._badListeners.get(A);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,A,R,n).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const c=this._badListeners.get(A);this._badListeners.set(A,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,R,b,n){const g=[],o=Date.now(),{document:c,reason:u}=n,{version:F}=c,y=Object.freeze({document:c,reason:u,waitUntil(f){if(Object.isFrozen(g))throw(0,t.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(f))}});try{R.apply(b,[y])}catch(f){return Promise.reject(f)}return Object.freeze(g),new Promise((f,d)=>{const D=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(D),f(l)}).catch(l=>{clearTimeout(D),d(l)})}).then(f=>{const d={edits:[]};for(const D of f)if(Array.isArray(D)&&D.every(l=>l instanceof E.TextEdit))for(const{newText:l,newEol:M,range:r}of D)d.edits.push({_type:2,resource:c.uri,edit:{range:r&&T.Range.from(r),text:l,eol:M&&T.EndOfLine.from(M)}});if(d.edits.length!==0)return F===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(ye[165],_e([0,1,4,29,2,8,7]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(R,b,n,g,o){this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter,this._config=0,n&&(this._config+=1),g&&(this._config+=2),o&&(this._config+=4);const c=(0,t.parse)(b),u=R(F=>{if(!n)for(let y of F.created){const f=E.URI.revive(y);c(f.fsPath)&&this._onDidCreate.fire(f)}if(!g)for(let y of F.changed){const f=E.URI.revive(y);c(f.fsPath)&&this._onDidChange.fire(f)}if(!o)for(let y of F.deleted){const f=E.URI.revive(y);c(f.fsPath)&&this._onDidDelete.fire(f)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(R,b,n){this._logService=b,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,b,n,g){return new I(this._onFileSystemEvent.event,R,b,n,g)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,b){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,b){return(n,g,o)=>{const c=function(F){n.call(g,F)};return c.extension=R,b.event(c,void 0,o)}}async $onWillRunFileOperation(R,b,n,g){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(o=>({oldUri:E.URI.revive(o.source),newUri:E.URI.revive(o.target)}))},n,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(o=>E.URI.revive(o.target))},n,g);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(o=>E.URI.revive(o.target))},n,g)}}async _fireWillEvent(R,b,n,g){const o=new Set,c=[];if(await R.fireAsync(b,g,async(F,y)=>{const f=Date.now(),d=await Promise.resolve(F);d instanceof k.WorkspaceEdit&&(c.push(d),o.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-f>n&&this._logService.warn("SLOW file-participant",y.extension.identifier)}),g.isCancellationRequested||c.length===0)return;const u={edits:[]};for(let F of c){let{edits:y}=T.WorkspaceEdit.from(F,this._extHostDocumentsAndEditors);u.edits=u.edits.concat(y)}return{edit:u,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=C}),define(ye[166],_e([0,1,11,26,2,8,87]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(b,n,g,o){this.start=b,this.deletedCount=n,this.deletedItems=g,this.items=o}static asApiEvents(b){return b.map(n=>({start:n.start,deletedCount:n.deletedCount,deletedItems:n.deletedItems,items:n.items.map(g=>g.apiCell)}))}}class C{constructor(b,n,g){this.notebook=b,this._extHostDocument=n,this._cellData=g,this.handle=g.handle,this.uri=E.URI.revive(g.uri),this.cellKind=g.cellKind,this._outputs=g.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=g.internalMetadata??{},this._metadata=Object.freeze(g.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(g.internalMetadata??{}))}static asModelAddData(b,n){return{EOL:n.eol,lines:n.source,languageId:n.language,uri:n.uri,isDirty:!1,versionId:1,notebook:b}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,n=this._extHostDocument.getDocument(this.uri);if(!n)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:n.document,get mime(){return b._mime},set mime(g){b._mime=g},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}})}return this._apiCell}setOutputs(b){this._outputs=b.map(T.NotebookCellOutput.to)}setOutputItems(b,n,g){const o=g.map(T.NotebookCellOutputItem.to),c=this._outputs.find(u=>u.id===b);c&&(n||(c.items.length=0),c.items.push(...o))}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=C;class A{constructor(b,n,g,o,c,u){this._proxy=b,this._textDocumentsAndEditors=n,this._textDocuments=g,this._emitter=o,this.uri=c,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=u.viewType,this._metadata=Object.freeze(u.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,u.cells]],!0),this._versionId=u.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this;this._notebook={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===s.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(n){return n=b._validateIndex(n),b._cells[n].apiCell},getCells(n){return(n?b._getCells(n):b._cells).map(o=>o.apiCell)},save(){return b._save()}}}return this._notebook}updateBackup(b){this._backup?.delete(),this._backup=b}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,n){this._versionId=b.versionId,this._isDirty=n;for(const g of b.rawEvents)g.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(g.changes,!1):g.kind===k.NotebookCellsChangeType.Move?this._moveCell(g.index,g.newIdx):g.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(g.index,g.outputs):g.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(g.index,g.outputId,g.append,g.outputItems):g.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(g.index,g.language):g.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(g.index,g.mime):g.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(g.index,g.metadata):g.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(g.index,g.internalMetadata)}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let n=b.start|0,g=b.end|0;return n<0&&(n=0),g>this._cells.length&&(g=this._cells.length),b.with({start:n,end:g})}_getCells(b){b=this._validateRange(b);const n=[];for(let g=b.start;g<b.end;g++)n.push(this._cells[g]);return n}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,n){if(this._disposed)return;const g=[],o=[],c=[];b.reverse().forEach(u=>{const y=u[2].map(D=>{const l=new C(this,this._textDocumentsAndEditors,D);return n||o.push(C.asModelAddData(this.apiNotebook,D)),l}),f=new I(u[0],u[1],[],y),d=this._cells.splice(u[0],u[1],...y);for(const D of d)c.push(D.uri),f.deletedItems.push(D.apiCell);g.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:c}),n||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(g)}))}_moveCell(b,n){const g=this._cells.splice(b,1);this._cells.splice(n,0,...g);const o=[new I(b,1,g.map(c=>c.apiCell),[]),new I(n,0,[],g)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(o)}))}_setCellOutputs(b,n){const g=this._cells[b];g.setOutputs(n),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_setCellOutputItems(b,n,g,o){const c=this._cells[b];c.setOutputItems(n,g,o),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_changeCellLanguage(b,n){const g=this._cells[b];g.apiCell.document.languageId!==n&&this._textDocuments.$acceptModelLanguageChanged(g.uri,n)}_changeCellMime(b,n){const g=this._cells[b];g.apiCell.mime=n}_changeCellMetadata(b,n){const g=this._cells[b],o=g.apiCell.metadata;g.setMetadata(n);const c=g.apiCell.metadata;(0,t.equals)(o,c)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:g.apiCell}))}_changeCellInternalMetadata(b,n){this._cells[b].setInternalMetadata(n)}getCellFromApiCell(b){return this._cells.find(n=>n.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(n=>n.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(ye[91],_e([0,1,7,8,15]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:A})}replaceCells(C,A,R){this._throwIfFinalized(),!(C===A&&R.length===0)&&this._collectedEdits.push({editType:1,index:C,count:A-C,cells:R.map(t.NotebookCellData.from)})}}class k{constructor(C,A,R,b,n,g){this.id=C,this._proxy=A,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=b,this._viewColumn=g}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(A){if(!Array.isArray(A)||!A.every(s.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");C._selections=A,C._trySetSelections(A)},get visibleRanges(){return C._visibleRanges},revealRange(A,R){C._proxy.$tryRevealRange(C.id,t.NotebookRange.from(A),R??s.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(A){const R=new T(this.document.version);return A(R),C._applyEdit(R.finalize())},setDecorations(A,R){return C.setDecorations(A,R)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(t.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const A=[];let R=-1;for(let b=0;b<C.cellEdits.length;b++){if(R<0){A.push(C.cellEdits[b]),R++;continue}const g=A[R],o=C.cellEdits[b];if(g.editType===1&&o.editType===1&&g.index===o.index){g.cells.push(...C.cellEdits[b].cells),g.count+=C.cellEdits[b].count;continue}A.push(C.cellEdits[b]),R++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,A)}setDecorations(C,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return A.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(A),C.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(ye[167],_e([0,1,8,139,120,20,53,15]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,g,o){const c=this._handles++,{title:u,location:F,cancellable:y}=g,f={label:(0,E.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(c,{location:s.ProgressLocation.from(F),title:u,source:f,cancellable:y},n).catch(I.onUnexpectedExternalError),this._withProgress(c,o,!!y)}_withProgress(n,g,o){let c;o&&(c=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,c));const u=y=>{this._proxy.$progressEnd(y),this._mapHandleToCancellationSource.delete(y),c&&c.dispose()};let F;try{F=g(new R(this._proxy,n),o&&c?c.token:T.CancellationToken.None)}catch(y){throw u(n),y}return F.then(y=>u(n),y=>u(n)),F}$acceptProgressCanceled(n){const g=this._mapHandleToCancellationSource.get(n);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=C;function A(b,n){return b.message=n.message,typeof n.increment=="number"&&(typeof b.increment=="number"?b.increment+=n.increment:b.increment=n.increment),b}class R extends t.Progress{constructor(n,g){super(o=>this.throttledReport(o));this._proxy=n,this._handle=g}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Be([(0,k.throttle)(100,(b,n)=>A(b,n),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(ye[92],_e([0,1,42,15,54,8,7]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(n,g,o){const c=I._Keys.nextId();n.$registerTextEditorDecorationType(g.identifier,c,T.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:c,dispose(){n.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=I,I._Keys=new E.IdGenerator("TextEditorDecorationType");class C{constructor(n,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,g){this._throwIfFinalized();let o=null;if(n instanceof k.Position)o=new k.Range(n,n);else if(n instanceof k.Range)o=n;else throw new Error("Unrecognized location");this._pushEdit(o,g,!1)}insert(n,g){this._throwIfFinalized(),this._pushEdit(new k.Range(n,n),g,!0)}delete(n){this._throwIfFinalized();let g=null;if(n instanceof k.Range)g=n;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(n,g,o){const c=this._document.validateRange(n);this._collectedEdits.push({range:c,text:g,forceMoveMarkers:o})}setEndOfLine(n){if(this._throwIfFinalized(),n!==k.EndOfLine.LF&&n!==k.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=C;class A{constructor(n,g,o,c){this._proxy=n,this._id=g,this._accept(o),this._logService=c;const u=this;this.value={get tabSize(){return u._tabSize},set tabSize(F){u._setTabSize(F)},get insertSpaces(){return u._insertSpaces},set insertSpaces(F){u._setInsertSpaces(F)},get cursorStyle(){return u._cursorStyle},set cursorStyle(F){u._setCursorStyle(F)},get lineNumbers(){return u._lineNumbers},set lineNumbers(F){u._setLineNumbers(F)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const g=Math.floor(n);return g>0?g:null}if(typeof n=="string"){const g=parseInt(n,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(n){const g=this._validateTabSize(n);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const g=this._validateInsertSpaces(n);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(n)})))}assign(n){const g={};let o=!1;if(typeof n.tabSize!="undefined"){const c=this._validateTabSize(n.tabSize);c==="auto"?(o=!0,g.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,o=!0,g.tabSize=c)}if(typeof n.insertSpaces!="undefined"){const c=this._validateInsertSpaces(n.insertSpaces);c==="auto"?(o=!0,g.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,o=!0,g.insertSpaces=c)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,o=!0,g.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,o=!0,g.lineNumbers=T.TextEditorLineNumbersStyle.from(n.lineNumbers)),o&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,g))}_warnOnError(n,g){g.catch(o=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(o)})}}e.ExtHostTextEditorOptions=A;class R{constructor(n,g,o,c,u,F,y,f){this.id=n,this._proxy=g,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._options=new A(this._proxy,this.id,F,o),this._visibleRanges=y,this._viewColumn=f;const d=this;this.value=Object.freeze({get document(){return c.getValue()},set document(D){throw(0,t.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(D){if(!(D instanceof k.Selection))throw(0,t.illegalArgument)("selection");d._selections=[D],d._trySetSelection()},get selections(){return d._selections},set selections(D){if(!Array.isArray(D)||D.some(l=>!(l instanceof k.Selection)))throw(0,t.illegalArgument)("selections");d._selections=D,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(D){throw(0,t.readonly)("visibleRanges")},get options(){return d._options.value},set options(D){d._disposed||d._options.assign(D)},get viewColumn(){return d._viewColumn},set viewColumn(D){throw(0,t.readonly)("viewColumn")},edit(D,l={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new C(c.getValue(),l);return D(M),d._applyEdit(M)},insertSnippet(D,l,M={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!l||Array.isArray(l)&&l.length===0)r=d._selections.map(i=>T.Range.from(i));else if(l instanceof k.Position){const{lineNumber:i,column:p}=T.Position.from(l);r=[{startLineNumber:i,startColumn:p,endLineNumber:i,endColumn:p}]}else if(l instanceof k.Range)r=[T.Range.from(l)];else{r=[];for(const i of l)if(i instanceof k.Range)r.push(T.Range.from(i));else{const{lineNumber:p,column:m}=T.Position.from(i);r.push({startLineNumber:p,startColumn:m,endLineNumber:p,endColumn:m})}}return g.$tryInsertSnippet(n,D.value,r,M)},setDecorations(D,l){const M=l.length===0;M&&!d._hasDecorationsForKey.has(D.key)||(M?d._hasDecorationsForKey.delete(D.key):d._hasDecorationsForKey.add(D.key),d._runOnProxy(()=>{if(T.isDecorationOptionsArr(l))return g.$trySetDecorations(n,D.key,T.fromRangeOrRangeWithMessage(l));{const r=new Array(4*l.length);for(let i=0,p=l.length;i<p;i++){const m=l[i];r[4*i]=m.start.line+1,r[4*i+1]=m.start.character+1,r[4*i+2]=m.end.line+1,r[4*i+3]=m.end.character+1}return g.$trySetDecorationsFast(n,D.key,r)}}))},revealRange(D,l){d._runOnProxy(()=>g.$tryRevealRange(n,T.Range.from(D),l||k.TextEditorRevealType.Default))},show(D){g.$tryShowEditor(n,T.ViewColumn.from(D))},hide(){g.$tryHideEditor(n)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,s.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,s.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,s.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,s.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const g=n.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const o=g.edits.map(u=>u.range);o.sort((u,F)=>u.end.line===F.end.line?u.end.character===F.end.character?u.start.line===F.start.line?u.start.character-F.start.character:u.start.line-F.start.line:u.end.character-F.end.character:u.end.line-F.end.line);for(let u=0,F=o.length-1;u<F;u++){const y=o[u].end;if(o[u+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=g.edits.map(u=>({range:T.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,c,{setEndOfLine:typeof g.setEndOfLine=="number"?T.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=R}),define(ye[168],_e([0,1,14,4,6,10,48,8,88,67]),function(Z,e,s,t,E,T,k,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new k.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const g=this.diff[this.diff.length-1];if(g&&n[0]===1){if(g[0]===1&&g[1].extId===n[1].extId){(0,C.applyTestItemUpdate)(g[1],n[1]);return}if(g[0]===0&&g[1].item.extId===n[1].extId){(0,C.applyTestItemUpdate)(g[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,g){const o=this.tree.get(n);if(!!o){if((o.expandLevels===void 0||g>o.expandLevels)&&(o.expandLevels=g),o.expand===1){const c=this.resolveChildren(o);return c.isOpen()?this.expandChildren(o,g-1):c.wait().then(()=>this.expandChildren(o,g-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,g-1)):this.expandChildren(o,g-1)}}dispose(){for(const n of this.tree.values())(0,k.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,g){switch(g.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(n.fullId,g.id));break;case 0:this.upsertItem(g.item,n);break;case 4:for(const o of g.ops)this.onTestItemEvent(n,o);break;case 3:{const{key:o,value:c,previous:u}=g,F=n.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(c,u,F);break;case"range":this.pushDiff([1,{extId:F,item:{range:I.Range.from(c)}}]);break;case"error":this.pushDiff([1,{extId:F,item:{error:I.MarkdownString.fromStrict(c)||null}}]);break;default:this.pushDiff([1,{extId:F,item:{[o]:c??null}}]);break}break}default:(0,T.assertNever)(g)}}upsertItem(n,g){if(!(n instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const o=A.TestId.fromExtHostTestItem(n,this.root.id,g?.actual),c=(0,k.getPrivateApiFor)(n);c.parent&&c.parent!==g?.actual&&c.parent.children.delete(n.id);let u=this.tree.get(o.toString());if(!u){u={fullId:o,actual:n,parent:g?o.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(u.fullId.toString(),u),this.setItemParent(n,g),this.pushDiff([0,{parent:u.parent&&u.parent.toString(),controllerId:this.controllerId,expand:u.expand,item:I.TestItem.from(n)}]),this.connectItemAndChildren(n,u,g);return}if(u.actual===n){this.connectItem(n,u,g);return}const F=u.actual.children,y=u.actual,f=(0,k.diffTestItems)(y,n);(0,k.getPrivateApiFor)(y).listener=void 0,u.actual=n,u.expand=0;for(const[d,D]of f)this.onTestItemEvent(u,{op:3,key:d,value:D,previous:y[d]});this.connectItemAndChildren(n,u,g);for(const d of F)n.children.get(d.id)||this.removeItem(A.TestId.joinToString(o,d.id))}diffTagRefs(n,g,o){const c=new Set(g.map(u=>u.id));for(const u of n)c.delete(u.id)||this.incrementTagRefs(u);this.pushDiff([1,{extId:o,item:{tags:n.map(u=>I.TestTag.namespace(this.controllerId,u.id))}}]),c.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const g=this.tags.get(n.id);g?g.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const g=this.tags.get(n);g&&!--g.refCount&&(this.tags.delete(n),this.pushDiff([6,I.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,g){(0,k.getPrivateApiFor)(n).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(n,g,o){this.setItemParent(n,o);const c=(0,k.getPrivateApiFor)(n);c.parent=o?.actual,c.listener=u=>this.onTestItemEvent(g,u),this.updateExpandability(g)}connectItemAndChildren(n,g,o){this.connectItem(n,g,o);for(const c of n.children)this.upsertItem(c,g)}updateExpandability(n){let g;this._resolveHandler?n.resolveBarrier?g=n.resolveBarrier.isOpen()?3:2:g=n.actual.canResolveChildren?1:0:g=0,g!==n.expand&&(n.expand=g,this.pushDiff([1,{extId:n.fullId.toString(),expand:g}]),g===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,g){if(g<0)return;const o=[];for(const c of n.actual.children){const u=this.expand(A.TestId.joinToString(n.fullId,c.id),g);(0,s.isThenable)(u)&&o.push(u)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const u=new s.Barrier;return u.open(),u}n.expand=2,this.pushExpandStateUpdate(n);const g=n.resolveBarrier=new s.Barrier,o=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=u.stack||u.message||String(u))};let c;try{c=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(u){o(u)}return(0,s.isThenable)(c)?c.catch(o).then(()=>{g.open(),this.updateExpandability(n)}):(g.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const g=this.tree.get(n);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const o=[g];for(;o.length;){const c=o.pop();if(!!c){(0,k.getPrivateApiFor)(c.actual).listener=void 0;for(const u of c.actual.tags)this.decrementTagRefs(u.id);this.tree.delete(c.fullId.toString());for(const u of c.actual.children)o.push(this.tree.get(A.TestId.joinToString(c.fullId,u.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=R}),define(ye[169],_e([0,1,3,135]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[170],_e([0,1,25,4,17]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=T;class k{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(s.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(s.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let b of R.activationEvents)b==="onUri"&&(b=`onUri:${s.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(R)}}keepOnly(R){const b=new Set;R.forEach(n=>b.add(s.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>b.has(s.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,b){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const n=k._findLoopingExtensions(this._extensionDescriptions);if(b=b.concat(n.map(g=>g.identifier)),b.length>0){const g=new Set;b.forEach(o=>g.add(s.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!g.has(s.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(n)}static _findLoopingExtensions(R){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(u){this._nodesSet.has(u)||(this._nodesSet.add(u),this._nodesArr.push(u))}addArc(u,F){this.addNode(u),this.addNode(F),this._arcs.has(u)?this._arcs.get(u).push(F):this._arcs.set(u,[F])}getArcs(u){return this._arcs.has(u)?this._arcs.get(u):[]}hasOnlyGoodArcs(u,F){const y=b.getArcs(u);for(let f=0;f<y.length;f++)if(!F.has(y[f]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let u of R){const F=s.ExtensionIdentifier.toKey(u.identifier);if(n.set(F,u),u.extensionDependencies)for(let y of u.extensionDependencies){const f=s.ExtensionIdentifier.toKey(y);b.addArc(F,f)}}let g=new Set;b.getNodes().filter(u=>b.getArcs(u).length===0).forEach(u=>g.add(u));let o=b.getNodes().filter(u=>!g.has(u)),c;do{c=!1;for(let u=0;u<o.length;u++){const F=o[u];b.hasOnlyGoodArcs(F,g)&&(o.splice(u,1),u--,g.add(F),c=!0)}}while(c);return o.map(u=>n.get(u))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(s.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const b=this._activationMap.get(R);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const b=this._extensionsMap.get(s.ExtensionIdentifier.toKey(R));return b||void 0}}e.ExtensionDescriptionRegistry=k;var I;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(I||(I={}));function C(A,R){const b=A.isBuiltin?0:A.isUnderDevelopment?2:1,n=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(b!==n)return b-n;const g=E.posix.basename(A.extensionLocation.path),o=E.posix.basename(R.extensionLocation.path);return g<o?-1:g>o?1:0}}),define(ye[171],_e([0,1,22]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function T(I){const C=s.VSBuffer.alloc(1);switch(I){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=T;function k(I,C){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=k}),define(ye[27],_e([0,1,4,2,3,25,142]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var I;(function(d){d[d.None=0]="None",d[d.LocalProcess=1]="LocalProcess",d[d.LocalWebWorker=2]="LocalWebWorker",d[d.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(d){switch(d){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class A{constructor(D){this.dependency=D}}e.MissingExtensionDependency=A;var R;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(d){switch(d){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=b;function n(d,D){return d.enabledApiProposals?d.enabledApiProposals.includes(D):!1}e.isProposedApiEnabled=n;function g(d,D){if(!n(d,D))throw new Error(`Extension '${d.identifier.value}' CANNOT use API proposal: ${D}.
Its package.json#enabledApiProposals-property declares: ${d.enabledApiProposals?.join(", ")??"[]"} but NOT ${D}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.checkProposedApiEnabled=g;class o{constructor(D,l,M,r){this.codeLoadingTime=D,this.activateCallTime=l,this.activateResolvedTime=M,this.activationReason=r}}e.ActivationTimes=o;class c{constructor(D,l){this.description=D,this.value=l}}e.ExtensionPointContribution=c,e.ExtensionHostLogFileName="exthost";var u;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(u=e.ActivationKind||(e.ActivationKind={}));function F(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=F;function y(d,D){return{identifier:new T.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!!D,extensionLocation:d.location,...d.manifest,uuid:d.identifier.uuid}}e.toExtensionDescription=y;class f{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None}activateByEvent(D){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(D){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(D){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(D){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(D,l){return Promise.resolve()}_onWillActivateExtension(D){}_onDidActivateExtension(D,l,M,r,i){}_onDidActivateExtensionError(D,l){}_onExtensionRuntimeError(D,l){}_onExtensionHostExit(D){}}e.NullExtensionService=f}),define(ye[172],_e([0,1,15,25,27,12]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class I{constructor(c,u,F,y){this.startup=c,this.codeLoadingTime=u,this.activateCallTime=F,this.activateResolvedTime=y}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class C{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,u){return c===-1||u===-1?-1:u-c}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class A{constructor(c,u,F,y,f,d){this.activationFailed=c,this.activationFailedError=u,this.activationTimes=F,this.module=y,this.exports=f,this.subscriptions=d}}e.ActivatedExtension=A;class R extends A{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class b extends A{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class n extends A{constructor(c){super(!0,c,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let g=class{constructor(c,u,F,y,f){this._logService=f,this._isDisposed=!1,this._registry=c,this._resolvedExtensionsSet=new Set,u.forEach(d=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,F.forEach(d=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(d),d)),this._host=y,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(c){const u=t.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(u)}getActivatedExtension(c){const u=t.ExtensionIdentifier.toKey(c),F=this._activatedExtensions.get(u);if(!F)throw new Error("Extension `"+c.value+"` is not known or not activated");return F}activateByEvent(c,u){if(this._alreadyActivatedEvents[c])return k;const F=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(F.map(y=>({id:y.identifier,reason:{startup:u,extensionId:y.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,u){const F=this._registry.getExtensionDescription(c);if(!F)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:F.identifier,reason:u}])}_handleActivateRequest(c,u,F){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(c.id))){u[t.ExtensionIdentifier.toKey(c.id)]=c;return}const y=this._registry.getExtensionDescription(c.id);if(!y){const D=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,D,new E.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(c.id),new n(D));return}const f=typeof y.extensionDependencies=="undefined"?[]:y.extensionDependencies;let d=!0;for(let D=0,l=f.length;D<l;D++){const M=f[D];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(M)))continue;const r=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(M));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const h=y.displayName||y.identifier.value,w=this._registry.getExtensionDescription(M),v=w&&w.displayName||M,a=new Error(`Cannot activate the '${h}' extension because its dependency '${v}' failed to activate`);a.detail=r.activationFailedError,this._host.onExtensionActivationError(y.identifier,a,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(y.identifier),new n(a));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(M))){d=!1,u[t.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(M)),reason:c.reason};continue}const i=this._registry.getExtensionDescription(M);if(i){if(!i.main&&!i.browser)continue;d=!1,u[t.ExtensionIdentifier.toKey(M)]={id:i.identifier,reason:c.reason};continue}const p=y.displayName||y.identifier.value,m=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(y.identifier,m,new E.MissingExtensionDependency(M)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(y.identifier),new n(m));return}d?u[t.ExtensionIdentifier.toKey(y.identifier)]=c:F.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(f=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(f.id))),c.length===0))return Promise.resolve(void 0);const u=Object.create(null),F=[];for(let f=0,d=c.length;f<d;f++)this._handleActivateRequest(c[f],u,F);for(let f=0,d=F.length;f<d;f++){const D=t.ExtensionIdentifier.toKey(F[f].id);u[D]&&delete u[D]}const y=Object.keys(u).map(f=>u[f]);return F.length===0?Promise.all(y.map(f=>this._activateExtension(f.id,f.reason))).then(f=>{}):this._activateExtensions(y).then(f=>this._activateExtensions(F))}_activateExtension(c,u){const F=t.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(F))return Promise.resolve(void 0);const y=this._activatingExtensions.get(F);if(y)return y;const f=this._host.actualActivateExtension(c,u).then(void 0,d=>{const D=new Error;return d&&d.name&&(D.name=d.name),d&&d.message?D.message=`Activating extension '${c.value}' failed: ${d.message}.`:D.message=`Activating extension '${c.value}' failed: ${d}.`,d&&d.stack&&(D.stack=d.stack),this._isDisposed&&s.isPromiseCanceledError(d)?new n(d):(this._host.onExtensionActivationError(c,D,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(d),new n(d))}).then(d=>{this._activatedExtensions.set(F,d),this._activatingExtensions.delete(F)});return this._activatingExtensions.set(F,f),f}};g=Be([He(4,T.ILogService)],g),e.ExtensionsActivator=g}),define(ye[173],_e([0,1,12,28,27]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends s.LogService{constructor(I,C){super(I.createLogger(C.logFile,{name:E.ExtensionHostLogFileName}))}};T=Be([He(0,s.ILoggerService),He(1,t.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(ye[174],_e([0,1,15]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,k)=>{this._actualOk=T,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,s.onUnexpectedError)(T))}then(T,k){return this._ensureActual().then(T,k)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=t}),define(ye[38],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class s{constructor(A,R){this._proxyIdentifierBrand=void 0,this.isMain=A,this.sid=R,this.nid=++s.count}}e.ProxyIdentifier=s,s.count=0;const t=[];function E(C){const A=new s(!0,C);return t[A.nid]=A,A}e.createMainContextProxyIdentifier=E;function T(C){const A=new s(!1,C);return t[A.nid]=A,A}e.createExtHostContextProxyIdentifier=T;function k(C){return t[C].sid}e.getStringIdentifierForProxy=k;class I{constructor(A){this.value=A}}e.SerializableObjectWithBuffers=I}),define(ye[5],_e([0,1,55,2,38]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var k;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(f){f.name="$ident";function d(l,M){return Object.defineProperty(l,f.name,{value:M,enumerable:!0}),l}f.mixin=d;function D(l){return l[f.name]}f.of=D})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(d){return d._id=g._n++,d}}e.IdObject=g,g._n=0;var o;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var u;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(u=e.WorkspaceEditType||(e.WorkspaceEditType={}));function F(f){if(f&&f.edits)for(const d of f.edits)typeof d.resource=="object"?d.resource=t.URI.revive(d.resource):(d.newUri=t.URI.revive(d.newUri),d.oldUri=t.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,s.revive)(d.metadata));return f}e.reviveWorkspaceEditDto=F;var y;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,E.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ye[68],_e([0,1,5,4,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,C){return this._proxy.$getPassword(I,C)}store(I,C,A){return this._proxy.$setPassword(I,C,A)}delete(I,C){return this._proxy.$deletePassword(I,C)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(ye[69],_e([0,1,3,12,5,13]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(C,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(E.MainContext.MainThreadTelemetry)}report(C,A,R){const b=this.getUsageKey(C,A);this._reportedUsages.has(b)||(this._reportedUsages.add(b),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:C}))}getUsageKey(C,A){return`${C}-${A.identifier.value}`}};k=Be([He(0,T.IExtHostRpcService),He(1,t.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(I,C,A){}})}),define(ye[175],_e([0,1,4,5,7,25]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,A,R,b={}){const n=T.ExtensionIdentifier.toKey(C.identifier),g=this._inFlightRequests.get(n)||[],o=[...R].sort().join(" ");let c=g.find(u=>u.scopes===o);if(c)return c.result;{const u=this._getSession(C,n,A,R,b);c={scopes:o,result:u},g.push(c),this._inFlightRequests.set(n,g);try{await u}finally{const F=g.findIndex(y=>y.scopes===o);F>-1&&(g.splice(F),this._inFlightRequests.set(n,g))}return u}}async _getSession(C,A,R,b,n={}){await this._proxy.$ensureProvider(R);const g=C.displayName||C.name;return this._proxy.$getSession(R,b,A,g,n)}async removeSession(C,A){const R=this._authenticationProviders.get(C);return R?R.provider.removeSession(A):this._proxy.$removeSession(C,A)}registerAuthenticationProvider(C,A,R,b){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:A,provider:R,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===C)||this._providers.push({id:C,label:A});const n=R.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(C,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,A,b?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(C);const g=this._providers.findIndex(o=>o.id===C);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,A){return this._onDidChangeSessions.fire({provider:{id:C,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(ye[176],_e([0,1,5,13,8]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(I,C){this._extHostDocumentsAndEditors=C,this._proxy=I.getProxy(s.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const C=E.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};T=Be([He(0,t.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ye[177],_e([0,1,5]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(T){const k=T.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(I){return k.$writeText(I)}})}}e.ExtHostClipboard=t});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[39],_e([0,1,10,7,8,26,5,16,12,55,59,227,2,6,3,13,48,22,38,43]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let D=class{constructor(m,h){d.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ze(this,d,m.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=h,this.converter=new l(this,w=>{const v=this._apiCommands.get(w);return v?.result===r.Void?v:void 0},h),this._argumentProcessors=[{processArgument(w){return(0,A.revive)(w)}},{processArgument(w){return(0,T.cloneAndChange)(w,function(v){if(R.Range.isIRange(v))return E.Range.to(v);if(b.Position.isIPosition(v))return E.Position.to(v);if(R.Range.isIRange(v.range)&&n.URI.isUri(v.uri))return E.location.to(v);if(v instanceof F.VSBuffer)return v.buffer.buffer;if(!Array.isArray(v))return v})}}]}registerArgumentProcessor(m){this._argumentProcessors.push(m)}registerApiCommand(m){const h=this.registerCommand(!1,m.id,async(...w)=>{const v=m.args.map((S,P)=>{if(!S.validate(w[P]))throw new Error(`Invalid argument '${S.name}' when running '${m.id}', received: ${w[P]}`);return S.convert(w[P])}),a=await this.executeCommand(m.internalId,...v);return m.result.convert(a,w,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this._apiCommands.set(m.id,m),new t.Disposable(()=>{h.dispose(),this._apiCommands.delete(m.id)})}registerCommand(m,h,w,v,a,S){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:w,thisArg:v,description:a,extension:S}),m&&Ie(this,d,"f").$registerCommand(h),new t.Disposable(()=>{this._commands.delete(h)&&m&&Ie(this,d,"f").$unregisterCommand(h)})}executeCommand(m,...h){return this._logService.trace("ExtHostCommands#executeCommand",m),this._doExecuteCommand(m,h,!0)}async _doExecuteCommand(m,h,w){if(this._commands.has(m))return this._executeContributedCommand(m,h,!1);{let v=!1;const a=(0,T.cloneAndChange)(h,function(S){if(S instanceof t.Position)return E.Position.from(S);if(S instanceof t.Range)return E.Range.from(S);if(S instanceof t.Location)return E.location.from(S);if(t.NotebookRange.isNotebookRange(S))return E.NotebookRange.from(S);if(S instanceof ArrayBuffer)return v=!0,F.VSBuffer.wrap(new Uint8Array(S));if(S instanceof Uint8Array)return v=!0,F.VSBuffer.wrap(S);if(!Array.isArray(S))return S});try{const S=await Ie(this,d,"f").$executeCommand(m,v?new y.SerializableObjectWithBuffers(a):a,w);return(0,A.revive)(S)}catch(S){if(S instanceof Error&&S.message==="$executeCommand:retry")return this._doExecuteCommand(m,h,!1);throw S}}}async _executeContributedCommand(m,h,w){const v=this._commands.get(m);if(!v)throw new Error("Unknown command");let{callback:a,thisArg:S,description:P}=v;if(P)for(let N=0;N<P.args.length;N++)try{(0,s.validateConstraint)(h[N],P.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${P.args[N].name}' - ${P.args[N].description}`)}try{return await a.apply(S,h)}catch(N){if(m===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...h);B&&(m=B.command)}throw this._logService.error(N,m,v.extension?.identifier),w?new class extends Error{constructor(){super((0,f.toErrorMessage)(N));this.id=m,this.source=v.extension?.displayName??v.extension?.name}}:N}}$executeContributedCommand(m,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",m),this._commands.has(m)?(h=h.map(w=>this._argumentProcessors.reduce((v,a)=>a.processArgument(v),w)),this._executeContributedCommand(m,h,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this._logService.trace("ExtHostCommands#getCommands",m),Ie(this,d,"f").$getCommands().then(h=>(m&&(h=h.filter(w=>w[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const m=Object.create(null);for(let[h,w]of this._commands){let{description:v}=w;v&&(m[h]=v)}return Promise.resolve(m)}};d=new WeakMap,D=Be([He(0,c.IExtHostRpcService),He(1,C.ILogService)],D),e.ExtHostCommands=D,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class l{constructor(m,h,w){this._commands=m,this._lookupApiCommand=h,this._logService=w,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(m,h){if(!m)return;const w={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return w;const v=this._lookupApiCommand(m.command);if(v)w.id=v.internalId,w.arguments=v.args.map((a,S)=>a.convert(m.arguments&&m.arguments[S]));else if((0,I.isNonEmptyArray)(m.arguments)){const a=++this._cachIdPool;this._cache.set(a,m),h.add((0,g.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),w.$ident=a,w.id=this.delegatingCommandId,w.arguments=[a],this._logService.trace("CommandsConverter#CREATE",m.command,a)}return w}fromInternal(m){const h=k.ObjectIdentifier.of(m);return typeof h=="number"?this._cache.get(h):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this._cache.get(m[0])}_executeConvertedCommand(...m){const h=this.getActualCommand(...m);return this._logService.trace("CommandsConverter#EXECUTE",m[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class M{constructor(m,h,w,v){this.name=m,this.description=h,this.validate=w,this.convert=v}optional(){return new M(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,h){return new M(m??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=M,M.Uri=new M("uri","Uri of a text document",p=>n.URI.isUri(p),p=>p),M.Position=new M("position","A position in a text document",p=>t.Position.isPosition(p),E.Position.from),M.Range=new M("range","A range in a text document",p=>t.Range.isRange(p),E.Range.from),M.Selection=new M("selection","A selection in a text document",p=>t.Selection.isSelection(p),E.Selection.from),M.Number=new M("number","",p=>typeof p=="number",p=>p),M.String=new M("string","",p=>typeof p=="string",p=>p),M.CallHierarchyItem=new M("item","A call hierarchy item",p=>p instanceof t.CallHierarchyItem,E.CallHierarchyItem.from),M.TypeHierarchyItem=new M("item","A type hierarchy item",p=>p instanceof t.TypeHierarchyItem,E.TypeHierarchyItem.from),M.TestItem=new M("testItem","A VS Code TestItem",p=>p instanceof u.TestItemImpl,E.TestItem.from);class r{constructor(m,h){this.description=m,this.convert=h}}e.ApiCommandResult=r,r.Void=new r("no result",p=>p);class i{constructor(m,h,w,v,a){this.id=m,this.internalId=h,this.description=w,this.args=v,this.result=a}}e.ApiCommand=i}),define(ye[178],_e([0,1,8,7,58,39,16,79]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(s.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,g)=>{if((0,k.isFalsyOrEmpty)(n))return;class o extends t.SymbolInformation{static to(u){const F=new o(u.name,s.SymbolKind.to(u.kind),u.containerName||"",new t.Location(g[0],s.Range.to(u.range)));return F.detail=u.detail,F.range=F.location.range,F.selectionRange=s.Range.to(u.selectionRange),F.children=u.children?u.children.map(o.to):[],F}}return n.map(o.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(s.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(s.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(s.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(s.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(s.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(g=>t.Position.isPosition(g)),n=>n.map(s.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(g=>{let o;for(const c of g.reverse())o=new t.SelectionRange(s.Range.to(c),o);return o}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(s.WorkspaceSymbol.to))),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(s.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(s.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(s.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:s.Range.to(n.range),placeholder:n.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return s.WorkspaceEdit.to(n)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(s.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const g=(0,I.decodeSemanticTokensDto)(n);if(g.type==="full")return new t.SemanticTokens(g.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const g=(0,I.decodeSemanticTokensDto)(n);if(g.type==="full")return new t.SemanticTokens(g.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,g,o)=>{if(!n)return new t.CompletionList([]);const c=n.suggestions.map(u=>s.CompletionItem.to(u,o));return new t.CompletionList(c,n.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return s.SignatureHelp.to(n)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,g,o)=>R(c=>new t.CodeLens(s.Range.to(c.range),c.command&&o.fromInternal(c.command)))(n))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>t.Range.isRange(n),n=>t.Selection.isSelection(n)?s.Selection.from(n):s.Range.from(n)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,g,o)=>R(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(c.command)}else{const u=new t.CodeAction(c.title,c.kind?new t.CodeActionKind(c.kind):void 0);return c.edit&&(u.edit=s.WorkspaceEdit.to(c.edit)),c.command&&(u.command=o.fromInternal(c.command)),u.isPreferred=c.isPreferred,u}})(n))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(g=>new t.ColorInformation(s.Range.to(g.range),s.Color.to(g.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",n=>n instanceof t.Color,s.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:s.Range.from(n.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(s.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(s.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(g=>s.NotebookExclusiveDocumentPattern.to(g))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(s.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[s.ViewColumn.from(n),void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[s.ViewColumn.from(n),void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(s.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(s.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(s.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class A{static register(g){C.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=A;function R(n){return g=>{if(Array.isArray(g))return g.map(n)}}function b(n){if(!Array.isArray(n))return;const g=[];for(const o of n)E.isLocationLink(o)?g.push(s.DefinitionLink.to(o)):g.push(s.location.to(o));return g}}),define(ye[179],_e([0,1,14,53,4,6,2,58,25,8,7,5]),function(Z,e,s,t,E,T,k,I,C,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(g,o,c){const u=g.getProxy(b.MainContext.MainThreadComments);class F{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const p=this._commentControllers.get(i.handle);return p||i}else if(i&&i.$mid===7){const p=this._commentControllers.get(i.commentControlHandle);if(!p)return i;const m=p.getCommentThread(i.commentThreadHandle);return m||i}else if(i&&i.$mid===8){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const m=p.getCommentThread(i.thread.commentThreadHandle);return m?{thread:m,text:i.text}:i}else if(i&&i.$mid===9){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const m=p.getCommentThread(i.thread.commentThreadHandle);if(!m)return i;let h=i.commentUniqueId,w=m.getCommentByUniqueId(h);return w||i}else if(i&&i.$mid===10){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const m=p.getCommentThread(i.thread.commentThreadHandle);if(!m)return i;let h=i.text,w=i.commentUniqueId,v=m.getCommentByUniqueId(w);return v?(v.body=h,v):i}return i}})}createCommentController(i,p,m){const h=F.handlePool++,w=new f(i,h,p,m);this._commentControllers.set(w.handle,w);const v=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return v.push(w),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),v),w.value}$createCommentThreadTemplate(i,p,m){const h=this._commentControllers.get(i);!h||h.$createCommentThreadTemplate(p,m)}async $updateCommentThreadTemplate(i,p,m){const h=this._commentControllers.get(i);!h||h.$updateCommentThreadTemplate(p,m)}$deleteCommentThread(i,p){const m=this._commentControllers.get(i);m&&m.$deleteCommentThread(p)}$provideCommentingRanges(i,p,m){const h=this._commentControllers.get(i);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=c.getDocument(k.URI.revive(p));return(0,s.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(w,m)).then(v=>v?v.map(a=>A.Range.from(a)):void 0)}$toggleReaction(i,p,m,h,w){const v=this._commentControllers.get(i);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const a=v.getCommentThread(p);if(a){const S=a.getCommentByUniqueId(h.uniqueIdInThread);if(v!==void 0&&S&&v.reactionHandler)return v.reactionHandler(S,l(w))}return Promise.resolve(void 0)})}dispose(){}}F.handlePool=0;class y{constructor(i,p,m,h,w,v,a){this._commentControllerHandle=p,this._id=m,this._uri=h,this._range=w,this._comments=v,this.handle=y._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),u.$createCommentThread(p,this.handle,this._id,this._uri,A.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{u.$deleteCommentThread(p,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(P){S.range=P},get comments(){return S.comments},set comments(P){S.comments=P},get collapsibleState(){return S.collapsibleState},set collapsibleState(P){S.collapsibleState=P},get canReply(){return S.canReply},set canReply(P){S.canReply=P},get contextValue(){return S.contextValue},set contextValue(P){S.contextValue=P},get label(){return S.label},set label(P){S.label=P},dispose:()=>{S.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const i=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),p={};i("range")&&(p.range=A.Range.from(this._range)),i("label")&&(p.label=this.label),i("contextValue")&&(p.contextValue=this.contextValue??null),i("comments")&&(p.comments=this._comments.map(m=>d(this,m,this._commentsMap))),i("collapsibleState")&&(p.collapseState=M(this._collapseState)),i("canReply")&&(p.canReply=this.canReply),this.modifications={},u.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(i){for(let p of this._commentsMap){let m=p[0],h=p[1];if(i===h)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}y._handlePool=0,Be([(0,t.debounce)(100)],y.prototype,"eventuallyUpdateCommentThread",null);class f{constructor(i,p,m,h){this._extension=i,this._handle=p,this._id=m,this._label=h,this._threads=new Map,u.$registerCommentController(this.handle,m,h);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(v){w.options=v},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(v){w.commentingRangeProvider=v},get reactionHandler(){return w.reactionHandler},set reactionHandler(v){w.reactionHandler=v},createCommentThread(v,a,S){return w.createCommentThread(v,a,S).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,u.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,p,m,h){if(typeof i=="string"){const w=new y(this.id,this.handle,i,p,m,h,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new y(this.id,this.handle,void 0,i,p,m,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(i,p){const m=new y(this.id,this.handle,void 0,k.URI.revive(i),A.Range.to(p),[],this._extension.identifier);return m.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(i,p){let m=this._threads.get(i);m&&(m.range=A.Range.to(p))}$deleteCommentThread(i){let p=this._threads.get(i);p&&p.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function d(r,i,p){let m=p.get(i);m||(m=++r.commentHandle,p.set(i,m));const h=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:m,body:A.MarkdownString.from(i.body),userName:i.author.name,userIconPath:h,label:i.label,commentReactions:i.reactions?i.reactions.map(w=>D(w)):void 0}}function D(r){return{label:r.label,iconPath:r.iconPath?A.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function l(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?k.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function M(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new F}e.createExtHostComments=n}),define(ye[93],_e([0,1,2,5,7,3,13,12,16,9,17]),function(Z,e,s,t,E,T,k,I,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class bi{constructor(g,o){this._logService=o,this._provider=new Map,this._proxy=g.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,o){const c=bi._handlePool++;this._provider.set(c,{provider:g,extensionId:o}),this._proxy.$registerDecorationProvider(c,o.value);const u=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(F=>{if(!F){this._proxy.$onDidChange(c,null);return}let y=(0,C.asArray)(F);if(y.length<=bi._maxEventSize){this._proxy.$onDidChange(c,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,y.length);const f=y.map(l=>({uri:l,rank:(0,A.count)(l.path,"/")})),d=(0,C.groupBy)(f,(l,M)=>l.rank-M.rank||(0,A.compare)(l.uri.path,M.uri.path));let D=[];e:for(let l of d){let M;for(let r of l){let i=(0,R.dirname)(r.uri.path);if(M!==i&&(M=i,D.push(r.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(c,D)});return new E.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(g,o,c){if(!this._provider.has(g))return Object.create(null);const u=Object.create(null),{provider:F,extensionId:y}=this._provider.get(g);return await Promise.all(o.map(async f=>{try{const{uri:d,id:D}=f,l=await Promise.resolve(F.provideFileDecoration(s.URI.revive(d),c));if(!l)return;try{E.FileDecoration.validate(l),u[D]=[l.propagate,l.tooltip,l.badge,l.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${y.value}': ${M}`)}}catch(d){this._logService.error(d)}})),u}};b._handlePool=0,b._maxEventSize=250,b=Be([He(0,k.IExtHostRpcService),He(1,I.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[180],_e([0,1,118,82,2,5,7,8,4,12,21,30]),function(Z,e,s,t,E,T,k,I,C,A,R,b){"use strict";var n,g,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class c{constructor(y,f,d,D,l,M){this._name=y,this._owner=f,this._maxDiagnosticsPerFile=d,n.set(this,void 0),g.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,Ze(this,o,new R.ResourceMap(r=>D.getComparisonKey(r)),"f"),Ze(this,n,l,"f"),Ze(this,g,M,"f")}dispose(){this._isDisposed||(Ie(this,g,"f").fire([...Ie(this,o,"f").keys()]),Ie(this,n,"f")&&Ie(this,n,"f").$clear(this._owner),Ie(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(y,f){if(!y){this.clear();return}this._checkDisposed();let d=[];if(E.URI.isUri(y)){if(!f){this.delete(y);return}Ie(this,o,"f").set(y,f.slice()),d=[y]}else if(Array.isArray(y)){d=[];let l;y=[...y].sort(c._compareIndexedTuplesByUri);for(const M of y){const[r,i]=M;if((!l||r.toString()!==l.toString())&&(l&&Ie(this,o,"f").get(l).length===0&&Ie(this,o,"f").delete(l),l=r,d.push(r),Ie(this,o,"f").set(r,[])),i){const p=Ie(this,o,"f").get(r);p&&p.push(...i)}else{const p=Ie(this,o,"f").get(r);p&&(p.length=0)}}}if(Ie(this,g,"f").fire(d),!Ie(this,n,"f"))return;const D=[];for(let l of d){let M=[];const r=Ie(this,o,"f").get(l);if(r)if(r.length>this._maxDiagnosticsPerFile){M=[];const i=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(let m of r)if(m.severity===i[p]&&M.push(I.Diagnostic.from(m))===this._maxDiagnosticsPerFile)break e;M.push({severity:t.MarkerSeverity.Info,message:(0,s.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=r.map(i=>I.Diagnostic.from(i));D.push([l,M])}Ie(this,n,"f").$changeMany(this._owner,D)}delete(y){this._checkDisposed(),Ie(this,g,"f").fire([y]),Ie(this,o,"f").delete(y),Ie(this,n,"f")&&Ie(this,n,"f").$changeMany(this._owner,[[y,void 0]])}clear(){this._checkDisposed(),Ie(this,g,"f").fire([...Ie(this,o,"f").keys()]),Ie(this,o,"f").clear(),Ie(this,n,"f")&&Ie(this,n,"f").$clear(this._owner)}forEach(y,f){this._checkDisposed();for(let d of Ie(this,o,"f").keys())y.apply(f,[d,this.get(d),this])}get(y){this._checkDisposed();const f=Ie(this,o,"f").get(y);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(y){return this._checkDisposed(),Array.isArray(Ie(this,o,"f").get(y))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(y,f){return y[0].toString()<f[0].toString()?-1:y[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=c,n=new WeakMap,g=new WeakMap,o=new WeakMap;let u=class oi{constructor(y,f,d){this._logService=f,this._fileSystemInfoService=d,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=y.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(y){const f=new R.ResourceMap;for(const d of y)f.set(d,d);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(y,f){const{_collections:d,_proxy:D,_onDidChangeDiagnostics:l,_logService:M,_fileSystemInfoService:r}=this,i=new class{$changeMany(h,w){D.$changeMany(h,w),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",y.value,h,w.length===0?"CLEARING":w)}$clear(h){D.$clear(h),M.trace("[DiagnosticCollection] remove all (extension, owner)",y.value,h)}dispose(){D.dispose()}};let p;if(!f)f="_generated_diagnostic_collection_name_#"+oi._idPool++,p=f;else if(!d.has(f))p=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do p=f+oi._idPool++;while(d.has(p))}return new class extends c{constructor(){super(f,p,oi._maxDiagnosticsPerFile,r.extUri,i,l);d.set(p,this)}dispose(){super.dispose(),d.delete(p)}}}getDiagnostics(y){if(y)return this._getDiagnostics(y);{const f=new Map,d=[];for(const D of this._collections.values())D.forEach((l,M)=>{let r=f.get(l.toString());typeof r=="undefined"&&(r=d.length,f.set(l.toString(),r),d.push([l,[]])),d[r][1]=d[r][1].concat(...M)});return d}}_getDiagnostics(y){let f=[];for(let d of this._collections.values())d.has(y)&&(f=f.concat(d.get(y)));return f}$acceptMarkersChange(y){if(!this._mirrorCollection){const f="_generated_mirror",d=new c(f,f,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,d),this._mirrorCollection=d}for(const[f,d]of y)this._mirrorCollection.set(E.URI.revive(f),d.map(I.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=Be([He(1,A.ILogService),He(2,b.IExtHostFileSystemInfo)],u),e.ExtHostDiagnostics=u}),define(ye[181],_e([0,1,2,5]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(k){this._proxy=k.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(I=>I?I.map(C=>s.URI.revive(C)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(I=>I?s.URI.revive(I):void 0)}}e.ExtHostDialogs=E}),define(ye[182],_e([0,1,15,2,7,5,11,20,9]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(b,n,g){this._documentsAndEditors=n,this._logService=g,this._documentContentProviders=new Map,this._proxy=b.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,n){if(Object.keys(k.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const g=A._handlePool++;this._documentContentProviders.set(g,n),this._proxy.$registerTextContentProvider(g,b);let o;return typeof n.onDidChange=="function"&&(o=n.onDidChange(c=>{if(c.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(g,c).then(u=>{if(!u&&typeof u!="string")return;const F=this._documentsAndEditors.getDocument(c);if(!F)return;const y=(0,C.splitLines)(u);if(!F.equalLines(y))return this._proxy.$onVirtualDocumentChange(c,u)},s.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(b,n){const g=this._documentContentProviders.get(b);return g?Promise.resolve(g.provideTextDocumentContent(t.URI.revive(n),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(ye[183],_e([0,1,4,6,2,5,86,8,10,26,7]),function(Z,e,s,t,E,T,k,I,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(g,o){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const u of c)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const u of c)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!g)return;const o=this._documentsAndEditors.getDocument(g);if(o)return o}getDocument(g){const o=this.getDocumentData(g);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${g}'`);return o.document}ensureDocumentData(g){const o=this._documentsAndEditors.getDocument(g);if(o)return Promise.resolve(o);let c=this._documentLoader.get(g.toString());return c||(c=this._proxy.$tryOpenDocument(g).then(u=>{this._documentLoader.delete(g.toString());const F=E.URI.revive(u);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(F))},u=>(this._documentLoader.delete(g.toString()),Promise.reject(u))),this._documentLoader.set(g.toString(),c)),c}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(o=>E.URI.revive(o))}$acceptModelLanguageChanged(g,o){const c=E.URI.revive(g),u=this._documentsAndEditors.getDocument(c);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(o),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(g){const o=E.URI.revive(g),c=this._documentsAndEditors.getDocument(o);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(g,o){const c=E.URI.revive(g),u=this._documentsAndEditors.getDocument(c);if(!u)throw new Error("unknown document");u._acceptIsDirty(o),this._onDidChangeDocument.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(g,o,c){const u=E.URI.revive(g),F=this._documentsAndEditors.getDocument(u);if(!F)throw new Error("unknown document");F._acceptIsDirty(c),F.onEvents(o);let y;o.isUndoing?y=R.TextDocumentChangeReason.Undo:o.isRedoing&&(y=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:F.document,contentChanges:o.changes.map(f=>({range:I.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:y}))}setWordDefinitionFor(g,o){(0,k.setWordDefinitionFor)(g,o)}}e.ExtHostDocuments=b}),define(ye[49],_e([0,1,42,4,6,2,3,5,86,13,92,8,12,21,11,157,228]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class F{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(d,D){this._extHostRpc=d,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const D=[],l=[],M=[];if(d.removedDocuments)for(const r of d.removedDocuments){const i=T.URI.revive(r),p=this._documents.get(i);p?.unref()&&(this._documents.delete(i),D.push(p.value))}if(d.addedDocuments)for(const r of d.addedDocuments){const i=T.URI.revive(r.uri);let p=this._documents.get(i);if(p&&i.scheme!==o.Schemas.vscodeNotebookCell&&i.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);p||(p=new F(new C.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,p),l.push(p.value)),p.ref()}if(d.removedEditors)for(const r of d.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&M.push(i)}if(d.addedEditors)for(const r of d.addedEditors){const i=T.URI.revive(r.documentUri);s.ok(this._documents.has(i),`document '${i}' does not exist`),s.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const p=this._documents.get(i).value,m=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new u.Lazy(()=>p.document),r.selections.map(b.Selection.to),r.options,r.visibleRanges.map(h=>b.Range.to(h)),typeof r.editorPosition=="number"?b.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,m)}d.newActiveEditor!==void 0&&(s.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,E.dispose)(D),(0,E.dispose)(M),d.removedDocuments&&this._onDidRemoveDocuments.fire(D),d.addedDocuments&&this._onDidAddDocuments.fire(l),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return d?D:D?.value}allEditors(){return[...this._editors.values()]}};y=Be([He(0,A.IExtHostRpcService),He(1,n.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[70],_e([0,1,8,5,2,4,3,13,14]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");let A=class{constructor(b){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new T.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=b.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(b){let n=-1;this._tabs=b.map((o,c)=>(o.isActive&&(n=c),Object.freeze({label:o.label,viewColumn:s.ViewColumn.to(o.viewColumn),index:c,resource:E.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:u,viewId:F})=>({resource:E.URI.revive(u),viewId:F})),viewId:o.editorId,isActive:o.isActive,move:async(u,F)=>{this._proxy.$moveTab(o,u,s.ViewColumn.from(F)),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,c)=>o.viewColumn===c.viewColumn?o.index-c.index:o.viewColumn-c.viewColumn);const g=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==g&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};A=Be([He(0,I.IExtHostRpcService)],A),e.ExtHostEditorTabs=A}),define(ye[184],_e([0,1,2,5,6,7,8,229,9,22,27]),function(Z,e,s,t,E,T,k,I,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const c=this._schemes.indexOf(o);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),c=[];let u,F,y=14,f=14;for(const d of o){let D=u?(0,C.commonPrefixLength)(u,d):0;for(D===0?F=1:F=f;D<d.length;D++)D+1===d.length?(y=f,f=9):f+=1,c.push([F,d.toUpperCase().charCodeAt(D),f]),c.push([F,d.toLowerCase().charCodeAt(D),f]),F=f;u=d,f=y}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new I.StateMachine(c)}}provideDocumentLinks(o){this._initStateMachine();const c=[],u=I.LinkComputer.computeLinks({getLineContent(F){return o.lineAt(F-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const F of u){const y=k.DocumentLink.to(F);y.target&&c.push(y)}return c}}class n{constructor(o,c){this._extHostLanguageFeatures=c,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(o,c,u,F={}){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const y=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(y,u);let f=2;F.isCaseSensitive&&(f+=1024),F.isReadonly&&(f+=2048),typeof u.copy=="function"&&(f+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,R.checkProposedApiEnabled)(o,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(y,c,f).catch(D=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${c}`),console.error(D)});const d=u.onDidChangeFile(D=>{const l=[];for(const M of D){let{uri:r,type:i}=M;if(r.scheme!==c)continue;let p;switch(i){case T.FileChangeType.Changed:p=0;break;case T.FileChangeType.Created:p=1;break;case T.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:r,type:p})}this._proxy.$onFileSystemChange(y,l)});return(0,E.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(y),this._proxy.$unregisterProvider(y)})}static _asIStat(o){const{type:c,ctime:u,mtime:F,size:y,permissions:f}=o;return{type:c,ctime:u,mtime:F,size:y,permissions:f}}$stat(o,c){return Promise.resolve(this._getFsProvider(o).stat(s.URI.revive(c))).then(u=>n._asIStat(u))}$readdir(o,c){return Promise.resolve(this._getFsProvider(o).readDirectory(s.URI.revive(c)))}$readFile(o,c){return Promise.resolve(this._getFsProvider(o).readFile(s.URI.revive(c))).then(u=>A.VSBuffer.wrap(u))}$writeFile(o,c,u,F){return Promise.resolve(this._getFsProvider(o).writeFile(s.URI.revive(c),u.buffer,F))}$delete(o,c,u){return Promise.resolve(this._getFsProvider(o).delete(s.URI.revive(c),u))}$rename(o,c,u,F){return Promise.resolve(this._getFsProvider(o).rename(s.URI.revive(c),s.URI.revive(u),F))}$copy(o,c,u,F){const y=this._getFsProvider(o);if(!y.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(y.copy(s.URI.revive(c),s.URI.revive(u),F))}$mkdir(o,c){return Promise.resolve(this._getFsProvider(o).createDirectory(s.URI.revive(c)))}$watch(o,c,u,F){const y=this._getFsProvider(o).watch(s.URI.revive(u),F);this._watches.set(c,y)}$unwatch(o,c){const u=this._watches.get(c);u&&(u.dispose(),this._watches.delete(c))}$open(o,c,u){const F=this._getFsProvider(o);if(!F.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(F.open(s.URI.revive(c),u))}$close(o,c){const u=this._getFsProvider(o);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(c))}$read(o,c,u,F){const y=this._getFsProvider(o);if(!y.read)throw new Error('FileSystemProvider does not implement "read"');const f=A.VSBuffer.alloc(F);return Promise.resolve(y.read(c,u,f.buffer,0,F)).then(d=>f.slice(0,d))}$write(o,c,u,F){const y=this._getFsProvider(o);if(!y.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(y.write(c,u,F.buffer,0,F.byteLength))}_getFsProvider(o){const c=this._fsProvider.get(o);if(!c){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return c}}e.ExtHostFileSystem=n}),define(ye[50],_e([0,1,5,46,7,22,3,13,30,6]),function(Z,e,s,t,E,T,k,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Ht{constructor(n,g){this._fileSystemProvider=new Map,this._proxy=n.getProxy(s.MainContext.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(c){try{const u=o._fileSystemProvider.get(c.scheme);if(!u)return await o._proxy.$stat(c);await o._proxy.$ensureActivation(c.scheme);const F=await u.stat(c);return{type:F.type,ctime:F.ctime,mtime:F.mtime,size:F.size,permissions:F.permissions}}catch(u){Ht._handleError(u)}},async readDirectory(c){try{const u=o._fileSystemProvider.get(c.scheme);return u?(await o._proxy.$ensureActivation(c.scheme),(await u.readDirectory(c)).slice()):await o._proxy.$readdir(c)}catch(u){return Ht._handleError(u)}},async createDirectory(c){try{return await o._proxy.$mkdir(c)}catch(u){return Ht._handleError(u)}},async readFile(c){try{const u=o._fileSystemProvider.get(c.scheme);return u?(await o._proxy.$ensureActivation(c.scheme),(await u.readFile(c)).slice()):(await o._proxy.$readFile(c)).buffer}catch(u){return Ht._handleError(u)}},async writeFile(c,u){try{return await o._proxy.$writeFile(c,T.VSBuffer.wrap(u))}catch(F){return Ht._handleError(F)}},async delete(c,u){try{const F=o._fileSystemProvider.get(c.scheme);return F?(await o._proxy.$ensureActivation(c.scheme),await F.delete(c,{recursive:!1,...u})):await o._proxy.$delete(c,{recursive:!1,useTrash:!1,...u})}catch(F){return Ht._handleError(F)}},async rename(c,u,F){try{return await o._proxy.$rename(c,u,{overwrite:!1,...F})}catch(y){return Ht._handleError(y)}},async copy(c,u,F){try{return await o._proxy.$copy(c,u,{overwrite:!1,...F})}catch(y){return Ht._handleError(y)}},isWritableFileSystem(c){const u=g.getCapabilities(c);if(typeof u=="number")return!(u&2048)}})}static _handleError(n){if(n instanceof E.FileSystemError)throw n;if(!(n instanceof Error))throw new E.FileSystemError(String(n));if(n.name==="ENOPRO")throw E.FileSystemError.Unavailable(n.message);switch(n.name){case t.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(n.message);case t.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(n.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(n.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(n.message);case t.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(n.message);case t.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(n.message);default:throw new E.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,g){return this._fileSystemProvider.set(n,g),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(n))}};R=Be([He(0,I.IExtHostRpcService),He(1,C.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[185],_e([0,1,2,39]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(k,I,C,A){this._extHostNotebooks=I,this._textDocumentsAndEditors=C,this._commands=A;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new t.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new t.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new t.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new t.ApiCommandResult("Notebook and input URI",b=>{if(b.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(b.notebookEditorId);return{notebookUri:s.URI.revive(b.notebookUri),inputUri:s.URI.revive(b.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:s.URI.revive(b.notebookUri),inputUri:s.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(k,I,C,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:C,uri:k,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(s.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=E}),define(ye[186],_e([0,1,6,5]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(k){this._handlePool=0,this._proxy=k.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,k),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=E}),define(ye[187],_e([0,1,2,26,8,7,5,9,59,16,10,230,6,79,54,63,188,15,4]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentSymbols(H,G){const X=this._documents.getDocument(H),oe=await this._provider.provideDocumentSymbols(X,G);if(!(0,A.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(E.DocumentSymbol.from):f._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((oe,q)=>{let ee=oe.location.range.start.compareTo(q.location.range.start);return ee===0&&(ee=q.location.range.end.compareTo(oe.location.range.end)),ee});const G=[],X=[];for(const oe of H){const q={name:oe.name||"!!MISSING: name!!",kind:E.SymbolKind.from(oe.kind),tags:oe.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:E.Range.from(oe.location.range),selectionRange:E.Range.from(oe.location.range),children:[]};for(;;){if(X.length===0){X.push(q),G.push(q);break}const ee=X[X.length-1];if(C.Range.containsRange(ee.range,q.range)&&!C.Range.equalsRange(ee.range,q.range)){ee.children&&ee.children.push(q),X.push(q);break}X.pop()}}return G}}class d{constructor(H,G,X){this._documents=H,this._commands=G,this._provider=X,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,G){const X=this._documents.getDocument(H),oe=await this._provider.provideCodeLenses(X,G);if(!oe||G.isCancellationRequested)return;const q=this._cache.add(oe),ee=new n.DisposableStore;this._disposables.set(q,ee);const he={cacheId:q,lenses:[]};for(let Re=0;Re<oe.length;Re++)he.lenses.push({cacheId:[q,Re],range:E.Range.from(oe[Re].range),command:this._commands.toInternal(oe[Re].command,ee)});return he}async resolveCodeLens(H,G){const X=H.cacheId&&this._cache.get(...H.cacheId);if(!X)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?oe=X:oe=await this._provider.resolveCodeLens(X,G),oe||(oe=X),G.isCancellationRequested)return;const q=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!q)return H.command=this._commands.toInternal(oe.command??d._badCmd,q),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function D(je){return Array.isArray(je)?je.map(E.DefinitionLink.from):je?[E.DefinitionLink.from(je)]:[]}class l{constructor(H,G){this._documents=H,this._provider=G}async provideDefinition(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.provideDefinition(oe,q,X);return D(ee)}}class M{constructor(H,G){this._documents=H,this._provider=G}async provideDeclaration(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.provideDeclaration(oe,q,X);return D(ee)}}class r{constructor(H,G){this._documents=H,this._provider=G}async provideImplementation(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.provideImplementation(oe,q,X);return D(ee)}}class i{constructor(H,G){this._documents=H,this._provider=G}async provideTypeDefinition(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.provideTypeDefinition(oe,q,X);return D(ee)}}class p{constructor(H,G){this._documents=H,this._provider=G}async provideHover(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.provideHover(oe,q,X);if(!(!ee||(0,A.isFalsyOrEmpty)(ee.contents)))return ee.range||(ee.range=oe.getWordRangeAtPosition(q)),ee.range||(ee.range=new T.Range(q,q)),E.Hover.from(ee)}}class m{constructor(H,G){this._documents=H,this._provider=G}async provideEvaluatableExpression(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.provideEvaluatableExpression(oe,q,X);if(ee)return E.EvaluatableExpression.from(ee)}}class h{constructor(H,G){this._documents=H,this._provider=G}async provideInlineValues(H,G,X,oe){const q=this._documents.getDocument(H),ee=await this._provider.provideInlineValues(q,E.Range.to(G),E.InlineValueContext.to(X),oe);if(Array.isArray(ee))return ee.map(he=>E.InlineValue.from(he))}}class w{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentHighlights(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.provideDocumentHighlights(oe,q,X);if(Array.isArray(ee))return ee.map(E.DocumentHighlight.from)}}class v{constructor(H,G){this._documents=H,this._provider=G}async provideLinkedEditingRanges(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.provideLinkedEditingRanges(oe,q,X);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,A.coalesce)(ee.ranges.map(E.Range.from)),wordPattern:ee.wordPattern}}}class a{constructor(H,G){this._documents=H,this._provider=G}async provideReferences(H,G,X,oe){const q=this._documents.getDocument(H),ee=E.Position.to(G),he=await this._provider.provideReferences(q,ee,X,oe);if(Array.isArray(he))return he.map(E.location.from)}}class S{constructor(H,G,X,oe,q,ee,he){this._documents=H,this._commands=G,this._diagnostics=X,this._provider=oe,this._logService=q,this._extension=ee,this._apiDeprecation=he,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,G,X,oe){const q=this._documents.getDocument(H),ee=b.Selection.isISelection(G)?E.Selection.to(G):E.Range.to(G),he=[];for(const st of this._diagnostics.getDiagnostics(H))if(ee.intersection(st.range)&&he.push(st)>S._maxCodeActionsPerFile)break;const Re={diagnostics:he,only:X.only?new T.CodeActionKind(X.only):void 0,triggerKind:E.CodeActionTriggerKind.to(X.trigger)},Ue=await this._provider.provideCodeActions(q,ee,Re,oe);if(!(0,A.isNonEmptyArray)(Ue)||oe.isCancellationRequested)return;const ze=this._cache.add(Ue),Qe=new n.DisposableStore;this._disposables.set(ze,Qe);const et=[];for(let st=0;st<Ue.length;st++){const Xe=Ue[st];!Xe||(S._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,Qe)})):(Re.only&&(Xe.kind?Re.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[ze,st],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,Qe),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(E.Diagnostic.from),edit:Xe.edit&&E.WorkspaceEdit.from(Xe.edit),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:ze,actions:et}}async resolveCodeAction(H,G){const[X,oe]=H,q=this._cache.get(X,oe);if(!q||S._isCommand(q)||!this._provider.resolveCodeAction)return;const ee=await this._provider.resolveCodeAction(q,G)??q;return ee?.edit?E.WorkspaceEdit.from(ee.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}S._maxCodeActionsPerFile=1e3;class P{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentFormattingEdits(H,G,X){const oe=this._documents.getDocument(H),q=await this._provider.provideDocumentFormattingEdits(oe,G,X);if(Array.isArray(q))return q.map(E.TextEdit.from)}}class N{constructor(H,G){this._documents=H,this._provider=G}async provideDocumentRangeFormattingEdits(H,G,X,oe){const q=this._documents.getDocument(H),ee=E.Range.to(G),he=await this._provider.provideDocumentRangeFormattingEdits(q,ee,X,oe);if(Array.isArray(he))return he.map(E.TextEdit.from)}}class B{constructor(H,G){this._documents=H,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,G,X,oe,q){const ee=this._documents.getDocument(H),he=E.Position.to(G),Re=await this._provider.provideOnTypeFormattingEdits(ee,he,X,oe,q);if(Array.isArray(Re))return Re.map(E.TextEdit.from)}}class _{constructor(H,G){this._provider=H,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(H,G){const X=k.IdObject.mixin({symbols:[]}),oe=await this._provider.provideWorkspaceSymbols(H,G);if((0,A.isNonEmptyArray)(oe))for(const q of oe){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ee=k.IdObject.mixin(E.WorkspaceSymbol.from(q));this._symbolCache.set(ee._id,q),X.symbols.push(ee)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(H,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const X=this._symbolCache.get(H._id);if(X){const oe=await this._provider.resolveWorkspaceSymbol(X,G);return oe&&(0,t.mixin)(H,E.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(H){const G=this._resultCache.get(H);if(G){for(let[X,oe]=G;X<=oe;X++)this._symbolCache.delete(X);this._resultCache.delete(H)}}}class O{constructor(H,G,X){this._documents=H,this._provider=G,this._logService=X}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,G,X,oe){const q=this._documents.getDocument(H),ee=E.Position.to(G);try{const he=await this._provider.provideRenameEdits(q,ee,X,oe);return he?E.WorkspaceEdit.from(he):void 0}catch(he){const Re=O._asMessage(he);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(H,G,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(H),q=E.Position.to(G);try{const ee=await this._provider.prepareRename(oe,q,X);let he,Re;if(T.Range.isRange(ee)?(he=ee,Re=oe.getText(ee)):(0,R.isObject)(ee)&&(he=ee.range,Re=ee.placeholder),!he||!Re)return;if(he.start.line>q.line||he.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(he),text:Re}}catch(ee){const he=O._asMessage(ee);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(ee)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class z{constructor(H,G){this.resultId=H,this.tokens=G}}class U{constructor(H,G){this._documents=H,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,G,X){const oe=this._documents.getDocument(H),q=G!==0?this._previousResults.get(G):null;let ee=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,q.resultId,X):await this._provider.provideDocumentSemanticTokens(oe,X);return q&&this._previousResults.delete(G),ee?(ee=U._fixProvidedSemanticTokens(ee),this._send(U._convertToEdits(q,ee),ee)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return U._isSemanticTokens(H)?U._isCorrectSemanticTokens(H)?H:new T.SemanticTokens(new Uint32Array(H.data),H.resultId):U._isSemanticTokensEdits(H)?U._isCorrectSemanticTokensEdits(H)?H:new T.SemanticTokensEdits(H.edits.map(G=>new T.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const G of H.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,G){if(!U._isSemanticTokens(G)||!H||!H.tokens)return G;const X=H.tokens,oe=X.length,q=G.data,ee=q.length;let he=0;const Re=Math.min(oe,ee);for(;he<Re&&X[he]===q[he];)he++;if(he===oe&&he===ee)return new T.SemanticTokensEdits([],G.resultId);let Ue=0;const ze=Re-he;for(;Ue<ze&&X[oe-Ue-1]===q[ee-Ue-1];)Ue++;return new T.SemanticTokensEdits([{start:he,deleteCount:oe-he-Ue,data:q.subarray(he,ee-Ue)}],G.resultId)}_send(H,G){if(U._isSemanticTokens(H)){const X=this._nextResultId++;return this._previousResults.set(X,new z(H.resultId,H.data)),(0,g.encodeSemanticTokensDto)({id:X,type:"full",data:H.data})}if(U._isSemanticTokensEdits(H)){const X=this._nextResultId++;return U._isSemanticTokens(G)?this._previousResults.set(X,new z(G.resultId,G.data)):this._previousResults.set(X,new z(H.resultId)),(0,g.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(H.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class ${constructor(H,G){this._documents=H,this._provider=G}async provideDocumentRangeSemanticTokens(H,G,X){const oe=this._documents.getDocument(H),q=await this._provider.provideDocumentRangeSemanticTokens(oe,E.Range.to(G),X);return q?this._send(q):null}_send(H){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=$;class V{constructor(H,G,X,oe,q){this._documents=H,this._commands=G,this._provider=X,this._apiDeprecation=oe,this._extension=q,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,G,X,oe){const q=this._documents.getDocument(H),ee=E.Position.to(G),he=q.getWordRangeAtPosition(ee)||new T.Range(ee,ee),Re=he.with({end:ee}),Ue=new u.StopWatch(!0),ze=await this._provider.provideCompletionItems(q,ee,oe,E.CompletionContext.to(X));if(!ze||oe.isCancellationRequested)return;const Qe=Array.isArray(ze)?new T.CompletionList(ze):ze,et=V.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const Xe=[],nt={x:et,b:Xe,a:{replace:E.Range.from(he),insert:E.Range.from(Re)},c:Qe.isIncomplete||void 0,d:Ue.elapsed()};for(let lt=0;lt<Qe.items.length;lt++){const vt=Qe.items[lt],Oe=this._convertCompletionItem(vt,[et,lt],Re,he);Xe.push(Oe)}return nt}async resolveCompletionItem(H,G){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...H);if(!X)return;const oe=await this._provider.resolveCompletionItem(X,G);if(!!oe)return this._convertCompletionItem(oe,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,G,X,oe){const q=this._disposables.get(G[0]);if(!q)throw Error("DisposableStore is missing...");const ee={x:G,a:H.label,b:H.kind!==void 0?E.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(E.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(H.command,q)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ee.h=H.textEdit.newText):typeof H.insertText=="string"?ee.h=H.insertText:H.insertText instanceof T.SnippetString&&(ee.h=H.insertText.value,ee.i|=4);let he;return H.textEdit?he=H.textEdit.range:H.range&&(he=H.range),T.Range.isRange(he)?ee.j=E.Range.from(he):he&&(!X?.isEqual(he.inserting)||!oe?.isEqual(he.replacing))&&(ee.j={insert:E.Range.from(he.inserting),replace:E.Range.from(he.replacing)}),ee}}class ue{constructor(H,G,X){this._documents=H,this._provider=G,this._commands=X,this._cache=new c.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,G,X,oe){const q=this._documents.getDocument(H),ee=E.Position.to(G),he=await this._provider.provideInlineCompletionItems(q,ee,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:E.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text,isSnippetText:X.selectedSuggestionInfo.isSnippetText,completionKind:E.CompletionItemKind.to(X.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:X.triggerKind},oe);if(!he||oe.isCancellationRequested)return;const Re=(0,R.isArray)(he)?{items:he}:he,Ue=this._cache.add(Re.items);let ze;return{pid:Ue,items:Re.items.map((Qe,et)=>{let st;return Qe.command&&(ze||(ze=new n.DisposableStore,this._disposables.set(Ue,ze)),st=this._commands.toInternal(Qe.command,ze)),{text:Qe.text,range:Qe.range?E.Range.from(Qe.range):void 0,command:st,idx:et}})}}disposeCompletions(H){this._cache.delete(H);const G=this._disposables.get(H);G&&G.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,G){const X=this._cache.get(H,G);X&&K.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class K{constructor(){this._onDidShowCompletionItemEmitter=new y.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let G=K.map.get(H);return G||(G=new K,K.map.set(H,G)),G}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=K,K.map=new WeakMap;class re{constructor(H,G){this._documents=H,this._provider=G,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(H,G,X,oe){const q=this._documents.getDocument(H),ee=E.Position.to(G),he=this.reviveContext(X),Re=await this._provider.provideSignatureHelp(q,ee,oe,he);if(Re){const Ue=this._cache.add([Re]);return{...E.SignatureHelp.from(Re),id:Ue}}}reviveContext(H){let G;if(H.activeSignatureHelp){const X=E.SignatureHelp.to(H.activeSignatureHelp),oe=this._cache.get(H.activeSignatureHelp.id,0);oe?(G=oe,G.activeSignature=X.activeSignature,G.activeParameter=X.activeParameter):G=X}return{...H,activeSignatureHelp:G}}releaseSignatureHelp(H){this._cache.delete(H)}}class pe{constructor(H,G){this._documents=H,this._provider=G}async provideInlayHints(H,G,X){const oe=this._documents.getDocument(H),q=await this._provider.provideInlayHints(oe,E.Range.to(G),X);return q?{hints:q.map(E.InlayHint.from)}:void 0}}class be{constructor(H,G){this._documents=H,this._provider=G,this._cache=new c.Cache("DocumentLink")}async provideLinks(H,G){const X=this._documents.getDocument(H),oe=await this._provider.provideDocumentLinks(X,G);if(!(!Array.isArray(oe)||oe.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(be._validateLink).map(E.DocumentLink.from)};{const q=this._cache.add(oe),ee={links:[],id:q};for(let he=0;he<oe.length;he++){if(!be._validateLink(oe[he]))continue;const Re=E.DocumentLink.from(oe[he]);Re.cacheId=[q,he],ee.links.push(Re)}return ee}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,G){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...H);if(!X)return;const oe=await this._provider.resolveDocumentLink(X,G);if(!(!oe||!be._validateLink(oe)))return E.DocumentLink.from(oe)}releaseLinks(H){this._cache.delete(H)}}class ae{constructor(H,G){this._documents=H,this._provider=G}async provideColors(H,G){const X=this._documents.getDocument(H),oe=await this._provider.provideDocumentColors(X,G);return Array.isArray(oe)?oe.map(ee=>({color:E.Color.from(ee.color),range:E.Range.from(ee.range)})):[]}async provideColorPresentations(H,G,X){const oe=this._documents.getDocument(H),q=E.Range.to(G.range),ee=E.Color.to(G.color),he=await this._provider.provideColorPresentations(ee,{document:oe,range:q},X);if(!!Array.isArray(he))return he.map(E.ColorPresentation.from)}}class le{constructor(H,G){this._documents=H,this._provider=G}async provideFoldingRanges(H,G,X){const oe=this._documents.getDocument(H),q=await this._provider.provideFoldingRanges(oe,G,X);if(!!Array.isArray(q))return q.map(E.FoldingRange.from)}}class Ce{constructor(H,G,X){this._documents=H,this._provider=G,this._logService=X}async provideSelectionRanges(H,G,X){const oe=this._documents.getDocument(H),q=G.map(E.Position.to),ee=await this._provider.provideSelectionRanges(oe,q,X);if(!(0,A.isNonEmptyArray)(ee))return[];if(ee.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Re=0;Re<q.length;Re++){const Ue=[];he.push(Ue);let ze=q[Re],Qe=ee[Re];for(;;){if(!Qe.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(E.SelectionRange.from(Qe)),!Qe.parent)break;ze=Qe.range,Qe=Qe.parent}}return he}}class Ee{constructor(H,G){this._documents=H,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.prepareCallHierarchy(oe,q,X);if(!ee)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(ee)?ee.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,ee)]}async provideCallsTo(H,G,X){const oe=this._itemFromCache(H,G);if(!oe)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(oe,X);if(!!q)return q.map(ee=>({from:this._cacheAndConvertItem(H,ee.from),fromRanges:ee.fromRanges.map(he=>E.Range.from(he))}))}async provideCallsFrom(H,G,X){const oe=this._itemFromCache(H,G);if(!oe)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(oe,X);if(!!q)return q.map(ee=>({to:this._cacheAndConvertItem(H,ee.to),fromRanges:ee.fromRanges.map(he=>E.Range.from(he))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,G){const X=this._cache.get(H),oe=E.CallHierarchyItem.from(G,H,X.size.toString(36));return X.set(oe._itemId,G),oe}_itemFromCache(H,G){return this._cache.get(H)?.get(G)}}class Fe{constructor(H,G){this._documents=H,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(H,G,X){const oe=this._documents.getDocument(H),q=E.Position.to(G),ee=await this._provider.prepareTypeHierarchy(oe,q,X);if(!ee)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(ee)?ee.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,ee)]}async provideSupertypes(H,G,X){const oe=this._itemFromCache(H,G);if(!oe)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(oe,X);if(!!q)return q.map(ee=>this._cacheAndConvertItem(H,ee))}async provideSubtypes(H,G,X){const oe=this._itemFromCache(H,G);if(!oe)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(oe,X);if(!!q)return q.map(ee=>this._cacheAndConvertItem(H,ee))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,G){const X=this._cache.get(H),oe=E.TypeHierarchyItem.from(G,H,X.size.toString(36));return X.set(oe._itemId,G),oe}_itemFromCache(H,G){return this._cache.get(H)?.get(G)}}class $e{constructor(H,G){this.adapter=H,this.extension=G}}class Ve{constructor(H,G,X,oe,q,ee,he){this._adapter=new Map,this._uriTransformer=G,this._proxy=H.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=oe,this._diagnostics=q,this._logService=ee,this._apiDeprecation=he}_transformDocumentSelector(H){return E.DocumentSelector.from(H,this._uriTransformer)}_createDisposable(H){return new T.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ve._handlePool++}_withAdapter(H,G,X,oe,q=!1){const ee=this._adapter.get(H);if(!ee)return Promise.resolve(oe);if(ee.adapter instanceof G){let he;ee.extension&&(he=Date.now(),this._logService.trace(`[${ee.extension.identifier.value}] INVOKE provider '${G.name}'`));const Re=X(ee.adapter,ee.extension),Ue=ee.extension;return Ue&&Promise.resolve(Re).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),ze=>{q&&ze instanceof F.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error(ze))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,G){const X=this._nextHandle();return this._adapter.set(X,new $e(H,G)),X}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,G,X,oe){const q=this._addNewAdapter(new f(this._documents,X),H),ee=oe&&oe.label||Ve._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(G),ee),this._createDisposable(q)}$provideDocumentSymbols(H,G,X){return this._withAdapter(H,f,oe=>oe.provideDocumentSymbols(s.URI.revive(G),X),void 0)}registerCodeLensProvider(H,G,X){const oe=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new $e(new d(this._documents,this._commands.converter,X),H)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(G),q);let ee=this._createDisposable(oe);if(q!==void 0){const he=X.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));ee=T.Disposable.from(ee,he)}return ee}$provideCodeLenses(H,G,X){return this._withAdapter(H,d,oe=>oe.provideCodeLenses(s.URI.revive(G),X),void 0)}$resolveCodeLens(H,G,X){return this._withAdapter(H,d,oe=>oe.resolveCodeLens(G,X),void 0)}$releaseCodeLenses(H,G){this._withAdapter(H,d,X=>Promise.resolve(X.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(H,G,X){const oe=this._addNewAdapter(new l(this._documents,X),H);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDefinition(H,G,X,oe){return this._withAdapter(H,l,q=>q.provideDefinition(s.URI.revive(G),X,oe),[])}registerDeclarationProvider(H,G,X){const oe=this._addNewAdapter(new M(this._documents,X),H);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDeclaration(H,G,X,oe){return this._withAdapter(H,M,q=>q.provideDeclaration(s.URI.revive(G),X,oe),[])}registerImplementationProvider(H,G,X){const oe=this._addNewAdapter(new r(this._documents,X),H);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideImplementation(H,G,X,oe){return this._withAdapter(H,r,q=>q.provideImplementation(s.URI.revive(G),X,oe),[])}registerTypeDefinitionProvider(H,G,X){const oe=this._addNewAdapter(new i(this._documents,X),H);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideTypeDefinition(H,G,X,oe){return this._withAdapter(H,i,q=>q.provideTypeDefinition(s.URI.revive(G),X,oe),[])}registerHoverProvider(H,G,X,oe){const q=this._addNewAdapter(new p(this._documents,X),H);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideHover(H,G,X,oe){return this._withAdapter(H,p,q=>q.provideHover(s.URI.revive(G),X,oe),void 0)}registerEvaluatableExpressionProvider(H,G,X,oe){const q=this._addNewAdapter(new m(this._documents,X),H);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideEvaluatableExpression(H,G,X,oe){return this._withAdapter(H,m,q=>q.provideEvaluatableExpression(s.URI.revive(G),X,oe),void 0)}registerInlineValuesProvider(H,G,X,oe){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new h(this._documents,X),H);this._proxy.$registerInlineValuesProvider(ee,this._transformDocumentSelector(G),q);let he=this._createDisposable(ee);if(q!==void 0){const Re=X.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(q));he=T.Disposable.from(he,Re)}return he}$provideInlineValues(H,G,X,oe,q){return this._withAdapter(H,h,ee=>ee.provideInlineValues(s.URI.revive(G),X,oe,q),void 0)}registerDocumentHighlightProvider(H,G,X){const oe=this._addNewAdapter(new w(this._documents,X),H);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentHighlights(H,G,X,oe){return this._withAdapter(H,w,q=>q.provideDocumentHighlights(s.URI.revive(G),X,oe),void 0)}registerLinkedEditingRangeProvider(H,G,X){const oe=this._addNewAdapter(new v(this._documents,X),H);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideLinkedEditingRanges(H,G,X,oe){return this._withAdapter(H,v,async q=>{const ee=await q.provideLinkedEditingRanges(s.URI.revive(G),X,oe);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?Ve._serializeRegExp(ee.wordPattern):void 0}},void 0)}registerReferenceProvider(H,G,X){const oe=this._addNewAdapter(new a(this._documents,X),H);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideReferences(H,G,X,oe,q){return this._withAdapter(H,a,ee=>ee.provideReferences(s.URI.revive(G),X,oe,q),void 0)}registerCodeActionProvider(H,G,X,oe){const q=new n.DisposableStore,ee=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,X,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(ee,this._transformDocumentSelector(G),{providedKinds:oe?.providedCodeActionKinds?.map(he=>he.value),documentation:oe?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,q)}))},Ve._extLabel(H),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(ee)),q}$provideCodeActions(H,G,X,oe,q){return this._withAdapter(H,S,ee=>ee.provideCodeActions(s.URI.revive(G),X,oe,q),void 0)}$resolveCodeAction(H,G,X){return this._withAdapter(H,S,oe=>oe.resolveCodeAction(G,X),void 0)}$releaseCodeActions(H,G){this._withAdapter(H,S,X=>Promise.resolve(X.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(H,G,X){const oe=this._addNewAdapter(new P(this._documents,X),H);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(G),H.identifier,H.displayName||H.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(H,G,X,oe){return this._withAdapter(H,P,q=>q.provideDocumentFormattingEdits(s.URI.revive(G),X,oe),void 0)}registerDocumentRangeFormattingEditProvider(H,G,X){const oe=this._addNewAdapter(new N(this._documents,X),H);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(G),H.identifier,H.displayName||H.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(H,G,X,oe,q){return this._withAdapter(H,N,ee=>ee.provideDocumentRangeFormattingEdits(s.URI.revive(G),X,oe,q),void 0)}registerOnTypeFormattingEditProvider(H,G,X,oe){const q=this._addNewAdapter(new B(this._documents,X),H);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(G),oe,H.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(H,G,X,oe,q,ee){return this._withAdapter(H,B,he=>he.provideOnTypeFormattingEdits(s.URI.revive(G),X,oe,q,ee),void 0)}registerWorkspaceSymbolProvider(H,G){const X=this._addNewAdapter(new _(G,this._logService),H);return this._proxy.$registerNavigateTypeSupport(X,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols(H,G,X){return this._withAdapter(H,_,oe=>oe.provideWorkspaceSymbols(G,X),{symbols:[]})}$resolveWorkspaceSymbol(H,G,X){return this._withAdapter(H,_,oe=>oe.resolveWorkspaceSymbol(G,X),void 0)}$releaseWorkspaceSymbols(H,G){this._withAdapter(H,_,X=>X.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(H,G,X){const oe=this._addNewAdapter(new O(this._documents,X,this._logService),H);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(G),O.supportsResolving(X)),this._createDisposable(oe)}$provideRenameEdits(H,G,X,oe,q){return this._withAdapter(H,O,ee=>ee.provideRenameEdits(s.URI.revive(G),X,oe,q),void 0)}$resolveRenameLocation(H,G,X,oe){return this._withAdapter(H,O,q=>q.resolveRenameLocation(s.URI.revive(G),X,oe),void 0)}registerDocumentSemanticTokensProvider(H,G,X,oe){const q=this._nextHandle(),ee=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new $e(new U(this._documents,X),H)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(G),oe,ee);let he=this._createDisposable(q);if(ee){const Re=X.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(ee));he=T.Disposable.from(he,Re)}return he}$provideDocumentSemanticTokens(H,G,X,oe){return this._withAdapter(H,U,q=>q.provideDocumentSemanticTokens(s.URI.revive(G),X,oe),null,!0)}$releaseDocumentSemanticTokens(H,G){this._withAdapter(H,U,X=>X.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(H,G,X,oe){const q=this._addNewAdapter(new $(this._documents,X),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(G),oe),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(H,G,X,oe){return this._withAdapter(H,$,q=>q.provideDocumentRangeSemanticTokens(s.URI.revive(G),X,oe),null,!0)}registerCompletionItemProvider(H,G,X,oe){const q=this._addNewAdapter(new V(this._documents,this._commands.converter,X,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(G),oe,V.supportsResolving(X),`${H.identifier.value}(${oe.join("")})`),this._createDisposable(q)}$provideCompletionItems(H,G,X,oe,q){return this._withAdapter(H,V,ee=>ee.provideCompletionItems(s.URI.revive(G),X,oe,q),void 0)}$resolveCompletionItem(H,G,X){return this._withAdapter(H,V,oe=>oe.resolveCompletionItem(G,X),void 0)}$releaseCompletionItems(H,G){this._withAdapter(H,V,X=>X.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(H,G,X){const oe=this._addNewAdapter(new ue(this._documents,X,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideInlineCompletions(H,G,X,oe,q){return this._withAdapter(H,ue,ee=>ee.provideInlineCompletions(s.URI.revive(G),X,oe,q),void 0)}$handleInlineCompletionDidShow(H,G,X){this._withAdapter(H,ue,async oe=>{oe.handleDidShowCompletionItem(G,X)},void 0)}$freeInlineCompletionsList(H,G){this._withAdapter(H,ue,async X=>{X.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(H,G,X,oe){const q=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ee=this._addNewAdapter(new re(this._documents,X),H);return this._proxy.$registerSignatureHelpProvider(ee,this._transformDocumentSelector(G),q),this._createDisposable(ee)}$provideSignatureHelp(H,G,X,oe,q){return this._withAdapter(H,re,ee=>ee.provideSignatureHelp(s.URI.revive(G),X,oe,q),void 0)}$releaseSignatureHelp(H,G){this._withAdapter(H,re,X=>X.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(H,G,X){const oe=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new pe(this._documents,X),H);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(G),oe);let ee=this._createDisposable(q);if(oe!==void 0){const he=X.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(oe));ee=T.Disposable.from(ee,he)}return ee}$provideInlayHints(H,G,X,oe){return this._withAdapter(H,pe,q=>q.provideInlayHints(s.URI.revive(G),X,oe),void 0)}registerDocumentLinkProvider(H,G,X){const oe=this._addNewAdapter(new be(this._documents,X),H);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(G),typeof X.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(H,G,X){return this._withAdapter(H,be,oe=>oe.provideLinks(s.URI.revive(G),X),void 0)}$resolveDocumentLink(H,G,X){return this._withAdapter(H,be,oe=>oe.resolveLink(G,X),void 0)}$releaseDocumentLinks(H,G){this._withAdapter(H,be,X=>X.releaseLinks(G),void 0)}registerColorProvider(H,G,X){const oe=this._addNewAdapter(new ae(this._documents,X),H);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentColors(H,G,X){return this._withAdapter(H,ae,oe=>oe.provideColors(s.URI.revive(G),X),[])}$provideColorPresentations(H,G,X,oe){return this._withAdapter(H,ae,q=>q.provideColorPresentations(s.URI.revive(G),X,oe),void 0)}registerFoldingRangeProvider(H,G,X){const oe=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new $e(new le(this._documents,X),H)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(G),q);let ee=this._createDisposable(oe);if(q!==void 0){const he=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ee=T.Disposable.from(ee,he)}return ee}$provideFoldingRanges(H,G,X,oe){return this._withAdapter(H,le,q=>q.provideFoldingRanges(s.URI.revive(G),X,oe),void 0)}registerSelectionRangeProvider(H,G,X){const oe=this._addNewAdapter(new Ce(this._documents,X,this._logService),H);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideSelectionRanges(H,G,X,oe){return this._withAdapter(H,Ce,q=>q.provideSelectionRanges(s.URI.revive(G),X,oe),[])}registerCallHierarchyProvider(H,G,X){const oe=this._addNewAdapter(new Ee(this._documents,X),H);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$prepareCallHierarchy(H,G,X,oe){return this._withAdapter(H,Ee,q=>Promise.resolve(q.prepareSession(s.URI.revive(G),X,oe)),void 0)}$provideCallHierarchyIncomingCalls(H,G,X,oe){return this._withAdapter(H,Ee,q=>q.provideCallsTo(G,X,oe),void 0)}$provideCallHierarchyOutgoingCalls(H,G,X,oe){return this._withAdapter(H,Ee,q=>q.provideCallsFrom(G,X,oe),void 0)}$releaseCallHierarchy(H,G){this._withAdapter(H,Ee,X=>Promise.resolve(X.releaseSession(G)),void 0)}registerTypeHierarchyProvider(H,G,X){const oe=this._addNewAdapter(new Fe(this._documents,X),H);return this._proxy.$registerTypeHierarchyProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$prepareTypeHierarchy(H,G,X,oe){return this._withAdapter(H,Fe,q=>Promise.resolve(q.prepareSession(s.URI.revive(G),X,oe)),void 0)}$provideTypeHierarchySupertypes(H,G,X,oe){return this._withAdapter(H,Fe,q=>q.provideSupertypes(G,X,oe),void 0)}$provideTypeHierarchySubtypes(H,G,X,oe){return this._withAdapter(H,Fe,q=>q.provideSubtypes(G,X,oe),void 0)}$releaseTypeHierarchy(H,G){this._withAdapter(H,Fe,X=>Promise.resolve(X.releaseSession(G)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,I.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ve._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ve._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ve._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ve._serializeRegExp(H.beforeText),afterText:H.afterText?Ve._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ve._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(H,G,X){let{wordPattern:oe}=X;if(oe&&(0,I.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(G,oe):this._documents.setWordDefinitionFor(G,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const q=this._nextHandle(),ee={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ve._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ve._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ve._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,G,ee),this._createDisposable(q)}$setWordDefinitions(H){for(const G of H)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(ye[189],_e([0,1,5,8,7,34,14,6]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(R,b,n,g){this._documents=b,this._commands=n,this._uriTransformer=g,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,b){await this._proxy.$changeLanguage(R,b);const n=this._documents.getDocumentData(R);if(!n)throw new Error(`document '${R.toString}' NOT found`);return n.document}async tokenAtPosition(R,b){const n=R.version,g=t.Position.from(b),o=await this._proxy.$tokensAtPosition(R.uri,g),c={type:E.StandardTokenType.Other,range:R.getWordRangeAtPosition(b)??new E.Range(b.line,b.character,b.line,b.character)};if(!o)return c;const u={range:t.Range.to(o.range),type:t.TokenType.to(o.type)};return!u.range.contains(b)||n!==R.version?c:u}createLanguageStatusItem(R,b,n){const g=this._handlePool++,o=this._proxy,c=this._ids,u=`${R.identifier.value}/${b}`;if(c.has(u))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);c.add(u);const F={selector:n,id:b,name:R.displayName??R.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let y,f=new I.DisposableStore;const d=()=>{y?.dispose(),y=(0,k.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(g,{id:u,name:F.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(F.selector,this._uriTransformer),label:F.text,detail:F.detail??"",severity:F.severity===E.LanguageStatusSeverity.Error?T.default.Error:F.severity===E.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:F.command&&this._commands.toInternal(F.command,f),accessibilityInfo:F.accessibilityInformation,busy:F.busy})},0)},D={dispose(){f.dispose(),y?.dispose(),o.$removeLanguageStatus(g),c.delete(u)},get id(){return F.id},get name(){return F.name},set name(l){F.name=l,d()},get selector(){return F.selector},set selector(l){F.selector=l,d()},get text(){return F.text},set text(l){F.text=l,d()},get detail(){return F.detail},set detail(l){F.detail=l,d()},get severity(){return F.severity},set severity(l){F.severity=l,d()},get accessibilityInformation(){return F.accessibilityInformation},set accessibilityInformation(l){F.accessibilityInformation=l,d()},get command(){return F.command},set command(l){F.command=l,d()},get busy(){return F.busy},set busy(l){F.busy=l,d()}};return d(),D}}e.ExtHostLanguages=C}),define(ye[190],_e([0,1,12,5,28,13,4]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends s.AbstractLoggerService{constructor(R,b){const n=new k.Emitter;super(b.logLevel,n.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,b,n){return new C(this._proxy,R,b,n)}};I=Be([He(0,T.IExtHostRpcService),He(1,E.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class C extends s.AbstractMessageLogger{constructor(R,b,n,g){super(g?.always);this.proxy=R,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(b,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,b){const n=[[R,b]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(R){this.proxy.$log(this.file,R)}}}),define(ye[191],_e([0,1,5,12,27]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(I){return I&&I.title}let k=class{constructor(C,A){this._logService=A,this._proxy=C.getProxy(s.MainContext.MainThreadMessageService)}showMessage(C,A,R,b,n){const g={extension:C};let o;typeof b=="string"||T(b)?o=[b,...n]:(g.modal=b?.modal,g.useCustom=b?.useCustom,g.detail=b?.detail,o=n),g.useCustom&&(0,E.checkProposedApiEnabled)(C,"resolvers");const c=[];for(let u=0;u<o.length;u++){const F=o[u];if(typeof F=="string")c.push({title:F,handle:u,isCloseAffordance:!1});else if(typeof F=="object"){let{title:y,isCloseAffordance:f}=F;c.push({title:y,isCloseAffordance:!!f,handle:u})}else this._logService.warn("Invalid message item:",F)}return this._proxy.$showMessage(A,R,g,c).then(u=>{if(typeof u=="number")return o[u]})}};k=Be([He(1,t.ILogService)],k),e.ExtHostMessageService=k}),define(ye[192],_e([0,1,22,4,57,6,21,9,10,2,63,5,8,7,38,166,91]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class F{constructor(f,d,D,l,M){this._textDocumentsAndEditors=D,this._textDocuments=l,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,p=r.cell.handle,h=this._documents.get(i)?.getCell(p);if(h)return h.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){const d=this._editors.get(f);if(!d)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(f){for(const[d,D]of this._editors)if(D.apiEditor===f)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,d){const D=this._documents.get(f);if(!D&&!d)throw new Error(`NO notebook document for '${f}'`);return D}_getProviderData(f){const d=this._notebookContentProviders.get(f);if(!d)throw new Error(`NO provider for '${f}'`);return d}registerNotebookContentProvider(f,d,D,l,M){if((0,I.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:f,provider:D});let r;return D.onDidChangeNotebookContentOptions&&(r=D.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(D.options);this._notebookProxy.$updateNotebookProviderOptions(d,i)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},d,n.NotebookDocumentContentOptions.from(l),F._convertNotebookRegistrationData(f,M)),new g.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(f,d){if(!d)return;const D=d.filenamePattern.map(l=>n.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(d.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:d.displayName,filenamePattern:D,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,d,D){const l=F._notebookStatusBarItemProviderHandlePool++,M=typeof D.onDidChangeCellStatusBarItems=="function"?F._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,M,d);let r;return M!==void 0&&(r=D.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(M))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,M),r&&r.dispose()})}async createNotebookDocument(f){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&n.NotebookData.from(f.content)});return A.URI.revive(d)}async openNotebookDocument(f){const d=this._documents.get(f);if(d)return d.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(f),l=this._documents.get(A.URI.revive(D));return(0,C.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(f,d){A.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let D;typeof d=="object"?D={position:n.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(n.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:D={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.notebookType,D),M=l&&this._editors.get(l)?.apiEditor;if(M)return M;throw l?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,d,D,l){const M=this._notebookStatusBarItemProviders.get(f),r=A.URI.revive(d),i=this._documents.get(r);if(!i||!M)return;const p=i.getCellFromIndex(D);if(!p)return;const m=await M.provideCellStatusBarItems(p.apiCell,l);if(!m)return;const h=new T.DisposableStore,w=this._statusBarCache.add([h]),a=(Array.isArray(m)?m:[m]).map(S=>n.NotebookStatusBarItem.from(S,this._commandsConverter,h));return{cacheId:w,items:a}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,d,D,l,M){if((0,I.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,D),this._notebookProxy.$registerNotebookSerializer(r,{id:f.identifier,location:f.extensionLocation},d,n.NotebookDocumentContentOptions.from(l),F._convertNotebookRegistrationData(f,M)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(f,d,D){const l=this._notebookSerializer.get(f);if(!l)throw new Error("NO serializer found");const M=await l.deserializeNotebook(d.buffer,D);return new o.SerializableObjectWithBuffers(n.NotebookData.from(M))}async $notebookToData(f,d,D){const l=this._notebookSerializer.get(f);if(!l)throw new Error("NO serializer found");const M=await l.serializeNotebook(n.NotebookData.to(d.value),D);return s.VSBuffer.wrap(M)}async $openNotebook(f,d,D,l,M){const{provider:r}=this._getProviderData(f),i=await r.openNotebook(A.URI.revive(d),{backupId:D,untitledDocumentData:l?.buffer},M);return new o.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(f,d,D){const l=this.getNotebookDocument(A.URI.revive(d)),{provider:M}=this._getProviderData(f);return await M.saveNotebook(l.apiNotebook,D),!0}async $saveNotebookAs(f,d,D,l){const M=this.getNotebookDocument(A.URI.revive(d)),{provider:r}=this._getProviderData(f);return await r.saveNotebookAs(A.URI.revive(D),M.apiNotebook,l),!0}async $backupNotebook(f,d,D){const l=this.getNotebookDocument(A.URI.revive(d)),M=this._getProviderData(f),r=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),i=String((0,E.hash)([l.uri.toString(),this._backupIdPool++])),p=A.URI.joinPath(r,i),m=await M.provider.backupNotebook(l.apiNotebook,{destination:p},D);return l.updateBackup(m),m.id}_createExtHostEditor(f,d,D){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const l=new u.ExtHostNotebookEditor(d,this._notebookEditorsProxy,f,D.visibleRanges.map(n.NotebookRange.to),D.selections.map(n.NotebookRange.to),typeof D.viewColumn=="number"?n.ViewColumn.to(D.viewColumn):void 0);this._editors.set(d,l)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const D of f.value.removedDocuments){const l=A.URI.revive(D),M=this._documents.get(l);M&&(M.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===l.toString()&&this._editors.delete(r.id)}if(f.value.addedDocuments){const D=[];for(const l of f.value.addedDocuments){const M=A.URI.revive(l.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const r=this,i=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(p){r._onDidChangeNotebookCells.fire(p)},emitCellOutputsChange(p){r._onDidChangeCellOutputs.fire(p)},emitCellMetadataChange(p){r._onDidChangeCellMetadata.fire(p)}},M,l);D.push(...l.cells.map(p=>c.ExtHostCell.asModelAddData(i.apiNotebook,p))),this._documents.get(M)?.dispose(),this._documents.set(M,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(f.value.addedEditors)for(const D of f.value.addedEditors){if(this._editors.has(D.id))return;const l=A.URI.revive(D.documentUri),M=this._documents.get(l);M&&this._createExtHostEditor(M,D.id,D)}const d=[];if(f.value.removedEditors)for(const D of f.value.removedEditors){const l=this._editors.get(D);l&&(this._editors.delete(D),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),d.push(l))}if(f.value.visibleEditors){this._visibleNotebookEditors=f.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const D=new Set;this._visibleNotebookEditors.forEach(l=>D.add(l.id));for(const l of this._editors.values()){const M=D.has(l.id);l._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this._activeNotebookEditor=void 0:f.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=F,F._notebookStatusBarItemProviderHandlePool=0}),define(ye[193],_e([0,1,4,54,12,5,13,8]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(b,n){const g=C._Keys.nextId();b.$registerNotebookEditorDecorationType(g,I.NotebookDecorationRenderOptions.from(n)),this.value={key:g,dispose(){b.$removeNotebookEditorDecorationType(g)}}}}C._Keys=new t.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(b,n,g){this._logService=b,this._extHostRpc=n,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(b){return new C(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),b).value}$acceptEditorPropertiesChanged(b,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,n);const g=this._notebooksAndEditors.getEditorById(b);n.visibleRanges&&g._acceptVisibleRanges(n.visibleRanges.ranges.map(I.NotebookRange.to)),n.selections&&g._acceptSelections(n.selections.selections.map(I.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:g.apiEditor,visibleRanges:g.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:g.apiEditor,selections:g.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const n in b)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(I.ViewColumn.to(b[n]))}};A=Be([He(0,E.ILogService),He(1,k.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(ye[194],_e([0,1,16,14,20,4,6,21,2,25,12,5,39,8,7,66,158,27,38]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let f=class{constructor(r,i,p,m,h){this._initData=i,this._extHostNotebook=p,this._commands=m,this._logService=h,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(b.MainContext.MainThreadNotebookKernels);const w=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",v=>!0,v=>{if(v&&"notebookEditor"in v&&"id"in v){const a=this._extHostNotebook.getIdByEditor(v.notebookEditor);return{id:v.id,extension:v.extension,notebookEditorId:a}}else if(v&&"notebookEditor"in v){const a=this._extHostNotebook.getIdByEditor(v.notebookEditor);if(a===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${v.notebookEditor.document.uri.toString()}`);return{notebookEditorId:a}}return v})],n.ApiCommandResult.Void);this._commands.registerApiCommand(w)}createNotebookController(r,i,p,m,h,w){for(const re of this._kernelData.values())if(re.controller.id===i&&A.ExtensionIdentifier.equals(r.identifier,re.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const v=this._handlePool++,a=this;this._logService.trace(`NotebookController[${v}], CREATED by ${r.identifier.value}, ${i}`);const S=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${r.identifier}'`);let P=!1;const N=new k.DisposableStore,B=new T.Emitter,_=new T.Emitter,O={id:`${r.identifier.value}/${i}`,notebookType:p,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:m||r.identifier.value,preloads:w?w.map(g.NotebookRendererScript.from):[]};let z=h??S,U;this._proxy.$addKernel(v,O).catch(re=>{console.log(re),P=!0});let $=0;const V=()=>{if(P)return;const re=++$;Promise.resolve().then(()=>{re===$&&this._proxy.$updateKernel(v,O)})},ue=new I.ResourceMap,K={get id(){return i},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return O.label},set label(re){O.label=re??r.displayName??r.name,V()},get detail(){return O.detail??""},set detail(re){O.detail=re,V()},get description(){return O.description??""},set description(re){O.description=re,V()},get kind(){return(0,F.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind??""},set kind(re){(0,F.checkProposedApiEnabled)(r,"notebookControllerKind"),O.kind=re,V()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(re){O.supportedLanguages=re,V()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(re){O.supportsExecutionOrder=re,V()},get rendererScripts(){return O.preloads?O.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(re){z=re??S},get interruptHandler(){return U},set interruptHandler(re){U=re,O.supportsInterrupt=Boolean(re),V()},createNotebookCellExecution(re){if(P)throw new Error("notebook controller is DISPOSED");if(!ue.has(re.notebook.uri))throw a._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(pe=>pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return a._createNotebookCellExecution(re)},dispose:()=>{P||(this._logService.trace(`NotebookController[${v}], DISPOSED`),P=!0,this._kernelData.delete(v),N.dispose(),B.dispose(),_.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(re,pe){a._proxy.$updateNotebookPriority(v,re.uri,pe)},onDidReceiveMessage:_.event,postMessage(re,pe){return(0,F.checkProposedApiEnabled)(r,"notebookMessaging"),a._proxy.$postMessage(v,pe&&a._extHostNotebook.getIdByEditor(pe),re)},asWebviewUri(re){return(0,F.checkProposedApiEnabled)(r,"notebookMessaging"),(0,c.asWebviewUri)(re,a._initData.remote)}};return this._kernelData.set(v,{extensionId:r.identifier,controller:K,onDidReceiveMessage:_,onDidChangeSelection:B,associatedNotebooks:ue}),K}$acceptNotebookAssociation(r,i,p){const m=this._kernelData.get(r);if(m){const h=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));p?m.associatedNotebooks.set(h.uri,!0):m.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,h.uri.toString(),p),m.onDidChangeSelection.fire({selected:p,notebook:h.apiNotebook})}}async $executeCells(r,i,p){const m=this._kernelData.get(r);if(!m)return;const h=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)),w=[];for(const v of p){const a=h.getCell(v);a&&w.push(a.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,h.uri.toString(),w.length),await m.controller.executeHandler.call(m.controller,w,h.apiNotebook,m.controller)}catch(v){this._logService.error(`NotebookController[${r}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(r,i,p){const m=this._kernelData.get(r);if(!m)return;const h=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,h.apiNotebook);else for(const w of p){const v=h.getCell(w);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,p){const m=this._kernelData.get(r);if(!m)return;const h=this._extHostNotebook.getEditorById(i);m.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:p}))}$cellExecutionChanged(r,i,p){const h=this._extHostNotebook.getNotebookDocument(C.URI.revive(r)).getCell(i);h&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:p??o.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!p)throw new Error("invalid cell");if(this._activeExecutions.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const m=new D(p.notebook,p,this._proxy);this._activeExecutions.set(p.uri,m);const h=m.onDidChangeState(()=>{m.state===d.Resolved&&(m.dispose(),h.dispose(),this._activeExecutions.delete(p.uri))});return m.asApiObject()}};f=Be([He(4,R.ILogService)],f),e.ExtHostNotebookKernels=f;var d;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(d||(d={}));class D extends k.Disposable{constructor(r,i,p){super();this._document=r,this._cell=i,this._proxy=p,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new l(10,m=>this.update(m)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new y.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const p=o.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return p===i.items?g.NotebookCellOutput.from(i):g.NotebookCellOutput.from({items:p,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,p){const m=this.cellIndexToHandle(i),h=this.validateAndConvertOutputs((0,s.asArray)(r));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:m,append:p,outputs:h})}async updateOutputItems(r,i,p){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(r),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:r.map(g.NotebookCellOutputItem.from),outputId:i.id,append:p})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(p){r._executionOrder=p,r.update([{editType:u.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,executionOrder:r._executionOrder}])},start(p){if(r._state===d.Resolved||r._state===d.Started)throw new Error("Cannot call start again");r._state=d.Started,r._onDidChangeState.fire(),r.update({editType:u.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,runStartTime:p})},end(p,m){if(r._state===d.Resolved)throw new Error("Cannot call resolve twice");r._state=d.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._document.uri,r._cell.handle,new y.SerializableObjectWithBuffers({uri:r._document.uri,cellHandle:r._cell.handle,runEndTime:m,lastRunSuccess:p}))},clearOutput(p){return r.verifyStateForOutput(),r.updateOutputs([],p,!1)},appendOutput(p,m){return r.verifyStateForOutput(),r.updateOutputs(p,m,!0)},replaceOutput(p,m){return r.verifyStateForOutput(),r.updateOutputs(p,m,!1)},appendOutputItems(p,m){return r.verifyStateForOutput(),r.updateOutputItems(p,m,!0)},replaceOutputItems(p,m){return r.verifyStateForOutput(),r.updateOutputItems(p,m,!1)}})}}class l{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(ye[195],_e([0,1,4,5,91,27]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(C,A){this._extHostNotebook=A,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,A,R){const b=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(A)?.fire({editor:b.apiEditor,message:R})}createRendererMessaging(C,A){if(!C.contributes?.notebookRenderer?.some(g=>g.id===A))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${A})`);const R=(0,T.isProposedApiEnabled)(C,"notebookEditor"),b=new WeakMap;return{onDidReceiveMessage:(g,o,c)=>{const u=R?g:F=>{const y={};b.set(y,F.editor),g({editor:y,message:F.message})};return this.getOrCreateEmitterFor(A).event(u,o,c)},postMessage:(g,o)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(g)&&([g,o]=[o,g]);const c=R?o:b.get(o),u=c&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);return this.proxy.$postMessage(u?.id,A,g)}}}getOrCreateEmitterFor(C){let A=this._rendererMessageEmitters.get(C);return A||(A=new s.Emitter({onLastListenerRemove:()=>{A?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,A),A)}}e.ExtHostNotebookRenderers=k}),define(ye[94],_e([0,1,5,6,3,13,12,159,50,28,30,109,22]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class g extends t.Disposable{constructor(u,F,y,f){super();this.id=u,this.name=F,this.logger=y,this.proxy=f,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(u){this.append(u+`
`)}append(u){this.write(u),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const u=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,u)}replace(u){const F=this.offset;this.write(u),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,F),this.visible&&this.logger.flush()}show(u,F){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof u=="boolean"?u:F))}hide(){this.proxy.$close(this.id)}write(u){this.offset+=n.VSBuffer.fromString(u).byteLength,this.logger.info(u)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=g;let o=class{constructor(u,F,y,f,d){this.extHostFileSystem=y,this.extHostFileSystemInfo=f,this.loggerService=d,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=u.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(F.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.visibleChannelId=u;for(const[F,y]of this.channels)y.visible=F===this.visibleChannelId}createOutputChannel(u,F){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const y=this.doCreateOutputChannel(u,F);return y.then(f=>{this.channels.set(f.id,f),f.visible=f.id===this.visibleChannelId}),this.createExtHostOutputChannel(u,y)}async doCreateOutputChannel(u,F){const y=await this.createOutputDirectory(),f=this.extHostFileSystemInfo.extUri.joinPath(y,`${this.namePool++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(f,{always:!0,donotRotate:!0,donotUseFormatters:!0}),D=await this.proxy.$register(u,!1,f,F.identifier.value);return new g(D,u,d,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(u,F){let y=!1;const f=()=>{if(y)throw new Error("Channel has been closed")};return{get name(){return u},append(d){f(),F.then(D=>D.append(d))},appendLine(d){f(),F.then(D=>D.appendLine(d))},clear(){f(),F.then(d=>d.clear())},replace(d){f(),F.then(D=>D.replace(d))},show(d,D){f(),F.then(l=>l.show(d,D))},hide(){f(),F.then(d=>d.hide())},dispose(){y=!0,F.then(d=>d.dispose())}}}};o=Be([He(0,T.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,C.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,k.ILoggerService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(ye[196],_e([0,1,14,20,4,6,5,2,7,15,16,34,62,27]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(c,u,F){const y=c.getProxy(k.MainContext.MainThreadQuickOpen);class f{constructor(h,w){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=w}showQuickPick(h,w,v=t.CancellationToken.None){this._onDidSelectItem=void 0;const a=Promise.resolve(h),S=++this._instances,P=y.$show(S,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},v),N={},B=P.then(()=>N);return Promise.race([B,a]).then(_=>{if(_!==N)return a.then(O=>{const z=[];for(let U=0;U<O.length;U++){const $=O[U];typeof $=="string"?z.push({label:$,handle:U}):$.kind===C.QuickPickItemKind.Separator?z.push({type:"separator",label:$.label}):z.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:U})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{w.onDidSelectItem(O[U])}),y.$setItems(S,z),P.then(U=>{if(typeof U=="number")return O[U];if(Array.isArray(U))return U.map($=>O[$])})})}).then(void 0,_=>{if(!(0,A.isPromiseCanceledError)(_))return y.$setError(S,_),Promise.reject(_)})}$onItemSelected(h){this._onDidSelectItem&&this._onDidSelectItem(h)}showInput(h,w=t.CancellationToken.None){return this._validateInput=h?h.validateInput:void 0,y.$input(h,typeof this._validateInput=="function",w).then(void 0,v=>{if(!(0,A.isPromiseCanceledError)(v))return Promise.reject(v)})}$validateInput(h){return this._validateInput?(0,s.asPromise)(()=>this._validateInput(h)):Promise.resolve(void 0)}async showWorkspaceFolderPick(h,w=t.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!v)return;const a=await this._workspace.getWorkspaceFolders2();if(!!a)return a.find(S=>S.uri.toString()===v.uri.toString())}createQuickPick(h){const w=new i(h,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(h){const w=new p(h,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}$onDidChangeValue(h,w){const v=this._sessions.get(h);v&&v._fireDidChangeValue(w)}$onDidAccept(h){const w=this._sessions.get(h);w&&w._fireDidAccept()}$onDidChangeActive(h,w){const v=this._sessions.get(h);v instanceof i&&v._fireDidChangeActive(w)}$onDidChangeSelection(h,w){const v=this._sessions.get(h);v instanceof i&&v._fireDidChangeSelection(w)}$onDidTriggerButton(h,w){const v=this._sessions.get(h);v&&v._fireDidTriggerButton(w)}$onDidTriggerItemButton(h,w,v){const a=this._sessions.get(h);a instanceof i&&a._fireDidTriggerItemButton(w,v)}$onDidHide(h){const w=this._sessions.get(h);w&&w._fireDidHide()}}class d{constructor(h,w){this._extensionId=h,this._onDidDispose=w,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((w,v)=>{const a=w===C.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(a,w)}),this.update({buttons:h.map((w,v)=>({...r(w),tooltip:w.tooltip,handle:w===C.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const w=this._handlesToButtons.get(h);w&&this._onDidTriggerButtonEmitter.fire(w)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),y.$dispose(this._id))}update(h){if(!this._disposed){for(const w of Object.keys(h)){const v=h[w];this._pendingUpdate[w]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){y.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}d._nextId=1;function D(m){if(m instanceof C.ThemeIcon)return{id:m.id};const h=M(m),w=l(m);return{dark:typeof h=="string"?I.URI.file(h):h,light:typeof w=="string"?I.URI.file(w):w}}function l(m){return typeof m=="object"&&"light"in m?m.light:m}function M(m){return typeof m=="object"&&"dark"in m?m.dark:m}function r(m){const h=D(m.iconPath);let w,v;return"id"in h?v=n.ThemeIcon.asClassName(h):w=h,{iconPath:w,iconClass:v}}class i extends d{constructor(h,w){super(h.identifier,w);this.extension=h,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){h.some(v=>v.kind!==void 0)&&(0,g.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((v,a)=>{this._handlesToItems.set(a,v),this._itemsToHandles.set(v,a)});const w=[];for(let v=0;v<h.length;v++){const a=h[v];a.kind===C.QuickPickItemKind.Separator?w.push({type:"separator",label:a.label}):w.push({handle:v,label:a.label,description:a.description,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow,buttons:a.buttons?.map((S,P)=>({...r(S),tooltip:S.tooltip,handle:P}))})}this.update({items:w})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(h){this._keepScrollPosition=h,this.update({keepScrollPosition:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(w=>this._itemsToHandles.has(w)),this.update({activeItems:this._activeItems.map(w=>this._itemsToHandles.get(w))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(w=>this._itemsToHandles.has(w)),this.update({selectedItems:this._selectedItems.map(w=>this._itemsToHandles.get(w))})}_fireDidChangeActive(h){const w=(0,R.coalesce)(h.map(v=>this._handlesToItems.get(v)));this._activeItems=w,this._onDidChangeActiveEmitter.fire(w)}_fireDidChangeSelection(h){const w=(0,R.coalesce)(h.map(v=>this._handlesToItems.get(v)));this._selectedItems=w,this._onDidChangeSelectionEmitter.fire(w)}_fireDidTriggerItemButton(h,w){const v=this._handlesToItems.get(h);if(!v||!v.buttons||!v.buttons.length)return;const a=v.buttons[w];a&&this._onDidTriggerItemButtonEmitter.fire({button:a,item:v})}}class p extends d{constructor(h,w){super(h,w);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,this.update({validationMessage:h,severity:h?b.default.Error:b.default.Ignore})}}return new f(u,F)}e.createExtHostQuickOpen=o});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[197],_e([0,1,2,4,53,6,14,5,16,104,12,25,62,8,27]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o){"use strict";var c,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function F(w){if(w)return typeof w.iconPath=="string"?s.URI.file(w.iconPath):s.URI.isUri(w.iconPath)||n.ThemeIcon.isThemeIcon(w.iconPath)?w.iconPath:void 0}function y(w,v){if(!w.iconPath&&!v.iconPath)return 0;if(w.iconPath){if(!v.iconPath)return 1}else return-1;const a=typeof w.iconPath=="string"?w.iconPath:s.URI.isUri(w.iconPath)?w.iconPath.fsPath:w.iconPath.id,S=typeof v.iconPath=="string"?v.iconPath:s.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,A.comparePaths)(a,S)}function f(w,v){let a=0;if(w.strikeThrough!==v.strikeThrough)return w.strikeThrough?1:-1;if(w.faded!==v.faded)return w.faded?1:-1;if(w.tooltip!==v.tooltip)return(w.tooltip||"").localeCompare(v.tooltip||"");if(a=y(w,v),a!==0)return a;if(w.light&&v.light)a=y(w.light,v.light);else{if(w.light)return 1;if(v.light)return-1}if(a!==0)return a;if(w.dark&&v.dark)a=y(w.dark,v.dark);else{if(w.dark)return 1;if(v.dark)return-1}return a}function d(w,v){if(w.command!==v.command)return w.command<v.command?-1:1;if(w.title!==v.title)return w.title<v.title?-1:1;if(w.tooltip!==v.tooltip){if(w.tooltip!==void 0&&v.tooltip!==void 0)return w.tooltip<v.tooltip?-1:1;if(w.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(w.arguments===v.arguments)return 0;if(w.arguments)if(v.arguments){if(w.arguments.length!==v.arguments.length)return w.arguments.length-v.arguments.length}else return 1;else return-1;for(let a=0;a<w.arguments.length;a++){const S=w.arguments[a],P=v.arguments[a];if(S!==P)return S<P?-1:1}return 0}function D(w,v){let a=(0,A.comparePaths)(w.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(a!==0)return a;if(w.command&&v.command)a=d(w.command,v.command);else{if(w.command)return 1;if(v.command)return-1}if(a!==0)return a;if(w.decorations&&v.decorations)a=f(w.decorations,v.decorations);else{if(w.decorations)return 1;if(v.decorations)return-1}return a}function l(w,v){for(let a=0;a<w.length;a++)if(w[a]!==v[a])return!1;return!0}function M(w,v){return w.command===v.command&&w.title===v.title&&w.tooltip===v.tooltip&&(w.arguments&&v.arguments?l(w.arguments,v.arguments):w.arguments===v.arguments)}function r(w,v){return(0,C.equals)(w,v,M)}class i{constructor(v,a,S){this._extension=v,this._sourceControlHandle=S,c.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Ze(this,c,a,"f")}get value(){return this._value}set value(v){v=v??"",Ie(this,c,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Ie(this,c,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Ie(this,c,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Ie(this,c,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}showValidationMessage(v,a){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),Ie(this,c,"f").$showValidationMessage(this._sourceControlHandle,v,a)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=i,c=new WeakMap;class p{constructor(v,a,S,P,N){this._proxy=v,this._commands=a,this._sourceControlHandle=S,this._id=P,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=p._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,a){const S=this._resourceStatesCommandsMap.get(v);return S?(0,k.asPromise)(()=>this._commands.executeCommand(S.command,...S.arguments||[],a)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(D),S=(0,C.sortedDiff)(this._resourceSnapshot,v,D).map(B=>{const _=B.toInsert.map(O=>{const z=this._resourceHandlePool++;this._resourceStatesMap.set(z,O);const U=O.resourceUri;let $;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Ee=new T.DisposableStore;$=this._commands.converter.toInternal(O.command,Ee),this._resourceStatesDisposablesMap.set(z,Ee)}else this._resourceStatesCommandsMap.set(z,O.command);const V=F(O.decorations),ue=O.decorations&&F(O.decorations.light)||V,K=O.decorations&&F(O.decorations.dark)||V,re=[ue,K],pe=O.decorations&&O.decorations.tooltip||"",be=O.decorations&&!!O.decorations.strikeThrough,ae=O.decorations&&!!O.decorations.faded,le=O.contextValue||"";return{rawResource:[z,U,re,pe,be,ae,le,$],handle:z}});return{start:B.start,deleteCount:B.deleteCount,toInsert:_}}),P=S.map(({start:B,deleteCount:_,toInsert:O})=>[B,_,O.map(z=>z.rawResource)]),N=S.reverse();for(const{start:B,deleteCount:_,toInsert:O}of N){const z=O.map($=>$.handle),U=this._handlesSnapshot.splice(B,_,...z);for(const $ of U)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=v,P}dispose(){this._disposed=!0,this._onDidDispose.fire()}}p._handlePool=0;class m{constructor(v,a,S,P,N,B){this._extension=v,this._commands=S,this._id=P,this._label=N,this._rootUri=B,u.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=m._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ze(this,u,a,"f"),this._inputBox=new i(v,Ie(this,u,"f"),this.handle),Ie(this,u,"f").$registerSourceControl(this.handle,P,N,B)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Ie(this,u,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Ie(this,u,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Ie(this,u,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=v;const a=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Ie(this,u,"f").$updateSourceControl(this.handle,{acceptInputCommand:a})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=v;const a=v!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Ie(this,u,"f").$updateSourceControl(this.handle,{actionButton:a??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&r(this._statusBarCommands,v))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=v;const a=(v||[]).map(S=>this._commands.converter.toInternal(S,this._statusBarDisposables.value));Ie(this,u,"f").$updateSourceControl(this.handle,{statusBarCommands:a})}get selected(){return this._selected}createResourceGroup(v,a){const S=new p(Ie(this,u,"f"),this._commands,this.handle,v,a),P=t.Event.once(S.onDidDispose)(()=>this.createdResourceGroups.delete(S));return this.createdResourceGroups.set(S,P),this.eventuallyAddResourceGroups(),S}eventuallyAddResourceGroups(){const v=[],a=[];for(const[S,P]of this.createdResourceGroups){P.dispose();const N=S.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(S),this.eventuallyUpdateResourceStates()});t.Event.once(S.onDidDispose)(()=>{this.updatedResourceGroups.delete(S),N.dispose(),this._groups.delete(S.handle),Ie(this,u,"f").$unregisterGroup(this.handle,S.handle)}),v.push([S.handle,S.id,S.label,S.features]);const B=S._takeResourceStateSnapshot();B.length>0&&a.push([S.handle,B]),this._groups.set(S.handle,S)}Ie(this,u,"f").$registerGroups(this.handle,v,a),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(a=>{const S=a._takeResourceStateSnapshot();S.length!==0&&v.push([a.handle,S])}),v.length>0&&Ie(this,u,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Ie(this,u,"f").$unregisterSourceControl(this.handle)}}u=new WeakMap,m._handlePool=0,Be([(0,E.debounce)(100)],m.prototype,"eventuallyAddResourceGroups",null),Be([(0,E.debounce)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let h=class zi{constructor(v,a,S){this._commands=a,this.logService=S,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=v.getProxy(I.MainContext.MainThreadSCM),this._telemetry=v.getProxy(I.MainContext.MainThreadTelemetry),a.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const N=this._sourceControls.get(P.sourceControlHandle);if(!N)return P;const B=N.getResourceGroup(P.groupHandle);return B?B.getResourceState(P.handle):P}else if(P&&P.$mid===4){const N=this._sourceControls.get(P.sourceControlHandle);return N?N.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const N=this._sourceControls.get(P.handle);return N||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(v,a,S,P){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,a,S,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const N=zi._handlePool++,B=new m(v,this._proxy,this._commands,a,S,P);this._sourceControls.set(N,B);const _=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier))||[];return _.push(B),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(v.identifier),_),B}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const a=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier)),S=a&&a[a.length-1];return S&&S.inputBox}$provideOriginalResource(v,a,S){const P=s.URI.revive(a);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,P.toString());const N=this._sourceControls.get(v);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(P,S)).then(B=>B||null)}$onInputBoxValueChange(v,a){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const S=this._sourceControls.get(v);return S&&S.inputBox.$onInputBoxValueChange(a),Promise.resolve(void 0)}$executeResourceCommand(v,a,S,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,a,S);const N=this._sourceControls.get(v);if(!N)return Promise.resolve(void 0);const B=N.getResourceGroup(a);return B?B.$executeResourceCommand(S,P):Promise.resolve(void 0)}$validateInput(v,a,S){this.logService.trace("ExtHostSCM#$validateInput",v);const P=this._sourceControls.get(v);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>P.inputBox.validateInput(a,S)).then(N=>{if(!N)return Promise.resolve(void 0);const B=g.MarkdownString.fromStrict(N.message);return B?Promise.resolve([B,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};h._handlePool=0,h=Be([He(2,R.ILogService)],h),e.ExtHostSCM=h});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[198],_e([0,1,7,5,121,6,8,10]),function(Z,e,s,t,E,T,k,I){"use strict";var C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(o,c,u,F,y=s.StatusBarAlignment.Left,f){C.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ze(this,C,o,"f"),Ze(this,A,c,"f"),this._entryId=R.ID_GEN++,this._extension=u,this._id=F,this._alignment=y,this._priority=this.validatePriority(f)}validatePriority(o){if(!!(0,I.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!R.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Ie(this,A,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Ie(this,A,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ie(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let c;this._name?c=this._name:c=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const F=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;Ie(this,C,"f").$setEntry(this._entryId,o,c,this._text,F,this._command?.internal,u,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,C=new WeakMap,A=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const c={message:o};return this._messages.unshift(c),this._update(),new s.Disposable(()=>{const u=this._messages.indexOf(c);u>=0&&(this._messages.splice(u,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,c){this._proxy=o.getProxy(t.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new b(this)}createStatusBarEntry(o,c,u,F){return new R(this._proxy,this._commands,o,c,u,F)}setStatusBarMessage(o,c){const u=this._statusMessage.setMessage(o);let F;return typeof c=="number"?F=setTimeout(()=>u.dispose(),c):typeof c!="undefined"&&c.then(()=>u.dispose(),()=>u.dispose()),new s.Disposable(()=>{u.dispose(),clearTimeout(F)})}}e.ExtHostStatusBar=n}),define(ye[71],_e([0,1,5,4,3]),function(Z,e,s,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,C){this._proxy.$registerExtensionStorageKeysToSync(I,C)}getValue(I,C,A){return this._proxy.$getValue(I,C).then(R=>R||A)}setValue(I,C,A){return this._proxy.$setValue(I,C,A)}$acceptValue(I,C,A){this._onDidChangeStorage.fire({shared:I,key:C,value:A})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(ye[72],_e([0,1,3,28,12,50,2]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let I=class{constructor(A,R,b){this._logService=R,this._extHostFileSystem=b,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(A){return k.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,R=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(A){if(this._value)return k.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return k.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=Be([He(0,t.IExtHostInitDataService),He(1,E.ILogService),He(2,T.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(ye[40],_e([0,1,4,5,3,2,13,6,7,122,15,161,20,36,144,62,10,14]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class y{constructor(m,h,w,v){this._proxy=m,this._id=h,this._creationOptions=w,this._name=v,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(S=>this._pidPromiseComplete=S);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},get state(){return a._state},sendText(S,P=!0){a._checkDisposed(),a._proxy.$sendText(a._id,S,P)},show(S){a._checkDisposed(),a._proxy.$show(a._id,S)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(m,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:m.name,shellPath:(0,u.withNullAsUndefined)(m.shellPath),shellArgs:(0,u.withNullAsUndefined)(m.shellArgs),cwd:(0,u.withNullAsUndefined)(m.cwd),env:(0,u.withNullAsUndefined)(m.env),icon:(0,u.withNullAsUndefined)(r(m.iconPath)),color:c.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:(0,u.withNullAsUndefined)(m.message),strictEnv:(0,u.withNullAsUndefined)(m.strictEnv),hideFromUser:(0,u.withNullAsUndefined)(m.hideFromUser),isFeatureTerminal:(0,u.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,u.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(m.location,h?.resolvedExtHostIdentifier),disablePersistence:(0,u.withNullAsUndefined)(m.disablePersistence)})}async createExtensionTerminal(m,h,w,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:w,color:c.ThemeColor.isThemeColor(v)?v.id:void 0,location:this._serializeParentTerminal(m,h),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(m,h){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in m?{viewColumn:m.viewColumn,preserveFocus:m.preserveFocus}:void 0:m}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(m){this._name=m}setExitCode(m){this._exitStatus=Object.freeze({code:m})}setDimensions(m,h){return m===this._cols&&h===this._rows||m===0||h===0?!1:(this._cols=m,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(m){this._pidPromiseComplete?(this._pidPromiseComplete(m),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==m&&(this._pidPromise=Promise.resolve(m))})}}e.ExtHostTerminal=y;class f{constructor(m){this._pty=m,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(m){this._pty.handleInput?.(m)}resize(m,h){this._pty.setDimensions?.({columns:m,rows:h})}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(m){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(m||void 0),m&&this._pty.setDimensions?.(m),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=f;let d=1,D=class extends I.Disposable{constructor(m,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=h.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new s.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(m),this._register({dispose:()=>{for(const[w,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(m=>m.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(m,h){const w=new y(this._proxy,(0,g.generateUuid)(),m,m.name),v=new f(m.pty);return w.createExtensionTerminal(m.location,this._serializeParentTerminal(m,h).resolvedExtHostIdentifier,r(m.iconPath),i(m.color)).then(a=>{const S=this._setupExtHostProcessListeners(a,v);this._terminalProcessDisposables[a]=S}),this._terminals.push(w),w.value}_serializeParentTerminal(m,h){if(h=h||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const w=m.location.parentTerminal;if(w){const v=this._terminals.find(a=>a.value===w);v&&(h.resolvedExtHostIdentifier=v._id)}}else m.location&&typeof m.location!="object"?h.location=m.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(m,h){if(!this._getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const v=new f(h),a=this._setupExtHostProcessListeners(m,v);this._terminalProcessDisposables[m]=a}async $acceptActiveTerminalChanged(m){const h=this._activeTerminal;if(m===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const w=this._getTerminalById(m);w&&(this._activeTerminal=w,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(m,h){const w=this._getTerminalById(m);w&&this._onDidWriteTerminalData.fire({terminal:w.value,data:h})}async $acceptTerminalDimensions(m,h,w){const v=this._getTerminalById(m);v&&v.setDimensions(h,w)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(m,h,w){this._terminalProcesses.get(m)?.resize(h,w)}async $acceptTerminalTitleChange(m,h){const w=this._getTerminalById(m);w&&(w.name=h)}async $acceptTerminalClosed(m,h){const w=this._getTerminalObjectIndexById(this._terminals,m);if(w!==null){const v=this._terminals.splice(w,1)[0];v.setExitCode(h),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(m,h,w,v){if(h){const P=this._getTerminalObjectIndexById(this._terminals,h);if(P!==null){this._terminals[P]._id=m,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const a={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:T.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},S=new y(this._proxy,m,a,w);this._terminals.push(S),this._onDidOpenTerminal.fire(S.value),S.isOpen=!0}async $acceptTerminalProcessId(m,h){const w=this._getTerminalById(m);w&&w._setProcessId(h)}async $startExtensionTerminal(m,h){const w=this._getTerminalById(m);if(!w)return{message:(0,A.localize)(0,null,m)};w.isOpen||await new Promise(a=>{const S=this.onDidOpenTerminal(async P=>{P===w.value&&(S.dispose(),a())})});const v=this._terminalProcesses.get(m);v?v.startSendingEvents(h):this._extensionTerminalAwaitingStart[m]={initialDimensions:h}}_setupExtHostProcessListeners(m,h){const w=new I.DisposableStore;w.add(h.onProcessReady(a=>this._proxy.$sendProcessReady(m,a.pid,a.cwd))),w.add(h.onDidChangeProperty(a=>this._proxy.$sendProcessProperty(m,a))),this._bufferer.startBuffering(m,h.onProcessData),w.add(h.onProcessExit(a=>this._onProcessExit(m,a))),this._terminalProcesses.set(m,h);const v=this._extensionTerminalAwaitingStart[m];return v&&h instanceof f&&(h.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[m]),w}$acceptProcessAckDataEvent(m,h){this._terminalProcesses.get(m)?.acknowledgeDataEvent(h)}$acceptProcessInput(m,h){this._terminalProcesses.get(m)?.input(h)}$acceptTerminalInteraction(m){const h=this._getTerminalById(m);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(m,h,w){try{this._terminalProcesses.get(m)?.resize(h,w)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(m,h){this._terminalProcesses.get(m)?.shutdown(h)}$acceptProcessRequestInitialCwd(m){this._terminalProcesses.get(m)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(m,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(m){this._terminalProcesses.get(m)?.getCwd().then(h=>this._proxy.$sendProcessProperty(m,{type:"cwd",value:h}))}$acceptProcessRequestLatency(m){return m}registerLinkProvider(m){return this._linkProviders.add(m),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(m),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(m,h,w){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,w),this._proxy.$registerProfileProvider(h,m.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(m,h){const w=new n.CancellationTokenSource().token;let v=await this._profileProviders.get(m)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(v&&!("options"in v)&&(v={options:v}),!v||!("options"in v))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in v.options){this.createExtensionTerminal(v.options,h);return}this.createTerminalFromOptions(v.options,h)}}async $provideLinks(m,h){const w=this._getTerminalById(m);if(!w)return[];this._terminalLinkCache.delete(m);const v=this._terminalLinkCancellationSource.get(m);v&&v.dispose(!0);const a=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(m,a);const S=[],P={terminal:w.value,line:h},N=[];for(const O of this._linkProviders)N.push(F.Promises.withAsyncBody(async z=>{a.token.onCancellationRequested(()=>z({provider:O,links:[]}));const U=await O.provideTerminalLinks(P,a.token)||[];a.token.isCancellationRequested||z({provider:O,links:U})}));const B=await Promise.all(N);if(a.token.isCancellationRequested)return[];const _=new Map;for(const O of B)O&&O.links.length>0&&S.push(...O.links.map(z=>{const U={id:d++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return _.set(U.id,{provider:O.provider,link:z}),U}));return this._terminalLinkCache.set(m,_),S}$activateLink(m,h){const w=this._terminalLinkCache.get(m)?.get(h);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(m,h){this._bufferer.stopBuffering(m),this._terminalProcesses.delete(m),delete this._extensionTerminalAwaitingStart[m];const w=this._terminalProcessDisposables[m];w&&(w.dispose(),delete this._terminalProcessDisposables[m]),this._proxy.$sendProcessExit(m,h)}_getTerminalById(m){return this._getTerminalObjectById(this._terminals,m)}_getTerminalObjectById(m,h){const w=this._getTerminalObjectIndexById(m,h);return w!==null?m[w]:null}_getTerminalObjectIndexById(m,h){let w=null;return m.some((v,a)=>v._id===h?(w=a,!0):!1),w}getEnvironmentVariableCollection(m){let h=this._environmentVariableCollections.get(m.identifier.value);return h||(h=new l,this._setEnvironmentVariableCollection(m.identifier.value,h)),h}_syncEnvironmentVariableCollection(m,h){const w=(0,b.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(m,h.persistent,w.length===0?void 0:w)}$initEnvironmentVariableCollections(m){m.forEach(h=>{const w=h[0],v=new l(h[1]);this._setEnvironmentVariableCollection(w,v)})}$acceptDefaultProfile(m,h){this._defaultProfile=m,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(m,h){this._environmentVariableCollections.set(m,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(m,h)})}};D=Be([He(1,k.IExtHostRpcService)],D),e.BaseExtHostTerminalService=D;class l{constructor(m){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(m)}get persistent(){return this._persistent}set persistent(m){this._persistent=m,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(m,h){this._setIfDiffers(m,{value:h,type:C.EnvironmentVariableMutatorType.Replace})}append(m,h){this._setIfDiffers(m,{value:h,type:C.EnvironmentVariableMutatorType.Append})}prepend(m,h){this._setIfDiffers(m,{value:h,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(m,h){const w=this.map.get(m);(!w||w.value!==h.value||w.type!==h.type)&&(this.map.set(m,h),this._onDidChangeCollection.fire())}get(m){return this.map.get(m)}forEach(m,h){this.map.forEach((w,v)=>m.call(h,v,w,this))}delete(m){this.map.delete(m),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let M=class extends D{constructor(m){super(!1,m)}createTerminal(m,h,w){throw new R.NotSupportedError}createTerminalFromOptions(m,h){throw new R.NotSupportedError}};M=Be([He(0,k.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function r(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function i(p){return c.ThemeColor.isThemeColor(p)?p:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[199],_e([0,1,16,22,20,4,231,57,6,26,10,36,5,13,48,8,7,168,88,67]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let D=class{constructor(P,N){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=P.getProxy(n.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new M(this.proxy),N.registerArgumentProcessor({processArgument:B=>B?.$mid===13?c.TestItem.toItemFromContext(B):B})}createTestController(P,N){if(this.controllers.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const B=new C.DisposableStore,_=B.add(new F.SingleUseTestCollection(P));_.root.label=N;const O=new Map,z=this.proxy,U={items:_.root.children,get label(){return N},set label(V){N=V,_.root.label=V,z.$updateControllerLabel(P,N)},get id(){return P},createRunProfile:(V,ue,K,re,pe)=>{let be=(0,I.hash)(V);for(;O.has(be);)be++;const ae=new v(this.proxy,P,be,V,ue,K,re,pe);return O.set(be,ae),ae},createTestItem(V,ue,K){return new o.TestItemImpl(P,V,ue,K)},createTestRun:(V,ue,K=!0)=>this.runTracker.createTestRun(P,_,V,ue,K),set resolveHandler(V){_.resolveHandler=V},get resolveHandler(){return _.resolveHandler},dispose:()=>{B.dispose()}};U.createRunConfiguration=U.createRunProfile,z.$registerTestController(P,N),B.add((0,C.toDisposable)(()=>z.$unregisterTestController(P)));const $={controller:U,collection:_,profiles:O};return this.controllers.set(P,$),B.add((0,C.toDisposable)(()=>this.controllers.delete(P))),B.add(_.onDidGenerateDiff(V=>z.$publishDiff(P,V))),U}createTestObserver(){return this.observer.checkout()}async runTests(P,N=E.CancellationToken.None){const B=r(P);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const _=this.controllers.get(B.controllerId);if(!_)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:P.include?.map(O=>O.id)??[_.collection.root.id],profileGroup:a[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:P.exclude?.map(O=>O.id)},N)}$provideFileCoverage(P,N,B){return(0,s.mapFind)(this.runTracker.trackers,O=>O.id===P?O.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(P,N,B,_){return(0,s.mapFind)(this.runTracker.trackers,z=>z.id===P?z.getCoverage(N):void 0)?.resolveFileCoverage(B,_)??Promise.resolve([])}$configureRunProfile(P,N){this.controllers.get(P)?.profiles.get(N)?.configureHandler?.()}$publishTestResults(P){this.results=Object.freeze(P.map(N=>(0,A.deepFreeze)(c.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(P,N){const B=this.controllers.get(f.TestId.fromString(P).controllerId)?.collection;B&&(await B.expand(P,N<0?1/0:N),B.flushDiff())}$acceptDiff(P){this.observer.applyDiff(P)}async $runControllerTests(P,N){const B=this.controllers.get(P.controllerId);if(!B)return;const{collection:_,profiles:O}=B,z=O.get(P.profileId);if(!z)return;const U=P.testIds.map(K=>_.tree.get(K)).filter(R.isDefined),$=P.excludeExtIds.map(K=>B.collection.tree.get(K)).filter(R.isDefined).filter(K=>U.some(re=>re.fullId.compare(K.fullId)===2));if(!U.length)return;const V=new u.TestRunRequest(U.some(K=>K.actual instanceof o.TestItemRootImpl)?void 0:U.map(K=>K.actual),$.map(K=>K.actual),z),ue=this.runTracker.prepareForMainThreadTestRun(V,i.fromInternal(P,B.collection),N);try{await z.runHandler(V,N)}finally{ue.isRunning&&!N.isCancellationRequested&&await T.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(P){P===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(P)}};D=Be([He(0,g.IExtHostRpcService)],D),e.ExtHostTesting=D;class l extends C.Disposable{constructor(P,N,B){super();this.dto=P,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:_}of this.tasks.values())_.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(P){return this.tasks.get(P)?.coverage}createRun(P){const N=this.dto.id,B=this.dto.controllerId,_=(0,b.generateUuid)(),O=new p(this.proxy,N,_),z=ue=>(K,...re)=>{if($){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),ue(K,...re))},U=(ue,K)=>{const re=K instanceof Array?K.map(c.TestMessage.from):[c.TestMessage.from(K)];if(ue.uri&&ue.range){const pe={range:c.Range.from(ue.range),uri:ue.uri};for(const be of re)be.location=be.location||pe}this.proxy.$appendTestMessagesInRun(N,_,f.TestId.fromExtHostTestItem(ue,B).toString(),re)};let $=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:P,get coverageProvider(){return O.coverageProvider},set coverageProvider(ue){O.coverageProvider=ue},enqueued:z(ue=>{this.proxy.$updateTestStateInRun(N,_,f.TestId.fromExtHostTestItem(ue,B).toString(),1)}),skipped:z(ue=>{this.proxy.$updateTestStateInRun(N,_,f.TestId.fromExtHostTestItem(ue,B).toString(),5)}),started:z(ue=>{this.proxy.$updateTestStateInRun(N,_,f.TestId.fromExtHostTestItem(ue,B).toString(),2)}),errored:z((ue,K,re)=>{U(ue,K),this.proxy.$updateTestStateInRun(N,_,f.TestId.fromExtHostTestItem(ue,B).toString(),6,re)}),failed:z((ue,K,re)=>{U(ue,K),this.proxy.$updateTestStateInRun(N,_,f.TestId.fromExtHostTestItem(ue,B).toString(),4,re)}),passed:z((ue,K)=>{this.proxy.$updateTestStateInRun(N,_,f.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,K)}),appendOutput:(ue,K,re)=>{$||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(N,_,t.VSBuffer.fromString(ue),K&&c.location.from(K),re&&f.TestId.fromExtHostTestItem(re,B).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(N,_),this.tasks.delete(_),this.isRunning||this.dispose())}};return this.tasks.set(_,{run:V,coverage:O}),this.proxy.$startedTestRunTask(N,{id:_,name:P,running:!0}),V}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(P){if(!(P instanceof o.TestItemImpl))throw new o.InvalidTestItemError(P.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(P,this.dto.controllerId).toString()))return;const N=[],B=this.dto.colllection.root;for(;;){const _=c.TestItem.from(P);if(N.unshift(_),this.sharedTestIds.has(_.extId)||(this.sharedTestIds.add(_.extId),P===B))break;P=P.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class M{constructor(P){this.proxy=P,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(P,N,B){return this.getTracker(P,N,B)}cancelRunById(P){for(const N of this.tracked.values())if(N.id===P){N.dispose();return}}cancelAllRuns(){for(const P of this.tracked.values())P.dispose()}createTestRun(P,N,B,_,O){const z=this.tracked.get(B);if(z)return z.createRun(_);const U=i.fromPublic(P,N,B,O),$=r(B);this.proxy.$startedExtensionTestRun({controllerId:P,profile:$&&{group:a[$.kind],id:$.profileId},exclude:B.exclude?.map(ue=>ue.id)??[],id:U.id,include:B.include?.map(ue=>ue.id)??[N.root.id],persist:O});const V=this.getTracker(B,U);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),V.createRun(_)}getTracker(P,N,B){const _=new l(N,this.proxy,B);return this.tracked.set(P,_),_.onEnd(()=>this.tracked.delete(P)),_}}e.TestRunCoordinator=M;const r=S=>{if(!!S.profile){if(!(S.profile instanceof v))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return S.profile}};class i{constructor(P,N,B,_,O,z){this.controllerId=P,this.id=N,this.isPersisted=O,this.colllection=z,this.includePrefix=B.map(U=>U+"\0"),this.excludePrefix=_.map(U=>U+"\0")}static fromPublic(P,N,B,_){return new i(P,(0,b.generateUuid)(),B.include?.map(O=>f.TestId.fromExtHostTestItem(O,P).toString())??[P],B.exclude?.map(O=>f.TestId.fromExtHostTestItem(O,P).toString())??[],_,N)}static fromInternal(P,N){return new i(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,N)}isIncluded(P){const N=f.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(N===B||N.startsWith(B))return!1;for(const B of this.includePrefix)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=i;class p{constructor(P,N,B){this.proxy=P,this.runId=N,this.taskId=B}set coverageProvider(P){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!P||(this._coverageProvider=P,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(P){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(P))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(P,N){const B=await this.fileCoverage;let _=B?.[P];return!this._coverageProvider||!B||!_?[]:(_.detailedCoverage||(_=B[P]=await this._coverageProvider.resolveFileCoverage?.(_,N)??_),_.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class m extends y.IncrementalChangeCollector{constructor(P){super();this.emitter=P,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(P){this.added.add(P)}update(P){Object.assign(P.revived,c.TestItem.toPlain(P.item)),this.added.has(P)||this.updated.add(P)}remove(P){if(this.added.has(P)){this.added.delete(P);return}if(this.updated.delete(P),P.parent&&this.alreadyRemoved.has(P.parent)){this.alreadyRemoved.add(P.item.extId);return}this.removed.add(P)}getChangeEvent(){const{added:P,updated:N,removed:B}=this;return{get added(){return[...P].map(_=>_.revived)},get updated(){return[...N].map(_=>_.revived)},get removed(){return[...B].map(_=>_.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(P){return this.items.get(P)}getMirroredTestDataByReference(P){return this.items.get(P.id)}createItem(P,N){return{...P,revived:c.TestItem.toPlain(P.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}e.MirroredTestCollection=h;class w{constructor(P){this.proxy=P}checkout(){this.current||(this.current=this.createObserverData());const P=this.current;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(N=>N.revived)},dispose:(0,k.once)(()=>{--P.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(P){return this.current?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.current?.tests.apply(P)}createObserverData(){const P=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:P}}}class v{constructor(P,N,B,_,O,z,U=!1,$=void 0){this.controllerId=N,this.profileId=B,this._label=_,this.kind=O,this.runHandler=z,this._isDefault=U,this._tag=$,d.set(this,void 0),Ze(this,d,P,"f");const V=a[O];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${O}`);Ie(this,d,"f").$publishTestRunProfile({profileId:B,controllerId:N,tag:$?c.TestTag.namespace(this.controllerId,$.id):null,label:_,group:V,isDefault:U,hasConfigurationHandler:!1})}get label(){return this._label}set label(P){P!==this._label&&(this._label=P,Ie(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:P}))}get isDefault(){return this._isDefault}set isDefault(P){P!==this._isDefault&&(this._isDefault=P,Ie(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,Ie(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:P?c.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(P){P!==this._configureHandler&&(this._configureHandler=P,Ie(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!P}))}dispose(){Ie(this,d,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=v,d=new WeakMap;const a={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(ye[200],_e([0,1,4,16,5,92,8,7]),function(Z,e,s,t,E,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(R,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new s.Emitter,this._onDidChangeTextEditorOptions=new s.Emitter,this._onDidChangeTextEditorVisibleRanges=new s.Emitter,this._onDidChangeTextEditorViewColumn=new s.Emitter,this._onDidChangeActiveTextEditor=new s.Emitter,this._onDidChangeVisibleTextEditors=new s.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const b=this._extHostDocumentsAndEditors.allEditors();return R?b:b.map(n=>n.value)}async showTextDocument(R,b,n){let g;typeof b=="number"?g={position:k.ViewColumn.from(b),preserveFocus:n}:typeof b=="object"?g={position:k.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?k.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:g={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(R.uri,g),c=o&&this._extHostDocumentsAndEditors.getEditor(o);if(c)return c.value;throw o?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,b){return new T.TextEditorDecorationType(this._proxy,R,b).value}$acceptEditorPropertiesChanged(R,b){const n=this._extHostDocumentsAndEditors.getEditor(R);if(!n)throw new Error("unknown text editor");if(b.options&&n._acceptOptions(b.options),b.selections){const g=b.selections.selections.map(k.Selection.to);n._acceptSelections(g)}if(b.visibleRanges){const g=t.coalesce(b.visibleRanges.map(k.Range.to));n._acceptVisibleRanges(g)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...b.options,lineNumbers:k.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const g=I.TextEditorSelectionChangeKind.fromValue(b.selections.source),o=b.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:o,kind:g})}if(b.visibleRanges){const g=t.coalesce(b.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:g})}}$acceptEditorPositionData(R){for(const b in R){const n=this._extHostDocumentsAndEditors.getEditor(b);if(!n)throw new Error("Unknown text editor");const g=k.ViewColumn.to(R[b]);n.value.viewColumn!==g&&(n._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:g}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=C}),define(ye[201],_e([0,1,2,3,5,6,7]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(R,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(E.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const g=n.uri===void 0?void 0:s.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(C(g))?.get(n.handle)}return n}})}async $getTimeline(R,b,n,g,o){return this._providers.get(R)?.provideTimeline(s.URI.revive(b),n,g,o)}registerTimelineProvider(R,b,n,g){const o=new T.DisposableStore,c=this.convertTimelineItem(b.id,g,o).bind(this);let u;b.onDidChange&&(u=b.onDidChange(y=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...y,id:b.id}),this));const F=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:R,onDidChange:void 0,async provideTimeline(y,f,d,D){D?.resetCache&&(o.clear(),F.get(b.id)?.clear());const l=await b.provideTimeline(y,f,d);if(l==null)return;const M=c(y,D);return{...l,source:b.id,items:l.items.map(M)}},dispose(){for(const y of F.values())y.get(b.id)?.clear();u?.dispose(),o.dispose()}})}convertTimelineItem(R,b,n){return(g,o)=>{let c;if(o?.cacheResults){let u=this._itemsBySourceAndUriMap.get(R);u===void 0&&(u=new Map,this._itemsBySourceAndUriMap.set(R,u));const F=C(g);c=u.get(F),c===void 0&&(c=new Map,u.set(F,c))}return u=>{const{iconPath:F,...y}=u,f=`${R}|${u.id??u.timestamp}`;c?.set(f,u);let d,D,l;return u.iconPath&&(F instanceof k.ThemeIcon?l={id:F.id,color:F.color}:s.URI.isUri(F)?(d=F,D=F):{light:d,dark:D}=F),{...y,id:y.id??void 0,handle:f,source:R,command:u.command?b.toInternal(u.command,n):void 0,icon:d,iconDark:D,themeIcon:l,accessibilityInformation:u.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,T.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=I;function C(A){return A?.toString()}}),define(ye[202],_e([0,1,6,11,2,5]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(C){this._openers=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,A,R,b){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const n=b.schemes.find(g=>!k.supportedSchemes.has(g));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,R),this._proxy.$registerUriOpener(A,b.schemes,C,b.label),(0,s.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(C,A,R){const b=this._openers.get(C);if(!b)throw new Error(`Unknown opener with id: ${C}`);const n=E.URI.revive(A);return b.canOpenExternalUri(n,R)}async $openUri(C,A,R){const b=this._openers.get(C);if(!b)throw new Error(`Unknown opener id: '${C}'`);return b.openExternalUri(E.URI.revive(A.resolvedUri),{sourceUri:E.URI.revive(A.sourceUri)},R)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[203],_e([0,1,5,2,6,15,25]),function(Z,e,s,t,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(A,R){if(this.handles.has(k.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const b=I.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(A)),this.handlers.set(b,R),this._proxy.$registerUriHandler(b,A),(0,E.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(A)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(A,R){const b=this.handlers.get(A);if(!b)return Promise.resolve(void 0);try{b.handleUri(t.URI.revive(R))}catch(n){(0,T.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(A){return t.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=I,I.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[51],_e([0,1,4,11,2,131,151,66,5]),function(Z,e,s,t,E,T,k,I,C){"use strict";var A,R,b,n,g,o,c,u,F,y,f,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{constructor(w,v,a,S,P,N,B){A.set(this,void 0),R.set(this,void 0),b.set(this,void 0),n.set(this,void 0),g.set(this,void 0),o.set(this,void 0),c.set(this,""),u.set(this,void 0),F.set(this,!1),y.set(this,!1),f.set(this,!1),this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new s.Emitter),this._onDidDispose=Ie(this,d,"f").event,Ze(this,A,w,"f"),Ze(this,R,v,"f"),Ze(this,u,a,"f"),Ze(this,n,S,"f"),Ze(this,g,P,"f"),Ze(this,o,N,"f"),Ze(this,f,l(N),"f"),Ze(this,b,B,"f")}dispose(){Ze(this,F,!0,"f"),Ie(this,d,"f").fire(),Ie(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return Ze(this,y,!0,"f"),(0,I.asWebviewUri)(w,Ie(this,n,"f").remote)}get cspSource(){const w=Ie(this,o,"f").extensionLocation;if(w.scheme===t.Schemas.https||w.scheme===t.Schemas.http){let v=w.toString();return v.endsWith("/")||(v+="/"),v+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ie(this,c,"f")}set html(w){this.assertNotDisposed(),Ie(this,c,"f")!==w&&(Ze(this,c,w,"f"),!Ie(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(Ze(this,y,!0,"f"),Ie(this,b,"f").report("Webview vscode-resource: uris",Ie(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ie(this,R,"f").$setHtml(Ie(this,A,"f"),w))}get options(){return this.assertNotDisposed(),Ie(this,u,"f")}set options(w){this.assertNotDisposed(),Ie(this,R,"f").$setOptions(Ie(this,A,"f"),i(Ie(this,o,"f"),Ie(this,g,"f"),w)),Ze(this,u,w,"f")}async postMessage(w){if(Ie(this,F,"f"))return!1;const v=(0,k.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Ie(this,f,"f")});return Ie(this,R,"f").$postMessage(Ie(this,A,"f"),v.message,...v.buffers)}assertNotDisposed(){if(Ie(this,F,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=D,A=new WeakMap,R=new WeakMap,b=new WeakMap,n=new WeakMap,g=new WeakMap,o=new WeakMap,c=new WeakMap,u=new WeakMap,F=new WeakMap,y=new WeakMap,f=new WeakMap,d=new WeakMap;function l(h){try{const w=(0,T.normalizeVersion)((0,T.parseVersion)(h.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class M{constructor(w,v,a,S,P){this.initData=v,this.workspace=a,this._logService=S,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=w.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(w,v,a){const S=this.getWebview(w);if(S){const{message:P}=(0,k.deserializeWebviewMessage)(v,a.value);S._onMessageEmitter.fire(P)}}$onMissingCsp(w,v){this._logService.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,v,a){const S=new D(w,this._webviewProxy,p(v),this.initData,this.workspace,a,this._deprecationService);return this._webviews.set(w,S),S._onDidDispose(()=>{this._webviews.delete(w)}),S}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=M;function r(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=r;function i(h,w,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||m(h,w)}}e.serializeWebviewOptions=i;function p(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(w=>E.URI.from(w))}}e.reviveOptions=p;function m(h,w){return[...(w?.getWorkspaceFolders()||[]).map(v=>v.uri),h.extensionLocation]}}),define(ye[204],_e([0,1,20,57,6,11,24,2,8,51,63,5,7]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(l,M){this.document=l,this._storagePath=M,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,M){await this.getEdit(l).undo(),M||this.disposeBackup()}async redo(l,M){await this.getEdit(l).redo(),M||this.disposeBackup()}disposeEdits(l){for(const M of l)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=d(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const M=this._edits.get(l,0);if(!M)throw new Error("No edit found");return M}}class o{constructor(){this._documents=new Map}get(l,M){return this._documents.get(this.key(l,M))}add(l,M,r){const i=this.key(l,M.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${l} resource:${M.uri}`);const p=new g(M,r);return this._documents.set(i,p),p}delete(l,M){const r=this.key(l,M.uri);this._documents.delete(r)}key(l,M){return`${l}@@@${M}`}}var c;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(c||(c={}));class u{constructor(){this._providers=new Map}addTextProvider(l,M,r){return this.add(0,l,M,r)}addCustomProvider(l,M,r){return this.add(1,l,M,r)}get(l){return this._providers.get(l)}add(l,M,r,i){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:l,extension:r,provider:i}),new n.Disposable(()=>this._providers.delete(M))}}class F{constructor(l,M,r,i,p){this._extHostDocuments=M,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=p,this._editorProviders=new u,this._documents=new o,this._proxy=l.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,M,r,i){const p=new E.DisposableStore;return y(r)?(p.add(this._editorProviders.addTextProvider(M,l,r)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(l),M,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(l))):(p.add(this._editorProviders.addCustomProvider(M,l,r)),this.supportEditing(r)&&p.add(r.onDidChangeCustomDocument(m=>{const h=this.getCustomDocumentEntry(M,m.document.uri);if(f(m)){const w=h.addEdit(m);this._proxy.$onDidEdit(m.document.uri,M,w,m.label)}else this._proxy.$onContentChange(m.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(l),M,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(l))),n.Disposable.from(p,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(l,M,r,i,p){const m=this._editorProviders.get(M);if(!m)throw new Error(`No provider found for '${M}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${M}'`);const h=I.URI.revive(l),w=await m.provider.openCustomDocument(h,{backupId:r,untitledDocumentData:i?.buffer},p);let v;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(v=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(M,w,v),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(l,M){const r=this._editorProviders.get(M);if(!r)throw new Error(`No provider found for '${M}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${M}'`);const i=I.URI.revive(l),{document:p}=this.getCustomDocumentEntry(M,i);this._documents.delete(M,p),p.dispose()}async $resolveWebviewEditor(l,M,r,i,p,m){const h=this._editorProviders.get(r);if(!h)throw new Error(`No provider found for '${r}'`);const w=C.ViewColumn.to(p),v=this._extHostWebview.createNewWebview(M,i.webviewOptions,h.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(M,r,i.title,w,i.panelOptions,v),S=I.URI.revive(l);switch(h.type){case 1:{const{document:P}=this.getCustomDocumentEntry(r,S);return h.provider.resolveCustomEditor(P,a,m)}case 0:{const P=this._extHostDocuments.getDocument(S);return h.provider.resolveCustomTextEditor(P,a,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,M,r){this.getCustomDocumentEntry(M,l).disposeEdits(r)}async $onMoveCustomEditor(l,M,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const p=this._extHostWebviewPanels.getWebviewPanel(l);if(!p)throw new Error("No webview found");const m=I.URI.revive(M),h=this._extHostDocuments.getDocument(m);await i.provider.moveCustomTextEditor(h,p,s.CancellationToken.None)}async $undo(l,M,r,i){return this.getCustomDocumentEntry(M,l).undo(r,i)}async $redo(l,M,r,i){return this.getCustomDocumentEntry(M,l).redo(r,i)}async $revert(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(l,M,r,i){const p=this.getCustomDocumentEntry(M,l);return this.getCustomEditorProvider(M).saveCustomDocumentAs(p.document,I.URI.revive(r),i)}async $backup(l,M,r){const i=this.getCustomDocumentEntry(M,l),m=await this.getCustomEditorProvider(M).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(m),m.id}getCustomDocumentEntry(l,M){const r=this._documents.get(l,I.URI.revive(M));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(l){const r=this._editorProviders.get(l)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=F;function y(D){return typeof D.resolveCustomTextEditor=="function"}function f(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function d(D){const l=D.scheme===T.Schemas.file||D.scheme===T.Schemas.untitled?D.fsPath:D.toString();return(0,t.hash)(l)+""}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[205],_e([0,1,4,6,2,36,8,51,5,7]),function(Z,e,s,t,E,T,k,I,C,A){"use strict";var R,b,n,g,o,c,u,F,y,f,d,D,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends t.Disposable{constructor(m,h,w,v,a,S,P){super();R.set(this,void 0),b.set(this,void 0),n.set(this,void 0),g.set(this,void 0),o.set(this,void 0),c.set(this,void 0),u.set(this,void 0),F.set(this,void 0),y.set(this,!0),f.set(this,!0),d.set(this,!1),D.set(this,this._register(new s.Emitter)),this.onDidDispose=Ie(this,D,"f").event,l.set(this,this._register(new s.Emitter)),this.onDidChangeViewState=Ie(this,l,"f").event,Ze(this,R,m,"f"),Ze(this,b,h,"f"),Ze(this,n,w,"f"),Ze(this,o,S,"f"),Ze(this,F,a,"f"),Ze(this,c,v,"f"),Ze(this,g,P,"f")}dispose(){Ie(this,d,"f")||(Ze(this,d,!0,"f"),Ie(this,D,"f").fire(),Ie(this,b,"f").$disposeWebview(Ie(this,R,"f")),Ie(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ie(this,g,"f")}get viewType(){return this.assertNotDisposed(),Ie(this,n,"f")}get title(){return this.assertNotDisposed(),Ie(this,c,"f")}set title(m){this.assertNotDisposed(),Ie(this,c,"f")!==m&&(Ze(this,c,m,"f"),Ie(this,b,"f").$setTitle(Ie(this,R,"f"),m))}get iconPath(){return this.assertNotDisposed(),Ie(this,u,"f")}set iconPath(m){this.assertNotDisposed(),Ie(this,u,"f")!==m&&(Ze(this,u,m,"f"),Ie(this,b,"f").$setIconPath(Ie(this,R,"f"),E.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Ie(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ie(this,F,"f")=="number"&&Ie(this,F,"f")<0))return Ie(this,F,"f")}get active(){return this.assertNotDisposed(),Ie(this,f,"f")}get visible(){return this.assertNotDisposed(),Ie(this,y,"f")}_updateViewState(m){Ie(this,d,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(Ze(this,f,m.active,"f"),Ze(this,y,m.visible,"f"),Ze(this,F,m.viewColumn,"f"),Ie(this,l,"f").fire({webviewPanel:this}))}reveal(m,h){this.assertNotDisposed(),Ie(this,b,"f").$reveal(Ie(this,R,"f"),{viewColumn:m?k.ViewColumn.from(m):void 0,preserveFocus:!!h})}assertNotDisposed(){if(Ie(this,d,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,b=new WeakMap,n=new WeakMap,g=new WeakMap,o=new WeakMap,c=new WeakMap,u=new WeakMap,F=new WeakMap,y=new WeakMap,f=new WeakMap,d=new WeakMap,D=new WeakMap,l=new WeakMap;class r{constructor(m,h,w){this.webviews=h,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(m,h,w,v,a={}){const S=typeof v=="object"?v.viewColumn:v,P={viewColumn:k.ViewColumn.from(S),preserveFocus:typeof v=="object"&&!!v.preserveFocus},N=(0,I.shouldSerializeBuffersForPostMessage)(m),B=r.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(m),B,h,{title:w,panelOptions:i(a),webviewOptions:(0,I.serializeWebviewOptions)(m,this.workspace,a),serializeBuffersForPostMessage:N},P);const _=this.webviews.createNewWebview(B,a,m);return this.createNewWebviewPanel(B,h,w,S,a,_)}$onDidChangeWebviewPanelViewStates(m){const h=Object.keys(m);h.sort((w,v)=>{const a=m[w],S=m[v];return a.active?1:S.active?-1:+a.visible-+S.visible});for(const w of h){const v=this.getWebviewPanel(w);if(!v)continue;const a=m[w];v._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,h,w){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:w,extension:m}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(m)}),new A.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(m,h,w,v){const a=this._serializers.get(h);if(!a)throw new Error(`No serializer found for '${h}'`);const{serializer:S,extension:P}=a,N=this.webviews.createNewWebview(m,w.webviewOptions,P),B=this.createNewWebviewPanel(m,h,w.title,v,w.panelOptions,N);await S.deserializeWebviewPanel(B,w.state)}createNewWebviewPanel(m,h,w,v,a,S){const P=new M(m,this._proxy,h,w,v,a,S);return this._webviewPanels.set(m,P),P}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=r;function i(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[206],_e([0,1,4,6,51,5,7]),function(Z,e,s,t,E,T,k){"use strict";var I,C,A,R,b,n,g,o,c,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class F extends t.Disposable{constructor(d,D,l,M,r,i){super();I.set(this,void 0),C.set(this,void 0),A.set(this,void 0),R.set(this,void 0),b.set(this,!1),n.set(this,void 0),g.set(this,void 0),o.set(this,void 0),c.set(this,this._register(new s.Emitter)),this.onDidChangeVisibility=Ie(this,c,"f").event,u.set(this,this._register(new s.Emitter)),this.onDidDispose=Ie(this,u,"f").event,Ze(this,A,l,"f"),Ze(this,g,M,"f"),Ze(this,I,d,"f"),Ze(this,C,D,"f"),Ze(this,R,r,"f"),Ze(this,n,i,"f")}dispose(){Ie(this,b,"f")||(Ze(this,b,!0,"f"),Ie(this,u,"f").fire(),Ie(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ie(this,g,"f")}set title(d){this.assertNotDisposed(),Ie(this,g,"f")!==d&&(Ze(this,g,d,"f"),Ie(this,C,"f").$setWebviewViewTitle(Ie(this,I,"f"),d))}get description(){return this.assertNotDisposed(),Ie(this,o,"f")}set description(d){this.assertNotDisposed(),Ie(this,o,"f")!==d&&(Ze(this,o,d,"f"),Ie(this,C,"f").$setWebviewViewDescription(Ie(this,I,"f"),d))}get visible(){return Ie(this,n,"f")}get webview(){return Ie(this,R,"f")}get viewType(){return Ie(this,A,"f")}_setVisible(d){d===Ie(this,n,"f")||Ie(this,b,"f")||(Ze(this,n,d,"f"),Ie(this,c,"f").fire())}show(d){this.assertNotDisposed(),Ie(this,C,"f").$show(Ie(this,I,"f"),!!d)}assertNotDisposed(){if(Ie(this,b,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,C=new WeakMap,A=new WeakMap,R=new WeakMap,b=new WeakMap,n=new WeakMap,g=new WeakMap,o=new WeakMap,c=new WeakMap,u=new WeakMap;class y{constructor(d,D){this._extHostWebview=D,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,D,l,M){if(this._viewProviders.has(D))throw new Error(`View provider for '${D}' already registered`);return this._viewProviders.set(D,{provider:l,extension:d}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(d),D,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(D),this._proxy.$unregisterWebviewViewProvider(D)})}async $resolveWebviewView(d,D,l,M,r){const i=this._viewProviders.get(D);if(!i)throw new Error(`No view provider found for '${D}'`);const{provider:p,extension:m}=i,h=this._extHostWebview.createNewWebview(d,{},m),w=new F(d,this._proxy,D,l,h,!0);this._webviewViews.set(d,w),await p.resolveWebviewView(w,{state:M},r)}async $onDidChangeWebviewViewVisibility(d,D){this.getWebviewView(d)._setVisible(D)}async $disposeWebviewView(d){const D=this.getWebviewView(d);this._webviewViews.delete(d),D.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const D=this._webviewViews.get(d);if(!D)throw new Error("No webview found");return D}}e.ExtHostWebviewViews=y}),define(ye[95],_e([0,1,4,5,2,11,9,3,13]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Wi{constructor(b){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=b.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,n){let g;if(typeof b=="string"){g=b;try{b=E.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,k.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,g,n)}async asExternalUri(b,n){if((0,k.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(b,n);return E.URI.from(g)}};A.InitialState={focused:!0},A=Be([He(0,C.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(ye[207],_e([0,1,14,22,20,15,4,6,105,174,38]),function(Z,e,s,t,E,T,k,I,C,A,R){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(a,S){try{return JSON.stringify(a,S)}catch{return"null"}}const g="$$ref$$",o={[g]:-1};class c{constructor(S,P){this.jsonString=S,this.referencedBuffers=P}}function u(a,S=null,P=!1){const N=[];return{jsonString:(P?n:JSON.stringify)(a,(_,O)=>{if(typeof O=="undefined")return o;if(typeof O=="object"){if(O instanceof t.VSBuffer){const z=N.push(O)-1;return{[g]:z}}if(S)return S(_,O)}return O}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=u;function F(a,S,P){return JSON.parse(a,(N,B)=>{if(B){const _=B[g];if(typeof _=="number")return S[_];if(P&&B.$mid===1)return P.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=F;function y(a,S){return JSON.stringify(a,S)}function f(a){return a?(S,P)=>P&&P.$mid===1?a.transformOutgoing(P):P:null}var d;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},M=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends I.Disposable{constructor(S,P=null,N=null){super();this[b]=!0,this._onDidChangeResponsiveState=this._register(new k.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=S,this._logger=P,this._uriTransformer=N,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,_=R.ProxyIdentifier.count;B<_;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(S=>{this._pendingRPCReplies[S].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(S){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(S){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(S){this._responsiveState!==S&&(this._responsiveState=S,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(S){return this._uriTransformer?(0,C.transformIncomingURIs)(S,this._uriTransformer):S}getProxy(S){const{nid:P,sid:N}=S;return this._proxies[P]||(this._proxies[P]=this._createProxy(P,N)),this._proxies[P]}_createProxy(S,P){let N={get:(B,_)=>(typeof _=="string"&&!B[_]&&_.charCodeAt(0)===36&&(B[_]=(...O)=>this._remoteCall(S,_,O)),_===r?P:B[_])};return new Proxy(Object.create(null),N)}set(S,P){return this._locals[S.nid]=P,P}assertRegistered(S){for(let P=0,N=S.length;P<N;P++){const B=S[P];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(S){if(this._isDisposed)return;const P=S.byteLength,N=p.read(S,0),B=N.readUInt8(),_=N.readUInt32();switch(B){case 1:case 2:{let{rpcId:O,method:z,args:U}=h.deserializeRequestJSONArgs(N);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(P,_,O,z,U,B===2);break}case 3:case 4:{let{rpcId:O,method:z,args:U}=h.deserializeRequestMixedArgs(N);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(P,_,O,z,U,B===4);break}case 5:{this._logger&&this._logger.logIncoming(P,_,0,"ack"),this._onDidReceiveAcknowledge(_);break}case 6:{this._receiveCancel(P,_);break}case 7:{this._receiveReply(P,_,void 0);break}case 9:{let O=h.deserializeReplyOKJSON(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReply(P,_,O);break}case 10:{const O=h.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(P,_,O);break}case 8:{let O=h.deserializeReplyOKVSBuffer(N);this._receiveReply(P,_,O);break}case 11:{let O=h.deserializeReplyErrError(N);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveReplyErr(P,_,O);break}case 12:{this._receiveReplyErr(P,_,void 0);break}default:console.error("received unexpected message"),console.error(S)}}_receiveRequest(S,P,N,B,_,O){this._logger&&this._logger.logIncoming(S,P,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(N)}.${B}(`,_);const z=String(P);let U,$;if(O){const ue=new E.CancellationTokenSource;_.push(ue.token),U=this._invokeHandler(N,B,_),$=()=>ue.cancel()}else U=this._invokeHandler(N,B,_),$=l;this._cancelInvokedHandlers[z]=$;const V=h.serializeAcknowledged(P);this._logger&&this._logger.logOutgoing(V.byteLength,P,1,"ack"),this._protocol.send(V),U.then(ue=>{delete this._cancelInvokedHandlers[z];const K=h.serializeReplyOK(P,ue,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,P,1,"reply:",ue),this._protocol.send(K)},ue=>{delete this._cancelInvokedHandlers[z];const K=h.serializeReplyErr(P,ue);this._logger&&this._logger.logOutgoing(K.byteLength,P,1,"replyErr:",ue),this._protocol.send(K)})}_receiveCancel(S,P){this._logger&&this._logger.logIncoming(S,P,1,"receiveCancel");const N=String(P);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(S,P,N){this._logger&&this._logger.logIncoming(S,P,0,"receiveReply:",N);const B=String(P);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const _=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],_.resolveOk(N)}_receiveReplyErr(S,P,N){this._logger&&this._logger.logIncoming(S,P,0,"receiveReplyErr:",N);const B=String(P);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const _=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let O;N&&(N.$isError?(O=new Error,O.name=N.name,O.message=N.message,O.stack=N.stack):O=N),_.resolveErr(O)}_invokeHandler(S,P,N){try{return Promise.resolve(this._doInvokeHandler(S,P,N))}catch(B){return Promise.reject(B)}}_doInvokeHandler(S,P,N){const B=this._locals[S];if(!B)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(S));let _=B[P];if(typeof _!="function")throw new Error("Unknown method "+P+" on actor "+(0,R.getStringIdentifierForProxy)(S));return _.apply(B,N)}_remoteCall(S,P,N){if(this._isDisposed)return Promise.reject(T.canceled());let B=null;if(N.length>0&&E.CancellationToken.isCancellationToken(N[N.length-1])&&(B=N.pop()),B&&B.isCancellationRequested)return Promise.reject(T.canceled());const _=h.serializeRequestArguments(N,this._uriReplacer),O=++this._lastMessageId,z=String(O),U=new A.LazyPromise;B&&B.onCancellationRequested(()=>{const V=h.serializeCancel(O);this._logger&&this._logger.logOutgoing(V.byteLength,O,0,"cancel"),this._protocol.send(h.serializeCancel(O))}),this._pendingRPCReplies[z]=U,this._onWillSendRequest(O);const $=h.serializeRequest(O,S,P,_,!!B);return this._logger&&this._logger.logOutgoing($.byteLength,O,0,`request: ${(0,R.getStringIdentifierForProxy)(S)}.${P}(`,N),this._protocol.send($),U}}e.RPCProtocol=i,b=M,i.UNRESPONSIVE_TIME=3*1e3;class p{constructor(S,P){this._buff=S,this._offset=P}static alloc(S,P,N){let B=new p(t.VSBuffer.alloc(N+1+4),0);return B.writeUInt8(S),B.writeUInt32(P),B}static read(S,P){return new p(S,P)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(S){this._buff.writeUInt8(S,this._offset),this._offset+=1}readUInt8(){const S=this._buff.readUInt8(this._offset);return this._offset+=1,S}writeUInt32(S){this._buff.writeUInt32BE(S,this._offset),this._offset+=4}readUInt32(){const S=this._buff.readUInt32BE(this._offset);return this._offset+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this._buff.writeUInt8(S.byteLength,this._offset),this._offset+=1,this._buff.set(S,this._offset),this._offset+=S.byteLength}readShortString(){const S=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,N}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readLongString(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,N}writeBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readVSBuffer(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const P=this._buff.slice(this._offset,this._offset+S);return this._offset+=S,P}static sizeMixedArray(S){let P=0;P+=1;for(let N=0,B=S.length;N<B;N++){const _=S[N];switch(P+=1,_.type){case 1:P+=this.sizeLongString(_.value);break;case 2:P+=this.sizeVSBuffer(_.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(_.value);for(let O=0;O<_.buffers.length;++O)P+=this.sizeVSBuffer(_.buffers[O]);break;case 4:break}}return P}writeMixedArray(S){this._buff.writeUInt8(S.length,this._offset),this._offset+=1;for(let P=0,N=S.length;P<N;P++){const B=S[P];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let _=0;_<B.buffers.length;++_)this.writeBuffer(B.buffers[_]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this._buff.readUInt8(this._offset);this._offset+=1;let P=new Array(S);for(let N=0;N<S;N++)switch(this.readUInt8()){case 1:P[N]=this.readLongString();break;case 2:P[N]=this.readVSBuffer();break;case 3:{const _=this.readUInt32(),O=this.readLongString(),z=[];for(let U=0;U<_;++U)z.push(this.readVSBuffer());P[N]=new R.SerializableObjectWithBuffers(F(O,z,null));break}case 4:P[N]=void 0;break}return P}}p.sizeUInt32=4;var m;(function(a){a[a.Simple=0]="Simple",a[a.Mixed=1]="Mixed"})(m||(m={}));class h{static _useMixedArgSerialization(S){for(let P=0,N=S.length;P<N;P++)if(S[P]instanceof t.VSBuffer||S[P]instanceof R.SerializableObjectWithBuffers||typeof S[P]=="undefined")return!0;return!1}static serializeRequestArguments(S,P){if(this._useMixedArgSerialization(S)){const N=[];for(let B=0,_=S.length;B<_;B++){const O=S[B];if(O instanceof t.VSBuffer)N[B]={type:2,value:O};else if(typeof O=="undefined")N[B]={type:4};else if(O instanceof R.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:U}=u(O.value,P);N[B]={type:3,value:t.VSBuffer.fromString(z),buffers:U}}else N[B]={type:1,value:t.VSBuffer.fromString(y(O,P))}}return{type:1,args:N}}return{type:0,args:y(S,P)}}static serializeRequest(S,P,N,B,_){switch(B.type){case 0:return this._requestJSONArgs(S,P,N,B.args,_);case 1:return this._requestMixedArgs(S,P,N,B.args,_)}}static _requestJSONArgs(S,P,N,B,_){const O=t.VSBuffer.fromString(N),z=t.VSBuffer.fromString(B);let U=0;U+=p.sizeUInt8(),U+=p.sizeShortString(O),U+=p.sizeLongString(z);let $=p.alloc(_?2:1,S,U);return $.writeUInt8(P),$.writeShortString(O),$.writeLongString(z),$.buffer}static deserializeRequestJSONArgs(S){const P=S.readUInt8(),N=S.readShortString(),B=S.readLongString();return{rpcId:P,method:N,args:JSON.parse(B)}}static _requestMixedArgs(S,P,N,B,_){const O=t.VSBuffer.fromString(N);let z=0;z+=p.sizeUInt8(),z+=p.sizeShortString(O),z+=p.sizeMixedArray(B);let U=p.alloc(_?4:3,S,z);return U.writeUInt8(P),U.writeShortString(O),U.writeMixedArray(B),U.buffer}static deserializeRequestMixedArgs(S){const P=S.readUInt8(),N=S.readShortString(),B=S.readMixedArray(),_=new Array(B.length);for(let O=0,z=B.length;O<z;O++){const U=B[O];typeof U=="string"?_[O]=JSON.parse(U):_[O]=U}return{rpcId:P,method:N,args:_}}static serializeAcknowledged(S){return p.alloc(5,S,0).buffer}static serializeCancel(S){return p.alloc(6,S,0).buffer}static serializeReplyOK(S,P,N){if(typeof P=="undefined")return this._serializeReplyOKEmpty(S);if(P instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(S,P);if(P instanceof R.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:_}=u(P.value,N,!0);return this._serializeReplyOKJSONWithBuffers(S,B,_)}else return this._serializeReplyOKJSON(S,n(P,N))}static _serializeReplyOKEmpty(S){return p.alloc(7,S,0).buffer}static _serializeReplyOKVSBuffer(S,P){let N=0;N+=p.sizeVSBuffer(P);let B=p.alloc(8,S,N);return B.writeVSBuffer(P),B.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static _serializeReplyOKJSON(S,P){const N=t.VSBuffer.fromString(P);let B=0;B+=p.sizeLongString(N);let _=p.alloc(9,S,B);return _.writeLongString(N),_.buffer}static _serializeReplyOKJSONWithBuffers(S,P,N){const B=t.VSBuffer.fromString(P);let _=0;_+=p.sizeUInt32,_+=p.sizeLongString(B);for(const z of N)_+=p.sizeVSBuffer(z);let O=p.alloc(10,S,_);O.writeUInt32(N.length),O.writeLongString(B);for(const z of N)O.writeBuffer(z);return O.buffer}static deserializeReplyOKJSON(S){const P=S.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(S,P){const N=S.readUInt32(),B=S.readLongString(),_=[];for(let O=0;O<N;++O)_.push(S.readVSBuffer());return new R.SerializableObjectWithBuffers(F(B,_,P))}static serializeReplyErr(S,P){return P?this._serializeReplyErrEror(S,P):this._serializeReplyErrEmpty(S)}static _serializeReplyErrEror(S,P){const N=t.VSBuffer.fromString(n(T.transformErrorForSerialization(P),null));let B=0;B+=p.sizeLongString(N);let _=p.alloc(11,S,B);return _.writeLongString(N),_.buffer}static deserializeReplyErrError(S){const P=S.readLongString();return JSON.parse(P)}static _serializeReplyErrEmpty(S){return p.alloc(12,S,0).buffer}}var w;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",a[a.ReplyErrError=11]="ReplyErrError",a[a.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var v;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",a[a.Undefined=4]="Undefined"})(v||(v={}))}),define(ye[208],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const s=function(T){const k=I=>{self.removeEventListener("message",k);const C=I.data;Object.defineProperties(self,{postMessage:{value(A,R){C.postMessage(A,R)}},onmessage:{get(){return C.onmessage},set(A){C.onmessage=A}}}),C.addEventListener("message",A=>{self.dispatchEvent(new MessageEvent("message",{data:A.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",k)}.toString();class t extends EventTarget{constructor(T,k,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${s})('${k}'))`,A=new Blob([C],{type:"application/javascript"}),R=URL.createObjectURL(A),b=new MessageChannel,n=R,g={type:"_newWorker",id:n,port:b.port2,url:R,options:I};T(g,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:n};b.port1.postMessage(o),URL.revokeObjectURL(R),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(o){b.port1.onmessage=o}},onmessageerror:{get(){return b.port1.onmessageerror},set(o){b.port1.onmessageerror=o}}}),b.port1.addEventListener("messageerror",o=>{const c=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(c)}),b.port1.addEventListener("message",o=>{const c=new MessageEvent("message",{data:o.data});this.dispatchEvent(c)}),b.port1.start()}}e.NestedWorker=t}),define(ye[209],_e([0,1,3]),function(Z,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService")}),define(ye[210],_e([0,1,35,11,17,23,24,2,3,61,47,169,209]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let g=class Vi{constructor(c,u,F,y){this.localUserHome=c,this.remoteAgentService=u,this.environmentService=F,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||T.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome||c})()}async hasValidBasename(c){if(c.scheme===t.Schemas.file||c.scheme===t.Schemas.vscodeRemote){const u=await this.resolveOS;return(0,s.isValidBasename)((0,k.basename)(c),u===1)}return!0}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(c,u){if(c.remoteAuthority)return t.Schemas.vscodeRemote;const F=(0,A.getVirtualWorkspaceScheme)(u.getWorkspace());if(F)return F;const y=u.getWorkspace().folders[0];if(y)return y.uri.scheme;const f=u.getWorkspace().configuration;return f?f.scheme:t.Schemas.file}async userHome(c){return c?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(c=>c===1?E.win32:E.posix)}async fileURI(c){let u="";if(await this.resolveOS===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const y=c.indexOf("/",2);y===-1?(u=c.substring(2),c="/"):(u=c.substring(2,y),c=c.substring(y)||"/")}return I.URI.from({scheme:t.Schemas.file,authority:u,path:c,query:"",fragment:""})}};g=Be([He(1,n.IRemoteAgentService),He(2,b.IWorkbenchEnvironmentService),He(3,R.IWorkspaceContextService)],g),e.AbstractPathService=g}),define(ye[96],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(k,I){this.line=k,this.character=I}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,I){return new s(0,0)}with(k){return new s(0,0)}}e.Position=s;class t{constructor(k,I,C,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(k,I),this.end=new s(C,A)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new t(0,0,0,0)}with(k){return new t(0,0,0,0)}}e.Range=t;var E;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[41],_e([0,1,16,29,26,35,9,3,17,15,96,10]),function(Z,e,s,t,E,T,k,I,C,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",g=" characters skipped \u27EB",o=(n.length+g.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var c;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function F(V){return!!V.preview}e.resultIsMatch=F;function y(V){return!!V.resource}e.isFileMatch=y;function f(V){return!!V.message}e.isProgressMessage=f;var d;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=D;class l{constructor(ue,K,re){this.ranges=K;const pe=Array.isArray(K)?K:[K];if(re&&re.matchLines===1&&M(pe)){ue=(0,k.getNLines)(ue,re.matchLines);let be="",ae=0,le=0;const Ce=Math.floor(re.charsPerLine/5),Ee=[];for(const Fe of pe){const $e=Math.max(Fe.startColumn-Ce,0),Ve=Fe.startColumn+re.charsPerLine;if($e>le+Ce+o){const je=n+($e-le)+g;be+=je+ue.slice($e,Ve),ae+=$e-(le+je.length)}else be+=ue.slice(le,Ve);Ee.push(new i(0,Fe.startColumn-ae,Fe.endColumn-ae)),le=Ve}this.preview={text:be,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const be=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:ue,matches:(0,s.mapArrayOrNot)(K,ae=>new r(ae.startLineNumber-be,ae.startColumn,ae.endLineNumber-be,ae.endColumn))}}}}e.TextSearchMatch=l;function M(V){const ue=V[0].startLineNumber;for(const K of V)if(K.startLineNumber!==ue||K.endLineNumber!==ue)return!1;return!0}class r{constructor(ue,K,re,pe){this.startLineNumber=ue,this.startColumn=K,this.endLineNumber=re,this.endColumn=pe}}e.SearchRange=r;class i extends r{constructor(ue,K,re){super(ue,K,ue,re)}}e.OneLineRange=i;var p;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function m(V,ue=!0){const K=V&&V.files&&V.files.exclude,re=ue&&V&&V.search&&V.search.exclude;if(!K&&!re)return;if(!K||!re)return K||re;let pe=Object.create(null);return pe=E.mixin(pe,E.deepClone(K)),pe=E.mixin(pe,E.deepClone(re),!0),pe}e.getExcludes=m;function h(V,ue){return V.excludePattern&&t.match(V.excludePattern,ue)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&t.match(V.includePattern,ue)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(K=>{const re=K.folder.fsPath;if(T.isEqualOrParent(ue,re)){const pe=C.relative(re,ue);return!K.includePattern||!!t.match(K.includePattern,pe)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var w;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(ue,K){super(ue);this.code=K}}e.SearchError=v;function a(V){const ue=V.message;if((0,A.isPromiseCanceledError)(V))return new v(ue,w.canceled);try{const K=JSON.parse(ue);return new v(K.message,K.code)}catch{return new v(ue,w.other)}}e.deserializeSearchError=a;function S(V){const ue={message:V.message,code:V.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=S;function P(V){return V.type==="error"?!0:V.type==="success"}e.isSerializedSearchComplete=P;function N(V){return V.type==="success"}e.isSerializedSearchSuccess=N;function B(V){return!!V.path}e.isSerializedFileMatch=B;function _(V,ue){const K=V.searchPath?V.searchPath:V.relativePath;return(0,k.fuzzyContains)(K,ue)}e.isFilePatternMatch=_;class O{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function z(V,ue){const K={...V||{},...ue||{}};return Object.keys(K).filter(re=>{const pe=K[re];return typeof pe=="boolean"&&pe})}e.resolvePatternsForProvider=z;class U{constructor(ue,K){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let re=ue.includePattern;K.includePattern&&(re?re={...re,...K.includePattern}:re=K.includePattern),re&&(this._parsedIncludeExpression=t.parse(re))}matchesExcludesSync(ue,K,re){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,re))}includedInQuerySync(ue,K,re){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,re)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,K,re))}includedInQuery(ue,K,re){const pe=this._parsedExcludeExpression(ue,K,re),be=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,K,re):!0;return(0,b.isPromise)(pe)?pe.then(ae=>ae?!1:be()):be()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=U;function $(V){for(const ue in V)if(typeof V[ue]!="boolean")return!0;return!1}}),define(ye[31],_e([0,1,16,14,20,4,21,11,75,24,9,10,2,124,3,12,137,47,30,28,13,7,41,5]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y,f,d,D,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(S,P,N){return new A.ExtUri(B=>h(B,N)).isEqual(S,P)}function i(S,P,N){return r(S.uri,P.uri,N)?0:(0,R.compare)(S.uri.toString(),P.uri.toString())}function p(S,P,N){return S.index!==P.index?S.index<P.index?-1:1:r(S.uri,P.uri,N)?(0,R.compare)(S.name,P.name):(0,R.compare)(S.uri.toString(),P.uri.toString())}function m(S,P,N,B){const _=S.slice(0).sort((z,U)=>N(z,U,B)),O=P.slice(0).sort((z,U)=>N(z,U,B));return(0,s.delta)(_,O,(z,U)=>N(z,U,B))}function h(S,P){const N=P.getCapabilities(S.scheme);return!(N&&N&1024)}class w extends F.Workspace{constructor(P,N,B,_,O,z,U){super(P,B.map($=>new F.WorkspaceFolder($)),_,O,U);this._name=N,this._isUntitled=z,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(U),B.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(P,N,B,_){if(!P)return{workspace:null,added:[],removed:[]};const{id:O,name:z,folders:U,configuration:$,transient:V,isUntitled:ue}=P,K=[],re=N;N?U.forEach((le,Ce)=>{const Ee=n.URI.revive(le.uri),Fe=w._findFolder(B||N,Ee,_);Fe?(Fe.name=le.name,Fe.index=le.index,K.push(Fe)):K.push({uri:Ee,name:le.name,index:Ce})}):K.push(...U.map(({uri:le,name:Ce,index:Ee})=>({uri:n.URI.revive(le),name:Ce,index:Ee}))),K.sort((le,Ce)=>le.index<Ce.index?-1:1);const pe=new w(O,z,K,!!V,$?n.URI.revive($):null,!!ue,le=>h(le,_)),{added:be,removed:ae}=m(re?re.workspaceFolders:[],pe.workspaceFolders,i,_);return{workspace:pe,added:be,removed:ae}}static _findFolder(P,N,B){for(let _=0;_<P.folders.length;_++){const O=P.workspaceFolders[_];if(r(O.uri,N,B))return O}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(P,N){return N&&this._structure.get(P)&&(P=(0,A.dirname)(P)),this._structure.findSubstr(P)}resolveWorkspaceFolder(P){return this._structure.get(P)}}let v=class{constructor(P,N,B,_){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=_,this._extHostFileSystemInfo=B,this._requestIdProvider=new C.Counter,this._barrier=new t.Barrier,this._proxy=P.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=P.getProxy(M.MainContext.MainThreadMessageService);const O=N.workspace;this._confirmedWorkspace=O?new w(O.id,O.name,[],!!O.transient,O.configuration?n.URI.revive(O.configuration):null,!!O.isUntitled,z=>h(z,B)):void 0}$initializeWorkspace(P,N){this._trusted=N,this.$acceptWorkspaceData(P),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:I.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(P,N,B,..._){const O=[];if(Array.isArray(_)&&_.forEach(ue=>{n.URI.isUri(ue.uri)&&!O.some(K=>r(K.uri,ue.uri,this._extHostFileSystemInfo))&&O.push({uri:ue.uri,name:ue.name||(0,A.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[N,B].some(ue=>typeof ue!="number"||ue<0)||B===0&&O.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+B>z.length)return!1;const U=z.slice(0);U.splice(N,B,...O.map(ue=>({uri:ue.uri,name:ue.name||(0,A.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<U.length;ue++){const K=U[ue];if(U.some((re,pe)=>pe!==ue&&r(K.uri,re.uri,this._extHostFileSystemInfo)))return!1}U.forEach((ue,K)=>ue.index=K);const{added:$,removed:V}=m(z,U,p,this._extHostFileSystemInfo);if($.length===0&&V.length===0)return!1;if(this._proxy){const ue=P.displayName||P.name;this._proxy.$updateWorkspaceFolders(ue,N,B,O).then(void 0,K=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(u.Severity.Error,(0,g.localize)(0,null,ue,K.toString()),{extension:P},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(P,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,N)}async getWorkspaceFolder2(P,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,N)}async resolveWorkspaceFolder(P){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(P)}getPath(){if(!this._actualWorkspace)return;const{folders:P}=this._actualWorkspace;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,N){let B,_="";if(typeof P=="string"?(B=n.URI.file(P),_=P):typeof P!="undefined"&&(B=P,_=P.fsPath),!B)return _;const O=this.getWorkspaceFolder(B,!0);if(!O)return _;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let z=(0,A.relativePath)(O.uri,B);return N&&O.name&&(z=`${O.name}/${z}`),z}trySetWorkspaceFolders(P){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:P,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:N,added:B,removed:_}=w.toExtHostWorkspace(P,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:_}))}findFiles(P,N,B,_,O=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${_.value}, entryPoint: findFiles`);let z;if(N===null?z=!1:N&&(typeof N=="string"?z=N:z=N.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:$}=a(P);return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(U),(0,b.withUndefinedAsNull)($),(0,b.withUndefinedAsNull)(z),(0,b.withUndefinedAsNull)(B),O).then(V=>Array.isArray(V)?V.map(ue=>n.URI.revive(ue)):[])}async findTextInFiles(P,N,B,_,O=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${_.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),U=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:$,folder:V}=a(N.include),ue=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,K={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:U,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:$,excludePattern:ue},re=!1;if(this._activeSearchCallbacks[z]=pe=>{if(re)return;const be=n.URI.revive(pe.resource);pe.results.forEach(ae=>{(0,l.resultIsMatch)(ae)?B({uri:be,preview:{text:ae.preview.text,matches:(0,s.mapArrayOrNot)(ae.preview.matches,le=>new D.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))},ranges:(0,s.mapArrayOrNot)(ae.ranges,le=>new D.Range(le.startLineNumber,le.startColumn,le.endLineNumber,le.endColumn))}):B({uri:be,text:ae.text,lineNumber:ae.lineNumber})})},O.isCancellationRequested)return{};try{const pe=await this._proxy.$startTextSearch(P,(0,b.withUndefinedAsNull)(V),K,z,O);return delete this._activeSearchCallbacks[z],pe||{}}catch(pe){throw delete this._activeSearchCallbacks[z],pe}}$handleTextSearchResult(P,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](P)}saveAll(P){return this._proxy.$saveAll(P)}resolveProxy(P){return this._proxy.$resolveProxy(P)}get trusted(){return this._trusted}requestWorkspaceTrust(P){return this._proxy.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=Be([He(0,d.IExtHostRpcService),He(1,f.IExtHostInitDataService),He(2,y.IExtHostFileSystemInfo),He(3,c.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function a(S){let P,N;return S&&(typeof S=="string"?P=S:(P=S.pattern,N=S.baseFolder||n.URI.file(S.base))),{includePattern:P,folder:N}}}),define(ye[32],_e([0,1,26,4,31,5,7,141,83,10,14,3,13,12,2]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(M,r){if(r){const i=r.split(".");let p=M;for(let m=0;p&&m<i.length;m++)p=p[i[m]];return p}}function u(M){return M instanceof o.URI}function F(M){return M&&M.uri instanceof o.URI&&M.languageId&&typeof M.languageId=="string"}function y(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function f(M){return M&&M.uri instanceof o.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function d(M){if(u(M))return{resource:M};if(F(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(y(M))return{overrideIdentifier:M.languageId};if(f(M))return{resource:M.uri};if(M===null)return{resource:null}}let D=class{constructor(r,i,p){this._proxy=r.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=p,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new l(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(r,i))}};D=Be([He(0,n.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,g.ILogService)],D),e.ExtHostConfiguration=D;class l{constructor(r,i,p,m){this._onDidChangeConfiguration=new t.Emitter,this._proxy=r,this._logService=m,this._extHostWorkspace=i,this._configuration=I.Configuration.parse(p),this._configurationScopes=this._toMap(p.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const p={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,p))}getConfiguration(r,i,p){const m=d(i)||{},h=this._toReadonlyValue(r?c(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,m,p?.identifier);function w(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const v={has(a){return typeof c(h,a)!="undefined"},get:(a,S)=>{this._validateConfigurationAccess(r?`${r}.${a}`:a,m,p?.identifier);let P=c(h,a);if(typeof P=="undefined")P=S;else{let N;const B=(_,O)=>{let z;const U=()=>{N=N||(0,s.deepClone)(h),z=z||c(N,O)};return(0,A.isObject)(_)?new Proxy(_,{get:($,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return U(),()=>z;if(N)return z=z||c(N,O),z[V];const ue=$[V];return typeof V=="string"?B(ue,`${O}.${V}`):ue},set:($,V,ue)=>(U(),z&&(z[V]=ue),!0),deleteProperty:($,V)=>(U(),z&&delete z[V],!0),defineProperty:($,V,ue)=>(U(),z&&Object.defineProperty(z,V,ue),!0)}):_};P=B(P,a)}return P},update:(a,S,P,N)=>{a=r?`${r}.${a}`:a;const B=w(P);return S!==void 0?this._proxy.$updateConfigurationOption(B,a,S,m,N):this._proxy.$removeConfigurationOption(B,a,m,N)},inspect:a=>{a=r?`${r}.${a}`:a;const S=(0,s.deepClone)(this._configuration.inspect(a,m,this._extHostWorkspace.workspace));if(S)return{key:a,defaultValue:S.default?.value,globalValue:S.user?.value,workspaceValue:S.workspace?.value,workspaceFolderValue:S.workspaceFolder?.value,defaultLanguageValue:S.default?.override,globalLanguageValue:S.user?.override,workspaceLanguageValue:S.workspace?.override,workspaceFolderLanguageValue:S.workspaceFolder?.override,languageIds:S.overrideIdentifiers}}};return typeof h=="object"&&(0,s.mixin)(v,h,!1),Object.freeze(v)}_toReadonlyValue(r){const i=p=>(0,A.isObject)(p)?new Proxy(p,{get:(m,h)=>i(m[h]),set:(m,h,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(m,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(m,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return i(r)}_validateConfigurationAccess(r,i,p){const m=C.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),h=p?`[${p.value}] `:"";if(m===4){typeof i?.resource=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){i?.resource&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const p=new I.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,h)=>p.affectsConfiguration(m,d(h))})}_toMap(r){return r.reduce((i,p)=>(i.set(p[0],p[1]),i),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[97],_e([0,1,2,14,4,5,7,31,49,32,20,40,13,28,3,11,23,12,69,160,15]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y,f,d){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(O){function z(V){if(V){const ue=V;return ue&&!!ue.process}else return!1}O.is=z;function U(V){if(V==null)return;const ue={process:V.process,args:V.args};return V.options&&(ue.options=r.from(V.options)),ue}O.from=U;function $(V){if(V!=null)return new k.ProcessExecution(V.process,V.args,V.options)}O.to=$})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var p;(function(O){function z($){if($!=null)return $}O.from=z;function U($){if($!=null)return $}O.to=U})(p=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(O){function z(V){if(V){const ue=V;return ue&&(!!ue.commandLine||!!ue.command)}else return!1}O.is=z;function U(V){if(V==null)return;const ue={};return V.commandLine!==void 0?ue.commandLine=V.commandLine:(ue.command=V.command,ue.args=V.args),V.options&&(ue.options=p.from(V.options)),ue}O.from=U;function $(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new k.ShellExecution(V.commandLine,V.options):new k.ShellExecution(V.command,V.args?V.args:[],V.options)}O.to=$})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(O){function z(V){if(V){let ue=V;return ue&&ue.customExecution==="customExecution"}else return!1}O.is=z;function U(V){return{customExecution:"customExecution"}}O.from=U;function $(V,ue){return ue.get(V)}O.to=$})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(O){function z(U,$){let V;return U.scope!==void 0&&typeof U.scope!="number"?V=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===k.TaskScope.Workspace&&$&&$.workspaceFile?V=$.workspaceFile:V=f.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:V}}O.from=z})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(O){function z(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}O.from=z})(v=e.TaskGroupDTO||(e.TaskGroupDTO={}));var a;(function(O){function z(V,ue){if(V==null)return[];const K=[];for(let re of V){const pe=U(re,ue);pe&&K.push(pe)}return K}O.fromMany=z;function U(V,ue){if(V==null)return;let K;V.execution instanceof k.ProcessExecution?K=i.from(V.execution):V.execution instanceof k.ShellExecution?K=m.from(V.execution):V.execution&&V.execution instanceof k.CustomExecution&&(K=h.from(V.execution));const re=l.from(V.definition);let pe;return V.scope?typeof V.scope=="number"?pe=V.scope:pe=V.scope.uri:pe=k.TaskScope.Workspace,!re||!pe?void 0:{_id:V._id,definition:re,name:V.name,source:{extensionId:ue.identifier.value,label:V.source,scope:pe},execution:K,isBackground:V.isBackground,group:v.from(V.group),presentationOptions:M.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}O.from=U;async function $(V,ue,K){if(V==null)return;let re;i.is(V.execution)?re=i.to(V.execution):m.is(V.execution)?re=m.to(V.execution):h.is(V.execution)&&(re=h.to(V._id,K));const pe=l.to(V.definition);let be;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?be=V.source.scope:be=await ue.resolveWorkspaceFolder(s.URI.revive(V.source.scope)):be=k.TaskScope.Workspace),!pe||!be)return;const ae=new k.Task(pe,be,V.name,V.source.label,re,V.problemMatchers);return V.isBackground!==void 0&&(ae.isBackground=V.isBackground),V.group!==void 0&&(ae.group=k.TaskGroup.from(V.group._id),ae.group&&V.group.isDefault&&(ae.group=new k.TaskGroup(ae.group.id,ae.group.label),V.group.isDefault&&(ae.group.isDefault=V.group.isDefault))),V.presentationOptions&&(ae.presentationOptions=M.to(V.presentationOptions)),V._id&&(ae._id=V._id),V.detail&&(ae.detail=V.detail),ae}O.to=$})(a=e.TaskDTO||(e.TaskDTO={}));var S;(function(O){function z($){return $}O.from=z;function U($){if(!!$)return Object.assign(Object.create(null),$)}O.to=U})(S=e.TaskFilterDTO||(e.TaskFilterDTO={}));class P{constructor(z,U,$){this._id=U,this._task=$,D.set(this,void 0),Ze(this,D,z,"f")}get task(){return this._task}terminate(){Ie(this,D,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}D=new WeakMap;var N;(function(O){function z(U){return{id:U._id,task:void 0}}O.from=z})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(z,U,$,V,ue,K,re,pe){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=V,this._configurationService=ue,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=pe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,U,$){if(!$)return new k.Disposable(()=>{});const V=this.nextHandle();return this._handlers.set(V,{type:U,provider:$,extension:z}),this._proxy.$registerTaskProvider(V,U),new k.Disposable(()=>{this._handlers.delete(V),this._proxy.$unregisterTaskProvider(V)})}registerTaskSystem(z,U){this._proxy.$registerTaskSystem(z,U)}fetchTasks(z){return this._proxy.$fetchTasks(S.from(z)).then(async U=>{const $=[];for(let V of U){const ue=await a.to(V,this._workspaceProvider,this._providedCustomExecutions2);ue&&$.push(ue)}return $})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(U=>z.push(U)),z}terminateTask(z){if(!(z instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,U,$){const V=this._providedCustomExecutions2.get(z.id);V&&(this._activeCustomExecutions2.set(z.id,V),this._terminalService.attachPtyToTerminal(U,await V.callback($))),this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const U=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const U=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:U,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const U=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:z.exitCode})}$provideTasks(z,U){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));const V=[],ue=(0,t.asPromise)(()=>$.provider.provideTasks(R.CancellationToken.None)).then(K=>this.provideTasksInternal(U,V,$,K));return new Promise(K=>{ue.then(re=>{Promise.all(V).then(()=>{K(re)})})})}async $resolveTask(z,U){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));if(U.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${$.type}].`);const V=await a.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const ue=await $.provider.resolveTask(V,R.CancellationToken.None);if(!ue)return;this.checkDeprecation(ue,$);const K=a.from(ue,$.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(ue.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(K.execution)&&await this.addCustomExecution(K,ue,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,U,$){const V=await this._proxy.$createTaskId(z);!$&&!this._providedCustomExecutions2.has(V)&&(this._notProvidedCustomExecutions.add(V),this._activeCustomExecutions2.set(V,U.execution)),this._providedCustomExecutions2.set(V,U.execution)}async getTaskExecution(z,U){if(typeof z=="string"){const ue=this._taskExecutionPromises.get(z);if(!ue)throw new Error("Unexpected: The specified task is missing an execution");return ue}let $=this._taskExecutionPromises.get(z.id);if($)return $;const V=new Promise((ue,K)=>{function re(pe,be,ae){ae?ue(new P(pe,be.id,ae)):K("Unexpected: Task does not exist.")}U?re(this,z,U):a.to(z.task,this._workspaceProvider,this._providedCustomExecutions2).then(pe=>re(this,z,pe))});return this._taskExecutionPromises.set(z.id,V),V.then(ue=>(this._taskExecutions.set(z.id,ue),ue),ue=>Promise.reject(ue))}checkDeprecation(z,U){z._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let $=this._notProvidedCustomExecutions.values(),V=$.next();for(;!V.done;)!this._activeCustomExecutions2.has(V.value)&&this._lastStartedTask!==V.value&&(this._providedCustomExecutions2.delete(V.value),this._notProvidedCustomExecutions.delete(V.value)),V=$.next()}};B=Be([He(0,n.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,b.IExtHostTerminalService),He(6,F.ILogService),He(7,y.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let _=class extends B{constructor(z,U,$,V,ue,K,re,pe){super(z,U,$,V,ue,K,re,pe);this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(0)})}async executeTask(z,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const $=a.from(U,z);if($===void 0)throw new Error("Task is not valid");if(h.is($.execution))await this.addCustomExecution($,U,!1);else throw new d.NotSupportedError;const V=await this.getTaskExecution(await this._proxy.$getTaskExecution($),U);return this._proxy.$executeTask($).catch(ue=>{throw new Error(ue)}),V}provideTasksInternal(z,U,$,V){const ue=[];if(V)for(let K of V){this.checkDeprecation(K,$),(!K.definition||!z[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const re=a.from(K,$.extension);re&&h.is(re.execution)?(ue.push(re),U.push(this.addCustomExecution(re,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ue,extension:$.extension}}async resolveTaskInternal(z){if(h.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,U,$){}};_=Be([He(0,n.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,b.IExtHostTerminalService),He(6,F.ILogService),He(7,y.IExtHostApiDeprecationService)],_),e.WorkerExtHostTask=_,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(ye[211],_e([0,1,16,74,29,78,21,11,17,24,9,10,2,232,127,81,47,90,210,41]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(w,v,a,S){this.configurationService=w,this.workspaceContextService=v,this.editorGroupsService=a,this.pathService=S}text(w,v,a={}){w=this.getContentPattern(w,a);const S=this.configurationService.getValue(),P=v&&v.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(v?.map(u.toWorkspaceFolder),a),type:2,contentPattern:w,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:S.search.usePCRE2||P||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles}}getContentPattern(w,v){const a=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const S={...w,wordSeparators:a.editor.wordSeparators};return this.isCaseSensitive(w,v)&&(S.isCaseSensitive=!0),this.isMultiline(w)&&(S.isMultiline=!0),S}file(w,v={}){return{...this.commonQuery(w,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}handleIncludeExclude(w,v){return w?(w=Array.isArray(w)?w.map(i):i(w),v?this.parseSearchPaths(w):{pattern:l(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],v={}){const a=this.handleIncludeExclude(v.includePattern,v.expandPatterns),S=this.handleIncludeExclude(v.excludePattern,v.expandPatterns),P=w.length>1,N=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,v,S)):w.map(O=>this.getFolderQueryForRoot(O,v,S,P))).filter(O=>!!O),B={_reason:v._reason,folderQueries:N,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:S.pattern,includePattern:a.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const z=s.coalesce(s.flatten(this.editorGroupsService.groups.map($=>$.editors.map(V=>V.resource)))).filter($=>(0,f.pathIncludedInQuery)(B,$.fsPath)),U=this.commonQueryFromFileList(z);return{...B,...U}}const _=v.extraFileResources&&v.extraFileResources.filter(O=>(0,f.pathIncludedInQuery)(B,O.fsPath));return B.extraFileResources=_&&_.length?_:void 0,B}commonQueryFromFileList(w){const v=[],a=new k.ResourceMap,S={};let P=!1;return w.forEach(N=>{if(N.scheme===I.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(N)){const _=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:C.dirname(N.fsPath)});let O=a.get(_);O||(P=!0,O={folder:_,includePattern:{}},v.push(O),a.set(_,O));const z=C.relative(_.fsPath,N.fsPath);(0,b.assertIsDefined)(O.includePattern)[z.replace(/\\/g,"/")]=!0}else N.fsPath&&(P=!0,S[N.fsPath]=!0)}),{folderQueries:v,includePattern:S,usingSearchPaths:!0,excludePattern:P?void 0:{"**/*":!0}}}isCaseSensitive(w,v){if(v.isSmartCase){if(w.isRegExp){if(R.containsUppercaseCharacter(w.pattern,!0))return!0}else if(R.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,g.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const v=U=>C.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),S=(Array.isArray(w)?w:M(w)).map(U=>{const $=this.pathService.resolvedUserHome;return $?(0,T.untildify)(U,$.scheme===I.Schemas.file?$.fsPath:$.path):U}),P=t.groupBy(S,U=>v(U)?"searchPaths":"exprSegments"),N=(P.exprSegments||[]).map(U=>R.rtrim(U,"/")).map(U=>R.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),r(U))),B={},_=this.expandSearchPathPatterns(P.searchPaths||[]);_&&_.length&&(B.searchPaths=_);const O=s.flatten(N),z=l(...O);return z&&(B.pattern=z),B}getExcludesForFolder(w,v){return v.disregardExcludeSettings?void 0:(0,f.getExcludes)(w,!v.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const v=s.flatten(w.map(S=>{let{pathPortion:P,globPortion:N}=D(S);N&&(N=p(N));const B=this.expandOneSearchPath(P);return s.flatten(B.map(_=>this.resolveOneSearchPathPattern(_,N)))})),a=new Map;return v.forEach(S=>{const P=S.searchPath.toString(),N=a.get(P);N?S.pattern&&(N.pattern=N.pattern||{},N.pattern[S.pattern]=!0):a.set(P,{searchPath:S.searchPath,pattern:S.pattern?l(S.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(w){if(C.isAbsolute(w)){const v=this.workspaceContextService.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==I.Schemas.file?[{searchPath:v[0].uri.with({path:w})}]:[{searchPath:n.URI.file(C.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const v=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=i(w),w.startsWith("../")||w===".."){const S=C.posix.resolve(v.path,w);return[{searchPath:v.with({path:S})}]}const a=p(w);return[{searchPath:v,pattern:a}]}else{if(w==="./"||w===".\\")return[];{const v=w.replace(/^\.[\/\\]/,""),S=this.workspaceContextService.getWorkspace().folders.map(P=>{const N=v.match(new RegExp(`^${R.escapeRegExpCharacters(P.name)}(?:/(.*)|$)`));return N?{match:N,folder:P}:null}).filter(b.isDefined);if(S.length)return S.map(P=>{const N=P.match[1];return{searchPath:P.folder.uri,pattern:N&&p(N)}});{const P=w.match(/\.[\/\\](.+)[\/\\]?/),N=P?P[1]:w,B=o.localize(0,null,N);throw new Error(B)}}}}resolveOneSearchPathPattern(w,v){const a=w.pattern&&v?`${w.pattern}/${v}`:w.pattern||v,S=[{searchPath:w.searchPath,pattern:a}];return a&&!a.endsWith("**")&&S.push({searchPath:w.searchPath,pattern:a+"/**"}),S}getFolderQueryForSearchPath(w,v,a){const S=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(w.searchPath),v,a,!1);return S?{...S,includePattern:w.pattern}:null}getFolderQueryForRoot(w,v,a,S){let P;const N=n.URI.isUri(w)?w:w.uri;if(a.searchPaths){const U=a.searchPaths.filter($=>(0,A.isEqual)($.searchPath,N))[0];if(U&&!U.pattern)return null;U&&(P=U.pattern)}const B=this.configurationService.getValue({resource:N}),O={...this.getExcludesForFolder(B,v)||{},...P||{}},z=n.URI.isUri(w)?(0,A.basename)(w):w.name;return{folder:N,folderName:S?z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!B.search.followSymlinks}}};d=Be([He(0,c.IConfigurationService),He(1,u.IWorkspaceContextService),He(2,F.IEditorGroupsService),He(3,y.IPathService)],d),e.QueryBuilder=d;function D(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const v=w.index,a=h.substr(0,v).match(/[/|\\][^/\\]*$/);if(a){let S=h.substr(0,a.index);return S.match(/[/\\]/)||(S+="/"),{pathPortion:S,globPortion:h.substr((a.index||0)+1)}}}return{pathPortion:h}}function l(...h){return h.length?h.reduce((w,v)=>(w[v]=!0,w),Object.create(null)):void 0}function M(h){return E.splitGlobAware(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function r(h){return[`**/${h}/**`,`**/${h}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function i(h){return h.replace(/\\/g,"/")}function p(h){return i(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(h,w){h=s.distinct(h,S=>S.toString());const v=[],a=w.getWorkspace();return h&&h.forEach(S=>{let P;if(w.getWorkbenchState()===2)P=(0,A.relativePath)(a.folders[0].uri,S),P&&P!=="."&&(P="./"+P);else{const N=w.getWorkspaceFolder(S);if(N){const B=N.name;if(a.folders.filter(O=>O.name===B).length===1){const O=(0,A.relativePath)(N.uri,S);O===""?P=`./${N.name}`:P=`./${N.name}/${O}`}else P=S.fsPath}}P&&v.push(P)}),v}e.resolveResourcesForSearchIncludes=m}),define(ye[212],_e([0,1,24,2,20,15,3,211,41,47]),function(Z,e,s,t,E,T,k,I,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function b(c,u){const F=u.activationEvents;if(!F)return Promise.resolve(void 0);const y=[],f=[];for(const i of F)if(/^workspaceContains:/.test(i)){const p=i.substr("workspaceContains:".length);p.indexOf("*")>=0||p.indexOf("?")>=0||c.forceUsingSearch?f.push(p):y.push(p)}if(y.length===0&&f.length===0)return Promise.resolve(void 0);let d;const D=new Promise((i,p)=>{d=i}),l=i=>d({activationEvent:i}),M=Promise.all(y.map(i=>n(c,i,l))).then(()=>{}),r=g(c,u.identifier,f,l);return Promise.all([M,r]).then(()=>{d(void 0)}),D}e.checkActivateWorkspaceContainsExtension=b;async function n(c,u,F){for(const y of c.folders)if(await c.exists(s.joinPath(t.URI.revive(y),u))){F(`workspaceContains:${u}`);return}}async function g(c,u,F,y){if(F.length===0)return Promise.resolve(void 0);const f=new E.CancellationTokenSource,d=c.checkExists(c.folders,F,f.token),D=setTimeout(async()=>{f.cancel(),c.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${F.join(",")}`)},R);let l=!1;try{l=await d}catch(M){T.isPromiseCanceledError(M)||T.onUnexpectedError(M)}f.dispose(),clearTimeout(D),l&&y(`workspaceContains:${F.join(",")}`)}function o(c,u,F,y){const f=c.get(k.IInstantiationService),d=c.get(C.ISearchService),l=f.createInstance(I.QueryBuilder).file(u.map(M=>(0,A.toWorkspaceFolder)(t.URI.revive(M))),{_reason:"checkExists",includePattern:F,exists:!0});return d.fileSearch(l,y).then(M=>!!M.limitHit,M=>T.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=o});var Ze=this&&this.__classPrivateFieldSet||function(Z,e,s,t,E){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!E:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?E.call(Z,s):E?E.value=s:e.set(Z,s),s},Ie=this&&this.__classPrivateFieldGet||function(Z,e,s,t){if(s==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?t:s==="a"?t.call(Z):t?t.value:e.get(Z)};define(ye[33],_e([0,1,119,17,73,24,14,6,21,2,12,5,32,172,71,31,27,170,15,25,22,146,7,84,3,28,72,13,60,64,40,4,212,68,148,11]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y,f,d,D,l,M,r,i,p,m,h,w,v,a,S,P,N,B){"use strict";var _,O,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class ji extends I.Disposable{constructor(K,re,pe,be,ae,le,Ce,Ee,Fe,$e){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=re,this._extHostContext=pe,this._initData=Ce,this._extHostWorkspace=be,this._extHostConfiguration=ae,this._logService=le,this._extHostTunnelService=Fe,this._extHostTerminalService=$e,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new F.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=Ee,this._instaService=K.createChild(new h.ServiceCollection([o.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(je=>Ve.add(f.ExtensionIdentifier.toKey(je))),this._activator=this._register(new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(je,H,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(je,y.transformErrorForSerialization(H),G)},actualActivateExtension:async(je,H)=>{if(Ve.has(f.ExtensionIdentifier.toKey(je)))return await this._mainThreadExtensionsProxy.$activateExtension(je,H),new g.HostExtension;const G=this._registry.getExtensionDescription(je);return this._activateExtension(G,H)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(K){y.onUnexpectedError(K)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let K=[];try{K=this._registry.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this._deactivate(ae))}catch{}await Promise.all(K)}isActivated(K){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(K):!1}_activateByEvent(K,re){return this._activator.activateByEvent(K,re)}_activateById(K,re){return this._activator.activateById(K,re)}activateByIdWithErrors(K,re){return this._activateById(K,re).then(()=>{const pe=this._activator.getActivatedExtension(K);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(K=>this._registry)}getExtensionExports(K){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(K).exports:null}async _realPathExtensionUri(K){if(K.scheme!==B.Schemas.file)return K;const re=await this._hostUtils.realpath(K.fsPath);return A.URI.file(re)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const K=C.TernarySearchTree.forUris(re=>T.extUriBiasedIgnorePathCase.ignorePathCasing(re));for(const re of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(re)){const pe=await this._realPathExtensionUri(re.extensionLocation);K.set(pe,re)}return K})()),this._extensionPathIndex}_deactivate(K){let re=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(K))return re;const pe=this._activator.getActivatedExtension(K);if(!pe)return re;try{typeof pe.module.deactivate=="function"&&(re=Promise.resolve(pe.module.deactivate()).then(void 0,be=>(this._logService.error(be),Promise.resolve(void 0))))}catch(be){this._logService.error(`An error occurred when deactivating the extension '${K.value}':`),this._logService.error(be)}try{(0,I.dispose)(pe.subscriptions)}catch(be){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this._logService.error(be)}return re}async _activateExtension(K,re){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier),this._doActivateExtension(K,re).then(pe=>{const be=pe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(K.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,re),this._logExtensionActivationTimes(K,re,"success",be),pe},pe=>{throw this._logExtensionActivationTimes(K,re,"failure"),pe})}_logExtensionActivationTimes(K,re,pe,be){const ae=$(K,re);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ae,...be||{},outcome:pe})}_doActivateExtension(K,re){const pe=$(K,re);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",pe);const be=this._getEntryPoint(K);if(!be)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${re.startup}, activationEvent: '${re.activationEvent}'${K.identifier.value!==re.extensionId.value?`, root cause: ${re.extensionId.value}`:""}`),this._logService.flush();const ae=new g.ExtensionActivationTimesBuilder(re.startup);return Promise.all([this._loadCommonJSModule(K.identifier,(0,T.joinPath)(K.extensionLocation,be),ae),this._loadExtensionContext(K)]).then(le=>(E.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),ji._callActivate(this._logService,K.identifier,le[0],le[1],ae))).then(le=>(E.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),le))}_loadExtensionContext(K){const re=new D.ExtensionGlobalMemento(K,this._storage),pe=new D.ExtensionMemento(K.identifier.value,!1,this._storage),be=new N.ExtensionSecrets(K,this._secretState),ae=K.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,le=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([re.whenReady,pe.whenReady,this._storagePath.whenReady]).then(()=>{const Ce=this;let Ee;return Object.freeze({globalState:re,workspaceState:pe,secrets:be,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Fe){return t.join(K.extensionLocation.fsPath,Fe)},get storagePath(){return Ce._storagePath.workspaceValue(K)?.fsPath},get globalStoragePath(){return Ce._storagePath.globalValue(K).fsPath},get logPath(){return t.join(Ce._initData.logsLocation.fsPath,K.identifier.value)},get logUri(){return A.URI.joinPath(Ce._initData.logsLocation,K.identifier.value)},get storageUri(){return Ce._storagePath.workspaceValue(K)},get globalStorageUri(){return Ce._storagePath.globalValue(K)},get extensionMode(){return ae},get extension(){return Ee===void 0&&(Ee=new V(Ce,K.identifier,K,le)),Ee},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(K,"extensionRuntime"),Ce.extensionRuntime},get environmentVariableCollection(){return Ce._extHostTerminalService.getEnvironmentVariableCollection(K)}})})}static _callActivate(K,re,pe,be,ae){return pe=pe||{activate:void 0,deactivate:void 0},this._callActivateOptional(K,re,pe,be,ae).then(le=>new g.ActivatedExtension(!1,null,ae.build(),pe,le,be.subscriptions))}static _callActivateOptional(K,re,pe,be,ae){if(typeof pe.activate=="function")try{ae.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${re.value}`);const le=typeof global=="object"?global:self,Ce=pe.activate.apply(le,[be]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(Ce).then(Ee=>(ae.activateResolveStop(),Ee))}catch(le){return Promise.reject(le)}else return Promise.resolve(pe)}_activateOneStartupFinished(K,re){this._activateById(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:re}).then(void 0,pe=>{this._logService.error(pe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const K of this._registry.getAllExtensionDescriptions())if(K.activationEvents)for(const re of K.activationEvents)re==="onStartupFinished"&&this._activateOneStartupFinished(K,re)}_handleEagerExtensions(){const K=this._activateByEvent("*",!0).then(void 0,ae=>{this._logService.error(ae)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ae=>this._handleWorkspaceContainsEagerExtensions(ae.added)));const re=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],pe=this._handleWorkspaceContainsEagerExtensions(re),be=Promise.all([K,pe]).then(()=>{});return Promise.race([be,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),be}_handleWorkspaceContainsEagerExtensions(K){return K.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(re=>this._handleWorkspaceContainsEagerExtension(K,re))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(K,re){if(this.isActivated(re.identifier))return;const pe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,be={logService:this._logService,folders:K.map(le=>le.uri),forceUsingSearch:pe,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,Ce,Ee)=>this._mainThreadWorkspaceProxy.$checkExists(le,Ce,Ee)},ae=await(0,S.checkActivateWorkspaceContainsExtension)(be,re);if(!!ae)return this._activateById(re.identifier,{startup:!0,extensionId:re.identifier,activationEvent:ae.activationEvent}).then(void 0,le=>this._logService.error(le))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(K){throw console.error(K),K}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:re}=this._initData.environment;if(!K||!re)throw new Error(s.localize(0,null));const pe=await this._loadCommonJSModule(null,re,new g.ExtensionActivationTimesBuilder(!1));if(!pe||typeof pe.run!="function")throw new Error(s.localize(1,null,re.toString()));return new Promise((be,ae)=>{const le=(Fe,$e)=>{Fe?ae(Fe):be(typeof $e=="number"&&$e>0?1:0)},Ce=(0,T.originalFSPath)(re),Ee=pe.run(Ce,le);Ee&&Ee.then&&Ee.then(()=>{be(0)}).catch(Fe=>{ae(Fe instanceof Error&&Fe.stack?Fe.stack:String(Fe))})})}async $extensionTestsExit(K){this._logService.info(`Extension host terminating: test runner requested exit with code ${K}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`),this._logService.flush(),this._hostUtils.exit(K)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,re){return this._resolvers[K]=re,(0,I.toDisposable)(()=>{delete this._resolvers[K]})}async _activateAndGetResolver(K){const re=K.indexOf("+");if(re===-1)throw new Error("Not an authority that can be resolved!");const pe=K.substr(0,re);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this._resolvers[pe]}}async $resolveAuthority(K,re){const{authorityPrefix:pe,resolver:be}=await this._activateAndGetResolver(K);if(!be)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${pe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(be)),E.mark(`code/extHost/willResolveAuthority/${pe}`);const ae=await be.resolve(K,{resolveAttempt:re});E.mark(`code/extHost/didResolveAuthorityOK/${pe}`);const le={authority:K,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},Ce={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:le,options:Ce,tunnelInformation:{environmentTunnels:ae.environmentTunnels}}}}catch(ae){if(E.mark(`code/extHost/didResolveAuthorityError/${pe}`),ae instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(K,re){const{authorityPrefix:pe,resolver:be}=await this._activateAndGetResolver(K);if(!be)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${pe}`);const ae=A.URI.revive(re);if(typeof be.getCanonicalURI=="undefined")return ae;const le=await(0,k.asPromise)(()=>be.getCanonicalURI(ae));return le||ae}$startExtensionHost(K){return this._registry.keepOnly(K),this._startExtensionHost()}$activateByEvent(K,re){return re===1?this._activateByEvent(K,!1):this._readyToRunExtensions.wait().then(pe=>this._activateByEvent(K,!1))}async $activate(K,re){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(K)?(await this._activateById(K,re),!0):!1}async $deltaExtensions(K,re){K.forEach(be=>be.extensionLocation=A.URI.revive(be.extensionLocation));const pe=await this.getExtensionPathIndex();return await Promise.all(re.map(async be=>{const ae=this._registry.getExtensionDescription(be);ae&&pe.delete(await this._realPathExtensionUri(ae.extensionLocation))})),await Promise.all(K.map(async be=>{const ae=await this._realPathExtensionUri(be.extensionLocation);pe.set(ae,be)})),this._registry.deltaExtensions(K,re),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){let re=d.VSBuffer.alloc(K),pe=Math.random()%256;for(let be=0;be<K;be++)re.writeUInt8(pe,be);return re}async $updateRemoteConnectionData(K){this._remoteConnectionData=K,this._onDidChangeRemoteConnectionData.fire()}};U=Be([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,m.IExtHostRpcService),He(3,c.IExtHostWorkspace),He(4,n.IExtHostConfiguration),He(5,R.ILogService),He(6,i.IExtHostInitDataService),He(7,p.IExtensionStoragePaths),He(8,w.IExtHostTunnelService),He(9,v.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function $(ue,K){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class V{constructor(K,re,pe,be){_.set(this,void 0),O.set(this,void 0),z.set(this,void 0),Ze(this,_,K,"f"),Ze(this,O,re,"f"),Ze(this,z,pe.identifier,"f"),this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=t.normalize((0,T.originalFSPath)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=be}get isActive(){return Ie(this,_,"f").isActivated(Ie(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ie(this,_,"f").getExtensionExports(Ie(this,z,"f"))}activate(){return Ie(this,_,"f").activateByIdWithErrors(Ie(this,z,"f"),{startup:!1,extensionId:Ie(this,O,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=V,_=new WeakMap,O=new WeakMap,z=new WeakMap}),define(ye[98],_e([0,1,17,2,4,14,5,7,155,31,33,49,162,32,156,13,3,10,89,70]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,u.createDecorator)("IExtHostDebugService");let d=class{constructor(h,w,v,a,S,P){this._workspaceService=w,this._extensionService=v,this._editorsService=a,this._configurationService=S,this._editorTabs=P,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=h.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(B=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,w){const v=h;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let a=`debug:${encodeURIComponent(v.path||"")}`,S="?";return w&&(a+=`${S}session=${encodeURIComponent(w.id)}`,S="&"),a+=`${S}ref=${v.sourceReference}`,t.URI.parse(a)}else{if(v.path)return t.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const w=[];for(const v of h.getAllExtensionDescriptions())if(v.contributes){const a=v.contributes.debuggers;if(a&&a.length>0)for(const S of a)(0,o.isDebuggerMainContribution)(S)&&w.push(S.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(w=>h.push(w)),h}addBreakpoints(h){this.startBreakpoints();const w=h.filter(S=>{const P=S.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,S),!0)});this.fireBreakpointChanges(w,[],[]);const v=[],a=new Map;for(const S of w)if(S instanceof I.SourceBreakpoint){let P=a.get(S.location.uri.toString());P||(P={type:"sourceMulti",uri:S.location.uri,lines:[]},a.set(S.location.uri.toString(),P),v.push(P)),P.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character})}else S instanceof I.FunctionBreakpoint&&v.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName});return this._debugServiceProxy.$registerBreakpoints(v)}removeBreakpoints(h){this.startBreakpoints();const w=h.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],w,[]);const v=w.filter(P=>P instanceof I.SourceBreakpoint).map(P=>P.id),a=w.filter(P=>P instanceof I.FunctionBreakpoint).map(P=>P.id),S=w.filter(P=>P instanceof I.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(v,a,S)}startDebugging(h,w,v){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,w,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,debugUI:v.debugUI,suppressSaveBeforeStart:v.suppressSaveBeforeStart})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,w,v){if(!w)return new I.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:a,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,v,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,a),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(h,w,v){if(!v)return new I.Disposable(()=>{});if(!this.definesDebugType(h,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:a,factory:v}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,a),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==v),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(h,w){if(!w)return new I.Disposable(()=>{});const v=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:v,factory:w}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==w)})}async $runInTerminal(h,w){return Promise.resolve(void 0)}async $substituteVariables(h,w){if(!this._variableResolver){const[S,P]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(S||[],this._editorsService,P)}let v;const a=await this.getFolder(h);return a&&(v={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(v,w)}createDebugAdapter(h,w){if(h.type==="implementation")return new i(h.implementation)}createSignService(){}async $startDASession(h,w){const v=this,a=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const P=this.convertToDto(S),N=this.createDebugAdapter(P,a);if(!N)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const B=N;return this._debugAdapters.set(h,B),this.getDebugAdapterTrackers(a).then(_=>(_&&this._debugAdaptersTrackers.set(h,_),B.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const z=O,U={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(z.arguments.value);U.body={signature:$},B.sendResponse(U)}else throw new Error("no signer")}catch($){U.success=!1,U.message=$.message,B.sendResponse(U)}}else _&&_.onDidSendMessage&&_.onDidSendMessage(O),O=(0,o.convertToVSCPaths)(O,!0),v._debugServiceProxy.$acceptDAMessage(h,O)}),B.onError(O=>{_&&_.onError&&_.onError(O),this._debugServiceProxy.$acceptDAError(h,O.name,O.message,O.stack)}),B.onExit(O=>{_&&_.onExit&&_.onExit((0,F.withNullAsUndefined)(O),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,F.withNullAsUndefined)(O),void 0)}),_&&_.onWillStartSession&&_.onWillStartSession(),B.startSession()))})}$sendDAMessage(h,w){w=(0,o.convertToDAPaths)(w,!1);const v=this._debugAdaptersTrackers.get(h);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(w);const a=this._debugAdapters.get(h);a&&a.sendMessage(w)}$stopDASession(h){const w=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),w&&w.onWillStopSession&&w.onWillStopSession();const v=this._debugAdapters.get(h);return this._debugAdapters.delete(h),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const w=[],v=[],a=[];if(h.added)for(const S of h.added){const P=S.id;if(P&&!this._breakpoints.has(P)){let N;if(S.type==="function")N=new I.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage);else if(S.type==="data")N=new I.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage);else{const B=t.URI.revive(S.uri);N=new I.SourceBreakpoint(new I.Location(B,new I.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage)}N._id=P,this._breakpoints.set(P,N),w.push(N)}}if(h.removed)for(const S of h.removed){const P=this._breakpoints.get(S);P&&(this._breakpoints.delete(S),v.push(P))}if(h.changed){for(const S of h.changed)if(S.id){const P=this._breakpoints.get(S.id);if(P){if(P instanceof I.FunctionBreakpoint&&S.type==="function"){const N=P;N.enabled=S.enabled,N.condition=S.condition,N.hitCondition=S.hitCondition,N.logMessage=S.logMessage,N.functionName=S.functionName}else if(P instanceof I.SourceBreakpoint&&S.type==="source"){const N=P;N.enabled=S.enabled,N.condition=S.condition,N.hitCondition=S.hitCondition,N.logMessage=S.logMessage,N.location=new I.Location(t.URI.revive(S.uri),new I.Position(S.line,S.character))}a.push(P)}}}this.fireBreakpointChanges(w,v,a)}$provideDebugConfigurations(h,w,v){return(0,T.asPromise)(async()=>{const a=this.getConfigProviderByHandle(h);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(w);return a.provideDebugConfigurations(S,v)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(h,w,v,a){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(h);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(w);return S.resolveDebugConfiguration(P,v,a)})}$resolveDebugConfigurationWithSubstitutedVariables(h,w,v,a){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(h);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(w);return S.resolveDebugConfigurationWithSubstitutedVariables(P,v,a)})}async $provideDebugAdapter(h,w){const v=this.getAdapterDescriptorFactoryByHandle(h);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(w);return this.getAdapterDescriptor(v,a).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(h){const w=await this.getSession(h);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(h){const w=await this.getSession(h);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,w){const v=await this.getSession(h);v&&v._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(h,w){const a={session:await this.getSession(h),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(h){if(h instanceof I.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof I.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const w=this._adapterFactories.filter(v=>v.type===h);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(h){const w=this._adapterFactories.filter(v=>v.handle===h);if(w.length>0)return w[0].factory}getConfigProviderByHandle(h){const w=this._configProviders.filter(v=>v.handle===h);if(w.length>0)return w[0].provider}definesDebugType(h,w){if(h.contributes){const v=h.contributes.debuggers;if(v&&v.length>0){for(const a of v)if(a.label&&a.type&&a.type===w)return!0}}return!1}getDebugAdapterTrackers(h){const v=h.configuration.type,a=this._trackerFactories.filter(S=>S.type===v||S.type==="*").map(S=>(0,T.asPromise)(()=>S.factory.createDebugAdapterTracker(h)).then(P=>P,P=>null));return Promise.race([Promise.all(a).then(S=>{const P=S.filter(N=>!!N);if(P.length>0)return new r(P)}),new Promise((S,P)=>{const N=setTimeout(()=>{clearTimeout(N),P(new Error("timeout"))},1e3)})]).catch(S=>{})}async getAdapterDescriptor(h,w){const v=w.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new I.DebugAdapterServer(v));if(h){const S=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>h.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,S))).then(P=>{if(P)return P})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,a))}daExecutableFromPackage(h,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,w,v){(h.length>0||w.length>0||v.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:w,changed:v}))}async getSession(h){if(h)if(typeof h=="string"){const w=this._debugSessions.get(h);if(w)return w}else{let w=this._debugSessions.get(h.id);if(!w){const v=await this.getFolder(h.folderUri),a=h.parent?this._debugSessions.get(h.parent):void 0;w=new D(this._debugServiceProxy,h.id,h.type,h.name,v,h.configuration,a),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(h){if(h){const w=t.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};d=Be([He(0,c.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,b.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,f.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class D{constructor(h,w,v,a,S,P,N){this._debugServiceProxy=h,this._id=w,this._type=v,this._name=a,this._workspaceFolder=S,this._configuration=P,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}get parentSession(){return this._parentSession}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,w)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=D;class l{constructor(h){this.value=Object.freeze({append(w){h.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=l;class M extends n.AbstractVariableResolverService{constructor(h,w,v,a,S){function P(){if(w){const N=w.activeEditor();if(N)return N.document.uri;const B=a.tabs.filter(_=>_.isActive);if(B.length>0){const _=B[0].resource;return _&&(_.primary||_.secondary)?_.primary??_.secondary:B[0].resource}}}super({getFolderUri:N=>{const B=h.filter(_=>_.name===N);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(N,B)=>v.getConfiguration(void 0,N).get(B),getAppRoot:()=>y.cwd(),getExecPath:()=>y.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=P();if(N)return s.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(S){const N=P();if(N){const B=S.getWorkspaceFolder(N);if(B)return s.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(w){const N=w.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(w){const N=w.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(y.env))}}e.ExtHostVariableResolverService=M;class r{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(w=>w.onError?w.onError(h):void 0)}onExit(h,w){this.trackers.forEach(v=>v.onExit?v.onExit(h,w):void 0)}}class i extends C.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let p=class extends d{constructor(h,w,v,a,S,P){super(h,w,v,a,S,P)}createVariableResolver(h,w,v){return new M(h,w,v,this._editorTabs)}};p=Be([He(0,c.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,b.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,f.IExtHostEditorTabs)],p),e.WorkerExtHostDebugService=p}),define(ye[213],_e([0,1,73,2,5,32,27,25,13,28,3,33,89,12]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(f,d,D,l,M,r,i){this._apiFactory=f,this._extensionRegistry=d,this._instaService=D,this._extHostConfiguration=l,this._extHostExtensionService=M,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,d,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(u,d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(F,d,this._initData.environment.appUriScheme))}register(f){if(Array.isArray(f.nodeModuleName))for(let d of f.nodeModuleName)this._factories.set(d,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(d=>f.alternativeModuleName(d))}};o=Be([He(2,R.IInstantiationService),He(3,T.IExtHostConfiguration),He(4,b.IExtHostExtensionService),He(5,A.IExtHostInitDataService),He(6,g.ILogService)],o),e.RequireInterceptor=o;class c{constructor(f,d,D,l,M){this._apiFactory=f,this._extensionPaths=d,this._extensionRegistry=D,this._configProvider=l,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,d){const D=this._extensionPaths.findSubstr(d);if(D){let l=this._extApiImpl.get(I.ExtensionIdentifier.toKey(D.identifier));return l||(l=this._apiFactory(D,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(D.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((M,r)=>l+=`	${r} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let u=class{constructor(f,d,D){this._extensionPaths=f,this.nodeModuleName="keytar",this._mainThreadTelemetry=d.getProxy(E.MainContext.MainThreadTelemetry);const{environment:l}=D,M=d.getProxy(E.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;n.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>M.$getPassword(r,i),setPassword:(r,i,p)=>M.$setPassword(r,i,p),deletePassword:(r,i)=>M.$deletePassword(r,i),findPassword:r=>M.$findPassword(r),findCredentials(r){return M.$findCredentials(r)}}}load(f,d){const D=this._extensionPaths.findSubstr(d);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:D?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(f){const d=f.length;if(d<=7||!this.alternativeNames)return;const D=d-7;if((f.charAt(D)==="/"||f.charAt(D)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}};u=Be([He(1,C.IExtHostRpcService),He(2,A.IExtHostInitDataService)],u);let F=class{constructor(f,d,D){this._extensionPaths=f,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=D.getProxy(E.MainContext.MainThreadTelemetry);const l=D.getProxy(E.MainContext.MainThreadWindow);this._impl=(M,r)=>{const i=t.URI.parse(M);return r?this.callOriginal(M,r):i.scheme==="http"||i.scheme==="https"?l.$openUri(i,M,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?l.$openUri(i,M,{}):this.callOriginal(M,r)}}load(f,d,D){const l=this._extensionPaths.findSubstr(d);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=D(f),this._impl}callOriginal(f,d){return this.sendNoForwardTelemetry(),this._original(f,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};F=Be([He(2,C.IExtHostRpcService)],F)}),define(ye[214],_e([0,1,14,15,73,6,2,5,207,12,44,60,28,136,13,65,33,40]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class y{constructor(d,D,l,M){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new C.RPCProtocol(d,null,M),D=y._transform(D,this._rpcProtocol);const r=new b.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...D}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(c.IURITransformerService,new c.URITransformerService(M)),r.set(u.IHostUtils,l);const i=new g.InstantiationService(r,!0);this._disposables.add(i.invokeFunction(w=>w.get(F.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(w=>w.get(u.IExtHostExtensionService))),this._logService=i.invokeFunction(w=>w.get(A.ILogService)),E.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",D),this._extensionService=i.invokeFunction(w=>w.get(u.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(w=>{Error.prepareStackTrace=(v,a)=>{let S="",P,N;for(const B of a)S+=`
	at ${B.toString()}`,N=B.getFileName(),!P&&N&&(P=w.findSubstr(k.URI.file(N)));return p.set(v,P),`${v.name||"Error"}: ${v.message||""}${S}`}});const m=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),h=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(w=>{const v=t.transformErrorForSerialization(w),a=p.get(w);a?m.$onExtensionRuntimeError(a.identifier,v):h.$onUnexpectedError(v)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const D=this._extensionService.deactivateAll();Promise.race([(0,s.timeout)(5e3),D]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(d,D){d.extensions.forEach(M=>M.extensionLocation=k.URI.revive(D.transformIncomingURIs(M.extensionLocation))),d.environment.appRoot=k.URI.revive(D.transformIncomingURIs(d.environment.appRoot));const l=d.environment.extensionDevelopmentLocationURI;return l&&(d.environment.extensionDevelopmentLocationURI=l.map(M=>k.URI.revive(D.transformIncomingURIs(M)))),d.environment.extensionTestsLocationURI=k.URI.revive(D.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=k.URI.revive(D.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=k.URI.revive(D.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=k.URI.revive(D.transformIncomingURIs(d.logsLocation)),d.logFile=k.URI.revive(D.transformIncomingURIs(d.logFile)),d.workspace=D.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=y}),define(ye[215],_e([0,1,17,20,43,29,24,188,41]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(n,g,o){this.config=n,this.provider=g,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&T.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&T.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const g=this.config.folderQueries||[];return new Promise((o,c)=>{const u=F=>{this.resultCount++,n(F)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(F=>{const y=F.toString(),f=s.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,f)||this.matchFile(u,{base:F,basename:f})}),Promise.all(g.map(F=>this.searchInFolder(F,u))).then(F=>{o({limitHit:this.isLimitHit,stats:F[0]||void 0})},F=>{c(new Error((0,E.toErrorMessage)(F)))})})}async searchInFolder(n,g){const o=new t.CancellationTokenSource,c=this.getSearchOptionsForFolder(n),u=this.initDirectoryTree(),F=new C.QueryGlobTester(this.config,n),y=!F.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(o),f=I.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,o.token),D=f.elapsed(),l=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(M=>{const r=s.posix.relative(n.folder.path,M.path);if(y){const i=s.basename(M.path);this.matchFile(g,{base:n.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(u,n.folder,r,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,F,g),{providerTime:D,postProcessTime:l.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(n){const g=(0,C.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),o=(0,C.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:o,includes:g,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},g,o,c){if(o===this.filePattern){const F=s.basename(this.filePattern);this.matchFile(c,{base:g,relativePath:this.filePattern,basename:F})}function u(F){const y=s.basename(F),f=s.dirname(F);let d=n[f];d||(d=n[f]=[],u(f)),d.push({base:g,relativePath:F,basename:y})}u(o)}matchDirectoryTree({rootEntries:n,pathToEntries:g},o,c){const u=this,F=this.filePattern;function y(f){const d=T.hasSiblingFn(()=>f.map(D=>D.basename));for(let D=0,l=f.length;D<l;D++){const M=f[D],{relativePath:r,basename:i}=M;if(o.matchesExcludesSync(r,i,F!==i?d:void 0))continue;const p=g[r];if(p)y(p);else{if(r===F)continue;u.matchFile(c,M)}if(u.isLimitHit)break}}y(n)}matchFile(n,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(g))}}class R{constructor(){this.sessions=new Map}fileSearch(n,g,o,c){const u=this.getSessionTokenSource(n.cacheKey),F=new A(n,g,u&&u.token);let y=0;const f=d=>{y+=d.length,o(d.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(F,R.BATCH_SIZE,f,c).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:d.stats}}))}clearCache(n){const g=this.getSessionTokenSource(n);g&&g.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new t.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:k.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,g,o,c){c.onCancellationRequested(()=>{n.cancel()});const u=y=>{y&&(F.push(y),g>0&&F.length>=g&&(o(F),F=[]))};let F=[];return n.search(u).then(y=>(F.length&&o(F),y),y=>(F.length&&o(F),Promise.reject(y)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ye[216],_e([0,1,16,20,43,29,11,17,24,10,2,41]),function(Z,e,s,t,E,T,k,I,C,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(f,d,D,l){this.query=f,this.provider=d,this.fileUtils=D,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,d){const D=this.query.folderQueries||[],l=new t.CancellationTokenSource;return d.onCancellationRequested(()=>l.cancel()),new Promise((M,r)=>{this.collector=new o(f);let i=!1;const p=(m,h)=>{if(!i&&!this.isLimitHit){const w=this.resultSize(m);u(m)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,i=!0,l.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const v=this.resultSize(m);this.resultCount+=v,(v>0||!u(m))&&this.collector.add(m,h)}};Promise.all(D.map((m,h)=>this.searchInFolder(m,w=>p(w,h),l.token))).then(m=>{l.dispose(),this.collector.flush();const h=m.some(w=>!!w&&!!w.limitHit);M({limitHit:this.isLimitHit||h,messages:(0,s.flatten)(m.map(w=>w?.message?(0,A.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},m=>{l.dispose();const h=(0,E.toErrorMessage)(m);r(new Error(h))})})}resultSize(f){return u(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,d){const D=Array.isArray(f.ranges)?f.ranges:[f.ranges],l=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:D.slice(0,d),preview:{matches:l.slice(0,d),text:f.preview.text},uri:f.uri}}async searchInFolder(f,d,D){const l=new b.QueryGlobTester(this.query,f),M=[],r={report:m=>{if(!this.validateProviderResult(m))return;const h=f.folder.scheme===k.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(m.uri))):void 0,w=C.relativePath(f.folder,m.uri);if(w){const v=l.includedInQuery(w,I.basename(w),h);(0,A.isPromise)(v)?M.push(v.then(a=>{a&&d(m)})):v&&d(m)}}},i=this.getSearchOptionsForFolder(f),p=await this.provider.provideTextSearchResults(g(this.query.contentPattern),i,r,D);return M.length&&await Promise.all(M),p}validateProviderResult(f){if(u(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const d=(0,b.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),D=(0,b.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),l={folder:R.URI.from(f.folder),excludes:D,includes:d,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=n;function g(y){return{isCaseSensitive:y.isCaseSensitive||!1,isRegExp:y.isRegExp||!1,isWordMatch:y.isWordMatch||!1,isMultiline:y.isMultiline||!1,pattern:y.pattern}}class o{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new F(512,d=>this.sendItems(d))}add(f,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!C.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(c(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=o;function c(y){return u(y)?{preview:{matches:(0,s.mapArrayOrNot)(y.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:y.preview.text},ranges:(0,s.mapArrayOrNot)(y.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:y.text,lineNumber:y.lineNumber}}function u(y){return!!y.preview}e.extensionResultIsMatch=u;class F{constructor(f,d){this.maxBatchSize=f,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,d){!f||this.addItemToBatch(f,d)}addItems(f,d){!f||this.addItemsToBatch(f,d)}addItemToBatch(f,d){this.batch.push(f),this.batchSize+=d,this.onUpdate()}addItemsToBatch(f,d){this.batch=this.batch.concat(f),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<F.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},F.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=F,F.TIMEOUT=4e3,F.START_BATCH_AFTER_COUNT=50}),define(ye[99],_e([0,1,6,5,3,215,13,65,12,2,216]),function(Z,e,s,t,E,T,k,I,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let b=class{constructor(c,u,F){this.extHostRpc=c,this._uriTransformer=u,this._logService=F,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,u){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const F=this._handlePool++;return this._textSearchProvider.set(F,u),this._proxy.$registerTextSearchProvider(F,this._transformScheme(c)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}registerFileSearchProvider(c,u){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const F=this._handlePool++;return this._fileSearchProvider.set(F,u),this._proxy.$registerFileSearchProvider(F,this._transformScheme(c)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}$provideFileSearchResults(c,u,F,y){const f=n(F),d=this._fileSearchProvider.get(c);if(d)return this._fileSearchManager.fileSearch(f,d,D=>{this._proxy.$handleFileMatch(c,u,D.map(l=>l.resource))},y);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,u,F,y){const f=this._textSearchProvider.get(c);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const d=n(F);return this.createTextSearchManager(d,f).search(l=>this._proxy.$handleTextMatch(c,u,l),y)}$enableExtensionHostSearch(){}createTextSearchManager(c,u){return new R.TextSearchManager(c,u,{readdir:F=>Promise.resolve([]),toCanonicalName:F=>F},"textSearchProvider")}};b=Be([He(0,k.IExtHostRpcService),He(1,I.IURITransformerService),He(2,C.ILogService)],b),e.ExtHostSearch=b;function n(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(g),extraFileResources:o.extraFileResources&&o.extraFileResources.map(c=>A.URI.revive(c))}}e.reviveQuery=n;function g(o){return{...o,folder:A.URI.revive(o.folder)}}}),define(ye[217],_e([0,1,44,94,31,93,32,39,49,40,97,98,99,71,64,69,95,50,30,68,85,70,190,12,173]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y,f,d,D,l,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(M.ILoggerService,l.ExtHostLoggerService),(0,s.registerSingleton)(M.ILogService,r.ExtHostLogService),(0,s.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService),(0,s.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,s.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,s.registerSingleton)(F.IExtHostConsumerFileSystem,F.ExtHostConsumerFileSystem),(0,s.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService),(0,s.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,s.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,s.registerSingleton)(y.IExtHostFileSystemInfo,y.ExtHostFileSystemInfo),(0,s.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,s.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,s.registerSingleton)(g.IExtHostStorage,g.ExtHostStorage),(0,s.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,s.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,s.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,s.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow),(0,s.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,s.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,s.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,s.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs)}),define(ye[218],_e([0,1,44,3]),function(Z,e,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class E{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(k){if(k&&this._dragOperations.has(k)){const I=this._dragOperations.get(k);return this._dragOperations.delete(k),I}}addDragOperationTransfer(k,I){this._dragOperations.set(k,I)}}e.TreeViewsDragAndDropService=E,(0,s.registerSingleton)(e.ITreeViewsDragAndDropService,E)}),define(ye[219],_e([0,1,123,24,2,4,6,14,7,10,16,8,20,152,218]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(y,f){if((0,A.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let d;return Array.isArray(y.highlights)&&(d=y.highlights.filter(D=>D.length===2&&typeof D[0]=="number"&&typeof D[1]=="number"),d=d.length?d:void 0),{label:y.label,highlights:d}}}class u{constructor(f,d,D){this._proxy=f,this.commands=d,this.logService=D,this.treeViews=new Map,this.treeDragAndDropService=new o.TreeViewsDragAndDropService;function l(M){return M&&M.$treeViewId&&M.$treeItemHandle}d.registerArgumentProcessor({processArgument:M=>l(M)?this.convertArgument(M):Array.isArray(M)&&M.length>0?M.map(r=>l(r)?this.convertArgument(r):r):M})}registerTreeDataProvider(f,d,D){const l=this.createTreeView(f,{treeDataProvider:d},D);return{dispose:()=>l.dispose()}}createTreeView(f,d,D){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=d.dragAndDropController?.supportedMimeTypes,M=!!d.dragAndDropController?.onWillDrop,r=this._proxy.$registerTreeViewDataProvider(f,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,dragAndDropMimeTypes:l,hasWillDrop:M}),i=this.createExtHostTreeView(f,d,D);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(p){i.message=p},get title(){return i.title},set title(p){i.title=p},get description(){return i.description},set description(p){i.description=p},reveal:(p,m)=>i.reveal(p,m),dispose:async()=>{await r,this.treeViews.delete(f),i.dispose()}}}$getChildren(f,d){const D=this.treeViews.get(f);return D?D.getChildren(d):Promise.reject(new Error((0,s.localize)(0,null,f)))}async $onDrop(f,d,D,l,M,r){const i=this.treeViews.get(f);if(!i)return Promise.reject(new Error((0,s.localize)(1,null,f)));const p=g.TreeDataTransferConverter.toITreeDataTransfer(d);return M===f&&r&&await this.addAdditionalTransferItems(p,i,r,l),i.onDrop(p,D)}async addAdditionalTransferItems(f,d,D,l){const M=this.treeDragAndDropService.removeDragOperationTransfer(l);let r;if(M)r=await M;else if(l&&d.onWillDrop){const i=d.onWillDrop(D);this.treeDragAndDropService.addDragOperationTransfer(l,i),r=await i}return r&&r.forEach((i,p)=>{i&&f.set(p,i)}),f}async $onWillDrop(f,d,D){const l=this.treeViews.get(f);if(!l)return Promise.reject(new Error((0,s.localize)(2,null,f)));const M=await this.addAdditionalTransferItems(new Map,l,d,D);if(!!M)return g.TreeDataTransferConverter.toTreeDataTransferDTO(M)}async $hasResolve(f){const d=this.treeViews.get(f);if(!d)throw new Error((0,s.localize)(3,null,f));return d.hasResolve}$resolve(f,d,D){const l=this.treeViews.get(f);if(!l)throw new Error((0,s.localize)(4,null,f));return l.resolveTreeItem(d,D)}$setExpanded(f,d,D){const l=this.treeViews.get(f);if(!l)throw new Error((0,s.localize)(5,null,f));l.setExpanded(d,D)}$setSelection(f,d){const D=this.treeViews.get(f);if(!D)throw new Error((0,s.localize)(6,null,f));D.setSelection(d)}$setVisible(f,d){const D=this.treeViews.get(f);if(!D)throw new Error((0,s.localize)(7,null,f));D.setVisible(d)}createExtHostTreeView(f,d,D){const l=new F(f,d,this._proxy,this.commands.converter,this.logService,D);return this.treeViews.set(f,l),l}convertArgument(f){const d=this.treeViews.get(f.$treeViewId);return d?d.getExtensionElement(f.$treeItemHandle):null}}e.ExtHostTreeViews=u;class F extends k.Disposable{constructor(f,d,D,l,M,r){super();if(this.viewId=f,this.proxy=D,this.commands=l,this.logService=M,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,r.contributes&&r.contributes.views)for(const m in r.contributes.views)for(const h of r.contributes.views[m])h.id===f&&(this._title=h.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(m=>this._onDidChangeData.fire({message:!1,element:m}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(m=>this._onDidChangeData.fire({message:!1,element:m})));let i,p;this._register(T.Event.debounce(this._onDidChangeData.event,(m,h)=>(m||(m={message:!1,elements:[]}),h.element!==!1&&(i||(i=new Promise(w=>p=w),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(h.element)?m.elements.push(...h.element):m.elements.push(h.element)),h.message&&(m.message=!0),m),200,!0)(({message:m,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=p;return i=null,this.refresh(h).then(()=>w())})),m&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(f=>this.getExtensionElement(f)).filter(f=>!(0,A.isUndefinedOrNull)(f))}async getChildren(f){const d=f?this.getExtensionElement(f):void 0;if(f&&!d)return this.logService.error(`No tree item with id '${f}' found.`),Promise.resolve([]);let D=this.getChildrenNodes(f);return D||(D=await this.fetchChildrenNodes(d)),D?D.map(l=>l.item):void 0}getExtensionElement(f){return this.elements.get(f)}reveal(f,d){d=d||{select:!0,focus:!1};const D=(0,A.isUndefinedOrNull)(d.select)?!0:d.select,l=(0,A.isUndefinedOrNull)(d.focus)?!1:d.focus,M=(0,A.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.refreshPromise.then(()=>this.resolveUnknownParentChain(f)).then(r=>this.resolveTreeNode(f,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(p=>p.item)},{select:D,focus:l,expand:M})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:D,focus:l,expand:M})}get message(){return this._message}set message(f){this._message=f,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(f){this._title=f,this.proxy.$setTitle(this.viewId,f,this._description)}get description(){return this._description}set description(f){this._description=f,this.proxy.$setTitle(this.viewId,this._title,f)}setExpanded(f,d){const D=this.getExtensionElement(f);D&&(d?this._onDidExpandElement.fire(Object.freeze({element:D})):this._onDidCollapseElement.fire(Object.freeze({element:D})))}setSelection(f){(0,R.equals)(this._selectedHandles,f)||(this._selectedHandles=f,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(f){f!==this._visible&&(this._visible=f,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(f){const d=[];for(const D of f){const l=this.getExtensionElement(D);l&&d.push(l)}if(!(!this.dndController?.onWillDrop||d.length===0))return this.dndController.onWillDrop(d)}get hasOnWillDrop(){return!!this.dndController?.onWillDrop}async onDrop(f,d){const D=this.getExtensionElement(d);if(!!D)return(0,I.asPromise)(()=>this.dndController?.onDrop(f,D))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(f,d){if(!this.dataProvider.resolveTreeItem)return;const D=this.elements.get(f);if(D){const l=this.nodes.get(D);if(l){const M=await this.dataProvider.resolveTreeItem(l.extensionItem,D,d)??l.extensionItem;return l.item.tooltip=this.getTooltip(M.tooltip),l.item.command=this.getCommand(l.disposableStore,M.command),l.item}}}resolveUnknownParentChain(f){return this.resolveParent(f).then(d=>d?this.resolveUnknownParentChain(d).then(D=>this.resolveTreeNode(d,D[D.length-1]).then(l=>(D.push(l),D))):Promise.resolve([]))}resolveParent(f){const d=this.nodes.get(f);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(f))}resolveTreeNode(f,d){const D=this.nodes.get(f);return D?Promise.resolve(D):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(l=>this.createHandle(f,l,d,!0)).then(l=>this.getChildren(d?d.item.handle:void 0).then(()=>{const M=this.getExtensionElement(l);if(M){const r=this.nodes.get(M);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(f){if(f){let d;if(typeof f=="string"){const D=this.getExtensionElement(f);d=D?this.nodes.get(D):void 0}else d=f;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(f){this.clearChildren(f);const d=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const D=f?this.nodes.get(f):void 0,l=await this.dataProvider.getChildren(f);if(d.token.isCancellationRequested)return;const M=await Promise.all((0,R.coalesce)(l||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,D):null}));return d.token.isCancellationRequested?void 0:(0,R.coalesce)(M)}finally{d.dispose()}}refresh(f){if(f.some(D=>!D))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const D=this.getHandlesToRefresh(f);if(D.length)return this.refreshHandles(D)}return Promise.resolve(void 0)}getHandlesToRefresh(f){const d=new Set,D=f.map(M=>this.nodes.get(M));for(const M of D)if(M&&!d.has(M.item.handle)){let r=M;for(;r&&r.parent&&D.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&d.add(M.item.handle)}const l=[];return d.forEach(M=>{const r=this.elements.get(M);if(r){const i=this.nodes.get(r);i&&(!i.parent||!d.has(i.parent.item.handle))&&l.push(M)}}),l}refreshHandles(f){const d={};return Promise.all(f.map(D=>this.refreshNode(D).then(l=>{l&&(d[D]=l.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(f){const d=this.getExtensionElement(f);if(d){const D=this.nodes.get(d);if(D)return this.clearChildren(d),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(l=>{if(l){const M=this.createTreeNode(d,l,D.parent);return this.updateNodeCache(d,M,D,D.parent),D.dispose(),M}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(f,d,D){const l=this.createTreeNode(f,d,D);if(d.id&&this.elements.has(l.item.handle))throw new Error((0,s.localize)(8,null,d.id));return this.addNodeToCache(f,l),this.addNodeToParentCache(l,D),l}getTooltip(f){return C.MarkdownString.isMarkdownString(f)?b.MarkdownString.from(f):f}getCommand(f,d){return d?this.commands.toInternal(d,f):void 0}createTreeNode(f,d,D){const l=new k.DisposableStore,M=this.createHandle(f,d,D),r=this.getLightIconPath(d);return{item:{handle:M,parentHandle:D?D.item.handle:void 0,label:c(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(l,d.command),contextValue:d.contextValue,icon:r,iconDark:this.getDarkIconPath(d)||r,themeIcon:this.getThemeIcon(d),collapsibleState:(0,A.isUndefinedOrNull)(d.collapsibleState)?C.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:D,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(f){return f.iconPath instanceof C.ThemeIcon?f.iconPath:void 0}createHandle(f,{id:d,label:D,resourceUri:l},M,r){if(d)return`${F.ID_HANDLE_PREFIX}/${d}`;const i=c(D,this.extension),p=M?M.item.handle:F.LABEL_HANDLE_PREFIX;let m=i?i.label:l?(0,t.basename)(l):"";m=m.indexOf("/")!==-1?m.replace("/","//"):m;const h=this.nodes.has(f)?this.nodes.get(f).item.handle:void 0,w=this.getChildrenNodes(M)||[];let v,a=0;do{if(v=`${p}/${a}:${m}`,r||!this.elements.has(v)||h===v)break;a++}while(a<=w.length);return v}getLightIconPath(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon))return typeof f.iconPath=="string"||E.URI.isUri(f.iconPath)?this.getIconPath(f.iconPath):this.getIconPath(f.iconPath.light)}getDarkIconPath(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon)&&f.iconPath.dark)return this.getIconPath(f.iconPath.dark)}getIconPath(f){return E.URI.isUri(f)?f:E.URI.file(f)}addNodeToCache(f,d){this.elements.set(d.item.handle,f),this.nodes.set(f,d)}updateNodeCache(f,d,D,l){this.elements.delete(d.item.handle),this.nodes.delete(f),d.item.handle!==D.item.handle&&this.elements.delete(D.item.handle),this.addNodeToCache(f,d);const M=this.getChildrenNodes(l)||[],r=M.filter(i=>i.item.handle===D.item.handle)[0];r&&M.splice(M.indexOf(r),1,d)}addNodeToParentCache(f,d){d?(d.children||(d.children=[]),d.children.push(f)):(this.roots||(this.roots=[]),this.roots.push(f))}clearChildren(f){if(f){const d=this.nodes.get(f);if(d){if(d.children)for(const D of d.children){const l=this.elements.get(D.item.handle);l&&this.clear(l)}d.children=void 0}}else this.clearAll()}clear(f){const d=this.nodes.get(f);if(d){if(d.children)for(const D of d.children){const l=this.elements.get(D.item.handle);l&&this.clear(l)}this.nodes.delete(f),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(f=>f.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}F.LABEL_HANDLE_PREFIX="0",F.ID_HANDLE_PREFIX="1"}),define(ye[220],_e([0,1,20,15,4,34,2,112,233,106,56,46,5,178,177,39,179,32,180,181,182,164,183,49,33,184,165,187,189,191,94,167,196,197,198,71,40,200,219,8,7,203,51,95,31,74,153,186,61,93,97,98,99,12,65,13,28,192,150,64,69,175,201,149,72,50,206,204,205,176,30,199,202,68,70,85,194,96,195,11,138,193,147,185,6,27]),function(Z,e,s,t,E,T,k,I,C,A,R,b,n,g,o,c,u,F,y,f,d,D,l,M,r,i,p,m,h,w,v,a,S,P,N,B,_,O,z,U,$,V,ue,K,re,pe,be,ae,le,Ce,Ee,Fe,$e,Ve,je,H,G,X,oe,q,ee,he,Re,Ue,ze,Qe,et,st,Xe,nt,lt,vt,Oe,Rt,j,Q,fe,Ne,qe,ot,ht,Je,Tt,Ae,De,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ie(se){const de=se.get(G.IExtHostInitDataService),me=se.get(lt.IExtHostFileSystemInfo),Te=se.get(Qe.IExtHostConsumerFileSystem),We=se.get(r.IExtHostExtensionService),Le=se.get(re.IExtHostWorkspace),Ke=se.get(Q.IExtHostTelemetry),it=se.get(F.IExtHostConfiguration),rt=se.get(je.IURITransformerService),ne=se.get(H.IExtHostRpcService),ge=se.get(B.IExtHostStorage),te=se.get(ze.IExtensionStoragePaths),W=se.get(Ve.ILoggerService),we=se.get(Ve.ILogService),Pe=se.get(q.IExtHostTunnelService),Ye=se.get(ee.IExtHostApiDeprecationService),xe=se.get(K.IExtHostWindow),ut=se.get(Rt.IExtHostSecretState),bt=se.get(j.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,me),ne.set(n.ExtHostContext.ExtHostLogLevelServiceShape,W),ne.set(n.ExtHostContext.ExtHostWorkspace,Le),ne.set(n.ExtHostContext.ExtHostConfiguration,it),ne.set(n.ExtHostContext.ExtHostExtensionService,We),ne.set(n.ExtHostContext.ExtHostStorage,ge),ne.set(n.ExtHostContext.ExtHostTunnelService,Pe),ne.set(n.ExtHostContext.ExtHostWindow,xe),ne.set(n.ExtHostContext.ExtHostSecretState,ut),ne.set(n.ExtHostContext.ExtHostTelemetry,Ke),ne.set(n.ExtHostContext.ExtHostEditorTabs,bt);const Ct=ne.set(n.ExtHostContext.ExtHostDecorations,se.get(Ce.IExtHostDecorations)),wt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,se.get(M.IExtHostDocumentsAndEditors)),ft=ne.set(n.ExtHostContext.ExtHostCommands,se.get(c.IExtHostCommands)),pt=ne.set(n.ExtHostContext.ExtHostTerminalService,se.get(_.IExtHostTerminalService)),yt=ne.set(n.ExtHostContext.ExtHostDebugService,se.get(Fe.IExtHostDebugService)),Ot=ne.set(n.ExtHostContext.ExtHostSearch,se.get($e.IExtHostSearch)),kt=ne.set(n.ExtHostContext.ExtHostTask,se.get(Ee.IExtHostTask)),It=ne.set(n.ExtHostContext.ExtHostOutputService,se.get(v.IExtHostOutputService)),At=ne.set(n.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(ne)),St=ne.set(n.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(ne,wt)),zt=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(ne,wt,we)),Lt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new D.ExtHostDocumentSaveParticipant(we,St,ne.getProxy(n.MainContext.MainThreadBulkEdits))),Et=ne.set(n.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(ne,ft,wt,St,te)),Qt=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new Tt.ExtHostNotebookDocuments(we,Et)),Vt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new Je.ExtHostNotebookEditors(we,ne,Et)),Yt=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(ne,de,Et,ft,we)),si=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new qe.ExtHostNotebookRenderers(ne,Et)),Ft=ne.set(n.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(ne,wt)),Xt=ne.set(n.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),ft,we)),ai=ne.set(n.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),Ft,de)),Jt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(ne,we,me)),Wt=ne.set(n.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(ne,St,ft.converter,rt)),gt=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(ne,rt,St,ft,Jt,we,Ye)),li=ne.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ne,gt)),Nt=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(ne,we,wt)),jt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,S.createExtHostQuickOpen)(ne,Le,ft)),Zt=ne.set(n.ExtHostContext.ExtHostSCM,new P.ExtHostSCM(ne,ft,we)),ci=ne.set(n.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(ne,ft,St)),fi=ne.set(n.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ae.ExtHostLabelService(ne)),mi=ne.set(n.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(ne)),ei=ne.set(n.ExtHostContext.ExtHostAuthentication,new he.ExtHostAuthentication(ne)),yi=ne.set(n.ExtHostContext.ExtHostTimeline,new Re.ExtHostTimeline(ne,ft)),qt=ne.set(n.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(ne,{remote:de.remote},Le,we,Ye)),Kt=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new Xe.ExtHostWebviewPanels(ne,qt,Le)),_i=ne.set(n.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(ne,St,te,qt,Kt)),Si=ne.set(n.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(ne,qt)),Gt=ne.set(n.ExtHostContext.ExtHostTesting,new vt.ExtHostTesting(ne,ft)),Ci=ne.set(n.ExtHostContext.ExtHostUriOpeners,new Oe.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(ne,Et,wt,ft));const ti=(0,pe.values)(n.ExtHostContext);ne.assertRegistered(ti);const Di=new nt.ExtHostBulkEdits(ne,wt),ki=new o.ExtHostClipboard(ne),ui=new w.ExtHostMessageService(ne,we),ii=new f.ExtHostDialogs(ne),gi=new N.ExtHostStatusBar(ne,ft.converter);return g.ExtHostApiCommands.register(ft),function(Me,xt,pi){const mt=function(){let Y=!Me.isUnderDevelopment;function ce(){Y||(we.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function ke(ct){if(Array.isArray(ct))ct.forEach(ke);else if(typeof ct=="string")ce();else{const _t=ct;typeof _t.scheme=="undefined"&&ce(),typeof _t.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ct}}(),ni={getSession(Y,ce,ke){return ei.getSession(Me,Y,ce,ke)},async hasSession(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"authSession"),!!await ei.getSession(Me,Y,ce,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(Y,ce,ke,ct){return ei.registerAuthenticationProvider(Y,ce,ke,ct)}},Ii={registerCommand(Y,ce,ke){return ft.registerCommand(!0,Y,ce,ke,void 0,Me)},registerTextEditorCommand(Y,ce,ke){return ft.registerCommand(!0,Y,(...ct)=>{const _t=Ft.getActiveTextEditor();if(!_t){we.warn("Cannot execute "+Y+" because there is no active text editor.");return}return _t.edit(Dt=>{ce.apply(ke,[_t,Dt,...ct])}).then(Dt=>{Dt||we.warn("Edits from command "+Y+" were not applied.")},Dt=>{we.warn("An error occurred while running command "+Y,Dt)})},void 0,void 0,Me)},registerDiffInformationCommand:(Y,ce,ke)=>((0,ve.checkProposedApiEnabled)(Me,"diffCommand"),ft.registerCommand(!0,Y,async(...ct)=>{const _t=wt.activeEditor(!0);if(!_t){we.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Dt=await Ft.getDiffInformation(_t.id);ce.apply(ke,[Dt,...ct])},void 0,void 0,Me)),executeCommand(Y,...ce){return ft.executeCommand(Y,...ce)},getCommands(Y=!1){return ft.getCommands(Y)}},vi={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return pt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ke.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ke.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ce){return xe.openUri(Y,{allowTunneling:!!de.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===de.environment.appUriScheme)return At.createAppUri(Y);try{return await xe.asExternalUri(Y,{allowTunneling:!!de.remote.authority})}catch(ce){if((0,ht.matchesScheme)(Y,ot.Schemas.http)||(0,ht.matchesScheme)(Y,ot.Schemas.https))return Y;throw ce}},get remoteName(){return(0,le.getRemoteName)(de.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),de.remote.authority},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=de.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Pi={createTestController(Y,ce){return Gt.createTestController(Y,ce)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.createTestObserver()},runTests(Y){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.runTests(Y)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.results}},Ti={getExtension(Y){const ce=xt.getExtensionDescription(Y);if(ce)return new r.Extension(We,Me.identifier,ce,wi)},get all(){return xt.getAllExtensionDescriptions().map(Y=>new r.Extension(We,Me.identifier,Y,wi))},get onDidChange(){return xt.onDidChange}},Ai={createDiagnosticCollection(Y){return Jt.createDiagnosticCollection(Me.identifier,Y)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:Y=>Jt.getDiagnostics(Y),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Y,ce){return Wt.changeLanguage(Y.uri,ce)},match(Y,ce){return(0,R.score)(U.LanguageSelector.from(Y),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Y,ce,ke){return gt.registerCodeActionProvider(Me,mt(Y),ce,ke)},registerCodeLensProvider(Y,ce){return gt.registerCodeLensProvider(Me,mt(Y),ce)},registerDefinitionProvider(Y,ce){return gt.registerDefinitionProvider(Me,mt(Y),ce)},registerDeclarationProvider(Y,ce){return gt.registerDeclarationProvider(Me,mt(Y),ce)},registerImplementationProvider(Y,ce){return gt.registerImplementationProvider(Me,mt(Y),ce)},registerTypeDefinitionProvider(Y,ce){return gt.registerTypeDefinitionProvider(Me,mt(Y),ce)},registerHoverProvider(Y,ce){return gt.registerHoverProvider(Me,mt(Y),ce,Me.identifier)},registerEvaluatableExpressionProvider(Y,ce){return gt.registerEvaluatableExpressionProvider(Me,mt(Y),ce,Me.identifier)},registerInlineValuesProvider(Y,ce){return gt.registerInlineValuesProvider(Me,mt(Y),ce,Me.identifier)},registerDocumentHighlightProvider(Y,ce){return gt.registerDocumentHighlightProvider(Me,mt(Y),ce)},registerLinkedEditingRangeProvider(Y,ce){return gt.registerLinkedEditingRangeProvider(Me,mt(Y),ce)},registerReferenceProvider(Y,ce){return gt.registerReferenceProvider(Me,mt(Y),ce)},registerRenameProvider(Y,ce){return gt.registerRenameProvider(Me,mt(Y),ce)},registerDocumentSymbolProvider(Y,ce,ke){return gt.registerDocumentSymbolProvider(Me,mt(Y),ce,ke)},registerWorkspaceSymbolProvider(Y){return gt.registerWorkspaceSymbolProvider(Me,Y)},registerDocumentFormattingEditProvider(Y,ce){return gt.registerDocumentFormattingEditProvider(Me,mt(Y),ce)},registerDocumentRangeFormattingEditProvider(Y,ce){return gt.registerDocumentRangeFormattingEditProvider(Me,mt(Y),ce)},registerOnTypeFormattingEditProvider(Y,ce,ke,...ct){return gt.registerOnTypeFormattingEditProvider(Me,mt(Y),ce,[ke].concat(ct))},registerDocumentSemanticTokensProvider(Y,ce,ke){return gt.registerDocumentSemanticTokensProvider(Me,mt(Y),ce,ke)},registerDocumentRangeSemanticTokensProvider(Y,ce,ke){return gt.registerDocumentRangeSemanticTokensProvider(Me,mt(Y),ce,ke)},registerSignatureHelpProvider(Y,ce,ke,...ct){return typeof ke=="object"?gt.registerSignatureHelpProvider(Me,mt(Y),ce,ke):gt.registerSignatureHelpProvider(Me,mt(Y),ce,typeof ke=="undefined"?[]:[ke,...ct])},registerCompletionItemProvider(Y,ce,...ke){return gt.registerCompletionItemProvider(Me,mt(Y),ce,ke)},registerInlineCompletionItemProvider(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),gt.registerInlineCompletionsProvider(Me,mt(Y),ce)},registerDocumentLinkProvider(Y,ce){return gt.registerDocumentLinkProvider(Me,mt(Y),ce)},registerColorProvider(Y,ce){return gt.registerColorProvider(Me,mt(Y),ce)},registerFoldingRangeProvider(Y,ce){return gt.registerFoldingRangeProvider(Me,mt(Y),ce)},registerSelectionRangeProvider(Y,ce){return gt.registerSelectionRangeProvider(Me,Y,ce)},registerCallHierarchyProvider(Y,ce){return gt.registerCallHierarchyProvider(Me,Y,ce)},registerTypeHierarchyProvider(Y,ce){return gt.registerTypeHierarchyProvider(Me,Y,ce)},setLanguageConfiguration:(Y,ce)=>gt.setLanguageConfiguration(Me,Y,ce),getTokenInformationAtPosition(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"tokenInformation"),Wt.tokenAtPosition(Y,ce)},registerInlayHintsProvider(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"inlayHints"),gt.registerInlayHintsProvider(Me,Y,ce)},createLanguageStatusItem(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"languageStatus"),Wt.createLanguageStatusItem(Me,Y,ce)}},Ri={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(Y,ce,ke){const ct=await(k.URI.isUri(Y)?Promise.resolve(ri.openTextDocument(Y)):Promise.resolve(Y));return Ft.showTextDocument(ct,ce,ke)},createTextEditorDecorationType(Y){return Ft.createTextEditorDecorationType(Me,Y)},onDidChangeActiveTextEditor(Y,ce,ke){return Ft.onDidChangeActiveTextEditor(Y,ce,ke)},onDidChangeVisibleTextEditors(Y,ce,ke){return Ft.onDidChangeVisibleTextEditors(Y,ce,ke)},onDidChangeTextEditorSelection(Y,ce,ke){return Ft.onDidChangeTextEditorSelection(Y,ce,ke)},onDidChangeTextEditorOptions(Y,ce,ke){return Ft.onDidChangeTextEditorOptions(Y,ce,ke)},onDidChangeTextEditorVisibleRanges(Y,ce,ke){return Ft.onDidChangeTextEditorVisibleRanges(Y,ce,ke)},onDidChangeTextEditorViewColumn(Y,ce,ke){return Ft.onDidChangeTextEditorViewColumn(Y,ce,ke)},onDidCloseTerminal(Y,ce,ke){return pt.onDidCloseTerminal(Y,ce,ke)},onDidOpenTerminal(Y,ce,ke){return pt.onDidOpenTerminal(Y,ce,ke)},onDidChangeActiveTerminal(Y,ce,ke){return pt.onDidChangeActiveTerminal(Y,ce,ke)},onDidChangeTerminalDimensions(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDimensions"),pt.onDidChangeTerminalDimensions(Y,ce,ke)},onDidChangeTerminalState(Y,ce,ke){return pt.onDidChangeTerminalState(Y,ce,ke)},onDidWriteTerminalData(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(Y,ce,ke)},get state(){return xe.state},onDidChangeWindowState(Y,ce,ke){return xe.onDidChangeWindowState(Y,ce,ke)},showInformationMessage(Y,...ce){return ui.showMessage(Me,T.default.Info,Y,ce[0],ce.slice(1))},showWarningMessage(Y,...ce){return ui.showMessage(Me,T.default.Warning,Y,ce[0],ce.slice(1))},showErrorMessage(Y,...ce){return ui.showMessage(Me,T.default.Error,Y,ce[0],ce.slice(1))},showQuickPick(Y,ce,ke){return Array.isArray(Y)&&Y.some(ct=>ct.kind===$.QuickPickItemKind.Separator)&&(0,ve.checkProposedApiEnabled)(Me,"quickPickSeparators"),jt.showQuickPick(Y,ce,ke)},showWorkspaceFolderPick(Y){return jt.showWorkspaceFolderPick(Y)},showInputBox(Y,ce){return jt.showInput(Y,ce)},showOpenDialog(Y){return ii.showOpenDialog(Y)},showSaveDialog(Y){return ii.showSaveDialog(Y)},createStatusBarItem(Y,ce,ke){let ct,_t,Dt;return typeof Y=="string"?(ct=Y,_t=ce,Dt=ke):(_t=Y,Dt=ce),gi.createStatusBarEntry(Me,ct,_t,Dt)},setStatusBarMessage(Y,ce){return gi.setStatusBarMessage(Y,ce)},withScmProgress(Y){return Ye.report("window.withScmProgress",Me,"Use 'withProgress' instead."),fi.withProgress(Me,{location:$.ProgressLocation.SourceControl},(ce,ke)=>Y({report(ct){}}))},withProgress(Y,ce){return fi.withProgress(Me,Y,ce)},createOutputChannel(Y){return It.createOutputChannel(Y,Me)},createWebviewPanel(Y,ce,ke,ct){return Kt.createWebviewPanel(Me,Y,ce,ke,ct)},createWebviewTextEditorInset(Y,ce,ke,ct){return(0,ve.checkProposedApiEnabled)(Me,"editorInsets"),ai.createWebviewEditorInset(Y,ce,ke,ct,Me)},createTerminal(Y,ce,ke){return typeof Y=="object"?"pty"in Y?pt.createExtensionTerminal(Y):pt.createTerminalFromOptions(Y):pt.createTerminal(Y,ce,ke)},registerTerminalLinkProvider(Y){return pt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ce){return pt.registerProfileProvider(Me,Y,ce)},registerTreeDataProvider(Y,ce){return Xt.registerTreeDataProvider(Y,ce,Me)},createTreeView(Y,ce){return Xt.createTreeView(Y,ce,Me)},registerWebviewPanelSerializer:(Y,ce)=>Kt.registerWebviewPanelSerializer(Me,Y,ce),registerCustomEditorProvider:(Y,ce,ke={})=>_i.registerCustomEditorProvider(Me,Y,ce,ke),registerFileDecorationProvider(Y){return Ct.registerFileDecorationProvider(Y,Me.identifier)},registerUriHandler(Y){return At.registerUriHandler(Me.identifier,Y)},createQuickPick(){return jt.createQuickPick(Me)},createInputBox(){return jt.createInputBox(Me.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,ce,ke){return mi.onDidChangeActiveColorTheme(Y,ce,ke)},registerWebviewViewProvider(Y,ce,ke){return Si.registerWebviewViewProvider(Me,Y,ce,ke?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(Y,ce,ke)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(Y,ce,ke)},onDidChangeNotebookEditorVisibleRanges(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(Y,ce,ke)},showNotebookDocument(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.showNotebookDocument(Y,ce)},registerExternalUriOpener(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"externalUriOpener"),Ci.registerExternalUriOpener(Me.identifier,Y,ce,ke)},get tabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),bt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),bt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),bt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),bt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),m.InlineCompletionController.get(Y)}},ri={get rootPath(){return Ye.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw t.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw t.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw t.readonly()},updateWorkspaceFolders:(Y,ce,...ke)=>Le.updateWorkspaceFolders(Me,Y,ce||0,...ke),onDidChangeWorkspaceFolders:function(Y,ce,ke){return Le.onDidChangeWorkspace(Y,ce,ke)},asRelativePath:(Y,ce)=>Le.getRelativePath(Y,ce),findFiles:(Y,ce,ke,ct)=>Le.findFiles(U.GlobPattern.from(Y),U.GlobPattern.from(ce),ke,Me.identifier,ct),findTextInFiles:(Y,ce,ke,ct)=>{(0,ve.checkProposedApiEnabled)(Me,"findTextInFiles");let _t,Dt;return typeof ce=="object"?(_t=ce,Dt=ke):(_t={},Dt=ce,ct=ke),Le.findTextInFiles(Y,_t||{},Dt,Me.identifier,ct)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ce,ke,ct)=>Nt.createFileSystemWatcher(U.GlobPattern.from(Y),ce,ke,ct),get textDocuments(){return St.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw t.readonly()},openTextDocument(Y){let ce;const ke=Y;if(typeof Y=="string")ce=Promise.resolve(k.URI.file(Y));else if(k.URI.isUri(Y))ce=Promise.resolve(Y);else if(!ke||typeof ke=="object")ce=St.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ct=>St.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(Y,ce,ke)=>St.onDidAddDocument(Y,ce,ke),onDidCloseTextDocument:(Y,ce,ke)=>St.onDidRemoveDocument(Y,ce,ke),onDidChangeTextDocument:(Y,ce,ke)=>St.onDidChangeDocument(Y,ce,ke),onDidSaveTextDocument:(Y,ce,ke)=>St.onDidSaveDocument(Y,ce,ke),onWillSaveTextDocument:(Y,ce,ke)=>Lt.getOnWillSaveTextDocumentEvent(Me)(Y,ce,ke),get notebookDocuments(){return Et.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ce){let ke;if(k.URI.isUri(Y))ke=Y,await Et.openNotebookDocument(Y);else if(typeof Y=="string")ke=k.URI.revive(await Et.createNotebookDocument({viewType:Y,content:ce}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ce,ke,ct){return Et.registerNotebookSerializer(Me,Y,ce,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(Y,ce,ke,ct)=>((0,ve.checkProposedApiEnabled)(Me,"notebookContentProvider"),Et.registerNotebookContentProvider(Me,Y,ce,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(Y,ce,ke)=>pi.onDidChangeConfiguration(Y,ce,ke),getConfiguration(Y,ce){return ce=arguments.length===1?void 0:ce,pi.getConfiguration(Y,ce,Me)},registerTextDocumentContentProvider(Y,ce){return zt.registerTextDocumentContentProvider(Y,ce)},registerTaskProvider:(Y,ce)=>(Ye.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Me,Y,ce)),registerFileSystemProvider(Y,ce,ke){return(0,De.combinedDisposable)(li.registerFileSystemProvider(Me,Y,ce,ke),Te.addFileSystemProvider(Y,ce))},get fs(){return Te.value},registerFileSearchProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"fileSearchProvider"),Ot.registerFileSearchProvider(Y,ce)),registerTextSearchProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"textSearchProvider"),Ot.registerTextSearchProvider(Y,ce)),registerRemoteAuthorityResolver:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),We.registerRemoteAuthorityResolver(Y,ce)),registerResourceLabelFormatter:Y=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ce,ke)=>Nt.onDidCreateFile(Y,ce,ke),onDidDeleteFiles:(Y,ce,ke)=>Nt.onDidDeleteFile(Y,ce,ke),onDidRenameFiles:(Y,ce,ke)=>Nt.onDidRenameFile(Y,ce,ke),onWillCreateFiles:(Y,ce,ke)=>Nt.getOnWillCreateFileEvent(Me)(Y,ce,ke),onWillDeleteFiles:(Y,ce,ke)=>Nt.getOnWillDeleteFileEvent(Me)(Y,ce,ke),onWillRenameFiles:(Y,ce,ke)=>Nt.getOnWillRenameFileEvent(Me)(Y,ce,ke),openTunnel:Y=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Pe.openTunnel(Me,Y).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),Pe.getTunnels()},onDidChangeTunnels:(Y,ce,ke)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Pe.onDidChangeTunnels(Y,ce,ke)),registerPortAttributesProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"portsAttributes"),Pe.registerPortsAttributesProvider(Y,ce)),registerTimelineProvider:(Y,ce)=>((0,ve.checkProposedApiEnabled)(Me,"timeline"),yi.registerTimelineProvider(Y,ce,Me.identifier,ft.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,ve.checkProposedApiEnabled)(Me,"workspaceTrust"),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ce,ke)=>Le.onDidGrantWorkspaceTrust(Y,ce,ke)},Fi={get inputBox(){return Ye.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Zt.getLastInputBox(Me)},createSourceControl(Y,ce,ke){return Zt.createSourceControl(Me,Y,ce,ke)}},Mi={createCommentController(Y,ce){return ci.createCommentController(Me,Y,ce)}},Oi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},onDidStartDebugSession(Y,ce,ke){return yt.onDidStartDebugSession(Y,ce,ke)},onDidTerminateDebugSession(Y,ce,ke){return yt.onDidTerminateDebugSession(Y,ce,ke)},onDidChangeActiveDebugSession(Y,ce,ke){return yt.onDidChangeActiveDebugSession(Y,ce,ke)},onDidReceiveDebugSessionCustomEvent(Y,ce,ke){return yt.onDidReceiveDebugSessionCustomEvent(Y,ce,ke)},onDidChangeBreakpoints(Y,ce,ke){return yt.onDidChangeBreakpoints(Y,ce,ke)},registerDebugConfigurationProvider(Y,ce,ke){return yt.registerDebugConfigurationProvider(Y,ce,ke||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ce){return yt.registerDebugAdapterDescriptorFactory(Me,Y,ce)},registerDebugAdapterTrackerFactory(Y,ce){return yt.registerDebugAdapterTrackerFactory(Y,ce)},startDebugging(Y,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?yt.startDebugging(Y,ce,{parentSession:ke}):yt.startDebugging(Y,ce,ke||{})},stopDebugging(Y){return yt.stopDebugging(Y)},addBreakpoints(Y){return yt.addBreakpoints(Y)},removeBreakpoints(Y){return yt.removeBreakpoints(Y)},asDebugSourceUri(Y,ce){return yt.asDebugSourceUri(Y,ce)}},Li={registerTaskProvider:(Y,ce)=>kt.registerTaskProvider(Me,Y,ce),fetchTasks:Y=>kt.fetchTasks(Y),executeTask:Y=>kt.executeTask(Me,Y),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(Y,ce,ke)=>kt.onDidStartTask(Y,ce,ke),onDidEndTask:(Y,ce,ke)=>kt.onDidEndTask(Y,ce,ke),onDidStartTaskProcess:(Y,ce,ke)=>kt.onDidStartTaskProcess(Y,ce,ke),onDidEndTaskProcess:(Y,ce,ke)=>kt.onDidEndTaskProcess(Y,ce,ke)},Ni={createNotebookController(Y,ce,ke,ct,_t){return Yt.createNotebookController(Me,Y,ce,ke,ct,(0,ve.isProposedApiEnabled)(Me,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ce)=>Et.registerNotebookCellStatusBarItemProvider(Me,Y,ce),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return si.createRendererMessaging(Me,Y)},onDidChangeNotebookDocumentMetadata(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(Y,ce,ke)},onDidChangeNotebookCells(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeNotebookCells(Y,ce,ke)},onDidChangeNotebookCellExecutionState(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(Y,ce,ke)},onDidChangeCellOutputs(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeCellOutputs(Y,ce,ke)},onDidChangeCellMetadata(Y,ce,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Et.onDidChangeCellMetadata(Y,ce,ke)},createConcatTextDocument(Y,ce){return(0,ve.checkProposedApiEnabled)(Me,"notebookConcatTextDocument"),new Ue.ExtHostNotebookConcatDocument(Et,St,Y,ce)}};return{version:de.version,authentication:ni,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ri,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:A.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:n.UIKind,Uri:k.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,TreeDataTransfer:$.TreeDataTransfer,TreeDataTransferItem:$.TreeDataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ie}),define(ye[221],_e([0,1,220,33,213,7,14,5,11]),function(Z,e,s,t,E,T,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class A extends E.RequireInterceptor{_installInterceptor(){}getModule(o,c){for(let u of this._alternatives){let F=u(o);if(F){o=F;break}}if(this._factories.has(o))return this._factories.get(o).load(o,c,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);n(o,this._initData.environment.isExtensionDevelopmentDebug);const c=this._instaService.invokeFunction(s.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,c,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,c,u){c=c.with({path:b(c.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const F=await fetch(C.FileAccess.asBrowserUri(c).toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),F.status!==200)throw new Error(F.statusText);const y=await F.text(),f=`${c.toString(!0)}#vscode-extension`,d=`${y}
//# sourceURL=${f}`;let D;try{D=new Function("module","exports","require",d)}catch(i){throw console.error(o?`Loading code for extension ${o.value} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${c.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}const l={},M={exports:l},r=i=>{const p=this._fakeModules.getModule(i,c);if(p===void 0)throw new Error(`Cannot load module '${i}'`);return p};try{return u.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),D(M,l,r),M.exports!==l?M.exports:l}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),u.codeLoadingStop()}}async $setRemoteEnvironment(o){}async _waitForDebuggerAttachment(o=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const c=Date.now()+o;for(;Date.now()<c&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=R;function b(g,o){return g.endsWith(o)?g:g+o}function n(g,o){c("info","log"),c("log","log"),c("warn","warn"),c("error","error");function c(y,f){const d=console[y];console[y]=function(){g.$logExtensionHostMessage({type:"__$console",severity:f,arguments:F(arguments)}),o&&d.apply(console,arguments)}}const u=1e5;function F(y){const f=[],d=[];if(y.length)for(let D=0;D<y.length;D++){if(typeof y[D]=="undefined")y[D]="undefined";else if(y[D]instanceof Error){const l=y[D];l.stack?y[D]=l.stack:y[D]=l.toString()}d.push(y[D])}try{const D=JSON.stringify(d,function(l,M){if(M&&typeof M=="object"){if(f.indexOf(M)!==-1)return"[Circular]";f.push(M)}return M});return D.length>u?"Output omitted for a large object that exceeds the limits":D}catch(D){return`Output omitted for an object that cannot be inspected ('${D.toString()}')`}}}}),define(ye[222],_e([0,1,44,33,72,221]),function(Z,e,s,t,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(t.IExtHostExtensionService,T.ExtHostExtensionService),(0,s.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths)}),define(ye[234],_e([0,1,22,4,171,214,208,17,73,11,2,217,222]),function(Z,e,s,t,E,T,k,I,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const g=fetch.bind(self);if(self.fetch=function(f,d){return f instanceof Request||/^file:/i.test(String(f))&&(f=A.FileAccess.asBrowserUri(R.URI.parse(String(f))).toString(!0)),g(f,d)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,d,D,l,M){return/^file:/i.test(d.toString())&&(d=A.FileAccess.asBrowserUri(R.URI.parse(d.toString())).toString(!0)),super.open(f,d,D??!0,l,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const f=self.Worker;Worker=function(d,D){/^file:/i.test(d.toString())&&(d=A.FileAccess.asBrowserUri(R.URI.parse(d.toString())).toString(!0));const M=`(${function(m){function h(a){return typeof a=="string"||a instanceof URL?String(a).replace(/^file:\/\//i,"vscode-file://vscode-app"):a}const w=fetch.bind(self);self.fetch=function(a,S){return a instanceof Request?w(a,S):w(h(a),S)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,S,P,N,B){return super.open(a,h(S),P??!0,N,B)}};const v=importScripts.bind(self);self.importScripts=(...a)=>{v(...a.map(h))},v(m)}.toString()}('${d}'))`;D=D||{},D.name=D.name||I.basename(d.toString());const r=new Blob([M],{type:"application/javascript"}),i=URL.createObjectURL(r);return new f(i,D)}}else self.Worker=class extends k.NestedWorker{constructor(f,d){super(n,f,{name:I.basename(f.toString()),...d})}};const o=new class{constructor(){this.pid=void 0}exit(f){b()}async exists(f){return!0}async realpath(f){return f}};class c{constructor(){const d=new MessageChannel,D=new t.Emitter;let l=!1;n(d.port2,[d.port2]),d.port1.onmessage=M=>{const{data:r}=M;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const i=s.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,E.isMessageOfType)(i,2)){l=!0,F("received terminate message from renderer");return}D.fire(i)},this.protocol={onMessage:D.event,send:M=>{if(!l){const r=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);d.port1.postMessage(r,[r])}}}}}function u(f){return new Promise(d=>{const D=f.onMessage(l=>{D.dispose();const M=JSON.parse(l.toString());f.send((0,E.createMessageOfType)(0)),d({protocol:f,initData:M})});f.send((0,E.createMessageOfType)(1))})}let F=f=>b();function y(){const f=new c;C.mark("code/extHost/willConnectToRenderer"),u(f.protocol).then(d=>{C.mark("code/extHost/didWaitForInitData");const D=new T.ExtensionHostMain(d.protocol,d.initData,o,null);F=l=>D.terminate(l)})}e.create=y})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/99305570d885bce929ba8f24d90f2c3ee54c5c2f/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
